var Module;
if (!Module) Module = (typeof Module !== "undefined" ? Module : null) || {};
var moduleOverrides = {};
for (var key in Module) {
 if (Module.hasOwnProperty(key)) {
  moduleOverrides[key] = Module[key];
 }
}
var ENVIRONMENT_IS_WEB = typeof window === "object";
var ENVIRONMENT_IS_WORKER = typeof importScripts === "function";
var ENVIRONMENT_IS_NODE = typeof process === "object" && typeof require === "function" && !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_WORKER;
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;
if (ENVIRONMENT_IS_NODE) {
 if (!Module["print"]) Module["print"] = function print(x) {
  process["stdout"].write(x + "\n");
 };
 if (!Module["printErr"]) Module["printErr"] = function printErr(x) {
  process["stderr"].write(x + "\n");
 };
 var nodeFS = require("fs");
 var nodePath = require("path");
 Module["read"] = function read(filename, binary) {
  filename = nodePath["normalize"](filename);
  var ret = nodeFS["readFileSync"](filename);
  if (!ret && filename != nodePath["resolve"](filename)) {
   filename = path.join(__dirname, "..", "src", filename);
   ret = nodeFS["readFileSync"](filename);
  }
  if (ret && !binary) ret = ret.toString();
  return ret;
 };
 Module["readBinary"] = function readBinary(filename) {
  var ret = Module["read"](filename, true);
  if (!ret.buffer) {
   ret = new Uint8Array(ret);
  }
  assert(ret.buffer);
  return ret;
 };
 Module["load"] = function load(f) {
  globalEval(read(f));
 };
 if (!Module["thisProgram"]) {
  if (process["argv"].length > 1) {
   Module["thisProgram"] = process["argv"][1].replace(/\\/g, "/");
  } else {
   Module["thisProgram"] = "unknown-program";
  }
 }
 Module["arguments"] = process["argv"].slice(2);
 if (typeof module !== "undefined") {
  module["exports"] = Module;
 }
 process["on"]("uncaughtException", (function(ex) {
  if (!(ex instanceof ExitStatus)) {
   throw ex;
  }
 }));
 Module["inspect"] = (function() {
  return "[Emscripten Module object]";
 });
} else if (ENVIRONMENT_IS_SHELL) {
 if (!Module["print"]) Module["print"] = print;
 if (typeof printErr != "undefined") Module["printErr"] = printErr;
 if (typeof read != "undefined") {
  Module["read"] = read;
 } else {
  Module["read"] = function read() {
   throw "no read() available (jsc?)";
  };
 }
 Module["readBinary"] = function readBinary(f) {
  if (typeof readbuffer === "function") {
   return new Uint8Array(readbuffer(f));
  }
  var data = read(f, "binary");
  assert(typeof data === "object");
  return data;
 };
 if (typeof scriptArgs != "undefined") {
  Module["arguments"] = scriptArgs;
 } else if (typeof arguments != "undefined") {
  Module["arguments"] = arguments;
 }
} else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
 Module["read"] = function read(url) {
  var xhr = new XMLHttpRequest;
  xhr.open("GET", url, false);
  xhr.send(null);
  return xhr.responseText;
 };
 if (typeof arguments != "undefined") {
  Module["arguments"] = arguments;
 }
 if (typeof console !== "undefined") {
  if (!Module["print"]) Module["print"] = function print(x) {
   console.log(x);
  };
  if (!Module["printErr"]) Module["printErr"] = function printErr(x) {
   console.log(x);
  };
 } else {
  var TRY_USE_DUMP = false;
  if (!Module["print"]) Module["print"] = TRY_USE_DUMP && typeof dump !== "undefined" ? (function(x) {
   dump(x);
  }) : (function(x) {});
 }
 if (ENVIRONMENT_IS_WORKER) {
  Module["load"] = importScripts;
 }
 if (typeof Module["setWindowTitle"] === "undefined") {
  Module["setWindowTitle"] = (function(title) {
   document.title = title;
  });
 }
} else {
 throw "Unknown runtime environment. Where are we?";
}
function globalEval(x) {
 eval.call(null, x);
}
if (!Module["load"] && Module["read"]) {
 Module["load"] = function load(f) {
  globalEval(Module["read"](f));
 };
}
if (!Module["print"]) {
 Module["print"] = (function() {});
}
if (!Module["printErr"]) {
 Module["printErr"] = Module["print"];
}
if (!Module["arguments"]) {
 Module["arguments"] = [];
}
if (!Module["thisProgram"]) {
 Module["thisProgram"] = "./this.program";
}
Module.print = Module["print"];
Module.printErr = Module["printErr"];
Module["preRun"] = [];
Module["postRun"] = [];
for (var key in moduleOverrides) {
 if (moduleOverrides.hasOwnProperty(key)) {
  Module[key] = moduleOverrides[key];
 }
}
var Runtime = {
 setTempRet0: (function(value) {
  tempRet0 = value;
 }),
 getTempRet0: (function() {
  return tempRet0;
 }),
 stackSave: (function() {
  return STACKTOP;
 }),
 stackRestore: (function(stackTop) {
  STACKTOP = stackTop;
 }),
 getNativeTypeSize: (function(type) {
  switch (type) {
  case "i1":
  case "i8":
   return 1;
  case "i16":
   return 2;
  case "i32":
   return 4;
  case "i64":
   return 8;
  case "float":
   return 4;
  case "double":
   return 8;
  default:
   {
    if (type[type.length - 1] === "*") {
     return Runtime.QUANTUM_SIZE;
    } else if (type[0] === "i") {
     var bits = parseInt(type.substr(1));
     assert(bits % 8 === 0);
     return bits / 8;
    } else {
     return 0;
    }
   }
  }
 }),
 getNativeFieldSize: (function(type) {
  return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
 }),
 STACK_ALIGN: 16,
 prepVararg: (function(ptr, type) {
  if (type === "double" || type === "i64") {
   if (ptr & 7) {
    assert((ptr & 7) === 4);
    ptr += 4;
   }
  } else {
   assert((ptr & 3) === 0);
  }
  return ptr;
 }),
 getAlignSize: (function(type, size, vararg) {
  if (!vararg && (type == "i64" || type == "double")) return 8;
  if (!type) return Math.min(size, 8);
  return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
 }),
 dynCall: (function(sig, ptr, args) {
  if (args && args.length) {
   if (!args.splice) args = Array.prototype.slice.call(args);
   args.splice(0, 0, ptr);
   return Module["dynCall_" + sig].apply(null, args);
  } else {
   return Module["dynCall_" + sig].call(null, ptr);
  }
 }),
 functionPointers: [],
 addFunction: (function(func) {
  for (var i = 0; i < Runtime.functionPointers.length; i++) {
   if (!Runtime.functionPointers[i]) {
    Runtime.functionPointers[i] = func;
    return 2 * (1 + i);
   }
  }
  throw "Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.";
 }),
 removeFunction: (function(index) {
  Runtime.functionPointers[(index - 2) / 2] = null;
 }),
 warnOnce: (function(text) {
  if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
  if (!Runtime.warnOnce.shown[text]) {
   Runtime.warnOnce.shown[text] = 1;
   Module.printErr(text);
  }
 }),
 funcWrappers: {},
 getFuncWrapper: (function(func, sig) {
  assert(sig);
  if (!Runtime.funcWrappers[sig]) {
   Runtime.funcWrappers[sig] = {};
  }
  var sigCache = Runtime.funcWrappers[sig];
  if (!sigCache[func]) {
   sigCache[func] = function dynCall_wrapper() {
    return Runtime.dynCall(sig, func, arguments);
   };
  }
  return sigCache[func];
 }),
 getCompilerSetting: (function(name) {
  throw "You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work";
 }),
 stackAlloc: (function(size) {
  var ret = STACKTOP;
  STACKTOP = STACKTOP + size | 0;
  STACKTOP = STACKTOP + 15 & -16;
  return ret;
 }),
 staticAlloc: (function(size) {
  var ret = STATICTOP;
  STATICTOP = STATICTOP + size | 0;
  STATICTOP = STATICTOP + 15 & -16;
  return ret;
 }),
 dynamicAlloc: (function(size) {
  var ret = DYNAMICTOP;
  DYNAMICTOP = DYNAMICTOP + size | 0;
  DYNAMICTOP = DYNAMICTOP + 15 & -16;
  if (DYNAMICTOP >= TOTAL_MEMORY) {
   var success = enlargeMemory();
   if (!success) {
    DYNAMICTOP = ret;
    return 0;
   }
  }
  return ret;
 }),
 alignMemory: (function(size, quantum) {
  var ret = size = Math.ceil(size / (quantum ? quantum : 16)) * (quantum ? quantum : 16);
  return ret;
 }),
 makeBigInt: (function(low, high, unsigned) {
  var ret = unsigned ? +(low >>> 0) + +(high >>> 0) * +4294967296 : +(low >>> 0) + +(high | 0) * +4294967296;
  return ret;
 }),
 GLOBAL_BASE: 8,
 QUANTUM_SIZE: 4,
 __dummy__: 0
};
Module["Runtime"] = Runtime;
var __THREW__ = 0;
var ABORT = false;
var EXITSTATUS = 0;
var undef = 0;
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;
function assert(condition, text) {
 if (!condition) {
  abort("Assertion failed: " + text);
 }
}
var globalScope = this;
function getCFunc(ident) {
 var func = Module["_" + ident];
 if (!func) {
  try {
   func = eval("_" + ident);
  } catch (e) {}
 }
 assert(func, "Cannot call unknown function " + ident + " (perhaps LLVM optimizations or closure removed it?)");
 return func;
}
var cwrap, ccall;
((function() {
 var JSfuncs = {
  "stackSave": (function() {
   Runtime.stackSave();
  }),
  "stackRestore": (function() {
   Runtime.stackRestore();
  }),
  "arrayToC": (function(arr) {
   var ret = Runtime.stackAlloc(arr.length);
   writeArrayToMemory(arr, ret);
   return ret;
  }),
  "stringToC": (function(str) {
   var ret = 0;
   if (str !== null && str !== undefined && str !== 0) {
    ret = Runtime.stackAlloc((str.length << 2) + 1);
    writeStringToMemory(str, ret);
   }
   return ret;
  })
 };
 var toC = {
  "string": JSfuncs["stringToC"],
  "array": JSfuncs["arrayToC"]
 };
 ccall = function ccallFunc(ident, returnType, argTypes, args, opts) {
  var func = getCFunc(ident);
  var cArgs = [];
  var stack = 0;
  if (args) {
   for (var i = 0; i < args.length; i++) {
    var converter = toC[argTypes[i]];
    if (converter) {
     if (stack === 0) stack = Runtime.stackSave();
     cArgs[i] = converter(args[i]);
    } else {
     cArgs[i] = args[i];
    }
   }
  }
  var ret = func.apply(null, cArgs);
  if (returnType === "string") ret = Pointer_stringify(ret);
  if (stack !== 0) {
   if (opts && opts.async) {
    EmterpreterAsync.asyncFinalizers.push((function() {
     Runtime.stackRestore(stack);
    }));
    return;
   }
   Runtime.stackRestore(stack);
  }
  return ret;
 };
 var sourceRegex = /^function\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;
 function parseJSFunc(jsfunc) {
  var parsed = jsfunc.toString().match(sourceRegex).slice(1);
  return {
   arguments: parsed[0],
   body: parsed[1],
   returnValue: parsed[2]
  };
 }
 var JSsource = {};
 for (var fun in JSfuncs) {
  if (JSfuncs.hasOwnProperty(fun)) {
   JSsource[fun] = parseJSFunc(JSfuncs[fun]);
  }
 }
 cwrap = function cwrap(ident, returnType, argTypes) {
  argTypes = argTypes || [];
  var cfunc = getCFunc(ident);
  var numericArgs = argTypes.every((function(type) {
   return type === "number";
  }));
  var numericRet = returnType !== "string";
  if (numericRet && numericArgs) {
   return cfunc;
  }
  var argNames = argTypes.map((function(x, i) {
   return "$" + i;
  }));
  var funcstr = "(function(" + argNames.join(",") + ") {";
  var nargs = argTypes.length;
  if (!numericArgs) {
   funcstr += "var stack = " + JSsource["stackSave"].body + ";";
   for (var i = 0; i < nargs; i++) {
    var arg = argNames[i], type = argTypes[i];
    if (type === "number") continue;
    var convertCode = JSsource[type + "ToC"];
    funcstr += "var " + convertCode.arguments + " = " + arg + ";";
    funcstr += convertCode.body + ";";
    funcstr += arg + "=" + convertCode.returnValue + ";";
   }
  }
  var cfuncname = parseJSFunc((function() {
   return cfunc;
  })).returnValue;
  funcstr += "var ret = " + cfuncname + "(" + argNames.join(",") + ");";
  if (!numericRet) {
   var strgfy = parseJSFunc((function() {
    return Pointer_stringify;
   })).returnValue;
   funcstr += "ret = " + strgfy + "(ret);";
  }
  if (!numericArgs) {
   funcstr += JSsource["stackRestore"].body.replace("()", "(stack)") + ";";
  }
  funcstr += "return ret})";
  return eval(funcstr);
 };
}))();
Module["ccall"] = ccall;
Module["cwrap"] = cwrap;
function setValue(ptr, value, type, noSafe) {
 type = type || "i8";
 if (type.charAt(type.length - 1) === "*") type = "i32";
 switch (type) {
 case "i1":
  HEAP8[ptr >> 0] = value;
  break;
 case "i8":
  HEAP8[ptr >> 0] = value;
  break;
 case "i16":
  HEAP16[ptr >> 1] = value;
  break;
 case "i32":
  HEAP32[ptr >> 2] = value;
  break;
 case "i64":
  tempI64 = [ value >>> 0, (tempDouble = value, +Math_abs(tempDouble) >= +1 ? tempDouble > +0 ? (Math_min(+Math_floor(tempDouble / +4294967296), +4294967295) | 0) >>> 0 : ~~+Math_ceil((tempDouble - +(~~tempDouble >>> 0)) / +4294967296) >>> 0 : 0) ], HEAP32[ptr >> 2] = tempI64[0], HEAP32[ptr + 4 >> 2] = tempI64[1];
  break;
 case "float":
  HEAPF32[ptr >> 2] = value;
  break;
 case "double":
  HEAPF64[ptr >> 3] = value;
  break;
 default:
  abort("invalid type for setValue: " + type);
 }
}
Module["setValue"] = setValue;
function getValue(ptr, type, noSafe) {
 type = type || "i8";
 if (type.charAt(type.length - 1) === "*") type = "i32";
 switch (type) {
 case "i1":
  return HEAP8[ptr >> 0];
 case "i8":
  return HEAP8[ptr >> 0];
 case "i16":
  return HEAP16[ptr >> 1];
 case "i32":
  return HEAP32[ptr >> 2];
 case "i64":
  return HEAP32[ptr >> 2];
 case "float":
  return HEAPF32[ptr >> 2];
 case "double":
  return HEAPF64[ptr >> 3];
 default:
  abort("invalid type for setValue: " + type);
 }
 return null;
}
Module["getValue"] = getValue;
var ALLOC_NORMAL = 0;
var ALLOC_STACK = 1;
var ALLOC_STATIC = 2;
var ALLOC_DYNAMIC = 3;
var ALLOC_NONE = 4;
Module["ALLOC_NORMAL"] = ALLOC_NORMAL;
Module["ALLOC_STACK"] = ALLOC_STACK;
Module["ALLOC_STATIC"] = ALLOC_STATIC;
Module["ALLOC_DYNAMIC"] = ALLOC_DYNAMIC;
Module["ALLOC_NONE"] = ALLOC_NONE;
function allocate(slab, types, allocator, ptr) {
 var zeroinit, size;
 if (typeof slab === "number") {
  zeroinit = true;
  size = slab;
 } else {
  zeroinit = false;
  size = slab.length;
 }
 var singleType = typeof types === "string" ? types : null;
 var ret;
 if (allocator == ALLOC_NONE) {
  ret = ptr;
 } else {
  ret = [ _malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc ][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
 }
 if (zeroinit) {
  var ptr = ret, stop;
  assert((ret & 3) == 0);
  stop = ret + (size & ~3);
  for (; ptr < stop; ptr += 4) {
   HEAP32[ptr >> 2] = 0;
  }
  stop = ret + size;
  while (ptr < stop) {
   HEAP8[ptr++ >> 0] = 0;
  }
  return ret;
 }
 if (singleType === "i8") {
  if (slab.subarray || slab.slice) {
   HEAPU8.set(slab, ret);
  } else {
   HEAPU8.set(new Uint8Array(slab), ret);
  }
  return ret;
 }
 var i = 0, type, typeSize, previousType;
 while (i < size) {
  var curr = slab[i];
  if (typeof curr === "function") {
   curr = Runtime.getFunctionIndex(curr);
  }
  type = singleType || types[i];
  if (type === 0) {
   i++;
   continue;
  }
  if (type == "i64") type = "i32";
  setValue(ret + i, curr, type);
  if (previousType !== type) {
   typeSize = Runtime.getNativeTypeSize(type);
   previousType = type;
  }
  i += typeSize;
 }
 return ret;
}
Module["allocate"] = allocate;
function getMemory(size) {
 if (!staticSealed) return Runtime.staticAlloc(size);
 if (typeof _sbrk !== "undefined" && !_sbrk.called || !runtimeInitialized) return Runtime.dynamicAlloc(size);
 return _malloc(size);
}
Module["getMemory"] = getMemory;
function Pointer_stringify(ptr, length) {
 if (length === 0 || !ptr) return "";
 var hasUtf = 0;
 var t;
 var i = 0;
 while (1) {
  t = HEAPU8[ptr + i >> 0];
  hasUtf |= t;
  if (t == 0 && !length) break;
  i++;
  if (length && i == length) break;
 }
 if (!length) length = i;
 var ret = "";
 if (hasUtf < 128) {
  var MAX_CHUNK = 1024;
  var curr;
  while (length > 0) {
   curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
   ret = ret ? ret + curr : curr;
   ptr += MAX_CHUNK;
   length -= MAX_CHUNK;
  }
  return ret;
 }
 return Module["UTF8ToString"](ptr);
}
Module["Pointer_stringify"] = Pointer_stringify;
function AsciiToString(ptr) {
 var str = "";
 while (1) {
  var ch = HEAP8[ptr++ >> 0];
  if (!ch) return str;
  str += String.fromCharCode(ch);
 }
}
Module["AsciiToString"] = AsciiToString;
function stringToAscii(str, outPtr) {
 return writeAsciiToMemory(str, outPtr, false);
}
Module["stringToAscii"] = stringToAscii;
function UTF8ArrayToString(u8Array, idx) {
 var u0, u1, u2, u3, u4, u5;
 var str = "";
 while (1) {
  u0 = u8Array[idx++];
  if (!u0) return str;
  if (!(u0 & 128)) {
   str += String.fromCharCode(u0);
   continue;
  }
  u1 = u8Array[idx++] & 63;
  if ((u0 & 224) == 192) {
   str += String.fromCharCode((u0 & 31) << 6 | u1);
   continue;
  }
  u2 = u8Array[idx++] & 63;
  if ((u0 & 240) == 224) {
   u0 = (u0 & 15) << 12 | u1 << 6 | u2;
  } else {
   u3 = u8Array[idx++] & 63;
   if ((u0 & 248) == 240) {
    u0 = (u0 & 7) << 18 | u1 << 12 | u2 << 6 | u3;
   } else {
    u4 = u8Array[idx++] & 63;
    if ((u0 & 252) == 248) {
     u0 = (u0 & 3) << 24 | u1 << 18 | u2 << 12 | u3 << 6 | u4;
    } else {
     u5 = u8Array[idx++] & 63;
     u0 = (u0 & 1) << 30 | u1 << 24 | u2 << 18 | u3 << 12 | u4 << 6 | u5;
    }
   }
  }
  if (u0 < 65536) {
   str += String.fromCharCode(u0);
  } else {
   var ch = u0 - 65536;
   str += String.fromCharCode(55296 | ch >> 10, 56320 | ch & 1023);
  }
 }
}
Module["UTF8ArrayToString"] = UTF8ArrayToString;
function UTF8ToString(ptr) {
 return UTF8ArrayToString(HEAPU8, ptr);
}
Module["UTF8ToString"] = UTF8ToString;
function stringToUTF8Array(str, outU8Array, outIdx, maxBytesToWrite) {
 if (!(maxBytesToWrite > 0)) return 0;
 var startIdx = outIdx;
 var endIdx = outIdx + maxBytesToWrite - 1;
 for (var i = 0; i < str.length; ++i) {
  var u = str.charCodeAt(i);
  if (u >= 55296 && u <= 57343) u = 65536 + ((u & 1023) << 10) | str.charCodeAt(++i) & 1023;
  if (u <= 127) {
   if (outIdx >= endIdx) break;
   outU8Array[outIdx++] = u;
  } else if (u <= 2047) {
   if (outIdx + 1 >= endIdx) break;
   outU8Array[outIdx++] = 192 | u >> 6;
   outU8Array[outIdx++] = 128 | u & 63;
  } else if (u <= 65535) {
   if (outIdx + 2 >= endIdx) break;
   outU8Array[outIdx++] = 224 | u >> 12;
   outU8Array[outIdx++] = 128 | u >> 6 & 63;
   outU8Array[outIdx++] = 128 | u & 63;
  } else if (u <= 2097151) {
   if (outIdx + 3 >= endIdx) break;
   outU8Array[outIdx++] = 240 | u >> 18;
   outU8Array[outIdx++] = 128 | u >> 12 & 63;
   outU8Array[outIdx++] = 128 | u >> 6 & 63;
   outU8Array[outIdx++] = 128 | u & 63;
  } else if (u <= 67108863) {
   if (outIdx + 4 >= endIdx) break;
   outU8Array[outIdx++] = 248 | u >> 24;
   outU8Array[outIdx++] = 128 | u >> 18 & 63;
   outU8Array[outIdx++] = 128 | u >> 12 & 63;
   outU8Array[outIdx++] = 128 | u >> 6 & 63;
   outU8Array[outIdx++] = 128 | u & 63;
  } else {
   if (outIdx + 5 >= endIdx) break;
   outU8Array[outIdx++] = 252 | u >> 30;
   outU8Array[outIdx++] = 128 | u >> 24 & 63;
   outU8Array[outIdx++] = 128 | u >> 18 & 63;
   outU8Array[outIdx++] = 128 | u >> 12 & 63;
   outU8Array[outIdx++] = 128 | u >> 6 & 63;
   outU8Array[outIdx++] = 128 | u & 63;
  }
 }
 outU8Array[outIdx] = 0;
 return outIdx - startIdx;
}
Module["stringToUTF8Array"] = stringToUTF8Array;
function stringToUTF8(str, outPtr, maxBytesToWrite) {
 return stringToUTF8Array(str, HEAPU8, outPtr, maxBytesToWrite);
}
Module["stringToUTF8"] = stringToUTF8;
function lengthBytesUTF8(str) {
 var len = 0;
 for (var i = 0; i < str.length; ++i) {
  var u = str.charCodeAt(i);
  if (u >= 55296 && u <= 57343) u = 65536 + ((u & 1023) << 10) | str.charCodeAt(++i) & 1023;
  if (u <= 127) {
   ++len;
  } else if (u <= 2047) {
   len += 2;
  } else if (u <= 65535) {
   len += 3;
  } else if (u <= 2097151) {
   len += 4;
  } else if (u <= 67108863) {
   len += 5;
  } else {
   len += 6;
  }
 }
 return len;
}
Module["lengthBytesUTF8"] = lengthBytesUTF8;
function UTF16ToString(ptr) {
 var i = 0;
 var str = "";
 while (1) {
  var codeUnit = HEAP16[ptr + i * 2 >> 1];
  if (codeUnit == 0) return str;
  ++i;
  str += String.fromCharCode(codeUnit);
 }
}
Module["UTF16ToString"] = UTF16ToString;
function stringToUTF16(str, outPtr, maxBytesToWrite) {
 if (maxBytesToWrite === undefined) {
  maxBytesToWrite = 2147483647;
 }
 if (maxBytesToWrite < 2) return 0;
 maxBytesToWrite -= 2;
 var startPtr = outPtr;
 var numCharsToWrite = maxBytesToWrite < str.length * 2 ? maxBytesToWrite / 2 : str.length;
 for (var i = 0; i < numCharsToWrite; ++i) {
  var codeUnit = str.charCodeAt(i);
  HEAP16[outPtr >> 1] = codeUnit;
  outPtr += 2;
 }
 HEAP16[outPtr >> 1] = 0;
 return outPtr - startPtr;
}
Module["stringToUTF16"] = stringToUTF16;
function lengthBytesUTF16(str) {
 return str.length * 2;
}
Module["lengthBytesUTF16"] = lengthBytesUTF16;
function UTF32ToString(ptr) {
 var i = 0;
 var str = "";
 while (1) {
  var utf32 = HEAP32[ptr + i * 4 >> 2];
  if (utf32 == 0) return str;
  ++i;
  if (utf32 >= 65536) {
   var ch = utf32 - 65536;
   str += String.fromCharCode(55296 | ch >> 10, 56320 | ch & 1023);
  } else {
   str += String.fromCharCode(utf32);
  }
 }
}
Module["UTF32ToString"] = UTF32ToString;
function stringToUTF32(str, outPtr, maxBytesToWrite) {
 if (maxBytesToWrite === undefined) {
  maxBytesToWrite = 2147483647;
 }
 if (maxBytesToWrite < 4) return 0;
 var startPtr = outPtr;
 var endPtr = startPtr + maxBytesToWrite - 4;
 for (var i = 0; i < str.length; ++i) {
  var codeUnit = str.charCodeAt(i);
  if (codeUnit >= 55296 && codeUnit <= 57343) {
   var trailSurrogate = str.charCodeAt(++i);
   codeUnit = 65536 + ((codeUnit & 1023) << 10) | trailSurrogate & 1023;
  }
  HEAP32[outPtr >> 2] = codeUnit;
  outPtr += 4;
  if (outPtr + 4 > endPtr) break;
 }
 HEAP32[outPtr >> 2] = 0;
 return outPtr - startPtr;
}
Module["stringToUTF32"] = stringToUTF32;
function lengthBytesUTF32(str) {
 var len = 0;
 for (var i = 0; i < str.length; ++i) {
  var codeUnit = str.charCodeAt(i);
  if (codeUnit >= 55296 && codeUnit <= 57343) ++i;
  len += 4;
 }
 return len;
}
Module["lengthBytesUTF32"] = lengthBytesUTF32;
function demangle(func) {
 var hasLibcxxabi = !!Module["___cxa_demangle"];
 if (hasLibcxxabi) {
  try {
   var buf = _malloc(func.length);
   writeStringToMemory(func.substr(1), buf);
   var status = _malloc(4);
   var ret = Module["___cxa_demangle"](buf, 0, 0, status);
   if (getValue(status, "i32") === 0 && ret) {
    return Pointer_stringify(ret);
   }
  } catch (e) {} finally {
   if (buf) _free(buf);
   if (status) _free(status);
   if (ret) _free(ret);
  }
 }
 var i = 3;
 var basicTypes = {
  "v": "void",
  "b": "bool",
  "c": "char",
  "s": "short",
  "i": "int",
  "l": "long",
  "f": "float",
  "d": "double",
  "w": "wchar_t",
  "a": "signed char",
  "h": "unsigned char",
  "t": "unsigned short",
  "j": "unsigned int",
  "m": "unsigned long",
  "x": "long long",
  "y": "unsigned long long",
  "z": "..."
 };
 var subs = [];
 var first = true;
 function dump(x) {
  if (x) Module.print(x);
  Module.print(func);
  var pre = "";
  for (var a = 0; a < i; a++) pre += " ";
  Module.print(pre + "^");
 }
 function parseNested() {
  i++;
  if (func[i] === "K") i++;
  var parts = [];
  while (func[i] !== "E") {
   if (func[i] === "S") {
    i++;
    var next = func.indexOf("_", i);
    var num = func.substring(i, next) || 0;
    parts.push(subs[num] || "?");
    i = next + 1;
    continue;
   }
   if (func[i] === "C") {
    parts.push(parts[parts.length - 1]);
    i += 2;
    continue;
   }
   var size = parseInt(func.substr(i));
   var pre = size.toString().length;
   if (!size || !pre) {
    i--;
    break;
   }
   var curr = func.substr(i + pre, size);
   parts.push(curr);
   subs.push(curr);
   i += pre + size;
  }
  i++;
  return parts;
 }
 function parse(rawList, limit, allowVoid) {
  limit = limit || Infinity;
  var ret = "", list = [];
  function flushList() {
   return "(" + list.join(", ") + ")";
  }
  var name;
  if (func[i] === "N") {
   name = parseNested().join("::");
   limit--;
   if (limit === 0) return rawList ? [ name ] : name;
  } else {
   if (func[i] === "K" || first && func[i] === "L") i++;
   var size = parseInt(func.substr(i));
   if (size) {
    var pre = size.toString().length;
    name = func.substr(i + pre, size);
    i += pre + size;
   }
  }
  first = false;
  if (func[i] === "I") {
   i++;
   var iList = parse(true);
   var iRet = parse(true, 1, true);
   ret += iRet[0] + " " + name + "<" + iList.join(", ") + ">";
  } else {
   ret = name;
  }
  paramLoop : while (i < func.length && limit-- > 0) {
   var c = func[i++];
   if (c in basicTypes) {
    list.push(basicTypes[c]);
   } else {
    switch (c) {
    case "P":
     list.push(parse(true, 1, true)[0] + "*");
     break;
    case "R":
     list.push(parse(true, 1, true)[0] + "&");
     break;
    case "L":
     {
      i++;
      var end = func.indexOf("E", i);
      var size = end - i;
      list.push(func.substr(i, size));
      i += size + 2;
      break;
     }
    case "A":
     {
      var size = parseInt(func.substr(i));
      i += size.toString().length;
      if (func[i] !== "_") throw "?";
      i++;
      list.push(parse(true, 1, true)[0] + " [" + size + "]");
      break;
     }
    case "E":
     break paramLoop;
    default:
     ret += "?" + c;
     break paramLoop;
    }
   }
  }
  if (!allowVoid && list.length === 1 && list[0] === "void") list = [];
  if (rawList) {
   if (ret) {
    list.push(ret + "?");
   }
   return list;
  } else {
   return ret + flushList();
  }
 }
 var parsed = func;
 try {
  if (func == "Object._main" || func == "_main") {
   return "main()";
  }
  if (typeof func === "number") func = Pointer_stringify(func);
  if (func[0] !== "_") return func;
  if (func[1] !== "_") return func;
  if (func[2] !== "Z") return func;
  switch (func[3]) {
  case "n":
   return "operator new()";
  case "d":
   return "operator delete()";
  }
  parsed = parse();
 } catch (e) {
  parsed += "?";
 }
 if (parsed.indexOf("?") >= 0 && !hasLibcxxabi) {
  Runtime.warnOnce("warning: a problem occurred in builtin C++ name demangling; build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");
 }
 return parsed;
}
function demangleAll(text) {
 return text.replace(/__Z[\w\d_]+/g, (function(x) {
  var y = demangle(x);
  return x === y ? x : x + " [" + y + "]";
 }));
}
function jsStackTrace() {
 var err = new Error;
 if (!err.stack) {
  try {
   throw new Error(0);
  } catch (e) {
   err = e;
  }
  if (!err.stack) {
   return "(no stack trace available)";
  }
 }
 return err.stack.toString();
}
function stackTrace() {
 return demangleAll(jsStackTrace());
}
Module["stackTrace"] = stackTrace;
var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
 if (x % 4096 > 0) {
  x += 4096 - x % 4096;
 }
 return x;
}
var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;
var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false;
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0;
var DYNAMIC_BASE = 0, DYNAMICTOP = 0;
function enlargeMemory() {
 var OLD_TOTAL_MEMORY = TOTAL_MEMORY;
 var LIMIT = Math.pow(2, 31);
 if (DYNAMICTOP >= LIMIT) return false;
 while (TOTAL_MEMORY <= DYNAMICTOP) {
  if (TOTAL_MEMORY < LIMIT / 2) {
   TOTAL_MEMORY = alignMemoryPage(2 * TOTAL_MEMORY);
  } else {
   var last = TOTAL_MEMORY;
   TOTAL_MEMORY = alignMemoryPage((3 * TOTAL_MEMORY + LIMIT) / 4);
   if (TOTAL_MEMORY <= last) return false;
  }
 }
 TOTAL_MEMORY = Math.max(TOTAL_MEMORY, 16 * 1024 * 1024);
 if (TOTAL_MEMORY >= LIMIT) return false;
 try {
  if (ArrayBuffer.transfer) {
   buffer = ArrayBuffer.transfer(buffer, TOTAL_MEMORY);
  } else {
   var oldHEAP8 = HEAP8;
   buffer = new ArrayBuffer(TOTAL_MEMORY);
  }
 } catch (e) {
  return false;
 }
 var success = _emscripten_replace_memory(buffer);
 if (!success) return false;
 Module["buffer"] = buffer;
 Module["HEAP8"] = HEAP8 = new Int8Array(buffer);
 Module["HEAP16"] = HEAP16 = new Int16Array(buffer);
 Module["HEAP32"] = HEAP32 = new Int32Array(buffer);
 Module["HEAPU8"] = HEAPU8 = new Uint8Array(buffer);
 Module["HEAPU16"] = HEAPU16 = new Uint16Array(buffer);
 Module["HEAPU32"] = HEAPU32 = new Uint32Array(buffer);
 Module["HEAPF32"] = HEAPF32 = new Float32Array(buffer);
 Module["HEAPF64"] = HEAPF64 = new Float64Array(buffer);
 if (!ArrayBuffer.transfer) {
  HEAP8.set(oldHEAP8);
 }
 return true;
}
var byteLength;
try {
 byteLength = Function.prototype.call.bind(Object.getOwnPropertyDescriptor(ArrayBuffer.prototype, "byteLength").get);
 byteLength(new ArrayBuffer(4));
} catch (e) {
 byteLength = (function(buffer) {
  return buffer.byteLength;
 });
}
var TOTAL_STACK = Module["TOTAL_STACK"] || 5242880;
var TOTAL_MEMORY = Module["TOTAL_MEMORY"] || 16777216;
var totalMemory = 64 * 1024;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2 * TOTAL_STACK) {
 if (totalMemory < 16 * 1024 * 1024) {
  totalMemory *= 2;
 } else {
  totalMemory += 16 * 1024 * 1024;
 }
}
totalMemory = Math.max(totalMemory, 16 * 1024 * 1024);
if (totalMemory !== TOTAL_MEMORY) {
 TOTAL_MEMORY = totalMemory;
}
assert(typeof Int32Array !== "undefined" && typeof Float64Array !== "undefined" && !!(new Int32Array(1))["subarray"] && !!(new Int32Array(1))["set"], "JS engine does not provide full typed array support");
var buffer;
buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, "Typed arrays 2 must be run on a little-endian system");
Module["HEAP"] = HEAP;
Module["buffer"] = buffer;
Module["HEAP8"] = HEAP8;
Module["HEAP16"] = HEAP16;
Module["HEAP32"] = HEAP32;
Module["HEAPU8"] = HEAPU8;
Module["HEAPU16"] = HEAPU16;
Module["HEAPU32"] = HEAPU32;
Module["HEAPF32"] = HEAPF32;
Module["HEAPF64"] = HEAPF64;
function callRuntimeCallbacks(callbacks) {
 while (callbacks.length > 0) {
  var callback = callbacks.shift();
  if (typeof callback == "function") {
   callback();
   continue;
  }
  var func = callback.func;
  if (typeof func === "number") {
   if (callback.arg === undefined) {
    Runtime.dynCall("v", func);
   } else {
    Runtime.dynCall("vi", func, [ callback.arg ]);
   }
  } else {
   func(callback.arg === undefined ? null : callback.arg);
  }
 }
}
var __ATPRERUN__ = [];
var __ATINIT__ = [];
var __ATMAIN__ = [];
var __ATEXIT__ = [];
var __ATPOSTRUN__ = [];
var runtimeInitialized = false;
var runtimeExited = false;
function preRun() {
 if (Module["preRun"]) {
  if (typeof Module["preRun"] == "function") Module["preRun"] = [ Module["preRun"] ];
  while (Module["preRun"].length) {
   addOnPreRun(Module["preRun"].shift());
  }
 }
 callRuntimeCallbacks(__ATPRERUN__);
}
function ensureInitRuntime() {
 if (runtimeInitialized) return;
 runtimeInitialized = true;
 callRuntimeCallbacks(__ATINIT__);
}
function preMain() {
 callRuntimeCallbacks(__ATMAIN__);
}
function exitRuntime() {
 callRuntimeCallbacks(__ATEXIT__);
 runtimeExited = true;
}
function postRun() {
 if (Module["postRun"]) {
  if (typeof Module["postRun"] == "function") Module["postRun"] = [ Module["postRun"] ];
  while (Module["postRun"].length) {
   addOnPostRun(Module["postRun"].shift());
  }
 }
 callRuntimeCallbacks(__ATPOSTRUN__);
}
function addOnPreRun(cb) {
 __ATPRERUN__.unshift(cb);
}
Module["addOnPreRun"] = addOnPreRun;
function addOnInit(cb) {
 __ATINIT__.unshift(cb);
}
Module["addOnInit"] = addOnInit;
function addOnPreMain(cb) {
 __ATMAIN__.unshift(cb);
}
Module["addOnPreMain"] = addOnPreMain;
function addOnExit(cb) {
 __ATEXIT__.unshift(cb);
}
Module["addOnExit"] = addOnExit;
function addOnPostRun(cb) {
 __ATPOSTRUN__.unshift(cb);
}
Module["addOnPostRun"] = addOnPostRun;
function intArrayFromString(stringy, dontAddNull, length) {
 var len = length > 0 ? length : lengthBytesUTF8(stringy) + 1;
 var u8array = new Array(len);
 var numBytesWritten = stringToUTF8Array(stringy, u8array, 0, u8array.length);
 if (dontAddNull) u8array.length = numBytesWritten;
 return u8array;
}
Module["intArrayFromString"] = intArrayFromString;
function intArrayToString(array) {
 var ret = [];
 for (var i = 0; i < array.length; i++) {
  var chr = array[i];
  if (chr > 255) {
   chr &= 255;
  }
  ret.push(String.fromCharCode(chr));
 }
 return ret.join("");
}
Module["intArrayToString"] = intArrayToString;
function writeStringToMemory(string, buffer, dontAddNull) {
 var array = intArrayFromString(string, dontAddNull);
 var i = 0;
 while (i < array.length) {
  var chr = array[i];
  HEAP8[buffer + i >> 0] = chr;
  i = i + 1;
 }
}
Module["writeStringToMemory"] = writeStringToMemory;
function writeArrayToMemory(array, buffer) {
 for (var i = 0; i < array.length; i++) {
  HEAP8[buffer++ >> 0] = array[i];
 }
}
Module["writeArrayToMemory"] = writeArrayToMemory;
function writeAsciiToMemory(str, buffer, dontAddNull) {
 for (var i = 0; i < str.length; ++i) {
  HEAP8[buffer++ >> 0] = str.charCodeAt(i);
 }
 if (!dontAddNull) HEAP8[buffer >> 0] = 0;
}
Module["writeAsciiToMemory"] = writeAsciiToMemory;
function unSign(value, bits, ignore) {
 if (value >= 0) {
  return value;
 }
 return bits <= 32 ? 2 * Math.abs(1 << bits - 1) + value : Math.pow(2, bits) + value;
}
function reSign(value, bits, ignore) {
 if (value <= 0) {
  return value;
 }
 var half = bits <= 32 ? Math.abs(1 << bits - 1) : Math.pow(2, bits - 1);
 if (value >= half && (bits <= 32 || value > half)) {
  value = -2 * half + value;
 }
 return value;
}
if (!Math["imul"] || Math["imul"](4294967295, 5) !== -5) Math["imul"] = function imul(a, b) {
 var ah = a >>> 16;
 var al = a & 65535;
 var bh = b >>> 16;
 var bl = b & 65535;
 return al * bl + (ah * bl + al * bh << 16) | 0;
};
Math.imul = Math["imul"];
if (!Math["clz32"]) Math["clz32"] = (function(x) {
 x = x >>> 0;
 for (var i = 0; i < 32; i++) {
  if (x & 1 << 31 - i) return i;
 }
 return 32;
});
Math.clz32 = Math["clz32"];
var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;
var Math_clz32 = Math.clz32;
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null;
function getUniqueRunDependency(id) {
 return id;
}
function addRunDependency(id) {
 runDependencies++;
 if (Module["monitorRunDependencies"]) {
  Module["monitorRunDependencies"](runDependencies);
 }
}
Module["addRunDependency"] = addRunDependency;
function removeRunDependency(id) {
 runDependencies--;
 if (Module["monitorRunDependencies"]) {
  Module["monitorRunDependencies"](runDependencies);
 }
 if (runDependencies == 0) {
  if (runDependencyWatcher !== null) {
   clearInterval(runDependencyWatcher);
   runDependencyWatcher = null;
  }
  if (dependenciesFulfilled) {
   var callback = dependenciesFulfilled;
   dependenciesFulfilled = null;
   callback();
  }
 }
}
Module["removeRunDependency"] = removeRunDependency;
Module["preloadedImages"] = {};
Module["preloadedAudios"] = {};
var memoryInitializer = null;
var ASM_CONSTS = [];
STATIC_BASE = 8;
STATICTOP = STATIC_BASE + 48496;
__ATINIT__.push({
 func: (function() {
  __GLOBAL__I_000101();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_maxi_emscr_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_bind_cpp();
 })
}, {
 func: (function() {
  __GLOBAL__sub_I_iostream_cpp();
 })
});
allocate([ 0, 0, 0, 0, 0, 0, 0, 0, 159, 114, 76, 22, 247, 31, 137, 63, 159, 114, 76, 22, 247, 31, 153, 63, 248, 85, 185, 80, 249, 215, 162, 63, 252, 199, 66, 116, 8, 28, 169, 63, 164, 228, 213, 57, 6, 100, 175, 63, 158, 10, 184, 231, 249, 211, 178, 63, 160, 195, 124, 121, 1, 246, 181, 63, 154, 6, 69, 243, 0, 22, 185, 63, 75, 234, 4, 52, 17, 54, 188, 63, 103, 15, 180, 2, 67, 86, 191, 63, 98, 161, 214, 52, 239, 56, 193, 63, 158, 94, 41, 203, 16, 199, 194, 63, 77, 248, 165, 126, 222, 84, 196, 63, 55, 224, 243, 195, 8, 225, 197, 63, 148, 164, 107, 38, 223, 108, 199, 63, 213, 33, 55, 195, 13, 248, 200, 63, 224, 16, 170, 212, 236, 129, 202, 63, 208, 184, 112, 32, 36, 11, 204, 63, 137, 210, 222, 224, 11, 147, 205, 63, 240, 22, 72, 80, 252, 24, 207, 63, 172, 173, 216, 95, 118, 79, 208, 63, 54, 229, 10, 239, 114, 17, 209, 63, 109, 231, 251, 169, 241, 210, 209, 63, 250, 126, 106, 188, 116, 147, 210, 63, 51, 225, 151, 250, 121, 83, 211, 63, 23, 14, 132, 100, 1, 19, 212, 63, 83, 208, 237, 37, 141, 209, 212, 63, 30, 22, 106, 77, 243, 142, 213, 63, 92, 56, 16, 146, 5, 76, 214, 63, 43, 222, 200, 60, 242, 7, 215, 63, 23, 43, 106, 48, 13, 195, 215, 63, 232, 48, 95, 94, 128, 125, 216, 63, 188, 150, 144, 15, 122, 54, 217, 63, 59, 199, 128, 236, 245, 238, 217, 63, 17, 141, 238, 32, 118, 166, 218, 63, 234, 178, 152, 216, 124, 92, 219, 63, 110, 163, 1, 188, 5, 18, 220, 63, 46, 226, 59, 49, 235, 197, 220, 63, 12, 200, 94, 239, 254, 120, 221, 63, 123, 49, 148, 19, 237, 42, 222, 63, 179, 12, 113, 172, 139, 219, 222, 63, 123, 107, 96, 171, 4, 139, 223, 63, 205, 175, 230, 0, 193, 28, 224, 63, 222, 89, 187, 237, 66, 115, 224, 63, 154, 206, 78, 6, 71, 201, 224, 63, 116, 234, 202, 103, 121, 30, 225, 63, 52, 191, 154, 3, 4, 115, 225, 63, 187, 213, 115, 210, 251, 198, 225, 63, 67, 28, 235, 226, 54, 26, 226, 63, 176, 27, 182, 45, 202, 108, 226, 63, 88, 57, 180, 200, 118, 190, 226, 63, 143, 170, 38, 136, 186, 15, 227, 63, 28, 177, 22, 159, 2, 96, 227, 63, 114, 249, 15, 233, 183, 175, 227, 63, 3, 96, 60, 131, 134, 254, 227, 63, 91, 8, 114, 80, 194, 76, 228, 63, 11, 70, 37, 117, 2, 154, 228, 63, 188, 179, 118, 219, 133, 230, 228, 63, 138, 200, 176, 138, 55, 50, 229, 63, 148, 251, 29, 138, 2, 125, 229, 63, 101, 112, 148, 188, 58, 199, 229, 63, 141, 122, 136, 70, 119, 16, 230, 63, 13, 26, 250, 39, 184, 88, 230, 63, 142, 233, 9, 75, 60, 160, 230, 63, 16, 233, 183, 175, 3, 231, 230, 63, 6, 245, 45, 115, 186, 44, 231, 63, 83, 150, 33, 142, 117, 113, 231, 63, 132, 240, 104, 227, 136, 181, 231, 63, 70, 206, 194, 158, 118, 248, 231, 63, 237, 100, 112, 148, 188, 58, 232, 63, 235, 144, 155, 225, 6, 124, 232, 63, 92, 201, 142, 141, 64, 188, 232, 63, 36, 151, 255, 144, 126, 251, 232, 63, 68, 250, 237, 235, 192, 57, 233, 63, 101, 141, 122, 136, 70, 119, 233, 63, 79, 146, 174, 153, 124, 179, 233, 63, 59, 199, 128, 236, 245, 238, 233, 63, 183, 127, 101, 165, 73, 41, 234, 63, 109, 86, 125, 174, 182, 98, 234, 63, 180, 176, 167, 29, 254, 154, 234, 63, 251, 58, 112, 206, 136, 210, 234, 63, 13, 55, 224, 243, 195, 8, 235, 63, 117, 200, 205, 112, 3, 62, 235, 63, 53, 239, 56, 69, 71, 114, 235, 63, 190, 135, 75, 142, 59, 165, 235, 63, 43, 217, 177, 17, 136, 215, 235, 63, 99, 156, 191, 9, 133, 8, 236, 63, 71, 90, 42, 111, 71, 56, 236, 63, 72, 191, 125, 29, 56, 103, 236, 63, 219, 167, 227, 49, 3, 149, 236, 63, 54, 2, 241, 186, 126, 193, 236, 63, 147, 140, 156, 133, 61, 237, 236, 63, 243, 118, 132, 211, 130, 23, 237, 63, 198, 109, 52, 128, 183, 64, 237, 63, 212, 130, 23, 125, 5, 105, 237, 63, 171, 9, 162, 238, 3, 144, 237, 63, 217, 37, 170, 183, 6, 182, 237, 63, 208, 179, 89, 245, 185, 218, 237, 63, 88, 197, 27, 153, 71, 254, 237, 63, 84, 227, 165, 155, 196, 32, 238, 63, 252, 251, 140, 11, 7, 66, 238, 63, 24, 33, 60, 218, 56, 98, 238, 63, 27, 47, 221, 36, 6, 129, 238, 63, 59, 228, 102, 184, 1, 159, 238, 63, 93, 249, 44, 207, 131, 187, 238, 63, 215, 163, 112, 61, 10, 215, 238, 63, 112, 37, 59, 54, 2, 241, 238, 63, 10, 215, 163, 112, 61, 10, 239, 63, 167, 232, 72, 46, 255, 33, 239, 63, 241, 244, 74, 89, 134, 56, 239, 63, 174, 13, 21, 227, 252, 77, 239, 63, 24, 33, 60, 218, 56, 98, 239, 63, 48, 47, 192, 62, 58, 117, 239, 63, 244, 55, 161, 16, 1, 135, 239, 63, 129, 178, 41, 87, 120, 151, 239, 63, 73, 75, 229, 237, 8, 167, 239, 63, 77, 50, 114, 22, 246, 180, 239, 63, 139, 55, 50, 143, 252, 193, 239, 63, 118, 55, 79, 117, 200, 205, 239, 63, 42, 169, 19, 208, 68, 216, 239, 63, 140, 21, 53, 152, 134, 225, 239, 63, 182, 243, 253, 212, 120, 233, 239, 63, 113, 85, 217, 119, 69, 240, 239, 63, 246, 40, 92, 143, 194, 245, 239, 63, 39, 247, 59, 20, 5, 250, 239, 63, 204, 209, 227, 247, 54, 253, 239, 63, 87, 149, 125, 87, 4, 255, 239, 63, 86, 101, 223, 21, 193, 255, 239, 63, 87, 149, 125, 87, 4, 255, 239, 63, 204, 209, 227, 247, 54, 253, 239, 63, 39, 247, 59, 20, 5, 250, 239, 63, 246, 40, 92, 143, 194, 245, 239, 63, 113, 85, 217, 119, 69, 240, 239, 63, 182, 243, 253, 212, 120, 233, 239, 63, 140, 21, 53, 152, 134, 225, 239, 63, 42, 169, 19, 208, 68, 216, 239, 63, 118, 55, 79, 117, 200, 205, 239, 63, 139, 55, 50, 143, 252, 193, 239, 63, 77, 50, 114, 22, 246, 180, 239, 63, 73, 75, 229, 237, 8, 167, 239, 63, 129, 178, 41, 87, 120, 151, 239, 63, 244, 55, 161, 16, 1, 135, 239, 63, 48, 47, 192, 62, 58, 117, 239, 63, 24, 33, 60, 218, 56, 98, 239, 63, 174, 13, 21, 227, 252, 77, 239, 63, 241, 244, 74, 89, 134, 56, 239, 63, 167, 232, 72, 46, 255, 33, 239, 63, 10, 215, 163, 112, 61, 10, 239, 63, 112, 37, 59, 54, 2, 241, 238, 63, 215, 163, 112, 61, 10, 215, 238, 63, 93, 249, 44, 207, 131, 187, 238, 63, 59, 228, 102, 184, 1, 159, 238, 63, 27, 47, 221, 36, 6, 129, 238, 63, 24, 33, 60, 218, 56, 98, 238, 63, 252, 251, 140, 11, 7, 66, 238, 63, 84, 227, 165, 155, 196, 32, 238, 63, 88, 197, 27, 153, 71, 254, 237, 63, 208, 179, 89, 245, 185, 218, 237, 63, 217, 37, 170, 183, 6, 182, 237, 63, 171, 9, 162, 238, 3, 144, 237, 63, 212, 130, 23, 125, 5, 105, 237, 63, 198, 109, 52, 128, 183, 64, 237, 63, 243, 118, 132, 211, 130, 23, 237, 63, 147, 140, 156, 133, 61, 237, 236, 63, 54, 2, 241, 186, 126, 193, 236, 63, 219, 167, 227, 49, 3, 149, 236, 63, 72, 191, 125, 29, 56, 103, 236, 63, 71, 90, 42, 111, 71, 56, 236, 63, 99, 156, 191, 9, 133, 8, 236, 63, 43, 217, 177, 17, 136, 215, 235, 63, 190, 135, 75, 142, 59, 165, 235, 63, 53, 239, 56, 69, 71, 114, 235, 63, 117, 200, 205, 112, 3, 62, 235, 63, 13, 55, 224, 243, 195, 8, 235, 63, 251, 58, 112, 206, 136, 210, 234, 63, 180, 176, 167, 29, 254, 154, 234, 63, 109, 86, 125, 174, 182, 98, 234, 63, 183, 127, 101, 165, 73, 41, 234, 63, 59, 199, 128, 236, 245, 238, 233, 63, 79, 146, 174, 153, 124, 179, 233, 63, 101, 141, 122, 136, 70, 119, 233, 63, 68, 250, 237, 235, 192, 57, 233, 63, 36, 151, 255, 144, 126, 251, 232, 63, 92, 201, 142, 141, 64, 188, 232, 63, 235, 144, 155, 225, 6, 124, 232, 63, 237, 100, 112, 148, 188, 58, 232, 63, 70, 206, 194, 158, 118, 248, 231, 63, 132, 240, 104, 227, 136, 181, 231, 63, 83, 150, 33, 142, 117, 113, 231, 63, 6, 245, 45, 115, 186, 44, 231, 63, 16, 233, 183, 175, 3, 231, 230, 63, 142, 233, 9, 75, 60, 160, 230, 63, 13, 26, 250, 39, 184, 88, 230, 63, 141, 122, 136, 70, 119, 16, 230, 63, 101, 112, 148, 188, 58, 199, 229, 63, 148, 251, 29, 138, 2, 125, 229, 63, 138, 200, 176, 138, 55, 50, 229, 63, 188, 179, 118, 219, 133, 230, 228, 63, 11, 70, 37, 117, 2, 154, 228, 63, 91, 8, 114, 80, 194, 76, 228, 63, 3, 96, 60, 131, 134, 254, 227, 63, 114, 249, 15, 233, 183, 175, 227, 63, 28, 177, 22, 159, 2, 96, 227, 63, 143, 170, 38, 136, 186, 15, 227, 63, 88, 57, 180, 200, 118, 190, 226, 63, 176, 27, 182, 45, 202, 108, 226, 63, 67, 28, 235, 226, 54, 26, 226, 63, 187, 213, 115, 210, 251, 198, 225, 63, 52, 191, 154, 3, 4, 115, 225, 63, 116, 234, 202, 103, 121, 30, 225, 63, 154, 206, 78, 6, 71, 201, 224, 63, 222, 89, 187, 237, 66, 115, 224, 63, 205, 175, 230, 0, 193, 28, 224, 63, 123, 107, 96, 171, 4, 139, 223, 63, 179, 12, 113, 172, 139, 219, 222, 63, 123, 49, 148, 19, 237, 42, 222, 63, 12, 200, 94, 239, 254, 120, 221, 63, 46, 226, 59, 49, 235, 197, 220, 63, 110, 163, 1, 188, 5, 18, 220, 63, 234, 178, 152, 216, 124, 92, 219, 63, 17, 141, 238, 32, 118, 166, 218, 63, 59, 199, 128, 236, 245, 238, 217, 63, 188, 150, 144, 15, 122, 54, 217, 63, 232, 48, 95, 94, 128, 125, 216, 63, 23, 43, 106, 48, 13, 195, 215, 63, 43, 222, 200, 60, 242, 7, 215, 63, 92, 56, 16, 146, 5, 76, 214, 63, 30, 22, 106, 77, 243, 142, 213, 63, 83, 208, 237, 37, 141, 209, 212, 63, 23, 14, 132, 100, 1, 19, 212, 63, 51, 225, 151, 250, 121, 83, 211, 63, 250, 126, 106, 188, 116, 147, 210, 63, 109, 231, 251, 169, 241, 210, 209, 63, 54, 229, 10, 239, 114, 17, 209, 63, 172, 173, 216, 95, 118, 79, 208, 63, 240, 22, 72, 80, 252, 24, 207, 63, 137, 210, 222, 224, 11, 147, 205, 63, 208, 184, 112, 32, 36, 11, 204, 63, 224, 16, 170, 212, 236, 129, 202, 63, 213, 33, 55, 195, 13, 248, 200, 63, 148, 164, 107, 38, 223, 108, 199, 63, 55, 224, 243, 195, 8, 225, 197, 63, 77, 248, 165, 126, 222, 84, 196, 63, 158, 94, 41, 203, 16, 199, 194, 63, 98, 161, 214, 52, 239, 56, 193, 63, 103, 15, 180, 2, 67, 86, 191, 63, 75, 234, 4, 52, 17, 54, 188, 63, 154, 6, 69, 243, 0, 22, 185, 63, 160, 195, 124, 121, 1, 246, 181, 63, 158, 10, 184, 231, 249, 211, 178, 63, 164, 228, 213, 57, 6, 100, 175, 63, 252, 199, 66, 116, 8, 28, 169, 63, 248, 85, 185, 80, 249, 215, 162, 63, 159, 114, 76, 22, 247, 31, 153, 63, 159, 114, 76, 22, 247, 31, 137, 63, 0, 0, 0, 0, 0, 0, 0, 0, 159, 114, 76, 22, 247, 31, 137, 191, 159, 114, 76, 22, 247, 31, 153, 191, 248, 85, 185, 80, 249, 215, 162, 191, 252, 199, 66, 116, 8, 28, 169, 191, 164, 228, 213, 57, 6, 100, 175, 191, 158, 10, 184, 231, 249, 211, 178, 191, 160, 195, 124, 121, 1, 246, 181, 191, 154, 6, 69, 243, 0, 22, 185, 191, 75, 234, 4, 52, 17, 54, 188, 191, 103, 15, 180, 2, 67, 86, 191, 191, 98, 161, 214, 52, 239, 56, 193, 191, 158, 94, 41, 203, 16, 199, 194, 191, 77, 248, 165, 126, 222, 84, 196, 191, 55, 224, 243, 195, 8, 225, 197, 191, 148, 164, 107, 38, 223, 108, 199, 191, 213, 33, 55, 195, 13, 248, 200, 191, 224, 16, 170, 212, 236, 129, 202, 191, 208, 184, 112, 32, 36, 11, 204, 191, 137, 210, 222, 224, 11, 147, 205, 191, 240, 22, 72, 80, 252, 24, 207, 191, 172, 173, 216, 95, 118, 79, 208, 191, 54, 229, 10, 239, 114, 17, 209, 191, 109, 231, 251, 169, 241, 210, 209, 191, 250, 126, 106, 188, 116, 147, 210, 191, 51, 225, 151, 250, 121, 83, 211, 191, 23, 14, 132, 100, 1, 19, 212, 191, 83, 208, 237, 37, 141, 209, 212, 191, 30, 22, 106, 77, 243, 142, 213, 191, 92, 56, 16, 146, 5, 76, 214, 191, 43, 222, 200, 60, 242, 7, 215, 191, 23, 43, 106, 48, 13, 195, 215, 191, 232, 48, 95, 94, 128, 125, 216, 191, 188, 150, 144, 15, 122, 54, 217, 191, 59, 199, 128, 236, 245, 238, 217, 191, 17, 141, 238, 32, 118, 166, 218, 191, 234, 178, 152, 216, 124, 92, 219, 191, 110, 163, 1, 188, 5, 18, 220, 191, 46, 226, 59, 49, 235, 197, 220, 191, 12, 200, 94, 239, 254, 120, 221, 191, 123, 49, 148, 19, 237, 42, 222, 191, 179, 12, 113, 172, 139, 219, 222, 191, 123, 107, 96, 171, 4, 139, 223, 191, 205, 175, 230, 0, 193, 28, 224, 191, 222, 89, 187, 237, 66, 115, 224, 191, 154, 206, 78, 6, 71, 201, 224, 191, 116, 234, 202, 103, 121, 30, 225, 191, 52, 191, 154, 3, 4, 115, 225, 191, 187, 213, 115, 210, 251, 198, 225, 191, 67, 28, 235, 226, 54, 26, 226, 191, 176, 27, 182, 45, 202, 108, 226, 191, 88, 57, 180, 200, 118, 190, 226, 191, 143, 170, 38, 136, 186, 15, 227, 191, 28, 177, 22, 159, 2, 96, 227, 191, 114, 249, 15, 233, 183, 175, 227, 191, 3, 96, 60, 131, 134, 254, 227, 191, 91, 8, 114, 80, 194, 76, 228, 191, 11, 70, 37, 117, 2, 154, 228, 191, 188, 179, 118, 219, 133, 230, 228, 191, 138, 200, 176, 138, 55, 50, 229, 191, 148, 251, 29, 138, 2, 125, 229, 191, 101, 112, 148, 188, 58, 199, 229, 191, 141, 122, 136, 70, 119, 16, 230, 191, 13, 26, 250, 39, 184, 88, 230, 191, 142, 233, 9, 75, 60, 160, 230, 191, 16, 233, 183, 175, 3, 231, 230, 191, 6, 245, 45, 115, 186, 44, 231, 191, 83, 150, 33, 142, 117, 113, 231, 191, 132, 240, 104, 227, 136, 181, 231, 191, 70, 206, 194, 158, 118, 248, 231, 191, 237, 100, 112, 148, 188, 58, 232, 191, 235, 144, 155, 225, 6, 124, 232, 191, 92, 201, 142, 141, 64, 188, 232, 191, 36, 151, 255, 144, 126, 251, 232, 191, 68, 250, 237, 235, 192, 57, 233, 191, 101, 141, 122, 136, 70, 119, 233, 191, 79, 146, 174, 153, 124, 179, 233, 191, 59, 199, 128, 236, 245, 238, 233, 191, 183, 127, 101, 165, 73, 41, 234, 191, 109, 86, 125, 174, 182, 98, 234, 191, 180, 176, 167, 29, 254, 154, 234, 191, 251, 58, 112, 206, 136, 210, 234, 191, 13, 55, 224, 243, 195, 8, 235, 191, 117, 200, 205, 112, 3, 62, 235, 191, 53, 239, 56, 69, 71, 114, 235, 191, 190, 135, 75, 142, 59, 165, 235, 191, 43, 217, 177, 17, 136, 215, 235, 191, 99, 156, 191, 9, 133, 8, 236, 191, 71, 90, 42, 111, 71, 56, 236, 191, 72, 191, 125, 29, 56, 103, 236, 191, 219, 167, 227, 49, 3, 149, 236, 191, 54, 2, 241, 186, 126, 193, 236, 191, 147, 140, 156, 133, 61, 237, 236, 191, 243, 118, 132, 211, 130, 23, 237, 191, 198, 109, 52, 128, 183, 64, 237, 191, 212, 130, 23, 125, 5, 105, 237, 191, 171, 9, 162, 238, 3, 144, 237, 191, 217, 37, 170, 183, 6, 182, 237, 191, 208, 179, 89, 245, 185, 218, 237, 191, 88, 197, 27, 153, 71, 254, 237, 191, 84, 227, 165, 155, 196, 32, 238, 191, 252, 251, 140, 11, 7, 66, 238, 191, 24, 33, 60, 218, 56, 98, 238, 191, 27, 47, 221, 36, 6, 129, 238, 191, 59, 228, 102, 184, 1, 159, 238, 191, 93, 249, 44, 207, 131, 187, 238, 191, 215, 163, 112, 61, 10, 215, 238, 191, 112, 37, 59, 54, 2, 241, 238, 191, 10, 215, 163, 112, 61, 10, 239, 191, 167, 232, 72, 46, 255, 33, 239, 191, 241, 244, 74, 89, 134, 56, 239, 191, 174, 13, 21, 227, 252, 77, 239, 191, 24, 33, 60, 218, 56, 98, 239, 191, 48, 47, 192, 62, 58, 117, 239, 191, 244, 55, 161, 16, 1, 135, 239, 191, 129, 178, 41, 87, 120, 151, 239, 191, 73, 75, 229, 237, 8, 167, 239, 191, 77, 50, 114, 22, 246, 180, 239, 191, 139, 55, 50, 143, 252, 193, 239, 191, 118, 55, 79, 117, 200, 205, 239, 191, 42, 169, 19, 208, 68, 216, 239, 191, 140, 21, 53, 152, 134, 225, 239, 191, 182, 243, 253, 212, 120, 233, 239, 191, 113, 85, 217, 119, 69, 240, 239, 191, 246, 40, 92, 143, 194, 245, 239, 191, 39, 247, 59, 20, 5, 250, 239, 191, 204, 209, 227, 247, 54, 253, 239, 191, 87, 149, 125, 87, 4, 255, 239, 191, 86, 101, 223, 21, 193, 255, 239, 191, 87, 149, 125, 87, 4, 255, 239, 191, 204, 209, 227, 247, 54, 253, 239, 191, 39, 247, 59, 20, 5, 250, 239, 191, 246, 40, 92, 143, 194, 245, 239, 191, 113, 85, 217, 119, 69, 240, 239, 191, 182, 243, 253, 212, 120, 233, 239, 191, 140, 21, 53, 152, 134, 225, 239, 191, 42, 169, 19, 208, 68, 216, 239, 191, 118, 55, 79, 117, 200, 205, 239, 191, 139, 55, 50, 143, 252, 193, 239, 191, 77, 50, 114, 22, 246, 180, 239, 191, 73, 75, 229, 237, 8, 167, 239, 191, 129, 178, 41, 87, 120, 151, 239, 191, 244, 55, 161, 16, 1, 135, 239, 191, 48, 47, 192, 62, 58, 117, 239, 191, 24, 33, 60, 218, 56, 98, 239, 191, 174, 13, 21, 227, 252, 77, 239, 191, 241, 244, 74, 89, 134, 56, 239, 191, 167, 232, 72, 46, 255, 33, 239, 191, 10, 215, 163, 112, 61, 10, 239, 191, 112, 37, 59, 54, 2, 241, 238, 191, 215, 163, 112, 61, 10, 215, 238, 191, 93, 249, 44, 207, 131, 187, 238, 191, 59, 228, 102, 184, 1, 159, 238, 191, 27, 47, 221, 36, 6, 129, 238, 191, 24, 33, 60, 218, 56, 98, 238, 191, 252, 251, 140, 11, 7, 66, 238, 191, 84, 227, 165, 155, 196, 32, 238, 191, 88, 197, 27, 153, 71, 254, 237, 191, 208, 179, 89, 245, 185, 218, 237, 191, 217, 37, 170, 183, 6, 182, 237, 191, 171, 9, 162, 238, 3, 144, 237, 191, 212, 130, 23, 125, 5, 105, 237, 191, 198, 109, 52, 128, 183, 64, 237, 191, 243, 118, 132, 211, 130, 23, 237, 191, 147, 140, 156, 133, 61, 237, 236, 191, 54, 2, 241, 186, 126, 193, 236, 191, 219, 167, 227, 49, 3, 149, 236, 191, 72, 191, 125, 29, 56, 103, 236, 191, 71, 90, 42, 111, 71, 56, 236, 191, 99, 156, 191, 9, 133, 8, 236, 191, 43, 217, 177, 17, 136, 215, 235, 191, 190, 135, 75, 142, 59, 165, 235, 191, 53, 239, 56, 69, 71, 114, 235, 191, 117, 200, 205, 112, 3, 62, 235, 191, 13, 55, 224, 243, 195, 8, 235, 191, 251, 58, 112, 206, 136, 210, 234, 191, 180, 176, 167, 29, 254, 154, 234, 191, 109, 86, 125, 174, 182, 98, 234, 191, 183, 127, 101, 165, 73, 41, 234, 191, 59, 199, 128, 236, 245, 238, 233, 191, 79, 146, 174, 153, 124, 179, 233, 191, 101, 141, 122, 136, 70, 119, 233, 191, 68, 250, 237, 235, 192, 57, 233, 191, 36, 151, 255, 144, 126, 251, 232, 191, 92, 201, 142, 141, 64, 188, 232, 191, 235, 144, 155, 225, 6, 124, 232, 191, 237, 100, 112, 148, 188, 58, 232, 191, 70, 206, 194, 158, 118, 248, 231, 191, 132, 240, 104, 227, 136, 181, 231, 191, 83, 150, 33, 142, 117, 113, 231, 191, 6, 245, 45, 115, 186, 44, 231, 191, 16, 233, 183, 175, 3, 231, 230, 191, 142, 233, 9, 75, 60, 160, 230, 191, 13, 26, 250, 39, 184, 88, 230, 191, 141, 122, 136, 70, 119, 16, 230, 191, 101, 112, 148, 188, 58, 199, 229, 191, 148, 251, 29, 138, 2, 125, 229, 191, 138, 200, 176, 138, 55, 50, 229, 191, 188, 179, 118, 219, 133, 230, 228, 191, 11, 70, 37, 117, 2, 154, 228, 191, 91, 8, 114, 80, 194, 76, 228, 191, 3, 96, 60, 131, 134, 254, 227, 191, 114, 249, 15, 233, 183, 175, 227, 191, 28, 177, 22, 159, 2, 96, 227, 191, 143, 170, 38, 136, 186, 15, 227, 191, 88, 57, 180, 200, 118, 190, 226, 191, 176, 27, 182, 45, 202, 108, 226, 191, 67, 28, 235, 226, 54, 26, 226, 191, 187, 213, 115, 210, 251, 198, 225, 191, 52, 191, 154, 3, 4, 115, 225, 191, 116, 234, 202, 103, 121, 30, 225, 191, 154, 206, 78, 6, 71, 201, 224, 191, 222, 89, 187, 237, 66, 115, 224, 191, 205, 175, 230, 0, 193, 28, 224, 191, 123, 107, 96, 171, 4, 139, 223, 191, 179, 12, 113, 172, 139, 219, 222, 191, 123, 49, 148, 19, 237, 42, 222, 191, 12, 200, 94, 239, 254, 120, 221, 191, 46, 226, 59, 49, 235, 197, 220, 191, 110, 163, 1, 188, 5, 18, 220, 191, 234, 178, 152, 216, 124, 92, 219, 191, 17, 141, 238, 32, 118, 166, 218, 191, 59, 199, 128, 236, 245, 238, 217, 191, 188, 150, 144, 15, 122, 54, 217, 191, 232, 48, 95, 94, 128, 125, 216, 191, 23, 43, 106, 48, 13, 195, 215, 191, 43, 222, 200, 60, 242, 7, 215, 191, 92, 56, 16, 146, 5, 76, 214, 191, 30, 22, 106, 77, 243, 142, 213, 191, 83, 208, 237, 37, 141, 209, 212, 191, 23, 14, 132, 100, 1, 19, 212, 191, 51, 225, 151, 250, 121, 83, 211, 191, 250, 126, 106, 188, 116, 147, 210, 191, 109, 231, 251, 169, 241, 210, 209, 191, 54, 229, 10, 239, 114, 17, 209, 191, 172, 173, 216, 95, 118, 79, 208, 191, 240, 22, 72, 80, 252, 24, 207, 191, 137, 210, 222, 224, 11, 147, 205, 191, 208, 184, 112, 32, 36, 11, 204, 191, 224, 16, 170, 212, 236, 129, 202, 191, 213, 33, 55, 195, 13, 248, 200, 191, 148, 164, 107, 38, 223, 108, 199, 191, 55, 224, 243, 195, 8, 225, 197, 191, 77, 248, 165, 126, 222, 84, 196, 191, 158, 94, 41, 203, 16, 199, 194, 191, 98, 161, 214, 52, 239, 56, 193, 191, 103, 15, 180, 2, 67, 86, 191, 191, 75, 234, 4, 52, 17, 54, 188, 191, 154, 6, 69, 243, 0, 22, 185, 191, 160, 195, 124, 121, 1, 246, 181, 191, 158, 10, 184, 231, 249, 211, 178, 191, 164, 228, 213, 57, 6, 100, 175, 191, 252, 199, 66, 116, 8, 28, 169, 191, 248, 85, 185, 80, 249, 215, 162, 191, 159, 114, 76, 22, 247, 31, 153, 191, 159, 114, 76, 22, 247, 31, 137, 191, 0, 0, 0, 0, 0, 0, 0, 0, 159, 114, 76, 22, 247, 31, 137, 63, 68, 220, 156, 74, 6, 0, 224, 191, 68, 220, 156, 74, 6, 0, 224, 191, 11, 238, 7, 60, 48, 0, 224, 191, 153, 17, 222, 30, 132, 0, 224, 191, 192, 94, 97, 193, 253, 0, 224, 191, 231, 171, 228, 99, 119, 1, 224, 191, 2, 243, 144, 41, 31, 2, 224, 191, 251, 63, 135, 249, 242, 2, 224, 191, 73, 218, 141, 62, 230, 3, 224, 191, 128, 128, 181, 106, 215, 4, 224, 191, 6, 241, 129, 29, 255, 5, 224, 191, 84, 115, 185, 193, 80, 7, 224, 191, 178, 102, 100, 144, 187, 8, 224, 191, 16, 90, 15, 95, 38, 10, 224, 191, 235, 255, 28, 230, 203, 11, 224, 191, 141, 183, 149, 94, 155, 13, 224, 191, 251, 3, 229, 182, 125, 15, 224, 191, 151, 56, 242, 64, 100, 17, 224, 191, 153, 43, 131, 106, 131, 19, 224, 191, 121, 36, 94, 158, 206, 21, 224, 191, 247, 201, 81, 128, 40, 24, 224, 191, 209, 63, 193, 197, 138, 26, 224, 191, 204, 151, 23, 96, 31, 29, 224, 191, 0, 198, 51, 104, 232, 31, 224, 191, 120, 208, 236, 186, 183, 34, 224, 191, 121, 147, 223, 162, 147, 37, 224, 191, 110, 80, 251, 173, 157, 40, 224, 191, 201, 203, 154, 88, 224, 43, 224, 191, 36, 71, 58, 3, 35, 47, 224, 191, 98, 75, 143, 166, 122, 50, 224, 191, 80, 109, 112, 34, 250, 53, 224, 191, 142, 89, 246, 36, 176, 57, 224, 191, 204, 69, 124, 39, 102, 61, 224, 191, 26, 163, 117, 84, 53, 65, 224, 191, 25, 30, 251, 89, 44, 69, 224, 191, 35, 135, 136, 155, 83, 73, 224, 191, 44, 240, 21, 221, 122, 77, 224, 191, 116, 178, 212, 122, 191, 81, 224, 191, 86, 158, 64, 216, 41, 86, 224, 191, 43, 132, 213, 88, 194, 90, 224, 191, 212, 129, 172, 167, 86, 95, 224, 191, 232, 192, 114, 132, 12, 100, 224, 191, 195, 17, 164, 82, 236, 104, 224, 191, 32, 152, 163, 199, 239, 109, 224, 191, 80, 54, 229, 10, 239, 114, 224, 191, 48, 242, 178, 38, 22, 120, 224, 191, 192, 203, 12, 27, 101, 125, 224, 191, 166, 242, 118, 132, 211, 130, 224, 191, 71, 61, 68, 163, 59, 136, 224, 191, 220, 129, 58, 229, 209, 141, 224, 191, 11, 240, 221, 230, 141, 147, 224, 191, 74, 207, 244, 18, 99, 153, 224, 191, 70, 210, 110, 244, 49, 159, 224, 191, 99, 183, 207, 42, 51, 165, 224, 191, 3, 210, 254, 7, 88, 171, 224, 191, 111, 129, 4, 197, 143, 177, 224, 191, 174, 72, 76, 80, 195, 183, 224, 191, 37, 230, 89, 73, 43, 190, 224, 191, 31, 185, 53, 233, 182, 196, 224, 191, 185, 56, 42, 55, 81, 203, 224, 191, 59, 196, 63, 108, 233, 209, 224, 191, 178, 73, 126, 196, 175, 216, 224, 191, 240, 224, 39, 14, 160, 223, 224, 191, 91, 96, 143, 137, 148, 230, 224, 191, 10, 188, 147, 79, 143, 237, 224, 191, 105, 53, 36, 238, 177, 244, 224, 191, 166, 180, 254, 150, 0, 252, 224, 191, 227, 51, 217, 63, 79, 3, 225, 191, 146, 119, 14, 101, 168, 10, 225, 191, 173, 252, 50, 24, 35, 18, 225, 191, 187, 123, 128, 238, 203, 25, 225, 191, 157, 18, 16, 147, 112, 33, 225, 191, 7, 98, 217, 204, 33, 41, 225, 191, 220, 242, 145, 148, 244, 48, 225, 191, 143, 137, 148, 102, 243, 56, 225, 191, 186, 103, 93, 163, 229, 64, 225, 191, 200, 206, 219, 216, 236, 72, 225, 191, 66, 119, 73, 156, 21, 81, 225, 191, 63, 85, 133, 6, 98, 89, 225, 191, 179, 122, 135, 219, 161, 97, 225, 191, 56, 17, 253, 218, 250, 105, 225, 191, 252, 0, 164, 54, 113, 114, 225, 191, 43, 50, 58, 32, 9, 123, 225, 191, 164, 194, 216, 66, 144, 131, 225, 191, 92, 172, 168, 193, 52, 140, 225, 191, 82, 239, 169, 156, 246, 148, 225, 191, 112, 151, 253, 186, 211, 157, 225, 191, 216, 158, 89, 18, 160, 166, 225, 191, 149, 243, 197, 222, 139, 175, 225, 191, 121, 173, 132, 238, 146, 184, 225, 191, 65, 240, 248, 246, 174, 193, 225, 191, 83, 146, 117, 56, 186, 202, 225, 191, 232, 105, 192, 32, 233, 211, 225, 191, 164, 166, 93, 76, 51, 221, 225, 191, 210, 167, 85, 244, 135, 230, 225, 191, 120, 240, 19, 7, 208, 239, 225, 191, 160, 110, 160, 192, 59, 249, 225, 191, 217, 93, 160, 164, 192, 2, 226, 191, 86, 41, 61, 211, 75, 12, 226, 191, 98, 48, 127, 133, 204, 21, 226, 191, 194, 132, 209, 172, 108, 31, 226, 191, 75, 62, 118, 23, 40, 41, 226, 191, 211, 247, 26, 130, 227, 50, 226, 191, 0, 225, 67, 137, 150, 60, 226, 191, 131, 23, 125, 5, 105, 70, 226, 191, 22, 191, 41, 172, 84, 80, 226, 191, 101, 138, 57, 8, 58, 90, 226, 191, 158, 97, 106, 75, 29, 100, 226, 191, 208, 181, 47, 160, 23, 110, 226, 191, 65, 99, 38, 81, 47, 120, 226, 191, 19, 100, 4, 84, 56, 130, 226, 191, 251, 88, 193, 111, 67, 140, 226, 191, 199, 214, 51, 132, 99, 150, 226, 191, 209, 173, 215, 244, 160, 160, 226, 191, 248, 251, 197, 108, 201, 170, 226, 191, 77, 50, 114, 22, 246, 180, 226, 191, 132, 241, 211, 184, 55, 191, 226, 191, 205, 33, 169, 133, 146, 201, 226, 191, 5, 225, 10, 40, 212, 211, 226, 191, 151, 112, 232, 45, 30, 222, 226, 191, 247, 148, 156, 19, 123, 232, 226, 191, 57, 66, 6, 242, 236, 242, 226, 191, 62, 150, 62, 116, 65, 253, 226, 191, 203, 162, 176, 139, 162, 7, 227, 191, 13, 80, 26, 106, 20, 18, 227, 191, 6, 158, 123, 15, 151, 28, 227, 191, 147, 170, 237, 38, 248, 38, 227, 191, 214, 87, 87, 5, 106, 49, 227, 191, 184, 177, 217, 145, 234, 59, 227, 191, 11, 208, 182, 154, 117, 70, 227, 191, 10, 161, 131, 46, 225, 80, 227, 191, 168, 30, 105, 112, 91, 91, 227, 191, 251, 60, 70, 121, 230, 101, 227, 191, 79, 91, 35, 130, 113, 112, 227, 191, 123, 20, 174, 71, 225, 122, 227, 191, 93, 110, 48, 212, 97, 133, 227, 191, 176, 140, 13, 221, 236, 143, 227, 191, 237, 182, 11, 205, 117, 154, 227, 191, 236, 135, 216, 96, 225, 164, 227, 191, 160, 249, 156, 187, 93, 175, 227, 191, 221, 35, 155, 171, 230, 185, 227, 191, 146, 149, 95, 6, 99, 196, 227, 191, 76, 138, 143, 79, 200, 206, 227, 191, 166, 43, 216, 70, 60, 217, 227, 191, 90, 157, 156, 161, 184, 227, 227, 191, 89, 110, 105, 53, 36, 238, 227, 191, 139, 170, 95, 233, 124, 248, 227, 191, 23, 183, 209, 0, 222, 2, 228, 191, 22, 136, 158, 148, 73, 13, 228, 191, 4, 232, 247, 253, 155, 23, 228, 191, 82, 155, 56, 185, 223, 33, 228, 191, 229, 42, 22, 191, 41, 44, 228, 191, 233, 126, 78, 65, 126, 54, 228, 191, 152, 133, 118, 78, 179, 64, 228, 191, 191, 211, 100, 198, 219, 74, 228, 191, 19, 10, 17, 112, 8, 85, 228, 191, 195, 16, 57, 125, 61, 95, 228, 191, 217, 237, 179, 202, 76, 105, 228, 191, 148, 250, 178, 180, 83, 115, 228, 191, 124, 239, 111, 208, 94, 125, 228, 191, 123, 216, 11, 5, 108, 135, 228, 191, 202, 163, 27, 97, 81, 145, 228, 191, 191, 158, 175, 89, 46, 155, 228, 191, 224, 129, 1, 132, 15, 165, 228, 191, 2, 101, 83, 174, 240, 174, 228, 191, 24, 90, 157, 156, 161, 184, 228, 191, 24, 91, 8, 114, 80, 194, 228, 191, 47, 80, 82, 96, 1, 204, 228, 191, 24, 93, 222, 28, 174, 213, 228, 191, 223, 135, 131, 132, 40, 223, 228, 191, 144, 190, 73, 211, 160, 232, 228, 191, 65, 245, 15, 34, 25, 242, 228, 191, 150, 91, 90, 13, 137, 251, 228, 191, 225, 211, 156, 188, 200, 4, 229, 191, 254, 99, 33, 58, 4, 14, 229, 191, 4, 0, 199, 158, 61, 23, 229, 191, 107, 239, 83, 85, 104, 32, 229, 191, 245, 216, 150, 1, 103, 41, 229, 191, 58, 230, 60, 99, 95, 50, 229, 191, 82, 11, 37, 147, 83, 59, 229, 191, 135, 167, 87, 202, 50, 68, 229, 191, 11, 38, 254, 40, 234, 76, 229, 191, 53, 212, 40, 36, 153, 85, 229, 191, 26, 166, 182, 212, 65, 94, 229, 191, 215, 18, 242, 65, 207, 102, 229, 191, 18, 74, 95, 8, 57, 111, 229, 191, 220, 188, 113, 82, 152, 119, 229, 191, 51, 107, 41, 32, 237, 127, 229, 191, 54, 204, 208, 120, 34, 136, 229, 191, 204, 235, 136, 67, 54, 144, 229, 191, 241, 70, 230, 145, 63, 152, 229, 191, 165, 221, 232, 99, 62, 160, 229, 191, 145, 98, 128, 68, 19, 168, 229, 191, 63, 142, 230, 200, 202, 175, 229, 191, 123, 245, 241, 208, 119, 183, 229, 191, 24, 176, 228, 42, 22, 191, 229, 191, 193, 112, 174, 97, 134, 198, 229, 191, 89, 192, 4, 110, 221, 205, 229, 191, 82, 99, 66, 204, 37, 213, 229, 191, 171, 89, 103, 124, 95, 220, 229, 191, 204, 121, 198, 190, 100, 227, 229, 191, 243, 28, 145, 239, 82, 234, 229, 191, 123, 19, 67, 114, 50, 241, 229, 191, 77, 105, 253, 45, 1, 248, 229, 191, 162, 12, 85, 49, 149, 254, 229, 191, 253, 50, 24, 35, 18, 5, 230, 191, 207, 160, 161, 127, 130, 11, 230, 191, 213, 121, 84, 252, 223, 17, 230, 191, 26, 196, 7, 118, 252, 23, 230, 191, 123, 133, 5, 247, 3, 30, 230, 191, 61, 154, 234, 201, 252, 35, 230, 191, 51, 26, 249, 188, 226, 41, 230, 191, 58, 35, 74, 123, 131, 47, 230, 191, 116, 151, 196, 89, 17, 53, 230, 191, 226, 118, 104, 88, 140, 58, 230, 191, 85, 217, 119, 69, 240, 63, 230, 191, 8, 173, 135, 47, 19, 69, 230, 191, 215, 247, 225, 32, 33, 74, 230, 191, 195, 185, 134, 25, 26, 79, 230, 191, 90, 46, 27, 157, 243, 83, 230, 191, 138, 228, 43, 129, 148, 88, 230, 191, 147, 53, 234, 33, 26, 93, 230, 191, 185, 253, 242, 201, 138, 97, 230, 191, 92, 144, 45, 203, 215, 101, 230, 191, 176, 88, 195, 69, 238, 105, 230, 191, 220, 187, 6, 125, 233, 109, 230, 191, 247, 173, 214, 137, 203, 113, 230, 191, 76, 142, 59, 165, 131, 117, 230, 191, 149, 128, 152, 132, 11, 121, 230, 191, 160, 25, 196, 7, 118, 124, 230, 191, 131, 77, 157, 71, 197, 127, 230, 191, 92, 147, 110, 75, 228, 130, 230, 191, 64, 223, 22, 44, 213, 133, 230, 191, 252, 197, 108, 201, 170, 136, 230, 191, 99, 95, 178, 241, 96, 139, 230, 191, 123, 46, 83, 147, 224, 141, 230, 191, 227, 223, 103, 92, 56, 144, 230, 191, 35, 44, 42, 226, 116, 146, 230, 191, 202, 78, 63, 168, 139, 148, 230, 191, 245, 190, 241, 181, 103, 150, 230, 191, 133, 5, 247, 3, 30, 152, 230, 191, 239, 230, 169, 14, 185, 153, 230, 191, 213, 146, 142, 114, 48, 155, 230, 191, 228, 187, 148, 186, 100, 156, 230, 191, 113, 175, 204, 91, 117, 157, 230, 191, 191, 73, 211, 160, 104, 158, 230, 191, 183, 150, 201, 112, 60, 159, 230, 191, 126, 144, 101, 193, 196, 159, 230, 191, 193, 84, 51, 107, 41, 160, 230, 191, 221, 179, 174, 209, 114, 160, 230, 191, 164, 197, 25, 195, 156, 160, 230, 191, 221, 179, 174, 209, 114, 160, 230, 191, 193, 84, 51, 107, 41, 160, 230, 191, 80, 168, 167, 143, 192, 159, 230, 191, 115, 186, 44, 38, 54, 159, 230, 191, 77, 133, 120, 36, 94, 158, 230, 191, 141, 38, 23, 99, 96, 157, 230, 191, 143, 110, 132, 69, 69, 156, 230, 191, 202, 164, 134, 54, 0, 155, 230, 191, 23, 100, 203, 242, 117, 153, 230, 191, 157, 17, 165, 189, 193, 151, 230, 191, 206, 113, 110, 19, 238, 149, 230, 191, 10, 216, 14, 70, 236, 147, 230, 191, 156, 163, 142, 142, 171, 145, 230, 191, 36, 129, 6, 155, 58, 143, 230, 191, 86, 17, 110, 50, 170, 140, 230, 191, 102, 191, 238, 116, 231, 137, 230, 191, 249, 186, 12, 255, 233, 134, 230, 191, 153, 188, 1, 102, 190, 131, 230, 191, 136, 160, 106, 244, 106, 128, 230, 191, 85, 162, 236, 45, 229, 124, 230, 191, 166, 241, 11, 175, 36, 121, 230, 191, 48, 47, 192, 62, 58, 117, 230, 191, 243, 90, 9, 221, 37, 113, 230, 191, 34, 224, 16, 170, 212, 108, 230, 191, 48, 131, 49, 34, 81, 104, 230, 191, 141, 8, 198, 193, 165, 99, 230, 191, 201, 171, 115, 12, 200, 94, 230, 191, 114, 168, 223, 133, 173, 89, 230, 191, 248, 194, 100, 170, 96, 84, 230, 191, 229, 179, 60, 15, 238, 78, 230, 191, 177, 194, 45, 31, 73, 73, 230, 191, 165, 78, 64, 19, 97, 67, 230, 191, 141, 236, 74, 203, 72, 61, 230, 191, 221, 96, 168, 195, 10, 55, 230, 191, 56, 219, 220, 152, 158, 48, 230, 191, 51, 26, 249, 188, 226, 41, 230, 191, 103, 71, 170, 239, 252, 34, 230, 191, 2, 75, 174, 98, 241, 27, 230, 191, 191, 72, 104, 203, 185, 20, 230, 191, 216, 46, 109, 56, 44, 13, 230, 191, 42, 3, 7, 180, 116, 5, 230, 191, 226, 173, 243, 111, 151, 253, 229, 191, 235, 58, 84, 83, 146, 245, 229, 191, 11, 212, 98, 240, 48, 237, 229, 191, 123, 79, 229, 180, 167, 228, 229, 191, 58, 173, 219, 160, 246, 219, 229, 191, 29, 5, 136, 130, 25, 211, 229, 191, 136, 45, 61, 154, 234, 201, 229, 191, 255, 91, 201, 142, 141, 192, 229, 191, 175, 120, 234, 145, 6, 183, 229, 191, 107, 155, 226, 113, 81, 173, 229, 191, 11, 95, 95, 235, 82, 163, 229, 191, 92, 88, 55, 222, 29, 153, 229, 191, 253, 51, 131, 248, 192, 142, 229, 191, 101, 57, 9, 165, 47, 132, 229, 191, 35, 164, 110, 103, 95, 121, 229, 191, 100, 92, 113, 113, 84, 110, 229, 191, 222, 2, 9, 138, 31, 99, 229, 191, 242, 234, 28, 3, 178, 87, 229, 191, 138, 32, 206, 195, 9, 76, 229, 191, 210, 139, 218, 253, 42, 64, 229, 191, 15, 9, 223, 251, 27, 52, 229, 191, 231, 199, 95, 90, 212, 39, 229, 191, 65, 212, 125, 0, 82, 27, 229, 191, 145, 242, 147, 106, 159, 14, 229, 191, 145, 70, 5, 78, 182, 1, 229, 191, 254, 243, 52, 96, 144, 244, 228, 191, 27, 215, 191, 235, 51, 231, 228, 191, 114, 168, 223, 133, 173, 217, 228, 191, 53, 211, 189, 78, 234, 203, 228, 191, 55, 111, 156, 20, 230, 189, 228, 191, 23, 41, 148, 133, 175, 175, 228, 191, 49, 209, 32, 5, 79, 161, 228, 191, 228, 186, 41, 229, 181, 146, 228, 191, 147, 57, 150, 119, 213, 131, 228, 191, 31, 214, 27, 181, 194, 116, 228, 191, 229, 96, 54, 1, 134, 101, 228, 191, 160, 253, 72, 17, 25, 86, 228, 191, 228, 106, 100, 87, 90, 70, 228, 191, 51, 222, 86, 122, 109, 54, 228, 191, 188, 63, 222, 171, 86, 38, 228, 191, 103, 155, 27, 211, 19, 22, 228, 191, 87, 235, 196, 229, 120, 5, 228, 191, 128, 41, 3, 7, 180, 244, 227, 191, 204, 97, 247, 29, 195, 227, 227, 191, 58, 148, 161, 42, 166, 210, 227, 191, 4, 175, 150, 59, 51, 193, 227, 191, 240, 195, 65, 66, 148, 175, 227, 191, 254, 210, 162, 62, 201, 157, 227, 191, 25, 232, 218, 23, 208, 139, 227, 191, 0, 170, 184, 113, 139, 121, 227, 191, 198, 137, 175, 118, 20, 103, 227, 191, 174, 99, 92, 113, 113, 84, 227, 191, 139, 79, 1, 48, 158, 65, 227, 191, 122, 196, 232, 185, 133, 46, 227, 191, 26, 111, 43, 189, 54, 27, 227, 191, 242, 7, 3, 207, 189, 7, 227, 191, 146, 202, 20, 115, 16, 244, 226, 191, 159, 230, 228, 69, 38, 224, 226, 191, 70, 68, 49, 121, 3, 204, 226, 191, 15, 156, 51, 162, 180, 183, 226, 191, 137, 41, 145, 68, 47, 163, 226, 191, 156, 248, 106, 71, 113, 142, 226, 191, 120, 241, 126, 220, 126, 121, 226, 191, 72, 252, 138, 53, 92, 100, 226, 191, 201, 60, 242, 7, 3, 79, 226, 191, 228, 190, 213, 58, 113, 57, 226, 191, 33, 59, 111, 99, 179, 35, 226, 191, 15, 237, 99, 5, 191, 13, 226, 191, 152, 224, 212, 7, 146, 247, 225, 191, 231, 253, 127, 156, 48, 225, 225, 191, 135, 253, 158, 88, 167, 202, 225, 191, 169, 74, 91, 92, 227, 179, 225, 191, 79, 229, 180, 167, 228, 156, 225, 191, 234, 145, 6, 183, 181, 133, 225, 191, 213, 32, 204, 237, 94, 110, 225, 191, 159, 205, 170, 207, 213, 86, 225, 191, 121, 3, 204, 124, 7, 63, 225, 191, 141, 39, 130, 56, 15, 39, 225, 191, 218, 57, 205, 2, 237, 14, 225, 191, 74, 70, 206, 194, 158, 246, 224, 191, 157, 243, 83, 28, 7, 222, 224, 191, 42, 143, 110, 132, 69, 197, 224, 191, 6, 13, 253, 19, 92, 172, 224, 191, 51, 109, 255, 202, 74, 147, 224, 191, 22, 134, 200, 233, 235, 121, 224, 191, 73, 129, 5, 48, 101, 96, 224, 191, 227, 82, 149, 182, 184, 70, 224, 191, 182, 18, 186, 75, 226, 44, 224, 191, 132, 103, 66, 147, 196, 18, 224, 191, 21, 85, 191, 210, 249, 240, 223, 191, 240, 135, 159, 255, 30, 188, 223, 191, 62, 151, 169, 73, 240, 134, 223, 191, 55, 113, 114, 191, 67, 81, 223, 191, 71, 87, 233, 238, 58, 27, 223, 191, 247, 1, 72, 109, 226, 228, 222, 191, 71, 113, 142, 58, 58, 174, 222, 191, 204, 99, 205, 200, 32, 119, 222, 191, 12, 146, 62, 173, 162, 63, 222, 191, 71, 85, 19, 68, 221, 7, 222, 191, 200, 12, 84, 198, 191, 207, 221, 191, 4, 0, 199, 158, 61, 151, 221, 191, 43, 23, 42, 255, 90, 94, 221, 191, 31, 219, 50, 224, 44, 37, 221, 191, 42, 171, 233, 122, 162, 235, 220, 191, 77, 135, 78, 207, 187, 177, 220, 191, 15, 40, 155, 114, 133, 119, 220, 191, 233, 212, 149, 207, 242, 60, 220, 191, 8, 118, 252, 23, 8, 2, 220, 191, 153, 243, 140, 125, 201, 198, 219, 191, 247, 29, 195, 99, 63, 139, 219, 191, 109, 84, 167, 3, 89, 79, 219, 191, 40, 127, 247, 142, 26, 19, 219, 191, 85, 134, 113, 55, 136, 214, 218, 191, 170, 10, 13, 196, 178, 153, 218, 191, 69, 131, 20, 60, 133, 92, 218, 191, 201, 31, 12, 60, 247, 30, 218, 191, 26, 105, 169, 188, 29, 225, 217, 191, 194, 23, 38, 83, 5, 163, 217, 191, 9, 139, 138, 56, 157, 100, 217, 191, 12, 58, 33, 116, 208, 37, 217, 191, 221, 149, 93, 48, 184, 230, 216, 191, 49, 63, 55, 52, 101, 167, 216, 191, 174, 101, 50, 28, 207, 103, 216, 191, 94, 15, 38, 197, 199, 39, 216, 191, 100, 30, 249, 131, 129, 231, 215, 191, 238, 122, 105, 138, 0, 167, 215, 191, 205, 60, 185, 166, 64, 102, 215, 191, 14, 106, 191, 181, 19, 37, 215, 191, 164, 252, 164, 218, 167, 227, 214, 191, 190, 220, 39, 71, 1, 162, 214, 191, 91, 10, 72, 251, 31, 96, 214, 191, 180, 115, 154, 5, 218, 29, 214, 191, 99, 66, 204, 37, 85, 219, 213, 191, 150, 94, 155, 141, 149, 152, 213, 191, 75, 200, 7, 61, 155, 85, 213, 191, 115, 14, 158, 9, 77, 18, 213, 191, 196, 209, 85, 186, 187, 206, 212, 191, 151, 226, 170, 178, 239, 138, 212, 191, 28, 41, 91, 36, 237, 70, 212, 191, 109, 28, 177, 22, 159, 2, 212, 191, 186, 164, 106, 187, 9, 190, 211, 191, 228, 74, 61, 11, 66, 121, 211, 191, 101, 86, 239, 112, 59, 52, 211, 191, 104, 175, 62, 30, 250, 238, 210, 191, 148, 133, 175, 175, 117, 169, 210, 191, 113, 145, 123, 186, 186, 99, 210, 191, 209, 234, 228, 12, 197, 29, 210, 191, 180, 145, 235, 166, 148, 215, 209, 191, 117, 86, 11, 236, 49, 145, 209, 191, 141, 128, 10, 71, 144, 74, 209, 191, 84, 224, 100, 27, 184, 3, 209, 191, 205, 117, 26, 105, 169, 188, 208, 191, 127, 249, 100, 197, 112, 117, 208, 191, 134, 226, 142, 55, 249, 45, 208, 191, 126, 2, 40, 70, 150, 204, 207, 191, 6, 76, 224, 214, 221, 60, 207, 191, 0, 114, 194, 132, 209, 172, 206, 191, 92, 3, 91, 37, 88, 28, 206, 191, 190, 47, 46, 85, 105, 139, 205, 191, 238, 8, 167, 5, 47, 250, 204, 191, 144, 190, 73, 211, 160, 104, 204, 191, 73, 128, 154, 90, 182, 214, 203, 191, 100, 173, 161, 212, 94, 68, 203, 191, 242, 182, 210, 107, 179, 177, 202, 191, 167, 61, 37, 231, 196, 30, 202, 191, 42, 113, 29, 227, 138, 139, 201, 191, 179, 63, 80, 110, 219, 247, 200, 191, 101, 139, 164, 221, 232, 99, 200, 191, 63, 84, 26, 49, 179, 207, 199, 191, 65, 154, 177, 104, 58, 59, 199, 191, 0, 28, 123, 246, 92, 166, 198, 191, 140, 74, 234, 4, 52, 17, 198, 191, 246, 150, 114, 190, 216, 123, 197, 191, 228, 48, 152, 191, 66, 230, 196, 191, 142, 6, 240, 22, 72, 80, 196, 191, 22, 250, 96, 25, 27, 186, 195, 191, 33, 59, 111, 99, 179, 35, 195, 191, 176, 201, 26, 245, 16, 141, 194, 191, 103, 213, 231, 106, 43, 246, 193, 191, 70, 94, 214, 196, 2, 95, 193, 191, 94, 213, 89, 45, 176, 199, 192, 191, 85, 106, 246, 64, 43, 48, 192, 191, 158, 153, 96, 56, 215, 48, 191, 191, 152, 249, 14, 126, 226, 0, 190, 191, 187, 214, 222, 167, 170, 208, 188, 191, 228, 78, 233, 96, 253, 159, 187, 191, 53, 68, 21, 254, 12, 111, 186, 191, 151, 75, 244, 67, 182, 61, 185, 191, 198, 255, 120, 10, 20, 12, 184, 191, 195, 96, 163, 81, 38, 218, 182, 191, 225, 68, 244, 107, 235, 167, 181, 191, 127, 249, 100, 197, 112, 117, 180, 191, 66, 174, 121, 250, 173, 66, 179, 191, 133, 51, 174, 110, 171, 15, 178, 191, 75, 6, 128, 42, 110, 220, 176, 191, 148, 142, 205, 233, 13, 82, 175, 191, 233, 4, 217, 87, 195, 234, 172, 191, 83, 10, 21, 119, 23, 131, 170, 191, 135, 63, 121, 14, 27, 27, 168, 191, 227, 241, 254, 137, 219, 178, 165, 191, 16, 206, 167, 142, 85, 74, 163, 191, 175, 134, 122, 176, 123, 225, 160, 191, 102, 174, 194, 28, 243, 240, 156, 191, 137, 216, 187, 154, 151, 30, 152, 191, 212, 127, 214, 252, 248, 75, 147, 191, 116, 96, 57, 66, 6, 242, 140, 191, 21, 110, 191, 157, 192, 75, 131, 191, 98, 146, 29, 93, 157, 74, 115, 191, 209, 132, 242, 158, 117, 76, 196, 62, 176, 18, 28, 44, 214, 79, 115, 63, 60, 174, 62, 5, 93, 78, 131, 63, 131, 47, 241, 236, 151, 244, 140, 63, 91, 103, 50, 210, 65, 77, 147, 63, 97, 25, 27, 186, 217, 31, 152, 63, 76, 227, 23, 94, 73, 242, 156, 63, 34, 33, 37, 209, 38, 226, 160, 63, 124, 110, 87, 158, 246, 74, 163, 63, 167, 229, 172, 244, 127, 179, 165, 63, 162, 134, 37, 212, 194, 27, 168, 63, 23, 254, 194, 225, 187, 131, 170, 63, 5, 76, 133, 29, 107, 235, 172, 63, 0, 47, 125, 249, 174, 82, 175, 63, 129, 214, 87, 178, 190, 220, 176, 63, 18, 87, 132, 81, 255, 15, 178, 63, 207, 209, 79, 221, 1, 67, 179, 63, 181, 201, 60, 77, 193, 117, 180, 63, 107, 235, 76, 70, 58, 168, 181, 63, 80, 132, 121, 52, 122, 218, 182, 63, 84, 35, 79, 237, 103, 12, 184, 63, 121, 69, 75, 121, 8, 62, 185, 63, 195, 103, 235, 224, 96, 111, 186, 63, 113, 114, 191, 67, 81, 160, 187, 63, 146, 89, 189, 195, 237, 208, 188, 63, 38, 29, 229, 96, 54, 1, 190, 63, 43, 189, 54, 27, 43, 49, 191, 63, 28, 124, 97, 50, 85, 48, 192, 63, 37, 231, 196, 30, 218, 199, 192, 63, 13, 112, 65, 182, 44, 95, 193, 63, 46, 231, 82, 92, 85, 246, 193, 63, 119, 219, 133, 230, 58, 141, 194, 63, 141, 124, 94, 241, 212, 35, 195, 63, 221, 11, 204, 10, 69, 186, 195, 63, 85, 24, 91, 8, 114, 80, 196, 63, 80, 114, 135, 77, 100, 230, 196, 63, 189, 168, 221, 175, 2, 124, 197, 63, 83, 92, 85, 246, 93, 17, 198, 63, 108, 93, 106, 132, 126, 166, 198, 63, 8, 172, 28, 90, 100, 59, 199, 63, 171, 149, 9, 191, 212, 207, 199, 63, 209, 204, 147, 107, 10, 100, 200, 63, 122, 81, 187, 95, 5, 248, 200, 63, 241, 130, 136, 212, 180, 139, 201, 63, 19, 127, 20, 117, 230, 30, 202, 63, 93, 248, 193, 249, 212, 177, 202, 63, 208, 238, 144, 98, 128, 68, 203, 63, 16, 146, 5, 76, 224, 214, 203, 63, 252, 255, 56, 97, 194, 104, 204, 63, 90, 74, 150, 147, 80, 250, 204, 63, 133, 65, 153, 70, 147, 139, 205, 63, 35, 21, 198, 22, 130, 28, 206, 63, 108, 179, 177, 18, 243, 172, 206, 63, 113, 141, 207, 100, 255, 60, 207, 63, 68, 20, 147, 55, 192, 204, 207, 63, 106, 107, 68, 48, 14, 46, 208, 63, 98, 130, 26, 190, 133, 117, 208, 63, 176, 254, 207, 97, 190, 188, 208, 63, 56, 105, 26, 20, 205, 3, 209, 63, 112, 9, 192, 63, 165, 74, 209, 63, 43, 247, 2, 179, 66, 145, 209, 63, 151, 26, 161, 159, 169, 215, 209, 63, 135, 139, 220, 211, 213, 29, 210, 63, 39, 50, 115, 129, 203, 99, 210, 63, 74, 38, 167, 118, 134, 169, 210, 63, 30, 80, 54, 229, 10, 239, 210, 63, 72, 223, 164, 105, 80, 52, 211, 63, 154, 235, 52, 210, 82, 121, 211, 63, 111, 69, 98, 130, 26, 190, 211, 63, 35, 189, 168, 221, 175, 2, 212, 63, 209, 201, 82, 235, 253, 70, 212, 63, 77, 131, 162, 121, 0, 139, 212, 63, 122, 114, 77, 129, 204, 206, 212, 63, 41, 175, 149, 208, 93, 18, 213, 63, 1, 105, 255, 3, 172, 85, 213, 63, 76, 255, 146, 84, 166, 152, 213, 63, 25, 227, 195, 236, 101, 219, 213, 63, 106, 20, 146, 204, 234, 29, 214, 63, 227, 194, 129, 144, 44, 96, 214, 63, 116, 125, 31, 14, 18, 162, 214, 63, 90, 157, 156, 161, 184, 227, 214, 63, 196, 10, 183, 124, 36, 37, 215, 63, 131, 221, 176, 109, 81, 102, 215, 63, 164, 27, 97, 81, 17, 167, 215, 63, 26, 191, 240, 74, 146, 231, 215, 63, 20, 176, 29, 140, 216, 39, 216, 63, 100, 6, 42, 227, 223, 103, 216, 63, 231, 223, 46, 251, 117, 167, 216, 63, 147, 54, 85, 247, 200, 230, 216, 63, 149, 242, 90, 9, 221, 37, 217, 63, 191, 43, 130, 255, 173, 100, 217, 63, 120, 184, 29, 26, 22, 163, 217, 63, 208, 9, 161, 131, 46, 225, 217, 63, 81, 216, 69, 209, 3, 31, 218, 63, 205, 59, 78, 209, 145, 92, 218, 63, 51, 195, 70, 89, 191, 153, 218, 63, 222, 62, 171, 204, 148, 214, 218, 63, 176, 55, 49, 36, 39, 19, 219, 63, 246, 12, 225, 152, 101, 79, 219, 63, 128, 214, 252, 248, 75, 139, 219, 63, 33, 172, 198, 18, 214, 198, 219, 63, 144, 46, 54, 173, 20, 2, 220, 63, 113, 141, 207, 100, 255, 60, 220, 63, 152, 224, 212, 7, 146, 119, 220, 63, 213, 63, 136, 100, 200, 177, 220, 63, 178, 99, 35, 16, 175, 235, 220, 63, 167, 147, 108, 117, 57, 37, 221, 63, 179, 207, 99, 148, 103, 94, 221, 63, 141, 184, 0, 52, 74, 151, 221, 63, 35, 221, 207, 41, 200, 207, 221, 63, 162, 37, 143, 167, 229, 7, 222, 63, 148, 74, 120, 66, 175, 63, 222, 63, 84, 28, 7, 94, 45, 119, 222, 63, 162, 65, 10, 158, 66, 174, 222, 63, 128, 186, 129, 2, 239, 228, 222, 63, 162, 39, 101, 82, 67, 27, 223, 63, 191, 41, 172, 84, 80, 81, 223, 63, 153, 103, 37, 173, 248, 134, 223, 63, 121, 64, 217, 148, 43, 188, 223, 63, 157, 13, 249, 103, 6, 241, 223, 63, 200, 67, 223, 221, 202, 18, 224, 63, 227, 250, 119, 125, 230, 44, 224, 63, 16, 59, 83, 232, 188, 70, 224, 63, 119, 105, 195, 97, 105, 96, 224, 63, 68, 110, 134, 27, 240, 121, 224, 63, 97, 85, 189, 252, 78, 147, 224, 63, 52, 245, 186, 69, 96, 172, 224, 63, 87, 119, 44, 182, 73, 197, 224, 63, 203, 219, 17, 78, 11, 222, 224, 63, 119, 46, 140, 244, 162, 246, 224, 63, 8, 34, 139, 52, 241, 14, 225, 63, 187, 15, 64, 106, 19, 39, 225, 63, 167, 235, 137, 174, 11, 63, 225, 63, 181, 193, 137, 232, 215, 86, 225, 63, 3, 9, 138, 31, 99, 110, 225, 63, 24, 122, 196, 232, 185, 133, 225, 63, 125, 205, 114, 217, 232, 156, 225, 63, 215, 50, 25, 142, 231, 179, 225, 63, 157, 241, 125, 113, 169, 202, 225, 63, 254, 241, 94, 181, 50, 225, 225, 63, 174, 212, 179, 32, 148, 247, 225, 63, 38, 225, 66, 30, 193, 13, 226, 63, 56, 47, 78, 124, 181, 35, 226, 63, 17, 167, 147, 108, 117, 57, 226, 63, 224, 48, 209, 32, 5, 79, 226, 63, 117, 228, 72, 103, 96, 100, 226, 63, 142, 229, 93, 245, 128, 121, 226, 63, 179, 236, 73, 96, 115, 142, 226, 63, 159, 29, 112, 93, 49, 163, 226, 63, 37, 144, 18, 187, 182, 183, 226, 63, 92, 56, 16, 146, 5, 204, 226, 63, 182, 218, 195, 94, 40, 224, 226, 63, 169, 190, 243, 139, 18, 244, 226, 63, 9, 252, 225, 231, 191, 7, 227, 63, 48, 99, 10, 214, 56, 27, 227, 63, 145, 184, 199, 210, 135, 46, 227, 63, 139, 79, 1, 48, 158, 65, 227, 63, 197, 87, 59, 138, 115, 84, 227, 63, 198, 137, 175, 118, 20, 103, 227, 63, 23, 158, 151, 138, 141, 121, 227, 63, 47, 220, 185, 48, 210, 139, 227, 63, 21, 199, 129, 87, 203, 157, 227, 63, 240, 195, 65, 66, 148, 175, 227, 63, 26, 163, 117, 84, 53, 193, 227, 63, 58, 148, 161, 42, 166, 210, 227, 63, 204, 97, 247, 29, 195, 227, 227, 63, 128, 41, 3, 7, 180, 244, 227, 63, 110, 223, 163, 254, 122, 5, 228, 63, 126, 143, 250, 235, 21, 22, 228, 63, 211, 51, 189, 196, 88, 38, 228, 63, 74, 210, 53, 147, 111, 54, 228, 63, 228, 106, 100, 87, 90, 70, 228, 63, 160, 253, 72, 17, 25, 86, 228, 63, 229, 96, 54, 1, 134, 101, 228, 63, 31, 214, 27, 181, 194, 116, 228, 63, 147, 57, 150, 119, 213, 131, 228, 63, 228, 186, 41, 229, 181, 146, 228, 63, 49, 209, 32, 5, 79, 161, 228, 63, 23, 41, 148, 133, 175, 175, 228, 63, 55, 111, 156, 20, 230, 189, 228, 63, 53, 211, 189, 78, 234, 203, 228, 63, 114, 168, 223, 133, 173, 217, 228, 63, 27, 215, 191, 235, 51, 231, 228, 63, 254, 243, 52, 96, 144, 244, 228, 63, 145, 70, 5, 78, 182, 1, 229, 63, 145, 242, 147, 106, 159, 14, 229, 63, 65, 212, 125, 0, 82, 27, 229, 63, 231, 199, 95, 90, 212, 39, 229, 63, 15, 9, 223, 251, 27, 52, 229, 63, 210, 139, 218, 253, 42, 64, 229, 63, 138, 32, 206, 195, 9, 76, 229, 63, 242, 234, 28, 3, 178, 87, 229, 63, 222, 2, 9, 138, 31, 99, 229, 63, 100, 92, 113, 113, 84, 110, 229, 63, 35, 164, 110, 103, 95, 121, 229, 63, 101, 57, 9, 165, 47, 132, 229, 63, 253, 51, 131, 248, 192, 142, 229, 63, 92, 88, 55, 222, 29, 153, 229, 63, 11, 95, 95, 235, 82, 163, 229, 63, 107, 155, 226, 113, 81, 173, 229, 63, 175, 120, 234, 145, 6, 183, 229, 63, 255, 91, 201, 142, 141, 192, 229, 63, 136, 45, 61, 154, 234, 201, 229, 63, 29, 5, 136, 130, 25, 211, 229, 63, 58, 173, 219, 160, 246, 219, 229, 63, 123, 79, 229, 180, 167, 228, 229, 63, 11, 212, 98, 240, 48, 237, 229, 63, 235, 58, 84, 83, 146, 245, 229, 63, 226, 173, 243, 111, 151, 253, 229, 63, 42, 3, 7, 180, 116, 5, 230, 63, 216, 46, 109, 56, 44, 13, 230, 63, 191, 72, 104, 203, 185, 20, 230, 63, 2, 75, 174, 98, 241, 27, 230, 63, 103, 71, 170, 239, 252, 34, 230, 63, 51, 26, 249, 188, 226, 41, 230, 63, 56, 219, 220, 152, 158, 48, 230, 63, 221, 96, 168, 195, 10, 55, 230, 63, 141, 236, 74, 203, 72, 61, 230, 63, 165, 78, 64, 19, 97, 67, 230, 63, 200, 182, 12, 56, 75, 73, 230, 63, 229, 179, 60, 15, 238, 78, 230, 63, 248, 194, 100, 170, 96, 84, 230, 63, 114, 168, 223, 133, 173, 89, 230, 63, 201, 171, 115, 12, 200, 94, 230, 63, 141, 8, 198, 193, 165, 99, 230, 63, 48, 131, 49, 34, 81, 104, 230, 63, 57, 212, 239, 194, 214, 108, 230, 63, 243, 90, 9, 221, 37, 113, 230, 63, 48, 47, 192, 62, 58, 117, 230, 63, 166, 241, 11, 175, 36, 121, 230, 63, 85, 162, 236, 45, 229, 124, 230, 63, 159, 148, 73, 13, 109, 128, 230, 63, 153, 188, 1, 102, 190, 131, 230, 63, 249, 186, 12, 255, 233, 134, 230, 63, 102, 191, 238, 116, 231, 137, 230, 63, 86, 17, 110, 50, 170, 140, 230, 63, 36, 129, 6, 155, 58, 143, 230, 63, 156, 163, 142, 142, 171, 145, 230, 63, 10, 216, 14, 70, 236, 147, 230, 63, 206, 113, 110, 19, 238, 149, 230, 63, 157, 17, 165, 189, 193, 151, 230, 63, 23, 100, 203, 242, 117, 153, 230, 63, 225, 152, 101, 79, 2, 155, 230, 63, 143, 110, 132, 69, 69, 156, 230, 63, 164, 26, 246, 123, 98, 157, 230, 63, 77, 133, 120, 36, 94, 158, 230, 63, 138, 174, 11, 63, 56, 159, 230, 63, 103, 156, 134, 168, 194, 159, 230, 63, 193, 84, 51, 107, 41, 160, 230, 63, 221, 179, 174, 209, 114, 160, 230, 63, 164, 197, 25, 195, 156, 160, 230, 63, 221, 179, 174, 209, 114, 160, 230, 63, 193, 84, 51, 107, 41, 160, 230, 63, 126, 144, 101, 193, 196, 159, 230, 63, 206, 138, 168, 137, 62, 159, 230, 63, 213, 61, 178, 185, 106, 158, 230, 63, 113, 175, 204, 91, 117, 157, 230, 63, 251, 175, 115, 211, 102, 156, 230, 63, 236, 134, 109, 139, 50, 155, 230, 63, 239, 230, 169, 14, 185, 153, 230, 63, 156, 249, 213, 28, 32, 152, 230, 63, 11, 179, 208, 206, 105, 150, 230, 63, 225, 66, 30, 193, 141, 148, 230, 63, 35, 44, 42, 226, 116, 146, 230, 63, 227, 223, 103, 92, 56, 144, 230, 63, 146, 34, 50, 172, 226, 141, 230, 63 ], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
allocate([ 122, 83, 145, 10, 99, 139, 230, 63, 19, 186, 75, 226, 172, 136, 230, 63, 64, 223, 22, 44, 213, 133, 230, 63, 92, 147, 110, 75, 228, 130, 230, 63, 131, 77, 157, 71, 197, 127, 230, 63, 183, 13, 163, 32, 120, 124, 230, 63, 149, 128, 152, 132, 11, 121, 230, 63, 98, 130, 26, 190, 133, 117, 230, 63, 14, 162, 181, 162, 205, 113, 230, 63, 220, 187, 6, 125, 233, 109, 230, 63, 199, 76, 162, 94, 240, 105, 230, 63, 92, 144, 45, 203, 215, 101, 230, 63, 208, 241, 209, 226, 140, 97, 230, 63, 170, 41, 201, 58, 28, 93, 230, 63, 161, 216, 10, 154, 150, 88, 230, 63, 112, 34, 250, 181, 245, 83, 230, 63, 195, 185, 134, 25, 26, 79, 230, 63, 215, 247, 225, 32, 33, 74, 230, 63, 31, 161, 102, 72, 21, 69, 230, 63, 85, 217, 119, 69, 240, 63, 230, 63, 249, 106, 71, 113, 142, 58, 230, 63, 139, 139, 163, 114, 19, 53, 230, 63, 80, 23, 41, 148, 133, 47, 230, 63, 51, 26, 249, 188, 226, 41, 230, 63, 84, 142, 201, 226, 254, 35, 230, 63, 146, 121, 228, 15, 6, 30, 230, 63, 26, 196, 7, 118, 252, 23, 230, 63, 236, 109, 51, 21, 226, 17, 230, 63, 207, 160, 161, 127, 130, 11, 230, 63, 19, 39, 247, 59, 20, 5, 230, 63, 162, 12, 85, 49, 149, 254, 229, 63, 100, 93, 220, 70, 3, 248, 229, 63, 123, 19, 67, 114, 50, 241, 229, 63, 243, 28, 145, 239, 82, 234, 229, 63, 227, 109, 165, 215, 102, 227, 229, 63, 194, 77, 70, 149, 97, 220, 229, 63, 105, 87, 33, 229, 39, 213, 229, 63, 89, 192, 4, 110, 221, 205, 229, 63, 216, 100, 141, 122, 136, 198, 229, 63, 47, 164, 195, 67, 24, 191, 229, 63, 146, 233, 208, 233, 121, 183, 229, 63, 86, 130, 197, 225, 204, 175, 229, 63, 168, 86, 95, 93, 21, 168, 229, 63, 165, 221, 232, 99, 62, 160, 229, 63, 8, 59, 197, 170, 65, 152, 229, 63, 227, 223, 103, 92, 56, 144, 229, 63, 77, 192, 175, 145, 36, 136, 229, 63, 74, 95, 8, 57, 239, 127, 229, 63, 220, 188, 113, 82, 152, 119, 229, 63, 18, 74, 95, 8, 57, 111, 229, 63, 238, 6, 209, 90, 209, 102, 229, 63, 49, 154, 149, 237, 67, 94, 229, 63, 75, 200, 7, 61, 155, 85, 229, 63, 34, 26, 221, 65, 236, 76, 229, 63, 157, 155, 54, 227, 52, 68, 229, 63, 105, 255, 3, 172, 85, 59, 229, 63, 81, 218, 27, 124, 97, 50, 229, 63, 12, 205, 117, 26, 105, 41, 229, 63, 130, 227, 50, 110, 106, 32, 229, 63, 27, 244, 165, 183, 63, 23, 229, 63, 21, 88, 0, 83, 6, 14, 229, 63, 225, 211, 156, 188, 200, 4, 229, 63, 150, 91, 90, 13, 137, 251, 228, 63, 65, 245, 15, 34, 25, 242, 228, 63, 167, 178, 40, 236, 162, 232, 228, 63, 223, 135, 131, 132, 40, 223, 228, 63, 47, 81, 189, 53, 176, 213, 228, 63, 47, 80, 82, 96, 1, 204, 228, 63, 47, 79, 231, 138, 82, 194, 228, 63, 47, 78, 124, 181, 163, 184, 228, 63, 25, 89, 50, 199, 242, 174, 228, 63, 224, 129, 1, 132, 15, 165, 228, 63, 213, 146, 142, 114, 48, 155, 228, 63, 202, 163, 27, 97, 81, 145, 228, 63, 146, 204, 234, 29, 110, 135, 228, 63, 124, 239, 111, 208, 94, 125, 228, 63, 170, 238, 145, 205, 85, 115, 228, 63, 239, 225, 146, 227, 78, 105, 228, 63, 195, 16, 57, 125, 61, 95, 228, 63, 42, 254, 239, 136, 10, 85, 228, 63, 214, 199, 67, 223, 221, 74, 228, 63, 175, 121, 85, 103, 181, 64, 228, 63, 233, 126, 78, 65, 126, 54, 228, 63, 251, 30, 245, 215, 43, 44, 228, 63, 105, 143, 23, 210, 225, 33, 228, 63, 26, 220, 214, 22, 158, 23, 228, 63, 22, 136, 158, 148, 73, 13, 228, 63, 23, 183, 209, 0, 222, 2, 228, 63, 139, 170, 95, 233, 124, 248, 227, 63, 89, 110, 105, 53, 36, 238, 227, 63, 90, 157, 156, 161, 184, 227, 227, 63, 166, 43, 216, 70, 60, 217, 227, 63, 99, 126, 110, 104, 202, 206, 227, 63, 169, 137, 62, 31, 101, 196, 227, 63, 221, 35, 155, 171, 230, 185, 227, 63, 183, 237, 123, 212, 95, 175, 227, 63, 3, 124, 183, 121, 227, 164, 227, 63, 237, 182, 11, 205, 117, 154, 227, 63, 199, 128, 236, 245, 238, 143, 227, 63, 93, 110, 48, 212, 97, 133, 227, 63, 146, 8, 141, 96, 227, 122, 227, 63, 102, 79, 2, 155, 115, 112, 227, 63, 251, 60, 70, 121, 230, 101, 227, 63, 190, 18, 72, 137, 93, 91, 227, 63, 10, 161, 131, 46, 225, 80, 227, 63, 11, 208, 182, 154, 117, 70, 227, 63, 206, 165, 184, 170, 236, 59, 227, 63, 214, 87, 87, 5, 106, 49, 227, 63, 170, 158, 204, 63, 250, 38, 227, 63, 6, 158, 123, 15, 151, 28, 227, 63, 13, 80, 26, 106, 20, 18, 227, 63, 203, 162, 176, 139, 162, 7, 227, 63, 62, 150, 62, 116, 65, 253, 226, 63, 57, 66, 6, 242, 236, 242, 226, 63, 13, 137, 123, 44, 125, 232, 226, 63, 174, 100, 199, 70, 32, 222, 226, 63, 27, 213, 233, 64, 214, 211, 226, 63, 205, 33, 169, 133, 146, 201, 226, 63, 155, 229, 178, 209, 57, 191, 226, 63, 99, 38, 81, 47, 248, 180, 226, 63, 15, 240, 164, 133, 203, 170, 226, 63, 209, 173, 215, 244, 160, 160, 226, 63, 222, 202, 18, 157, 101, 150, 226, 63, 18, 77, 160, 136, 69, 140, 226, 63, 42, 88, 227, 108, 58, 130, 226, 63, 88, 87, 5, 106, 49, 120, 226, 63, 208, 181, 47, 160, 23, 110, 226, 63, 158, 97, 106, 75, 29, 100, 226, 63, 124, 126, 24, 33, 60, 90, 226, 63, 45, 179, 8, 197, 86, 80, 226, 63, 131, 23, 125, 5, 105, 70, 226, 63, 23, 213, 34, 162, 152, 60, 226, 63, 234, 235, 249, 154, 229, 50, 226, 63, 97, 50, 85, 48, 42, 41, 226, 63, 217, 120, 176, 197, 110, 31, 226, 63, 98, 48, 127, 133, 204, 21, 226, 63, 109, 29, 28, 236, 77, 12, 226, 63, 240, 81, 127, 189, 194, 2, 226, 63, 160, 110, 160, 192, 59, 249, 225, 63, 143, 228, 242, 31, 210, 239, 225, 63, 233, 155, 52, 13, 138, 230, 225, 63, 164, 166, 93, 76, 51, 221, 225, 63, 255, 93, 159, 57, 235, 211, 225, 63, 106, 134, 84, 81, 188, 202, 225, 63, 65, 240, 248, 246, 174, 193, 225, 63, 144, 161, 99, 7, 149, 184, 225, 63, 149, 243, 197, 222, 139, 175, 225, 63, 216, 158, 89, 18, 160, 166, 225, 63, 112, 151, 253, 186, 211, 157, 225, 63, 82, 239, 169, 156, 246, 148, 225, 63, 92, 172, 168, 193, 52, 140, 225, 63, 164, 194, 216, 66, 144, 131, 225, 63, 43, 50, 58, 32, 9, 123, 225, 63, 252, 0, 164, 54, 113, 114, 225, 63, 56, 17, 253, 218, 250, 105, 225, 63, 179, 122, 135, 219, 161, 97, 225, 63, 63, 85, 133, 6, 98, 89, 225, 63, 66, 119, 73, 156, 21, 81, 225, 63, 223, 194, 186, 241, 238, 72, 225, 63, 209, 91, 60, 188, 231, 64, 225, 63, 143, 137, 148, 102, 243, 56, 225, 63, 220, 242, 145, 148, 244, 48, 225, 63, 7, 98, 217, 204, 33, 41, 225, 63, 157, 18, 16, 147, 112, 33, 225, 63, 210, 111, 95, 7, 206, 25, 225, 63, 173, 252, 50, 24, 35, 18, 225, 63, 146, 119, 14, 101, 168, 10, 225, 63, 227, 51, 217, 63, 79, 3, 225, 63, 166, 180, 254, 150, 0, 252, 224, 63, 105, 53, 36, 238, 177, 244, 224, 63, 10, 188, 147, 79, 143, 237, 224, 63, 91, 96, 143, 137, 148, 230, 224, 63, 240, 224, 39, 14, 160, 223, 224, 63, 178, 73, 126, 196, 175, 216, 224, 63, 59, 196, 63, 108, 233, 209, 224, 63, 185, 56, 42, 55, 81, 203, 224, 63, 54, 173, 20, 2, 185, 196, 224, 63, 37, 230, 89, 73, 43, 190, 224, 63, 174, 72, 76, 80, 195, 183, 224, 63, 111, 129, 4, 197, 143, 177, 224, 63, 3, 210, 254, 7, 88, 171, 224, 63, 99, 183, 207, 42, 51, 165, 224, 63, 70, 210, 110, 244, 49, 159, 224, 63, 74, 207, 244, 18, 99, 153, 224, 63, 11, 240, 221, 230, 141, 147, 224, 63, 220, 129, 58, 229, 209, 141, 224, 63, 71, 61, 68, 163, 59, 136, 224, 63, 166, 242, 118, 132, 211, 130, 224, 63, 192, 203, 12, 27, 101, 125, 224, 63, 71, 230, 145, 63, 24, 120, 224, 63, 80, 54, 229, 10, 239, 114, 224, 63, 32, 152, 163, 199, 239, 109, 224, 63, 195, 17, 164, 82, 236, 104, 224, 63, 232, 192, 114, 132, 12, 100, 224, 63, 212, 129, 172, 167, 86, 95, 224, 63, 43, 132, 213, 88, 194, 90, 224, 63, 86, 158, 64, 216, 41, 86, 224, 63, 116, 178, 212, 122, 191, 81, 224, 63, 44, 240, 21, 221, 122, 77, 224, 63, 35, 135, 136, 155, 83, 73, 224, 63, 25, 30, 251, 89, 44, 69, 224, 63, 26, 163, 117, 84, 53, 65, 224, 63, 204, 69, 124, 39, 102, 61, 224, 63, 142, 89, 246, 36, 176, 57, 224, 63, 80, 109, 112, 34, 250, 53, 224, 63, 98, 75, 143, 166, 122, 50, 224, 63, 36, 71, 58, 3, 35, 47, 224, 63, 201, 203, 154, 88, 224, 43, 224, 63, 110, 80, 251, 173, 157, 40, 224, 63, 121, 147, 223, 162, 147, 37, 224, 63, 98, 220, 13, 162, 181, 34, 224, 63, 0, 198, 51, 104, 232, 31, 224, 63, 204, 151, 23, 96, 31, 29, 224, 63, 209, 63, 193, 197, 138, 26, 224, 63, 247, 201, 81, 128, 40, 24, 224, 63, 121, 36, 94, 158, 206, 21, 224, 63, 153, 43, 131, 106, 131, 19, 224, 63, 151, 56, 242, 64, 100, 17, 224, 63, 251, 3, 229, 182, 125, 15, 224, 63, 141, 183, 149, 94, 155, 13, 224, 63, 235, 255, 28, 230, 203, 11, 224, 63, 16, 90, 15, 95, 38, 10, 224, 63, 178, 102, 100, 144, 187, 8, 224, 63, 84, 115, 185, 193, 80, 7, 224, 63, 6, 241, 129, 29, 255, 5, 224, 63, 128, 128, 181, 106, 215, 4, 224, 63, 73, 218, 141, 62, 230, 3, 224, 63, 251, 63, 135, 249, 242, 2, 224, 63, 2, 243, 144, 41, 31, 2, 224, 63, 231, 171, 228, 99, 119, 1, 224, 63, 192, 94, 97, 193, 253, 0, 224, 63, 153, 17, 222, 30, 132, 0, 224, 63, 11, 238, 7, 60, 48, 0, 224, 63, 68, 220, 156, 74, 6, 0, 224, 63, 68, 220, 156, 74, 6, 0, 224, 63, 0, 0, 0, 0, 0, 0, 0, 0, 111, 183, 36, 7, 236, 82, 33, 64, 214, 54, 197, 227, 162, 90, 34, 64, 8, 118, 252, 23, 8, 114, 35, 64, 154, 153, 153, 153, 153, 153, 36, 64, 218, 113, 195, 239, 166, 211, 37, 64, 71, 114, 249, 15, 233, 31, 39, 64, 0, 0, 0, 0, 0, 128, 40, 64, 28, 64, 191, 239, 223, 244, 41, 64, 0, 0, 0, 0, 0, 128, 43, 64, 169, 78, 7, 178, 158, 34, 45, 64, 0, 139, 252, 250, 33, 222, 46, 64, 106, 78, 94, 100, 2, 90, 48, 64, 111, 183, 36, 7, 236, 82, 49, 64, 214, 54, 197, 227, 162, 90, 50, 64, 8, 118, 252, 23, 8, 114, 51, 64, 66, 64, 190, 132, 10, 154, 52, 64, 58, 122, 252, 222, 166, 211, 53, 64, 232, 105, 192, 32, 233, 31, 55, 64, 0, 0, 0, 0, 0, 128, 56, 64, 189, 55, 134, 0, 224, 244, 57, 64, 0, 0, 0, 0, 0, 128, 59, 64, 74, 70, 206, 194, 158, 34, 61, 64, 0, 139, 252, 250, 33, 222, 62, 64, 154, 210, 250, 91, 2, 90, 64, 64, 159, 59, 193, 254, 235, 82, 65, 64, 214, 54, 197, 227, 162, 90, 66, 64, 216, 241, 95, 32, 8, 114, 67, 64, 114, 196, 90, 124, 10, 154, 68, 64, 58, 122, 252, 222, 166, 211, 69, 64, 232, 105, 192, 32, 233, 31, 71, 64, 0, 0, 0, 0, 0, 128, 72, 64, 189, 55, 134, 0, 224, 244, 73, 64, 0, 0, 0, 0, 0, 128, 75, 64, 74, 70, 206, 194, 158, 34, 77, 64, 209, 6, 96, 3, 34, 222, 78, 64, 130, 144, 44, 96, 2, 90, 80, 64, 159, 59, 193, 254, 235, 82, 81, 64, 238, 120, 147, 223, 162, 90, 82, 64, 216, 241, 95, 32, 8, 114, 83, 64, 90, 130, 140, 128, 10, 154, 84, 64, 58, 122, 252, 222, 166, 211, 85, 64, 232, 105, 192, 32, 233, 31, 87, 64, 117, 90, 183, 65, 237, 127, 88, 64, 189, 55, 134, 0, 224, 244, 89, 64, 0, 0, 0, 0, 0, 128, 91, 64, 97, 136, 156, 190, 158, 34, 93, 64, 233, 72, 46, 255, 33, 222, 94, 64, 130, 144, 44, 96, 2, 90, 96, 64, 147, 26, 218, 0, 236, 82, 97, 64, 238, 120, 147, 223, 162, 90, 98, 64, 216, 241, 95, 32, 8, 114, 99, 64, 90, 130, 140, 128, 10, 154, 100, 64, 58, 122, 252, 222, 166, 211, 101, 64, 232, 105, 192, 32, 233, 31, 103, 64, 129, 123, 158, 63, 237, 127, 104, 64, 189, 55, 134, 0, 224, 244, 105, 64, 0, 0, 0, 0, 0, 128, 107, 64, 85, 103, 181, 192, 158, 34, 109, 64, 233, 72, 46, 255, 33, 222, 110, 64, 130, 144, 44, 96, 2, 90, 112, 64, 25, 171, 205, 255, 235, 82, 113, 64, 238, 120, 147, 223, 162, 90, 114, 64, 216, 241, 95, 32, 8, 114, 115, 64, 224, 18, 128, 127, 10, 154, 116, 64, 180, 233, 8, 224, 166, 211, 117, 64, 110, 250, 179, 31, 233, 31, 119, 64, 129, 123, 158, 63, 237, 127, 120, 64, 189, 55, 134, 0, 224, 244, 121, 64, 0, 0, 0, 0, 0, 128, 123, 64, 219, 247, 168, 191, 158, 34, 125, 64, 99, 184, 58, 0, 34, 222, 126, 64, 130, 144, 44, 96, 2, 90, 128, 64, 25, 171, 205, 255, 235, 82, 129, 64, 171, 176, 25, 224, 162, 90, 130, 64, 27, 186, 217, 31, 8, 114, 131, 64, 157, 74, 6, 128, 10, 154, 132, 64, 180, 233, 8, 224, 166, 211, 133, 64, 43, 50, 58, 32, 233, 31, 135, 64, 62, 179, 36, 64, 237, 127, 136, 64, 0, 0, 0, 0, 224, 244, 137, 64, 0, 0, 0, 0, 0, 128, 139, 64, 152, 47, 47, 192, 158, 34, 141, 64, 99, 184, 58, 0, 34, 222, 142, 64, 163, 116, 233, 95, 2, 90, 144, 64, 248, 198, 16, 0, 236, 82, 145, 64, 171, 176, 25, 224, 162, 90, 146, 64, 250, 213, 28, 32, 8, 114, 147, 64, 157, 74, 6, 128, 10, 154, 148, 64, 180, 233, 8, 224, 166, 211, 149, 64, 76, 22, 247, 31, 233, 31, 151, 64, 95, 151, 225, 63, 237, 127, 152, 64, 0, 0, 0, 0, 224, 244, 153, 64, 0, 0, 0, 0, 0, 128, 155, 64, 186, 19, 236, 191, 158, 34, 157, 64, 132, 156, 247, 255, 33, 222, 158, 64, 147, 2, 11, 96, 2, 90, 160, 64, 248, 198, 16, 0, 236, 82, 161, 64, 188, 34, 248, 223, 162, 90, 162, 64, 10, 72, 251, 31, 8, 114, 163, 64, 157, 74, 6, 128, 10, 154, 164, 64, 180, 233, 8, 224, 166, 211, 165, 64, 76, 22, 247, 31, 233, 31, 167, 64, 78, 37, 3, 64, 237, 127, 168, 64, 0, 0, 0, 0, 224, 244, 169, 64, 0, 0, 0, 0, 0, 128, 171, 64, 133, 235, 81, 184, 158, 34, 173, 64, 132, 156, 247, 255, 33, 222, 174, 64, 155, 59, 250, 95, 2, 90, 176, 64, 0, 0, 0, 0, 236, 82, 177, 64, 188, 34, 248, 223, 162, 90, 178, 64, 10, 72, 251, 31, 8, 114, 179, 64, 157, 74, 6, 128, 10, 154, 180, 64, 188, 34, 248, 223, 166, 211, 181, 64, 68, 221, 7, 32, 233, 31, 183, 64, 78, 37, 3, 64, 237, 127, 184, 64, 0, 0, 0, 0, 224, 244, 185, 64, 0, 0, 0, 0, 0, 128, 187, 64, 178, 218, 252, 191, 158, 34, 189, 64, 132, 156, 247, 255, 33, 222, 190, 64, 23, 159, 2, 96, 2, 90, 192, 64, 0, 0, 0, 0, 236, 82, 193, 64, 56, 134, 0, 224, 162, 90, 194, 64, 134, 171, 3, 32, 8, 114, 195, 64, 33, 231, 253, 127, 10, 154, 196, 64, 56, 134, 0, 224, 166, 211, 197, 64, 200, 121, 255, 31, 233, 31, 199, 64, 78, 37, 3, 64, 237, 127, 200, 64, 0, 0, 0, 0, 224, 244, 201, 64, 60, 75, 0, 0, 239, 124, 0, 0, 140, 75, 0, 0, 195, 124, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 104, 51, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 159, 124, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 112, 51, 0, 0, 0, 0, 0, 0, 180, 75, 0, 0, 20, 125, 0, 0, 0, 0, 0, 0, 136, 51, 0, 0, 180, 75, 0, 0, 57, 125, 0, 0, 1, 0, 0, 0, 136, 51, 0, 0, 60, 75, 0, 0, 118, 125, 0, 0, 140, 75, 0, 0, 184, 125, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 104, 51, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 148, 125, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 200, 51, 0, 0, 0, 0, 0, 0, 180, 75, 0, 0, 228, 125, 0, 0, 0, 0, 0, 0, 224, 51, 0, 0, 180, 75, 0, 0, 9, 126, 0, 0, 1, 0, 0, 0, 224, 51, 0, 0, 60, 75, 0, 0, 64, 126, 0, 0, 180, 75, 0, 0, 78, 126, 0, 0, 0, 0, 0, 0, 24, 52, 0, 0, 180, 75, 0, 0, 93, 126, 0, 0, 1, 0, 0, 0, 24, 52, 0, 0, 60, 75, 0, 0, 113, 126, 0, 0, 180, 75, 0, 0, 123, 126, 0, 0, 0, 0, 0, 0, 64, 52, 0, 0, 180, 75, 0, 0, 134, 126, 0, 0, 1, 0, 0, 0, 64, 52, 0, 0, 100, 75, 0, 0, 146, 126, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 97, 127, 0, 0, 100, 75, 0, 0, 131, 127, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 192, 127, 0, 0, 180, 75, 0, 0, 207, 127, 0, 0, 0, 0, 0, 0, 144, 52, 0, 0, 180, 75, 0, 0, 223, 127, 0, 0, 1, 0, 0, 0, 144, 52, 0, 0, 60, 75, 0, 0, 240, 127, 0, 0, 180, 75, 0, 0, 249, 127, 0, 0, 0, 0, 0, 0, 184, 52, 0, 0, 180, 75, 0, 0, 3, 128, 0, 0, 1, 0, 0, 0, 184, 52, 0, 0, 100, 75, 0, 0, 14, 128, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 219, 128, 0, 0, 100, 75, 0, 0, 250, 128, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 76, 129, 0, 0, 180, 75, 0, 0, 91, 129, 0, 0, 0, 0, 0, 0, 8, 53, 0, 0, 180, 75, 0, 0, 107, 129, 0, 0, 1, 0, 0, 0, 8, 53, 0, 0, 100, 75, 0, 0, 124, 129, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 85, 130, 0, 0, 100, 75, 0, 0, 122, 130, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 194, 130, 0, 0, 180, 75, 0, 0, 210, 130, 0, 0, 0, 0, 0, 0, 88, 53, 0, 0, 180, 75, 0, 0, 227, 130, 0, 0, 1, 0, 0, 0, 88, 53, 0, 0, 100, 75, 0, 0, 245, 130, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 208, 131, 0, 0, 100, 75, 0, 0, 246, 131, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 72, 132, 0, 0, 180, 75, 0, 0, 85, 132, 0, 0, 0, 0, 0, 0, 168, 53, 0, 0, 180, 75, 0, 0, 99, 132, 0, 0, 1, 0, 0, 0, 168, 53, 0, 0, 100, 75, 0, 0, 114, 132, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 71, 133, 0, 0, 100, 75, 0, 0, 106, 133, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 170, 133, 0, 0, 180, 75, 0, 0, 179, 133, 0, 0, 0, 0, 0, 0, 248, 53, 0, 0, 180, 75, 0, 0, 189, 133, 0, 0, 1, 0, 0, 0, 248, 53, 0, 0, 100, 75, 0, 0, 200, 133, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 149, 134, 0, 0, 100, 75, 0, 0, 180, 134, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 8, 135, 0, 0, 180, 75, 0, 0, 24, 135, 0, 0, 0, 0, 0, 0, 72, 54, 0, 0, 180, 75, 0, 0, 41, 135, 0, 0, 1, 0, 0, 0, 72, 54, 0, 0, 100, 75, 0, 0, 59, 135, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 22, 136, 0, 0, 100, 75, 0, 0, 60, 136, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 133, 136, 0, 0, 180, 75, 0, 0, 165, 136, 0, 0, 0, 0, 0, 0, 152, 54, 0, 0, 180, 75, 0, 0, 179, 136, 0, 0, 1, 0, 0, 0, 152, 54, 0, 0, 100, 75, 0, 0, 194, 136, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 151, 137, 0, 0, 100, 75, 0, 0, 186, 137, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 250, 137, 0, 0, 180, 75, 0, 0, 3, 138, 0, 0, 0, 0, 0, 0, 232, 54, 0, 0, 180, 75, 0, 0, 13, 138, 0, 0, 1, 0, 0, 0, 232, 54, 0, 0, 100, 75, 0, 0, 24, 138, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 229, 138, 0, 0, 100, 75, 0, 0, 4, 139, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 72, 139, 0, 0, 180, 75, 0, 0, 81, 139, 0, 0, 0, 0, 0, 0, 56, 55, 0, 0, 180, 75, 0, 0, 91, 139, 0, 0, 1, 0, 0, 0, 56, 55, 0, 0, 100, 75, 0, 0, 102, 139, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 51, 140, 0, 0, 100, 75, 0, 0, 82, 140, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 160, 140, 0, 0, 180, 75, 0, 0, 169, 140, 0, 0, 0, 0, 0, 0, 136, 55, 0, 0, 180, 75, 0, 0, 179, 140, 0, 0, 1, 0, 0, 0, 136, 55, 0, 0, 100, 75, 0, 0, 190, 140, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 139, 141, 0, 0, 100, 75, 0, 0, 170, 141, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 250, 141, 0, 0, 180, 75, 0, 0, 3, 142, 0, 0, 0, 0, 0, 0, 216, 55, 0, 0, 180, 75, 0, 0, 13, 142, 0, 0, 1, 0, 0, 0, 216, 55, 0, 0, 100, 75, 0, 0, 24, 142, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 229, 142, 0, 0, 100, 75, 0, 0, 4, 143, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 69, 143, 0, 0, 180, 75, 0, 0, 86, 143, 0, 0, 0, 0, 0, 0, 40, 56, 0, 0, 180, 75, 0, 0, 104, 143, 0, 0, 1, 0, 0, 0, 40, 56, 0, 0, 100, 75, 0, 0, 123, 143, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 88, 144, 0, 0, 100, 75, 0, 0, 127, 144, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 195, 144, 0, 0, 180, 75, 0, 0, 209, 144, 0, 0, 0, 0, 0, 0, 120, 56, 0, 0, 180, 75, 0, 0, 224, 144, 0, 0, 1, 0, 0, 0, 120, 56, 0, 0, 100, 75, 0, 0, 240, 144, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 199, 145, 0, 0, 100, 75, 0, 0, 235, 145, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 53, 146, 0, 0, 180, 75, 0, 0, 66, 146, 0, 0, 0, 0, 0, 0, 200, 56, 0, 0, 180, 75, 0, 0, 80, 146, 0, 0, 1, 0, 0, 0, 200, 56, 0, 0, 100, 75, 0, 0, 95, 146, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 52, 147, 0, 0, 100, 75, 0, 0, 87, 147, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 151, 147, 0, 0, 180, 75, 0, 0, 174, 147, 0, 0, 0, 0, 0, 0, 24, 57, 0, 0, 180, 75, 0, 0, 198, 147, 0, 0, 1, 0, 0, 0, 24, 57, 0, 0, 100, 75, 0, 0, 223, 147, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 200, 148, 0, 0, 100, 75, 0, 0, 245, 148, 0, 0, 168, 59, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 116, 154, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 16, 58, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 53, 154, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 16, 58, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 208, 153, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 16, 58, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 177, 153, 0, 0, 60, 75, 0, 0, 146, 153, 0, 0, 60, 75, 0, 0, 115, 153, 0, 0, 60, 75, 0, 0, 84, 153, 0, 0, 60, 75, 0, 0, 53, 153, 0, 0, 60, 75, 0, 0, 22, 153, 0, 0, 60, 75, 0, 0, 247, 152, 0, 0, 60, 75, 0, 0, 216, 152, 0, 0, 60, 75, 0, 0, 185, 152, 0, 0, 60, 75, 0, 0, 154, 152, 0, 0, 60, 75, 0, 0, 123, 152, 0, 0, 60, 75, 0, 0, 92, 152, 0, 0, 60, 75, 0, 0, 15, 154, 0, 0, 100, 75, 0, 0, 179, 154, 0, 0, 40, 58, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 192, 154, 0, 0, 100, 75, 0, 0, 205, 154, 0, 0, 40, 58, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 221, 154, 0, 0, 48, 58, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 238, 154, 0, 0, 40, 58, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 0, 155, 0, 0, 100, 75, 0, 0, 13, 155, 0, 0, 40, 58, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 25, 155, 0, 0, 96, 58, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 58, 155, 0, 0, 120, 58, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 128, 155, 0, 0, 120, 58, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 92, 155, 0, 0, 152, 58, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 162, 155, 0, 0, 120, 58, 0, 0, 0, 0, 0, 0, 32, 75, 0, 0, 202, 155, 0, 0, 32, 75, 0, 0, 204, 155, 0, 0, 32, 75, 0, 0, 207, 155, 0, 0, 32, 75, 0, 0, 209, 155, 0, 0, 32, 75, 0, 0, 211, 155, 0, 0, 32, 75, 0, 0, 213, 155, 0, 0, 32, 75, 0, 0, 215, 155, 0, 0, 32, 75, 0, 0, 217, 155, 0, 0, 32, 75, 0, 0, 219, 155, 0, 0, 32, 75, 0, 0, 221, 155, 0, 0, 32, 75, 0, 0, 196, 185, 0, 0, 32, 75, 0, 0, 223, 155, 0, 0, 32, 75, 0, 0, 225, 155, 0, 0, 32, 75, 0, 0, 227, 155, 0, 0, 100, 75, 0, 0, 229, 155, 0, 0, 136, 58, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 10, 156, 0, 0, 136, 58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 153, 177, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 216, 177, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 240, 177, 0, 0, 248, 59, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 9, 178, 0, 0, 248, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 33, 178, 0, 0, 140, 75, 0, 0, 58, 178, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 160, 59, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 88, 178, 0, 0, 112, 67, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 114, 178, 0, 0, 100, 75, 0, 0, 132, 178, 0, 0, 208, 59, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 174, 178, 0, 0, 208, 59, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 216, 178, 0, 0, 60, 75, 0, 0, 9, 179, 0, 0, 140, 75, 0, 0, 58, 179, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 216, 59, 0, 0, 3, 244, 255, 255, 140, 75, 0, 0, 105, 179, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 232, 59, 0, 0, 3, 244, 255, 255, 140, 75, 0, 0, 152, 179, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 216, 59, 0, 0, 3, 244, 255, 255, 140, 75, 0, 0, 199, 179, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 232, 59, 0, 0, 3, 244, 255, 255, 100, 75, 0, 0, 246, 179, 0, 0, 136, 67, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 114, 180, 0, 0, 160, 59, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 136, 180, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 160, 66, 0, 0, 2, 0, 0, 0, 140, 75, 0, 0, 154, 180, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 168, 66, 0, 0, 2, 0, 0, 0, 140, 75, 0, 0, 188, 180, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 168, 66, 0, 0, 2, 0, 0, 0, 140, 75, 0, 0, 223, 180, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 168, 66, 0, 0, 2, 0, 0, 0, 100, 75, 0, 0, 2, 181, 0, 0, 240, 60, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 36, 181, 0, 0, 240, 60, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 71, 181, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 168, 66, 0, 0, 2, 0, 0, 0, 100, 75, 0, 0, 105, 181, 0, 0, 128, 60, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 127, 181, 0, 0, 128, 60, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 147, 181, 0, 0, 128, 60, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 167, 181, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 160, 66, 0, 0, 2, 0, 0, 0, 100, 75, 0, 0, 185, 181, 0, 0, 128, 60, 0, 0, 0, 0, 0, 0, 100, 75, 0, 0, 206, 181, 0, 0, 128, 60, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 227, 181, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 176, 66, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 39, 182, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 200, 66, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 107, 182, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 224, 66, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 175, 182, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 248, 66, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 243, 182, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 16, 67, 0, 0, 2, 0, 0, 0, 24, 67, 0, 0, 0, 8, 0, 0, 140, 75, 0, 0, 56, 183, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 16, 67, 0, 0, 2, 0, 0, 0, 32, 67, 0, 0, 0, 8, 0, 0, 140, 75, 0, 0, 125, 183, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 40, 67, 0, 0, 0, 8, 0, 0, 140, 75, 0, 0, 194, 183, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 40, 67, 0, 0, 0, 8, 0, 0, 140, 75, 0, 0, 7, 184, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 48, 67, 0, 0, 2, 0, 0, 0, 140, 75, 0, 0, 35, 184, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 48, 67, 0, 0, 2, 0, 0, 0, 140, 75, 0, 0, 63, 184, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 48, 67, 0, 0, 2, 0, 0, 0, 140, 75, 0, 0, 91, 184, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 48, 67, 0, 0, 2, 0, 0, 0, 140, 75, 0, 0, 119, 184, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 56, 67, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 189, 184, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 64, 67, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 3, 185, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 72, 67, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 73, 185, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 80, 67, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 143, 185, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 88, 67, 0, 0, 2, 0, 0, 0, 140, 75, 0, 0, 164, 185, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 128, 60, 0, 0, 2, 0, 0, 0, 88, 67, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 7, 189, 0, 0, 60, 75, 0, 0, 240, 188, 0, 0, 140, 75, 0, 0, 218, 188, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 104, 67, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 171, 188, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 104, 67, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 149, 188, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 96, 67, 0, 0, 0, 0, 0, 0, 140, 75, 0, 0, 102, 188, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 96, 67, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 83, 188, 0, 0, 60, 75, 0, 0, 49, 188, 0, 0, 60, 75, 0, 0, 15, 188, 0, 0, 60, 75, 0, 0, 250, 187, 0, 0, 60, 75, 0, 0, 229, 187, 0, 0, 60, 75, 0, 0, 204, 187, 0, 0, 60, 75, 0, 0, 179, 187, 0, 0, 60, 75, 0, 0, 154, 187, 0, 0, 60, 75, 0, 0, 129, 187, 0, 0, 60, 75, 0, 0, 105, 187, 0, 0, 60, 75, 0, 0, 124, 188, 0, 0, 60, 75, 0, 0, 193, 188, 0, 0, 100, 75, 0, 0, 28, 189, 0, 0, 80, 58, 0, 0, 0, 0, 0, 0, 60, 75, 0, 0, 51, 189, 0, 0, 100, 75, 0, 0, 76, 189, 0, 0, 128, 67, 0, 0, 0, 0, 0, 0, 0, 0, 128, 63, 68, 172, 0, 0, 2, 0, 0, 0, 0, 4, 0, 0, 160, 51, 0, 0, 200, 58, 0, 0, 160, 51, 0, 0, 8, 59, 0, 0, 200, 58, 0, 0, 160, 51, 0, 0, 16, 59, 0, 0, 8, 59, 0, 0, 16, 59, 0, 0, 176, 51, 0, 0, 192, 51, 0, 0, 136, 51, 0, 0, 16, 59, 0, 0, 216, 58, 0, 0, 136, 51, 0, 0, 16, 59, 0, 0, 8, 59, 0, 0, 248, 51, 0, 0, 200, 58, 0, 0, 248, 51, 0, 0, 48, 59, 0, 0, 200, 58, 0, 0, 248, 51, 0, 0, 16, 59, 0, 0, 48, 59, 0, 0, 16, 59, 0, 0, 8, 52, 0, 0, 192, 51, 0, 0, 224, 51, 0, 0, 16, 59, 0, 0, 216, 58, 0, 0, 224, 51, 0, 0, 16, 59, 0, 0, 48, 59, 0, 0, 32, 52, 0, 0, 200, 58, 0, 0, 224, 51, 0, 0, 0, 0, 0, 0, 104, 52, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 1, 0, 0, 0, 4, 0, 0, 0, 120, 52, 0, 0, 0, 0, 0, 0, 128, 52, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 7, 0, 0, 0, 2, 0, 0, 0, 8, 0, 0, 0, 8, 59, 0, 0, 72, 52, 0, 0, 16, 59, 0, 0, 16, 59, 0, 0, 152, 52, 0, 0, 200, 58, 0, 0, 8, 59, 0, 0, 8, 59, 0, 0, 8, 59, 0, 0, 0, 0, 0, 0, 224, 52, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 11, 0, 0, 0, 3, 0, 0, 0, 12, 0, 0, 0, 240, 52, 0, 0, 0, 0, 0, 0, 248, 52, 0, 0, 5, 0, 0, 0, 13, 0, 0, 0, 14, 0, 0, 0, 2, 0, 0, 0, 15, 0, 0, 0, 48, 59, 0, 0, 192, 52, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 192, 52, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 192, 52, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 192, 52, 0, 0, 200, 58, 0, 0, 192, 52, 0, 0, 48, 59, 0, 0, 0, 0, 0, 0, 48, 53, 0, 0, 16, 0, 0, 0, 17, 0, 0, 0, 18, 0, 0, 0, 4, 0, 0, 0, 19, 0, 0, 0, 64, 53, 0, 0, 0, 0, 0, 0, 72, 53, 0, 0, 5, 0, 0, 0, 20, 0, 0, 0, 21, 0, 0, 0, 2, 0, 0, 0, 22, 0, 0, 0, 48, 59, 0, 0, 16, 53, 0, 0, 8, 59, 0, 0, 224, 51, 0, 0, 200, 58, 0, 0, 16, 53, 0, 0, 8, 59, 0, 0, 48, 59, 0, 0, 0, 0, 0, 0, 128, 53, 0, 0, 23, 0, 0, 0, 24, 0, 0, 0, 25, 0, 0, 0, 5, 0, 0, 0, 26, 0, 0, 0, 144, 53, 0, 0, 0, 0, 0, 0, 152, 53, 0, 0, 5, 0, 0, 0, 27, 0, 0, 0, 28, 0, 0, 0, 2, 0, 0, 0, 29, 0, 0, 0, 48, 59, 0, 0, 96, 53, 0, 0, 48, 59, 0, 0, 8, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 96, 53, 0, 0, 48, 59, 0, 0, 8, 59, 0, 0, 48, 59, 0, 0, 8, 59, 0, 0, 0, 0, 0, 0, 208, 53, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 32, 0, 0, 0, 6, 0, 0, 0, 33, 0, 0, 0, 224, 53, 0, 0, 0, 0, 0, 0, 232, 53, 0, 0, 5, 0, 0, 0, 34, 0, 0, 0, 35, 0, 0, 0, 2, 0, 0, 0, 36, 0, 0, 0, 48, 59, 0, 0, 176, 53, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 176, 53, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 0, 0, 0, 0, 32, 54, 0, 0, 37, 0, 0, 0, 38, 0, 0, 0, 39, 0, 0, 0, 7, 0, 0, 0, 40, 0, 0, 0, 48, 54, 0, 0, 0, 0, 0, 0, 56, 54, 0, 0, 5, 0, 0, 0, 41, 0, 0, 0, 42, 0, 0, 0, 2, 0, 0, 0, 43, 0, 0, 0, 200, 58, 0, 0, 0, 54, 0, 0, 48, 59, 0, 0, 224, 51, 0, 0, 48, 59, 0, 0, 200, 58, 0, 0, 0, 54, 0, 0, 48, 59, 0, 0, 224, 51, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 200, 58, 0, 0, 0, 54, 0, 0, 48, 59, 0, 0, 224, 51, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 0, 0, 0, 0, 112, 54, 0, 0, 44, 0, 0, 0, 45, 0, 0, 0, 46, 0, 0, 0, 8, 0, 0, 0, 47, 0, 0, 0, 128, 54, 0, 0, 0, 0, 0, 0, 136, 54, 0, 0, 5, 0, 0, 0, 48, 0, 0, 0, 49, 0, 0, 0, 2, 0, 0, 0, 50, 0, 0, 0, 200, 58, 0, 0, 80, 54, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 200, 58, 0, 0, 80, 54, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 80, 54, 0, 0, 0, 0, 0, 0, 192, 54, 0, 0, 51, 0, 0, 0, 52, 0, 0, 0, 53, 0, 0, 0, 9, 0, 0, 0, 54, 0, 0, 0, 208, 54, 0, 0, 0, 0, 0, 0, 216, 54, 0, 0, 55, 0, 0, 0, 56, 0, 0, 0, 57, 0, 0, 0, 2, 0, 0, 0, 58, 0, 0, 0, 24, 59, 0, 0, 160, 54, 0, 0, 200, 58, 0, 0, 160, 54, 0, 0, 224, 51, 0, 0, 216, 58, 0, 0, 160, 54, 0, 0, 48, 59, 0, 0, 160, 54, 0, 0, 48, 59, 0, 0, 160, 54, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 160, 54, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 200, 58, 0, 0, 160, 54, 0, 0, 0, 0, 0, 0, 16, 55, 0, 0, 59, 0, 0, 0, 60, 0, 0, 0, 61, 0, 0, 0, 10, 0, 0, 0, 62, 0, 0, 0, 32, 55, 0, 0, 0, 0, 0, 0, 40, 55, 0, 0, 5, 0, 0, 0, 63, 0, 0, 0, 64, 0, 0, 0, 2, 0, 0, 0, 65, 0, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 8, 59, 0, 0, 8, 59, 0, 0, 8, 59, 0, 0, 8, 59, 0, 0, 0, 0, 0, 0, 96, 55, 0, 0, 66, 0, 0, 0, 67, 0, 0, 0, 68, 0, 0, 0, 11, 0, 0, 0, 69, 0, 0, 0, 112, 55, 0, 0, 0, 0, 0, 0, 120, 55, 0, 0, 5, 0, 0, 0, 70, 0, 0, 0, 71, 0, 0, 0, 2, 0, 0, 0, 72, 0, 0, 0, 48, 59, 0, 0, 64, 55, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 24, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 64, 55, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 0, 0, 0, 0, 176, 55, 0, 0, 73, 0, 0, 0, 74, 0, 0, 0, 75, 0, 0, 0, 12, 0, 0, 0, 76, 0, 0, 0, 192, 55, 0, 0, 0, 0, 0, 0, 200, 55, 0, 0, 5, 0, 0, 0, 77, 0, 0, 0, 78, 0, 0, 0, 2, 0, 0, 0, 79, 0, 0, 0, 48, 59, 0, 0, 144, 55, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 24, 59, 0, 0, 8, 59, 0, 0, 48, 59, 0, 0, 144, 55, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 24, 59, 0, 0, 8, 59, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 80, 0, 0, 0, 81, 0, 0, 0, 82, 0, 0, 0, 13, 0, 0, 0, 83, 0, 0, 0, 16, 56, 0, 0, 0, 0, 0, 0, 24, 56, 0, 0, 5, 0, 0, 0, 84, 0, 0, 0, 85, 0, 0, 0, 2, 0, 0, 0, 86, 0, 0, 0, 48, 59, 0, 0, 224, 55, 0, 0, 8, 59, 0, 0, 0, 0, 0, 0, 80, 56, 0, 0, 87, 0, 0, 0, 88, 0, 0, 0, 89, 0, 0, 0, 14, 0, 0, 0, 90, 0, 0, 0, 96, 56, 0, 0, 0, 0, 0, 0, 104, 56, 0, 0, 5, 0, 0, 0, 91, 0, 0, 0, 92, 0, 0, 0, 2, 0, 0, 0, 93, 0, 0, 0, 48, 59, 0, 0, 48, 56, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 56, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 0, 0, 0, 0, 160, 56, 0, 0, 94, 0, 0, 0, 95, 0, 0, 0, 96, 0, 0, 0, 15, 0, 0, 0, 97, 0, 0, 0, 176, 56, 0, 0, 0, 0, 0, 0, 184, 56, 0, 0, 5, 0, 0, 0, 98, 0, 0, 0, 99, 0, 0, 0, 2, 0, 0, 0, 100, 0, 0, 0, 48, 59, 0, 0, 128, 56, 0, 0, 48, 59, 0, 0, 16, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 0, 0, 0, 0, 240, 56, 0, 0, 101, 0, 0, 0, 102, 0, 0, 0, 103, 0, 0, 0, 16, 0, 0, 0, 104, 0, 0, 0, 0, 57, 0, 0, 0, 0, 0, 0, 8, 57, 0, 0, 5, 0, 0, 0, 105, 0, 0, 0, 106, 0, 0, 0, 2, 0, 0, 0, 107, 0, 0, 0, 48, 59, 0, 0, 208, 56, 0, 0, 48, 59, 0, 0, 16, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 0, 0, 0, 0, 64, 57, 0, 0, 108, 0, 0, 0, 109, 0, 0, 0, 110, 0, 0, 0, 17, 0, 0, 0, 111, 0, 0, 0, 80, 57, 0, 0, 0, 0, 0, 0, 88, 57, 0, 0, 5, 0, 0, 0, 112, 0, 0, 0, 113, 0, 0, 0, 2, 0, 0, 0, 114, 0, 0, 0, 200, 58, 0, 0, 32, 57, 0, 0, 48, 59, 0, 0, 48, 59, 0, 0, 32, 57, 0, 0, 48, 59, 0, 0, 200, 58, 0, 0, 32, 57, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 24, 58, 0, 0, 115, 0, 0, 0, 116, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 58, 0, 0, 117, 0, 0, 0, 118, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 80, 58, 0, 0, 119, 0, 0, 0, 120, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 64, 58, 0, 0, 117, 0, 0, 0, 121, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 104, 58, 0, 0, 122, 0, 0, 0, 123, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 184, 58, 0, 0, 124, 0, 0, 0, 125, 0, 0, 0, 126, 0, 0, 0, 127, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 136, 58, 0, 0, 124, 0, 0, 0, 128, 0, 0, 0, 126, 0, 0, 0, 127, 0, 0, 0, 2, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 56, 59, 0, 0, 124, 0, 0, 0, 129, 0, 0, 0, 126, 0, 0, 0, 127, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 72, 59, 0, 0, 124, 0, 0, 0, 130, 0, 0, 0, 126, 0, 0, 0, 127, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 168, 58, 0, 0, 124, 0, 0, 0, 131, 0, 0, 0, 126, 0, 0, 0, 127, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 228, 158, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 192, 3, 0, 0, 192, 4, 0, 0, 192, 5, 0, 0, 192, 6, 0, 0, 192, 7, 0, 0, 192, 8, 0, 0, 192, 9, 0, 0, 192, 10, 0, 0, 192, 11, 0, 0, 192, 12, 0, 0, 192, 13, 0, 0, 192, 14, 0, 0, 192, 15, 0, 0, 192, 16, 0, 0, 192, 17, 0, 0, 192, 18, 0, 0, 192, 19, 0, 0, 192, 20, 0, 0, 192, 21, 0, 0, 192, 22, 0, 0, 192, 23, 0, 0, 192, 24, 0, 0, 192, 25, 0, 0, 192, 26, 0, 0, 192, 27, 0, 0, 192, 28, 0, 0, 192, 29, 0, 0, 192, 30, 0, 0, 192, 31, 0, 0, 192, 0, 0, 0, 179, 1, 0, 0, 195, 2, 0, 0, 195, 3, 0, 0, 195, 4, 0, 0, 195, 5, 0, 0, 195, 6, 0, 0, 195, 7, 0, 0, 195, 8, 0, 0, 195, 9, 0, 0, 195, 10, 0, 0, 195, 11, 0, 0, 195, 12, 0, 0, 195, 13, 0, 0, 211, 14, 0, 0, 195, 15, 0, 0, 195, 0, 0, 12, 187, 1, 0, 12, 195, 2, 0, 12, 195, 3, 0, 12, 195, 4, 0, 12, 211, 132, 77, 0, 0, 244, 77, 0, 0, 100, 78, 0, 0, 100, 78, 0, 0, 164, 118, 0, 0, 212, 86, 0, 0, 212, 80, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 100, 0, 0, 0, 232, 3, 0, 0, 16, 39, 0, 0, 160, 134, 1, 0, 64, 66, 15, 0, 128, 150, 152, 0, 0, 225, 245, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 130, 175, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 122, 171, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 6, 0, 0, 0, 114, 167, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 255, 255, 255, 255 ], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 10240);
allocate([ 1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 11, 0, 0, 0, 12, 0, 0, 0, 13, 0, 0, 0, 14, 0, 0, 0, 15, 0, 0, 0, 16, 0, 0, 0, 17, 0, 0, 0, 18, 0, 0, 0, 19, 0, 0, 0, 20, 0, 0, 0, 21, 0, 0, 0, 22, 0, 0, 0, 23, 0, 0, 0, 24, 0, 0, 0, 25, 0, 0, 0, 26, 0, 0, 0, 27, 0, 0, 0, 28, 0, 0, 0, 29, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 32, 0, 0, 0, 33, 0, 0, 0, 34, 0, 0, 0, 35, 0, 0, 0, 36, 0, 0, 0, 37, 0, 0, 0, 38, 0, 0, 0, 39, 0, 0, 0, 40, 0, 0, 0, 41, 0, 0, 0, 42, 0, 0, 0, 43, 0, 0, 0, 44, 0, 0, 0, 45, 0, 0, 0, 46, 0, 0, 0, 47, 0, 0, 0, 48, 0, 0, 0, 49, 0, 0, 0, 50, 0, 0, 0, 51, 0, 0, 0, 52, 0, 0, 0, 53, 0, 0, 0, 54, 0, 0, 0, 55, 0, 0, 0, 56, 0, 0, 0, 57, 0, 0, 0, 58, 0, 0, 0, 59, 0, 0, 0, 60, 0, 0, 0, 61, 0, 0, 0, 62, 0, 0, 0, 63, 0, 0, 0, 64, 0, 0, 0, 65, 0, 0, 0, 66, 0, 0, 0, 67, 0, 0, 0, 68, 0, 0, 0, 69, 0, 0, 0, 70, 0, 0, 0, 71, 0, 0, 0, 72, 0, 0, 0, 73, 0, 0, 0, 74, 0, 0, 0, 75, 0, 0, 0, 76, 0, 0, 0, 77, 0, 0, 0, 78, 0, 0, 0, 79, 0, 0, 0, 80, 0, 0, 0, 81, 0, 0, 0, 82, 0, 0, 0, 83, 0, 0, 0, 84, 0, 0, 0, 85, 0, 0, 0, 86, 0, 0, 0, 87, 0, 0, 0, 88, 0, 0, 0, 89, 0, 0, 0, 90, 0, 0, 0, 91, 0, 0, 0, 92, 0, 0, 0, 93, 0, 0, 0, 94, 0, 0, 0, 95, 0, 0, 0, 96, 0, 0, 0, 65, 0, 0, 0, 66, 0, 0, 0, 67, 0, 0, 0, 68, 0, 0, 0, 69, 0, 0, 0, 70, 0, 0, 0, 71, 0, 0, 0, 72, 0, 0, 0, 73, 0, 0, 0, 74, 0, 0, 0, 75, 0, 0, 0, 76, 0, 0, 0, 77, 0, 0, 0, 78, 0, 0, 0, 79, 0, 0, 0, 80, 0, 0, 0, 81, 0, 0, 0, 82, 0, 0, 0, 83, 0, 0, 0, 84, 0, 0, 0, 85, 0, 0, 0, 86, 0, 0, 0, 87, 0, 0, 0, 88, 0, 0, 0, 89, 0, 0, 0, 90, 0, 0, 0, 123, 0, 0, 0, 124, 0, 0, 0, 125, 0, 0, 0, 126, 0, 0, 0, 127 ], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 20688);
allocate([ 1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 11, 0, 0, 0, 12, 0, 0, 0, 13, 0, 0, 0, 14, 0, 0, 0, 15, 0, 0, 0, 16, 0, 0, 0, 17, 0, 0, 0, 18, 0, 0, 0, 19, 0, 0, 0, 20, 0, 0, 0, 21, 0, 0, 0, 22, 0, 0, 0, 23, 0, 0, 0, 24, 0, 0, 0, 25, 0, 0, 0, 26, 0, 0, 0, 27, 0, 0, 0, 28, 0, 0, 0, 29, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 32, 0, 0, 0, 33, 0, 0, 0, 34, 0, 0, 0, 35, 0, 0, 0, 36, 0, 0, 0, 37, 0, 0, 0, 38, 0, 0, 0, 39, 0, 0, 0, 40, 0, 0, 0, 41, 0, 0, 0, 42, 0, 0, 0, 43, 0, 0, 0, 44, 0, 0, 0, 45, 0, 0, 0, 46, 0, 0, 0, 47, 0, 0, 0, 48, 0, 0, 0, 49, 0, 0, 0, 50, 0, 0, 0, 51, 0, 0, 0, 52, 0, 0, 0, 53, 0, 0, 0, 54, 0, 0, 0, 55, 0, 0, 0, 56, 0, 0, 0, 57, 0, 0, 0, 58, 0, 0, 0, 59, 0, 0, 0, 60, 0, 0, 0, 61, 0, 0, 0, 62, 0, 0, 0, 63, 0, 0, 0, 64, 0, 0, 0, 97, 0, 0, 0, 98, 0, 0, 0, 99, 0, 0, 0, 100, 0, 0, 0, 101, 0, 0, 0, 102, 0, 0, 0, 103, 0, 0, 0, 104, 0, 0, 0, 105, 0, 0, 0, 106, 0, 0, 0, 107, 0, 0, 0, 108, 0, 0, 0, 109, 0, 0, 0, 110, 0, 0, 0, 111, 0, 0, 0, 112, 0, 0, 0, 113, 0, 0, 0, 114, 0, 0, 0, 115, 0, 0, 0, 116, 0, 0, 0, 117, 0, 0, 0, 118, 0, 0, 0, 119, 0, 0, 0, 120, 0, 0, 0, 121, 0, 0, 0, 122, 0, 0, 0, 91, 0, 0, 0, 92, 0, 0, 0, 93, 0, 0, 0, 94, 0, 0, 0, 95, 0, 0, 0, 96, 0, 0, 0, 97, 0, 0, 0, 98, 0, 0, 0, 99, 0, 0, 0, 100, 0, 0, 0, 101, 0, 0, 0, 102, 0, 0, 0, 103, 0, 0, 0, 104, 0, 0, 0, 105, 0, 0, 0, 106, 0, 0, 0, 107, 0, 0, 0, 108, 0, 0, 0, 109, 0, 0, 0, 110, 0, 0, 0, 111, 0, 0, 0, 112, 0, 0, 0, 113, 0, 0, 0, 114, 0, 0, 0, 115, 0, 0, 0, 116, 0, 0, 0, 117, 0, 0, 0, 118, 0, 0, 0, 119, 0, 0, 0, 120, 0, 0, 0, 121, 0, 0, 0, 122, 0, 0, 0, 123, 0, 0, 0, 124, 0, 0, 0, 125, 0, 0, 0, 126, 0, 0, 0, 127 ], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 22224);
allocate([ 96, 59, 0, 0, 132, 0, 0, 0, 133, 0, 0, 0, 1, 0, 0, 0, 9, 0, 0, 0, 4, 0, 0, 0, 4, 0, 0, 0, 6, 0, 0, 0, 7, 0, 0, 0, 10, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 18, 0, 0, 0, 11, 0, 0, 0, 19, 0, 0, 0, 0, 0, 0, 0, 112, 59, 0, 0, 132, 0, 0, 0, 134, 0, 0, 0, 2, 0, 0, 0, 9, 0, 0, 0, 4, 0, 0, 0, 4, 0, 0, 0, 10, 0, 0, 0, 7, 0, 0, 0, 10, 0, 0, 0, 11, 0, 0, 0, 12, 0, 0, 0, 20, 0, 0, 0, 12, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 128, 59, 0, 0, 135, 0, 0, 0, 136, 0, 0, 0, 3, 0, 0, 0, 13, 0, 0, 0, 5, 0, 0, 0, 5, 0, 0, 0, 13, 0, 0, 0, 14, 0, 0, 0, 14, 0, 0, 0, 15, 0, 0, 0, 16, 0, 0, 0, 22, 0, 0, 0, 15, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 144, 59, 0, 0, 135, 0, 0, 0, 137, 0, 0, 0, 4, 0, 0, 0, 13, 0, 0, 0, 5, 0, 0, 0, 5, 0, 0, 0, 17, 0, 0, 0, 14, 0, 0, 0, 14, 0, 0, 0, 18, 0, 0, 0, 19, 0, 0, 0, 24, 0, 0, 0, 16, 0, 0, 0, 25, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 248, 59, 0, 0, 135, 0, 0, 0, 138, 0, 0, 0, 5, 0, 0, 0, 13, 0, 0, 0, 5, 0, 0, 0, 5, 0, 0, 0, 17, 0, 0, 0, 14, 0, 0, 0, 14, 0, 0, 0, 15, 0, 0, 0, 16, 0, 0, 0, 22, 0, 0, 0, 16, 0, 0, 0, 25, 0, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 132, 0, 0, 0, 139, 0, 0, 0, 6, 0, 0, 0, 9, 0, 0, 0, 4, 0, 0, 0, 4, 0, 0, 0, 10, 0, 0, 0, 7, 0, 0, 0, 10, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 18, 0, 0, 0, 12, 0, 0, 0, 21, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 8, 60, 0, 0, 140, 0, 0, 0, 141, 0, 0, 0, 248, 255, 255, 255, 248, 255, 255, 255, 8, 60, 0, 0, 142, 0, 0, 0, 143, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 32, 60, 0, 0, 144, 0, 0, 0, 145, 0, 0, 0, 248, 255, 255, 255, 248, 255, 255, 255, 32, 60, 0, 0, 146, 0, 0, 0, 147, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 56, 60, 0, 0, 148, 0, 0, 0, 149, 0, 0, 0, 252, 255, 255, 255, 252, 255, 255, 255, 56, 60, 0, 0, 150, 0, 0, 0, 151, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 80, 60, 0, 0, 152, 0, 0, 0, 153, 0, 0, 0, 252, 255, 255, 255, 252, 255, 255, 255, 80, 60, 0, 0, 154, 0, 0, 0, 155, 0, 0, 0, 0, 0, 0, 0, 192, 59, 0, 0, 156, 0, 0, 0, 157, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 208, 59, 0, 0, 158, 0, 0, 0, 159, 0, 0, 0, 0, 0, 0, 0, 104, 60, 0, 0, 160, 0, 0, 0, 161, 0, 0, 0, 20, 0, 0, 0, 1, 0, 0, 0, 17, 0, 0, 0, 18, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 61, 0, 0, 162, 0, 0, 0, 163, 0, 0, 0, 164, 0, 0, 0, 1, 0, 0, 0, 6, 0, 0, 0, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 61, 0, 0, 165, 0, 0, 0, 166, 0, 0, 0, 164, 0, 0, 0, 2, 0, 0, 0, 7, 0, 0, 0, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 61, 0, 0, 167, 0, 0, 0, 168, 0, 0, 0, 164, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 61, 0, 0, 169, 0, 0, 0, 170, 0, 0, 0, 164, 0, 0, 0, 12, 0, 0, 0, 13, 0, 0, 0, 14, 0, 0, 0, 15, 0, 0, 0, 16, 0, 0, 0, 17, 0, 0, 0, 18, 0, 0, 0, 19, 0, 0, 0, 20, 0, 0, 0, 21, 0, 0, 0, 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 62, 0, 0, 171, 0, 0, 0, 172, 0, 0, 0, 164, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 23, 0, 0, 0, 5, 0, 0, 0, 24, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 62, 0, 0, 173, 0, 0, 0, 174, 0, 0, 0, 164, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 25, 0, 0, 0, 9, 0, 0, 0, 26, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 62, 0, 0, 175, 0, 0, 0, 176, 0, 0, 0, 164, 0, 0, 0, 21, 0, 0, 0, 27, 0, 0, 0, 28, 0, 0, 0, 29, 0, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 1, 0, 0, 0, 248, 255, 255, 255, 64, 62, 0, 0, 22, 0, 0, 0, 23, 0, 0, 0, 24, 0, 0, 0, 25, 0, 0, 0, 26, 0, 0, 0, 27, 0, 0, 0, 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 104, 62, 0, 0, 177, 0, 0, 0, 178, 0, 0, 0, 164, 0, 0, 0, 29, 0, 0, 0, 32, 0, 0, 0, 33, 0, 0, 0, 34, 0, 0, 0, 35, 0, 0, 0, 36, 0, 0, 0, 2, 0, 0, 0, 248, 255, 255, 255, 104, 62, 0, 0, 30, 0, 0, 0, 31, 0, 0, 0, 32, 0, 0, 0, 33, 0, 0, 0, 34, 0, 0, 0, 35, 0, 0, 0, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 62, 0, 0, 179, 0, 0, 0, 180, 0, 0, 0, 164, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 62, 0, 0, 181, 0, 0, 0, 182, 0, 0, 0, 164, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 62, 0, 0, 183, 0, 0, 0, 184, 0, 0, 0, 164, 0, 0, 0, 37, 0, 0, 0, 38, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 39, 0, 0, 0, 11, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 62, 0, 0, 185, 0, 0, 0, 186, 0, 0, 0, 164, 0, 0, 0, 40, 0, 0, 0, 41, 0, 0, 0, 13, 0, 0, 0, 14, 0, 0, 0, 15, 0, 0, 0, 16, 0, 0, 0, 42, 0, 0, 0, 17, 0, 0, 0, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 63, 0, 0, 187, 0, 0, 0, 188, 0, 0, 0, 164, 0, 0, 0, 43, 0, 0, 0, 44, 0, 0, 0, 19, 0, 0, 0, 20, 0, 0, 0, 21, 0, 0, 0, 22, 0, 0, 0, 45, 0, 0, 0, 23, 0, 0, 0, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 63, 0, 0, 189, 0, 0, 0, 190, 0, 0, 0, 164, 0, 0, 0, 46, 0, 0, 0, 47, 0, 0, 0, 25, 0, 0, 0, 26, 0, 0, 0, 27, 0, 0, 0, 28, 0, 0, 0, 48, 0, 0, 0, 29, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 63, 0, 0, 191, 0, 0, 0, 192, 0, 0, 0, 164, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 63, 0, 0, 193, 0, 0, 0, 194, 0, 0, 0, 164, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 144, 63, 0, 0, 195, 0, 0, 0, 196, 0, 0, 0, 164, 0, 0, 0, 1, 0, 0, 0, 37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 176, 63, 0, 0, 197, 0, 0, 0, 198, 0, 0, 0, 164, 0, 0, 0, 2, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 208, 63, 0, 0, 199, 0, 0, 0, 200, 0, 0, 0, 164, 0, 0, 0, 21, 0, 0, 0, 6, 0, 0, 0, 31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 63, 0, 0, 201, 0, 0, 0, 202, 0, 0, 0, 164, 0, 0, 0, 22, 0, 0, 0, 7, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 61, 0, 0, 203, 0, 0, 0, 204, 0, 0, 0, 164, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 61, 0, 0, 205, 0, 0, 0, 206, 0, 0, 0, 164, 0, 0, 0, 26, 0, 0, 0, 23, 0, 0, 0, 27, 0, 0, 0, 24, 0, 0, 0, 28, 0, 0, 0, 1, 0, 0, 0, 25, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 61, 0, 0, 207, 0, 0, 0, 208, 0, 0, 0, 164, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 12, 0, 0, 0, 49, 0, 0, 0, 50, 0, 0, 0, 13, 0, 0, 0, 51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 160, 61, 0, 0, 209, 0, 0, 0, 210, 0, 0, 0, 164, 0, 0, 0, 52, 0, 0, 0, 53, 0, 0, 0, 33, 0, 0, 0, 34, 0, 0, 0, 35, 0, 0, 0, 0, 0, 0, 0, 176, 61, 0, 0, 211, 0, 0, 0, 212, 0, 0, 0, 164, 0, 0, 0, 54, 0, 0, 0, 55, 0, 0, 0, 36, 0, 0, 0, 37, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 128, 60, 0, 0, 213, 0, 0, 0, 214, 0, 0, 0, 164, 0, 0, 0, 0, 0, 0, 0, 144, 60, 0, 0, 213, 0, 0, 0, 215, 0, 0, 0, 164, 0, 0, 0, 26, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 4, 0, 0, 0, 29, 0, 0, 0, 27, 0, 0, 0, 30, 0, 0, 0, 28, 0, 0, 0, 31, 0, 0, 0, 5, 0, 0, 0, 29, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 176, 60, 0, 0, 213, 0, 0, 0, 216, 0, 0, 0, 164, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 15, 0, 0, 0, 56, 0, 0, 0, 57, 0, 0, 0, 16, 0, 0, 0, 58, 0, 0, 0, 0, 0, 0, 0, 208, 60, 0, 0, 213, 0, 0, 0, 217, 0, 0, 0, 164, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 17, 0, 0, 0, 59, 0, 0, 0, 60, 0, 0, 0, 18, 0, 0, 0, 61, 0, 0, 0, 0, 0, 0, 0, 240, 60, 0, 0, 213, 0, 0, 0, 218, 0, 0, 0, 164, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 19, 0, 0, 0, 62, 0, 0, 0, 63, 0, 0, 0, 20, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 16, 61, 0, 0, 213, 0, 0, 0, 219, 0, 0, 0, 164, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 19, 0, 0, 0, 62, 0, 0, 0, 63, 0, 0, 0, 20, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 32, 61, 0, 0, 213, 0, 0, 0, 220, 0, 0, 0, 164, 0, 0, 0, 9, 0, 0, 0, 10, 0, 0, 0, 19, 0, 0, 0, 62, 0, 0, 0, 63, 0, 0, 0, 20, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 72, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 83, 0, 0, 0, 37, 0, 0, 0, 109, 0, 0, 0, 47, 0, 0, 0, 37, 0, 0, 0, 100, 0, 0, 0, 47, 0, 0, 0, 37, 0, 0, 0, 121, 0, 0, 0, 37, 0, 0, 0, 89, 0, 0, 0, 45, 0, 0, 0, 37, 0, 0, 0, 109, 0, 0, 0, 45, 0, 0, 0, 37, 0, 0, 0, 100, 0, 0, 0, 37, 0, 0, 0, 73, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 83, 0, 0, 0, 32, 0, 0, 0, 37, 0, 0, 0, 112, 0, 0, 0, 37, 0, 0, 0, 72, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 37, 0, 0, 0, 72, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 83, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 116, 0, 0, 0, 114, 0, 0, 0, 117, 0, 0, 0, 101, 0, 0, 0, 0, 0, 0, 0, 102, 0, 0, 0, 97, 0, 0, 0, 108, 0, 0, 0, 115, 0, 0, 0, 101, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83, 0, 0, 0, 117, 0, 0, 0, 110, 0, 0, 0, 100, 0, 0, 0, 97, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 77, 0, 0, 0, 111, 0, 0, 0, 110, 0, 0, 0, 100, 0, 0, 0, 97, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 84, 0, 0, 0, 117, 0, 0, 0, 101, 0, 0, 0, 115, 0, 0, 0, 100, 0, 0, 0, 97, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 87, 0, 0, 0, 101, 0, 0, 0, 100, 0, 0, 0, 110, 0, 0, 0, 101, 0, 0, 0, 115, 0, 0, 0, 100, 0, 0, 0, 97, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 84, 0, 0, 0, 104, 0, 0, 0, 117, 0, 0, 0, 114, 0, 0, 0, 115, 0, 0, 0, 100, 0, 0, 0, 97, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 70, 0, 0, 0, 114, 0, 0, 0, 105, 0, 0, 0, 100, 0, 0, 0, 97, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 83, 0, 0, 0, 97, 0, 0, 0, 116, 0, 0, 0, 117, 0, 0, 0, 114, 0, 0, 0, 100, 0, 0, 0, 97, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 83, 0, 0, 0, 117, 0, 0, 0, 110, 0, 0, 0, 0, 0, 0, 0, 77, 0, 0, 0, 111, 0, 0, 0, 110, 0, 0, 0, 0, 0, 0, 0, 84, 0, 0, 0, 117, 0, 0, 0, 101, 0, 0, 0, 0, 0, 0, 0, 87, 0, 0, 0, 101, 0, 0, 0, 100, 0, 0, 0, 0, 0, 0, 0, 84, 0, 0, 0, 104, 0, 0, 0, 117, 0, 0, 0, 0, 0, 0, 0, 70, 0, 0, 0, 114, 0, 0, 0, 105, 0, 0, 0, 0, 0, 0, 0, 83, 0, 0, 0, 97, 0, 0, 0, 116, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 74, 0, 0, 0, 97, 0, 0, 0, 110, 0, 0, 0, 117, 0, 0, 0, 97, 0, 0, 0, 114, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 70, 0, 0, 0, 101, 0, 0, 0, 98, 0, 0, 0, 114, 0, 0, 0, 117, 0, 0, 0, 97, 0, 0, 0, 114, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 77, 0, 0, 0, 97, 0, 0, 0, 114, 0, 0, 0, 99, 0, 0, 0, 104, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 112, 0, 0, 0, 114, 0, 0, 0, 105, 0, 0, 0, 108, 0, 0, 0, 0, 0, 0, 0, 77, 0, 0, 0, 97, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 74, 0, 0, 0, 117, 0, 0, 0, 110, 0, 0, 0, 101, 0, 0, 0, 0, 0, 0, 0, 74, 0, 0, 0, 117, 0, 0, 0, 108, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 117, 0, 0, 0, 103, 0, 0, 0, 117, 0, 0, 0, 115, 0, 0, 0, 116, 0, 0, 0, 0, 0, 0, 0, 83, 0, 0, 0, 101, 0, 0, 0, 112, 0, 0, 0, 116, 0, 0, 0, 101, 0, 0, 0, 109, 0, 0, 0, 98, 0, 0, 0, 101, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 79, 0, 0, 0, 99, 0, 0, 0, 116, 0, 0, 0, 111, 0, 0, 0, 98, 0, 0, 0, 101, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 78, 0, 0, 0, 111, 0, 0, 0, 118, 0, 0, 0, 101, 0, 0, 0, 109, 0, 0, 0, 98, 0, 0, 0, 101, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 101, 0, 0, 0, 99, 0, 0, 0, 101, 0, 0, 0, 109, 0, 0, 0, 98, 0, 0, 0, 101, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 74, 0, 0, 0, 97, 0, 0, 0, 110, 0, 0, 0, 0, 0, 0, 0, 70, 0, 0, 0, 101, 0, 0, 0, 98, 0, 0, 0, 0, 0, 0, 0, 77, 0, 0, 0, 97, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 112, 0, 0, 0, 114, 0, 0, 0, 0, 0, 0, 0, 74, 0, 0, 0, 117, 0, 0, 0, 110, 0, 0, 0, 0, 0, 0, 0, 74, 0, 0, 0, 117, 0, 0, 0, 108, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 117, 0, 0, 0, 103, 0, 0, 0, 0, 0, 0, 0, 83, 0, 0, 0, 101, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 79, 0, 0, 0, 99, 0, 0, 0, 116, 0, 0, 0, 0, 0, 0, 0, 78, 0, 0, 0, 111, 0, 0, 0, 118, 0, 0, 0, 0, 0, 0, 0, 68, 0, 0, 0, 101, 0, 0, 0, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65, 0, 0, 0, 77, 0, 0, 0, 0, 0, 0, 0, 80, 0, 0, 0, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 109, 0, 0, 0, 47, 0, 0, 0, 37, 0, 0, 0, 100, 0, 0, 0, 47, 0, 0, 0, 37, 0, 0, 0, 121, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 72, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 83, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 97, 0, 0, 0, 32, 0, 0, 0, 37, 0, 0, 0, 98, 0, 0, 0, 32, 0, 0, 0, 37, 0, 0, 0, 100, 0, 0, 0, 32, 0, 0, 0, 37, 0, 0, 0, 72, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 83, 0, 0, 0, 32, 0, 0, 0, 37, 0, 0, 0, 89, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 0, 0, 0, 73, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 77, 0, 0, 0, 58, 0, 0, 0, 37, 0, 0, 0, 83, 0, 0, 0, 32, 0, 0, 0, 37, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 67, 0, 0, 221, 0, 0, 0, 222, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 3, 32, 2, 32, 2, 32, 2, 32, 2, 32, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 1, 96, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 8, 216, 8, 216, 8, 216, 8, 216, 8, 216, 8, 216, 8, 216, 8, 216, 8, 216, 8, 216, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 8, 213, 8, 213, 8, 213, 8, 213, 8, 213, 8, 213, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 8, 197, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 4, 192, 8, 214, 8, 214, 8, 214, 8, 214, 8, 214, 8, 214, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 8, 198, 4, 192, 4, 192, 4, 192, 4, 192, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 86, 101, 99, 116, 111, 114, 73, 110, 116, 0, 86, 101, 99, 116, 111, 114, 68, 111, 117, 98, 108, 101, 0, 118, 101, 99, 116, 111, 114, 84, 111, 111, 108, 115, 0, 99, 108, 101, 97, 114, 86, 101, 99, 116, 111, 114, 68, 98, 108, 0, 109, 97, 120, 105, 84, 101, 115, 116, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 79, 115, 99, 62, 0, 115, 117, 109, 65, 114, 114, 97, 121, 0, 109, 97, 120, 105, 83, 101, 116, 116, 105, 110, 103, 115, 0, 115, 101, 116, 117, 112, 0, 109, 97, 120, 105, 79, 115, 99, 0, 115, 105, 110, 101, 119, 97, 118, 101, 0, 99, 111, 115, 119, 97, 118, 101, 0, 112, 104, 97, 115, 111, 114, 0, 115, 97, 119, 0, 116, 114, 105, 97, 110, 103, 108, 101, 0, 115, 113, 117, 97, 114, 101, 0, 112, 117, 108, 115, 101, 0, 110, 111, 105, 115, 101, 0, 115, 105, 110, 101, 98, 117, 102, 0, 115, 105, 110, 101, 98, 117, 102, 52, 0, 115, 97, 119, 110, 0, 114, 101, 99, 116, 0, 112, 104, 97, 115, 101, 82, 101, 115, 101, 116, 0, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 62, 0, 108, 105, 110, 101, 0, 116, 114, 105, 103, 103, 101, 114, 0, 97, 109, 112, 108, 105, 116, 117, 100, 101, 0, 109, 97, 120, 105, 68, 101, 108, 97, 121, 108, 105, 110, 101, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 68, 101, 108, 97, 121, 108, 105, 110, 101, 62, 0, 100, 108, 0, 109, 97, 120, 105, 70, 105, 108, 116, 101, 114, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 70, 105, 108, 116, 101, 114, 62, 0, 108, 111, 114, 101, 115, 0, 104, 105, 114, 101, 115, 0, 98, 97, 110, 100, 112, 97, 115, 115, 0, 108, 111, 112, 97, 115, 115, 0, 104, 105, 112, 97, 115, 115, 0, 109, 97, 120, 105, 77, 105, 120, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 77, 105, 120, 62, 0, 115, 116, 101, 114, 101, 111, 0, 113, 117, 97, 100, 0, 97, 109, 98, 105, 115, 111, 110, 105, 99, 0, 109, 97, 120, 105, 76, 97, 103, 69, 120, 112, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 76, 97, 103, 69, 120, 112, 60, 100, 111, 117, 98, 108, 101, 62, 62, 0, 105, 110, 105, 116, 0, 97, 100, 100, 83, 97, 109, 112, 108, 101, 0, 118, 97, 108, 117, 101, 0, 109, 97, 120, 105, 83, 97, 109, 112, 108, 101, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 83, 97, 109, 112, 108, 101, 62, 0, 103, 101, 116, 76, 101, 110, 103, 116, 104, 0, 115, 101, 116, 83, 97, 109, 112, 108, 101, 0, 105, 115, 82, 101, 97, 100, 121, 0, 112, 108, 97, 121, 79, 110, 99, 101, 0, 112, 108, 97, 121, 0, 112, 108, 97, 121, 52, 0, 99, 108, 101, 97, 114, 0, 109, 97, 120, 105, 77, 97, 112, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 77, 97, 112, 62, 0, 108, 105, 110, 108, 105, 110, 0, 108, 105, 110, 101, 120, 112, 0, 101, 120, 112, 108, 105, 110, 0, 99, 108, 97, 109, 112, 0, 109, 97, 120, 105, 68, 121, 110, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 68, 121, 110, 62, 0, 103, 97, 116, 101, 0, 99, 111, 109, 112, 114, 101, 115, 115, 111, 114, 0, 109, 97, 120, 105, 69, 110, 118, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 69, 110, 118, 62, 0, 97, 114, 0, 97, 100, 115, 114, 0, 99, 111, 110, 118, 101, 114, 116, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 99, 111, 110, 118, 101, 114, 116, 62, 0, 109, 116, 111, 102, 0, 109, 97, 120, 105, 68, 105, 115, 116, 111, 114, 116, 105, 111, 110, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 68, 105, 115, 116, 111, 114, 116, 105, 111, 110, 62, 0, 102, 97, 115, 116, 65, 116, 97, 110, 0, 97, 116, 97, 110, 68, 105, 115, 116, 0, 102, 97, 115, 116, 65, 116, 97, 110, 68, 105, 115, 116, 0, 109, 97, 120, 105, 70, 108, 97, 110, 103, 101, 114, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 70, 108, 97, 110, 103, 101, 114, 62, 0, 102, 108, 97, 110, 103, 101, 0, 109, 97, 120, 105, 67, 104, 111, 114, 117, 115, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 67, 104, 111, 114, 117, 115, 62, 0, 99, 104, 111, 114, 117, 115, 0, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 70, 111, 108, 108, 111, 119, 101, 114, 0, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 60, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 70, 111, 108, 108, 111, 119, 101, 114, 62, 0, 115, 101, 116, 65, 116, 116, 97, 99, 107, 0, 115, 101, 116, 82, 101, 108, 101, 97, 115, 101, 0, 114, 101, 115, 101, 116, 0, 112, 117, 115, 104, 95, 98, 97, 99, 107, 0, 114, 101, 115, 105, 122, 101, 0, 115, 105, 122, 101, 0, 103, 101, 116, 0, 115, 101, 116, 0, 78, 83, 116, 51, 95, 95, 49, 54, 118, 101, 99, 116, 111, 114, 73, 105, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 105, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 51, 95, 95, 118, 101, 99, 116, 111, 114, 95, 98, 97, 115, 101, 73, 105, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 105, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 118, 101, 99, 116, 111, 114, 95, 98, 97, 115, 101, 95, 99, 111, 109, 109, 111, 110, 73, 76, 98, 49, 69, 69, 69, 0, 80, 78, 83, 116, 51, 95, 95, 49, 54, 118, 101, 99, 116, 111, 114, 73, 105, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 105, 69, 69, 69, 69, 0, 80, 75, 78, 83, 116, 51, 95, 95, 49, 54, 118, 101, 99, 116, 111, 114, 73, 105, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 105, 69, 69, 69, 69, 0, 105, 105, 0, 118, 0, 118, 105, 0, 118, 105, 105, 105, 0, 118, 105, 105, 105, 105, 0, 105, 105, 105, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 51, 118, 97, 108, 69, 0, 105, 105, 105, 105, 0, 105, 105, 105, 105, 105, 0, 78, 83, 116, 51, 95, 95, 49, 54, 118, 101, 99, 116, 111, 114, 73, 100, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 100, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 51, 95, 95, 118, 101, 99, 116, 111, 114, 95, 98, 97, 115, 101, 73, 100, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 100, 69, 69, 69, 69, 0, 80, 78, 83, 116, 51, 95, 95, 49, 54, 118, 101, 99, 116, 111, 114, 73, 100, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 100, 69, 69, 69, 69, 0, 80, 75, 78, 83, 116, 51, 95, 95, 49, 54, 118, 101, 99, 116, 111, 114, 73, 100, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 100, 69, 69, 69, 69, 0, 118, 105, 105, 100, 0, 118, 105, 105, 105, 100, 0, 105, 105, 105, 105, 100, 0, 49, 49, 118, 101, 99, 116, 111, 114, 84, 111, 111, 108, 115, 0, 80, 49, 49, 118, 101, 99, 116, 111, 114, 84, 111, 111, 108, 115, 0, 80, 75, 49, 49, 118, 101, 99, 116, 111, 114, 84, 111, 111, 108, 115, 0, 118, 105, 105, 0, 56, 109, 97, 120, 105, 84, 101, 115, 116, 0, 80, 56, 109, 97, 120, 105, 84, 101, 115, 116, 0, 80, 75, 56, 109, 97, 120, 105, 84, 101, 115, 116, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 56, 109, 97, 120, 105, 84, 101, 115, 116, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 56, 109, 97, 120, 105, 84, 101, 115, 116, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 56, 109, 97, 120, 105, 84, 101, 115, 116, 69, 69, 0, 105, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 56, 109, 97, 120, 105, 84, 101, 115, 116, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 49, 50, 109, 97, 120, 105, 83, 101, 116, 116, 105, 110, 103, 115, 0, 80, 49, 50, 109, 97, 120, 105, 83, 101, 116, 116, 105, 110, 103, 115, 0, 80, 75, 49, 50, 109, 97, 120, 105, 83, 101, 116, 116, 105, 110, 103, 115, 0, 55, 109, 97, 120, 105, 79, 115, 99, 0, 80, 55, 109, 97, 120, 105, 79, 115, 99, 0, 80, 75, 55, 109, 97, 120, 105, 79, 115, 99, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 55, 109, 97, 120, 105, 79, 115, 99, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 79, 115, 99, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 79, 115, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 55, 109, 97, 120, 105, 79, 115, 99, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 100, 105, 105, 100, 0, 100, 105, 105, 100, 100, 100, 0, 100, 105, 105, 100, 100, 0, 100, 105, 105, 0, 49, 50, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 0, 80, 49, 50, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 0, 80, 75, 49, 50, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 49, 50, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 50, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 50, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 49, 50, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 100, 105, 105, 105, 105, 0, 49, 51, 109, 97, 120, 105, 68, 101, 108, 97, 121, 108, 105, 110, 101, 0, 80, 49, 51, 109, 97, 120, 105, 68, 101, 108, 97, 121, 108, 105, 110, 101, 0, 80, 75, 49, 51, 109, 97, 120, 105, 68, 101, 108, 97, 121, 108, 105, 110, 101, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 49, 51, 109, 97, 120, 105, 68, 101, 108, 97, 121, 108, 105, 110, 101, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 51, 109, 97, 120, 105, 68, 101, 108, 97, 121, 108, 105, 110, 101, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 51, 109, 97, 120, 105, 68, 101, 108, 97, 121, 108, 105, 110, 101, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 49, 51, 109, 97, 120, 105, 68, 101, 108, 97, 121, 108, 105, 110, 101, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 100, 105, 105, 100, 105, 100, 0, 100, 105, 105, 100, 105, 100, 105, 0, 49, 48, 109, 97, 120, 105, 70, 105, 108, 116, 101, 114, 0, 80, 49, 48, 109, 97, 120, 105, 70, 105, 108, 116, 101, 114, 0, 80, 75, 49, 48, 109, 97, 120, 105, 70, 105, 108, 116, 101, 114, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 49, 48, 109, 97, 120, 105, 70, 105, 108, 116, 101, 114, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 48, 109, 97, 120, 105, 70, 105, 108, 116, 101, 114, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 48, 109, 97, 120, 105, 70, 105, 108, 116, 101, 114, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 49, 48, 109, 97, 120, 105, 70, 105, 108, 116, 101, 114, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 55, 109, 97, 120, 105, 77, 105, 120, 0, 80, 55, 109, 97, 120, 105, 77, 105, 120, 0, 80, 75, 55, 109, 97, 120, 105, 77, 105, 120, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 55, 109, 97, 120, 105, 77, 105, 120, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 77, 105, 120, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 77, 105, 120, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 55, 109, 97, 120, 105, 77, 105, 120, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 118, 105, 105, 100, 105, 100, 0, 118, 105, 105, 100, 105, 100, 100, 0, 118, 105, 105, 100, 105, 100, 100, 100, 0, 49, 48, 109, 97, 120, 105, 76, 97, 103, 69, 120, 112, 73, 100, 69, 0, 80, 49, 48, 109, 97, 120, 105, 76, 97, 103, 69, 120, 112, 73, 100, 69, 0, 80, 75, 49, 48, 109, 97, 120, 105, 76, 97, 103, 69, 120, 112, 73, 100, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 49, 48, 109, 97, 120, 105, 76, 97, 103, 69, 120, 112, 73, 100, 69, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 50, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 50, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 48, 109, 97, 120, 105, 76, 97, 103, 69, 120, 112, 73, 100, 69, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 48, 109, 97, 120, 105, 76, 97, 103, 69, 120, 112, 73, 100, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 49, 48, 109, 97, 120, 105, 76, 97, 103, 69, 120, 112, 73, 100, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 50, 95, 69, 69, 69, 69, 0, 118, 105, 105, 100, 100, 0, 49, 48, 109, 97, 120, 105, 83, 97, 109, 112, 108, 101, 0, 102, 114, 101, 101, 105, 110, 103, 32, 83, 97, 109, 112, 108, 101, 68, 97, 116, 97, 0, 80, 49, 48, 109, 97, 120, 105, 83, 97, 109, 112, 108, 101, 0, 80, 75, 49, 48, 109, 97, 120, 105, 83, 97, 109, 112, 108, 101, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97 ], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 24776);
allocate([ 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 49, 48, 109, 97, 120, 105, 83, 97, 109, 112, 108, 101, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 48, 109, 97, 120, 105, 83, 97, 109, 112, 108, 101, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 48, 109, 97, 120, 105, 83, 97, 109, 112, 108, 101, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 49, 48, 109, 97, 120, 105, 83, 97, 109, 112, 108, 101, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 55, 109, 97, 120, 105, 77, 97, 112, 0, 80, 55, 109, 97, 120, 105, 77, 97, 112, 0, 80, 75, 55, 109, 97, 120, 105, 77, 97, 112, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 55, 109, 97, 120, 105, 77, 97, 112, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 77, 97, 112, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 77, 97, 112, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 55, 109, 97, 120, 105, 77, 97, 112, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 100, 105, 100, 100, 100, 100, 100, 0, 55, 109, 97, 120, 105, 68, 121, 110, 0, 80, 55, 109, 97, 120, 105, 68, 121, 110, 0, 80, 75, 55, 109, 97, 120, 105, 68, 121, 110, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 55, 109, 97, 120, 105, 68, 121, 110, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 68, 121, 110, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 68, 121, 110, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 55, 109, 97, 120, 105, 68, 121, 110, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 100, 105, 105, 100, 100, 105, 100, 100, 0, 100, 105, 105, 100, 100, 100, 100, 100, 0, 55, 109, 97, 120, 105, 69, 110, 118, 0, 80, 55, 109, 97, 120, 105, 69, 110, 118, 0, 80, 75, 55, 109, 97, 120, 105, 69, 110, 118, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 55, 109, 97, 120, 105, 69, 110, 118, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 69, 110, 118, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 109, 97, 120, 105, 69, 110, 118, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 55, 109, 97, 120, 105, 69, 110, 118, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 100, 105, 105, 100, 100, 100, 105, 105, 0, 100, 105, 105, 100, 100, 100, 100, 100, 105, 105, 0, 55, 99, 111, 110, 118, 101, 114, 116, 0, 80, 55, 99, 111, 110, 118, 101, 114, 116, 0, 80, 75, 55, 99, 111, 110, 118, 101, 114, 116, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 55, 99, 111, 110, 118, 101, 114, 116, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 99, 111, 110, 118, 101, 114, 116, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 55, 99, 111, 110, 118, 101, 114, 116, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 55, 99, 111, 110, 118, 101, 114, 116, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 100, 105, 105, 105, 0, 49, 52, 109, 97, 120, 105, 68, 105, 115, 116, 111, 114, 116, 105, 111, 110, 0, 80, 49, 52, 109, 97, 120, 105, 68, 105, 115, 116, 111, 114, 116, 105, 111, 110, 0, 80, 75, 49, 52, 109, 97, 120, 105, 68, 105, 115, 116, 111, 114, 116, 105, 111, 110, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 49, 52, 109, 97, 120, 105, 68, 105, 115, 116, 111, 114, 116, 105, 111, 110, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 52, 109, 97, 120, 105, 68, 105, 115, 116, 111, 114, 116, 105, 111, 110, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 52, 109, 97, 120, 105, 68, 105, 115, 116, 111, 114, 116, 105, 111, 110, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 49, 52, 109, 97, 120, 105, 68, 105, 115, 116, 111, 114, 116, 105, 111, 110, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 49, 49, 109, 97, 120, 105, 70, 108, 97, 110, 103, 101, 114, 0, 80, 49, 49, 109, 97, 120, 105, 70, 108, 97, 110, 103, 101, 114, 0, 80, 75, 49, 49, 109, 97, 120, 105, 70, 108, 97, 110, 103, 101, 114, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 49, 49, 109, 97, 120, 105, 70, 108, 97, 110, 103, 101, 114, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 49, 109, 97, 120, 105, 70, 108, 97, 110, 103, 101, 114, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 49, 109, 97, 120, 105, 70, 108, 97, 110, 103, 101, 114, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 49, 49, 109, 97, 120, 105, 70, 108, 97, 110, 103, 101, 114, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 100, 105, 105, 100, 105, 100, 100, 100, 0, 49, 48, 109, 97, 120, 105, 67, 104, 111, 114, 117, 115, 0, 80, 49, 48, 109, 97, 120, 105, 67, 104, 111, 114, 117, 115, 0, 80, 75, 49, 48, 109, 97, 120, 105, 67, 104, 111, 114, 117, 115, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 49, 48, 109, 97, 120, 105, 67, 104, 111, 114, 117, 115, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 48, 109, 97, 120, 105, 67, 104, 111, 114, 117, 115, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 49, 48, 109, 97, 120, 105, 67, 104, 111, 114, 117, 115, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 49, 48, 109, 97, 120, 105, 67, 104, 111, 114, 117, 115, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 50, 48, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 70, 111, 108, 108, 111, 119, 101, 114, 0, 80, 50, 48, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 70, 111, 108, 108, 111, 119, 101, 114, 0, 80, 75, 50, 48, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 70, 111, 108, 108, 111, 119, 101, 114, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 112, 111, 105, 110, 116, 101, 114, 73, 80, 50, 48, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 70, 111, 108, 108, 111, 119, 101, 114, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 95, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 83, 49, 95, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 53, 115, 109, 97, 114, 116, 95, 112, 116, 114, 95, 116, 114, 97, 105, 116, 73, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 50, 48, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 70, 111, 108, 108, 111, 119, 101, 114, 69, 69, 69, 49, 49, 118, 97, 108, 95, 100, 101, 108, 101, 116, 101, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 73, 50, 48, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 70, 111, 108, 108, 111, 119, 101, 114, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 115, 104, 97, 114, 101, 100, 95, 112, 116, 114, 95, 101, 109, 112, 108, 97, 99, 101, 73, 50, 48, 109, 97, 120, 105, 69, 110, 118, 101, 108, 111, 112, 101, 70, 111, 108, 108, 111, 119, 101, 114, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 83, 49, 95, 69, 69, 69, 69, 0, 118, 111, 105, 100, 0, 98, 111, 111, 108, 0, 99, 104, 97, 114, 0, 115, 105, 103, 110, 101, 100, 32, 99, 104, 97, 114, 0, 117, 110, 115, 105, 103, 110, 101, 100, 32, 99, 104, 97, 114, 0, 115, 104, 111, 114, 116, 0, 117, 110, 115, 105, 103, 110, 101, 100, 32, 115, 104, 111, 114, 116, 0, 105, 110, 116, 0, 117, 110, 115, 105, 103, 110, 101, 100, 32, 105, 110, 116, 0, 108, 111, 110, 103, 0, 117, 110, 115, 105, 103, 110, 101, 100, 32, 108, 111, 110, 103, 0, 102, 108, 111, 97, 116, 0, 100, 111, 117, 98, 108, 101, 0, 115, 116, 100, 58, 58, 115, 116, 114, 105, 110, 103, 0, 115, 116, 100, 58, 58, 98, 97, 115, 105, 99, 95, 115, 116, 114, 105, 110, 103, 60, 117, 110, 115, 105, 103, 110, 101, 100, 32, 99, 104, 97, 114, 62, 0, 115, 116, 100, 58, 58, 119, 115, 116, 114, 105, 110, 103, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 118, 97, 108, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 99, 104, 97, 114, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 115, 105, 103, 110, 101, 100, 32, 99, 104, 97, 114, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 117, 110, 115, 105, 103, 110, 101, 100, 32, 99, 104, 97, 114, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 115, 104, 111, 114, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 117, 110, 115, 105, 103, 110, 101, 100, 32, 115, 104, 111, 114, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 105, 110, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 117, 110, 115, 105, 103, 110, 101, 100, 32, 105, 110, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 108, 111, 110, 103, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 117, 110, 115, 105, 103, 110, 101, 100, 32, 108, 111, 110, 103, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 105, 110, 116, 56, 95, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 117, 105, 110, 116, 56, 95, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 105, 110, 116, 49, 54, 95, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 117, 105, 110, 116, 49, 54, 95, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 105, 110, 116, 51, 50, 95, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 117, 105, 110, 116, 51, 50, 95, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 102, 108, 111, 97, 116, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 100, 111, 117, 98, 108, 101, 62, 0, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 58, 58, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 60, 108, 111, 110, 103, 32, 100, 111, 117, 98, 108, 101, 62, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 101, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 100, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 102, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 109, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 108, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 106, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 105, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 116, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 115, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 104, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 97, 69, 69, 0, 78, 49, 48, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 49, 49, 109, 101, 109, 111, 114, 121, 95, 118, 105, 101, 119, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 50, 98, 97, 115, 105, 99, 95, 115, 116, 114, 105, 110, 103, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 119, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 49, 95, 95, 98, 97, 115, 105, 99, 95, 115, 116, 114, 105, 110, 103, 95, 99, 111, 109, 109, 111, 110, 73, 76, 98, 49, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 50, 98, 97, 115, 105, 99, 95, 115, 116, 114, 105, 110, 103, 73, 104, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 104, 69, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 104, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 50, 98, 97, 115, 105, 99, 95, 115, 116, 114, 105, 110, 103, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 78, 83, 95, 57, 97, 108, 108, 111, 99, 97, 116, 111, 114, 73, 99, 69, 69, 69, 69, 0, 83, 116, 57, 98, 97, 100, 95, 97, 108, 108, 111, 99, 0, 83, 116, 57, 101, 120, 99, 101, 112, 116, 105, 111, 110, 0, 83, 116, 49, 49, 108, 111, 103, 105, 99, 95, 101, 114, 114, 111, 114, 0, 83, 116, 49, 50, 111, 117, 116, 95, 111, 102, 95, 114, 97, 110, 103, 101, 0, 83, 116, 49, 51, 114, 117, 110, 116, 105, 109, 101, 95, 101, 114, 114, 111, 114, 0, 83, 116, 57, 116, 121, 112, 101, 95, 105, 110, 102, 111, 0, 83, 116, 56, 98, 97, 100, 95, 99, 97, 115, 116, 0, 78, 49, 48, 95, 95, 99, 120, 120, 97, 98, 105, 118, 49, 49, 54, 95, 95, 115, 104, 105, 109, 95, 116, 121, 112, 101, 95, 105, 110, 102, 111, 69, 0, 78, 49, 48, 95, 95, 99, 120, 120, 97, 98, 105, 118, 49, 49, 55, 95, 95, 99, 108, 97, 115, 115, 95, 116, 121, 112, 101, 95, 105, 110, 102, 111, 69, 0, 78, 49, 48, 95, 95, 99, 120, 120, 97, 98, 105, 118, 49, 49, 57, 95, 95, 112, 111, 105, 110, 116, 101, 114, 95, 116, 121, 112, 101, 95, 105, 110, 102, 111, 69, 0, 78, 49, 48, 95, 95, 99, 120, 120, 97, 98, 105, 118, 49, 49, 55, 95, 95, 112, 98, 97, 115, 101, 95, 116, 121, 112, 101, 95, 105, 110, 102, 111, 69, 0, 78, 49, 48, 95, 95, 99, 120, 120, 97, 98, 105, 118, 49, 50, 51, 95, 95, 102, 117, 110, 100, 97, 109, 101, 110, 116, 97, 108, 95, 116, 121, 112, 101, 95, 105, 110, 102, 111, 69, 0, 118, 0, 68, 110, 0, 98, 0, 99, 0, 104, 0, 97, 0, 115, 0, 116, 0, 105, 0, 106, 0, 109, 0, 102, 0, 100, 0, 78, 49, 48, 95, 95, 99, 120, 120, 97, 98, 105, 118, 49, 50, 48, 95, 95, 115, 105, 95, 99, 108, 97, 115, 115, 95, 116, 121, 112, 101, 95, 105, 110, 102, 111, 69, 0, 78, 49, 48, 95, 95, 99, 120, 120, 97, 98, 105, 118, 49, 50, 49, 95, 95, 118, 109, 105, 95, 99, 108, 97, 115, 115, 95, 116, 121, 112, 101, 95, 105, 110, 102, 111, 69, 0, 33, 34, 118, 101, 99, 116, 111, 114, 32, 108, 101, 110, 103, 116, 104, 95, 101, 114, 114, 111, 114, 34, 0, 47, 85, 115, 101, 114, 115, 47, 68, 97, 110, 47, 68, 111, 99, 117, 109, 101, 110, 116, 115, 47, 80, 114, 111, 103, 114, 97, 109, 109, 105, 110, 103, 47, 69, 109, 115, 99, 114, 105, 112, 116, 101, 110, 47, 101, 109, 115, 100, 107, 95, 112, 111, 114, 116, 97, 98, 108, 101, 47, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 47, 49, 46, 51, 53, 46, 48, 47, 115, 121, 115, 116, 101, 109, 47, 105, 110, 99, 108, 117, 100, 101, 47, 108, 105, 98, 99, 120, 120, 47, 118, 101, 99, 116, 111, 114, 0, 95, 95, 116, 104, 114, 111, 119, 95, 108, 101, 110, 103, 116, 104, 95, 101, 114, 114, 111, 114, 0, 112, 116, 104, 114, 101, 97, 100, 95, 111, 110, 99, 101, 32, 102, 97, 105, 108, 117, 114, 101, 32, 105, 110, 32, 95, 95, 99, 120, 97, 95, 103, 101, 116, 95, 103, 108, 111, 98, 97, 108, 115, 95, 102, 97, 115, 116, 40, 41, 0, 115, 116, 100, 58, 58, 98, 97, 100, 95, 97, 108, 108, 111, 99, 0, 116, 101, 114, 109, 105, 110, 97, 116, 101, 95, 104, 97, 110, 100, 108, 101, 114, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 108, 121, 32, 114, 101, 116, 117, 114, 110, 101, 100, 0, 116, 101, 114, 109, 105, 110, 97, 116, 101, 95, 104, 97, 110, 100, 108, 101, 114, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 108, 121, 32, 116, 104, 114, 101, 119, 32, 97, 110, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 0, 115, 116, 100, 58, 58, 98, 97, 100, 95, 99, 97, 115, 116, 0, 99, 97, 110, 110, 111, 116, 32, 99, 114, 101, 97, 116, 101, 32, 112, 116, 104, 114, 101, 97, 100, 32, 107, 101, 121, 32, 102, 111, 114, 32, 95, 95, 99, 120, 97, 95, 103, 101, 116, 95, 103, 108, 111, 98, 97, 108, 115, 40, 41, 0, 99, 97, 110, 110, 111, 116, 32, 122, 101, 114, 111, 32, 111, 117, 116, 32, 116, 104, 114, 101, 97, 100, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 95, 95, 99, 120, 97, 95, 103, 101, 116, 95, 103, 108, 111, 98, 97, 108, 115, 40, 41, 0, 33, 34, 98, 97, 115, 105, 99, 95, 115, 116, 114, 105, 110, 103, 32, 108, 101, 110, 103, 116, 104, 95, 101, 114, 114, 111, 114, 34, 0, 47, 85, 115, 101, 114, 115, 47, 68, 97, 110, 47, 68, 111, 99, 117, 109, 101, 110, 116, 115, 47, 80, 114, 111, 103, 114, 97, 109, 109, 105, 110, 103, 47, 69, 109, 115, 99, 114, 105, 112, 116, 101, 110, 47, 101, 109, 115, 100, 107, 95, 112, 111, 114, 116, 97, 98, 108, 101, 47, 101, 109, 115, 99, 114, 105, 112, 116, 101, 110, 47, 49, 46, 51, 53, 46, 48, 47, 115, 121, 115, 116, 101, 109, 47, 105, 110, 99, 108, 117, 100, 101, 47, 108, 105, 98, 99, 120, 120, 47, 115, 116, 114, 105, 110, 103, 0, 116, 101, 114, 109, 105, 110, 97, 116, 105, 110, 103, 32, 119, 105, 116, 104, 32, 37, 115, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 32, 111, 102, 32, 116, 121, 112, 101, 32, 37, 115, 58, 32, 37, 115, 0, 116, 101, 114, 109, 105, 110, 97, 116, 105, 110, 103, 32, 119, 105, 116, 104, 32, 37, 115, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 32, 111, 102, 32, 116, 121, 112, 101, 32, 37, 115, 0, 116, 101, 114, 109, 105, 110, 97, 116, 105, 110, 103, 32, 119, 105, 116, 104, 32, 37, 115, 32, 102, 111, 114, 101, 105, 103, 110, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 0, 116, 101, 114, 109, 105, 110, 97, 116, 105, 110, 103, 0, 117, 110, 99, 97, 117, 103, 104, 116, 0, 84, 33, 34, 25, 13, 1, 2, 3, 17, 75, 28, 12, 16, 4, 11, 29, 18, 30, 39, 104, 110, 111, 112, 113, 98, 32, 5, 6, 15, 19, 20, 21, 26, 8, 22, 7, 40, 36, 23, 24, 9, 10, 14, 27, 31, 37, 35, 131, 130, 125, 38, 42, 43, 60, 61, 62, 63, 67, 71, 74, 77, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 99, 100, 101, 102, 103, 105, 106, 107, 108, 114, 115, 116, 121, 122, 123, 124, 0, 73, 108, 108, 101, 103, 97, 108, 32, 98, 121, 116, 101, 32, 115, 101, 113, 117, 101, 110, 99, 101, 0, 68, 111, 109, 97, 105, 110, 32, 101, 114, 114, 111, 114, 0, 82, 101, 115, 117, 108, 116, 32, 110, 111, 116, 32, 114, 101, 112, 114, 101, 115, 101, 110, 116, 97, 98, 108, 101, 0, 78, 111, 116, 32, 97, 32, 116, 116, 121, 0, 80, 101, 114, 109, 105, 115, 115, 105, 111, 110, 32, 100, 101, 110, 105, 101, 100, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 110, 111, 116, 32, 112, 101, 114, 109, 105, 116, 116, 101, 100, 0, 78, 111, 32, 115, 117, 99, 104, 32, 102, 105, 108, 101, 32, 111, 114, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0, 78, 111, 32, 115, 117, 99, 104, 32, 112, 114, 111, 99, 101, 115, 115, 0, 70, 105, 108, 101, 32, 101, 120, 105, 115, 116, 115, 0, 86, 97, 108, 117, 101, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 32, 102, 111, 114, 32, 100, 97, 116, 97, 32, 116, 121, 112, 101, 0, 78, 111, 32, 115, 112, 97, 99, 101, 32, 108, 101, 102, 116, 32, 111, 110, 32, 100, 101, 118, 105, 99, 101, 0, 79, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 98, 117, 115, 121, 0, 73, 110, 116, 101, 114, 114, 117, 112, 116, 101, 100, 32, 115, 121, 115, 116, 101, 109, 32, 99, 97, 108, 108, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 116, 101, 109, 112, 111, 114, 97, 114, 105, 108, 121, 32, 117, 110, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 73, 110, 118, 97, 108, 105, 100, 32, 115, 101, 101, 107, 0, 67, 114, 111, 115, 115, 45, 100, 101, 118, 105, 99, 101, 32, 108, 105, 110, 107, 0, 82, 101, 97, 100, 45, 111, 110, 108, 121, 32, 102, 105, 108, 101, 32, 115, 121, 115, 116, 101, 109, 0, 68, 105, 114, 101, 99, 116, 111, 114, 121, 32, 110, 111, 116, 32, 101, 109, 112, 116, 121, 0, 67, 111, 110, 110, 101, 99, 116, 105, 111, 110, 32, 114, 101, 115, 101, 116, 32, 98, 121, 32, 112, 101, 101, 114, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 116, 105, 109, 101, 100, 32, 111, 117, 116, 0, 67, 111, 110, 110, 101, 99, 116, 105, 111, 110, 32, 114, 101, 102, 117, 115, 101, 100, 0, 72, 111, 115, 116, 32, 105, 115, 32, 100, 111, 119, 110, 0, 72, 111, 115, 116, 32, 105, 115, 32, 117, 110, 114, 101, 97, 99, 104, 97, 98, 108, 101, 0, 65, 100, 100, 114, 101, 115, 115, 32, 105, 110, 32, 117, 115, 101, 0, 66, 114, 111, 107, 101, 110, 32, 112, 105, 112, 101, 0, 73, 47, 79, 32, 101, 114, 114, 111, 114, 0, 78, 111, 32, 115, 117, 99, 104, 32, 100, 101, 118, 105, 99, 101, 32, 111, 114, 32, 97, 100, 100, 114, 101, 115, 115, 0, 66, 108, 111, 99, 107, 32, 100, 101, 118, 105, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 0, 78, 111, 32, 115, 117, 99, 104, 32, 100, 101, 118, 105, 99, 101, 0, 78, 111, 116, 32, 97, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0, 73, 115, 32, 97, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0, 84, 101, 120, 116, 32, 102, 105, 108, 101, 32, 98, 117, 115, 121, 0, 69, 120, 101, 99, 32, 102, 111, 114, 109, 97, 116, 32, 101, 114, 114, 111, 114, 0, 73, 110, 118, 97, 108, 105, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 0, 65, 114, 103, 117, 109, 101, 110, 116, 32, 108, 105, 115, 116, 32, 116, 111, 111, 32, 108, 111, 110, 103, 0, 83, 121, 109, 98, 111, 108, 105, 99, 32, 108, 105, 110, 107, 32, 108, 111, 111, 112, 0, 70, 105, 108, 101, 110, 97, 109, 101, 32, 116, 111, 111, 32, 108, 111, 110, 103, 0, 84, 111, 111, 32, 109, 97, 110, 121, 32, 111, 112, 101, 110, 32, 102, 105, 108, 101, 115, 32, 105, 110, 32, 115, 121, 115, 116, 101, 109, 0, 78, 111, 32, 102, 105, 108, 101, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 66, 97, 100, 32, 102, 105, 108, 101, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 0, 78, 111, 32, 99, 104, 105, 108, 100, 32, 112, 114, 111, 99, 101, 115, 115, 0, 66, 97, 100, 32, 97, 100, 100, 114, 101, 115, 115, 0, 70, 105, 108, 101, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 0, 84, 111, 111, 32, 109, 97, 110, 121, 32, 108, 105, 110, 107, 115, 0, 78, 111, 32, 108, 111, 99, 107, 115, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 100, 101, 97, 100, 108, 111, 99, 107, 32, 119, 111, 117, 108, 100, 32, 111, 99, 99, 117, 114, 0, 83, 116, 97, 116, 101, 32, 110, 111, 116, 32, 114, 101, 99, 111, 118, 101, 114, 97, 98, 108, 101, 0, 80, 114, 101, 118, 105, 111, 117, 115, 32, 111, 119, 110, 101, 114, 32, 100, 105, 101, 100, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 110, 99, 101, 108, 101, 100, 0, 70, 117, 110, 99, 116, 105, 111, 110, 32, 110, 111, 116, 32, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 0, 78, 111, 32, 109, 101, 115, 115, 97, 103, 101, 32, 111, 102, 32, 100, 101, 115, 105, 114, 101, 100, 32, 116, 121, 112, 101, 0, 73, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 114, 101, 109, 111, 118, 101, 100, 0, 68, 101, 118, 105, 99, 101, 32, 110, 111, 116, 32, 97, 32, 115, 116, 114, 101, 97, 109, 0, 78, 111, 32, 100, 97, 116, 97, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 68, 101, 118, 105, 99, 101, 32, 116, 105, 109, 101, 111, 117, 116, 0, 79, 117, 116, 32, 111, 102, 32, 115, 116, 114, 101, 97, 109, 115, 32, 114, 101, 115, 111, 117, 114, 99, 101, 115, 0, 76, 105, 110, 107, 32, 104, 97, 115, 32, 98, 101, 101, 110, 32, 115, 101, 118, 101, 114, 101, 100, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 101, 114, 114, 111, 114, 0, 66, 97, 100, 32, 109, 101, 115, 115, 97, 103, 101, 0, 70, 105, 108, 101, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 105, 110, 32, 98, 97, 100, 32, 115, 116, 97, 116, 101, 0, 78, 111, 116, 32, 97, 32, 115, 111, 99, 107, 101, 116, 0, 68, 101, 115, 116, 105, 110, 97, 116, 105, 111, 110, 32, 97, 100, 100, 114, 101, 115, 115, 32, 114, 101, 113, 117, 105, 114, 101, 100, 0, 77, 101, 115, 115, 97, 103, 101, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 119, 114, 111, 110, 103, 32, 116, 121, 112, 101, 32, 102, 111, 114, 32, 115, 111, 99, 107, 101, 116, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 110, 111, 116, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 83, 111, 99, 107, 101, 116, 32, 116, 121, 112, 101, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 78, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 102, 97, 109, 105, 108, 121, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 65, 100, 100, 114, 101, 115, 115, 32, 102, 97, 109, 105, 108, 121, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 98, 121, 32, 112, 114, 111, 116, 111, 99, 111, 108, 0, 65, 100, 100, 114, 101, 115, 115, 32, 110, 111, 116, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 78, 101, 116, 119, 111, 114, 107, 32, 105, 115, 32, 100, 111, 119, 110, 0, 78, 101, 116, 119, 111, 114, 107, 32, 117, 110, 114, 101, 97, 99, 104, 97, 98, 108, 101, 0, 67, 111, 110, 110, 101, 99, 116, 105, 111, 110, 32, 114, 101, 115, 101, 116, 32, 98, 121, 32, 110, 101, 116, 119, 111, 114, 107, 0, 67, 111, 110, 110, 101, 99, 116, 105, 111, 110, 32, 97, 98, 111, 114, 116, 101, 100, 0, 78, 111, 32, 98, 117, 102, 102, 101, 114, 32, 115, 112, 97, 99, 101, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 83, 111, 99, 107, 101, 116, 32, 105, 115, 32, 99, 111, 110, 110, 101, 99, 116, 101, 100, 0, 83, 111, 99, 107, 101, 116, 32, 110, 111, 116, 32, 99, 111, 110, 110, 101, 99, 116, 101, 100, 0, 67, 97, 110, 110, 111, 116, 32, 115, 101, 110, 100, 32, 97, 102, 116, 101, 114, 32, 115, 111, 99, 107, 101, 116, 32, 115, 104, 117, 116, 100, 111, 119, 110, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 97, 108, 114, 101, 97, 100, 121, 32, 105, 110, 32, 112, 114, 111, 103, 114, 101, 115, 115, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 105, 110, 32, 112, 114, 111, 103, 114, 101, 115, 115, 0, 83, 116, 97, 108, 101, 32, 102, 105, 108, 101, 32, 104, 97, 110, 100, 108, 101, 0, 82, 101, 109, 111, 116, 101, 32, 73, 47, 79, 32, 101, 114, 114, 111, 114, 0, 81, 117, 111, 116, 97, 32, 101, 120, 99, 101, 101, 100, 101, 100, 0, 78, 111, 32, 109, 101, 100, 105, 117, 109, 32, 102, 111, 117, 110, 100, 0, 87, 114, 111, 110, 103, 32, 109, 101, 100, 105, 117, 109, 32, 116, 121, 112, 101, 0, 78, 111, 32, 101, 114, 114, 111, 114, 32, 105, 110, 102, 111, 114, 109, 97, 116, 105, 111, 110, 0, 0, 105, 110, 102, 105, 110, 105, 116, 121, 0, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 255, 255, 255, 255, 255, 255, 255, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 255, 255, 255, 255, 255, 255, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 0, 1, 2, 4, 7, 3, 6, 5, 0, 80, 79, 83, 73, 88 ], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 35016);
allocate([ 17, 0, 10, 0, 17, 17, 17, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 15, 10, 17, 17, 17, 3, 10, 7, 0, 1, 19, 9, 11, 11, 0, 0, 9, 6, 11, 0, 0, 11, 0, 6, 17, 0, 0, 0, 17, 17, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 10, 10, 17, 17, 17, 0, 10, 0, 0, 2, 0, 9, 11, 0, 0, 0, 9, 0, 11, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 12, 0, 0, 0, 0, 9, 12, 0, 0, 0, 0, 0, 12, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 4, 13, 0, 0, 0, 0, 9, 14, 0, 0, 0, 0, 0, 14, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 15, 0, 0, 0, 0, 9, 16, 0, 0, 0, 0, 0, 16, 0, 0, 16, 0, 0, 18, 0, 0, 0, 18, 18, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 18, 18, 18, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 10, 0, 0, 0, 0, 9, 11, 0, 0, 0, 0, 0, 11, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 12, 0, 0, 0, 0, 9, 12, 0, 0, 0, 0, 0, 12, 0, 0, 12, 0, 0, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70, 45, 43, 32, 32, 32, 48, 88, 48, 120, 0, 40, 110, 117, 108, 108, 41, 0, 45, 48, 88, 43, 48, 88, 32, 48, 88, 45, 48, 120, 43, 48, 120, 32, 48, 120, 0, 105, 110, 102, 0, 73, 78, 70, 0, 110, 97, 110, 0, 78, 65, 78, 0, 46, 0, 0, 78, 83, 116, 51, 95, 95, 49, 49, 49, 95, 95, 115, 116, 100, 111, 117, 116, 98, 117, 102, 73, 119, 69, 69, 0, 117, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 108, 111, 99, 97, 108, 101, 32, 102, 111, 114, 32, 115, 116, 97, 110, 100, 97, 114, 100, 32, 105, 110, 112, 117, 116, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 95, 95, 115, 116, 100, 105, 110, 98, 117, 102, 73, 119, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 49, 95, 95, 115, 116, 100, 111, 117, 116, 98, 117, 102, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 95, 95, 115, 116, 100, 105, 110, 98, 117, 102, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 52, 95, 95, 115, 104, 97, 114, 101, 100, 95, 99, 111, 117, 110, 116, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 57, 95, 95, 115, 104, 97, 114, 101, 100, 95, 119, 101, 97, 107, 95, 99, 111, 117, 110, 116, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 105, 111, 115, 95, 98, 97, 115, 101, 55, 102, 97, 105, 108, 117, 114, 101, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 105, 111, 115, 95, 98, 97, 115, 101, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 98, 97, 115, 105, 99, 95, 105, 111, 115, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 98, 97, 115, 105, 99, 95, 105, 111, 115, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 53, 98, 97, 115, 105, 99, 95, 115, 116, 114, 101, 97, 109, 98, 117, 102, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 53, 98, 97, 115, 105, 99, 95, 115, 116, 114, 101, 97, 109, 98, 117, 102, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 51, 98, 97, 115, 105, 99, 95, 105, 115, 116, 114, 101, 97, 109, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 51, 98, 97, 115, 105, 99, 95, 105, 115, 116, 114, 101, 97, 109, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 51, 98, 97, 115, 105, 99, 95, 111, 115, 116, 114, 101, 97, 109, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 51, 98, 97, 115, 105, 99, 95, 111, 115, 116, 114, 101, 97, 109, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 57, 95, 95, 105, 111, 115, 116, 114, 101, 97, 109, 95, 99, 97, 116, 101, 103, 111, 114, 121, 69, 0, 105, 111, 115, 95, 98, 97, 115, 101, 58, 58, 99, 108, 101, 97, 114, 0, 105, 111, 115, 116, 114, 101, 97, 109, 0, 117, 110, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 105, 111, 115, 116, 114, 101, 97, 109, 95, 99, 97, 116, 101, 103, 111, 114, 121, 32, 101, 114, 114, 111, 114, 0, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 97, 98, 99, 100, 101, 102, 65, 66, 67, 68, 69, 70, 120, 88, 43, 45, 112, 80, 105, 73, 110, 78, 0, 78, 83, 116, 51, 95, 95, 49, 54, 108, 111, 99, 97, 108, 101, 53, 102, 97, 99, 101, 116, 69, 0, 78, 83, 116, 51, 95, 95, 49, 53, 99, 116, 121, 112, 101, 73, 119, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 99, 111, 100, 101, 99, 118, 116, 73, 99, 99, 49, 49, 95, 95, 109, 98, 115, 116, 97, 116, 101, 95, 116, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 99, 111, 100, 101, 99, 118, 116, 73, 68, 115, 99, 49, 49, 95, 95, 109, 98, 115, 116, 97, 116, 101, 95, 116, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 99, 111, 100, 101, 99, 118, 116, 73, 68, 105, 99, 49, 49, 95, 95, 109, 98, 115, 116, 97, 116, 101, 95, 116, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 54, 95, 95, 110, 97, 114, 114, 111, 119, 95, 116, 111, 95, 117, 116, 102, 56, 73, 76, 106, 51, 50, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 55, 95, 95, 119, 105, 100, 101, 110, 95, 102, 114, 111, 109, 95, 117, 116, 102, 56, 73, 76, 106, 51, 50, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 99, 111, 100, 101, 99, 118, 116, 73, 119, 99, 49, 49, 95, 95, 109, 98, 115, 116, 97, 116, 101, 95, 116, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 54, 108, 111, 99, 97, 108, 101, 53, 95, 95, 105, 109, 112, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 99, 111, 108, 108, 97, 116, 101, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 99, 111, 108, 108, 97, 116, 101, 73, 119, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 53, 99, 116, 121, 112, 101, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 110, 117, 109, 112, 117, 110, 99, 116, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 110, 117, 109, 112, 117, 110, 99, 116, 73, 119, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 110, 117, 109, 95, 103, 101, 116, 73, 99, 78, 83, 95, 49, 57, 105, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 110, 117, 109, 95, 103, 101, 116, 73, 119, 78, 83, 95, 49, 57, 105, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 110, 117, 109, 95, 112, 117, 116, 73, 99, 78, 83, 95, 49, 57, 111, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 55, 110, 117, 109, 95, 112, 117, 116, 73, 119, 78, 83, 95, 49, 57, 111, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 116, 105, 109, 101, 95, 103, 101, 116, 73, 99, 78, 83, 95, 49, 57, 105, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 116, 105, 109, 101, 95, 103, 101, 116, 73, 119, 78, 83, 95, 49, 57, 105, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 116, 105, 109, 101, 95, 112, 117, 116, 73, 99, 78, 83, 95, 49, 57, 111, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 116, 105, 109, 101, 95, 112, 117, 116, 73, 119, 78, 83, 95, 49, 57, 111, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 109, 111, 110, 101, 121, 112, 117, 110, 99, 116, 73, 99, 76, 98, 48, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 109, 111, 110, 101, 121, 112, 117, 110, 99, 116, 73, 99, 76, 98, 49, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 109, 111, 110, 101, 121, 112, 117, 110, 99, 116, 73, 119, 76, 98, 48, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 109, 111, 110, 101, 121, 112, 117, 110, 99, 116, 73, 119, 76, 98, 49, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 109, 111, 110, 101, 121, 95, 103, 101, 116, 73, 99, 78, 83, 95, 49, 57, 105, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 109, 111, 110, 101, 121, 95, 103, 101, 116, 73, 119, 78, 83, 95, 49, 57, 105, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 109, 111, 110, 101, 121, 95, 112, 117, 116, 73, 99, 78, 83, 95, 49, 57, 111, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 99, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 99, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 109, 111, 110, 101, 121, 95, 112, 117, 116, 73, 119, 78, 83, 95, 49, 57, 111, 115, 116, 114, 101, 97, 109, 98, 117, 102, 95, 105, 116, 101, 114, 97, 116, 111, 114, 73, 119, 78, 83, 95, 49, 49, 99, 104, 97, 114, 95, 116, 114, 97, 105, 116, 115, 73, 119, 69, 69, 69, 69, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 109, 101, 115, 115, 97, 103, 101, 115, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 56, 109, 101, 115, 115, 97, 103, 101, 115, 73, 119, 69, 69, 0, 37, 112, 0, 67, 0, 37, 0, 0, 0, 0, 0, 108, 0, 108, 108, 0, 0, 76, 0, 37, 112, 0, 0, 0, 0, 37, 72, 58, 37, 77, 58, 37, 83, 37, 109, 47, 37, 100, 47, 37, 121, 37, 89, 45, 37, 109, 45, 37, 100, 37, 73, 58, 37, 77, 58, 37, 83, 32, 37, 112, 37, 72, 58, 37, 77, 37, 72, 58, 37, 77, 58, 37, 83, 108, 111, 99, 97, 108, 101, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 0, 37, 76, 102, 0, 109, 111, 110, 101, 121, 95, 103, 101, 116, 32, 101, 114, 114, 111, 114, 0, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 0, 37, 46, 48, 76, 102, 0, 118, 101, 99, 116, 111, 114, 0, 116, 114, 117, 101, 0, 102, 97, 108, 115, 101, 0, 83, 117, 110, 100, 97, 121, 0, 77, 111, 110, 100, 97, 121, 0, 84, 117, 101, 115, 100, 97, 121, 0, 87, 101, 100, 110, 101, 115, 100, 97, 121, 0, 84, 104, 117, 114, 115, 100, 97, 121, 0, 70, 114, 105, 100, 97, 121, 0, 83, 97, 116, 117, 114, 100, 97, 121, 0, 83, 117, 110, 0, 77, 111, 110, 0, 84, 117, 101, 0, 87, 101, 100, 0, 84, 104, 117, 0, 70, 114, 105, 0, 83, 97, 116, 0, 74, 97, 110, 117, 97, 114, 121, 0, 70, 101, 98, 114, 117, 97, 114, 121, 0, 77, 97, 114, 99, 104, 0, 65, 112, 114, 105, 108, 0, 77, 97, 121, 0, 74, 117, 110, 101, 0, 74, 117, 108, 121, 0, 65, 117, 103, 117, 115, 116, 0, 83, 101, 112, 116, 101, 109, 98, 101, 114, 0, 79, 99, 116, 111, 98, 101, 114, 0, 78, 111, 118, 101, 109, 98, 101, 114, 0, 68, 101, 99, 101, 109, 98, 101, 114, 0, 74, 97, 110, 0, 70, 101, 98, 0, 77, 97, 114, 0, 65, 112, 114, 0, 74, 117, 110, 0, 74, 117, 108, 0, 65, 117, 103, 0, 83, 101, 112, 0, 79, 99, 116, 0, 78, 111, 118, 0, 68, 101, 99, 0, 65, 77, 0, 80, 77, 0, 37, 109, 47, 37, 100, 47, 37, 121, 0, 37, 72, 58, 37, 77, 58, 37, 83, 0, 37, 97, 32, 37, 98, 32, 37, 100, 32, 37, 72, 58, 37, 77, 58, 37, 83, 32, 37, 89, 0, 37, 73, 58, 37, 77, 58, 37, 83, 32, 37, 112, 0, 78, 83, 116, 51, 95, 95, 49, 49, 51, 109, 101, 115, 115, 97, 103, 101, 115, 95, 98, 97, 115, 101, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 49, 95, 95, 109, 111, 110, 101, 121, 95, 112, 117, 116, 73, 119, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 49, 95, 95, 109, 111, 110, 101, 121, 95, 112, 117, 116, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 49, 95, 95, 109, 111, 110, 101, 121, 95, 103, 101, 116, 73, 119, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 49, 95, 95, 109, 111, 110, 101, 121, 95, 103, 101, 116, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 109, 111, 110, 101, 121, 95, 98, 97, 115, 101, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 95, 95, 116, 105, 109, 101, 95, 112, 117, 116, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 116, 105, 109, 101, 95, 103, 101, 116, 95, 99, 95, 115, 116, 111, 114, 97, 103, 101, 73, 119, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 50, 48, 95, 95, 116, 105, 109, 101, 95, 103, 101, 116, 95, 99, 95, 115, 116, 111, 114, 97, 103, 101, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 116, 105, 109, 101, 95, 98, 97, 115, 101, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 95, 95, 110, 117, 109, 95, 112, 117, 116, 73, 119, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 52, 95, 95, 110, 117, 109, 95, 112, 117, 116, 95, 98, 97, 115, 101, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 95, 95, 110, 117, 109, 95, 112, 117, 116, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 95, 95, 110, 117, 109, 95, 103, 101, 116, 73, 119, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 52, 95, 95, 110, 117, 109, 95, 103, 101, 116, 95, 98, 97, 115, 101, 69, 0, 78, 83, 116, 51, 95, 95, 49, 57, 95, 95, 110, 117, 109, 95, 103, 101, 116, 73, 99, 69, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 50, 99, 111, 100, 101, 99, 118, 116, 95, 98, 97, 115, 101, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 48, 99, 116, 121, 112, 101, 95, 98, 97, 115, 101, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 50, 115, 121, 115, 116, 101, 109, 95, 101, 114, 114, 111, 114, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 52, 101, 114, 114, 111, 114, 95, 99, 97, 116, 101, 103, 111, 114, 121, 69, 0, 78, 83, 116, 51, 95, 95, 49, 49, 50, 95, 95, 100, 111, 95, 109, 101, 115, 115, 97, 103, 101, 69, 0, 58, 32, 0 ], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE + 44922);
var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);
assert(tempDoublePtr % 8 == 0);
function copyTempFloat(ptr) {
 HEAP8[tempDoublePtr] = HEAP8[ptr];
 HEAP8[tempDoublePtr + 1] = HEAP8[ptr + 1];
 HEAP8[tempDoublePtr + 2] = HEAP8[ptr + 2];
 HEAP8[tempDoublePtr + 3] = HEAP8[ptr + 3];
}
function copyTempDouble(ptr) {
 HEAP8[tempDoublePtr] = HEAP8[ptr];
 HEAP8[tempDoublePtr + 1] = HEAP8[ptr + 1];
 HEAP8[tempDoublePtr + 2] = HEAP8[ptr + 2];
 HEAP8[tempDoublePtr + 3] = HEAP8[ptr + 3];
 HEAP8[tempDoublePtr + 4] = HEAP8[ptr + 4];
 HEAP8[tempDoublePtr + 5] = HEAP8[ptr + 5];
 HEAP8[tempDoublePtr + 6] = HEAP8[ptr + 6];
 HEAP8[tempDoublePtr + 7] = HEAP8[ptr + 7];
}
function _atexit(func, arg) {
 __ATEXIT__.unshift({
  func: func,
  arg: arg
 });
}
function ___cxa_atexit() {
 return _atexit.apply(null, arguments);
}
var registeredTypes = {};
function _free() {}
Module["_free"] = _free;
function embind_init_charCodes() {
 var codes = new Array(256);
 for (var i = 0; i < 256; ++i) {
  codes[i] = String.fromCharCode(i);
 }
 embind_charCodes = codes;
}
var embind_charCodes = undefined;
function readLatin1String(ptr) {
 var ret = "";
 var c = ptr;
 while (HEAPU8[c]) {
  ret += embind_charCodes[HEAPU8[c++]];
 }
 return ret;
}
function getTypeName(type) {
 var ptr = ___getTypeName(type);
 var rv = readLatin1String(ptr);
 _free(ptr);
 return rv;
}
var char_0 = 48;
var char_9 = 57;
function makeLegalFunctionName(name) {
 if (undefined === name) {
  return "_unknown";
 }
 name = name.replace(/[^a-zA-Z0-9_]/g, "$");
 var f = name.charCodeAt(0);
 if (f >= char_0 && f <= char_9) {
  return "_" + name;
 } else {
  return name;
 }
}
function createNamedFunction(name, body) {
 name = makeLegalFunctionName(name);
 return (new Function("body", "return function " + name + "() {\n" + '    "use strict";' + "    return body.apply(this, arguments);\n" + "};\n"))(body);
}
function extendError(baseErrorType, errorName) {
 var errorClass = createNamedFunction(errorName, (function(message) {
  this.name = errorName;
  this.message = message;
  var stack = (new Error(message)).stack;
  if (stack !== undefined) {
   this.stack = this.toString() + "\n" + stack.replace(/^Error(:[^\n]*)?\n/, "");
  }
 }));
 errorClass.prototype = Object.create(baseErrorType.prototype);
 errorClass.prototype.constructor = errorClass;
 errorClass.prototype.toString = (function() {
  if (this.message === undefined) {
   return this.name;
  } else {
   return this.name + ": " + this.message;
  }
 });
 return errorClass;
}
var BindingError = undefined;
function throwBindingError(message) {
 throw new BindingError(message);
}
function requireRegisteredType(rawType, humanName) {
 var impl = registeredTypes[rawType];
 if (undefined === impl) {
  throwBindingError(humanName + " has unknown type " + getTypeName(rawType));
 }
 return impl;
}
function __emval_lookupTypes(argCount, argTypes, argWireTypes) {
 var a = new Array(argCount);
 for (var i = 0; i < argCount; ++i) {
  a[i] = requireRegisteredType(HEAP32[(argTypes >> 2) + i], "parameter " + i);
 }
 return a;
}
var emval_free_list = [];
var emval_handle_array = [ {}, {
 value: undefined
}, {
 value: null
}, {
 value: true
}, {
 value: false
} ];
function count_emval_handles() {
 var count = 0;
 for (var i = 5; i < emval_handle_array.length; ++i) {
  if (emval_handle_array[i] !== undefined) {
   ++count;
  }
 }
 return count;
}
function get_first_emval() {
 for (var i = 5; i < emval_handle_array.length; ++i) {
  if (emval_handle_array[i] !== undefined) {
   return emval_handle_array[i];
  }
 }
 return null;
}
function init_emval() {
 Module["count_emval_handles"] = count_emval_handles;
 Module["get_first_emval"] = get_first_emval;
}
function __emval_register(value) {
 switch (value) {
 case undefined:
  {
   return 1;
  }
 case null:
  {
   return 2;
  }
 case true:
  {
   return 3;
  }
 case false:
  {
   return 4;
  }
 default:
  {
   var handle = emval_free_list.length ? emval_free_list.pop() : emval_handle_array.length;
   emval_handle_array[handle] = {
    refcount: 1,
    value: value
   };
   return handle;
  }
 }
}
function requireHandle(handle) {
 if (!handle) {
  throwBindingError("Cannot use deleted val. handle = " + handle);
 }
 return emval_handle_array[handle].value;
}
function __emval_call(handle, argCount, argTypes, argv) {
 handle = requireHandle(handle);
 var types = __emval_lookupTypes(argCount, argTypes);
 var args = new Array(argCount);
 for (var i = 0; i < argCount; ++i) {
  var type = types[i];
  args[i] = type["readValueFromPointer"](argv);
  argv += type["argPackAdvance"];
 }
 var rv = handle.apply(undefined, args);
 return __emval_register(rv);
}
Module["_i64Subtract"] = _i64Subtract;
function ___setErrNo(value) {
 if (Module["___errno_location"]) HEAP32[Module["___errno_location"]() >> 2] = value;
 return value;
}
var ERRNO_CODES = {
 EPERM: 1,
 ENOENT: 2,
 ESRCH: 3,
 EINTR: 4,
 EIO: 5,
 ENXIO: 6,
 E2BIG: 7,
 ENOEXEC: 8,
 EBADF: 9,
 ECHILD: 10,
 EAGAIN: 11,
 EWOULDBLOCK: 11,
 ENOMEM: 12,
 EACCES: 13,
 EFAULT: 14,
 ENOTBLK: 15,
 EBUSY: 16,
 EEXIST: 17,
 EXDEV: 18,
 ENODEV: 19,
 ENOTDIR: 20,
 EISDIR: 21,
 EINVAL: 22,
 ENFILE: 23,
 EMFILE: 24,
 ENOTTY: 25,
 ETXTBSY: 26,
 EFBIG: 27,
 ENOSPC: 28,
 ESPIPE: 29,
 EROFS: 30,
 EMLINK: 31,
 EPIPE: 32,
 EDOM: 33,
 ERANGE: 34,
 ENOMSG: 42,
 EIDRM: 43,
 ECHRNG: 44,
 EL2NSYNC: 45,
 EL3HLT: 46,
 EL3RST: 47,
 ELNRNG: 48,
 EUNATCH: 49,
 ENOCSI: 50,
 EL2HLT: 51,
 EDEADLK: 35,
 ENOLCK: 37,
 EBADE: 52,
 EBADR: 53,
 EXFULL: 54,
 ENOANO: 55,
 EBADRQC: 56,
 EBADSLT: 57,
 EDEADLOCK: 35,
 EBFONT: 59,
 ENOSTR: 60,
 ENODATA: 61,
 ETIME: 62,
 ENOSR: 63,
 ENONET: 64,
 ENOPKG: 65,
 EREMOTE: 66,
 ENOLINK: 67,
 EADV: 68,
 ESRMNT: 69,
 ECOMM: 70,
 EPROTO: 71,
 EMULTIHOP: 72,
 EDOTDOT: 73,
 EBADMSG: 74,
 ENOTUNIQ: 76,
 EBADFD: 77,
 EREMCHG: 78,
 ELIBACC: 79,
 ELIBBAD: 80,
 ELIBSCN: 81,
 ELIBMAX: 82,
 ELIBEXEC: 83,
 ENOSYS: 38,
 ENOTEMPTY: 39,
 ENAMETOOLONG: 36,
 ELOOP: 40,
 EOPNOTSUPP: 95,
 EPFNOSUPPORT: 96,
 ECONNRESET: 104,
 ENOBUFS: 105,
 EAFNOSUPPORT: 97,
 EPROTOTYPE: 91,
 ENOTSOCK: 88,
 ENOPROTOOPT: 92,
 ESHUTDOWN: 108,
 ECONNREFUSED: 111,
 EADDRINUSE: 98,
 ECONNABORTED: 103,
 ENETUNREACH: 101,
 ENETDOWN: 100,
 ETIMEDOUT: 110,
 EHOSTDOWN: 112,
 EHOSTUNREACH: 113,
 EINPROGRESS: 115,
 EALREADY: 114,
 EDESTADDRREQ: 89,
 EMSGSIZE: 90,
 EPROTONOSUPPORT: 93,
 ESOCKTNOSUPPORT: 94,
 EADDRNOTAVAIL: 99,
 ENETRESET: 102,
 EISCONN: 106,
 ENOTCONN: 107,
 ETOOMANYREFS: 109,
 EUSERS: 87,
 EDQUOT: 122,
 ESTALE: 116,
 ENOTSUP: 95,
 ENOMEDIUM: 123,
 EILSEQ: 84,
 EOVERFLOW: 75,
 ECANCELED: 125,
 ENOTRECOVERABLE: 131,
 EOWNERDEAD: 130,
 ESTRPIPE: 86
};
function _sysconf(name) {
 switch (name) {
 case 30:
  return PAGE_SIZE;
 case 85:
  return totalMemory / PAGE_SIZE;
 case 132:
 case 133:
 case 12:
 case 137:
 case 138:
 case 15:
 case 235:
 case 16:
 case 17:
 case 18:
 case 19:
 case 20:
 case 149:
 case 13:
 case 10:
 case 236:
 case 153:
 case 9:
 case 21:
 case 22:
 case 159:
 case 154:
 case 14:
 case 77:
 case 78:
 case 139:
 case 80:
 case 81:
 case 82:
 case 68:
 case 67:
 case 164:
 case 11:
 case 29:
 case 47:
 case 48:
 case 95:
 case 52:
 case 51:
 case 46:
  return 200809;
 case 79:
  return 0;
 case 27:
 case 246:
 case 127:
 case 128:
 case 23:
 case 24:
 case 160:
 case 161:
 case 181:
 case 182:
 case 242:
 case 183:
 case 184:
 case 243:
 case 244:
 case 245:
 case 165:
 case 178:
 case 179:
 case 49:
 case 50:
 case 168:
 case 169:
 case 175:
 case 170:
 case 171:
 case 172:
 case 97:
 case 76:
 case 32:
 case 173:
 case 35:
  return -1;
 case 176:
 case 177:
 case 7:
 case 155:
 case 8:
 case 157:
 case 125:
 case 126:
 case 92:
 case 93:
 case 129:
 case 130:
 case 131:
 case 94:
 case 91:
  return 1;
 case 74:
 case 60:
 case 69:
 case 70:
 case 4:
  return 1024;
 case 31:
 case 42:
 case 72:
  return 32;
 case 87:
 case 26:
 case 33:
  return 2147483647;
 case 34:
 case 1:
  return 47839;
 case 38:
 case 36:
  return 99;
 case 43:
 case 37:
  return 2048;
 case 0:
  return 2097152;
 case 3:
  return 65536;
 case 28:
  return 32768;
 case 44:
  return 32767;
 case 75:
  return 16384;
 case 39:
  return 1e3;
 case 89:
  return 700;
 case 71:
  return 256;
 case 40:
  return 255;
 case 2:
  return 100;
 case 180:
  return 64;
 case 25:
  return 20;
 case 5:
  return 16;
 case 6:
  return 6;
 case 73:
  return 4;
 case 84:
  {
   if (typeof navigator === "object") return navigator["hardwareConcurrency"] || 1;
   return 1;
  }
 }
 ___setErrNo(ERRNO_CODES.EINVAL);
 return -1;
}
function __ZSt18uncaught_exceptionv() {
 return !!__ZSt18uncaught_exceptionv.uncaught_exception;
}
var EXCEPTIONS = {
 last: 0,
 caught: [],
 infos: {},
 deAdjust: (function(adjusted) {
  if (!adjusted || EXCEPTIONS.infos[adjusted]) return adjusted;
  for (var ptr in EXCEPTIONS.infos) {
   var info = EXCEPTIONS.infos[ptr];
   if (info.adjusted === adjusted) {
    return ptr;
   }
  }
  return adjusted;
 }),
 addRef: (function(ptr) {
  if (!ptr) return;
  var info = EXCEPTIONS.infos[ptr];
  info.refcount++;
 }),
 decRef: (function(ptr) {
  if (!ptr) return;
  var info = EXCEPTIONS.infos[ptr];
  assert(info.refcount > 0);
  info.refcount--;
  if (info.refcount === 0) {
   if (info.destructor) {
    Runtime.dynCall("vi", info.destructor, [ ptr ]);
   }
   delete EXCEPTIONS.infos[ptr];
   ___cxa_free_exception(ptr);
  }
 }),
 clearRef: (function(ptr) {
  if (!ptr) return;
  var info = EXCEPTIONS.infos[ptr];
  info.refcount = 0;
 })
};
function ___resumeException(ptr) {
 if (!EXCEPTIONS.last) {
  EXCEPTIONS.last = ptr;
 }
 EXCEPTIONS.clearRef(EXCEPTIONS.deAdjust(ptr));
 throw ptr;
}
function ___cxa_find_matching_catch() {
 var thrown = EXCEPTIONS.last;
 if (!thrown) {
  return (asm["setTempRet0"](0), 0) | 0;
 }
 var info = EXCEPTIONS.infos[thrown];
 var throwntype = info.type;
 if (!throwntype) {
  return (asm["setTempRet0"](0), thrown) | 0;
 }
 var typeArray = Array.prototype.slice.call(arguments);
 var pointer = Module["___cxa_is_pointer_type"](throwntype);
 if (!___cxa_find_matching_catch.buffer) ___cxa_find_matching_catch.buffer = _malloc(4);
 HEAP32[___cxa_find_matching_catch.buffer >> 2] = thrown;
 thrown = ___cxa_find_matching_catch.buffer;
 for (var i = 0; i < typeArray.length; i++) {
  if (typeArray[i] && Module["___cxa_can_catch"](typeArray[i], throwntype, thrown)) {
   thrown = HEAP32[thrown >> 2];
   info.adjusted = thrown;
   return (asm["setTempRet0"](typeArray[i]), thrown) | 0;
  }
 }
 thrown = HEAP32[thrown >> 2];
 return (asm["setTempRet0"](throwntype), thrown) | 0;
}
function ___cxa_throw(ptr, type, destructor) {
 EXCEPTIONS.infos[ptr] = {
  ptr: ptr,
  adjusted: ptr,
  type: type,
  destructor: destructor,
  refcount: 0
 };
 EXCEPTIONS.last = ptr;
 if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
  __ZSt18uncaught_exceptionv.uncaught_exception = 1;
 } else {
  __ZSt18uncaught_exceptionv.uncaught_exception++;
 }
 throw ptr;
}
var _emscripten_resume = true;
var _emscripten_landingpad = true;
function ___cxa_free_exception(ptr) {
 try {
  return _free(ptr);
 } catch (e) {}
}
function ___cxa_end_catch() {
 if (___cxa_end_catch.rethrown) {
  ___cxa_end_catch.rethrown = false;
  return;
 }
 asm["setThrew"](0);
 var ptr = EXCEPTIONS.caught.pop();
 if (ptr) {
  EXCEPTIONS.decRef(EXCEPTIONS.deAdjust(ptr));
  EXCEPTIONS.last = 0;
 }
}
function _malloc(bytes) {
 var ptr = Runtime.dynamicAlloc(bytes + 8);
 return ptr + 8 & 4294967288;
}
Module["_malloc"] = _malloc;
var awaitingDependencies = {};
var typeDependencies = {};
var InternalError = undefined;
function throwInternalError(message) {
 throw new InternalError(message);
}
function whenDependentTypesAreResolved(myTypes, dependentTypes, getTypeConverters) {
 myTypes.forEach((function(type) {
  typeDependencies[type] = dependentTypes;
 }));
 function onComplete(typeConverters) {
  var myTypeConverters = getTypeConverters(typeConverters);
  if (myTypeConverters.length !== myTypes.length) {
   throwInternalError("Mismatched type converter count");
  }
  for (var i = 0; i < myTypes.length; ++i) {
   registerType(myTypes[i], myTypeConverters[i]);
  }
 }
 var typeConverters = new Array(dependentTypes.length);
 var unregisteredTypes = [];
 var registered = 0;
 dependentTypes.forEach((function(dt, i) {
  if (registeredTypes.hasOwnProperty(dt)) {
   typeConverters[i] = registeredTypes[dt];
  } else {
   unregisteredTypes.push(dt);
   if (!awaitingDependencies.hasOwnProperty(dt)) {
    awaitingDependencies[dt] = [];
   }
   awaitingDependencies[dt].push((function() {
    typeConverters[i] = registeredTypes[dt];
    ++registered;
    if (registered === unregisteredTypes.length) {
     onComplete(typeConverters);
    }
   }));
  }
 }));
 if (0 === unregisteredTypes.length) {
  onComplete(typeConverters);
 }
}
function registerType(rawType, registeredInstance, options) {
 options = options || {};
 if (!("argPackAdvance" in registeredInstance)) {
  throw new TypeError("registerType registeredInstance requires argPackAdvance");
 }
 var name = registeredInstance.name;
 if (!rawType) {
  throwBindingError('type "' + name + '" must have a positive integer typeid pointer');
 }
 if (registeredTypes.hasOwnProperty(rawType)) {
  if (options.ignoreDuplicateRegistrations) {
   return;
  } else {
   throwBindingError("Cannot register type '" + name + "' twice");
  }
 }
 registeredTypes[rawType] = registeredInstance;
 delete typeDependencies[rawType];
 if (awaitingDependencies.hasOwnProperty(rawType)) {
  var callbacks = awaitingDependencies[rawType];
  delete awaitingDependencies[rawType];
  callbacks.forEach((function(cb) {
   cb();
  }));
 }
}
function simpleReadValueFromPointer(pointer) {
 return this["fromWireType"](HEAPU32[pointer >> 2]);
}
function __embind_register_std_wstring(rawType, charSize, name) {
 name = readLatin1String(name);
 var getHeap, shift;
 if (charSize === 2) {
  getHeap = (function() {
   return HEAPU16;
  });
  shift = 1;
 } else if (charSize === 4) {
  getHeap = (function() {
   return HEAPU32;
  });
  shift = 2;
 }
 registerType(rawType, {
  name: name,
  "fromWireType": (function(value) {
   var HEAP = getHeap();
   var length = HEAPU32[value >> 2];
   var a = new Array(length);
   var start = value + 4 >> shift;
   for (var i = 0; i < length; ++i) {
    a[i] = String.fromCharCode(HEAP[start + i]);
   }
   _free(value);
   return a.join("");
  }),
  "toWireType": (function(destructors, value) {
   var HEAP = getHeap();
   var length = value.length;
   var ptr = _malloc(4 + length * charSize);
   HEAPU32[ptr >> 2] = length;
   var start = ptr + 4 >> shift;
   for (var i = 0; i < length; ++i) {
    HEAP[start + i] = value.charCodeAt(i);
   }
   if (destructors !== null) {
    destructors.push(_free, ptr);
   }
   return ptr;
  }),
  "argPackAdvance": 8,
  "readValueFromPointer": simpleReadValueFromPointer,
  destructorFunction: (function(ptr) {
   _free(ptr);
  })
 });
}
function __emval_decref(handle) {
 if (handle > 4 && 0 === --emval_handle_array[handle].refcount) {
  emval_handle_array[handle] = undefined;
  emval_free_list.push(handle);
 }
}
var _log = Math_log;
var _emscripten_postinvoke = true;
var PTHREAD_SPECIFIC = {};
var PTHREAD_SPECIFIC_NEXT_KEY = 1;
function _pthread_key_create(key, destructor) {
 if (key == 0) {
  return ERRNO_CODES.EINVAL;
 }
 HEAP32[key >> 2] = PTHREAD_SPECIFIC_NEXT_KEY;
 PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
 PTHREAD_SPECIFIC_NEXT_KEY++;
 return 0;
}
function getShiftFromSize(size) {
 switch (size) {
 case 1:
  return 0;
 case 2:
  return 1;
 case 4:
  return 2;
 case 8:
  return 3;
 default:
  throw new TypeError("Unknown type size: " + size);
 }
}
function __embind_register_bool(rawType, name, size, trueValue, falseValue) {
 var shift = getShiftFromSize(size);
 name = readLatin1String(name);
 registerType(rawType, {
  name: name,
  "fromWireType": (function(wt) {
   return !!wt;
  }),
  "toWireType": (function(destructors, o) {
   return o ? trueValue : falseValue;
  }),
  "argPackAdvance": 8,
  "readValueFromPointer": (function(pointer) {
   var heap;
   if (size === 1) {
    heap = HEAP8;
   } else if (size === 2) {
    heap = HEAP16;
   } else if (size === 4) {
    heap = HEAP32;
   } else {
    throw new TypeError("Unknown boolean type size: " + name);
   }
   return this["fromWireType"](heap[pointer >> shift]);
  }),
  destructorFunction: null
 });
}
function __emval_take_value(type, argv) {
 type = requireRegisteredType(type, "_emval_take_value");
 var v = type["readValueFromPointer"](argv);
 return __emval_register(v);
}
function __embind_register_emval(rawType, name) {
 name = readLatin1String(name);
 registerType(rawType, {
  name: name,
  "fromWireType": (function(handle) {
   var rv = emval_handle_array[handle].value;
   __emval_decref(handle);
   return rv;
  }),
  "toWireType": (function(destructors, value) {
   return __emval_register(value);
  }),
  "argPackAdvance": 8,
  "readValueFromPointer": simpleReadValueFromPointer,
  destructorFunction: null
 });
}
var ERRNO_MESSAGES = {
 0: "Success",
 1: "Not super-user",
 2: "No such file or directory",
 3: "No such process",
 4: "Interrupted system call",
 5: "I/O error",
 6: "No such device or address",
 7: "Arg list too long",
 8: "Exec format error",
 9: "Bad file number",
 10: "No children",
 11: "No more processes",
 12: "Not enough core",
 13: "Permission denied",
 14: "Bad address",
 15: "Block device required",
 16: "Mount device busy",
 17: "File exists",
 18: "Cross-device link",
 19: "No such device",
 20: "Not a directory",
 21: "Is a directory",
 22: "Invalid argument",
 23: "Too many open files in system",
 24: "Too many open files",
 25: "Not a typewriter",
 26: "Text file busy",
 27: "File too large",
 28: "No space left on device",
 29: "Illegal seek",
 30: "Read only file system",
 31: "Too many links",
 32: "Broken pipe",
 33: "Math arg out of domain of func",
 34: "Math result not representable",
 35: "File locking deadlock error",
 36: "File or path name too long",
 37: "No record locks available",
 38: "Function not implemented",
 39: "Directory not empty",
 40: "Too many symbolic links",
 42: "No message of desired type",
 43: "Identifier removed",
 44: "Channel number out of range",
 45: "Level 2 not synchronized",
 46: "Level 3 halted",
 47: "Level 3 reset",
 48: "Link number out of range",
 49: "Protocol driver not attached",
 50: "No CSI structure available",
 51: "Level 2 halted",
 52: "Invalid exchange",
 53: "Invalid request descriptor",
 54: "Exchange full",
 55: "No anode",
 56: "Invalid request code",
 57: "Invalid slot",
 59: "Bad font file fmt",
 60: "Device not a stream",
 61: "No data (for no delay io)",
 62: "Timer expired",
 63: "Out of streams resources",
 64: "Machine is not on the network",
 65: "Package not installed",
 66: "The object is remote",
 67: "The link has been severed",
 68: "Advertise error",
 69: "Srmount error",
 70: "Communication error on send",
 71: "Protocol error",
 72: "Multihop attempted",
 73: "Cross mount point (not really error)",
 74: "Trying to read unreadable message",
 75: "Value too large for defined data type",
 76: "Given log. name not unique",
 77: "f.d. invalid for this operation",
 78: "Remote address changed",
 79: "Can   access a needed shared lib",
 80: "Accessing a corrupted shared lib",
 81: ".lib section in a.out corrupted",
 82: "Attempting to link in too many libs",
 83: "Attempting to exec a shared library",
 84: "Illegal byte sequence",
 86: "Streams pipe error",
 87: "Too many users",
 88: "Socket operation on non-socket",
 89: "Destination address required",
 90: "Message too long",
 91: "Protocol wrong type for socket",
 92: "Protocol not available",
 93: "Unknown protocol",
 94: "Socket type not supported",
 95: "Not supported",
 96: "Protocol family not supported",
 97: "Address family not supported by protocol family",
 98: "Address already in use",
 99: "Address not available",
 100: "Network interface is not configured",
 101: "Network is unreachable",
 102: "Connection reset by network",
 103: "Connection aborted",
 104: "Connection reset by peer",
 105: "No buffer space available",
 106: "Socket is already connected",
 107: "Socket is not connected",
 108: "Can't send after socket shutdown",
 109: "Too many references",
 110: "Connection timed out",
 111: "Connection refused",
 112: "Host is down",
 113: "Host is unreachable",
 114: "Socket already connected",
 115: "Connection already in progress",
 116: "Stale file handle",
 122: "Quota exceeded",
 123: "No medium (in tape drive)",
 125: "Operation canceled",
 130: "Previous owner died",
 131: "State not recoverable"
};
var PATH = {
 splitPath: (function(filename) {
  var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
  return splitPathRe.exec(filename).slice(1);
 }),
 normalizeArray: (function(parts, allowAboveRoot) {
  var up = 0;
  for (var i = parts.length - 1; i >= 0; i--) {
   var last = parts[i];
   if (last === ".") {
    parts.splice(i, 1);
   } else if (last === "..") {
    parts.splice(i, 1);
    up++;
   } else if (up) {
    parts.splice(i, 1);
    up--;
   }
  }
  if (allowAboveRoot) {
   for (; up--; up) {
    parts.unshift("..");
   }
  }
  return parts;
 }),
 normalize: (function(path) {
  var isAbsolute = path.charAt(0) === "/", trailingSlash = path.substr(-1) === "/";
  path = PATH.normalizeArray(path.split("/").filter((function(p) {
   return !!p;
  })), !isAbsolute).join("/");
  if (!path && !isAbsolute) {
   path = ".";
  }
  if (path && trailingSlash) {
   path += "/";
  }
  return (isAbsolute ? "/" : "") + path;
 }),
 dirname: (function(path) {
  var result = PATH.splitPath(path), root = result[0], dir = result[1];
  if (!root && !dir) {
   return ".";
  }
  if (dir) {
   dir = dir.substr(0, dir.length - 1);
  }
  return root + dir;
 }),
 basename: (function(path) {
  if (path === "/") return "/";
  var lastSlash = path.lastIndexOf("/");
  if (lastSlash === -1) return path;
  return path.substr(lastSlash + 1);
 }),
 extname: (function(path) {
  return PATH.splitPath(path)[3];
 }),
 join: (function() {
  var paths = Array.prototype.slice.call(arguments, 0);
  return PATH.normalize(paths.join("/"));
 }),
 join2: (function(l, r) {
  return PATH.normalize(l + "/" + r);
 }),
 resolve: (function() {
  var resolvedPath = "", resolvedAbsolute = false;
  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
   var path = i >= 0 ? arguments[i] : FS.cwd();
   if (typeof path !== "string") {
    throw new TypeError("Arguments to path.resolve must be strings");
   } else if (!path) {
    return "";
   }
   resolvedPath = path + "/" + resolvedPath;
   resolvedAbsolute = path.charAt(0) === "/";
  }
  resolvedPath = PATH.normalizeArray(resolvedPath.split("/").filter((function(p) {
   return !!p;
  })), !resolvedAbsolute).join("/");
  return (resolvedAbsolute ? "/" : "") + resolvedPath || ".";
 }),
 relative: (function(from, to) {
  from = PATH.resolve(from).substr(1);
  to = PATH.resolve(to).substr(1);
  function trim(arr) {
   var start = 0;
   for (; start < arr.length; start++) {
    if (arr[start] !== "") break;
   }
   var end = arr.length - 1;
   for (; end >= 0; end--) {
    if (arr[end] !== "") break;
   }
   if (start > end) return [];
   return arr.slice(start, end - start + 1);
  }
  var fromParts = trim(from.split("/"));
  var toParts = trim(to.split("/"));
  var length = Math.min(fromParts.length, toParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
   if (fromParts[i] !== toParts[i]) {
    samePartsLength = i;
    break;
   }
  }
  var outputParts = [];
  for (var i = samePartsLength; i < fromParts.length; i++) {
   outputParts.push("..");
  }
  outputParts = outputParts.concat(toParts.slice(samePartsLength));
  return outputParts.join("/");
 })
};
var TTY = {
 ttys: [],
 init: (function() {}),
 shutdown: (function() {}),
 register: (function(dev, ops) {
  TTY.ttys[dev] = {
   input: [],
   output: [],
   ops: ops
  };
  FS.registerDevice(dev, TTY.stream_ops);
 }),
 stream_ops: {
  open: (function(stream) {
   var tty = TTY.ttys[stream.node.rdev];
   if (!tty) {
    throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
   }
   stream.tty = tty;
   stream.seekable = false;
  }),
  close: (function(stream) {
   stream.tty.ops.flush(stream.tty);
  }),
  flush: (function(stream) {
   stream.tty.ops.flush(stream.tty);
  }),
  read: (function(stream, buffer, offset, length, pos) {
   if (!stream.tty || !stream.tty.ops.get_char) {
    throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
   }
   var bytesRead = 0;
   for (var i = 0; i < length; i++) {
    var result;
    try {
     result = stream.tty.ops.get_char(stream.tty);
    } catch (e) {
     throw new FS.ErrnoError(ERRNO_CODES.EIO);
    }
    if (result === undefined && bytesRead === 0) {
     throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
    }
    if (result === null || result === undefined) break;
    bytesRead++;
    buffer[offset + i] = result;
   }
   if (bytesRead) {
    stream.node.timestamp = Date.now();
   }
   return bytesRead;
  }),
  write: (function(stream, buffer, offset, length, pos) {
   if (!stream.tty || !stream.tty.ops.put_char) {
    throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
   }
   for (var i = 0; i < length; i++) {
    try {
     stream.tty.ops.put_char(stream.tty, buffer[offset + i]);
    } catch (e) {
     throw new FS.ErrnoError(ERRNO_CODES.EIO);
    }
   }
   if (length) {
    stream.node.timestamp = Date.now();
   }
   return i;
  })
 },
 default_tty_ops: {
  get_char: (function(tty) {
   if (!tty.input.length) {
    var result = null;
    if (ENVIRONMENT_IS_NODE) {
     var BUFSIZE = 256;
     var buf = new Buffer(BUFSIZE);
     var bytesRead = 0;
     var fd = process.stdin.fd;
     var usingDevice = false;
     try {
      fd = fs.openSync("/dev/stdin", "r");
      usingDevice = true;
     } catch (e) {}
     bytesRead = fs.readSync(fd, buf, 0, BUFSIZE, null);
     if (usingDevice) {
      fs.closeSync(fd);
     }
     if (bytesRead > 0) {
      result = buf.slice(0, bytesRead).toString("utf-8");
     } else {
      result = null;
     }
    } else if (typeof window != "undefined" && typeof window.prompt == "function") {
     result = window.prompt("Input: ");
     if (result !== null) {
      result += "\n";
     }
    } else if (typeof readline == "function") {
     result = readline();
     if (result !== null) {
      result += "\n";
     }
    }
    if (!result) {
     return null;
    }
    tty.input = intArrayFromString(result, true);
   }
   return tty.input.shift();
  }),
  put_char: (function(tty, val) {
   if (val === null || val === 10) {
    Module["print"](UTF8ArrayToString(tty.output, 0));
    tty.output = [];
   } else {
    if (val != 0) tty.output.push(val);
   }
  }),
  flush: (function(tty) {
   if (tty.output && tty.output.length > 0) {
    Module["print"](UTF8ArrayToString(tty.output, 0));
    tty.output = [];
   }
  })
 },
 default_tty1_ops: {
  put_char: (function(tty, val) {
   if (val === null || val === 10) {
    Module["printErr"](UTF8ArrayToString(tty.output, 0));
    tty.output = [];
   } else {
    if (val != 0) tty.output.push(val);
   }
  }),
  flush: (function(tty) {
   if (tty.output && tty.output.length > 0) {
    Module["printErr"](UTF8ArrayToString(tty.output, 0));
    tty.output = [];
   }
  })
 }
};
var MEMFS = {
 ops_table: null,
 mount: (function(mount) {
  return MEMFS.createNode(null, "/", 16384 | 511, 0);
 }),
 createNode: (function(parent, name, mode, dev) {
  if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (!MEMFS.ops_table) {
   MEMFS.ops_table = {
    dir: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr,
      lookup: MEMFS.node_ops.lookup,
      mknod: MEMFS.node_ops.mknod,
      rename: MEMFS.node_ops.rename,
      unlink: MEMFS.node_ops.unlink,
      rmdir: MEMFS.node_ops.rmdir,
      readdir: MEMFS.node_ops.readdir,
      symlink: MEMFS.node_ops.symlink
     },
     stream: {
      llseek: MEMFS.stream_ops.llseek
     }
    },
    file: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr
     },
     stream: {
      llseek: MEMFS.stream_ops.llseek,
      read: MEMFS.stream_ops.read,
      write: MEMFS.stream_ops.write,
      allocate: MEMFS.stream_ops.allocate,
      mmap: MEMFS.stream_ops.mmap,
      msync: MEMFS.stream_ops.msync
     }
    },
    link: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr,
      readlink: MEMFS.node_ops.readlink
     },
     stream: {}
    },
    chrdev: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr
     },
     stream: FS.chrdev_stream_ops
    }
   };
  }
  var node = FS.createNode(parent, name, mode, dev);
  if (FS.isDir(node.mode)) {
   node.node_ops = MEMFS.ops_table.dir.node;
   node.stream_ops = MEMFS.ops_table.dir.stream;
   node.contents = {};
  } else if (FS.isFile(node.mode)) {
   node.node_ops = MEMFS.ops_table.file.node;
   node.stream_ops = MEMFS.ops_table.file.stream;
   node.usedBytes = 0;
   node.contents = null;
  } else if (FS.isLink(node.mode)) {
   node.node_ops = MEMFS.ops_table.link.node;
   node.stream_ops = MEMFS.ops_table.link.stream;
  } else if (FS.isChrdev(node.mode)) {
   node.node_ops = MEMFS.ops_table.chrdev.node;
   node.stream_ops = MEMFS.ops_table.chrdev.stream;
  }
  node.timestamp = Date.now();
  if (parent) {
   parent.contents[name] = node;
  }
  return node;
 }),
 getFileDataAsRegularArray: (function(node) {
  if (node.contents && node.contents.subarray) {
   var arr = [];
   for (var i = 0; i < node.usedBytes; ++i) arr.push(node.contents[i]);
   return arr;
  }
  return node.contents;
 }),
 getFileDataAsTypedArray: (function(node) {
  if (!node.contents) return new Uint8Array;
  if (node.contents.subarray) return node.contents.subarray(0, node.usedBytes);
  return new Uint8Array(node.contents);
 }),
 expandFileStorage: (function(node, newCapacity) {
  if (node.contents && node.contents.subarray && newCapacity > node.contents.length) {
   node.contents = MEMFS.getFileDataAsRegularArray(node);
   node.usedBytes = node.contents.length;
  }
  if (!node.contents || node.contents.subarray) {
   var prevCapacity = node.contents ? node.contents.buffer.byteLength : 0;
   if (prevCapacity >= newCapacity) return;
   var CAPACITY_DOUBLING_MAX = 1024 * 1024;
   newCapacity = Math.max(newCapacity, prevCapacity * (prevCapacity < CAPACITY_DOUBLING_MAX ? 2 : 1.125) | 0);
   if (prevCapacity != 0) newCapacity = Math.max(newCapacity, 256);
   var oldContents = node.contents;
   node.contents = new Uint8Array(newCapacity);
   if (node.usedBytes > 0) node.contents.set(oldContents.subarray(0, node.usedBytes), 0);
   return;
  }
  if (!node.contents && newCapacity > 0) node.contents = [];
  while (node.contents.length < newCapacity) node.contents.push(0);
 }),
 resizeFileStorage: (function(node, newSize) {
  if (node.usedBytes == newSize) return;
  if (newSize == 0) {
   node.contents = null;
   node.usedBytes = 0;
   return;
  }
  if (!node.contents || node.contents.subarray) {
   var oldContents = node.contents;
   node.contents = new Uint8Array(new ArrayBuffer(newSize));
   if (oldContents) {
    node.contents.set(oldContents.subarray(0, Math.min(newSize, node.usedBytes)));
   }
   node.usedBytes = newSize;
   return;
  }
  if (!node.contents) node.contents = [];
  if (node.contents.length > newSize) node.contents.length = newSize; else while (node.contents.length < newSize) node.contents.push(0);
  node.usedBytes = newSize;
 }),
 node_ops: {
  getattr: (function(node) {
   var attr = {};
   attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
   attr.ino = node.id;
   attr.mode = node.mode;
   attr.nlink = 1;
   attr.uid = 0;
   attr.gid = 0;
   attr.rdev = node.rdev;
   if (FS.isDir(node.mode)) {
    attr.size = 4096;
   } else if (FS.isFile(node.mode)) {
    attr.size = node.usedBytes;
   } else if (FS.isLink(node.mode)) {
    attr.size = node.link.length;
   } else {
    attr.size = 0;
   }
   attr.atime = new Date(node.timestamp);
   attr.mtime = new Date(node.timestamp);
   attr.ctime = new Date(node.timestamp);
   attr.blksize = 4096;
   attr.blocks = Math.ceil(attr.size / attr.blksize);
   return attr;
  }),
  setattr: (function(node, attr) {
   if (attr.mode !== undefined) {
    node.mode = attr.mode;
   }
   if (attr.timestamp !== undefined) {
    node.timestamp = attr.timestamp;
   }
   if (attr.size !== undefined) {
    MEMFS.resizeFileStorage(node, attr.size);
   }
  }),
  lookup: (function(parent, name) {
   throw FS.genericErrors[ERRNO_CODES.ENOENT];
  }),
  mknod: (function(parent, name, mode, dev) {
   return MEMFS.createNode(parent, name, mode, dev);
  }),
  rename: (function(old_node, new_dir, new_name) {
   if (FS.isDir(old_node.mode)) {
    var new_node;
    try {
     new_node = FS.lookupNode(new_dir, new_name);
    } catch (e) {}
    if (new_node) {
     for (var i in new_node.contents) {
      throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
     }
    }
   }
   delete old_node.parent.contents[old_node.name];
   old_node.name = new_name;
   new_dir.contents[new_name] = old_node;
   old_node.parent = new_dir;
  }),
  unlink: (function(parent, name) {
   delete parent.contents[name];
  }),
  rmdir: (function(parent, name) {
   var node = FS.lookupNode(parent, name);
   for (var i in node.contents) {
    throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
   }
   delete parent.contents[name];
  }),
  readdir: (function(node) {
   var entries = [ ".", ".." ];
   for (var key in node.contents) {
    if (!node.contents.hasOwnProperty(key)) {
     continue;
    }
    entries.push(key);
   }
   return entries;
  }),
  symlink: (function(parent, newname, oldpath) {
   var node = MEMFS.createNode(parent, newname, 511 | 40960, 0);
   node.link = oldpath;
   return node;
  }),
  readlink: (function(node) {
   if (!FS.isLink(node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return node.link;
  })
 },
 stream_ops: {
  read: (function(stream, buffer, offset, length, position) {
   var contents = stream.node.contents;
   if (position >= stream.node.usedBytes) return 0;
   var size = Math.min(stream.node.usedBytes - position, length);
   assert(size >= 0);
   if (size > 8 && contents.subarray) {
    buffer.set(contents.subarray(position, position + size), offset);
   } else {
    for (var i = 0; i < size; i++) buffer[offset + i] = contents[position + i];
   }
   return size;
  }),
  write: (function(stream, buffer, offset, length, position, canOwn) {
   if (!length) return 0;
   var node = stream.node;
   node.timestamp = Date.now();
   if (buffer.subarray && (!node.contents || node.contents.subarray)) {
    if (canOwn) {
     node.contents = buffer.subarray(offset, offset + length);
     node.usedBytes = length;
     return length;
    } else if (node.usedBytes === 0 && position === 0) {
     node.contents = new Uint8Array(buffer.subarray(offset, offset + length));
     node.usedBytes = length;
     return length;
    } else if (position + length <= node.usedBytes) {
     node.contents.set(buffer.subarray(offset, offset + length), position);
     return length;
    }
   }
   MEMFS.expandFileStorage(node, position + length);
   if (node.contents.subarray && buffer.subarray) node.contents.set(buffer.subarray(offset, offset + length), position); else {
    for (var i = 0; i < length; i++) {
     node.contents[position + i] = buffer[offset + i];
    }
   }
   node.usedBytes = Math.max(node.usedBytes, position + length);
   return length;
  }),
  llseek: (function(stream, offset, whence) {
   var position = offset;
   if (whence === 1) {
    position += stream.position;
   } else if (whence === 2) {
    if (FS.isFile(stream.node.mode)) {
     position += stream.node.usedBytes;
    }
   }
   if (position < 0) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return position;
  }),
  allocate: (function(stream, offset, length) {
   MEMFS.expandFileStorage(stream.node, offset + length);
   stream.node.usedBytes = Math.max(stream.node.usedBytes, offset + length);
  }),
  mmap: (function(stream, buffer, offset, length, position, prot, flags) {
   if (!FS.isFile(stream.node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
   }
   var ptr;
   var allocated;
   var contents = stream.node.contents;
   if (!(flags & 2) && (contents.buffer === buffer || contents.buffer === buffer.buffer)) {
    allocated = false;
    ptr = contents.byteOffset;
   } else {
    if (position > 0 || position + length < stream.node.usedBytes) {
     if (contents.subarray) {
      contents = contents.subarray(position, position + length);
     } else {
      contents = Array.prototype.slice.call(contents, position, position + length);
     }
    }
    allocated = true;
    ptr = _malloc(length);
    if (!ptr) {
     throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
    }
    buffer.set(contents, ptr);
   }
   return {
    ptr: ptr,
    allocated: allocated
   };
  }),
  msync: (function(stream, buffer, offset, length, mmapFlags) {
   if (!FS.isFile(stream.node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
   }
   if (mmapFlags & 2) {
    return 0;
   }
   var bytesWritten = MEMFS.stream_ops.write(stream, buffer, 0, length, offset, false);
   return 0;
  })
 }
};
var IDBFS = {
 dbs: {},
 indexedDB: (function() {
  if (typeof indexedDB !== "undefined") return indexedDB;
  var ret = null;
  if (typeof window === "object") ret = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
  assert(ret, "IDBFS used, but indexedDB not supported");
  return ret;
 }),
 DB_VERSION: 21,
 DB_STORE_NAME: "FILE_DATA",
 mount: (function(mount) {
  return MEMFS.mount.apply(null, arguments);
 }),
 syncfs: (function(mount, populate, callback) {
  IDBFS.getLocalSet(mount, (function(err, local) {
   if (err) return callback(err);
   IDBFS.getRemoteSet(mount, (function(err, remote) {
    if (err) return callback(err);
    var src = populate ? remote : local;
    var dst = populate ? local : remote;
    IDBFS.reconcile(src, dst, callback);
   }));
  }));
 }),
 getDB: (function(name, callback) {
  var db = IDBFS.dbs[name];
  if (db) {
   return callback(null, db);
  }
  var req;
  try {
   req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
  } catch (e) {
   return callback(e);
  }
  req.onupgradeneeded = (function(e) {
   var db = e.target.result;
   var transaction = e.target.transaction;
   var fileStore;
   if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
    fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
   } else {
    fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
   }
   if (!fileStore.indexNames.contains("timestamp")) {
    fileStore.createIndex("timestamp", "timestamp", {
     unique: false
    });
   }
  });
  req.onsuccess = (function() {
   db = req.result;
   IDBFS.dbs[name] = db;
   callback(null, db);
  });
  req.onerror = (function(e) {
   callback(this.error);
   e.preventDefault();
  });
 }),
 getLocalSet: (function(mount, callback) {
  var entries = {};
  function isRealDir(p) {
   return p !== "." && p !== "..";
  }
  function toAbsolute(root) {
   return (function(p) {
    return PATH.join2(root, p);
   });
  }
  var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  while (check.length) {
   var path = check.pop();
   var stat;
   try {
    stat = FS.stat(path);
   } catch (e) {
    return callback(e);
   }
   if (FS.isDir(stat.mode)) {
    check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
   }
   entries[path] = {
    timestamp: stat.mtime
   };
  }
  return callback(null, {
   type: "local",
   entries: entries
  });
 }),
 getRemoteSet: (function(mount, callback) {
  var entries = {};
  IDBFS.getDB(mount.mountpoint, (function(err, db) {
   if (err) return callback(err);
   var transaction = db.transaction([ IDBFS.DB_STORE_NAME ], "readonly");
   transaction.onerror = (function(e) {
    callback(this.error);
    e.preventDefault();
   });
   var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
   var index = store.index("timestamp");
   index.openKeyCursor().onsuccess = (function(event) {
    var cursor = event.target.result;
    if (!cursor) {
     return callback(null, {
      type: "remote",
      db: db,
      entries: entries
     });
    }
    entries[cursor.primaryKey] = {
     timestamp: cursor.key
    };
    cursor.continue();
   });
  }));
 }),
 loadLocalEntry: (function(path, callback) {
  var stat, node;
  try {
   var lookup = FS.lookupPath(path);
   node = lookup.node;
   stat = FS.stat(path);
  } catch (e) {
   return callback(e);
  }
  if (FS.isDir(stat.mode)) {
   return callback(null, {
    timestamp: stat.mtime,
    mode: stat.mode
   });
  } else if (FS.isFile(stat.mode)) {
   node.contents = MEMFS.getFileDataAsTypedArray(node);
   return callback(null, {
    timestamp: stat.mtime,
    mode: stat.mode,
    contents: node.contents
   });
  } else {
   return callback(new Error("node type not supported"));
  }
 }),
 storeLocalEntry: (function(path, entry, callback) {
  try {
   if (FS.isDir(entry.mode)) {
    FS.mkdir(path, entry.mode);
   } else if (FS.isFile(entry.mode)) {
    FS.writeFile(path, entry.contents, {
     encoding: "binary",
     canOwn: true
    });
   } else {
    return callback(new Error("node type not supported"));
   }
   FS.chmod(path, entry.mode);
   FS.utime(path, entry.timestamp, entry.timestamp);
  } catch (e) {
   return callback(e);
  }
  callback(null);
 }),
 removeLocalEntry: (function(path, callback) {
  try {
   var lookup = FS.lookupPath(path);
   var stat = FS.stat(path);
   if (FS.isDir(stat.mode)) {
    FS.rmdir(path);
   } else if (FS.isFile(stat.mode)) {
    FS.unlink(path);
   }
  } catch (e) {
   return callback(e);
  }
  callback(null);
 }),
 loadRemoteEntry: (function(store, path, callback) {
  var req = store.get(path);
  req.onsuccess = (function(event) {
   callback(null, event.target.result);
  });
  req.onerror = (function(e) {
   callback(this.error);
   e.preventDefault();
  });
 }),
 storeRemoteEntry: (function(store, path, entry, callback) {
  var req = store.put(entry, path);
  req.onsuccess = (function() {
   callback(null);
  });
  req.onerror = (function(e) {
   callback(this.error);
   e.preventDefault();
  });
 }),
 removeRemoteEntry: (function(store, path, callback) {
  var req = store.delete(path);
  req.onsuccess = (function() {
   callback(null);
  });
  req.onerror = (function(e) {
   callback(this.error);
   e.preventDefault();
  });
 }),
 reconcile: (function(src, dst, callback) {
  var total = 0;
  var create = [];
  Object.keys(src.entries).forEach((function(key) {
   var e = src.entries[key];
   var e2 = dst.entries[key];
   if (!e2 || e.timestamp > e2.timestamp) {
    create.push(key);
    total++;
   }
  }));
  var remove = [];
  Object.keys(dst.entries).forEach((function(key) {
   var e = dst.entries[key];
   var e2 = src.entries[key];
   if (!e2) {
    remove.push(key);
    total++;
   }
  }));
  if (!total) {
   return callback(null);
  }
  var errored = false;
  var completed = 0;
  var db = src.type === "remote" ? src.db : dst.db;
  var transaction = db.transaction([ IDBFS.DB_STORE_NAME ], "readwrite");
  var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  function done(err) {
   if (err) {
    if (!done.errored) {
     done.errored = true;
     return callback(err);
    }
    return;
   }
   if (++completed >= total) {
    return callback(null);
   }
  }
  transaction.onerror = (function(e) {
   done(this.error);
   e.preventDefault();
  });
  create.sort().forEach((function(path) {
   if (dst.type === "local") {
    IDBFS.loadRemoteEntry(store, path, (function(err, entry) {
     if (err) return done(err);
     IDBFS.storeLocalEntry(path, entry, done);
    }));
   } else {
    IDBFS.loadLocalEntry(path, (function(err, entry) {
     if (err) return done(err);
     IDBFS.storeRemoteEntry(store, path, entry, done);
    }));
   }
  }));
  remove.sort().reverse().forEach((function(path) {
   if (dst.type === "local") {
    IDBFS.removeLocalEntry(path, done);
   } else {
    IDBFS.removeRemoteEntry(store, path, done);
   }
  }));
 })
};
var NODEFS = {
 isWindows: false,
 staticInit: (function() {
  NODEFS.isWindows = !!process.platform.match(/^win/);
 }),
 mount: (function(mount) {
  assert(ENVIRONMENT_IS_NODE);
  return NODEFS.createNode(null, "/", NODEFS.getMode(mount.opts.root), 0);
 }),
 createNode: (function(parent, name, mode, dev) {
  if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var node = FS.createNode(parent, name, mode);
  node.node_ops = NODEFS.node_ops;
  node.stream_ops = NODEFS.stream_ops;
  return node;
 }),
 getMode: (function(path) {
  var stat;
  try {
   stat = fs.lstatSync(path);
   if (NODEFS.isWindows) {
    stat.mode = stat.mode | (stat.mode & 146) >> 1;
   }
  } catch (e) {
   if (!e.code) throw e;
   throw new FS.ErrnoError(ERRNO_CODES[e.code]);
  }
  return stat.mode;
 }),
 realPath: (function(node) {
  var parts = [];
  while (node.parent !== node) {
   parts.push(node.name);
   node = node.parent;
  }
  parts.push(node.mount.opts.root);
  parts.reverse();
  return PATH.join.apply(null, parts);
 }),
 flagsToPermissionStringMap: {
  0: "r",
  1: "r+",
  2: "r+",
  64: "r",
  65: "r+",
  66: "r+",
  129: "rx+",
  193: "rx+",
  514: "w+",
  577: "w",
  578: "w+",
  705: "wx",
  706: "wx+",
  1024: "a",
  1025: "a",
  1026: "a+",
  1089: "a",
  1090: "a+",
  1153: "ax",
  1154: "ax+",
  1217: "ax",
  1218: "ax+",
  4096: "rs",
  4098: "rs+"
 },
 flagsToPermissionString: (function(flags) {
  flags &= ~32768;
  if (flags in NODEFS.flagsToPermissionStringMap) {
   return NODEFS.flagsToPermissionStringMap[flags];
  } else {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
 }),
 node_ops: {
  getattr: (function(node) {
   var path = NODEFS.realPath(node);
   var stat;
   try {
    stat = fs.lstatSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   if (NODEFS.isWindows && !stat.blksize) {
    stat.blksize = 4096;
   }
   if (NODEFS.isWindows && !stat.blocks) {
    stat.blocks = (stat.size + stat.blksize - 1) / stat.blksize | 0;
   }
   return {
    dev: stat.dev,
    ino: stat.ino,
    mode: stat.mode,
    nlink: stat.nlink,
    uid: stat.uid,
    gid: stat.gid,
    rdev: stat.rdev,
    size: stat.size,
    atime: stat.atime,
    mtime: stat.mtime,
    ctime: stat.ctime,
    blksize: stat.blksize,
    blocks: stat.blocks
   };
  }),
  setattr: (function(node, attr) {
   var path = NODEFS.realPath(node);
   try {
    if (attr.mode !== undefined) {
     fs.chmodSync(path, attr.mode);
     node.mode = attr.mode;
    }
    if (attr.timestamp !== undefined) {
     var date = new Date(attr.timestamp);
     fs.utimesSync(path, date, date);
    }
    if (attr.size !== undefined) {
     fs.truncateSync(path, attr.size);
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  lookup: (function(parent, name) {
   var path = PATH.join2(NODEFS.realPath(parent), name);
   var mode = NODEFS.getMode(path);
   return NODEFS.createNode(parent, name, mode);
  }),
  mknod: (function(parent, name, mode, dev) {
   var node = NODEFS.createNode(parent, name, mode, dev);
   var path = NODEFS.realPath(node);
   try {
    if (FS.isDir(node.mode)) {
     fs.mkdirSync(path, node.mode);
    } else {
     fs.writeFileSync(path, "", {
      mode: node.mode
     });
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   return node;
  }),
  rename: (function(oldNode, newDir, newName) {
   var oldPath = NODEFS.realPath(oldNode);
   var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
   try {
    fs.renameSync(oldPath, newPath);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  unlink: (function(parent, name) {
   var path = PATH.join2(NODEFS.realPath(parent), name);
   try {
    fs.unlinkSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  rmdir: (function(parent, name) {
   var path = PATH.join2(NODEFS.realPath(parent), name);
   try {
    fs.rmdirSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  readdir: (function(node) {
   var path = NODEFS.realPath(node);
   try {
    return fs.readdirSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  symlink: (function(parent, newName, oldPath) {
   var newPath = PATH.join2(NODEFS.realPath(parent), newName);
   try {
    fs.symlinkSync(oldPath, newPath);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  readlink: (function(node) {
   var path = NODEFS.realPath(node);
   try {
    path = fs.readlinkSync(path);
    path = NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root), path);
    return path;
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  })
 },
 stream_ops: {
  open: (function(stream) {
   var path = NODEFS.realPath(stream.node);
   try {
    if (FS.isFile(stream.node.mode)) {
     stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  close: (function(stream) {
   try {
    if (FS.isFile(stream.node.mode) && stream.nfd) {
     fs.closeSync(stream.nfd);
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  read: (function(stream, buffer, offset, length, position) {
   if (length === 0) return 0;
   var nbuffer = new Buffer(length);
   var res;
   try {
    res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
   } catch (e) {
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   if (res > 0) {
    for (var i = 0; i < res; i++) {
     buffer[offset + i] = nbuffer[i];
    }
   }
   return res;
  }),
  write: (function(stream, buffer, offset, length, position) {
   var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
   var res;
   try {
    res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
   } catch (e) {
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   return res;
  }),
  llseek: (function(stream, offset, whence) {
   var position = offset;
   if (whence === 1) {
    position += stream.position;
   } else if (whence === 2) {
    if (FS.isFile(stream.node.mode)) {
     try {
      var stat = fs.fstatSync(stream.nfd);
      position += stat.size;
     } catch (e) {
      throw new FS.ErrnoError(ERRNO_CODES[e.code]);
     }
    }
   }
   if (position < 0) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return position;
  })
 }
};
var WORKERFS = {
 DIR_MODE: 16895,
 FILE_MODE: 33279,
 reader: null,
 mount: (function(mount) {
  assert(ENVIRONMENT_IS_WORKER);
  if (!WORKERFS.reader) WORKERFS.reader = new FileReaderSync;
  var root = WORKERFS.createNode(null, "/", WORKERFS.DIR_MODE, 0);
  var createdParents = {};
  function ensureParent(path) {
   var parts = path.split("/");
   var parent = root;
   for (var i = 0; i < parts.length - 1; i++) {
    var curr = parts.slice(0, i + 1).join("/");
    if (!createdParents[curr]) {
     createdParents[curr] = WORKERFS.createNode(parent, curr, WORKERFS.DIR_MODE, 0);
    }
    parent = createdParents[curr];
   }
   return parent;
  }
  function base(path) {
   var parts = path.split("/");
   return parts[parts.length - 1];
  }
  Array.prototype.forEach.call(mount.opts["files"] || [], (function(file) {
   WORKERFS.createNode(ensureParent(file.name), base(file.name), WORKERFS.FILE_MODE, 0, file, file.lastModifiedDate);
  }));
  (mount.opts["blobs"] || []).forEach((function(obj) {
   WORKERFS.createNode(ensureParent(obj["name"]), base(obj["name"]), WORKERFS.FILE_MODE, 0, obj["data"]);
  }));
  (mount.opts["packages"] || []).forEach((function(pack) {
   pack["metadata"].files.forEach((function(file) {
    var name = file.filename.substr(1);
    WORKERFS.createNode(ensureParent(name), base(name), WORKERFS.FILE_MODE, 0, pack["blob"].slice(file.start, file.end));
   }));
  }));
  return root;
 }),
 createNode: (function(parent, name, mode, dev, contents, mtime) {
  var node = FS.createNode(parent, name, mode);
  node.mode = mode;
  node.node_ops = WORKERFS.node_ops;
  node.stream_ops = WORKERFS.stream_ops;
  node.timestamp = (mtime || new Date).getTime();
  assert(WORKERFS.FILE_MODE !== WORKERFS.DIR_MODE);
  if (mode === WORKERFS.FILE_MODE) {
   node.size = contents.size;
   node.contents = contents;
  } else {
   node.size = 4096;
   node.contents = {};
  }
  if (parent) {
   parent.contents[name] = node;
  }
  return node;
 }),
 node_ops: {
  getattr: (function(node) {
   return {
    dev: 1,
    ino: undefined,
    mode: node.mode,
    nlink: 1,
    uid: 0,
    gid: 0,
    rdev: undefined,
    size: node.size,
    atime: new Date(node.timestamp),
    mtime: new Date(node.timestamp),
    ctime: new Date(node.timestamp),
    blksize: 4096,
    blocks: Math.ceil(node.size / 4096)
   };
  }),
  setattr: (function(node, attr) {
   if (attr.mode !== undefined) {
    node.mode = attr.mode;
   }
   if (attr.timestamp !== undefined) {
    node.timestamp = attr.timestamp;
   }
  }),
  lookup: (function(parent, name) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }),
  mknod: (function(parent, name, mode, dev) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }),
  rename: (function(oldNode, newDir, newName) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }),
  unlink: (function(parent, name) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }),
  rmdir: (function(parent, name) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }),
  readdir: (function(node) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }),
  symlink: (function(parent, newName, oldPath) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }),
  readlink: (function(node) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  })
 },
 stream_ops: {
  read: (function(stream, buffer, offset, length, position) {
   if (position >= stream.node.size) return 0;
   var chunk = stream.node.contents.slice(position, position + length);
   var ab = WORKERFS.reader.readAsArrayBuffer(chunk);
   buffer.set(new Uint8Array(ab), offset);
   return chunk.size;
  }),
  write: (function(stream, buffer, offset, length, position) {
   throw new FS.ErrnoError(ERRNO_CODES.EIO);
  }),
  llseek: (function(stream, offset, whence) {
   var position = offset;
   if (whence === 1) {
    position += stream.position;
   } else if (whence === 2) {
    if (FS.isFile(stream.node.mode)) {
     position += stream.node.size;
    }
   }
   if (position < 0) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return position;
  })
 }
};
var _stdin = allocate(1, "i32*", ALLOC_STATIC);
var _stdout = allocate(1, "i32*", ALLOC_STATIC);
var _stderr = allocate(1, "i32*", ALLOC_STATIC);
var FS = {
 root: null,
 mounts: [],
 devices: [ null ],
 streams: [],
 nextInode: 1,
 nameTable: null,
 currentPath: "/",
 initialized: false,
 ignorePermissions: true,
 trackingDelegate: {},
 tracking: {
  openFlags: {
   READ: 1,
   WRITE: 2
  }
 },
 ErrnoError: null,
 genericErrors: {},
 filesystems: null,
 handleFSError: (function(e) {
  if (!(e instanceof FS.ErrnoError)) throw e + " : " + stackTrace();
  return ___setErrNo(e.errno);
 }),
 lookupPath: (function(path, opts) {
  path = PATH.resolve(FS.cwd(), path);
  opts = opts || {};
  if (!path) return {
   path: "",
   node: null
  };
  var defaults = {
   follow_mount: true,
   recurse_count: 0
  };
  for (var key in defaults) {
   if (opts[key] === undefined) {
    opts[key] = defaults[key];
   }
  }
  if (opts.recurse_count > 8) {
   throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
  }
  var parts = PATH.normalizeArray(path.split("/").filter((function(p) {
   return !!p;
  })), false);
  var current = FS.root;
  var current_path = "/";
  for (var i = 0; i < parts.length; i++) {
   var islast = i === parts.length - 1;
   if (islast && opts.parent) {
    break;
   }
   current = FS.lookupNode(current, parts[i]);
   current_path = PATH.join2(current_path, parts[i]);
   if (FS.isMountpoint(current)) {
    if (!islast || islast && opts.follow_mount) {
     current = current.mounted.root;
    }
   }
   if (!islast || opts.follow) {
    var count = 0;
    while (FS.isLink(current.mode)) {
     var link = FS.readlink(current_path);
     current_path = PATH.resolve(PATH.dirname(current_path), link);
     var lookup = FS.lookupPath(current_path, {
      recurse_count: opts.recurse_count
     });
     current = lookup.node;
     if (count++ > 40) {
      throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
     }
    }
   }
  }
  return {
   path: current_path,
   node: current
  };
 }),
 getPath: (function(node) {
  var path;
  while (true) {
   if (FS.isRoot(node)) {
    var mount = node.mount.mountpoint;
    if (!path) return mount;
    return mount[mount.length - 1] !== "/" ? mount + "/" + path : mount + path;
   }
   path = path ? node.name + "/" + path : node.name;
   node = node.parent;
  }
 }),
 hashName: (function(parentid, name) {
  var hash = 0;
  for (var i = 0; i < name.length; i++) {
   hash = (hash << 5) - hash + name.charCodeAt(i) | 0;
  }
  return (parentid + hash >>> 0) % FS.nameTable.length;
 }),
 hashAddNode: (function(node) {
  var hash = FS.hashName(node.parent.id, node.name);
  node.name_next = FS.nameTable[hash];
  FS.nameTable[hash] = node;
 }),
 hashRemoveNode: (function(node) {
  var hash = FS.hashName(node.parent.id, node.name);
  if (FS.nameTable[hash] === node) {
   FS.nameTable[hash] = node.name_next;
  } else {
   var current = FS.nameTable[hash];
   while (current) {
    if (current.name_next === node) {
     current.name_next = node.name_next;
     break;
    }
    current = current.name_next;
   }
  }
 }),
 lookupNode: (function(parent, name) {
  var err = FS.mayLookup(parent);
  if (err) {
   throw new FS.ErrnoError(err, parent);
  }
  var hash = FS.hashName(parent.id, name);
  for (var node = FS.nameTable[hash]; node; node = node.name_next) {
   var nodeName = node.name;
   if (node.parent.id === parent.id && nodeName === name) {
    return node;
   }
  }
  return FS.lookup(parent, name);
 }),
 createNode: (function(parent, name, mode, rdev) {
  if (!FS.FSNode) {
   FS.FSNode = (function(parent, name, mode, rdev) {
    if (!parent) {
     parent = this;
    }
    this.parent = parent;
    this.mount = parent.mount;
    this.mounted = null;
    this.id = FS.nextInode++;
    this.name = name;
    this.mode = mode;
    this.node_ops = {};
    this.stream_ops = {};
    this.rdev = rdev;
   });
   FS.FSNode.prototype = {};
   var readMode = 292 | 73;
   var writeMode = 146;
   Object.defineProperties(FS.FSNode.prototype, {
    read: {
     get: (function() {
      return (this.mode & readMode) === readMode;
     }),
     set: (function(val) {
      val ? this.mode |= readMode : this.mode &= ~readMode;
     })
    },
    write: {
     get: (function() {
      return (this.mode & writeMode) === writeMode;
     }),
     set: (function(val) {
      val ? this.mode |= writeMode : this.mode &= ~writeMode;
     })
    },
    isFolder: {
     get: (function() {
      return FS.isDir(this.mode);
     })
    },
    isDevice: {
     get: (function() {
      return FS.isChrdev(this.mode);
     })
    }
   });
  }
  var node = new FS.FSNode(parent, name, mode, rdev);
  FS.hashAddNode(node);
  return node;
 }),
 destroyNode: (function(node) {
  FS.hashRemoveNode(node);
 }),
 isRoot: (function(node) {
  return node === node.parent;
 }),
 isMountpoint: (function(node) {
  return !!node.mounted;
 }),
 isFile: (function(mode) {
  return (mode & 61440) === 32768;
 }),
 isDir: (function(mode) {
  return (mode & 61440) === 16384;
 }),
 isLink: (function(mode) {
  return (mode & 61440) === 40960;
 }),
 isChrdev: (function(mode) {
  return (mode & 61440) === 8192;
 }),
 isBlkdev: (function(mode) {
  return (mode & 61440) === 24576;
 }),
 isFIFO: (function(mode) {
  return (mode & 61440) === 4096;
 }),
 isSocket: (function(mode) {
  return (mode & 49152) === 49152;
 }),
 flagModes: {
  "r": 0,
  "rs": 1052672,
  "r+": 2,
  "w": 577,
  "wx": 705,
  "xw": 705,
  "w+": 578,
  "wx+": 706,
  "xw+": 706,
  "a": 1089,
  "ax": 1217,
  "xa": 1217,
  "a+": 1090,
  "ax+": 1218,
  "xa+": 1218
 },
 modeStringToFlags: (function(str) {
  var flags = FS.flagModes[str];
  if (typeof flags === "undefined") {
   throw new Error("Unknown file open mode: " + str);
  }
  return flags;
 }),
 flagsToPermissionString: (function(flag) {
  var perms = [ "r", "w", "rw" ][flag & 3];
  if (flag & 512) {
   perms += "w";
  }
  return perms;
 }),
 nodePermissions: (function(node, perms) {
  if (FS.ignorePermissions) {
   return 0;
  }
  if (perms.indexOf("r") !== -1 && !(node.mode & 292)) {
   return ERRNO_CODES.EACCES;
  } else if (perms.indexOf("w") !== -1 && !(node.mode & 146)) {
   return ERRNO_CODES.EACCES;
  } else if (perms.indexOf("x") !== -1 && !(node.mode & 73)) {
   return ERRNO_CODES.EACCES;
  }
  return 0;
 }),
 mayLookup: (function(dir) {
  var err = FS.nodePermissions(dir, "x");
  if (err) return err;
  if (!dir.node_ops.lookup) return ERRNO_CODES.EACCES;
  return 0;
 }),
 mayCreate: (function(dir, name) {
  try {
   var node = FS.lookupNode(dir, name);
   return ERRNO_CODES.EEXIST;
  } catch (e) {}
  return FS.nodePermissions(dir, "wx");
 }),
 mayDelete: (function(dir, name, isdir) {
  var node;
  try {
   node = FS.lookupNode(dir, name);
  } catch (e) {
   return e.errno;
  }
  var err = FS.nodePermissions(dir, "wx");
  if (err) {
   return err;
  }
  if (isdir) {
   if (!FS.isDir(node.mode)) {
    return ERRNO_CODES.ENOTDIR;
   }
   if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
    return ERRNO_CODES.EBUSY;
   }
  } else {
   if (FS.isDir(node.mode)) {
    return ERRNO_CODES.EISDIR;
   }
  }
  return 0;
 }),
 mayOpen: (function(node, flags) {
  if (!node) {
   return ERRNO_CODES.ENOENT;
  }
  if (FS.isLink(node.mode)) {
   return ERRNO_CODES.ELOOP;
  } else if (FS.isDir(node.mode)) {
   if ((flags & 2097155) !== 0 || flags & 512) {
    return ERRNO_CODES.EISDIR;
   }
  }
  return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
 }),
 MAX_OPEN_FDS: 4096,
 nextfd: (function(fd_start, fd_end) {
  fd_start = fd_start || 0;
  fd_end = fd_end || FS.MAX_OPEN_FDS;
  for (var fd = fd_start; fd <= fd_end; fd++) {
   if (!FS.streams[fd]) {
    return fd;
   }
  }
  throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
 }),
 getStream: (function(fd) {
  return FS.streams[fd];
 }),
 createStream: (function(stream, fd_start, fd_end) {
  if (!FS.FSStream) {
   FS.FSStream = (function() {});
   FS.FSStream.prototype = {};
   Object.defineProperties(FS.FSStream.prototype, {
    object: {
     get: (function() {
      return this.node;
     }),
     set: (function(val) {
      this.node = val;
     })
    },
    isRead: {
     get: (function() {
      return (this.flags & 2097155) !== 1;
     })
    },
    isWrite: {
     get: (function() {
      return (this.flags & 2097155) !== 0;
     })
    },
    isAppend: {
     get: (function() {
      return this.flags & 1024;
     })
    }
   });
  }
  var newStream = new FS.FSStream;
  for (var p in stream) {
   newStream[p] = stream[p];
  }
  stream = newStream;
  var fd = FS.nextfd(fd_start, fd_end);
  stream.fd = fd;
  FS.streams[fd] = stream;
  return stream;
 }),
 closeStream: (function(fd) {
  FS.streams[fd] = null;
 }),
 chrdev_stream_ops: {
  open: (function(stream) {
   var device = FS.getDevice(stream.node.rdev);
   stream.stream_ops = device.stream_ops;
   if (stream.stream_ops.open) {
    stream.stream_ops.open(stream);
   }
  }),
  llseek: (function() {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  })
 },
 major: (function(dev) {
  return dev >> 8;
 }),
 minor: (function(dev) {
  return dev & 255;
 }),
 makedev: (function(ma, mi) {
  return ma << 8 | mi;
 }),
 registerDevice: (function(dev, ops) {
  FS.devices[dev] = {
   stream_ops: ops
  };
 }),
 getDevice: (function(dev) {
  return FS.devices[dev];
 }),
 getMounts: (function(mount) {
  var mounts = [];
  var check = [ mount ];
  while (check.length) {
   var m = check.pop();
   mounts.push(m);
   check.push.apply(check, m.mounts);
  }
  return mounts;
 }),
 syncfs: (function(populate, callback) {
  if (typeof populate === "function") {
   callback = populate;
   populate = false;
  }
  var mounts = FS.getMounts(FS.root.mount);
  var completed = 0;
  function done(err) {
   if (err) {
    if (!done.errored) {
     done.errored = true;
     return callback(err);
    }
    return;
   }
   if (++completed >= mounts.length) {
    callback(null);
   }
  }
  mounts.forEach((function(mount) {
   if (!mount.type.syncfs) {
    return done(null);
   }
   mount.type.syncfs(mount, populate, done);
  }));
 }),
 mount: (function(type, opts, mountpoint) {
  var root = mountpoint === "/";
  var pseudo = !mountpoint;
  var node;
  if (root && FS.root) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  } else if (!root && !pseudo) {
   var lookup = FS.lookupPath(mountpoint, {
    follow_mount: false
   });
   mountpoint = lookup.path;
   node = lookup.node;
   if (FS.isMountpoint(node)) {
    throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
   }
   if (!FS.isDir(node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
   }
  }
  var mount = {
   type: type,
   opts: opts,
   mountpoint: mountpoint,
   mounts: []
  };
  var mountRoot = type.mount(mount);
  mountRoot.mount = mount;
  mount.root = mountRoot;
  if (root) {
   FS.root = mountRoot;
  } else if (node) {
   node.mounted = mount;
   if (node.mount) {
    node.mount.mounts.push(mount);
   }
  }
  return mountRoot;
 }),
 unmount: (function(mountpoint) {
  var lookup = FS.lookupPath(mountpoint, {
   follow_mount: false
  });
  if (!FS.isMountpoint(lookup.node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var node = lookup.node;
  var mount = node.mounted;
  var mounts = FS.getMounts(mount);
  Object.keys(FS.nameTable).forEach((function(hash) {
   var current = FS.nameTable[hash];
   while (current) {
    var next = current.name_next;
    if (mounts.indexOf(current.mount) !== -1) {
     FS.destroyNode(current);
    }
    current = next;
   }
  }));
  node.mounted = null;
  var idx = node.mount.mounts.indexOf(mount);
  assert(idx !== -1);
  node.mount.mounts.splice(idx, 1);
 }),
 lookup: (function(parent, name) {
  return parent.node_ops.lookup(parent, name);
 }),
 mknod: (function(path, mode, dev) {
  var lookup = FS.lookupPath(path, {
   parent: true
  });
  var parent = lookup.node;
  var name = PATH.basename(path);
  if (!name || name === "." || name === "..") {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var err = FS.mayCreate(parent, name);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.mknod) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  return parent.node_ops.mknod(parent, name, mode, dev);
 }),
 create: (function(path, mode) {
  mode = mode !== undefined ? mode : 438;
  mode &= 4095;
  mode |= 32768;
  return FS.mknod(path, mode, 0);
 }),
 mkdir: (function(path, mode) {
  mode = mode !== undefined ? mode : 511;
  mode &= 511 | 512;
  mode |= 16384;
  return FS.mknod(path, mode, 0);
 }),
 mkdev: (function(path, mode, dev) {
  if (typeof dev === "undefined") {
   dev = mode;
   mode = 438;
  }
  mode |= 8192;
  return FS.mknod(path, mode, dev);
 }),
 symlink: (function(oldpath, newpath) {
  if (!PATH.resolve(oldpath)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  var lookup = FS.lookupPath(newpath, {
   parent: true
  });
  var parent = lookup.node;
  if (!parent) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  var newname = PATH.basename(newpath);
  var err = FS.mayCreate(parent, newname);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.symlink) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  return parent.node_ops.symlink(parent, newname, oldpath);
 }),
 rename: (function(old_path, new_path) {
  var old_dirname = PATH.dirname(old_path);
  var new_dirname = PATH.dirname(new_path);
  var old_name = PATH.basename(old_path);
  var new_name = PATH.basename(new_path);
  var lookup, old_dir, new_dir;
  try {
   lookup = FS.lookupPath(old_path, {
    parent: true
   });
   old_dir = lookup.node;
   lookup = FS.lookupPath(new_path, {
    parent: true
   });
   new_dir = lookup.node;
  } catch (e) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  if (!old_dir || !new_dir) throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  if (old_dir.mount !== new_dir.mount) {
   throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
  }
  var old_node = FS.lookupNode(old_dir, old_name);
  var relative = PATH.relative(old_path, new_dirname);
  if (relative.charAt(0) !== ".") {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  relative = PATH.relative(new_path, old_dirname);
  if (relative.charAt(0) !== ".") {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
  }
  var new_node;
  try {
   new_node = FS.lookupNode(new_dir, new_name);
  } catch (e) {}
  if (old_node === new_node) {
   return;
  }
  var isdir = FS.isDir(old_node.mode);
  var err = FS.mayDelete(old_dir, old_name, isdir);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  err = new_node ? FS.mayDelete(new_dir, new_name, isdir) : FS.mayCreate(new_dir, new_name);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!old_dir.node_ops.rename) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isMountpoint(old_node) || new_node && FS.isMountpoint(new_node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  if (new_dir !== old_dir) {
   err = FS.nodePermissions(old_dir, "w");
   if (err) {
    throw new FS.ErrnoError(err);
   }
  }
  try {
   if (FS.trackingDelegate["willMovePath"]) {
    FS.trackingDelegate["willMovePath"](old_path, new_path);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['willMovePath']('" + old_path + "', '" + new_path + "') threw an exception: " + e.message);
  }
  FS.hashRemoveNode(old_node);
  try {
   old_dir.node_ops.rename(old_node, new_dir, new_name);
  } catch (e) {
   throw e;
  } finally {
   FS.hashAddNode(old_node);
  }
  try {
   if (FS.trackingDelegate["onMovePath"]) FS.trackingDelegate["onMovePath"](old_path, new_path);
  } catch (e) {
   console.log("FS.trackingDelegate['onMovePath']('" + old_path + "', '" + new_path + "') threw an exception: " + e.message);
  }
 }),
 rmdir: (function(path) {
  var lookup = FS.lookupPath(path, {
   parent: true
  });
  var parent = lookup.node;
  var name = PATH.basename(path);
  var node = FS.lookupNode(parent, name);
  var err = FS.mayDelete(parent, name, true);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.rmdir) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isMountpoint(node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  try {
   if (FS.trackingDelegate["willDeletePath"]) {
    FS.trackingDelegate["willDeletePath"](path);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['willDeletePath']('" + path + "') threw an exception: " + e.message);
  }
  parent.node_ops.rmdir(parent, name);
  FS.destroyNode(node);
  try {
   if (FS.trackingDelegate["onDeletePath"]) FS.trackingDelegate["onDeletePath"](path);
  } catch (e) {
   console.log("FS.trackingDelegate['onDeletePath']('" + path + "') threw an exception: " + e.message);
  }
 }),
 readdir: (function(path) {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  var node = lookup.node;
  if (!node.node_ops.readdir) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
  }
  return node.node_ops.readdir(node);
 }),
 unlink: (function(path) {
  var lookup = FS.lookupPath(path, {
   parent: true
  });
  var parent = lookup.node;
  var name = PATH.basename(path);
  var node = FS.lookupNode(parent, name);
  var err = FS.mayDelete(parent, name, false);
  if (err) {
   if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.unlink) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isMountpoint(node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  try {
   if (FS.trackingDelegate["willDeletePath"]) {
    FS.trackingDelegate["willDeletePath"](path);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['willDeletePath']('" + path + "') threw an exception: " + e.message);
  }
  parent.node_ops.unlink(parent, name);
  FS.destroyNode(node);
  try {
   if (FS.trackingDelegate["onDeletePath"]) FS.trackingDelegate["onDeletePath"](path);
  } catch (e) {
   console.log("FS.trackingDelegate['onDeletePath']('" + path + "') threw an exception: " + e.message);
  }
 }),
 readlink: (function(path) {
  var lookup = FS.lookupPath(path);
  var link = lookup.node;
  if (!link) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  if (!link.node_ops.readlink) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  return PATH.resolve(FS.getPath(link.parent), link.node_ops.readlink(link));
 }),
 stat: (function(path, dontFollow) {
  var lookup = FS.lookupPath(path, {
   follow: !dontFollow
  });
  var node = lookup.node;
  if (!node) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  if (!node.node_ops.getattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  return node.node_ops.getattr(node);
 }),
 lstat: (function(path) {
  return FS.stat(path, true);
 }),
 chmod: (function(path, mode, dontFollow) {
  var node;
  if (typeof path === "string") {
   var lookup = FS.lookupPath(path, {
    follow: !dontFollow
   });
   node = lookup.node;
  } else {
   node = path;
  }
  if (!node.node_ops.setattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  node.node_ops.setattr(node, {
   mode: mode & 4095 | node.mode & ~4095,
   timestamp: Date.now()
  });
 }),
 lchmod: (function(path, mode) {
  FS.chmod(path, mode, true);
 }),
 fchmod: (function(fd, mode) {
  var stream = FS.getStream(fd);
  if (!stream) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  FS.chmod(stream.node, mode);
 }),
 chown: (function(path, uid, gid, dontFollow) {
  var node;
  if (typeof path === "string") {
   var lookup = FS.lookupPath(path, {
    follow: !dontFollow
   });
   node = lookup.node;
  } else {
   node = path;
  }
  if (!node.node_ops.setattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  node.node_ops.setattr(node, {
   timestamp: Date.now()
  });
 }),
 lchown: (function(path, uid, gid) {
  FS.chown(path, uid, gid, true);
 }),
 fchown: (function(fd, uid, gid) {
  var stream = FS.getStream(fd);
  if (!stream) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  FS.chown(stream.node, uid, gid);
 }),
 truncate: (function(path, len) {
  if (len < 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var node;
  if (typeof path === "string") {
   var lookup = FS.lookupPath(path, {
    follow: true
   });
   node = lookup.node;
  } else {
   node = path;
  }
  if (!node.node_ops.setattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isDir(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
  }
  if (!FS.isFile(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var err = FS.nodePermissions(node, "w");
  if (err) {
   throw new FS.ErrnoError(err);
  }
  node.node_ops.setattr(node, {
   size: len,
   timestamp: Date.now()
  });
 }),
 ftruncate: (function(fd, len) {
  var stream = FS.getStream(fd);
  if (!stream) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if ((stream.flags & 2097155) === 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  FS.truncate(stream.node, len);
 }),
 utime: (function(path, atime, mtime) {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  var node = lookup.node;
  node.node_ops.setattr(node, {
   timestamp: Math.max(atime, mtime)
  });
 }),
 open: (function(path, flags, mode, fd_start, fd_end) {
  if (path === "") {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  flags = typeof flags === "string" ? FS.modeStringToFlags(flags) : flags;
  mode = typeof mode === "undefined" ? 438 : mode;
  if (flags & 64) {
   mode = mode & 4095 | 32768;
  } else {
   mode = 0;
  }
  var node;
  if (typeof path === "object") {
   node = path;
  } else {
   path = PATH.normalize(path);
   try {
    var lookup = FS.lookupPath(path, {
     follow: !(flags & 131072)
    });
    node = lookup.node;
   } catch (e) {}
  }
  var created = false;
  if (flags & 64) {
   if (node) {
    if (flags & 128) {
     throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
    }
   } else {
    node = FS.mknod(path, mode, 0);
    created = true;
   }
  }
  if (!node) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  if (FS.isChrdev(node.mode)) {
   flags &= ~512;
  }
  if (flags & 65536 && !FS.isDir(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
  }
  if (!created) {
   var err = FS.mayOpen(node, flags);
   if (err) {
    throw new FS.ErrnoError(err);
   }
  }
  if (flags & 512) {
   FS.truncate(node, 0);
  }
  flags &= ~(128 | 512);
  var stream = FS.createStream({
   node: node,
   path: FS.getPath(node),
   flags: flags,
   seekable: true,
   position: 0,
   stream_ops: node.stream_ops,
   ungotten: [],
   error: false
  }, fd_start, fd_end);
  if (stream.stream_ops.open) {
   stream.stream_ops.open(stream);
  }
  if (Module["logReadFiles"] && !(flags & 1)) {
   if (!FS.readFiles) FS.readFiles = {};
   if (!(path in FS.readFiles)) {
    FS.readFiles[path] = 1;
    Module["printErr"]("read file: " + path);
   }
  }
  try {
   if (FS.trackingDelegate["onOpenFile"]) {
    var trackingFlags = 0;
    if ((flags & 2097155) !== 1) {
     trackingFlags |= FS.tracking.openFlags.READ;
    }
    if ((flags & 2097155) !== 0) {
     trackingFlags |= FS.tracking.openFlags.WRITE;
    }
    FS.trackingDelegate["onOpenFile"](path, trackingFlags);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['onOpenFile']('" + path + "', flags) threw an exception: " + e.message);
  }
  return stream;
 }),
 close: (function(stream) {
  if (stream.getdents) stream.getdents = null;
  try {
   if (stream.stream_ops.close) {
    stream.stream_ops.close(stream);
   }
  } catch (e) {
   throw e;
  } finally {
   FS.closeStream(stream.fd);
  }
 }),
 llseek: (function(stream, offset, whence) {
  if (!stream.seekable || !stream.stream_ops.llseek) {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  }
  stream.position = stream.stream_ops.llseek(stream, offset, whence);
  stream.ungotten = [];
  return stream.position;
 }),
 read: (function(stream, buffer, offset, length, position) {
  if (length < 0 || position < 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if ((stream.flags & 2097155) === 1) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if (FS.isDir(stream.node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
  }
  if (!stream.stream_ops.read) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var seeking = true;
  if (typeof position === "undefined") {
   position = stream.position;
   seeking = false;
  } else if (!stream.seekable) {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  }
  var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
  if (!seeking) stream.position += bytesRead;
  return bytesRead;
 }),
 write: (function(stream, buffer, offset, length, position, canOwn) {
  if (length < 0 || position < 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if ((stream.flags & 2097155) === 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if (FS.isDir(stream.node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
  }
  if (!stream.stream_ops.write) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if (stream.flags & 1024) {
   FS.llseek(stream, 0, 2);
  }
  var seeking = true;
  if (typeof position === "undefined") {
   position = stream.position;
   seeking = false;
  } else if (!stream.seekable) {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  }
  var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
  if (!seeking) stream.position += bytesWritten;
  try {
   if (stream.path && FS.trackingDelegate["onWriteToFile"]) FS.trackingDelegate["onWriteToFile"](stream.path);
  } catch (e) {
   console.log("FS.trackingDelegate['onWriteToFile']('" + path + "') threw an exception: " + e.message);
  }
  return bytesWritten;
 }),
 allocate: (function(stream, offset, length) {
  if (offset < 0 || length <= 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if ((stream.flags & 2097155) === 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
  }
  if (!stream.stream_ops.allocate) {
   throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
  }
  stream.stream_ops.allocate(stream, offset, length);
 }),
 mmap: (function(stream, buffer, offset, length, position, prot, flags) {
  if ((stream.flags & 2097155) === 1) {
   throw new FS.ErrnoError(ERRNO_CODES.EACCES);
  }
  if (!stream.stream_ops.mmap) {
   throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
  }
  return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
 }),
 msync: (function(stream, buffer, offset, length, mmapFlags) {
  if (!stream || !stream.stream_ops.msync) {
   return 0;
  }
  return stream.stream_ops.msync(stream, buffer, offset, length, mmapFlags);
 }),
 munmap: (function(stream) {
  return 0;
 }),
 ioctl: (function(stream, cmd, arg) {
  if (!stream.stream_ops.ioctl) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
  }
  return stream.stream_ops.ioctl(stream, cmd, arg);
 }),
 readFile: (function(path, opts) {
  opts = opts || {};
  opts.flags = opts.flags || "r";
  opts.encoding = opts.encoding || "binary";
  if (opts.encoding !== "utf8" && opts.encoding !== "binary") {
   throw new Error('Invalid encoding type "' + opts.encoding + '"');
  }
  var ret;
  var stream = FS.open(path, opts.flags);
  var stat = FS.stat(path);
  var length = stat.size;
  var buf = new Uint8Array(length);
  FS.read(stream, buf, 0, length, 0);
  if (opts.encoding === "utf8") {
   ret = UTF8ArrayToString(buf, 0);
  } else if (opts.encoding === "binary") {
   ret = buf;
  }
  FS.close(stream);
  return ret;
 }),
 writeFile: (function(path, data, opts) {
  opts = opts || {};
  opts.flags = opts.flags || "w";
  opts.encoding = opts.encoding || "utf8";
  if (opts.encoding !== "utf8" && opts.encoding !== "binary") {
   throw new Error('Invalid encoding type "' + opts.encoding + '"');
  }
  var stream = FS.open(path, opts.flags, opts.mode);
  if (opts.encoding === "utf8") {
   var buf = new Uint8Array(lengthBytesUTF8(data) + 1);
   var actualNumBytes = stringToUTF8Array(data, buf, 0, buf.length);
   FS.write(stream, buf, 0, actualNumBytes, 0, opts.canOwn);
  } else if (opts.encoding === "binary") {
   FS.write(stream, data, 0, data.length, 0, opts.canOwn);
  }
  FS.close(stream);
 }),
 cwd: (function() {
  return FS.currentPath;
 }),
 chdir: (function(path) {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  if (!FS.isDir(lookup.node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
  }
  var err = FS.nodePermissions(lookup.node, "x");
  if (err) {
   throw new FS.ErrnoError(err);
  }
  FS.currentPath = lookup.path;
 }),
 createDefaultDirectories: (function() {
  FS.mkdir("/tmp");
  FS.mkdir("/home");
  FS.mkdir("/home/web_user");
 }),
 createDefaultDevices: (function() {
  FS.mkdir("/dev");
  FS.registerDevice(FS.makedev(1, 3), {
   read: (function() {
    return 0;
   }),
   write: (function(stream, buffer, offset, length, pos) {
    return length;
   })
  });
  FS.mkdev("/dev/null", FS.makedev(1, 3));
  TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
  TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
  FS.mkdev("/dev/tty", FS.makedev(5, 0));
  FS.mkdev("/dev/tty1", FS.makedev(6, 0));
  var random_device;
  if (typeof crypto !== "undefined") {
   var randomBuffer = new Uint8Array(1);
   random_device = (function() {
    crypto.getRandomValues(randomBuffer);
    return randomBuffer[0];
   });
  } else if (ENVIRONMENT_IS_NODE) {
   random_device = (function() {
    return require("crypto").randomBytes(1)[0];
   });
  } else {
   random_device = (function() {
    return Math.random() * 256 | 0;
   });
  }
  FS.createDevice("/dev", "random", random_device);
  FS.createDevice("/dev", "urandom", random_device);
  FS.mkdir("/dev/shm");
  FS.mkdir("/dev/shm/tmp");
 }),
 createSpecialDirectories: (function() {
  FS.mkdir("/proc");
  FS.mkdir("/proc/self");
  FS.mkdir("/proc/self/fd");
  FS.mount({
   mount: (function() {
    var node = FS.createNode("/proc/self", "fd", 16384 | 511, 73);
    node.node_ops = {
     lookup: (function(parent, name) {
      var fd = +name;
      var stream = FS.getStream(fd);
      if (!stream) throw new FS.ErrnoError(ERRNO_CODES.EBADF);
      var ret = {
       parent: null,
       mount: {
        mountpoint: "fake"
       },
       node_ops: {
        readlink: (function() {
         return stream.path;
        })
       }
      };
      ret.parent = ret;
      return ret;
     })
    };
    return node;
   })
  }, {}, "/proc/self/fd");
 }),
 createStandardStreams: (function() {
  if (Module["stdin"]) {
   FS.createDevice("/dev", "stdin", Module["stdin"]);
  } else {
   FS.symlink("/dev/tty", "/dev/stdin");
  }
  if (Module["stdout"]) {
   FS.createDevice("/dev", "stdout", null, Module["stdout"]);
  } else {
   FS.symlink("/dev/tty", "/dev/stdout");
  }
  if (Module["stderr"]) {
   FS.createDevice("/dev", "stderr", null, Module["stderr"]);
  } else {
   FS.symlink("/dev/tty1", "/dev/stderr");
  }
  var stdin = FS.open("/dev/stdin", "r");
  assert(stdin.fd === 0, "invalid handle for stdin (" + stdin.fd + ")");
  var stdout = FS.open("/dev/stdout", "w");
  assert(stdout.fd === 1, "invalid handle for stdout (" + stdout.fd + ")");
  var stderr = FS.open("/dev/stderr", "w");
  assert(stderr.fd === 2, "invalid handle for stderr (" + stderr.fd + ")");
 }),
 ensureErrnoError: (function() {
  if (FS.ErrnoError) return;
  FS.ErrnoError = function ErrnoError(errno, node) {
   this.node = node;
   this.setErrno = (function(errno) {
    this.errno = errno;
    for (var key in ERRNO_CODES) {
     if (ERRNO_CODES[key] === errno) {
      this.code = key;
      break;
     }
    }
   });
   this.setErrno(errno);
   this.message = ERRNO_MESSAGES[errno];
  };
  FS.ErrnoError.prototype = new Error;
  FS.ErrnoError.prototype.constructor = FS.ErrnoError;
  [ ERRNO_CODES.ENOENT ].forEach((function(code) {
   FS.genericErrors[code] = new FS.ErrnoError(code);
   FS.genericErrors[code].stack = "<generic error, no stack>";
  }));
 }),
 staticInit: (function() {
  FS.ensureErrnoError();
  FS.nameTable = new Array(4096);
  FS.mount(MEMFS, {}, "/");
  FS.createDefaultDirectories();
  FS.createDefaultDevices();
  FS.createSpecialDirectories();
  FS.filesystems = {
   "MEMFS": MEMFS,
   "IDBFS": IDBFS,
   "NODEFS": NODEFS,
   "WORKERFS": WORKERFS
  };
 }),
 init: (function(input, output, error) {
  assert(!FS.init.initialized, "FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");
  FS.init.initialized = true;
  FS.ensureErrnoError();
  Module["stdin"] = input || Module["stdin"];
  Module["stdout"] = output || Module["stdout"];
  Module["stderr"] = error || Module["stderr"];
  FS.createStandardStreams();
 }),
 quit: (function() {
  FS.init.initialized = false;
  var fflush = Module["_fflush"];
  if (fflush) fflush(0);
  for (var i = 0; i < FS.streams.length; i++) {
   var stream = FS.streams[i];
   if (!stream) {
    continue;
   }
   FS.close(stream);
  }
 }),
 getMode: (function(canRead, canWrite) {
  var mode = 0;
  if (canRead) mode |= 292 | 73;
  if (canWrite) mode |= 146;
  return mode;
 }),
 joinPath: (function(parts, forceRelative) {
  var path = PATH.join.apply(null, parts);
  if (forceRelative && path[0] == "/") path = path.substr(1);
  return path;
 }),
 absolutePath: (function(relative, base) {
  return PATH.resolve(base, relative);
 }),
 standardizePath: (function(path) {
  return PATH.normalize(path);
 }),
 findObject: (function(path, dontResolveLastLink) {
  var ret = FS.analyzePath(path, dontResolveLastLink);
  if (ret.exists) {
   return ret.object;
  } else {
   ___setErrNo(ret.error);
   return null;
  }
 }),
 analyzePath: (function(path, dontResolveLastLink) {
  try {
   var lookup = FS.lookupPath(path, {
    follow: !dontResolveLastLink
   });
   path = lookup.path;
  } catch (e) {}
  var ret = {
   isRoot: false,
   exists: false,
   error: 0,
   name: null,
   path: null,
   object: null,
   parentExists: false,
   parentPath: null,
   parentObject: null
  };
  try {
   var lookup = FS.lookupPath(path, {
    parent: true
   });
   ret.parentExists = true;
   ret.parentPath = lookup.path;
   ret.parentObject = lookup.node;
   ret.name = PATH.basename(path);
   lookup = FS.lookupPath(path, {
    follow: !dontResolveLastLink
   });
   ret.exists = true;
   ret.path = lookup.path;
   ret.object = lookup.node;
   ret.name = lookup.node.name;
   ret.isRoot = lookup.path === "/";
  } catch (e) {
   ret.error = e.errno;
  }
  return ret;
 }),
 createFolder: (function(parent, name, canRead, canWrite) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  var mode = FS.getMode(canRead, canWrite);
  return FS.mkdir(path, mode);
 }),
 createPath: (function(parent, path, canRead, canWrite) {
  parent = typeof parent === "string" ? parent : FS.getPath(parent);
  var parts = path.split("/").reverse();
  while (parts.length) {
   var part = parts.pop();
   if (!part) continue;
   var current = PATH.join2(parent, part);
   try {
    FS.mkdir(current);
   } catch (e) {}
   parent = current;
  }
  return current;
 }),
 createFile: (function(parent, name, properties, canRead, canWrite) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  var mode = FS.getMode(canRead, canWrite);
  return FS.create(path, mode);
 }),
 createDataFile: (function(parent, name, data, canRead, canWrite, canOwn) {
  var path = name ? PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name) : parent;
  var mode = FS.getMode(canRead, canWrite);
  var node = FS.create(path, mode);
  if (data) {
   if (typeof data === "string") {
    var arr = new Array(data.length);
    for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
    data = arr;
   }
   FS.chmod(node, mode | 146);
   var stream = FS.open(node, "w");
   FS.write(stream, data, 0, data.length, 0, canOwn);
   FS.close(stream);
   FS.chmod(node, mode);
  }
  return node;
 }),
 createDevice: (function(parent, name, input, output) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  var mode = FS.getMode(!!input, !!output);
  if (!FS.createDevice.major) FS.createDevice.major = 64;
  var dev = FS.makedev(FS.createDevice.major++, 0);
  FS.registerDevice(dev, {
   open: (function(stream) {
    stream.seekable = false;
   }),
   close: (function(stream) {
    if (output && output.buffer && output.buffer.length) {
     output(10);
    }
   }),
   read: (function(stream, buffer, offset, length, pos) {
    var bytesRead = 0;
    for (var i = 0; i < length; i++) {
     var result;
     try {
      result = input();
     } catch (e) {
      throw new FS.ErrnoError(ERRNO_CODES.EIO);
     }
     if (result === undefined && bytesRead === 0) {
      throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
     }
     if (result === null || result === undefined) break;
     bytesRead++;
     buffer[offset + i] = result;
    }
    if (bytesRead) {
     stream.node.timestamp = Date.now();
    }
    return bytesRead;
   }),
   write: (function(stream, buffer, offset, length, pos) {
    for (var i = 0; i < length; i++) {
     try {
      output(buffer[offset + i]);
     } catch (e) {
      throw new FS.ErrnoError(ERRNO_CODES.EIO);
     }
    }
    if (length) {
     stream.node.timestamp = Date.now();
    }
    return i;
   })
  });
  return FS.mkdev(path, mode, dev);
 }),
 createLink: (function(parent, name, target, canRead, canWrite) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  return FS.symlink(target, path);
 }),
 forceLoadFile: (function(obj) {
  if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
  var success = true;
  if (typeof XMLHttpRequest !== "undefined") {
   throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
  } else if (Module["read"]) {
   try {
    obj.contents = intArrayFromString(Module["read"](obj.url), true);
    obj.usedBytes = obj.contents.length;
   } catch (e) {
    success = false;
   }
  } else {
   throw new Error("Cannot load without read() or XMLHttpRequest.");
  }
  if (!success) ___setErrNo(ERRNO_CODES.EIO);
  return success;
 }),
 createLazyFile: (function(parent, name, url, canRead, canWrite) {
  function LazyUint8Array() {
   this.lengthKnown = false;
   this.chunks = [];
  }
  LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
   if (idx > this.length - 1 || idx < 0) {
    return undefined;
   }
   var chunkOffset = idx % this.chunkSize;
   var chunkNum = idx / this.chunkSize | 0;
   return this.getter(chunkNum)[chunkOffset];
  };
  LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
   this.getter = getter;
  };
  LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
   var xhr = new XMLHttpRequest;
   xhr.open("HEAD", url, false);
   xhr.send(null);
   if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
   var datalength = Number(xhr.getResponseHeader("Content-length"));
   var header;
   var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
   var chunkSize = 1024 * 1024;
   if (!hasByteServing) chunkSize = datalength;
   var doXHR = (function(from, to) {
    if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
    if (to > datalength - 1) throw new Error("only " + datalength + " bytes available! programmer error!");
    var xhr = new XMLHttpRequest;
    xhr.open("GET", url, false);
    if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
    if (typeof Uint8Array != "undefined") xhr.responseType = "arraybuffer";
    if (xhr.overrideMimeType) {
     xhr.overrideMimeType("text/plain; charset=x-user-defined");
    }
    xhr.send(null);
    if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
    if (xhr.response !== undefined) {
     return new Uint8Array(xhr.response || []);
    } else {
     return intArrayFromString(xhr.responseText || "", true);
    }
   });
   var lazyArray = this;
   lazyArray.setDataGetter((function(chunkNum) {
    var start = chunkNum * chunkSize;
    var end = (chunkNum + 1) * chunkSize - 1;
    end = Math.min(end, datalength - 1);
    if (typeof lazyArray.chunks[chunkNum] === "undefined") {
     lazyArray.chunks[chunkNum] = doXHR(start, end);
    }
    if (typeof lazyArray.chunks[chunkNum] === "undefined") throw new Error("doXHR failed!");
    return lazyArray.chunks[chunkNum];
   }));
   this._length = datalength;
   this._chunkSize = chunkSize;
   this.lengthKnown = true;
  };
  if (typeof XMLHttpRequest !== "undefined") {
   if (!ENVIRONMENT_IS_WORKER) throw "Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";
   var lazyArray = new LazyUint8Array;
   Object.defineProperty(lazyArray, "length", {
    get: (function() {
     if (!this.lengthKnown) {
      this.cacheLength();
     }
     return this._length;
    })
   });
   Object.defineProperty(lazyArray, "chunkSize", {
    get: (function() {
     if (!this.lengthKnown) {
      this.cacheLength();
     }
     return this._chunkSize;
    })
   });
   var properties = {
    isDevice: false,
    contents: lazyArray
   };
  } else {
   var properties = {
    isDevice: false,
    url: url
   };
  }
  var node = FS.createFile(parent, name, properties, canRead, canWrite);
  if (properties.contents) {
   node.contents = properties.contents;
  } else if (properties.url) {
   node.contents = null;
   node.url = properties.url;
  }
  Object.defineProperty(node, "usedBytes", {
   get: (function() {
    return this.contents.length;
   })
  });
  var stream_ops = {};
  var keys = Object.keys(node.stream_ops);
  keys.forEach((function(key) {
   var fn = node.stream_ops[key];
   stream_ops[key] = function forceLoadLazyFile() {
    if (!FS.forceLoadFile(node)) {
     throw new FS.ErrnoError(ERRNO_CODES.EIO);
    }
    return fn.apply(null, arguments);
   };
  }));
  stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
   if (!FS.forceLoadFile(node)) {
    throw new FS.ErrnoError(ERRNO_CODES.EIO);
   }
   var contents = stream.node.contents;
   if (position >= contents.length) return 0;
   var size = Math.min(contents.length - position, length);
   assert(size >= 0);
   if (contents.slice) {
    for (var i = 0; i < size; i++) {
     buffer[offset + i] = contents[position + i];
    }
   } else {
    for (var i = 0; i < size; i++) {
     buffer[offset + i] = contents.get(position + i);
    }
   }
   return size;
  };
  node.stream_ops = stream_ops;
  return node;
 }),
 createPreloadedFile: (function(parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn, preFinish) {
  Browser.init();
  var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
  var dep = getUniqueRunDependency("cp " + fullname);
  function processData(byteArray) {
   function finish(byteArray) {
    if (preFinish) preFinish();
    if (!dontCreateFile) {
     FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
    }
    if (onload) onload();
    removeRunDependency(dep);
   }
   var handled = false;
   Module["preloadPlugins"].forEach((function(plugin) {
    if (handled) return;
    if (plugin["canHandle"](fullname)) {
     plugin["handle"](byteArray, fullname, finish, (function() {
      if (onerror) onerror();
      removeRunDependency(dep);
     }));
     handled = true;
    }
   }));
   if (!handled) finish(byteArray);
  }
  addRunDependency(dep);
  if (typeof url == "string") {
   Browser.asyncLoad(url, (function(byteArray) {
    processData(byteArray);
   }), onerror);
  } else {
   processData(url);
  }
 }),
 indexedDB: (function() {
  return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
 }),
 DB_NAME: (function() {
  return "EM_FS_" + window.location.pathname;
 }),
 DB_VERSION: 20,
 DB_STORE_NAME: "FILE_DATA",
 saveFilesToDB: (function(paths, onload, onerror) {
  onload = onload || (function() {});
  onerror = onerror || (function() {});
  var indexedDB = FS.indexedDB();
  try {
   var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
  } catch (e) {
   return onerror(e);
  }
  openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
   console.log("creating db");
   var db = openRequest.result;
   db.createObjectStore(FS.DB_STORE_NAME);
  };
  openRequest.onsuccess = function openRequest_onsuccess() {
   var db = openRequest.result;
   var transaction = db.transaction([ FS.DB_STORE_NAME ], "readwrite");
   var files = transaction.objectStore(FS.DB_STORE_NAME);
   var ok = 0, fail = 0, total = paths.length;
   function finish() {
    if (fail == 0) onload(); else onerror();
   }
   paths.forEach((function(path) {
    var putRequest = files.put(FS.analyzePath(path).object.contents, path);
    putRequest.onsuccess = function putRequest_onsuccess() {
     ok++;
     if (ok + fail == total) finish();
    };
    putRequest.onerror = function putRequest_onerror() {
     fail++;
     if (ok + fail == total) finish();
    };
   }));
   transaction.onerror = onerror;
  };
  openRequest.onerror = onerror;
 }),
 loadFilesFromDB: (function(paths, onload, onerror) {
  onload = onload || (function() {});
  onerror = onerror || (function() {});
  var indexedDB = FS.indexedDB();
  try {
   var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
  } catch (e) {
   return onerror(e);
  }
  openRequest.onupgradeneeded = onerror;
  openRequest.onsuccess = function openRequest_onsuccess() {
   var db = openRequest.result;
   try {
    var transaction = db.transaction([ FS.DB_STORE_NAME ], "readonly");
   } catch (e) {
    onerror(e);
    return;
   }
   var files = transaction.objectStore(FS.DB_STORE_NAME);
   var ok = 0, fail = 0, total = paths.length;
   function finish() {
    if (fail == 0) onload(); else onerror();
   }
   paths.forEach((function(path) {
    var getRequest = files.get(path);
    getRequest.onsuccess = function getRequest_onsuccess() {
     if (FS.analyzePath(path).exists) {
      FS.unlink(path);
     }
     FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
     ok++;
     if (ok + fail == total) finish();
    };
    getRequest.onerror = function getRequest_onerror() {
     fail++;
     if (ok + fail == total) finish();
    };
   }));
   transaction.onerror = onerror;
  };
  openRequest.onerror = onerror;
 })
};
var SYSCALLS = {
 DEFAULT_POLLMASK: 5,
 mappings: {},
 umask: 511,
 calculateAt: (function(dirfd, path) {
  if (path[0] !== "/") {
   var dir;
   if (dirfd === -100) {
    dir = FS.cwd();
   } else {
    var dirstream = FS.getStream(dirfd);
    if (!dirstream) throw new FS.ErrnoError(ERRNO_CODES.EBADF);
    dir = dirstream.path;
   }
   path = PATH.join2(dir, path);
  }
  return path;
 }),
 doStat: (function(func, path, buf) {
  try {
   var stat = func(path);
  } catch (e) {
   if (e && e.node && PATH.normalize(path) !== PATH.normalize(FS.getPath(e.node))) {
    return -ERRNO_CODES.ENOTDIR;
   }
   throw e;
  }
  HEAP32[buf >> 2] = stat.dev;
  HEAP32[buf + 4 >> 2] = 0;
  HEAP32[buf + 8 >> 2] = stat.ino;
  HEAP32[buf + 12 >> 2] = stat.mode;
  HEAP32[buf + 16 >> 2] = stat.nlink;
  HEAP32[buf + 20 >> 2] = stat.uid;
  HEAP32[buf + 24 >> 2] = stat.gid;
  HEAP32[buf + 28 >> 2] = stat.rdev;
  HEAP32[buf + 32 >> 2] = 0;
  HEAP32[buf + 36 >> 2] = stat.size;
  HEAP32[buf + 40 >> 2] = 4096;
  HEAP32[buf + 44 >> 2] = stat.blocks;
  HEAP32[buf + 48 >> 2] = stat.atime.getTime() / 1e3 | 0;
  HEAP32[buf + 52 >> 2] = 0;
  HEAP32[buf + 56 >> 2] = stat.mtime.getTime() / 1e3 | 0;
  HEAP32[buf + 60 >> 2] = 0;
  HEAP32[buf + 64 >> 2] = stat.ctime.getTime() / 1e3 | 0;
  HEAP32[buf + 68 >> 2] = 0;
  HEAP32[buf + 72 >> 2] = stat.ino;
  return 0;
 }),
 doMsync: (function(addr, stream, len, flags) {
  var buffer = new Uint8Array(HEAPU8.subarray(addr, addr + len));
  FS.msync(stream, buffer, 0, len, flags);
 }),
 doMkdir: (function(path, mode) {
  path = PATH.normalize(path);
  if (path[path.length - 1] === "/") path = path.substr(0, path.length - 1);
  FS.mkdir(path, mode, 0);
  return 0;
 }),
 doMknod: (function(path, mode, dev) {
  switch (mode & 61440) {
  case 32768:
  case 8192:
  case 24576:
  case 4096:
  case 49152:
   break;
  default:
   return -ERRNO_CODES.EINVAL;
  }
  FS.mknod(path, mode, dev);
  return 0;
 }),
 doReadlink: (function(path, buf, bufsize) {
  if (bufsize <= 0) return -ERRNO_CODES.EINVAL;
  var ret = FS.readlink(path);
  ret = ret.slice(0, Math.max(0, bufsize));
  writeStringToMemory(ret, buf, true);
  return ret.length;
 }),
 doAccess: (function(path, amode) {
  if (amode & ~7) {
   return -ERRNO_CODES.EINVAL;
  }
  var node;
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  node = lookup.node;
  var perms = "";
  if (amode & 4) perms += "r";
  if (amode & 2) perms += "w";
  if (amode & 1) perms += "x";
  if (perms && FS.nodePermissions(node, perms)) {
   return -ERRNO_CODES.EACCES;
  }
  return 0;
 }),
 doDup: (function(path, flags, suggestFD) {
  var suggest = FS.getStream(suggestFD);
  if (suggest) FS.close(suggest);
  return FS.open(path, flags, 0, suggestFD, suggestFD).fd;
 }),
 doReadv: (function(stream, iov, iovcnt, offset) {
  var ret = 0;
  for (var i = 0; i < iovcnt; i++) {
   var ptr = HEAP32[iov + i * 8 >> 2];
   var len = HEAP32[iov + (i * 8 + 4) >> 2];
   var curr = FS.read(stream, HEAP8, ptr, len, offset);
   if (curr < 0) return -1;
   ret += curr;
   if (curr < len) break;
  }
  return ret;
 }),
 doWritev: (function(stream, iov, iovcnt, offset) {
  var ret = 0;
  for (var i = 0; i < iovcnt; i++) {
   var ptr = HEAP32[iov + i * 8 >> 2];
   var len = HEAP32[iov + (i * 8 + 4) >> 2];
   var curr = FS.write(stream, HEAP8, ptr, len, offset);
   if (curr < 0) return -1;
   ret += curr;
  }
  return ret;
 }),
 varargs: 0,
 get: (function(varargs) {
  SYSCALLS.varargs += 4;
  var ret = HEAP32[SYSCALLS.varargs - 4 >> 2];
  return ret;
 }),
 getStr: (function() {
  var ret = Pointer_stringify(SYSCALLS.get());
  return ret;
 }),
 getStreamFromFD: (function() {
  var stream = FS.getStream(SYSCALLS.get());
  if (!stream) throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  return stream;
 }),
 getSocketFromFD: (function() {
  var socket = SOCKFS.getSocket(SYSCALLS.get());
  if (!socket) throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  return socket;
 }),
 getSocketAddress: (function(allowNull) {
  var addrp = SYSCALLS.get(), addrlen = SYSCALLS.get();
  if (allowNull && addrp === 0) return null;
  var info = __read_sockaddr(addrp, addrlen);
  if (info.errno) throw new FS.ErrnoError(info.errno);
  info.addr = DNS.lookup_addr(info.addr) || info.addr;
  return info;
 }),
 get64: (function() {
  var low = SYSCALLS.get(), high = SYSCALLS.get();
  if (low >= 0) assert(high === 0); else assert(high === -1);
  return low;
 }),
 getZero: (function() {
  assert(SYSCALLS.get() === 0);
 })
};
function ___syscall54(which, varargs) {
 SYSCALLS.varargs = varargs;
 try {
  var stream = SYSCALLS.getStreamFromFD(), op = SYSCALLS.get();
  switch (op) {
  case 21505:
   {
    if (!stream.tty) return -ERRNO_CODES.ENOTTY;
    return 0;
   }
  case 21506:
   {
    if (!stream.tty) return -ERRNO_CODES.ENOTTY;
    return 0;
   }
  case 21519:
   {
    if (!stream.tty) return -ERRNO_CODES.ENOTTY;
    var argp = SYSCALLS.get();
    HEAP32[argp >> 2] = 0;
    return 0;
   }
  case 21520:
   {
    if (!stream.tty) return -ERRNO_CODES.ENOTTY;
    return -ERRNO_CODES.EINVAL;
   }
  case 21531:
   {
    var argp = SYSCALLS.get();
    return FS.ioctl(stream, op, argp);
   }
  default:
   abort("bad ioctl syscall " + op);
  }
 } catch (e) {
  if (typeof FS === "undefined" || !(e instanceof FS.ErrnoError)) abort(e);
  return -e.errno;
 }
}
Module["_bitshift64Lshr"] = _bitshift64Lshr;
function upcastPointer(ptr, ptrClass, desiredClass) {
 while (ptrClass !== desiredClass) {
  if (!ptrClass.upcast) {
   throwBindingError("Expected null or instance of " + desiredClass.name + ", got an instance of " + ptrClass.name);
  }
  ptr = ptrClass.upcast(ptr);
  ptrClass = ptrClass.baseClass;
 }
 return ptr;
}
function constNoSmartPtrRawPointerToWireType(destructors, handle) {
 if (handle === null) {
  if (this.isReference) {
   throwBindingError("null is not a valid " + this.name);
  }
  return 0;
 }
 if (!handle.$$) {
  throwBindingError('Cannot pass "' + _embind_repr(handle) + '" as a ' + this.name);
 }
 if (!handle.$$.ptr) {
  throwBindingError("Cannot pass deleted object as a pointer of type " + this.name);
 }
 var handleClass = handle.$$.ptrType.registeredClass;
 var ptr = upcastPointer(handle.$$.ptr, handleClass, this.registeredClass);
 return ptr;
}
function genericPointerToWireType(destructors, handle) {
 if (handle === null) {
  if (this.isReference) {
   throwBindingError("null is not a valid " + this.name);
  }
  if (this.isSmartPointer) {
   var ptr = this.rawConstructor();
   if (destructors !== null) {
    destructors.push(this.rawDestructor, ptr);
   }
   return ptr;
  } else {
   return 0;
  }
 }
 if (!handle.$$) {
  throwBindingError('Cannot pass "' + _embind_repr(handle) + '" as a ' + this.name);
 }
 if (!handle.$$.ptr) {
  throwBindingError("Cannot pass deleted object as a pointer of type " + this.name);
 }
 if (!this.isConst && handle.$$.ptrType.isConst) {
  throwBindingError("Cannot convert argument of type " + (handle.$$.smartPtrType ? handle.$$.smartPtrType.name : handle.$$.ptrType.name) + " to parameter type " + this.name);
 }
 var handleClass = handle.$$.ptrType.registeredClass;
 var ptr = upcastPointer(handle.$$.ptr, handleClass, this.registeredClass);
 if (this.isSmartPointer) {
  if (undefined === handle.$$.smartPtr) {
   throwBindingError("Passing raw pointer to smart pointer is illegal");
  }
  switch (this.sharingPolicy) {
  case 0:
   if (handle.$$.smartPtrType === this) {
    ptr = handle.$$.smartPtr;
   } else {
    throwBindingError("Cannot convert argument of type " + (handle.$$.smartPtrType ? handle.$$.smartPtrType.name : handle.$$.ptrType.name) + " to parameter type " + this.name);
   }
   break;
  case 1:
   ptr = handle.$$.smartPtr;
   break;
  case 2:
   if (handle.$$.smartPtrType === this) {
    ptr = handle.$$.smartPtr;
   } else {
    var clonedHandle = handle["clone"]();
    ptr = this.rawShare(ptr, __emval_register((function() {
     clonedHandle["delete"]();
    })));
    if (destructors !== null) {
     destructors.push(this.rawDestructor, ptr);
    }
   }
   break;
  default:
   throwBindingError("Unsupporting sharing policy");
  }
 }
 return ptr;
}
function nonConstNoSmartPtrRawPointerToWireType(destructors, handle) {
 if (handle === null) {
  if (this.isReference) {
   throwBindingError("null is not a valid " + this.name);
  }
  return 0;
 }
 if (!handle.$$) {
  throwBindingError('Cannot pass "' + _embind_repr(handle) + '" as a ' + this.name);
 }
 if (!handle.$$.ptr) {
  throwBindingError("Cannot pass deleted object as a pointer of type " + this.name);
 }
 if (handle.$$.ptrType.isConst) {
  throwBindingError("Cannot convert argument of type " + handle.$$.ptrType.name + " to parameter type " + this.name);
 }
 var handleClass = handle.$$.ptrType.registeredClass;
 var ptr = upcastPointer(handle.$$.ptr, handleClass, this.registeredClass);
 return ptr;
}
function RegisteredPointer_getPointee(ptr) {
 if (this.rawGetPointee) {
  ptr = this.rawGetPointee(ptr);
 }
 return ptr;
}
function RegisteredPointer_destructor(ptr) {
 if (this.rawDestructor) {
  this.rawDestructor(ptr);
 }
}
function RegisteredPointer_deleteObject(handle) {
 if (handle !== null) {
  handle["delete"]();
 }
}
function downcastPointer(ptr, ptrClass, desiredClass) {
 if (ptrClass === desiredClass) {
  return ptr;
 }
 if (undefined === desiredClass.baseClass) {
  return null;
 }
 var rv = downcastPointer(ptr, ptrClass, desiredClass.baseClass);
 if (rv === null) {
  return null;
 }
 return desiredClass.downcast(rv);
}
var registeredPointers = {};
function getInheritedInstanceCount() {
 return Object.keys(registeredInstances).length;
}
function getLiveInheritedInstances() {
 var rv = [];
 for (var k in registeredInstances) {
  if (registeredInstances.hasOwnProperty(k)) {
   rv.push(registeredInstances[k]);
  }
 }
 return rv;
}
var deletionQueue = [];
function flushPendingDeletes() {
 while (deletionQueue.length) {
  var obj = deletionQueue.pop();
  obj.$$.deleteScheduled = false;
  obj["delete"]();
 }
}
var delayFunction = undefined;
function setDelayFunction(fn) {
 delayFunction = fn;
 if (deletionQueue.length && delayFunction) {
  delayFunction(flushPendingDeletes);
 }
}
function init_embind() {
 Module["getInheritedInstanceCount"] = getInheritedInstanceCount;
 Module["getLiveInheritedInstances"] = getLiveInheritedInstances;
 Module["flushPendingDeletes"] = flushPendingDeletes;
 Module["setDelayFunction"] = setDelayFunction;
}
var registeredInstances = {};
function getBasestPointer(class_, ptr) {
 if (ptr === undefined) {
  throwBindingError("ptr should not be undefined");
 }
 while (class_.baseClass) {
  ptr = class_.upcast(ptr);
  class_ = class_.baseClass;
 }
 return ptr;
}
function getInheritedInstance(class_, ptr) {
 ptr = getBasestPointer(class_, ptr);
 return registeredInstances[ptr];
}
var _throwInternalError = undefined;
function makeClassHandle(prototype, record) {
 if (!record.ptrType || !record.ptr) {
  throwInternalError("makeClassHandle requires ptr and ptrType");
 }
 var hasSmartPtrType = !!record.smartPtrType;
 var hasSmartPtr = !!record.smartPtr;
 if (hasSmartPtrType !== hasSmartPtr) {
  throwInternalError("Both smartPtrType and smartPtr must be specified");
 }
 record.count = {
  value: 1
 };
 return Object.create(prototype, {
  $$: {
   value: record
  }
 });
}
function RegisteredPointer_fromWireType(ptr) {
 var rawPointer = this.getPointee(ptr);
 if (!rawPointer) {
  this.destructor(ptr);
  return null;
 }
 var registeredInstance = getInheritedInstance(this.registeredClass, rawPointer);
 if (undefined !== registeredInstance) {
  if (0 === registeredInstance.$$.count.value) {
   registeredInstance.$$.ptr = rawPointer;
   registeredInstance.$$.smartPtr = ptr;
   return registeredInstance["clone"]();
  } else {
   var rv = registeredInstance["clone"]();
   this.destructor(ptr);
   return rv;
  }
 }
 function makeDefaultHandle() {
  if (this.isSmartPointer) {
   return makeClassHandle(this.registeredClass.instancePrototype, {
    ptrType: this.pointeeType,
    ptr: rawPointer,
    smartPtrType: this,
    smartPtr: ptr
   });
  } else {
   return makeClassHandle(this.registeredClass.instancePrototype, {
    ptrType: this,
    ptr: ptr
   });
  }
 }
 var actualType = this.registeredClass.getActualType(rawPointer);
 var registeredPointerRecord = registeredPointers[actualType];
 if (!registeredPointerRecord) {
  return makeDefaultHandle.call(this);
 }
 var toType;
 if (this.isConst) {
  toType = registeredPointerRecord.constPointerType;
 } else {
  toType = registeredPointerRecord.pointerType;
 }
 var dp = downcastPointer(rawPointer, this.registeredClass, toType.registeredClass);
 if (dp === null) {
  return makeDefaultHandle.call(this);
 }
 if (this.isSmartPointer) {
  return makeClassHandle(toType.registeredClass.instancePrototype, {
   ptrType: toType,
   ptr: dp,
   smartPtrType: this,
   smartPtr: ptr
  });
 } else {
  return makeClassHandle(toType.registeredClass.instancePrototype, {
   ptrType: toType,
   ptr: dp
  });
 }
}
function init_RegisteredPointer() {
 RegisteredPointer.prototype.getPointee = RegisteredPointer_getPointee;
 RegisteredPointer.prototype.destructor = RegisteredPointer_destructor;
 RegisteredPointer.prototype["argPackAdvance"] = 8;
 RegisteredPointer.prototype["readValueFromPointer"] = simpleReadValueFromPointer;
 RegisteredPointer.prototype["deleteObject"] = RegisteredPointer_deleteObject;
 RegisteredPointer.prototype["fromWireType"] = RegisteredPointer_fromWireType;
}
function RegisteredPointer(name, registeredClass, isReference, isConst, isSmartPointer, pointeeType, sharingPolicy, rawGetPointee, rawConstructor, rawShare, rawDestructor) {
 this.name = name;
 this.registeredClass = registeredClass;
 this.isReference = isReference;
 this.isConst = isConst;
 this.isSmartPointer = isSmartPointer;
 this.pointeeType = pointeeType;
 this.sharingPolicy = sharingPolicy;
 this.rawGetPointee = rawGetPointee;
 this.rawConstructor = rawConstructor;
 this.rawShare = rawShare;
 this.rawDestructor = rawDestructor;
 if (!isSmartPointer && registeredClass.baseClass === undefined) {
  if (isConst) {
   this["toWireType"] = constNoSmartPtrRawPointerToWireType;
   this.destructorFunction = null;
  } else {
   this["toWireType"] = nonConstNoSmartPtrRawPointerToWireType;
   this.destructorFunction = null;
  }
 } else {
  this["toWireType"] = genericPointerToWireType;
 }
}
function requireFunction(signature, rawFunction) {
 signature = readLatin1String(signature);
 function makeDynCaller(dynCall) {
  var args = [];
  for (var i = 1; i < signature.length; ++i) {
   args.push("a" + i);
  }
  var name = "dynCall_" + signature + "_" + rawFunction;
  var body = "return function " + name + "(" + args.join(", ") + ") {\n";
  body += "    return dynCall(rawFunction" + (args.length ? ", " : "") + args.join(", ") + ");\n";
  body += "};\n";
  return (new Function("dynCall", "rawFunction", body))(dynCall, rawFunction);
 }
 var fp;
 if (Module["FUNCTION_TABLE_" + signature] !== undefined) {
  fp = Module["FUNCTION_TABLE_" + signature][rawFunction];
 } else if (typeof FUNCTION_TABLE !== "undefined") {
  fp = FUNCTION_TABLE[rawFunction];
 } else {
  var dc = asm["dynCall_" + signature];
  if (dc === undefined) {
   dc = asm["dynCall_" + signature.replace(/f/g, "d")];
   if (dc === undefined) {
    throwBindingError("No dynCall invoker for signature: " + signature);
   }
  }
  fp = makeDynCaller(dc);
 }
 if (typeof fp !== "function") {
  throwBindingError("unknown function pointer with signature " + signature + ": " + rawFunction);
 }
 return fp;
}
function __embind_register_smart_ptr(rawType, rawPointeeType, name, sharingPolicy, getPointeeSignature, rawGetPointee, constructorSignature, rawConstructor, shareSignature, rawShare, destructorSignature, rawDestructor) {
 name = readLatin1String(name);
 rawGetPointee = requireFunction(getPointeeSignature, rawGetPointee);
 rawConstructor = requireFunction(constructorSignature, rawConstructor);
 rawShare = requireFunction(shareSignature, rawShare);
 rawDestructor = requireFunction(destructorSignature, rawDestructor);
 whenDependentTypesAreResolved([ rawType ], [ rawPointeeType ], (function(pointeeType) {
  pointeeType = pointeeType[0];
  var registeredPointer = new RegisteredPointer(name, pointeeType.registeredClass, false, false, true, pointeeType, sharingPolicy, rawGetPointee, rawConstructor, rawShare, rawDestructor);
  return [ registeredPointer ];
 }));
}
var _BDtoIHigh = true;
function _pthread_cleanup_push(routine, arg) {
 __ATEXIT__.push((function() {
  Runtime.dynCall("vi", routine, [ arg ]);
 }));
 _pthread_cleanup_push.level = __ATEXIT__.length;
}
function _pthread_cond_broadcast() {
 return 0;
}
function new_(constructor, argumentList) {
 if (!(constructor instanceof Function)) {
  throw new TypeError("new_ called with constructor type " + typeof constructor + " which is not a function");
 }
 var dummy = createNamedFunction(constructor.name || "unknownFunctionName", (function() {}));
 dummy.prototype = constructor.prototype;
 var obj = new dummy;
 var r = constructor.apply(obj, argumentList);
 return r instanceof Object ? r : obj;
}
function runDestructors(destructors) {
 while (destructors.length) {
  var ptr = destructors.pop();
  var del = destructors.pop();
  del(ptr);
 }
}
function craftInvokerFunction(humanName, argTypes, classType, cppInvokerFunc, cppTargetFunc) {
 var argCount = argTypes.length;
 if (argCount < 2) {
  throwBindingError("argTypes array size mismatch! Must at least get return value and 'this' types!");
 }
 var isClassMethodFunc = argTypes[1] !== null && classType !== null;
 var argsList = "";
 var argsListWired = "";
 for (var i = 0; i < argCount - 2; ++i) {
  argsList += (i !== 0 ? ", " : "") + "arg" + i;
  argsListWired += (i !== 0 ? ", " : "") + "arg" + i + "Wired";
 }
 var invokerFnBody = "return function " + makeLegalFunctionName(humanName) + "(" + argsList + ") {\n" + "if (arguments.length !== " + (argCount - 2) + ") {\n" + "throwBindingError('function " + humanName + " called with ' + arguments.length + ' arguments, expected " + (argCount - 2) + " args!');\n" + "}\n";
 var needsDestructorStack = false;
 for (var i = 1; i < argTypes.length; ++i) {
  if (argTypes[i] !== null && argTypes[i].destructorFunction === undefined) {
   needsDestructorStack = true;
   break;
  }
 }
 if (needsDestructorStack) {
  invokerFnBody += "var destructors = [];\n";
 }
 var dtorStack = needsDestructorStack ? "destructors" : "null";
 var args1 = [ "throwBindingError", "invoker", "fn", "runDestructors", "retType", "classParam" ];
 var args2 = [ throwBindingError, cppInvokerFunc, cppTargetFunc, runDestructors, argTypes[0], argTypes[1] ];
 if (isClassMethodFunc) {
  invokerFnBody += "var thisWired = classParam.toWireType(" + dtorStack + ", this);\n";
 }
 for (var i = 0; i < argCount - 2; ++i) {
  invokerFnBody += "var arg" + i + "Wired = argType" + i + ".toWireType(" + dtorStack + ", arg" + i + "); // " + argTypes[i + 2].name + "\n";
  args1.push("argType" + i);
  args2.push(argTypes[i + 2]);
 }
 if (isClassMethodFunc) {
  argsListWired = "thisWired" + (argsListWired.length > 0 ? ", " : "") + argsListWired;
 }
 var returns = argTypes[0].name !== "void";
 invokerFnBody += (returns ? "var rv = " : "") + "invoker(fn" + (argsListWired.length > 0 ? ", " : "") + argsListWired + ");\n";
 if (needsDestructorStack) {
  invokerFnBody += "runDestructors(destructors);\n";
 } else {
  for (var i = isClassMethodFunc ? 1 : 2; i < argTypes.length; ++i) {
   var paramName = i === 1 ? "thisWired" : "arg" + (i - 2) + "Wired";
   if (argTypes[i].destructorFunction !== null) {
    invokerFnBody += paramName + "_dtor(" + paramName + "); // " + argTypes[i].name + "\n";
    args1.push(paramName + "_dtor");
    args2.push(argTypes[i].destructorFunction);
   }
  }
 }
 if (returns) {
  invokerFnBody += "var ret = retType.fromWireType(rv);\n" + "return ret;\n";
 } else {}
 invokerFnBody += "}\n";
 args1.push(invokerFnBody);
 var invokerFunction = new_(Function, args1).apply(null, args2);
 return invokerFunction;
}
function ensureOverloadTable(proto, methodName, humanName) {
 if (undefined === proto[methodName].overloadTable) {
  var prevFunc = proto[methodName];
  proto[methodName] = (function() {
   if (!proto[methodName].overloadTable.hasOwnProperty(arguments.length)) {
    throwBindingError("Function '" + humanName + "' called with an invalid number of arguments (" + arguments.length + ") - expects one of (" + proto[methodName].overloadTable + ")!");
   }
   return proto[methodName].overloadTable[arguments.length].apply(this, arguments);
  });
  proto[methodName].overloadTable = [];
  proto[methodName].overloadTable[prevFunc.argCount] = prevFunc;
 }
}
function heap32VectorToArray(count, firstElement) {
 var array = [];
 for (var i = 0; i < count; i++) {
  array.push(HEAP32[(firstElement >> 2) + i]);
 }
 return array;
}
var UnboundTypeError = undefined;
function throwUnboundTypeError(message, types) {
 var unboundTypes = [];
 var seen = {};
 function visit(type) {
  if (seen[type]) {
   return;
  }
  if (registeredTypes[type]) {
   return;
  }
  if (typeDependencies[type]) {
   typeDependencies[type].forEach(visit);
   return;
  }
  unboundTypes.push(type);
  seen[type] = true;
 }
 types.forEach(visit);
 throw new UnboundTypeError(message + ": " + unboundTypes.map(getTypeName).join([ ", " ]));
}
function __embind_register_class_class_function(rawClassType, methodName, argCount, rawArgTypesAddr, invokerSignature, rawInvoker, fn) {
 var rawArgTypes = heap32VectorToArray(argCount, rawArgTypesAddr);
 methodName = readLatin1String(methodName);
 rawInvoker = requireFunction(invokerSignature, rawInvoker);
 whenDependentTypesAreResolved([], [ rawClassType ], (function(classType) {
  classType = classType[0];
  var humanName = classType.name + "." + methodName;
  function unboundTypesHandler() {
   throwUnboundTypeError("Cannot call " + humanName + " due to unbound types", rawArgTypes);
  }
  var proto = classType.registeredClass.constructor;
  if (undefined === proto[methodName]) {
   unboundTypesHandler.argCount = argCount - 1;
   proto[methodName] = unboundTypesHandler;
  } else {
   ensureOverloadTable(proto, methodName, humanName);
   proto[methodName].overloadTable[argCount - 1] = unboundTypesHandler;
  }
  whenDependentTypesAreResolved([], rawArgTypes, (function(argTypes) {
   var invokerArgsArray = [ argTypes[0], null ].concat(argTypes.slice(1));
   var func = craftInvokerFunction(humanName, invokerArgsArray, null, rawInvoker, fn);
   if (undefined === proto[methodName].overloadTable) {
    proto[methodName] = func;
   } else {
    proto[methodName].overloadTable[argCount - 1] = func;
   }
   return [];
  }));
  return [];
 }));
}
function _pthread_cleanup_pop() {
 assert(_pthread_cleanup_push.level == __ATEXIT__.length, "cannot pop if something else added meanwhile!");
 __ATEXIT__.pop();
 _pthread_cleanup_push.level = __ATEXIT__.length;
}
function _pthread_mutex_unlock() {}
function _emscripten_memcpy_big(dest, src, num) {
 HEAPU8.set(HEAPU8.subarray(src, src + num), dest);
 return dest;
}
Module["_memcpy"] = _memcpy;
function _pthread_mutex_lock() {}
var _llvm_pow_f64 = Math_pow;
function _sbrk(bytes) {
 var self = _sbrk;
 if (!self.called) {
  DYNAMICTOP = alignMemoryPage(DYNAMICTOP);
  self.called = true;
  assert(Runtime.dynamicAlloc);
  self.alloc = Runtime.dynamicAlloc;
  Runtime.dynamicAlloc = (function() {
   abort("cannot dynamically allocate, sbrk now has control");
  });
 }
 var ret = DYNAMICTOP;
 if (bytes != 0) {
  var success = self.alloc(bytes);
  if (!success) return -1 >>> 0;
 }
 return ret;
}
Module["_bitshift64Shl"] = _bitshift64Shl;
function ___cxa_guard_abort() {}
Module["_memmove"] = _memmove;
var _emscripten_preinvoke = true;
var _BItoD = true;
function _pthread_cond_wait() {
 return 0;
}
function ___cxa_rethrow() {
 ___cxa_end_catch.rethrown = true;
 var ptr = EXCEPTIONS.caught.pop();
 EXCEPTIONS.last = ptr;
 throw ptr;
}
function __embind_register_memory_view(rawType, dataTypeIndex, name) {
 var typeMapping = [ Int8Array, Uint8Array, Int16Array, Uint16Array, Int32Array, Uint32Array, Float32Array, Float64Array ];
 var TA = typeMapping[dataTypeIndex];
 function decodeMemoryView(handle) {
  handle = handle >> 2;
  var heap = HEAPU32;
  var size = heap[handle];
  var data = heap[handle + 1];
  return new TA(heap["buffer"], data, size);
 }
 name = readLatin1String(name);
 registerType(rawType, {
  name: name,
  "fromWireType": decodeMemoryView,
  "argPackAdvance": 8,
  "readValueFromPointer": decodeMemoryView
 }, {
  ignoreDuplicateRegistrations: true
 });
}
function ___cxa_guard_release() {}
function __embind_register_std_string(rawType, name) {
 name = readLatin1String(name);
 registerType(rawType, {
  name: name,
  "fromWireType": (function(value) {
   var length = HEAPU32[value >> 2];
   var a = new Array(length);
   for (var i = 0; i < length; ++i) {
    a[i] = String.fromCharCode(HEAPU8[value + 4 + i]);
   }
   _free(value);
   return a.join("");
  }),
  "toWireType": (function(destructors, value) {
   if (value instanceof ArrayBuffer) {
    value = new Uint8Array(value);
   }
   function getTAElement(ta, index) {
    return ta[index];
   }
   function getStringElement(string, index) {
    return string.charCodeAt(index);
   }
   var getElement;
   if (value instanceof Uint8Array) {
    getElement = getTAElement;
   } else if (value instanceof Int8Array) {
    getElement = getTAElement;
   } else if (typeof value === "string") {
    getElement = getStringElement;
   } else {
    throwBindingError("Cannot pass non-string to std::string");
   }
   var length = value.length;
   var ptr = _malloc(4 + length);
   HEAPU32[ptr >> 2] = length;
   for (var i = 0; i < length; ++i) {
    var charCode = getElement(value, i);
    if (charCode > 255) {
     _free(ptr);
     throwBindingError("String has UTF-16 code units that do not fit in 8 bits");
    }
    HEAPU8[ptr + 4 + i] = charCode;
   }
   if (destructors !== null) {
    destructors.push(_free, ptr);
   }
   return ptr;
  }),
  "argPackAdvance": 8,
  "readValueFromPointer": simpleReadValueFromPointer,
  destructorFunction: (function(ptr) {
   _free(ptr);
  })
 });
}
function ___assert_fail(condition, filename, line, func) {
 ABORT = true;
 throw "Assertion failed: " + Pointer_stringify(condition) + ", at: " + [ filename ? Pointer_stringify(filename) : "unknown filename", line, func ? Pointer_stringify(func) : "unknown function" ] + " at " + stackTrace();
}
function __embind_register_void(rawType, name) {
 name = readLatin1String(name);
 registerType(rawType, {
  isVoid: true,
  name: name,
  "argPackAdvance": 0,
  "fromWireType": (function() {
   return undefined;
  }),
  "toWireType": (function(destructors, o) {
   return undefined;
  })
 });
}
Module["_memset"] = _memset;
var _BDtoILow = true;
function ___gxx_personality_v0() {}
function __isLeapYear(year) {
 return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
}
function __arraySum(array, index) {
 var sum = 0;
 for (var i = 0; i <= index; sum += array[i++]) ;
 return sum;
}
var __MONTH_DAYS_LEAP = [ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ];
var __MONTH_DAYS_REGULAR = [ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ];
function __addDays(date, days) {
 var newDate = new Date(date.getTime());
 while (days > 0) {
  var leap = __isLeapYear(newDate.getFullYear());
  var currentMonth = newDate.getMonth();
  var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  if (days > daysInCurrentMonth - newDate.getDate()) {
   days -= daysInCurrentMonth - newDate.getDate() + 1;
   newDate.setDate(1);
   if (currentMonth < 11) {
    newDate.setMonth(currentMonth + 1);
   } else {
    newDate.setMonth(0);
    newDate.setFullYear(newDate.getFullYear() + 1);
   }
  } else {
   newDate.setDate(newDate.getDate() + days);
   return newDate;
  }
 }
 return newDate;
}
function _strftime(s, maxsize, format, tm) {
 var tm_zone = HEAP32[tm + 40 >> 2];
 var date = {
  tm_sec: HEAP32[tm >> 2],
  tm_min: HEAP32[tm + 4 >> 2],
  tm_hour: HEAP32[tm + 8 >> 2],
  tm_mday: HEAP32[tm + 12 >> 2],
  tm_mon: HEAP32[tm + 16 >> 2],
  tm_year: HEAP32[tm + 20 >> 2],
  tm_wday: HEAP32[tm + 24 >> 2],
  tm_yday: HEAP32[tm + 28 >> 2],
  tm_isdst: HEAP32[tm + 32 >> 2],
  tm_gmtoff: HEAP32[tm + 36 >> 2],
  tm_zone: tm_zone ? Pointer_stringify(tm_zone) : ""
 };
 var pattern = Pointer_stringify(format);
 var EXPANSION_RULES_1 = {
  "%c": "%a %b %d %H:%M:%S %Y",
  "%D": "%m/%d/%y",
  "%F": "%Y-%m-%d",
  "%h": "%b",
  "%r": "%I:%M:%S %p",
  "%R": "%H:%M",
  "%T": "%H:%M:%S",
  "%x": "%m/%d/%y",
  "%X": "%H:%M:%S"
 };
 for (var rule in EXPANSION_RULES_1) {
  pattern = pattern.replace(new RegExp(rule, "g"), EXPANSION_RULES_1[rule]);
 }
 var WEEKDAYS = [ "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" ];
 var MONTHS = [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ];
 function leadingSomething(value, digits, character) {
  var str = typeof value === "number" ? value.toString() : value || "";
  while (str.length < digits) {
   str = character[0] + str;
  }
  return str;
 }
 function leadingNulls(value, digits) {
  return leadingSomething(value, digits, "0");
 }
 function compareByDay(date1, date2) {
  function sgn(value) {
   return value < 0 ? -1 : value > 0 ? 1 : 0;
  }
  var compare;
  if ((compare = sgn(date1.getFullYear() - date2.getFullYear())) === 0) {
   if ((compare = sgn(date1.getMonth() - date2.getMonth())) === 0) {
    compare = sgn(date1.getDate() - date2.getDate());
   }
  }
  return compare;
 }
 function getFirstWeekStartDate(janFourth) {
  switch (janFourth.getDay()) {
  case 0:
   return new Date(janFourth.getFullYear() - 1, 11, 29);
  case 1:
   return janFourth;
  case 2:
   return new Date(janFourth.getFullYear(), 0, 3);
  case 3:
   return new Date(janFourth.getFullYear(), 0, 2);
  case 4:
   return new Date(janFourth.getFullYear(), 0, 1);
  case 5:
   return new Date(janFourth.getFullYear() - 1, 11, 31);
  case 6:
   return new Date(janFourth.getFullYear() - 1, 11, 30);
  }
 }
 function getWeekBasedYear(date) {
  var thisDate = __addDays(new Date(date.tm_year + 1900, 0, 1), date.tm_yday);
  var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
  var janFourthNextYear = new Date(thisDate.getFullYear() + 1, 0, 4);
  var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
  var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
   if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
    return thisDate.getFullYear() + 1;
   } else {
    return thisDate.getFullYear();
   }
  } else {
   return thisDate.getFullYear() - 1;
  }
 }
 var EXPANSION_RULES_2 = {
  "%a": (function(date) {
   return WEEKDAYS[date.tm_wday].substring(0, 3);
  }),
  "%A": (function(date) {
   return WEEKDAYS[date.tm_wday];
  }),
  "%b": (function(date) {
   return MONTHS[date.tm_mon].substring(0, 3);
  }),
  "%B": (function(date) {
   return MONTHS[date.tm_mon];
  }),
  "%C": (function(date) {
   var year = date.tm_year + 1900;
   return leadingNulls(year / 100 | 0, 2);
  }),
  "%d": (function(date) {
   return leadingNulls(date.tm_mday, 2);
  }),
  "%e": (function(date) {
   return leadingSomething(date.tm_mday, 2, " ");
  }),
  "%g": (function(date) {
   return getWeekBasedYear(date).toString().substring(2);
  }),
  "%G": (function(date) {
   return getWeekBasedYear(date);
  }),
  "%H": (function(date) {
   return leadingNulls(date.tm_hour, 2);
  }),
  "%I": (function(date) {
   return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour - 12, 2);
  }),
  "%j": (function(date) {
   return leadingNulls(date.tm_mday + __arraySum(__isLeapYear(date.tm_year + 1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon - 1), 3);
  }),
  "%m": (function(date) {
   return leadingNulls(date.tm_mon + 1, 2);
  }),
  "%M": (function(date) {
   return leadingNulls(date.tm_min, 2);
  }),
  "%n": (function() {
   return "\n";
  }),
  "%p": (function(date) {
   if (date.tm_hour > 0 && date.tm_hour < 13) {
    return "AM";
   } else {
    return "PM";
   }
  }),
  "%S": (function(date) {
   return leadingNulls(date.tm_sec, 2);
  }),
  "%t": (function() {
   return "\t";
  }),
  "%u": (function(date) {
   var day = new Date(date.tm_year + 1900, date.tm_mon + 1, date.tm_mday, 0, 0, 0, 0);
   return day.getDay() || 7;
  }),
  "%U": (function(date) {
   var janFirst = new Date(date.tm_year + 1900, 0, 1);
   var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7 - janFirst.getDay());
   var endDate = new Date(date.tm_year + 1900, date.tm_mon, date.tm_mday);
   if (compareByDay(firstSunday, endDate) < 0) {
    var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth() - 1) - 31;
    var firstSundayUntilEndJanuary = 31 - firstSunday.getDate();
    var days = firstSundayUntilEndJanuary + februaryFirstUntilEndMonth + endDate.getDate();
    return leadingNulls(Math.ceil(days / 7), 2);
   }
   return compareByDay(firstSunday, janFirst) === 0 ? "01" : "00";
  }),
  "%V": (function(date) {
   var janFourthThisYear = new Date(date.tm_year + 1900, 0, 4);
   var janFourthNextYear = new Date(date.tm_year + 1901, 0, 4);
   var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
   var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
   var endDate = __addDays(new Date(date.tm_year + 1900, 0, 1), date.tm_yday);
   if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
    return "53";
   }
   if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
    return "01";
   }
   var daysDifference;
   if (firstWeekStartThisYear.getFullYear() < date.tm_year + 1900) {
    daysDifference = date.tm_yday + 32 - firstWeekStartThisYear.getDate();
   } else {
    daysDifference = date.tm_yday + 1 - firstWeekStartThisYear.getDate();
   }
   return leadingNulls(Math.ceil(daysDifference / 7), 2);
  }),
  "%w": (function(date) {
   var day = new Date(date.tm_year + 1900, date.tm_mon + 1, date.tm_mday, 0, 0, 0, 0);
   return day.getDay();
  }),
  "%W": (function(date) {
   var janFirst = new Date(date.tm_year, 0, 1);
   var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7 - janFirst.getDay() + 1);
   var endDate = new Date(date.tm_year + 1900, date.tm_mon, date.tm_mday);
   if (compareByDay(firstMonday, endDate) < 0) {
    var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth() - 1) - 31;
    var firstMondayUntilEndJanuary = 31 - firstMonday.getDate();
    var days = firstMondayUntilEndJanuary + februaryFirstUntilEndMonth + endDate.getDate();
    return leadingNulls(Math.ceil(days / 7), 2);
   }
   return compareByDay(firstMonday, janFirst) === 0 ? "01" : "00";
  }),
  "%y": (function(date) {
   return (date.tm_year + 1900).toString().substring(2);
  }),
  "%Y": (function(date) {
   return date.tm_year + 1900;
  }),
  "%z": (function(date) {
   var off = date.tm_gmtoff;
   var ahead = off >= 0;
   off = Math.abs(off) / 60;
   off = off / 60 * 100 + off % 60;
   return (ahead ? "+" : "-") + String("0000" + off).slice(-4);
  }),
  "%Z": (function(date) {
   return date.tm_zone;
  }),
  "%%": (function() {
   return "%";
  })
 };
 for (var rule in EXPANSION_RULES_2) {
  if (pattern.indexOf(rule) >= 0) {
   pattern = pattern.replace(new RegExp(rule, "g"), EXPANSION_RULES_2[rule](date));
  }
 }
 var bytes = intArrayFromString(pattern, false);
 if (bytes.length > maxsize) {
  return 0;
 }
 writeArrayToMemory(bytes, s);
 return bytes.length - 1;
}
function _strftime_l(s, maxsize, format, tm) {
 return _strftime(s, maxsize, format, tm);
}
function _abort() {
 Module["abort"]();
}
function validateThis(this_, classType, humanName) {
 if (!(this_ instanceof Object)) {
  throwBindingError(humanName + ' with invalid "this": ' + this_);
 }
 if (!(this_ instanceof classType.registeredClass.constructor)) {
  throwBindingError(humanName + ' incompatible with "this" of type ' + this_.constructor.name);
 }
 if (!this_.$$.ptr) {
  throwBindingError("cannot call emscripten binding method " + humanName + " on deleted object");
 }
 return upcastPointer(this_.$$.ptr, this_.$$.ptrType.registeredClass, classType.registeredClass);
}
function __embind_register_class_property(classType, fieldName, getterReturnType, getterSignature, getter, getterContext, setterArgumentType, setterSignature, setter, setterContext) {
 fieldName = readLatin1String(fieldName);
 getter = requireFunction(getterSignature, getter);
 whenDependentTypesAreResolved([], [ classType ], (function(classType) {
  classType = classType[0];
  var humanName = classType.name + "." + fieldName;
  var desc = {
   get: (function() {
    throwUnboundTypeError("Cannot access " + humanName + " due to unbound types", [ getterReturnType, setterArgumentType ]);
   }),
   enumerable: true,
   configurable: true
  };
  if (setter) {
   desc.set = (function() {
    throwUnboundTypeError("Cannot access " + humanName + " due to unbound types", [ getterReturnType, setterArgumentType ]);
   });
  } else {
   desc.set = (function(v) {
    throwBindingError(humanName + " is a read-only property");
   });
  }
  Object.defineProperty(classType.registeredClass.instancePrototype, fieldName, desc);
  whenDependentTypesAreResolved([], setter ? [ getterReturnType, setterArgumentType ] : [ getterReturnType ], (function(types) {
   var getterReturnType = types[0];
   var desc = {
    get: (function() {
     var ptr = validateThis(this, classType, humanName + " getter");
     return getterReturnType["fromWireType"](getter(getterContext, ptr));
    }),
    enumerable: true
   };
   if (setter) {
    setter = requireFunction(setterSignature, setter);
    var setterArgumentType = types[1];
    desc.set = (function(v) {
     var ptr = validateThis(this, classType, humanName + " setter");
     var destructors = [];
     setter(setterContext, ptr, setterArgumentType["toWireType"](destructors, v));
     runDestructors(destructors);
    });
   }
   Object.defineProperty(classType.registeredClass.instancePrototype, fieldName, desc);
   return [];
  }));
  return [];
 }));
}
function _pthread_once(ptr, func) {
 if (!_pthread_once.seen) _pthread_once.seen = {};
 if (ptr in _pthread_once.seen) return;
 Runtime.dynCall("v", func);
 _pthread_once.seen[ptr] = 1;
}
function ClassHandle_isAliasOf(other) {
 if (!(this instanceof ClassHandle)) {
  return false;
 }
 if (!(other instanceof ClassHandle)) {
  return false;
 }
 var leftClass = this.$$.ptrType.registeredClass;
 var left = this.$$.ptr;
 var rightClass = other.$$.ptrType.registeredClass;
 var right = other.$$.ptr;
 while (leftClass.baseClass) {
  left = leftClass.upcast(left);
  leftClass = leftClass.baseClass;
 }
 while (rightClass.baseClass) {
  right = rightClass.upcast(right);
  rightClass = rightClass.baseClass;
 }
 return leftClass === rightClass && left === right;
}
function shallowCopyInternalPointer(o) {
 return {
  count: o.count,
  deleteScheduled: o.deleteScheduled,
  preservePointerOnDelete: o.preservePointerOnDelete,
  ptr: o.ptr,
  ptrType: o.ptrType,
  smartPtr: o.smartPtr,
  smartPtrType: o.smartPtrType
 };
}
function throwInstanceAlreadyDeleted(obj) {
 function getInstanceTypeName(handle) {
  return handle.$$.ptrType.registeredClass.name;
 }
 throwBindingError(getInstanceTypeName(obj) + " instance already deleted");
}
function ClassHandle_clone() {
 if (!this.$$.ptr) {
  throwInstanceAlreadyDeleted(this);
 }
 if (this.$$.preservePointerOnDelete) {
  this.$$.count.value += 1;
  return this;
 } else {
  var clone = Object.create(Object.getPrototypeOf(this), {
   $$: {
    value: shallowCopyInternalPointer(this.$$)
   }
  });
  clone.$$.count.value += 1;
  clone.$$.deleteScheduled = false;
  return clone;
 }
}
function runDestructor(handle) {
 var $$ = handle.$$;
 if ($$.smartPtr) {
  $$.smartPtrType.rawDestructor($$.smartPtr);
 } else {
  $$.ptrType.registeredClass.rawDestructor($$.ptr);
 }
}
function ClassHandle_delete() {
 if (!this.$$.ptr) {
  throwInstanceAlreadyDeleted(this);
 }
 if (this.$$.deleteScheduled && !this.$$.preservePointerOnDelete) {
  throwBindingError("Object already scheduled for deletion");
 }
 this.$$.count.value -= 1;
 var toDelete = 0 === this.$$.count.value;
 if (toDelete) {
  runDestructor(this);
 }
 if (!this.$$.preservePointerOnDelete) {
  this.$$.smartPtr = undefined;
  this.$$.ptr = undefined;
 }
}
function ClassHandle_isDeleted() {
 return !this.$$.ptr;
}
function ClassHandle_deleteLater() {
 if (!this.$$.ptr) {
  throwInstanceAlreadyDeleted(this);
 }
 if (this.$$.deleteScheduled && !this.$$.preservePointerOnDelete) {
  throwBindingError("Object already scheduled for deletion");
 }
 deletionQueue.push(this);
 if (deletionQueue.length === 1 && delayFunction) {
  delayFunction(flushPendingDeletes);
 }
 this.$$.deleteScheduled = true;
 return this;
}
function init_ClassHandle() {
 ClassHandle.prototype["isAliasOf"] = ClassHandle_isAliasOf;
 ClassHandle.prototype["clone"] = ClassHandle_clone;
 ClassHandle.prototype["delete"] = ClassHandle_delete;
 ClassHandle.prototype["isDeleted"] = ClassHandle_isDeleted;
 ClassHandle.prototype["deleteLater"] = ClassHandle_deleteLater;
}
function ClassHandle() {}
function exposePublicSymbol(name, value, numArguments) {
 if (Module.hasOwnProperty(name)) {
  if (undefined === numArguments || undefined !== Module[name].overloadTable && undefined !== Module[name].overloadTable[numArguments]) {
   throwBindingError("Cannot register public name '" + name + "' twice");
  }
  ensureOverloadTable(Module, name, name);
  if (Module.hasOwnProperty(numArguments)) {
   throwBindingError("Cannot register multiple overloads of a function with the same number of arguments (" + numArguments + ")!");
  }
  Module[name].overloadTable[numArguments] = value;
 } else {
  Module[name] = value;
  if (undefined !== numArguments) {
   Module[name].numArguments = numArguments;
  }
 }
}
function RegisteredClass(name, constructor, instancePrototype, rawDestructor, baseClass, getActualType, upcast, downcast) {
 this.name = name;
 this.constructor = constructor;
 this.instancePrototype = instancePrototype;
 this.rawDestructor = rawDestructor;
 this.baseClass = baseClass;
 this.getActualType = getActualType;
 this.upcast = upcast;
 this.downcast = downcast;
 this.pureVirtualFunctions = [];
}
function replacePublicSymbol(name, value, numArguments) {
 if (!Module.hasOwnProperty(name)) {
  throwInternalError("Replacing nonexistant public symbol");
 }
 if (undefined !== Module[name].overloadTable && undefined !== numArguments) {
  Module[name].overloadTable[numArguments] = value;
 } else {
  Module[name] = value;
 }
}
function __embind_register_class(rawType, rawPointerType, rawConstPointerType, baseClassRawType, getActualTypeSignature, getActualType, upcastSignature, upcast, downcastSignature, downcast, name, destructorSignature, rawDestructor) {
 name = readLatin1String(name);
 getActualType = requireFunction(getActualTypeSignature, getActualType);
 if (upcast) {
  upcast = requireFunction(upcastSignature, upcast);
 }
 if (downcast) {
  downcast = requireFunction(downcastSignature, downcast);
 }
 rawDestructor = requireFunction(destructorSignature, rawDestructor);
 var legalFunctionName = makeLegalFunctionName(name);
 exposePublicSymbol(legalFunctionName, (function() {
  throwUnboundTypeError("Cannot construct " + name + " due to unbound types", [ baseClassRawType ]);
 }));
 whenDependentTypesAreResolved([ rawType, rawPointerType, rawConstPointerType ], baseClassRawType ? [ baseClassRawType ] : [], (function(base) {
  base = base[0];
  var baseClass;
  var basePrototype;
  if (baseClassRawType) {
   baseClass = base.registeredClass;
   basePrototype = baseClass.instancePrototype;
  } else {
   basePrototype = ClassHandle.prototype;
  }
  var constructor = createNamedFunction(legalFunctionName, (function() {
   if (Object.getPrototypeOf(this) !== instancePrototype) {
    throw new BindingError("Use 'new' to construct " + name);
   }
   if (undefined === registeredClass.constructor_body) {
    throw new BindingError(name + " has no accessible constructor");
   }
   var body = registeredClass.constructor_body[arguments.length];
   if (undefined === body) {
    throw new BindingError("Tried to invoke ctor of " + name + " with invalid number of parameters (" + arguments.length + ") - expected (" + Object.keys(registeredClass.constructor_body).toString() + ") parameters instead!");
   }
   return body.apply(this, arguments);
  }));
  var instancePrototype = Object.create(basePrototype, {
   constructor: {
    value: constructor
   }
  });
  constructor.prototype = instancePrototype;
  var registeredClass = new RegisteredClass(name, constructor, instancePrototype, rawDestructor, baseClass, getActualType, upcast, downcast);
  var referenceConverter = new RegisteredPointer(name, registeredClass, true, false, false);
  var pointerConverter = new RegisteredPointer(name + "*", registeredClass, false, false, false);
  var constPointerConverter = new RegisteredPointer(name + " const*", registeredClass, false, true, false);
  registeredPointers[rawType] = {
   pointerType: pointerConverter,
   constPointerType: constPointerConverter
  };
  replacePublicSymbol(legalFunctionName, constructor);
  return [ referenceConverter, pointerConverter, constPointerConverter ];
 }));
}
function ___lock() {}
function ___unlock() {}
function _pthread_getspecific(key) {
 return PTHREAD_SPECIFIC[key] || 0;
}
var _fabs = Math_abs;
var _floor = Math_floor;
var _sqrt = Math_sqrt;
function _embind_repr(v) {
 if (v === null) {
  return "null";
 }
 var t = typeof v;
 if (t === "object" || t === "array" || t === "function") {
  return v.toString();
 } else {
  return "" + v;
 }
}
function integerReadValueFromPointer(name, shift, signed) {
 switch (shift) {
 case 0:
  return signed ? function readS8FromPointer(pointer) {
   return HEAP8[pointer];
  } : function readU8FromPointer(pointer) {
   return HEAPU8[pointer];
  };
 case 1:
  return signed ? function readS16FromPointer(pointer) {
   return HEAP16[pointer >> 1];
  } : function readU16FromPointer(pointer) {
   return HEAPU16[pointer >> 1];
  };
 case 2:
  return signed ? function readS32FromPointer(pointer) {
   return HEAP32[pointer >> 2];
  } : function readU32FromPointer(pointer) {
   return HEAPU32[pointer >> 2];
  };
 default:
  throw new TypeError("Unknown integer type: " + name);
 }
}
function __embind_register_integer(primitiveType, name, size, minRange, maxRange) {
 name = readLatin1String(name);
 if (maxRange === -1) {
  maxRange = 4294967295;
 }
 var shift = getShiftFromSize(size);
 var fromWireType = (function(value) {
  return value;
 });
 if (minRange === 0) {
  var bitshift = 32 - 8 * size;
  fromWireType = (function(value) {
   return value << bitshift >>> bitshift;
  });
 }
 registerType(primitiveType, {
  name: name,
  "fromWireType": fromWireType,
  "toWireType": (function(destructors, value) {
   if (typeof value !== "number" && typeof value !== "boolean") {
    throw new TypeError('Cannot convert "' + _embind_repr(value) + '" to ' + this.name);
   }
   if (value < minRange || value > maxRange) {
    throw new TypeError('Passing a number "' + _embind_repr(value) + '" from JS side to C/C++ side to an argument of type "' + name + '", which is outside the valid range [' + minRange + ", " + maxRange + "]!");
   }
   return value | 0;
  }),
  "argPackAdvance": 8,
  "readValueFromPointer": integerReadValueFromPointer(name, shift, minRange !== 0),
  destructorFunction: null
 });
}
function _emscripten_set_main_loop_timing(mode, value) {
 Browser.mainLoop.timingMode = mode;
 Browser.mainLoop.timingValue = value;
 if (!Browser.mainLoop.func) {
  return 1;
 }
 if (mode == 0) {
  Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler_setTimeout() {
   setTimeout(Browser.mainLoop.runner, value);
  };
  Browser.mainLoop.method = "timeout";
 } else if (mode == 1) {
  Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler_rAF() {
   Browser.requestAnimationFrame(Browser.mainLoop.runner);
  };
  Browser.mainLoop.method = "rAF";
 } else if (mode == 2) {
  if (!window["setImmediate"]) {
   var setImmediates = [];
   var emscriptenMainLoopMessageId = "__emcc";
   function Browser_setImmediate_messageHandler(event) {
    if (event.source === window && event.data === emscriptenMainLoopMessageId) {
     event.stopPropagation();
     setImmediates.shift()();
    }
   }
   window.addEventListener("message", Browser_setImmediate_messageHandler, true);
   window["setImmediate"] = function Browser_emulated_setImmediate(func) {
    setImmediates.push(func);
    window.postMessage(emscriptenMainLoopMessageId, "*");
   };
  }
  Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler_setImmediate() {
   window["setImmediate"](Browser.mainLoop.runner);
  };
  Browser.mainLoop.method = "immediate";
 }
 return 0;
}
function _emscripten_set_main_loop(func, fps, simulateInfiniteLoop, arg, noSetTiming) {
 Module["noExitRuntime"] = true;
 assert(!Browser.mainLoop.func, "emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");
 Browser.mainLoop.func = func;
 Browser.mainLoop.arg = arg;
 var thisMainLoopId = Browser.mainLoop.currentlyRunningMainloop;
 Browser.mainLoop.runner = function Browser_mainLoop_runner() {
  if (ABORT) return;
  if (Browser.mainLoop.queue.length > 0) {
   var start = Date.now();
   var blocker = Browser.mainLoop.queue.shift();
   blocker.func(blocker.arg);
   if (Browser.mainLoop.remainingBlockers) {
    var remaining = Browser.mainLoop.remainingBlockers;
    var next = remaining % 1 == 0 ? remaining - 1 : Math.floor(remaining);
    if (blocker.counted) {
     Browser.mainLoop.remainingBlockers = next;
    } else {
     next = next + .5;
     Browser.mainLoop.remainingBlockers = (8 * remaining + next) / 9;
    }
   }
   console.log('main loop blocker "' + blocker.name + '" took ' + (Date.now() - start) + " ms");
   Browser.mainLoop.updateStatus();
   setTimeout(Browser.mainLoop.runner, 0);
   return;
  }
  if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop) return;
  Browser.mainLoop.currentFrameNumber = Browser.mainLoop.currentFrameNumber + 1 | 0;
  if (Browser.mainLoop.timingMode == 1 && Browser.mainLoop.timingValue > 1 && Browser.mainLoop.currentFrameNumber % Browser.mainLoop.timingValue != 0) {
   Browser.mainLoop.scheduler();
   return;
  }
  if (Browser.mainLoop.method === "timeout" && Module.ctx) {
   Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");
   Browser.mainLoop.method = "";
  }
  Browser.mainLoop.runIter((function() {
   if (typeof arg !== "undefined") {
    Runtime.dynCall("vi", func, [ arg ]);
   } else {
    Runtime.dynCall("v", func);
   }
  }));
  if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop) return;
  if (typeof SDL === "object" && SDL.audio && SDL.audio.queueNewAudioData) SDL.audio.queueNewAudioData();
  Browser.mainLoop.scheduler();
 };
 if (!noSetTiming) {
  if (fps && fps > 0) _emscripten_set_main_loop_timing(0, 1e3 / fps); else _emscripten_set_main_loop_timing(1, 1);
  Browser.mainLoop.scheduler();
 }
 if (simulateInfiniteLoop) {
  throw "SimulateInfiniteLoop";
 }
}
var Browser = {
 mainLoop: {
  scheduler: null,
  method: "",
  currentlyRunningMainloop: 0,
  func: null,
  arg: 0,
  timingMode: 0,
  timingValue: 0,
  currentFrameNumber: 0,
  queue: [],
  pause: (function() {
   Browser.mainLoop.scheduler = null;
   Browser.mainLoop.currentlyRunningMainloop++;
  }),
  resume: (function() {
   Browser.mainLoop.currentlyRunningMainloop++;
   var timingMode = Browser.mainLoop.timingMode;
   var timingValue = Browser.mainLoop.timingValue;
   var func = Browser.mainLoop.func;
   Browser.mainLoop.func = null;
   _emscripten_set_main_loop(func, 0, false, Browser.mainLoop.arg, true);
   _emscripten_set_main_loop_timing(timingMode, timingValue);
   Browser.mainLoop.scheduler();
  }),
  updateStatus: (function() {
   if (Module["setStatus"]) {
    var message = Module["statusMessage"] || "Please wait...";
    var remaining = Browser.mainLoop.remainingBlockers;
    var expected = Browser.mainLoop.expectedBlockers;
    if (remaining) {
     if (remaining < expected) {
      Module["setStatus"](message + " (" + (expected - remaining) + "/" + expected + ")");
     } else {
      Module["setStatus"](message);
     }
    } else {
     Module["setStatus"]("");
    }
   }
  }),
  runIter: (function(func) {
   if (ABORT) return;
   if (Module["preMainLoop"]) {
    var preRet = Module["preMainLoop"]();
    if (preRet === false) {
     return;
    }
   }
   try {
    func();
   } catch (e) {
    if (e instanceof ExitStatus) {
     return;
    } else {
     if (e && typeof e === "object" && e.stack) Module.printErr("exception thrown: " + [ e, e.stack ]);
     throw e;
    }
   }
   if (Module["postMainLoop"]) Module["postMainLoop"]();
  })
 },
 isFullScreen: false,
 pointerLock: false,
 moduleContextCreatedCallbacks: [],
 workers: [],
 init: (function() {
  if (!Module["preloadPlugins"]) Module["preloadPlugins"] = [];
  if (Browser.initted) return;
  Browser.initted = true;
  try {
   new Blob;
   Browser.hasBlobConstructor = true;
  } catch (e) {
   Browser.hasBlobConstructor = false;
   console.log("warning: no blob constructor, cannot create blobs with mimetypes");
  }
  Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : !Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null;
  Browser.URLObject = typeof window != "undefined" ? window.URL ? window.URL : window.webkitURL : undefined;
  if (!Module.noImageDecoding && typeof Browser.URLObject === "undefined") {
   console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
   Module.noImageDecoding = true;
  }
  var imagePlugin = {};
  imagePlugin["canHandle"] = function imagePlugin_canHandle(name) {
   return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
  };
  imagePlugin["handle"] = function imagePlugin_handle(byteArray, name, onload, onerror) {
   var b = null;
   if (Browser.hasBlobConstructor) {
    try {
     b = new Blob([ byteArray ], {
      type: Browser.getMimetype(name)
     });
     if (b.size !== byteArray.length) {
      b = new Blob([ (new Uint8Array(byteArray)).buffer ], {
       type: Browser.getMimetype(name)
      });
     }
    } catch (e) {
     Runtime.warnOnce("Blob constructor present but fails: " + e + "; falling back to blob builder");
    }
   }
   if (!b) {
    var bb = new Browser.BlobBuilder;
    bb.append((new Uint8Array(byteArray)).buffer);
    b = bb.getBlob();
   }
   var url = Browser.URLObject.createObjectURL(b);
   var img = new Image;
   img.onload = function img_onload() {
    assert(img.complete, "Image " + name + " could not be decoded");
    var canvas = document.createElement("canvas");
    canvas.width = img.width;
    canvas.height = img.height;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, 0, 0);
    Module["preloadedImages"][name] = canvas;
    Browser.URLObject.revokeObjectURL(url);
    if (onload) onload(byteArray);
   };
   img.onerror = function img_onerror(event) {
    console.log("Image " + url + " could not be decoded");
    if (onerror) onerror();
   };
   img.src = url;
  };
  Module["preloadPlugins"].push(imagePlugin);
  var audioPlugin = {};
  audioPlugin["canHandle"] = function audioPlugin_canHandle(name) {
   return !Module.noAudioDecoding && name.substr(-4) in {
    ".ogg": 1,
    ".wav": 1,
    ".mp3": 1
   };
  };
  audioPlugin["handle"] = function audioPlugin_handle(byteArray, name, onload, onerror) {
   var done = false;
   function finish(audio) {
    if (done) return;
    done = true;
    Module["preloadedAudios"][name] = audio;
    if (onload) onload(byteArray);
   }
   function fail() {
    if (done) return;
    done = true;
    Module["preloadedAudios"][name] = new Audio;
    if (onerror) onerror();
   }
   if (Browser.hasBlobConstructor) {
    try {
     var b = new Blob([ byteArray ], {
      type: Browser.getMimetype(name)
     });
    } catch (e) {
     return fail();
    }
    var url = Browser.URLObject.createObjectURL(b);
    var audio = new Audio;
    audio.addEventListener("canplaythrough", (function() {
     finish(audio);
    }), false);
    audio.onerror = function audio_onerror(event) {
     if (done) return;
     console.log("warning: browser could not fully decode audio " + name + ", trying slower base64 approach");
     function encode64(data) {
      var BASE = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
      var PAD = "=";
      var ret = "";
      var leftchar = 0;
      var leftbits = 0;
      for (var i = 0; i < data.length; i++) {
       leftchar = leftchar << 8 | data[i];
       leftbits += 8;
       while (leftbits >= 6) {
        var curr = leftchar >> leftbits - 6 & 63;
        leftbits -= 6;
        ret += BASE[curr];
       }
      }
      if (leftbits == 2) {
       ret += BASE[(leftchar & 3) << 4];
       ret += PAD + PAD;
      } else if (leftbits == 4) {
       ret += BASE[(leftchar & 15) << 2];
       ret += PAD;
      }
      return ret;
     }
     audio.src = "data:audio/x-" + name.substr(-3) + ";base64," + encode64(byteArray);
     finish(audio);
    };
    audio.src = url;
    Browser.safeSetTimeout((function() {
     finish(audio);
    }), 1e4);
   } else {
    return fail();
   }
  };
  Module["preloadPlugins"].push(audioPlugin);
  var canvas = Module["canvas"];
  function pointerLockChange() {
   Browser.pointerLock = document["pointerLockElement"] === canvas || document["mozPointerLockElement"] === canvas || document["webkitPointerLockElement"] === canvas || document["msPointerLockElement"] === canvas;
  }
  if (canvas) {
   canvas.requestPointerLock = canvas["requestPointerLock"] || canvas["mozRequestPointerLock"] || canvas["webkitRequestPointerLock"] || canvas["msRequestPointerLock"] || (function() {});
   canvas.exitPointerLock = document["exitPointerLock"] || document["mozExitPointerLock"] || document["webkitExitPointerLock"] || document["msExitPointerLock"] || (function() {});
   canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
   document.addEventListener("pointerlockchange", pointerLockChange, false);
   document.addEventListener("mozpointerlockchange", pointerLockChange, false);
   document.addEventListener("webkitpointerlockchange", pointerLockChange, false);
   document.addEventListener("mspointerlockchange", pointerLockChange, false);
   if (Module["elementPointerLock"]) {
    canvas.addEventListener("click", (function(ev) {
     if (!Browser.pointerLock && canvas.requestPointerLock) {
      canvas.requestPointerLock();
      ev.preventDefault();
     }
    }), false);
   }
  }
 }),
 createContext: (function(canvas, useWebGL, setInModule, webGLContextAttributes) {
  if (useWebGL && Module.ctx && canvas == Module.canvas) return Module.ctx;
  var ctx;
  var contextHandle;
  if (useWebGL) {
   var contextAttributes = {
    antialias: false,
    alpha: false
   };
   if (webGLContextAttributes) {
    for (var attribute in webGLContextAttributes) {
     contextAttributes[attribute] = webGLContextAttributes[attribute];
    }
   }
   contextHandle = GL.createContext(canvas, contextAttributes);
   if (contextHandle) {
    ctx = GL.getContext(contextHandle).GLctx;
   }
   canvas.style.backgroundColor = "black";
  } else {
   ctx = canvas.getContext("2d");
  }
  if (!ctx) return null;
  if (setInModule) {
   if (!useWebGL) assert(typeof GLctx === "undefined", "cannot set in module if GLctx is used, but we are a non-GL context that would replace it");
   Module.ctx = ctx;
   if (useWebGL) GL.makeContextCurrent(contextHandle);
   Module.useWebGL = useWebGL;
   Browser.moduleContextCreatedCallbacks.forEach((function(callback) {
    callback();
   }));
   Browser.init();
  }
  return ctx;
 }),
 destroyContext: (function(canvas, useWebGL, setInModule) {}),
 fullScreenHandlersInstalled: false,
 lockPointer: undefined,
 resizeCanvas: undefined,
 requestFullScreen: (function(lockPointer, resizeCanvas, vrDevice) {
  Browser.lockPointer = lockPointer;
  Browser.resizeCanvas = resizeCanvas;
  Browser.vrDevice = vrDevice;
  if (typeof Browser.lockPointer === "undefined") Browser.lockPointer = true;
  if (typeof Browser.resizeCanvas === "undefined") Browser.resizeCanvas = false;
  if (typeof Browser.vrDevice === "undefined") Browser.vrDevice = null;
  var canvas = Module["canvas"];
  function fullScreenChange() {
   Browser.isFullScreen = false;
   var canvasContainer = canvas.parentNode;
   if ((document["webkitFullScreenElement"] || document["webkitFullscreenElement"] || document["mozFullScreenElement"] || document["mozFullscreenElement"] || document["fullScreenElement"] || document["fullscreenElement"] || document["msFullScreenElement"] || document["msFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvasContainer) {
    canvas.cancelFullScreen = document["cancelFullScreen"] || document["mozCancelFullScreen"] || document["webkitCancelFullScreen"] || document["msExitFullscreen"] || document["exitFullscreen"] || (function() {});
    canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
    if (Browser.lockPointer) canvas.requestPointerLock();
    Browser.isFullScreen = true;
    if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
   } else {
    canvasContainer.parentNode.insertBefore(canvas, canvasContainer);
    canvasContainer.parentNode.removeChild(canvasContainer);
    if (Browser.resizeCanvas) Browser.setWindowedCanvasSize();
   }
   if (Module["onFullScreen"]) Module["onFullScreen"](Browser.isFullScreen);
   Browser.updateCanvasDimensions(canvas);
  }
  if (!Browser.fullScreenHandlersInstalled) {
   Browser.fullScreenHandlersInstalled = true;
   document.addEventListener("fullscreenchange", fullScreenChange, false);
   document.addEventListener("mozfullscreenchange", fullScreenChange, false);
   document.addEventListener("webkitfullscreenchange", fullScreenChange, false);
   document.addEventListener("MSFullscreenChange", fullScreenChange, false);
  }
  var canvasContainer = document.createElement("div");
  canvas.parentNode.insertBefore(canvasContainer, canvas);
  canvasContainer.appendChild(canvas);
  canvasContainer.requestFullScreen = canvasContainer["requestFullScreen"] || canvasContainer["mozRequestFullScreen"] || canvasContainer["msRequestFullscreen"] || (canvasContainer["webkitRequestFullScreen"] ? (function() {
   canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"]);
  }) : null);
  if (vrDevice) {
   canvasContainer.requestFullScreen({
    vrDisplay: vrDevice
   });
  } else {
   canvasContainer.requestFullScreen();
  }
 }),
 nextRAF: 0,
 fakeRequestAnimationFrame: (function(func) {
  var now = Date.now();
  if (Browser.nextRAF === 0) {
   Browser.nextRAF = now + 1e3 / 60;
  } else {
   while (now + 2 >= Browser.nextRAF) {
    Browser.nextRAF += 1e3 / 60;
   }
  }
  var delay = Math.max(Browser.nextRAF - now, 0);
  setTimeout(func, delay);
 }),
 requestAnimationFrame: function requestAnimationFrame(func) {
  if (typeof window === "undefined") {
   Browser.fakeRequestAnimationFrame(func);
  } else {
   if (!window.requestAnimationFrame) {
    window.requestAnimationFrame = window["requestAnimationFrame"] || window["mozRequestAnimationFrame"] || window["webkitRequestAnimationFrame"] || window["msRequestAnimationFrame"] || window["oRequestAnimationFrame"] || Browser.fakeRequestAnimationFrame;
   }
   window.requestAnimationFrame(func);
  }
 },
 safeCallback: (function(func) {
  return (function() {
   if (!ABORT) return func.apply(null, arguments);
  });
 }),
 allowAsyncCallbacks: true,
 queuedAsyncCallbacks: [],
 pauseAsyncCallbacks: (function() {
  Browser.allowAsyncCallbacks = false;
 }),
 resumeAsyncCallbacks: (function() {
  Browser.allowAsyncCallbacks = true;
  if (Browser.queuedAsyncCallbacks.length > 0) {
   var callbacks = Browser.queuedAsyncCallbacks;
   Browser.queuedAsyncCallbacks = [];
   callbacks.forEach((function(func) {
    func();
   }));
  }
 }),
 safeRequestAnimationFrame: (function(func) {
  return Browser.requestAnimationFrame((function() {
   if (ABORT) return;
   if (Browser.allowAsyncCallbacks) {
    func();
   } else {
    Browser.queuedAsyncCallbacks.push(func);
   }
  }));
 }),
 safeSetTimeout: (function(func, timeout) {
  Module["noExitRuntime"] = true;
  return setTimeout((function() {
   if (ABORT) return;
   if (Browser.allowAsyncCallbacks) {
    func();
   } else {
    Browser.queuedAsyncCallbacks.push(func);
   }
  }), timeout);
 }),
 safeSetInterval: (function(func, timeout) {
  Module["noExitRuntime"] = true;
  return setInterval((function() {
   if (ABORT) return;
   if (Browser.allowAsyncCallbacks) {
    func();
   }
  }), timeout);
 }),
 getMimetype: (function(name) {
  return {
   "jpg": "image/jpeg",
   "jpeg": "image/jpeg",
   "png": "image/png",
   "bmp": "image/bmp",
   "ogg": "audio/ogg",
   "wav": "audio/wav",
   "mp3": "audio/mpeg"
  }[name.substr(name.lastIndexOf(".") + 1)];
 }),
 getUserMedia: (function(func) {
  if (!window.getUserMedia) {
   window.getUserMedia = navigator["getUserMedia"] || navigator["mozGetUserMedia"];
  }
  window.getUserMedia(func);
 }),
 getMovementX: (function(event) {
  return event["movementX"] || event["mozMovementX"] || event["webkitMovementX"] || 0;
 }),
 getMovementY: (function(event) {
  return event["movementY"] || event["mozMovementY"] || event["webkitMovementY"] || 0;
 }),
 getMouseWheelDelta: (function(event) {
  var delta = 0;
  switch (event.type) {
  case "DOMMouseScroll":
   delta = event.detail;
   break;
  case "mousewheel":
   delta = event.wheelDelta;
   break;
  case "wheel":
   delta = event["deltaY"];
   break;
  default:
   throw "unrecognized mouse wheel event: " + event.type;
  }
  return delta;
 }),
 mouseX: 0,
 mouseY: 0,
 mouseMovementX: 0,
 mouseMovementY: 0,
 touches: {},
 lastTouches: {},
 calculateMouseEvent: (function(event) {
  if (Browser.pointerLock) {
   if (event.type != "mousemove" && "mozMovementX" in event) {
    Browser.mouseMovementX = Browser.mouseMovementY = 0;
   } else {
    Browser.mouseMovementX = Browser.getMovementX(event);
    Browser.mouseMovementY = Browser.getMovementY(event);
   }
   if (typeof SDL != "undefined") {
    Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
    Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
   } else {
    Browser.mouseX += Browser.mouseMovementX;
    Browser.mouseY += Browser.mouseMovementY;
   }
  } else {
   var rect = Module["canvas"].getBoundingClientRect();
   var cw = Module["canvas"].width;
   var ch = Module["canvas"].height;
   var scrollX = typeof window.scrollX !== "undefined" ? window.scrollX : window.pageXOffset;
   var scrollY = typeof window.scrollY !== "undefined" ? window.scrollY : window.pageYOffset;
   if (event.type === "touchstart" || event.type === "touchend" || event.type === "touchmove") {
    var touch = event.touch;
    if (touch === undefined) {
     return;
    }
    var adjustedX = touch.pageX - (scrollX + rect.left);
    var adjustedY = touch.pageY - (scrollY + rect.top);
    adjustedX = adjustedX * (cw / rect.width);
    adjustedY = adjustedY * (ch / rect.height);
    var coords = {
     x: adjustedX,
     y: adjustedY
    };
    if (event.type === "touchstart") {
     Browser.lastTouches[touch.identifier] = coords;
     Browser.touches[touch.identifier] = coords;
    } else if (event.type === "touchend" || event.type === "touchmove") {
     var last = Browser.touches[touch.identifier];
     if (!last) last = coords;
     Browser.lastTouches[touch.identifier] = last;
     Browser.touches[touch.identifier] = coords;
    }
    return;
   }
   var x = event.pageX - (scrollX + rect.left);
   var y = event.pageY - (scrollY + rect.top);
   x = x * (cw / rect.width);
   y = y * (ch / rect.height);
   Browser.mouseMovementX = x - Browser.mouseX;
   Browser.mouseMovementY = y - Browser.mouseY;
   Browser.mouseX = x;
   Browser.mouseY = y;
  }
 }),
 xhrLoad: (function(url, onload, onerror) {
  var xhr = new XMLHttpRequest;
  xhr.open("GET", url, true);
  xhr.responseType = "arraybuffer";
  xhr.onload = function xhr_onload() {
   if (xhr.status == 200 || xhr.status == 0 && xhr.response) {
    onload(xhr.response);
   } else {
    onerror();
   }
  };
  xhr.onerror = onerror;
  xhr.send(null);
 }),
 asyncLoad: (function(url, onload, onerror, noRunDep) {
  Browser.xhrLoad(url, (function(arrayBuffer) {
   assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
   onload(new Uint8Array(arrayBuffer));
   if (!noRunDep) removeRunDependency("al " + url);
  }), (function(event) {
   if (onerror) {
    onerror();
   } else {
    throw 'Loading data file "' + url + '" failed.';
   }
  }));
  if (!noRunDep) addRunDependency("al " + url);
 }),
 resizeListeners: [],
 updateResizeListeners: (function() {
  var canvas = Module["canvas"];
  Browser.resizeListeners.forEach((function(listener) {
   listener(canvas.width, canvas.height);
  }));
 }),
 setCanvasSize: (function(width, height, noUpdates) {
  var canvas = Module["canvas"];
  Browser.updateCanvasDimensions(canvas, width, height);
  if (!noUpdates) Browser.updateResizeListeners();
 }),
 windowedWidth: 0,
 windowedHeight: 0,
 setFullScreenCanvasSize: (function() {
  if (typeof SDL != "undefined") {
   var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
   flags = flags | 8388608;
   HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags;
  }
  Browser.updateResizeListeners();
 }),
 setWindowedCanvasSize: (function() {
  if (typeof SDL != "undefined") {
   var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
   flags = flags & ~8388608;
   HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags;
  }
  Browser.updateResizeListeners();
 }),
 updateCanvasDimensions: (function(canvas, wNative, hNative) {
  if (wNative && hNative) {
   canvas.widthNative = wNative;
   canvas.heightNative = hNative;
  } else {
   wNative = canvas.widthNative;
   hNative = canvas.heightNative;
  }
  var w = wNative;
  var h = hNative;
  if (Module["forcedAspectRatio"] && Module["forcedAspectRatio"] > 0) {
   if (w / h < Module["forcedAspectRatio"]) {
    w = Math.round(h * Module["forcedAspectRatio"]);
   } else {
    h = Math.round(w / Module["forcedAspectRatio"]);
   }
  }
  if ((document["webkitFullScreenElement"] || document["webkitFullscreenElement"] || document["mozFullScreenElement"] || document["mozFullscreenElement"] || document["fullScreenElement"] || document["fullscreenElement"] || document["msFullScreenElement"] || document["msFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvas.parentNode && typeof screen != "undefined") {
   var factor = Math.min(screen.width / w, screen.height / h);
   w = Math.round(w * factor);
   h = Math.round(h * factor);
  }
  if (Browser.resizeCanvas) {
   if (canvas.width != w) canvas.width = w;
   if (canvas.height != h) canvas.height = h;
   if (typeof canvas.style != "undefined") {
    canvas.style.removeProperty("width");
    canvas.style.removeProperty("height");
   }
  } else {
   if (canvas.width != wNative) canvas.width = wNative;
   if (canvas.height != hNative) canvas.height = hNative;
   if (typeof canvas.style != "undefined") {
    if (w != wNative || h != hNative) {
     canvas.style.setProperty("width", w + "px", "important");
     canvas.style.setProperty("height", h + "px", "important");
    } else {
     canvas.style.removeProperty("width");
     canvas.style.removeProperty("height");
    }
   }
  }
 }),
 wgetRequests: {},
 nextWgetRequestHandle: 0,
 getNextWgetRequestHandle: (function() {
  var handle = Browser.nextWgetRequestHandle;
  Browser.nextWgetRequestHandle++;
  return handle;
 })
};
function _pthread_setspecific(key, value) {
 if (!(key in PTHREAD_SPECIFIC)) {
  return ERRNO_CODES.EINVAL;
 }
 PTHREAD_SPECIFIC[key] = value;
 return 0;
}
function ___cxa_allocate_exception(size) {
 return _malloc(size);
}
var _sin = Math_sin;
Module["_i64Add"] = _i64Add;
var _atan = Math_atan;
function floatReadValueFromPointer(name, shift) {
 switch (shift) {
 case 2:
  return (function(pointer) {
   return this["fromWireType"](HEAPF32[pointer >> 2]);
  });
 case 3:
  return (function(pointer) {
   return this["fromWireType"](HEAPF64[pointer >> 3]);
  });
 default:
  throw new TypeError("Unknown float type: " + name);
 }
}
function __embind_register_float(rawType, name, size) {
 var shift = getShiftFromSize(size);
 name = readLatin1String(name);
 registerType(rawType, {
  name: name,
  "fromWireType": (function(value) {
   return value;
  }),
  "toWireType": (function(destructors, value) {
   if (typeof value !== "number" && typeof value !== "boolean") {
    throw new TypeError('Cannot convert "' + _embind_repr(value) + '" to ' + this.name);
   }
   return value;
  }),
  "argPackAdvance": 8,
  "readValueFromPointer": floatReadValueFromPointer(name, shift),
  destructorFunction: null
 });
}
function __embind_register_class_function(rawClassType, methodName, argCount, rawArgTypesAddr, invokerSignature, rawInvoker, context, isPureVirtual) {
 var rawArgTypes = heap32VectorToArray(argCount, rawArgTypesAddr);
 methodName = readLatin1String(methodName);
 rawInvoker = requireFunction(invokerSignature, rawInvoker);
 whenDependentTypesAreResolved([], [ rawClassType ], (function(classType) {
  classType = classType[0];
  var humanName = classType.name + "." + methodName;
  if (isPureVirtual) {
   classType.registeredClass.pureVirtualFunctions.push(methodName);
  }
  function unboundTypesHandler() {
   throwUnboundTypeError("Cannot call " + humanName + " due to unbound types", rawArgTypes);
  }
  var proto = classType.registeredClass.instancePrototype;
  var method = proto[methodName];
  if (undefined === method || undefined === method.overloadTable && method.className !== classType.name && method.argCount === argCount - 2) {
   unboundTypesHandler.argCount = argCount - 2;
   unboundTypesHandler.className = classType.name;
   proto[methodName] = unboundTypesHandler;
  } else {
   ensureOverloadTable(proto, methodName, humanName);
   proto[methodName].overloadTable[argCount - 2] = unboundTypesHandler;
  }
  whenDependentTypesAreResolved([], rawArgTypes, (function(argTypes) {
   var memberFunction = craftInvokerFunction(humanName, argTypes, classType, rawInvoker, context);
   if (undefined === proto[methodName].overloadTable) {
    proto[methodName] = memberFunction;
   } else {
    proto[methodName].overloadTable[argCount - 2] = memberFunction;
   }
   return [];
  }));
  return [];
 }));
}
function ___cxa_guard_acquire(variable) {
 if (!HEAP8[variable >> 0]) {
  HEAP8[variable >> 0] = 1;
  return 1;
 }
 return 0;
}
function ___cxa_begin_catch(ptr) {
 __ZSt18uncaught_exceptionv.uncaught_exception--;
 EXCEPTIONS.caught.push(ptr);
 EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));
 return ptr;
}
function ___syscall6(which, varargs) {
 SYSCALLS.varargs = varargs;
 try {
  var stream = SYSCALLS.getStreamFromFD();
  FS.close(stream);
  return 0;
 } catch (e) {
  if (typeof FS === "undefined" || !(e instanceof FS.ErrnoError)) abort(e);
  return -e.errno;
 }
}
var _cos = Math_cos;
function __embind_register_class_constructor(rawClassType, argCount, rawArgTypesAddr, invokerSignature, invoker, rawConstructor) {
 var rawArgTypes = heap32VectorToArray(argCount, rawArgTypesAddr);
 invoker = requireFunction(invokerSignature, invoker);
 whenDependentTypesAreResolved([], [ rawClassType ], (function(classType) {
  classType = classType[0];
  var humanName = "constructor " + classType.name;
  if (undefined === classType.registeredClass.constructor_body) {
   classType.registeredClass.constructor_body = [];
  }
  if (undefined !== classType.registeredClass.constructor_body[argCount - 1]) {
   throw new BindingError("Cannot register multiple constructors with identical number of parameters (" + (argCount - 1) + ") for class '" + classType.name + "'! Overload resolution is currently only performed using the parameter count, not actual type info!");
  }
  classType.registeredClass.constructor_body[argCount - 1] = function unboundTypeHandler() {
   throwUnboundTypeError("Cannot construct " + classType.name + " due to unbound types", rawArgTypes);
  };
  whenDependentTypesAreResolved([], rawArgTypes, (function(argTypes) {
   classType.registeredClass.constructor_body[argCount - 1] = function constructor_body() {
    if (arguments.length !== argCount - 1) {
     throwBindingError(humanName + " called with " + arguments.length + " arguments, expected " + (argCount - 1));
    }
    var destructors = [];
    var args = new Array(argCount);
    args[0] = rawConstructor;
    for (var i = 1; i < argCount; ++i) {
     args[i] = argTypes[i]["toWireType"](destructors, arguments[i - 1]);
    }
    var ptr = invoker.apply(null, args);
    runDestructors(destructors);
    return argTypes[0]["fromWireType"](ptr);
   };
   return [];
  }));
  return [];
 }));
}
function _time(ptr) {
 var ret = Date.now() / 1e3 | 0;
 if (ptr) {
  HEAP32[ptr >> 2] = ret;
 }
 return ret;
}
function _pthread_self() {
 return 0;
}
function ___syscall140(which, varargs) {
 SYSCALLS.varargs = varargs;
 try {
  var stream = SYSCALLS.getStreamFromFD(), offset_high = SYSCALLS.get(), offset_low = SYSCALLS.get(), result = SYSCALLS.get(), whence = SYSCALLS.get();
  var offset = offset_low;
  assert(offset_high === 0);
  FS.llseek(stream, offset, whence);
  HEAP32[result >> 2] = stream.position;
  if (stream.getdents && offset === 0 && whence === 0) stream.getdents = null;
  return 0;
 } catch (e) {
  if (typeof FS === "undefined" || !(e instanceof FS.ErrnoError)) abort(e);
  return -e.errno;
 }
}
function __emval_incref(handle) {
 if (handle > 4) {
  emval_handle_array[handle].refcount += 1;
 }
}
function ___syscall146(which, varargs) {
 SYSCALLS.varargs = varargs;
 try {
  var stream = SYSCALLS.getStreamFromFD(), iov = SYSCALLS.get(), iovcnt = SYSCALLS.get();
  return SYSCALLS.doWritev(stream, iov, iovcnt);
 } catch (e) {
  if (typeof FS === "undefined" || !(e instanceof FS.ErrnoError)) abort(e);
  return -e.errno;
 }
}
function ___syscall145(which, varargs) {
 SYSCALLS.varargs = varargs;
 try {
  var stream = SYSCALLS.getStreamFromFD(), iov = SYSCALLS.get(), iovcnt = SYSCALLS.get();
  return SYSCALLS.doReadv(stream, iov, iovcnt);
 } catch (e) {
  if (typeof FS === "undefined" || !(e instanceof FS.ErrnoError)) abort(e);
  return -e.errno;
 }
}
var ___dso_handle = allocate(1, "i32*", ALLOC_STATIC);
embind_init_charCodes();
BindingError = Module["BindingError"] = extendError(Error, "BindingError");
init_emval();
InternalError = Module["InternalError"] = extendError(Error, "InternalError");
FS.staticInit();
__ATINIT__.unshift((function() {
 if (!Module["noFSInit"] && !FS.init.initialized) FS.init();
}));
__ATMAIN__.push((function() {
 FS.ignorePermissions = false;
}));
__ATEXIT__.push((function() {
 FS.quit();
}));
Module["FS_createFolder"] = FS.createFolder;
Module["FS_createPath"] = FS.createPath;
Module["FS_createDataFile"] = FS.createDataFile;
Module["FS_createPreloadedFile"] = FS.createPreloadedFile;
Module["FS_createLazyFile"] = FS.createLazyFile;
Module["FS_createLink"] = FS.createLink;
Module["FS_createDevice"] = FS.createDevice;
Module["FS_unlink"] = FS.unlink;
__ATINIT__.unshift((function() {
 TTY.init();
}));
__ATEXIT__.push((function() {
 TTY.shutdown();
}));
if (ENVIRONMENT_IS_NODE) {
 var fs = require("fs");
 var NODEJS_PATH = require("path");
 NODEFS.staticInit();
}
init_RegisteredPointer();
init_embind();
UnboundTypeError = Module["UnboundTypeError"] = extendError(Error, "UnboundTypeError");
init_ClassHandle();
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas, vrDevice) {
 Browser.requestFullScreen(lockPointer, resizeCanvas, vrDevice);
};
Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) {
 Browser.requestAnimationFrame(func);
};
Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) {
 Browser.setCanvasSize(width, height, noUpdates);
};
Module["pauseMainLoop"] = function Module_pauseMainLoop() {
 Browser.mainLoop.pause();
};
Module["resumeMainLoop"] = function Module_resumeMainLoop() {
 Browser.mainLoop.resume();
};
Module["getUserMedia"] = function Module_getUserMedia() {
 Browser.getUserMedia();
};
Module["createContext"] = function Module_createContext(canvas, useWebGL, setInModule, webGLContextAttributes) {
 return Browser.createContext(canvas, useWebGL, setInModule, webGLContextAttributes);
};
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);
staticSealed = true;
STACK_MAX = STACK_BASE + TOTAL_STACK;
DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);
assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");
var cttz_i8 = allocate([ 8, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 7, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0 ], "i8", ALLOC_DYNAMIC);
function invoke_iiiiiiii(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  return Module["dynCall_iiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diddidd(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_diddidd"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vid(index, a1, a2) {
 try {
  Module["dynCall_vid"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diididi(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_diididi"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vi(index, a1) {
 try {
  Module["dynCall_vi"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vii(index, a1, a2) {
 try {
  Module["dynCall_vii"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiii(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_iiiiiii"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diididdd(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  return Module["dynCall_diididdd"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diddd(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_diddd"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_ii(index, a1) {
 try {
  return Module["dynCall_ii"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vididdd(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_vididdd"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vidid(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_vidid"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiid(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_iiiiiid"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viidd(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viidd"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_didddddii(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  return Module["dynCall_didddddii"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiii(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viiiii"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vididd(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_vididd"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiii(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_iiiiii"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10) {
 try {
  Module["dynCall_viiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_i(index) {
 try {
  return Module["dynCall_i"](index);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diddddd(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_diddddd"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vidd(index, a1, a2, a3) {
 try {
  Module["dynCall_vidd"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiii(index, a1, a2, a3) {
 try {
  return Module["dynCall_iiii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diiddidd(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  return Module["dynCall_diiddidd"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_dddddd(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_dddddd"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiii(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_viiiiii"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diiii(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_diiii"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viii(index, a1, a2, a3) {
 try {
  Module["dynCall_viii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_di(index, a1) {
 try {
  return Module["dynCall_di"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diiddd(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_diiddd"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viid(index, a1, a2, a3) {
 try {
  Module["dynCall_viid"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diid(index, a1, a2, a3) {
 try {
  return Module["dynCall_diid"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diidid(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_diidid"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiii(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  Module["dynCall_viiiiiii"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11) {
 try {
  return Module["dynCall_iiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_didid(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_didid"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viididdd(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  Module["dynCall_viididdd"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iii(index, a1, a2) {
 try {
  return Module["dynCall_iii"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diiddddd(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  return Module["dynCall_diiddddd"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diii(index, a1, a2, a3) {
 try {
  return Module["dynCall_diii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diidddii(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  return Module["dynCall_diidddii"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_didd(index, a1, a2, a3) {
 try {
  return Module["dynCall_didd"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diidddddii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
 try {
  return Module["dynCall_diidddddii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diidd(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_diidd"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_dii(index, a1, a2) {
 try {
  return Module["dynCall_dii"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_did(index, a1, a2) {
 try {
  return Module["dynCall_did"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15) {
 try {
  Module["dynCall_viiiiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiid(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_iiiiid"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiii(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_iiiii"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_dididdd(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_dididdd"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiid(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viiid"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viidid(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viidid"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_didddii(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_didddii"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_v(index) {
 try {
  Module["dynCall_v"](index);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  return Module["dynCall_iiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viididd(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_viididd"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_dididi(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_dididi"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiid(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_iiiid"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiii(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viiii"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
Module.asmGlobalArg = {
 "Math": Math,
 "Int8Array": Int8Array,
 "Int16Array": Int16Array,
 "Int32Array": Int32Array,
 "Uint8Array": Uint8Array,
 "Uint16Array": Uint16Array,
 "Uint32Array": Uint32Array,
 "Float32Array": Float32Array,
 "Float64Array": Float64Array,
 "NaN": NaN,
 "Infinity": Infinity,
 "byteLength": byteLength
};
Module.asmLibraryArg = {
 "abort": abort,
 "assert": assert,
 "invoke_iiiiiiii": invoke_iiiiiiii,
 "invoke_diddidd": invoke_diddidd,
 "invoke_vid": invoke_vid,
 "invoke_diididi": invoke_diididi,
 "invoke_vi": invoke_vi,
 "invoke_vii": invoke_vii,
 "invoke_iiiiiii": invoke_iiiiiii,
 "invoke_diididdd": invoke_diididdd,
 "invoke_diddd": invoke_diddd,
 "invoke_ii": invoke_ii,
 "invoke_vididdd": invoke_vididdd,
 "invoke_vidid": invoke_vidid,
 "invoke_iiiiiid": invoke_iiiiiid,
 "invoke_viidd": invoke_viidd,
 "invoke_didddddii": invoke_didddddii,
 "invoke_viiiii": invoke_viiiii,
 "invoke_vididd": invoke_vididd,
 "invoke_iiiiii": invoke_iiiiii,
 "invoke_viiiiiiiiii": invoke_viiiiiiiiii,
 "invoke_i": invoke_i,
 "invoke_diddddd": invoke_diddddd,
 "invoke_vidd": invoke_vidd,
 "invoke_iiii": invoke_iiii,
 "invoke_diiddidd": invoke_diiddidd,
 "invoke_dddddd": invoke_dddddd,
 "invoke_viiiiii": invoke_viiiiii,
 "invoke_diiii": invoke_diiii,
 "invoke_viii": invoke_viii,
 "invoke_di": invoke_di,
 "invoke_diiddd": invoke_diiddd,
 "invoke_viid": invoke_viid,
 "invoke_diid": invoke_diid,
 "invoke_diidid": invoke_diidid,
 "invoke_viiiiiii": invoke_viiiiiii,
 "invoke_iiiiiiiiiiii": invoke_iiiiiiiiiiii,
 "invoke_didid": invoke_didid,
 "invoke_viididdd": invoke_viididdd,
 "invoke_iii": invoke_iii,
 "invoke_diiddddd": invoke_diiddddd,
 "invoke_diii": invoke_diii,
 "invoke_diidddii": invoke_diidddii,
 "invoke_didd": invoke_didd,
 "invoke_diidddddii": invoke_diidddddii,
 "invoke_diidd": invoke_diidd,
 "invoke_dii": invoke_dii,
 "invoke_did": invoke_did,
 "invoke_viiiiiiiiiiiiiii": invoke_viiiiiiiiiiiiiii,
 "invoke_iiiiid": invoke_iiiiid,
 "invoke_iiiii": invoke_iiiii,
 "invoke_dididdd": invoke_dididdd,
 "invoke_viiid": invoke_viiid,
 "invoke_viidid": invoke_viidid,
 "invoke_didddii": invoke_didddii,
 "invoke_v": invoke_v,
 "invoke_iiiiiiiii": invoke_iiiiiiiii,
 "invoke_viididd": invoke_viididd,
 "invoke_dididi": invoke_dididi,
 "invoke_iiiid": invoke_iiiid,
 "invoke_viiii": invoke_viiii,
 "_fabs": _fabs,
 "floatReadValueFromPointer": floatReadValueFromPointer,
 "simpleReadValueFromPointer": simpleReadValueFromPointer,
 "_pthread_key_create": _pthread_key_create,
 "throwInternalError": throwInternalError,
 "get_first_emval": get_first_emval,
 "___cxa_guard_acquire": ___cxa_guard_acquire,
 "getLiveInheritedInstances": getLiveInheritedInstances,
 "___assert_fail": ___assert_fail,
 "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv,
 "ClassHandle": ClassHandle,
 "getShiftFromSize": getShiftFromSize,
 "_atan": _atan,
 "__addDays": __addDays,
 "_emscripten_set_main_loop_timing": _emscripten_set_main_loop_timing,
 "_sbrk": _sbrk,
 "___cxa_begin_catch": ___cxa_begin_catch,
 "_emscripten_memcpy_big": _emscripten_memcpy_big,
 "runDestructor": runDestructor,
 "_sysconf": _sysconf,
 "throwInstanceAlreadyDeleted": throwInstanceAlreadyDeleted,
 "RegisteredPointer_fromWireType": RegisteredPointer_fromWireType,
 "init_RegisteredPointer": init_RegisteredPointer,
 "___lock": ___lock,
 "_cos": _cos,
 "ClassHandle_isAliasOf": ClassHandle_isAliasOf,
 "flushPendingDeletes": flushPendingDeletes,
 "makeClassHandle": makeClassHandle,
 "whenDependentTypesAreResolved": whenDependentTypesAreResolved,
 "__isLeapYear": __isLeapYear,
 "__embind_register_class_constructor": __embind_register_class_constructor,
 "___cxa_atexit": ___cxa_atexit,
 "___cxa_rethrow": ___cxa_rethrow,
 "init_ClassHandle": init_ClassHandle,
 "_pthread_cleanup_push": _pthread_cleanup_push,
 "___syscall140": ___syscall140,
 "ClassHandle_clone": ClassHandle_clone,
 "___syscall145": ___syscall145,
 "___syscall146": ___syscall146,
 "_pthread_cleanup_pop": _pthread_cleanup_pop,
 "throwBindingError": throwBindingError,
 "RegisteredClass": RegisteredClass,
 "___cxa_free_exception": ___cxa_free_exception,
 "___cxa_find_matching_catch": ___cxa_find_matching_catch,
 "__embind_register_emval": __embind_register_emval,
 "___setErrNo": ___setErrNo,
 "__embind_register_class_class_function": __embind_register_class_class_function,
 "__embind_register_bool": __embind_register_bool,
 "___resumeException": ___resumeException,
 "createNamedFunction": createNamedFunction,
 "__embind_register_class_property": __embind_register_class_property,
 "embind_init_charCodes": embind_init_charCodes,
 "_floor": _floor,
 "__emval_decref": __emval_decref,
 "_pthread_once": _pthread_once,
 "getBasestPointer": getBasestPointer,
 "__embind_register_class": __embind_register_class,
 "constNoSmartPtrRawPointerToWireType": constNoSmartPtrRawPointerToWireType,
 "heap32VectorToArray": heap32VectorToArray,
 "__emval_lookupTypes": __emval_lookupTypes,
 "ClassHandle_delete": ClassHandle_delete,
 "RegisteredPointer_destructor": RegisteredPointer_destructor,
 "___syscall6": ___syscall6,
 "ensureOverloadTable": ensureOverloadTable,
 "__emval_call": __emval_call,
 "_time": _time,
 "_pthread_mutex_lock": _pthread_mutex_lock,
 "new_": new_,
 "downcastPointer": downcastPointer,
 "replacePublicSymbol": replacePublicSymbol,
 "___cxa_guard_abort": ___cxa_guard_abort,
 "init_embind": init_embind,
 "_llvm_pow_f64": _llvm_pow_f64,
 "ClassHandle_deleteLater": ClassHandle_deleteLater,
 "___syscall54": ___syscall54,
 "RegisteredPointer_deleteObject": RegisteredPointer_deleteObject,
 "ClassHandle_isDeleted": ClassHandle_isDeleted,
 "__embind_register_integer": __embind_register_integer,
 "___cxa_allocate_exception": ___cxa_allocate_exception,
 "__emval_take_value": __emval_take_value,
 "___cxa_end_catch": ___cxa_end_catch,
 "getTypeName": getTypeName,
 "_strftime": _strftime,
 "throwUnboundTypeError": throwUnboundTypeError,
 "craftInvokerFunction": craftInvokerFunction,
 "runDestructors": runDestructors,
 "requireRegisteredType": requireRegisteredType,
 "makeLegalFunctionName": makeLegalFunctionName,
 "_log": _log,
 "upcastPointer": upcastPointer,
 "init_emval": init_emval,
 "_pthread_cond_broadcast": _pthread_cond_broadcast,
 "shallowCopyInternalPointer": shallowCopyInternalPointer,
 "nonConstNoSmartPtrRawPointerToWireType": nonConstNoSmartPtrRawPointerToWireType,
 "_abort": _abort,
 "requireHandle": requireHandle,
 "_embind_repr": _embind_repr,
 "validateThis": validateThis,
 "exposePublicSymbol": exposePublicSymbol,
 "__embind_register_std_string": __embind_register_std_string,
 "_pthread_getspecific": _pthread_getspecific,
 "_pthread_cond_wait": _pthread_cond_wait,
 "_sin": _sin,
 "__embind_register_memory_view": __embind_register_memory_view,
 "getInheritedInstance": getInheritedInstance,
 "setDelayFunction": setDelayFunction,
 "___gxx_personality_v0": ___gxx_personality_v0,
 "extendError": extendError,
 "__embind_register_void": __embind_register_void,
 "__embind_register_smart_ptr": __embind_register_smart_ptr,
 "_strftime_l": _strftime_l,
 "RegisteredPointer_getPointee": RegisteredPointer_getPointee,
 "__emval_register": __emval_register,
 "__embind_register_std_wstring": __embind_register_std_wstring,
 "__embind_register_class_function": __embind_register_class_function,
 "__emval_incref": __emval_incref,
 "RegisteredPointer": RegisteredPointer,
 "__arraySum": __arraySum,
 "readLatin1String": readLatin1String,
 "_pthread_self": _pthread_self,
 "_pthread_mutex_unlock": _pthread_mutex_unlock,
 "getInheritedInstanceCount": getInheritedInstanceCount,
 "__embind_register_float": __embind_register_float,
 "integerReadValueFromPointer": integerReadValueFromPointer,
 "___unlock": ___unlock,
 "_emscripten_set_main_loop": _emscripten_set_main_loop,
 "___cxa_guard_release": ___cxa_guard_release,
 "_pthread_setspecific": _pthread_setspecific,
 "genericPointerToWireType": genericPointerToWireType,
 "registerType": registerType,
 "___cxa_throw": ___cxa_throw,
 "count_emval_handles": count_emval_handles,
 "requireFunction": requireFunction,
 "_atexit": _atexit,
 "_sqrt": _sqrt,
 "STACKTOP": STACKTOP,
 "STACK_MAX": STACK_MAX,
 "tempDoublePtr": tempDoublePtr,
 "ABORT": ABORT,
 "cttz_i8": cttz_i8,
 "___dso_handle": ___dso_handle
};
// EMSCRIPTEN_START_ASM

var asm = (function(global,env,buffer) {

  'use asm';
  
  
  var Int8View = global.Int8Array;
  var Int16View = global.Int16Array;
  var Int32View = global.Int32Array;
  var Uint8View = global.Uint8Array;
  var Uint16View = global.Uint16Array;
  var Uint32View = global.Uint32Array;
  var Float32View = global.Float32Array;
  var Float64View = global.Float64Array;
  var HEAP8 = new Int8View(buffer);
  var HEAP16 = new Int16View(buffer);
  var HEAP32 = new Int32View(buffer);
  var HEAPU8 = new Uint8View(buffer);
  var HEAPU16 = new Uint16View(buffer);
  var HEAPU32 = new Uint32View(buffer);
  var HEAPF32 = new Float32View(buffer);
  var HEAPF64 = new Float64View(buffer);
  var byteLength = global.byteLength;


  var STACKTOP=env.STACKTOP|0;
  var STACK_MAX=env.STACK_MAX|0;
  var tempDoublePtr=env.tempDoublePtr|0;
  var ABORT=env.ABORT|0;
  var cttz_i8=env.cttz_i8|0;
  var ___dso_handle=env.___dso_handle|0;

  var __THREW__ = 0;
  var threwValue = 0;
  var setjmpId = 0;
  var undef = 0;
  var nan = global.NaN, inf = global.Infinity;
  var tempInt = 0, tempBigInt = 0, tempBigIntP = 0, tempBigIntS = 0, tempBigIntR = 0.0, tempBigIntI = 0, tempBigIntD = 0, tempValue = 0, tempDouble = 0.0;

  var tempRet0 = 0;
  var tempRet1 = 0;
  var tempRet2 = 0;
  var tempRet3 = 0;
  var tempRet4 = 0;
  var tempRet5 = 0;
  var tempRet6 = 0;
  var tempRet7 = 0;
  var tempRet8 = 0;
  var tempRet9 = 0;
  var Math_floor=global.Math.floor;
  var Math_abs=global.Math.abs;
  var Math_sqrt=global.Math.sqrt;
  var Math_pow=global.Math.pow;
  var Math_cos=global.Math.cos;
  var Math_sin=global.Math.sin;
  var Math_tan=global.Math.tan;
  var Math_acos=global.Math.acos;
  var Math_asin=global.Math.asin;
  var Math_atan=global.Math.atan;
  var Math_atan2=global.Math.atan2;
  var Math_exp=global.Math.exp;
  var Math_log=global.Math.log;
  var Math_ceil=global.Math.ceil;
  var Math_imul=global.Math.imul;
  var Math_min=global.Math.min;
  var Math_clz32=global.Math.clz32;
  var abort=env.abort;
  var assert=env.assert;
  var invoke_iiiiiiii=env.invoke_iiiiiiii;
  var invoke_diddidd=env.invoke_diddidd;
  var invoke_vid=env.invoke_vid;
  var invoke_diididi=env.invoke_diididi;
  var invoke_vi=env.invoke_vi;
  var invoke_vii=env.invoke_vii;
  var invoke_iiiiiii=env.invoke_iiiiiii;
  var invoke_diididdd=env.invoke_diididdd;
  var invoke_diddd=env.invoke_diddd;
  var invoke_ii=env.invoke_ii;
  var invoke_vididdd=env.invoke_vididdd;
  var invoke_vidid=env.invoke_vidid;
  var invoke_iiiiiid=env.invoke_iiiiiid;
  var invoke_viidd=env.invoke_viidd;
  var invoke_didddddii=env.invoke_didddddii;
  var invoke_viiiii=env.invoke_viiiii;
  var invoke_vididd=env.invoke_vididd;
  var invoke_iiiiii=env.invoke_iiiiii;
  var invoke_viiiiiiiiii=env.invoke_viiiiiiiiii;
  var invoke_i=env.invoke_i;
  var invoke_diddddd=env.invoke_diddddd;
  var invoke_vidd=env.invoke_vidd;
  var invoke_iiii=env.invoke_iiii;
  var invoke_diiddidd=env.invoke_diiddidd;
  var invoke_dddddd=env.invoke_dddddd;
  var invoke_viiiiii=env.invoke_viiiiii;
  var invoke_diiii=env.invoke_diiii;
  var invoke_viii=env.invoke_viii;
  var invoke_di=env.invoke_di;
  var invoke_diiddd=env.invoke_diiddd;
  var invoke_viid=env.invoke_viid;
  var invoke_diid=env.invoke_diid;
  var invoke_diidid=env.invoke_diidid;
  var invoke_viiiiiii=env.invoke_viiiiiii;
  var invoke_iiiiiiiiiiii=env.invoke_iiiiiiiiiiii;
  var invoke_didid=env.invoke_didid;
  var invoke_viididdd=env.invoke_viididdd;
  var invoke_iii=env.invoke_iii;
  var invoke_diiddddd=env.invoke_diiddddd;
  var invoke_diii=env.invoke_diii;
  var invoke_diidddii=env.invoke_diidddii;
  var invoke_didd=env.invoke_didd;
  var invoke_diidddddii=env.invoke_diidddddii;
  var invoke_diidd=env.invoke_diidd;
  var invoke_dii=env.invoke_dii;
  var invoke_did=env.invoke_did;
  var invoke_viiiiiiiiiiiiiii=env.invoke_viiiiiiiiiiiiiii;
  var invoke_iiiiid=env.invoke_iiiiid;
  var invoke_iiiii=env.invoke_iiiii;
  var invoke_dididdd=env.invoke_dididdd;
  var invoke_viiid=env.invoke_viiid;
  var invoke_viidid=env.invoke_viidid;
  var invoke_didddii=env.invoke_didddii;
  var invoke_v=env.invoke_v;
  var invoke_iiiiiiiii=env.invoke_iiiiiiiii;
  var invoke_viididd=env.invoke_viididd;
  var invoke_dididi=env.invoke_dididi;
  var invoke_iiiid=env.invoke_iiiid;
  var invoke_viiii=env.invoke_viiii;
  var _fabs=env._fabs;
  var floatReadValueFromPointer=env.floatReadValueFromPointer;
  var simpleReadValueFromPointer=env.simpleReadValueFromPointer;
  var _pthread_key_create=env._pthread_key_create;
  var throwInternalError=env.throwInternalError;
  var get_first_emval=env.get_first_emval;
  var ___cxa_guard_acquire=env.___cxa_guard_acquire;
  var getLiveInheritedInstances=env.getLiveInheritedInstances;
  var ___assert_fail=env.___assert_fail;
  var __ZSt18uncaught_exceptionv=env.__ZSt18uncaught_exceptionv;
  var ClassHandle=env.ClassHandle;
  var getShiftFromSize=env.getShiftFromSize;
  var _atan=env._atan;
  var __addDays=env.__addDays;
  var _emscripten_set_main_loop_timing=env._emscripten_set_main_loop_timing;
  var _sbrk=env._sbrk;
  var ___cxa_begin_catch=env.___cxa_begin_catch;
  var _emscripten_memcpy_big=env._emscripten_memcpy_big;
  var runDestructor=env.runDestructor;
  var _sysconf=env._sysconf;
  var throwInstanceAlreadyDeleted=env.throwInstanceAlreadyDeleted;
  var RegisteredPointer_fromWireType=env.RegisteredPointer_fromWireType;
  var init_RegisteredPointer=env.init_RegisteredPointer;
  var ___lock=env.___lock;
  var _cos=env._cos;
  var ClassHandle_isAliasOf=env.ClassHandle_isAliasOf;
  var flushPendingDeletes=env.flushPendingDeletes;
  var makeClassHandle=env.makeClassHandle;
  var whenDependentTypesAreResolved=env.whenDependentTypesAreResolved;
  var __isLeapYear=env.__isLeapYear;
  var __embind_register_class_constructor=env.__embind_register_class_constructor;
  var ___cxa_atexit=env.___cxa_atexit;
  var ___cxa_rethrow=env.___cxa_rethrow;
  var init_ClassHandle=env.init_ClassHandle;
  var _pthread_cleanup_push=env._pthread_cleanup_push;
  var ___syscall140=env.___syscall140;
  var ClassHandle_clone=env.ClassHandle_clone;
  var ___syscall145=env.___syscall145;
  var ___syscall146=env.___syscall146;
  var _pthread_cleanup_pop=env._pthread_cleanup_pop;
  var throwBindingError=env.throwBindingError;
  var RegisteredClass=env.RegisteredClass;
  var ___cxa_free_exception=env.___cxa_free_exception;
  var ___cxa_find_matching_catch=env.___cxa_find_matching_catch;
  var __embind_register_emval=env.__embind_register_emval;
  var ___setErrNo=env.___setErrNo;
  var __embind_register_class_class_function=env.__embind_register_class_class_function;
  var __embind_register_bool=env.__embind_register_bool;
  var ___resumeException=env.___resumeException;
  var createNamedFunction=env.createNamedFunction;
  var __embind_register_class_property=env.__embind_register_class_property;
  var embind_init_charCodes=env.embind_init_charCodes;
  var _floor=env._floor;
  var __emval_decref=env.__emval_decref;
  var _pthread_once=env._pthread_once;
  var getBasestPointer=env.getBasestPointer;
  var __embind_register_class=env.__embind_register_class;
  var constNoSmartPtrRawPointerToWireType=env.constNoSmartPtrRawPointerToWireType;
  var heap32VectorToArray=env.heap32VectorToArray;
  var __emval_lookupTypes=env.__emval_lookupTypes;
  var ClassHandle_delete=env.ClassHandle_delete;
  var RegisteredPointer_destructor=env.RegisteredPointer_destructor;
  var ___syscall6=env.___syscall6;
  var ensureOverloadTable=env.ensureOverloadTable;
  var __emval_call=env.__emval_call;
  var _time=env._time;
  var _pthread_mutex_lock=env._pthread_mutex_lock;
  var new_=env.new_;
  var downcastPointer=env.downcastPointer;
  var replacePublicSymbol=env.replacePublicSymbol;
  var ___cxa_guard_abort=env.___cxa_guard_abort;
  var init_embind=env.init_embind;
  var _llvm_pow_f64=env._llvm_pow_f64;
  var ClassHandle_deleteLater=env.ClassHandle_deleteLater;
  var ___syscall54=env.___syscall54;
  var RegisteredPointer_deleteObject=env.RegisteredPointer_deleteObject;
  var ClassHandle_isDeleted=env.ClassHandle_isDeleted;
  var __embind_register_integer=env.__embind_register_integer;
  var ___cxa_allocate_exception=env.___cxa_allocate_exception;
  var __emval_take_value=env.__emval_take_value;
  var ___cxa_end_catch=env.___cxa_end_catch;
  var getTypeName=env.getTypeName;
  var _strftime=env._strftime;
  var throwUnboundTypeError=env.throwUnboundTypeError;
  var craftInvokerFunction=env.craftInvokerFunction;
  var runDestructors=env.runDestructors;
  var requireRegisteredType=env.requireRegisteredType;
  var makeLegalFunctionName=env.makeLegalFunctionName;
  var _log=env._log;
  var upcastPointer=env.upcastPointer;
  var init_emval=env.init_emval;
  var _pthread_cond_broadcast=env._pthread_cond_broadcast;
  var shallowCopyInternalPointer=env.shallowCopyInternalPointer;
  var nonConstNoSmartPtrRawPointerToWireType=env.nonConstNoSmartPtrRawPointerToWireType;
  var _abort=env._abort;
  var requireHandle=env.requireHandle;
  var _embind_repr=env._embind_repr;
  var validateThis=env.validateThis;
  var exposePublicSymbol=env.exposePublicSymbol;
  var __embind_register_std_string=env.__embind_register_std_string;
  var _pthread_getspecific=env._pthread_getspecific;
  var _pthread_cond_wait=env._pthread_cond_wait;
  var _sin=env._sin;
  var __embind_register_memory_view=env.__embind_register_memory_view;
  var getInheritedInstance=env.getInheritedInstance;
  var setDelayFunction=env.setDelayFunction;
  var ___gxx_personality_v0=env.___gxx_personality_v0;
  var extendError=env.extendError;
  var __embind_register_void=env.__embind_register_void;
  var __embind_register_smart_ptr=env.__embind_register_smart_ptr;
  var _strftime_l=env._strftime_l;
  var RegisteredPointer_getPointee=env.RegisteredPointer_getPointee;
  var __emval_register=env.__emval_register;
  var __embind_register_std_wstring=env.__embind_register_std_wstring;
  var __embind_register_class_function=env.__embind_register_class_function;
  var __emval_incref=env.__emval_incref;
  var RegisteredPointer=env.RegisteredPointer;
  var __arraySum=env.__arraySum;
  var readLatin1String=env.readLatin1String;
  var _pthread_self=env._pthread_self;
  var _pthread_mutex_unlock=env._pthread_mutex_unlock;
  var getInheritedInstanceCount=env.getInheritedInstanceCount;
  var __embind_register_float=env.__embind_register_float;
  var integerReadValueFromPointer=env.integerReadValueFromPointer;
  var ___unlock=env.___unlock;
  var _emscripten_set_main_loop=env._emscripten_set_main_loop;
  var ___cxa_guard_release=env.___cxa_guard_release;
  var _pthread_setspecific=env._pthread_setspecific;
  var genericPointerToWireType=env.genericPointerToWireType;
  var registerType=env.registerType;
  var ___cxa_throw=env.___cxa_throw;
  var count_emval_handles=env.count_emval_handles;
  var requireFunction=env.requireFunction;
  var _atexit=env._atexit;
  var _sqrt=env._sqrt;
  var tempFloat = 0.0;

function _emscripten_replace_memory(newBuffer) {
  if ((byteLength(newBuffer) & 0xffffff || byteLength(newBuffer) <= 0xffffff) || byteLength(newBuffer) > 0x80000000) return false;
  HEAP8 = new Int8View(newBuffer);
  HEAP16 = new Int16View(newBuffer);
  HEAP32 = new Int32View(newBuffer);
  HEAPU8 = new Uint8View(newBuffer);
  HEAPU16 = new Uint16View(newBuffer);
  HEAPU32 = new Uint32View(newBuffer);
  HEAPF32 = new Float32View(newBuffer);
  HEAPF64 = new Float64View(newBuffer);
  buffer = newBuffer;
  return true;
}

// EMSCRIPTEN_START_FUNCS

function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 i13 = i12 + 96 | 0;
 i14 = i12 + 104 | 0;
 i15 = i12 + 88 | 0;
 i16 = i12 + 80 | 0;
 i17 = i12 + 76 | 0;
 i18 = i12 + 504 | 0;
 i19 = i12 + 72 | 0;
 i20 = i12 + 68 | 0;
 i21 = i12 + 56 | 0;
 i22 = i12 + 44 | 0;
 i23 = i12 + 32 | 0;
 i24 = i12 + 20 | 0;
 i25 = i12 + 8 | 0;
 i26 = i12 + 4 | 0;
 i27 = i12;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i15 >> 2] = i14;
 i11 = i15 + 4 | 0;
 HEAP32[i11 >> 2] = 287;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i17 >> 2] = i14 + 400;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 __THREW__ = 0;
 invoke_viiiiiiiiii(2, i3 | 0, i4 | 0, i18 | 0, i19 | 0, i20 | 0, i21 | 0, i22 | 0, i23 | 0, i24 | 0, i26 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i4 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  i28 = i3;
  i29 = tempRet0;
 } else {
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  i3 = i23 + 4 | 0;
  i30 = i24 + 4 | 0;
  i31 = i24 + 8 | 0;
  i32 = i23 + 8 | 0;
  i33 = (i5 & 512 | 0) != 0;
  i34 = i22 + 8 | 0;
  i35 = i22 + 4 | 0;
  i36 = i25 + 4 | 0;
  i37 = i25 + 8 | 0;
  i38 = i18 + 3 | 0;
  i39 = i21 + 4 | 0;
  i40 = i14;
  i41 = 0;
  i42 = 0;
  L4 : while (1) {
   i43 = HEAP32[i1 >> 2] | 0;
   do if (i43) {
    i44 = HEAP32[i43 + 12 >> 2] | 0;
    if ((i44 | 0) == (HEAP32[i43 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i45 = invoke_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 36 >> 2] | 0, i43 | 0) | 0;
     i46 = __THREW__;
     __THREW__ = 0;
     if (i46 & 1) {
      i47 = 26;
      break L4;
     } else i48 = i45;
    } else i48 = HEAP32[i44 >> 2] | 0;
    if ((i48 | 0) == -1) {
     HEAP32[i1 >> 2] = 0;
     i49 = 1;
     break;
    } else {
     i49 = (HEAP32[i1 >> 2] | 0) == 0;
     break;
    }
   } else i49 = 1; while (0);
   i43 = HEAP32[i2 >> 2] | 0;
   do if (i43) {
    i44 = HEAP32[i43 + 12 >> 2] | 0;
    if ((i44 | 0) == (HEAP32[i43 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i45 = invoke_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 36 >> 2] | 0, i43 | 0) | 0;
     i46 = __THREW__;
     __THREW__ = 0;
     if (i46 & 1) {
      i47 = 26;
      break L4;
     } else i50 = i45;
    } else i50 = HEAP32[i44 >> 2] | 0;
    if ((i50 | 0) != -1) if (i49) {
     i51 = i43;
     break;
    } else {
     i52 = i40;
     i53 = i42;
     i47 = 244;
     break L4;
    } else {
     HEAP32[i2 >> 2] = 0;
     i47 = 16;
     break;
    }
   } else i47 = 16; while (0);
   if ((i47 | 0) == 16) {
    i47 = 0;
    if (i49) {
     i52 = i40;
     i53 = i42;
     i47 = 244;
     break;
    } else i51 = 0;
   }
   L28 : do switch (HEAP8[i18 + i41 >> 0] | 0) {
   case 1:
    {
     if ((i41 | 0) != 3) {
      i43 = HEAP32[i1 >> 2] | 0;
      i44 = HEAP32[i43 + 12 >> 2] | 0;
      if ((i44 | 0) == (HEAP32[i43 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i45 = invoke_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 36 >> 2] | 0, i43 | 0) | 0;
       i43 = __THREW__;
       __THREW__ = 0;
       if (i43 & 1) {
        i47 = 26;
        break L4;
       } else i54 = i45;
      } else i54 = HEAP32[i44 >> 2] | 0;
      __THREW__ = 0;
      i44 = invoke_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, 8192, i54 | 0) | 0;
      i45 = __THREW__;
      __THREW__ = 0;
      if (i45 & 1) {
       i47 = 26;
       break L4;
      }
      if (!i44) {
       i47 = 42;
       break L4;
      }
      i44 = HEAP32[i1 >> 2] | 0;
      i45 = i44 + 12 | 0;
      i43 = HEAP32[i45 >> 2] | 0;
      if ((i43 | 0) == (HEAP32[i44 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i46 = invoke_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 40 >> 2] | 0, i44 | 0) | 0;
       i44 = __THREW__;
       __THREW__ = 0;
       if (i44 & 1) {
        i47 = 26;
        break L4;
       } else i55 = i46;
      } else {
       HEAP32[i45 >> 2] = i43 + 4;
       i55 = HEAP32[i43 >> 2] | 0;
      }
      __THREW__ = 0;
      invoke_vii(70, i25 | 0, i55 | 0);
      i43 = __THREW__;
      __THREW__ = 0;
      if (i43 & 1) {
       i47 = 26;
       break L4;
      } else {
       i56 = i51;
       i57 = i51;
       i47 = 44;
      }
     } else {
      i58 = i40;
      i59 = i42;
     }
     break;
    }
   case 0:
    {
     if ((i41 | 0) == 3) {
      i58 = i40;
      i59 = i42;
     } else {
      i56 = i51;
      i57 = i51;
      i47 = 44;
     }
     break;
    }
   case 3:
    {
     i43 = HEAP8[i23 >> 0] | 0;
     i45 = (i43 & 1) == 0 ? (i43 & 255) >>> 1 : HEAP32[i3 >> 2] | 0;
     i46 = HEAP8[i24 >> 0] | 0;
     i44 = (i46 & 1) == 0 ? (i46 & 255) >>> 1 : HEAP32[i30 >> 2] | 0;
     if ((i45 | 0) == (0 - i44 | 0)) {
      i58 = i40;
      i59 = i42;
     } else {
      if (!i45) {
       i45 = HEAP32[i1 >> 2] | 0;
       i60 = HEAP32[i45 + 12 >> 2] | 0;
       if ((i60 | 0) == (HEAP32[i45 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i61 = invoke_ii(HEAP32[(HEAP32[i45 >> 2] | 0) + 36 >> 2] | 0, i45 | 0) | 0;
        i45 = __THREW__;
        __THREW__ = 0;
        if (i45 & 1) {
         i47 = 26;
         break L4;
        }
        i62 = i61;
        i63 = HEAP8[i24 >> 0] | 0;
       } else {
        i62 = HEAP32[i60 >> 2] | 0;
        i63 = i46;
       }
       if ((i62 | 0) != (HEAP32[((i63 & 1) == 0 ? i30 : HEAP32[i31 >> 2] | 0) >> 2] | 0)) {
        i58 = i40;
        i59 = i42;
        break L28;
       }
       i46 = HEAP32[i1 >> 2] | 0;
       i60 = i46 + 12 | 0;
       i61 = HEAP32[i60 >> 2] | 0;
       if ((i61 | 0) == (HEAP32[i46 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i46 >> 2] | 0) + 40 >> 2] | 0, i46 | 0) | 0;
        i46 = __THREW__;
        __THREW__ = 0;
        if (i46 & 1) {
         i47 = 26;
         break L4;
        }
       } else HEAP32[i60 >> 2] = i61 + 4;
       HEAP8[i7 >> 0] = 1;
       i61 = HEAP8[i24 >> 0] | 0;
       i58 = i40;
       i59 = ((i61 & 1) == 0 ? (i61 & 255) >>> 1 : HEAP32[i30 >> 2] | 0) >>> 0 > 1 ? i24 : i42;
       break L28;
      }
      i61 = HEAP32[i1 >> 2] | 0;
      i60 = HEAP32[i61 + 12 >> 2] | 0;
      i46 = HEAP32[i61 + 16 >> 2] | 0;
      i45 = (i60 | 0) == (i46 | 0);
      if (!i44) {
       if (i45) {
        __THREW__ = 0;
        i44 = invoke_ii(HEAP32[(HEAP32[i61 >> 2] | 0) + 36 >> 2] | 0, i61 | 0) | 0;
        i64 = __THREW__;
        __THREW__ = 0;
        if (i64 & 1) {
         i47 = 26;
         break L4;
        }
        i65 = i44;
        i66 = HEAP8[i23 >> 0] | 0;
       } else {
        i65 = HEAP32[i60 >> 2] | 0;
        i66 = i43;
       }
       if ((i65 | 0) != (HEAP32[((i66 & 1) == 0 ? i3 : HEAP32[i32 >> 2] | 0) >> 2] | 0)) {
        HEAP8[i7 >> 0] = 1;
        i58 = i40;
        i59 = i42;
        break L28;
       }
       i44 = HEAP32[i1 >> 2] | 0;
       i64 = i44 + 12 | 0;
       i67 = HEAP32[i64 >> 2] | 0;
       if ((i67 | 0) == (HEAP32[i44 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 40 >> 2] | 0, i44 | 0) | 0;
        i44 = __THREW__;
        __THREW__ = 0;
        if (i44 & 1) {
         i47 = 26;
         break L4;
        }
       } else HEAP32[i64 >> 2] = i67 + 4;
       i67 = HEAP8[i23 >> 0] | 0;
       i58 = i40;
       i59 = ((i67 & 1) == 0 ? (i67 & 255) >>> 1 : HEAP32[i3 >> 2] | 0) >>> 0 > 1 ? i23 : i42;
       break L28;
      }
      if (i45) {
       __THREW__ = 0;
       i45 = invoke_ii(HEAP32[(HEAP32[i61 >> 2] | 0) + 36 >> 2] | 0, i61 | 0) | 0;
       i67 = __THREW__;
       __THREW__ = 0;
       if (i67 & 1) {
        i47 = 26;
        break L4;
       }
       i67 = HEAP32[i1 >> 2] | 0;
       i68 = i45;
       i69 = HEAP8[i23 >> 0] | 0;
       i70 = i67;
       i71 = HEAP32[i67 + 12 >> 2] | 0;
       i72 = HEAP32[i67 + 16 >> 2] | 0;
      } else {
       i68 = HEAP32[i60 >> 2] | 0;
       i69 = i43;
       i70 = i61;
       i71 = i60;
       i72 = i46;
      }
      i46 = i70 + 12 | 0;
      i60 = (i71 | 0) == (i72 | 0);
      if ((i68 | 0) == (HEAP32[((i69 & 1) == 0 ? i3 : HEAP32[i32 >> 2] | 0) >> 2] | 0)) {
       if (i60) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i70 >> 2] | 0) + 40 >> 2] | 0, i70 | 0) | 0;
        i61 = __THREW__;
        __THREW__ = 0;
        if (i61 & 1) {
         i47 = 26;
         break L4;
        }
       } else HEAP32[i46 >> 2] = i71 + 4;
       i46 = HEAP8[i23 >> 0] | 0;
       i58 = i40;
       i59 = ((i46 & 1) == 0 ? (i46 & 255) >>> 1 : HEAP32[i3 >> 2] | 0) >>> 0 > 1 ? i23 : i42;
       break L28;
      }
      if (i60) {
       __THREW__ = 0;
       i60 = invoke_ii(HEAP32[(HEAP32[i70 >> 2] | 0) + 36 >> 2] | 0, i70 | 0) | 0;
       i46 = __THREW__;
       __THREW__ = 0;
       if (i46 & 1) {
        i47 = 26;
        break L4;
       } else i73 = i60;
      } else i73 = HEAP32[i71 >> 2] | 0;
      if ((i73 | 0) != (HEAP32[((HEAP8[i24 >> 0] & 1) == 0 ? i30 : HEAP32[i31 >> 2] | 0) >> 2] | 0)) {
       i47 = 107;
       break L4;
      }
      i60 = HEAP32[i1 >> 2] | 0;
      i46 = i60 + 12 | 0;
      i61 = HEAP32[i46 >> 2] | 0;
      if ((i61 | 0) == (HEAP32[i60 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i60 >> 2] | 0) + 40 >> 2] | 0, i60 | 0) | 0;
       i60 = __THREW__;
       __THREW__ = 0;
       if (i60 & 1) {
        i47 = 26;
        break L4;
       }
      } else HEAP32[i46 >> 2] = i61 + 4;
      HEAP8[i7 >> 0] = 1;
      i61 = HEAP8[i24 >> 0] | 0;
      i58 = i40;
      i59 = ((i61 & 1) == 0 ? (i61 & 255) >>> 1 : HEAP32[i30 >> 2] | 0) >>> 0 > 1 ? i24 : i42;
     }
     break;
    }
   case 2:
    {
     if (!(i41 >>> 0 < 2 | (i42 | 0) != 0) ? !(i33 | (i41 | 0) == 2 & (HEAP8[i38 >> 0] | 0) != 0) : 0) {
      i58 = i40;
      i59 = 0;
      break L28;
     }
     i61 = HEAP8[i22 >> 0] | 0;
     i46 = HEAP32[i34 >> 2] | 0;
     i60 = (i61 & 1) == 0 ? i35 : i46;
     i43 = i60;
     L97 : do if ((i41 | 0) != 0 ? (HEAPU8[i18 + (i41 + -1) >> 0] | 0) < 2 : 0) {
      i67 = (i61 & 1) == 0;
      L100 : do if ((i60 | 0) == ((i67 ? i35 : i46) + ((i67 ? (i61 & 255) >>> 1 : HEAP32[i35 >> 2] | 0) << 2) | 0)) {
       i74 = i61;
       i75 = i46;
       i76 = i43;
      } else {
       i45 = i60;
       i64 = i43;
       while (1) {
        __THREW__ = 0;
        i44 = invoke_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, 8192, HEAP32[i45 >> 2] | 0) | 0;
        i77 = __THREW__;
        __THREW__ = 0;
        if (i77 & 1) {
         i47 = 23;
         break L4;
        }
        if (!i44) {
         i78 = i64;
         break;
        }
        i45 = i45 + 4 | 0;
        i44 = i45;
        i77 = HEAP8[i22 >> 0] | 0;
        i79 = HEAP32[i34 >> 2] | 0;
        i80 = (i77 & 1) == 0;
        if ((i45 | 0) == ((i80 ? i35 : i79) + ((i80 ? (i77 & 255) >>> 1 : HEAP32[i35 >> 2] | 0) << 2) | 0)) {
         i74 = i77;
         i75 = i79;
         i76 = i44;
         break L100;
        } else i64 = i44;
       }
       i74 = HEAP8[i22 >> 0] | 0;
       i75 = HEAP32[i34 >> 2] | 0;
       i76 = i78;
      } while (0);
      i67 = (i74 & 1) == 0 ? i35 : i75;
      i64 = i67;
      i45 = i76 - i64 >> 2;
      i44 = HEAP8[i25 >> 0] | 0;
      i79 = (i44 & 1) == 0;
      i77 = i79 ? (i44 & 255) >>> 1 : HEAP32[i36 >> 2] | 0;
      if (i77 >>> 0 >= i45 >>> 0) {
       i44 = i79 ? i36 : HEAP32[i37 >> 2] | 0;
       i79 = i44 + (i77 << 2) | 0;
       if (!i45) {
        i81 = i75;
        i82 = i74;
        i83 = i76;
       } else {
        i80 = i67;
        i67 = i44 + (i77 - i45 << 2) | 0;
        while (1) {
         if ((HEAP32[i67 >> 2] | 0) != (HEAP32[i80 >> 2] | 0)) {
          i81 = i75;
          i82 = i74;
          i83 = i64;
          break L97;
         }
         i67 = i67 + 4 | 0;
         if ((i67 | 0) == (i79 | 0)) {
          i81 = i75;
          i82 = i74;
          i83 = i76;
          break;
         } else i80 = i80 + 4 | 0;
        }
       }
      } else {
       i81 = i75;
       i82 = i74;
       i83 = i64;
      }
     } else {
      i81 = i46;
      i82 = i61;
      i83 = i43;
     } while (0);
     i43 = (i82 & 1) == 0;
     i61 = (i43 ? i35 : i81) + ((i43 ? (i82 & 255) >>> 1 : HEAP32[i35 >> 2] | 0) << 2) | 0;
     i43 = i83;
     L113 : do if ((i43 | 0) == (i61 | 0)) i84 = i61; else {
      i46 = i51;
      i60 = i51;
      i80 = i43;
      while (1) {
       i79 = HEAP32[i1 >> 2] | 0;
       do if (i79) {
        i67 = HEAP32[i79 + 12 >> 2] | 0;
        if ((i67 | 0) == (HEAP32[i79 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         i45 = invoke_ii(HEAP32[(HEAP32[i79 >> 2] | 0) + 36 >> 2] | 0, i79 | 0) | 0;
         i77 = __THREW__;
         __THREW__ = 0;
         if (i77 & 1) {
          i47 = 22;
          break L4;
         } else i85 = i45;
        } else i85 = HEAP32[i67 >> 2] | 0;
        if ((i85 | 0) == -1) {
         HEAP32[i1 >> 2] = 0;
         i86 = 1;
         break;
        } else {
         i86 = (HEAP32[i1 >> 2] | 0) == 0;
         break;
        }
       } else i86 = 1; while (0);
       do if (i60) {
        i79 = HEAP32[i60 + 12 >> 2] | 0;
        if ((i79 | 0) == (HEAP32[i60 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         i67 = invoke_ii(HEAP32[(HEAP32[i60 >> 2] | 0) + 36 >> 2] | 0, i60 | 0) | 0;
         i45 = __THREW__;
         __THREW__ = 0;
         if (i45 & 1) {
          i47 = 22;
          break L4;
         } else i87 = i67;
        } else i87 = HEAP32[i79 >> 2] | 0;
        if ((i87 | 0) != -1) if (i86 ^ (i46 | 0) == 0) {
         i88 = i46;
         i89 = i46;
         break;
        } else {
         i84 = i80;
         break L113;
        } else {
         HEAP32[i2 >> 2] = 0;
         i90 = 0;
         i47 = 136;
         break;
        }
       } else {
        i90 = i46;
        i47 = 136;
       } while (0);
       if ((i47 | 0) == 136) {
        i47 = 0;
        if (i86) {
         i84 = i80;
         break L113;
        } else {
         i88 = i90;
         i89 = 0;
        }
       }
       i79 = HEAP32[i1 >> 2] | 0;
       i67 = HEAP32[i79 + 12 >> 2] | 0;
       if ((i67 | 0) == (HEAP32[i79 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i45 = invoke_ii(HEAP32[(HEAP32[i79 >> 2] | 0) + 36 >> 2] | 0, i79 | 0) | 0;
        i79 = __THREW__;
        __THREW__ = 0;
        if (i79 & 1) {
         i47 = 22;
         break L4;
        } else i91 = i45;
       } else i91 = HEAP32[i67 >> 2] | 0;
       if ((i91 | 0) != (HEAP32[i80 >> 2] | 0)) {
        i84 = i80;
        break L113;
       }
       i67 = HEAP32[i1 >> 2] | 0;
       i45 = i67 + 12 | 0;
       i79 = HEAP32[i45 >> 2] | 0;
       if ((i79 | 0) == (HEAP32[i67 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i67 >> 2] | 0) + 40 >> 2] | 0, i67 | 0) | 0;
        i67 = __THREW__;
        __THREW__ = 0;
        if (i67 & 1) {
         i47 = 22;
         break L4;
        }
       } else HEAP32[i45 >> 2] = i79 + 4;
       i80 = i80 + 4 | 0;
       i79 = HEAP8[i22 >> 0] | 0;
       i45 = (i79 & 1) == 0;
       i67 = (i45 ? i35 : HEAP32[i34 >> 2] | 0) + ((i45 ? (i79 & 255) >>> 1 : HEAP32[i35 >> 2] | 0) << 2) | 0;
       if ((i80 | 0) == (i67 | 0)) {
        i84 = i67;
        break;
       } else {
        i46 = i88;
        i60 = i89;
       }
      }
     } while (0);
     if (i33 ? (i43 = HEAP8[i22 >> 0] | 0, i61 = (i43 & 1) == 0, (i84 | 0) != ((i61 ? i35 : HEAP32[i34 >> 2] | 0) + ((i61 ? (i43 & 255) >>> 1 : HEAP32[i35 >> 2] | 0) << 2) | 0)) : 0) {
      i47 = 148;
      break L4;
     } else {
      i58 = i40;
      i59 = i42;
     }
     break;
    }
   case 4:
    {
     i43 = HEAP32[i20 >> 2] | 0;
     i61 = i51;
     i60 = i51;
     i46 = i40;
     i80 = 0;
     L150 : while (1) {
      i64 = HEAP32[i1 >> 2] | 0;
      do if (i64) {
       i67 = HEAP32[i64 + 12 >> 2] | 0;
       if ((i67 | 0) == (HEAP32[i64 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i79 = invoke_ii(HEAP32[(HEAP32[i64 >> 2] | 0) + 36 >> 2] | 0, i64 | 0) | 0;
        i45 = __THREW__;
        __THREW__ = 0;
        if (i45 & 1) {
         i47 = 25;
         break L4;
        } else i92 = i79;
       } else i92 = HEAP32[i67 >> 2] | 0;
       if ((i92 | 0) == -1) {
        HEAP32[i1 >> 2] = 0;
        i93 = 1;
        break;
       } else {
        i93 = (HEAP32[i1 >> 2] | 0) == 0;
        break;
       }
      } else i93 = 1; while (0);
      do if (i60) {
       i64 = HEAP32[i60 + 12 >> 2] | 0;
       if ((i64 | 0) == (HEAP32[i60 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i67 = invoke_ii(HEAP32[(HEAP32[i60 >> 2] | 0) + 36 >> 2] | 0, i60 | 0) | 0;
        i79 = __THREW__;
        __THREW__ = 0;
        if (i79 & 1) {
         i47 = 25;
         break L4;
        } else i94 = i67;
       } else i94 = HEAP32[i64 >> 2] | 0;
       if ((i94 | 0) != -1) if (i93 ^ (i61 | 0) == 0) {
        i95 = i61;
        i96 = i61;
        break;
       } else {
        i97 = i46;
        i98 = i61;
        i99 = i80;
        break L150;
       } else {
        HEAP32[i2 >> 2] = 0;
        i100 = 0;
        i47 = 162;
        break;
       }
      } else {
       i100 = i61;
       i47 = 162;
      } while (0);
      if ((i47 | 0) == 162) {
       i47 = 0;
       if (i93) {
        i97 = i46;
        i98 = i100;
        i99 = i80;
        break;
       } else {
        i95 = i100;
        i96 = 0;
       }
      }
      i64 = HEAP32[i1 >> 2] | 0;
      i67 = HEAP32[i64 + 12 >> 2] | 0;
      if ((i67 | 0) == (HEAP32[i64 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i79 = invoke_ii(HEAP32[(HEAP32[i64 >> 2] | 0) + 36 >> 2] | 0, i64 | 0) | 0;
       i64 = __THREW__;
       __THREW__ = 0;
       if (i64 & 1) {
        i47 = 25;
        break L4;
       } else i101 = i79;
      } else i101 = HEAP32[i67 >> 2] | 0;
      __THREW__ = 0;
      i67 = invoke_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, 2048, i101 | 0) | 0;
      i79 = __THREW__;
      __THREW__ = 0;
      if (i79 & 1) {
       i47 = 25;
       break L4;
      }
      if (i67) {
       i67 = HEAP32[i10 >> 2] | 0;
       if ((i67 | 0) == (HEAP32[i13 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(12, i9 | 0, i10 | 0, i13 | 0);
        i79 = __THREW__;
        __THREW__ = 0;
        if (i79 & 1) {
         i47 = 25;
         break L4;
        }
        i102 = HEAP32[i10 >> 2] | 0;
       } else i102 = i67;
       HEAP32[i10 >> 2] = i102 + 4;
       HEAP32[i102 >> 2] = i101;
       i103 = i46;
       i104 = i80 + 1 | 0;
      } else {
       i67 = HEAP8[i21 >> 0] | 0;
       if (!((i101 | 0) == (i43 | 0) & ((i80 | 0) != 0 ? (((i67 & 1) == 0 ? (i67 & 255) >>> 1 : HEAP32[i39 >> 2] | 0) | 0) != 0 : 0))) {
        i97 = i46;
        i98 = i95;
        i99 = i80;
        break;
       }
       if ((i46 | 0) == (HEAP32[i17 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(11, i15 | 0, i16 | 0, i17 | 0);
        i67 = __THREW__;
        __THREW__ = 0;
        if (i67 & 1) {
         i47 = 25;
         break L4;
        }
        i105 = HEAP32[i16 >> 2] | 0;
       } else i105 = i46;
       i67 = i105 + 4 | 0;
       HEAP32[i16 >> 2] = i67;
       HEAP32[i105 >> 2] = i80;
       i103 = i67;
       i104 = 0;
      }
      i67 = HEAP32[i1 >> 2] | 0;
      i79 = i67 + 12 | 0;
      i64 = HEAP32[i79 >> 2] | 0;
      if ((i64 | 0) == (HEAP32[i67 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i67 >> 2] | 0) + 40 >> 2] | 0, i67 | 0) | 0;
       i67 = __THREW__;
       __THREW__ = 0;
       if (i67 & 1) {
        i47 = 25;
        break L4;
       } else {
        i61 = i95;
        i60 = i96;
        i46 = i103;
        i80 = i104;
        continue;
       }
      } else {
       HEAP32[i79 >> 2] = i64 + 4;
       i61 = i95;
       i60 = i96;
       i46 = i103;
       i80 = i104;
       continue;
      }
     }
     if ((i99 | 0) != 0 ? (HEAP32[i15 >> 2] | 0) != (i97 | 0) : 0) {
      if ((i97 | 0) == (HEAP32[i17 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_viii(11, i15 | 0, i16 | 0, i17 | 0);
       i80 = __THREW__;
       __THREW__ = 0;
       if (i80 & 1) {
        i47 = 26;
        break L4;
       }
       i106 = HEAP32[i16 >> 2] | 0;
      } else i106 = i97;
      i80 = i106 + 4 | 0;
      HEAP32[i16 >> 2] = i80;
      HEAP32[i106 >> 2] = i99;
      i107 = i80;
     } else i107 = i97;
     i80 = HEAP32[i26 >> 2] | 0;
     if ((i80 | 0) > 0) {
      i46 = HEAP32[i1 >> 2] | 0;
      do if (i46) {
       i60 = HEAP32[i46 + 12 >> 2] | 0;
       if ((i60 | 0) == (HEAP32[i46 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i61 = invoke_ii(HEAP32[(HEAP32[i46 >> 2] | 0) + 36 >> 2] | 0, i46 | 0) | 0;
        i43 = __THREW__;
        __THREW__ = 0;
        if (i43 & 1) {
         i47 = 26;
         break L4;
        } else i108 = i61;
       } else i108 = HEAP32[i60 >> 2] | 0;
       if ((i108 | 0) == -1) {
        HEAP32[i1 >> 2] = 0;
        i109 = 1;
        break;
       } else {
        i109 = (HEAP32[i1 >> 2] | 0) == 0;
        break;
       }
      } else i109 = 1; while (0);
      do if (i98) {
       i46 = HEAP32[i98 + 12 >> 2] | 0;
       if ((i46 | 0) == (HEAP32[i98 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i60 = invoke_ii(HEAP32[(HEAP32[i98 >> 2] | 0) + 36 >> 2] | 0, i98 | 0) | 0;
        i61 = __THREW__;
        __THREW__ = 0;
        if (i61 & 1) {
         i47 = 26;
         break L4;
        } else i110 = i60;
       } else i110 = HEAP32[i46 >> 2] | 0;
       if ((i110 | 0) != -1) if (i109) {
        i111 = i98;
        break;
       } else {
        i47 = 206;
        break L4;
       } else {
        HEAP32[i2 >> 2] = 0;
        i47 = 200;
        break;
       }
      } else i47 = 200; while (0);
      if ((i47 | 0) == 200) {
       i47 = 0;
       if (i109) {
        i47 = 206;
        break L4;
       } else i111 = 0;
      }
      i46 = HEAP32[i1 >> 2] | 0;
      i60 = HEAP32[i46 + 12 >> 2] | 0;
      if ((i60 | 0) == (HEAP32[i46 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i61 = invoke_ii(HEAP32[(HEAP32[i46 >> 2] | 0) + 36 >> 2] | 0, i46 | 0) | 0;
       i46 = __THREW__;
       __THREW__ = 0;
       if (i46 & 1) {
        i47 = 26;
        break L4;
       } else i112 = i61;
      } else i112 = HEAP32[i60 >> 2] | 0;
      if ((i112 | 0) != (HEAP32[i19 >> 2] | 0)) {
       i47 = 206;
       break L4;
      }
      i60 = HEAP32[i1 >> 2] | 0;
      i61 = i60 + 12 | 0;
      i46 = HEAP32[i61 >> 2] | 0;
      if ((i46 | 0) == (HEAP32[i60 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i60 >> 2] | 0) + 40 >> 2] | 0, i60 | 0) | 0;
       i60 = __THREW__;
       __THREW__ = 0;
       if (i60 & 1) {
        i47 = 26;
        break L4;
       }
      } else HEAP32[i61 >> 2] = i46 + 4;
      if ((i80 | 0) > 0) {
       i46 = i111;
       i61 = i111;
       i60 = i80;
       while (1) {
        i43 = HEAP32[i1 >> 2] | 0;
        do if (i43) {
         i64 = HEAP32[i43 + 12 >> 2] | 0;
         if ((i64 | 0) == (HEAP32[i43 + 16 >> 2] | 0)) {
          __THREW__ = 0;
          i79 = invoke_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 36 >> 2] | 0, i43 | 0) | 0;
          i67 = __THREW__;
          __THREW__ = 0;
          if (i67 & 1) {
           i47 = 24;
           break L4;
          } else i113 = i79;
         } else i113 = HEAP32[i64 >> 2] | 0;
         if ((i113 | 0) == -1) {
          HEAP32[i1 >> 2] = 0;
          i114 = 1;
          break;
         } else {
          i114 = (HEAP32[i1 >> 2] | 0) == 0;
          break;
         }
        } else i114 = 1; while (0);
        do if (i61) {
         i43 = HEAP32[i61 + 12 >> 2] | 0;
         if ((i43 | 0) == (HEAP32[i61 + 16 >> 2] | 0)) {
          __THREW__ = 0;
          i64 = invoke_ii(HEAP32[(HEAP32[i61 >> 2] | 0) + 36 >> 2] | 0, i61 | 0) | 0;
          i79 = __THREW__;
          __THREW__ = 0;
          if (i79 & 1) {
           i47 = 24;
           break L4;
          } else i115 = i64;
         } else i115 = HEAP32[i43 >> 2] | 0;
         if ((i115 | 0) != -1) if (i114 ^ (i46 | 0) == 0) {
          i116 = i46;
          i117 = i46;
          break;
         } else {
          i47 = 231;
          break L4;
         } else {
          HEAP32[i2 >> 2] = 0;
          i118 = 0;
          i47 = 224;
          break;
         }
        } else {
         i118 = i46;
         i47 = 224;
        } while (0);
        if ((i47 | 0) == 224) {
         i47 = 0;
         if (i114) {
          i47 = 231;
          break L4;
         } else {
          i116 = i118;
          i117 = 0;
         }
        }
        i43 = HEAP32[i1 >> 2] | 0;
        i64 = HEAP32[i43 + 12 >> 2] | 0;
        if ((i64 | 0) == (HEAP32[i43 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         i79 = invoke_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 36 >> 2] | 0, i43 | 0) | 0;
         i43 = __THREW__;
         __THREW__ = 0;
         if (i43 & 1) {
          i47 = 24;
          break L4;
         } else i119 = i79;
        } else i119 = HEAP32[i64 >> 2] | 0;
        __THREW__ = 0;
        i64 = invoke_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, 2048, i119 | 0) | 0;
        i79 = __THREW__;
        __THREW__ = 0;
        if (i79 & 1) {
         i47 = 24;
         break L4;
        }
        if (!i64) {
         i47 = 231;
         break L4;
        }
        if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i13 >> 2] | 0) ? (__THREW__ = 0, invoke_viii(12, i9 | 0, i10 | 0, i13 | 0), i64 = __THREW__, __THREW__ = 0, i64 & 1) : 0) {
         i47 = 24;
         break L4;
        }
        i64 = HEAP32[i1 >> 2] | 0;
        i79 = HEAP32[i64 + 12 >> 2] | 0;
        if ((i79 | 0) == (HEAP32[i64 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         i43 = invoke_ii(HEAP32[(HEAP32[i64 >> 2] | 0) + 36 >> 2] | 0, i64 | 0) | 0;
         i64 = __THREW__;
         __THREW__ = 0;
         if (i64 & 1) {
          i47 = 24;
          break L4;
         } else i120 = i43;
        } else i120 = HEAP32[i79 >> 2] | 0;
        i79 = HEAP32[i10 >> 2] | 0;
        HEAP32[i10 >> 2] = i79 + 4;
        HEAP32[i79 >> 2] = i120;
        i79 = i60;
        i60 = i60 + -1 | 0;
        HEAP32[i26 >> 2] = i60;
        i43 = HEAP32[i1 >> 2] | 0;
        i64 = i43 + 12 | 0;
        i67 = HEAP32[i64 >> 2] | 0;
        if ((i67 | 0) == (HEAP32[i43 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         invoke_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 40 >> 2] | 0, i43 | 0) | 0;
         i43 = __THREW__;
         __THREW__ = 0;
         if (i43 & 1) {
          i47 = 24;
          break L4;
         }
        } else HEAP32[i64 >> 2] = i67 + 4;
        if ((i79 | 0) <= 1) break; else {
         i46 = i116;
         i61 = i117;
        }
       }
      }
     }
     if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) {
      i47 = 242;
      break L4;
     } else {
      i58 = i107;
      i59 = i42;
     }
     break;
    }
   default:
    {
     i58 = i40;
     i59 = i42;
    }
   } while (0);
   L278 : do if ((i47 | 0) == 44) while (1) {
    i47 = 0;
    i61 = HEAP32[i1 >> 2] | 0;
    do if (i61) {
     i46 = HEAP32[i61 + 12 >> 2] | 0;
     if ((i46 | 0) == (HEAP32[i61 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i60 = invoke_ii(HEAP32[(HEAP32[i61 >> 2] | 0) + 36 >> 2] | 0, i61 | 0) | 0;
      i80 = __THREW__;
      __THREW__ = 0;
      if (i80 & 1) {
       i47 = 21;
       break L4;
      } else i121 = i60;
     } else i121 = HEAP32[i46 >> 2] | 0;
     if ((i121 | 0) == -1) {
      HEAP32[i1 >> 2] = 0;
      i122 = 1;
      break;
     } else {
      i122 = (HEAP32[i1 >> 2] | 0) == 0;
      break;
     }
    } else i122 = 1; while (0);
    do if (i57) {
     i61 = HEAP32[i57 + 12 >> 2] | 0;
     if ((i61 | 0) == (HEAP32[i57 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i46 = invoke_ii(HEAP32[(HEAP32[i57 >> 2] | 0) + 36 >> 2] | 0, i57 | 0) | 0;
      i60 = __THREW__;
      __THREW__ = 0;
      if (i60 & 1) {
       i47 = 21;
       break L4;
      } else i123 = i46;
     } else i123 = HEAP32[i61 >> 2] | 0;
     if ((i123 | 0) != -1) if (i122 ^ (i56 | 0) == 0) {
      i124 = i56;
      i125 = i56;
      break;
     } else {
      i58 = i40;
      i59 = i42;
      break L278;
     } else {
      HEAP32[i2 >> 2] = 0;
      i126 = 0;
      i47 = 57;
      break;
     }
    } else {
     i126 = i56;
     i47 = 57;
    } while (0);
    if ((i47 | 0) == 57) {
     i47 = 0;
     if (i122) {
      i58 = i40;
      i59 = i42;
      break L278;
     } else {
      i124 = i126;
      i125 = 0;
     }
    }
    i61 = HEAP32[i1 >> 2] | 0;
    i46 = HEAP32[i61 + 12 >> 2] | 0;
    if ((i46 | 0) == (HEAP32[i61 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i60 = invoke_ii(HEAP32[(HEAP32[i61 >> 2] | 0) + 36 >> 2] | 0, i61 | 0) | 0;
     i61 = __THREW__;
     __THREW__ = 0;
     if (i61 & 1) {
      i47 = 21;
      break L4;
     } else i127 = i60;
    } else i127 = HEAP32[i46 >> 2] | 0;
    __THREW__ = 0;
    i46 = invoke_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, 8192, i127 | 0) | 0;
    i60 = __THREW__;
    __THREW__ = 0;
    if (i60 & 1) {
     i47 = 21;
     break L4;
    }
    if (!i46) {
     i58 = i40;
     i59 = i42;
     break L278;
    }
    i46 = HEAP32[i1 >> 2] | 0;
    i60 = i46 + 12 | 0;
    i61 = HEAP32[i60 >> 2] | 0;
    if ((i61 | 0) == (HEAP32[i46 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i80 = invoke_ii(HEAP32[(HEAP32[i46 >> 2] | 0) + 40 >> 2] | 0, i46 | 0) | 0;
     i46 = __THREW__;
     __THREW__ = 0;
     if (i46 & 1) {
      i47 = 21;
      break L4;
     } else i128 = i80;
    } else {
     HEAP32[i60 >> 2] = i61 + 4;
     i128 = HEAP32[i61 >> 2] | 0;
    }
    __THREW__ = 0;
    invoke_vii(70, i25 | 0, i128 | 0);
    i61 = __THREW__;
    __THREW__ = 0;
    if (i61 & 1) {
     i47 = 21;
     break L4;
    } else {
     i56 = i124;
     i57 = i125;
     i47 = 44;
    }
   } while (0);
   i41 = i41 + 1 | 0;
   if (i41 >>> 0 >= 4) {
    i52 = i58;
    i53 = i59;
    i47 = 244;
    break;
   } else {
    i40 = i58;
    i42 = i59;
   }
  }
  L314 : switch (i47 | 0) {
  case 21:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 22:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 23:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 24:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 25:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 26:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 42:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i129 = 0;
    break;
   }
  case 107:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i129 = 0;
    break;
   }
  case 148:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i129 = 0;
    break;
   }
  case 206:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i129 = 0;
    break;
   }
  case 231:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i129 = 0;
    break;
   }
  case 242:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i129 = 0;
    break;
   }
  case 244:
   {
    L316 : do if (i53) {
     i42 = i53 + 4 | 0;
     i40 = i53 + 8 | 0;
     i41 = 1;
     L318 : while (1) {
      i39 = HEAP8[i53 >> 0] | 0;
      if (!(i39 & 1)) i130 = (i39 & 255) >>> 1; else i130 = HEAP32[i42 >> 2] | 0;
      if (i41 >>> 0 >= i130 >>> 0) break L316;
      i39 = HEAP32[i1 >> 2] | 0;
      do if (i39) {
       i35 = HEAP32[i39 + 12 >> 2] | 0;
       if ((i35 | 0) == (HEAP32[i39 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i34 = invoke_ii(HEAP32[(HEAP32[i39 >> 2] | 0) + 36 >> 2] | 0, i39 | 0) | 0;
        i33 = __THREW__;
        __THREW__ = 0;
        if (i33 & 1) {
         i47 = 20;
         break L318;
        } else i131 = i34;
       } else i131 = HEAP32[i35 >> 2] | 0;
       if ((i131 | 0) == -1) {
        HEAP32[i1 >> 2] = 0;
        i132 = 1;
        break;
       } else {
        i132 = (HEAP32[i1 >> 2] | 0) == 0;
        break;
       }
      } else i132 = 1; while (0);
      i39 = HEAP32[i2 >> 2] | 0;
      do if (i39) {
       i35 = HEAP32[i39 + 12 >> 2] | 0;
       if ((i35 | 0) == (HEAP32[i39 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i34 = invoke_ii(HEAP32[(HEAP32[i39 >> 2] | 0) + 36 >> 2] | 0, i39 | 0) | 0;
        i33 = __THREW__;
        __THREW__ = 0;
        if (i33 & 1) {
         i47 = 20;
         break L318;
        } else i133 = i34;
       } else i133 = HEAP32[i35 >> 2] | 0;
       if ((i133 | 0) != -1) if (i132) break; else {
        i47 = 271;
        break L318;
       } else {
        HEAP32[i2 >> 2] = 0;
        i47 = 263;
        break;
       }
      } else i47 = 263; while (0);
      if ((i47 | 0) == 263 ? (i47 = 0, i132) : 0) {
       i47 = 271;
       break;
      }
      i39 = HEAP32[i1 >> 2] | 0;
      i35 = HEAP32[i39 + 12 >> 2] | 0;
      if ((i35 | 0) == (HEAP32[i39 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i34 = invoke_ii(HEAP32[(HEAP32[i39 >> 2] | 0) + 36 >> 2] | 0, i39 | 0) | 0;
       i39 = __THREW__;
       __THREW__ = 0;
       if (i39 & 1) {
        i47 = 20;
        break;
       } else i134 = i34;
      } else i134 = HEAP32[i35 >> 2] | 0;
      if (!(HEAP8[i53 >> 0] & 1)) i135 = i42; else i135 = HEAP32[i40 >> 2] | 0;
      if ((i134 | 0) != (HEAP32[i135 + (i41 << 2) >> 2] | 0)) {
       i47 = 271;
       break;
      }
      i35 = i41 + 1 | 0;
      i34 = HEAP32[i1 >> 2] | 0;
      i39 = i34 + 12 | 0;
      i33 = HEAP32[i39 >> 2] | 0;
      if ((i33 | 0) == (HEAP32[i34 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i34 >> 2] | 0) + 40 >> 2] | 0, i34 | 0) | 0;
       i34 = __THREW__;
       __THREW__ = 0;
       if (i34 & 1) {
        i47 = 20;
        break;
       } else {
        i41 = i35;
        continue;
       }
      } else {
       HEAP32[i39 >> 2] = i33 + 4;
       i41 = i35;
       continue;
      }
     }
     if ((i47 | 0) == 20) {
      i41 = ___cxa_find_matching_catch() | 0;
      i28 = i41;
      i29 = tempRet0;
      break L1;
     } else if ((i47 | 0) == 271) {
      HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
      i129 = 0;
      break L314;
     }
    } while (0);
    i41 = HEAP32[i15 >> 2] | 0;
    if ((i41 | 0) != (i52 | 0) ? (HEAP32[i27 >> 2] = 0, __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i21, i41, i52, i27), (HEAP32[i27 >> 2] | 0) != 0) : 0) {
     HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
     i129 = 0;
    } else i129 = 1;
    break;
   }
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i25);
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i24);
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i23);
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i22);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  i41 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = 0;
  if ((i41 | 0) != 0 ? (__THREW__ = 0, invoke_vi(HEAP32[i11 >> 2] | 0, i41 | 0), i41 = __THREW__, __THREW__ = 0, i41 & 1) : 0) {
   i41 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i41);
  }
  STACKTOP = i12;
  return i129 | 0;
 } while (0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i25);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i24);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i23);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i22);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
 i21 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 if ((i21 | 0) != 0 ? (__THREW__ = 0, invoke_vi(HEAP32[i11 >> 2] | 0, i21 | 0), i21 = __THREW__, __THREW__ = 0, i21 & 1) : 0) {
  i21 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i21);
 }
 ___resumeException(i28 | 0);
 return 0;
}

function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 i13 = i12 + 88 | 0;
 i14 = i12 + 96 | 0;
 i15 = i12 + 80 | 0;
 i16 = i12 + 72 | 0;
 i17 = i12 + 68 | 0;
 i18 = i12 + 500 | 0;
 i19 = i12 + 497 | 0;
 i20 = i12 + 496 | 0;
 i21 = i12 + 56 | 0;
 i22 = i12 + 44 | 0;
 i23 = i12 + 32 | 0;
 i24 = i12 + 20 | 0;
 i25 = i12 + 8 | 0;
 i26 = i12 + 4 | 0;
 i27 = i12;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i15 >> 2] = i14;
 i11 = i15 + 4 | 0;
 HEAP32[i11 >> 2] = 287;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i17 >> 2] = i14 + 400;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 __THREW__ = 0;
 invoke_viiiiiiiiii(1, i3 | 0, i4 | 0, i18 | 0, i19 | 0, i20 | 0, i21 | 0, i22 | 0, i23 | 0, i24 | 0, i26 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i4 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  i28 = i3;
  i29 = tempRet0;
 } else {
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  i3 = i8 + 8 | 0;
  i30 = i23 + 4 | 0;
  i31 = i24 + 4 | 0;
  i32 = i24 + 8 | 0;
  i33 = i24 + 1 | 0;
  i34 = i23 + 8 | 0;
  i35 = i23 + 1 | 0;
  i36 = (i5 & 512 | 0) != 0;
  i37 = i22 + 8 | 0;
  i38 = i22 + 1 | 0;
  i39 = i22 + 4 | 0;
  i40 = i25 + 4 | 0;
  i41 = i25 + 8 | 0;
  i42 = i25 + 1 | 0;
  i43 = i18 + 3 | 0;
  i44 = i21 + 4 | 0;
  i45 = i14;
  i46 = 0;
  i47 = 0;
  L4 : while (1) {
   i48 = HEAP32[i1 >> 2] | 0;
   do if (i48) if ((HEAP32[i48 + 12 >> 2] | 0) == (HEAP32[i48 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i49 = invoke_ii(HEAP32[(HEAP32[i48 >> 2] | 0) + 36 >> 2] | 0, i48 | 0) | 0;
    i50 = __THREW__;
    __THREW__ = 0;
    if (i50 & 1) {
     i51 = 24;
     break L4;
    }
    if ((i49 | 0) == -1) {
     HEAP32[i1 >> 2] = 0;
     i52 = 0;
     break;
    } else {
     i52 = HEAP32[i1 >> 2] | 0;
     break;
    }
   } else i52 = i48; else i52 = 0; while (0);
   i48 = (i52 | 0) == 0;
   i49 = HEAP32[i2 >> 2] | 0;
   do if (i49) {
    if ((HEAP32[i49 + 12 >> 2] | 0) != (HEAP32[i49 + 16 >> 2] | 0)) if (i48) {
     i53 = i49;
     break;
    } else {
     i54 = i45;
     i55 = i47;
     i51 = 235;
     break L4;
    }
    __THREW__ = 0;
    i50 = invoke_ii(HEAP32[(HEAP32[i49 >> 2] | 0) + 36 >> 2] | 0, i49 | 0) | 0;
    i56 = __THREW__;
    __THREW__ = 0;
    if (i56 & 1) {
     i51 = 24;
     break L4;
    }
    if ((i50 | 0) != -1) if (i48) {
     i53 = i49;
     break;
    } else {
     i54 = i45;
     i55 = i47;
     i51 = 235;
     break L4;
    } else {
     HEAP32[i2 >> 2] = 0;
     i51 = 15;
     break;
    }
   } else i51 = 15; while (0);
   if ((i51 | 0) == 15) {
    i51 = 0;
    if (i48) {
     i54 = i45;
     i55 = i47;
     i51 = 235;
     break;
    } else i53 = 0;
   }
   L26 : do switch (HEAP8[i18 + i46 >> 0] | 0) {
   case 1:
    {
     if ((i46 | 0) != 3) {
      i49 = HEAP32[i1 >> 2] | 0;
      i50 = HEAP32[i49 + 12 >> 2] | 0;
      if ((i50 | 0) == (HEAP32[i49 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i56 = invoke_ii(HEAP32[(HEAP32[i49 >> 2] | 0) + 36 >> 2] | 0, i49 | 0) | 0;
       i49 = __THREW__;
       __THREW__ = 0;
       if (i49 & 1) {
        i51 = 24;
        break L4;
       } else i57 = i56;
      } else i57 = HEAPU8[i50 >> 0] | 0;
      if ((i57 & 255) << 24 >> 24 <= -1) {
       i51 = 40;
       break L4;
      }
      if (!(HEAP16[(HEAP32[i3 >> 2] | 0) + (i57 << 24 >> 24 << 1) >> 1] & 8192)) {
       i51 = 40;
       break L4;
      }
      i50 = HEAP32[i1 >> 2] | 0;
      i56 = i50 + 12 | 0;
      i49 = HEAP32[i56 >> 2] | 0;
      if ((i49 | 0) == (HEAP32[i50 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i58 = invoke_ii(HEAP32[(HEAP32[i50 >> 2] | 0) + 40 >> 2] | 0, i50 | 0) | 0;
       i50 = __THREW__;
       __THREW__ = 0;
       if (i50 & 1) {
        i51 = 24;
        break L4;
       } else i59 = i58;
      } else {
       HEAP32[i56 >> 2] = i49 + 1;
       i59 = HEAPU8[i49 >> 0] | 0;
      }
      __THREW__ = 0;
      invoke_vii(67, i25 | 0, i59 & 255 | 0);
      i49 = __THREW__;
      __THREW__ = 0;
      if (i49 & 1) {
       i51 = 24;
       break L4;
      } else {
       i60 = i53;
       i61 = i53;
       i51 = 42;
      }
     } else {
      i62 = i45;
      i63 = i47;
     }
     break;
    }
   case 0:
    {
     if ((i46 | 0) == 3) {
      i62 = i45;
      i63 = i47;
     } else {
      i60 = i53;
      i61 = i53;
      i51 = 42;
     }
     break;
    }
   case 3:
    {
     i49 = HEAP8[i23 >> 0] | 0;
     i56 = (i49 & 1) == 0 ? (i49 & 255) >>> 1 : HEAP32[i30 >> 2] | 0;
     i58 = HEAP8[i24 >> 0] | 0;
     i50 = (i58 & 1) == 0 ? (i58 & 255) >>> 1 : HEAP32[i31 >> 2] | 0;
     if ((i56 | 0) == (0 - i50 | 0)) {
      i62 = i45;
      i63 = i47;
     } else {
      if (!i56) {
       i56 = HEAP32[i1 >> 2] | 0;
       i64 = HEAP32[i56 + 12 >> 2] | 0;
       if ((i64 | 0) == (HEAP32[i56 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i65 = invoke_ii(HEAP32[(HEAP32[i56 >> 2] | 0) + 36 >> 2] | 0, i56 | 0) | 0;
        i56 = __THREW__;
        __THREW__ = 0;
        if (i56 & 1) {
         i51 = 24;
         break L4;
        }
        i66 = i65;
        i67 = HEAP8[i24 >> 0] | 0;
       } else {
        i66 = HEAPU8[i64 >> 0] | 0;
        i67 = i58;
       }
       if ((i66 & 255) << 24 >> 24 != (HEAP8[((i67 & 1) == 0 ? i33 : HEAP32[i32 >> 2] | 0) >> 0] | 0)) {
        i62 = i45;
        i63 = i47;
        break L26;
       }
       i58 = HEAP32[i1 >> 2] | 0;
       i64 = i58 + 12 | 0;
       i65 = HEAP32[i64 >> 2] | 0;
       if ((i65 | 0) == (HEAP32[i58 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i58 >> 2] | 0) + 40 >> 2] | 0, i58 | 0) | 0;
        i58 = __THREW__;
        __THREW__ = 0;
        if (i58 & 1) {
         i51 = 24;
         break L4;
        }
       } else HEAP32[i64 >> 2] = i65 + 1;
       HEAP8[i7 >> 0] = 1;
       i65 = HEAP8[i24 >> 0] | 0;
       i62 = i45;
       i63 = ((i65 & 1) == 0 ? (i65 & 255) >>> 1 : HEAP32[i31 >> 2] | 0) >>> 0 > 1 ? i24 : i47;
       break L26;
      }
      i65 = HEAP32[i1 >> 2] | 0;
      i64 = HEAP32[i65 + 12 >> 2] | 0;
      i58 = HEAP32[i65 + 16 >> 2] | 0;
      i56 = (i64 | 0) == (i58 | 0);
      if (!i50) {
       if (i56) {
        __THREW__ = 0;
        i50 = invoke_ii(HEAP32[(HEAP32[i65 >> 2] | 0) + 36 >> 2] | 0, i65 | 0) | 0;
        i68 = __THREW__;
        __THREW__ = 0;
        if (i68 & 1) {
         i51 = 24;
         break L4;
        }
        i69 = i50;
        i70 = HEAP8[i23 >> 0] | 0;
       } else {
        i69 = HEAPU8[i64 >> 0] | 0;
        i70 = i49;
       }
       if ((i69 & 255) << 24 >> 24 != (HEAP8[((i70 & 1) == 0 ? i35 : HEAP32[i34 >> 2] | 0) >> 0] | 0)) {
        HEAP8[i7 >> 0] = 1;
        i62 = i45;
        i63 = i47;
        break L26;
       }
       i50 = HEAP32[i1 >> 2] | 0;
       i68 = i50 + 12 | 0;
       i71 = HEAP32[i68 >> 2] | 0;
       if ((i71 | 0) == (HEAP32[i50 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i50 >> 2] | 0) + 40 >> 2] | 0, i50 | 0) | 0;
        i50 = __THREW__;
        __THREW__ = 0;
        if (i50 & 1) {
         i51 = 24;
         break L4;
        }
       } else HEAP32[i68 >> 2] = i71 + 1;
       i71 = HEAP8[i23 >> 0] | 0;
       i62 = i45;
       i63 = ((i71 & 1) == 0 ? (i71 & 255) >>> 1 : HEAP32[i30 >> 2] | 0) >>> 0 > 1 ? i23 : i47;
       break L26;
      }
      if (i56) {
       __THREW__ = 0;
       i56 = invoke_ii(HEAP32[(HEAP32[i65 >> 2] | 0) + 36 >> 2] | 0, i65 | 0) | 0;
       i71 = __THREW__;
       __THREW__ = 0;
       if (i71 & 1) {
        i51 = 24;
        break L4;
       }
       i71 = HEAP32[i1 >> 2] | 0;
       i72 = i56;
       i73 = HEAP8[i23 >> 0] | 0;
       i74 = i71;
       i75 = HEAP32[i71 + 12 >> 2] | 0;
       i76 = HEAP32[i71 + 16 >> 2] | 0;
      } else {
       i72 = HEAPU8[i64 >> 0] | 0;
       i73 = i49;
       i74 = i65;
       i75 = i64;
       i76 = i58;
      }
      i58 = i74 + 12 | 0;
      i64 = (i75 | 0) == (i76 | 0);
      if ((i72 & 255) << 24 >> 24 == (HEAP8[((i73 & 1) == 0 ? i35 : HEAP32[i34 >> 2] | 0) >> 0] | 0)) {
       if (i64) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i74 >> 2] | 0) + 40 >> 2] | 0, i74 | 0) | 0;
        i65 = __THREW__;
        __THREW__ = 0;
        if (i65 & 1) {
         i51 = 24;
         break L4;
        }
       } else HEAP32[i58 >> 2] = i75 + 1;
       i58 = HEAP8[i23 >> 0] | 0;
       i62 = i45;
       i63 = ((i58 & 1) == 0 ? (i58 & 255) >>> 1 : HEAP32[i30 >> 2] | 0) >>> 0 > 1 ? i23 : i47;
       break L26;
      }
      if (i64) {
       __THREW__ = 0;
       i64 = invoke_ii(HEAP32[(HEAP32[i74 >> 2] | 0) + 36 >> 2] | 0, i74 | 0) | 0;
       i58 = __THREW__;
       __THREW__ = 0;
       if (i58 & 1) {
        i51 = 24;
        break L4;
       } else i77 = i64;
      } else i77 = HEAPU8[i75 >> 0] | 0;
      if ((i77 & 255) << 24 >> 24 != (HEAP8[((HEAP8[i24 >> 0] & 1) == 0 ? i33 : HEAP32[i32 >> 2] | 0) >> 0] | 0)) {
       i51 = 104;
       break L4;
      }
      i64 = HEAP32[i1 >> 2] | 0;
      i58 = i64 + 12 | 0;
      i65 = HEAP32[i58 >> 2] | 0;
      if ((i65 | 0) == (HEAP32[i64 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i64 >> 2] | 0) + 40 >> 2] | 0, i64 | 0) | 0;
       i64 = __THREW__;
       __THREW__ = 0;
       if (i64 & 1) {
        i51 = 24;
        break L4;
       }
      } else HEAP32[i58 >> 2] = i65 + 1;
      HEAP8[i7 >> 0] = 1;
      i65 = HEAP8[i24 >> 0] | 0;
      i62 = i45;
      i63 = ((i65 & 1) == 0 ? (i65 & 255) >>> 1 : HEAP32[i31 >> 2] | 0) >>> 0 > 1 ? i24 : i47;
     }
     break;
    }
   case 2:
    {
     if (!(i46 >>> 0 < 2 | (i47 | 0) != 0) ? !(i36 | (i46 | 0) == 2 & (HEAP8[i43 >> 0] | 0) != 0) : 0) {
      i62 = i45;
      i63 = 0;
      break L26;
     }
     i65 = HEAP8[i22 >> 0] | 0;
     i58 = (i65 & 1) == 0;
     i64 = HEAP32[i37 >> 2] | 0;
     i49 = i58 ? i38 : i64;
     i71 = i49;
     L95 : do if ((i46 | 0) != 0 ? (HEAPU8[i18 + (i46 + -1) >> 0] | 0) < 2 : 0) {
      i56 = i58 ? (i65 & 255) >>> 1 : HEAP32[i39 >> 2] | 0;
      i68 = i49 + i56 | 0;
      i50 = HEAP32[i3 >> 2] | 0;
      L98 : do if (!i56) i78 = i71; else {
       i79 = i49;
       i80 = i71;
       while (1) {
        i81 = HEAP8[i79 >> 0] | 0;
        if (i81 << 24 >> 24 <= -1) {
         i78 = i80;
         break L98;
        }
        if (!(HEAP16[i50 + (i81 << 24 >> 24 << 1) >> 1] & 8192)) {
         i78 = i80;
         break L98;
        }
        i79 = i79 + 1 | 0;
        i81 = i79;
        if ((i79 | 0) == (i68 | 0)) {
         i78 = i81;
         break;
        } else i80 = i81;
       }
      } while (0);
      i68 = i78 - i71 | 0;
      i50 = HEAP8[i25 >> 0] | 0;
      i56 = (i50 & 1) == 0;
      i80 = i56 ? (i50 & 255) >>> 1 : HEAP32[i40 >> 2] | 0;
      if (i80 >>> 0 >= i68 >>> 0) {
       i50 = i56 ? i42 : HEAP32[i41 >> 2] | 0;
       i56 = i50 + i80 | 0;
       if ((i78 | 0) == (i71 | 0)) i82 = i78; else {
        i79 = i49;
        i81 = i50 + (i80 - i68) | 0;
        while (1) {
         if ((HEAP8[i81 >> 0] | 0) != (HEAP8[i79 >> 0] | 0)) {
          i82 = i71;
          break L95;
         }
         i81 = i81 + 1 | 0;
         if ((i81 | 0) == (i56 | 0)) {
          i82 = i78;
          break;
         } else i79 = i79 + 1 | 0;
        }
       }
      } else i82 = i71;
     } else i82 = i71; while (0);
     i71 = (i65 & 1) == 0;
     i49 = (i71 ? i38 : i64) + (i71 ? (i65 & 255) >>> 1 : HEAP32[i39 >> 2] | 0) | 0;
     i71 = i82;
     L110 : do if ((i71 | 0) == (i49 | 0)) i83 = i49; else {
      i58 = i53;
      i79 = i53;
      i56 = i71;
      while (1) {
       i81 = HEAP32[i1 >> 2] | 0;
       do if (i81) if ((HEAP32[i81 + 12 >> 2] | 0) == (HEAP32[i81 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i68 = invoke_ii(HEAP32[(HEAP32[i81 >> 2] | 0) + 36 >> 2] | 0, i81 | 0) | 0;
        i80 = __THREW__;
        __THREW__ = 0;
        if (i80 & 1) {
         i51 = 21;
         break L4;
        }
        if ((i68 | 0) == -1) {
         HEAP32[i1 >> 2] = 0;
         i84 = 0;
         break;
        } else {
         i84 = HEAP32[i1 >> 2] | 0;
         break;
        }
       } else i84 = i81; else i84 = 0; while (0);
       i81 = (i84 | 0) == 0;
       do if (i79) {
        if ((HEAP32[i79 + 12 >> 2] | 0) != (HEAP32[i79 + 16 >> 2] | 0)) if (i81) {
         i85 = i58;
         i86 = i79;
         break;
        } else {
         i83 = i56;
         break L110;
        }
        __THREW__ = 0;
        i68 = invoke_ii(HEAP32[(HEAP32[i79 >> 2] | 0) + 36 >> 2] | 0, i79 | 0) | 0;
        i80 = __THREW__;
        __THREW__ = 0;
        if (i80 & 1) {
         i51 = 21;
         break L4;
        }
        if ((i68 | 0) != -1) if (i81 ^ (i58 | 0) == 0) {
         i85 = i58;
         i86 = i58;
         break;
        } else {
         i83 = i56;
         break L110;
        } else {
         HEAP32[i2 >> 2] = 0;
         i87 = 0;
         i51 = 131;
         break;
        }
       } else {
        i87 = i58;
        i51 = 131;
       } while (0);
       if ((i51 | 0) == 131) {
        i51 = 0;
        if (i81) {
         i83 = i56;
         break L110;
        } else {
         i85 = i87;
         i86 = 0;
        }
       }
       i68 = HEAP32[i1 >> 2] | 0;
       i80 = HEAP32[i68 + 12 >> 2] | 0;
       if ((i80 | 0) == (HEAP32[i68 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i50 = invoke_ii(HEAP32[(HEAP32[i68 >> 2] | 0) + 36 >> 2] | 0, i68 | 0) | 0;
        i68 = __THREW__;
        __THREW__ = 0;
        if (i68 & 1) {
         i51 = 21;
         break L4;
        } else i88 = i50;
       } else i88 = HEAPU8[i80 >> 0] | 0;
       if ((i88 & 255) << 24 >> 24 != (HEAP8[i56 >> 0] | 0)) {
        i83 = i56;
        break L110;
       }
       i80 = HEAP32[i1 >> 2] | 0;
       i50 = i80 + 12 | 0;
       i68 = HEAP32[i50 >> 2] | 0;
       if ((i68 | 0) == (HEAP32[i80 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i80 >> 2] | 0) + 40 >> 2] | 0, i80 | 0) | 0;
        i80 = __THREW__;
        __THREW__ = 0;
        if (i80 & 1) {
         i51 = 21;
         break L4;
        }
       } else HEAP32[i50 >> 2] = i68 + 1;
       i56 = i56 + 1 | 0;
       i68 = HEAP8[i22 >> 0] | 0;
       i50 = (i68 & 1) == 0;
       i80 = (i50 ? i38 : HEAP32[i37 >> 2] | 0) + (i50 ? (i68 & 255) >>> 1 : HEAP32[i39 >> 2] | 0) | 0;
       if ((i56 | 0) == (i80 | 0)) {
        i83 = i80;
        break;
       } else {
        i58 = i85;
        i79 = i86;
       }
      }
     } while (0);
     if (i36 ? (i71 = HEAP8[i22 >> 0] | 0, i49 = (i71 & 1) == 0, (i83 | 0) != ((i49 ? i38 : HEAP32[i37 >> 2] | 0) + (i49 ? (i71 & 255) >>> 1 : HEAP32[i39 >> 2] | 0) | 0)) : 0) {
      i51 = 143;
      break L4;
     } else {
      i62 = i45;
      i63 = i47;
     }
     break;
    }
   case 4:
    {
     i71 = HEAP8[i20 >> 0] | 0;
     i49 = i53;
     i65 = i53;
     i64 = i45;
     i79 = 0;
     L145 : while (1) {
      i58 = HEAP32[i1 >> 2] | 0;
      do if (i58) if ((HEAP32[i58 + 12 >> 2] | 0) == (HEAP32[i58 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i56 = invoke_ii(HEAP32[(HEAP32[i58 >> 2] | 0) + 36 >> 2] | 0, i58 | 0) | 0;
       i80 = __THREW__;
       __THREW__ = 0;
       if (i80 & 1) {
        i51 = 23;
        break L4;
       }
       if ((i56 | 0) == -1) {
        HEAP32[i1 >> 2] = 0;
        i89 = 0;
        break;
       } else {
        i89 = HEAP32[i1 >> 2] | 0;
        break;
       }
      } else i89 = i58; else i89 = 0; while (0);
      i58 = (i89 | 0) == 0;
      do if (i65) {
       if ((HEAP32[i65 + 12 >> 2] | 0) != (HEAP32[i65 + 16 >> 2] | 0)) if (i58) {
        i90 = i49;
        i91 = i65;
        break;
       } else {
        i92 = i64;
        i93 = i49;
        i94 = i79;
        break L145;
       }
       __THREW__ = 0;
       i56 = invoke_ii(HEAP32[(HEAP32[i65 >> 2] | 0) + 36 >> 2] | 0, i65 | 0) | 0;
       i80 = __THREW__;
       __THREW__ = 0;
       if (i80 & 1) {
        i51 = 23;
        break L4;
       }
       if ((i56 | 0) != -1) if (i58 ^ (i49 | 0) == 0) {
        i90 = i49;
        i91 = i49;
        break;
       } else {
        i92 = i64;
        i93 = i49;
        i94 = i79;
        break L145;
       } else {
        HEAP32[i2 >> 2] = 0;
        i95 = 0;
        i51 = 156;
        break;
       }
      } else {
       i95 = i49;
       i51 = 156;
      } while (0);
      if ((i51 | 0) == 156) {
       i51 = 0;
       if (i58) {
        i92 = i64;
        i93 = i95;
        i94 = i79;
        break;
       } else {
        i90 = i95;
        i91 = 0;
       }
      }
      i56 = HEAP32[i1 >> 2] | 0;
      i80 = HEAP32[i56 + 12 >> 2] | 0;
      if ((i80 | 0) == (HEAP32[i56 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i68 = invoke_ii(HEAP32[(HEAP32[i56 >> 2] | 0) + 36 >> 2] | 0, i56 | 0) | 0;
       i56 = __THREW__;
       __THREW__ = 0;
       if (i56 & 1) {
        i51 = 23;
        break L4;
       } else i96 = i68;
      } else i96 = HEAPU8[i80 >> 0] | 0;
      i80 = i96 & 255;
      if (i80 << 24 >> 24 > -1 ? (HEAP16[(HEAP32[i3 >> 2] | 0) + (i96 << 24 >> 24 << 1) >> 1] & 2048) != 0 : 0) {
       i68 = HEAP32[i10 >> 2] | 0;
       if ((i68 | 0) == (HEAP32[i13 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(10, i9 | 0, i10 | 0, i13 | 0);
        i56 = __THREW__;
        __THREW__ = 0;
        if (i56 & 1) {
         i51 = 23;
         break L4;
        }
        i97 = HEAP32[i10 >> 2] | 0;
       } else i97 = i68;
       HEAP32[i10 >> 2] = i97 + 1;
       HEAP8[i97 >> 0] = i80;
       i98 = i64;
       i99 = i79 + 1 | 0;
      } else {
       i68 = HEAP8[i21 >> 0] | 0;
       if (!(i80 << 24 >> 24 == i71 << 24 >> 24 & ((i79 | 0) != 0 ? (((i68 & 1) == 0 ? (i68 & 255) >>> 1 : HEAP32[i44 >> 2] | 0) | 0) != 0 : 0))) {
        i92 = i64;
        i93 = i90;
        i94 = i79;
        break;
       }
       if ((i64 | 0) == (HEAP32[i17 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(11, i15 | 0, i16 | 0, i17 | 0);
        i68 = __THREW__;
        __THREW__ = 0;
        if (i68 & 1) {
         i51 = 23;
         break L4;
        }
        i100 = HEAP32[i16 >> 2] | 0;
       } else i100 = i64;
       i68 = i100 + 4 | 0;
       HEAP32[i16 >> 2] = i68;
       HEAP32[i100 >> 2] = i79;
       i98 = i68;
       i99 = 0;
      }
      i68 = HEAP32[i1 >> 2] | 0;
      i80 = i68 + 12 | 0;
      i56 = HEAP32[i80 >> 2] | 0;
      if ((i56 | 0) == (HEAP32[i68 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i68 >> 2] | 0) + 40 >> 2] | 0, i68 | 0) | 0;
       i68 = __THREW__;
       __THREW__ = 0;
       if (i68 & 1) {
        i51 = 23;
        break L4;
       } else {
        i49 = i90;
        i65 = i91;
        i64 = i98;
        i79 = i99;
        continue;
       }
      } else {
       HEAP32[i80 >> 2] = i56 + 1;
       i49 = i90;
       i65 = i91;
       i64 = i98;
       i79 = i99;
       continue;
      }
     }
     if ((i94 | 0) != 0 ? (HEAP32[i15 >> 2] | 0) != (i92 | 0) : 0) {
      if ((i92 | 0) == (HEAP32[i17 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_viii(11, i15 | 0, i16 | 0, i17 | 0);
       i79 = __THREW__;
       __THREW__ = 0;
       if (i79 & 1) {
        i51 = 24;
        break L4;
       }
       i101 = HEAP32[i16 >> 2] | 0;
      } else i101 = i92;
      i79 = i101 + 4 | 0;
      HEAP32[i16 >> 2] = i79;
      HEAP32[i101 >> 2] = i94;
      i102 = i79;
     } else i102 = i92;
     i79 = HEAP32[i26 >> 2] | 0;
     if ((i79 | 0) > 0) {
      i64 = HEAP32[i1 >> 2] | 0;
      do if (i64) if ((HEAP32[i64 + 12 >> 2] | 0) == (HEAP32[i64 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i65 = invoke_ii(HEAP32[(HEAP32[i64 >> 2] | 0) + 36 >> 2] | 0, i64 | 0) | 0;
       i49 = __THREW__;
       __THREW__ = 0;
       if (i49 & 1) {
        i51 = 24;
        break L4;
       }
       if ((i65 | 0) == -1) {
        HEAP32[i1 >> 2] = 0;
        i103 = 0;
        break;
       } else {
        i103 = HEAP32[i1 >> 2] | 0;
        break;
       }
      } else i103 = i64; else i103 = 0; while (0);
      i64 = (i103 | 0) == 0;
      do if (i93) {
       if ((HEAP32[i93 + 12 >> 2] | 0) == (HEAP32[i93 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i65 = invoke_ii(HEAP32[(HEAP32[i93 >> 2] | 0) + 36 >> 2] | 0, i93 | 0) | 0;
        i49 = __THREW__;
        __THREW__ = 0;
        if (i49 & 1) {
         i51 = 24;
         break L4;
        }
        if ((i65 | 0) == -1) {
         HEAP32[i2 >> 2] = 0;
         i51 = 193;
         break;
        }
       }
       if (i64) i104 = i93; else {
        i51 = 198;
        break L4;
       }
      } else i51 = 193; while (0);
      if ((i51 | 0) == 193) {
       i51 = 0;
       if (i64) {
        i51 = 198;
        break L4;
       } else i104 = 0;
      }
      i65 = HEAP32[i1 >> 2] | 0;
      i49 = HEAP32[i65 + 12 >> 2] | 0;
      if ((i49 | 0) == (HEAP32[i65 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i71 = invoke_ii(HEAP32[(HEAP32[i65 >> 2] | 0) + 36 >> 2] | 0, i65 | 0) | 0;
       i65 = __THREW__;
       __THREW__ = 0;
       if (i65 & 1) {
        i51 = 24;
        break L4;
       } else i105 = i71;
      } else i105 = HEAPU8[i49 >> 0] | 0;
      if ((i105 & 255) << 24 >> 24 != (HEAP8[i19 >> 0] | 0)) {
       i51 = 198;
       break L4;
      }
      i49 = HEAP32[i1 >> 2] | 0;
      i71 = i49 + 12 | 0;
      i65 = HEAP32[i71 >> 2] | 0;
      if ((i65 | 0) == (HEAP32[i49 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i49 >> 2] | 0) + 40 >> 2] | 0, i49 | 0) | 0;
       i49 = __THREW__;
       __THREW__ = 0;
       if (i49 & 1) {
        i51 = 24;
        break L4;
       }
      } else HEAP32[i71 >> 2] = i65 + 1;
      if ((i79 | 0) > 0) {
       i65 = i104;
       i71 = i104;
       i49 = i79;
       while (1) {
        i56 = HEAP32[i1 >> 2] | 0;
        do if (i56) if ((HEAP32[i56 + 12 >> 2] | 0) == (HEAP32[i56 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         i80 = invoke_ii(HEAP32[(HEAP32[i56 >> 2] | 0) + 36 >> 2] | 0, i56 | 0) | 0;
         i68 = __THREW__;
         __THREW__ = 0;
         if (i68 & 1) {
          i51 = 22;
          break L4;
         }
         if ((i80 | 0) == -1) {
          HEAP32[i1 >> 2] = 0;
          i106 = 0;
          break;
         } else {
          i106 = HEAP32[i1 >> 2] | 0;
          break;
         }
        } else i106 = i56; else i106 = 0; while (0);
        i56 = (i106 | 0) == 0;
        do if (i71) {
         if ((HEAP32[i71 + 12 >> 2] | 0) != (HEAP32[i71 + 16 >> 2] | 0)) if (i56) {
          i107 = i65;
          i108 = i71;
          break;
         } else {
          i51 = 222;
          break L4;
         }
         __THREW__ = 0;
         i58 = invoke_ii(HEAP32[(HEAP32[i71 >> 2] | 0) + 36 >> 2] | 0, i71 | 0) | 0;
         i80 = __THREW__;
         __THREW__ = 0;
         if (i80 & 1) {
          i51 = 22;
          break L4;
         }
         if ((i58 | 0) != -1) if (i56 ^ (i65 | 0) == 0) {
          i107 = i65;
          i108 = i65;
          break;
         } else {
          i51 = 222;
          break L4;
         } else {
          HEAP32[i2 >> 2] = 0;
          i109 = 0;
          i51 = 215;
          break;
         }
        } else {
         i109 = i65;
         i51 = 215;
        } while (0);
        if ((i51 | 0) == 215) {
         i51 = 0;
         if (i56) {
          i51 = 222;
          break L4;
         } else {
          i107 = i109;
          i108 = 0;
         }
        }
        i58 = HEAP32[i1 >> 2] | 0;
        i80 = HEAP32[i58 + 12 >> 2] | 0;
        if ((i80 | 0) == (HEAP32[i58 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         i68 = invoke_ii(HEAP32[(HEAP32[i58 >> 2] | 0) + 36 >> 2] | 0, i58 | 0) | 0;
         i58 = __THREW__;
         __THREW__ = 0;
         if (i58 & 1) {
          i51 = 22;
          break L4;
         } else i110 = i68;
        } else i110 = HEAPU8[i80 >> 0] | 0;
        if ((i110 & 255) << 24 >> 24 <= -1) {
         i51 = 222;
         break L4;
        }
        if (!(HEAP16[(HEAP32[i3 >> 2] | 0) + (i110 << 24 >> 24 << 1) >> 1] & 2048)) {
         i51 = 222;
         break L4;
        }
        if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i13 >> 2] | 0) ? (__THREW__ = 0, invoke_viii(10, i9 | 0, i10 | 0, i13 | 0), i80 = __THREW__, __THREW__ = 0, i80 & 1) : 0) {
         i51 = 22;
         break L4;
        }
        i80 = HEAP32[i1 >> 2] | 0;
        i68 = HEAP32[i80 + 12 >> 2] | 0;
        if ((i68 | 0) == (HEAP32[i80 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         i58 = invoke_ii(HEAP32[(HEAP32[i80 >> 2] | 0) + 36 >> 2] | 0, i80 | 0) | 0;
         i80 = __THREW__;
         __THREW__ = 0;
         if (i80 & 1) {
          i51 = 22;
          break L4;
         } else i111 = i58;
        } else i111 = HEAPU8[i68 >> 0] | 0;
        i68 = HEAP32[i10 >> 2] | 0;
        HEAP32[i10 >> 2] = i68 + 1;
        HEAP8[i68 >> 0] = i111;
        i68 = i49;
        i49 = i49 + -1 | 0;
        HEAP32[i26 >> 2] = i49;
        i58 = HEAP32[i1 >> 2] | 0;
        i80 = i58 + 12 | 0;
        i50 = HEAP32[i80 >> 2] | 0;
        if ((i50 | 0) == (HEAP32[i58 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         invoke_ii(HEAP32[(HEAP32[i58 >> 2] | 0) + 40 >> 2] | 0, i58 | 0) | 0;
         i58 = __THREW__;
         __THREW__ = 0;
         if (i58 & 1) {
          i51 = 22;
          break L4;
         }
        } else HEAP32[i80 >> 2] = i50 + 1;
        if ((i68 | 0) <= 1) break; else {
         i65 = i107;
         i71 = i108;
        }
       }
      }
     }
     if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) {
      i51 = 233;
      break L4;
     } else {
      i62 = i102;
      i63 = i47;
     }
     break;
    }
   default:
    {
     i62 = i45;
     i63 = i47;
    }
   } while (0);
   L266 : do if ((i51 | 0) == 42) while (1) {
    i51 = 0;
    i48 = HEAP32[i1 >> 2] | 0;
    do if (i48) if ((HEAP32[i48 + 12 >> 2] | 0) == (HEAP32[i48 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i71 = invoke_ii(HEAP32[(HEAP32[i48 >> 2] | 0) + 36 >> 2] | 0, i48 | 0) | 0;
     i65 = __THREW__;
     __THREW__ = 0;
     if (i65 & 1) {
      i51 = 20;
      break L4;
     }
     if ((i71 | 0) == -1) {
      HEAP32[i1 >> 2] = 0;
      i112 = 0;
      break;
     } else {
      i112 = HEAP32[i1 >> 2] | 0;
      break;
     }
    } else i112 = i48; else i112 = 0; while (0);
    i48 = (i112 | 0) == 0;
    do if (i61) {
     if ((HEAP32[i61 + 12 >> 2] | 0) != (HEAP32[i61 + 16 >> 2] | 0)) if (i48) {
      i113 = i60;
      i114 = i61;
      break;
     } else {
      i62 = i45;
      i63 = i47;
      break L266;
     }
     __THREW__ = 0;
     i56 = invoke_ii(HEAP32[(HEAP32[i61 >> 2] | 0) + 36 >> 2] | 0, i61 | 0) | 0;
     i71 = __THREW__;
     __THREW__ = 0;
     if (i71 & 1) {
      i51 = 20;
      break L4;
     }
     if ((i56 | 0) != -1) if (i48 ^ (i60 | 0) == 0) {
      i113 = i60;
      i114 = i60;
      break;
     } else {
      i62 = i45;
      i63 = i47;
      break L266;
     } else {
      HEAP32[i2 >> 2] = 0;
      i115 = 0;
      i51 = 54;
      break;
     }
    } else {
     i115 = i60;
     i51 = 54;
    } while (0);
    if ((i51 | 0) == 54) {
     i51 = 0;
     if (i48) {
      i62 = i45;
      i63 = i47;
      break L266;
     } else {
      i113 = i115;
      i114 = 0;
     }
    }
    i56 = HEAP32[i1 >> 2] | 0;
    i71 = HEAP32[i56 + 12 >> 2] | 0;
    if ((i71 | 0) == (HEAP32[i56 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i65 = invoke_ii(HEAP32[(HEAP32[i56 >> 2] | 0) + 36 >> 2] | 0, i56 | 0) | 0;
     i56 = __THREW__;
     __THREW__ = 0;
     if (i56 & 1) {
      i51 = 20;
      break L4;
     } else i116 = i65;
    } else i116 = HEAPU8[i71 >> 0] | 0;
    if ((i116 & 255) << 24 >> 24 <= -1) {
     i62 = i45;
     i63 = i47;
     break L266;
    }
    if (!(HEAP16[(HEAP32[i3 >> 2] | 0) + (i116 << 24 >> 24 << 1) >> 1] & 8192)) {
     i62 = i45;
     i63 = i47;
     break L266;
    }
    i71 = HEAP32[i1 >> 2] | 0;
    i65 = i71 + 12 | 0;
    i56 = HEAP32[i65 >> 2] | 0;
    if ((i56 | 0) == (HEAP32[i71 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i49 = invoke_ii(HEAP32[(HEAP32[i71 >> 2] | 0) + 40 >> 2] | 0, i71 | 0) | 0;
     i71 = __THREW__;
     __THREW__ = 0;
     if (i71 & 1) {
      i51 = 20;
      break L4;
     } else i117 = i49;
    } else {
     HEAP32[i65 >> 2] = i56 + 1;
     i117 = HEAPU8[i56 >> 0] | 0;
    }
    __THREW__ = 0;
    invoke_vii(67, i25 | 0, i117 & 255 | 0);
    i56 = __THREW__;
    __THREW__ = 0;
    if (i56 & 1) {
     i51 = 20;
     break L4;
    } else {
     i60 = i113;
     i61 = i114;
     i51 = 42;
    }
   } while (0);
   i46 = i46 + 1 | 0;
   if (i46 >>> 0 >= 4) {
    i54 = i62;
    i55 = i63;
    i51 = 235;
    break;
   } else {
    i45 = i62;
    i47 = i63;
   }
  }
  L300 : switch (i51 | 0) {
  case 20:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 21:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 22:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 23:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 24:
   {
    i28 = ___cxa_find_matching_catch() | 0;
    i29 = tempRet0;
    break L1;
    break;
   }
  case 40:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i118 = 0;
    break;
   }
  case 104:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i118 = 0;
    break;
   }
  case 143:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i118 = 0;
    break;
   }
  case 198:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i118 = 0;
    break;
   }
  case 222:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i118 = 0;
    break;
   }
  case 233:
   {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i118 = 0;
    break;
   }
  case 235:
   {
    L302 : do if (i55) {
     i47 = i55 + 1 | 0;
     i45 = i55 + 8 | 0;
     i46 = i55 + 4 | 0;
     i3 = 1;
     L304 : while (1) {
      i44 = HEAP8[i55 >> 0] | 0;
      if (!(i44 & 1)) i119 = (i44 & 255) >>> 1; else i119 = HEAP32[i46 >> 2] | 0;
      if (i3 >>> 0 >= i119 >>> 0) break L302;
      i44 = HEAP32[i1 >> 2] | 0;
      do if (i44) if ((HEAP32[i44 + 12 >> 2] | 0) == (HEAP32[i44 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i39 = invoke_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 36 >> 2] | 0, i44 | 0) | 0;
       i37 = __THREW__;
       __THREW__ = 0;
       if (i37 & 1) {
        i51 = 19;
        break L304;
       }
       if ((i39 | 0) == -1) {
        HEAP32[i1 >> 2] = 0;
        i120 = 0;
        break;
       } else {
        i120 = HEAP32[i1 >> 2] | 0;
        break;
       }
      } else i120 = i44; else i120 = 0; while (0);
      i44 = (i120 | 0) == 0;
      i39 = HEAP32[i2 >> 2] | 0;
      do if (i39) {
       if ((HEAP32[i39 + 12 >> 2] | 0) == (HEAP32[i39 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i37 = invoke_ii(HEAP32[(HEAP32[i39 >> 2] | 0) + 36 >> 2] | 0, i39 | 0) | 0;
        i38 = __THREW__;
        __THREW__ = 0;
        if (i38 & 1) {
         i51 = 19;
         break L304;
        }
        if ((i37 | 0) == -1) {
         HEAP32[i2 >> 2] = 0;
         i51 = 253;
         break;
        }
       }
       if (!i44) {
        i51 = 260;
        break L304;
       }
      } else i51 = 253; while (0);
      if ((i51 | 0) == 253 ? (i51 = 0, i44) : 0) {
       i51 = 260;
       break;
      }
      i39 = HEAP32[i1 >> 2] | 0;
      i37 = HEAP32[i39 + 12 >> 2] | 0;
      if ((i37 | 0) == (HEAP32[i39 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i38 = invoke_ii(HEAP32[(HEAP32[i39 >> 2] | 0) + 36 >> 2] | 0, i39 | 0) | 0;
       i39 = __THREW__;
       __THREW__ = 0;
       if (i39 & 1) {
        i51 = 19;
        break;
       } else i121 = i38;
      } else i121 = HEAPU8[i37 >> 0] | 0;
      if (!(HEAP8[i55 >> 0] & 1)) i122 = i47; else i122 = HEAP32[i45 >> 2] | 0;
      if ((i121 & 255) << 24 >> 24 != (HEAP8[i122 + i3 >> 0] | 0)) {
       i51 = 260;
       break;
      }
      i37 = i3 + 1 | 0;
      i38 = HEAP32[i1 >> 2] | 0;
      i39 = i38 + 12 | 0;
      i36 = HEAP32[i39 >> 2] | 0;
      if ((i36 | 0) == (HEAP32[i38 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i38 >> 2] | 0) + 40 >> 2] | 0, i38 | 0) | 0;
       i38 = __THREW__;
       __THREW__ = 0;
       if (i38 & 1) {
        i51 = 19;
        break;
       } else {
        i3 = i37;
        continue;
       }
      } else {
       HEAP32[i39 >> 2] = i36 + 1;
       i3 = i37;
       continue;
      }
     }
     if ((i51 | 0) == 19) {
      i3 = ___cxa_find_matching_catch() | 0;
      i28 = i3;
      i29 = tempRet0;
      break L1;
     } else if ((i51 | 0) == 260) {
      HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
      i118 = 0;
      break L300;
     }
    } while (0);
    i3 = HEAP32[i15 >> 2] | 0;
    if ((i3 | 0) != (i54 | 0) ? (HEAP32[i27 >> 2] = 0, __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i21, i3, i54, i27), (HEAP32[i27 >> 2] | 0) != 0) : 0) {
     HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
     i118 = 0;
    } else i118 = 1;
    break;
   }
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  i3 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = 0;
  if ((i3 | 0) != 0 ? (__THREW__ = 0, invoke_vi(HEAP32[i11 >> 2] | 0, i3 | 0), i3 = __THREW__, __THREW__ = 0, i3 & 1) : 0) {
   i3 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i3);
  }
  STACKTOP = i12;
  return i118 | 0;
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
 i21 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 if ((i21 | 0) != 0 ? (__THREW__ = 0, invoke_vi(HEAP32[i11 >> 2] | 0, i21 | 0), i21 = __THREW__, __THREW__ = 0, i21 & 1) : 0) {
  i21 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i21);
 }
 ___resumeException(i28 | 0);
 return 0;
}

function ___floatscan(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, d44 = 0.0, i45 = 0, d46 = 0.0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, d57 = 0.0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, d65 = 0.0, i66 = 0, d67 = 0.0, d68 = 0.0, i69 = 0, d70 = 0.0, i71 = 0, d72 = 0.0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, d82 = 0.0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, d87 = 0.0, i88 = 0, i89 = 0, i90 = 0, d91 = 0.0, d92 = 0.0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, d159 = 0.0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, d212 = 0.0, d213 = 0.0, d214 = 0.0, d215 = 0.0, d216 = 0.0, d217 = 0.0, d218 = 0.0, i219 = 0, i220 = 0, d221 = 0.0, i222 = 0, d223 = 0.0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 i5 = i4;
 switch (i2 | 0) {
 case 0:
  {
   i6 = 24;
   i7 = -149;
   i8 = 4;
   break;
  }
 case 1:
  {
   i6 = 53;
   i7 = -1074;
   i8 = 4;
   break;
  }
 case 2:
  {
   i6 = 53;
   i7 = -1074;
   i8 = 4;
   break;
  }
 default:
  d9 = 0.0;
 }
 L4 : do if ((i8 | 0) == 4) {
  i2 = i1 + 4 | 0;
  i10 = i1 + 100 | 0;
  do {
   i11 = HEAP32[i2 >> 2] | 0;
   if (i11 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
    HEAP32[i2 >> 2] = i11 + 1;
    i12 = HEAPU8[i11 >> 0] | 0;
   } else i12 = ___shgetc(i1) | 0;
  } while ((_isspace(i12) | 0) != 0);
  i13 = i12;
  L13 : do switch (i13 | 0) {
  case 43:
  case 45:
   {
    i11 = 1 - (((i13 | 0) == 45 & 1) << 1) | 0;
    i14 = HEAP32[i2 >> 2] | 0;
    if (i14 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
     HEAP32[i2 >> 2] = i14 + 1;
     i15 = HEAPU8[i14 >> 0] | 0;
     i16 = i11;
     break L13;
    } else {
     i15 = ___shgetc(i1) | 0;
     i16 = i11;
     break L13;
    }
    break;
   }
  default:
   {
    i15 = i13;
    i16 = 1;
   }
  } while (0);
  i11 = i15;
  i14 = 0;
  while (1) {
   if ((i11 | 32 | 0) != (HEAP8[42577 + i14 >> 0] | 0)) {
    i17 = i11;
    i18 = i14;
    break;
   }
   do if (i14 >>> 0 < 7) {
    i19 = HEAP32[i2 >> 2] | 0;
    if (i19 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
     HEAP32[i2 >> 2] = i19 + 1;
     i20 = HEAPU8[i19 >> 0] | 0;
     break;
    } else {
     i20 = ___shgetc(i1) | 0;
     break;
    }
   } else i20 = i11; while (0);
   i19 = i14 + 1 | 0;
   if (i19 >>> 0 < 8) {
    i11 = i20;
    i14 = i19;
   } else {
    i17 = i20;
    i18 = i19;
    break;
   }
  }
  L29 : do switch (i18 | 0) {
  case 8:
   break;
  case 3:
   {
    i8 = 23;
    break;
   }
  default:
   {
    i14 = (i3 | 0) != 0;
    if (i14 & i18 >>> 0 > 3) if ((i18 | 0) == 8) break L29; else {
     i8 = 23;
     break L29;
    }
    L34 : do if (!i18) {
     i11 = i17;
     i19 = 0;
     while (1) {
      if ((i11 | 32 | 0) != (HEAP8[45454 + i19 >> 0] | 0)) {
       i21 = i11;
       i22 = i19;
       break L34;
      }
      do if (i19 >>> 0 < 2) {
       i23 = HEAP32[i2 >> 2] | 0;
       if (i23 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
        HEAP32[i2 >> 2] = i23 + 1;
        i24 = HEAPU8[i23 >> 0] | 0;
        break;
       } else {
        i24 = ___shgetc(i1) | 0;
        break;
       }
      } else i24 = i11; while (0);
      i23 = i19 + 1 | 0;
      if (i23 >>> 0 < 3) {
       i11 = i24;
       i19 = i23;
      } else {
       i21 = i24;
       i22 = i23;
       break;
      }
     }
    } else {
     i21 = i17;
     i22 = i18;
    } while (0);
    switch (i22 | 0) {
    case 3:
     {
      i19 = HEAP32[i2 >> 2] | 0;
      if (i19 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
       HEAP32[i2 >> 2] = i19 + 1;
       i25 = HEAPU8[i19 >> 0] | 0;
      } else i25 = ___shgetc(i1) | 0;
      if ((i25 | 0) == 40) i26 = 1; else {
       if (!(HEAP32[i10 >> 2] | 0)) {
        d9 = nan;
        break L4;
       }
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
       d9 = nan;
       break L4;
      }
      while (1) {
       i19 = HEAP32[i2 >> 2] | 0;
       if (i19 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
        HEAP32[i2 >> 2] = i19 + 1;
        i27 = HEAPU8[i19 >> 0] | 0;
       } else i27 = ___shgetc(i1) | 0;
       if (!((i27 + -48 | 0) >>> 0 < 10 | (i27 + -65 | 0) >>> 0 < 26) ? !((i27 | 0) == 95 | (i27 + -97 | 0) >>> 0 < 26) : 0) {
        i28 = i27;
        i29 = i26;
        break;
       }
       i26 = i26 + 1 | 0;
      }
      if ((i28 | 0) == 41) {
       d9 = nan;
       break L4;
      }
      i19 = (HEAP32[i10 >> 2] | 0) == 0;
      if (!i19) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
      if (!i14) {
       i11 = ___errno_location() | 0;
       HEAP32[i11 >> 2] = 22;
       ___shlim(i1, 0);
       d9 = 0.0;
       break L4;
      }
      if (!i29) {
       d9 = nan;
       break L4;
      } else i30 = i29;
      while (1) {
       i30 = i30 + -1 | 0;
       if (!i19) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
       if (!i30) {
        d9 = nan;
        break L4;
       }
      }
      break;
     }
    case 0:
     {
      do if ((i21 | 0) == 48) {
       i19 = HEAP32[i2 >> 2] | 0;
       if (i19 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
        HEAP32[i2 >> 2] = i19 + 1;
        i31 = HEAPU8[i19 >> 0] | 0;
       } else i31 = ___shgetc(i1) | 0;
       if ((i31 | 32 | 0) != 120) {
        if (!(HEAP32[i10 >> 2] | 0)) {
         i32 = 48;
         break;
        }
        HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
        i32 = 48;
        break;
       }
       i19 = HEAP32[i2 >> 2] | 0;
       if (i19 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
        HEAP32[i2 >> 2] = i19 + 1;
        i33 = HEAPU8[i19 >> 0] | 0;
        i34 = 0;
       } else {
        i33 = ___shgetc(i1) | 0;
        i34 = 0;
       }
       L94 : while (1) {
        switch (i33 | 0) {
        case 46:
         {
          i35 = i34;
          i8 = 74;
          break L94;
          break;
         }
        case 48:
         break;
        default:
         {
          i36 = 0;
          i37 = 0;
          i38 = 0;
          i39 = 0;
          i40 = i33;
          i41 = i34;
          i42 = 0;
          i43 = 0;
          d44 = 1.0;
          i45 = 0;
          d46 = 0.0;
          break L94;
         }
        }
        i19 = HEAP32[i2 >> 2] | 0;
        if (i19 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
         HEAP32[i2 >> 2] = i19 + 1;
         i33 = HEAPU8[i19 >> 0] | 0;
         i34 = 1;
         continue;
        } else {
         i33 = ___shgetc(i1) | 0;
         i34 = 1;
         continue;
        }
       }
       if ((i8 | 0) == 74) {
        i19 = HEAP32[i2 >> 2] | 0;
        if (i19 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
         HEAP32[i2 >> 2] = i19 + 1;
         i47 = HEAPU8[i19 >> 0] | 0;
        } else i47 = ___shgetc(i1) | 0;
        if ((i47 | 0) == 48) {
         i19 = 0;
         i14 = 0;
         while (1) {
          i11 = HEAP32[i2 >> 2] | 0;
          if (i11 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
           HEAP32[i2 >> 2] = i11 + 1;
           i48 = HEAPU8[i11 >> 0] | 0;
          } else i48 = ___shgetc(i1) | 0;
          i11 = _i64Add(i19 | 0, i14 | 0, -1, -1) | 0;
          i23 = tempRet0;
          if ((i48 | 0) == 48) {
           i19 = i11;
           i14 = i23;
          } else {
           i36 = 0;
           i37 = 0;
           i38 = i11;
           i39 = i23;
           i40 = i48;
           i41 = 1;
           i42 = 1;
           i43 = 0;
           d44 = 1.0;
           i45 = 0;
           d46 = 0.0;
           break;
          }
         }
        } else {
         i36 = 0;
         i37 = 0;
         i38 = 0;
         i39 = 0;
         i40 = i47;
         i41 = i35;
         i42 = 1;
         i43 = 0;
         d44 = 1.0;
         i45 = 0;
         d46 = 0.0;
        }
       }
       while (1) {
        i14 = i40 + -48 | 0;
        i19 = i40 | 32;
        if (i14 >>> 0 >= 10) {
         i23 = (i40 | 0) == 46;
         if (!(i23 | (i19 + -97 | 0) >>> 0 < 6)) {
          i49 = i37;
          i50 = i38;
          i51 = i36;
          i52 = i39;
          i53 = i40;
          i54 = i41;
          i55 = i42;
          i56 = i45;
          d57 = d46;
          break;
         }
         if (i23) if (!i42) {
          i58 = i37;
          i59 = i36;
          i60 = i37;
          i61 = i36;
          i62 = i41;
          i63 = 1;
          i64 = i43;
          d65 = d44;
          i66 = i45;
          d67 = d46;
         } else {
          i49 = i37;
          i50 = i38;
          i51 = i36;
          i52 = i39;
          i53 = 46;
          i54 = i41;
          i55 = i42;
          i56 = i45;
          d57 = d46;
          break;
         } else i8 = 86;
        } else i8 = 86;
        if ((i8 | 0) == 86) {
         i8 = 0;
         i23 = (i40 | 0) > 57 ? i19 + -87 | 0 : i14;
         do if (!((i36 | 0) < 0 | (i36 | 0) == 0 & i37 >>> 0 < 8)) {
          if ((i36 | 0) < 0 | (i36 | 0) == 0 & i37 >>> 0 < 14) {
           d68 = d44 * .0625;
           i69 = i43;
           d70 = d68;
           i71 = i45;
           d72 = d46 + d68 * +(i23 | 0);
           break;
          }
          if ((i43 | 0) != 0 | (i23 | 0) == 0) {
           i69 = i43;
           d70 = d44;
           i71 = i45;
           d72 = d46;
          } else {
           i69 = 1;
           d70 = d44;
           i71 = i45;
           d72 = d46 + d44 * .5;
          }
         } else {
          i69 = i43;
          d70 = d44;
          i71 = i23 + (i45 << 4) | 0;
          d72 = d46;
         } while (0);
         i23 = _i64Add(i37 | 0, i36 | 0, 1, 0) | 0;
         i58 = i38;
         i59 = i39;
         i60 = i23;
         i61 = tempRet0;
         i62 = 1;
         i63 = i42;
         i64 = i69;
         d65 = d70;
         i66 = i71;
         d67 = d72;
        }
        i23 = HEAP32[i2 >> 2] | 0;
        if (i23 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
         HEAP32[i2 >> 2] = i23 + 1;
         i36 = i61;
         i37 = i60;
         i38 = i58;
         i39 = i59;
         i40 = HEAPU8[i23 >> 0] | 0;
         i41 = i62;
         i42 = i63;
         i43 = i64;
         d44 = d65;
         i45 = i66;
         d46 = d67;
         continue;
        } else {
         i36 = i61;
         i37 = i60;
         i38 = i58;
         i39 = i59;
         i40 = ___shgetc(i1) | 0;
         i41 = i62;
         i42 = i63;
         i43 = i64;
         d44 = d65;
         i45 = i66;
         d46 = d67;
         continue;
        }
       }
       if (!i54) {
        i23 = (HEAP32[i10 >> 2] | 0) == 0;
        if (!i23) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
        if (i3) {
         if (!i23 ? (i23 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i23 + -1, (i55 | 0) != 0) : 0) HEAP32[i2 >> 2] = i23 + -2;
        } else ___shlim(i1, 0);
        d9 = +(i16 | 0) * 0.0;
        break L4;
       }
       i23 = (i55 | 0) == 0;
       i14 = i23 ? i49 : i50;
       i19 = i23 ? i51 : i52;
       if ((i51 | 0) < 0 | (i51 | 0) == 0 & i49 >>> 0 < 8) {
        i23 = i49;
        i11 = i51;
        i73 = i56;
        while (1) {
         i74 = i73 << 4;
         i23 = _i64Add(i23 | 0, i11 | 0, 1, 0) | 0;
         i11 = tempRet0;
         if (!((i11 | 0) < 0 | (i11 | 0) == 0 & i23 >>> 0 < 8)) {
          i75 = i74;
          break;
         } else i73 = i74;
        }
       } else i75 = i56;
       if ((i53 | 32 | 0) == 112) {
        i73 = _scanexp(i1, i3) | 0;
        i23 = tempRet0;
        if ((i73 | 0) == 0 & (i23 | 0) == -2147483648) {
         if (!i3) {
          ___shlim(i1, 0);
          d9 = 0.0;
          break L4;
         }
         if (!(HEAP32[i10 >> 2] | 0)) {
          i76 = 0;
          i77 = 0;
         } else {
          HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
          i76 = 0;
          i77 = 0;
         }
        } else {
         i76 = i73;
         i77 = i23;
        }
       } else if (!(HEAP32[i10 >> 2] | 0)) {
        i76 = 0;
        i77 = 0;
       } else {
        HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
        i76 = 0;
        i77 = 0;
       }
       i23 = _bitshift64Shl(i14 | 0, i19 | 0, 2) | 0;
       i73 = _i64Add(i23 | 0, tempRet0 | 0, -32, -1) | 0;
       i23 = _i64Add(i73 | 0, tempRet0 | 0, i76 | 0, i77 | 0) | 0;
       i73 = tempRet0;
       if (!i75) {
        d9 = +(i16 | 0) * 0.0;
        break L4;
       }
       if ((i73 | 0) > 0 | (i73 | 0) == 0 & i23 >>> 0 > (0 - i7 | 0) >>> 0) {
        i11 = ___errno_location() | 0;
        HEAP32[i11 >> 2] = 34;
        d9 = +(i16 | 0) * 1797693134862315708145274.0e284 * 1797693134862315708145274.0e284;
        break L4;
       }
       i11 = i7 + -106 | 0;
       i74 = ((i11 | 0) < 0) << 31 >> 31;
       if ((i73 | 0) < (i74 | 0) | (i73 | 0) == (i74 | 0) & i23 >>> 0 < i11 >>> 0) {
        i11 = ___errno_location() | 0;
        HEAP32[i11 >> 2] = 34;
        d9 = +(i16 | 0) * 2.2250738585072014e-308 * 2.2250738585072014e-308;
        break L4;
       }
       if ((i75 | 0) > -1) {
        i11 = i23;
        i74 = i73;
        i78 = i75;
        d68 = d57;
        while (1) {
         i79 = !(d68 >= .5);
         i80 = i79 & 1 | i78 << 1;
         i81 = i80 ^ 1;
         d82 = d68 + (i79 ? d68 : d68 + -1.0);
         i79 = _i64Add(i11 | 0, i74 | 0, -1, -1) | 0;
         i83 = tempRet0;
         if ((i80 | 0) > -1) {
          i11 = i79;
          i74 = i83;
          i78 = i81;
          d68 = d82;
         } else {
          i84 = i79;
          i85 = i83;
          i86 = i81;
          d87 = d82;
          break;
         }
        }
       } else {
        i84 = i23;
        i85 = i73;
        i86 = i75;
        d87 = d57;
       }
       i78 = _i64Subtract(32, 0, i7 | 0, ((i7 | 0) < 0) << 31 >> 31 | 0) | 0;
       i74 = _i64Add(i84 | 0, i85 | 0, i78 | 0, tempRet0 | 0) | 0;
       i78 = tempRet0;
       if (0 > (i78 | 0) | 0 == (i78 | 0) & i6 >>> 0 > i74 >>> 0) if ((i74 | 0) < 0) {
        i88 = 0;
        i8 = 127;
       } else {
        i89 = i74;
        i8 = 125;
       } else {
        i89 = i6;
        i8 = 125;
       }
       if ((i8 | 0) == 125) if ((i89 | 0) < 53) {
        i88 = i89;
        i8 = 127;
       } else {
        i90 = i89;
        d91 = +(i16 | 0);
        d92 = 0.0;
       }
       if ((i8 | 0) == 127) {
        d68 = +(i16 | 0);
        i90 = i88;
        d91 = d68;
        d92 = +_copysignl(+_scalbn(1.0, 84 - i88 | 0), d68);
       }
       i74 = (i86 & 1 | 0) == 0 & (d87 != 0.0 & (i90 | 0) < 32);
       d68 = d91 * (i74 ? 0.0 : d87) + (d92 + d91 * +(((i74 & 1) + i86 | 0) >>> 0)) - d92;
       if (!(d68 != 0.0)) {
        i74 = ___errno_location() | 0;
        HEAP32[i74 >> 2] = 34;
       }
       d9 = +_scalbnl(d68, i84);
       break L4;
      } else i32 = i21; while (0);
      i74 = i7 + i6 | 0;
      i78 = 0 - i74 | 0;
      i11 = i32;
      i19 = 0;
      L184 : while (1) {
       switch (i11 | 0) {
       case 46:
        {
         i93 = i19;
         i8 = 138;
         break L184;
         break;
        }
       case 48:
        break;
       default:
        {
         i94 = i11;
         i95 = 0;
         i96 = 0;
         i97 = i19;
         i98 = 0;
         break L184;
        }
       }
       i14 = HEAP32[i2 >> 2] | 0;
       if (i14 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
        HEAP32[i2 >> 2] = i14 + 1;
        i11 = HEAPU8[i14 >> 0] | 0;
        i19 = 1;
        continue;
       } else {
        i11 = ___shgetc(i1) | 0;
        i19 = 1;
        continue;
       }
      }
      if ((i8 | 0) == 138) {
       i19 = HEAP32[i2 >> 2] | 0;
       if (i19 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
        HEAP32[i2 >> 2] = i19 + 1;
        i99 = HEAPU8[i19 >> 0] | 0;
       } else i99 = ___shgetc(i1) | 0;
       if ((i99 | 0) == 48) {
        i19 = 0;
        i11 = 0;
        while (1) {
         i14 = _i64Add(i19 | 0, i11 | 0, -1, -1) | 0;
         i81 = tempRet0;
         i83 = HEAP32[i2 >> 2] | 0;
         if (i83 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
          HEAP32[i2 >> 2] = i83 + 1;
          i100 = HEAPU8[i83 >> 0] | 0;
         } else i100 = ___shgetc(i1) | 0;
         if ((i100 | 0) == 48) {
          i19 = i14;
          i11 = i81;
         } else {
          i94 = i100;
          i95 = i14;
          i96 = i81;
          i97 = 1;
          i98 = 1;
          break;
         }
        }
       } else {
        i94 = i99;
        i95 = 0;
        i96 = 0;
        i97 = i93;
        i98 = 1;
       }
      }
      HEAP32[i5 >> 2] = 0;
      i11 = i94 + -48 | 0;
      i19 = (i94 | 0) == 46;
      L203 : do if (i19 | i11 >>> 0 < 10) {
       i81 = i5 + 496 | 0;
       i14 = i94;
       i83 = 0;
       i79 = 0;
       i80 = i19;
       i101 = i11;
       i102 = i95;
       i103 = i96;
       i104 = i97;
       i105 = i98;
       i106 = 0;
       i107 = 0;
       i108 = 0;
       L205 : while (1) {
        do if (i80) if (!i105) {
         i109 = i83;
         i110 = i79;
         i111 = i83;
         i112 = i79;
         i113 = i104;
         i114 = 1;
         i115 = i106;
         i116 = i107;
         i117 = i108;
        } else {
         i118 = i102;
         i119 = i103;
         i120 = i83;
         i121 = i79;
         i122 = i104;
         i123 = i106;
         i124 = i107;
         i125 = i108;
         break L205;
        } else {
         i126 = _i64Add(i83 | 0, i79 | 0, 1, 0) | 0;
         i127 = tempRet0;
         i128 = (i14 | 0) != 48;
         if ((i107 | 0) >= 125) {
          if (!i128) {
           i109 = i102;
           i110 = i103;
           i111 = i126;
           i112 = i127;
           i113 = i104;
           i114 = i105;
           i115 = i106;
           i116 = i107;
           i117 = i108;
           break;
          }
          HEAP32[i81 >> 2] = HEAP32[i81 >> 2] | 1;
          i109 = i102;
          i110 = i103;
          i111 = i126;
          i112 = i127;
          i113 = i104;
          i114 = i105;
          i115 = i106;
          i116 = i107;
          i117 = i108;
          break;
         }
         i129 = i5 + (i107 << 2) | 0;
         if (!i106) i130 = i101; else i130 = i14 + -48 + ((HEAP32[i129 >> 2] | 0) * 10 | 0) | 0;
         HEAP32[i129 >> 2] = i130;
         i129 = i106 + 1 | 0;
         i131 = (i129 | 0) == 9;
         i109 = i102;
         i110 = i103;
         i111 = i126;
         i112 = i127;
         i113 = 1;
         i114 = i105;
         i115 = i131 ? 0 : i129;
         i116 = (i131 & 1) + i107 | 0;
         i117 = i128 ? i126 : i108;
        } while (0);
        i126 = HEAP32[i2 >> 2] | 0;
        if (i126 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
         HEAP32[i2 >> 2] = i126 + 1;
         i132 = HEAPU8[i126 >> 0] | 0;
        } else i132 = ___shgetc(i1) | 0;
        i101 = i132 + -48 | 0;
        i80 = (i132 | 0) == 46;
        if (!(i80 | i101 >>> 0 < 10)) {
         i133 = i132;
         i134 = i111;
         i135 = i109;
         i136 = i112;
         i137 = i110;
         i138 = i113;
         i139 = i114;
         i140 = i115;
         i141 = i116;
         i142 = i117;
         i8 = 161;
         break L203;
        } else {
         i14 = i132;
         i83 = i111;
         i79 = i112;
         i102 = i109;
         i103 = i110;
         i104 = i113;
         i105 = i114;
         i106 = i115;
         i107 = i116;
         i108 = i117;
        }
       }
       i143 = i120;
       i144 = i121;
       i145 = i118;
       i146 = i119;
       i147 = (i122 | 0) != 0;
       i148 = i123;
       i149 = i124;
       i150 = i125;
       i8 = 169;
      } else {
       i133 = i94;
       i134 = 0;
       i135 = i95;
       i136 = 0;
       i137 = i96;
       i138 = i97;
       i139 = i98;
       i140 = 0;
       i141 = 0;
       i142 = 0;
       i8 = 161;
      } while (0);
      do if ((i8 | 0) == 161) {
       i11 = (i139 | 0) == 0;
       i19 = i11 ? i134 : i135;
       i108 = i11 ? i136 : i137;
       i11 = (i138 | 0) != 0;
       if (!((i133 | 32 | 0) == 101 & i11)) if ((i133 | 0) > -1) {
        i143 = i134;
        i144 = i136;
        i145 = i19;
        i146 = i108;
        i147 = i11;
        i148 = i140;
        i149 = i141;
        i150 = i142;
        i8 = 169;
        break;
       } else {
        i151 = i134;
        i152 = i136;
        i153 = i11;
        i154 = i19;
        i155 = i108;
        i156 = i140;
        i157 = i141;
        i158 = i142;
        i8 = 171;
        break;
       }
       i11 = _scanexp(i1, i3) | 0;
       i107 = tempRet0;
       if ((i11 | 0) == 0 & (i107 | 0) == -2147483648) {
        if (!i3) {
         ___shlim(i1, 0);
         d159 = 0.0;
         break;
        }
        if (!(HEAP32[i10 >> 2] | 0)) {
         i160 = 0;
         i161 = 0;
        } else {
         HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
         i160 = 0;
         i161 = 0;
        }
       } else {
        i160 = i11;
        i161 = i107;
       }
       i107 = _i64Add(i160 | 0, i161 | 0, i19 | 0, i108 | 0) | 0;
       i162 = i107;
       i163 = i134;
       i164 = tempRet0;
       i165 = i136;
       i166 = i140;
       i167 = i141;
       i168 = i142;
       i8 = 173;
      } while (0);
      if ((i8 | 0) == 169) if (HEAP32[i10 >> 2] | 0) {
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
       if (i147) {
        i162 = i145;
        i163 = i143;
        i164 = i146;
        i165 = i144;
        i166 = i148;
        i167 = i149;
        i168 = i150;
        i8 = 173;
       } else i8 = 172;
      } else {
       i151 = i143;
       i152 = i144;
       i153 = i147;
       i154 = i145;
       i155 = i146;
       i156 = i148;
       i157 = i149;
       i158 = i150;
       i8 = 171;
      }
      if ((i8 | 0) == 171) if (i153) {
       i162 = i154;
       i163 = i151;
       i164 = i155;
       i165 = i152;
       i166 = i156;
       i167 = i157;
       i168 = i158;
       i8 = 173;
      } else i8 = 172;
      do if ((i8 | 0) == 172) {
       i107 = ___errno_location() | 0;
       HEAP32[i107 >> 2] = 22;
       ___shlim(i1, 0);
       d159 = 0.0;
      } else if ((i8 | 0) == 173) {
       i107 = HEAP32[i5 >> 2] | 0;
       if (!i107) {
        d159 = +(i16 | 0) * 0.0;
        break;
       }
       if (((i165 | 0) < 0 | (i165 | 0) == 0 & i163 >>> 0 < 10) & ((i162 | 0) == (i163 | 0) & (i164 | 0) == (i165 | 0)) ? i6 >>> 0 > 30 | (i107 >>> i6 | 0) == 0 : 0) {
        d159 = +(i16 | 0) * +(i107 >>> 0);
        break;
       }
       i107 = (i7 | 0) / -2 | 0;
       i108 = ((i107 | 0) < 0) << 31 >> 31;
       if ((i164 | 0) > (i108 | 0) | (i164 | 0) == (i108 | 0) & i162 >>> 0 > i107 >>> 0) {
        i107 = ___errno_location() | 0;
        HEAP32[i107 >> 2] = 34;
        d159 = +(i16 | 0) * 1797693134862315708145274.0e284 * 1797693134862315708145274.0e284;
        break;
       }
       i107 = i7 + -106 | 0;
       i108 = ((i107 | 0) < 0) << 31 >> 31;
       if ((i164 | 0) < (i108 | 0) | (i164 | 0) == (i108 | 0) & i162 >>> 0 < i107 >>> 0) {
        i107 = ___errno_location() | 0;
        HEAP32[i107 >> 2] = 34;
        d159 = +(i16 | 0) * 2.2250738585072014e-308 * 2.2250738585072014e-308;
        break;
       }
       if (!i166) i169 = i167; else {
        if ((i166 | 0) < 9) {
         i107 = i5 + (i167 << 2) | 0;
         i108 = HEAP32[i107 >> 2] | 0;
         i19 = i166;
         while (1) {
          i11 = i108 * 10 | 0;
          i19 = i19 + 1 | 0;
          if ((i19 | 0) == 9) {
           i170 = i11;
           break;
          } else i108 = i11;
         }
         HEAP32[i107 >> 2] = i170;
        }
        i169 = i167 + 1 | 0;
       }
       if ((i168 | 0) < 9 ? (i168 | 0) <= (i162 | 0) & (i162 | 0) < 18 : 0) {
        if ((i162 | 0) == 9) {
         d159 = +(i16 | 0) * +((HEAP32[i5 >> 2] | 0) >>> 0);
         break;
        }
        if ((i162 | 0) < 9) {
         d159 = +(i16 | 0) * +((HEAP32[i5 >> 2] | 0) >>> 0) / +(HEAP32[19692 + (8 - i162 << 2) >> 2] | 0);
         break;
        }
        i108 = i6 + 27 + (Math_imul(i162, -3) | 0) | 0;
        i19 = HEAP32[i5 >> 2] | 0;
        if ((i108 | 0) > 30 | (i19 >>> i108 | 0) == 0) {
         d159 = +(i16 | 0) * +(i19 >>> 0) * +(HEAP32[19692 + (i162 + -10 << 2) >> 2] | 0);
         break;
        }
       }
       i19 = (i162 | 0) % 9 | 0;
       if (!i19) {
        i171 = 0;
        i172 = 0;
        i173 = i162;
        i174 = i169;
       } else {
        i108 = (i162 | 0) > -1 ? i19 : i19 + 9 | 0;
        i19 = HEAP32[19692 + (8 - i108 << 2) >> 2] | 0;
        if (i169) {
         i11 = 1e9 / (i19 | 0) | 0;
         i106 = 0;
         i105 = 0;
         i104 = 0;
         i103 = i162;
         while (1) {
          i102 = i5 + (i104 << 2) | 0;
          i79 = HEAP32[i102 >> 2] | 0;
          i83 = ((i79 >>> 0) / (i19 >>> 0) | 0) + i105 | 0;
          HEAP32[i102 >> 2] = i83;
          i102 = Math_imul((i79 >>> 0) % (i19 >>> 0) | 0, i11) | 0;
          i79 = (i104 | 0) == (i106 | 0) & (i83 | 0) == 0;
          i104 = i104 + 1 | 0;
          i83 = i79 ? i103 + -9 | 0 : i103;
          i14 = i79 ? i104 & 127 : i106;
          if ((i104 | 0) == (i169 | 0)) {
           i175 = i102;
           i176 = i14;
           i177 = i83;
           break;
          } else {
           i106 = i14;
           i105 = i102;
           i103 = i83;
          }
         }
         if (!i175) {
          i178 = i176;
          i179 = i177;
          i180 = i169;
         } else {
          HEAP32[i5 + (i169 << 2) >> 2] = i175;
          i178 = i176;
          i179 = i177;
          i180 = i169 + 1 | 0;
         }
        } else {
         i178 = 0;
         i179 = i162;
         i180 = 0;
        }
        i171 = i178;
        i172 = 0;
        i173 = 9 - i108 + i179 | 0;
        i174 = i180;
       }
       L284 : while (1) {
        i103 = (i173 | 0) < 18;
        i105 = (i173 | 0) == 18;
        i106 = i5 + (i171 << 2) | 0;
        i104 = i172;
        i11 = i174;
        while (1) {
         if (!i103) {
          if (!i105) {
           i181 = i171;
           i182 = i104;
           i183 = i173;
           i184 = i11;
           break L284;
          }
          if ((HEAP32[i106 >> 2] | 0) >>> 0 >= 9007199) {
           i181 = i171;
           i182 = i104;
           i183 = 18;
           i184 = i11;
           break L284;
          }
         }
         i19 = 0;
         i107 = i11 + 127 | 0;
         i83 = i11;
         while (1) {
          i102 = i107 & 127;
          i14 = i5 + (i102 << 2) | 0;
          i79 = _bitshift64Shl(HEAP32[i14 >> 2] | 0, 0, 29) | 0;
          i101 = _i64Add(i79 | 0, tempRet0 | 0, i19 | 0, 0) | 0;
          i79 = tempRet0;
          if (i79 >>> 0 > 0 | (i79 | 0) == 0 & i101 >>> 0 > 1e9) {
           i80 = ___udivdi3(i101 | 0, i79 | 0, 1e9, 0) | 0;
           i81 = ___uremdi3(i101 | 0, i79 | 0, 1e9, 0) | 0;
           i185 = i81;
           i186 = i80;
          } else {
           i185 = i101;
           i186 = 0;
          }
          HEAP32[i14 >> 2] = i185;
          i14 = (i102 | 0) == (i171 | 0);
          i101 = (i102 | 0) != (i83 + 127 & 127 | 0) | i14 ? i83 : (i185 | 0) == 0 ? i102 : i83;
          if (i14) {
           i187 = i186;
           i188 = i101;
           break;
          } else {
           i19 = i186;
           i107 = i102 + -1 | 0;
           i83 = i101;
          }
         }
         i83 = i104 + -29 | 0;
         if (!i187) {
          i104 = i83;
          i11 = i188;
         } else {
          i189 = i83;
          i190 = i187;
          i191 = i188;
          break;
         }
        }
        i11 = i171 + 127 & 127;
        if ((i11 | 0) == (i191 | 0)) {
         i104 = i191 + 127 & 127;
         i106 = i5 + ((i191 + 126 & 127) << 2) | 0;
         HEAP32[i106 >> 2] = HEAP32[i106 >> 2] | HEAP32[i5 + (i104 << 2) >> 2];
         i192 = i104;
        } else i192 = i191;
        HEAP32[i5 + (i11 << 2) >> 2] = i190;
        i171 = i11;
        i172 = i189;
        i173 = i173 + 9 | 0;
        i174 = i192;
       }
       L302 : while (1) {
        i193 = i184 + 1 & 127;
        i108 = i5 + ((i184 + 127 & 127) << 2) | 0;
        i11 = i181;
        i104 = i182;
        i106 = i183;
        while (1) {
         i105 = (i106 | 0) == 18;
         i103 = (i106 | 0) > 27 ? 9 : 1;
         i83 = i105 ^ 1;
         i194 = i11;
         i195 = i104;
         while (1) {
          i196 = i194 & 127;
          i197 = (i196 | 0) == (i184 | 0);
          do if (!i197) {
           i107 = HEAP32[i5 + (i196 << 2) >> 2] | 0;
           if (i107 >>> 0 < 9007199) {
            i8 = 219;
            break;
           }
           if (i107 >>> 0 > 9007199) break;
           i107 = i194 + 1 & 127;
           if ((i107 | 0) == (i184 | 0)) {
            i8 = 219;
            break;
           }
           i19 = HEAP32[i5 + (i107 << 2) >> 2] | 0;
           if (i19 >>> 0 < 254740991) {
            i8 = 219;
            break;
           }
           if (!(i19 >>> 0 > 254740991 | i83)) {
            i198 = i196;
            i199 = i194;
            i200 = i195;
            i201 = i184;
            break L302;
           }
          } else i8 = 219; while (0);
          if ((i8 | 0) == 219 ? (i8 = 0, i105) : 0) {
           i8 = 220;
           break L302;
          }
          i19 = i195 + i103 | 0;
          if ((i194 | 0) == (i184 | 0)) {
           i194 = i184;
           i195 = i19;
          } else {
           i202 = i19;
           i203 = i194;
           break;
          }
         }
         i105 = (1 << i103) + -1 | 0;
         i83 = 1e9 >>> i103;
         i19 = i203;
         i107 = 0;
         i101 = i203;
         i102 = i106;
         while (1) {
          i14 = i5 + (i101 << 2) | 0;
          i80 = HEAP32[i14 >> 2] | 0;
          i81 = (i80 >>> i103) + i107 | 0;
          HEAP32[i14 >> 2] = i81;
          i14 = Math_imul(i80 & i105, i83) | 0;
          i80 = (i101 | 0) == (i19 | 0) & (i81 | 0) == 0;
          i101 = i101 + 1 & 127;
          i81 = i80 ? i102 + -9 | 0 : i102;
          i79 = i80 ? i101 : i19;
          if ((i101 | 0) == (i184 | 0)) {
           i204 = i14;
           i205 = i79;
           i206 = i81;
           break;
          } else {
           i19 = i79;
           i107 = i14;
           i102 = i81;
          }
         }
         if (!i204) {
          i11 = i205;
          i104 = i202;
          i106 = i206;
          continue;
         }
         if ((i193 | 0) != (i205 | 0)) {
          i207 = i202;
          i208 = i204;
          i209 = i205;
          i210 = i206;
          break;
         }
         HEAP32[i108 >> 2] = HEAP32[i108 >> 2] | 1;
         i11 = i205;
         i104 = i202;
         i106 = i206;
        }
        HEAP32[i5 + (i184 << 2) >> 2] = i208;
        i181 = i209;
        i182 = i207;
        i183 = i210;
        i184 = i193;
       }
       if ((i8 | 0) == 220) if (i197) {
        HEAP32[i5 + (i193 + -1 << 2) >> 2] = 0;
        i198 = i184;
        i199 = i194;
        i200 = i195;
        i201 = i193;
       } else {
        i198 = i196;
        i199 = i194;
        i200 = i195;
        i201 = i184;
       }
       d68 = +((HEAP32[i5 + (i198 << 2) >> 2] | 0) >>> 0);
       i106 = i199 + 1 & 127;
       if ((i106 | 0) == (i201 | 0)) {
        i104 = i199 + 2 & 127;
        HEAP32[i5 + (i104 + -1 << 2) >> 2] = 0;
        i211 = i104;
       } else i211 = i201;
       d82 = +(i16 | 0);
       d212 = d82 * (d68 * 1.0e9 + +((HEAP32[i5 + (i106 << 2) >> 2] | 0) >>> 0));
       i106 = i200 + 53 | 0;
       i104 = i106 - i7 | 0;
       i11 = (i104 | 0) < (i6 | 0);
       i108 = i11 & 1;
       i102 = i11 ? ((i104 | 0) < 0 ? 0 : i104) : i6;
       if ((i102 | 0) < 53) {
        d68 = +_copysignl(+_scalbn(1.0, 105 - i102 | 0), d212);
        d213 = +_fmodl(d212, +_scalbn(1.0, 53 - i102 | 0));
        d214 = d68;
        d215 = d213;
        d216 = d68 + (d212 - d213);
       } else {
        d214 = 0.0;
        d215 = 0.0;
        d216 = d212;
       }
       i107 = i199 + 2 & 127;
       do if ((i107 | 0) == (i211 | 0)) d217 = d215; else {
        i19 = HEAP32[i5 + (i107 << 2) >> 2] | 0;
        do if (i19 >>> 0 >= 5e8) {
         if (i19 >>> 0 > 5e8) {
          d218 = d82 * .75 + d215;
          break;
         }
         if ((i199 + 3 & 127 | 0) == (i211 | 0)) {
          d218 = d82 * .5 + d215;
          break;
         } else {
          d218 = d82 * .75 + d215;
          break;
         }
        } else {
         if ((i19 | 0) == 0 ? (i199 + 3 & 127 | 0) == (i211 | 0) : 0) {
          d218 = d215;
          break;
         }
         d218 = d82 * .25 + d215;
        } while (0);
        if ((53 - i102 | 0) <= 1) {
         d217 = d218;
         break;
        }
        if (+_fmodl(d218, 1.0) != 0.0) {
         d217 = d218;
         break;
        }
        d217 = d218 + 1.0;
       } while (0);
       d82 = d216 + d217 - d214;
       do if ((i106 & 2147483647 | 0) > (-2 - i74 | 0)) {
        if (!(+Math_abs(+d82) >= 9007199254740992.0)) {
         i219 = i108;
         i220 = i200;
         d221 = d82;
        } else {
         i219 = i11 & (i102 | 0) == (i104 | 0) ? 0 : i108;
         i220 = i200 + 1 | 0;
         d221 = d82 * .5;
        }
        if ((i220 + 50 | 0) <= (i78 | 0) ? !(d217 != 0.0 & (i219 | 0) != 0) : 0) {
         i222 = i220;
         d223 = d221;
         break;
        }
        i107 = ___errno_location() | 0;
        HEAP32[i107 >> 2] = 34;
        i222 = i220;
        d223 = d221;
       } else {
        i222 = i200;
        d223 = d82;
       } while (0);
       d159 = +_scalbnl(d223, i222);
      } while (0);
      d9 = d159;
      break L4;
      break;
     }
    default:
     {
      if (HEAP32[i10 >> 2] | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
      i78 = ___errno_location() | 0;
      HEAP32[i78 >> 2] = 22;
      ___shlim(i1, 0);
      d9 = 0.0;
      break L4;
     }
    }
   }
  } while (0);
  if ((i8 | 0) == 23) {
   i78 = (HEAP32[i10 >> 2] | 0) == 0;
   if (!i78) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   if ((i3 | 0) != 0 & i18 >>> 0 > 3) {
    i74 = i18;
    do {
     if (!i78) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     i74 = i74 + -1 | 0;
    } while (i74 >>> 0 > 3);
   }
  }
  d9 = +(i16 | 0) * inf;
 } while (0);
 STACKTOP = i4;
 return +d9;
}

function _malloc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0;
 do if (i1 >>> 0 < 245) {
  i2 = i1 >>> 0 < 11 ? 16 : i1 + 11 & -8;
  i3 = i2 >>> 3;
  i4 = HEAP32[5813] | 0;
  i5 = i4 >>> i3;
  if (i5 & 3) {
   i6 = (i5 & 1 ^ 1) + i3 | 0;
   i7 = i6 << 1;
   i8 = 23292 + (i7 << 2) | 0;
   i9 = 23292 + (i7 + 2 << 2) | 0;
   i7 = HEAP32[i9 >> 2] | 0;
   i10 = i7 + 8 | 0;
   i11 = HEAP32[i10 >> 2] | 0;
   do if ((i8 | 0) != (i11 | 0)) {
    if (i11 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
    i12 = i11 + 12 | 0;
    if ((HEAP32[i12 >> 2] | 0) == (i7 | 0)) {
     HEAP32[i12 >> 2] = i8;
     HEAP32[i9 >> 2] = i11;
     break;
    } else _abort();
   } else HEAP32[5813] = i4 & ~(1 << i6); while (0);
   i11 = i6 << 3;
   HEAP32[i7 + 4 >> 2] = i11 | 3;
   i9 = i7 + (i11 | 4) | 0;
   HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
   i13 = i10;
   return i13 | 0;
  }
  i9 = HEAP32[5815] | 0;
  if (i2 >>> 0 > i9 >>> 0) {
   if (i5) {
    i11 = 2 << i3;
    i8 = i5 << i3 & (i11 | 0 - i11);
    i11 = (i8 & 0 - i8) + -1 | 0;
    i8 = i11 >>> 12 & 16;
    i12 = i11 >>> i8;
    i11 = i12 >>> 5 & 8;
    i14 = i12 >>> i11;
    i12 = i14 >>> 2 & 4;
    i15 = i14 >>> i12;
    i14 = i15 >>> 1 & 2;
    i16 = i15 >>> i14;
    i15 = i16 >>> 1 & 1;
    i17 = (i11 | i8 | i12 | i14 | i15) + (i16 >>> i15) | 0;
    i15 = i17 << 1;
    i16 = 23292 + (i15 << 2) | 0;
    i14 = 23292 + (i15 + 2 << 2) | 0;
    i15 = HEAP32[i14 >> 2] | 0;
    i12 = i15 + 8 | 0;
    i8 = HEAP32[i12 >> 2] | 0;
    do if ((i16 | 0) != (i8 | 0)) {
     if (i8 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
     i11 = i8 + 12 | 0;
     if ((HEAP32[i11 >> 2] | 0) == (i15 | 0)) {
      HEAP32[i11 >> 2] = i16;
      HEAP32[i14 >> 2] = i8;
      i18 = HEAP32[5815] | 0;
      break;
     } else _abort();
    } else {
     HEAP32[5813] = i4 & ~(1 << i17);
     i18 = i9;
    } while (0);
    i9 = i17 << 3;
    i4 = i9 - i2 | 0;
    HEAP32[i15 + 4 >> 2] = i2 | 3;
    i8 = i15 + i2 | 0;
    HEAP32[i15 + (i2 | 4) >> 2] = i4 | 1;
    HEAP32[i15 + i9 >> 2] = i4;
    if (i18) {
     i9 = HEAP32[5818] | 0;
     i14 = i18 >>> 3;
     i16 = i14 << 1;
     i3 = 23292 + (i16 << 2) | 0;
     i5 = HEAP32[5813] | 0;
     i10 = 1 << i14;
     if (i5 & i10) {
      i14 = 23292 + (i16 + 2 << 2) | 0;
      i7 = HEAP32[i14 >> 2] | 0;
      if (i7 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
       i19 = i14;
       i20 = i7;
      }
     } else {
      HEAP32[5813] = i5 | i10;
      i19 = 23292 + (i16 + 2 << 2) | 0;
      i20 = i3;
     }
     HEAP32[i19 >> 2] = i9;
     HEAP32[i20 + 12 >> 2] = i9;
     HEAP32[i9 + 8 >> 2] = i20;
     HEAP32[i9 + 12 >> 2] = i3;
    }
    HEAP32[5815] = i4;
    HEAP32[5818] = i8;
    i13 = i12;
    return i13 | 0;
   }
   i8 = HEAP32[5814] | 0;
   if (i8) {
    i4 = (i8 & 0 - i8) + -1 | 0;
    i8 = i4 >>> 12 & 16;
    i3 = i4 >>> i8;
    i4 = i3 >>> 5 & 8;
    i9 = i3 >>> i4;
    i3 = i9 >>> 2 & 4;
    i16 = i9 >>> i3;
    i9 = i16 >>> 1 & 2;
    i10 = i16 >>> i9;
    i16 = i10 >>> 1 & 1;
    i5 = HEAP32[23556 + ((i4 | i8 | i3 | i9 | i16) + (i10 >>> i16) << 2) >> 2] | 0;
    i16 = (HEAP32[i5 + 4 >> 2] & -8) - i2 | 0;
    i10 = i5;
    i9 = i5;
    while (1) {
     i5 = HEAP32[i10 + 16 >> 2] | 0;
     if (!i5) {
      i3 = HEAP32[i10 + 20 >> 2] | 0;
      if (!i3) {
       i21 = i16;
       i22 = i9;
       break;
      } else i23 = i3;
     } else i23 = i5;
     i5 = (HEAP32[i23 + 4 >> 2] & -8) - i2 | 0;
     i3 = i5 >>> 0 < i16 >>> 0;
     i16 = i3 ? i5 : i16;
     i10 = i23;
     i9 = i3 ? i23 : i9;
    }
    i9 = HEAP32[5817] | 0;
    if (i22 >>> 0 < i9 >>> 0) _abort();
    i10 = i22 + i2 | 0;
    if (i22 >>> 0 >= i10 >>> 0) _abort();
    i16 = HEAP32[i22 + 24 >> 2] | 0;
    i12 = HEAP32[i22 + 12 >> 2] | 0;
    do if ((i12 | 0) == (i22 | 0)) {
     i15 = i22 + 20 | 0;
     i17 = HEAP32[i15 >> 2] | 0;
     if (!i17) {
      i3 = i22 + 16 | 0;
      i5 = HEAP32[i3 >> 2] | 0;
      if (!i5) {
       i24 = 0;
       break;
      } else {
       i25 = i5;
       i26 = i3;
      }
     } else {
      i25 = i17;
      i26 = i15;
     }
     while (1) {
      i15 = i25 + 20 | 0;
      i17 = HEAP32[i15 >> 2] | 0;
      if (i17) {
       i25 = i17;
       i26 = i15;
       continue;
      }
      i15 = i25 + 16 | 0;
      i17 = HEAP32[i15 >> 2] | 0;
      if (!i17) {
       i27 = i25;
       i28 = i26;
       break;
      } else {
       i25 = i17;
       i26 = i15;
      }
     }
     if (i28 >>> 0 < i9 >>> 0) _abort(); else {
      HEAP32[i28 >> 2] = 0;
      i24 = i27;
      break;
     }
    } else {
     i15 = HEAP32[i22 + 8 >> 2] | 0;
     if (i15 >>> 0 < i9 >>> 0) _abort();
     i17 = i15 + 12 | 0;
     if ((HEAP32[i17 >> 2] | 0) != (i22 | 0)) _abort();
     i3 = i12 + 8 | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i22 | 0)) {
      HEAP32[i17 >> 2] = i12;
      HEAP32[i3 >> 2] = i15;
      i24 = i12;
      break;
     } else _abort();
    } while (0);
    do if (i16) {
     i12 = HEAP32[i22 + 28 >> 2] | 0;
     i9 = 23556 + (i12 << 2) | 0;
     if ((i22 | 0) == (HEAP32[i9 >> 2] | 0)) {
      HEAP32[i9 >> 2] = i24;
      if (!i24) {
       HEAP32[5814] = HEAP32[5814] & ~(1 << i12);
       break;
      }
     } else {
      if (i16 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
      i12 = i16 + 16 | 0;
      if ((HEAP32[i12 >> 2] | 0) == (i22 | 0)) HEAP32[i12 >> 2] = i24; else HEAP32[i16 + 20 >> 2] = i24;
      if (!i24) break;
     }
     i12 = HEAP32[5817] | 0;
     if (i24 >>> 0 < i12 >>> 0) _abort();
     HEAP32[i24 + 24 >> 2] = i16;
     i9 = HEAP32[i22 + 16 >> 2] | 0;
     do if (i9) if (i9 >>> 0 < i12 >>> 0) _abort(); else {
      HEAP32[i24 + 16 >> 2] = i9;
      HEAP32[i9 + 24 >> 2] = i24;
      break;
     } while (0);
     i9 = HEAP32[i22 + 20 >> 2] | 0;
     if (i9) if (i9 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
      HEAP32[i24 + 20 >> 2] = i9;
      HEAP32[i9 + 24 >> 2] = i24;
      break;
     }
    } while (0);
    if (i21 >>> 0 < 16) {
     i16 = i21 + i2 | 0;
     HEAP32[i22 + 4 >> 2] = i16 | 3;
     i9 = i22 + (i16 + 4) | 0;
     HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
    } else {
     HEAP32[i22 + 4 >> 2] = i2 | 3;
     HEAP32[i22 + (i2 | 4) >> 2] = i21 | 1;
     HEAP32[i22 + (i21 + i2) >> 2] = i21;
     i9 = HEAP32[5815] | 0;
     if (i9) {
      i16 = HEAP32[5818] | 0;
      i12 = i9 >>> 3;
      i9 = i12 << 1;
      i15 = 23292 + (i9 << 2) | 0;
      i3 = HEAP32[5813] | 0;
      i17 = 1 << i12;
      if (i3 & i17) {
       i12 = 23292 + (i9 + 2 << 2) | 0;
       i5 = HEAP32[i12 >> 2] | 0;
       if (i5 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
        i29 = i12;
        i30 = i5;
       }
      } else {
       HEAP32[5813] = i3 | i17;
       i29 = 23292 + (i9 + 2 << 2) | 0;
       i30 = i15;
      }
      HEAP32[i29 >> 2] = i16;
      HEAP32[i30 + 12 >> 2] = i16;
      HEAP32[i16 + 8 >> 2] = i30;
      HEAP32[i16 + 12 >> 2] = i15;
     }
     HEAP32[5815] = i21;
     HEAP32[5818] = i10;
    }
    i13 = i22 + 8 | 0;
    return i13 | 0;
   } else i31 = i2;
  } else i31 = i2;
 } else if (i1 >>> 0 <= 4294967231) {
  i15 = i1 + 11 | 0;
  i16 = i15 & -8;
  i9 = HEAP32[5814] | 0;
  if (i9) {
   i17 = 0 - i16 | 0;
   i3 = i15 >>> 8;
   if (i3) if (i16 >>> 0 > 16777215) i32 = 31; else {
    i15 = (i3 + 1048320 | 0) >>> 16 & 8;
    i5 = i3 << i15;
    i3 = (i5 + 520192 | 0) >>> 16 & 4;
    i12 = i5 << i3;
    i5 = (i12 + 245760 | 0) >>> 16 & 2;
    i8 = 14 - (i3 | i15 | i5) + (i12 << i5 >>> 15) | 0;
    i32 = i16 >>> (i8 + 7 | 0) & 1 | i8 << 1;
   } else i32 = 0;
   i8 = HEAP32[23556 + (i32 << 2) >> 2] | 0;
   L123 : do if (!i8) {
    i33 = i17;
    i34 = 0;
    i35 = 0;
    i36 = 86;
   } else {
    i5 = i17;
    i12 = 0;
    i15 = i16 << ((i32 | 0) == 31 ? 0 : 25 - (i32 >>> 1) | 0);
    i3 = i8;
    i4 = 0;
    while (1) {
     i7 = HEAP32[i3 + 4 >> 2] & -8;
     i14 = i7 - i16 | 0;
     if (i14 >>> 0 < i5 >>> 0) if ((i7 | 0) == (i16 | 0)) {
      i37 = i14;
      i38 = i3;
      i39 = i3;
      i36 = 90;
      break L123;
     } else {
      i40 = i14;
      i41 = i3;
     } else {
      i40 = i5;
      i41 = i4;
     }
     i14 = HEAP32[i3 + 20 >> 2] | 0;
     i3 = HEAP32[i3 + 16 + (i15 >>> 31 << 2) >> 2] | 0;
     i7 = (i14 | 0) == 0 | (i14 | 0) == (i3 | 0) ? i12 : i14;
     if (!i3) {
      i33 = i40;
      i34 = i7;
      i35 = i41;
      i36 = 86;
      break;
     } else {
      i5 = i40;
      i12 = i7;
      i15 = i15 << 1;
      i4 = i41;
     }
    }
   } while (0);
   if ((i36 | 0) == 86) {
    if ((i34 | 0) == 0 & (i35 | 0) == 0) {
     i8 = 2 << i32;
     i17 = i9 & (i8 | 0 - i8);
     if (!i17) {
      i31 = i16;
      break;
     }
     i8 = (i17 & 0 - i17) + -1 | 0;
     i17 = i8 >>> 12 & 16;
     i2 = i8 >>> i17;
     i8 = i2 >>> 5 & 8;
     i10 = i2 >>> i8;
     i2 = i10 >>> 2 & 4;
     i4 = i10 >>> i2;
     i10 = i4 >>> 1 & 2;
     i15 = i4 >>> i10;
     i4 = i15 >>> 1 & 1;
     i42 = HEAP32[23556 + ((i8 | i17 | i2 | i10 | i4) + (i15 >>> i4) << 2) >> 2] | 0;
     i43 = 0;
    } else {
     i42 = i34;
     i43 = i35;
    }
    if (!i42) {
     i44 = i33;
     i45 = i43;
    } else {
     i37 = i33;
     i38 = i42;
     i39 = i43;
     i36 = 90;
    }
   }
   if ((i36 | 0) == 90) while (1) {
    i36 = 0;
    i4 = (HEAP32[i38 + 4 >> 2] & -8) - i16 | 0;
    i15 = i4 >>> 0 < i37 >>> 0;
    i10 = i15 ? i4 : i37;
    i4 = i15 ? i38 : i39;
    i15 = HEAP32[i38 + 16 >> 2] | 0;
    if (i15) {
     i37 = i10;
     i38 = i15;
     i39 = i4;
     i36 = 90;
     continue;
    }
    i38 = HEAP32[i38 + 20 >> 2] | 0;
    if (!i38) {
     i44 = i10;
     i45 = i4;
     break;
    } else {
     i37 = i10;
     i39 = i4;
     i36 = 90;
    }
   }
   if ((i45 | 0) != 0 ? i44 >>> 0 < ((HEAP32[5815] | 0) - i16 | 0) >>> 0 : 0) {
    i9 = HEAP32[5817] | 0;
    if (i45 >>> 0 < i9 >>> 0) _abort();
    i4 = i45 + i16 | 0;
    if (i45 >>> 0 >= i4 >>> 0) _abort();
    i10 = HEAP32[i45 + 24 >> 2] | 0;
    i15 = HEAP32[i45 + 12 >> 2] | 0;
    do if ((i15 | 0) == (i45 | 0)) {
     i2 = i45 + 20 | 0;
     i17 = HEAP32[i2 >> 2] | 0;
     if (!i17) {
      i8 = i45 + 16 | 0;
      i12 = HEAP32[i8 >> 2] | 0;
      if (!i12) {
       i46 = 0;
       break;
      } else {
       i47 = i12;
       i48 = i8;
      }
     } else {
      i47 = i17;
      i48 = i2;
     }
     while (1) {
      i2 = i47 + 20 | 0;
      i17 = HEAP32[i2 >> 2] | 0;
      if (i17) {
       i47 = i17;
       i48 = i2;
       continue;
      }
      i2 = i47 + 16 | 0;
      i17 = HEAP32[i2 >> 2] | 0;
      if (!i17) {
       i49 = i47;
       i50 = i48;
       break;
      } else {
       i47 = i17;
       i48 = i2;
      }
     }
     if (i50 >>> 0 < i9 >>> 0) _abort(); else {
      HEAP32[i50 >> 2] = 0;
      i46 = i49;
      break;
     }
    } else {
     i2 = HEAP32[i45 + 8 >> 2] | 0;
     if (i2 >>> 0 < i9 >>> 0) _abort();
     i17 = i2 + 12 | 0;
     if ((HEAP32[i17 >> 2] | 0) != (i45 | 0)) _abort();
     i8 = i15 + 8 | 0;
     if ((HEAP32[i8 >> 2] | 0) == (i45 | 0)) {
      HEAP32[i17 >> 2] = i15;
      HEAP32[i8 >> 2] = i2;
      i46 = i15;
      break;
     } else _abort();
    } while (0);
    do if (i10) {
     i15 = HEAP32[i45 + 28 >> 2] | 0;
     i9 = 23556 + (i15 << 2) | 0;
     if ((i45 | 0) == (HEAP32[i9 >> 2] | 0)) {
      HEAP32[i9 >> 2] = i46;
      if (!i46) {
       HEAP32[5814] = HEAP32[5814] & ~(1 << i15);
       break;
      }
     } else {
      if (i10 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
      i15 = i10 + 16 | 0;
      if ((HEAP32[i15 >> 2] | 0) == (i45 | 0)) HEAP32[i15 >> 2] = i46; else HEAP32[i10 + 20 >> 2] = i46;
      if (!i46) break;
     }
     i15 = HEAP32[5817] | 0;
     if (i46 >>> 0 < i15 >>> 0) _abort();
     HEAP32[i46 + 24 >> 2] = i10;
     i9 = HEAP32[i45 + 16 >> 2] | 0;
     do if (i9) if (i9 >>> 0 < i15 >>> 0) _abort(); else {
      HEAP32[i46 + 16 >> 2] = i9;
      HEAP32[i9 + 24 >> 2] = i46;
      break;
     } while (0);
     i9 = HEAP32[i45 + 20 >> 2] | 0;
     if (i9) if (i9 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
      HEAP32[i46 + 20 >> 2] = i9;
      HEAP32[i9 + 24 >> 2] = i46;
      break;
     }
    } while (0);
    L199 : do if (i44 >>> 0 >= 16) {
     HEAP32[i45 + 4 >> 2] = i16 | 3;
     HEAP32[i45 + (i16 | 4) >> 2] = i44 | 1;
     HEAP32[i45 + (i44 + i16) >> 2] = i44;
     i10 = i44 >>> 3;
     if (i44 >>> 0 < 256) {
      i9 = i10 << 1;
      i15 = 23292 + (i9 << 2) | 0;
      i2 = HEAP32[5813] | 0;
      i8 = 1 << i10;
      if (i2 & i8) {
       i10 = 23292 + (i9 + 2 << 2) | 0;
       i17 = HEAP32[i10 >> 2] | 0;
       if (i17 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
        i51 = i10;
        i52 = i17;
       }
      } else {
       HEAP32[5813] = i2 | i8;
       i51 = 23292 + (i9 + 2 << 2) | 0;
       i52 = i15;
      }
      HEAP32[i51 >> 2] = i4;
      HEAP32[i52 + 12 >> 2] = i4;
      HEAP32[i45 + (i16 + 8) >> 2] = i52;
      HEAP32[i45 + (i16 + 12) >> 2] = i15;
      break;
     }
     i15 = i44 >>> 8;
     if (i15) if (i44 >>> 0 > 16777215) i53 = 31; else {
      i9 = (i15 + 1048320 | 0) >>> 16 & 8;
      i8 = i15 << i9;
      i15 = (i8 + 520192 | 0) >>> 16 & 4;
      i2 = i8 << i15;
      i8 = (i2 + 245760 | 0) >>> 16 & 2;
      i17 = 14 - (i15 | i9 | i8) + (i2 << i8 >>> 15) | 0;
      i53 = i44 >>> (i17 + 7 | 0) & 1 | i17 << 1;
     } else i53 = 0;
     i17 = 23556 + (i53 << 2) | 0;
     HEAP32[i45 + (i16 + 28) >> 2] = i53;
     HEAP32[i45 + (i16 + 20) >> 2] = 0;
     HEAP32[i45 + (i16 + 16) >> 2] = 0;
     i8 = HEAP32[5814] | 0;
     i2 = 1 << i53;
     if (!(i8 & i2)) {
      HEAP32[5814] = i8 | i2;
      HEAP32[i17 >> 2] = i4;
      HEAP32[i45 + (i16 + 24) >> 2] = i17;
      HEAP32[i45 + (i16 + 12) >> 2] = i4;
      HEAP32[i45 + (i16 + 8) >> 2] = i4;
      break;
     }
     i2 = HEAP32[i17 >> 2] | 0;
     L217 : do if ((HEAP32[i2 + 4 >> 2] & -8 | 0) != (i44 | 0)) {
      i17 = i44 << ((i53 | 0) == 31 ? 0 : 25 - (i53 >>> 1) | 0);
      i8 = i2;
      while (1) {
       i9 = i8 + 16 + (i17 >>> 31 << 2) | 0;
       i15 = HEAP32[i9 >> 2] | 0;
       if (!i15) {
        i54 = i9;
        i55 = i8;
        break;
       }
       if ((HEAP32[i15 + 4 >> 2] & -8 | 0) == (i44 | 0)) {
        i56 = i15;
        break L217;
       } else {
        i17 = i17 << 1;
        i8 = i15;
       }
      }
      if (i54 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
       HEAP32[i54 >> 2] = i4;
       HEAP32[i45 + (i16 + 24) >> 2] = i55;
       HEAP32[i45 + (i16 + 12) >> 2] = i4;
       HEAP32[i45 + (i16 + 8) >> 2] = i4;
       break L199;
      }
     } else i56 = i2; while (0);
     i2 = i56 + 8 | 0;
     i8 = HEAP32[i2 >> 2] | 0;
     i17 = HEAP32[5817] | 0;
     if (i8 >>> 0 >= i17 >>> 0 & i56 >>> 0 >= i17 >>> 0) {
      HEAP32[i8 + 12 >> 2] = i4;
      HEAP32[i2 >> 2] = i4;
      HEAP32[i45 + (i16 + 8) >> 2] = i8;
      HEAP32[i45 + (i16 + 12) >> 2] = i56;
      HEAP32[i45 + (i16 + 24) >> 2] = 0;
      break;
     } else _abort();
    } else {
     i8 = i44 + i16 | 0;
     HEAP32[i45 + 4 >> 2] = i8 | 3;
     i2 = i45 + (i8 + 4) | 0;
     HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
    } while (0);
    i13 = i45 + 8 | 0;
    return i13 | 0;
   } else i31 = i16;
  } else i31 = i16;
 } else i31 = -1; while (0);
 i45 = HEAP32[5815] | 0;
 if (i45 >>> 0 >= i31 >>> 0) {
  i44 = i45 - i31 | 0;
  i56 = HEAP32[5818] | 0;
  if (i44 >>> 0 > 15) {
   HEAP32[5818] = i56 + i31;
   HEAP32[5815] = i44;
   HEAP32[i56 + (i31 + 4) >> 2] = i44 | 1;
   HEAP32[i56 + i45 >> 2] = i44;
   HEAP32[i56 + 4 >> 2] = i31 | 3;
  } else {
   HEAP32[5815] = 0;
   HEAP32[5818] = 0;
   HEAP32[i56 + 4 >> 2] = i45 | 3;
   i44 = i56 + (i45 + 4) | 0;
   HEAP32[i44 >> 2] = HEAP32[i44 >> 2] | 1;
  }
  i13 = i56 + 8 | 0;
  return i13 | 0;
 }
 i56 = HEAP32[5816] | 0;
 if (i56 >>> 0 > i31 >>> 0) {
  i44 = i56 - i31 | 0;
  HEAP32[5816] = i44;
  i56 = HEAP32[5819] | 0;
  HEAP32[5819] = i56 + i31;
  HEAP32[i56 + (i31 + 4) >> 2] = i44 | 1;
  HEAP32[i56 + 4 >> 2] = i31 | 3;
  i13 = i56 + 8 | 0;
  return i13 | 0;
 }
 do if (!(HEAP32[5931] | 0)) {
  i56 = _sysconf(30) | 0;
  if (!(i56 + -1 & i56)) {
   HEAP32[5933] = i56;
   HEAP32[5932] = i56;
   HEAP32[5934] = -1;
   HEAP32[5935] = -1;
   HEAP32[5936] = 0;
   HEAP32[5924] = 0;
   i56 = (_time(0) | 0) & -16 ^ 1431655768;
   HEAP32[5931] = i56;
   break;
  } else _abort();
 } while (0);
 i56 = i31 + 48 | 0;
 i44 = HEAP32[5933] | 0;
 i45 = i31 + 47 | 0;
 i55 = i44 + i45 | 0;
 i54 = 0 - i44 | 0;
 i44 = i55 & i54;
 if (i44 >>> 0 <= i31 >>> 0) {
  i13 = 0;
  return i13 | 0;
 }
 i53 = HEAP32[5923] | 0;
 if ((i53 | 0) != 0 ? (i52 = HEAP32[5921] | 0, i51 = i52 + i44 | 0, i51 >>> 0 <= i52 >>> 0 | i51 >>> 0 > i53 >>> 0) : 0) {
  i13 = 0;
  return i13 | 0;
 }
 L258 : do if (!(HEAP32[5924] & 4)) {
  i53 = HEAP32[5819] | 0;
  L260 : do if (i53) {
   i51 = 23700;
   while (1) {
    i52 = HEAP32[i51 >> 2] | 0;
    if (i52 >>> 0 <= i53 >>> 0 ? (i46 = i51 + 4 | 0, (i52 + (HEAP32[i46 >> 2] | 0) | 0) >>> 0 > i53 >>> 0) : 0) {
     i57 = i51;
     i58 = i46;
     break;
    }
    i51 = HEAP32[i51 + 8 >> 2] | 0;
    if (!i51) {
     i36 = 174;
     break L260;
    }
   }
   i51 = i55 - (HEAP32[5816] | 0) & i54;
   if (i51 >>> 0 < 2147483647) {
    i46 = _sbrk(i51 | 0) | 0;
    i52 = (i46 | 0) == ((HEAP32[i57 >> 2] | 0) + (HEAP32[i58 >> 2] | 0) | 0);
    i49 = i52 ? i51 : 0;
    if (i52) if ((i46 | 0) == (-1 | 0)) i59 = i49; else {
     i60 = i46;
     i61 = i49;
     i36 = 194;
     break L258;
    } else {
     i62 = i46;
     i63 = i51;
     i64 = i49;
     i36 = 184;
    }
   } else i59 = 0;
  } else i36 = 174; while (0);
  do if ((i36 | 0) == 174) {
   i53 = _sbrk(0) | 0;
   if ((i53 | 0) != (-1 | 0)) {
    i16 = i53;
    i49 = HEAP32[5932] | 0;
    i51 = i49 + -1 | 0;
    if (!(i51 & i16)) i65 = i44; else i65 = i44 - i16 + (i51 + i16 & 0 - i49) | 0;
    i49 = HEAP32[5921] | 0;
    i16 = i49 + i65 | 0;
    if (i65 >>> 0 > i31 >>> 0 & i65 >>> 0 < 2147483647) {
     i51 = HEAP32[5923] | 0;
     if ((i51 | 0) != 0 ? i16 >>> 0 <= i49 >>> 0 | i16 >>> 0 > i51 >>> 0 : 0) {
      i59 = 0;
      break;
     }
     i51 = _sbrk(i65 | 0) | 0;
     i16 = (i51 | 0) == (i53 | 0);
     i49 = i16 ? i65 : 0;
     if (i16) {
      i60 = i53;
      i61 = i49;
      i36 = 194;
      break L258;
     } else {
      i62 = i51;
      i63 = i65;
      i64 = i49;
      i36 = 184;
     }
    } else i59 = 0;
   } else i59 = 0;
  } while (0);
  L280 : do if ((i36 | 0) == 184) {
   i49 = 0 - i63 | 0;
   do if (i56 >>> 0 > i63 >>> 0 & (i63 >>> 0 < 2147483647 & (i62 | 0) != (-1 | 0)) ? (i51 = HEAP32[5933] | 0, i53 = i45 - i63 + i51 & 0 - i51, i53 >>> 0 < 2147483647) : 0) if ((_sbrk(i53 | 0) | 0) == (-1 | 0)) {
    _sbrk(i49 | 0) | 0;
    i59 = i64;
    break L280;
   } else {
    i66 = i53 + i63 | 0;
    break;
   } else i66 = i63; while (0);
   if ((i62 | 0) == (-1 | 0)) i59 = i64; else {
    i60 = i62;
    i61 = i66;
    i36 = 194;
    break L258;
   }
  } while (0);
  HEAP32[5924] = HEAP32[5924] | 4;
  i67 = i59;
  i36 = 191;
 } else {
  i67 = 0;
  i36 = 191;
 } while (0);
 if ((((i36 | 0) == 191 ? i44 >>> 0 < 2147483647 : 0) ? (i59 = _sbrk(i44 | 0) | 0, i44 = _sbrk(0) | 0, i59 >>> 0 < i44 >>> 0 & ((i59 | 0) != (-1 | 0) & (i44 | 0) != (-1 | 0))) : 0) ? (i66 = i44 - i59 | 0, i44 = i66 >>> 0 > (i31 + 40 | 0) >>> 0, i44) : 0) {
  i60 = i59;
  i61 = i44 ? i66 : i67;
  i36 = 194;
 }
 if ((i36 | 0) == 194) {
  i67 = (HEAP32[5921] | 0) + i61 | 0;
  HEAP32[5921] = i67;
  if (i67 >>> 0 > (HEAP32[5922] | 0) >>> 0) HEAP32[5922] = i67;
  i67 = HEAP32[5819] | 0;
  L299 : do if (i67) {
   i66 = 23700;
   do {
    i44 = HEAP32[i66 >> 2] | 0;
    i59 = i66 + 4 | 0;
    i62 = HEAP32[i59 >> 2] | 0;
    if ((i60 | 0) == (i44 + i62 | 0)) {
     i68 = i44;
     i69 = i59;
     i70 = i62;
     i71 = i66;
     i36 = 204;
     break;
    }
    i66 = HEAP32[i66 + 8 >> 2] | 0;
   } while ((i66 | 0) != 0);
   if (((i36 | 0) == 204 ? (HEAP32[i71 + 12 >> 2] & 8 | 0) == 0 : 0) ? i67 >>> 0 < i60 >>> 0 & i67 >>> 0 >= i68 >>> 0 : 0) {
    HEAP32[i69 >> 2] = i70 + i61;
    i66 = (HEAP32[5816] | 0) + i61 | 0;
    i62 = i67 + 8 | 0;
    i59 = (i62 & 7 | 0) == 0 ? 0 : 0 - i62 & 7;
    i62 = i66 - i59 | 0;
    HEAP32[5819] = i67 + i59;
    HEAP32[5816] = i62;
    HEAP32[i67 + (i59 + 4) >> 2] = i62 | 1;
    HEAP32[i67 + (i66 + 4) >> 2] = 40;
    HEAP32[5820] = HEAP32[5935];
    break;
   }
   i66 = HEAP32[5817] | 0;
   if (i60 >>> 0 < i66 >>> 0) {
    HEAP32[5817] = i60;
    i72 = i60;
   } else i72 = i66;
   i66 = i60 + i61 | 0;
   i62 = 23700;
   while (1) {
    if ((HEAP32[i62 >> 2] | 0) == (i66 | 0)) {
     i73 = i62;
     i74 = i62;
     i36 = 212;
     break;
    }
    i62 = HEAP32[i62 + 8 >> 2] | 0;
    if (!i62) {
     i75 = 23700;
     break;
    }
   }
   if ((i36 | 0) == 212) if (!(HEAP32[i74 + 12 >> 2] & 8)) {
    HEAP32[i73 >> 2] = i60;
    i62 = i74 + 4 | 0;
    HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + i61;
    i62 = i60 + 8 | 0;
    i66 = (i62 & 7 | 0) == 0 ? 0 : 0 - i62 & 7;
    i62 = i60 + (i61 + 8) | 0;
    i59 = (i62 & 7 | 0) == 0 ? 0 : 0 - i62 & 7;
    i62 = i60 + (i59 + i61) | 0;
    i44 = i66 + i31 | 0;
    i64 = i60 + i44 | 0;
    i63 = i62 - (i60 + i66) - i31 | 0;
    HEAP32[i60 + (i66 + 4) >> 2] = i31 | 3;
    L324 : do if ((i62 | 0) != (i67 | 0)) {
     if ((i62 | 0) == (HEAP32[5818] | 0)) {
      i45 = (HEAP32[5815] | 0) + i63 | 0;
      HEAP32[5815] = i45;
      HEAP32[5818] = i64;
      HEAP32[i60 + (i44 + 4) >> 2] = i45 | 1;
      HEAP32[i60 + (i45 + i44) >> 2] = i45;
      break;
     }
     i45 = i61 + 4 | 0;
     i56 = HEAP32[i60 + (i45 + i59) >> 2] | 0;
     if ((i56 & 3 | 0) == 1) {
      i65 = i56 & -8;
      i58 = i56 >>> 3;
      L332 : do if (i56 >>> 0 >= 256) {
       i57 = HEAP32[i60 + ((i59 | 24) + i61) >> 2] | 0;
       i54 = HEAP32[i60 + (i61 + 12 + i59) >> 2] | 0;
       do if ((i54 | 0) == (i62 | 0)) {
        i55 = i59 | 16;
        i49 = i60 + (i45 + i55) | 0;
        i53 = HEAP32[i49 >> 2] | 0;
        if (!i53) {
         i51 = i60 + (i55 + i61) | 0;
         i55 = HEAP32[i51 >> 2] | 0;
         if (!i55) {
          i76 = 0;
          break;
         } else {
          i77 = i55;
          i78 = i51;
         }
        } else {
         i77 = i53;
         i78 = i49;
        }
        while (1) {
         i49 = i77 + 20 | 0;
         i53 = HEAP32[i49 >> 2] | 0;
         if (i53) {
          i77 = i53;
          i78 = i49;
          continue;
         }
         i49 = i77 + 16 | 0;
         i53 = HEAP32[i49 >> 2] | 0;
         if (!i53) {
          i79 = i77;
          i80 = i78;
          break;
         } else {
          i77 = i53;
          i78 = i49;
         }
        }
        if (i80 >>> 0 < i72 >>> 0) _abort(); else {
         HEAP32[i80 >> 2] = 0;
         i76 = i79;
         break;
        }
       } else {
        i49 = HEAP32[i60 + ((i59 | 8) + i61) >> 2] | 0;
        if (i49 >>> 0 < i72 >>> 0) _abort();
        i53 = i49 + 12 | 0;
        if ((HEAP32[i53 >> 2] | 0) != (i62 | 0)) _abort();
        i51 = i54 + 8 | 0;
        if ((HEAP32[i51 >> 2] | 0) == (i62 | 0)) {
         HEAP32[i53 >> 2] = i54;
         HEAP32[i51 >> 2] = i49;
         i76 = i54;
         break;
        } else _abort();
       } while (0);
       if (!i57) break;
       i54 = HEAP32[i60 + (i61 + 28 + i59) >> 2] | 0;
       i49 = 23556 + (i54 << 2) | 0;
       do if ((i62 | 0) != (HEAP32[i49 >> 2] | 0)) {
        if (i57 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
        i51 = i57 + 16 | 0;
        if ((HEAP32[i51 >> 2] | 0) == (i62 | 0)) HEAP32[i51 >> 2] = i76; else HEAP32[i57 + 20 >> 2] = i76;
        if (!i76) break L332;
       } else {
        HEAP32[i49 >> 2] = i76;
        if (i76) break;
        HEAP32[5814] = HEAP32[5814] & ~(1 << i54);
        break L332;
       } while (0);
       i54 = HEAP32[5817] | 0;
       if (i76 >>> 0 < i54 >>> 0) _abort();
       HEAP32[i76 + 24 >> 2] = i57;
       i49 = i59 | 16;
       i51 = HEAP32[i60 + (i49 + i61) >> 2] | 0;
       do if (i51) if (i51 >>> 0 < i54 >>> 0) _abort(); else {
        HEAP32[i76 + 16 >> 2] = i51;
        HEAP32[i51 + 24 >> 2] = i76;
        break;
       } while (0);
       i51 = HEAP32[i60 + (i45 + i49) >> 2] | 0;
       if (!i51) break;
       if (i51 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
        HEAP32[i76 + 20 >> 2] = i51;
        HEAP32[i51 + 24 >> 2] = i76;
        break;
       }
      } else {
       i51 = HEAP32[i60 + ((i59 | 8) + i61) >> 2] | 0;
       i54 = HEAP32[i60 + (i61 + 12 + i59) >> 2] | 0;
       i57 = 23292 + (i58 << 1 << 2) | 0;
       do if ((i51 | 0) != (i57 | 0)) {
        if (i51 >>> 0 < i72 >>> 0) _abort();
        if ((HEAP32[i51 + 12 >> 2] | 0) == (i62 | 0)) break;
        _abort();
       } while (0);
       if ((i54 | 0) == (i51 | 0)) {
        HEAP32[5813] = HEAP32[5813] & ~(1 << i58);
        break;
       }
       do if ((i54 | 0) == (i57 | 0)) i81 = i54 + 8 | 0; else {
        if (i54 >>> 0 < i72 >>> 0) _abort();
        i49 = i54 + 8 | 0;
        if ((HEAP32[i49 >> 2] | 0) == (i62 | 0)) {
         i81 = i49;
         break;
        }
        _abort();
       } while (0);
       HEAP32[i51 + 12 >> 2] = i54;
       HEAP32[i81 >> 2] = i51;
      } while (0);
      i82 = i60 + ((i65 | i59) + i61) | 0;
      i83 = i65 + i63 | 0;
     } else {
      i82 = i62;
      i83 = i63;
     }
     i58 = i82 + 4 | 0;
     HEAP32[i58 >> 2] = HEAP32[i58 >> 2] & -2;
     HEAP32[i60 + (i44 + 4) >> 2] = i83 | 1;
     HEAP32[i60 + (i83 + i44) >> 2] = i83;
     i58 = i83 >>> 3;
     if (i83 >>> 0 < 256) {
      i45 = i58 << 1;
      i56 = 23292 + (i45 << 2) | 0;
      i57 = HEAP32[5813] | 0;
      i49 = 1 << i58;
      do if (!(i57 & i49)) {
       HEAP32[5813] = i57 | i49;
       i84 = 23292 + (i45 + 2 << 2) | 0;
       i85 = i56;
      } else {
       i58 = 23292 + (i45 + 2 << 2) | 0;
       i53 = HEAP32[i58 >> 2] | 0;
       if (i53 >>> 0 >= (HEAP32[5817] | 0) >>> 0) {
        i84 = i58;
        i85 = i53;
        break;
       }
       _abort();
      } while (0);
      HEAP32[i84 >> 2] = i64;
      HEAP32[i85 + 12 >> 2] = i64;
      HEAP32[i60 + (i44 + 8) >> 2] = i85;
      HEAP32[i60 + (i44 + 12) >> 2] = i56;
      break;
     }
     i45 = i83 >>> 8;
     do if (!i45) i86 = 0; else {
      if (i83 >>> 0 > 16777215) {
       i86 = 31;
       break;
      }
      i49 = (i45 + 1048320 | 0) >>> 16 & 8;
      i57 = i45 << i49;
      i65 = (i57 + 520192 | 0) >>> 16 & 4;
      i53 = i57 << i65;
      i57 = (i53 + 245760 | 0) >>> 16 & 2;
      i58 = 14 - (i65 | i49 | i57) + (i53 << i57 >>> 15) | 0;
      i86 = i83 >>> (i58 + 7 | 0) & 1 | i58 << 1;
     } while (0);
     i45 = 23556 + (i86 << 2) | 0;
     HEAP32[i60 + (i44 + 28) >> 2] = i86;
     HEAP32[i60 + (i44 + 20) >> 2] = 0;
     HEAP32[i60 + (i44 + 16) >> 2] = 0;
     i56 = HEAP32[5814] | 0;
     i58 = 1 << i86;
     if (!(i56 & i58)) {
      HEAP32[5814] = i56 | i58;
      HEAP32[i45 >> 2] = i64;
      HEAP32[i60 + (i44 + 24) >> 2] = i45;
      HEAP32[i60 + (i44 + 12) >> 2] = i64;
      HEAP32[i60 + (i44 + 8) >> 2] = i64;
      break;
     }
     i58 = HEAP32[i45 >> 2] | 0;
     L418 : do if ((HEAP32[i58 + 4 >> 2] & -8 | 0) != (i83 | 0)) {
      i45 = i83 << ((i86 | 0) == 31 ? 0 : 25 - (i86 >>> 1) | 0);
      i56 = i58;
      while (1) {
       i57 = i56 + 16 + (i45 >>> 31 << 2) | 0;
       i53 = HEAP32[i57 >> 2] | 0;
       if (!i53) {
        i87 = i57;
        i88 = i56;
        break;
       }
       if ((HEAP32[i53 + 4 >> 2] & -8 | 0) == (i83 | 0)) {
        i89 = i53;
        break L418;
       } else {
        i45 = i45 << 1;
        i56 = i53;
       }
      }
      if (i87 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
       HEAP32[i87 >> 2] = i64;
       HEAP32[i60 + (i44 + 24) >> 2] = i88;
       HEAP32[i60 + (i44 + 12) >> 2] = i64;
       HEAP32[i60 + (i44 + 8) >> 2] = i64;
       break L324;
      }
     } else i89 = i58; while (0);
     i58 = i89 + 8 | 0;
     i56 = HEAP32[i58 >> 2] | 0;
     i45 = HEAP32[5817] | 0;
     if (i56 >>> 0 >= i45 >>> 0 & i89 >>> 0 >= i45 >>> 0) {
      HEAP32[i56 + 12 >> 2] = i64;
      HEAP32[i58 >> 2] = i64;
      HEAP32[i60 + (i44 + 8) >> 2] = i56;
      HEAP32[i60 + (i44 + 12) >> 2] = i89;
      HEAP32[i60 + (i44 + 24) >> 2] = 0;
      break;
     } else _abort();
    } else {
     i56 = (HEAP32[5816] | 0) + i63 | 0;
     HEAP32[5816] = i56;
     HEAP32[5819] = i64;
     HEAP32[i60 + (i44 + 4) >> 2] = i56 | 1;
    } while (0);
    i13 = i60 + (i66 | 8) | 0;
    return i13 | 0;
   } else i75 = 23700;
   while (1) {
    i44 = HEAP32[i75 >> 2] | 0;
    if (i44 >>> 0 <= i67 >>> 0 ? (i64 = HEAP32[i75 + 4 >> 2] | 0, i63 = i44 + i64 | 0, i63 >>> 0 > i67 >>> 0) : 0) {
     i90 = i44;
     i91 = i64;
     i92 = i63;
     break;
    }
    i75 = HEAP32[i75 + 8 >> 2] | 0;
   }
   i66 = i90 + (i91 + -39) | 0;
   i63 = i90 + (i91 + -47 + ((i66 & 7 | 0) == 0 ? 0 : 0 - i66 & 7)) | 0;
   i66 = i67 + 16 | 0;
   i64 = i63 >>> 0 < i66 >>> 0 ? i67 : i63;
   i63 = i64 + 8 | 0;
   i44 = i60 + 8 | 0;
   i62 = (i44 & 7 | 0) == 0 ? 0 : 0 - i44 & 7;
   i44 = i61 + -40 - i62 | 0;
   HEAP32[5819] = i60 + i62;
   HEAP32[5816] = i44;
   HEAP32[i60 + (i62 + 4) >> 2] = i44 | 1;
   HEAP32[i60 + (i61 + -36) >> 2] = 40;
   HEAP32[5820] = HEAP32[5935];
   i44 = i64 + 4 | 0;
   HEAP32[i44 >> 2] = 27;
   HEAP32[i63 >> 2] = HEAP32[5925];
   HEAP32[i63 + 4 >> 2] = HEAP32[5926];
   HEAP32[i63 + 8 >> 2] = HEAP32[5927];
   HEAP32[i63 + 12 >> 2] = HEAP32[5928];
   HEAP32[5925] = i60;
   HEAP32[5926] = i61;
   HEAP32[5928] = 0;
   HEAP32[5927] = i63;
   i63 = i64 + 28 | 0;
   HEAP32[i63 >> 2] = 7;
   if ((i64 + 32 | 0) >>> 0 < i92 >>> 0) {
    i62 = i63;
    do {
     i63 = i62;
     i62 = i62 + 4 | 0;
     HEAP32[i62 >> 2] = 7;
    } while ((i63 + 8 | 0) >>> 0 < i92 >>> 0);
   }
   if ((i64 | 0) != (i67 | 0)) {
    i62 = i64 - i67 | 0;
    HEAP32[i44 >> 2] = HEAP32[i44 >> 2] & -2;
    HEAP32[i67 + 4 >> 2] = i62 | 1;
    HEAP32[i64 >> 2] = i62;
    i63 = i62 >>> 3;
    if (i62 >>> 0 < 256) {
     i59 = i63 << 1;
     i56 = 23292 + (i59 << 2) | 0;
     i58 = HEAP32[5813] | 0;
     i45 = 1 << i63;
     if (i58 & i45) {
      i63 = 23292 + (i59 + 2 << 2) | 0;
      i51 = HEAP32[i63 >> 2] | 0;
      if (i51 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
       i93 = i63;
       i94 = i51;
      }
     } else {
      HEAP32[5813] = i58 | i45;
      i93 = 23292 + (i59 + 2 << 2) | 0;
      i94 = i56;
     }
     HEAP32[i93 >> 2] = i67;
     HEAP32[i94 + 12 >> 2] = i67;
     HEAP32[i67 + 8 >> 2] = i94;
     HEAP32[i67 + 12 >> 2] = i56;
     break;
    }
    i56 = i62 >>> 8;
    if (i56) if (i62 >>> 0 > 16777215) i95 = 31; else {
     i59 = (i56 + 1048320 | 0) >>> 16 & 8;
     i45 = i56 << i59;
     i56 = (i45 + 520192 | 0) >>> 16 & 4;
     i58 = i45 << i56;
     i45 = (i58 + 245760 | 0) >>> 16 & 2;
     i51 = 14 - (i56 | i59 | i45) + (i58 << i45 >>> 15) | 0;
     i95 = i62 >>> (i51 + 7 | 0) & 1 | i51 << 1;
    } else i95 = 0;
    i51 = 23556 + (i95 << 2) | 0;
    HEAP32[i67 + 28 >> 2] = i95;
    HEAP32[i67 + 20 >> 2] = 0;
    HEAP32[i66 >> 2] = 0;
    i45 = HEAP32[5814] | 0;
    i58 = 1 << i95;
    if (!(i45 & i58)) {
     HEAP32[5814] = i45 | i58;
     HEAP32[i51 >> 2] = i67;
     HEAP32[i67 + 24 >> 2] = i51;
     HEAP32[i67 + 12 >> 2] = i67;
     HEAP32[i67 + 8 >> 2] = i67;
     break;
    }
    i58 = HEAP32[i51 >> 2] | 0;
    L459 : do if ((HEAP32[i58 + 4 >> 2] & -8 | 0) != (i62 | 0)) {
     i51 = i62 << ((i95 | 0) == 31 ? 0 : 25 - (i95 >>> 1) | 0);
     i45 = i58;
     while (1) {
      i59 = i45 + 16 + (i51 >>> 31 << 2) | 0;
      i56 = HEAP32[i59 >> 2] | 0;
      if (!i56) {
       i96 = i59;
       i97 = i45;
       break;
      }
      if ((HEAP32[i56 + 4 >> 2] & -8 | 0) == (i62 | 0)) {
       i98 = i56;
       break L459;
      } else {
       i51 = i51 << 1;
       i45 = i56;
      }
     }
     if (i96 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
      HEAP32[i96 >> 2] = i67;
      HEAP32[i67 + 24 >> 2] = i97;
      HEAP32[i67 + 12 >> 2] = i67;
      HEAP32[i67 + 8 >> 2] = i67;
      break L299;
     }
    } else i98 = i58; while (0);
    i58 = i98 + 8 | 0;
    i62 = HEAP32[i58 >> 2] | 0;
    i66 = HEAP32[5817] | 0;
    if (i62 >>> 0 >= i66 >>> 0 & i98 >>> 0 >= i66 >>> 0) {
     HEAP32[i62 + 12 >> 2] = i67;
     HEAP32[i58 >> 2] = i67;
     HEAP32[i67 + 8 >> 2] = i62;
     HEAP32[i67 + 12 >> 2] = i98;
     HEAP32[i67 + 24 >> 2] = 0;
     break;
    } else _abort();
   }
  } else {
   i62 = HEAP32[5817] | 0;
   if ((i62 | 0) == 0 | i60 >>> 0 < i62 >>> 0) HEAP32[5817] = i60;
   HEAP32[5925] = i60;
   HEAP32[5926] = i61;
   HEAP32[5928] = 0;
   HEAP32[5822] = HEAP32[5931];
   HEAP32[5821] = -1;
   i62 = 0;
   do {
    i58 = i62 << 1;
    i66 = 23292 + (i58 << 2) | 0;
    HEAP32[23292 + (i58 + 3 << 2) >> 2] = i66;
    HEAP32[23292 + (i58 + 2 << 2) >> 2] = i66;
    i62 = i62 + 1 | 0;
   } while ((i62 | 0) != 32);
   i62 = i60 + 8 | 0;
   i66 = (i62 & 7 | 0) == 0 ? 0 : 0 - i62 & 7;
   i62 = i61 + -40 - i66 | 0;
   HEAP32[5819] = i60 + i66;
   HEAP32[5816] = i62;
   HEAP32[i60 + (i66 + 4) >> 2] = i62 | 1;
   HEAP32[i60 + (i61 + -36) >> 2] = 40;
   HEAP32[5820] = HEAP32[5935];
  } while (0);
  i61 = HEAP32[5816] | 0;
  if (i61 >>> 0 > i31 >>> 0) {
   i60 = i61 - i31 | 0;
   HEAP32[5816] = i60;
   i61 = HEAP32[5819] | 0;
   HEAP32[5819] = i61 + i31;
   HEAP32[i61 + (i31 + 4) >> 2] = i60 | 1;
   HEAP32[i61 + 4 >> 2] = i31 | 3;
   i13 = i61 + 8 | 0;
   return i13 | 0;
  }
 }
 i61 = ___errno_location() | 0;
 HEAP32[i61 >> 2] = 12;
 i13 = 0;
 return i13 | 0;
}

function _printf_core(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, d100 = 0.0, d101 = 0.0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, d107 = 0.0, d108 = 0.0, d109 = 0.0, d110 = 0.0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, d119 = 0.0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, d147 = 0.0, d148 = 0.0, d149 = 0.0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 i7 = i6 + 24 | 0;
 i8 = i6 + 16 | 0;
 i9 = i6 + 588 | 0;
 i10 = i6 + 576 | 0;
 i11 = i6;
 i12 = i6 + 536 | 0;
 i13 = i6 + 8 | 0;
 i14 = i6 + 528 | 0;
 i15 = (i1 | 0) != 0;
 i16 = i12 + 40 | 0;
 i17 = i16;
 i18 = i12 + 39 | 0;
 i12 = i13 + 4 | 0;
 i19 = i10 + 12 | 0;
 i20 = i10 + 11 | 0;
 i10 = i9;
 i21 = i19;
 i22 = i21 - i10 | 0;
 i23 = -2 - i10 | 0;
 i24 = i21 + 2 | 0;
 i25 = i7 + 288 | 0;
 i26 = i9 + 9 | 0;
 i27 = i26;
 i28 = i9 + 8 | 0;
 i29 = 0;
 i30 = i2;
 i2 = 0;
 i31 = 0;
 L1 : while (1) {
  do if ((i29 | 0) > -1) if ((i2 | 0) > (2147483647 - i29 | 0)) {
   i32 = ___errno_location() | 0;
   HEAP32[i32 >> 2] = 75;
   i33 = -1;
   break;
  } else {
   i33 = i2 + i29 | 0;
   break;
  } else i33 = i29; while (0);
  i32 = HEAP8[i30 >> 0] | 0;
  if (!(i32 << 24 >> 24)) {
   i34 = i33;
   i35 = i31;
   i36 = 245;
   break;
  } else {
   i37 = i32;
   i38 = i30;
  }
  L9 : while (1) {
   switch (i37 << 24 >> 24) {
   case 37:
    {
     i39 = i38;
     i40 = i38;
     i36 = 9;
     break L9;
     break;
    }
   case 0:
    {
     i41 = i38;
     i42 = i38;
     break L9;
     break;
    }
   default:
    {}
   }
   i32 = i38 + 1 | 0;
   i37 = HEAP8[i32 >> 0] | 0;
   i38 = i32;
  }
  L12 : do if ((i36 | 0) == 9) while (1) {
   i36 = 0;
   if ((HEAP8[i39 + 1 >> 0] | 0) != 37) {
    i41 = i39;
    i42 = i40;
    break L12;
   }
   i32 = i40 + 1 | 0;
   i43 = i39 + 2 | 0;
   if ((HEAP8[i43 >> 0] | 0) == 37) {
    i39 = i43;
    i40 = i32;
    i36 = 9;
   } else {
    i41 = i43;
    i42 = i32;
    break;
   }
  } while (0);
  i32 = i42 - i30 | 0;
  if (i15 ? (HEAP32[i1 >> 2] & 32 | 0) == 0 : 0) ___fwritex(i30, i32, i1) | 0;
  if ((i42 | 0) != (i30 | 0)) {
   i29 = i33;
   i30 = i41;
   i2 = i32;
   continue;
  }
  i43 = i41 + 1 | 0;
  i44 = HEAP8[i43 >> 0] | 0;
  i45 = (i44 << 24 >> 24) + -48 | 0;
  if (i45 >>> 0 < 10) {
   i46 = (HEAP8[i41 + 2 >> 0] | 0) == 36;
   i47 = i46 ? i41 + 3 | 0 : i43;
   i48 = HEAP8[i47 >> 0] | 0;
   i49 = i46 ? i45 : -1;
   i50 = i46 ? 1 : i31;
   i51 = i47;
  } else {
   i48 = i44;
   i49 = -1;
   i50 = i31;
   i51 = i43;
  }
  i43 = i48 << 24 >> 24;
  L25 : do if ((i43 & -32 | 0) == 32) {
   i44 = i43;
   i47 = i48;
   i46 = 0;
   i45 = i51;
   while (1) {
    if (!(1 << i44 + -32 & 75913)) {
     i52 = i47;
     i53 = i46;
     i54 = i45;
     break L25;
    }
    i55 = 1 << (i47 << 24 >> 24) + -32 | i46;
    i56 = i45 + 1 | 0;
    i57 = HEAP8[i56 >> 0] | 0;
    i44 = i57 << 24 >> 24;
    if ((i44 & -32 | 0) != 32) {
     i52 = i57;
     i53 = i55;
     i54 = i56;
     break;
    } else {
     i47 = i57;
     i46 = i55;
     i45 = i56;
    }
   }
  } else {
   i52 = i48;
   i53 = 0;
   i54 = i51;
  } while (0);
  do if (i52 << 24 >> 24 == 42) {
   i43 = i54 + 1 | 0;
   i45 = (HEAP8[i43 >> 0] | 0) + -48 | 0;
   if (i45 >>> 0 < 10 ? (HEAP8[i54 + 2 >> 0] | 0) == 36 : 0) {
    HEAP32[i5 + (i45 << 2) >> 2] = 10;
    i58 = 1;
    i59 = i54 + 3 | 0;
    i60 = HEAP32[i4 + ((HEAP8[i43 >> 0] | 0) + -48 << 3) >> 2] | 0;
   } else {
    if (i50) {
     i61 = -1;
     break L1;
    }
    if (!i15) {
     i62 = i53;
     i63 = i43;
     i64 = 0;
     i65 = 0;
     break;
    }
    i45 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
    i46 = HEAP32[i45 >> 2] | 0;
    HEAP32[i3 >> 2] = i45 + 4;
    i58 = 0;
    i59 = i43;
    i60 = i46;
   }
   if ((i60 | 0) < 0) {
    i62 = i53 | 8192;
    i63 = i59;
    i64 = i58;
    i65 = 0 - i60 | 0;
   } else {
    i62 = i53;
    i63 = i59;
    i64 = i58;
    i65 = i60;
   }
  } else {
   i46 = (i52 << 24 >> 24) + -48 | 0;
   if (i46 >>> 0 < 10) {
    i43 = i54;
    i45 = 0;
    i47 = i46;
    while (1) {
     i46 = (i45 * 10 | 0) + i47 | 0;
     i44 = i43 + 1 | 0;
     i47 = (HEAP8[i44 >> 0] | 0) + -48 | 0;
     if (i47 >>> 0 >= 10) {
      i66 = i46;
      i67 = i44;
      break;
     } else {
      i43 = i44;
      i45 = i46;
     }
    }
    if ((i66 | 0) < 0) {
     i61 = -1;
     break L1;
    } else {
     i62 = i53;
     i63 = i67;
     i64 = i50;
     i65 = i66;
    }
   } else {
    i62 = i53;
    i63 = i54;
    i64 = i50;
    i65 = 0;
   }
  } while (0);
  L46 : do if ((HEAP8[i63 >> 0] | 0) == 46) {
   i45 = i63 + 1 | 0;
   i43 = HEAP8[i45 >> 0] | 0;
   if (i43 << 24 >> 24 != 42) {
    i47 = (i43 << 24 >> 24) + -48 | 0;
    if (i47 >>> 0 < 10) {
     i68 = i45;
     i69 = 0;
     i70 = i47;
    } else {
     i71 = i45;
     i72 = 0;
     break;
    }
    while (1) {
     i45 = (i69 * 10 | 0) + i70 | 0;
     i47 = i68 + 1 | 0;
     i70 = (HEAP8[i47 >> 0] | 0) + -48 | 0;
     if (i70 >>> 0 >= 10) {
      i71 = i47;
      i72 = i45;
      break L46;
     } else {
      i68 = i47;
      i69 = i45;
     }
    }
   }
   i45 = i63 + 2 | 0;
   i47 = (HEAP8[i45 >> 0] | 0) + -48 | 0;
   if (i47 >>> 0 < 10 ? (HEAP8[i63 + 3 >> 0] | 0) == 36 : 0) {
    HEAP32[i5 + (i47 << 2) >> 2] = 10;
    i71 = i63 + 4 | 0;
    i72 = HEAP32[i4 + ((HEAP8[i45 >> 0] | 0) + -48 << 3) >> 2] | 0;
    break;
   }
   if (i64) {
    i61 = -1;
    break L1;
   }
   if (i15) {
    i47 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
    i43 = HEAP32[i47 >> 2] | 0;
    HEAP32[i3 >> 2] = i47 + 4;
    i71 = i45;
    i72 = i43;
   } else {
    i71 = i45;
    i72 = 0;
   }
  } else {
   i71 = i63;
   i72 = -1;
  } while (0);
  i45 = i71;
  i43 = 0;
  while (1) {
   i47 = (HEAP8[i45 >> 0] | 0) + -65 | 0;
   if (i47 >>> 0 > 57) {
    i61 = -1;
    break L1;
   }
   i46 = i45 + 1 | 0;
   i44 = HEAP8[44930 + (i43 * 58 | 0) + i47 >> 0] | 0;
   i47 = i44 & 255;
   if ((i47 + -1 | 0) >>> 0 < 8) {
    i45 = i46;
    i43 = i47;
   } else {
    i73 = i46;
    i74 = i44;
    i75 = i47;
    i76 = i45;
    i77 = i43;
    break;
   }
  }
  if (!(i74 << 24 >> 24)) {
   i61 = -1;
   break;
  }
  i43 = (i49 | 0) > -1;
  do if (i74 << 24 >> 24 == 19) if (i43) {
   i61 = -1;
   break L1;
  } else i36 = 52; else {
   if (i43) {
    HEAP32[i5 + (i49 << 2) >> 2] = i75;
    i45 = i4 + (i49 << 3) | 0;
    i47 = HEAP32[i45 + 4 >> 2] | 0;
    i44 = i11;
    HEAP32[i44 >> 2] = HEAP32[i45 >> 2];
    HEAP32[i44 + 4 >> 2] = i47;
    i36 = 52;
    break;
   }
   if (!i15) {
    i61 = 0;
    break L1;
   }
   _pop_arg(i11, i75, i3);
  } while (0);
  if ((i36 | 0) == 52 ? (i36 = 0, !i15) : 0) {
   i29 = i33;
   i30 = i73;
   i2 = i32;
   i31 = i64;
   continue;
  }
  i43 = HEAP8[i76 >> 0] | 0;
  i47 = (i77 | 0) != 0 & (i43 & 15 | 0) == 3 ? i43 & -33 : i43;
  i43 = i62 & -65537;
  i44 = (i62 & 8192 | 0) == 0 ? i62 : i43;
  L75 : do switch (i47 | 0) {
  case 110:
   {
    switch (i77 | 0) {
    case 0:
     {
      HEAP32[HEAP32[i11 >> 2] >> 2] = i33;
      i29 = i33;
      i30 = i73;
      i2 = i32;
      i31 = i64;
      continue L1;
      break;
     }
    case 1:
     {
      HEAP32[HEAP32[i11 >> 2] >> 2] = i33;
      i29 = i33;
      i30 = i73;
      i2 = i32;
      i31 = i64;
      continue L1;
      break;
     }
    case 2:
     {
      i45 = HEAP32[i11 >> 2] | 0;
      HEAP32[i45 >> 2] = i33;
      HEAP32[i45 + 4 >> 2] = ((i33 | 0) < 0) << 31 >> 31;
      i29 = i33;
      i30 = i73;
      i2 = i32;
      i31 = i64;
      continue L1;
      break;
     }
    case 3:
     {
      HEAP16[HEAP32[i11 >> 2] >> 1] = i33;
      i29 = i33;
      i30 = i73;
      i2 = i32;
      i31 = i64;
      continue L1;
      break;
     }
    case 4:
     {
      HEAP8[HEAP32[i11 >> 2] >> 0] = i33;
      i29 = i33;
      i30 = i73;
      i2 = i32;
      i31 = i64;
      continue L1;
      break;
     }
    case 6:
     {
      HEAP32[HEAP32[i11 >> 2] >> 2] = i33;
      i29 = i33;
      i30 = i73;
      i2 = i32;
      i31 = i64;
      continue L1;
      break;
     }
    case 7:
     {
      i45 = HEAP32[i11 >> 2] | 0;
      HEAP32[i45 >> 2] = i33;
      HEAP32[i45 + 4 >> 2] = ((i33 | 0) < 0) << 31 >> 31;
      i29 = i33;
      i30 = i73;
      i2 = i32;
      i31 = i64;
      continue L1;
      break;
     }
    default:
     {
      i29 = i33;
      i30 = i73;
      i2 = i32;
      i31 = i64;
      continue L1;
     }
    }
    break;
   }
  case 112:
   {
    i78 = i44 | 8;
    i79 = i72 >>> 0 > 8 ? i72 : 8;
    i80 = 120;
    i36 = 64;
    break;
   }
  case 88:
  case 120:
   {
    i78 = i44;
    i79 = i72;
    i80 = i47;
    i36 = 64;
    break;
   }
  case 111:
   {
    i45 = i11;
    i46 = HEAP32[i45 >> 2] | 0;
    i56 = HEAP32[i45 + 4 >> 2] | 0;
    if ((i46 | 0) == 0 & (i56 | 0) == 0) i81 = i16; else {
     i45 = i16;
     i55 = i46;
     i46 = i56;
     while (1) {
      i56 = i45 + -1 | 0;
      HEAP8[i56 >> 0] = i55 & 7 | 48;
      i55 = _bitshift64Lshr(i55 | 0, i46 | 0, 3) | 0;
      i46 = tempRet0;
      if ((i55 | 0) == 0 & (i46 | 0) == 0) {
       i81 = i56;
       break;
      } else i45 = i56;
     }
    }
    if (!(i44 & 8)) {
     i82 = i81;
     i83 = i44;
     i84 = i72;
     i85 = 0;
     i86 = 45410;
     i36 = 77;
    } else {
     i45 = i17 - i81 + 1 | 0;
     i82 = i81;
     i83 = i44;
     i84 = (i72 | 0) < (i45 | 0) ? i45 : i72;
     i85 = 0;
     i86 = 45410;
     i36 = 77;
    }
    break;
   }
  case 105:
  case 100:
   {
    i45 = i11;
    i46 = HEAP32[i45 >> 2] | 0;
    i55 = HEAP32[i45 + 4 >> 2] | 0;
    if ((i55 | 0) < 0) {
     i45 = _i64Subtract(0, 0, i46 | 0, i55 | 0) | 0;
     i56 = tempRet0;
     i57 = i11;
     HEAP32[i57 >> 2] = i45;
     HEAP32[i57 + 4 >> 2] = i56;
     i87 = i45;
     i88 = i56;
     i89 = 1;
     i90 = 45410;
     i36 = 76;
     break L75;
    }
    if (!(i44 & 2048)) {
     i56 = i44 & 1;
     i87 = i46;
     i88 = i55;
     i89 = i56;
     i90 = (i56 | 0) == 0 ? 45410 : 45412;
     i36 = 76;
    } else {
     i87 = i46;
     i88 = i55;
     i89 = 1;
     i90 = 45411;
     i36 = 76;
    }
    break;
   }
  case 117:
   {
    i55 = i11;
    i87 = HEAP32[i55 >> 2] | 0;
    i88 = HEAP32[i55 + 4 >> 2] | 0;
    i89 = 0;
    i90 = 45410;
    i36 = 76;
    break;
   }
  case 99:
   {
    HEAP8[i18 >> 0] = HEAP32[i11 >> 2];
    i91 = i18;
    i92 = i43;
    i93 = 1;
    i94 = 0;
    i95 = 45410;
    i96 = i16;
    break;
   }
  case 109:
   {
    i55 = ___errno_location() | 0;
    i97 = _strerror(HEAP32[i55 >> 2] | 0) | 0;
    i36 = 82;
    break;
   }
  case 115:
   {
    i55 = HEAP32[i11 >> 2] | 0;
    i97 = (i55 | 0) != 0 ? i55 : 45420;
    i36 = 82;
    break;
   }
  case 67:
   {
    HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 >> 2] = 0;
    HEAP32[i11 >> 2] = i13;
    i98 = -1;
    i36 = 86;
    break;
   }
  case 83:
   {
    if (!i72) {
     _pad(i1, 32, i65, 0, i44);
     i99 = 0;
     i36 = 98;
    } else {
     i98 = i72;
     i36 = 86;
    }
    break;
   }
  case 65:
  case 71:
  case 70:
  case 69:
  case 97:
  case 103:
  case 102:
  case 101:
   {
    d100 = +HEAPF64[i11 >> 3];
    HEAP32[i8 >> 2] = 0;
    HEAPF64[tempDoublePtr >> 3] = d100;
    if ((HEAP32[tempDoublePtr + 4 >> 2] | 0) >= 0) if (!(i44 & 2048)) {
     i55 = i44 & 1;
     d101 = d100;
     i102 = i55;
     i103 = (i55 | 0) == 0 ? 45428 : 45433;
    } else {
     d101 = d100;
     i102 = 1;
     i103 = 45430;
    } else {
     d101 = -d100;
     i102 = 1;
     i103 = 45427;
    }
    HEAPF64[tempDoublePtr >> 3] = d101;
    i55 = HEAP32[tempDoublePtr + 4 >> 2] & 2146435072;
    do if (i55 >>> 0 < 2146435072 | (i55 | 0) == 2146435072 & 0 < 0) {
     d100 = +_frexpl(d101, i8) * 2.0;
     i46 = d100 != 0.0;
     if (i46) HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
     i56 = i47 | 32;
     if ((i56 | 0) == 97) {
      i45 = i47 & 32;
      i57 = (i45 | 0) == 0 ? i103 : i103 + 9 | 0;
      i104 = i102 | 2;
      i105 = 12 - i72 | 0;
      do if (!(i72 >>> 0 > 11 | (i105 | 0) == 0)) {
       i106 = i105;
       d107 = 8.0;
       while (1) {
        i106 = i106 + -1 | 0;
        d108 = d107 * 16.0;
        if (!i106) {
         d109 = d108;
         break;
        } else d107 = d108;
       }
       if ((HEAP8[i57 >> 0] | 0) == 45) {
        d110 = -(d109 + (-d100 - d109));
        break;
       } else {
        d110 = d100 + d109 - d109;
        break;
       }
      } else d110 = d100; while (0);
      i105 = HEAP32[i8 >> 2] | 0;
      i106 = (i105 | 0) < 0 ? 0 - i105 | 0 : i105;
      i111 = _fmt_u(i106, ((i106 | 0) < 0) << 31 >> 31, i19) | 0;
      if ((i111 | 0) == (i19 | 0)) {
       HEAP8[i20 >> 0] = 48;
       i112 = i20;
      } else i112 = i111;
      HEAP8[i112 + -1 >> 0] = (i105 >> 31 & 2) + 43;
      i105 = i112 + -2 | 0;
      HEAP8[i105 >> 0] = i47 + 15;
      i111 = (i72 | 0) < 1;
      i106 = (i44 & 8 | 0) == 0;
      d107 = d110;
      i113 = i9;
      while (1) {
       i114 = ~~d107;
       i115 = i113 + 1 | 0;
       HEAP8[i113 >> 0] = HEAPU8[45394 + i114 >> 0] | i45;
       d107 = (d107 - +(i114 | 0)) * 16.0;
       do if ((i115 - i10 | 0) == 1) {
        if (i106 & (i111 & d107 == 0.0)) {
         i116 = i115;
         break;
        }
        HEAP8[i115 >> 0] = 46;
        i116 = i113 + 2 | 0;
       } else i116 = i115; while (0);
       if (!(d107 != 0.0)) {
        i117 = i116;
        break;
       } else i113 = i116;
      }
      i113 = i117;
      i111 = (i72 | 0) != 0 & (i23 + i113 | 0) < (i72 | 0) ? i24 + i72 - i105 | 0 : i22 - i105 + i113 | 0;
      i106 = i111 + i104 | 0;
      _pad(i1, 32, i65, i106, i44);
      if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i57, i104, i1) | 0;
      _pad(i1, 48, i65, i106, i44 ^ 65536);
      i45 = i113 - i10 | 0;
      if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i9, i45, i1) | 0;
      i113 = i21 - i105 | 0;
      _pad(i1, 48, i111 - (i45 + i113) | 0, 0, 0);
      if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i105, i113, i1) | 0;
      _pad(i1, 32, i65, i106, i44 ^ 8192);
      i118 = (i106 | 0) < (i65 | 0) ? i65 : i106;
      break;
     }
     i106 = (i72 | 0) < 0 ? 6 : i72;
     if (i46) {
      i113 = (HEAP32[i8 >> 2] | 0) + -28 | 0;
      HEAP32[i8 >> 2] = i113;
      d119 = d100 * 268435456.0;
      i120 = i113;
     } else {
      d119 = d100;
      i120 = HEAP32[i8 >> 2] | 0;
     }
     i113 = (i120 | 0) < 0 ? i7 : i25;
     i45 = i113;
     d107 = d119;
     i111 = i113;
     while (1) {
      i115 = ~~d107 >>> 0;
      HEAP32[i111 >> 2] = i115;
      i114 = i111 + 4 | 0;
      d107 = (d107 - +(i115 >>> 0)) * 1.0e9;
      if (!(d107 != 0.0)) {
       i121 = i114;
       break;
      } else i111 = i114;
     }
     i111 = HEAP32[i8 >> 2] | 0;
     if ((i111 | 0) > 0) {
      i46 = i111;
      i105 = i113;
      i104 = i121;
      while (1) {
       i57 = (i46 | 0) > 29 ? 29 : i46;
       i114 = i104 + -4 | 0;
       do if (i114 >>> 0 < i105 >>> 0) i122 = i105; else {
        i115 = 0;
        i123 = i114;
        while (1) {
         i124 = _bitshift64Shl(HEAP32[i123 >> 2] | 0, 0, i57 | 0) | 0;
         i125 = _i64Add(i124 | 0, tempRet0 | 0, i115 | 0, 0) | 0;
         i124 = tempRet0;
         i126 = ___uremdi3(i125 | 0, i124 | 0, 1e9, 0) | 0;
         HEAP32[i123 >> 2] = i126;
         i126 = ___udivdi3(i125 | 0, i124 | 0, 1e9, 0) | 0;
         i123 = i123 + -4 | 0;
         if (i123 >>> 0 < i105 >>> 0) {
          i127 = i126;
          break;
         } else i115 = i126;
        }
        if (!i127) {
         i122 = i105;
         break;
        }
        i115 = i105 + -4 | 0;
        HEAP32[i115 >> 2] = i127;
        i122 = i115;
       } while (0);
       i114 = i104;
       while (1) {
        if (i114 >>> 0 <= i122 >>> 0) {
         i128 = i114;
         break;
        }
        i115 = i114 + -4 | 0;
        if (!(HEAP32[i115 >> 2] | 0)) i114 = i115; else {
         i128 = i114;
         break;
        }
       }
       i114 = (HEAP32[i8 >> 2] | 0) - i57 | 0;
       HEAP32[i8 >> 2] = i114;
       if ((i114 | 0) > 0) {
        i46 = i114;
        i105 = i122;
        i104 = i128;
       } else {
        i129 = i114;
        i130 = i122;
        i131 = i128;
        break;
       }
      }
     } else {
      i129 = i111;
      i130 = i113;
      i131 = i121;
     }
     if ((i129 | 0) < 0) {
      i104 = ((i106 + 25 | 0) / 9 | 0) + 1 | 0;
      i105 = (i56 | 0) == 102;
      i46 = i129;
      i114 = i130;
      i115 = i131;
      while (1) {
       i123 = 0 - i46 | 0;
       i126 = (i123 | 0) > 9 ? 9 : i123;
       do if (i114 >>> 0 < i115 >>> 0) {
        i123 = (1 << i126) + -1 | 0;
        i124 = 1e9 >>> i126;
        i125 = 0;
        i132 = i114;
        while (1) {
         i133 = HEAP32[i132 >> 2] | 0;
         HEAP32[i132 >> 2] = (i133 >>> i126) + i125;
         i134 = Math_imul(i133 & i123, i124) | 0;
         i132 = i132 + 4 | 0;
         if (i132 >>> 0 >= i115 >>> 0) {
          i135 = i134;
          break;
         } else i125 = i134;
        }
        i125 = (HEAP32[i114 >> 2] | 0) == 0 ? i114 + 4 | 0 : i114;
        if (!i135) {
         i136 = i125;
         i137 = i115;
         break;
        }
        HEAP32[i115 >> 2] = i135;
        i136 = i125;
        i137 = i115 + 4 | 0;
       } else {
        i136 = (HEAP32[i114 >> 2] | 0) == 0 ? i114 + 4 | 0 : i114;
        i137 = i115;
       } while (0);
       i57 = i105 ? i113 : i136;
       i125 = (i137 - i57 >> 2 | 0) > (i104 | 0) ? i57 + (i104 << 2) | 0 : i137;
       i46 = (HEAP32[i8 >> 2] | 0) + i126 | 0;
       HEAP32[i8 >> 2] = i46;
       if ((i46 | 0) >= 0) {
        i138 = i136;
        i139 = i125;
        break;
       } else {
        i114 = i136;
        i115 = i125;
       }
      }
     } else {
      i138 = i130;
      i139 = i131;
     }
     do if (i138 >>> 0 < i139 >>> 0) {
      i115 = (i45 - i138 >> 2) * 9 | 0;
      i114 = HEAP32[i138 >> 2] | 0;
      if (i114 >>> 0 < 10) {
       i140 = i115;
       break;
      } else {
       i141 = i115;
       i142 = 10;
      }
      while (1) {
       i142 = i142 * 10 | 0;
       i115 = i141 + 1 | 0;
       if (i114 >>> 0 < i142 >>> 0) {
        i140 = i115;
        break;
       } else i141 = i115;
      }
     } else i140 = 0; while (0);
     i114 = (i56 | 0) == 103;
     i126 = (i106 | 0) != 0;
     i115 = i106 - ((i56 | 0) != 102 ? i140 : 0) + ((i126 & i114) << 31 >> 31) | 0;
     if ((i115 | 0) < (((i139 - i45 >> 2) * 9 | 0) + -9 | 0)) {
      i46 = i115 + 9216 | 0;
      i115 = (i46 | 0) / 9 | 0;
      i104 = i113 + (i115 + -1023 << 2) | 0;
      i105 = ((i46 | 0) % 9 | 0) + 1 | 0;
      if ((i105 | 0) < 9) {
       i46 = 10;
       i111 = i105;
       while (1) {
        i105 = i46 * 10 | 0;
        i111 = i111 + 1 | 0;
        if ((i111 | 0) == 9) {
         i143 = i105;
         break;
        } else i46 = i105;
       }
      } else i143 = 10;
      i46 = HEAP32[i104 >> 2] | 0;
      i111 = (i46 >>> 0) % (i143 >>> 0) | 0;
      if ((i111 | 0) == 0 ? (i113 + (i115 + -1022 << 2) | 0) == (i139 | 0) : 0) {
       i144 = i138;
       i145 = i104;
       i146 = i140;
      } else i36 = 163;
      do if ((i36 | 0) == 163) {
       i36 = 0;
       d107 = (((i46 >>> 0) / (i143 >>> 0) | 0) & 1 | 0) == 0 ? 9007199254740992.0 : 9007199254740994.0;
       i56 = (i143 | 0) / 2 | 0;
       do if (i111 >>> 0 < i56 >>> 0) d147 = .5; else {
        if ((i111 | 0) == (i56 | 0) ? (i113 + (i115 + -1022 << 2) | 0) == (i139 | 0) : 0) {
         d147 = 1.0;
         break;
        }
        d147 = 1.5;
       } while (0);
       do if (!i102) {
        d148 = d107;
        d149 = d147;
       } else {
        if ((HEAP8[i103 >> 0] | 0) != 45) {
         d148 = d107;
         d149 = d147;
         break;
        }
        d148 = -d107;
        d149 = -d147;
       } while (0);
       i56 = i46 - i111 | 0;
       HEAP32[i104 >> 2] = i56;
       if (!(d148 + d149 != d148)) {
        i144 = i138;
        i145 = i104;
        i146 = i140;
        break;
       }
       i105 = i56 + i143 | 0;
       HEAP32[i104 >> 2] = i105;
       if (i105 >>> 0 > 999999999) {
        i105 = i138;
        i56 = i104;
        while (1) {
         i125 = i56 + -4 | 0;
         HEAP32[i56 >> 2] = 0;
         if (i125 >>> 0 < i105 >>> 0) {
          i57 = i105 + -4 | 0;
          HEAP32[i57 >> 2] = 0;
          i150 = i57;
         } else i150 = i105;
         i57 = (HEAP32[i125 >> 2] | 0) + 1 | 0;
         HEAP32[i125 >> 2] = i57;
         if (i57 >>> 0 > 999999999) {
          i105 = i150;
          i56 = i125;
         } else {
          i151 = i150;
          i152 = i125;
          break;
         }
        }
       } else {
        i151 = i138;
        i152 = i104;
       }
       i56 = (i45 - i151 >> 2) * 9 | 0;
       i105 = HEAP32[i151 >> 2] | 0;
       if (i105 >>> 0 < 10) {
        i144 = i151;
        i145 = i152;
        i146 = i56;
        break;
       } else {
        i153 = i56;
        i154 = 10;
       }
       while (1) {
        i154 = i154 * 10 | 0;
        i56 = i153 + 1 | 0;
        if (i105 >>> 0 < i154 >>> 0) {
         i144 = i151;
         i145 = i152;
         i146 = i56;
         break;
        } else i153 = i56;
       }
      } while (0);
      i104 = i145 + 4 | 0;
      i155 = i144;
      i156 = i146;
      i157 = i139 >>> 0 > i104 >>> 0 ? i104 : i139;
     } else {
      i155 = i138;
      i156 = i140;
      i157 = i139;
     }
     i104 = 0 - i156 | 0;
     i111 = i157;
     while (1) {
      if (i111 >>> 0 <= i155 >>> 0) {
       i158 = 0;
       i159 = i111;
       break;
      }
      i46 = i111 + -4 | 0;
      if (!(HEAP32[i46 >> 2] | 0)) i111 = i46; else {
       i158 = 1;
       i159 = i111;
       break;
      }
     }
     do if (i114) {
      i111 = (i126 & 1 ^ 1) + i106 | 0;
      if ((i111 | 0) > (i156 | 0) & (i156 | 0) > -5) {
       i160 = i47 + -1 | 0;
       i161 = i111 + -1 - i156 | 0;
      } else {
       i160 = i47 + -2 | 0;
       i161 = i111 + -1 | 0;
      }
      i111 = i44 & 8;
      if (i111) {
       i162 = i160;
       i163 = i161;
       i164 = i111;
       break;
      }
      do if (i158) {
       i111 = HEAP32[i159 + -4 >> 2] | 0;
       if (!i111) {
        i165 = 9;
        break;
       }
       if (!((i111 >>> 0) % 10 | 0)) {
        i166 = 10;
        i167 = 0;
       } else {
        i165 = 0;
        break;
       }
       while (1) {
        i166 = i166 * 10 | 0;
        i46 = i167 + 1 | 0;
        if ((i111 >>> 0) % (i166 >>> 0) | 0) {
         i165 = i46;
         break;
        } else i167 = i46;
       }
      } else i165 = 9; while (0);
      i111 = ((i159 - i45 >> 2) * 9 | 0) + -9 | 0;
      if ((i160 | 32 | 0) == 102) {
       i46 = i111 - i165 | 0;
       i115 = (i46 | 0) < 0 ? 0 : i46;
       i162 = i160;
       i163 = (i161 | 0) < (i115 | 0) ? i161 : i115;
       i164 = 0;
       break;
      } else {
       i115 = i111 + i156 - i165 | 0;
       i111 = (i115 | 0) < 0 ? 0 : i115;
       i162 = i160;
       i163 = (i161 | 0) < (i111 | 0) ? i161 : i111;
       i164 = 0;
       break;
      }
     } else {
      i162 = i47;
      i163 = i106;
      i164 = i44 & 8;
     } while (0);
     i106 = i163 | i164;
     i45 = (i106 | 0) != 0 & 1;
     i126 = (i162 | 32 | 0) == 102;
     if (i126) {
      i168 = (i156 | 0) > 0 ? i156 : 0;
      i169 = 0;
     } else {
      i114 = (i156 | 0) < 0 ? i104 : i156;
      i111 = _fmt_u(i114, ((i114 | 0) < 0) << 31 >> 31, i19) | 0;
      if ((i21 - i111 | 0) < 2) {
       i114 = i111;
       while (1) {
        i115 = i114 + -1 | 0;
        HEAP8[i115 >> 0] = 48;
        if ((i21 - i115 | 0) < 2) i114 = i115; else {
         i170 = i115;
         break;
        }
       }
      } else i170 = i111;
      HEAP8[i170 + -1 >> 0] = (i156 >> 31 & 2) + 43;
      i114 = i170 + -2 | 0;
      HEAP8[i114 >> 0] = i162;
      i168 = i21 - i114 | 0;
      i169 = i114;
     }
     i114 = i102 + 1 + i163 + i45 + i168 | 0;
     _pad(i1, 32, i65, i114, i44);
     if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i103, i102, i1) | 0;
     _pad(i1, 48, i65, i114, i44 ^ 65536);
     do if (i126) {
      i104 = i155 >>> 0 > i113 >>> 0 ? i113 : i155;
      i115 = i104;
      while (1) {
       i46 = _fmt_u(HEAP32[i115 >> 2] | 0, 0, i26) | 0;
       do if ((i115 | 0) == (i104 | 0)) {
        if ((i46 | 0) != (i26 | 0)) {
         i171 = i46;
         break;
        }
        HEAP8[i28 >> 0] = 48;
        i171 = i28;
       } else {
        if (i46 >>> 0 > i9 >>> 0) i172 = i46; else {
         i171 = i46;
         break;
        }
        while (1) {
         i105 = i172 + -1 | 0;
         HEAP8[i105 >> 0] = 48;
         if (i105 >>> 0 > i9 >>> 0) i172 = i105; else {
          i171 = i105;
          break;
         }
        }
       } while (0);
       if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i171, i27 - i171 | 0, i1) | 0;
       i46 = i115 + 4 | 0;
       if (i46 >>> 0 > i113 >>> 0) {
        i173 = i46;
        break;
       } else i115 = i46;
      }
      do if (i106) {
       if (HEAP32[i1 >> 2] & 32) break;
       ___fwritex(45462, 1, i1) | 0;
      } while (0);
      if ((i163 | 0) > 0 & i173 >>> 0 < i159 >>> 0) {
       i115 = i163;
       i104 = i173;
       while (1) {
        i46 = _fmt_u(HEAP32[i104 >> 2] | 0, 0, i26) | 0;
        if (i46 >>> 0 > i9 >>> 0) {
         i105 = i46;
         while (1) {
          i56 = i105 + -1 | 0;
          HEAP8[i56 >> 0] = 48;
          if (i56 >>> 0 > i9 >>> 0) i105 = i56; else {
           i174 = i56;
           break;
          }
         }
        } else i174 = i46;
        if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i174, (i115 | 0) > 9 ? 9 : i115, i1) | 0;
        i104 = i104 + 4 | 0;
        i105 = i115 + -9 | 0;
        if (!((i115 | 0) > 9 & i104 >>> 0 < i159 >>> 0)) {
         i175 = i105;
         break;
        } else i115 = i105;
       }
      } else i175 = i163;
      _pad(i1, 48, i175 + 9 | 0, 9, 0);
     } else {
      i115 = i158 ? i159 : i155 + 4 | 0;
      if ((i163 | 0) > -1) {
       i104 = (i164 | 0) == 0;
       i105 = i163;
       i56 = i155;
       while (1) {
        i125 = _fmt_u(HEAP32[i56 >> 2] | 0, 0, i26) | 0;
        if ((i125 | 0) == (i26 | 0)) {
         HEAP8[i28 >> 0] = 48;
         i176 = i28;
        } else i176 = i125;
        do if ((i56 | 0) == (i155 | 0)) {
         i125 = i176 + 1 | 0;
         if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i176, 1, i1) | 0;
         if (i104 & (i105 | 0) < 1) {
          i177 = i125;
          break;
         }
         if (HEAP32[i1 >> 2] & 32) {
          i177 = i125;
          break;
         }
         ___fwritex(45462, 1, i1) | 0;
         i177 = i125;
        } else {
         if (i176 >>> 0 > i9 >>> 0) i178 = i176; else {
          i177 = i176;
          break;
         }
         while (1) {
          i125 = i178 + -1 | 0;
          HEAP8[i125 >> 0] = 48;
          if (i125 >>> 0 > i9 >>> 0) i178 = i125; else {
           i177 = i125;
           break;
          }
         }
        } while (0);
        i46 = i27 - i177 | 0;
        if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i177, (i105 | 0) > (i46 | 0) ? i46 : i105, i1) | 0;
        i125 = i105 - i46 | 0;
        i56 = i56 + 4 | 0;
        if (!(i56 >>> 0 < i115 >>> 0 & (i125 | 0) > -1)) {
         i179 = i125;
         break;
        } else i105 = i125;
       }
      } else i179 = i163;
      _pad(i1, 48, i179 + 18 | 0, 18, 0);
      if (HEAP32[i1 >> 2] & 32) break;
      ___fwritex(i169, i21 - i169 | 0, i1) | 0;
     } while (0);
     _pad(i1, 32, i65, i114, i44 ^ 8192);
     i118 = (i114 | 0) < (i65 | 0) ? i65 : i114;
    } else {
     i106 = (i47 & 32 | 0) != 0;
     i113 = d101 != d101 | 0.0 != 0.0;
     i126 = i113 ? 0 : i102;
     i45 = i126 + 3 | 0;
     _pad(i1, 32, i65, i45, i43);
     i111 = HEAP32[i1 >> 2] | 0;
     if (!(i111 & 32)) {
      ___fwritex(i103, i126, i1) | 0;
      i180 = HEAP32[i1 >> 2] | 0;
     } else i180 = i111;
     if (!(i180 & 32)) ___fwritex(i113 ? (i106 ? 45454 : 45458) : i106 ? 45446 : 45450, 3, i1) | 0;
     _pad(i1, 32, i65, i45, i44 ^ 8192);
     i118 = (i45 | 0) < (i65 | 0) ? i65 : i45;
    } while (0);
    i29 = i33;
    i30 = i73;
    i2 = i118;
    i31 = i64;
    continue L1;
    break;
   }
  default:
   {
    i91 = i30;
    i92 = i44;
    i93 = i72;
    i94 = 0;
    i95 = 45410;
    i96 = i16;
   }
  } while (0);
  L313 : do if ((i36 | 0) == 64) {
   i36 = 0;
   i47 = i11;
   i32 = HEAP32[i47 >> 2] | 0;
   i55 = HEAP32[i47 + 4 >> 2] | 0;
   i47 = i80 & 32;
   if (!((i32 | 0) == 0 & (i55 | 0) == 0)) {
    i45 = i16;
    i106 = i32;
    i32 = i55;
    while (1) {
     i55 = i45 + -1 | 0;
     HEAP8[i55 >> 0] = HEAPU8[45394 + (i106 & 15) >> 0] | i47;
     i106 = _bitshift64Lshr(i106 | 0, i32 | 0, 4) | 0;
     i32 = tempRet0;
     if ((i106 | 0) == 0 & (i32 | 0) == 0) {
      i181 = i55;
      break;
     } else i45 = i55;
    }
    i45 = i11;
    if ((i78 & 8 | 0) == 0 | (HEAP32[i45 >> 2] | 0) == 0 & (HEAP32[i45 + 4 >> 2] | 0) == 0) {
     i82 = i181;
     i83 = i78;
     i84 = i79;
     i85 = 0;
     i86 = 45410;
     i36 = 77;
    } else {
     i82 = i181;
     i83 = i78;
     i84 = i79;
     i85 = 2;
     i86 = 45410 + (i80 >> 4) | 0;
     i36 = 77;
    }
   } else {
    i82 = i16;
    i83 = i78;
    i84 = i79;
    i85 = 0;
    i86 = 45410;
    i36 = 77;
   }
  } else if ((i36 | 0) == 76) {
   i36 = 0;
   i82 = _fmt_u(i87, i88, i16) | 0;
   i83 = i44;
   i84 = i72;
   i85 = i89;
   i86 = i90;
   i36 = 77;
  } else if ((i36 | 0) == 82) {
   i36 = 0;
   i45 = _memchr(i97, 0, i72) | 0;
   i32 = (i45 | 0) == 0;
   i91 = i97;
   i92 = i43;
   i93 = i32 ? i72 : i45 - i97 | 0;
   i94 = 0;
   i95 = 45410;
   i96 = i32 ? i97 + i72 | 0 : i45;
  } else if ((i36 | 0) == 86) {
   i36 = 0;
   i45 = 0;
   i32 = 0;
   i106 = HEAP32[i11 >> 2] | 0;
   while (1) {
    i47 = HEAP32[i106 >> 2] | 0;
    if (!i47) {
     i182 = i45;
     i183 = i32;
     break;
    }
    i55 = _wctomb(i14, i47) | 0;
    if ((i55 | 0) < 0 | i55 >>> 0 > (i98 - i45 | 0) >>> 0) {
     i182 = i45;
     i183 = i55;
     break;
    }
    i47 = i55 + i45 | 0;
    if (i98 >>> 0 > i47 >>> 0) {
     i45 = i47;
     i32 = i55;
     i106 = i106 + 4 | 0;
    } else {
     i182 = i47;
     i183 = i55;
     break;
    }
   }
   if ((i183 | 0) < 0) {
    i61 = -1;
    break L1;
   }
   _pad(i1, 32, i65, i182, i44);
   if (!i182) {
    i99 = 0;
    i36 = 98;
   } else {
    i106 = 0;
    i32 = HEAP32[i11 >> 2] | 0;
    while (1) {
     i45 = HEAP32[i32 >> 2] | 0;
     if (!i45) {
      i99 = i182;
      i36 = 98;
      break L313;
     }
     i55 = _wctomb(i14, i45) | 0;
     i106 = i55 + i106 | 0;
     if ((i106 | 0) > (i182 | 0)) {
      i99 = i182;
      i36 = 98;
      break L313;
     }
     if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i14, i55, i1) | 0;
     if (i106 >>> 0 >= i182 >>> 0) {
      i99 = i182;
      i36 = 98;
      break;
     } else i32 = i32 + 4 | 0;
    }
   }
  } while (0);
  if ((i36 | 0) == 98) {
   i36 = 0;
   _pad(i1, 32, i65, i99, i44 ^ 8192);
   i29 = i33;
   i30 = i73;
   i2 = (i65 | 0) > (i99 | 0) ? i65 : i99;
   i31 = i64;
   continue;
  }
  if ((i36 | 0) == 77) {
   i36 = 0;
   i43 = (i84 | 0) > -1 ? i83 & -65537 : i83;
   i32 = i11;
   i106 = (HEAP32[i32 >> 2] | 0) != 0 | (HEAP32[i32 + 4 >> 2] | 0) != 0;
   if ((i84 | 0) != 0 | i106) {
    i32 = (i106 & 1 ^ 1) + (i17 - i82) | 0;
    i91 = i82;
    i92 = i43;
    i93 = (i84 | 0) > (i32 | 0) ? i84 : i32;
    i94 = i85;
    i95 = i86;
    i96 = i16;
   } else {
    i91 = i16;
    i92 = i43;
    i93 = 0;
    i94 = i85;
    i95 = i86;
    i96 = i16;
   }
  }
  i43 = i96 - i91 | 0;
  i32 = (i93 | 0) < (i43 | 0) ? i43 : i93;
  i106 = i94 + i32 | 0;
  i55 = (i65 | 0) < (i106 | 0) ? i106 : i65;
  _pad(i1, 32, i55, i106, i92);
  if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i95, i94, i1) | 0;
  _pad(i1, 48, i55, i106, i92 ^ 65536);
  _pad(i1, 48, i32, i43, 0);
  if (!(HEAP32[i1 >> 2] & 32)) ___fwritex(i91, i43, i1) | 0;
  _pad(i1, 32, i55, i106, i92 ^ 8192);
  i29 = i33;
  i30 = i73;
  i2 = i55;
  i31 = i64;
 }
 L348 : do if ((i36 | 0) == 245) if (!i1) if (i35) {
  i64 = 1;
  while (1) {
   i31 = HEAP32[i5 + (i64 << 2) >> 2] | 0;
   if (!i31) {
    i184 = i64;
    break;
   }
   _pop_arg(i4 + (i64 << 3) | 0, i31, i3);
   i64 = i64 + 1 | 0;
   if ((i64 | 0) >= 10) {
    i61 = 1;
    break L348;
   }
  }
  if ((i184 | 0) < 10) {
   i64 = i184;
   while (1) {
    if (HEAP32[i5 + (i64 << 2) >> 2] | 0) {
     i61 = -1;
     break L348;
    }
    i64 = i64 + 1 | 0;
    if ((i64 | 0) >= 10) {
     i61 = 1;
     break;
    }
   }
  } else i61 = 1;
 } else i61 = 0; else i61 = i34; while (0);
 STACKTOP = i6;
 return i61 | 0;
}

function _vfscanf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, d98 = 0.0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i5 = i4 + 16 | 0;
 i6 = i4 + 8 | 0;
 i7 = i4 + 33 | 0;
 i8 = i4;
 i9 = i4 + 32 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) i10 = ___lockfile(i1) | 0; else i10 = 0;
 i11 = HEAP8[i2 >> 0] | 0;
 L4 : do if (i11 << 24 >> 24) {
  i12 = i1 + 4 | 0;
  i13 = i1 + 100 | 0;
  i14 = i1 + 108 | 0;
  i15 = i1 + 8 | 0;
  i16 = i7 + 10 | 0;
  i17 = i7 + 33 | 0;
  i18 = i6 + 4 | 0;
  i19 = i7 + 46 | 0;
  i20 = i7 + 94 | 0;
  i21 = i11;
  i22 = 0;
  i23 = i2;
  i24 = 0;
  i25 = 0;
  i26 = 0;
  L6 : while (1) {
   L8 : do if (!(_isspace(i21 & 255) | 0)) {
    i27 = (HEAP8[i23 >> 0] | 0) == 37;
    L10 : do if (i27) {
     i28 = i23 + 1 | 0;
     i29 = HEAP8[i28 >> 0] | 0;
     L12 : do switch (i29 << 24 >> 24) {
     case 37:
      {
       break L10;
       break;
      }
     case 42:
      {
       i30 = 0;
       i31 = i23 + 2 | 0;
       break;
      }
     default:
      {
       i32 = (i29 & 255) + -48 | 0;
       if (i32 >>> 0 < 10 ? (HEAP8[i23 + 2 >> 0] | 0) == 36 : 0) {
        HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
        i33 = i32;
        while (1) {
         i32 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
         i34 = HEAP32[i32 >> 2] | 0;
         HEAP32[i5 >> 2] = i32 + 4;
         if (i33 >>> 0 > 1) i33 = i33 + -1 | 0; else {
          i35 = i34;
          break;
         }
        }
        i30 = i35;
        i31 = i23 + 3 | 0;
        break L12;
       }
       i33 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
       i34 = HEAP32[i33 >> 2] | 0;
       HEAP32[i3 >> 2] = i33 + 4;
       i30 = i34;
       i31 = i28;
      }
     } while (0);
     i28 = HEAP8[i31 >> 0] | 0;
     i29 = i28 & 255;
     if ((i29 + -48 | 0) >>> 0 < 10) {
      i34 = i29;
      i29 = i31;
      i33 = 0;
      while (1) {
       i32 = (i33 * 10 | 0) + -48 + i34 | 0;
       i36 = i29 + 1 | 0;
       i37 = HEAP8[i36 >> 0] | 0;
       i34 = i37 & 255;
       if ((i34 + -48 | 0) >>> 0 >= 10) {
        i38 = i37;
        i39 = i36;
        i40 = i32;
        break;
       } else {
        i29 = i36;
        i33 = i32;
       }
      }
     } else {
      i38 = i28;
      i39 = i31;
      i40 = 0;
     }
     if (i38 << 24 >> 24 == 109) {
      i33 = i39 + 1 | 0;
      i41 = HEAP8[i33 >> 0] | 0;
      i42 = (i30 | 0) != 0 & 1;
      i43 = i33;
      i44 = 0;
      i45 = 0;
     } else {
      i41 = i38;
      i42 = 0;
      i43 = i39;
      i44 = i25;
      i45 = i26;
     }
     i33 = i43 + 1 | 0;
     switch (i41 & 255 | 0) {
     case 104:
      {
       i29 = (HEAP8[i33 >> 0] | 0) == 104;
       i46 = i29 ? i43 + 2 | 0 : i33;
       i47 = i29 ? -2 : -1;
       break;
      }
     case 108:
      {
       i29 = (HEAP8[i33 >> 0] | 0) == 108;
       i46 = i29 ? i43 + 2 | 0 : i33;
       i47 = i29 ? 3 : 1;
       break;
      }
     case 106:
      {
       i46 = i33;
       i47 = 3;
       break;
      }
     case 116:
     case 122:
      {
       i46 = i33;
       i47 = 1;
       break;
      }
     case 76:
      {
       i46 = i33;
       i47 = 2;
       break;
      }
     case 110:
     case 112:
     case 67:
     case 83:
     case 91:
     case 99:
     case 115:
     case 88:
     case 71:
     case 70:
     case 69:
     case 65:
     case 103:
     case 102:
     case 101:
     case 97:
     case 120:
     case 117:
     case 111:
     case 105:
     case 100:
      {
       i46 = i43;
       i47 = 0;
       break;
      }
     default:
      {
       i48 = i42;
       i49 = i22;
       i50 = i44;
       i51 = i45;
       i52 = 152;
       break L6;
      }
     }
     i33 = HEAPU8[i46 >> 0] | 0;
     i29 = (i33 & 47 | 0) == 3;
     i34 = i29 ? i33 | 32 : i33;
     i33 = i29 ? 1 : i47;
     switch (i34 | 0) {
     case 99:
      {
       i53 = i24;
       i54 = (i40 | 0) < 1 ? 1 : i40;
       break;
      }
     case 91:
      {
       i53 = i24;
       i54 = i40;
       break;
      }
     case 110:
      {
       if (!i30) {
        i55 = i22;
        i56 = i46;
        i57 = i24;
        i58 = i44;
        i59 = i45;
        break L8;
       }
       switch (i33 | 0) {
       case -2:
        {
         HEAP8[i30 >> 0] = i24;
         i55 = i22;
         i56 = i46;
         i57 = i24;
         i58 = i44;
         i59 = i45;
         break L8;
         break;
        }
       case -1:
        {
         HEAP16[i30 >> 1] = i24;
         i55 = i22;
         i56 = i46;
         i57 = i24;
         i58 = i44;
         i59 = i45;
         break L8;
         break;
        }
       case 0:
        {
         HEAP32[i30 >> 2] = i24;
         i55 = i22;
         i56 = i46;
         i57 = i24;
         i58 = i44;
         i59 = i45;
         break L8;
         break;
        }
       case 1:
        {
         HEAP32[i30 >> 2] = i24;
         i55 = i22;
         i56 = i46;
         i57 = i24;
         i58 = i44;
         i59 = i45;
         break L8;
         break;
        }
       case 3:
        {
         i29 = i30;
         HEAP32[i29 >> 2] = i24;
         HEAP32[i29 + 4 >> 2] = ((i24 | 0) < 0) << 31 >> 31;
         i55 = i22;
         i56 = i46;
         i57 = i24;
         i58 = i44;
         i59 = i45;
         break L8;
         break;
        }
       default:
        {
         i55 = i22;
         i56 = i46;
         i57 = i24;
         i58 = i44;
         i59 = i45;
         break L8;
        }
       }
       break;
      }
     default:
      {
       ___shlim(i1, 0);
       do {
        i29 = HEAP32[i12 >> 2] | 0;
        if (i29 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
         HEAP32[i12 >> 2] = i29 + 1;
         i60 = HEAPU8[i29 >> 0] | 0;
        } else i60 = ___shgetc(i1) | 0;
       } while ((_isspace(i60) | 0) != 0);
       i28 = HEAP32[i12 >> 2] | 0;
       if (!(HEAP32[i13 >> 2] | 0)) i61 = i28; else {
        i29 = i28 + -1 | 0;
        HEAP32[i12 >> 2] = i29;
        i61 = i29;
       }
       i53 = (HEAP32[i14 >> 2] | 0) + i24 + i61 - (HEAP32[i15 >> 2] | 0) | 0;
       i54 = i40;
      }
     }
     ___shlim(i1, i54);
     i29 = HEAP32[i12 >> 2] | 0;
     i28 = HEAP32[i13 >> 2] | 0;
     if (i29 >>> 0 < i28 >>> 0) {
      HEAP32[i12 >> 2] = i29 + 1;
      i62 = i28;
     } else {
      if ((___shgetc(i1) | 0) < 0) {
       i48 = i42;
       i49 = i22;
       i50 = i44;
       i51 = i45;
       i52 = 152;
       break L6;
      }
      i62 = HEAP32[i13 >> 2] | 0;
     }
     if (i62) HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
     L67 : do switch (i34 | 0) {
     case 91:
     case 99:
     case 115:
      {
       i28 = (i34 | 0) == 99;
       L69 : do if ((i34 & 239 | 0) == 99) {
        _memset(i7 | 0, -1, 257) | 0;
        HEAP8[i7 >> 0] = 0;
        if ((i34 | 0) == 115) {
         HEAP8[i17 >> 0] = 0;
         HEAP8[i16 >> 0] = 0;
         HEAP8[i16 + 1 >> 0] = 0;
         HEAP8[i16 + 2 >> 0] = 0;
         HEAP8[i16 + 3 >> 0] = 0;
         HEAP8[i16 + 4 >> 0] = 0;
         i63 = i46;
        } else i63 = i46;
       } else {
        i29 = i46 + 1 | 0;
        i32 = (HEAP8[i29 >> 0] | 0) == 94;
        i36 = i32 & 1;
        i37 = i32 ? i29 : i46;
        i64 = i32 ? i46 + 2 | 0 : i29;
        _memset(i7 | 0, i32 & 1 | 0, 257) | 0;
        HEAP8[i7 >> 0] = 0;
        switch (HEAP8[i64 >> 0] | 0) {
        case 45:
         {
          i32 = (i36 ^ 1) & 255;
          HEAP8[i19 >> 0] = i32;
          i65 = i32;
          i66 = i37 + 2 | 0;
          break;
         }
        case 93:
         {
          i32 = (i36 ^ 1) & 255;
          HEAP8[i20 >> 0] = i32;
          i65 = i32;
          i66 = i37 + 2 | 0;
          break;
         }
        default:
         {
          i65 = (i36 ^ 1) & 255;
          i66 = i64;
         }
        }
        i64 = i66;
        while (1) {
         i36 = HEAP8[i64 >> 0] | 0;
         L80 : do switch (i36 << 24 >> 24) {
         case 0:
          {
           i48 = i42;
           i49 = i22;
           i50 = i44;
           i51 = i45;
           i52 = 152;
           break L6;
           break;
          }
         case 93:
          {
           i63 = i64;
           break L69;
           break;
          }
         case 45:
          {
           i37 = i64 + 1 | 0;
           i32 = HEAP8[i37 >> 0] | 0;
           switch (i32 << 24 >> 24) {
           case 93:
           case 0:
            {
             i67 = 45;
             i68 = i64;
             break L80;
             break;
            }
           default:
            {}
           }
           i29 = HEAP8[i64 + -1 >> 0] | 0;
           if ((i29 & 255) < (i32 & 255)) {
            i69 = i29 & 255;
            do {
             i69 = i69 + 1 | 0;
             HEAP8[i7 + i69 >> 0] = i65;
             i29 = HEAP8[i37 >> 0] | 0;
            } while ((i69 | 0) < (i29 & 255 | 0));
            i67 = i29;
            i68 = i37;
           } else {
            i67 = i32;
            i68 = i37;
           }
           break;
          }
         default:
          {
           i67 = i36;
           i68 = i64;
          }
         } while (0);
         HEAP8[i7 + ((i67 & 255) + 1) >> 0] = i65;
         i64 = i68 + 1 | 0;
        }
       } while (0);
       i64 = i28 ? i54 + 1 | 0 : 31;
       i36 = (i33 | 0) == 1;
       i69 = (i42 | 0) != 0;
       L88 : do if (i36) {
        if (i69) {
         i29 = _malloc(i64 << 2) | 0;
         if (!i29) {
          i48 = i42;
          i49 = i22;
          i50 = 0;
          i51 = i29;
          i52 = 152;
          break L6;
         } else i70 = i29;
        } else i70 = i30;
        HEAP32[i6 >> 2] = 0;
        HEAP32[i18 >> 2] = 0;
        i29 = 0;
        i71 = i64;
        i72 = i70;
        L94 : while (1) {
         i73 = (i72 | 0) == 0;
         i74 = i29;
         while (1) {
          L98 : while (1) {
           i75 = HEAP32[i12 >> 2] | 0;
           if (i75 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
            HEAP32[i12 >> 2] = i75 + 1;
            i76 = HEAPU8[i75 >> 0] | 0;
           } else i76 = ___shgetc(i1) | 0;
           if (!(HEAP8[i7 + (i76 + 1) >> 0] | 0)) {
            i77 = i74;
            i78 = i72;
            break L94;
           }
           HEAP8[i9 >> 0] = i76;
           switch (_mbrtowc(i8, i9, 1, i6) | 0) {
           case -1:
            {
             i48 = i42;
             i49 = i22;
             i50 = 0;
             i51 = i72;
             i52 = 152;
             break L6;
             break;
            }
           case -2:
            break;
           default:
            break L98;
           }
          }
          if (i73) i79 = i74; else {
           HEAP32[i72 + (i74 << 2) >> 2] = HEAP32[i8 >> 2];
           i79 = i74 + 1 | 0;
          }
          if (i69 & (i79 | 0) == (i71 | 0)) break; else i74 = i79;
         }
         i74 = i71 << 1 | 1;
         i73 = _realloc(i72, i74 << 2) | 0;
         if (!i73) {
          i48 = i42;
          i49 = i22;
          i50 = 0;
          i51 = i72;
          i52 = 152;
          break L6;
         }
         i37 = i71;
         i71 = i74;
         i72 = i73;
         i29 = i37;
        }
        if (!(_mbsinit(i6) | 0)) {
         i48 = i42;
         i49 = i22;
         i50 = 0;
         i51 = i78;
         i52 = 152;
         break L6;
        } else {
         i80 = i77;
         i81 = 0;
         i82 = i78;
        }
       } else {
        if (i69) {
         i29 = _malloc(i64) | 0;
         if (!i29) {
          i48 = i42;
          i49 = i22;
          i50 = 0;
          i51 = 0;
          i52 = 152;
          break L6;
         } else {
          i83 = 0;
          i84 = i64;
          i85 = i29;
         }
         while (1) {
          i29 = i83;
          do {
           i72 = HEAP32[i12 >> 2] | 0;
           if (i72 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
            HEAP32[i12 >> 2] = i72 + 1;
            i86 = HEAPU8[i72 >> 0] | 0;
           } else i86 = ___shgetc(i1) | 0;
           if (!(HEAP8[i7 + (i86 + 1) >> 0] | 0)) {
            i80 = i29;
            i81 = i85;
            i82 = 0;
            break L88;
           }
           HEAP8[i85 + i29 >> 0] = i86;
           i29 = i29 + 1 | 0;
          } while ((i29 | 0) != (i84 | 0));
          i29 = i84 << 1 | 1;
          i72 = _realloc(i85, i29) | 0;
          if (!i72) {
           i48 = i42;
           i49 = i22;
           i50 = i85;
           i51 = 0;
           i52 = 152;
           break L6;
          } else {
           i71 = i84;
           i84 = i29;
           i85 = i72;
           i83 = i71;
          }
         }
        }
        if (!i30) {
         i71 = i62;
         while (1) {
          i72 = HEAP32[i12 >> 2] | 0;
          if (i72 >>> 0 < i71 >>> 0) {
           HEAP32[i12 >> 2] = i72 + 1;
           i87 = HEAPU8[i72 >> 0] | 0;
          } else i87 = ___shgetc(i1) | 0;
          if (!(HEAP8[i7 + (i87 + 1) >> 0] | 0)) {
           i80 = 0;
           i81 = 0;
           i82 = 0;
           break L88;
          }
          i71 = HEAP32[i13 >> 2] | 0;
         }
        } else {
         i71 = i62;
         i72 = 0;
         while (1) {
          i29 = HEAP32[i12 >> 2] | 0;
          if (i29 >>> 0 < i71 >>> 0) {
           HEAP32[i12 >> 2] = i29 + 1;
           i88 = HEAPU8[i29 >> 0] | 0;
          } else i88 = ___shgetc(i1) | 0;
          if (!(HEAP8[i7 + (i88 + 1) >> 0] | 0)) {
           i80 = i72;
           i81 = i30;
           i82 = 0;
           break L88;
          }
          HEAP8[i30 + i72 >> 0] = i88;
          i71 = HEAP32[i13 >> 2] | 0;
          i72 = i72 + 1 | 0;
         }
        }
       } while (0);
       i64 = HEAP32[i12 >> 2] | 0;
       if (!(HEAP32[i13 >> 2] | 0)) i89 = i64; else {
        i72 = i64 + -1 | 0;
        HEAP32[i12 >> 2] = i72;
        i89 = i72;
       }
       i72 = i89 - (HEAP32[i15 >> 2] | 0) + (HEAP32[i14 >> 2] | 0) | 0;
       if (!i72) {
        i90 = i42;
        i91 = i22;
        i92 = i81;
        i93 = i82;
        break L6;
       }
       if (!((i72 | 0) == (i54 | 0) | i28 ^ 1)) {
        i90 = i42;
        i91 = i22;
        i92 = i81;
        i93 = i82;
        break L6;
       }
       do if (i69) if (i36) {
        HEAP32[i30 >> 2] = i82;
        break;
       } else {
        HEAP32[i30 >> 2] = i81;
        break;
       } while (0);
       if (i28) {
        i94 = i63;
        i95 = i81;
        i96 = i82;
       } else {
        if (i82) HEAP32[i82 + (i80 << 2) >> 2] = 0;
        if (!i81) {
         i94 = i63;
         i95 = 0;
         i96 = i82;
         break L67;
        }
        HEAP8[i81 + i80 >> 0] = 0;
        i94 = i63;
        i95 = i81;
        i96 = i82;
       }
       break;
      }
     case 120:
     case 88:
     case 112:
      {
       i97 = 16;
       i52 = 134;
       break;
      }
     case 111:
      {
       i97 = 8;
       i52 = 134;
       break;
      }
     case 117:
     case 100:
      {
       i97 = 10;
       i52 = 134;
       break;
      }
     case 105:
      {
       i97 = 0;
       i52 = 134;
       break;
      }
     case 71:
     case 103:
     case 70:
     case 102:
     case 69:
     case 101:
     case 65:
     case 97:
      {
       d98 = +___floatscan(i1, i33, 0);
       if ((HEAP32[i14 >> 2] | 0) == ((HEAP32[i15 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0)) {
        i90 = i42;
        i91 = i22;
        i92 = i44;
        i93 = i45;
        break L6;
       }
       if (!i30) {
        i94 = i46;
        i95 = i44;
        i96 = i45;
       } else switch (i33 | 0) {
       case 0:
        {
         HEAPF32[i30 >> 2] = d98;
         i94 = i46;
         i95 = i44;
         i96 = i45;
         break L67;
         break;
        }
       case 1:
        {
         HEAPF64[i30 >> 3] = d98;
         i94 = i46;
         i95 = i44;
         i96 = i45;
         break L67;
         break;
        }
       case 2:
        {
         HEAPF64[i30 >> 3] = d98;
         i94 = i46;
         i95 = i44;
         i96 = i45;
         break L67;
         break;
        }
       default:
        {
         i94 = i46;
         i95 = i44;
         i96 = i45;
         break L67;
        }
       }
       break;
      }
     default:
      {
       i94 = i46;
       i95 = i44;
       i96 = i45;
      }
     } while (0);
     L168 : do if ((i52 | 0) == 134) {
      i52 = 0;
      i36 = ___intscan(i1, i97, 0, -1, -1) | 0;
      if ((HEAP32[i14 >> 2] | 0) == ((HEAP32[i15 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0)) {
       i90 = i42;
       i91 = i22;
       i92 = i44;
       i93 = i45;
       break L6;
      }
      if ((i30 | 0) != 0 & (i34 | 0) == 112) {
       HEAP32[i30 >> 2] = i36;
       i94 = i46;
       i95 = i44;
       i96 = i45;
       break;
      }
      if (!i30) {
       i94 = i46;
       i95 = i44;
       i96 = i45;
      } else switch (i33 | 0) {
      case -2:
       {
        HEAP8[i30 >> 0] = i36;
        i94 = i46;
        i95 = i44;
        i96 = i45;
        break L168;
        break;
       }
      case -1:
       {
        HEAP16[i30 >> 1] = i36;
        i94 = i46;
        i95 = i44;
        i96 = i45;
        break L168;
        break;
       }
      case 0:
       {
        HEAP32[i30 >> 2] = i36;
        i94 = i46;
        i95 = i44;
        i96 = i45;
        break L168;
        break;
       }
      case 1:
       {
        HEAP32[i30 >> 2] = i36;
        i94 = i46;
        i95 = i44;
        i96 = i45;
        break L168;
        break;
       }
      case 3:
       {
        i69 = i30;
        HEAP32[i69 >> 2] = i36;
        HEAP32[i69 + 4 >> 2] = tempRet0;
        i94 = i46;
        i95 = i44;
        i96 = i45;
        break L168;
        break;
       }
      default:
       {
        i94 = i46;
        i95 = i44;
        i96 = i45;
        break L168;
       }
      }
     } while (0);
     i55 = ((i30 | 0) != 0 & 1) + i22 | 0;
     i56 = i94;
     i57 = (HEAP32[i14 >> 2] | 0) + i53 + (HEAP32[i12 >> 2] | 0) - (HEAP32[i15 >> 2] | 0) | 0;
     i58 = i95;
     i59 = i96;
     break L8;
    } while (0);
    i33 = i23 + (i27 & 1) | 0;
    ___shlim(i1, 0);
    i34 = HEAP32[i12 >> 2] | 0;
    if (i34 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
     HEAP32[i12 >> 2] = i34 + 1;
     i99 = HEAPU8[i34 >> 0] | 0;
    } else i99 = ___shgetc(i1) | 0;
    if ((i99 | 0) != (HEAPU8[i33 >> 0] | 0)) {
     i100 = i99;
     i101 = i22;
     i102 = i25;
     i103 = i26;
     i52 = 21;
     break L6;
    }
    i55 = i22;
    i56 = i33;
    i57 = i24 + 1 | 0;
    i58 = i25;
    i59 = i26;
   } else {
    i33 = i23;
    while (1) {
     i34 = i33 + 1 | 0;
     if (!(_isspace(HEAPU8[i34 >> 0] | 0) | 0)) {
      i104 = i33;
      break;
     } else i33 = i34;
    }
    ___shlim(i1, 0);
    do {
     i33 = HEAP32[i12 >> 2] | 0;
     if (i33 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
      HEAP32[i12 >> 2] = i33 + 1;
      i105 = HEAPU8[i33 >> 0] | 0;
     } else i105 = ___shgetc(i1) | 0;
    } while ((_isspace(i105) | 0) != 0);
    i33 = HEAP32[i12 >> 2] | 0;
    if (!(HEAP32[i13 >> 2] | 0)) i106 = i33; else {
     i27 = i33 + -1 | 0;
     HEAP32[i12 >> 2] = i27;
     i106 = i27;
    }
    i55 = i22;
    i56 = i104;
    i57 = (HEAP32[i14 >> 2] | 0) + i24 + i106 - (HEAP32[i15 >> 2] | 0) | 0;
    i58 = i25;
    i59 = i26;
   } while (0);
   i23 = i56 + 1 | 0;
   i21 = HEAP8[i23 >> 0] | 0;
   if (!(i21 << 24 >> 24)) {
    i107 = i55;
    break L4;
   } else {
    i22 = i55;
    i24 = i57;
    i25 = i58;
    i26 = i59;
   }
  }
  if ((i52 | 0) == 21) {
   if (HEAP32[i13 >> 2] | 0) HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
   if ((i101 | 0) != 0 | (i100 | 0) > -1) {
    i107 = i101;
    break;
   } else {
    i108 = 0;
    i109 = i102;
    i110 = i103;
    i52 = 153;
   }
  } else if ((i52 | 0) == 152) if (!i49) {
   i108 = i48;
   i109 = i50;
   i110 = i51;
   i52 = 153;
  } else {
   i90 = i48;
   i91 = i49;
   i92 = i50;
   i93 = i51;
  }
  if ((i52 | 0) == 153) {
   i90 = i108;
   i91 = -1;
   i92 = i109;
   i93 = i110;
  }
  if (!i90) i107 = i91; else {
   _free(i92);
   _free(i93);
   i107 = i91;
  }
 } else i107 = 0; while (0);
 if (i10) ___unlockfile(i1);
 STACKTOP = i4;
 return i107 | 0;
}

function __ZN38EmscriptenBindingInitializer_my_moduleC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 __ZN10emscripten15register_vectorIiEENS_6class_INSt3__16vectorIT_NS2_9allocatorIS4_EEEENS_8internal11NoBaseClassEEEPKc(i1 + 1 | 0, 30884);
 __ZN10emscripten15register_vectorIdEENS_6class_INSt3__16vectorIT_NS2_9allocatorIS4_EEEENS_8internal11NoBaseClassEEEPKc(i1, 30894);
 __embind_register_class(13336, 13344, 13360, 0, 32095, 65, 32098, 0, 32098, 0, 30907, 32100, 223);
 __embind_register_class_constructor(13336, 1, 17456, 32095, 66, 1);
 __embind_register_class_class_function(13336, 30919, 2, 17460, 32365, 39, 224);
 __embind_register_class(13376, 13384, 13400, 0, 32095, 67, 32098, 0, 32098, 0, 30934, 32100, 225);
 __embind_register_smart_ptr(13432, 13376, 30943, 2, 32095, 68, 32641, 2, 32114, 32, 32100, 226);
 __embind_register_class_constructor(13376, 1, 17496, 32095, 69, 227);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 30;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13376, 30963, 4, 17528, 32142, 6, i2 | 0, 0);
 __embind_register_class(13456, 13464, 13480, 0, 32095, 70, 32098, 0, 32098, 0, 30972, 32100, 228);
 __embind_register_class_constructor(13456, 1, 17544, 32095, 71, 3);
 __embind_register_class_class_function(13456, 30985, 4, 17548, 32108, 8, 3);
 __embind_register_class(13496, 13504, 13520, 0, 32095, 72, 32098, 0, 32098, 0, 30991, 32100, 229);
 __embind_register_smart_ptr(13552, 13496, 30943, 2, 32095, 73, 32641, 4, 32114, 33, 32100, 230);
 __embind_register_class_constructor(13496, 1, 17592, 32095, 74, 231);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 30999, 3, 17624, 33078, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 2;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31008, 3, 17624, 33078, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 3;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31016, 3, 17624, 33078, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31016, 5, 17636, 33083, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 4;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31023, 3, 17624, 33078, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 5;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31027, 3, 17624, 33078, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31036, 3, 17624, 33078, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31043, 4, 17656, 33090, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31049, 2, 17672, 33096, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 7;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31055, 3, 17624, 33078, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 8;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31063, 3, 17624, 33078, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 9;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31072, 3, 17624, 33078, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 2;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31077, 4, 17656, 33090, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13496, 31082, 3, 17680, 32303, 1, i2 | 0, 0);
 __embind_register_class(13576, 13584, 13600, 0, 32095, 75, 32098, 0, 32098, 0, 31093, 32100, 232);
 __embind_register_smart_ptr(13632, 13576, 31106, 2, 32095, 76, 32641, 5, 32114, 34, 32100, 233);
 __embind_register_class_constructor(13576, 1, 17720, 32095, 77, 234);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13576, 31131, 4, 17752, 33468, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 2;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13576, 31136, 4, 17768, 32308, 1, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 2;
 HEAP32[i2 + 4 >> 2] = 0;
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 2;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_property(13576, 31144, 15152, 33096, 2, i2 | 0, 15152, 32303, 3, i3 | 0);
 __embind_register_class(13656, 13664, 13680, 0, 32095, 78, 32098, 0, 32098, 0, 31154, 32100, 235);
 __embind_register_smart_ptr(13712, 13656, 31168, 2, 32095, 79, 32641, 6, 32114, 35, 32100, 236);
 __embind_register_class_constructor(13656, 1, 17812, 32095, 80, 237);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13656, 31194, 5, 17844, 33849, 1, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13656, 31194, 6, 17864, 33856, 1, i3 | 0, 0);
 __embind_register_class(13736, 13744, 13760, 0, 32095, 81, 32098, 0, 32098, 0, 31197, 32100, 238);
 __embind_register_smart_ptr(13792, 13736, 31208, 2, 32095, 82, 32641, 7, 32114, 36, 32100, 239);
 __embind_register_class_constructor(13736, 1, 17916, 32095, 83, 240);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 2;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13736, 31231, 5, 17948, 33083, 2, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13736, 31237, 5, 17948, 33083, 2, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 4;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13736, 31243, 5, 17948, 33083, 2, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13736, 31252, 4, 17968, 33090, 2, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 4;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13736, 31259, 4, 17968, 33090, 2, i3 | 0, 0);
 __embind_register_class(13816, 13824, 13840, 0, 32095, 84, 32098, 0, 32098, 0, 31266, 32100, 241);
 __embind_register_smart_ptr(13872, 13816, 31274, 2, 32095, 85, 32641, 8, 32114, 37, 32100, 242);
 __embind_register_class_constructor(13816, 1, 18012, 32095, 86, 243);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13816, 31294, 5, 18044, 34544, 1, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13816, 31301, 6, 18064, 34551, 1, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13816, 31306, 7, 18088, 34559, 1, i3 | 0, 0);
 __embind_register_class(13896, 13904, 13920, 0, 32095, 87, 32098, 0, 32098, 0, 31316, 32100, 244);
 __embind_register_smart_ptr(13952, 13896, 31327, 2, 32095, 88, 32641, 9, 32114, 38, 32100, 245);
 __embind_register_class_constructor(13896, 1, 18144, 32095, 89, 246);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13896, 31358, 4, 18176, 34943, 1, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13896, 31363, 3, 18192, 32303, 4, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13896, 31373, 2, 18204, 33096, 3, i3 | 0, 0);
 __embind_register_class(13976, 13984, 14e3, 0, 32095, 90, 32098, 0, 32098, 0, 31379, 32100, 247);
 __embind_register_smart_ptr(14032, 13976, 31390, 2, 32095, 91, 32641, 10, 32114, 39, 32100, 248);
 __embind_register_class_constructor(13976, 1, 18240, 32095, 92, 249);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 93;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31413, 2, 18272, 32114, 40, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 40;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31423, 3, 18280, 32103, 4, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 94;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31433, 2, 18292, 32114, 41, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 4;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31441, 2, 18300, 33096, 4, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 10;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31441, 3, 18308, 33078, 2, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 5;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31450, 2, 18300, 33096, 4, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 11;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31450, 3, 18308, 33078, 2, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 5;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31450, 5, 18320, 33083, 3, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 6;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31455, 5, 18320, 33083, 3, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 250;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31136, 2, 18340, 32365, 41, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 251;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(13976, 31461, 2, 18340, 32365, 41, i3 | 0, 0);
 __embind_register_class(14056, 14064, 14080, 0, 32095, 95, 32098, 0, 32098, 0, 31467, 32100, 252);
 __embind_register_smart_ptr(14112, 14056, 31475, 2, 32095, 96, 32641, 11, 32114, 42, 32100, 253);
 __embind_register_class_constructor(14056, 1, 18376, 32095, 97, 254);
 i3 = __Znwj(4) | 0;
 HEAP32[i3 >> 2] = 1;
 __embind_register_class_function(14056, 31495, 6, 18408, 35648, 1, i3 | 0, 0);
 i3 = __Znwj(4) | 0;
 HEAP32[i3 >> 2] = 2;
 __embind_register_class_function(14056, 31502, 6, 18408, 35648, 1, i3 | 0, 0);
 i3 = __Znwj(4) | 0;
 HEAP32[i3 >> 2] = 3;
 __embind_register_class_function(14056, 31509, 6, 18408, 35648, 1, i3 | 0, 0);
 i3 = __Znwj(4) | 0;
 HEAP32[i3 >> 2] = 31;
 __embind_register_class_function(14056, 31516, 4, 18432, 32142, 7, i3 | 0, 0);
 __embind_register_class(14136, 14144, 14160, 0, 32095, 98, 32098, 0, 32098, 0, 31522, 32100, 255);
 __embind_register_smart_ptr(14192, 14136, 31530, 2, 32095, 99, 32641, 12, 32114, 43, 32100, 256);
 __embind_register_class_constructor(14136, 1, 18476, 32095, 100, 257);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14136, 31550, 7, 18508, 35982, 1, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 2;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14136, 31555, 7, 18536, 35991, 1, i3 | 0, 0);
 __embind_register_class(14216, 14224, 14240, 0, 32095, 101, 32098, 0, 32098, 0, 31566, 32100, 258);
 __embind_register_smart_ptr(14272, 14216, 31574, 2, 32095, 102, 32641, 13, 32114, 44, 32100, 259);
 __embind_register_class_constructor(14216, 1, 18592, 32095, 103, 260);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14216, 31594, 7, 18624, 36326, 1, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14216, 31597, 9, 18652, 36335, 1, i3 | 0, 0);
 __embind_register_class(14296, 14304, 14320, 0, 32095, 104, 32098, 0, 32098, 0, 31602, 32100, 261);
 __embind_register_smart_ptr(14352, 14296, 31610, 2, 32095, 105, 32641, 14, 32114, 45, 32100, 262);
 __embind_register_class_constructor(14296, 1, 18716, 32095, 106, 263);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 5;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14296, 31630, 3, 18748, 36672, 2, i3 | 0, 0);
 __embind_register_class(14376, 14384, 14400, 0, 32095, 107, 32098, 0, 32098, 0, 31635, 32100, 264);
 __embind_register_smart_ptr(14432, 14376, 31650, 2, 32095, 108, 32641, 15, 32114, 46, 32100, 265);
 __embind_register_class_constructor(14376, 1, 18788, 32095, 109, 266);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 12;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14376, 31677, 3, 18820, 33078, 3, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 5;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14376, 31686, 4, 18832, 33090, 3, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 6;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14376, 31695, 4, 18832, 33090, 3, i3 | 0, 0);
 __embind_register_class(14456, 14464, 14480, 0, 32095, 110, 32098, 0, 32098, 0, 31708, 32100, 267);
 __embind_register_smart_ptr(14512, 14456, 31720, 2, 32095, 111, 32641, 16, 32114, 47, 32100, 268);
 __embind_register_class_constructor(14456, 1, 18876, 32095, 112, 269);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14456, 31744, 7, 18908, 37420, 1, i3 | 0, 0);
 __embind_register_class(14536, 14544, 14560, 0, 32095, 113, 32098, 0, 32098, 0, 31751, 32100, 270);
 __embind_register_smart_ptr(14592, 14536, 31762, 2, 32095, 114, 32641, 17, 32114, 48, 32100, 271);
 __embind_register_class_constructor(14536, 1, 18964, 32095, 115, 272);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 2;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14536, 31785, 7, 18996, 37420, 2, i3 | 0, 0);
 __embind_register_class(14616, 14624, 14640, 0, 32095, 116, 32098, 0, 32098, 0, 31792, 32100, 273);
 __embind_register_smart_ptr(14672, 14616, 31813, 2, 32095, 117, 32641, 18, 32114, 49, 32100, 274);
 __embind_register_class_constructor(14616, 1, 19052, 32095, 118, 275);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 4;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14616, 31846, 3, 19084, 32303, 5, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 5;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14616, 31856, 3, 19084, 32303, 5, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 13;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14616, 31450, 3, 19096, 33078, 4, i3 | 0, 0);
 i3 = __Znwj(8) | 0;
 HEAP32[i3 >> 2] = 276;
 HEAP32[i3 + 4 >> 2] = 0;
 __embind_register_class_function(14616, 31867, 2, 19108, 32365, 42, i3 | 0, 0);
 STACKTOP = i1;
 return;
}

function _free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 if (!i1) return;
 i2 = i1 + -8 | 0;
 i3 = HEAP32[5817] | 0;
 if (i2 >>> 0 < i3 >>> 0) _abort();
 i4 = HEAP32[i1 + -4 >> 2] | 0;
 i5 = i4 & 3;
 if ((i5 | 0) == 1) _abort();
 i6 = i4 & -8;
 i7 = i1 + (i6 + -8) | 0;
 do if (!(i4 & 1)) {
  i8 = HEAP32[i2 >> 2] | 0;
  if (!i5) return;
  i9 = -8 - i8 | 0;
  i10 = i1 + i9 | 0;
  i11 = i8 + i6 | 0;
  if (i10 >>> 0 < i3 >>> 0) _abort();
  if ((i10 | 0) == (HEAP32[5818] | 0)) {
   i12 = i1 + (i6 + -4) | 0;
   i13 = HEAP32[i12 >> 2] | 0;
   if ((i13 & 3 | 0) != 3) {
    i14 = i10;
    i15 = i11;
    break;
   }
   HEAP32[5815] = i11;
   HEAP32[i12 >> 2] = i13 & -2;
   HEAP32[i1 + (i9 + 4) >> 2] = i11 | 1;
   HEAP32[i7 >> 2] = i11;
   return;
  }
  i13 = i8 >>> 3;
  if (i8 >>> 0 < 256) {
   i8 = HEAP32[i1 + (i9 + 8) >> 2] | 0;
   i12 = HEAP32[i1 + (i9 + 12) >> 2] | 0;
   i16 = 23292 + (i13 << 1 << 2) | 0;
   if ((i8 | 0) != (i16 | 0)) {
    if (i8 >>> 0 < i3 >>> 0) _abort();
    if ((HEAP32[i8 + 12 >> 2] | 0) != (i10 | 0)) _abort();
   }
   if ((i12 | 0) == (i8 | 0)) {
    HEAP32[5813] = HEAP32[5813] & ~(1 << i13);
    i14 = i10;
    i15 = i11;
    break;
   }
   if ((i12 | 0) != (i16 | 0)) {
    if (i12 >>> 0 < i3 >>> 0) _abort();
    i16 = i12 + 8 | 0;
    if ((HEAP32[i16 >> 2] | 0) == (i10 | 0)) i17 = i16; else _abort();
   } else i17 = i12 + 8 | 0;
   HEAP32[i8 + 12 >> 2] = i12;
   HEAP32[i17 >> 2] = i8;
   i14 = i10;
   i15 = i11;
   break;
  }
  i8 = HEAP32[i1 + (i9 + 24) >> 2] | 0;
  i12 = HEAP32[i1 + (i9 + 12) >> 2] | 0;
  do if ((i12 | 0) == (i10 | 0)) {
   i16 = i1 + (i9 + 20) | 0;
   i13 = HEAP32[i16 >> 2] | 0;
   if (!i13) {
    i18 = i1 + (i9 + 16) | 0;
    i19 = HEAP32[i18 >> 2] | 0;
    if (!i19) {
     i20 = 0;
     break;
    } else {
     i21 = i19;
     i22 = i18;
    }
   } else {
    i21 = i13;
    i22 = i16;
   }
   while (1) {
    i16 = i21 + 20 | 0;
    i13 = HEAP32[i16 >> 2] | 0;
    if (i13) {
     i21 = i13;
     i22 = i16;
     continue;
    }
    i16 = i21 + 16 | 0;
    i13 = HEAP32[i16 >> 2] | 0;
    if (!i13) {
     i23 = i21;
     i24 = i22;
     break;
    } else {
     i21 = i13;
     i22 = i16;
    }
   }
   if (i24 >>> 0 < i3 >>> 0) _abort(); else {
    HEAP32[i24 >> 2] = 0;
    i20 = i23;
    break;
   }
  } else {
   i16 = HEAP32[i1 + (i9 + 8) >> 2] | 0;
   if (i16 >>> 0 < i3 >>> 0) _abort();
   i13 = i16 + 12 | 0;
   if ((HEAP32[i13 >> 2] | 0) != (i10 | 0)) _abort();
   i18 = i12 + 8 | 0;
   if ((HEAP32[i18 >> 2] | 0) == (i10 | 0)) {
    HEAP32[i13 >> 2] = i12;
    HEAP32[i18 >> 2] = i16;
    i20 = i12;
    break;
   } else _abort();
  } while (0);
  if (i8) {
   i12 = HEAP32[i1 + (i9 + 28) >> 2] | 0;
   i16 = 23556 + (i12 << 2) | 0;
   if ((i10 | 0) == (HEAP32[i16 >> 2] | 0)) {
    HEAP32[i16 >> 2] = i20;
    if (!i20) {
     HEAP32[5814] = HEAP32[5814] & ~(1 << i12);
     i14 = i10;
     i15 = i11;
     break;
    }
   } else {
    if (i8 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
    i12 = i8 + 16 | 0;
    if ((HEAP32[i12 >> 2] | 0) == (i10 | 0)) HEAP32[i12 >> 2] = i20; else HEAP32[i8 + 20 >> 2] = i20;
    if (!i20) {
     i14 = i10;
     i15 = i11;
     break;
    }
   }
   i12 = HEAP32[5817] | 0;
   if (i20 >>> 0 < i12 >>> 0) _abort();
   HEAP32[i20 + 24 >> 2] = i8;
   i16 = HEAP32[i1 + (i9 + 16) >> 2] | 0;
   do if (i16) if (i16 >>> 0 < i12 >>> 0) _abort(); else {
    HEAP32[i20 + 16 >> 2] = i16;
    HEAP32[i16 + 24 >> 2] = i20;
    break;
   } while (0);
   i16 = HEAP32[i1 + (i9 + 20) >> 2] | 0;
   if (i16) if (i16 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
    HEAP32[i20 + 20 >> 2] = i16;
    HEAP32[i16 + 24 >> 2] = i20;
    i14 = i10;
    i15 = i11;
    break;
   } else {
    i14 = i10;
    i15 = i11;
   }
  } else {
   i14 = i10;
   i15 = i11;
  }
 } else {
  i14 = i2;
  i15 = i6;
 } while (0);
 if (i14 >>> 0 >= i7 >>> 0) _abort();
 i2 = i1 + (i6 + -4) | 0;
 i20 = HEAP32[i2 >> 2] | 0;
 if (!(i20 & 1)) _abort();
 if (!(i20 & 2)) {
  if ((i7 | 0) == (HEAP32[5819] | 0)) {
   i3 = (HEAP32[5816] | 0) + i15 | 0;
   HEAP32[5816] = i3;
   HEAP32[5819] = i14;
   HEAP32[i14 + 4 >> 2] = i3 | 1;
   if ((i14 | 0) != (HEAP32[5818] | 0)) return;
   HEAP32[5818] = 0;
   HEAP32[5815] = 0;
   return;
  }
  if ((i7 | 0) == (HEAP32[5818] | 0)) {
   i3 = (HEAP32[5815] | 0) + i15 | 0;
   HEAP32[5815] = i3;
   HEAP32[5818] = i14;
   HEAP32[i14 + 4 >> 2] = i3 | 1;
   HEAP32[i14 + i3 >> 2] = i3;
   return;
  }
  i3 = (i20 & -8) + i15 | 0;
  i23 = i20 >>> 3;
  do if (i20 >>> 0 >= 256) {
   i24 = HEAP32[i1 + (i6 + 16) >> 2] | 0;
   i22 = HEAP32[i1 + (i6 | 4) >> 2] | 0;
   do if ((i22 | 0) == (i7 | 0)) {
    i21 = i1 + (i6 + 12) | 0;
    i17 = HEAP32[i21 >> 2] | 0;
    if (!i17) {
     i5 = i1 + (i6 + 8) | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     if (!i4) {
      i25 = 0;
      break;
     } else {
      i26 = i4;
      i27 = i5;
     }
    } else {
     i26 = i17;
     i27 = i21;
    }
    while (1) {
     i21 = i26 + 20 | 0;
     i17 = HEAP32[i21 >> 2] | 0;
     if (i17) {
      i26 = i17;
      i27 = i21;
      continue;
     }
     i21 = i26 + 16 | 0;
     i17 = HEAP32[i21 >> 2] | 0;
     if (!i17) {
      i28 = i26;
      i29 = i27;
      break;
     } else {
      i26 = i17;
      i27 = i21;
     }
    }
    if (i29 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
     HEAP32[i29 >> 2] = 0;
     i25 = i28;
     break;
    }
   } else {
    i21 = HEAP32[i1 + i6 >> 2] | 0;
    if (i21 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
    i17 = i21 + 12 | 0;
    if ((HEAP32[i17 >> 2] | 0) != (i7 | 0)) _abort();
    i5 = i22 + 8 | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i7 | 0)) {
     HEAP32[i17 >> 2] = i22;
     HEAP32[i5 >> 2] = i21;
     i25 = i22;
     break;
    } else _abort();
   } while (0);
   if (i24) {
    i22 = HEAP32[i1 + (i6 + 20) >> 2] | 0;
    i11 = 23556 + (i22 << 2) | 0;
    if ((i7 | 0) == (HEAP32[i11 >> 2] | 0)) {
     HEAP32[i11 >> 2] = i25;
     if (!i25) {
      HEAP32[5814] = HEAP32[5814] & ~(1 << i22);
      break;
     }
    } else {
     if (i24 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
     i22 = i24 + 16 | 0;
     if ((HEAP32[i22 >> 2] | 0) == (i7 | 0)) HEAP32[i22 >> 2] = i25; else HEAP32[i24 + 20 >> 2] = i25;
     if (!i25) break;
    }
    i22 = HEAP32[5817] | 0;
    if (i25 >>> 0 < i22 >>> 0) _abort();
    HEAP32[i25 + 24 >> 2] = i24;
    i11 = HEAP32[i1 + (i6 + 8) >> 2] | 0;
    do if (i11) if (i11 >>> 0 < i22 >>> 0) _abort(); else {
     HEAP32[i25 + 16 >> 2] = i11;
     HEAP32[i11 + 24 >> 2] = i25;
     break;
    } while (0);
    i11 = HEAP32[i1 + (i6 + 12) >> 2] | 0;
    if (i11) if (i11 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
     HEAP32[i25 + 20 >> 2] = i11;
     HEAP32[i11 + 24 >> 2] = i25;
     break;
    }
   }
  } else {
   i11 = HEAP32[i1 + i6 >> 2] | 0;
   i22 = HEAP32[i1 + (i6 | 4) >> 2] | 0;
   i24 = 23292 + (i23 << 1 << 2) | 0;
   if ((i11 | 0) != (i24 | 0)) {
    if (i11 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
    if ((HEAP32[i11 + 12 >> 2] | 0) != (i7 | 0)) _abort();
   }
   if ((i22 | 0) == (i11 | 0)) {
    HEAP32[5813] = HEAP32[5813] & ~(1 << i23);
    break;
   }
   if ((i22 | 0) != (i24 | 0)) {
    if (i22 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
    i24 = i22 + 8 | 0;
    if ((HEAP32[i24 >> 2] | 0) == (i7 | 0)) i30 = i24; else _abort();
   } else i30 = i22 + 8 | 0;
   HEAP32[i11 + 12 >> 2] = i22;
   HEAP32[i30 >> 2] = i11;
  } while (0);
  HEAP32[i14 + 4 >> 2] = i3 | 1;
  HEAP32[i14 + i3 >> 2] = i3;
  if ((i14 | 0) == (HEAP32[5818] | 0)) {
   HEAP32[5815] = i3;
   return;
  } else i31 = i3;
 } else {
  HEAP32[i2 >> 2] = i20 & -2;
  HEAP32[i14 + 4 >> 2] = i15 | 1;
  HEAP32[i14 + i15 >> 2] = i15;
  i31 = i15;
 }
 i15 = i31 >>> 3;
 if (i31 >>> 0 < 256) {
  i20 = i15 << 1;
  i2 = 23292 + (i20 << 2) | 0;
  i3 = HEAP32[5813] | 0;
  i30 = 1 << i15;
  if (i3 & i30) {
   i15 = 23292 + (i20 + 2 << 2) | 0;
   i7 = HEAP32[i15 >> 2] | 0;
   if (i7 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
    i32 = i15;
    i33 = i7;
   }
  } else {
   HEAP32[5813] = i3 | i30;
   i32 = 23292 + (i20 + 2 << 2) | 0;
   i33 = i2;
  }
  HEAP32[i32 >> 2] = i14;
  HEAP32[i33 + 12 >> 2] = i14;
  HEAP32[i14 + 8 >> 2] = i33;
  HEAP32[i14 + 12 >> 2] = i2;
  return;
 }
 i2 = i31 >>> 8;
 if (i2) if (i31 >>> 0 > 16777215) i34 = 31; else {
  i33 = (i2 + 1048320 | 0) >>> 16 & 8;
  i32 = i2 << i33;
  i2 = (i32 + 520192 | 0) >>> 16 & 4;
  i20 = i32 << i2;
  i32 = (i20 + 245760 | 0) >>> 16 & 2;
  i30 = 14 - (i2 | i33 | i32) + (i20 << i32 >>> 15) | 0;
  i34 = i31 >>> (i30 + 7 | 0) & 1 | i30 << 1;
 } else i34 = 0;
 i30 = 23556 + (i34 << 2) | 0;
 HEAP32[i14 + 28 >> 2] = i34;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 i32 = HEAP32[5814] | 0;
 i20 = 1 << i34;
 L199 : do if (i32 & i20) {
  i33 = HEAP32[i30 >> 2] | 0;
  L202 : do if ((HEAP32[i33 + 4 >> 2] & -8 | 0) != (i31 | 0)) {
   i2 = i31 << ((i34 | 0) == 31 ? 0 : 25 - (i34 >>> 1) | 0);
   i3 = i33;
   while (1) {
    i7 = i3 + 16 + (i2 >>> 31 << 2) | 0;
    i15 = HEAP32[i7 >> 2] | 0;
    if (!i15) {
     i35 = i7;
     i36 = i3;
     break;
    }
    if ((HEAP32[i15 + 4 >> 2] & -8 | 0) == (i31 | 0)) {
     i37 = i15;
     break L202;
    } else {
     i2 = i2 << 1;
     i3 = i15;
    }
   }
   if (i35 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
    HEAP32[i35 >> 2] = i14;
    HEAP32[i14 + 24 >> 2] = i36;
    HEAP32[i14 + 12 >> 2] = i14;
    HEAP32[i14 + 8 >> 2] = i14;
    break L199;
   }
  } else i37 = i33; while (0);
  i33 = i37 + 8 | 0;
  i3 = HEAP32[i33 >> 2] | 0;
  i2 = HEAP32[5817] | 0;
  if (i3 >>> 0 >= i2 >>> 0 & i37 >>> 0 >= i2 >>> 0) {
   HEAP32[i3 + 12 >> 2] = i14;
   HEAP32[i33 >> 2] = i14;
   HEAP32[i14 + 8 >> 2] = i3;
   HEAP32[i14 + 12 >> 2] = i37;
   HEAP32[i14 + 24 >> 2] = 0;
   break;
  } else _abort();
 } else {
  HEAP32[5814] = i32 | i20;
  HEAP32[i30 >> 2] = i14;
  HEAP32[i14 + 24 >> 2] = i30;
  HEAP32[i14 + 12 >> 2] = i14;
  HEAP32[i14 + 8 >> 2] = i14;
 } while (0);
 i14 = (HEAP32[5821] | 0) + -1 | 0;
 HEAP32[5821] = i14;
 if (!i14) i38 = 23708; else return;
 while (1) {
  i14 = HEAP32[i38 >> 2] | 0;
  if (!i14) break; else i38 = i14 + 8 | 0;
 }
 HEAP32[5821] = -1;
 return;
}

function ___intscan(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0;
 L1 : do if (i2 >>> 0 > 36) {
  i6 = ___errno_location() | 0;
  HEAP32[i6 >> 2] = 22;
  i7 = 0;
  i8 = 0;
 } else {
  i6 = i1 + 4 | 0;
  i9 = i1 + 100 | 0;
  do {
   i10 = HEAP32[i6 >> 2] | 0;
   if (i10 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
    HEAP32[i6 >> 2] = i10 + 1;
    i11 = HEAPU8[i10 >> 0] | 0;
   } else i11 = ___shgetc(i1) | 0;
  } while ((_isspace(i11) | 0) != 0);
  i12 = i11;
  L11 : do switch (i12 | 0) {
  case 43:
  case 45:
   {
    i10 = ((i12 | 0) == 45) << 31 >> 31;
    i13 = HEAP32[i6 >> 2] | 0;
    if (i13 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
     HEAP32[i6 >> 2] = i13 + 1;
     i14 = HEAPU8[i13 >> 0] | 0;
     i15 = i10;
     break L11;
    } else {
     i14 = ___shgetc(i1) | 0;
     i15 = i10;
     break L11;
    }
    break;
   }
  default:
   {
    i14 = i12;
    i15 = 0;
   }
  } while (0);
  i10 = (i2 | 0) == 0;
  do if ((i2 & -17 | 0) == 0 & (i14 | 0) == 48) {
   i13 = HEAP32[i6 >> 2] | 0;
   if (i13 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
    HEAP32[i6 >> 2] = i13 + 1;
    i16 = HEAPU8[i13 >> 0] | 0;
   } else i16 = ___shgetc(i1) | 0;
   if ((i16 | 32 | 0) != 120) if (i10) {
    i17 = 8;
    i18 = i16;
    i19 = 46;
    break;
   } else {
    i20 = i2;
    i21 = i16;
    i19 = 32;
    break;
   }
   i13 = HEAP32[i6 >> 2] | 0;
   if (i13 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
    HEAP32[i6 >> 2] = i13 + 1;
    i22 = HEAPU8[i13 >> 0] | 0;
   } else i22 = ___shgetc(i1) | 0;
   if ((HEAPU8[42586 + (i22 + 1) >> 0] | 0) > 15) {
    i13 = (HEAP32[i9 >> 2] | 0) == 0;
    if (!i13) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    if (!i3) {
     ___shlim(i1, 0);
     i7 = 0;
     i8 = 0;
     break L1;
    }
    if (i13) {
     i7 = 0;
     i8 = 0;
     break L1;
    }
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i7 = 0;
    i8 = 0;
    break L1;
   } else {
    i17 = 16;
    i18 = i22;
    i19 = 46;
   }
  } else {
   i13 = i10 ? 10 : i2;
   if ((HEAPU8[42586 + (i14 + 1) >> 0] | 0) >>> 0 < i13 >>> 0) {
    i20 = i13;
    i21 = i14;
    i19 = 32;
   } else {
    if (HEAP32[i9 >> 2] | 0) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    ___shlim(i1, 0);
    i13 = ___errno_location() | 0;
    HEAP32[i13 >> 2] = 22;
    i7 = 0;
    i8 = 0;
    break L1;
   }
  } while (0);
  if ((i19 | 0) == 32) if ((i20 | 0) == 10) {
   i10 = i21 + -48 | 0;
   if (i10 >>> 0 < 10) {
    i13 = i10;
    i10 = 0;
    while (1) {
     i23 = (i10 * 10 | 0) + i13 | 0;
     i24 = HEAP32[i6 >> 2] | 0;
     if (i24 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
      HEAP32[i6 >> 2] = i24 + 1;
      i25 = HEAPU8[i24 >> 0] | 0;
     } else i25 = ___shgetc(i1) | 0;
     i13 = i25 + -48 | 0;
     if (!(i13 >>> 0 < 10 & i23 >>> 0 < 429496729)) {
      i26 = i23;
      i27 = i25;
      break;
     } else i10 = i23;
    }
    i28 = i26;
    i29 = 0;
    i30 = i27;
   } else {
    i28 = 0;
    i29 = 0;
    i30 = i21;
   }
   i10 = i30 + -48 | 0;
   if (i10 >>> 0 < 10) {
    i13 = i28;
    i23 = i29;
    i24 = i10;
    i10 = i30;
    while (1) {
     i31 = ___muldi3(i13 | 0, i23 | 0, 10, 0) | 0;
     i32 = tempRet0;
     i33 = ((i24 | 0) < 0) << 31 >> 31;
     i34 = ~i33;
     if (i32 >>> 0 > i34 >>> 0 | (i32 | 0) == (i34 | 0) & i31 >>> 0 > ~i24 >>> 0) {
      i35 = i24;
      i36 = i13;
      i37 = i23;
      i38 = i10;
      break;
     }
     i34 = _i64Add(i31 | 0, i32 | 0, i24 | 0, i33 | 0) | 0;
     i33 = tempRet0;
     i32 = HEAP32[i6 >> 2] | 0;
     if (i32 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
      HEAP32[i6 >> 2] = i32 + 1;
      i39 = HEAPU8[i32 >> 0] | 0;
     } else i39 = ___shgetc(i1) | 0;
     i32 = i39 + -48 | 0;
     if (i32 >>> 0 < 10 & (i33 >>> 0 < 429496729 | (i33 | 0) == 429496729 & i34 >>> 0 < 2576980378)) {
      i13 = i34;
      i23 = i33;
      i24 = i32;
      i10 = i39;
     } else {
      i35 = i32;
      i36 = i34;
      i37 = i33;
      i38 = i39;
      break;
     }
    }
    if (i35 >>> 0 > 9) {
     i40 = i37;
     i41 = i36;
     i42 = i15;
    } else {
     i43 = 10;
     i44 = i36;
     i45 = i37;
     i46 = i38;
     i19 = 72;
    }
   } else {
    i40 = i29;
    i41 = i28;
    i42 = i15;
   }
  } else {
   i17 = i20;
   i18 = i21;
   i19 = 46;
  }
  L63 : do if ((i19 | 0) == 46) {
   if (!(i17 + -1 & i17)) {
    i10 = HEAP8[42843 + ((i17 * 23 | 0) >>> 5 & 7) >> 0] | 0;
    i24 = HEAP8[42586 + (i18 + 1) >> 0] | 0;
    i23 = i24 & 255;
    if (i23 >>> 0 < i17 >>> 0) {
     i13 = i23;
     i23 = 0;
     while (1) {
      i33 = i13 | i23 << i10;
      i34 = HEAP32[i6 >> 2] | 0;
      if (i34 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
       HEAP32[i6 >> 2] = i34 + 1;
       i47 = HEAPU8[i34 >> 0] | 0;
      } else i47 = ___shgetc(i1) | 0;
      i34 = HEAP8[42586 + (i47 + 1) >> 0] | 0;
      i13 = i34 & 255;
      if (!(i33 >>> 0 < 134217728 & i13 >>> 0 < i17 >>> 0)) {
       i48 = i33;
       i49 = i34;
       i50 = i47;
       break;
      } else i23 = i33;
     }
     i51 = i49;
     i52 = 0;
     i53 = i48;
     i54 = i50;
    } else {
     i51 = i24;
     i52 = 0;
     i53 = 0;
     i54 = i18;
    }
    i23 = _bitshift64Lshr(-1, -1, i10 | 0) | 0;
    i13 = tempRet0;
    if ((i51 & 255) >>> 0 >= i17 >>> 0 | (i52 >>> 0 > i13 >>> 0 | (i52 | 0) == (i13 | 0) & i53 >>> 0 > i23 >>> 0)) {
     i43 = i17;
     i44 = i53;
     i45 = i52;
     i46 = i54;
     i19 = 72;
     break;
    } else {
     i55 = i53;
     i56 = i52;
     i57 = i51;
    }
    while (1) {
     i33 = _bitshift64Shl(i55 | 0, i56 | 0, i10 | 0) | 0;
     i34 = tempRet0;
     i32 = i57 & 255 | i33;
     i33 = HEAP32[i6 >> 2] | 0;
     if (i33 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
      HEAP32[i6 >> 2] = i33 + 1;
      i58 = HEAPU8[i33 >> 0] | 0;
     } else i58 = ___shgetc(i1) | 0;
     i57 = HEAP8[42586 + (i58 + 1) >> 0] | 0;
     if ((i57 & 255) >>> 0 >= i17 >>> 0 | (i34 >>> 0 > i13 >>> 0 | (i34 | 0) == (i13 | 0) & i32 >>> 0 > i23 >>> 0)) {
      i43 = i17;
      i44 = i32;
      i45 = i34;
      i46 = i58;
      i19 = 72;
      break L63;
     } else {
      i55 = i32;
      i56 = i34;
     }
    }
   }
   i23 = HEAP8[42586 + (i18 + 1) >> 0] | 0;
   i13 = i23 & 255;
   if (i13 >>> 0 < i17 >>> 0) {
    i10 = i13;
    i13 = 0;
    while (1) {
     i24 = i10 + (Math_imul(i13, i17) | 0) | 0;
     i34 = HEAP32[i6 >> 2] | 0;
     if (i34 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
      HEAP32[i6 >> 2] = i34 + 1;
      i59 = HEAPU8[i34 >> 0] | 0;
     } else i59 = ___shgetc(i1) | 0;
     i34 = HEAP8[42586 + (i59 + 1) >> 0] | 0;
     i10 = i34 & 255;
     if (!(i24 >>> 0 < 119304647 & i10 >>> 0 < i17 >>> 0)) {
      i60 = i24;
      i61 = i34;
      i62 = i59;
      break;
     } else i13 = i24;
    }
    i63 = i61;
    i64 = i60;
    i65 = 0;
    i66 = i62;
   } else {
    i63 = i23;
    i64 = 0;
    i65 = 0;
    i66 = i18;
   }
   if ((i63 & 255) >>> 0 < i17 >>> 0) {
    i13 = ___udivdi3(-1, -1, i17 | 0, 0) | 0;
    i10 = tempRet0;
    i24 = i65;
    i34 = i64;
    i32 = i63;
    i33 = i66;
    while (1) {
     if (i24 >>> 0 > i10 >>> 0 | (i24 | 0) == (i10 | 0) & i34 >>> 0 > i13 >>> 0) {
      i43 = i17;
      i44 = i34;
      i45 = i24;
      i46 = i33;
      i19 = 72;
      break L63;
     }
     i31 = ___muldi3(i34 | 0, i24 | 0, i17 | 0, 0) | 0;
     i67 = tempRet0;
     i68 = i32 & 255;
     if (i67 >>> 0 > 4294967295 | (i67 | 0) == -1 & i31 >>> 0 > ~i68 >>> 0) {
      i43 = i17;
      i44 = i34;
      i45 = i24;
      i46 = i33;
      i19 = 72;
      break L63;
     }
     i69 = _i64Add(i68 | 0, 0, i31 | 0, i67 | 0) | 0;
     i67 = tempRet0;
     i31 = HEAP32[i6 >> 2] | 0;
     if (i31 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
      HEAP32[i6 >> 2] = i31 + 1;
      i70 = HEAPU8[i31 >> 0] | 0;
     } else i70 = ___shgetc(i1) | 0;
     i32 = HEAP8[42586 + (i70 + 1) >> 0] | 0;
     if ((i32 & 255) >>> 0 >= i17 >>> 0) {
      i43 = i17;
      i44 = i69;
      i45 = i67;
      i46 = i70;
      i19 = 72;
      break;
     } else {
      i24 = i67;
      i34 = i69;
      i33 = i70;
     }
    }
   } else {
    i43 = i17;
    i44 = i64;
    i45 = i65;
    i46 = i66;
    i19 = 72;
   }
  } while (0);
  if ((i19 | 0) == 72) if ((HEAPU8[42586 + (i46 + 1) >> 0] | 0) >>> 0 < i43 >>> 0) {
   do {
    i33 = HEAP32[i6 >> 2] | 0;
    if (i33 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
     HEAP32[i6 >> 2] = i33 + 1;
     i71 = HEAPU8[i33 >> 0] | 0;
    } else i71 = ___shgetc(i1) | 0;
   } while ((HEAPU8[42586 + (i71 + 1) >> 0] | 0) >>> 0 < i43 >>> 0);
   i33 = ___errno_location() | 0;
   HEAP32[i33 >> 2] = 34;
   i40 = i5;
   i41 = i4;
   i42 = (i4 & 1 | 0) == 0 & 0 == 0 ? i15 : 0;
  } else {
   i40 = i45;
   i41 = i44;
   i42 = i15;
  }
  if (HEAP32[i9 >> 2] | 0) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  if (!(i40 >>> 0 < i5 >>> 0 | (i40 | 0) == (i5 | 0) & i41 >>> 0 < i4 >>> 0)) {
   if (!((i4 & 1 | 0) != 0 | 0 != 0 | (i42 | 0) != 0)) {
    i33 = ___errno_location() | 0;
    HEAP32[i33 >> 2] = 34;
    i33 = _i64Add(i4 | 0, i5 | 0, -1, -1) | 0;
    i7 = tempRet0;
    i8 = i33;
    break;
   }
   if (i40 >>> 0 > i5 >>> 0 | (i40 | 0) == (i5 | 0) & i41 >>> 0 > i4 >>> 0) {
    i33 = ___errno_location() | 0;
    HEAP32[i33 >> 2] = 34;
    i7 = i5;
    i8 = i4;
    break;
   }
  }
  i33 = ((i42 | 0) < 0) << 31 >> 31;
  i34 = _i64Subtract(i41 ^ i42 | 0, i40 ^ i33 | 0, i42 | 0, i33 | 0) | 0;
  i7 = tempRet0;
  i8 = i34;
 } while (0);
 tempRet0 = i7;
 return i8 | 0;
}

function _dispose_chunk(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i3 = i1 + i2 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 do if (!(i4 & 1)) {
  i5 = HEAP32[i1 >> 2] | 0;
  if (!(i4 & 3)) return;
  i6 = i1 + (0 - i5) | 0;
  i7 = i5 + i2 | 0;
  i8 = HEAP32[5817] | 0;
  if (i6 >>> 0 < i8 >>> 0) _abort();
  if ((i6 | 0) == (HEAP32[5818] | 0)) {
   i9 = i1 + (i2 + 4) | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   if ((i10 & 3 | 0) != 3) {
    i11 = i6;
    i12 = i7;
    break;
   }
   HEAP32[5815] = i7;
   HEAP32[i9 >> 2] = i10 & -2;
   HEAP32[i1 + (4 - i5) >> 2] = i7 | 1;
   HEAP32[i3 >> 2] = i7;
   return;
  }
  i10 = i5 >>> 3;
  if (i5 >>> 0 < 256) {
   i9 = HEAP32[i1 + (8 - i5) >> 2] | 0;
   i13 = HEAP32[i1 + (12 - i5) >> 2] | 0;
   i14 = 23292 + (i10 << 1 << 2) | 0;
   if ((i9 | 0) != (i14 | 0)) {
    if (i9 >>> 0 < i8 >>> 0) _abort();
    if ((HEAP32[i9 + 12 >> 2] | 0) != (i6 | 0)) _abort();
   }
   if ((i13 | 0) == (i9 | 0)) {
    HEAP32[5813] = HEAP32[5813] & ~(1 << i10);
    i11 = i6;
    i12 = i7;
    break;
   }
   if ((i13 | 0) != (i14 | 0)) {
    if (i13 >>> 0 < i8 >>> 0) _abort();
    i14 = i13 + 8 | 0;
    if ((HEAP32[i14 >> 2] | 0) == (i6 | 0)) i15 = i14; else _abort();
   } else i15 = i13 + 8 | 0;
   HEAP32[i9 + 12 >> 2] = i13;
   HEAP32[i15 >> 2] = i9;
   i11 = i6;
   i12 = i7;
   break;
  }
  i9 = HEAP32[i1 + (24 - i5) >> 2] | 0;
  i13 = HEAP32[i1 + (12 - i5) >> 2] | 0;
  do if ((i13 | 0) == (i6 | 0)) {
   i14 = 16 - i5 | 0;
   i10 = i1 + (i14 + 4) | 0;
   i16 = HEAP32[i10 >> 2] | 0;
   if (!i16) {
    i17 = i1 + i14 | 0;
    i14 = HEAP32[i17 >> 2] | 0;
    if (!i14) {
     i18 = 0;
     break;
    } else {
     i19 = i14;
     i20 = i17;
    }
   } else {
    i19 = i16;
    i20 = i10;
   }
   while (1) {
    i10 = i19 + 20 | 0;
    i16 = HEAP32[i10 >> 2] | 0;
    if (i16) {
     i19 = i16;
     i20 = i10;
     continue;
    }
    i10 = i19 + 16 | 0;
    i16 = HEAP32[i10 >> 2] | 0;
    if (!i16) {
     i21 = i19;
     i22 = i20;
     break;
    } else {
     i19 = i16;
     i20 = i10;
    }
   }
   if (i22 >>> 0 < i8 >>> 0) _abort(); else {
    HEAP32[i22 >> 2] = 0;
    i18 = i21;
    break;
   }
  } else {
   i10 = HEAP32[i1 + (8 - i5) >> 2] | 0;
   if (i10 >>> 0 < i8 >>> 0) _abort();
   i16 = i10 + 12 | 0;
   if ((HEAP32[i16 >> 2] | 0) != (i6 | 0)) _abort();
   i17 = i13 + 8 | 0;
   if ((HEAP32[i17 >> 2] | 0) == (i6 | 0)) {
    HEAP32[i16 >> 2] = i13;
    HEAP32[i17 >> 2] = i10;
    i18 = i13;
    break;
   } else _abort();
  } while (0);
  if (i9) {
   i13 = HEAP32[i1 + (28 - i5) >> 2] | 0;
   i8 = 23556 + (i13 << 2) | 0;
   if ((i6 | 0) == (HEAP32[i8 >> 2] | 0)) {
    HEAP32[i8 >> 2] = i18;
    if (!i18) {
     HEAP32[5814] = HEAP32[5814] & ~(1 << i13);
     i11 = i6;
     i12 = i7;
     break;
    }
   } else {
    if (i9 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
    i13 = i9 + 16 | 0;
    if ((HEAP32[i13 >> 2] | 0) == (i6 | 0)) HEAP32[i13 >> 2] = i18; else HEAP32[i9 + 20 >> 2] = i18;
    if (!i18) {
     i11 = i6;
     i12 = i7;
     break;
    }
   }
   i13 = HEAP32[5817] | 0;
   if (i18 >>> 0 < i13 >>> 0) _abort();
   HEAP32[i18 + 24 >> 2] = i9;
   i8 = 16 - i5 | 0;
   i10 = HEAP32[i1 + i8 >> 2] | 0;
   do if (i10) if (i10 >>> 0 < i13 >>> 0) _abort(); else {
    HEAP32[i18 + 16 >> 2] = i10;
    HEAP32[i10 + 24 >> 2] = i18;
    break;
   } while (0);
   i10 = HEAP32[i1 + (i8 + 4) >> 2] | 0;
   if (i10) if (i10 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
    HEAP32[i18 + 20 >> 2] = i10;
    HEAP32[i10 + 24 >> 2] = i18;
    i11 = i6;
    i12 = i7;
    break;
   } else {
    i11 = i6;
    i12 = i7;
   }
  } else {
   i11 = i6;
   i12 = i7;
  }
 } else {
  i11 = i1;
  i12 = i2;
 } while (0);
 i18 = HEAP32[5817] | 0;
 if (i3 >>> 0 < i18 >>> 0) _abort();
 i21 = i1 + (i2 + 4) | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 if (!(i22 & 2)) {
  if ((i3 | 0) == (HEAP32[5819] | 0)) {
   i20 = (HEAP32[5816] | 0) + i12 | 0;
   HEAP32[5816] = i20;
   HEAP32[5819] = i11;
   HEAP32[i11 + 4 >> 2] = i20 | 1;
   if ((i11 | 0) != (HEAP32[5818] | 0)) return;
   HEAP32[5818] = 0;
   HEAP32[5815] = 0;
   return;
  }
  if ((i3 | 0) == (HEAP32[5818] | 0)) {
   i20 = (HEAP32[5815] | 0) + i12 | 0;
   HEAP32[5815] = i20;
   HEAP32[5818] = i11;
   HEAP32[i11 + 4 >> 2] = i20 | 1;
   HEAP32[i11 + i20 >> 2] = i20;
   return;
  }
  i20 = (i22 & -8) + i12 | 0;
  i19 = i22 >>> 3;
  do if (i22 >>> 0 >= 256) {
   i15 = HEAP32[i1 + (i2 + 24) >> 2] | 0;
   i4 = HEAP32[i1 + (i2 + 12) >> 2] | 0;
   do if ((i4 | 0) == (i3 | 0)) {
    i10 = i1 + (i2 + 20) | 0;
    i13 = HEAP32[i10 >> 2] | 0;
    if (!i13) {
     i5 = i1 + (i2 + 16) | 0;
     i9 = HEAP32[i5 >> 2] | 0;
     if (!i9) {
      i23 = 0;
      break;
     } else {
      i24 = i9;
      i25 = i5;
     }
    } else {
     i24 = i13;
     i25 = i10;
    }
    while (1) {
     i10 = i24 + 20 | 0;
     i13 = HEAP32[i10 >> 2] | 0;
     if (i13) {
      i24 = i13;
      i25 = i10;
      continue;
     }
     i10 = i24 + 16 | 0;
     i13 = HEAP32[i10 >> 2] | 0;
     if (!i13) {
      i26 = i24;
      i27 = i25;
      break;
     } else {
      i24 = i13;
      i25 = i10;
     }
    }
    if (i27 >>> 0 < i18 >>> 0) _abort(); else {
     HEAP32[i27 >> 2] = 0;
     i23 = i26;
     break;
    }
   } else {
    i10 = HEAP32[i1 + (i2 + 8) >> 2] | 0;
    if (i10 >>> 0 < i18 >>> 0) _abort();
    i13 = i10 + 12 | 0;
    if ((HEAP32[i13 >> 2] | 0) != (i3 | 0)) _abort();
    i5 = i4 + 8 | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i3 | 0)) {
     HEAP32[i13 >> 2] = i4;
     HEAP32[i5 >> 2] = i10;
     i23 = i4;
     break;
    } else _abort();
   } while (0);
   if (i15) {
    i4 = HEAP32[i1 + (i2 + 28) >> 2] | 0;
    i7 = 23556 + (i4 << 2) | 0;
    if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
     HEAP32[i7 >> 2] = i23;
     if (!i23) {
      HEAP32[5814] = HEAP32[5814] & ~(1 << i4);
      break;
     }
    } else {
     if (i15 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
     i4 = i15 + 16 | 0;
     if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) HEAP32[i4 >> 2] = i23; else HEAP32[i15 + 20 >> 2] = i23;
     if (!i23) break;
    }
    i4 = HEAP32[5817] | 0;
    if (i23 >>> 0 < i4 >>> 0) _abort();
    HEAP32[i23 + 24 >> 2] = i15;
    i7 = HEAP32[i1 + (i2 + 16) >> 2] | 0;
    do if (i7) if (i7 >>> 0 < i4 >>> 0) _abort(); else {
     HEAP32[i23 + 16 >> 2] = i7;
     HEAP32[i7 + 24 >> 2] = i23;
     break;
    } while (0);
    i7 = HEAP32[i1 + (i2 + 20) >> 2] | 0;
    if (i7) if (i7 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
     HEAP32[i23 + 20 >> 2] = i7;
     HEAP32[i7 + 24 >> 2] = i23;
     break;
    }
   }
  } else {
   i7 = HEAP32[i1 + (i2 + 8) >> 2] | 0;
   i4 = HEAP32[i1 + (i2 + 12) >> 2] | 0;
   i15 = 23292 + (i19 << 1 << 2) | 0;
   if ((i7 | 0) != (i15 | 0)) {
    if (i7 >>> 0 < i18 >>> 0) _abort();
    if ((HEAP32[i7 + 12 >> 2] | 0) != (i3 | 0)) _abort();
   }
   if ((i4 | 0) == (i7 | 0)) {
    HEAP32[5813] = HEAP32[5813] & ~(1 << i19);
    break;
   }
   if ((i4 | 0) != (i15 | 0)) {
    if (i4 >>> 0 < i18 >>> 0) _abort();
    i15 = i4 + 8 | 0;
    if ((HEAP32[i15 >> 2] | 0) == (i3 | 0)) i28 = i15; else _abort();
   } else i28 = i4 + 8 | 0;
   HEAP32[i7 + 12 >> 2] = i4;
   HEAP32[i28 >> 2] = i7;
  } while (0);
  HEAP32[i11 + 4 >> 2] = i20 | 1;
  HEAP32[i11 + i20 >> 2] = i20;
  if ((i11 | 0) == (HEAP32[5818] | 0)) {
   HEAP32[5815] = i20;
   return;
  } else i29 = i20;
 } else {
  HEAP32[i21 >> 2] = i22 & -2;
  HEAP32[i11 + 4 >> 2] = i12 | 1;
  HEAP32[i11 + i12 >> 2] = i12;
  i29 = i12;
 }
 i12 = i29 >>> 3;
 if (i29 >>> 0 < 256) {
  i22 = i12 << 1;
  i21 = 23292 + (i22 << 2) | 0;
  i20 = HEAP32[5813] | 0;
  i28 = 1 << i12;
  if (i20 & i28) {
   i12 = 23292 + (i22 + 2 << 2) | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   if (i3 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
    i30 = i12;
    i31 = i3;
   }
  } else {
   HEAP32[5813] = i20 | i28;
   i30 = 23292 + (i22 + 2 << 2) | 0;
   i31 = i21;
  }
  HEAP32[i30 >> 2] = i11;
  HEAP32[i31 + 12 >> 2] = i11;
  HEAP32[i11 + 8 >> 2] = i31;
  HEAP32[i11 + 12 >> 2] = i21;
  return;
 }
 i21 = i29 >>> 8;
 if (i21) if (i29 >>> 0 > 16777215) i32 = 31; else {
  i31 = (i21 + 1048320 | 0) >>> 16 & 8;
  i30 = i21 << i31;
  i21 = (i30 + 520192 | 0) >>> 16 & 4;
  i22 = i30 << i21;
  i30 = (i22 + 245760 | 0) >>> 16 & 2;
  i28 = 14 - (i21 | i31 | i30) + (i22 << i30 >>> 15) | 0;
  i32 = i29 >>> (i28 + 7 | 0) & 1 | i28 << 1;
 } else i32 = 0;
 i28 = 23556 + (i32 << 2) | 0;
 HEAP32[i11 + 28 >> 2] = i32;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 i30 = HEAP32[5814] | 0;
 i22 = 1 << i32;
 if (!(i30 & i22)) {
  HEAP32[5814] = i30 | i22;
  HEAP32[i28 >> 2] = i11;
  HEAP32[i11 + 24 >> 2] = i28;
  HEAP32[i11 + 12 >> 2] = i11;
  HEAP32[i11 + 8 >> 2] = i11;
  return;
 }
 i22 = HEAP32[i28 >> 2] | 0;
 L191 : do if ((HEAP32[i22 + 4 >> 2] & -8 | 0) == (i29 | 0)) i33 = i22; else {
  i28 = i29 << ((i32 | 0) == 31 ? 0 : 25 - (i32 >>> 1) | 0);
  i30 = i22;
  while (1) {
   i31 = i30 + 16 + (i28 >>> 31 << 2) | 0;
   i21 = HEAP32[i31 >> 2] | 0;
   if (!i21) {
    i34 = i31;
    i35 = i30;
    break;
   }
   if ((HEAP32[i21 + 4 >> 2] & -8 | 0) == (i29 | 0)) {
    i33 = i21;
    break L191;
   } else {
    i28 = i28 << 1;
    i30 = i21;
   }
  }
  if (i34 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
  HEAP32[i34 >> 2] = i11;
  HEAP32[i11 + 24 >> 2] = i35;
  HEAP32[i11 + 12 >> 2] = i11;
  HEAP32[i11 + 8 >> 2] = i11;
  return;
 } while (0);
 i35 = i33 + 8 | 0;
 i34 = HEAP32[i35 >> 2] | 0;
 i29 = HEAP32[5817] | 0;
 if (!(i34 >>> 0 >= i29 >>> 0 & i33 >>> 0 >= i29 >>> 0)) _abort();
 HEAP32[i34 + 12 >> 2] = i11;
 HEAP32[i35 >> 2] = i11;
 HEAP32[i11 + 8 >> 2] = i34;
 HEAP32[i11 + 12 >> 2] = i33;
 HEAP32[i11 + 24 >> 2] = 0;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i9 = i8 + 132 | 0;
 i10 = i8 + 116 | 0;
 i11 = i8 + 128 | 0;
 i12 = i8 + 124 | 0;
 i13 = i8 + 120 | 0;
 i14 = i8 + 112 | 0;
 i15 = i8 + 108 | 0;
 i16 = i8 + 104 | 0;
 i17 = i8 + 100 | 0;
 i18 = i8 + 96 | 0;
 i19 = i8 + 92 | 0;
 i20 = i8 + 88 | 0;
 i21 = i8 + 84 | 0;
 i22 = i8 + 80 | 0;
 i23 = i8 + 76 | 0;
 i24 = i8 + 72 | 0;
 i25 = i8 + 68 | 0;
 i26 = i8 + 64 | 0;
 i27 = i8 + 60 | 0;
 i28 = i8 + 56 | 0;
 i29 = i8 + 52 | 0;
 i30 = i8 + 48 | 0;
 i31 = i8 + 44 | 0;
 i32 = i8 + 40 | 0;
 i33 = i8 + 36 | 0;
 i34 = i8 + 32 | 0;
 i35 = i8 + 28 | 0;
 i36 = i8 + 24 | 0;
 i37 = i8 + 20 | 0;
 i38 = i8 + 16 | 0;
 i39 = i8 + 12 | 0;
 i40 = i8 + 8 | 0;
 i41 = i8 + 4 | 0;
 i42 = i8;
 HEAP32[i5 >> 2] = 0;
 i43 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i11 >> 2] = i43;
 __THREW__ = 0;
 i44 = invoke_iii(55, i11 | 0, 26572) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i11 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i43) | 0;
  ___resumeException(i11 | 0);
 }
 __ZNSt3__114__shared_count16__release_sharedEv(i43) | 0;
 do switch (i7 << 24 >> 24 | 0) {
 case 65:
 case 97:
  {
   HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 24 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 104:
 case 66:
 case 98:
  {
   HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 16 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 99:
  {
   i43 = i1 + 8 | 0;
   i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i43 >> 2] | 0) + 12 >> 2] & 255](i43) | 0;
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
   i43 = HEAP8[i11 >> 0] | 0;
   i46 = (i43 & 1) == 0;
   i47 = i11 + 4 | 0;
   i48 = i46 ? i47 : HEAP32[i11 + 8 >> 2] | 0;
   i11 = i48 + ((i46 ? (i43 & 255) >>> 1 : HEAP32[i47 >> 2] | 0) << 2) | 0;
   HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
   i47 = __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i10, i9, i4, i5, i6, i48, i11) | 0;
   HEAP32[i2 >> 2] = i47;
   i45 = 28;
   break;
  }
 case 101:
 case 100:
  {
   HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 12 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 68:
  {
   HEAP32[i17 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i18 >> 2];
   i47 = __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i10, i9, i4, i5, i6, 27180, 27212) | 0;
   HEAP32[i2 >> 2] = i47;
   i45 = 28;
   break;
  }
 case 70:
  {
   HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i20 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i20 >> 2];
   i47 = __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i10, i9, i4, i5, i6, 27212, 27244) | 0;
   HEAP32[i2 >> 2] = i47;
   i45 = 28;
   break;
  }
 case 72:
  {
   HEAP32[i21 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i21 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 8 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 73:
  {
   HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i22 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 8 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 106:
  {
   HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i23 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 28 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 109:
  {
   HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i24 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 16 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 77:
  {
   HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i25 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 4 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 116:
 case 110:
  {
   HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i26 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 112:
  {
   HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i27 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 8 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 114:
  {
   HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i29 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i29 >> 2];
   i47 = __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i10, i9, i4, i5, i6, 27244, 27288) | 0;
   HEAP32[i2 >> 2] = i47;
   i45 = 28;
   break;
  }
 case 82:
  {
   HEAP32[i30 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i31 >> 2];
   i47 = __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i10, i9, i4, i5, i6, 27288, 27308) | 0;
   HEAP32[i2 >> 2] = i47;
   i45 = 28;
   break;
  }
 case 83:
  {
   HEAP32[i32 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i32 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 84:
  {
   HEAP32[i33 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i34 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i34 >> 2];
   i47 = __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i10, i9, i4, i5, i6, 27308, 27340) | 0;
   HEAP32[i2 >> 2] = i47;
   i45 = 28;
   break;
  }
 case 119:
  {
   HEAP32[i35 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i35 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 24 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 120:
  {
   i47 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i36 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i37 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i37 >> 2];
   i49 = FUNCTION_TABLE_iiiiiii[i47 & 63](i1, i10, i9, i4, i5, i6) | 0;
   break;
  }
 case 88:
  {
   i47 = i1 + 8 | 0;
   i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i47 >> 2] | 0) + 24 >> 2] & 255](i47) | 0;
   HEAP32[i38 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i39 >> 2] = HEAP32[i3 >> 2];
   i47 = HEAP8[i11 >> 0] | 0;
   i48 = (i47 & 1) == 0;
   i43 = i11 + 4 | 0;
   i46 = i48 ? i43 : HEAP32[i11 + 8 >> 2] | 0;
   i11 = i46 + ((i48 ? (i47 & 255) >>> 1 : HEAP32[i43 >> 2] | 0) << 2) | 0;
   HEAP32[i10 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i39 >> 2];
   i43 = __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i10, i9, i4, i5, i6, i46, i11) | 0;
   HEAP32[i2 >> 2] = i43;
   i45 = 28;
   break;
  }
 case 121:
  {
   HEAP32[i40 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i40 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 20 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 89:
  {
   HEAP32[i41 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i41 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 20 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 37:
  {
   HEAP32[i42 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i42 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 default:
  {
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 4;
   i45 = 28;
  }
 } while (0);
 if ((i45 | 0) == 28) i49 = HEAP32[i2 >> 2] | 0;
 STACKTOP = i8;
 return i49 | 0;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i9 = i8 + 132 | 0;
 i10 = i8 + 116 | 0;
 i11 = i8 + 128 | 0;
 i12 = i8 + 124 | 0;
 i13 = i8 + 120 | 0;
 i14 = i8 + 112 | 0;
 i15 = i8 + 108 | 0;
 i16 = i8 + 104 | 0;
 i17 = i8 + 100 | 0;
 i18 = i8 + 96 | 0;
 i19 = i8 + 92 | 0;
 i20 = i8 + 88 | 0;
 i21 = i8 + 84 | 0;
 i22 = i8 + 80 | 0;
 i23 = i8 + 76 | 0;
 i24 = i8 + 72 | 0;
 i25 = i8 + 68 | 0;
 i26 = i8 + 64 | 0;
 i27 = i8 + 60 | 0;
 i28 = i8 + 56 | 0;
 i29 = i8 + 52 | 0;
 i30 = i8 + 48 | 0;
 i31 = i8 + 44 | 0;
 i32 = i8 + 40 | 0;
 i33 = i8 + 36 | 0;
 i34 = i8 + 32 | 0;
 i35 = i8 + 28 | 0;
 i36 = i8 + 24 | 0;
 i37 = i8 + 20 | 0;
 i38 = i8 + 16 | 0;
 i39 = i8 + 12 | 0;
 i40 = i8 + 8 | 0;
 i41 = i8 + 4 | 0;
 i42 = i8;
 HEAP32[i5 >> 2] = 0;
 i43 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i11 >> 2] = i43;
 __THREW__ = 0;
 i44 = invoke_iii(55, i11 | 0, 26580) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i11 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i43) | 0;
  ___resumeException(i11 | 0);
 }
 __ZNSt3__114__shared_count16__release_sharedEv(i43) | 0;
 do switch (i7 << 24 >> 24 | 0) {
 case 65:
 case 97:
  {
   HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 24 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 104:
 case 66:
 case 98:
  {
   HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 16 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 99:
  {
   i43 = i1 + 8 | 0;
   i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i43 >> 2] | 0) + 12 >> 2] & 255](i43) | 0;
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
   i43 = HEAP8[i11 >> 0] | 0;
   i46 = (i43 & 1) == 0;
   i47 = i46 ? i11 + 1 | 0 : HEAP32[i11 + 8 >> 2] | 0;
   i48 = i47 + (i46 ? (i43 & 255) >>> 1 : HEAP32[i11 + 4 >> 2] | 0) | 0;
   HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
   i11 = __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i10, i9, i4, i5, i6, i47, i48) | 0;
   HEAP32[i2 >> 2] = i11;
   i45 = 28;
   break;
  }
 case 101:
 case 100:
  {
   HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 12 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 68:
  {
   HEAP32[i17 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i18 >> 2];
   i11 = __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i10, i9, i4, i5, i6, 47578, 47586) | 0;
   HEAP32[i2 >> 2] = i11;
   i45 = 28;
   break;
  }
 case 70:
  {
   HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i20 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i20 >> 2];
   i11 = __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i10, i9, i4, i5, i6, 47586, 47594) | 0;
   HEAP32[i2 >> 2] = i11;
   i45 = 28;
   break;
  }
 case 72:
  {
   HEAP32[i21 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i21 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 8 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 73:
  {
   HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i22 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 8 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 106:
  {
   HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i23 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 28 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 109:
  {
   HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i24 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 16 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 77:
  {
   HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i25 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 4 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 116:
 case 110:
  {
   HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i26 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 112:
  {
   HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i27 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 8 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 114:
  {
   HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i29 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i29 >> 2];
   i11 = __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i10, i9, i4, i5, i6, 47594, 47605) | 0;
   HEAP32[i2 >> 2] = i11;
   i45 = 28;
   break;
  }
 case 82:
  {
   HEAP32[i30 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i31 >> 2];
   i11 = __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i10, i9, i4, i5, i6, 47605, 47610) | 0;
   HEAP32[i2 >> 2] = i11;
   i45 = 28;
   break;
  }
 case 83:
  {
   HEAP32[i32 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i32 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 84:
  {
   HEAP32[i33 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i34 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i34 >> 2];
   i11 = __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i10, i9, i4, i5, i6, 47610, 47618) | 0;
   HEAP32[i2 >> 2] = i11;
   i45 = 28;
   break;
  }
 case 119:
  {
   HEAP32[i35 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i35 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 24 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 120:
  {
   i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i36 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i37 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i37 >> 2];
   i49 = FUNCTION_TABLE_iiiiiii[i11 & 63](i1, i10, i9, i4, i5, i6) | 0;
   break;
  }
 case 88:
  {
   i11 = i1 + 8 | 0;
   i48 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] & 255](i11) | 0;
   HEAP32[i38 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i39 >> 2] = HEAP32[i3 >> 2];
   i11 = HEAP8[i48 >> 0] | 0;
   i47 = (i11 & 1) == 0;
   i43 = i47 ? i48 + 1 | 0 : HEAP32[i48 + 8 >> 2] | 0;
   i46 = i43 + (i47 ? (i11 & 255) >>> 1 : HEAP32[i48 + 4 >> 2] | 0) | 0;
   HEAP32[i10 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i39 >> 2];
   i48 = __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i10, i9, i4, i5, i6, i43, i46) | 0;
   HEAP32[i2 >> 2] = i48;
   i45 = 28;
   break;
  }
 case 121:
  {
   HEAP32[i40 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i40 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 20 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 89:
  {
   HEAP32[i41 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i41 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 20 | 0, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 case 37:
  {
   HEAP32[i42 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i42 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i9, i5, i44);
   i45 = 28;
   break;
  }
 default:
  {
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 4;
   i45 = 28;
  }
 } while (0);
 if ((i45 | 0) == 28) i49 = HEAP32[i2 >> 2] | 0;
 STACKTOP = i8;
 return i49 | 0;
}

function __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i12 = i11 + 108 | 0;
 i13 = i11 + 96 | 0;
 i14 = i11 + 92 | 0;
 i15 = i11 + 80 | 0;
 i16 = i11 + 68 | 0;
 i17 = i11 + 56 | 0;
 i18 = i11 + 52 | 0;
 i19 = i11 + 40 | 0;
 i20 = i11 + 36 | 0;
 i21 = i11 + 24 | 0;
 i22 = i11 + 12 | 0;
 i23 = i11;
 do if (i1) {
  i24 = __ZNKSt3__16locale9use_facetERNS0_2idE(i3, 26188) | 0;
  i25 = HEAP32[i24 >> 2] | 0;
  do if (i2) {
   FUNCTION_TABLE_vii[HEAP32[i25 + 44 >> 2] & 127](i12, i24);
   i26 = HEAP32[i12 >> 2] | 0;
   HEAP8[i4 >> 0] = i26;
   HEAP8[i4 + 1 >> 0] = i26 >> 8;
   HEAP8[i4 + 2 >> 0] = i26 >> 16;
   HEAP8[i4 + 3 >> 0] = i26 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i24 >> 2] | 0) + 32 >> 2] & 127](i13, i24);
   if (!(HEAP8[i9 >> 0] & 1)) {
    HEAP8[i9 + 1 >> 0] = 0;
    HEAP8[i9 >> 0] = 0;
   } else {
    HEAP8[HEAP32[i9 + 8 >> 2] >> 0] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
   }
   __THREW__ = 0;
   invoke_vii(69, i9 | 0, 0);
   i26 = __THREW__;
   __THREW__ = 0;
   if (i26 & 1) {
    i26 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i26);
   } else {
    HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = 0;
    HEAP32[i13 + 8 >> 2] = 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    i27 = i24;
    break;
   }
  } else {
   FUNCTION_TABLE_vii[HEAP32[i25 + 40 >> 2] & 127](i14, i24);
   i26 = HEAP32[i14 >> 2] | 0;
   HEAP8[i4 >> 0] = i26;
   HEAP8[i4 + 1 >> 0] = i26 >> 8;
   HEAP8[i4 + 2 >> 0] = i26 >> 16;
   HEAP8[i4 + 3 >> 0] = i26 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i24 >> 2] | 0) + 28 >> 2] & 127](i15, i24);
   if (!(HEAP8[i9 >> 0] & 1)) {
    HEAP8[i9 + 1 >> 0] = 0;
    HEAP8[i9 >> 0] = 0;
   } else {
    HEAP8[HEAP32[i9 + 8 >> 2] >> 0] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
   }
   __THREW__ = 0;
   invoke_vii(69, i9 | 0, 0);
   i26 = __THREW__;
   __THREW__ = 0;
   if (i26 & 1) {
    i26 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i26);
   } else {
    HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i15 + 8 >> 2] = 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
    i27 = i24;
    break;
   }
  } while (0);
  i25 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] & 255](i24) | 0;
  HEAP8[i5 >> 0] = i25;
  i25 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i24 >> 2] | 0) + 16 >> 2] & 255](i24) | 0;
  HEAP8[i6 >> 0] = i25;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i27 >> 2] | 0) + 20 >> 2] & 127](i16, i24);
  if (!(HEAP8[i7 >> 0] & 1)) {
   HEAP8[i7 + 1 >> 0] = 0;
   HEAP8[i7 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i7 + 8 >> 2] >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i7 | 0, 0);
  i25 = __THREW__;
  __THREW__ = 0;
  if (i25 & 1) {
   i25 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i25);
  };
  HEAP32[i7 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i27 >> 2] | 0) + 24 >> 2] & 127](i17, i24);
  if (!(HEAP8[i8 >> 0] & 1)) {
   HEAP8[i8 + 1 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i8 + 8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i8 | 0, 0);
  i25 = __THREW__;
  __THREW__ = 0;
  if (i25 & 1) {
   i25 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i25);
  } else {
   HEAP32[i8 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i17 >> 2] = 0;
   HEAP32[i17 + 4 >> 2] = 0;
   HEAP32[i17 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   i28 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] & 255](i24) | 0;
   break;
  }
 } else {
  i25 = __ZNKSt3__16locale9use_facetERNS0_2idE(i3, 26124) | 0;
  i26 = HEAP32[i25 >> 2] | 0;
  do if (i2) {
   FUNCTION_TABLE_vii[HEAP32[i26 + 44 >> 2] & 127](i18, i25);
   i29 = HEAP32[i18 >> 2] | 0;
   HEAP8[i4 >> 0] = i29;
   HEAP8[i4 + 1 >> 0] = i29 >> 8;
   HEAP8[i4 + 2 >> 0] = i29 >> 16;
   HEAP8[i4 + 3 >> 0] = i29 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i25 >> 2] | 0) + 32 >> 2] & 127](i19, i25);
   if (!(HEAP8[i9 >> 0] & 1)) {
    HEAP8[i9 + 1 >> 0] = 0;
    HEAP8[i9 >> 0] = 0;
   } else {
    HEAP8[HEAP32[i9 + 8 >> 2] >> 0] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
   }
   __THREW__ = 0;
   invoke_vii(69, i9 | 0, 0);
   i29 = __THREW__;
   __THREW__ = 0;
   if (i29 & 1) {
    i29 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i29);
   } else {
    HEAP32[i9 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i19 >> 2] = 0;
    HEAP32[i19 + 4 >> 2] = 0;
    HEAP32[i19 + 8 >> 2] = 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
    i30 = i25;
    break;
   }
  } else {
   FUNCTION_TABLE_vii[HEAP32[i26 + 40 >> 2] & 127](i20, i25);
   i29 = HEAP32[i20 >> 2] | 0;
   HEAP8[i4 >> 0] = i29;
   HEAP8[i4 + 1 >> 0] = i29 >> 8;
   HEAP8[i4 + 2 >> 0] = i29 >> 16;
   HEAP8[i4 + 3 >> 0] = i29 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i25 >> 2] | 0) + 28 >> 2] & 127](i21, i25);
   if (!(HEAP8[i9 >> 0] & 1)) {
    HEAP8[i9 + 1 >> 0] = 0;
    HEAP8[i9 >> 0] = 0;
   } else {
    HEAP8[HEAP32[i9 + 8 >> 2] >> 0] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
   }
   __THREW__ = 0;
   invoke_vii(69, i9 | 0, 0);
   i29 = __THREW__;
   __THREW__ = 0;
   if (i29 & 1) {
    i29 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i29);
   } else {
    HEAP32[i9 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i21 >> 2] = 0;
    HEAP32[i21 + 4 >> 2] = 0;
    HEAP32[i21 + 8 >> 2] = 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
    i30 = i25;
    break;
   }
  } while (0);
  i26 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] & 255](i25) | 0;
  HEAP8[i5 >> 0] = i26;
  i26 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 16 >> 2] & 255](i25) | 0;
  HEAP8[i6 >> 0] = i26;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i30 >> 2] | 0) + 20 >> 2] & 127](i22, i25);
  if (!(HEAP8[i7 >> 0] & 1)) {
   HEAP8[i7 + 1 >> 0] = 0;
   HEAP8[i7 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i7 + 8 >> 2] >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i7 | 0, 0);
  i26 = __THREW__;
  __THREW__ = 0;
  if (i26 & 1) {
   i26 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i26);
  };
  HEAP32[i7 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i30 >> 2] | 0) + 24 >> 2] & 127](i23, i25);
  if (!(HEAP8[i8 >> 0] & 1)) {
   HEAP8[i8 + 1 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i8 + 8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i8 | 0, 0);
  i26 = __THREW__;
  __THREW__ = 0;
  if (i26 & 1) {
   i26 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i26);
  } else {
   HEAP32[i8 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   HEAP32[i23 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
   i28 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] & 255](i25) | 0;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i28;
 STACKTOP = i11;
 return;
}

function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i9 = i8;
 i10 = (i4 - i3 | 0) / 12 | 0;
 do if (i10 >>> 0 > 100) {
  i11 = _malloc(i10) | 0;
  if ((i11 | 0) == 0 ? (__THREW__ = 0, invoke_v(5), i12 = __THREW__, __THREW__ = 0, i12 & 1) : 0) {
   i13 = 0;
   i14 = 6;
   break;
  }
  i15 = i11;
  i16 = i11;
  i14 = 11;
 } else {
  i15 = 0;
  i16 = i9;
  i14 = 11;
 } while (0);
 L6 : do if ((i14 | 0) == 11) {
  if ((i3 | 0) == (i4 | 0)) {
   i17 = 0;
   i18 = i10;
  } else {
   i9 = i3;
   i11 = 0;
   i12 = i10;
   i19 = i16;
   while (1) {
    i20 = HEAP8[i9 >> 0] | 0;
    if (!(i20 & 1)) i21 = (i20 & 255) >>> 1; else i21 = HEAP32[i9 + 4 >> 2] | 0;
    if (!i21) {
     HEAP8[i19 >> 0] = 2;
     i22 = i11 + 1 | 0;
     i23 = i12 + -1 | 0;
    } else {
     HEAP8[i19 >> 0] = 1;
     i22 = i11;
     i23 = i12;
    }
    i9 = i9 + 12 | 0;
    if ((i9 | 0) == (i4 | 0)) {
     i17 = i22;
     i18 = i23;
     break;
    } else {
     i11 = i22;
     i12 = i23;
     i19 = i19 + 1 | 0;
    }
   }
  }
  i19 = (i3 | 0) == (i4 | 0);
  i12 = (i3 | 0) == (i4 | 0);
  i11 = 0;
  i9 = i17;
  i20 = i18;
  L20 : while (1) {
   i24 = HEAP32[i1 >> 2] | 0;
   do if (i24) {
    i25 = HEAP32[i24 + 12 >> 2] | 0;
    if ((i25 | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i26 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i14 = 5;
      break L20;
     } else i28 = i26;
    } else i28 = HEAP32[i25 >> 2] | 0;
    if ((i28 | 0) == -1) {
     HEAP32[i1 >> 2] = 0;
     i29 = 1;
     break;
    } else {
     i29 = (HEAP32[i1 >> 2] | 0) == 0;
     break;
    }
   } else i29 = 1; while (0);
   i24 = HEAP32[i2 >> 2] | 0;
   if (i24) {
    i25 = HEAP32[i24 + 12 >> 2] | 0;
    if ((i25 | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i26 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i14 = 5;
      break;
     } else i30 = i26;
    } else i30 = HEAP32[i25 >> 2] | 0;
    if ((i30 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i31 = 0;
     i32 = 1;
    } else {
     i31 = i24;
     i32 = 0;
    }
   } else {
    i31 = 0;
    i32 = 1;
   }
   i24 = HEAP32[i1 >> 2] | 0;
   if (!((i20 | 0) != 0 & (i29 ^ i32))) {
    i33 = i24;
    i34 = i31;
    i14 = 66;
    break;
   }
   i25 = HEAP32[i24 + 12 >> 2] | 0;
   if ((i25 | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i26 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
    i24 = __THREW__;
    __THREW__ = 0;
    if (i24 & 1) {
     i14 = 5;
     break;
    } else i35 = i26;
   } else i35 = HEAP32[i25 >> 2] | 0;
   if (!i7) {
    __THREW__ = 0;
    i25 = invoke_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i35 | 0) | 0;
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i14 = 5;
     break;
    } else i36 = i25;
   } else i36 = i35;
   i25 = i11 + 1 | 0;
   if (i19) {
    i37 = 0;
    i38 = i9;
    i39 = i20;
   } else {
    i26 = 0;
    i24 = i3;
    i27 = i9;
    i40 = i20;
    i41 = i16;
    while (1) {
     do if ((HEAP8[i41 >> 0] | 0) == 1) {
      if (!(HEAP8[i24 >> 0] & 1)) i42 = i24 + 4 | 0; else i42 = HEAP32[i24 + 8 >> 2] | 0;
      i43 = HEAP32[i42 + (i11 << 2) >> 2] | 0;
      if (!i7) {
       __THREW__ = 0;
       i44 = invoke_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i43 | 0) | 0;
       i45 = __THREW__;
       __THREW__ = 0;
       if (i45 & 1) {
        i14 = 4;
        break L20;
       } else i46 = i44;
      } else i46 = i43;
      if ((i36 | 0) != (i46 | 0)) {
       HEAP8[i41 >> 0] = 0;
       i47 = i26;
       i48 = i27;
       i49 = i40 + -1 | 0;
       break;
      }
      i43 = HEAP8[i24 >> 0] | 0;
      if (!(i43 & 1)) i50 = (i43 & 255) >>> 1; else i50 = HEAP32[i24 + 4 >> 2] | 0;
      if ((i50 | 0) == (i25 | 0)) {
       HEAP8[i41 >> 0] = 2;
       i47 = 1;
       i48 = i27 + 1 | 0;
       i49 = i40 + -1 | 0;
      } else {
       i47 = 1;
       i48 = i27;
       i49 = i40;
      }
     } else {
      i47 = i26;
      i48 = i27;
      i49 = i40;
     } while (0);
     i24 = i24 + 12 | 0;
     if ((i24 | 0) == (i4 | 0)) {
      i37 = i47;
      i38 = i48;
      i39 = i49;
      break;
     } else {
      i26 = i47;
      i27 = i48;
      i40 = i49;
      i41 = i41 + 1 | 0;
     }
    }
   }
   if (!i37) {
    i11 = i25;
    i9 = i38;
    i20 = i39;
    continue;
   }
   i41 = HEAP32[i1 >> 2] | 0;
   i40 = i41 + 12 | 0;
   i27 = HEAP32[i40 >> 2] | 0;
   if ((i27 | 0) == (HEAP32[i41 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i41 >> 2] | 0) + 40 >> 2] | 0, i41 | 0) | 0;
    i41 = __THREW__;
    __THREW__ = 0;
    if (i41 & 1) {
     i14 = 5;
     break;
    }
   } else HEAP32[i40 >> 2] = i27 + 4;
   if ((i38 + i39 | 0) >>> 0 < 2 | i12) {
    i11 = i25;
    i9 = i38;
    i20 = i39;
    continue;
   } else {
    i51 = i3;
    i52 = i38;
    i53 = i16;
   }
   while (1) {
    if ((HEAP8[i53 >> 0] | 0) == 2) {
     i27 = HEAP8[i51 >> 0] | 0;
     if (!(i27 & 1)) i54 = (i27 & 255) >>> 1; else i54 = HEAP32[i51 + 4 >> 2] | 0;
     if ((i54 | 0) != (i25 | 0)) {
      HEAP8[i53 >> 0] = 0;
      i55 = i52 + -1 | 0;
     } else i55 = i52;
    } else i55 = i52;
    i27 = i51 + 12 | 0;
    if ((i27 | 0) == (i4 | 0)) {
     i11 = i25;
     i9 = i55;
     i20 = i39;
     continue L20;
    } else {
     i51 = i27;
     i52 = i55;
     i53 = i53 + 1 | 0;
    }
   }
  }
  if ((i14 | 0) == 4) {
   i20 = ___cxa_find_matching_catch() | 0;
   i56 = i15;
   i57 = i20;
   i58 = tempRet0;
   break;
  } else if ((i14 | 0) == 5) {
   i20 = ___cxa_find_matching_catch() | 0;
   i56 = i15;
   i57 = i20;
   i58 = tempRet0;
   break;
  } else if ((i14 | 0) == 66) {
   do if (i33) {
    i20 = HEAP32[i33 + 12 >> 2] | 0;
    if ((i20 | 0) == (HEAP32[i33 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i9 = invoke_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 36 >> 2] | 0, i33 | 0) | 0;
     i11 = __THREW__;
     __THREW__ = 0;
     if (i11 & 1) {
      i13 = i15;
      i14 = 6;
      break L6;
     } else i59 = i9;
    } else i59 = HEAP32[i20 >> 2] | 0;
    if ((i59 | 0) == -1) {
     HEAP32[i1 >> 2] = 0;
     i60 = 1;
     break;
    } else {
     i60 = (HEAP32[i1 >> 2] | 0) == 0;
     break;
    }
   } else i60 = 1; while (0);
   do if (i34) {
    i20 = HEAP32[i34 + 12 >> 2] | 0;
    if ((i20 | 0) == (HEAP32[i34 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i9 = invoke_ii(HEAP32[(HEAP32[i34 >> 2] | 0) + 36 >> 2] | 0, i34 | 0) | 0;
     i11 = __THREW__;
     __THREW__ = 0;
     if (i11 & 1) {
      i13 = i15;
      i14 = 6;
      break L6;
     } else i61 = i9;
    } else i61 = HEAP32[i20 >> 2] | 0;
    if ((i61 | 0) != -1) if (i60) break; else {
     i14 = 81;
     break;
    } else {
     HEAP32[i2 >> 2] = 0;
     i14 = 79;
     break;
    }
   } else i14 = 79; while (0);
   if ((i14 | 0) == 79 ? i60 : 0) i14 = 81;
   if ((i14 | 0) == 81) HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2;
   L113 : do if ((i3 | 0) == (i4 | 0)) i14 = 85; else {
    i20 = i3;
    i9 = i16;
    while (1) {
     if ((HEAP8[i9 >> 0] | 0) == 2) {
      i62 = i20;
      break L113;
     }
     i20 = i20 + 12 | 0;
     if ((i20 | 0) == (i4 | 0)) {
      i14 = 85;
      break;
     } else i9 = i9 + 1 | 0;
    }
   } while (0);
   if ((i14 | 0) == 85) {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i62 = i4;
   }
   if (i15) _free(i15);
   STACKTOP = i8;
   return i62 | 0;
  }
 } while (0);
 if ((i14 | 0) == 6) {
  i14 = ___cxa_find_matching_catch() | 0;
  i56 = i13;
  i57 = i14;
  i58 = tempRet0;
 }
 if (i56) _free(i56);
 ___resumeException(i57 | 0);
 return 0;
}

function __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i12 = i11 + 108 | 0;
 i13 = i11 + 96 | 0;
 i14 = i11 + 92 | 0;
 i15 = i11 + 80 | 0;
 i16 = i11 + 68 | 0;
 i17 = i11 + 56 | 0;
 i18 = i11 + 52 | 0;
 i19 = i11 + 40 | 0;
 i20 = i11 + 36 | 0;
 i21 = i11 + 24 | 0;
 i22 = i11 + 12 | 0;
 i23 = i11;
 do if (i1) {
  i24 = __ZNKSt3__16locale9use_facetERNS0_2idE(i3, 26316) | 0;
  i25 = HEAP32[i24 >> 2] | 0;
  do if (i2) {
   FUNCTION_TABLE_vii[HEAP32[i25 + 44 >> 2] & 127](i12, i24);
   i26 = HEAP32[i12 >> 2] | 0;
   HEAP8[i4 >> 0] = i26;
   HEAP8[i4 + 1 >> 0] = i26 >> 8;
   HEAP8[i4 + 2 >> 0] = i26 >> 16;
   HEAP8[i4 + 3 >> 0] = i26 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i24 >> 2] | 0) + 32 >> 2] & 127](i13, i24);
   if (!(HEAP8[i9 >> 0] & 1)) HEAP8[i9 >> 0] = 0; else HEAP32[HEAP32[i9 + 8 >> 2] >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   __THREW__ = 0;
   invoke_vii(71, i9 | 0, 0);
   i26 = __THREW__;
   __THREW__ = 0;
   if (i26 & 1) {
    i26 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i26);
   } else {
    HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = 0;
    HEAP32[i13 + 8 >> 2] = 0;
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i13);
    break;
   }
  } else {
   FUNCTION_TABLE_vii[HEAP32[i25 + 40 >> 2] & 127](i14, i24);
   i26 = HEAP32[i14 >> 2] | 0;
   HEAP8[i4 >> 0] = i26;
   HEAP8[i4 + 1 >> 0] = i26 >> 8;
   HEAP8[i4 + 2 >> 0] = i26 >> 16;
   HEAP8[i4 + 3 >> 0] = i26 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i24 >> 2] | 0) + 28 >> 2] & 127](i15, i24);
   if (!(HEAP8[i9 >> 0] & 1)) HEAP8[i9 >> 0] = 0; else HEAP32[HEAP32[i9 + 8 >> 2] >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   __THREW__ = 0;
   invoke_vii(71, i9 | 0, 0);
   i26 = __THREW__;
   __THREW__ = 0;
   if (i26 & 1) {
    i26 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i26);
   } else {
    HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i15 + 8 >> 2] = 0;
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i15);
    break;
   }
  } while (0);
  i25 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] & 255](i24) | 0;
  HEAP32[i5 >> 2] = i25;
  i25 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i24 >> 2] | 0) + 16 >> 2] & 255](i24) | 0;
  HEAP32[i6 >> 2] = i25;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i24 >> 2] | 0) + 20 >> 2] & 127](i16, i24);
  if (!(HEAP8[i7 >> 0] & 1)) {
   HEAP8[i7 + 1 >> 0] = 0;
   HEAP8[i7 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i7 + 8 >> 2] >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i7 | 0, 0);
  i25 = __THREW__;
  __THREW__ = 0;
  if (i25 & 1) {
   i25 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i25);
  };
  HEAP32[i7 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i24 >> 2] | 0) + 24 >> 2] & 127](i17, i24);
  if (!(HEAP8[i8 >> 0] & 1)) HEAP8[i8 >> 0] = 0; else HEAP32[HEAP32[i8 + 8 >> 2] >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  __THREW__ = 0;
  invoke_vii(71, i8 | 0, 0);
  i25 = __THREW__;
  __THREW__ = 0;
  if (i25 & 1) {
   i25 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i25);
  } else {
   HEAP32[i8 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i17 >> 2] = 0;
   HEAP32[i17 + 4 >> 2] = 0;
   HEAP32[i17 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i17);
   i27 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] & 255](i24) | 0;
   break;
  }
 } else {
  i25 = __ZNKSt3__16locale9use_facetERNS0_2idE(i3, 26252) | 0;
  i26 = HEAP32[i25 >> 2] | 0;
  do if (i2) {
   FUNCTION_TABLE_vii[HEAP32[i26 + 44 >> 2] & 127](i18, i25);
   i28 = HEAP32[i18 >> 2] | 0;
   HEAP8[i4 >> 0] = i28;
   HEAP8[i4 + 1 >> 0] = i28 >> 8;
   HEAP8[i4 + 2 >> 0] = i28 >> 16;
   HEAP8[i4 + 3 >> 0] = i28 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i25 >> 2] | 0) + 32 >> 2] & 127](i19, i25);
   if (!(HEAP8[i9 >> 0] & 1)) HEAP8[i9 >> 0] = 0; else HEAP32[HEAP32[i9 + 8 >> 2] >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   __THREW__ = 0;
   invoke_vii(71, i9 | 0, 0);
   i28 = __THREW__;
   __THREW__ = 0;
   if (i28 & 1) {
    i28 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i28);
   } else {
    HEAP32[i9 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i19 >> 2] = 0;
    HEAP32[i19 + 4 >> 2] = 0;
    HEAP32[i19 + 8 >> 2] = 0;
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i19);
    break;
   }
  } else {
   FUNCTION_TABLE_vii[HEAP32[i26 + 40 >> 2] & 127](i20, i25);
   i28 = HEAP32[i20 >> 2] | 0;
   HEAP8[i4 >> 0] = i28;
   HEAP8[i4 + 1 >> 0] = i28 >> 8;
   HEAP8[i4 + 2 >> 0] = i28 >> 16;
   HEAP8[i4 + 3 >> 0] = i28 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i25 >> 2] | 0) + 28 >> 2] & 127](i21, i25);
   if (!(HEAP8[i9 >> 0] & 1)) HEAP8[i9 >> 0] = 0; else HEAP32[HEAP32[i9 + 8 >> 2] >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   __THREW__ = 0;
   invoke_vii(71, i9 | 0, 0);
   i28 = __THREW__;
   __THREW__ = 0;
   if (i28 & 1) {
    i28 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i28);
   } else {
    HEAP32[i9 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i21 >> 2] = 0;
    HEAP32[i21 + 4 >> 2] = 0;
    HEAP32[i21 + 8 >> 2] = 0;
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i21);
    break;
   }
  } while (0);
  i26 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] & 255](i25) | 0;
  HEAP32[i5 >> 2] = i26;
  i26 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 16 >> 2] & 255](i25) | 0;
  HEAP32[i6 >> 2] = i26;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i25 >> 2] | 0) + 20 >> 2] & 127](i22, i25);
  if (!(HEAP8[i7 >> 0] & 1)) {
   HEAP8[i7 + 1 >> 0] = 0;
   HEAP8[i7 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i7 + 8 >> 2] >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i7 | 0, 0);
  i26 = __THREW__;
  __THREW__ = 0;
  if (i26 & 1) {
   i26 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i26);
  };
  HEAP32[i7 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i25 >> 2] | 0) + 24 >> 2] & 127](i23, i25);
  if (!(HEAP8[i8 >> 0] & 1)) HEAP8[i8 >> 0] = 0; else HEAP32[HEAP32[i8 + 8 >> 2] >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  __THREW__ = 0;
  invoke_vii(71, i8 | 0, 0);
  i26 = __THREW__;
  __THREW__ = 0;
  if (i26 & 1) {
   i26 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i26);
  } else {
   HEAP32[i8 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   HEAP32[i23 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i23);
   i27 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] & 255](i25) | 0;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i27;
 STACKTOP = i11;
 return;
}

function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i9 = i8;
 i10 = (i4 - i3 | 0) / 12 | 0;
 do if (i10 >>> 0 > 100) {
  i11 = _malloc(i10) | 0;
  if ((i11 | 0) == 0 ? (__THREW__ = 0, invoke_v(5), i12 = __THREW__, __THREW__ = 0, i12 & 1) : 0) {
   i13 = 0;
   i14 = 6;
   break;
  }
  i15 = i11;
  i16 = i11;
  i14 = 11;
 } else {
  i15 = 0;
  i16 = i9;
  i14 = 11;
 } while (0);
 L6 : do if ((i14 | 0) == 11) {
  if ((i3 | 0) == (i4 | 0)) {
   i17 = 0;
   i18 = i10;
  } else {
   i9 = i3;
   i11 = 0;
   i12 = i10;
   i19 = i16;
   while (1) {
    i20 = HEAP8[i9 >> 0] | 0;
    if (!(i20 & 1)) i21 = (i20 & 255) >>> 1; else i21 = HEAP32[i9 + 4 >> 2] | 0;
    if (!i21) {
     HEAP8[i19 >> 0] = 2;
     i22 = i11 + 1 | 0;
     i23 = i12 + -1 | 0;
    } else {
     HEAP8[i19 >> 0] = 1;
     i22 = i11;
     i23 = i12;
    }
    i9 = i9 + 12 | 0;
    if ((i9 | 0) == (i4 | 0)) {
     i17 = i22;
     i18 = i23;
     break;
    } else {
     i11 = i22;
     i12 = i23;
     i19 = i19 + 1 | 0;
    }
   }
  }
  i19 = (i3 | 0) == (i4 | 0);
  i12 = (i3 | 0) == (i4 | 0);
  i11 = 0;
  i9 = i17;
  i20 = i18;
  L20 : while (1) {
   i24 = HEAP32[i1 >> 2] | 0;
   do if (i24) if ((HEAP32[i24 + 12 >> 2] | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i25 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i14 = 5;
     break L20;
    }
    if ((i25 | 0) == -1) {
     HEAP32[i1 >> 2] = 0;
     i27 = 0;
     break;
    } else {
     i27 = HEAP32[i1 >> 2] | 0;
     break;
    }
   } else i27 = i24; else i27 = 0; while (0);
   i24 = (i27 | 0) == 0;
   i25 = HEAP32[i2 >> 2] | 0;
   if (i25) if ((HEAP32[i25 + 12 >> 2] | 0) == (HEAP32[i25 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i26 = invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i14 = 5;
     break;
    }
    if ((i26 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i29 = 0;
    } else i29 = i25;
   } else i29 = i25; else i29 = 0;
   i25 = (i29 | 0) == 0;
   i26 = HEAP32[i1 >> 2] | 0;
   if (!((i20 | 0) != 0 & (i24 ^ i25))) {
    i30 = i25;
    i31 = i26;
    i32 = i29;
    i14 = 64;
    break;
   }
   i25 = HEAP32[i26 + 12 >> 2] | 0;
   if ((i25 | 0) == (HEAP32[i26 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i24 = invoke_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 36 >> 2] | 0, i26 | 0) | 0;
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i14 = 5;
     break;
    } else i33 = i24;
   } else i33 = HEAPU8[i25 >> 0] | 0;
   i25 = i33 & 255;
   if (!i7) {
    __THREW__ = 0;
    i24 = invoke_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i25 | 0) | 0;
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i14 = 5;
     break;
    } else i34 = i24;
   } else i34 = i25;
   i25 = i11 + 1 | 0;
   if (i19) {
    i35 = 0;
    i36 = i9;
    i37 = i20;
   } else {
    i24 = 0;
    i26 = i3;
    i28 = i9;
    i38 = i20;
    i39 = i16;
    while (1) {
     do if ((HEAP8[i39 >> 0] | 0) == 1) {
      if (!(HEAP8[i26 >> 0] & 1)) i40 = i26 + 1 | 0; else i40 = HEAP32[i26 + 8 >> 2] | 0;
      i41 = HEAP8[i40 + i11 >> 0] | 0;
      if (!i7) {
       __THREW__ = 0;
       i42 = invoke_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i41 | 0) | 0;
       i43 = __THREW__;
       __THREW__ = 0;
       if (i43 & 1) {
        i14 = 4;
        break L20;
       } else i44 = i42;
      } else i44 = i41;
      if (i34 << 24 >> 24 != i44 << 24 >> 24) {
       HEAP8[i39 >> 0] = 0;
       i45 = i24;
       i46 = i28;
       i47 = i38 + -1 | 0;
       break;
      }
      i41 = HEAP8[i26 >> 0] | 0;
      if (!(i41 & 1)) i48 = (i41 & 255) >>> 1; else i48 = HEAP32[i26 + 4 >> 2] | 0;
      if ((i48 | 0) == (i25 | 0)) {
       HEAP8[i39 >> 0] = 2;
       i45 = 1;
       i46 = i28 + 1 | 0;
       i47 = i38 + -1 | 0;
      } else {
       i45 = 1;
       i46 = i28;
       i47 = i38;
      }
     } else {
      i45 = i24;
      i46 = i28;
      i47 = i38;
     } while (0);
     i26 = i26 + 12 | 0;
     if ((i26 | 0) == (i4 | 0)) {
      i35 = i45;
      i36 = i46;
      i37 = i47;
      break;
     } else {
      i24 = i45;
      i28 = i46;
      i38 = i47;
      i39 = i39 + 1 | 0;
     }
    }
   }
   if (!i35) {
    i11 = i25;
    i9 = i36;
    i20 = i37;
    continue;
   }
   i39 = HEAP32[i1 >> 2] | 0;
   i38 = i39 + 12 | 0;
   i28 = HEAP32[i38 >> 2] | 0;
   if ((i28 | 0) == (HEAP32[i39 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i39 >> 2] | 0) + 40 >> 2] | 0, i39 | 0) | 0;
    i39 = __THREW__;
    __THREW__ = 0;
    if (i39 & 1) {
     i14 = 5;
     break;
    }
   } else HEAP32[i38 >> 2] = i28 + 1;
   if ((i36 + i37 | 0) >>> 0 < 2 | i12) {
    i11 = i25;
    i9 = i36;
    i20 = i37;
    continue;
   } else {
    i49 = i3;
    i50 = i36;
    i51 = i16;
   }
   while (1) {
    if ((HEAP8[i51 >> 0] | 0) == 2) {
     i28 = HEAP8[i49 >> 0] | 0;
     if (!(i28 & 1)) i52 = (i28 & 255) >>> 1; else i52 = HEAP32[i49 + 4 >> 2] | 0;
     if ((i52 | 0) != (i25 | 0)) {
      HEAP8[i51 >> 0] = 0;
      i53 = i50 + -1 | 0;
     } else i53 = i50;
    } else i53 = i50;
    i28 = i49 + 12 | 0;
    if ((i28 | 0) == (i4 | 0)) {
     i11 = i25;
     i9 = i53;
     i20 = i37;
     continue L20;
    } else {
     i49 = i28;
     i50 = i53;
     i51 = i51 + 1 | 0;
    }
   }
  }
  if ((i14 | 0) == 4) {
   i20 = ___cxa_find_matching_catch() | 0;
   i54 = i15;
   i55 = i20;
   i56 = tempRet0;
   break;
  } else if ((i14 | 0) == 5) {
   i20 = ___cxa_find_matching_catch() | 0;
   i54 = i15;
   i55 = i20;
   i56 = tempRet0;
   break;
  } else if ((i14 | 0) == 64) {
   do if (i31) if ((HEAP32[i31 + 12 >> 2] | 0) == (HEAP32[i31 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i20 = invoke_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = i15;
     i14 = 6;
     break L6;
    }
    if ((i20 | 0) == -1) {
     HEAP32[i1 >> 2] = 0;
     i57 = 0;
     break;
    } else {
     i57 = HEAP32[i1 >> 2] | 0;
     break;
    }
   } else i57 = i31; else i57 = 0; while (0);
   i20 = (i57 | 0) == 0;
   do if (!i30) {
    if ((HEAP32[i32 + 12 >> 2] | 0) == (HEAP32[i32 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i9 = invoke_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0;
     i11 = __THREW__;
     __THREW__ = 0;
     if (i11 & 1) {
      i13 = i15;
      i14 = 6;
      break L6;
     }
     if ((i9 | 0) == -1) {
      HEAP32[i2 >> 2] = 0;
      i14 = 76;
      break;
     }
    }
    if (!i20) i14 = 77;
   } else i14 = 76; while (0);
   if ((i14 | 0) == 76 ? i20 : 0) i14 = 77;
   if ((i14 | 0) == 77) HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2;
   L105 : do if ((i3 | 0) == (i4 | 0)) i14 = 81; else {
    i9 = i3;
    i11 = i16;
    while (1) {
     if ((HEAP8[i11 >> 0] | 0) == 2) {
      i58 = i9;
      break L105;
     }
     i9 = i9 + 12 | 0;
     if ((i9 | 0) == (i4 | 0)) {
      i14 = 81;
      break;
     } else i11 = i11 + 1 | 0;
    }
   } while (0);
   if ((i14 | 0) == 81) {
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
    i58 = i4;
   }
   if (i15) _free(i15);
   STACKTOP = i8;
   return i58 | 0;
  }
 } while (0);
 if ((i14 | 0) == 6) {
  i14 = ___cxa_find_matching_catch() | 0;
  i54 = i13;
  i55 = i14;
  i56 = tempRet0;
 }
 if (i54) _free(i54);
 ___resumeException(i55 | 0);
 return 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i10 = i9 + 16 | 0;
 i11 = i9 + 12 | 0;
 i12 = i9 + 8 | 0;
 i13 = i9 + 4 | 0;
 i14 = i9;
 i15 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i12 >> 2] = i15;
 __THREW__ = 0;
 i16 = invoke_iii(55, i12 | 0, 26572) | 0;
 i12 = __THREW__;
 __THREW__ = 0;
 if (i12 & 1) {
  i12 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  ___resumeException(i12 | 0);
 }
 __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
 HEAP32[i5 >> 2] = 0;
 i15 = HEAP32[i2 >> 2] | 0;
 L4 : do if ((i7 | 0) != (i8 | 0)) {
  i12 = i7;
  i17 = i15;
  L5 : while (1) {
   i18 = i17;
   if (i17) {
    i19 = HEAP32[i17 + 12 >> 2] | 0;
    if ((i19 | 0) == (HEAP32[i17 + 16 >> 2] | 0)) i20 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 36 >> 2] & 255](i17) | 0; else i20 = HEAP32[i19 >> 2] | 0;
    if ((i20 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i21 = 0;
     i22 = 1;
     i23 = 0;
    } else {
     i21 = i17;
     i22 = 0;
     i23 = i18;
    }
   } else {
    i21 = 0;
    i22 = 1;
    i23 = i18;
   }
   i18 = HEAP32[i3 >> 2] | 0;
   i19 = i18;
   do if (i18) {
    i24 = HEAP32[i18 + 12 >> 2] | 0;
    if ((i24 | 0) == (HEAP32[i18 + 16 >> 2] | 0)) i25 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] & 255](i18) | 0; else i25 = HEAP32[i24 >> 2] | 0;
    if ((i25 | 0) != -1) if (i22) {
     i26 = i18;
     i27 = i19;
     break;
    } else {
     i28 = i21;
     i29 = 17;
     break L5;
    } else {
     HEAP32[i3 >> 2] = 0;
     i30 = 0;
     i29 = 15;
     break;
    }
   } else {
    i30 = i19;
    i29 = 15;
   } while (0);
   if ((i29 | 0) == 15) {
    i29 = 0;
    if (i22) {
     i28 = i21;
     i29 = 17;
     break;
    } else {
     i26 = 0;
     i27 = i30;
    }
   }
   L27 : do if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i16 >> 2] | 0) + 52 >> 2] & 63](i16, HEAP32[i12 >> 2] | 0, 0) | 0) << 24 >> 24 == 37) {
    i19 = i12 + 4 | 0;
    if ((i19 | 0) == (i8 | 0)) {
     i31 = i21;
     i29 = 21;
     break L5;
    }
    i18 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i16 >> 2] | 0) + 52 >> 2] & 63](i16, HEAP32[i19 >> 2] | 0, 0) | 0;
    switch (i18 << 24 >> 24) {
    case 48:
    case 69:
     {
      i24 = i12 + 8 | 0;
      if ((i24 | 0) == (i8 | 0)) {
       i32 = i21;
       i29 = 24;
       break L5;
      }
      i33 = i19;
      i34 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i16 >> 2] | 0) + 52 >> 2] & 63](i16, HEAP32[i24 >> 2] | 0, 0) | 0;
      i35 = i18;
      break;
     }
    default:
     {
      i33 = i12;
      i34 = i18;
      i35 = 0;
     }
    }
    i18 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
    HEAP32[i13 >> 2] = i23;
    HEAP32[i14 >> 2] = i27;
    HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
    i24 = FUNCTION_TABLE_iiiiiiiii[i18 & 15](i1, i11, i10, i4, i5, i6, i34, i35) | 0;
    HEAP32[i2 >> 2] = i24;
    i36 = i33 + 8 | 0;
   } else {
    if (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] & 63](i16, 8192, HEAP32[i12 >> 2] | 0) | 0) i37 = i12; else {
     i24 = i21 + 12 | 0;
     i18 = HEAP32[i24 >> 2] | 0;
     i19 = i21 + 16 | 0;
     if ((i18 | 0) == (HEAP32[i19 >> 2] | 0)) i38 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] & 255](i21) | 0; else i38 = HEAP32[i18 >> 2] | 0;
     i18 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] & 63](i16, i38) | 0;
     if ((i18 | 0) != (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] & 63](i16, HEAP32[i12 >> 2] | 0) | 0)) {
      i29 = 61;
      break L5;
     }
     i18 = HEAP32[i24 >> 2] | 0;
     if ((i18 | 0) == (HEAP32[i19 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i21 >> 2] | 0) + 40 >> 2] & 255](i21) | 0; else HEAP32[i24 >> 2] = i18 + 4;
     i36 = i12 + 4 | 0;
     break;
    }
    while (1) {
     i18 = i37 + 4 | 0;
     if ((i18 | 0) == (i8 | 0)) {
      i39 = i8;
      break;
     }
     if (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] & 63](i16, 8192, HEAP32[i18 >> 2] | 0) | 0) i37 = i18; else {
      i39 = i18;
      break;
     }
    }
    i18 = i21;
    i24 = i26;
    i19 = i26;
    while (1) {
     if (i18) {
      i40 = HEAP32[i18 + 12 >> 2] | 0;
      if ((i40 | 0) == (HEAP32[i18 + 16 >> 2] | 0)) i41 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] & 255](i18) | 0; else i41 = HEAP32[i40 >> 2] | 0;
      if ((i41 | 0) == -1) {
       HEAP32[i2 >> 2] = 0;
       i42 = 1;
       i43 = 0;
      } else {
       i42 = 0;
       i43 = i18;
      }
     } else {
      i42 = 1;
      i43 = 0;
     }
     do if (i19) {
      i40 = HEAP32[i19 + 12 >> 2] | 0;
      if ((i40 | 0) == (HEAP32[i19 + 16 >> 2] | 0)) i44 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i19 >> 2] | 0) + 36 >> 2] & 255](i19) | 0; else i44 = HEAP32[i40 >> 2] | 0;
      if ((i44 | 0) != -1) if (i42 ^ (i24 | 0) == 0) {
       i45 = i24;
       i46 = i24;
       break;
      } else {
       i36 = i39;
       break L27;
      } else {
       HEAP32[i3 >> 2] = 0;
       i47 = 0;
       i29 = 44;
       break;
      }
     } else {
      i47 = i24;
      i29 = 44;
     } while (0);
     if ((i29 | 0) == 44) {
      i29 = 0;
      if (i42) {
       i36 = i39;
       break L27;
      } else {
       i45 = i47;
       i46 = 0;
      }
     }
     i40 = i43 + 12 | 0;
     i48 = HEAP32[i40 >> 2] | 0;
     i49 = i43 + 16 | 0;
     if ((i48 | 0) == (HEAP32[i49 >> 2] | 0)) i50 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i43 >> 2] | 0) + 36 >> 2] & 255](i43) | 0; else i50 = HEAP32[i48 >> 2] | 0;
     if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] & 63](i16, 8192, i50) | 0)) {
      i36 = i39;
      break L27;
     }
     i48 = HEAP32[i40 >> 2] | 0;
     if ((i48 | 0) == (HEAP32[i49 >> 2] | 0)) {
      FUNCTION_TABLE_ii[HEAP32[(HEAP32[i43 >> 2] | 0) + 40 >> 2] & 255](i43) | 0;
      i18 = i43;
      i24 = i45;
      i19 = i46;
      continue;
     } else {
      HEAP32[i40 >> 2] = i48 + 4;
      i18 = i43;
      i24 = i45;
      i19 = i46;
      continue;
     }
    }
   } while (0);
   i19 = HEAP32[i2 >> 2] | 0;
   if ((i36 | 0) != (i8 | 0) & (HEAP32[i5 >> 2] | 0) == 0) {
    i12 = i36;
    i17 = i19;
   } else {
    i51 = i19;
    break L4;
   }
  }
  if ((i29 | 0) == 17) {
   HEAP32[i5 >> 2] = 4;
   i51 = i28;
   break;
  } else if ((i29 | 0) == 21) {
   HEAP32[i5 >> 2] = 4;
   i51 = i31;
   break;
  } else if ((i29 | 0) == 24) {
   HEAP32[i5 >> 2] = 4;
   i51 = i32;
   break;
  } else if ((i29 | 0) == 61) {
   HEAP32[i5 >> 2] = 4;
   i51 = HEAP32[i2 >> 2] | 0;
   break;
  }
 } else i51 = i15; while (0);
 if (i51) {
  i15 = HEAP32[i51 + 12 >> 2] | 0;
  if ((i15 | 0) == (HEAP32[i51 + 16 >> 2] | 0)) i52 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i51 >> 2] | 0) + 36 >> 2] & 255](i51) | 0; else i52 = HEAP32[i15 >> 2] | 0;
  if ((i52 | 0) == -1) {
   HEAP32[i2 >> 2] = 0;
   i53 = 0;
   i54 = 1;
  } else {
   i53 = i51;
   i54 = 0;
  }
 } else {
  i53 = 0;
  i54 = 1;
 }
 i51 = HEAP32[i3 >> 2] | 0;
 do if (i51) {
  i2 = HEAP32[i51 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i51 + 16 >> 2] | 0)) i55 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i51 >> 2] | 0) + 36 >> 2] & 255](i51) | 0; else i55 = HEAP32[i2 >> 2] | 0;
  if ((i55 | 0) != -1) if (i54) break; else {
   i29 = 76;
   break;
  } else {
   HEAP32[i3 >> 2] = 0;
   i29 = 74;
   break;
  }
 } else i29 = 74; while (0);
 if ((i29 | 0) == 74 ? i54 : 0) i29 = 76;
 if ((i29 | 0) == 76) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
 STACKTOP = i9;
 return i53 | 0;
}
function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i7 = i1;
 i8 = i1 + 208 | 0;
 i9 = i1 + 32 | 0;
 i10 = i1 + 28 | 0;
 i11 = i1 + 16 | 0;
 i12 = i1 + 12 | 0;
 i13 = i1 + 48 | 0;
 i14 = i1 + 8 | 0;
 i15 = i1 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __THREW__ = 0;
 i16 = invoke_ii(131, i4 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (i4 & 1) {
  i17 = ___cxa_find_matching_catch() | 0;
  i18 = i17;
  i19 = tempRet0;
 } else {
  HEAP32[i10 >> 2] = i16;
  __THREW__ = 0;
  i17 = invoke_iii(55, i10 | 0, 26572) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  if (!(i20 & 1) ? (__THREW__ = 0, invoke_iiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 48 >> 2] | 0, i17 | 0, 46161, 46187, i8 | 0) | 0, i17 = __THREW__, __THREW__ = 0, !(i17 & 1)) : 0) {
   __ZNSt3__114__shared_count16__release_sharedEv(i16) | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   if (!(HEAP8[i11 >> 0] & 1)) i21 = 10; else i21 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
   __THREW__ = 0;
   invoke_viii(9, i11 | 0, i21 | 0, 0);
   i17 = __THREW__;
   __THREW__ = 0;
   L10 : do if (!(i17 & 1)) {
    i20 = i11 + 8 | 0;
    i22 = i11 + 1 | 0;
    i23 = (HEAP8[i11 >> 0] & 1) == 0 ? i22 : HEAP32[i20 >> 2] | 0;
    HEAP32[i12 >> 2] = i23;
    HEAP32[i14 >> 2] = i13;
    HEAP32[i15 >> 2] = 0;
    i24 = i11 + 4 | 0;
    i25 = HEAP32[i2 >> 2] | 0;
    i26 = i23;
    L12 : while (1) {
     if (i25) {
      i23 = HEAP32[i25 + 12 >> 2] | 0;
      if ((i23 | 0) == (HEAP32[i25 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i27 = invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
       i28 = __THREW__;
       __THREW__ = 0;
       if (i28 & 1) {
        i29 = 30;
        break;
       } else i30 = i27;
      } else i30 = HEAP32[i23 >> 2] | 0;
      if ((i30 | 0) == -1) {
       HEAP32[i2 >> 2] = 0;
       i31 = 0;
       i32 = 1;
      } else {
       i31 = i25;
       i32 = 0;
      }
     } else {
      i31 = 0;
      i32 = 1;
     }
     i23 = HEAP32[i3 >> 2] | 0;
     do if (i23) {
      i27 = HEAP32[i23 + 12 >> 2] | 0;
      if ((i27 | 0) == (HEAP32[i23 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i28 = invoke_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] | 0, i23 | 0) | 0;
       i33 = __THREW__;
       __THREW__ = 0;
       if (i33 & 1) {
        i29 = 30;
        break L12;
       } else i34 = i28;
      } else i34 = HEAP32[i27 >> 2] | 0;
      if ((i34 | 0) != -1) if (i32) {
       i35 = i23;
       break;
      } else {
       i36 = i31;
       i37 = i23;
       i38 = i26;
       break L12;
      } else {
       HEAP32[i3 >> 2] = 0;
       i29 = 20;
       break;
      }
     } else i29 = 20; while (0);
     if ((i29 | 0) == 20) {
      i29 = 0;
      if (i32) {
       i36 = i31;
       i37 = 0;
       i38 = i26;
       break;
      } else i35 = 0;
     }
     i23 = HEAP8[i11 >> 0] | 0;
     i27 = (i23 & 1) == 0 ? (i23 & 255) >>> 1 : HEAP32[i24 >> 2] | 0;
     if ((HEAP32[i12 >> 2] | 0) == (i26 + i27 | 0)) {
      __THREW__ = 0;
      invoke_viii(9, i11 | 0, i27 << 1 | 0, 0);
      i23 = __THREW__;
      __THREW__ = 0;
      if (i23 & 1) {
       i29 = 30;
       break;
      }
      if (!(HEAP8[i11 >> 0] & 1)) i39 = 10; else i39 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
      __THREW__ = 0;
      invoke_viii(9, i11 | 0, i39 | 0, 0);
      i23 = __THREW__;
      __THREW__ = 0;
      if (i23 & 1) {
       i29 = 30;
       break;
      }
      i23 = (HEAP8[i11 >> 0] & 1) == 0 ? i22 : HEAP32[i20 >> 2] | 0;
      HEAP32[i12 >> 2] = i23 + i27;
      i40 = i23;
     } else i40 = i26;
     i23 = i31 + 12 | 0;
     i27 = HEAP32[i23 >> 2] | 0;
     i28 = i31 + 16 | 0;
     if ((i27 | 0) == (HEAP32[i28 >> 2] | 0)) {
      __THREW__ = 0;
      i33 = invoke_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
      i41 = __THREW__;
      __THREW__ = 0;
      if (i41 & 1) {
       i29 = 30;
       break;
      } else i42 = i33;
     } else i42 = HEAP32[i27 >> 2] | 0;
     if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i42, 16, i40, i12, i15, 0, i9, i13, i14, i8) | 0) {
      i36 = i31;
      i37 = i35;
      i38 = i40;
      break;
     }
     i27 = HEAP32[i23 >> 2] | 0;
     if ((i27 | 0) == (HEAP32[i28 >> 2] | 0)) {
      __THREW__ = 0;
      invoke_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 40 >> 2] | 0, i31 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) {
       i29 = 30;
       break;
      } else {
       i25 = i31;
       i26 = i40;
       continue;
      }
     } else {
      HEAP32[i23 >> 2] = i27 + 4;
      i25 = i31;
      i26 = i40;
      continue;
     }
    }
    if ((i29 | 0) == 30) {
     i26 = ___cxa_find_matching_catch() | 0;
     i43 = i26;
     i44 = tempRet0;
     break;
    }
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, (HEAP32[i12 >> 2] | 0) - i38 | 0, 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if ((!(i26 & 1) ? (i26 = HEAP8[i11 >> 0] | 0, i25 = HEAP32[i20 >> 2] | 0, __THREW__ = 0, i24 = invoke_i(22) | 0, i27 = __THREW__, __THREW__ = 0, !(i27 & 1)) : 0) ? (__THREW__ = 0, HEAP32[i7 >> 2] = i6, i27 = invoke_iiiii(9, ((i26 & 1) == 0 ? i22 : i25) | 0, i24 | 0, 47545, i7 | 0) | 0, i24 = __THREW__, __THREW__ = 0, !(i24 & 1)) : 0) {
     if ((i27 | 0) != 1) HEAP32[i5 >> 2] = 4;
     if (i36) {
      i27 = HEAP32[i36 + 12 >> 2] | 0;
      if ((i27 | 0) == (HEAP32[i36 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i24 = invoke_ii(HEAP32[(HEAP32[i36 >> 2] | 0) + 36 >> 2] | 0, i36 | 0) | 0;
       i25 = __THREW__;
       __THREW__ = 0;
       if (i25 & 1) {
        i29 = 31;
        break;
       } else i45 = i24;
      } else i45 = HEAP32[i27 >> 2] | 0;
      if ((i45 | 0) == -1) {
       HEAP32[i2 >> 2] = 0;
       i46 = 1;
      } else i46 = 0;
     } else i46 = 1;
     do if (i37) {
      i27 = HEAP32[i37 + 12 >> 2] | 0;
      if ((i27 | 0) == (HEAP32[i37 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i24 = invoke_ii(HEAP32[(HEAP32[i37 >> 2] | 0) + 36 >> 2] | 0, i37 | 0) | 0;
       i25 = __THREW__;
       __THREW__ = 0;
       if (i25 & 1) {
        i29 = 31;
        break L10;
       } else i47 = i24;
      } else i47 = HEAP32[i27 >> 2] | 0;
      if ((i47 | 0) != -1) if (i46) break; else {
       i29 = 59;
       break;
      } else {
       HEAP32[i3 >> 2] = 0;
       i29 = 57;
       break;
      }
     } else i29 = 57; while (0);
     if ((i29 | 0) == 57 ? i46 : 0) i29 = 59;
     if ((i29 | 0) == 59) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
     i22 = HEAP32[i2 >> 2] | 0;
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
     STACKTOP = i1;
     return i22 | 0;
    } else i29 = 31;
   } else i29 = 31; while (0);
   if ((i29 | 0) == 31) {
    i17 = ___cxa_find_matching_catch() | 0;
    i43 = i17;
    i44 = tempRet0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i18 = i43;
   i19 = i44;
   break;
  }
  i17 = ___cxa_find_matching_catch() | 0;
  i22 = tempRet0;
  __ZNSt3__114__shared_count16__release_sharedEv(i16) | 0;
  i18 = i17;
  i19 = i22;
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i18 | 0);
 return 0;
}

function __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8;
 i10 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 26572) | 0;
 i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 26728) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] & 127](i9, i11);
 HEAP32[i6 >> 2] = i4;
 i7 = HEAP8[i1 >> 0] | 0;
 switch (i7 << 24 >> 24) {
 case 43:
 case 45:
  {
   __THREW__ = 0;
   i12 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, i7 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) i13 = 8; else {
    i7 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i7 + 4;
    HEAP32[i7 >> 2] = i12;
    i14 = i1 + 1 | 0;
    i13 = 10;
   }
   break;
  }
 default:
  {
   i14 = i1;
   i13 = 10;
  }
 }
 L4 : do if ((i13 | 0) == 10) {
  i12 = i3;
  L6 : do if ((i12 - i14 | 0) > 1 ? (HEAP8[i14 >> 0] | 0) == 48 : 0) {
   i7 = i14 + 1 | 0;
   switch (HEAP8[i7 >> 0] | 0) {
   case 88:
   case 120:
    break;
   default:
    {
     i13 = 11;
     break L6;
    }
   }
   __THREW__ = 0;
   i15 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, 48) | 0;
   i16 = __THREW__;
   __THREW__ = 0;
   if (i16 & 1) {
    i13 = 8;
    break L4;
   }
   i16 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i16 + 4;
   HEAP32[i16 >> 2] = i15;
   i15 = i14 + 2 | 0;
   __THREW__ = 0;
   i16 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, HEAP8[i7 >> 0] | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i13 = 8;
    break L4;
   }
   i7 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i7 + 4;
   HEAP32[i7 >> 2] = i16;
   if (i15 >>> 0 < i3 >>> 0) {
    i16 = i15;
    while (1) {
     i7 = HEAP8[i16 >> 0] | 0;
     __THREW__ = 0;
     i17 = invoke_i(22) | 0;
     i18 = __THREW__;
     __THREW__ = 0;
     if (i18 & 1) break;
     __THREW__ = 0;
     i18 = invoke_iii(56, i7 << 24 >> 24 | 0, i17 | 0) | 0;
     i17 = __THREW__;
     __THREW__ = 0;
     if (i17 & 1) break;
     if (!i18) {
      i19 = i15;
      i20 = i16;
      break L6;
     }
     i18 = i16 + 1 | 0;
     if (i18 >>> 0 < i3 >>> 0) i16 = i18; else {
      i19 = i15;
      i20 = i18;
      break L6;
     }
    }
    i16 = ___cxa_find_matching_catch() | 0;
    i21 = i16;
    i22 = tempRet0;
    break L4;
   } else {
    i19 = i15;
    i20 = i15;
   }
  } else i13 = 11; while (0);
  L18 : do if ((i13 | 0) == 11) if (i14 >>> 0 < i3 >>> 0) {
   i16 = i14;
   while (1) {
    i18 = HEAP8[i16 >> 0] | 0;
    __THREW__ = 0;
    i17 = invoke_i(22) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) break;
    __THREW__ = 0;
    i7 = invoke_iii(57, i18 << 24 >> 24 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) break;
    if (!i7) {
     i19 = i14;
     i20 = i16;
     break L18;
    }
    i7 = i16 + 1 | 0;
    if (i7 >>> 0 < i3 >>> 0) i16 = i7; else {
     i19 = i14;
     i20 = i7;
     break L18;
    }
   }
   i16 = ___cxa_find_matching_catch() | 0;
   i21 = i16;
   i22 = tempRet0;
   break L4;
  } else {
   i19 = i14;
   i20 = i14;
  } while (0);
  i16 = HEAP8[i9 >> 0] | 0;
  i15 = i9 + 4 | 0;
  if (((i16 & 1) == 0 ? (i16 & 255) >>> 1 : HEAP32[i15 >> 2] | 0) | 0) {
   if ((i19 | 0) != (i20 | 0) ? (i16 = i20 + -1 | 0, i19 >>> 0 < i16 >>> 0) : 0) {
    i7 = i19;
    i17 = i16;
    do {
     i16 = HEAP8[i7 >> 0] | 0;
     HEAP8[i7 >> 0] = HEAP8[i17 >> 0] | 0;
     HEAP8[i17 >> 0] = i16;
     i7 = i7 + 1 | 0;
     i17 = i17 + -1 | 0;
    } while (i7 >>> 0 < i17 >>> 0);
   }
   __THREW__ = 0;
   i17 = invoke_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i13 = 8;
    break;
   }
   i7 = i9 + 8 | 0;
   i16 = i9 + 1 | 0;
   L37 : do if (i19 >>> 0 < i20 >>> 0) {
    i18 = 0;
    i23 = 0;
    i24 = i19;
    while (1) {
     i25 = HEAP8[((HEAP8[i9 >> 0] & 1) == 0 ? i16 : HEAP32[i7 >> 2] | 0) + i23 >> 0] | 0;
     if (i25 << 24 >> 24 > 0 & (i18 | 0) == (i25 << 24 >> 24 | 0)) {
      i25 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i25 + 4;
      HEAP32[i25 >> 2] = i17;
      i25 = HEAP8[i9 >> 0] | 0;
      i26 = 0;
      i27 = (i23 >>> 0 < (((i25 & 1) == 0 ? (i25 & 255) >>> 1 : HEAP32[i15 >> 2] | 0) + -1 | 0) >>> 0 & 1) + i23 | 0;
     } else {
      i26 = i18;
      i27 = i23;
     }
     __THREW__ = 0;
     i25 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, HEAP8[i24 >> 0] | 0) | 0;
     i28 = __THREW__;
     __THREW__ = 0;
     if (i28 & 1) break;
     i28 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i28 + 4;
     HEAP32[i28 >> 2] = i25;
     i24 = i24 + 1 | 0;
     if (i24 >>> 0 >= i20 >>> 0) break L37; else {
      i18 = i26 + 1 | 0;
      i23 = i27;
     }
    }
    i23 = ___cxa_find_matching_catch() | 0;
    i21 = i23;
    i22 = tempRet0;
    break L4;
   } while (0);
   i15 = i4 + (i19 - i1 << 2) | 0;
   i17 = HEAP32[i6 >> 2] | 0;
   if ((i15 | 0) != (i17 | 0)) {
    i7 = i17 + -4 | 0;
    if (i15 >>> 0 < i7 >>> 0) {
     i16 = i15;
     i23 = i7;
     do {
      i7 = HEAP32[i16 >> 2] | 0;
      HEAP32[i16 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i23 >> 2] = i7;
      i16 = i16 + 4 | 0;
      i23 = i23 + -4 | 0;
     } while (i16 >>> 0 < i23 >>> 0);
     i29 = i10;
     i30 = i17;
    } else {
     i29 = i10;
     i30 = i17;
    }
   } else {
    i29 = i10;
    i30 = i15;
   }
  } else {
   __THREW__ = 0;
   invoke_iiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 48 >> 2] | 0, i10 | 0, i19 | 0, i20 | 0, HEAP32[i6 >> 2] | 0) | 0;
   i23 = __THREW__;
   __THREW__ = 0;
   if (i23 & 1) {
    i13 = 8;
    break;
   }
   i23 = (HEAP32[i6 >> 2] | 0) + (i20 - i19 << 2) | 0;
   HEAP32[i6 >> 2] = i23;
   i29 = i10;
   i30 = i23;
  }
  L50 : do if (i20 >>> 0 < i3 >>> 0) {
   i23 = i20;
   while (1) {
    i16 = HEAP8[i23 >> 0] | 0;
    if (i16 << 24 >> 24 == 46) {
     i31 = i23;
     break;
    }
    __THREW__ = 0;
    i7 = invoke_iii(HEAP32[(HEAP32[i29 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, i16 | 0) | 0;
    i16 = __THREW__;
    __THREW__ = 0;
    if (i16 & 1) {
     i13 = 4;
     break;
    }
    i16 = HEAP32[i6 >> 2] | 0;
    i18 = i16 + 4 | 0;
    HEAP32[i6 >> 2] = i18;
    HEAP32[i16 >> 2] = i7;
    i7 = i23 + 1 | 0;
    if (i7 >>> 0 < i3 >>> 0) i23 = i7; else {
     i32 = i18;
     i33 = i7;
     break L50;
    }
   }
   if ((i13 | 0) == 4) {
    i23 = ___cxa_find_matching_catch() | 0;
    i21 = i23;
    i22 = tempRet0;
    break L4;
   }
   __THREW__ = 0;
   i23 = invoke_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i13 = 8;
    break L4;
   }
   i7 = HEAP32[i6 >> 2] | 0;
   i18 = i7 + 4 | 0;
   HEAP32[i6 >> 2] = i18;
   HEAP32[i7 >> 2] = i23;
   i32 = i18;
   i33 = i31 + 1 | 0;
  } else {
   i32 = i30;
   i33 = i20;
  } while (0);
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 48 >> 2] | 0, i10 | 0, i33 | 0, i3 | 0, i32 | 0) | 0;
  i15 = __THREW__;
  __THREW__ = 0;
  if (i15 & 1) i13 = 8; else {
   i15 = (HEAP32[i6 >> 2] | 0) + (i12 - i33 << 2) | 0;
   HEAP32[i6 >> 2] = i15;
   HEAP32[i5 >> 2] = (i2 | 0) == (i3 | 0) ? i15 : i4 + (i2 - i1 << 2) | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i8;
   return;
  }
 } while (0);
 if ((i13 | 0) == 8) {
  i13 = ___cxa_find_matching_catch() | 0;
  i21 = i13;
  i22 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i21 | 0);
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i10 = i9 + 16 | 0;
 i11 = i9 + 12 | 0;
 i12 = i9 + 8 | 0;
 i13 = i9 + 4 | 0;
 i14 = i9;
 i15 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i12 >> 2] = i15;
 __THREW__ = 0;
 i16 = invoke_iii(55, i12 | 0, 26580) | 0;
 i12 = __THREW__;
 __THREW__ = 0;
 if (i12 & 1) {
  i12 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  ___resumeException(i12 | 0);
 }
 __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
 HEAP32[i5 >> 2] = 0;
 i15 = i16 + 8 | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 L4 : do if ((i7 | 0) != (i8 | 0)) {
  i17 = i7;
  i18 = i12;
  L5 : while (1) {
   i19 = i18;
   if (i18) if ((HEAP32[i18 + 12 >> 2] | 0) == (HEAP32[i18 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] & 255](i18) | 0) == -1 : 0) {
    HEAP32[i2 >> 2] = 0;
    i20 = 0;
    i21 = 0;
   } else {
    i20 = i18;
    i21 = i19;
   } else {
    i20 = 0;
    i21 = i19;
   }
   i19 = (i20 | 0) == 0;
   i22 = HEAP32[i3 >> 2] | 0;
   i23 = i22;
   do if (i22) {
    if ((HEAP32[i22 + 12 >> 2] | 0) == (HEAP32[i22 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] & 255](i22) | 0) == -1 : 0) {
     HEAP32[i3 >> 2] = 0;
     i24 = 0;
     i25 = 12;
     break;
    }
    if (i19) {
     i26 = i22;
     i27 = i23;
    } else {
     i28 = i20;
     i25 = 13;
     break L5;
    }
   } else {
    i24 = i23;
    i25 = 12;
   } while (0);
   if ((i25 | 0) == 12) {
    i25 = 0;
    if (i19) {
     i28 = i20;
     i25 = 13;
     break;
    } else {
     i26 = 0;
     i27 = i24;
    }
   }
   L21 : do if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] & 63](i16, HEAP8[i17 >> 0] | 0, 0) | 0) << 24 >> 24 == 37) {
    i23 = i17 + 1 | 0;
    if ((i23 | 0) == (i8 | 0)) {
     i29 = i20;
     i25 = 17;
     break L5;
    }
    i22 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] & 63](i16, HEAP8[i23 >> 0] | 0, 0) | 0;
    switch (i22 << 24 >> 24) {
    case 48:
    case 69:
     {
      i30 = i17 + 2 | 0;
      if ((i30 | 0) == (i8 | 0)) {
       i31 = i20;
       i25 = 20;
       break L5;
      }
      i32 = i23;
      i33 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] & 63](i16, HEAP8[i30 >> 0] | 0, 0) | 0;
      i34 = i22;
      break;
     }
    default:
     {
      i32 = i17;
      i33 = i22;
      i34 = 0;
     }
    }
    i22 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
    HEAP32[i13 >> 2] = i21;
    HEAP32[i14 >> 2] = i27;
    HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
    i30 = FUNCTION_TABLE_iiiiiiiii[i22 & 15](i1, i11, i10, i4, i5, i6, i33, i34) | 0;
    HEAP32[i2 >> 2] = i30;
    i35 = i32 + 2 | 0;
   } else {
    i30 = HEAP8[i17 >> 0] | 0;
    if (i30 << 24 >> 24 > -1 ? (i22 = HEAP32[i15 >> 2] | 0, (HEAP16[i22 + (i30 << 24 >> 24 << 1) >> 1] & 8192) != 0) : 0) {
     i30 = i17;
     while (1) {
      i23 = i30 + 1 | 0;
      if ((i23 | 0) == (i8 | 0)) {
       i36 = i8;
       break;
      }
      i37 = HEAP8[i23 >> 0] | 0;
      if (i37 << 24 >> 24 <= -1) {
       i36 = i23;
       break;
      }
      if (!(HEAP16[i22 + (i37 << 24 >> 24 << 1) >> 1] & 8192)) {
       i36 = i23;
       break;
      } else i30 = i23;
     }
     i30 = i20;
     i22 = i26;
     i23 = i26;
     while (1) {
      if (i30) if ((HEAP32[i30 + 12 >> 2] | 0) == (HEAP32[i30 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 36 >> 2] & 255](i30) | 0) == -1 : 0) {
       HEAP32[i2 >> 2] = 0;
       i38 = 0;
      } else i38 = i30; else i38 = 0;
      i37 = (i38 | 0) == 0;
      do if (i23) {
       if ((HEAP32[i23 + 12 >> 2] | 0) != (HEAP32[i23 + 16 >> 2] | 0)) if (i37) {
        i39 = i22;
        i40 = i23;
        break;
       } else {
        i35 = i36;
        break L21;
       }
       if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] & 255](i23) | 0) != -1) if (i37 ^ (i22 | 0) == 0) {
        i39 = i22;
        i40 = i22;
        break;
       } else {
        i35 = i36;
        break L21;
       } else {
        HEAP32[i3 >> 2] = 0;
        i41 = 0;
        i25 = 39;
        break;
       }
      } else {
       i41 = i22;
       i25 = 39;
      } while (0);
      if ((i25 | 0) == 39) {
       i25 = 0;
       if (i37) {
        i35 = i36;
        break L21;
       } else {
        i39 = i41;
        i40 = 0;
       }
      }
      i42 = i38 + 12 | 0;
      i43 = HEAP32[i42 >> 2] | 0;
      i44 = i38 + 16 | 0;
      if ((i43 | 0) == (HEAP32[i44 >> 2] | 0)) i45 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i38 >> 2] | 0) + 36 >> 2] & 255](i38) | 0; else i45 = HEAPU8[i43 >> 0] | 0;
      if ((i45 & 255) << 24 >> 24 <= -1) {
       i35 = i36;
       break L21;
      }
      if (!(HEAP16[(HEAP32[i15 >> 2] | 0) + (i45 << 24 >> 24 << 1) >> 1] & 8192)) {
       i35 = i36;
       break L21;
      }
      i43 = HEAP32[i42 >> 2] | 0;
      if ((i43 | 0) == (HEAP32[i44 >> 2] | 0)) {
       FUNCTION_TABLE_ii[HEAP32[(HEAP32[i38 >> 2] | 0) + 40 >> 2] & 255](i38) | 0;
       i30 = i38;
       i22 = i39;
       i23 = i40;
       continue;
      } else {
       HEAP32[i42 >> 2] = i43 + 1;
       i30 = i38;
       i22 = i39;
       i23 = i40;
       continue;
      }
     }
    }
    i23 = i20 + 12 | 0;
    i22 = HEAP32[i23 >> 2] | 0;
    i30 = i20 + 16 | 0;
    if ((i22 | 0) == (HEAP32[i30 >> 2] | 0)) i46 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i20 >> 2] | 0) + 36 >> 2] & 255](i20) | 0; else i46 = HEAPU8[i22 >> 0] | 0;
    i22 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] & 63](i16, i46 & 255) | 0;
    if (i22 << 24 >> 24 != (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] & 63](i16, HEAP8[i17 >> 0] | 0) | 0) << 24 >> 24) {
     i25 = 57;
     break L5;
    }
    i22 = HEAP32[i23 >> 2] | 0;
    if ((i22 | 0) == (HEAP32[i30 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i20 >> 2] | 0) + 40 >> 2] & 255](i20) | 0; else HEAP32[i23 >> 2] = i22 + 1;
    i35 = i17 + 1 | 0;
   } while (0);
   i19 = HEAP32[i2 >> 2] | 0;
   if ((i35 | 0) != (i8 | 0) & (HEAP32[i5 >> 2] | 0) == 0) {
    i17 = i35;
    i18 = i19;
   } else {
    i47 = i19;
    break L4;
   }
  }
  if ((i25 | 0) == 13) {
   HEAP32[i5 >> 2] = 4;
   i47 = i28;
   break;
  } else if ((i25 | 0) == 17) {
   HEAP32[i5 >> 2] = 4;
   i47 = i29;
   break;
  } else if ((i25 | 0) == 20) {
   HEAP32[i5 >> 2] = 4;
   i47 = i31;
   break;
  } else if ((i25 | 0) == 57) {
   HEAP32[i5 >> 2] = 4;
   i47 = HEAP32[i2 >> 2] | 0;
   break;
  }
 } else i47 = i12; while (0);
 if (i47) if ((HEAP32[i47 + 12 >> 2] | 0) == (HEAP32[i47 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i47 >> 2] | 0) + 36 >> 2] & 255](i47) | 0) == -1 : 0) {
  HEAP32[i2 >> 2] = 0;
  i48 = 0;
 } else i48 = i47; else i48 = 0;
 i47 = (i48 | 0) == 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do if (i2) {
  if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 255](i2) | 0) == -1 : 0) {
   HEAP32[i3 >> 2] = 0;
   i25 = 67;
   break;
  }
  if (!i47) i25 = 68;
 } else i25 = 67; while (0);
 if ((i25 | 0) == 67 ? i47 : 0) i25 = 68;
 if ((i25 | 0) == 68) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
 STACKTOP = i9;
 return i48 | 0;
}

function __ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i12 = i11 + 100 | 0;
 i13 = i11 + 88 | 0;
 i14 = i11 + 76 | 0;
 i15 = i11 + 64 | 0;
 i16 = i11 + 52 | 0;
 i17 = i11 + 48 | 0;
 i18 = i11 + 36 | 0;
 i19 = i11 + 24 | 0;
 i20 = i11 + 12 | 0;
 i21 = i11;
 do if (i1) {
  i22 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 26188) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 44 >> 2] & 127](i12, i22);
  i23 = HEAP32[i12 >> 2] | 0;
  HEAP8[i3 >> 0] = i23;
  HEAP8[i3 + 1 >> 0] = i23 >> 8;
  HEAP8[i3 + 2 >> 0] = i23 >> 16;
  HEAP8[i3 + 3 >> 0] = i23 >> 24;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 32 >> 2] & 127](i13, i22);
  if (!(HEAP8[i9 >> 0] & 1)) {
   HEAP8[i9 + 1 >> 0] = 0;
   HEAP8[i9 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i9 + 8 >> 2] >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i9 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] & 127](i14, i22);
  if (!(HEAP8[i8 >> 0] & 1)) {
   HEAP8[i8 + 1 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i8 + 8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i8 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i23 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] & 255](i22) | 0;
  HEAP8[i4 >> 0] = i23;
  i23 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] & 255](i22) | 0;
  HEAP8[i5 >> 0] = i23;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 20 >> 2] & 127](i15, i22);
  if (!(HEAP8[i6 >> 0] & 1)) {
   HEAP8[i6 + 1 >> 0] = 0;
   HEAP8[i6 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i6 + 8 >> 2] >> 0] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i6 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] & 127](i16, i22);
  if (!(HEAP8[i7 >> 0] & 1)) {
   HEAP8[i7 + 1 >> 0] = 0;
   HEAP8[i7 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i7 + 8 >> 2] >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i7 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  } else {
   HEAP32[i7 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
   i24 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] & 255](i22) | 0;
   break;
  }
 } else {
  i22 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 26124) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 44 >> 2] & 127](i17, i22);
  i23 = HEAP32[i17 >> 2] | 0;
  HEAP8[i3 >> 0] = i23;
  HEAP8[i3 + 1 >> 0] = i23 >> 8;
  HEAP8[i3 + 2 >> 0] = i23 >> 16;
  HEAP8[i3 + 3 >> 0] = i23 >> 24;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 32 >> 2] & 127](i18, i22);
  if (!(HEAP8[i9 >> 0] & 1)) {
   HEAP8[i9 + 1 >> 0] = 0;
   HEAP8[i9 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i9 + 8 >> 2] >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i9 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i9 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] & 127](i19, i22);
  if (!(HEAP8[i8 >> 0] & 1)) {
   HEAP8[i8 + 1 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i8 + 8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i8 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i8 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
  i23 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] & 255](i22) | 0;
  HEAP8[i4 >> 0] = i23;
  i23 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] & 255](i22) | 0;
  HEAP8[i5 >> 0] = i23;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 20 >> 2] & 127](i20, i22);
  if (!(HEAP8[i6 >> 0] & 1)) {
   HEAP8[i6 + 1 >> 0] = 0;
   HEAP8[i6 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i6 + 8 >> 2] >> 0] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i6 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] & 127](i21, i22);
  if (!(HEAP8[i7 >> 0] & 1)) {
   HEAP8[i7 + 1 >> 0] = 0;
   HEAP8[i7 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i7 + 8 >> 2] >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i7 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  } else {
   HEAP32[i7 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
   i24 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] & 255](i22) | 0;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i24;
 STACKTOP = i11;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1;
 i8 = i1 + 208 | 0;
 i9 = i1 + 32 | 0;
 i10 = i1 + 28 | 0;
 i11 = i1 + 16 | 0;
 i12 = i1 + 12 | 0;
 i13 = i1 + 48 | 0;
 i14 = i1 + 8 | 0;
 i15 = i1 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __THREW__ = 0;
 i16 = invoke_ii(131, i4 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (i4 & 1) {
  i17 = ___cxa_find_matching_catch() | 0;
  i18 = i17;
  i19 = tempRet0;
 } else {
  HEAP32[i10 >> 2] = i16;
  __THREW__ = 0;
  i17 = invoke_iii(55, i10 | 0, 26580) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  if (!(i20 & 1) ? (__THREW__ = 0, invoke_iiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 32 >> 2] | 0, i17 | 0, 46161, 46187, i8 | 0) | 0, i17 = __THREW__, __THREW__ = 0, !(i17 & 1)) : 0) {
   __ZNSt3__114__shared_count16__release_sharedEv(i16) | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   if (!(HEAP8[i11 >> 0] & 1)) i21 = 10; else i21 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
   __THREW__ = 0;
   invoke_viii(9, i11 | 0, i21 | 0, 0);
   i17 = __THREW__;
   __THREW__ = 0;
   L10 : do if (!(i17 & 1)) {
    i20 = i11 + 8 | 0;
    i22 = i11 + 1 | 0;
    i23 = (HEAP8[i11 >> 0] & 1) == 0 ? i22 : HEAP32[i20 >> 2] | 0;
    HEAP32[i12 >> 2] = i23;
    HEAP32[i14 >> 2] = i13;
    HEAP32[i15 >> 2] = 0;
    i24 = i11 + 4 | 0;
    i25 = HEAP32[i2 >> 2] | 0;
    i26 = i23;
    L12 : while (1) {
     if (i25) if ((HEAP32[i25 + 12 >> 2] | 0) == (HEAP32[i25 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i23 = invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i28 = 29;
       break;
      }
      if ((i23 | 0) == -1) {
       HEAP32[i2 >> 2] = 0;
       i29 = 0;
      } else i29 = i25;
     } else i29 = i25; else i29 = 0;
     i23 = (i29 | 0) == 0;
     i27 = HEAP32[i3 >> 2] | 0;
     do if (i27) {
      if ((HEAP32[i27 + 12 >> 2] | 0) != (HEAP32[i27 + 16 >> 2] | 0)) if (i23) {
       i30 = i27;
       break;
      } else {
       i31 = i29;
       i32 = i27;
       i33 = i26;
       break L12;
      }
      __THREW__ = 0;
      i34 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
      i35 = __THREW__;
      __THREW__ = 0;
      if (i35 & 1) {
       i28 = 29;
       break L12;
      }
      if ((i34 | 0) != -1) if (i23) {
       i30 = i27;
       break;
      } else {
       i31 = i29;
       i32 = i27;
       i33 = i26;
       break L12;
      } else {
       HEAP32[i3 >> 2] = 0;
       i28 = 19;
       break;
      }
     } else i28 = 19; while (0);
     if ((i28 | 0) == 19) {
      i28 = 0;
      if (i23) {
       i31 = i29;
       i32 = 0;
       i33 = i26;
       break;
      } else i30 = 0;
     }
     i27 = HEAP8[i11 >> 0] | 0;
     i34 = (i27 & 1) == 0 ? (i27 & 255) >>> 1 : HEAP32[i24 >> 2] | 0;
     if ((HEAP32[i12 >> 2] | 0) == (i26 + i34 | 0)) {
      __THREW__ = 0;
      invoke_viii(9, i11 | 0, i34 << 1 | 0, 0);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i28 = 29;
       break;
      }
      if (!(HEAP8[i11 >> 0] & 1)) i36 = 10; else i36 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
      __THREW__ = 0;
      invoke_viii(9, i11 | 0, i36 | 0, 0);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i28 = 29;
       break;
      }
      i27 = (HEAP8[i11 >> 0] & 1) == 0 ? i22 : HEAP32[i20 >> 2] | 0;
      HEAP32[i12 >> 2] = i27 + i34;
      i37 = i27;
     } else i37 = i26;
     i27 = i29 + 12 | 0;
     i34 = HEAP32[i27 >> 2] | 0;
     i35 = i29 + 16 | 0;
     if ((i34 | 0) == (HEAP32[i35 >> 2] | 0)) {
      __THREW__ = 0;
      i38 = invoke_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 36 >> 2] | 0, i29 | 0) | 0;
      i39 = __THREW__;
      __THREW__ = 0;
      if (i39 & 1) {
       i28 = 29;
       break;
      } else i40 = i38;
     } else i40 = HEAPU8[i34 >> 0] | 0;
     if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i40 & 255, 16, i37, i12, i15, 0, i9, i13, i14, i8) | 0) {
      i31 = i29;
      i32 = i30;
      i33 = i37;
      break;
     }
     i34 = HEAP32[i27 >> 2] | 0;
     if ((i34 | 0) == (HEAP32[i35 >> 2] | 0)) {
      __THREW__ = 0;
      invoke_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 40 >> 2] | 0, i29 | 0) | 0;
      i35 = __THREW__;
      __THREW__ = 0;
      if (i35 & 1) {
       i28 = 29;
       break;
      } else {
       i25 = i29;
       i26 = i37;
       continue;
      }
     } else {
      HEAP32[i27 >> 2] = i34 + 1;
      i25 = i29;
      i26 = i37;
      continue;
     }
    }
    if ((i28 | 0) == 29) {
     i26 = ___cxa_find_matching_catch() | 0;
     i41 = i26;
     i42 = tempRet0;
     break;
    }
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, (HEAP32[i12 >> 2] | 0) - i33 | 0, 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if ((!(i26 & 1) ? (i26 = HEAP8[i11 >> 0] | 0, i25 = HEAP32[i20 >> 2] | 0, __THREW__ = 0, i24 = invoke_i(22) | 0, i34 = __THREW__, __THREW__ = 0, !(i34 & 1)) : 0) ? (__THREW__ = 0, HEAP32[i7 >> 2] = i6, i34 = invoke_iiiii(9, ((i26 & 1) == 0 ? i22 : i25) | 0, i24 | 0, 47545, i7 | 0) | 0, i24 = __THREW__, __THREW__ = 0, !(i24 & 1)) : 0) {
     if ((i34 | 0) != 1) HEAP32[i5 >> 2] = 4;
     if (i31) if ((HEAP32[i31 + 12 >> 2] | 0) == (HEAP32[i31 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i34 = invoke_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
      i24 = __THREW__;
      __THREW__ = 0;
      if (i24 & 1) {
       i28 = 30;
       break;
      }
      if ((i34 | 0) == -1) {
       HEAP32[i2 >> 2] = 0;
       i43 = 0;
      } else i43 = i31;
     } else i43 = i31; else i43 = 0;
     i34 = (i43 | 0) == 0;
     do if (i32) {
      if ((HEAP32[i32 + 12 >> 2] | 0) == (HEAP32[i32 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i24 = invoke_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0;
       i25 = __THREW__;
       __THREW__ = 0;
       if (i25 & 1) {
        i28 = 30;
        break L10;
       }
       if ((i24 | 0) == -1) {
        HEAP32[i3 >> 2] = 0;
        i28 = 55;
        break;
       }
      }
      if (!i34) i28 = 56;
     } else i28 = 55; while (0);
     if ((i28 | 0) == 55 ? i34 : 0) i28 = 56;
     if ((i28 | 0) == 56) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
     i22 = HEAP32[i2 >> 2] | 0;
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
     STACKTOP = i1;
     return i22 | 0;
    } else i28 = 30;
   } else i28 = 30; while (0);
   if ((i28 | 0) == 30) {
    i17 = ___cxa_find_matching_catch() | 0;
    i41 = i17;
    i42 = tempRet0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i18 = i41;
   i19 = i42;
   break;
  }
  i17 = ___cxa_find_matching_catch() | 0;
  i22 = tempRet0;
  __ZNSt3__114__shared_count16__release_sharedEv(i16) | 0;
  i18 = i17;
  i19 = i22;
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i18 | 0);
 return 0;
}

function __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8;
 i10 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 26580) | 0;
 i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 26720) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] & 127](i9, i11);
 HEAP32[i6 >> 2] = i4;
 i7 = HEAP8[i1 >> 0] | 0;
 switch (i7 << 24 >> 24) {
 case 43:
 case 45:
  {
   __THREW__ = 0;
   i12 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i7 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) i13 = 8; else {
    i7 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i7 + 1;
    HEAP8[i7 >> 0] = i12;
    i14 = i1 + 1 | 0;
    i13 = 10;
   }
   break;
  }
 default:
  {
   i14 = i1;
   i13 = 10;
  }
 }
 L4 : do if ((i13 | 0) == 10) {
  i12 = i3;
  L6 : do if ((i12 - i14 | 0) > 1 ? (HEAP8[i14 >> 0] | 0) == 48 : 0) {
   i7 = i14 + 1 | 0;
   switch (HEAP8[i7 >> 0] | 0) {
   case 88:
   case 120:
    break;
   default:
    {
     i13 = 11;
     break L6;
    }
   }
   __THREW__ = 0;
   i15 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, 48) | 0;
   i16 = __THREW__;
   __THREW__ = 0;
   if (i16 & 1) {
    i13 = 8;
    break L4;
   }
   i16 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i16 + 1;
   HEAP8[i16 >> 0] = i15;
   i15 = i14 + 2 | 0;
   __THREW__ = 0;
   i16 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, HEAP8[i7 >> 0] | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i13 = 8;
    break L4;
   }
   i7 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i7 + 1;
   HEAP8[i7 >> 0] = i16;
   if (i15 >>> 0 < i3 >>> 0) {
    i16 = i15;
    while (1) {
     i7 = HEAP8[i16 >> 0] | 0;
     __THREW__ = 0;
     i17 = invoke_i(22) | 0;
     i18 = __THREW__;
     __THREW__ = 0;
     if (i18 & 1) break;
     __THREW__ = 0;
     i18 = invoke_iii(56, i7 << 24 >> 24 | 0, i17 | 0) | 0;
     i17 = __THREW__;
     __THREW__ = 0;
     if (i17 & 1) break;
     if (!i18) {
      i19 = i15;
      i20 = i16;
      break L6;
     }
     i18 = i16 + 1 | 0;
     if (i18 >>> 0 < i3 >>> 0) i16 = i18; else {
      i19 = i15;
      i20 = i18;
      break L6;
     }
    }
    i16 = ___cxa_find_matching_catch() | 0;
    i21 = i16;
    i22 = tempRet0;
    break L4;
   } else {
    i19 = i15;
    i20 = i15;
   }
  } else i13 = 11; while (0);
  L18 : do if ((i13 | 0) == 11) if (i14 >>> 0 < i3 >>> 0) {
   i16 = i14;
   while (1) {
    i18 = HEAP8[i16 >> 0] | 0;
    __THREW__ = 0;
    i17 = invoke_i(22) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) break;
    __THREW__ = 0;
    i7 = invoke_iii(57, i18 << 24 >> 24 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) break;
    if (!i7) {
     i19 = i14;
     i20 = i16;
     break L18;
    }
    i7 = i16 + 1 | 0;
    if (i7 >>> 0 < i3 >>> 0) i16 = i7; else {
     i19 = i14;
     i20 = i7;
     break L18;
    }
   }
   i16 = ___cxa_find_matching_catch() | 0;
   i21 = i16;
   i22 = tempRet0;
   break L4;
  } else {
   i19 = i14;
   i20 = i14;
  } while (0);
  i16 = HEAP8[i9 >> 0] | 0;
  i15 = i9 + 4 | 0;
  if (((i16 & 1) == 0 ? (i16 & 255) >>> 1 : HEAP32[i15 >> 2] | 0) | 0) {
   if ((i19 | 0) != (i20 | 0) ? (i16 = i20 + -1 | 0, i19 >>> 0 < i16 >>> 0) : 0) {
    i7 = i19;
    i17 = i16;
    do {
     i16 = HEAP8[i7 >> 0] | 0;
     HEAP8[i7 >> 0] = HEAP8[i17 >> 0] | 0;
     HEAP8[i17 >> 0] = i16;
     i7 = i7 + 1 | 0;
     i17 = i17 + -1 | 0;
    } while (i7 >>> 0 < i17 >>> 0);
   }
   __THREW__ = 0;
   i17 = invoke_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i13 = 8;
    break;
   }
   i7 = i9 + 8 | 0;
   i16 = i9 + 1 | 0;
   L37 : do if (i19 >>> 0 < i20 >>> 0) {
    i18 = 0;
    i23 = 0;
    i24 = i19;
    while (1) {
     i25 = HEAP8[((HEAP8[i9 >> 0] & 1) == 0 ? i16 : HEAP32[i7 >> 2] | 0) + i23 >> 0] | 0;
     if (i25 << 24 >> 24 > 0 & (i18 | 0) == (i25 << 24 >> 24 | 0)) {
      i25 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i25 + 1;
      HEAP8[i25 >> 0] = i17;
      i25 = HEAP8[i9 >> 0] | 0;
      i26 = 0;
      i27 = (i23 >>> 0 < (((i25 & 1) == 0 ? (i25 & 255) >>> 1 : HEAP32[i15 >> 2] | 0) + -1 | 0) >>> 0 & 1) + i23 | 0;
     } else {
      i26 = i18;
      i27 = i23;
     }
     __THREW__ = 0;
     i25 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, HEAP8[i24 >> 0] | 0) | 0;
     i28 = __THREW__;
     __THREW__ = 0;
     if (i28 & 1) break;
     i28 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i28 + 1;
     HEAP8[i28 >> 0] = i25;
     i24 = i24 + 1 | 0;
     if (i24 >>> 0 >= i20 >>> 0) break L37; else {
      i18 = i26 + 1 | 0;
      i23 = i27;
     }
    }
    i23 = ___cxa_find_matching_catch() | 0;
    i21 = i23;
    i22 = tempRet0;
    break L4;
   } while (0);
   i15 = i4 + (i19 - i1) | 0;
   i17 = HEAP32[i6 >> 2] | 0;
   if ((i15 | 0) != (i17 | 0) ? (i7 = i17 + -1 | 0, i15 >>> 0 < i7 >>> 0) : 0) {
    i17 = i15;
    i15 = i7;
    do {
     i7 = HEAP8[i17 >> 0] | 0;
     HEAP8[i17 >> 0] = HEAP8[i15 >> 0] | 0;
     HEAP8[i15 >> 0] = i7;
     i17 = i17 + 1 | 0;
     i15 = i15 + -1 | 0;
    } while (i17 >>> 0 < i15 >>> 0);
    i29 = i10;
   } else i29 = i10;
  } else {
   __THREW__ = 0;
   invoke_iiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i19 | 0, i20 | 0, HEAP32[i6 >> 2] | 0) | 0;
   i15 = __THREW__;
   __THREW__ = 0;
   if (i15 & 1) {
    i13 = 8;
    break;
   }
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i20 - i19);
   i29 = i10;
  }
  L50 : do if (i20 >>> 0 < i3 >>> 0) {
   i15 = i20;
   while (1) {
    i17 = HEAP8[i15 >> 0] | 0;
    if (i17 << 24 >> 24 == 46) {
     i30 = i15;
     break;
    }
    __THREW__ = 0;
    i7 = invoke_iii(HEAP32[(HEAP32[i29 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i13 = 4;
     break;
    }
    i17 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i17 + 1;
    HEAP8[i17 >> 0] = i7;
    i7 = i15 + 1 | 0;
    if (i7 >>> 0 < i3 >>> 0) i15 = i7; else {
     i31 = i7;
     break L50;
    }
   }
   if ((i13 | 0) == 4) {
    i15 = ___cxa_find_matching_catch() | 0;
    i21 = i15;
    i22 = tempRet0;
    break L4;
   }
   __THREW__ = 0;
   i15 = invoke_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i13 = 8;
    break L4;
   }
   i7 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i7 + 1;
   HEAP8[i7 >> 0] = i15;
   i31 = i30 + 1 | 0;
  } else i31 = i20; while (0);
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i31 | 0, i3 | 0, HEAP32[i6 >> 2] | 0) | 0;
  i15 = __THREW__;
  __THREW__ = 0;
  if (i15 & 1) i13 = 8; else {
   i15 = (HEAP32[i6 >> 2] | 0) + (i12 - i31) | 0;
   HEAP32[i6 >> 2] = i15;
   HEAP32[i5 >> 2] = (i2 | 0) == (i3 | 0) ? i15 : i4 + (i2 - i1) | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i8;
   return;
  }
 } while (0);
 if ((i13 | 0) == 8) {
  i13 = ___cxa_find_matching_catch() | 0;
  i21 = i13;
  i22 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i21 | 0);
}

function __ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i12 = i11 + 100 | 0;
 i13 = i11 + 88 | 0;
 i14 = i11 + 76 | 0;
 i15 = i11 + 64 | 0;
 i16 = i11 + 52 | 0;
 i17 = i11 + 48 | 0;
 i18 = i11 + 36 | 0;
 i19 = i11 + 24 | 0;
 i20 = i11 + 12 | 0;
 i21 = i11;
 do if (i1) {
  i22 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 26316) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 44 >> 2] & 127](i12, i22);
  i23 = HEAP32[i12 >> 2] | 0;
  HEAP8[i3 >> 0] = i23;
  HEAP8[i3 + 1 >> 0] = i23 >> 8;
  HEAP8[i3 + 2 >> 0] = i23 >> 16;
  HEAP8[i3 + 3 >> 0] = i23 >> 24;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 32 >> 2] & 127](i13, i22);
  if (!(HEAP8[i9 >> 0] & 1)) HEAP8[i9 >> 0] = 0; else HEAP32[HEAP32[i9 + 8 >> 2] >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  __THREW__ = 0;
  invoke_vii(71, i9 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i13);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] & 127](i14, i22);
  if (!(HEAP8[i8 >> 0] & 1)) HEAP8[i8 >> 0] = 0; else HEAP32[HEAP32[i8 + 8 >> 2] >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  __THREW__ = 0;
  invoke_vii(71, i8 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i14);
  i23 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] & 255](i22) | 0;
  HEAP32[i4 >> 2] = i23;
  i23 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] & 255](i22) | 0;
  HEAP32[i5 >> 2] = i23;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 20 >> 2] & 127](i15, i22);
  if (!(HEAP8[i6 >> 0] & 1)) {
   HEAP8[i6 + 1 >> 0] = 0;
   HEAP8[i6 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i6 + 8 >> 2] >> 0] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i6 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] & 127](i16, i22);
  if (!(HEAP8[i7 >> 0] & 1)) HEAP8[i7 >> 0] = 0; else HEAP32[HEAP32[i7 + 8 >> 2] >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  __THREW__ = 0;
  invoke_vii(71, i7 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  } else {
   HEAP32[i7 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i16);
   i24 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] & 255](i22) | 0;
   break;
  }
 } else {
  i22 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 26252) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 44 >> 2] & 127](i17, i22);
  i23 = HEAP32[i17 >> 2] | 0;
  HEAP8[i3 >> 0] = i23;
  HEAP8[i3 + 1 >> 0] = i23 >> 8;
  HEAP8[i3 + 2 >> 0] = i23 >> 16;
  HEAP8[i3 + 3 >> 0] = i23 >> 24;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 32 >> 2] & 127](i18, i22);
  if (!(HEAP8[i9 >> 0] & 1)) HEAP8[i9 >> 0] = 0; else HEAP32[HEAP32[i9 + 8 >> 2] >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  __THREW__ = 0;
  invoke_vii(71, i9 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i9 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i18);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] & 127](i19, i22);
  if (!(HEAP8[i8 >> 0] & 1)) HEAP8[i8 >> 0] = 0; else HEAP32[HEAP32[i8 + 8 >> 2] >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  __THREW__ = 0;
  invoke_vii(71, i8 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i8 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i19);
  i23 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] & 255](i22) | 0;
  HEAP32[i4 >> 2] = i23;
  i23 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] & 255](i22) | 0;
  HEAP32[i5 >> 2] = i23;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 20 >> 2] & 127](i20, i22);
  if (!(HEAP8[i6 >> 0] & 1)) {
   HEAP8[i6 + 1 >> 0] = 0;
   HEAP8[i6 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i6 + 8 >> 2] >> 0] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
  }
  __THREW__ = 0;
  invoke_vii(69, i6 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  };
  HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] & 127](i21, i22);
  if (!(HEAP8[i7 >> 0] & 1)) HEAP8[i7 >> 0] = 0; else HEAP32[HEAP32[i7 + 8 >> 2] >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  __THREW__ = 0;
  invoke_vii(71, i7 | 0, 0);
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i23 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i23);
  } else {
   HEAP32[i7 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i21);
   i24 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] & 255](i22) | 0;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i24;
 STACKTOP = i11;
 return;
}
function __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0;
 HEAP32[i3 >> 2] = i1;
 i16 = i14 + 4 | 0;
 i17 = i14 + 8 | 0;
 i18 = i14 + 1 | 0;
 i19 = i13 + 4 | 0;
 i20 = (i4 & 512 | 0) == 0;
 i21 = i13 + 8 | 0;
 i22 = i13 + 1 | 0;
 i23 = i7 + 8 | 0;
 i24 = (i15 | 0) > 0;
 i25 = i12 + 4 | 0;
 i26 = i12 + 8 | 0;
 i27 = i12 + 1 | 0;
 i28 = i15 + 1 | 0;
 i29 = -2 - i15 - ((i15 | 0) < 0 ? ~i15 : -1) | 0;
 i30 = (i15 | 0) > 0;
 i31 = i5;
 i5 = 0;
 while (1) {
  switch (HEAP8[i9 + i5 >> 0] | 0) {
  case 0:
   {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i32 = i31;
    break;
   }
  case 1:
   {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i33 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 63](i7, 32) | 0;
    i34 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 >> 2] = i34 + 1;
    HEAP8[i34 >> 0] = i33;
    i32 = i31;
    break;
   }
  case 3:
   {
    i33 = HEAP8[i14 >> 0] | 0;
    i34 = (i33 & 1) == 0;
    if (!((i34 ? (i33 & 255) >>> 1 : HEAP32[i16 >> 2] | 0) | 0)) i32 = i31; else {
     i33 = HEAP8[(i34 ? i18 : HEAP32[i17 >> 2] | 0) >> 0] | 0;
     i34 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = i34 + 1;
     HEAP8[i34 >> 0] = i33;
     i32 = i31;
    }
    break;
   }
  case 2:
   {
    i33 = HEAP8[i13 >> 0] | 0;
    i34 = (i33 & 1) == 0;
    i35 = i34 ? (i33 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
    if (i20 | (i35 | 0) == 0) i32 = i31; else {
     i33 = i34 ? i22 : HEAP32[i21 >> 2] | 0;
     i34 = i33 + i35 | 0;
     i36 = HEAP32[i3 >> 2] | 0;
     if (!i35) i37 = i36; else {
      i35 = i36;
      i36 = i33;
      while (1) {
       HEAP8[i35 >> 0] = HEAP8[i36 >> 0] | 0;
       i36 = i36 + 1 | 0;
       i33 = i35 + 1 | 0;
       if ((i36 | 0) == (i34 | 0)) {
        i37 = i33;
        break;
       } else i35 = i33;
      }
     }
     HEAP32[i3 >> 2] = i37;
     i32 = i31;
    }
    break;
   }
  case 4:
   {
    i35 = HEAP32[i3 >> 2] | 0;
    i34 = i8 ? i31 + 1 | 0 : i31;
    i36 = i34;
    i33 = HEAP32[i23 >> 2] | 0;
    L15 : do if (i34 >>> 0 < i6 >>> 0) {
     i38 = i34;
     while (1) {
      i39 = HEAP8[i38 >> 0] | 0;
      if (i39 << 24 >> 24 <= -1) {
       i40 = i38;
       break L15;
      }
      if (!(HEAP16[i33 + (i39 << 24 >> 24 << 1) >> 1] & 2048)) {
       i40 = i38;
       break L15;
      }
      i39 = i38 + 1 | 0;
      if (i39 >>> 0 < i6 >>> 0) i38 = i39; else {
       i40 = i39;
       break;
      }
     }
    } else i40 = i34; while (0);
    i33 = i40;
    if (i24) {
     i38 = -2 - i33 - ~(i33 >>> 0 > i36 >>> 0 ? i36 : i33) | 0;
     i33 = i29 >>> 0 > i38 >>> 0 ? i29 : i38;
     if (i40 >>> 0 > i34 >>> 0 & i30) {
      i38 = i40;
      i39 = i15;
      while (1) {
       i38 = i38 + -1 | 0;
       i41 = HEAP8[i38 >> 0] | 0;
       i42 = HEAP32[i3 >> 2] | 0;
       HEAP32[i3 >> 2] = i42 + 1;
       HEAP8[i42 >> 0] = i41;
       i41 = (i39 | 0) > 1;
       if (!(i38 >>> 0 > i34 >>> 0 & i41)) {
        i43 = i41;
        break;
       } else i39 = i39 + -1 | 0;
      }
     } else i43 = i30;
     i39 = i28 + i33 | 0;
     i38 = i40 + (i33 + 1) | 0;
     if (i43) i44 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 63](i7, 48) | 0; else i44 = 0;
     i36 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = i36 + 1;
     if ((i39 | 0) > 0) {
      i41 = i36;
      i42 = i39;
      while (1) {
       HEAP8[i41 >> 0] = i44;
       i39 = HEAP32[i3 >> 2] | 0;
       HEAP32[i3 >> 2] = i39 + 1;
       if ((i42 | 0) > 1) {
        i41 = i39;
        i42 = i42 + -1 | 0;
       } else {
        i45 = i39;
        break;
       }
      }
     } else i45 = i36;
     HEAP8[i45 >> 0] = i10;
     i46 = i38;
    } else i46 = i40;
    if ((i46 | 0) != (i34 | 0)) {
     i42 = HEAP8[i12 >> 0] | 0;
     i41 = (i42 & 1) == 0;
     if (!((i41 ? (i42 & 255) >>> 1 : HEAP32[i25 >> 2] | 0) | 0)) i47 = -1; else i47 = HEAP8[(i41 ? i27 : HEAP32[i26 >> 2] | 0) >> 0] | 0;
     if ((i46 | 0) != (i34 | 0)) {
      i41 = i46;
      i42 = i47;
      i33 = 0;
      i39 = 0;
      while (1) {
       if ((i39 | 0) == (i42 | 0)) {
        i48 = HEAP32[i3 >> 2] | 0;
        HEAP32[i3 >> 2] = i48 + 1;
        HEAP8[i48 >> 0] = i11;
        i48 = i33 + 1 | 0;
        i49 = HEAP8[i12 >> 0] | 0;
        i50 = (i49 & 1) == 0;
        if (i48 >>> 0 < (i50 ? (i49 & 255) >>> 1 : HEAP32[i25 >> 2] | 0) >>> 0) {
         i49 = HEAP8[(i50 ? i27 : HEAP32[i26 >> 2] | 0) + i48 >> 0] | 0;
         i51 = i49 << 24 >> 24 == 127 ? -1 : i49 << 24 >> 24;
         i52 = i48;
         i53 = 0;
        } else {
         i51 = i39;
         i52 = i48;
         i53 = 0;
        }
       } else {
        i51 = i42;
        i52 = i33;
        i53 = i39;
       }
       i41 = i41 + -1 | 0;
       i48 = HEAP8[i41 >> 0] | 0;
       i49 = HEAP32[i3 >> 2] | 0;
       HEAP32[i3 >> 2] = i49 + 1;
       HEAP8[i49 >> 0] = i48;
       if ((i41 | 0) == (i34 | 0)) break; else {
        i42 = i51;
        i33 = i52;
        i39 = i53 + 1 | 0;
       }
      }
     }
    } else {
     i39 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 63](i7, 48) | 0;
     i33 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = i33 + 1;
     HEAP8[i33 >> 0] = i39;
    }
    i39 = HEAP32[i3 >> 2] | 0;
    if ((i35 | 0) != (i39 | 0) ? (i33 = i39 + -1 | 0, i35 >>> 0 < i33 >>> 0) : 0) {
     i39 = i35;
     i42 = i33;
     do {
      i33 = HEAP8[i39 >> 0] | 0;
      HEAP8[i39 >> 0] = HEAP8[i42 >> 0] | 0;
      HEAP8[i42 >> 0] = i33;
      i39 = i39 + 1 | 0;
      i42 = i42 + -1 | 0;
     } while (i39 >>> 0 < i42 >>> 0);
     i32 = i34;
    } else i32 = i34;
    break;
   }
  default:
   i32 = i31;
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == 4) break; else i31 = i32;
 }
 i32 = HEAP8[i14 >> 0] | 0;
 i14 = (i32 & 1) == 0;
 i31 = i14 ? (i32 & 255) >>> 1 : HEAP32[i16 >> 2] | 0;
 if (i31 >>> 0 > 1) {
  i16 = i14 ? i18 : HEAP32[i17 >> 2] | 0;
  i17 = i16 + i31 | 0;
  i18 = HEAP32[i3 >> 2] | 0;
  if ((i31 | 0) == 1) i54 = i18; else {
   i31 = i18;
   i18 = i16 + 1 | 0;
   while (1) {
    HEAP8[i31 >> 0] = HEAP8[i18 >> 0] | 0;
    i16 = i31 + 1 | 0;
    i18 = i18 + 1 | 0;
    if ((i18 | 0) == (i17 | 0)) {
     i54 = i16;
     break;
    } else i31 = i16;
   }
  }
  HEAP32[i3 >> 2] = i54;
 }
 switch (i4 & 176 | 0) {
 case 32:
  {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   break;
  }
 case 16:
  break;
 default:
  HEAP32[i2 >> 2] = i1;
 }
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, d44 = 0.0, i45 = 0, i46 = 0, i47 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 40 | 0;
 i9 = i1 + 36 | 0;
 i10 = i1 + 24 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 48 | 0;
 i14 = i1 + 4 | 0;
 i15 = i1;
 i16 = i1 + 337 | 0;
 i17 = i1 + 336 | 0;
 __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i10, i4, i7, i8, i9);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 if (!(HEAP8[i11 >> 0] & 1)) i18 = 10; else i18 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i11 | 0, i18 | 0, 0);
 i18 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i18 & 1)) {
  i4 = i11 + 8 | 0;
  i19 = i11 + 1 | 0;
  i20 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = i20;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i15 >> 2] = 0;
  HEAP8[i16 >> 0] = 1;
  HEAP8[i17 >> 0] = 69;
  i21 = i11 + 4 | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i23 = HEAP32[i9 >> 2] | 0;
  i24 = HEAP32[i2 >> 2] | 0;
  i25 = i20;
  L6 : while (1) {
   if (i24) {
    i20 = HEAP32[i24 + 12 >> 2] | 0;
    if ((i20 | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i26 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i28 = 25;
      break;
     } else i29 = i26;
    } else i29 = HEAP32[i20 >> 2] | 0;
    if ((i29 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i30 = 0;
     i31 = 1;
    } else {
     i30 = i24;
     i31 = 0;
    }
   } else {
    i30 = 0;
    i31 = 1;
   }
   i20 = HEAP32[i3 >> 2] | 0;
   do if (i20) {
    i26 = HEAP32[i20 + 12 >> 2] | 0;
    if ((i26 | 0) == (HEAP32[i20 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i27 = invoke_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 36 >> 2] | 0, i20 | 0) | 0;
     i32 = __THREW__;
     __THREW__ = 0;
     if (i32 & 1) {
      i28 = 25;
      break L6;
     } else i33 = i27;
    } else i33 = HEAP32[i26 >> 2] | 0;
    if ((i33 | 0) != -1) if (i31) {
     i34 = i20;
     break;
    } else {
     i35 = i30;
     i36 = i20;
     i37 = i25;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i28 = 17;
     break;
    }
   } else i28 = 17; while (0);
   if ((i28 | 0) == 17) {
    i28 = 0;
    if (i31) {
     i35 = i30;
     i36 = 0;
     i37 = i25;
     break;
    } else i34 = 0;
   }
   i20 = HEAP8[i11 >> 0] | 0;
   i26 = (i20 & 1) == 0 ? (i20 & 255) >>> 1 : HEAP32[i21 >> 2] | 0;
   if ((HEAP32[i12 >> 2] | 0) == (i25 + i26 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i26 << 1 | 0, 0);
    i20 = __THREW__;
    __THREW__ = 0;
    if (i20 & 1) {
     i28 = 25;
     break;
    }
    if (!(HEAP8[i11 >> 0] & 1)) i38 = 10; else i38 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i38 | 0, 0);
    i20 = __THREW__;
    __THREW__ = 0;
    if (i20 & 1) {
     i28 = 25;
     break;
    }
    i20 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
    HEAP32[i12 >> 2] = i20 + i26;
    i39 = i20;
   } else i39 = i25;
   i20 = i30 + 12 | 0;
   i26 = HEAP32[i20 >> 2] | 0;
   i27 = i30 + 16 | 0;
   if ((i26 | 0) == (HEAP32[i27 >> 2] | 0)) {
    __THREW__ = 0;
    i32 = invoke_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 36 >> 2] | 0, i30 | 0) | 0;
    i40 = __THREW__;
    __THREW__ = 0;
    if (i40 & 1) {
     i28 = 25;
     break;
    } else i41 = i32;
   } else i41 = HEAP32[i26 >> 2] | 0;
   if (__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i41, i16, i17, i39, i12, i22, i23, i10, i13, i14, i15, i7) | 0) {
    i35 = i30;
    i36 = i34;
    i37 = i39;
    break;
   }
   i26 = HEAP32[i20 >> 2] | 0;
   if ((i26 | 0) == (HEAP32[i27 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 40 >> 2] | 0, i30 | 0) | 0;
    i27 = __THREW__;
    __THREW__ = 0;
    if (i27 & 1) {
     i28 = 25;
     break;
    } else {
     i24 = i30;
     i25 = i39;
     continue;
    }
   } else {
    HEAP32[i20 >> 2] = i26 + 4;
    i24 = i30;
    i25 = i39;
    continue;
   }
  }
  if ((i28 | 0) == 25) {
   i25 = ___cxa_find_matching_catch() | 0;
   i42 = i25;
   i43 = tempRet0;
   break;
  }
  i25 = HEAP8[i10 >> 0] | 0;
  if (!((HEAP8[i16 >> 0] | 0) == 0 ? 1 : (((i25 & 1) == 0 ? (i25 & 255) >>> 1 : HEAP32[i10 + 4 >> 2] | 0) | 0) == 0) ? (i25 = HEAP32[i14 >> 2] | 0, (i25 - i13 | 0) < 160) : 0) {
   i24 = HEAP32[i15 >> 2] | 0;
   HEAP32[i14 >> 2] = i25 + 4;
   HEAP32[i25 >> 2] = i24;
  }
  __THREW__ = 0;
  d44 = +invoke_diii(3, i37 | 0, HEAP32[i12 >> 2] | 0, i5 | 0);
  i24 = __THREW__;
  __THREW__ = 0;
  if (!(i24 & 1)) {
   HEAPF32[i6 >> 2] = d44;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i10, i13, HEAP32[i14 >> 2] | 0, i5);
   if (i35) {
    i24 = HEAP32[i35 + 12 >> 2] | 0;
    if ((i24 | 0) == (HEAP32[i35 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i25 = invoke_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 36 >> 2] | 0, i35 | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i28 = 26;
      break;
     } else i45 = i25;
    } else i45 = HEAP32[i24 >> 2] | 0;
    if ((i45 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i46 = 1;
    } else i46 = 0;
   } else i46 = 1;
   do if (i36) {
    i24 = HEAP32[i36 + 12 >> 2] | 0;
    if ((i24 | 0) == (HEAP32[i36 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i25 = invoke_ii(HEAP32[(HEAP32[i36 >> 2] | 0) + 36 >> 2] | 0, i36 | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i28 = 26;
      break L4;
     } else i47 = i25;
    } else i47 = HEAP32[i24 >> 2] | 0;
    if ((i47 | 0) != -1) if (i46) break; else {
     i28 = 53;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i28 = 51;
     break;
    }
   } else i28 = 51; while (0);
   if ((i28 | 0) == 51 ? i46 : 0) i28 = 53;
   if ((i28 | 0) == 53) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i24 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   STACKTOP = i1;
   return i24 | 0;
  } else i28 = 26;
 } else i28 = 26; while (0);
 if ((i28 | 0) == 26) {
  i28 = ___cxa_find_matching_catch() | 0;
  i42 = i28;
  i43 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 ___resumeException(i42 | 0);
 return 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, d44 = 0.0, i45 = 0, i46 = 0, i47 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 40 | 0;
 i9 = i1 + 36 | 0;
 i10 = i1 + 24 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 48 | 0;
 i14 = i1 + 4 | 0;
 i15 = i1;
 i16 = i1 + 337 | 0;
 i17 = i1 + 336 | 0;
 __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i10, i4, i7, i8, i9);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 if (!(HEAP8[i11 >> 0] & 1)) i18 = 10; else i18 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i11 | 0, i18 | 0, 0);
 i18 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i18 & 1)) {
  i4 = i11 + 8 | 0;
  i19 = i11 + 1 | 0;
  i20 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = i20;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i15 >> 2] = 0;
  HEAP8[i16 >> 0] = 1;
  HEAP8[i17 >> 0] = 69;
  i21 = i11 + 4 | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i23 = HEAP32[i9 >> 2] | 0;
  i24 = HEAP32[i2 >> 2] | 0;
  i25 = i20;
  L6 : while (1) {
   if (i24) {
    i20 = HEAP32[i24 + 12 >> 2] | 0;
    if ((i20 | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i26 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i28 = 25;
      break;
     } else i29 = i26;
    } else i29 = HEAP32[i20 >> 2] | 0;
    if ((i29 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i30 = 0;
     i31 = 1;
    } else {
     i30 = i24;
     i31 = 0;
    }
   } else {
    i30 = 0;
    i31 = 1;
   }
   i20 = HEAP32[i3 >> 2] | 0;
   do if (i20) {
    i26 = HEAP32[i20 + 12 >> 2] | 0;
    if ((i26 | 0) == (HEAP32[i20 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i27 = invoke_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 36 >> 2] | 0, i20 | 0) | 0;
     i32 = __THREW__;
     __THREW__ = 0;
     if (i32 & 1) {
      i28 = 25;
      break L6;
     } else i33 = i27;
    } else i33 = HEAP32[i26 >> 2] | 0;
    if ((i33 | 0) != -1) if (i31) {
     i34 = i20;
     break;
    } else {
     i35 = i30;
     i36 = i20;
     i37 = i25;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i28 = 17;
     break;
    }
   } else i28 = 17; while (0);
   if ((i28 | 0) == 17) {
    i28 = 0;
    if (i31) {
     i35 = i30;
     i36 = 0;
     i37 = i25;
     break;
    } else i34 = 0;
   }
   i20 = HEAP8[i11 >> 0] | 0;
   i26 = (i20 & 1) == 0 ? (i20 & 255) >>> 1 : HEAP32[i21 >> 2] | 0;
   if ((HEAP32[i12 >> 2] | 0) == (i25 + i26 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i26 << 1 | 0, 0);
    i20 = __THREW__;
    __THREW__ = 0;
    if (i20 & 1) {
     i28 = 25;
     break;
    }
    if (!(HEAP8[i11 >> 0] & 1)) i38 = 10; else i38 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i38 | 0, 0);
    i20 = __THREW__;
    __THREW__ = 0;
    if (i20 & 1) {
     i28 = 25;
     break;
    }
    i20 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
    HEAP32[i12 >> 2] = i20 + i26;
    i39 = i20;
   } else i39 = i25;
   i20 = i30 + 12 | 0;
   i26 = HEAP32[i20 >> 2] | 0;
   i27 = i30 + 16 | 0;
   if ((i26 | 0) == (HEAP32[i27 >> 2] | 0)) {
    __THREW__ = 0;
    i32 = invoke_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 36 >> 2] | 0, i30 | 0) | 0;
    i40 = __THREW__;
    __THREW__ = 0;
    if (i40 & 1) {
     i28 = 25;
     break;
    } else i41 = i32;
   } else i41 = HEAP32[i26 >> 2] | 0;
   if (__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i41, i16, i17, i39, i12, i22, i23, i10, i13, i14, i15, i7) | 0) {
    i35 = i30;
    i36 = i34;
    i37 = i39;
    break;
   }
   i26 = HEAP32[i20 >> 2] | 0;
   if ((i26 | 0) == (HEAP32[i27 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 40 >> 2] | 0, i30 | 0) | 0;
    i27 = __THREW__;
    __THREW__ = 0;
    if (i27 & 1) {
     i28 = 25;
     break;
    } else {
     i24 = i30;
     i25 = i39;
     continue;
    }
   } else {
    HEAP32[i20 >> 2] = i26 + 4;
    i24 = i30;
    i25 = i39;
    continue;
   }
  }
  if ((i28 | 0) == 25) {
   i25 = ___cxa_find_matching_catch() | 0;
   i42 = i25;
   i43 = tempRet0;
   break;
  }
  i25 = HEAP8[i10 >> 0] | 0;
  if (!((HEAP8[i16 >> 0] | 0) == 0 ? 1 : (((i25 & 1) == 0 ? (i25 & 255) >>> 1 : HEAP32[i10 + 4 >> 2] | 0) | 0) == 0) ? (i25 = HEAP32[i14 >> 2] | 0, (i25 - i13 | 0) < 160) : 0) {
   i24 = HEAP32[i15 >> 2] | 0;
   HEAP32[i14 >> 2] = i25 + 4;
   HEAP32[i25 >> 2] = i24;
  }
  __THREW__ = 0;
  d44 = +invoke_diii(5, i37 | 0, HEAP32[i12 >> 2] | 0, i5 | 0);
  i24 = __THREW__;
  __THREW__ = 0;
  if (!(i24 & 1)) {
   HEAPF64[i6 >> 3] = d44;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i10, i13, HEAP32[i14 >> 2] | 0, i5);
   if (i35) {
    i24 = HEAP32[i35 + 12 >> 2] | 0;
    if ((i24 | 0) == (HEAP32[i35 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i25 = invoke_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 36 >> 2] | 0, i35 | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i28 = 26;
      break;
     } else i45 = i25;
    } else i45 = HEAP32[i24 >> 2] | 0;
    if ((i45 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i46 = 1;
    } else i46 = 0;
   } else i46 = 1;
   do if (i36) {
    i24 = HEAP32[i36 + 12 >> 2] | 0;
    if ((i24 | 0) == (HEAP32[i36 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i25 = invoke_ii(HEAP32[(HEAP32[i36 >> 2] | 0) + 36 >> 2] | 0, i36 | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i28 = 26;
      break L4;
     } else i47 = i25;
    } else i47 = HEAP32[i24 >> 2] | 0;
    if ((i47 | 0) != -1) if (i46) break; else {
     i28 = 53;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i28 = 51;
     break;
    }
   } else i28 = 51; while (0);
   if ((i28 | 0) == 51 ? i46 : 0) i28 = 53;
   if ((i28 | 0) == 53) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i24 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   STACKTOP = i1;
   return i24 | 0;
  } else i28 = 26;
 } else i28 = 26; while (0);
 if ((i28 | 0) == 26) {
  i28 = ___cxa_find_matching_catch() | 0;
  i42 = i28;
  i43 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 ___resumeException(i42 | 0);
 return 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, d44 = 0.0, i45 = 0, i46 = 0, i47 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 40 | 0;
 i9 = i1 + 36 | 0;
 i10 = i1 + 24 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 48 | 0;
 i14 = i1 + 4 | 0;
 i15 = i1;
 i16 = i1 + 337 | 0;
 i17 = i1 + 336 | 0;
 __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i10, i4, i7, i8, i9);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 if (!(HEAP8[i11 >> 0] & 1)) i18 = 10; else i18 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i11 | 0, i18 | 0, 0);
 i18 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i18 & 1)) {
  i4 = i11 + 8 | 0;
  i19 = i11 + 1 | 0;
  i20 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = i20;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i15 >> 2] = 0;
  HEAP8[i16 >> 0] = 1;
  HEAP8[i17 >> 0] = 69;
  i21 = i11 + 4 | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i23 = HEAP32[i9 >> 2] | 0;
  i24 = HEAP32[i2 >> 2] | 0;
  i25 = i20;
  L6 : while (1) {
   if (i24) {
    i20 = HEAP32[i24 + 12 >> 2] | 0;
    if ((i20 | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i26 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i28 = 25;
      break;
     } else i29 = i26;
    } else i29 = HEAP32[i20 >> 2] | 0;
    if ((i29 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i30 = 0;
     i31 = 1;
    } else {
     i30 = i24;
     i31 = 0;
    }
   } else {
    i30 = 0;
    i31 = 1;
   }
   i20 = HEAP32[i3 >> 2] | 0;
   do if (i20) {
    i26 = HEAP32[i20 + 12 >> 2] | 0;
    if ((i26 | 0) == (HEAP32[i20 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i27 = invoke_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 36 >> 2] | 0, i20 | 0) | 0;
     i32 = __THREW__;
     __THREW__ = 0;
     if (i32 & 1) {
      i28 = 25;
      break L6;
     } else i33 = i27;
    } else i33 = HEAP32[i26 >> 2] | 0;
    if ((i33 | 0) != -1) if (i31) {
     i34 = i20;
     break;
    } else {
     i35 = i30;
     i36 = i20;
     i37 = i25;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i28 = 17;
     break;
    }
   } else i28 = 17; while (0);
   if ((i28 | 0) == 17) {
    i28 = 0;
    if (i31) {
     i35 = i30;
     i36 = 0;
     i37 = i25;
     break;
    } else i34 = 0;
   }
   i20 = HEAP8[i11 >> 0] | 0;
   i26 = (i20 & 1) == 0 ? (i20 & 255) >>> 1 : HEAP32[i21 >> 2] | 0;
   if ((HEAP32[i12 >> 2] | 0) == (i25 + i26 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i26 << 1 | 0, 0);
    i20 = __THREW__;
    __THREW__ = 0;
    if (i20 & 1) {
     i28 = 25;
     break;
    }
    if (!(HEAP8[i11 >> 0] & 1)) i38 = 10; else i38 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i38 | 0, 0);
    i20 = __THREW__;
    __THREW__ = 0;
    if (i20 & 1) {
     i28 = 25;
     break;
    }
    i20 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
    HEAP32[i12 >> 2] = i20 + i26;
    i39 = i20;
   } else i39 = i25;
   i20 = i30 + 12 | 0;
   i26 = HEAP32[i20 >> 2] | 0;
   i27 = i30 + 16 | 0;
   if ((i26 | 0) == (HEAP32[i27 >> 2] | 0)) {
    __THREW__ = 0;
    i32 = invoke_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 36 >> 2] | 0, i30 | 0) | 0;
    i40 = __THREW__;
    __THREW__ = 0;
    if (i40 & 1) {
     i28 = 25;
     break;
    } else i41 = i32;
   } else i41 = HEAP32[i26 >> 2] | 0;
   if (__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i41, i16, i17, i39, i12, i22, i23, i10, i13, i14, i15, i7) | 0) {
    i35 = i30;
    i36 = i34;
    i37 = i39;
    break;
   }
   i26 = HEAP32[i20 >> 2] | 0;
   if ((i26 | 0) == (HEAP32[i27 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 40 >> 2] | 0, i30 | 0) | 0;
    i27 = __THREW__;
    __THREW__ = 0;
    if (i27 & 1) {
     i28 = 25;
     break;
    } else {
     i24 = i30;
     i25 = i39;
     continue;
    }
   } else {
    HEAP32[i20 >> 2] = i26 + 4;
    i24 = i30;
    i25 = i39;
    continue;
   }
  }
  if ((i28 | 0) == 25) {
   i25 = ___cxa_find_matching_catch() | 0;
   i42 = i25;
   i43 = tempRet0;
   break;
  }
  i25 = HEAP8[i10 >> 0] | 0;
  if (!((HEAP8[i16 >> 0] | 0) == 0 ? 1 : (((i25 & 1) == 0 ? (i25 & 255) >>> 1 : HEAP32[i10 + 4 >> 2] | 0) | 0) == 0) ? (i25 = HEAP32[i14 >> 2] | 0, (i25 - i13 | 0) < 160) : 0) {
   i24 = HEAP32[i15 >> 2] | 0;
   HEAP32[i14 >> 2] = i25 + 4;
   HEAP32[i25 >> 2] = i24;
  }
  __THREW__ = 0;
  d44 = +invoke_diii(4, i37 | 0, HEAP32[i12 >> 2] | 0, i5 | 0);
  i24 = __THREW__;
  __THREW__ = 0;
  if (!(i24 & 1)) {
   HEAPF64[i6 >> 3] = d44;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i10, i13, HEAP32[i14 >> 2] | 0, i5);
   if (i35) {
    i24 = HEAP32[i35 + 12 >> 2] | 0;
    if ((i24 | 0) == (HEAP32[i35 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i25 = invoke_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 36 >> 2] | 0, i35 | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i28 = 26;
      break;
     } else i45 = i25;
    } else i45 = HEAP32[i24 >> 2] | 0;
    if ((i45 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i46 = 1;
    } else i46 = 0;
   } else i46 = 1;
   do if (i36) {
    i24 = HEAP32[i36 + 12 >> 2] | 0;
    if ((i24 | 0) == (HEAP32[i36 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i25 = invoke_ii(HEAP32[(HEAP32[i36 >> 2] | 0) + 36 >> 2] | 0, i36 | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i28 = 26;
      break L4;
     } else i47 = i25;
    } else i47 = HEAP32[i24 >> 2] | 0;
    if ((i47 | 0) != -1) if (i46) break; else {
     i28 = 53;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i28 = 51;
     break;
    }
   } else i28 = 51; while (0);
   if ((i28 | 0) == 51 ? i46 : 0) i28 = 53;
   if ((i28 | 0) == 53) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i24 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   STACKTOP = i1;
   return i24 | 0;
  } else i28 = 26;
 } else i28 = 26; while (0);
 if ((i28 | 0) == 26) {
  i28 = ___cxa_find_matching_catch() | 0;
  i42 = i28;
  i43 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 ___resumeException(i42 | 0);
 return 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP32[i8 >> 2] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) {
    i18 = HEAP32[i21 + 12 >> 2] | 0;
    if ((i18 | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i23 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i25 = 25;
      break;
     } else i26 = i23;
    } else i26 = HEAP32[i18 >> 2] | 0;
    if ((i26 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i27 = 0;
     i28 = 1;
    } else {
     i27 = i21;
     i28 = 0;
    }
   } else {
    i27 = 0;
    i28 = 1;
   }
   i18 = HEAP32[i3 >> 2] | 0;
   do if (i18) {
    i23 = HEAP32[i18 + 12 >> 2] | 0;
    if ((i23 | 0) == (HEAP32[i18 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0, i18 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) {
      i25 = 25;
      break L6;
     } else i30 = i24;
    } else i30 = HEAP32[i23 >> 2] | 0;
    if ((i30 | 0) != -1) if (i28) {
     i31 = i18;
     break;
    } else {
     i32 = i27;
     i33 = i18;
     i34 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 17;
     break;
    }
   } else i25 = 17; while (0);
   if ((i25 | 0) == 17) {
    i25 = 0;
    if (i28) {
     i32 = i27;
     i33 = 0;
     i34 = i22;
     break;
    } else i31 = 0;
   }
   i18 = HEAP8[i10 >> 0] | 0;
   i23 = (i18 & 1) == 0 ? (i18 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i23 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i23 << 1 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i35 = 10; else i35 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i35 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i18 + i23;
    i36 = i18;
   } else i36 = i22;
   i18 = i27 + 12 | 0;
   i23 = HEAP32[i18 >> 2] | 0;
   i24 = i27 + 16 | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    i29 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i37 = __THREW__;
    __THREW__ = 0;
    if (i37 & 1) {
     i25 = 25;
     break;
    } else i38 = i29;
   } else i38 = HEAP32[i23 >> 2] | 0;
   if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i38, i15, i36, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i32 = i27;
    i33 = i31;
    i34 = i36;
    break;
   }
   i23 = HEAP32[i18 >> 2] | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 40 >> 2] | 0, i27 | 0) | 0;
    i24 = __THREW__;
    __THREW__ = 0;
    if (i24 & 1) {
     i25 = 25;
     break;
    } else {
     i21 = i27;
     i22 = i36;
     continue;
    }
   } else {
    HEAP32[i18 >> 2] = i23 + 4;
    i21 = i27;
    i22 = i36;
    continue;
   }
  }
  if ((i25 | 0) == 25) {
   i22 = ___cxa_find_matching_catch() | 0;
   i39 = i22;
   i40 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(19, i34 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = tempRet0;
  i20 = __THREW__;
  __THREW__ = 0;
  if (!(i20 & 1)) {
   i20 = i6;
   HEAP32[i20 >> 2] = i21;
   HEAP32[i20 + 4 >> 2] = i22;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i32) {
    i22 = HEAP32[i32 + 12 >> 2] | 0;
    if ((i22 | 0) == (HEAP32[i32 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i20 = invoke_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i25 = 26;
      break;
     } else i41 = i20;
    } else i41 = HEAP32[i22 >> 2] | 0;
    if ((i41 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i42 = 1;
    } else i42 = 0;
   } else i42 = 1;
   do if (i33) {
    i22 = HEAP32[i33 + 12 >> 2] | 0;
    if ((i22 | 0) == (HEAP32[i33 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i20 = invoke_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 36 >> 2] | 0, i33 | 0) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i25 = 26;
      break L4;
     } else i43 = i20;
    } else i43 = HEAP32[i22 >> 2] | 0;
    if ((i43 | 0) != -1) if (i42) break; else {
     i25 = 53;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 51;
     break;
    }
   } else i25 = 51; while (0);
   if ((i25 | 0) == 51 ? i42 : 0) i25 = 53;
   if ((i25 | 0) == 53) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i22 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i22 | 0;
  } else i25 = 26;
 } else i25 = 26; while (0);
 if ((i25 | 0) == 26) {
  i25 = ___cxa_find_matching_catch() | 0;
  i39 = i25;
  i40 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i39 | 0);
 return 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP32[i8 >> 2] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) {
    i18 = HEAP32[i21 + 12 >> 2] | 0;
    if ((i18 | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i23 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i25 = 25;
      break;
     } else i26 = i23;
    } else i26 = HEAP32[i18 >> 2] | 0;
    if ((i26 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i27 = 0;
     i28 = 1;
    } else {
     i27 = i21;
     i28 = 0;
    }
   } else {
    i27 = 0;
    i28 = 1;
   }
   i18 = HEAP32[i3 >> 2] | 0;
   do if (i18) {
    i23 = HEAP32[i18 + 12 >> 2] | 0;
    if ((i23 | 0) == (HEAP32[i18 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0, i18 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) {
      i25 = 25;
      break L6;
     } else i30 = i24;
    } else i30 = HEAP32[i23 >> 2] | 0;
    if ((i30 | 0) != -1) if (i28) {
     i31 = i18;
     break;
    } else {
     i32 = i27;
     i33 = i18;
     i34 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 17;
     break;
    }
   } else i25 = 17; while (0);
   if ((i25 | 0) == 17) {
    i25 = 0;
    if (i28) {
     i32 = i27;
     i33 = 0;
     i34 = i22;
     break;
    } else i31 = 0;
   }
   i18 = HEAP8[i10 >> 0] | 0;
   i23 = (i18 & 1) == 0 ? (i18 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i23 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i23 << 1 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i35 = 10; else i35 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i35 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i18 + i23;
    i36 = i18;
   } else i36 = i22;
   i18 = i27 + 12 | 0;
   i23 = HEAP32[i18 >> 2] | 0;
   i24 = i27 + 16 | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    i29 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i37 = __THREW__;
    __THREW__ = 0;
    if (i37 & 1) {
     i25 = 25;
     break;
    } else i38 = i29;
   } else i38 = HEAP32[i23 >> 2] | 0;
   if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i38, i15, i36, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i32 = i27;
    i33 = i31;
    i34 = i36;
    break;
   }
   i23 = HEAP32[i18 >> 2] | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 40 >> 2] | 0, i27 | 0) | 0;
    i24 = __THREW__;
    __THREW__ = 0;
    if (i24 & 1) {
     i25 = 25;
     break;
    } else {
     i21 = i27;
     i22 = i36;
     continue;
    }
   } else {
    HEAP32[i18 >> 2] = i23 + 4;
    i21 = i27;
    i22 = i36;
    continue;
   }
  }
  if ((i25 | 0) == 25) {
   i22 = ___cxa_find_matching_catch() | 0;
   i39 = i22;
   i40 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(15, i34 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = tempRet0;
  i20 = __THREW__;
  __THREW__ = 0;
  if (!(i20 & 1)) {
   i20 = i6;
   HEAP32[i20 >> 2] = i21;
   HEAP32[i20 + 4 >> 2] = i22;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i32) {
    i22 = HEAP32[i32 + 12 >> 2] | 0;
    if ((i22 | 0) == (HEAP32[i32 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i20 = invoke_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i25 = 26;
      break;
     } else i41 = i20;
    } else i41 = HEAP32[i22 >> 2] | 0;
    if ((i41 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i42 = 1;
    } else i42 = 0;
   } else i42 = 1;
   do if (i33) {
    i22 = HEAP32[i33 + 12 >> 2] | 0;
    if ((i22 | 0) == (HEAP32[i33 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i20 = invoke_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 36 >> 2] | 0, i33 | 0) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i25 = 26;
      break L4;
     } else i43 = i20;
    } else i43 = HEAP32[i22 >> 2] | 0;
    if ((i43 | 0) != -1) if (i42) break; else {
     i25 = 53;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 51;
     break;
    }
   } else i25 = 51; while (0);
   if ((i25 | 0) == 51 ? i42 : 0) i25 = 53;
   if ((i25 | 0) == 53) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i22 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i22 | 0;
  } else i25 = 26;
 } else i25 = 26; while (0);
 if ((i25 | 0) == 26) {
  i25 = ___cxa_find_matching_catch() | 0;
  i39 = i25;
  i40 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i39 | 0);
 return 0;
}

function __ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 i8 = i1 + 424 | 0;
 i9 = i1;
 i10 = i1 + 24 | 0;
 i11 = i1 + 16 | 0;
 i12 = i1 + 12 | 0;
 i13 = i1 + 8 | 0;
 i14 = i1 + 464 | 0;
 i15 = i1 + 4 | 0;
 i16 = i1 + 468 | 0;
 HEAP32[i11 >> 2] = i10;
 i17 = i11 + 4 | 0;
 HEAP32[i17 >> 2] = 287;
 i18 = i10 + 400 | 0;
 __THREW__ = 0;
 i19 = invoke_ii(131, i5 | 0) | 0;
 i20 = __THREW__;
 __THREW__ = 0;
 if (!(i20 & 1)) {
  HEAP32[i13 >> 2] = i19;
  __THREW__ = 0;
  i19 = invoke_iii(55, i13 | 0, 26572) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  L4 : do if (!(i20 & 1) ? (HEAP8[i14 >> 0] = 0, HEAP32[i15 >> 2] = HEAP32[i3 >> 2], i21 = HEAP32[i5 + 4 >> 2] | 0, __THREW__ = 0, HEAP32[i8 >> 2] = HEAP32[i15 >> 2], i22 = invoke_iiiiiiiiiiii(2, i2 | 0, i8 | 0, i4 | 0, i13 | 0, i21 | 0, i6 | 0, i14 | 0, i19 | 0, i11 | 0, i12 | 0, i18 | 0) | 0, i21 = __THREW__, __THREW__ = 0, !(i21 & 1)) : 0) {
   L7 : do if (i22) {
    __THREW__ = 0;
    invoke_iiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 48 >> 2] | 0, i19 | 0, 47670, 47680, i8 | 0) | 0;
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) {
     i23 = 10;
     break L4;
    }
    i21 = HEAP32[i12 >> 2] | 0;
    i24 = HEAP32[i11 >> 2] | 0;
    i25 = i21 - i24 | 0;
    if ((i25 | 0) > 392) {
     i26 = _malloc((i25 >> 2) + 2 | 0) | 0;
     i25 = i26;
     if (!i26) {
      __THREW__ = 0;
      invoke_v(5);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) i28 = i25; else {
       i29 = i25;
       i30 = 0;
       i23 = 13;
      }
     } else {
      i29 = i25;
      i30 = i26;
      i23 = 13;
     }
    } else {
     i29 = 0;
     i30 = i16;
     i23 = 13;
    }
    do if ((i23 | 0) == 13) {
     if (!(HEAP8[i14 >> 0] | 0)) i31 = i30; else {
      HEAP8[i30 >> 0] = 45;
      i31 = i30 + 1 | 0;
     }
     i26 = i8 + 40 | 0;
     i25 = i8;
     if (i24 >>> 0 < i21 >>> 0) {
      i27 = i8 + 4 | 0;
      i32 = i27 + 4 | 0;
      i33 = i32 + 4 | 0;
      i34 = i33 + 4 | 0;
      i35 = i34 + 4 | 0;
      i36 = i35 + 4 | 0;
      i37 = i36 + 4 | 0;
      i38 = i37 + 4 | 0;
      i39 = i38 + 4 | 0;
      i40 = i31;
      i41 = i24;
      while (1) {
       i42 = HEAP32[i41 >> 2] | 0;
       do if ((HEAP32[i8 >> 2] | 0) != (i42 | 0)) if ((HEAP32[i27 >> 2] | 0) != (i42 | 0)) if ((HEAP32[i32 >> 2] | 0) != (i42 | 0)) if ((HEAP32[i33 >> 2] | 0) != (i42 | 0)) if ((HEAP32[i34 >> 2] | 0) == (i42 | 0)) i43 = i34; else {
        if ((HEAP32[i35 >> 2] | 0) == (i42 | 0)) {
         i43 = i35;
         break;
        }
        if ((HEAP32[i36 >> 2] | 0) == (i42 | 0)) {
         i43 = i36;
         break;
        }
        if ((HEAP32[i37 >> 2] | 0) == (i42 | 0)) {
         i43 = i37;
         break;
        }
        if ((HEAP32[i38 >> 2] | 0) == (i42 | 0)) {
         i43 = i38;
         break;
        }
        i43 = (HEAP32[i39 >> 2] | 0) == (i42 | 0) ? i39 : i26;
       } else i43 = i33; else i43 = i32; else i43 = i27; else i43 = i8; while (0);
       HEAP8[i40 >> 0] = HEAP8[47670 + (i43 - i25 >> 2) >> 0] | 0;
       i41 = i41 + 4 | 0;
       i42 = i40 + 1 | 0;
       if (i41 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) {
        i44 = i42;
        break;
       } else i40 = i42;
      }
     } else i44 = i31;
     HEAP8[i44 >> 0] = 0;
     HEAP32[i9 >> 2] = i7;
     if ((_sscanf(i16, 47650, i9) | 0) != 1 ? (__THREW__ = 0, invoke_vi(288, 47654), i40 = __THREW__, __THREW__ = 0, i40 & 1) : 0) {
      i28 = i29;
      break;
     }
     if (i29) _free(i29);
     break L7;
    } while (0);
    i24 = ___cxa_find_matching_catch() | 0;
    i21 = tempRet0;
    if (!i28) {
     i45 = i24;
     i46 = i21;
     i47 = i11;
     break L4;
    }
    _free(i28);
    i45 = i24;
    i46 = i21;
    i47 = i11;
    break L4;
   } while (0);
   i22 = HEAP32[i2 >> 2] | 0;
   do if (i22) {
    i21 = HEAP32[i22 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i22 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] | 0, i22 | 0) | 0;
     i40 = __THREW__;
     __THREW__ = 0;
     if (i40 & 1) {
      i23 = 10;
      break L4;
     } else i48 = i24;
    } else i48 = HEAP32[i21 >> 2] | 0;
    if ((i48 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i49 = 1;
     break;
    } else {
     i49 = (HEAP32[i2 >> 2] | 0) == 0;
     break;
    }
   } else i49 = 1; while (0);
   i22 = HEAP32[i3 >> 2] | 0;
   do if (i22) {
    i21 = HEAP32[i22 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i22 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] | 0, i22 | 0) | 0;
     i40 = __THREW__;
     __THREW__ = 0;
     if (i40 & 1) {
      i23 = 10;
      break L4;
     } else i50 = i24;
    } else i50 = HEAP32[i21 >> 2] | 0;
    if ((i50 | 0) != -1) if (i49) break; else {
     i23 = 40;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i23 = 38;
     break;
    }
   } else i23 = 38; while (0);
   if ((i23 | 0) == 38 ? i49 : 0) i23 = 40;
   if ((i23 | 0) == 40) HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2;
   i22 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
   i21 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = 0;
   if ((i21 | 0) != 0 ? (__THREW__ = 0, invoke_vi(HEAP32[i17 >> 2] | 0, i21 | 0), i21 = __THREW__, __THREW__ = 0, i21 & 1) : 0) {
    i21 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i21);
   }
   STACKTOP = i1;
   return i22 | 0;
  } else i23 = 10; while (0);
  if ((i23 | 0) == 10) {
   i1 = ___cxa_find_matching_catch() | 0;
   i45 = i1;
   i46 = tempRet0;
   i47 = i11;
  }
  __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
  i13 = HEAP32[i47 >> 2] | 0;
  HEAP32[i47 >> 2] = 0;
  if (!i13) {
   i51 = i45;
   i52 = i46;
  } else {
   i53 = i45;
   i54 = i46;
   i55 = HEAP32[i17 >> 2] | 0;
   i56 = i13;
   i23 = 47;
  }
 } else {
  i13 = ___cxa_find_matching_catch() | 0;
  HEAP32[i11 >> 2] = 0;
  i53 = i13;
  i54 = tempRet0;
  i55 = 287;
  i56 = i10;
  i23 = 47;
 }
 if ((i23 | 0) == 47) {
  __THREW__ = 0;
  invoke_vi(i55 | 0, i56 | 0);
  i56 = __THREW__;
  __THREW__ = 0;
  if (i56 & 1) {
   i56 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i56);
  } else {
   i51 = i53;
   i52 = i54;
  }
 }
 ___resumeException(i51 | 0);
 return 0;
}

function __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0;
 HEAP32[i3 >> 2] = i1;
 i16 = i14 + 4 | 0;
 i17 = i14 + 8 | 0;
 i18 = i13 + 4 | 0;
 i19 = (i4 & 512 | 0) == 0;
 i20 = i13 + 8 | 0;
 i21 = (i15 | 0) > 0;
 i22 = i12 + 4 | 0;
 i23 = i12 + 8 | 0;
 i24 = i12 + 1 | 0;
 i25 = (i15 | 0) > 0;
 i26 = i5;
 i5 = 0;
 while (1) {
  switch (HEAP8[i9 + i5 >> 0] | 0) {
  case 0:
   {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i27 = i26;
    break;
   }
  case 1:
   {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i28 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] & 63](i7, 32) | 0;
    i29 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 >> 2] = i29 + 4;
    HEAP32[i29 >> 2] = i28;
    i27 = i26;
    break;
   }
  case 3:
   {
    i28 = HEAP8[i14 >> 0] | 0;
    i29 = (i28 & 1) == 0;
    if (!((i29 ? (i28 & 255) >>> 1 : HEAP32[i16 >> 2] | 0) | 0)) i27 = i26; else {
     i28 = HEAP32[(i29 ? i16 : HEAP32[i17 >> 2] | 0) >> 2] | 0;
     i29 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = i29 + 4;
     HEAP32[i29 >> 2] = i28;
     i27 = i26;
    }
    break;
   }
  case 2:
   {
    i28 = HEAP8[i13 >> 0] | 0;
    i29 = (i28 & 1) == 0;
    i30 = i29 ? (i28 & 255) >>> 1 : HEAP32[i18 >> 2] | 0;
    if (i19 | (i30 | 0) == 0) i27 = i26; else {
     i28 = i29 ? i18 : HEAP32[i20 >> 2] | 0;
     i29 = i28 + (i30 << 2) | 0;
     i31 = HEAP32[i3 >> 2] | 0;
     if (i30) {
      i32 = i31;
      i33 = i28;
      while (1) {
       HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
       i33 = i33 + 4 | 0;
       if ((i33 | 0) == (i29 | 0)) break; else i32 = i32 + 4 | 0;
      }
     }
     HEAP32[i3 >> 2] = i31 + (i30 << 2);
     i27 = i26;
    }
    break;
   }
  case 4:
   {
    i32 = HEAP32[i3 >> 2] | 0;
    i29 = i8 ? i26 + 4 | 0 : i26;
    L15 : do if (i29 >>> 0 < i6 >>> 0) {
     i33 = i29;
     while (1) {
      if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] & 63](i7, 2048, HEAP32[i33 >> 2] | 0) | 0)) {
       i34 = i33;
       break L15;
      }
      i28 = i33 + 4 | 0;
      if (i28 >>> 0 < i6 >>> 0) i33 = i28; else {
       i34 = i28;
       break;
      }
     }
    } else i34 = i29; while (0);
    if (i21) {
     if (i34 >>> 0 > i29 >>> 0 & i25) {
      i30 = HEAP32[i3 >> 2] | 0;
      i31 = i34;
      i33 = i15;
      while (1) {
       i28 = i31 + -4 | 0;
       i35 = i30 + 4 | 0;
       HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
       i36 = i33 + -1 | 0;
       i37 = (i33 | 0) > 1;
       if (i28 >>> 0 > i29 >>> 0 & i37) {
        i30 = i35;
        i31 = i28;
        i33 = i36;
       } else {
        i38 = i28;
        i39 = i36;
        i40 = i37;
        i41 = i35;
        break;
       }
      }
      HEAP32[i3 >> 2] = i41;
      i42 = i40;
      i43 = i38;
      i44 = i39;
     } else {
      i42 = i25;
      i43 = i34;
      i44 = i15;
     }
     if (i42) i45 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] & 63](i7, 48) | 0; else i45 = 0;
     i33 = HEAP32[i3 >> 2] | 0;
     i31 = i44 + ((i44 | 0) < 0 ? ~i44 : -1) | 0;
     if ((i44 | 0) > 0) {
      i30 = i33;
      i35 = i44;
      while (1) {
       HEAP32[i30 >> 2] = i45;
       if ((i35 | 0) > 1) {
        i30 = i30 + 4 | 0;
        i35 = i35 + -1 | 0;
       } else break;
      }
     }
     HEAP32[i3 >> 2] = i33 + (i31 + 2 << 2);
     HEAP32[i33 + (i31 + 1 << 2) >> 2] = i10;
     i46 = i43;
    } else i46 = i34;
    if ((i46 | 0) == (i29 | 0)) {
     i35 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] & 63](i7, 48) | 0;
     i30 = HEAP32[i3 >> 2] | 0;
     i37 = i30 + 4 | 0;
     HEAP32[i3 >> 2] = i37;
     HEAP32[i30 >> 2] = i35;
     i47 = i37;
    } else {
     i37 = HEAP8[i12 >> 0] | 0;
     i35 = (i37 & 1) == 0;
     i30 = HEAP32[i22 >> 2] | 0;
     if (!((i35 ? (i37 & 255) >>> 1 : i30) | 0)) i48 = -1; else i48 = HEAP8[(i35 ? i24 : HEAP32[i23 >> 2] | 0) >> 0] | 0;
     if ((i46 | 0) != (i29 | 0)) {
      i35 = i46;
      i37 = i48;
      i36 = 0;
      i28 = 0;
      while (1) {
       i49 = HEAP32[i3 >> 2] | 0;
       if ((i28 | 0) == (i37 | 0)) {
        i50 = i49 + 4 | 0;
        HEAP32[i3 >> 2] = i50;
        HEAP32[i49 >> 2] = i11;
        i51 = i36 + 1 | 0;
        i52 = HEAP8[i12 >> 0] | 0;
        i53 = (i52 & 1) == 0;
        if (i51 >>> 0 < (i53 ? (i52 & 255) >>> 1 : i30) >>> 0) {
         i52 = HEAP8[(i53 ? i24 : HEAP32[i23 >> 2] | 0) + i51 >> 0] | 0;
         i54 = i50;
         i55 = i52 << 24 >> 24 == 127 ? -1 : i52 << 24 >> 24;
         i56 = i51;
         i57 = 0;
        } else {
         i54 = i50;
         i55 = i28;
         i56 = i51;
         i57 = 0;
        }
       } else {
        i54 = i49;
        i55 = i37;
        i56 = i36;
        i57 = i28;
       }
       i35 = i35 + -4 | 0;
       i49 = HEAP32[i35 >> 2] | 0;
       HEAP32[i3 >> 2] = i54 + 4;
       HEAP32[i54 >> 2] = i49;
       if ((i35 | 0) == (i29 | 0)) break; else {
        i37 = i55;
        i36 = i56;
        i28 = i57 + 1 | 0;
       }
      }
     }
     i47 = HEAP32[i3 >> 2] | 0;
    }
    if ((i32 | 0) != (i47 | 0) ? (i28 = i47 + -4 | 0, i32 >>> 0 < i28 >>> 0) : 0) {
     i36 = i32;
     i37 = i28;
     do {
      i28 = HEAP32[i36 >> 2] | 0;
      HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i37 >> 2] = i28;
      i36 = i36 + 4 | 0;
      i37 = i37 + -4 | 0;
     } while (i36 >>> 0 < i37 >>> 0);
     i27 = i29;
    } else i27 = i29;
    break;
   }
  default:
   i27 = i26;
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == 4) break; else i26 = i27;
 }
 i27 = HEAP8[i14 >> 0] | 0;
 i14 = (i27 & 1) == 0;
 i26 = i14 ? (i27 & 255) >>> 1 : HEAP32[i16 >> 2] | 0;
 if (i26 >>> 0 > 1) {
  i27 = i14 ? i16 : HEAP32[i17 >> 2] | 0;
  i17 = i27 + 4 | 0;
  i16 = i27 + (i26 << 2) | 0;
  i27 = HEAP32[i3 >> 2] | 0;
  i14 = i16 - i17 | 0;
  if ((i26 | 0) != 1) {
   i26 = i27;
   i5 = i17;
   while (1) {
    HEAP32[i26 >> 2] = HEAP32[i5 >> 2];
    i5 = i5 + 4 | 0;
    if ((i5 | 0) == (i16 | 0)) break; else i26 = i26 + 4 | 0;
   }
  }
  HEAP32[i3 >> 2] = i27 + (i14 >>> 2 << 2);
 }
 switch (i4 & 176 | 0) {
 case 32:
  {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   break;
  }
 case 16:
  break;
 default:
  HEAP32[i2 >> 2] = i1;
 }
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP32[i8 >> 2] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) {
    i18 = HEAP32[i21 + 12 >> 2] | 0;
    if ((i18 | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i23 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i25 = 25;
      break;
     } else i26 = i23;
    } else i26 = HEAP32[i18 >> 2] | 0;
    if ((i26 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i27 = 0;
     i28 = 1;
    } else {
     i27 = i21;
     i28 = 0;
    }
   } else {
    i27 = 0;
    i28 = 1;
   }
   i18 = HEAP32[i3 >> 2] | 0;
   do if (i18) {
    i23 = HEAP32[i18 + 12 >> 2] | 0;
    if ((i23 | 0) == (HEAP32[i18 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0, i18 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) {
      i25 = 25;
      break L6;
     } else i30 = i24;
    } else i30 = HEAP32[i23 >> 2] | 0;
    if ((i30 | 0) != -1) if (i28) {
     i31 = i18;
     break;
    } else {
     i32 = i27;
     i33 = i18;
     i34 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 17;
     break;
    }
   } else i25 = 17; while (0);
   if ((i25 | 0) == 17) {
    i25 = 0;
    if (i28) {
     i32 = i27;
     i33 = 0;
     i34 = i22;
     break;
    } else i31 = 0;
   }
   i18 = HEAP8[i10 >> 0] | 0;
   i23 = (i18 & 1) == 0 ? (i18 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i23 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i23 << 1 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i35 = 10; else i35 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i35 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i18 + i23;
    i36 = i18;
   } else i36 = i22;
   i18 = i27 + 12 | 0;
   i23 = HEAP32[i18 >> 2] | 0;
   i24 = i27 + 16 | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    i29 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i37 = __THREW__;
    __THREW__ = 0;
    if (i37 & 1) {
     i25 = 25;
     break;
    } else i38 = i29;
   } else i38 = HEAP32[i23 >> 2] | 0;
   if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i38, i15, i36, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i32 = i27;
    i33 = i31;
    i34 = i36;
    break;
   }
   i23 = HEAP32[i18 >> 2] | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 40 >> 2] | 0, i27 | 0) | 0;
    i24 = __THREW__;
    __THREW__ = 0;
    if (i24 & 1) {
     i25 = 25;
     break;
    } else {
     i21 = i27;
     i22 = i36;
     continue;
    }
   } else {
    HEAP32[i18 >> 2] = i23 + 4;
    i21 = i27;
    i22 = i36;
    continue;
   }
  }
  if ((i25 | 0) == 25) {
   i22 = ___cxa_find_matching_catch() | 0;
   i39 = i22;
   i40 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(16, i34 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (!(i22 & 1)) {
   HEAP16[i6 >> 1] = i21;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i32) {
    i21 = HEAP32[i32 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i32 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i25 = 26;
      break;
     } else i41 = i22;
    } else i41 = HEAP32[i21 >> 2] | 0;
    if ((i41 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i42 = 1;
    } else i42 = 0;
   } else i42 = 1;
   do if (i33) {
    i21 = HEAP32[i33 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i33 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 36 >> 2] | 0, i33 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i25 = 26;
      break L4;
     } else i43 = i22;
    } else i43 = HEAP32[i21 >> 2] | 0;
    if ((i43 | 0) != -1) if (i42) break; else {
     i25 = 53;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 51;
     break;
    }
   } else i25 = 51; while (0);
   if ((i25 | 0) == 51 ? i42 : 0) i25 = 53;
   if ((i25 | 0) == 53) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i21 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i21 | 0;
  } else i25 = 26;
 } else i25 = 26; while (0);
 if ((i25 | 0) == 26) {
  i25 = ___cxa_find_matching_catch() | 0;
  i39 = i25;
  i40 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i39 | 0);
 return 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP32[i8 >> 2] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) {
    i18 = HEAP32[i21 + 12 >> 2] | 0;
    if ((i18 | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i23 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i25 = 25;
      break;
     } else i26 = i23;
    } else i26 = HEAP32[i18 >> 2] | 0;
    if ((i26 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i27 = 0;
     i28 = 1;
    } else {
     i27 = i21;
     i28 = 0;
    }
   } else {
    i27 = 0;
    i28 = 1;
   }
   i18 = HEAP32[i3 >> 2] | 0;
   do if (i18) {
    i23 = HEAP32[i18 + 12 >> 2] | 0;
    if ((i23 | 0) == (HEAP32[i18 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0, i18 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) {
      i25 = 25;
      break L6;
     } else i30 = i24;
    } else i30 = HEAP32[i23 >> 2] | 0;
    if ((i30 | 0) != -1) if (i28) {
     i31 = i18;
     break;
    } else {
     i32 = i27;
     i33 = i18;
     i34 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 17;
     break;
    }
   } else i25 = 17; while (0);
   if ((i25 | 0) == 17) {
    i25 = 0;
    if (i28) {
     i32 = i27;
     i33 = 0;
     i34 = i22;
     break;
    } else i31 = 0;
   }
   i18 = HEAP8[i10 >> 0] | 0;
   i23 = (i18 & 1) == 0 ? (i18 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i23 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i23 << 1 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i35 = 10; else i35 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i35 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i18 + i23;
    i36 = i18;
   } else i36 = i22;
   i18 = i27 + 12 | 0;
   i23 = HEAP32[i18 >> 2] | 0;
   i24 = i27 + 16 | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    i29 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i37 = __THREW__;
    __THREW__ = 0;
    if (i37 & 1) {
     i25 = 25;
     break;
    } else i38 = i29;
   } else i38 = HEAP32[i23 >> 2] | 0;
   if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i38, i15, i36, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i32 = i27;
    i33 = i31;
    i34 = i36;
    break;
   }
   i23 = HEAP32[i18 >> 2] | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 40 >> 2] | 0, i27 | 0) | 0;
    i24 = __THREW__;
    __THREW__ = 0;
    if (i24 & 1) {
     i25 = 25;
     break;
    } else {
     i21 = i27;
     i22 = i36;
     continue;
    }
   } else {
    HEAP32[i18 >> 2] = i23 + 4;
    i21 = i27;
    i22 = i36;
    continue;
   }
  }
  if ((i25 | 0) == 25) {
   i22 = ___cxa_find_matching_catch() | 0;
   i39 = i22;
   i40 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(18, i34 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (!(i22 & 1)) {
   HEAP32[i6 >> 2] = i21;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i32) {
    i21 = HEAP32[i32 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i32 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i25 = 26;
      break;
     } else i41 = i22;
    } else i41 = HEAP32[i21 >> 2] | 0;
    if ((i41 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i42 = 1;
    } else i42 = 0;
   } else i42 = 1;
   do if (i33) {
    i21 = HEAP32[i33 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i33 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 36 >> 2] | 0, i33 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i25 = 26;
      break L4;
     } else i43 = i22;
    } else i43 = HEAP32[i21 >> 2] | 0;
    if ((i43 | 0) != -1) if (i42) break; else {
     i25 = 53;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 51;
     break;
    }
   } else i25 = 51; while (0);
   if ((i25 | 0) == 51 ? i42 : 0) i25 = 53;
   if ((i25 | 0) == 53) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i21 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i21 | 0;
  } else i25 = 26;
 } else i25 = 26; while (0);
 if ((i25 | 0) == 26) {
  i25 = ___cxa_find_matching_catch() | 0;
  i39 = i25;
  i40 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i39 | 0);
 return 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP32[i8 >> 2] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) {
    i18 = HEAP32[i21 + 12 >> 2] | 0;
    if ((i18 | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i23 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i25 = 25;
      break;
     } else i26 = i23;
    } else i26 = HEAP32[i18 >> 2] | 0;
    if ((i26 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i27 = 0;
     i28 = 1;
    } else {
     i27 = i21;
     i28 = 0;
    }
   } else {
    i27 = 0;
    i28 = 1;
   }
   i18 = HEAP32[i3 >> 2] | 0;
   do if (i18) {
    i23 = HEAP32[i18 + 12 >> 2] | 0;
    if ((i23 | 0) == (HEAP32[i18 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0, i18 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) {
      i25 = 25;
      break L6;
     } else i30 = i24;
    } else i30 = HEAP32[i23 >> 2] | 0;
    if ((i30 | 0) != -1) if (i28) {
     i31 = i18;
     break;
    } else {
     i32 = i27;
     i33 = i18;
     i34 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 17;
     break;
    }
   } else i25 = 17; while (0);
   if ((i25 | 0) == 17) {
    i25 = 0;
    if (i28) {
     i32 = i27;
     i33 = 0;
     i34 = i22;
     break;
    } else i31 = 0;
   }
   i18 = HEAP8[i10 >> 0] | 0;
   i23 = (i18 & 1) == 0 ? (i18 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i23 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i23 << 1 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i35 = 10; else i35 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i35 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i18 + i23;
    i36 = i18;
   } else i36 = i22;
   i18 = i27 + 12 | 0;
   i23 = HEAP32[i18 >> 2] | 0;
   i24 = i27 + 16 | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    i29 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i37 = __THREW__;
    __THREW__ = 0;
    if (i37 & 1) {
     i25 = 25;
     break;
    } else i38 = i29;
   } else i38 = HEAP32[i23 >> 2] | 0;
   if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i38, i15, i36, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i32 = i27;
    i33 = i31;
    i34 = i36;
    break;
   }
   i23 = HEAP32[i18 >> 2] | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 40 >> 2] | 0, i27 | 0) | 0;
    i24 = __THREW__;
    __THREW__ = 0;
    if (i24 & 1) {
     i25 = 25;
     break;
    } else {
     i21 = i27;
     i22 = i36;
     continue;
    }
   } else {
    HEAP32[i18 >> 2] = i23 + 4;
    i21 = i27;
    i22 = i36;
    continue;
   }
  }
  if ((i25 | 0) == 25) {
   i22 = ___cxa_find_matching_catch() | 0;
   i39 = i22;
   i40 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(17, i34 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (!(i22 & 1)) {
   HEAP32[i6 >> 2] = i21;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i32) {
    i21 = HEAP32[i32 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i32 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i25 = 26;
      break;
     } else i41 = i22;
    } else i41 = HEAP32[i21 >> 2] | 0;
    if ((i41 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i42 = 1;
    } else i42 = 0;
   } else i42 = 1;
   do if (i33) {
    i21 = HEAP32[i33 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i33 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 36 >> 2] | 0, i33 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i25 = 26;
      break L4;
     } else i43 = i22;
    } else i43 = HEAP32[i21 >> 2] | 0;
    if ((i43 | 0) != -1) if (i42) break; else {
     i25 = 53;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 51;
     break;
    }
   } else i25 = 51; while (0);
   if ((i25 | 0) == 51 ? i42 : 0) i25 = 53;
   if ((i25 | 0) == 53) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i21 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i21 | 0;
  } else i25 = 26;
 } else i25 = 26; while (0);
 if ((i25 | 0) == 26) {
  i25 = ___cxa_find_matching_catch() | 0;
  i39 = i25;
  i40 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i39 | 0);
 return 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP32[i8 >> 2] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) {
    i18 = HEAP32[i21 + 12 >> 2] | 0;
    if ((i18 | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i23 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i25 = 25;
      break;
     } else i26 = i23;
    } else i26 = HEAP32[i18 >> 2] | 0;
    if ((i26 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i27 = 0;
     i28 = 1;
    } else {
     i27 = i21;
     i28 = 0;
    }
   } else {
    i27 = 0;
    i28 = 1;
   }
   i18 = HEAP32[i3 >> 2] | 0;
   do if (i18) {
    i23 = HEAP32[i18 + 12 >> 2] | 0;
    if ((i23 | 0) == (HEAP32[i18 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0, i18 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) {
      i25 = 25;
      break L6;
     } else i30 = i24;
    } else i30 = HEAP32[i23 >> 2] | 0;
    if ((i30 | 0) != -1) if (i28) {
     i31 = i18;
     break;
    } else {
     i32 = i27;
     i33 = i18;
     i34 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 17;
     break;
    }
   } else i25 = 17; while (0);
   if ((i25 | 0) == 17) {
    i25 = 0;
    if (i28) {
     i32 = i27;
     i33 = 0;
     i34 = i22;
     break;
    } else i31 = 0;
   }
   i18 = HEAP8[i10 >> 0] | 0;
   i23 = (i18 & 1) == 0 ? (i18 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i23 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i23 << 1 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i35 = 10; else i35 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i35 | 0, 0);
    i18 = __THREW__;
    __THREW__ = 0;
    if (i18 & 1) {
     i25 = 25;
     break;
    }
    i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i18 + i23;
    i36 = i18;
   } else i36 = i22;
   i18 = i27 + 12 | 0;
   i23 = HEAP32[i18 >> 2] | 0;
   i24 = i27 + 16 | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    i29 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i37 = __THREW__;
    __THREW__ = 0;
    if (i37 & 1) {
     i25 = 25;
     break;
    } else i38 = i29;
   } else i38 = HEAP32[i23 >> 2] | 0;
   if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i38, i15, i36, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i32 = i27;
    i33 = i31;
    i34 = i36;
    break;
   }
   i23 = HEAP32[i18 >> 2] | 0;
   if ((i23 | 0) == (HEAP32[i24 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 40 >> 2] | 0, i27 | 0) | 0;
    i24 = __THREW__;
    __THREW__ = 0;
    if (i24 & 1) {
     i25 = 25;
     break;
    } else {
     i21 = i27;
     i22 = i36;
     continue;
    }
   } else {
    HEAP32[i18 >> 2] = i23 + 4;
    i21 = i27;
    i22 = i36;
    continue;
   }
  }
  if ((i25 | 0) == 25) {
   i22 = ___cxa_find_matching_catch() | 0;
   i39 = i22;
   i40 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(14, i34 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (!(i22 & 1)) {
   HEAP32[i6 >> 2] = i21;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i32) {
    i21 = HEAP32[i32 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i32 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i25 = 26;
      break;
     } else i41 = i22;
    } else i41 = HEAP32[i21 >> 2] | 0;
    if ((i41 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i42 = 1;
    } else i42 = 0;
   } else i42 = 1;
   do if (i33) {
    i21 = HEAP32[i33 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i33 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 36 >> 2] | 0, i33 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i25 = 26;
      break L4;
     } else i43 = i22;
    } else i43 = HEAP32[i21 >> 2] | 0;
    if ((i43 | 0) != -1) if (i42) break; else {
     i25 = 53;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i25 = 51;
     break;
    }
   } else i25 = 51; while (0);
   if ((i25 | 0) == 51 ? i42 : 0) i25 = 53;
   if ((i25 | 0) == 53) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i21 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i21 | 0;
  } else i25 = 26;
 } else i25 = 26; while (0);
 if ((i25 | 0) == 26) {
  i25 = ___cxa_find_matching_catch() | 0;
  i39 = i25;
  i40 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i39 | 0);
 return 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, d42 = 0.0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 203 | 0;
 i9 = i1 + 202 | 0;
 i10 = i1 + 24 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 40 | 0;
 i14 = i1 + 4 | 0;
 i15 = i1;
 i16 = i1 + 201 | 0;
 i17 = i1 + 200 | 0;
 __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i10, i4, i7, i8, i9);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 if (!(HEAP8[i11 >> 0] & 1)) i18 = 10; else i18 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i11 | 0, i18 | 0, 0);
 i18 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i18 & 1)) {
  i4 = i11 + 8 | 0;
  i19 = i11 + 1 | 0;
  i20 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = i20;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i15 >> 2] = 0;
  HEAP8[i16 >> 0] = 1;
  HEAP8[i17 >> 0] = 69;
  i21 = i11 + 4 | 0;
  i22 = HEAP8[i8 >> 0] | 0;
  i23 = HEAP8[i9 >> 0] | 0;
  i24 = HEAP32[i2 >> 2] | 0;
  i25 = i20;
  L6 : while (1) {
   if (i24) if ((HEAP32[i24 + 12 >> 2] | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i20 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 24;
     break;
    }
    if ((i20 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i28 = 0;
    } else i28 = i24;
   } else i28 = i24; else i28 = 0;
   i20 = (i28 | 0) == 0;
   i26 = HEAP32[i3 >> 2] | 0;
   do if (i26) {
    if ((HEAP32[i26 + 12 >> 2] | 0) != (HEAP32[i26 + 16 >> 2] | 0)) if (i20) {
     i29 = i26;
     break;
    } else {
     i30 = i28;
     i31 = i26;
     i32 = i25;
     break L6;
    }
    __THREW__ = 0;
    i33 = invoke_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 36 >> 2] | 0, i26 | 0) | 0;
    i34 = __THREW__;
    __THREW__ = 0;
    if (i34 & 1) {
     i27 = 24;
     break L6;
    }
    if ((i33 | 0) != -1) if (i20) {
     i29 = i26;
     break;
    } else {
     i30 = i28;
     i31 = i26;
     i32 = i25;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i27 = 16;
     break;
    }
   } else i27 = 16; while (0);
   if ((i27 | 0) == 16) {
    i27 = 0;
    if (i20) {
     i30 = i28;
     i31 = 0;
     i32 = i25;
     break;
    } else i29 = 0;
   }
   i26 = HEAP8[i11 >> 0] | 0;
   i33 = (i26 & 1) == 0 ? (i26 & 255) >>> 1 : HEAP32[i21 >> 2] | 0;
   if ((HEAP32[i12 >> 2] | 0) == (i25 + i33 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i33 << 1 | 0, 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 24;
     break;
    }
    if (!(HEAP8[i11 >> 0] & 1)) i35 = 10; else i35 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i35 | 0, 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 24;
     break;
    }
    i26 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
    HEAP32[i12 >> 2] = i26 + i33;
    i36 = i26;
   } else i36 = i25;
   i26 = i28 + 12 | 0;
   i33 = HEAP32[i26 >> 2] | 0;
   i34 = i28 + 16 | 0;
   if ((i33 | 0) == (HEAP32[i34 >> 2] | 0)) {
    __THREW__ = 0;
    i37 = invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
    i38 = __THREW__;
    __THREW__ = 0;
    if (i38 & 1) {
     i27 = 24;
     break;
    } else i39 = i37;
   } else i39 = HEAPU8[i33 >> 0] | 0;
   if (__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i39 & 255, i16, i17, i36, i12, i22, i23, i10, i13, i14, i15, i7) | 0) {
    i30 = i28;
    i31 = i29;
    i32 = i36;
    break;
   }
   i33 = HEAP32[i26 >> 2] | 0;
   if ((i33 | 0) == (HEAP32[i34 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 40 >> 2] | 0, i28 | 0) | 0;
    i34 = __THREW__;
    __THREW__ = 0;
    if (i34 & 1) {
     i27 = 24;
     break;
    } else {
     i24 = i28;
     i25 = i36;
     continue;
    }
   } else {
    HEAP32[i26 >> 2] = i33 + 1;
    i24 = i28;
    i25 = i36;
    continue;
   }
  }
  if ((i27 | 0) == 24) {
   i25 = ___cxa_find_matching_catch() | 0;
   i40 = i25;
   i41 = tempRet0;
   break;
  }
  i25 = HEAP8[i10 >> 0] | 0;
  if (!((HEAP8[i16 >> 0] | 0) == 0 ? 1 : (((i25 & 1) == 0 ? (i25 & 255) >>> 1 : HEAP32[i10 + 4 >> 2] | 0) | 0) == 0) ? (i25 = HEAP32[i14 >> 2] | 0, (i25 - i13 | 0) < 160) : 0) {
   i24 = HEAP32[i15 >> 2] | 0;
   HEAP32[i14 >> 2] = i25 + 4;
   HEAP32[i25 >> 2] = i24;
  }
  __THREW__ = 0;
  d42 = +invoke_diii(3, i32 | 0, HEAP32[i12 >> 2] | 0, i5 | 0);
  i24 = __THREW__;
  __THREW__ = 0;
  if (!(i24 & 1)) {
   HEAPF32[i6 >> 2] = d42;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i10, i13, HEAP32[i14 >> 2] | 0, i5);
   if (i30) if ((HEAP32[i30 + 12 >> 2] | 0) == (HEAP32[i30 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i24 = invoke_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 36 >> 2] | 0, i30 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i27 = 25;
     break;
    }
    if ((i24 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i43 = 0;
    } else i43 = i30;
   } else i43 = i30; else i43 = 0;
   i24 = (i43 | 0) == 0;
   do if (i31) {
    if ((HEAP32[i31 + 12 >> 2] | 0) == (HEAP32[i31 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i25 = invoke_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i27 = 25;
      break L4;
     }
     if ((i25 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i27 = 49;
      break;
     }
    }
    if (!i24) i27 = 50;
   } else i27 = 49; while (0);
   if ((i27 | 0) == 49 ? i24 : 0) i27 = 50;
   if ((i27 | 0) == 50) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i25 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   STACKTOP = i1;
   return i25 | 0;
  } else i27 = 25;
 } else i27 = 25; while (0);
 if ((i27 | 0) == 25) {
  i27 = ___cxa_find_matching_catch() | 0;
  i40 = i27;
  i41 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 ___resumeException(i40 | 0);
 return 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, d42 = 0.0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 203 | 0;
 i9 = i1 + 202 | 0;
 i10 = i1 + 24 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 40 | 0;
 i14 = i1 + 4 | 0;
 i15 = i1;
 i16 = i1 + 201 | 0;
 i17 = i1 + 200 | 0;
 __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i10, i4, i7, i8, i9);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 if (!(HEAP8[i11 >> 0] & 1)) i18 = 10; else i18 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i11 | 0, i18 | 0, 0);
 i18 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i18 & 1)) {
  i4 = i11 + 8 | 0;
  i19 = i11 + 1 | 0;
  i20 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = i20;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i15 >> 2] = 0;
  HEAP8[i16 >> 0] = 1;
  HEAP8[i17 >> 0] = 69;
  i21 = i11 + 4 | 0;
  i22 = HEAP8[i8 >> 0] | 0;
  i23 = HEAP8[i9 >> 0] | 0;
  i24 = HEAP32[i2 >> 2] | 0;
  i25 = i20;
  L6 : while (1) {
   if (i24) if ((HEAP32[i24 + 12 >> 2] | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i20 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 24;
     break;
    }
    if ((i20 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i28 = 0;
    } else i28 = i24;
   } else i28 = i24; else i28 = 0;
   i20 = (i28 | 0) == 0;
   i26 = HEAP32[i3 >> 2] | 0;
   do if (i26) {
    if ((HEAP32[i26 + 12 >> 2] | 0) != (HEAP32[i26 + 16 >> 2] | 0)) if (i20) {
     i29 = i26;
     break;
    } else {
     i30 = i28;
     i31 = i26;
     i32 = i25;
     break L6;
    }
    __THREW__ = 0;
    i33 = invoke_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 36 >> 2] | 0, i26 | 0) | 0;
    i34 = __THREW__;
    __THREW__ = 0;
    if (i34 & 1) {
     i27 = 24;
     break L6;
    }
    if ((i33 | 0) != -1) if (i20) {
     i29 = i26;
     break;
    } else {
     i30 = i28;
     i31 = i26;
     i32 = i25;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i27 = 16;
     break;
    }
   } else i27 = 16; while (0);
   if ((i27 | 0) == 16) {
    i27 = 0;
    if (i20) {
     i30 = i28;
     i31 = 0;
     i32 = i25;
     break;
    } else i29 = 0;
   }
   i26 = HEAP8[i11 >> 0] | 0;
   i33 = (i26 & 1) == 0 ? (i26 & 255) >>> 1 : HEAP32[i21 >> 2] | 0;
   if ((HEAP32[i12 >> 2] | 0) == (i25 + i33 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i33 << 1 | 0, 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 24;
     break;
    }
    if (!(HEAP8[i11 >> 0] & 1)) i35 = 10; else i35 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i35 | 0, 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 24;
     break;
    }
    i26 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
    HEAP32[i12 >> 2] = i26 + i33;
    i36 = i26;
   } else i36 = i25;
   i26 = i28 + 12 | 0;
   i33 = HEAP32[i26 >> 2] | 0;
   i34 = i28 + 16 | 0;
   if ((i33 | 0) == (HEAP32[i34 >> 2] | 0)) {
    __THREW__ = 0;
    i37 = invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
    i38 = __THREW__;
    __THREW__ = 0;
    if (i38 & 1) {
     i27 = 24;
     break;
    } else i39 = i37;
   } else i39 = HEAPU8[i33 >> 0] | 0;
   if (__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i39 & 255, i16, i17, i36, i12, i22, i23, i10, i13, i14, i15, i7) | 0) {
    i30 = i28;
    i31 = i29;
    i32 = i36;
    break;
   }
   i33 = HEAP32[i26 >> 2] | 0;
   if ((i33 | 0) == (HEAP32[i34 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 40 >> 2] | 0, i28 | 0) | 0;
    i34 = __THREW__;
    __THREW__ = 0;
    if (i34 & 1) {
     i27 = 24;
     break;
    } else {
     i24 = i28;
     i25 = i36;
     continue;
    }
   } else {
    HEAP32[i26 >> 2] = i33 + 1;
    i24 = i28;
    i25 = i36;
    continue;
   }
  }
  if ((i27 | 0) == 24) {
   i25 = ___cxa_find_matching_catch() | 0;
   i40 = i25;
   i41 = tempRet0;
   break;
  }
  i25 = HEAP8[i10 >> 0] | 0;
  if (!((HEAP8[i16 >> 0] | 0) == 0 ? 1 : (((i25 & 1) == 0 ? (i25 & 255) >>> 1 : HEAP32[i10 + 4 >> 2] | 0) | 0) == 0) ? (i25 = HEAP32[i14 >> 2] | 0, (i25 - i13 | 0) < 160) : 0) {
   i24 = HEAP32[i15 >> 2] | 0;
   HEAP32[i14 >> 2] = i25 + 4;
   HEAP32[i25 >> 2] = i24;
  }
  __THREW__ = 0;
  d42 = +invoke_diii(5, i32 | 0, HEAP32[i12 >> 2] | 0, i5 | 0);
  i24 = __THREW__;
  __THREW__ = 0;
  if (!(i24 & 1)) {
   HEAPF64[i6 >> 3] = d42;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i10, i13, HEAP32[i14 >> 2] | 0, i5);
   if (i30) if ((HEAP32[i30 + 12 >> 2] | 0) == (HEAP32[i30 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i24 = invoke_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 36 >> 2] | 0, i30 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i27 = 25;
     break;
    }
    if ((i24 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i43 = 0;
    } else i43 = i30;
   } else i43 = i30; else i43 = 0;
   i24 = (i43 | 0) == 0;
   do if (i31) {
    if ((HEAP32[i31 + 12 >> 2] | 0) == (HEAP32[i31 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i25 = invoke_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i27 = 25;
      break L4;
     }
     if ((i25 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i27 = 49;
      break;
     }
    }
    if (!i24) i27 = 50;
   } else i27 = 49; while (0);
   if ((i27 | 0) == 49 ? i24 : 0) i27 = 50;
   if ((i27 | 0) == 50) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i25 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   STACKTOP = i1;
   return i25 | 0;
  } else i27 = 25;
 } else i27 = 25; while (0);
 if ((i27 | 0) == 25) {
  i27 = ___cxa_find_matching_catch() | 0;
  i40 = i27;
  i41 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 ___resumeException(i40 | 0);
 return 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, d42 = 0.0, i43 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 208 | 0;
 i8 = i1 + 203 | 0;
 i9 = i1 + 202 | 0;
 i10 = i1 + 24 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 40 | 0;
 i14 = i1 + 4 | 0;
 i15 = i1;
 i16 = i1 + 201 | 0;
 i17 = i1 + 200 | 0;
 __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i10, i4, i7, i8, i9);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 if (!(HEAP8[i11 >> 0] & 1)) i18 = 10; else i18 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i11 | 0, i18 | 0, 0);
 i18 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i18 & 1)) {
  i4 = i11 + 8 | 0;
  i19 = i11 + 1 | 0;
  i20 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = i20;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i15 >> 2] = 0;
  HEAP8[i16 >> 0] = 1;
  HEAP8[i17 >> 0] = 69;
  i21 = i11 + 4 | 0;
  i22 = HEAP8[i8 >> 0] | 0;
  i23 = HEAP8[i9 >> 0] | 0;
  i24 = HEAP32[i2 >> 2] | 0;
  i25 = i20;
  L6 : while (1) {
   if (i24) if ((HEAP32[i24 + 12 >> 2] | 0) == (HEAP32[i24 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i20 = invoke_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 24;
     break;
    }
    if ((i20 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i28 = 0;
    } else i28 = i24;
   } else i28 = i24; else i28 = 0;
   i20 = (i28 | 0) == 0;
   i26 = HEAP32[i3 >> 2] | 0;
   do if (i26) {
    if ((HEAP32[i26 + 12 >> 2] | 0) != (HEAP32[i26 + 16 >> 2] | 0)) if (i20) {
     i29 = i26;
     break;
    } else {
     i30 = i28;
     i31 = i26;
     i32 = i25;
     break L6;
    }
    __THREW__ = 0;
    i33 = invoke_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 36 >> 2] | 0, i26 | 0) | 0;
    i34 = __THREW__;
    __THREW__ = 0;
    if (i34 & 1) {
     i27 = 24;
     break L6;
    }
    if ((i33 | 0) != -1) if (i20) {
     i29 = i26;
     break;
    } else {
     i30 = i28;
     i31 = i26;
     i32 = i25;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i27 = 16;
     break;
    }
   } else i27 = 16; while (0);
   if ((i27 | 0) == 16) {
    i27 = 0;
    if (i20) {
     i30 = i28;
     i31 = 0;
     i32 = i25;
     break;
    } else i29 = 0;
   }
   i26 = HEAP8[i11 >> 0] | 0;
   i33 = (i26 & 1) == 0 ? (i26 & 255) >>> 1 : HEAP32[i21 >> 2] | 0;
   if ((HEAP32[i12 >> 2] | 0) == (i25 + i33 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i33 << 1 | 0, 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 24;
     break;
    }
    if (!(HEAP8[i11 >> 0] & 1)) i35 = 10; else i35 = (HEAP32[i11 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i11 | 0, i35 | 0, 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 24;
     break;
    }
    i26 = (HEAP8[i11 >> 0] & 1) == 0 ? i19 : HEAP32[i4 >> 2] | 0;
    HEAP32[i12 >> 2] = i26 + i33;
    i36 = i26;
   } else i36 = i25;
   i26 = i28 + 12 | 0;
   i33 = HEAP32[i26 >> 2] | 0;
   i34 = i28 + 16 | 0;
   if ((i33 | 0) == (HEAP32[i34 >> 2] | 0)) {
    __THREW__ = 0;
    i37 = invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
    i38 = __THREW__;
    __THREW__ = 0;
    if (i38 & 1) {
     i27 = 24;
     break;
    } else i39 = i37;
   } else i39 = HEAPU8[i33 >> 0] | 0;
   if (__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i39 & 255, i16, i17, i36, i12, i22, i23, i10, i13, i14, i15, i7) | 0) {
    i30 = i28;
    i31 = i29;
    i32 = i36;
    break;
   }
   i33 = HEAP32[i26 >> 2] | 0;
   if ((i33 | 0) == (HEAP32[i34 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 40 >> 2] | 0, i28 | 0) | 0;
    i34 = __THREW__;
    __THREW__ = 0;
    if (i34 & 1) {
     i27 = 24;
     break;
    } else {
     i24 = i28;
     i25 = i36;
     continue;
    }
   } else {
    HEAP32[i26 >> 2] = i33 + 1;
    i24 = i28;
    i25 = i36;
    continue;
   }
  }
  if ((i27 | 0) == 24) {
   i25 = ___cxa_find_matching_catch() | 0;
   i40 = i25;
   i41 = tempRet0;
   break;
  }
  i25 = HEAP8[i10 >> 0] | 0;
  if (!((HEAP8[i16 >> 0] | 0) == 0 ? 1 : (((i25 & 1) == 0 ? (i25 & 255) >>> 1 : HEAP32[i10 + 4 >> 2] | 0) | 0) == 0) ? (i25 = HEAP32[i14 >> 2] | 0, (i25 - i13 | 0) < 160) : 0) {
   i24 = HEAP32[i15 >> 2] | 0;
   HEAP32[i14 >> 2] = i25 + 4;
   HEAP32[i25 >> 2] = i24;
  }
  __THREW__ = 0;
  d42 = +invoke_diii(4, i32 | 0, HEAP32[i12 >> 2] | 0, i5 | 0);
  i24 = __THREW__;
  __THREW__ = 0;
  if (!(i24 & 1)) {
   HEAPF64[i6 >> 3] = d42;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i10, i13, HEAP32[i14 >> 2] | 0, i5);
   if (i30) if ((HEAP32[i30 + 12 >> 2] | 0) == (HEAP32[i30 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i24 = invoke_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 36 >> 2] | 0, i30 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i27 = 25;
     break;
    }
    if ((i24 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i43 = 0;
    } else i43 = i30;
   } else i43 = i30; else i43 = 0;
   i24 = (i43 | 0) == 0;
   do if (i31) {
    if ((HEAP32[i31 + 12 >> 2] | 0) == (HEAP32[i31 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i25 = invoke_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i27 = 25;
      break L4;
     }
     if ((i25 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i27 = 49;
      break;
     }
    }
    if (!i24) i27 = 50;
   } else i27 = 49; while (0);
   if ((i27 | 0) == 49 ? i24 : 0) i27 = 50;
   if ((i27 | 0) == 50) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i25 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   STACKTOP = i1;
   return i25 | 0;
  } else i27 = 25;
 } else i27 = 25; while (0);
 if ((i27 | 0) == 25) {
  i27 = ___cxa_find_matching_catch() | 0;
  i40 = i27;
  i41 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 ___resumeException(i40 | 0);
 return 0;
}

function __ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i8 = i1 + 24 | 0;
 i9 = i1;
 i10 = i1 + 136 | 0;
 i11 = i1 + 16 | 0;
 i12 = i1 + 12 | 0;
 i13 = i1 + 8 | 0;
 i14 = i1 + 134 | 0;
 i15 = i1 + 4 | 0;
 i16 = i1 + 124 | 0;
 HEAP32[i11 >> 2] = i10;
 i17 = i11 + 4 | 0;
 HEAP32[i17 >> 2] = 287;
 i18 = i10 + 100 | 0;
 __THREW__ = 0;
 i19 = invoke_ii(131, i5 | 0) | 0;
 i20 = __THREW__;
 __THREW__ = 0;
 if (!(i20 & 1)) {
  HEAP32[i13 >> 2] = i19;
  __THREW__ = 0;
  i19 = invoke_iii(55, i13 | 0, 26580) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  L4 : do if (!(i20 & 1) ? (HEAP8[i14 >> 0] = 0, HEAP32[i15 >> 2] = HEAP32[i3 >> 2], i21 = HEAP32[i5 + 4 >> 2] | 0, __THREW__ = 0, HEAP32[i8 >> 2] = HEAP32[i15 >> 2], i22 = invoke_iiiiiiiiiiii(1, i2 | 0, i8 | 0, i4 | 0, i13 | 0, i21 | 0, i6 | 0, i14 | 0, i19 | 0, i11 | 0, i12 | 0, i18 | 0) | 0, i21 = __THREW__, __THREW__ = 0, !(i21 & 1)) : 0) {
   L7 : do if (i22) {
    __THREW__ = 0;
    invoke_iiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 32 >> 2] | 0, i19 | 0, 47639, 47649, i16 | 0) | 0;
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) {
     i23 = 10;
     break L4;
    }
    i21 = HEAP32[i12 >> 2] | 0;
    i24 = HEAP32[i11 >> 2] | 0;
    i25 = i21 - i24 | 0;
    if ((i25 | 0) > 98) {
     i26 = _malloc(i25 + 2 | 0) | 0;
     i25 = i26;
     if (!i26) {
      __THREW__ = 0;
      invoke_v(5);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) i28 = i25; else {
       i29 = i25;
       i30 = 0;
       i23 = 13;
      }
     } else {
      i29 = i25;
      i30 = i26;
      i23 = 13;
     }
    } else {
     i29 = 0;
     i30 = i8;
     i23 = 13;
    }
    do if ((i23 | 0) == 13) {
     if (!(HEAP8[i14 >> 0] | 0)) i31 = i30; else {
      HEAP8[i30 >> 0] = 45;
      i31 = i30 + 1 | 0;
     }
     i26 = i16 + 10 | 0;
     i25 = i16;
     if (i24 >>> 0 < i21 >>> 0) {
      i27 = i16 + 1 | 0;
      i32 = i27 + 1 | 0;
      i33 = i32 + 1 | 0;
      i34 = i33 + 1 | 0;
      i35 = i34 + 1 | 0;
      i36 = i35 + 1 | 0;
      i37 = i36 + 1 | 0;
      i38 = i37 + 1 | 0;
      i39 = i38 + 1 | 0;
      i40 = i31;
      i41 = i24;
      while (1) {
       i42 = HEAP8[i41 >> 0] | 0;
       do if ((HEAP8[i16 >> 0] | 0) != i42 << 24 >> 24) if ((HEAP8[i27 >> 0] | 0) != i42 << 24 >> 24) if ((HEAP8[i32 >> 0] | 0) != i42 << 24 >> 24) if ((HEAP8[i33 >> 0] | 0) != i42 << 24 >> 24) if ((HEAP8[i34 >> 0] | 0) == i42 << 24 >> 24) i43 = i34; else {
        if ((HEAP8[i35 >> 0] | 0) == i42 << 24 >> 24) {
         i43 = i35;
         break;
        }
        if ((HEAP8[i36 >> 0] | 0) == i42 << 24 >> 24) {
         i43 = i36;
         break;
        }
        if ((HEAP8[i37 >> 0] | 0) == i42 << 24 >> 24) {
         i43 = i37;
         break;
        }
        if ((HEAP8[i38 >> 0] | 0) == i42 << 24 >> 24) {
         i43 = i38;
         break;
        }
        i43 = (HEAP8[i39 >> 0] | 0) == i42 << 24 >> 24 ? i39 : i26;
       } else i43 = i33; else i43 = i32; else i43 = i27; else i43 = i16; while (0);
       HEAP8[i40 >> 0] = HEAP8[47639 + (i43 - i25) >> 0] | 0;
       i41 = i41 + 1 | 0;
       i42 = i40 + 1 | 0;
       if (i41 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) {
        i44 = i42;
        break;
       } else i40 = i42;
      }
     } else i44 = i31;
     HEAP8[i44 >> 0] = 0;
     HEAP32[i9 >> 2] = i7;
     if ((_sscanf(i8, 47650, i9) | 0) != 1 ? (__THREW__ = 0, invoke_vi(288, 47654), i40 = __THREW__, __THREW__ = 0, i40 & 1) : 0) {
      i28 = i29;
      break;
     }
     if (i29) _free(i29);
     break L7;
    } while (0);
    i24 = ___cxa_find_matching_catch() | 0;
    i21 = tempRet0;
    if (!i28) {
     i45 = i24;
     i46 = i21;
     i47 = i11;
     break L4;
    }
    _free(i28);
    i45 = i24;
    i46 = i21;
    i47 = i11;
    break L4;
   } while (0);
   i22 = HEAP32[i2 >> 2] | 0;
   do if (i22) if ((HEAP32[i22 + 12 >> 2] | 0) == (HEAP32[i22 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i21 = invoke_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] | 0, i22 | 0) | 0;
    i24 = __THREW__;
    __THREW__ = 0;
    if (i24 & 1) {
     i23 = 10;
     break L4;
    }
    if ((i21 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i48 = 0;
     break;
    } else {
     i48 = HEAP32[i2 >> 2] | 0;
     break;
    }
   } else i48 = i22; else i48 = 0; while (0);
   i22 = (i48 | 0) == 0;
   i21 = HEAP32[i3 >> 2] | 0;
   do if (i21) {
    if ((HEAP32[i21 + 12 >> 2] | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
     i40 = __THREW__;
     __THREW__ = 0;
     if (i40 & 1) {
      i23 = 10;
      break L4;
     }
     if ((i24 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i23 = 37;
      break;
     }
    }
    if (!i22) i23 = 38;
   } else i23 = 37; while (0);
   if ((i23 | 0) == 37 ? i22 : 0) i23 = 38;
   if ((i23 | 0) == 38) HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2;
   i21 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
   i24 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = 0;
   if ((i24 | 0) != 0 ? (__THREW__ = 0, invoke_vi(HEAP32[i17 >> 2] | 0, i24 | 0), i24 = __THREW__, __THREW__ = 0, i24 & 1) : 0) {
    i24 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i24);
   }
   STACKTOP = i1;
   return i21 | 0;
  } else i23 = 10; while (0);
  if ((i23 | 0) == 10) {
   i1 = ___cxa_find_matching_catch() | 0;
   i45 = i1;
   i46 = tempRet0;
   i47 = i11;
  }
  __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
  i13 = HEAP32[i47 >> 2] | 0;
  HEAP32[i47 >> 2] = 0;
  if (!i13) {
   i49 = i45;
   i50 = i46;
  } else {
   i51 = i45;
   i52 = i46;
   i53 = HEAP32[i17 >> 2] | 0;
   i54 = i13;
   i23 = 45;
  }
 } else {
  i13 = ___cxa_find_matching_catch() | 0;
  HEAP32[i11 >> 2] = 0;
  i51 = i13;
  i52 = tempRet0;
  i53 = 287;
  i54 = i10;
  i23 = 45;
 }
 if ((i23 | 0) == 45) {
  __THREW__ = 0;
  invoke_vi(i53 | 0, i54 | 0);
  i54 = __THREW__;
  __THREW__ = 0;
  if (i54 & 1) {
   i54 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i54);
  } else {
   i49 = i51;
   i50 = i52;
  }
 }
 ___resumeException(i49 | 0);
 return 0;
}

function __ZNSt3__16locale5__impC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = 26556;
 i2 = i1 + 8 | 0;
 __THREW__ = 0;
 invoke_vii(73, i2 | 0, 28);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  i4 = tempRet0;
  i5 = i3;
 } else {
  i3 = i1 + 144 | 0;
  __THREW__ = 0;
  invoke_viii(13, i3 | 0, 47548, 1);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch() | 0;
   i7 = tempRet0;
   i8 = i6;
  } else {
   i6 = HEAP32[i2 >> 2] | 0;
   i9 = i1 + 12 | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   if ((i10 | 0) != (i6 | 0)) {
    i11 = i10;
    while (1) {
     i10 = i11 + -4 | 0;
     if ((i10 | 0) == (i6 | 0)) {
      i12 = i10;
      break;
     } else i11 = i10;
    }
    HEAP32[i9 >> 2] = i12;
   }
   HEAP32[4103] = 0;
   HEAP32[4102] = 25484;
   __THREW__ = 0;
   invoke_vii(74, i1 | 0, 16408);
   i12 = __THREW__;
   __THREW__ = 0;
   do if (((((((((((((!(i12 & 1) ? (HEAP32[4105] = 0, HEAP32[4104] = 25524, __THREW__ = 0, invoke_vii(75, i1 | 0, 16416), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (HEAP32[4107] = 0, HEAP32[4106] = 26596, HEAP32[4108] = 0, HEAP8[16436] = 0, i9 = __ZNSt3__15ctypeIcE13classic_tableEv() | 0, HEAP32[4108] = i9, __THREW__ = 0, invoke_vii(76, i1 | 0, 16424), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (HEAP32[4111] = 0, HEAP32[4110] = 26844, __THREW__ = 0, invoke_vii(77, i1 | 0, 16440), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (HEAP32[4113] = 0, HEAP32[4112] = 26912, __THREW__ = 0, invoke_vii(78, i1 | 0, 16448), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (__THREW__ = 0, invoke_vii(79, 16456, 1), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (__THREW__ = 0, invoke_vii(80, i1 | 0, 16456), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (HEAP32[4119] = 0, HEAP32[4118] = 26960, __THREW__ = 0, invoke_vii(81, i1 | 0, 16472), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (HEAP32[4121] = 0, HEAP32[4120] = 27008, __THREW__ = 0, invoke_vii(82, i1 | 0, 16480), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (__ZNSt3__18numpunctIcEC2Ej(16488, 1), __THREW__ = 0, invoke_vii(83, i1 | 0, 16488), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (__ZNSt3__18numpunctIwEC2Ej(16512, 1), __THREW__ = 0, invoke_vii(84, i1 | 0, 16512), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (HEAP32[4137] = 0, HEAP32[4136] = 25564, __THREW__ = 0, invoke_vii(85, i1 | 0, 16544), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (HEAP32[4139] = 0, HEAP32[4138] = 25636, __THREW__ = 0, invoke_vii(86, i1 | 0, 16552), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) ? (HEAP32[4141] = 0, HEAP32[4140] = 25708, __THREW__ = 0, invoke_vii(87, i1 | 0, 16560), i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) {
    HEAP32[4143] = 0;
    HEAP32[4142] = 25768;
    __THREW__ = 0;
    invoke_vii(88, i1 | 0, 16568);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4145] = 0;
    HEAP32[4144] = 26076;
    __THREW__ = 0;
    invoke_vii(89, i1 | 0, 16576);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4147] = 0;
    HEAP32[4146] = 26140;
    __THREW__ = 0;
    invoke_vii(90, i1 | 0, 16584);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4149] = 0;
    HEAP32[4148] = 26204;
    __THREW__ = 0;
    invoke_vii(91, i1 | 0, 16592);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4151] = 0;
    HEAP32[4150] = 26268;
    __THREW__ = 0;
    invoke_vii(92, i1 | 0, 16600);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4153] = 0;
    HEAP32[4152] = 26332;
    __THREW__ = 0;
    invoke_vii(93, i1 | 0, 16608);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4155] = 0;
    HEAP32[4154] = 26368;
    __THREW__ = 0;
    invoke_vii(94, i1 | 0, 16616);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4157] = 0;
    HEAP32[4156] = 26404;
    __THREW__ = 0;
    invoke_vii(95, i1 | 0, 16624);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4159] = 0;
    HEAP32[4158] = 26440;
    __THREW__ = 0;
    invoke_vii(96, i1 | 0, 16632);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4161] = 0;
    HEAP32[4160] = 25828;
    HEAP32[4162] = 25876;
    __THREW__ = 0;
    invoke_vii(97, i1 | 0, 16640);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4165] = 0;
    HEAP32[4164] = 25920;
    HEAP32[4166] = 25968;
    __THREW__ = 0;
    invoke_vii(98, i1 | 0, 16656);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4169] = 0;
    HEAP32[4168] = 26824;
    __THREW__ = 0;
    i9 = invoke_i(22) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i11 = ___cxa_find_matching_catch() | 0;
     i14 = tempRet0;
     i15 = i11;
     break;
    }
    HEAP32[4170] = i9;
    HEAP32[4168] = 26012;
    __THREW__ = 0;
    invoke_vii(99, i1 | 0, 16672);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4173] = 0;
    HEAP32[4172] = 26824;
    __THREW__ = 0;
    i9 = invoke_i(22) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i11 = ___cxa_find_matching_catch() | 0;
     i14 = tempRet0;
     i15 = i11;
     break;
    }
    HEAP32[4174] = i9;
    HEAP32[4172] = 26044;
    __THREW__ = 0;
    invoke_vii(100, i1 | 0, 16688);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4177] = 0;
    HEAP32[4176] = 26476;
    __THREW__ = 0;
    invoke_vii(101, i1 | 0, 16704);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    HEAP32[4179] = 0;
    HEAP32[4178] = 26516;
    __THREW__ = 0;
    invoke_vii(102, i1 | 0, 16712);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i13 = 42;
     break;
    }
    return;
   } else i13 = 42; while (0);
   if ((i13 | 0) == 42) {
    i13 = ___cxa_find_matching_catch() | 0;
    i14 = tempRet0;
    i15 = i13;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   i7 = i14;
   i8 = i15;
  }
  __ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i2);
  i4 = i7;
  i5 = i8;
 }
 ___resumeException(i5 | 0);
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 202 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP8[i8 >> 0] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) if ((HEAP32[i21 + 12 >> 2] | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i18 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if ((i18 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i25 = 0;
    } else i25 = i21;
   } else i25 = i21; else i25 = 0;
   i18 = (i25 | 0) == 0;
   i23 = HEAP32[i3 >> 2] | 0;
   do if (i23) {
    if ((HEAP32[i23 + 12 >> 2] | 0) != (HEAP32[i23 + 16 >> 2] | 0)) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    }
    __THREW__ = 0;
    i30 = invoke_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] | 0, i23 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break L6;
    }
    if ((i30 | 0) != -1) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i24 = 16;
     break;
    }
   } else i24 = 16; while (0);
   if ((i24 | 0) == 16) {
    i24 = 0;
    if (i18) {
     i27 = i25;
     i28 = 0;
     i29 = i22;
     break;
    } else i26 = 0;
   }
   i23 = HEAP8[i10 >> 0] | 0;
   i30 = (i23 & 1) == 0 ? (i23 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i30 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i30 << 1 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i32 = 10; else i32 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i32 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    i23 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i23 + i30;
    i33 = i23;
   } else i33 = i22;
   i23 = i25 + 12 | 0;
   i30 = HEAP32[i23 >> 2] | 0;
   i31 = i25 + 16 | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    i34 = invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
    i35 = __THREW__;
    __THREW__ = 0;
    if (i35 & 1) {
     i24 = 24;
     break;
    } else i36 = i34;
   } else i36 = HEAPU8[i30 >> 0] | 0;
   if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i36 & 255, i15, i33, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i27 = i25;
    i28 = i26;
    i29 = i33;
    break;
   }
   i30 = HEAP32[i23 >> 2] | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 40 >> 2] | 0, i25 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break;
    } else {
     i21 = i25;
     i22 = i33;
     continue;
    }
   } else {
    HEAP32[i23 >> 2] = i30 + 1;
    i21 = i25;
    i22 = i33;
    continue;
   }
  }
  if ((i24 | 0) == 24) {
   i22 = ___cxa_find_matching_catch() | 0;
   i37 = i22;
   i38 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(19, i29 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = tempRet0;
  i20 = __THREW__;
  __THREW__ = 0;
  if (!(i20 & 1)) {
   i20 = i6;
   HEAP32[i20 >> 2] = i21;
   HEAP32[i20 + 4 >> 2] = i22;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i27) if ((HEAP32[i27 + 12 >> 2] | 0) == (HEAP32[i27 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i22 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i20 = __THREW__;
    __THREW__ = 0;
    if (i20 & 1) {
     i24 = 25;
     break;
    }
    if ((i22 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i39 = 0;
    } else i39 = i27;
   } else i39 = i27; else i39 = 0;
   i22 = (i39 | 0) == 0;
   do if (i28) {
    if ((HEAP32[i28 + 12 >> 2] | 0) == (HEAP32[i28 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i20 = invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i24 = 25;
      break L4;
     }
     if ((i20 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i24 = 49;
      break;
     }
    }
    if (!i22) i24 = 50;
   } else i24 = 49; while (0);
   if ((i24 | 0) == 49 ? i22 : 0) i24 = 50;
   if ((i24 | 0) == 50) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i20 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i20 | 0;
  } else i24 = 25;
 } else i24 = 25; while (0);
 if ((i24 | 0) == 25) {
  i24 = ___cxa_find_matching_catch() | 0;
  i37 = i24;
  i38 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i37 | 0);
 return 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 202 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP8[i8 >> 0] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) if ((HEAP32[i21 + 12 >> 2] | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i18 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if ((i18 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i25 = 0;
    } else i25 = i21;
   } else i25 = i21; else i25 = 0;
   i18 = (i25 | 0) == 0;
   i23 = HEAP32[i3 >> 2] | 0;
   do if (i23) {
    if ((HEAP32[i23 + 12 >> 2] | 0) != (HEAP32[i23 + 16 >> 2] | 0)) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    }
    __THREW__ = 0;
    i30 = invoke_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] | 0, i23 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break L6;
    }
    if ((i30 | 0) != -1) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i24 = 16;
     break;
    }
   } else i24 = 16; while (0);
   if ((i24 | 0) == 16) {
    i24 = 0;
    if (i18) {
     i27 = i25;
     i28 = 0;
     i29 = i22;
     break;
    } else i26 = 0;
   }
   i23 = HEAP8[i10 >> 0] | 0;
   i30 = (i23 & 1) == 0 ? (i23 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i30 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i30 << 1 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i32 = 10; else i32 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i32 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    i23 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i23 + i30;
    i33 = i23;
   } else i33 = i22;
   i23 = i25 + 12 | 0;
   i30 = HEAP32[i23 >> 2] | 0;
   i31 = i25 + 16 | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    i34 = invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
    i35 = __THREW__;
    __THREW__ = 0;
    if (i35 & 1) {
     i24 = 24;
     break;
    } else i36 = i34;
   } else i36 = HEAPU8[i30 >> 0] | 0;
   if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i36 & 255, i15, i33, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i27 = i25;
    i28 = i26;
    i29 = i33;
    break;
   }
   i30 = HEAP32[i23 >> 2] | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 40 >> 2] | 0, i25 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break;
    } else {
     i21 = i25;
     i22 = i33;
     continue;
    }
   } else {
    HEAP32[i23 >> 2] = i30 + 1;
    i21 = i25;
    i22 = i33;
    continue;
   }
  }
  if ((i24 | 0) == 24) {
   i22 = ___cxa_find_matching_catch() | 0;
   i37 = i22;
   i38 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(15, i29 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = tempRet0;
  i20 = __THREW__;
  __THREW__ = 0;
  if (!(i20 & 1)) {
   i20 = i6;
   HEAP32[i20 >> 2] = i21;
   HEAP32[i20 + 4 >> 2] = i22;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i27) if ((HEAP32[i27 + 12 >> 2] | 0) == (HEAP32[i27 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i22 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i20 = __THREW__;
    __THREW__ = 0;
    if (i20 & 1) {
     i24 = 25;
     break;
    }
    if ((i22 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i39 = 0;
    } else i39 = i27;
   } else i39 = i27; else i39 = 0;
   i22 = (i39 | 0) == 0;
   do if (i28) {
    if ((HEAP32[i28 + 12 >> 2] | 0) == (HEAP32[i28 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i20 = invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i24 = 25;
      break L4;
     }
     if ((i20 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i24 = 49;
      break;
     }
    }
    if (!i22) i24 = 50;
   } else i24 = 49; while (0);
   if ((i24 | 0) == 49 ? i22 : 0) i24 = 50;
   if ((i24 | 0) == 50) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i20 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i20 | 0;
  } else i24 = 25;
 } else i24 = 25; while (0);
 if ((i24 | 0) == 25) {
  i24 = ___cxa_find_matching_catch() | 0;
  i37 = i24;
  i38 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i37 | 0);
 return 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 202 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP8[i8 >> 0] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) if ((HEAP32[i21 + 12 >> 2] | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i18 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if ((i18 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i25 = 0;
    } else i25 = i21;
   } else i25 = i21; else i25 = 0;
   i18 = (i25 | 0) == 0;
   i23 = HEAP32[i3 >> 2] | 0;
   do if (i23) {
    if ((HEAP32[i23 + 12 >> 2] | 0) != (HEAP32[i23 + 16 >> 2] | 0)) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    }
    __THREW__ = 0;
    i30 = invoke_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] | 0, i23 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break L6;
    }
    if ((i30 | 0) != -1) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i24 = 16;
     break;
    }
   } else i24 = 16; while (0);
   if ((i24 | 0) == 16) {
    i24 = 0;
    if (i18) {
     i27 = i25;
     i28 = 0;
     i29 = i22;
     break;
    } else i26 = 0;
   }
   i23 = HEAP8[i10 >> 0] | 0;
   i30 = (i23 & 1) == 0 ? (i23 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i30 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i30 << 1 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i32 = 10; else i32 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i32 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    i23 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i23 + i30;
    i33 = i23;
   } else i33 = i22;
   i23 = i25 + 12 | 0;
   i30 = HEAP32[i23 >> 2] | 0;
   i31 = i25 + 16 | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    i34 = invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
    i35 = __THREW__;
    __THREW__ = 0;
    if (i35 & 1) {
     i24 = 24;
     break;
    } else i36 = i34;
   } else i36 = HEAPU8[i30 >> 0] | 0;
   if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i36 & 255, i15, i33, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i27 = i25;
    i28 = i26;
    i29 = i33;
    break;
   }
   i30 = HEAP32[i23 >> 2] | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 40 >> 2] | 0, i25 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break;
    } else {
     i21 = i25;
     i22 = i33;
     continue;
    }
   } else {
    HEAP32[i23 >> 2] = i30 + 1;
    i21 = i25;
    i22 = i33;
    continue;
   }
  }
  if ((i24 | 0) == 24) {
   i22 = ___cxa_find_matching_catch() | 0;
   i37 = i22;
   i38 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(16, i29 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (!(i22 & 1)) {
   HEAP16[i6 >> 1] = i21;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i27) if ((HEAP32[i27 + 12 >> 2] | 0) == (HEAP32[i27 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i21 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i22 = __THREW__;
    __THREW__ = 0;
    if (i22 & 1) {
     i24 = 25;
     break;
    }
    if ((i21 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i39 = 0;
    } else i39 = i27;
   } else i39 = i27; else i39 = 0;
   i21 = (i39 | 0) == 0;
   do if (i28) {
    if ((HEAP32[i28 + 12 >> 2] | 0) == (HEAP32[i28 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i24 = 25;
      break L4;
     }
     if ((i22 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i24 = 49;
      break;
     }
    }
    if (!i21) i24 = 50;
   } else i24 = 49; while (0);
   if ((i24 | 0) == 49 ? i21 : 0) i24 = 50;
   if ((i24 | 0) == 50) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i22 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i22 | 0;
  } else i24 = 25;
 } else i24 = 25; while (0);
 if ((i24 | 0) == 25) {
  i24 = ___cxa_find_matching_catch() | 0;
  i37 = i24;
  i38 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i37 | 0);
 return 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 202 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP8[i8 >> 0] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) if ((HEAP32[i21 + 12 >> 2] | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i18 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if ((i18 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i25 = 0;
    } else i25 = i21;
   } else i25 = i21; else i25 = 0;
   i18 = (i25 | 0) == 0;
   i23 = HEAP32[i3 >> 2] | 0;
   do if (i23) {
    if ((HEAP32[i23 + 12 >> 2] | 0) != (HEAP32[i23 + 16 >> 2] | 0)) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    }
    __THREW__ = 0;
    i30 = invoke_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] | 0, i23 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break L6;
    }
    if ((i30 | 0) != -1) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i24 = 16;
     break;
    }
   } else i24 = 16; while (0);
   if ((i24 | 0) == 16) {
    i24 = 0;
    if (i18) {
     i27 = i25;
     i28 = 0;
     i29 = i22;
     break;
    } else i26 = 0;
   }
   i23 = HEAP8[i10 >> 0] | 0;
   i30 = (i23 & 1) == 0 ? (i23 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i30 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i30 << 1 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i32 = 10; else i32 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i32 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    i23 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i23 + i30;
    i33 = i23;
   } else i33 = i22;
   i23 = i25 + 12 | 0;
   i30 = HEAP32[i23 >> 2] | 0;
   i31 = i25 + 16 | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    i34 = invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
    i35 = __THREW__;
    __THREW__ = 0;
    if (i35 & 1) {
     i24 = 24;
     break;
    } else i36 = i34;
   } else i36 = HEAPU8[i30 >> 0] | 0;
   if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i36 & 255, i15, i33, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i27 = i25;
    i28 = i26;
    i29 = i33;
    break;
   }
   i30 = HEAP32[i23 >> 2] | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 40 >> 2] | 0, i25 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break;
    } else {
     i21 = i25;
     i22 = i33;
     continue;
    }
   } else {
    HEAP32[i23 >> 2] = i30 + 1;
    i21 = i25;
    i22 = i33;
    continue;
   }
  }
  if ((i24 | 0) == 24) {
   i22 = ___cxa_find_matching_catch() | 0;
   i37 = i22;
   i38 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(18, i29 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (!(i22 & 1)) {
   HEAP32[i6 >> 2] = i21;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i27) if ((HEAP32[i27 + 12 >> 2] | 0) == (HEAP32[i27 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i21 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i22 = __THREW__;
    __THREW__ = 0;
    if (i22 & 1) {
     i24 = 25;
     break;
    }
    if ((i21 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i39 = 0;
    } else i39 = i27;
   } else i39 = i27; else i39 = 0;
   i21 = (i39 | 0) == 0;
   do if (i28) {
    if ((HEAP32[i28 + 12 >> 2] | 0) == (HEAP32[i28 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i24 = 25;
      break L4;
     }
     if ((i22 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i24 = 49;
      break;
     }
    }
    if (!i21) i24 = 50;
   } else i24 = 49; while (0);
   if ((i24 | 0) == 49 ? i21 : 0) i24 = 50;
   if ((i24 | 0) == 50) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i22 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i22 | 0;
  } else i24 = 25;
 } else i24 = 25; while (0);
 if ((i24 | 0) == 25) {
  i24 = ___cxa_find_matching_catch() | 0;
  i37 = i24;
  i38 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i37 | 0);
 return 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 202 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP8[i8 >> 0] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) if ((HEAP32[i21 + 12 >> 2] | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i18 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if ((i18 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i25 = 0;
    } else i25 = i21;
   } else i25 = i21; else i25 = 0;
   i18 = (i25 | 0) == 0;
   i23 = HEAP32[i3 >> 2] | 0;
   do if (i23) {
    if ((HEAP32[i23 + 12 >> 2] | 0) != (HEAP32[i23 + 16 >> 2] | 0)) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    }
    __THREW__ = 0;
    i30 = invoke_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] | 0, i23 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break L6;
    }
    if ((i30 | 0) != -1) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i24 = 16;
     break;
    }
   } else i24 = 16; while (0);
   if ((i24 | 0) == 16) {
    i24 = 0;
    if (i18) {
     i27 = i25;
     i28 = 0;
     i29 = i22;
     break;
    } else i26 = 0;
   }
   i23 = HEAP8[i10 >> 0] | 0;
   i30 = (i23 & 1) == 0 ? (i23 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i30 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i30 << 1 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i32 = 10; else i32 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i32 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    i23 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i23 + i30;
    i33 = i23;
   } else i33 = i22;
   i23 = i25 + 12 | 0;
   i30 = HEAP32[i23 >> 2] | 0;
   i31 = i25 + 16 | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    i34 = invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
    i35 = __THREW__;
    __THREW__ = 0;
    if (i35 & 1) {
     i24 = 24;
     break;
    } else i36 = i34;
   } else i36 = HEAPU8[i30 >> 0] | 0;
   if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i36 & 255, i15, i33, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i27 = i25;
    i28 = i26;
    i29 = i33;
    break;
   }
   i30 = HEAP32[i23 >> 2] | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 40 >> 2] | 0, i25 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break;
    } else {
     i21 = i25;
     i22 = i33;
     continue;
    }
   } else {
    HEAP32[i23 >> 2] = i30 + 1;
    i21 = i25;
    i22 = i33;
    continue;
   }
  }
  if ((i24 | 0) == 24) {
   i22 = ___cxa_find_matching_catch() | 0;
   i37 = i22;
   i38 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(17, i29 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (!(i22 & 1)) {
   HEAP32[i6 >> 2] = i21;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i27) if ((HEAP32[i27 + 12 >> 2] | 0) == (HEAP32[i27 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i21 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i22 = __THREW__;
    __THREW__ = 0;
    if (i22 & 1) {
     i24 = 25;
     break;
    }
    if ((i21 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i39 = 0;
    } else i39 = i27;
   } else i39 = i27; else i39 = 0;
   i21 = (i39 | 0) == 0;
   do if (i28) {
    if ((HEAP32[i28 + 12 >> 2] | 0) == (HEAP32[i28 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i24 = 25;
      break L4;
     }
     if ((i22 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i24 = 49;
      break;
     }
    }
    if (!i21) i24 = 50;
   } else i24 = 49; while (0);
   if ((i24 | 0) == 49 ? i21 : 0) i24 = 50;
   if ((i24 | 0) == 50) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i22 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i22 | 0;
  } else i24 = 25;
 } else i24 = 25; while (0);
 if ((i24 | 0) == 25) {
  i24 = ___cxa_find_matching_catch() | 0;
  i37 = i24;
  i38 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i37 | 0);
 return 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 202 | 0;
 i8 = i1 + 200 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1;
 i15 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i4) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i9, i4, i7, i8);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (!(HEAP8[i10 >> 0] & 1)) i16 = 10; else i16 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
 __THREW__ = 0;
 invoke_viii(9, i10 | 0, i16 | 0, 0);
 i16 = __THREW__;
 __THREW__ = 0;
 L4 : do if (!(i16 & 1)) {
  i4 = i10 + 8 | 0;
  i17 = i10 + 1 | 0;
  i18 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = 0;
  i19 = i10 + 4 | 0;
  i20 = HEAP8[i8 >> 0] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = i18;
  L6 : while (1) {
   if (i21) if ((HEAP32[i21 + 12 >> 2] | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i18 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if ((i18 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i25 = 0;
    } else i25 = i21;
   } else i25 = i21; else i25 = 0;
   i18 = (i25 | 0) == 0;
   i23 = HEAP32[i3 >> 2] | 0;
   do if (i23) {
    if ((HEAP32[i23 + 12 >> 2] | 0) != (HEAP32[i23 + 16 >> 2] | 0)) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    }
    __THREW__ = 0;
    i30 = invoke_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] | 0, i23 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break L6;
    }
    if ((i30 | 0) != -1) if (i18) {
     i26 = i23;
     break;
    } else {
     i27 = i25;
     i28 = i23;
     i29 = i22;
     break L6;
    } else {
     HEAP32[i3 >> 2] = 0;
     i24 = 16;
     break;
    }
   } else i24 = 16; while (0);
   if ((i24 | 0) == 16) {
    i24 = 0;
    if (i18) {
     i27 = i25;
     i28 = 0;
     i29 = i22;
     break;
    } else i26 = 0;
   }
   i23 = HEAP8[i10 >> 0] | 0;
   i30 = (i23 & 1) == 0 ? (i23 & 255) >>> 1 : HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i22 + i30 | 0)) {
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i30 << 1 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    if (!(HEAP8[i10 >> 0] & 1)) i32 = 10; else i32 = (HEAP32[i10 >> 2] & -2) + -1 | 0;
    __THREW__ = 0;
    invoke_viii(9, i10 | 0, i32 | 0, 0);
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i24 = 24;
     break;
    }
    i23 = (HEAP8[i10 >> 0] & 1) == 0 ? i17 : HEAP32[i4 >> 2] | 0;
    HEAP32[i11 >> 2] = i23 + i30;
    i33 = i23;
   } else i33 = i22;
   i23 = i25 + 12 | 0;
   i30 = HEAP32[i23 >> 2] | 0;
   i31 = i25 + 16 | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    i34 = invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
    i35 = __THREW__;
    __THREW__ = 0;
    if (i35 & 1) {
     i24 = 24;
     break;
    } else i36 = i34;
   } else i36 = HEAPU8[i30 >> 0] | 0;
   if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i36 & 255, i15, i33, i11, i14, i20, i9, i12, i13, i7) | 0) {
    i27 = i25;
    i28 = i26;
    i29 = i33;
    break;
   }
   i30 = HEAP32[i23 >> 2] | 0;
   if ((i30 | 0) == (HEAP32[i31 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 40 >> 2] | 0, i25 | 0) | 0;
    i31 = __THREW__;
    __THREW__ = 0;
    if (i31 & 1) {
     i24 = 24;
     break;
    } else {
     i21 = i25;
     i22 = i33;
     continue;
    }
   } else {
    HEAP32[i23 >> 2] = i30 + 1;
    i21 = i25;
    i22 = i33;
    continue;
   }
  }
  if ((i24 | 0) == 24) {
   i22 = ___cxa_find_matching_catch() | 0;
   i37 = i22;
   i38 = tempRet0;
   break;
  }
  i22 = HEAP8[i9 >> 0] | 0;
  if ((((i22 & 1) == 0 ? (i22 & 255) >>> 1 : HEAP32[i9 + 4 >> 2] | 0) | 0) != 0 ? (i22 = HEAP32[i13 >> 2] | 0, (i22 - i12 | 0) < 160) : 0) {
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i22 + 4;
   HEAP32[i22 >> 2] = i21;
  }
  __THREW__ = 0;
  i21 = invoke_iiiii(14, i29 | 0, HEAP32[i11 >> 2] | 0, i5 | 0, i15 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (!(i22 & 1)) {
   HEAP32[i6 >> 2] = i21;
   __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i9, i12, HEAP32[i13 >> 2] | 0, i5);
   if (i27) if ((HEAP32[i27 + 12 >> 2] | 0) == (HEAP32[i27 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i21 = invoke_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
    i22 = __THREW__;
    __THREW__ = 0;
    if (i22 & 1) {
     i24 = 25;
     break;
    }
    if ((i21 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i39 = 0;
    } else i39 = i27;
   } else i39 = i27; else i39 = 0;
   i21 = (i39 | 0) == 0;
   do if (i28) {
    if ((HEAP32[i28 + 12 >> 2] | 0) == (HEAP32[i28 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i22 = invoke_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i24 = 25;
      break L4;
     }
     if ((i22 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i24 = 49;
      break;
     }
    }
    if (!i21) i24 = 50;
   } else i24 = 49; while (0);
   if ((i24 | 0) == 49 ? i21 : 0) i24 = 50;
   if ((i24 | 0) == 50) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i22 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i1;
   return i22 | 0;
  } else i24 = 25;
 } else i24 = 25; while (0);
 if ((i24 | 0) == 25) {
  i24 = ___cxa_find_matching_catch() | 0;
  i37 = i24;
  i38 = tempRet0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i37 | 0);
 return 0;
}

function __ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe(i1, i2, i3, i4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 992 | 0;
 i7 = i1 + 8 | 0;
 i8 = i1;
 i9 = i1 + 888 | 0;
 i10 = i1 + 880 | 0;
 i11 = i1 + 480 | 0;
 i12 = i1 + 76 | 0;
 i13 = i1 + 884 | 0;
 i14 = i1 + 72 | 0;
 i15 = i1 + 68 | 0;
 i16 = i1 + 56 | 0;
 i17 = i1 + 44 | 0;
 i18 = i1 + 32 | 0;
 i19 = i1 + 28 | 0;
 i20 = i1 + 80 | 0;
 i21 = i1 + 24 | 0;
 i22 = i1 + 20 | 0;
 i23 = i1 + 16 | 0;
 HEAP32[i10 >> 2] = i9;
 HEAPF64[i7 >> 3] = d6;
 i24 = _snprintf(i9, 100, 47681, i7) | 0;
 do if (i24 >>> 0 > 99) {
  __THREW__ = 0;
  i9 = invoke_i(22) | 0;
  i25 = __THREW__;
  __THREW__ = 0;
  if (!(i25 & 1) ? (__THREW__ = 0, HEAPF64[i8 >> 3] = d6, i25 = invoke_iiiii(10, i10 | 0, i9 | 0, 47681, i8 | 0) | 0, i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) {
   i9 = HEAP32[i10 >> 2] | 0;
   if (!i9) {
    __THREW__ = 0;
    invoke_v(5);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 0;
     i28 = 0;
     i29 = 7;
     break;
    }
    i30 = HEAP32[i10 >> 2] | 0;
   } else i30 = i9;
   i9 = i30;
   i26 = _malloc(i25 << 2) | 0;
   i31 = i26;
   if (!i26) {
    __THREW__ = 0;
    invoke_v(5);
    i32 = __THREW__;
    __THREW__ = 0;
    if (i32 & 1) {
     i27 = i9;
     i28 = i31;
     i29 = 7;
    } else {
     i33 = i31;
     i34 = i9;
     i35 = 0;
     i36 = i25;
     i29 = 10;
    }
   } else {
    i33 = i31;
    i34 = i9;
    i35 = i26;
    i36 = i25;
    i29 = 10;
   }
  } else {
   i27 = 0;
   i28 = 0;
   i29 = 7;
  }
 } else {
  i33 = 0;
  i34 = 0;
  i35 = i11;
  i36 = i24;
  i29 = 10;
 } while (0);
 if ((i29 | 0) == 10) {
  __THREW__ = 0;
  i24 = invoke_ii(131, i4 | 0) | 0;
  i11 = __THREW__;
  __THREW__ = 0;
  if (i11 & 1) {
   i27 = i34;
   i28 = i33;
   i29 = 7;
  } else {
   HEAP32[i12 >> 2] = i24;
   __THREW__ = 0;
   i11 = invoke_iii(55, i12 | 0, 26572) | 0;
   i30 = __THREW__;
   __THREW__ = 0;
   if (!(i30 & 1) ? (i30 = HEAP32[i10 >> 2] | 0, __THREW__ = 0, invoke_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] | 0, i11 | 0, i30 | 0, i30 + i36 | 0, i35 | 0) | 0, i30 = __THREW__, __THREW__ = 0, !(i30 & 1)) : 0) {
    if (!i36) i37 = 0; else i37 = (HEAP8[HEAP32[i10 >> 2] >> 0] | 0) == 45;
    HEAP32[i16 >> 2] = 0;
    HEAP32[i16 + 4 >> 2] = 0;
    HEAP32[i16 + 8 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    HEAP32[i17 + 8 >> 2] = 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __THREW__ = 0;
    invoke_viiiiiiiiii(4, i3 | 0, i37 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) {
     i3 = HEAP32[i19 >> 2] | 0;
     if ((i36 | 0) > (i3 | 0)) {
      i19 = HEAP8[i18 >> 0] | 0;
      i10 = HEAP8[i17 >> 0] | 0;
      i38 = (i36 - i3 << 1 | 1) + i3 + ((i19 & 1) == 0 ? (i19 & 255) >>> 1 : HEAP32[i18 + 4 >> 2] | 0) + ((i10 & 1) == 0 ? (i10 & 255) >>> 1 : HEAP32[i17 + 4 >> 2] | 0) | 0;
     } else {
      i10 = HEAP8[i18 >> 0] | 0;
      i19 = HEAP8[i17 >> 0] | 0;
      i38 = i3 + 2 + ((i10 & 1) == 0 ? (i10 & 255) >>> 1 : HEAP32[i18 + 4 >> 2] | 0) + ((i19 & 1) == 0 ? (i19 & 255) >>> 1 : HEAP32[i17 + 4 >> 2] | 0) | 0;
     }
     if (i38 >>> 0 > 100) {
      i19 = _malloc(i38 << 2) | 0;
      i38 = i19;
      if (!i19) {
       __THREW__ = 0;
       invoke_v(5);
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) i39 = i38; else {
        i40 = i38;
        i41 = 0;
        i29 = 26;
       }
      } else {
       i40 = i38;
       i41 = i19;
       i29 = 26;
      }
     } else {
      i40 = 0;
      i41 = i20;
      i29 = 26;
     }
     if ((i29 | 0) == 26) {
      __THREW__ = 0;
      invoke_viiiiiiiiiiiiiii(2, i41 | 0, i21 | 0, i22 | 0, HEAP32[i4 + 4 >> 2] | 0, i35 | 0, i35 + (i36 << 2) | 0, i11 | 0, i37 | 0, i13 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] | 0, i16 | 0, i17 | 0, i18 | 0, i3 | 0);
      i3 = __THREW__;
      __THREW__ = 0;
      if (!(i3 & 1) ? (HEAP32[i23 >> 2] = HEAP32[i2 >> 2], i2 = HEAP32[i21 >> 2] | 0, i21 = HEAP32[i22 >> 2] | 0, __THREW__ = 0, HEAP32[i7 >> 2] = HEAP32[i23 >> 2], i23 = invoke_iiiiiii(40, i7 | 0, i41 | 0, i2 | 0, i21 | 0, i4 | 0, i5 | 0) | 0, i5 = __THREW__, __THREW__ = 0, !(i5 & 1)) : 0) {
       if (!i40) i42 = i24; else {
        _free(i40);
        i42 = HEAP32[i12 >> 2] | 0;
       }
       __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i18);
       __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i17);
       __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
       __ZNSt3__114__shared_count16__release_sharedEv(i42) | 0;
       if (i33) _free(i33);
       if (i34) _free(i34);
       STACKTOP = i1;
       return i23 | 0;
      } else i39 = i40;
     }
     i40 = ___cxa_find_matching_catch() | 0;
     i23 = tempRet0;
     if (!i39) {
      i43 = i40;
      i44 = i23;
      i45 = i24;
     } else {
      _free(i39);
      i43 = i40;
      i44 = i23;
      i45 = HEAP32[i12 >> 2] | 0;
     }
    } else {
     i12 = ___cxa_find_matching_catch() | 0;
     i43 = i12;
     i44 = tempRet0;
     i45 = i24;
    }
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i18);
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i17);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
    i46 = i43;
    i47 = i44;
    i48 = i45;
   } else {
    i45 = ___cxa_find_matching_catch() | 0;
    i46 = i45;
    i47 = tempRet0;
    i48 = i24;
   }
   __ZNSt3__114__shared_count16__release_sharedEv(i48) | 0;
   i49 = i46;
   i50 = i47;
   i51 = i33;
   i52 = i34;
  }
 }
 if ((i29 | 0) == 7) {
  i29 = ___cxa_find_matching_catch() | 0;
  i49 = i29;
  i50 = tempRet0;
  i51 = i28;
  i52 = i27;
 }
 if (i51) _free(i51);
 if (i52) _free(i52);
 ___resumeException(i49 | 0);
 return 0;
}

function __ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce(i1, i2, i3, i4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 i7 = i1 + 8 | 0;
 i8 = i1;
 i9 = i1 + 284 | 0;
 i10 = i1 + 72 | 0;
 i11 = i1 + 184 | 0;
 i12 = i1 + 68 | 0;
 i13 = i1 + 80 | 0;
 i14 = i1 + 77 | 0;
 i15 = i1 + 76 | 0;
 i16 = i1 + 56 | 0;
 i17 = i1 + 44 | 0;
 i18 = i1 + 32 | 0;
 i19 = i1 + 28 | 0;
 i20 = i1 + 84 | 0;
 i21 = i1 + 24 | 0;
 i22 = i1 + 20 | 0;
 i23 = i1 + 16 | 0;
 HEAP32[i10 >> 2] = i9;
 HEAPF64[i7 >> 3] = d6;
 i24 = _snprintf(i9, 100, 47681, i7) | 0;
 do if (i24 >>> 0 > 99) {
  __THREW__ = 0;
  i9 = invoke_i(22) | 0;
  i25 = __THREW__;
  __THREW__ = 0;
  if (!(i25 & 1) ? (__THREW__ = 0, HEAPF64[i8 >> 3] = d6, i25 = invoke_iiiii(10, i10 | 0, i9 | 0, 47681, i8 | 0) | 0, i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) {
   i9 = HEAP32[i10 >> 2] | 0;
   if (!i9) {
    __THREW__ = 0;
    invoke_v(5);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i27 = 0;
     i28 = 0;
     i29 = 7;
     break;
    }
    i30 = HEAP32[i10 >> 2] | 0;
   } else i30 = i9;
   i9 = i30;
   i26 = _malloc(i25) | 0;
   i31 = i26;
   if (!i26) {
    __THREW__ = 0;
    invoke_v(5);
    i32 = __THREW__;
    __THREW__ = 0;
    if (i32 & 1) {
     i27 = i9;
     i28 = i31;
     i29 = 7;
    } else {
     i33 = i31;
     i34 = i9;
     i35 = 0;
     i36 = i25;
     i29 = 10;
    }
   } else {
    i33 = i31;
    i34 = i9;
    i35 = i26;
    i36 = i25;
    i29 = 10;
   }
  } else {
   i27 = 0;
   i28 = 0;
   i29 = 7;
  }
 } else {
  i33 = 0;
  i34 = 0;
  i35 = i11;
  i36 = i24;
  i29 = 10;
 } while (0);
 if ((i29 | 0) == 10) {
  __THREW__ = 0;
  i24 = invoke_ii(131, i4 | 0) | 0;
  i11 = __THREW__;
  __THREW__ = 0;
  if (i11 & 1) {
   i27 = i34;
   i28 = i33;
   i29 = 7;
  } else {
   HEAP32[i12 >> 2] = i24;
   __THREW__ = 0;
   i11 = invoke_iii(55, i12 | 0, 26580) | 0;
   i30 = __THREW__;
   __THREW__ = 0;
   if (!(i30 & 1) ? (i30 = HEAP32[i10 >> 2] | 0, __THREW__ = 0, invoke_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 32 >> 2] | 0, i11 | 0, i30 | 0, i30 + i36 | 0, i35 | 0) | 0, i30 = __THREW__, __THREW__ = 0, !(i30 & 1)) : 0) {
    if (!i36) i37 = 0; else i37 = (HEAP8[HEAP32[i10 >> 2] >> 0] | 0) == 45;
    HEAP32[i16 >> 2] = 0;
    HEAP32[i16 + 4 >> 2] = 0;
    HEAP32[i16 + 8 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    HEAP32[i17 + 8 >> 2] = 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __THREW__ = 0;
    invoke_viiiiiiiiii(3, i3 | 0, i37 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) {
     i3 = HEAP32[i19 >> 2] | 0;
     if ((i36 | 0) > (i3 | 0)) {
      i19 = HEAP8[i18 >> 0] | 0;
      i10 = HEAP8[i17 >> 0] | 0;
      i38 = (i36 - i3 << 1 | 1) + i3 + ((i19 & 1) == 0 ? (i19 & 255) >>> 1 : HEAP32[i18 + 4 >> 2] | 0) + ((i10 & 1) == 0 ? (i10 & 255) >>> 1 : HEAP32[i17 + 4 >> 2] | 0) | 0;
     } else {
      i10 = HEAP8[i18 >> 0] | 0;
      i19 = HEAP8[i17 >> 0] | 0;
      i38 = i3 + 2 + ((i10 & 1) == 0 ? (i10 & 255) >>> 1 : HEAP32[i18 + 4 >> 2] | 0) + ((i19 & 1) == 0 ? (i19 & 255) >>> 1 : HEAP32[i17 + 4 >> 2] | 0) | 0;
     }
     if (i38 >>> 0 > 100) {
      i19 = _malloc(i38) | 0;
      i38 = i19;
      if (!i19) {
       __THREW__ = 0;
       invoke_v(5);
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) i39 = i38; else {
        i40 = i38;
        i41 = 0;
        i29 = 26;
       }
      } else {
       i40 = i38;
       i41 = i19;
       i29 = 26;
      }
     } else {
      i40 = 0;
      i41 = i20;
      i29 = 26;
     }
     if ((i29 | 0) == 26) {
      __THREW__ = 0;
      invoke_viiiiiiiiiiiiiii(1, i41 | 0, i21 | 0, i22 | 0, HEAP32[i4 + 4 >> 2] | 0, i35 | 0, i35 + i36 | 0, i11 | 0, i37 | 0, i13 | 0, HEAP8[i14 >> 0] | 0, HEAP8[i15 >> 0] | 0, i16 | 0, i17 | 0, i18 | 0, i3 | 0);
      i3 = __THREW__;
      __THREW__ = 0;
      if (!(i3 & 1) ? (HEAP32[i23 >> 2] = HEAP32[i2 >> 2], i2 = HEAP32[i21 >> 2] | 0, i21 = HEAP32[i22 >> 2] | 0, __THREW__ = 0, HEAP32[i7 >> 2] = HEAP32[i23 >> 2], i23 = invoke_iiiiiii(39, i7 | 0, i41 | 0, i2 | 0, i21 | 0, i4 | 0, i5 | 0) | 0, i5 = __THREW__, __THREW__ = 0, !(i5 & 1)) : 0) {
       if (!i40) i42 = i24; else {
        _free(i40);
        i42 = HEAP32[i12 >> 2] | 0;
       }
       __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
       __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
       __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
       __ZNSt3__114__shared_count16__release_sharedEv(i42) | 0;
       if (i33) _free(i33);
       if (i34) _free(i34);
       STACKTOP = i1;
       return i23 | 0;
      } else i39 = i40;
     }
     i40 = ___cxa_find_matching_catch() | 0;
     i23 = tempRet0;
     if (!i39) {
      i43 = i40;
      i44 = i23;
      i45 = i24;
     } else {
      _free(i39);
      i43 = i40;
      i44 = i23;
      i45 = HEAP32[i12 >> 2] | 0;
     }
    } else {
     i12 = ___cxa_find_matching_catch() | 0;
     i43 = i12;
     i44 = tempRet0;
     i45 = i24;
    }
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
    i46 = i43;
    i47 = i44;
    i48 = i45;
   } else {
    i45 = ___cxa_find_matching_catch() | 0;
    i46 = i45;
    i47 = tempRet0;
    i48 = i24;
   }
   __ZNSt3__114__shared_count16__release_sharedEv(i48) | 0;
   i49 = i46;
   i50 = i47;
   i51 = i33;
   i52 = i34;
  }
 }
 if ((i29 | 0) == 7) {
  i29 = ___cxa_find_matching_catch() | 0;
  i49 = i29;
  i50 = tempRet0;
  i51 = i28;
  i52 = i27;
 }
 if (i51) _free(i51);
 if (i52) _free(i52);
 ___resumeException(i49 | 0);
 return 0;
}

function _mbsrtowcs(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0;
 i5 = HEAP32[i2 >> 2] | 0;
 if ((i4 | 0) != 0 ? (i6 = HEAP32[i4 >> 2] | 0, (i6 | 0) != 0) : 0) if (!i1) {
  i7 = i3;
  i8 = i6;
  i9 = i5;
  i10 = 16;
 } else {
  HEAP32[i4 >> 2] = 0;
  i11 = i1;
  i12 = i3;
  i13 = i6;
  i14 = i5;
  i10 = 37;
 } else if (!i1) {
  i15 = i3;
  i16 = i5;
  i10 = 7;
 } else {
  i17 = i1;
  i18 = i3;
  i19 = i5;
  i10 = 6;
 }
 L7 : while (1) if ((i10 | 0) == 6) {
  i10 = 0;
  if (!i18) {
   i20 = i19;
   i10 = 26;
   break;
  } else {
   i21 = i17;
   i22 = i18;
   i23 = i19;
  }
  while (1) {
   i5 = HEAP8[i23 >> 0] | 0;
   do if (((i5 & 255) + -1 | 0) >>> 0 < 127 ? i22 >>> 0 > 4 & (i23 & 3 | 0) == 0 : 0) {
    i6 = i21;
    i4 = i22;
    i24 = i23;
    while (1) {
     i25 = HEAP32[i24 >> 2] | 0;
     if ((i25 + -16843009 | i25) & -2139062144) {
      i26 = i6;
      i27 = i4;
      i28 = i25;
      i29 = i24;
      i10 = 32;
      break;
     }
     HEAP32[i6 >> 2] = i25 & 255;
     HEAP32[i6 + 4 >> 2] = HEAPU8[i24 + 1 >> 0];
     HEAP32[i6 + 8 >> 2] = HEAPU8[i24 + 2 >> 0];
     i25 = i24 + 4 | 0;
     i30 = i6 + 16 | 0;
     HEAP32[i6 + 12 >> 2] = HEAPU8[i24 + 3 >> 0];
     i31 = i4 + -4 | 0;
     if (i31 >>> 0 > 4) {
      i6 = i30;
      i4 = i31;
      i24 = i25;
     } else {
      i32 = i25;
      i33 = i30;
      i34 = i31;
      i10 = 31;
      break;
     }
    }
    if ((i10 | 0) == 31) {
     i10 = 0;
     i35 = i33;
     i36 = i34;
     i37 = HEAP8[i32 >> 0] | 0;
     i38 = i32;
     break;
    } else if ((i10 | 0) == 32) {
     i10 = 0;
     i35 = i26;
     i36 = i27;
     i37 = i28 & 255;
     i38 = i29;
     break;
    }
   } else {
    i35 = i21;
    i36 = i22;
    i37 = i5;
    i38 = i23;
   } while (0);
   i5 = i37 & 255;
   if ((i5 + -1 | 0) >>> 0 >= 127) {
    i39 = i35;
    i40 = i36;
    i41 = i5;
    i42 = i38;
    break;
   }
   i24 = i38 + 1 | 0;
   HEAP32[i35 >> 2] = i5;
   i22 = i36 + -1 | 0;
   if (!i22) {
    i20 = i24;
    i10 = 26;
    break L7;
   } else {
    i21 = i35 + 4 | 0;
    i23 = i24;
   }
  }
  i24 = i41 + -194 | 0;
  if (i24 >>> 0 > 50) {
   i43 = i39;
   i44 = i40;
   i45 = i42;
   i10 = 48;
   break;
  }
  i11 = i39;
  i12 = i40;
  i13 = HEAP32[19456 + (i24 << 2) >> 2] | 0;
  i14 = i42 + 1 | 0;
  i10 = 37;
  continue;
 } else if ((i10 | 0) == 7) {
  i10 = 0;
  i24 = HEAP8[i16 >> 0] | 0;
  if (((i24 & 255) + -1 | 0) >>> 0 < 127 ? (i16 & 3 | 0) == 0 : 0) {
   i5 = HEAP32[i16 >> 2] | 0;
   if (!((i5 + -16843009 | i5) & -2139062144)) {
    i4 = i15;
    i6 = i16;
    while (1) {
     i31 = i6 + 4 | 0;
     i30 = i4 + -4 | 0;
     i25 = HEAP32[i31 >> 2] | 0;
     if (!((i25 + -16843009 | i25) & -2139062144)) {
      i4 = i30;
      i6 = i31;
     } else {
      i46 = i30;
      i47 = i25;
      i48 = i31;
      break;
     }
    }
   } else {
    i46 = i15;
    i47 = i5;
    i48 = i16;
   }
   i49 = i46;
   i50 = i47 & 255;
   i51 = i48;
  } else {
   i49 = i15;
   i50 = i24;
   i51 = i16;
  }
  i6 = i50 & 255;
  if ((i6 + -1 | 0) >>> 0 < 127) {
   i15 = i49 + -1 | 0;
   i16 = i51 + 1 | 0;
   i10 = 7;
   continue;
  } else {
   i52 = i49;
   i53 = i6;
   i54 = i51;
  }
  i6 = i53 + -194 | 0;
  if (i6 >>> 0 > 50) {
   i43 = i1;
   i44 = i52;
   i45 = i54;
   i10 = 48;
   break;
  }
  i7 = i52;
  i8 = HEAP32[19456 + (i6 << 2) >> 2] | 0;
  i9 = i54 + 1 | 0;
  i10 = 16;
  continue;
 } else if ((i10 | 0) == 16) {
  i10 = 0;
  i6 = (HEAPU8[i9 >> 0] | 0) >>> 3;
  if ((i6 + -16 | i6 + (i8 >> 26)) >>> 0 > 7) {
   i10 = 17;
   break;
  }
  i6 = i9 + 1 | 0;
  if (i8 & 33554432) {
   if ((HEAP8[i6 >> 0] & -64) << 24 >> 24 != -128) {
    i10 = 20;
    break;
   }
   i4 = i9 + 2 | 0;
   if (!(i8 & 524288)) i55 = i4; else {
    if ((HEAP8[i4 >> 0] & -64) << 24 >> 24 != -128) {
     i10 = 23;
     break;
    }
    i55 = i9 + 3 | 0;
   }
  } else i55 = i6;
  i15 = i7 + -1 | 0;
  i16 = i55;
  i10 = 7;
  continue;
 } else if ((i10 | 0) == 37) {
  i10 = 0;
  i6 = HEAPU8[i14 >> 0] | 0;
  i4 = i6 >>> 3;
  if ((i4 + -16 | i4 + (i13 >> 26)) >>> 0 > 7) {
   i10 = 38;
   break;
  }
  i4 = i14 + 1 | 0;
  i31 = i6 + -128 | i13 << 6;
  if ((i31 | 0) < 0) {
   i6 = HEAPU8[i4 >> 0] | 0;
   if ((i6 & 192 | 0) != 128) {
    i10 = 41;
    break;
   }
   i25 = i14 + 2 | 0;
   i30 = i6 + -128 | i31 << 6;
   if ((i30 | 0) < 0) {
    i6 = HEAPU8[i25 >> 0] | 0;
    if ((i6 & 192 | 0) != 128) {
     i10 = 44;
     break;
    }
    i56 = i6 + -128 | i30 << 6;
    i57 = i14 + 3 | 0;
   } else {
    i56 = i30;
    i57 = i25;
   }
  } else {
   i56 = i31;
   i57 = i4;
  }
  HEAP32[i11 >> 2] = i56;
  i17 = i11 + 4 | 0;
  i18 = i12 + -1 | 0;
  i19 = i57;
  i10 = 6;
  continue;
 }
 if ((i10 | 0) == 17) {
  i58 = i1;
  i59 = i7;
  i60 = i8;
  i61 = i9 + -1 | 0;
  i10 = 47;
 } else if ((i10 | 0) == 20) {
  i58 = i1;
  i59 = i7;
  i60 = i8;
  i61 = i9 + -1 | 0;
  i10 = 47;
 } else if ((i10 | 0) == 23) {
  i58 = i1;
  i59 = i7;
  i60 = i8;
  i61 = i9 + -1 | 0;
  i10 = 47;
 } else if ((i10 | 0) == 26) {
  HEAP32[i2 >> 2] = i20;
  i62 = i3;
 } else if ((i10 | 0) == 38) {
  i58 = i11;
  i59 = i12;
  i60 = i13;
  i61 = i14 + -1 | 0;
  i10 = 47;
 } else if ((i10 | 0) == 41) {
  i63 = i11;
  i64 = i14 + -1 | 0;
  i10 = 52;
 } else if ((i10 | 0) == 44) {
  i63 = i11;
  i64 = i14 + -1 | 0;
  i10 = 52;
 }
 if ((i10 | 0) == 47) if (!i60) {
  i43 = i58;
  i44 = i59;
  i45 = i61;
  i10 = 48;
 } else {
  i63 = i58;
  i64 = i61;
  i10 = 52;
 }
 if ((i10 | 0) == 48) if (!(HEAP8[i45 >> 0] | 0)) {
  if (i43) {
   HEAP32[i43 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
  }
  i62 = i3 - i44 | 0;
 } else {
  i63 = i43;
  i64 = i45;
  i10 = 52;
 }
 if ((i10 | 0) == 52) {
  i10 = ___errno_location() | 0;
  HEAP32[i10 >> 2] = 84;
  if (!i63) i62 = -1; else {
   HEAP32[i2 >> 2] = i64;
   i62 = -1;
  }
 }
 return i62 | 0;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i9;
 L1 : do if ((i3 | 0) == (i4 | 0)) i11 = i4; else {
  i12 = i3;
  while (1) {
   if (!(HEAP8[i12 >> 0] | 0)) {
    i11 = i12;
    break L1;
   }
   i12 = i12 + 1 | 0;
   if ((i12 | 0) == (i4 | 0)) {
    i11 = i4;
    break;
   }
  }
 } while (0);
 HEAP32[i8 >> 2] = i6;
 HEAP32[i5 >> 2] = i3;
 i12 = i7;
 i13 = i1 + 8 | 0;
 L6 : do if (!((i6 | 0) == (i7 | 0) | (i3 | 0) == (i4 | 0))) {
  i1 = i3;
  i14 = i6;
  i15 = i11;
  L7 : while (1) {
   i16 = i2;
   i17 = HEAP32[i16 + 4 >> 2] | 0;
   i18 = i10;
   HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i18 + 4 >> 2] = i17;
   i17 = i15;
   i18 = _uselocale(HEAP32[i13 >> 2] | 0) | 0;
   __THREW__ = 0;
   i16 = invoke_iiiiii(22, i14 | 0, i5 | 0, i17 - i1 | 0, i12 - i14 >> 2 | 0, i2 | 0) | 0;
   i19 = __THREW__;
   __THREW__ = 0;
   if (i19 & 1) {
    i20 = i18;
    i21 = 9;
    break;
   }
   if ((i18 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i18 | 0) | 0, i18 = __THREW__, __THREW__ = 0, i18 & 1) : 0) {
    i21 = 8;
    break;
   }
   switch (i16 | 0) {
   case 0:
    {
     i22 = 2;
     break L6;
     break;
    }
   case -1:
    {
     i23 = i1;
     i24 = i14;
     i25 = i17;
     i21 = 14;
     break L7;
     break;
    }
   default:
    {}
   }
   i17 = (HEAP32[i8 >> 2] | 0) + (i16 << 2) | 0;
   HEAP32[i8 >> 2] = i17;
   if ((i17 | 0) == (i7 | 0)) {
    i21 = 31;
    break;
   }
   i16 = HEAP32[i5 >> 2] | 0;
   if ((i15 | 0) == (i4 | 0)) {
    i26 = i16;
    i27 = i17;
    i28 = i4;
   } else {
    i18 = _uselocale(HEAP32[i13 >> 2] | 0) | 0;
    __THREW__ = 0;
    i19 = invoke_iiiii(13, i17 | 0, i16 | 0, 1, i2 | 0) | 0;
    i16 = __THREW__;
    __THREW__ = 0;
    if (i16 & 1) {
     i29 = i18;
     i21 = 38;
     break;
    }
    if ((i18 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i18 | 0) | 0, i18 = __THREW__, __THREW__ = 0, i18 & 1) : 0) {
     i21 = 37;
     break;
    }
    if (i19) {
     i22 = 2;
     break L6;
    }
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 4;
    i19 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
    HEAP32[i5 >> 2] = i19;
    L22 : do if ((i19 | 0) == (i4 | 0)) i30 = i4; else {
     i18 = i19;
     while (1) {
      if (!(HEAP8[i18 >> 0] | 0)) {
       i30 = i18;
       break L22;
      }
      i18 = i18 + 1 | 0;
      if ((i18 | 0) == (i4 | 0)) {
       i30 = i4;
       break;
      }
     }
    } while (0);
    i26 = i19;
    i27 = HEAP32[i8 >> 2] | 0;
    i28 = i30;
   }
   if ((i27 | 0) == (i7 | 0) | (i26 | 0) == (i4 | 0)) {
    i31 = i26;
    i21 = 47;
    break L6;
   } else {
    i1 = i26;
    i14 = i27;
    i15 = i28;
   }
  }
  if ((i21 | 0) == 8) {
   i15 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i15);
  } else if ((i21 | 0) == 9) {
   i15 = ___cxa_find_matching_catch() | 0;
   if ((i20 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i20 | 0) | 0, i14 = __THREW__, __THREW__ = 0, i14 & 1) : 0) {
    i14 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i14);
   }
   ___resumeException(i15 | 0);
  } else if ((i21 | 0) == 14) {
   HEAP32[i8 >> 2] = i24;
   L36 : do if ((i23 | 0) != (HEAP32[i5 >> 2] | 0)) {
    i15 = i23;
    i14 = i24;
    L37 : while (1) {
     i1 = _uselocale(HEAP32[i13 >> 2] | 0) | 0;
     __THREW__ = 0;
     i18 = invoke_iiiii(13, i14 | 0, i15 | 0, i25 - i15 | 0, i10 | 0) | 0;
     i16 = __THREW__;
     __THREW__ = 0;
     if (i16 & 1) {
      i32 = i1;
      i21 = 19;
      break;
     }
     if ((i1 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i1 | 0) | 0, i1 = __THREW__, __THREW__ = 0, i1 & 1) : 0) {
      i21 = 18;
      break;
     }
     switch (i18 | 0) {
     case -1:
      {
       i33 = i15;
       i21 = 25;
       break L37;
       break;
      }
     case -2:
      {
       i34 = i15;
       i21 = 26;
       break L37;
       break;
      }
     case 0:
      {
       i35 = i15 + 1 | 0;
       break;
      }
     default:
      i35 = i15 + i18 | 0;
     }
     i14 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
     HEAP32[i8 >> 2] = i14;
     if ((i35 | 0) == (HEAP32[i5 >> 2] | 0)) {
      i36 = i35;
      break L36;
     } else i15 = i35;
    }
    if ((i21 | 0) == 18) {
     i15 = ___cxa_find_matching_catch(0) | 0;
     ___clang_call_terminate(i15);
    } else if ((i21 | 0) == 19) {
     i15 = ___cxa_find_matching_catch() | 0;
     if ((i32 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i32 | 0) | 0, i14 = __THREW__, __THREW__ = 0, i14 & 1) : 0) {
      i14 = ___cxa_find_matching_catch(0) | 0;
      ___clang_call_terminate(i14);
     }
     ___resumeException(i15 | 0);
    } else if ((i21 | 0) == 25) {
     HEAP32[i5 >> 2] = i33;
     i22 = 2;
     break L6;
    } else if ((i21 | 0) == 26) {
     HEAP32[i5 >> 2] = i34;
     i22 = 1;
     break L6;
    }
   } else i36 = i23; while (0);
   HEAP32[i5 >> 2] = i36;
   i22 = (i36 | 0) != (i4 | 0) & 1;
   break;
  } else if ((i21 | 0) == 31) {
   i31 = HEAP32[i5 >> 2] | 0;
   i21 = 47;
   break;
  } else if ((i21 | 0) == 37) {
   i15 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i15);
  } else if ((i21 | 0) == 38) {
   i15 = ___cxa_find_matching_catch() | 0;
   if ((i29 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i29 | 0) | 0, i14 = __THREW__, __THREW__ = 0, i14 & 1) : 0) {
    i14 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i14);
   }
   ___resumeException(i15 | 0);
  }
 } else {
  i31 = i3;
  i21 = 47;
 } while (0);
 if ((i21 | 0) == 47) i22 = (i31 | 0) != (i4 | 0) & 1;
 STACKTOP = i9;
 return i22 | 0;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i9;
 i11 = i9 + 8 | 0;
 L1 : do if ((i3 | 0) == (i4 | 0)) i12 = i4; else {
  i13 = i3;
  while (1) {
   if (!(HEAP32[i13 >> 2] | 0)) {
    i12 = i13;
    break L1;
   }
   i13 = i13 + 4 | 0;
   if ((i13 | 0) == (i4 | 0)) {
    i12 = i4;
    break;
   }
  }
 } while (0);
 HEAP32[i8 >> 2] = i6;
 HEAP32[i5 >> 2] = i3;
 i13 = i7;
 i14 = i1 + 8 | 0;
 L6 : do if (!((i6 | 0) == (i7 | 0) | (i3 | 0) == (i4 | 0))) {
  i1 = i3;
  i15 = i6;
  i16 = i12;
  L7 : while (1) {
   i17 = i2;
   i18 = HEAP32[i17 + 4 >> 2] | 0;
   i19 = i10;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = i18;
   i18 = _uselocale(HEAP32[i14 >> 2] | 0) | 0;
   __THREW__ = 0;
   i19 = invoke_iiiiii(21, i15 | 0, i5 | 0, i16 - i1 >> 2 | 0, i13 - i15 | 0, i2 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i20 = i18;
    i21 = 9;
    break;
   }
   if ((i18 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i18 | 0) | 0, i18 = __THREW__, __THREW__ = 0, i18 & 1) : 0) {
    i21 = 8;
    break;
   }
   switch (i19 | 0) {
   case 0:
    {
     i22 = 1;
     break L6;
     break;
    }
   case -1:
    {
     i23 = i1;
     i24 = i15;
     i21 = 14;
     break L7;
     break;
    }
   default:
    {}
   }
   i18 = (HEAP32[i8 >> 2] | 0) + i19 | 0;
   HEAP32[i8 >> 2] = i18;
   if ((i18 | 0) == (i7 | 0)) {
    i21 = 27;
    break;
   }
   if ((i16 | 0) == (i4 | 0)) {
    i25 = HEAP32[i5 >> 2] | 0;
    i26 = i18;
    i27 = i4;
   } else {
    i18 = _uselocale(HEAP32[i14 >> 2] | 0) | 0;
    __THREW__ = 0;
    i19 = invoke_iiii(40, i11 | 0, 0, i2 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i28 = i18;
     i21 = 35;
     break;
    }
    if ((i18 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i18 | 0) | 0, i18 = __THREW__, __THREW__ = 0, i18 & 1) : 0) {
     i21 = 34;
     break;
    }
    if ((i19 | 0) == -1) {
     i22 = 2;
     break L6;
    }
    if (i19 >>> 0 > (i13 - (HEAP32[i8 >> 2] | 0) | 0) >>> 0) {
     i22 = 1;
     break L6;
    }
    if (i19) {
     i18 = i19;
     i19 = i11;
     while (1) {
      i17 = HEAP8[i19 >> 0] | 0;
      i29 = HEAP32[i8 >> 2] | 0;
      HEAP32[i8 >> 2] = i29 + 1;
      HEAP8[i29 >> 0] = i17;
      i18 = i18 + -1 | 0;
      if (!i18) break; else i19 = i19 + 1 | 0;
     }
    }
    i19 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
    HEAP32[i5 >> 2] = i19;
    L28 : do if ((i19 | 0) == (i4 | 0)) i30 = i4; else {
     i18 = i19;
     while (1) {
      if (!(HEAP32[i18 >> 2] | 0)) {
       i30 = i18;
       break L28;
      }
      i18 = i18 + 4 | 0;
      if ((i18 | 0) == (i4 | 0)) {
       i30 = i4;
       break;
      }
     }
    } while (0);
    i25 = i19;
    i26 = HEAP32[i8 >> 2] | 0;
    i27 = i30;
   }
   if ((i26 | 0) == (i7 | 0) | (i25 | 0) == (i4 | 0)) {
    i31 = i25;
    i21 = 47;
    break L6;
   } else {
    i1 = i25;
    i15 = i26;
    i16 = i27;
   }
  }
  if ((i21 | 0) == 8) {
   i16 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i16);
  } else if ((i21 | 0) == 9) {
   i16 = ___cxa_find_matching_catch() | 0;
   if ((i20 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i20 | 0) | 0, i15 = __THREW__, __THREW__ = 0, i15 & 1) : 0) {
    i15 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i15);
   }
   ___resumeException(i16 | 0);
  } else if ((i21 | 0) == 14) {
   HEAP32[i8 >> 2] = i24;
   L42 : do if ((i23 | 0) == (HEAP32[i5 >> 2] | 0)) i32 = i23; else {
    i16 = i23;
    i15 = i24;
    while (1) {
     i1 = HEAP32[i16 >> 2] | 0;
     i18 = _uselocale(HEAP32[i14 >> 2] | 0) | 0;
     __THREW__ = 0;
     i17 = invoke_iiii(40, i15 | 0, i1 | 0, i10 | 0) | 0;
     i1 = __THREW__;
     __THREW__ = 0;
     if (i1 & 1) {
      i33 = i18;
      break;
     }
     if ((i18 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i18 | 0) | 0, i18 = __THREW__, __THREW__ = 0, i18 & 1) : 0) {
      i21 = 18;
      break;
     }
     if ((i17 | 0) == -1) {
      i32 = i16;
      break L42;
     }
     i15 = (HEAP32[i8 >> 2] | 0) + i17 | 0;
     HEAP32[i8 >> 2] = i15;
     i17 = i16 + 4 | 0;
     if ((i17 | 0) == (HEAP32[i5 >> 2] | 0)) {
      i32 = i17;
      break L42;
     } else i16 = i17;
    }
    if ((i21 | 0) == 18) {
     i16 = ___cxa_find_matching_catch(0) | 0;
     ___clang_call_terminate(i16);
    }
    i16 = ___cxa_find_matching_catch() | 0;
    if ((i33 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i33 | 0) | 0, i15 = __THREW__, __THREW__ = 0, i15 & 1) : 0) {
     i15 = ___cxa_find_matching_catch(0) | 0;
     ___clang_call_terminate(i15);
    }
    ___resumeException(i16 | 0);
   } while (0);
   HEAP32[i5 >> 2] = i32;
   i22 = 2;
   break;
  } else if ((i21 | 0) == 27) {
   i31 = HEAP32[i5 >> 2] | 0;
   i21 = 47;
   break;
  } else if ((i21 | 0) == 34) {
   i16 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i16);
  } else if ((i21 | 0) == 35) {
   i16 = ___cxa_find_matching_catch() | 0;
   if ((i28 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i28 | 0) | 0, i15 = __THREW__, __THREW__ = 0, i15 & 1) : 0) {
    i15 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i15);
   }
   ___resumeException(i16 | 0);
  }
 } else {
  i31 = i3;
  i21 = 47;
 } while (0);
 if ((i21 | 0) == 47) i22 = (i31 | 0) != (i4 | 0) & 1;
 STACKTOP = i9;
 return i22 | 0;
}

function _try_realloc_chunk(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & -8;
 i6 = i1 + i5 | 0;
 i7 = HEAP32[5817] | 0;
 i8 = i4 & 3;
 if (!((i8 | 0) != 1 & i1 >>> 0 >= i7 >>> 0 & i1 >>> 0 < i6 >>> 0)) _abort();
 i9 = i1 + (i5 | 4) | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if (!(i10 & 1)) _abort();
 if (!i8) {
  if (i2 >>> 0 < 256) {
   i11 = 0;
   return i11 | 0;
  }
  if (i5 >>> 0 >= (i2 + 4 | 0) >>> 0 ? (i5 - i2 | 0) >>> 0 <= HEAP32[5933] << 1 >>> 0 : 0) {
   i11 = i1;
   return i11 | 0;
  }
  i11 = 0;
  return i11 | 0;
 }
 if (i5 >>> 0 >= i2 >>> 0) {
  i8 = i5 - i2 | 0;
  if (i8 >>> 0 <= 15) {
   i11 = i1;
   return i11 | 0;
  }
  HEAP32[i3 >> 2] = i4 & 1 | i2 | 2;
  HEAP32[i1 + (i2 + 4) >> 2] = i8 | 3;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
  _dispose_chunk(i1 + i2 | 0, i8);
  i11 = i1;
  return i11 | 0;
 }
 if ((i6 | 0) == (HEAP32[5819] | 0)) {
  i8 = (HEAP32[5816] | 0) + i5 | 0;
  if (i8 >>> 0 <= i2 >>> 0) {
   i11 = 0;
   return i11 | 0;
  }
  i9 = i8 - i2 | 0;
  HEAP32[i3 >> 2] = i4 & 1 | i2 | 2;
  HEAP32[i1 + (i2 + 4) >> 2] = i9 | 1;
  HEAP32[5819] = i1 + i2;
  HEAP32[5816] = i9;
  i11 = i1;
  return i11 | 0;
 }
 if ((i6 | 0) == (HEAP32[5818] | 0)) {
  i9 = (HEAP32[5815] | 0) + i5 | 0;
  if (i9 >>> 0 < i2 >>> 0) {
   i11 = 0;
   return i11 | 0;
  }
  i8 = i9 - i2 | 0;
  if (i8 >>> 0 > 15) {
   HEAP32[i3 >> 2] = i4 & 1 | i2 | 2;
   HEAP32[i1 + (i2 + 4) >> 2] = i8 | 1;
   HEAP32[i1 + i9 >> 2] = i8;
   i12 = i1 + (i9 + 4) | 0;
   HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -2;
   i13 = i1 + i2 | 0;
   i14 = i8;
  } else {
   HEAP32[i3 >> 2] = i4 & 1 | i9 | 2;
   i8 = i1 + (i9 + 4) | 0;
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1;
   i13 = 0;
   i14 = 0;
  }
  HEAP32[5815] = i14;
  HEAP32[5818] = i13;
  i11 = i1;
  return i11 | 0;
 }
 if (i10 & 2) {
  i11 = 0;
  return i11 | 0;
 }
 i13 = (i10 & -8) + i5 | 0;
 if (i13 >>> 0 < i2 >>> 0) {
  i11 = 0;
  return i11 | 0;
 }
 i14 = i13 - i2 | 0;
 i8 = i10 >>> 3;
 do if (i10 >>> 0 >= 256) {
  i9 = HEAP32[i1 + (i5 + 24) >> 2] | 0;
  i12 = HEAP32[i1 + (i5 + 12) >> 2] | 0;
  do if ((i12 | 0) == (i6 | 0)) {
   i15 = i1 + (i5 + 20) | 0;
   i16 = HEAP32[i15 >> 2] | 0;
   if (!i16) {
    i17 = i1 + (i5 + 16) | 0;
    i18 = HEAP32[i17 >> 2] | 0;
    if (!i18) {
     i19 = 0;
     break;
    } else {
     i20 = i18;
     i21 = i17;
    }
   } else {
    i20 = i16;
    i21 = i15;
   }
   while (1) {
    i15 = i20 + 20 | 0;
    i16 = HEAP32[i15 >> 2] | 0;
    if (i16) {
     i20 = i16;
     i21 = i15;
     continue;
    }
    i15 = i20 + 16 | 0;
    i16 = HEAP32[i15 >> 2] | 0;
    if (!i16) {
     i22 = i20;
     i23 = i21;
     break;
    } else {
     i20 = i16;
     i21 = i15;
    }
   }
   if (i23 >>> 0 < i7 >>> 0) _abort(); else {
    HEAP32[i23 >> 2] = 0;
    i19 = i22;
    break;
   }
  } else {
   i15 = HEAP32[i1 + (i5 + 8) >> 2] | 0;
   if (i15 >>> 0 < i7 >>> 0) _abort();
   i16 = i15 + 12 | 0;
   if ((HEAP32[i16 >> 2] | 0) != (i6 | 0)) _abort();
   i17 = i12 + 8 | 0;
   if ((HEAP32[i17 >> 2] | 0) == (i6 | 0)) {
    HEAP32[i16 >> 2] = i12;
    HEAP32[i17 >> 2] = i15;
    i19 = i12;
    break;
   } else _abort();
  } while (0);
  if (i9) {
   i12 = HEAP32[i1 + (i5 + 28) >> 2] | 0;
   i15 = 23556 + (i12 << 2) | 0;
   if ((i6 | 0) == (HEAP32[i15 >> 2] | 0)) {
    HEAP32[i15 >> 2] = i19;
    if (!i19) {
     HEAP32[5814] = HEAP32[5814] & ~(1 << i12);
     break;
    }
   } else {
    if (i9 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort();
    i12 = i9 + 16 | 0;
    if ((HEAP32[i12 >> 2] | 0) == (i6 | 0)) HEAP32[i12 >> 2] = i19; else HEAP32[i9 + 20 >> 2] = i19;
    if (!i19) break;
   }
   i12 = HEAP32[5817] | 0;
   if (i19 >>> 0 < i12 >>> 0) _abort();
   HEAP32[i19 + 24 >> 2] = i9;
   i15 = HEAP32[i1 + (i5 + 16) >> 2] | 0;
   do if (i15) if (i15 >>> 0 < i12 >>> 0) _abort(); else {
    HEAP32[i19 + 16 >> 2] = i15;
    HEAP32[i15 + 24 >> 2] = i19;
    break;
   } while (0);
   i15 = HEAP32[i1 + (i5 + 20) >> 2] | 0;
   if (i15) if (i15 >>> 0 < (HEAP32[5817] | 0) >>> 0) _abort(); else {
    HEAP32[i19 + 20 >> 2] = i15;
    HEAP32[i15 + 24 >> 2] = i19;
    break;
   }
  }
 } else {
  i15 = HEAP32[i1 + (i5 + 8) >> 2] | 0;
  i12 = HEAP32[i1 + (i5 + 12) >> 2] | 0;
  i9 = 23292 + (i8 << 1 << 2) | 0;
  if ((i15 | 0) != (i9 | 0)) {
   if (i15 >>> 0 < i7 >>> 0) _abort();
   if ((HEAP32[i15 + 12 >> 2] | 0) != (i6 | 0)) _abort();
  }
  if ((i12 | 0) == (i15 | 0)) {
   HEAP32[5813] = HEAP32[5813] & ~(1 << i8);
   break;
  }
  if ((i12 | 0) != (i9 | 0)) {
   if (i12 >>> 0 < i7 >>> 0) _abort();
   i9 = i12 + 8 | 0;
   if ((HEAP32[i9 >> 2] | 0) == (i6 | 0)) i24 = i9; else _abort();
  } else i24 = i12 + 8 | 0;
  HEAP32[i15 + 12 >> 2] = i12;
  HEAP32[i24 >> 2] = i15;
 } while (0);
 if (i14 >>> 0 < 16) {
  HEAP32[i3 >> 2] = i13 | i4 & 1 | 2;
  i24 = i1 + (i13 | 4) | 0;
  HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | 1;
  i11 = i1;
  return i11 | 0;
 } else {
  HEAP32[i3 >> 2] = i4 & 1 | i2 | 2;
  HEAP32[i1 + (i2 + 4) >> 2] = i14 | 3;
  i4 = i1 + (i13 | 4) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1;
  _dispose_chunk(i1 + i2 | 0, i14);
  i11 = i1;
  return i11 | 0;
 }
 return 0;
}

function __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 do if (i6) {
  i7 = HEAP32[i6 + 12 >> 2] | 0;
  if ((i7 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) i8 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] & 255](i6) | 0; else i8 = HEAP32[i7 >> 2] | 0;
  if ((i8 | 0) == -1) {
   HEAP32[i1 >> 2] = 0;
   i9 = 1;
   break;
  } else {
   i9 = (HEAP32[i1 >> 2] | 0) == 0;
   break;
  }
 } else i9 = 1; while (0);
 i8 = HEAP32[i2 >> 2] | 0;
 do if (i8) {
  i6 = HEAP32[i8 + 12 >> 2] | 0;
  if ((i6 | 0) == (HEAP32[i8 + 16 >> 2] | 0)) i10 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] & 255](i8) | 0; else i10 = HEAP32[i6 >> 2] | 0;
  if ((i10 | 0) != -1) if (i9) {
   i11 = i8;
   i12 = 17;
   break;
  } else {
   i12 = 16;
   break;
  } else {
   HEAP32[i2 >> 2] = 0;
   i12 = 14;
   break;
  }
 } else i12 = 14; while (0);
 if ((i12 | 0) == 14) if (i9) i12 = 16; else {
  i11 = 0;
  i12 = 17;
 }
 L22 : do if ((i12 | 0) == 16) {
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 6;
  i13 = 0;
 } else if ((i12 | 0) == 17) {
  i9 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i9 + 12 >> 2] | 0;
  if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i14 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 255](i9) | 0; else i14 = HEAP32[i8 >> 2] | 0;
  if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 63](i4, 2048, i14) | 0)) {
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 4;
   i13 = 0;
   break;
  }
  i8 = (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] & 63](i4, i14, 0) | 0) << 24 >> 24;
  i9 = HEAP32[i1 >> 2] | 0;
  i10 = i9 + 12 | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  if ((i6 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 255](i9) | 0;
   i15 = i5;
   i16 = i11;
   i17 = i11;
   i18 = i8;
  } else {
   HEAP32[i10 >> 2] = i6 + 4;
   i15 = i5;
   i16 = i11;
   i17 = i11;
   i18 = i8;
  }
  while (1) {
   i8 = i18 + -48 | 0;
   i6 = i15 + -1 | 0;
   i10 = HEAP32[i1 >> 2] | 0;
   do if (i10) {
    i9 = HEAP32[i10 + 12 >> 2] | 0;
    if ((i9 | 0) == (HEAP32[i10 + 16 >> 2] | 0)) i19 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] & 255](i10) | 0; else i19 = HEAP32[i9 >> 2] | 0;
    if ((i19 | 0) == -1) {
     HEAP32[i1 >> 2] = 0;
     i20 = 1;
     break;
    } else {
     i20 = (HEAP32[i1 >> 2] | 0) == 0;
     break;
    }
   } else i20 = 1; while (0);
   do if (i17) {
    i10 = HEAP32[i17 + 12 >> 2] | 0;
    if ((i10 | 0) == (HEAP32[i17 + 16 >> 2] | 0)) i21 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 36 >> 2] & 255](i17) | 0; else i21 = HEAP32[i10 >> 2] | 0;
    if ((i21 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i22 = 0;
     i23 = 0;
     i24 = 1;
     break;
    } else {
     i22 = i16;
     i23 = i16;
     i24 = (i16 | 0) == 0;
     break;
    }
   } else {
    i22 = i16;
    i23 = 0;
    i24 = 1;
   } while (0);
   i10 = HEAP32[i1 >> 2] | 0;
   if (!((i15 | 0) > 1 & (i20 ^ i24))) {
    i25 = i10;
    i26 = i22;
    i27 = i8;
    break;
   }
   i9 = HEAP32[i10 + 12 >> 2] | 0;
   if ((i9 | 0) == (HEAP32[i10 + 16 >> 2] | 0)) i28 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] & 255](i10) | 0; else i28 = HEAP32[i9 >> 2] | 0;
   if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 63](i4, 2048, i28) | 0)) {
    i13 = i8;
    break L22;
   }
   i9 = ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] & 63](i4, i28, 0) | 0) << 24 >> 24) + (i8 * 10 | 0) | 0;
   i10 = HEAP32[i1 >> 2] | 0;
   i7 = i10 + 12 | 0;
   i29 = HEAP32[i7 >> 2] | 0;
   if ((i29 | 0) == (HEAP32[i10 + 16 >> 2] | 0)) {
    FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] & 255](i10) | 0;
    i15 = i6;
    i16 = i22;
    i17 = i23;
    i18 = i9;
    continue;
   } else {
    HEAP32[i7 >> 2] = i29 + 4;
    i15 = i6;
    i16 = i22;
    i17 = i23;
    i18 = i9;
    continue;
   }
  }
  do if (i25) {
   i9 = HEAP32[i25 + 12 >> 2] | 0;
   if ((i9 | 0) == (HEAP32[i25 + 16 >> 2] | 0)) i30 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] & 255](i25) | 0; else i30 = HEAP32[i9 >> 2] | 0;
   if ((i30 | 0) == -1) {
    HEAP32[i1 >> 2] = 0;
    i31 = 1;
    break;
   } else {
    i31 = (HEAP32[i1 >> 2] | 0) == 0;
    break;
   }
  } else i31 = 1; while (0);
  do if (i26) {
   i9 = HEAP32[i26 + 12 >> 2] | 0;
   if ((i9 | 0) == (HEAP32[i26 + 16 >> 2] | 0)) i32 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i26 >> 2] | 0) + 36 >> 2] & 255](i26) | 0; else i32 = HEAP32[i9 >> 2] | 0;
   if ((i32 | 0) != -1) if (i31) {
    i13 = i27;
    break L22;
   } else break; else {
    HEAP32[i2 >> 2] = 0;
    i12 = 60;
    break;
   }
  } else i12 = 60; while (0);
  if ((i12 | 0) == 60 ? !i31 : 0) {
   i13 = i27;
   break;
  }
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 2;
  i13 = i27;
 } while (0);
 return i13 | 0;
}

function __ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i7 = i1 + 56 | 0;
 i8 = i1 + 52 | 0;
 i9 = i1 + 64 | 0;
 i10 = i1 + 61 | 0;
 i11 = i1 + 60 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 28 | 0;
 i14 = i1 + 16 | 0;
 i15 = i1 + 12 | 0;
 i16 = i1 + 68 | 0;
 i17 = i1 + 8 | 0;
 i18 = i1 + 4 | 0;
 i19 = i1;
 i20 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i8 >> 2] = i20;
 __THREW__ = 0;
 i21 = invoke_iii(55, i8 | 0, 26580) | 0;
 i22 = __THREW__;
 __THREW__ = 0;
 do if (i22 & 1) i23 = 13; else {
  i24 = HEAP8[i6 >> 0] | 0;
  i25 = (i24 & 1) == 0;
  i26 = i6 + 4 | 0;
  if (!((i25 ? (i24 & 255) >>> 1 : HEAP32[i26 >> 2] | 0) | 0)) i27 = 0; else {
   i24 = HEAP8[(i25 ? i6 + 1 | 0 : HEAP32[i6 + 8 >> 2] | 0) >> 0] | 0;
   __THREW__ = 0;
   i25 = invoke_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 28 >> 2] | 0, i21 | 0, 45) | 0;
   i28 = __THREW__;
   __THREW__ = 0;
   if (i28 & 1) {
    i23 = 13;
    break;
   }
   i27 = i24 << 24 >> 24 == i25 << 24 >> 24;
  }
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viiiiiiiiii(3, i3 | 0, i27 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0);
  i25 = __THREW__;
  __THREW__ = 0;
  if (!(i25 & 1)) {
   i25 = HEAP8[i6 >> 0] | 0;
   i24 = HEAP32[i26 >> 2] | 0;
   i28 = (i25 & 1) == 0 ? (i25 & 255) >>> 1 : i24;
   i29 = HEAP32[i15 >> 2] | 0;
   if ((i28 | 0) > (i29 | 0)) {
    i30 = HEAP8[i14 >> 0] | 0;
    i31 = HEAP8[i13 >> 0] | 0;
    i32 = (i28 - i29 << 1 | 1) + i29 + ((i30 & 1) == 0 ? (i30 & 255) >>> 1 : HEAP32[i14 + 4 >> 2] | 0) + ((i31 & 1) == 0 ? (i31 & 255) >>> 1 : HEAP32[i13 + 4 >> 2] | 0) | 0;
   } else {
    i31 = HEAP8[i14 >> 0] | 0;
    i30 = HEAP8[i13 >> 0] | 0;
    i32 = i29 + 2 + ((i31 & 1) == 0 ? (i31 & 255) >>> 1 : HEAP32[i14 + 4 >> 2] | 0) + ((i30 & 1) == 0 ? (i30 & 255) >>> 1 : HEAP32[i13 + 4 >> 2] | 0) | 0;
   }
   if (i32 >>> 0 > 100) {
    i30 = _malloc(i32) | 0;
    i31 = i30;
    if (!i30) {
     __THREW__ = 0;
     invoke_v(5);
     i28 = __THREW__;
     __THREW__ = 0;
     if (i28 & 1) i33 = i31; else {
      i34 = HEAP8[i6 >> 0] | 0;
      i35 = HEAP32[i26 >> 2] | 0;
      i36 = i31;
      i37 = 0;
      i23 = 17;
     }
    } else {
     i34 = i25;
     i35 = i24;
     i36 = i31;
     i37 = i30;
     i23 = 17;
    }
   } else {
    i34 = i25;
    i35 = i24;
    i36 = 0;
    i37 = i16;
    i23 = 17;
   }
   if ((i23 | 0) == 17) {
    i24 = (i34 & 1) == 0;
    i25 = i24 ? i6 + 1 | 0 : HEAP32[i6 + 8 >> 2] | 0;
    __THREW__ = 0;
    invoke_viiiiiiiiiiiiiii(1, i37 | 0, i17 | 0, i18 | 0, HEAP32[i4 + 4 >> 2] | 0, i25 | 0, i25 + (i24 ? (i34 & 255) >>> 1 : i35) | 0, i21 | 0, i27 | 0, i9 | 0, HEAP8[i10 >> 0] | 0, HEAP8[i11 >> 0] | 0, i12 | 0, i13 | 0, i14 | 0, i29 | 0);
    i29 = __THREW__;
    __THREW__ = 0;
    if (!(i29 & 1) ? (HEAP32[i19 >> 2] = HEAP32[i2 >> 2], i29 = HEAP32[i17 >> 2] | 0, i24 = HEAP32[i18 >> 2] | 0, __THREW__ = 0, HEAP32[i7 >> 2] = HEAP32[i19 >> 2], i25 = invoke_iiiiiii(39, i7 | 0, i37 | 0, i29 | 0, i24 | 0, i4 | 0, i5 | 0) | 0, i24 = __THREW__, __THREW__ = 0, !(i24 & 1)) : 0) {
     if (!i36) i38 = i20; else {
      _free(i36);
      i38 = HEAP32[i8 >> 2] | 0;
     }
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
     __ZNSt3__114__shared_count16__release_sharedEv(i38) | 0;
     STACKTOP = i1;
     return i25 | 0;
    } else i33 = i36;
   }
   i25 = ___cxa_find_matching_catch() | 0;
   i24 = tempRet0;
   if (!i33) {
    i39 = i25;
    i40 = i24;
    i41 = i20;
   } else {
    _free(i33);
    i39 = i25;
    i40 = i24;
    i41 = HEAP32[i8 >> 2] | 0;
   }
  } else {
   i24 = ___cxa_find_matching_catch() | 0;
   i39 = i24;
   i40 = tempRet0;
   i41 = i20;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i42 = i39;
  i43 = i40;
  i44 = i41;
 } while (0);
 if ((i23 | 0) == 13) {
  i23 = ___cxa_find_matching_catch() | 0;
  i42 = i23;
  i43 = tempRet0;
  i44 = i20;
 }
 __ZNSt3__114__shared_count16__release_sharedEv(i44) | 0;
 ___resumeException(i42 | 0);
 return 0;
}

function __ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 i7 = i1 + 468 | 0;
 i8 = i1 + 464 | 0;
 i9 = i1 + 472 | 0;
 i10 = i1 + 56 | 0;
 i11 = i1 + 52 | 0;
 i12 = i1 + 40 | 0;
 i13 = i1 + 28 | 0;
 i14 = i1 + 16 | 0;
 i15 = i1 + 12 | 0;
 i16 = i1 + 64 | 0;
 i17 = i1 + 8 | 0;
 i18 = i1 + 4 | 0;
 i19 = i1;
 i20 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i8 >> 2] = i20;
 __THREW__ = 0;
 i21 = invoke_iii(55, i8 | 0, 26572) | 0;
 i22 = __THREW__;
 __THREW__ = 0;
 do if (i22 & 1) i23 = 13; else {
  i24 = HEAP8[i6 >> 0] | 0;
  i25 = (i24 & 1) == 0;
  i26 = i6 + 4 | 0;
  if (!((i25 ? (i24 & 255) >>> 1 : HEAP32[i26 >> 2] | 0) | 0)) i27 = 0; else {
   i24 = HEAP32[(i25 ? i26 : HEAP32[i6 + 8 >> 2] | 0) >> 2] | 0;
   __THREW__ = 0;
   i25 = invoke_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 44 >> 2] | 0, i21 | 0, 45) | 0;
   i28 = __THREW__;
   __THREW__ = 0;
   if (i28 & 1) {
    i23 = 13;
    break;
   }
   i27 = (i24 | 0) == (i25 | 0);
  }
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viiiiiiiiii(4, i3 | 0, i27 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0);
  i25 = __THREW__;
  __THREW__ = 0;
  if (!(i25 & 1)) {
   i25 = HEAP8[i6 >> 0] | 0;
   i24 = HEAP32[i26 >> 2] | 0;
   i28 = (i25 & 1) == 0 ? (i25 & 255) >>> 1 : i24;
   i29 = HEAP32[i15 >> 2] | 0;
   if ((i28 | 0) > (i29 | 0)) {
    i30 = HEAP8[i14 >> 0] | 0;
    i31 = HEAP8[i13 >> 0] | 0;
    i32 = (i28 - i29 << 1 | 1) + i29 + ((i30 & 1) == 0 ? (i30 & 255) >>> 1 : HEAP32[i14 + 4 >> 2] | 0) + ((i31 & 1) == 0 ? (i31 & 255) >>> 1 : HEAP32[i13 + 4 >> 2] | 0) | 0;
   } else {
    i31 = HEAP8[i14 >> 0] | 0;
    i30 = HEAP8[i13 >> 0] | 0;
    i32 = i29 + 2 + ((i31 & 1) == 0 ? (i31 & 255) >>> 1 : HEAP32[i14 + 4 >> 2] | 0) + ((i30 & 1) == 0 ? (i30 & 255) >>> 1 : HEAP32[i13 + 4 >> 2] | 0) | 0;
   }
   if (i32 >>> 0 > 100) {
    i30 = _malloc(i32 << 2) | 0;
    i31 = i30;
    if (!i30) {
     __THREW__ = 0;
     invoke_v(5);
     i28 = __THREW__;
     __THREW__ = 0;
     if (i28 & 1) i33 = i31; else {
      i34 = HEAP8[i6 >> 0] | 0;
      i35 = HEAP32[i26 >> 2] | 0;
      i36 = i31;
      i37 = 0;
      i23 = 17;
     }
    } else {
     i34 = i25;
     i35 = i24;
     i36 = i31;
     i37 = i30;
     i23 = 17;
    }
   } else {
    i34 = i25;
    i35 = i24;
    i36 = 0;
    i37 = i16;
    i23 = 17;
   }
   if ((i23 | 0) == 17) {
    i24 = (i34 & 1) == 0;
    i25 = i24 ? i26 : HEAP32[i6 + 8 >> 2] | 0;
    __THREW__ = 0;
    invoke_viiiiiiiiiiiiiii(2, i37 | 0, i17 | 0, i18 | 0, HEAP32[i4 + 4 >> 2] | 0, i25 | 0, i25 + ((i24 ? (i34 & 255) >>> 1 : i35) << 2) | 0, i21 | 0, i27 | 0, i9 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, i12 | 0, i13 | 0, i14 | 0, i29 | 0);
    i29 = __THREW__;
    __THREW__ = 0;
    if (!(i29 & 1) ? (HEAP32[i19 >> 2] = HEAP32[i2 >> 2], i29 = HEAP32[i17 >> 2] | 0, i24 = HEAP32[i18 >> 2] | 0, __THREW__ = 0, HEAP32[i7 >> 2] = HEAP32[i19 >> 2], i25 = invoke_iiiiiii(40, i7 | 0, i37 | 0, i29 | 0, i24 | 0, i4 | 0, i5 | 0) | 0, i24 = __THREW__, __THREW__ = 0, !(i24 & 1)) : 0) {
     if (!i36) i38 = i20; else {
      _free(i36);
      i38 = HEAP32[i8 >> 2] | 0;
     }
     __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i14);
     __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i13);
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
     __ZNSt3__114__shared_count16__release_sharedEv(i38) | 0;
     STACKTOP = i1;
     return i25 | 0;
    } else i33 = i36;
   }
   i25 = ___cxa_find_matching_catch() | 0;
   i24 = tempRet0;
   if (!i33) {
    i39 = i25;
    i40 = i24;
    i41 = i20;
   } else {
    _free(i33);
    i39 = i25;
    i40 = i24;
    i41 = HEAP32[i8 >> 2] | 0;
   }
  } else {
   i24 = ___cxa_find_matching_catch() | 0;
   i39 = i24;
   i40 = tempRet0;
   i41 = i20;
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i14);
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i13);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i42 = i39;
  i43 = i40;
  i44 = i41;
 } while (0);
 if ((i23 | 0) == 13) {
  i23 = ___cxa_find_matching_catch() | 0;
  i42 = i23;
  i43 = tempRet0;
  i44 = i20;
 }
 __ZNSt3__114__shared_count16__release_sharedEv(i44) | 0;
 ___resumeException(i42 | 0);
 return 0;
}

function __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8;
 i10 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 26572) | 0;
 i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 26728) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] & 127](i9, i11);
 i7 = HEAP8[i9 >> 0] | 0;
 i12 = i9 + 4 | 0;
 L1 : do if (!(((i7 & 1) == 0 ? (i7 & 255) >>> 1 : HEAP32[i12 >> 2] | 0) | 0)) {
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 48 >> 2] | 0, i10 | 0, i1 | 0, i3 | 0, i4 | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) i14 = 5; else {
   i13 = i1;
   i15 = i4 + (i3 - i13 << 2) | 0;
   HEAP32[i6 >> 2] = i15;
   i16 = i13;
   i17 = i15;
   i14 = 28;
  }
 } else {
  HEAP32[i6 >> 2] = i4;
  i15 = HEAP8[i1 >> 0] | 0;
  switch (i15 << 24 >> 24) {
  case 43:
  case 45:
   {
    __THREW__ = 0;
    i13 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, i15 | 0) | 0;
    i15 = __THREW__;
    __THREW__ = 0;
    if (i15 & 1) {
     i14 = 5;
     break L1;
    }
    i15 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i15 + 4;
    HEAP32[i15 >> 2] = i13;
    i18 = i1 + 1 | 0;
    break;
   }
  default:
   i18 = i1;
  }
  L9 : do if ((i3 - i18 | 0) > 1 ? (HEAP8[i18 >> 0] | 0) == 48 : 0) {
   i13 = i18 + 1 | 0;
   switch (HEAP8[i13 >> 0] | 0) {
   case 88:
   case 120:
    break;
   default:
    {
     i19 = i18;
     break L9;
    }
   }
   __THREW__ = 0;
   i15 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, 48) | 0;
   i20 = __THREW__;
   __THREW__ = 0;
   if (i20 & 1) {
    i14 = 5;
    break L1;
   }
   i20 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i20 + 4;
   HEAP32[i20 >> 2] = i15;
   __THREW__ = 0;
   i15 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, HEAP8[i13 >> 0] | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) {
    i14 = 5;
    break L1;
   }
   i13 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i13 + 4;
   HEAP32[i13 >> 2] = i15;
   i19 = i18 + 2 | 0;
  } else i19 = i18; while (0);
  if ((i19 | 0) != (i3 | 0) ? (i15 = i3 + -1 | 0, i19 >>> 0 < i15 >>> 0) : 0) {
   i13 = i19;
   i20 = i15;
   do {
    i15 = HEAP8[i13 >> 0] | 0;
    HEAP8[i13 >> 0] = HEAP8[i20 >> 0] | 0;
    HEAP8[i20 >> 0] = i15;
    i13 = i13 + 1 | 0;
    i20 = i20 + -1 | 0;
   } while (i13 >>> 0 < i20 >>> 0);
  }
  __THREW__ = 0;
  i20 = invoke_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   i13 = i9 + 8 | 0;
   i15 = i9 + 1 | 0;
   L22 : do if (i19 >>> 0 < i3 >>> 0) {
    i21 = 0;
    i22 = 0;
    i23 = i19;
    while (1) {
     i24 = HEAP8[((HEAP8[i9 >> 0] & 1) == 0 ? i15 : HEAP32[i13 >> 2] | 0) + i22 >> 0] | 0;
     if (i24 << 24 >> 24 != 0 & (i21 | 0) == (i24 << 24 >> 24 | 0)) {
      i24 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i24 + 4;
      HEAP32[i24 >> 2] = i20;
      i24 = HEAP8[i9 >> 0] | 0;
      i25 = 0;
      i26 = (i22 >>> 0 < (((i24 & 1) == 0 ? (i24 & 255) >>> 1 : HEAP32[i12 >> 2] | 0) + -1 | 0) >>> 0 & 1) + i22 | 0;
     } else {
      i25 = i21;
      i26 = i22;
     }
     __THREW__ = 0;
     i24 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, HEAP8[i23 >> 0] | 0) | 0;
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) break;
     i27 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i27 + 4;
     HEAP32[i27 >> 2] = i24;
     i23 = i23 + 1 | 0;
     if (i23 >>> 0 >= i3 >>> 0) break L22; else {
      i21 = i25 + 1 | 0;
      i22 = i26;
     }
    }
    i22 = ___cxa_find_matching_catch() | 0;
    i28 = i22;
    i29 = tempRet0;
    break L1;
   } while (0);
   i20 = i1;
   i13 = i4 + (i19 - i20 << 2) | 0;
   i15 = HEAP32[i6 >> 2] | 0;
   if ((i13 | 0) != (i15 | 0)) {
    i22 = i15 + -4 | 0;
    if (i13 >>> 0 < i22 >>> 0) {
     i21 = i13;
     i23 = i22;
     do {
      i22 = HEAP32[i21 >> 2] | 0;
      HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i23 >> 2] = i22;
      i21 = i21 + 4 | 0;
      i23 = i23 + -4 | 0;
     } while (i21 >>> 0 < i23 >>> 0);
     i16 = i20;
     i17 = i15;
     i14 = 28;
    } else {
     i16 = i20;
     i17 = i15;
     i14 = 28;
    }
   } else {
    i16 = i20;
    i17 = i13;
    i14 = 28;
   }
  } else i14 = 5;
 } while (0);
 if ((i14 | 0) == 5) {
  i6 = ___cxa_find_matching_catch() | 0;
  i28 = i6;
  i29 = tempRet0;
 } else if ((i14 | 0) == 28) {
  HEAP32[i5 >> 2] = (i2 | 0) == (i3 | 0) ? i17 : i4 + (i2 - i16 << 2) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i8;
  return;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i28 | 0);
}

function __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8;
 i10 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 26580) | 0;
 i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 26720) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] & 127](i9, i11);
 i7 = HEAP8[i9 >> 0] | 0;
 i12 = i9 + 4 | 0;
 L1 : do if (!(((i7 & 1) == 0 ? (i7 & 255) >>> 1 : HEAP32[i12 >> 2] | 0) | 0)) {
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i1 | 0, i3 | 0, i4 | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) i14 = 5; else {
   i13 = i1;
   i15 = i4 + (i3 - i13) | 0;
   HEAP32[i6 >> 2] = i15;
   i16 = i13;
   i17 = i15;
   i14 = 29;
  }
 } else {
  HEAP32[i6 >> 2] = i4;
  i15 = HEAP8[i1 >> 0] | 0;
  switch (i15 << 24 >> 24) {
  case 43:
  case 45:
   {
    __THREW__ = 0;
    i13 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i15 | 0) | 0;
    i15 = __THREW__;
    __THREW__ = 0;
    if (i15 & 1) {
     i14 = 5;
     break L1;
    }
    i15 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i15 + 1;
    HEAP8[i15 >> 0] = i13;
    i18 = i1 + 1 | 0;
    break;
   }
  default:
   i18 = i1;
  }
  L9 : do if ((i3 - i18 | 0) > 1 ? (HEAP8[i18 >> 0] | 0) == 48 : 0) {
   i13 = i18 + 1 | 0;
   switch (HEAP8[i13 >> 0] | 0) {
   case 88:
   case 120:
    break;
   default:
    {
     i19 = i18;
     break L9;
    }
   }
   __THREW__ = 0;
   i15 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, 48) | 0;
   i20 = __THREW__;
   __THREW__ = 0;
   if (i20 & 1) {
    i14 = 5;
    break L1;
   }
   i20 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i20 + 1;
   HEAP8[i20 >> 0] = i15;
   __THREW__ = 0;
   i15 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, HEAP8[i13 >> 0] | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) {
    i14 = 5;
    break L1;
   }
   i13 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i13 + 1;
   HEAP8[i13 >> 0] = i15;
   i19 = i18 + 2 | 0;
  } else i19 = i18; while (0);
  if ((i19 | 0) != (i3 | 0) ? (i15 = i3 + -1 | 0, i19 >>> 0 < i15 >>> 0) : 0) {
   i13 = i19;
   i20 = i15;
   do {
    i15 = HEAP8[i13 >> 0] | 0;
    HEAP8[i13 >> 0] = HEAP8[i20 >> 0] | 0;
    HEAP8[i20 >> 0] = i15;
    i13 = i13 + 1 | 0;
    i20 = i20 + -1 | 0;
   } while (i13 >>> 0 < i20 >>> 0);
  }
  __THREW__ = 0;
  i20 = invoke_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   i13 = i9 + 8 | 0;
   i15 = i9 + 1 | 0;
   L22 : do if (i19 >>> 0 < i3 >>> 0) {
    i21 = 0;
    i22 = 0;
    i23 = i19;
    while (1) {
     i24 = HEAP8[((HEAP8[i9 >> 0] & 1) == 0 ? i15 : HEAP32[i13 >> 2] | 0) + i22 >> 0] | 0;
     if (i24 << 24 >> 24 != 0 & (i21 | 0) == (i24 << 24 >> 24 | 0)) {
      i24 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i24 + 1;
      HEAP8[i24 >> 0] = i20;
      i24 = HEAP8[i9 >> 0] | 0;
      i25 = 0;
      i26 = (i22 >>> 0 < (((i24 & 1) == 0 ? (i24 & 255) >>> 1 : HEAP32[i12 >> 2] | 0) + -1 | 0) >>> 0 & 1) + i22 | 0;
     } else {
      i25 = i21;
      i26 = i22;
     }
     __THREW__ = 0;
     i24 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, HEAP8[i23 >> 0] | 0) | 0;
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) break;
     i27 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i27 + 1;
     HEAP8[i27 >> 0] = i24;
     i23 = i23 + 1 | 0;
     if (i23 >>> 0 >= i3 >>> 0) break L22; else {
      i21 = i25 + 1 | 0;
      i22 = i26;
     }
    }
    i22 = ___cxa_find_matching_catch() | 0;
    i28 = i22;
    i29 = tempRet0;
    break L1;
   } while (0);
   i20 = i1;
   i13 = i4 + (i19 - i20) | 0;
   i15 = HEAP32[i6 >> 2] | 0;
   if ((i13 | 0) == (i15 | 0)) {
    i16 = i20;
    i17 = i13;
    i14 = 29;
   } else {
    i22 = i15 + -1 | 0;
    if (i13 >>> 0 < i22 >>> 0) {
     i15 = i13;
     i13 = i22;
     do {
      i22 = HEAP8[i15 >> 0] | 0;
      HEAP8[i15 >> 0] = HEAP8[i13 >> 0] | 0;
      HEAP8[i13 >> 0] = i22;
      i15 = i15 + 1 | 0;
      i13 = i13 + -1 | 0;
     } while (i15 >>> 0 < i13 >>> 0);
    }
    i16 = i20;
    i17 = HEAP32[i6 >> 2] | 0;
    i14 = 29;
   }
  } else i14 = 5;
 } while (0);
 if ((i14 | 0) == 5) {
  i6 = ___cxa_find_matching_catch() | 0;
  i28 = i6;
  i29 = tempRet0;
 } else if ((i14 | 0) == 29) {
  HEAP32[i5 >> 2] = (i2 | 0) == (i3 | 0) ? i17 : i4 + (i2 - i16) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i8;
  return;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i28 | 0);
}

function __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 do if (i6) if ((HEAP32[i6 + 12 >> 2] | 0) == (HEAP32[i6 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] & 255](i6) | 0) == -1) {
  HEAP32[i1 >> 2] = 0;
  i7 = 0;
  break;
 } else {
  i7 = HEAP32[i1 >> 2] | 0;
  break;
 } else i7 = i6; else i7 = 0; while (0);
 i6 = (i7 | 0) == 0;
 i7 = HEAP32[i2 >> 2] | 0;
 do if (i7) {
  if ((HEAP32[i7 + 12 >> 2] | 0) == (HEAP32[i7 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 255](i7) | 0) == -1 : 0) {
   HEAP32[i2 >> 2] = 0;
   i8 = 11;
   break;
  }
  if (i6) {
   i9 = i7;
   i8 = 13;
  } else i8 = 12;
 } else i8 = 11; while (0);
 if ((i8 | 0) == 11) if (i6) i8 = 12; else {
  i9 = 0;
  i8 = 13;
 }
 L16 : do if ((i8 | 0) == 12) {
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 6;
  i10 = 0;
 } else if ((i8 | 0) == 13) {
  i6 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i6 + 12 >> 2] | 0;
  if ((i7 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] & 255](i6) | 0; else i11 = HEAPU8[i7 >> 0] | 0;
  i7 = i11 & 255;
  if (i7 << 24 >> 24 > -1 ? (i6 = i4 + 8 | 0, (HEAP16[(HEAP32[i6 >> 2] | 0) + (i11 << 24 >> 24 << 1) >> 1] & 2048) != 0) : 0) {
   i12 = (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 63](i4, i7, 0) | 0) << 24 >> 24;
   i7 = HEAP32[i1 >> 2] | 0;
   i13 = i7 + 12 | 0;
   i14 = HEAP32[i13 >> 2] | 0;
   if ((i14 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) {
    FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] & 255](i7) | 0;
    i15 = i5;
    i16 = i9;
    i17 = i9;
    i18 = i12;
   } else {
    HEAP32[i13 >> 2] = i14 + 1;
    i15 = i5;
    i16 = i9;
    i17 = i9;
    i18 = i12;
   }
   while (1) {
    i12 = i18 + -48 | 0;
    i14 = i15 + -1 | 0;
    i13 = HEAP32[i1 >> 2] | 0;
    do if (i13) if ((HEAP32[i13 + 12 >> 2] | 0) == (HEAP32[i13 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] & 255](i13) | 0) == -1) {
     HEAP32[i1 >> 2] = 0;
     i19 = 0;
     break;
    } else {
     i19 = HEAP32[i1 >> 2] | 0;
     break;
    } else i19 = i13; else i19 = 0; while (0);
    i13 = (i19 | 0) == 0;
    if (i17) if ((HEAP32[i17 + 12 >> 2] | 0) == (HEAP32[i17 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 36 >> 2] & 255](i17) | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i20 = 0;
     i21 = 0;
    } else {
     i20 = i16;
     i21 = i16;
    } else {
     i20 = i16;
     i21 = i17;
    } else {
     i20 = i16;
     i21 = 0;
    }
    i7 = HEAP32[i1 >> 2] | 0;
    if (!((i15 | 0) > 1 & (i13 ^ (i21 | 0) == 0))) {
     i22 = i7;
     i23 = i20;
     i24 = i12;
     break;
    }
    i13 = HEAP32[i7 + 12 >> 2] | 0;
    if ((i13 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) i25 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 255](i7) | 0; else i25 = HEAPU8[i13 >> 0] | 0;
    i13 = i25 & 255;
    if (i13 << 24 >> 24 <= -1) {
     i10 = i12;
     break L16;
    }
    if (!(HEAP16[(HEAP32[i6 >> 2] | 0) + (i25 << 24 >> 24 << 1) >> 1] & 2048)) {
     i10 = i12;
     break L16;
    }
    i7 = ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 63](i4, i13, 0) | 0) << 24 >> 24) + (i12 * 10 | 0) | 0;
    i13 = HEAP32[i1 >> 2] | 0;
    i26 = i13 + 12 | 0;
    i27 = HEAP32[i26 >> 2] | 0;
    if ((i27 | 0) == (HEAP32[i13 + 16 >> 2] | 0)) {
     FUNCTION_TABLE_ii[HEAP32[(HEAP32[i13 >> 2] | 0) + 40 >> 2] & 255](i13) | 0;
     i15 = i14;
     i16 = i20;
     i17 = i21;
     i18 = i7;
     continue;
    } else {
     HEAP32[i26 >> 2] = i27 + 1;
     i15 = i14;
     i16 = i20;
     i17 = i21;
     i18 = i7;
     continue;
    }
   }
   do if (i22) if ((HEAP32[i22 + 12 >> 2] | 0) == (HEAP32[i22 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] & 255](i22) | 0) == -1) {
    HEAP32[i1 >> 2] = 0;
    i28 = 0;
    break;
   } else {
    i28 = HEAP32[i1 >> 2] | 0;
    break;
   } else i28 = i22; else i28 = 0; while (0);
   i6 = (i28 | 0) == 0;
   do if (i23) {
    if ((HEAP32[i23 + 12 >> 2] | 0) == (HEAP32[i23 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] & 255](i23) | 0) == -1 : 0) {
     HEAP32[i2 >> 2] = 0;
     i8 = 50;
     break;
    }
    if (i6) {
     i10 = i24;
     break L16;
    }
   } else i8 = 50; while (0);
   if ((i8 | 0) == 50 ? !i6 : 0) {
    i10 = i24;
    break;
   }
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 2;
   i10 = i24;
   break;
  }
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 4;
  i10 = 0;
 } while (0);
 return i10 | 0;
}

function __ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 i8 = i1 + 424 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 16 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 4 | 0;
 i13 = i1 + 428 | 0;
 i14 = i1;
 HEAP32[i10 >> 2] = i9;
 i15 = i10 + 4 | 0;
 HEAP32[i15 >> 2] = 287;
 i16 = i9 + 400 | 0;
 __THREW__ = 0;
 i17 = invoke_ii(131, i5 | 0) | 0;
 i18 = __THREW__;
 __THREW__ = 0;
 if (!(i18 & 1)) {
  HEAP32[i12 >> 2] = i17;
  __THREW__ = 0;
  i18 = invoke_iii(55, i12 | 0, 26572) | 0;
  i19 = __THREW__;
  __THREW__ = 0;
  L4 : do if (!(i19 & 1) ? (HEAP8[i13 >> 0] = 0, i20 = HEAP32[i3 >> 2] | 0, HEAP32[i14 >> 2] = i20, i21 = HEAP32[i5 + 4 >> 2] | 0, i22 = i20, __THREW__ = 0, HEAP32[i8 >> 2] = HEAP32[i14 >> 2], i23 = invoke_iiiiiiiiiiii(2, i2 | 0, i8 | 0, i4 | 0, i12 | 0, i21 | 0, i6 | 0, i13 | 0, i18 | 0, i10 | 0, i11 | 0, i16 | 0) | 0, i21 = __THREW__, __THREW__ = 0, !(i21 & 1)) : 0) {
   if (i23) {
    if (!(HEAP8[i7 >> 0] & 1)) HEAP8[i7 >> 0] = 0; else HEAP32[HEAP32[i7 + 8 >> 2] >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    if (HEAP8[i13 >> 0] | 0) {
     __THREW__ = 0;
     i23 = invoke_iii(HEAP32[(HEAP32[i18 >> 2] | 0) + 44 >> 2] | 0, i18 | 0, 45) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) break;
     __THREW__ = 0;
     invoke_vii(70, i7 | 0, i23 | 0);
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) break;
    }
    __THREW__ = 0;
    i23 = invoke_iii(HEAP32[(HEAP32[i18 >> 2] | 0) + 44 >> 2] | 0, i18 | 0, 48) | 0;
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) break;
    i21 = HEAP32[i10 >> 2] | 0;
    i24 = HEAP32[i11 >> 2] | 0;
    i25 = i24 + -4 | 0;
    L18 : do if (i21 >>> 0 < i25 >>> 0) {
     i26 = i21;
     while (1) {
      if ((HEAP32[i26 >> 2] | 0) != (i23 | 0)) {
       i27 = i26;
       break L18;
      }
      i28 = i26 + 4 | 0;
      if (i28 >>> 0 < i25 >>> 0) i26 = i28; else {
       i27 = i28;
       break;
      }
     }
    } else i27 = i21; while (0);
    __THREW__ = 0;
    invoke_iiii(39, i7 | 0, i27 | 0, i24 | 0) | 0;
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) break;
   }
   i21 = HEAP32[i2 >> 2] | 0;
   do if (i21) {
    i25 = HEAP32[i21 + 12 >> 2] | 0;
    if ((i25 | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i23 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
     i26 = __THREW__;
     __THREW__ = 0;
     if (i26 & 1) break L4; else i29 = i23;
    } else i29 = HEAP32[i25 >> 2] | 0;
    if ((i29 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i30 = 1;
     break;
    } else {
     i30 = (HEAP32[i2 >> 2] | 0) == 0;
     break;
    }
   } else i30 = 1; while (0);
   do if (i20) {
    i21 = HEAP32[i22 + 12 >> 2] | 0;
    if ((i21 | 0) == (HEAP32[i22 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 36 >> 2] | 0, i22 | 0) | 0;
     i25 = __THREW__;
     __THREW__ = 0;
     if (i25 & 1) break L4; else i31 = i24;
    } else i31 = HEAP32[i21 >> 2] | 0;
    if ((i31 | 0) != -1) if (i30) break; else {
     i32 = 32;
     break;
    } else {
     HEAP32[i3 >> 2] = 0;
     i32 = 30;
     break;
    }
   } else i32 = 30; while (0);
   if ((i32 | 0) == 30 ? i30 : 0) i32 = 32;
   if ((i32 | 0) == 32) HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2;
   i22 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__114__shared_count16__release_sharedEv(i17) | 0;
   i20 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = 0;
   if ((i20 | 0) != 0 ? (__THREW__ = 0, invoke_vi(HEAP32[i15 >> 2] | 0, i20 | 0), i20 = __THREW__, __THREW__ = 0, i20 & 1) : 0) {
    i20 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i20);
   }
   STACKTOP = i1;
   return i22 | 0;
  } while (0);
  i1 = ___cxa_find_matching_catch() | 0;
  i2 = tempRet0;
  __ZNSt3__114__shared_count16__release_sharedEv(i17) | 0;
  i17 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  if (!i17) {
   i33 = i2;
   i34 = i1;
  } else {
   i35 = i1;
   i36 = i2;
   i37 = i17;
   i32 = 38;
  }
 } else {
  i17 = ___cxa_find_matching_catch() | 0;
  HEAP32[i10 >> 2] = 0;
  i35 = i17;
  i36 = tempRet0;
  i37 = i9;
  i32 = 38;
 }
 if ((i32 | 0) == 38) {
  __THREW__ = 0;
  invoke_vi(HEAP32[i15 >> 2] | 0, i37 | 0);
  i37 = __THREW__;
  __THREW__ = 0;
  if (i37 & 1) {
   i37 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i37);
  } else {
   i33 = i36;
   i34 = i35;
  }
 }
 ___resumeException(i34 | 0);
 return 0;
}

function _fmod(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, d43 = 0.0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, d52 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i3 = HEAP32[tempDoublePtr >> 2] | 0;
 i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i5 = HEAP32[tempDoublePtr >> 2] | 0;
 i6 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i7 = _bitshift64Lshr(i3 | 0, i4 | 0, 52) | 0;
 i8 = i7 & 2047;
 i7 = _bitshift64Lshr(i5 | 0, i6 | 0, 52) | 0;
 i9 = i7 & 2047;
 i7 = i4 & -2147483648;
 i10 = _bitshift64Shl(i5 | 0, i6 | 0, 1) | 0;
 i11 = tempRet0;
 L1 : do if (!((i10 | 0) == 0 & (i11 | 0) == 0) ? (i12 = i6 & 2147483647, !(i12 >>> 0 > 2146435072 | (i12 | 0) == 2146435072 & i5 >>> 0 > 0 | (i8 | 0) == 2047)) : 0) {
  i12 = _bitshift64Shl(i3 | 0, i4 | 0, 1) | 0;
  i13 = tempRet0;
  if (!(i13 >>> 0 > i11 >>> 0 | (i13 | 0) == (i11 | 0) & i12 >>> 0 > i10 >>> 0)) return +((i12 | 0) == (i10 | 0) & (i13 | 0) == (i11 | 0) ? d1 * 0.0 : d1);
  if (!i8) {
   i13 = _bitshift64Shl(i3 | 0, i4 | 0, 12) | 0;
   i12 = tempRet0;
   if ((i12 | 0) > -1 | (i12 | 0) == -1 & i13 >>> 0 > 4294967295) {
    i14 = i13;
    i13 = i12;
    i12 = 0;
    while (1) {
     i15 = i12 + -1 | 0;
     i14 = _bitshift64Shl(i14 | 0, i13 | 0, 1) | 0;
     i13 = tempRet0;
     if (!((i13 | 0) > -1 | (i13 | 0) == -1 & i14 >>> 0 > 4294967295)) {
      i16 = i15;
      break;
     } else i12 = i15;
    }
   } else i16 = 0;
   i12 = _bitshift64Shl(i3 | 0, i4 | 0, 1 - i16 | 0) | 0;
   i17 = i12;
   i18 = tempRet0;
   i19 = i16;
  } else {
   i17 = i3;
   i18 = i4 & 1048575 | 1048576;
   i19 = i8;
  }
  if (!i9) {
   i12 = _bitshift64Shl(i5 | 0, i6 | 0, 12) | 0;
   i14 = tempRet0;
   if ((i14 | 0) > -1 | (i14 | 0) == -1 & i12 >>> 0 > 4294967295) {
    i13 = i12;
    i12 = i14;
    i14 = 0;
    while (1) {
     i15 = i14 + -1 | 0;
     i13 = _bitshift64Shl(i13 | 0, i12 | 0, 1) | 0;
     i12 = tempRet0;
     if (!((i12 | 0) > -1 | (i12 | 0) == -1 & i13 >>> 0 > 4294967295)) {
      i20 = i15;
      break;
     } else i14 = i15;
    }
   } else i20 = 0;
   i14 = _bitshift64Shl(i5 | 0, i6 | 0, 1 - i20 | 0) | 0;
   i21 = i14;
   i22 = tempRet0;
   i23 = i20;
  } else {
   i21 = i5;
   i22 = i6 & 1048575 | 1048576;
   i23 = i9;
  }
  i14 = _i64Subtract(i17 | 0, i18 | 0, i21 | 0, i22 | 0) | 0;
  i13 = tempRet0;
  i12 = (i13 | 0) > -1 | (i13 | 0) == -1 & i14 >>> 0 > 4294967295;
  L23 : do if ((i19 | 0) > (i23 | 0)) {
   i15 = i12;
   i24 = i14;
   i25 = i13;
   i26 = i17;
   i27 = i18;
   i28 = i19;
   while (1) {
    if (i15) if ((i26 | 0) == (i21 | 0) & (i27 | 0) == (i22 | 0)) break; else {
     i29 = i24;
     i30 = i25;
    } else {
     i29 = i26;
     i30 = i27;
    }
    i31 = _bitshift64Shl(i29 | 0, i30 | 0, 1) | 0;
    i32 = tempRet0;
    i33 = i28 + -1 | 0;
    i34 = _i64Subtract(i31 | 0, i32 | 0, i21 | 0, i22 | 0) | 0;
    i35 = tempRet0;
    i36 = (i35 | 0) > -1 | (i35 | 0) == -1 & i34 >>> 0 > 4294967295;
    if ((i33 | 0) > (i23 | 0)) {
     i15 = i36;
     i24 = i34;
     i25 = i35;
     i26 = i31;
     i27 = i32;
     i28 = i33;
    } else {
     i37 = i36;
     i38 = i31;
     i39 = i32;
     i40 = i34;
     i41 = i35;
     i42 = i33;
     break L23;
    }
   }
   d43 = d1 * 0.0;
   break L1;
  } else {
   i37 = i12;
   i38 = i17;
   i39 = i18;
   i40 = i14;
   i41 = i13;
   i42 = i19;
  } while (0);
  if (i37) if ((i38 | 0) == (i21 | 0) & (i39 | 0) == (i22 | 0)) {
   d43 = d1 * 0.0;
   break;
  } else {
   i44 = i41;
   i45 = i40;
  } else {
   i44 = i39;
   i45 = i38;
  }
  if (i44 >>> 0 < 1048576 | (i44 | 0) == 1048576 & i45 >>> 0 < 0) {
   i13 = i45;
   i14 = i44;
   i12 = i42;
   while (1) {
    i28 = _bitshift64Shl(i13 | 0, i14 | 0, 1) | 0;
    i27 = tempRet0;
    i26 = i12 + -1 | 0;
    if (i27 >>> 0 < 1048576 | (i27 | 0) == 1048576 & i28 >>> 0 < 0) {
     i13 = i28;
     i14 = i27;
     i12 = i26;
    } else {
     i46 = i28;
     i47 = i27;
     i48 = i26;
     break;
    }
   }
  } else {
   i46 = i45;
   i47 = i44;
   i48 = i42;
  }
  if ((i48 | 0) > 0) {
   i12 = _i64Add(i46 | 0, i47 | 0, 0, -1048576) | 0;
   i14 = tempRet0;
   i13 = _bitshift64Shl(i48 | 0, 0, 52) | 0;
   i49 = i14 | tempRet0;
   i50 = i12 | i13;
  } else {
   i13 = _bitshift64Lshr(i46 | 0, i47 | 0, 1 - i48 | 0) | 0;
   i49 = tempRet0;
   i50 = i13;
  }
  HEAP32[tempDoublePtr >> 2] = i50;
  HEAP32[tempDoublePtr + 4 >> 2] = i49 | i7;
  d43 = +HEAPF64[tempDoublePtr >> 3];
 } else i51 = 3; while (0);
 if ((i51 | 0) == 3) {
  d52 = d1 * d2;
  d43 = d52 / d52;
 }
 return +d43;
}

function __ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i8 = i1 + 24 | 0;
 i9 = i1 + 32 | 0;
 i10 = i1 + 16 | 0;
 i11 = i1 + 8 | 0;
 i12 = i1 + 4 | 0;
 i13 = i1 + 28 | 0;
 i14 = i1;
 HEAP32[i10 >> 2] = i9;
 i15 = i10 + 4 | 0;
 HEAP32[i15 >> 2] = 287;
 i16 = i9 + 100 | 0;
 __THREW__ = 0;
 i17 = invoke_ii(131, i5 | 0) | 0;
 i18 = __THREW__;
 __THREW__ = 0;
 if (!(i18 & 1)) {
  HEAP32[i12 >> 2] = i17;
  __THREW__ = 0;
  i18 = invoke_iii(55, i12 | 0, 26580) | 0;
  i19 = __THREW__;
  __THREW__ = 0;
  L4 : do if (!(i19 & 1) ? (HEAP8[i13 >> 0] = 0, i20 = HEAP32[i3 >> 2] | 0, HEAP32[i14 >> 2] = i20, i21 = HEAP32[i5 + 4 >> 2] | 0, i22 = i20, __THREW__ = 0, HEAP32[i8 >> 2] = HEAP32[i14 >> 2], i23 = invoke_iiiiiiiiiiii(1, i2 | 0, i8 | 0, i4 | 0, i12 | 0, i21 | 0, i6 | 0, i13 | 0, i18 | 0, i10 | 0, i11 | 0, i16 | 0) | 0, i21 = __THREW__, __THREW__ = 0, !(i21 & 1)) : 0) {
   if (i23) {
    if (!(HEAP8[i7 >> 0] & 1)) {
     HEAP8[i7 + 1 >> 0] = 0;
     HEAP8[i7 >> 0] = 0;
    } else {
     HEAP8[HEAP32[i7 + 8 >> 2] >> 0] = 0;
     HEAP32[i7 + 4 >> 2] = 0;
    }
    if (HEAP8[i13 >> 0] | 0) {
     __THREW__ = 0;
     i23 = invoke_iii(HEAP32[(HEAP32[i18 >> 2] | 0) + 28 >> 2] | 0, i18 | 0, 45) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) break;
     __THREW__ = 0;
     invoke_vii(67, i7 | 0, i23 | 0);
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) break;
    }
    __THREW__ = 0;
    i23 = invoke_iii(HEAP32[(HEAP32[i18 >> 2] | 0) + 28 >> 2] | 0, i18 | 0, 48) | 0;
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) break;
    i21 = HEAP32[i10 >> 2] | 0;
    i24 = HEAP32[i11 >> 2] | 0;
    i25 = i24 + -1 | 0;
    L18 : do if (i21 >>> 0 < i25 >>> 0) {
     i26 = i21;
     while (1) {
      if ((HEAP8[i26 >> 0] | 0) != i23 << 24 >> 24) {
       i27 = i26;
       break L18;
      }
      i28 = i26 + 1 | 0;
      if (i28 >>> 0 < i25 >>> 0) i26 = i28; else {
       i27 = i28;
       break;
      }
     }
    } else i27 = i21; while (0);
    __THREW__ = 0;
    invoke_iiii(38, i7 | 0, i27 | 0, i24 | 0) | 0;
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) break;
   }
   i21 = HEAP32[i2 >> 2] | 0;
   do if (i21) if ((HEAP32[i21 + 12 >> 2] | 0) == (HEAP32[i21 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i25 = invoke_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) break L4;
    if ((i25 | 0) == -1) {
     HEAP32[i2 >> 2] = 0;
     i29 = 0;
     break;
    } else {
     i29 = HEAP32[i2 >> 2] | 0;
     break;
    }
   } else i29 = i21; else i29 = 0; while (0);
   i21 = (i29 | 0) == 0;
   do if (i20) {
    if ((HEAP32[i22 + 12 >> 2] | 0) == (HEAP32[i22 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i24 = invoke_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 36 >> 2] | 0, i22 | 0) | 0;
     i25 = __THREW__;
     __THREW__ = 0;
     if (i25 & 1) break L4;
     if ((i24 | 0) == -1) {
      HEAP32[i3 >> 2] = 0;
      i30 = 29;
      break;
     }
    }
    if (!i21) i30 = 30;
   } else i30 = 29; while (0);
   if ((i30 | 0) == 29 ? i21 : 0) i30 = 30;
   if ((i30 | 0) == 30) HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2;
   i22 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__114__shared_count16__release_sharedEv(i17) | 0;
   i20 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = 0;
   if ((i20 | 0) != 0 ? (__THREW__ = 0, invoke_vi(HEAP32[i15 >> 2] | 0, i20 | 0), i20 = __THREW__, __THREW__ = 0, i20 & 1) : 0) {
    i20 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i20);
   }
   STACKTOP = i1;
   return i22 | 0;
  } while (0);
  i1 = ___cxa_find_matching_catch() | 0;
  i2 = tempRet0;
  __ZNSt3__114__shared_count16__release_sharedEv(i17) | 0;
  i17 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  if (!i17) {
   i31 = i2;
   i32 = i1;
  } else {
   i33 = i1;
   i34 = i2;
   i35 = i17;
   i30 = 36;
  }
 } else {
  i17 = ___cxa_find_matching_catch() | 0;
  HEAP32[i10 >> 2] = 0;
  i33 = i17;
  i34 = tempRet0;
  i35 = i9;
  i30 = 36;
 }
 if ((i30 | 0) == 36) {
  __THREW__ = 0;
  invoke_vi(HEAP32[i15 >> 2] | 0, i35 | 0);
  i35 = __THREW__;
  __THREW__ = 0;
  if (i35 & 1) {
   i35 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i35);
  } else {
   i31 = i34;
   i32 = i33;
  }
 }
 ___resumeException(i32 | 0);
 return 0;
}

function __ZN10maxiSample5play4Eddd(i1, d2, d3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 var i5 = 0, d6 = 0.0, d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, d15 = 0.0, d16 = 0.0, i17 = 0, i18 = 0, d19 = 0.0, i20 = 0, d21 = 0.0, d22 = 0.0, d23 = 0.0, d24 = 0.0, d25 = 0.0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 if (!(d2 > 0.0)) {
  i5 = i1 + 40 | 0;
  d6 = +HEAPF64[i5 >> 3];
  if (!(d6 <= d3)) d7 = d6; else {
   HEAPF64[i5 >> 3] = d4;
   d7 = d4;
  }
  d6 = d7 - (d4 - d3) / (+(HEAP32[4327] | 0) / ((d2 - (d2 + d2)) * +HEAPF32[4326]));
  HEAPF64[i5 >> 3] = d6;
  d7 = d6 - +Math_floor(+d6);
  i8 = i1 + 96 | 0;
  do if (d6 > d3 & d6 < d4 + -1.0) {
   i9 = ~~d6 + 1 | 0;
   i10 = i1 + 100 | 0;
   i11 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i10 >> 2] | 0) - i11 >> 3 >>> 0 > i9 >>> 0) {
    i12 = i10;
    i13 = i11;
    i14 = i11 + (i9 << 3) | 0;
    break;
   } else __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i8);
  } else {
   i9 = i1 + 100 | 0;
   i11 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i9 >> 2] | 0) == (i11 | 0)) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i8); else {
    i12 = i9;
    i13 = i11;
    i14 = i11;
   }
  } while (0);
  d6 = +HEAPF64[i14 >> 3];
  d15 = +HEAPF64[i5 >> 3];
  i14 = ~~d15;
  if ((HEAP32[i12 >> 2] | 0) - i13 >> 3 >>> 0 <= i14 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i8);
  d16 = +HEAPF64[i13 + (i14 << 3) >> 3];
  do if (d15 > d3) {
   i14 = ~~d15 + -1 | 0;
   if ((HEAP32[i12 >> 2] | 0) - i13 >> 3 >>> 0 > i14 >>> 0) {
    i17 = i13;
    i18 = i13 + (i14 << 3) | 0;
    break;
   } else __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i8);
  } else if ((HEAP32[i12 >> 2] | 0) == (i13 | 0)) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i8); else {
   i17 = i13;
   i18 = i13;
  } while (0);
  d15 = +HEAPF64[i18 >> 3];
  d19 = +HEAPF64[i5 >> 3];
  do if (d19 > d3 + 1.0) {
   i5 = ~~d19 + -2 | 0;
   if ((HEAP32[i12 >> 2] | 0) - i17 >> 3 >>> 0 > i5 >>> 0) {
    i20 = i17 + (i5 << 3) | 0;
    break;
   } else __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i8);
  } else if ((HEAP32[i12 >> 2] | 0) == (i17 | 0)) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i8); else i20 = i17; while (0);
  d19 = +HEAPF64[i20 >> 3];
  d21 = -d7;
  d22 = d16 + ((d15 - d6) * .5 + (d6 - d16 * 2.5 + d15 * 2.0 - d19 * .5 + d7 * ((d16 - d15) * 1.5 + (d19 - d6) * .5)) * d21) * d21;
  HEAPF64[i1 + 64 >> 3] = d22;
  d23 = d22;
  return +d23;
 }
 i20 = i1 + 40 | 0;
 d22 = +HEAPF64[i20 >> 3];
 if (d22 < d3) {
  HEAPF64[i20 >> 3] = d3;
  d24 = d3;
 } else d24 = d22;
 if (!(d24 >= d4)) d25 = d24; else {
  HEAPF64[i20 >> 3] = d3;
  d25 = d3;
 }
 d24 = (d4 - d3) / (+(HEAP32[4327] | 0) / (+HEAPF32[4326] * d2)) + d25;
 HEAPF64[i20 >> 3] = d24;
 d25 = +Math_floor(+d24);
 d2 = d24 - d25;
 i17 = i1 + 96 | 0;
 do if (!(d24 >= 1.0)) {
  i8 = i1 + 100 | 0;
  i12 = HEAP32[i17 >> 2] | 0;
  if ((HEAP32[i8 >> 2] | 0) == (i12 | 0)) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i17); else {
   i26 = i8;
   i27 = i12;
   i28 = i12;
  }
 } else {
  i12 = ~~d25 + -1 | 0;
  i8 = i1 + 100 | 0;
  i5 = HEAP32[i17 >> 2] | 0;
  if ((HEAP32[i8 >> 2] | 0) - i5 >> 3 >>> 0 > i12 >>> 0) {
   i26 = i8;
   i27 = i5;
   i28 = i5 + (i12 << 3) | 0;
   break;
  } else __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i17);
 } while (0);
 d25 = +HEAPF64[i28 >> 3];
 d24 = +HEAPF64[i20 >> 3];
 i28 = ~~d24;
 if ((HEAP32[i26 >> 2] | 0) - i27 >> 3 >>> 0 <= i28 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i17);
 d3 = +HEAPF64[i27 + (i28 << 3) >> 3];
 do if (d24 < d4 + -2.0) {
  i28 = ~~d24 + 1 | 0;
  if ((HEAP32[i26 >> 2] | 0) - i27 >> 3 >>> 0 > i28 >>> 0) {
   i29 = i27;
   i30 = i27 + (i28 << 3) | 0;
   break;
  } else __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i17);
 } else if ((HEAP32[i26 >> 2] | 0) == (i27 | 0)) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i17); else {
  i29 = i27;
  i30 = i27;
 } while (0);
 d24 = +HEAPF64[i30 >> 3];
 d22 = +HEAPF64[i20 >> 3];
 do if (d22 < d4 + -3.0) {
  i20 = ~~d22 + 2 | 0;
  if ((HEAP32[i26 >> 2] | 0) - i29 >> 3 >>> 0 > i20 >>> 0) {
   i31 = i29 + (i20 << 3) | 0;
   break;
  } else __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i17);
 } else if ((HEAP32[i26 >> 2] | 0) == (i29 | 0)) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i17); else i31 = i29; while (0);
 d22 = +HEAPF64[i31 >> 3];
 d4 = d3 + d2 * ((d24 - d25) * .5 + d2 * (d25 - d3 * 2.5 + d24 * 2.0 - d22 * .5 + d2 * ((d3 - d24) * 1.5 + (d22 - d25) * .5)));
 HEAPF64[i1 + 64 >> 3] = d4;
 d23 = d4;
 return +d23;
}

function __ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i7 = i2 + 184 | 0;
 i8 = i2 + 192 | 0;
 i9 = i2 + 180 | 0;
 i10 = i2 + 176 | 0;
 i11 = i2 + 168 | 0;
 i12 = i2 + 40 | 0;
 i13 = i2 + 32 | 0;
 i14 = i2 + 28 | 0;
 i15 = i2 + 16 | 0;
 i16 = i2 + 8 | 0;
 i17 = i2;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 >> 2] = 27056;
 i18 = HEAP8[i6 >> 0] | 0;
 i19 = (i18 & 1) == 0;
 i20 = i6 + 4 | 0;
 i21 = i19 ? i20 : HEAP32[i6 + 8 >> 2] | 0;
 i6 = i19 ? (i18 & 255) >>> 1 : HEAP32[i20 >> 2] | 0;
 i20 = i21 + (i6 << 2) | 0;
 i18 = i8 + 32 | 0;
 L1 : do if ((i6 | 0) > 0) {
  i19 = i21;
  L2 : while (1) {
   HEAP32[i10 >> 2] = i19;
   __THREW__ = 0;
   i22 = invoke_iiiiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i7 | 0, i19 | 0, i20 | 0, i10 | 0, i8 | 0, i18 | 0, i9 | 0) | 0;
   i23 = __THREW__;
   __THREW__ = 0;
   if (i23 & 1) {
    i24 = 12;
    break;
   }
   if ((i22 | 0) == 2 ? 1 : (HEAP32[i10 >> 2] | 0) == (i19 | 0)) {
    i24 = 5;
    break;
   }
   if (i8 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
    i23 = i8;
    do {
     __THREW__ = 0;
     invoke_vii(67, i15 | 0, HEAP8[i23 >> 0] | 0);
     i25 = __THREW__;
     __THREW__ = 0;
     if (i25 & 1) {
      i24 = 11;
      break L2;
     }
     i23 = i23 + 1 | 0;
    } while (i23 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
   }
   i19 = HEAP32[i10 >> 2] | 0;
   if (!((i22 | 0) != 2 & i19 >>> 0 < i20 >>> 0)) {
    i24 = 9;
    break L1;
   }
  }
  if ((i24 | 0) == 5) {
   __THREW__ = 0;
   invoke_vi(288, 47618);
   __THREW__ = 0;
   i19 = ___cxa_find_matching_catch() | 0;
   i26 = i19;
   i27 = tempRet0;
  } else if ((i24 | 0) == 11) {
   i19 = ___cxa_find_matching_catch() | 0;
   i26 = i19;
   i27 = tempRet0;
  } else if ((i24 | 0) == 12) {
   i19 = ___cxa_find_matching_catch() | 0;
   i26 = i19;
   i27 = tempRet0;
  }
  i28 = i26;
  i29 = i27;
 } else i24 = 9; while (0);
 L16 : do if ((i24 | 0) == 9) {
  __THREW__ = 0;
  i27 = invoke_iiiii(12, ((i3 | 0) == -1 ? -1 : i3 << 1) | 0, i4 | 0, i5 | 0, ((HEAP8[i15 >> 0] & 1) == 0 ? i15 + 1 | 0 : HEAP32[i15 + 8 >> 2] | 0) | 0) | 0;
  i26 = __THREW__;
  __THREW__ = 0;
  if (i26 & 1) {
   i26 = ___cxa_find_matching_catch() | 0;
   i28 = i26;
   i29 = tempRet0;
   break;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 >> 2] = 27104;
  i26 = _strlen(i27) | 0;
  i20 = i27 + i26 | 0;
  i10 = i20;
  i9 = i12 + 128 | 0;
  L21 : do if ((i26 | 0) > 0) {
   i8 = i27;
   L22 : while (1) {
    HEAP32[i14 >> 2] = i8;
    __THREW__ = 0;
    i18 = invoke_iiiiiiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] | 0, i17 | 0, i11 | 0, i8 | 0, ((i10 - i8 | 0) > 32 ? i8 + 32 | 0 : i20) | 0, i14 | 0, i12 | 0, i9 | 0, i13 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i24 = 24;
     break;
    }
    if ((i18 | 0) == 2 ? 1 : (HEAP32[i14 >> 2] | 0) == (i8 | 0)) {
     i24 = 18;
     break;
    }
    if (i12 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
     i7 = i12;
     do {
      __THREW__ = 0;
      invoke_vii(70, i1 | 0, HEAP32[i7 >> 2] | 0);
      i16 = __THREW__;
      __THREW__ = 0;
      if (i16 & 1) {
       i24 = 23;
       break L22;
      }
      i7 = i7 + 4 | 0;
     } while (i7 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
    }
    i8 = HEAP32[i14 >> 2] | 0;
    if (!((i18 | 0) != 2 & i8 >>> 0 < i20 >>> 0)) break L21;
   }
   if ((i24 | 0) == 18) {
    __THREW__ = 0;
    invoke_vi(288, 47618);
    __THREW__ = 0;
    i8 = ___cxa_find_matching_catch() | 0;
    i30 = i8;
    i31 = tempRet0;
   } else if ((i24 | 0) == 23) {
    i8 = ___cxa_find_matching_catch() | 0;
    i30 = i8;
    i31 = tempRet0;
   } else if ((i24 | 0) == 24) {
    i8 = ___cxa_find_matching_catch() | 0;
    i30 = i8;
    i31 = tempRet0;
   }
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1);
   i28 = i30;
   i29 = i31;
   break L16;
  } while (0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  STACKTOP = i2;
  return;
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 ___resumeException(i28 | 0);
}

function ___udivmoddi4(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i6 = i1;
 i7 = i2;
 i8 = i7;
 i9 = i3;
 i10 = i4;
 i11 = i10;
 if (!i8) {
  i12 = (i5 | 0) != 0;
  if (!i11) {
   if (i12) {
    HEAP32[i5 >> 2] = (i6 >>> 0) % (i9 >>> 0);
    HEAP32[i5 + 4 >> 2] = 0;
   }
   i13 = 0;
   i14 = (i6 >>> 0) / (i9 >>> 0) >>> 0;
   return (tempRet0 = i13, i14) | 0;
  } else {
   if (!i12) {
    i13 = 0;
    i14 = 0;
    return (tempRet0 = i13, i14) | 0;
   }
   HEAP32[i5 >> 2] = i1 | 0;
   HEAP32[i5 + 4 >> 2] = i2 & 0;
   i13 = 0;
   i14 = 0;
   return (tempRet0 = i13, i14) | 0;
  }
 }
 i12 = (i11 | 0) == 0;
 do if (i9) {
  if (!i12) {
   i15 = (Math_clz32(i11 | 0) | 0) - (Math_clz32(i8 | 0) | 0) | 0;
   if (i15 >>> 0 <= 31) {
    i16 = i15 + 1 | 0;
    i17 = 31 - i15 | 0;
    i18 = i15 - 31 >> 31;
    i19 = i16;
    i20 = i6 >>> (i16 >>> 0) & i18 | i8 << i17;
    i21 = i8 >>> (i16 >>> 0) & i18;
    i22 = 0;
    i23 = i6 << i17;
    break;
   }
   if (!i5) {
    i13 = 0;
    i14 = 0;
    return (tempRet0 = i13, i14) | 0;
   }
   HEAP32[i5 >> 2] = i1 | 0;
   HEAP32[i5 + 4 >> 2] = i7 | i2 & 0;
   i13 = 0;
   i14 = 0;
   return (tempRet0 = i13, i14) | 0;
  }
  i17 = i9 - 1 | 0;
  if (i17 & i9) {
   i18 = (Math_clz32(i9 | 0) | 0) + 33 - (Math_clz32(i8 | 0) | 0) | 0;
   i16 = 64 - i18 | 0;
   i15 = 32 - i18 | 0;
   i24 = i15 >> 31;
   i25 = i18 - 32 | 0;
   i26 = i25 >> 31;
   i19 = i18;
   i20 = i15 - 1 >> 31 & i8 >>> (i25 >>> 0) | (i8 << i15 | i6 >>> (i18 >>> 0)) & i26;
   i21 = i26 & i8 >>> (i18 >>> 0);
   i22 = i6 << i16 & i24;
   i23 = (i8 << i16 | i6 >>> (i25 >>> 0)) & i24 | i6 << i15 & i18 - 33 >> 31;
   break;
  }
  if (i5) {
   HEAP32[i5 >> 2] = i17 & i6;
   HEAP32[i5 + 4 >> 2] = 0;
  }
  if ((i9 | 0) == 1) {
   i13 = i7 | i2 & 0;
   i14 = i1 | 0 | 0;
   return (tempRet0 = i13, i14) | 0;
  } else {
   i17 = _llvm_cttz_i32(i9 | 0) | 0;
   i13 = i8 >>> (i17 >>> 0) | 0;
   i14 = i8 << 32 - i17 | i6 >>> (i17 >>> 0) | 0;
   return (tempRet0 = i13, i14) | 0;
  }
 } else {
  if (i12) {
   if (i5) {
    HEAP32[i5 >> 2] = (i8 >>> 0) % (i9 >>> 0);
    HEAP32[i5 + 4 >> 2] = 0;
   }
   i13 = 0;
   i14 = (i8 >>> 0) / (i9 >>> 0) >>> 0;
   return (tempRet0 = i13, i14) | 0;
  }
  if (!i6) {
   if (i5) {
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = (i8 >>> 0) % (i11 >>> 0);
   }
   i13 = 0;
   i14 = (i8 >>> 0) / (i11 >>> 0) >>> 0;
   return (tempRet0 = i13, i14) | 0;
  }
  i17 = i11 - 1 | 0;
  if (!(i17 & i11)) {
   if (i5) {
    HEAP32[i5 >> 2] = i1 | 0;
    HEAP32[i5 + 4 >> 2] = i17 & i8 | i2 & 0;
   }
   i13 = 0;
   i14 = i8 >>> ((_llvm_cttz_i32(i11 | 0) | 0) >>> 0);
   return (tempRet0 = i13, i14) | 0;
  }
  i17 = (Math_clz32(i11 | 0) | 0) - (Math_clz32(i8 | 0) | 0) | 0;
  if (i17 >>> 0 <= 30) {
   i18 = i17 + 1 | 0;
   i15 = 31 - i17 | 0;
   i19 = i18;
   i20 = i8 << i15 | i6 >>> (i18 >>> 0);
   i21 = i8 >>> (i18 >>> 0);
   i22 = 0;
   i23 = i6 << i15;
   break;
  }
  if (!i5) {
   i13 = 0;
   i14 = 0;
   return (tempRet0 = i13, i14) | 0;
  }
  HEAP32[i5 >> 2] = i1 | 0;
  HEAP32[i5 + 4 >> 2] = i7 | i2 & 0;
  i13 = 0;
  i14 = 0;
  return (tempRet0 = i13, i14) | 0;
 } while (0);
 if (!i19) {
  i27 = i23;
  i28 = i22;
  i29 = i21;
  i30 = i20;
  i31 = 0;
  i32 = 0;
 } else {
  i2 = i3 | 0 | 0;
  i3 = i10 | i4 & 0;
  i4 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
  i10 = tempRet0;
  i7 = i23;
  i23 = i22;
  i22 = i21;
  i21 = i20;
  i20 = i19;
  i19 = 0;
  do {
   i1 = i7;
   i7 = i23 >>> 31 | i7 << 1;
   i23 = i19 | i23 << 1;
   i6 = i21 << 1 | i1 >>> 31 | 0;
   i1 = i21 >>> 31 | i22 << 1 | 0;
   _i64Subtract(i4, i10, i6, i1) | 0;
   i8 = tempRet0;
   i11 = i8 >> 31 | ((i8 | 0) < 0 ? -1 : 0) << 1;
   i19 = i11 & 1;
   i21 = _i64Subtract(i6, i1, i11 & i2, (((i8 | 0) < 0 ? -1 : 0) >> 31 | ((i8 | 0) < 0 ? -1 : 0) << 1) & i3) | 0;
   i22 = tempRet0;
   i20 = i20 - 1 | 0;
  } while ((i20 | 0) != 0);
  i27 = i7;
  i28 = i23;
  i29 = i22;
  i30 = i21;
  i31 = 0;
  i32 = i19;
 }
 i19 = i28;
 i28 = 0;
 if (i5) {
  HEAP32[i5 >> 2] = i30;
  HEAP32[i5 + 4 >> 2] = i29;
 }
 i13 = (i19 | 0) >>> 31 | (i27 | i28) << 1 | (i28 << 1 | i19 >>> 31) & 0 | i31;
 i14 = (i19 << 1 | 0 >>> 31) & -2 | i32;
 return (tempRet0 = i13, i14) | 0;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 i6 = i1 + 312 | 0;
 i7 = i1 + 48 | 0;
 i8 = i1 + 32 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 8 | 0;
 i11 = i1;
 i12 = i1 + 316 | 0;
 i13 = i1 + 80 | 0;
 i14 = i1 + 84 | 0;
 i15 = i1 + 76 | 0;
 i16 = i1 + 72 | 0;
 i17 = i1 + 68 | 0;
 i18 = i1 + 64 | 0;
 i19 = i11;
 HEAP32[i19 >> 2] = 37;
 HEAP32[i19 + 4 >> 2] = 0;
 i19 = __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i11 + 1 | 0, 47561, HEAP32[i3 + 4 >> 2] | 0) | 0;
 HEAP32[i13 >> 2] = i12;
 i20 = __ZNSt3__16__clocEv() | 0;
 if (i19) {
  HEAP32[i10 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAPF64[i10 + 8 >> 3] = d5;
  i21 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i12, 30, i20, i11, i10) | 0;
 } else {
  HEAPF64[i9 >> 3] = d5;
  i21 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i12, 30, i20, i11, i9) | 0;
 }
 L5 : do if ((i21 | 0) > 29) {
  __THREW__ = 0;
  i9 = invoke_i(22) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  i10 = i20 & 1;
  if (i19) {
   if (!i10 ? (__THREW__ = 0, HEAP32[i8 >> 2] = HEAP32[i3 + 8 >> 2], HEAPF64[i8 + 8 >> 3] = d5, i20 = invoke_iiiii(10, i13 | 0, i9 | 0, i11 | 0, i8 | 0) | 0, i22 = __THREW__, __THREW__ = 0, !(i22 & 1)) : 0) {
    i23 = i20;
    i24 = 12;
   }
  } else if (!i10 ? (__THREW__ = 0, HEAP32[i7 >> 2] = HEAP32[i3 + 8 >> 2], HEAPF64[i7 + 8 >> 3] = d5, i10 = invoke_iiiii(10, i13 | 0, i9 | 0, i11 | 0, i7 | 0) | 0, i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) {
   i23 = i10;
   i24 = 12;
  }
  do if ((i24 | 0) == 12) {
   i10 = HEAP32[i13 >> 2] | 0;
   if (!i10) {
    __THREW__ = 0;
    invoke_v(5);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) break;
    i25 = HEAP32[i13 >> 2] | 0;
   } else i25 = i10;
   i26 = i25;
   i27 = i25;
   i28 = i23;
   i24 = 16;
   break L5;
  } while (0);
  i10 = ___cxa_find_matching_catch() | 0;
  i29 = i10;
  i30 = tempRet0;
 } else {
  i26 = HEAP32[i13 >> 2] | 0;
  i27 = 0;
  i28 = i21;
  i24 = 16;
 } while (0);
 if ((i24 | 0) == 16) {
  i21 = i26 + i28 | 0;
  i23 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i26, i21, i3) | 0;
  do if ((i26 | 0) == (i12 | 0)) {
   i31 = i12;
   i32 = 0;
   i33 = i14;
   i24 = 22;
  } else {
   i25 = _malloc(i28 << 3) | 0;
   if (!i25) {
    __THREW__ = 0;
    invoke_v(5);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i34 = 0;
     i24 = 20;
     break;
    }
    i35 = HEAP32[i13 >> 2] | 0;
   } else i35 = i26;
   i31 = i35;
   i32 = i25;
   i33 = i25;
   i24 = 22;
  } while (0);
  do if ((i24 | 0) == 22) {
   __THREW__ = 0;
   i35 = invoke_ii(131, i3 | 0) | 0;
   i26 = __THREW__;
   __THREW__ = 0;
   if (!(i26 & 1)) {
    HEAP32[i17 >> 2] = i35;
    __THREW__ = 0;
    invoke_viiiiiii(4, i31 | 0, i23 | 0, i21 | 0, i33 | 0, i15 | 0, i16 | 0, i17 | 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i26 = ___cxa_find_matching_catch() | 0;
     i13 = tempRet0;
     __ZNSt3__114__shared_count16__release_sharedEv(i35) | 0;
     i36 = i26;
     i37 = i13;
     i38 = i32;
     break;
    }
    __ZNSt3__114__shared_count16__release_sharedEv(i35) | 0;
    HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
    i35 = HEAP32[i15 >> 2] | 0;
    i13 = HEAP32[i16 >> 2] | 0;
    __THREW__ = 0;
    HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
    i26 = invoke_iiiiiii(40, i6 | 0, i33 | 0, i35 | 0, i13 | 0, i3 | 0, i4 | 0) | 0;
    i13 = __THREW__;
    __THREW__ = 0;
    if (!(i13 & 1)) {
     HEAP32[i2 >> 2] = i26;
     if (i32) _free(i32);
     if (i27) _free(i27);
     STACKTOP = i1;
     return i26 | 0;
    } else {
     i34 = i32;
     i24 = 20;
    }
   } else {
    i34 = i32;
    i24 = 20;
   }
  } while (0);
  if ((i24 | 0) == 20) {
   i24 = ___cxa_find_matching_catch() | 0;
   i36 = i24;
   i37 = tempRet0;
   i38 = i34;
  }
  if (i38) _free(i38);
  if (!i27) {
   i29 = i36;
   i30 = i37;
  } else {
   _free(i27);
   i29 = i36;
   i30 = i37;
  }
 }
 ___resumeException(i29 | 0);
 return 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i6 = i1 + 84 | 0;
 i7 = i1 + 48 | 0;
 i8 = i1 + 32 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 8 | 0;
 i11 = i1;
 i12 = i1 + 88 | 0;
 i13 = i1 + 80 | 0;
 i14 = i1 + 118 | 0;
 i15 = i1 + 76 | 0;
 i16 = i1 + 72 | 0;
 i17 = i1 + 68 | 0;
 i18 = i1 + 64 | 0;
 i19 = i11;
 HEAP32[i19 >> 2] = 37;
 HEAP32[i19 + 4 >> 2] = 0;
 i19 = __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i11 + 1 | 0, 47561, HEAP32[i3 + 4 >> 2] | 0) | 0;
 HEAP32[i13 >> 2] = i12;
 i20 = __ZNSt3__16__clocEv() | 0;
 if (i19) {
  HEAP32[i10 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAPF64[i10 + 8 >> 3] = d5;
  i21 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i12, 30, i20, i11, i10) | 0;
 } else {
  HEAPF64[i9 >> 3] = d5;
  i21 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i12, 30, i20, i11, i9) | 0;
 }
 L5 : do if ((i21 | 0) > 29) {
  __THREW__ = 0;
  i9 = invoke_i(22) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  i10 = i20 & 1;
  if (i19) {
   if (!i10 ? (__THREW__ = 0, HEAP32[i8 >> 2] = HEAP32[i3 + 8 >> 2], HEAPF64[i8 + 8 >> 3] = d5, i20 = invoke_iiiii(10, i13 | 0, i9 | 0, i11 | 0, i8 | 0) | 0, i22 = __THREW__, __THREW__ = 0, !(i22 & 1)) : 0) {
    i23 = i20;
    i24 = 12;
   }
  } else if (!i10 ? (__THREW__ = 0, HEAP32[i7 >> 2] = HEAP32[i3 + 8 >> 2], HEAPF64[i7 + 8 >> 3] = d5, i10 = invoke_iiiii(10, i13 | 0, i9 | 0, i11 | 0, i7 | 0) | 0, i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) {
   i23 = i10;
   i24 = 12;
  }
  do if ((i24 | 0) == 12) {
   i10 = HEAP32[i13 >> 2] | 0;
   if (!i10) {
    __THREW__ = 0;
    invoke_v(5);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) break;
    i25 = HEAP32[i13 >> 2] | 0;
   } else i25 = i10;
   i26 = i25;
   i27 = i25;
   i28 = i23;
   i24 = 16;
   break L5;
  } while (0);
  i10 = ___cxa_find_matching_catch() | 0;
  i29 = i10;
  i30 = tempRet0;
 } else {
  i26 = HEAP32[i13 >> 2] | 0;
  i27 = 0;
  i28 = i21;
  i24 = 16;
 } while (0);
 if ((i24 | 0) == 16) {
  i21 = i26 + i28 | 0;
  i23 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i26, i21, i3) | 0;
  do if ((i26 | 0) == (i12 | 0)) {
   i31 = i12;
   i32 = 0;
   i33 = i14;
   i24 = 22;
  } else {
   i25 = _malloc(i28 << 1) | 0;
   if (!i25) {
    __THREW__ = 0;
    invoke_v(5);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i34 = 0;
     i24 = 20;
     break;
    }
    i35 = HEAP32[i13 >> 2] | 0;
   } else i35 = i26;
   i31 = i35;
   i32 = i25;
   i33 = i25;
   i24 = 22;
  } while (0);
  do if ((i24 | 0) == 22) {
   __THREW__ = 0;
   i35 = invoke_ii(131, i3 | 0) | 0;
   i26 = __THREW__;
   __THREW__ = 0;
   if (!(i26 & 1)) {
    HEAP32[i17 >> 2] = i35;
    __THREW__ = 0;
    invoke_viiiiiii(2, i31 | 0, i23 | 0, i21 | 0, i33 | 0, i15 | 0, i16 | 0, i17 | 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i26 = ___cxa_find_matching_catch() | 0;
     i13 = tempRet0;
     __ZNSt3__114__shared_count16__release_sharedEv(i35) | 0;
     i36 = i26;
     i37 = i13;
     i38 = i32;
     break;
    }
    __ZNSt3__114__shared_count16__release_sharedEv(i35) | 0;
    HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
    i35 = HEAP32[i15 >> 2] | 0;
    i13 = HEAP32[i16 >> 2] | 0;
    __THREW__ = 0;
    HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
    i26 = invoke_iiiiiii(39, i6 | 0, i33 | 0, i35 | 0, i13 | 0, i3 | 0, i4 | 0) | 0;
    i13 = __THREW__;
    __THREW__ = 0;
    if (!(i13 & 1)) {
     HEAP32[i2 >> 2] = i26;
     if (i32) _free(i32);
     if (i27) _free(i27);
     STACKTOP = i1;
     return i26 | 0;
    } else {
     i34 = i32;
     i24 = 20;
    }
   } else {
    i34 = i32;
    i24 = 20;
   }
  } while (0);
  if ((i24 | 0) == 20) {
   i24 = ___cxa_find_matching_catch() | 0;
   i36 = i24;
   i37 = tempRet0;
   i38 = i34;
  }
  if (i38) _free(i38);
  if (!i27) {
   i29 = i36;
   i30 = i37;
  } else {
   _free(i27);
   i29 = i36;
   i30 = i37;
  }
 }
 ___resumeException(i29 | 0);
 return 0;
}

function __ZNSt3__18ios_base4InitC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[4916] | 0;
 __ZNSt3__110__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t(24428, i1, 24484);
 HEAP32[5937] = 25252;
 HEAP32[5939] = 25272;
 HEAP32[5938] = 0;
 i2 = HEAP32[6310] | 0;
 __THREW__ = 0;
 invoke_vii(62, 23748 + i2 | 0, 24428);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(23756);
  ___resumeException(i3 | 0);
 }
 HEAP32[23748 + (i2 + 72) >> 2] = 0;
 HEAP32[23748 + (i2 + 76) >> 2] = -1;
 i2 = HEAP32[4917] | 0;
 __ZNSt3__111__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t(24532, i2, 24492);
 HEAP32[5959] = 25332;
 HEAP32[5960] = 25352;
 i3 = HEAP32[6330] | 0;
 __THREW__ = 0;
 invoke_vii(62, 23836 + i3 | 0, 24532);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(23840);
  ___resumeException(i4 | 0);
 }
 i4 = i3 + 72 | 0;
 HEAP32[23836 + i4 >> 2] = 0;
 i5 = i3 + 76 | 0;
 HEAP32[23836 + i5 >> 2] = -1;
 i6 = HEAP32[4915] | 0;
 __ZNSt3__111__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t(24580, i6, 24500);
 HEAP32[5980] = 25332;
 HEAP32[5981] = 25352;
 __THREW__ = 0;
 invoke_vii(62, 23920 + i3 | 0, 24580);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(23924);
  ___resumeException(i7 | 0);
 }
 HEAP32[23920 + i4 >> 2] = 0;
 HEAP32[23920 + i5 >> 2] = -1;
 i7 = HEAP32[23920 + ((HEAP32[(HEAP32[5980] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
 HEAP32[6001] = 25332;
 HEAP32[6002] = 25352;
 __THREW__ = 0;
 invoke_vii(62, 24004 + i3 | 0, i7 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(24008);
  ___resumeException(i7 | 0);
 }
 HEAP32[24004 + i4 >> 2] = 0;
 HEAP32[24004 + i5 >> 2] = -1;
 HEAP32[23748 + ((HEAP32[(HEAP32[5937] | 0) + -12 >> 2] | 0) + 72) >> 2] = 23836;
 i5 = 23920 + ((HEAP32[(HEAP32[5980] | 0) + -12 >> 2] | 0) + 4) | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 8192;
 HEAP32[23920 + ((HEAP32[(HEAP32[5980] | 0) + -12 >> 2] | 0) + 72) >> 2] = 23836;
 __ZNSt3__110__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t(24628, i1, 24508);
 HEAP32[6022] = 25292;
 HEAP32[6024] = 25312;
 HEAP32[6023] = 0;
 i1 = HEAP32[6320] | 0;
 __THREW__ = 0;
 invoke_vii(62, 24088 + i1 | 0, 24628);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev(24096);
  ___resumeException(i5 | 0);
 }
 HEAP32[24088 + (i1 + 72) >> 2] = 0;
 HEAP32[24088 + (i1 + 76) >> 2] = -1;
 __ZNSt3__111__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t(24684, i2, 24516);
 HEAP32[6044] = 25372;
 HEAP32[6045] = 25392;
 i2 = HEAP32[6340] | 0;
 __THREW__ = 0;
 invoke_vii(62, 24176 + i2 | 0, 24684);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev(24180);
  ___resumeException(i1 | 0);
 }
 i1 = i2 + 72 | 0;
 HEAP32[24176 + i1 >> 2] = 0;
 i5 = i2 + 76 | 0;
 HEAP32[24176 + i5 >> 2] = -1;
 __ZNSt3__111__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t(24732, i6, 24524);
 HEAP32[6065] = 25372;
 HEAP32[6066] = 25392;
 __THREW__ = 0;
 invoke_vii(62, 24260 + i2 | 0, 24732);
 i6 = __THREW__;
 __THREW__ = 0;
 if (i6 & 1) {
  i6 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev(24264);
  ___resumeException(i6 | 0);
 }
 HEAP32[24260 + i1 >> 2] = 0;
 HEAP32[24260 + i5 >> 2] = -1;
 i6 = HEAP32[24260 + ((HEAP32[(HEAP32[6065] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
 HEAP32[6086] = 25372;
 HEAP32[6087] = 25392;
 __THREW__ = 0;
 invoke_vii(62, 24344 + i2 | 0, i6 | 0);
 i6 = __THREW__;
 __THREW__ = 0;
 if (i6 & 1) {
  i6 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev(24348);
  ___resumeException(i6 | 0);
 } else {
  HEAP32[24344 + i1 >> 2] = 0;
  HEAP32[24344 + i5 >> 2] = -1;
  HEAP32[24088 + ((HEAP32[(HEAP32[6022] | 0) + -12 >> 2] | 0) + 72) >> 2] = 24176;
  i5 = 24260 + ((HEAP32[(HEAP32[6065] | 0) + -12 >> 2] | 0) + 4) | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 8192;
  HEAP32[24260 + ((HEAP32[(HEAP32[6065] | 0) + -12 >> 2] | 0) + 72) >> 2] = 24176;
  return;
 }
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 i6 = i1 + 304 | 0;
 i7 = i1 + 48 | 0;
 i8 = i1 + 32 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 8 | 0;
 i11 = i1;
 i12 = i1 + 308 | 0;
 i13 = i1 + 72 | 0;
 i14 = i1 + 76 | 0;
 i15 = i1 + 68 | 0;
 i16 = i1 + 64 | 0;
 i17 = i1 + 60 | 0;
 i18 = i1 + 56 | 0;
 i19 = i11;
 HEAP32[i19 >> 2] = 37;
 HEAP32[i19 + 4 >> 2] = 0;
 i19 = __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i11 + 1 | 0, 47562, HEAP32[i3 + 4 >> 2] | 0) | 0;
 HEAP32[i13 >> 2] = i12;
 i20 = __ZNSt3__16__clocEv() | 0;
 if (i19) {
  HEAP32[i10 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAPF64[i10 + 8 >> 3] = d5;
  i21 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i12, 30, i20, i11, i10) | 0;
 } else {
  HEAPF64[i9 >> 3] = d5;
  i21 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i12, 30, i20, i11, i9) | 0;
 }
 L5 : do if ((i21 | 0) > 29) {
  __THREW__ = 0;
  i9 = invoke_i(22) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  i10 = i20 & 1;
  if (i19) {
   if (!i10 ? (__THREW__ = 0, HEAP32[i8 >> 2] = HEAP32[i3 + 8 >> 2], HEAPF64[i8 + 8 >> 3] = d5, i20 = invoke_iiiii(10, i13 | 0, i9 | 0, i11 | 0, i8 | 0) | 0, i22 = __THREW__, __THREW__ = 0, !(i22 & 1)) : 0) {
    i23 = i20;
    i24 = 12;
   }
  } else if (!i10 ? (__THREW__ = 0, HEAPF64[i7 >> 3] = d5, i10 = invoke_iiiii(10, i13 | 0, i9 | 0, i11 | 0, i7 | 0) | 0, i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) {
   i23 = i10;
   i24 = 12;
  }
  do if ((i24 | 0) == 12) {
   i10 = HEAP32[i13 >> 2] | 0;
   if (!i10) {
    __THREW__ = 0;
    invoke_v(5);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) break;
    i25 = HEAP32[i13 >> 2] | 0;
   } else i25 = i10;
   i26 = i25;
   i27 = i25;
   i28 = i23;
   i24 = 16;
   break L5;
  } while (0);
  i10 = ___cxa_find_matching_catch() | 0;
  i29 = i10;
  i30 = tempRet0;
 } else {
  i26 = HEAP32[i13 >> 2] | 0;
  i27 = 0;
  i28 = i21;
  i24 = 16;
 } while (0);
 if ((i24 | 0) == 16) {
  i21 = i26 + i28 | 0;
  i23 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i26, i21, i3) | 0;
  do if ((i26 | 0) == (i12 | 0)) {
   i31 = i12;
   i32 = 0;
   i33 = i14;
   i24 = 22;
  } else {
   i25 = _malloc(i28 << 3) | 0;
   if (!i25) {
    __THREW__ = 0;
    invoke_v(5);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i34 = 0;
     i24 = 20;
     break;
    }
    i35 = HEAP32[i13 >> 2] | 0;
   } else i35 = i26;
   i31 = i35;
   i32 = i25;
   i33 = i25;
   i24 = 22;
  } while (0);
  do if ((i24 | 0) == 22) {
   __THREW__ = 0;
   i35 = invoke_ii(131, i3 | 0) | 0;
   i26 = __THREW__;
   __THREW__ = 0;
   if (!(i26 & 1)) {
    HEAP32[i17 >> 2] = i35;
    __THREW__ = 0;
    invoke_viiiiiii(4, i31 | 0, i23 | 0, i21 | 0, i33 | 0, i15 | 0, i16 | 0, i17 | 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i26 = ___cxa_find_matching_catch() | 0;
     i13 = tempRet0;
     __ZNSt3__114__shared_count16__release_sharedEv(i35) | 0;
     i36 = i26;
     i37 = i13;
     i38 = i32;
     break;
    }
    __ZNSt3__114__shared_count16__release_sharedEv(i35) | 0;
    HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
    i35 = HEAP32[i15 >> 2] | 0;
    i13 = HEAP32[i16 >> 2] | 0;
    __THREW__ = 0;
    HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
    i26 = invoke_iiiiiii(40, i6 | 0, i33 | 0, i35 | 0, i13 | 0, i3 | 0, i4 | 0) | 0;
    i13 = __THREW__;
    __THREW__ = 0;
    if (!(i13 & 1)) {
     HEAP32[i2 >> 2] = i26;
     if (i32) _free(i32);
     if (i27) _free(i27);
     STACKTOP = i1;
     return i26 | 0;
    } else {
     i34 = i32;
     i24 = 20;
    }
   } else {
    i34 = i32;
    i24 = 20;
   }
  } while (0);
  if ((i24 | 0) == 20) {
   i24 = ___cxa_find_matching_catch() | 0;
   i36 = i24;
   i37 = tempRet0;
   i38 = i34;
  }
  if (i38) _free(i38);
  if (!i27) {
   i29 = i36;
   i30 = i37;
  } else {
   _free(i27);
   i29 = i36;
   i30 = i37;
  }
 }
 ___resumeException(i29 | 0);
 return 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i6 = i1 + 76 | 0;
 i7 = i1 + 48 | 0;
 i8 = i1 + 32 | 0;
 i9 = i1 + 24 | 0;
 i10 = i1 + 8 | 0;
 i11 = i1;
 i12 = i1 + 80 | 0;
 i13 = i1 + 72 | 0;
 i14 = i1 + 110 | 0;
 i15 = i1 + 68 | 0;
 i16 = i1 + 64 | 0;
 i17 = i1 + 60 | 0;
 i18 = i1 + 56 | 0;
 i19 = i11;
 HEAP32[i19 >> 2] = 37;
 HEAP32[i19 + 4 >> 2] = 0;
 i19 = __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i11 + 1 | 0, 47562, HEAP32[i3 + 4 >> 2] | 0) | 0;
 HEAP32[i13 >> 2] = i12;
 i20 = __ZNSt3__16__clocEv() | 0;
 if (i19) {
  HEAP32[i10 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAPF64[i10 + 8 >> 3] = d5;
  i21 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i12, 30, i20, i11, i10) | 0;
 } else {
  HEAPF64[i9 >> 3] = d5;
  i21 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i12, 30, i20, i11, i9) | 0;
 }
 L5 : do if ((i21 | 0) > 29) {
  __THREW__ = 0;
  i9 = invoke_i(22) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  i10 = i20 & 1;
  if (i19) {
   if (!i10 ? (__THREW__ = 0, HEAP32[i8 >> 2] = HEAP32[i3 + 8 >> 2], HEAPF64[i8 + 8 >> 3] = d5, i20 = invoke_iiiii(10, i13 | 0, i9 | 0, i11 | 0, i8 | 0) | 0, i22 = __THREW__, __THREW__ = 0, !(i22 & 1)) : 0) {
    i23 = i20;
    i24 = 12;
   }
  } else if (!i10 ? (__THREW__ = 0, HEAPF64[i7 >> 3] = d5, i10 = invoke_iiiii(10, i13 | 0, i9 | 0, i11 | 0, i7 | 0) | 0, i9 = __THREW__, __THREW__ = 0, !(i9 & 1)) : 0) {
   i23 = i10;
   i24 = 12;
  }
  do if ((i24 | 0) == 12) {
   i10 = HEAP32[i13 >> 2] | 0;
   if (!i10) {
    __THREW__ = 0;
    invoke_v(5);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) break;
    i25 = HEAP32[i13 >> 2] | 0;
   } else i25 = i10;
   i26 = i25;
   i27 = i25;
   i28 = i23;
   i24 = 16;
   break L5;
  } while (0);
  i10 = ___cxa_find_matching_catch() | 0;
  i29 = i10;
  i30 = tempRet0;
 } else {
  i26 = HEAP32[i13 >> 2] | 0;
  i27 = 0;
  i28 = i21;
  i24 = 16;
 } while (0);
 if ((i24 | 0) == 16) {
  i21 = i26 + i28 | 0;
  i23 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i26, i21, i3) | 0;
  do if ((i26 | 0) == (i12 | 0)) {
   i31 = i12;
   i32 = 0;
   i33 = i14;
   i24 = 22;
  } else {
   i25 = _malloc(i28 << 1) | 0;
   if (!i25) {
    __THREW__ = 0;
    invoke_v(5);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i34 = 0;
     i24 = 20;
     break;
    }
    i35 = HEAP32[i13 >> 2] | 0;
   } else i35 = i26;
   i31 = i35;
   i32 = i25;
   i33 = i25;
   i24 = 22;
  } while (0);
  do if ((i24 | 0) == 22) {
   __THREW__ = 0;
   i35 = invoke_ii(131, i3 | 0) | 0;
   i26 = __THREW__;
   __THREW__ = 0;
   if (!(i26 & 1)) {
    HEAP32[i17 >> 2] = i35;
    __THREW__ = 0;
    invoke_viiiiiii(2, i31 | 0, i23 | 0, i21 | 0, i33 | 0, i15 | 0, i16 | 0, i17 | 0);
    i26 = __THREW__;
    __THREW__ = 0;
    if (i26 & 1) {
     i26 = ___cxa_find_matching_catch() | 0;
     i13 = tempRet0;
     __ZNSt3__114__shared_count16__release_sharedEv(i35) | 0;
     i36 = i26;
     i37 = i13;
     i38 = i32;
     break;
    }
    __ZNSt3__114__shared_count16__release_sharedEv(i35) | 0;
    HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
    i35 = HEAP32[i15 >> 2] | 0;
    i13 = HEAP32[i16 >> 2] | 0;
    __THREW__ = 0;
    HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
    i26 = invoke_iiiiiii(39, i6 | 0, i33 | 0, i35 | 0, i13 | 0, i3 | 0, i4 | 0) | 0;
    i13 = __THREW__;
    __THREW__ = 0;
    if (!(i13 & 1)) {
     HEAP32[i2 >> 2] = i26;
     if (i32) _free(i32);
     if (i27) _free(i27);
     STACKTOP = i1;
     return i26 | 0;
    } else {
     i34 = i32;
     i24 = 20;
    }
   } else {
    i34 = i32;
    i24 = 20;
   }
  } while (0);
  if ((i24 | 0) == 20) {
   i24 = ___cxa_find_matching_catch() | 0;
   i36 = i24;
   i37 = tempRet0;
   i38 = i34;
  }
  if (i38) _free(i38);
  if (!i27) {
   i29 = i36;
   i30 = i37;
  } else {
   _free(i27);
   i29 = i36;
   i30 = i37;
  }
 }
 ___resumeException(i29 | 0);
 return 0;
}

function __ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i6 = i2;
 if ((((i5 & 4 | 0) != 0 ? (i6 - i1 | 0) > 2 : 0) ? (HEAP8[i1 >> 0] | 0) == -17 : 0) ? (HEAP8[i1 + 1 >> 0] | 0) == -69 : 0) i7 = (HEAP8[i1 + 2 >> 0] | 0) == -65 ? i1 + 3 | 0 : i1; else i7 = i1;
 L7 : do if ((i3 | 0) != 0 & i7 >>> 0 < i2 >>> 0) {
  i5 = i7;
  i8 = 0;
  L8 : while (1) {
   i9 = HEAP8[i5 >> 0] | 0;
   i10 = i9 & 255;
   if (i10 >>> 0 > i4 >>> 0) {
    i11 = i5;
    i12 = 42;
    break L7;
   }
   do if (i9 << 24 >> 24 > -1) {
    i13 = i5 + 1 | 0;
    i14 = i8;
   } else {
    if ((i9 & 255) < 194) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    if ((i9 & 255) < 224) {
     if ((i6 - i5 | 0) < 2) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     i15 = HEAPU8[i5 + 1 >> 0] | 0;
     if ((i15 & 192 | 0) != 128) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     if ((i15 & 63 | i10 << 6 & 1984) >>> 0 > i4 >>> 0) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     i13 = i5 + 2 | 0;
     i14 = i8;
     break;
    }
    if ((i9 & 255) < 240) {
     i15 = i5;
     if ((i6 - i15 | 0) < 3) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     i16 = HEAP8[i5 + 1 >> 0] | 0;
     i17 = HEAP8[i5 + 2 >> 0] | 0;
     switch (i10 | 0) {
     case 224:
      {
       if ((i16 & -32) << 24 >> 24 != -96) {
        i18 = i15;
        i12 = 20;
        break L8;
       }
       break;
      }
     case 237:
      {
       if ((i16 & -32) << 24 >> 24 != -128) {
        i19 = i15;
        i12 = 22;
        break L8;
       }
       break;
      }
     default:
      if ((i16 & -64) << 24 >> 24 != -128) {
       i20 = i15;
       i12 = 24;
       break L8;
      }
     }
     i15 = i17 & 255;
     if ((i15 & 192 | 0) != 128) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     if (((i16 & 255) << 6 & 4032 | i10 << 12 & 61440 | i15 & 63) >>> 0 > i4 >>> 0) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     i13 = i5 + 3 | 0;
     i14 = i8;
     break;
    }
    if ((i9 & 255) >= 245) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    i15 = i5;
    if ((i3 - i8 | 0) >>> 0 < 2 | (i6 - i15 | 0) < 4) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    i16 = HEAP8[i5 + 1 >> 0] | 0;
    i17 = HEAP8[i5 + 2 >> 0] | 0;
    i21 = HEAP8[i5 + 3 >> 0] | 0;
    switch (i10 | 0) {
    case 240:
     {
      if ((i16 + 112 & 255) >= 48) {
       i22 = i15;
       i12 = 32;
       break L8;
      }
      break;
     }
    case 244:
     {
      if ((i16 & -16) << 24 >> 24 != -128) {
       i23 = i15;
       i12 = 34;
       break L8;
      }
      break;
     }
    default:
     if ((i16 & -64) << 24 >> 24 != -128) {
      i24 = i15;
      i12 = 36;
      break L8;
     }
    }
    i15 = i17 & 255;
    if ((i15 & 192 | 0) != 128) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    i17 = i21 & 255;
    if ((i17 & 192 | 0) != 128) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    if (((i16 & 255) << 12 & 258048 | i10 << 18 & 1835008 | i15 << 6 & 4032 | i17 & 63) >>> 0 > i4 >>> 0) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    i13 = i5 + 4 | 0;
    i14 = i8 + 1 | 0;
   } while (0);
   i8 = i14 + 1 | 0;
   if (!(i8 >>> 0 < i3 >>> 0 & i13 >>> 0 < i2 >>> 0)) {
    i11 = i13;
    i12 = 42;
    break L7;
   } else i5 = i13;
  }
  if ((i12 | 0) == 20) {
   i25 = i18 - i1 | 0;
   break;
  } else if ((i12 | 0) == 22) {
   i25 = i19 - i1 | 0;
   break;
  } else if ((i12 | 0) == 24) {
   i25 = i20 - i1 | 0;
   break;
  } else if ((i12 | 0) == 32) {
   i25 = i22 - i1 | 0;
   break;
  } else if ((i12 | 0) == 34) {
   i25 = i23 - i1 | 0;
   break;
  } else if ((i12 | 0) == 36) {
   i25 = i24 - i1 | 0;
   break;
  }
 } else {
  i11 = i7;
  i12 = 42;
 } while (0);
 if ((i12 | 0) == 42) i25 = i11 - i1 | 0;
 return i25 | 0;
}

function __ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i6 >> 2] = i4;
 if (i8 & 4) {
  i8 = HEAP32[i3 >> 2] | 0;
  i1 = i2;
  if ((((i1 - i8 | 0) > 2 ? (HEAP8[i8 >> 0] | 0) == -17 : 0) ? (HEAP8[i8 + 1 >> 0] | 0) == -69 : 0) ? (HEAP8[i8 + 2 >> 0] | 0) == -65 : 0) {
   HEAP32[i3 >> 2] = i8 + 3;
   i9 = HEAP32[i6 >> 2] | 0;
   i10 = i1;
  } else {
   i9 = i4;
   i10 = i1;
  }
 } else {
  i9 = i4;
  i10 = i2;
 }
 i4 = i5;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = i1 >>> 0 < i2 >>> 0;
 L9 : do if (i8 & i9 >>> 0 < i5 >>> 0) {
  i11 = i1;
  i12 = i9;
  while (1) {
   i13 = HEAP8[i11 >> 0] | 0;
   i14 = i13 & 255;
   if (i14 >>> 0 > i7 >>> 0) {
    i15 = 2;
    break L9;
   }
   do if (i13 << 24 >> 24 > -1) {
    HEAP16[i12 >> 1] = i13 & 255;
    HEAP32[i3 >> 2] = i11 + 1;
   } else {
    if ((i13 & 255) < 194) {
     i15 = 2;
     break L9;
    }
    if ((i13 & 255) < 224) {
     if ((i10 - i11 | 0) < 2) {
      i15 = 1;
      break L9;
     }
     i16 = HEAPU8[i11 + 1 >> 0] | 0;
     if ((i16 & 192 | 0) != 128) {
      i15 = 2;
      break L9;
     }
     i17 = i16 & 63 | i14 << 6 & 1984;
     if (i17 >>> 0 > i7 >>> 0) {
      i15 = 2;
      break L9;
     }
     HEAP16[i12 >> 1] = i17;
     HEAP32[i3 >> 2] = i11 + 2;
     break;
    }
    if ((i13 & 255) < 240) {
     if ((i10 - i11 | 0) < 3) {
      i15 = 1;
      break L9;
     }
     i17 = HEAP8[i11 + 1 >> 0] | 0;
     i16 = HEAP8[i11 + 2 >> 0] | 0;
     switch (i14 | 0) {
     case 224:
      {
       if ((i17 & -32) << 24 >> 24 != -96) {
        i15 = 2;
        break L9;
       }
       break;
      }
     case 237:
      {
       if ((i17 & -32) << 24 >> 24 != -128) {
        i15 = 2;
        break L9;
       }
       break;
      }
     default:
      if ((i17 & -64) << 24 >> 24 != -128) {
       i15 = 2;
       break L9;
      }
     }
     i18 = i16 & 255;
     if ((i18 & 192 | 0) != 128) {
      i15 = 2;
      break L9;
     }
     i16 = (i17 & 255) << 6 & 4032 | i14 << 12 | i18 & 63;
     if ((i16 & 65535) >>> 0 > i7 >>> 0) {
      i15 = 2;
      break L9;
     }
     HEAP16[i12 >> 1] = i16;
     HEAP32[i3 >> 2] = i11 + 3;
     break;
    }
    if ((i13 & 255) >= 245) {
     i15 = 2;
     break L9;
    }
    if ((i10 - i11 | 0) < 4) {
     i15 = 1;
     break L9;
    }
    i16 = HEAP8[i11 + 1 >> 0] | 0;
    i18 = HEAP8[i11 + 2 >> 0] | 0;
    i17 = HEAP8[i11 + 3 >> 0] | 0;
    switch (i14 | 0) {
    case 240:
     {
      if ((i16 + 112 & 255) >= 48) {
       i15 = 2;
       break L9;
      }
      break;
     }
    case 244:
     {
      if ((i16 & -16) << 24 >> 24 != -128) {
       i15 = 2;
       break L9;
      }
      break;
     }
    default:
     if ((i16 & -64) << 24 >> 24 != -128) {
      i15 = 2;
      break L9;
     }
    }
    i19 = i18 & 255;
    if ((i19 & 192 | 0) != 128) {
     i15 = 2;
     break L9;
    }
    i18 = i17 & 255;
    if ((i18 & 192 | 0) != 128) {
     i15 = 2;
     break L9;
    }
    if ((i4 - i12 | 0) < 4) {
     i15 = 1;
     break L9;
    }
    i17 = i14 & 7;
    i20 = i16 & 255;
    i16 = i19 << 6;
    i21 = i18 & 63;
    if ((i20 << 12 & 258048 | i17 << 18 | i16 & 4032 | i21) >>> 0 > i7 >>> 0) {
     i15 = 2;
     break L9;
    }
    HEAP16[i12 >> 1] = i20 << 2 & 60 | i19 >>> 4 & 3 | ((i20 >>> 4 & 3 | i17 << 2) << 6) + 16320 | 55296;
    i17 = i12 + 2 | 0;
    HEAP32[i6 >> 2] = i17;
    HEAP16[i17 >> 1] = i21 | i16 & 960 | 56320;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 4;
   } while (0);
   i12 = (HEAP32[i6 >> 2] | 0) + 2 | 0;
   HEAP32[i6 >> 2] = i12;
   i11 = HEAP32[i3 >> 2] | 0;
   i14 = i11 >>> 0 < i2 >>> 0;
   if (!(i14 & i12 >>> 0 < i5 >>> 0)) {
    i22 = i14;
    i23 = 39;
    break;
   }
  }
 } else {
  i22 = i8;
  i23 = 39;
 } while (0);
 if ((i23 | 0) == 39) i15 = i22 & 1;
 return i15 | 0;
}
function __ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i6 = i2;
 if ((((i5 & 4 | 0) != 0 ? (i6 - i1 | 0) > 2 : 0) ? (HEAP8[i1 >> 0] | 0) == -17 : 0) ? (HEAP8[i1 + 1 >> 0] | 0) == -69 : 0) i7 = (HEAP8[i1 + 2 >> 0] | 0) == -65 ? i1 + 3 | 0 : i1; else i7 = i1;
 L7 : do if ((i3 | 0) != 0 & i7 >>> 0 < i2 >>> 0) {
  i5 = i7;
  i8 = 0;
  L8 : while (1) {
   i9 = HEAP8[i5 >> 0] | 0;
   i10 = i9 & 255;
   do if (i9 << 24 >> 24 > -1) {
    if (i10 >>> 0 > i4 >>> 0) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    i13 = i5 + 1 | 0;
   } else {
    if ((i9 & 255) < 194) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    if ((i9 & 255) < 224) {
     if ((i6 - i5 | 0) < 2) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     i14 = HEAPU8[i5 + 1 >> 0] | 0;
     if ((i14 & 192 | 0) != 128) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     if ((i14 & 63 | i10 << 6 & 1984) >>> 0 > i4 >>> 0) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     i13 = i5 + 2 | 0;
     break;
    }
    if ((i9 & 255) < 240) {
     i14 = i5;
     if ((i6 - i14 | 0) < 3) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     i15 = HEAP8[i5 + 1 >> 0] | 0;
     i16 = HEAP8[i5 + 2 >> 0] | 0;
     switch (i10 | 0) {
     case 224:
      {
       if ((i15 & -32) << 24 >> 24 != -96) {
        i17 = i14;
        i12 = 20;
        break L8;
       }
       break;
      }
     case 237:
      {
       if ((i15 & -32) << 24 >> 24 != -128) {
        i18 = i14;
        i12 = 22;
        break L8;
       }
       break;
      }
     default:
      if ((i15 & -64) << 24 >> 24 != -128) {
       i19 = i14;
       i12 = 24;
       break L8;
      }
     }
     i14 = i16 & 255;
     if ((i14 & 192 | 0) != 128) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     if (((i15 & 255) << 6 & 4032 | i10 << 12 & 61440 | i14 & 63) >>> 0 > i4 >>> 0) {
      i11 = i5;
      i12 = 42;
      break L7;
     }
     i13 = i5 + 3 | 0;
     break;
    }
    if ((i9 & 255) >= 245) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    i14 = i5;
    if ((i6 - i14 | 0) < 4) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    i15 = HEAP8[i5 + 1 >> 0] | 0;
    i16 = HEAP8[i5 + 2 >> 0] | 0;
    i20 = HEAP8[i5 + 3 >> 0] | 0;
    switch (i10 | 0) {
    case 240:
     {
      if ((i15 + 112 & 255) >= 48) {
       i21 = i14;
       i12 = 32;
       break L8;
      }
      break;
     }
    case 244:
     {
      if ((i15 & -16) << 24 >> 24 != -128) {
       i22 = i14;
       i12 = 34;
       break L8;
      }
      break;
     }
    default:
     if ((i15 & -64) << 24 >> 24 != -128) {
      i23 = i14;
      i12 = 36;
      break L8;
     }
    }
    i14 = i16 & 255;
    if ((i14 & 192 | 0) != 128) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    i16 = i20 & 255;
    if ((i16 & 192 | 0) != 128) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    if (((i15 & 255) << 12 & 258048 | i10 << 18 & 1835008 | i14 << 6 & 4032 | i16 & 63) >>> 0 > i4 >>> 0) {
     i11 = i5;
     i12 = 42;
     break L7;
    }
    i13 = i5 + 4 | 0;
   } while (0);
   i8 = i8 + 1 | 0;
   if (!(i8 >>> 0 < i3 >>> 0 & i13 >>> 0 < i2 >>> 0)) {
    i11 = i13;
    i12 = 42;
    break L7;
   } else i5 = i13;
  }
  if ((i12 | 0) == 20) {
   i24 = i17 - i1 | 0;
   break;
  } else if ((i12 | 0) == 22) {
   i24 = i18 - i1 | 0;
   break;
  } else if ((i12 | 0) == 24) {
   i24 = i19 - i1 | 0;
   break;
  } else if ((i12 | 0) == 32) {
   i24 = i21 - i1 | 0;
   break;
  } else if ((i12 | 0) == 34) {
   i24 = i22 - i1 | 0;
   break;
  } else if ((i12 | 0) == 36) {
   i24 = i23 - i1 | 0;
   break;
  }
 } else {
  i11 = i7;
  i12 = 42;
 } while (0);
 if ((i12 | 0) == 42) i24 = i11 - i1 | 0;
 return i24 | 0;
}

function __ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 L1 : do if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
  if ((HEAP32[i2 + 4 >> 2] | 0) == (i3 | 0) ? (i6 = i2 + 28 | 0, (HEAP32[i6 >> 2] | 0) != 1) : 0) HEAP32[i6 >> 2] = i4;
 } else {
  if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) {
   i6 = HEAP32[i1 + 12 >> 2] | 0;
   i7 = i1 + 16 + (i6 << 3) | 0;
   __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i1 + 16 | 0, i2, i3, i4, i5);
   i8 = i1 + 24 | 0;
   if ((i6 | 0) <= 1) break;
   i6 = HEAP32[i1 + 8 >> 2] | 0;
   if ((i6 & 2 | 0) == 0 ? (i9 = i2 + 36 | 0, (HEAP32[i9 >> 2] | 0) != 1) : 0) {
    if (!(i6 & 1)) {
     i6 = i2 + 54 | 0;
     i10 = i8;
     while (1) {
      if (HEAP8[i6 >> 0] | 0) break L1;
      if ((HEAP32[i9 >> 2] | 0) == 1) break L1;
      __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i10, i2, i3, i4, i5);
      i10 = i10 + 8 | 0;
      if (i10 >>> 0 >= i7 >>> 0) break L1;
     }
    }
    i10 = i2 + 24 | 0;
    i6 = i2 + 54 | 0;
    i11 = i8;
    while (1) {
     if (HEAP8[i6 >> 0] | 0) break L1;
     if ((HEAP32[i9 >> 2] | 0) == 1 ? (HEAP32[i10 >> 2] | 0) == 1 : 0) break L1;
     __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i11, i2, i3, i4, i5);
     i11 = i11 + 8 | 0;
     if (i11 >>> 0 >= i7 >>> 0) break L1;
    }
   }
   i11 = i2 + 54 | 0;
   i10 = i8;
   while (1) {
    if (HEAP8[i11 >> 0] | 0) break L1;
    __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i10, i2, i3, i4, i5);
    i10 = i10 + 8 | 0;
    if (i10 >>> 0 >= i7 >>> 0) break L1;
   }
  }
  if ((HEAP32[i2 + 16 >> 2] | 0) != (i3 | 0) ? (i7 = i2 + 20 | 0, (HEAP32[i7 >> 2] | 0) != (i3 | 0)) : 0) {
   HEAP32[i2 + 32 >> 2] = i4;
   i10 = i2 + 44 | 0;
   if ((HEAP32[i10 >> 2] | 0) == 4) break;
   i11 = HEAP32[i1 + 12 >> 2] | 0;
   i8 = i1 + 16 + (i11 << 3) | 0;
   i9 = i2 + 52 | 0;
   i6 = i2 + 53 | 0;
   i12 = i2 + 54 | 0;
   i13 = i1 + 8 | 0;
   i14 = i2 + 24 | 0;
   L34 : do if ((i11 | 0) > 0) {
    i15 = 0;
    i16 = 0;
    i17 = i1 + 16 | 0;
    while (1) {
     HEAP8[i9 >> 0] = 0;
     HEAP8[i6 >> 0] = 0;
     __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i17, i2, i3, i3, 1, i5);
     if (HEAP8[i12 >> 0] | 0) {
      i18 = i15;
      i19 = i16;
      i20 = 20;
      break L34;
     }
     do if (HEAP8[i6 >> 0] | 0) {
      if (!(HEAP8[i9 >> 0] | 0)) if (!(HEAP32[i13 >> 2] & 1)) {
       i18 = i15;
       i19 = 1;
       i20 = 20;
       break L34;
      } else {
       i21 = i15;
       i22 = 1;
       break;
      }
      if ((HEAP32[i14 >> 2] | 0) == 1) break L34;
      if (!(HEAP32[i13 >> 2] & 2)) break L34; else {
       i21 = 1;
       i22 = 1;
      }
     } else {
      i21 = i15;
      i22 = i16;
     } while (0);
     i17 = i17 + 8 | 0;
     if (i17 >>> 0 >= i8 >>> 0) {
      i18 = i21;
      i19 = i22;
      i20 = 20;
      break;
     } else {
      i15 = i21;
      i16 = i22;
     }
    }
   } else {
    i18 = 0;
    i19 = 0;
    i20 = 20;
   } while (0);
   do if ((i20 | 0) == 20) {
    if ((!i18 ? (HEAP32[i7 >> 2] = i3, i8 = i2 + 40 | 0, HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1, (HEAP32[i2 + 36 >> 2] | 0) == 1) : 0) ? (HEAP32[i14 >> 2] | 0) == 2 : 0) {
     HEAP8[i12 >> 0] = 1;
     if (i19) break;
    } else i20 = 24;
    if ((i20 | 0) == 24 ? i19 : 0) break;
    HEAP32[i10 >> 2] = 4;
    break L1;
   } while (0);
   HEAP32[i10 >> 2] = 3;
   break;
  }
  if ((i4 | 0) == 1) HEAP32[i2 + 32 >> 2] = 1;
 } while (0);
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i8 = i7 + 56 | 0;
 i9 = i7 + 52 | 0;
 i10 = i7 + 48 | 0;
 i11 = i7 + 44 | 0;
 i12 = i7 + 40 | 0;
 i13 = i7 + 36 | 0;
 i14 = i7 + 32 | 0;
 i15 = i7 + 8 | 0;
 i16 = i7;
 L1 : do if (!(HEAP32[i4 + 4 >> 2] & 1)) {
  HEAP32[i10 >> 2] = -1;
  i17 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  i18 = FUNCTION_TABLE_iiiiiii[i17 & 63](i1, i9, i8, i4, i5, i10) | 0;
  HEAP32[i2 >> 2] = i18;
  switch (HEAP32[i10 >> 2] | 0) {
  case 0:
   {
    HEAP8[i6 >> 0] = 0;
    i19 = i18;
    break L1;
    break;
   }
  case 1:
   {
    HEAP8[i6 >> 0] = 1;
    i19 = i18;
    break L1;
    break;
   }
  default:
   {
    HEAP8[i6 >> 0] = 1;
    HEAP32[i5 >> 2] = 4;
    i19 = i18;
    break L1;
   }
  }
 } else {
  i18 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
  HEAP32[i13 >> 2] = i18;
  __THREW__ = 0;
  i17 = invoke_iii(55, i13 | 0, 26572) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  do if (!(i20 & 1)) {
   __ZNSt3__114__shared_count16__release_sharedEv(i18) | 0;
   i21 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
   HEAP32[i14 >> 2] = i21;
   __THREW__ = 0;
   i22 = invoke_iii(55, i14 | 0, 26728) | 0;
   i23 = __THREW__;
   __THREW__ = 0;
   if (i23 & 1) {
    i23 = ___cxa_find_matching_catch() | 0;
    i24 = tempRet0;
    __ZNSt3__114__shared_count16__release_sharedEv(i21) | 0;
    i25 = i23;
    i26 = i24;
    break;
   }
   __ZNSt3__114__shared_count16__release_sharedEv(i21) | 0;
   __THREW__ = 0;
   invoke_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] | 0, i15 | 0, i22 | 0);
   i21 = __THREW__;
   __THREW__ = 0;
   if (!(i21 & 1)) {
    i21 = i15 + 12 | 0;
    __THREW__ = 0;
    invoke_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i21 | 0, i22 | 0);
    i22 = __THREW__;
    __THREW__ = 0;
    if (!(i22 & 1)) {
     HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
     __THREW__ = 0;
     HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
     i22 = invoke_iiiiiiii(8, i2 | 0, i8 | 0, i15 | 0, i15 + 24 | 0, i17 | 0, i5 | 0, 1) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i24 = ___cxa_find_matching_catch() | 0;
      i23 = tempRet0;
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i15 + 12 | 0);
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i15);
      i25 = i24;
      i26 = i23;
      break;
     } else {
      HEAP8[i6 >> 0] = (i22 | 0) == (i15 | 0) & 1;
      i22 = HEAP32[i2 >> 2] | 0;
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i15 + 12 | 0);
      __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i15);
      i19 = i22;
      break L1;
     }
    } else i27 = i21;
   } else i27 = i15;
   i21 = ___cxa_find_matching_catch() | 0;
   i22 = tempRet0;
   if ((i15 | 0) == (i27 | 0)) {
    i25 = i21;
    i26 = i22;
   } else {
    i23 = i27;
    do {
     i23 = i23 + -12 | 0;
     __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i23);
    } while ((i23 | 0) != (i15 | 0));
    i25 = i21;
    i26 = i22;
   }
  } else {
   i22 = ___cxa_find_matching_catch() | 0;
   i21 = tempRet0;
   __ZNSt3__114__shared_count16__release_sharedEv(i18) | 0;
   i25 = i22;
   i26 = i21;
  } while (0);
  ___resumeException(i25 | 0);
 } while (0);
 STACKTOP = i7;
 return i19 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i8 = i7 + 56 | 0;
 i9 = i7 + 52 | 0;
 i10 = i7 + 48 | 0;
 i11 = i7 + 44 | 0;
 i12 = i7 + 40 | 0;
 i13 = i7 + 36 | 0;
 i14 = i7 + 32 | 0;
 i15 = i7 + 8 | 0;
 i16 = i7;
 L1 : do if (!(HEAP32[i4 + 4 >> 2] & 1)) {
  HEAP32[i10 >> 2] = -1;
  i17 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  i18 = FUNCTION_TABLE_iiiiiii[i17 & 63](i1, i9, i8, i4, i5, i10) | 0;
  HEAP32[i2 >> 2] = i18;
  switch (HEAP32[i10 >> 2] | 0) {
  case 0:
   {
    HEAP8[i6 >> 0] = 0;
    i19 = i18;
    break L1;
    break;
   }
  case 1:
   {
    HEAP8[i6 >> 0] = 1;
    i19 = i18;
    break L1;
    break;
   }
  default:
   {
    HEAP8[i6 >> 0] = 1;
    HEAP32[i5 >> 2] = 4;
    i19 = i18;
    break L1;
   }
  }
 } else {
  i18 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
  HEAP32[i13 >> 2] = i18;
  __THREW__ = 0;
  i17 = invoke_iii(55, i13 | 0, 26580) | 0;
  i20 = __THREW__;
  __THREW__ = 0;
  do if (!(i20 & 1)) {
   __ZNSt3__114__shared_count16__release_sharedEv(i18) | 0;
   i21 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
   HEAP32[i14 >> 2] = i21;
   __THREW__ = 0;
   i22 = invoke_iii(55, i14 | 0, 26720) | 0;
   i23 = __THREW__;
   __THREW__ = 0;
   if (i23 & 1) {
    i23 = ___cxa_find_matching_catch() | 0;
    i24 = tempRet0;
    __ZNSt3__114__shared_count16__release_sharedEv(i21) | 0;
    i25 = i23;
    i26 = i24;
    break;
   }
   __ZNSt3__114__shared_count16__release_sharedEv(i21) | 0;
   __THREW__ = 0;
   invoke_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] | 0, i15 | 0, i22 | 0);
   i21 = __THREW__;
   __THREW__ = 0;
   if (!(i21 & 1)) {
    i21 = i15 + 12 | 0;
    __THREW__ = 0;
    invoke_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i21 | 0, i22 | 0);
    i22 = __THREW__;
    __THREW__ = 0;
    if (!(i22 & 1)) {
     HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
     __THREW__ = 0;
     HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
     i22 = invoke_iiiiiiii(7, i2 | 0, i8 | 0, i15 | 0, i15 + 24 | 0, i17 | 0, i5 | 0, 1) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i24 = ___cxa_find_matching_catch() | 0;
      i23 = tempRet0;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15 + 12 | 0);
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
      i25 = i24;
      i26 = i23;
      break;
     } else {
      HEAP8[i6 >> 0] = (i22 | 0) == (i15 | 0) & 1;
      i22 = HEAP32[i2 >> 2] | 0;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15 + 12 | 0);
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
      i19 = i22;
      break L1;
     }
    } else i27 = i21;
   } else i27 = i15;
   i21 = ___cxa_find_matching_catch() | 0;
   i22 = tempRet0;
   if ((i15 | 0) == (i27 | 0)) {
    i25 = i21;
    i26 = i22;
   } else {
    i23 = i27;
    do {
     i23 = i23 + -12 | 0;
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    } while ((i23 | 0) != (i15 | 0));
    i25 = i21;
    i26 = i22;
   }
  } else {
   i22 = ___cxa_find_matching_catch() | 0;
   i21 = tempRet0;
   __ZNSt3__114__shared_count16__release_sharedEv(i18) | 0;
   i25 = i22;
   i26 = i21;
  } while (0);
  ___resumeException(i25 | 0);
 } while (0);
 STACKTOP = i7;
 return i19 | 0;
}

function __ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i6 >> 2] = i4;
 if (i8 & 4) {
  i8 = HEAP32[i3 >> 2] | 0;
  i1 = i2;
  if ((((i1 - i8 | 0) > 2 ? (HEAP8[i8 >> 0] | 0) == -17 : 0) ? (HEAP8[i8 + 1 >> 0] | 0) == -69 : 0) ? (HEAP8[i8 + 2 >> 0] | 0) == -65 : 0) {
   HEAP32[i3 >> 2] = i8 + 3;
   i9 = HEAP32[i6 >> 2] | 0;
   i10 = i1;
  } else {
   i9 = i4;
   i10 = i1;
  }
 } else {
  i9 = i4;
  i10 = i2;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i4 >>> 0 < i2 >>> 0;
 L9 : do if (i1 & i9 >>> 0 < i5 >>> 0) {
  i8 = i4;
  i11 = i9;
  while (1) {
   i12 = HEAP8[i8 >> 0] | 0;
   i13 = i12 & 255;
   do if (i12 << 24 >> 24 > -1) {
    if (i13 >>> 0 > i7 >>> 0) {
     i14 = 2;
     break L9;
    }
    HEAP32[i11 >> 2] = i13;
    HEAP32[i3 >> 2] = i8 + 1;
   } else {
    if ((i12 & 255) < 194) {
     i14 = 2;
     break L9;
    }
    if ((i12 & 255) < 224) {
     if ((i10 - i8 | 0) < 2) {
      i14 = 1;
      break L9;
     }
     i15 = HEAPU8[i8 + 1 >> 0] | 0;
     if ((i15 & 192 | 0) != 128) {
      i14 = 2;
      break L9;
     }
     i16 = i15 & 63 | i13 << 6 & 1984;
     if (i16 >>> 0 > i7 >>> 0) {
      i14 = 2;
      break L9;
     }
     HEAP32[i11 >> 2] = i16;
     HEAP32[i3 >> 2] = i8 + 2;
     break;
    }
    if ((i12 & 255) < 240) {
     if ((i10 - i8 | 0) < 3) {
      i14 = 1;
      break L9;
     }
     i16 = HEAP8[i8 + 1 >> 0] | 0;
     i15 = HEAP8[i8 + 2 >> 0] | 0;
     switch (i13 | 0) {
     case 224:
      {
       if ((i16 & -32) << 24 >> 24 != -96) {
        i14 = 2;
        break L9;
       }
       break;
      }
     case 237:
      {
       if ((i16 & -32) << 24 >> 24 != -128) {
        i14 = 2;
        break L9;
       }
       break;
      }
     default:
      if ((i16 & -64) << 24 >> 24 != -128) {
       i14 = 2;
       break L9;
      }
     }
     i17 = i15 & 255;
     if ((i17 & 192 | 0) != 128) {
      i14 = 2;
      break L9;
     }
     i15 = (i16 & 255) << 6 & 4032 | i13 << 12 & 61440 | i17 & 63;
     if (i15 >>> 0 > i7 >>> 0) {
      i14 = 2;
      break L9;
     }
     HEAP32[i11 >> 2] = i15;
     HEAP32[i3 >> 2] = i8 + 3;
     break;
    }
    if ((i12 & 255) >= 245) {
     i14 = 2;
     break L9;
    }
    if ((i10 - i8 | 0) < 4) {
     i14 = 1;
     break L9;
    }
    i15 = HEAP8[i8 + 1 >> 0] | 0;
    i17 = HEAP8[i8 + 2 >> 0] | 0;
    i16 = HEAP8[i8 + 3 >> 0] | 0;
    switch (i13 | 0) {
    case 240:
     {
      if ((i15 + 112 & 255) >= 48) {
       i14 = 2;
       break L9;
      }
      break;
     }
    case 244:
     {
      if ((i15 & -16) << 24 >> 24 != -128) {
       i14 = 2;
       break L9;
      }
      break;
     }
    default:
     if ((i15 & -64) << 24 >> 24 != -128) {
      i14 = 2;
      break L9;
     }
    }
    i18 = i17 & 255;
    if ((i18 & 192 | 0) != 128) {
     i14 = 2;
     break L9;
    }
    i17 = i16 & 255;
    if ((i17 & 192 | 0) != 128) {
     i14 = 2;
     break L9;
    }
    i16 = (i15 & 255) << 12 & 258048 | i13 << 18 & 1835008 | i18 << 6 & 4032 | i17 & 63;
    if (i16 >>> 0 > i7 >>> 0) {
     i14 = 2;
     break L9;
    }
    HEAP32[i11 >> 2] = i16;
    HEAP32[i3 >> 2] = i8 + 4;
   } while (0);
   i11 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
   HEAP32[i6 >> 2] = i11;
   i8 = HEAP32[i3 >> 2] | 0;
   i13 = i8 >>> 0 < i2 >>> 0;
   if (!(i13 & i11 >>> 0 < i5 >>> 0)) {
    i19 = i13;
    i20 = 38;
    break;
   }
  }
 } else {
  i19 = i1;
  i20 = 38;
 } while (0);
 if ((i20 | 0) == 38) i14 = i19 & 1;
 return i14 | 0;
}

function __ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i6 >> 2] = i4;
 i1 = i5;
 if (i8 & 2) if ((i1 - i4 | 0) < 3) i9 = 1; else {
  HEAP32[i6 >> 2] = i4 + 1;
  HEAP8[i4 >> 0] = -17;
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + 1;
  HEAP8[i4 >> 0] = -69;
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + 1;
  HEAP8[i4 >> 0] = -65;
  i10 = 4;
 } else i10 = 4;
 L4 : do if ((i10 | 0) == 4) {
  i4 = i2;
  i8 = HEAP32[i3 >> 2] | 0;
  if (i8 >>> 0 < i2 >>> 0) {
   i5 = i8;
   while (1) {
    i8 = HEAP16[i5 >> 1] | 0;
    i11 = i8 & 65535;
    if (i11 >>> 0 > i7 >>> 0) {
     i9 = 2;
     break L4;
    }
    do if ((i8 & 65535) < 128) {
     i12 = HEAP32[i6 >> 2] | 0;
     if ((i1 - i12 | 0) < 1) {
      i9 = 1;
      break L4;
     }
     HEAP32[i6 >> 2] = i12 + 1;
     HEAP8[i12 >> 0] = i8;
    } else {
     if ((i8 & 65535) < 2048) {
      i12 = HEAP32[i6 >> 2] | 0;
      if ((i1 - i12 | 0) < 2) {
       i9 = 1;
       break L4;
      }
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i11 >>> 6 | 192;
      i12 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i11 & 63 | 128;
      break;
     }
     if ((i8 & 65535) < 55296) {
      i12 = HEAP32[i6 >> 2] | 0;
      if ((i1 - i12 | 0) < 3) {
       i9 = 1;
       break L4;
      }
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i11 >>> 12 | 224;
      i12 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i11 >>> 6 & 63 | 128;
      i12 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i11 & 63 | 128;
      break;
     }
     if ((i8 & 65535) >= 56320) {
      if ((i8 & 65535) < 57344) {
       i9 = 2;
       break L4;
      }
      i12 = HEAP32[i6 >> 2] | 0;
      if ((i1 - i12 | 0) < 3) {
       i9 = 1;
       break L4;
      }
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i11 >>> 12 | 224;
      i12 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i11 >>> 6 & 63 | 128;
      i12 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i11 & 63 | 128;
      break;
     }
     if ((i4 - i5 | 0) < 4) {
      i9 = 1;
      break L4;
     }
     i12 = i5 + 2 | 0;
     i13 = HEAPU16[i12 >> 1] | 0;
     if ((i13 & 64512 | 0) != 56320) {
      i9 = 2;
      break L4;
     }
     if ((i1 - (HEAP32[i6 >> 2] | 0) | 0) < 4) {
      i9 = 1;
      break L4;
     }
     i14 = i11 & 960;
     if (((i14 << 10) + 65536 | i11 << 10 & 64512 | i13 & 1023) >>> 0 > i7 >>> 0) {
      i9 = 2;
      break L4;
     }
     HEAP32[i3 >> 2] = i12;
     i12 = (i14 >>> 6) + 1 | 0;
     i14 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i14 + 1;
     HEAP8[i14 >> 0] = i12 >>> 2 | 240;
     i14 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i14 + 1;
     HEAP8[i14 >> 0] = i11 >>> 2 & 15 | i12 << 4 & 48 | 128;
     i12 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i12 + 1;
     HEAP8[i12 >> 0] = i11 << 4 & 48 | i13 >>> 6 & 15 | 128;
     i12 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i12 + 1;
     HEAP8[i12 >> 0] = i13 & 63 | 128;
    } while (0);
    i5 = (HEAP32[i3 >> 2] | 0) + 2 | 0;
    HEAP32[i3 >> 2] = i5;
    if (i5 >>> 0 >= i2 >>> 0) {
     i9 = 0;
     break;
    }
   }
  } else i9 = 0;
 } while (0);
 return i9 | 0;
}

function __ZNKSt3__120__time_get_c_storageIwE8__monthsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 L1 : do if ((HEAP8[16944] | 0) == 0 ? (___cxa_guard_acquire(16944) | 0) != 0 : 0) {
  if ((HEAP8[16952] | 0) == 0 ? (___cxa_guard_acquire(16952) | 0) != 0 : 0) {
   i1 = 28376;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != 28664);
   ___cxa_atexit(294, 0, ___dso_handle | 0) | 0;
   ___cxa_guard_release(16952);
  }
  __THREW__ = 0;
  invoke_iii(59, 28376, 28664) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  do if ((((((((((((((!(i1 & 1) ? (__THREW__ = 0, invoke_iii(59, 28388, 28696) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28400, 28732) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28412, 28756) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28424, 28780) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28436, 28796) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28448, 28816) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28460, 28836) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28472, 28864) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28484, 28904) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28496, 28936) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28508, 28972) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28520, 29008) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28532, 29024) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 28544, 29040) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) {
   __THREW__ = 0;
   invoke_iii(59, 28556, 29056) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(59, 28568, 28780) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(59, 28580, 29072) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(59, 28592, 29088) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(59, 28604, 29104) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(59, 28616, 29120) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(59, 28628, 29136) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(59, 28640, 29152) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(59, 28652, 29168) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   HEAP32[7296] = 28376;
   ___cxa_guard_release(16944);
   break L1;
  } while (0);
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(16944);
  ___resumeException(i1 | 0);
 } while (0);
 return HEAP32[7296] | 0;
}

function __ZNKSt3__120__time_get_c_storageIcE8__monthsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 L1 : do if ((HEAP8[16928] | 0) == 0 ? (___cxa_guard_acquire(16928) | 0) != 0 : 0) {
  if ((HEAP8[16936] | 0) == 0 ? (___cxa_guard_acquire(16936) | 0) != 0 : 0) {
   i1 = 28084;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != 28372);
   ___cxa_atexit(293, 0, ___dso_handle | 0) | 0;
   ___cxa_guard_release(16936);
  }
  __THREW__ = 0;
  invoke_iii(58, 28084, 47790) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  do if ((((((((((((((!(i1 & 1) ? (__THREW__ = 0, invoke_iii(58, 28096, 47798) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28108, 47807) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28120, 47813) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28132, 47819) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28144, 47823) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28156, 47828) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28168, 47833) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28180, 47840) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28192, 47850) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28204, 47858) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28216, 47867) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28228, 47876) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28240, 47880) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 28252, 47884) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) {
   __THREW__ = 0;
   invoke_iii(58, 28264, 47888) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(58, 28276, 47819) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(58, 28288, 47892) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(58, 28300, 47896) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(58, 28312, 47900) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(58, 28324, 47904) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(58, 28336, 47908) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(58, 28348, 47912) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   __THREW__ = 0;
   invoke_iii(58, 28360, 47916) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) break;
   HEAP32[7093] = 28084;
   ___cxa_guard_release(16928);
   break L1;
  } while (0);
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(16928);
  ___resumeException(i1 | 0);
 } while (0);
 return HEAP32[7093] | 0;
}

function __ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 L1 : do if (i1 << 24 >> 24 == i6 << 24 >> 24) if (HEAP8[i2 >> 0] | 0) {
  HEAP8[i2 >> 0] = 0;
  i13 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i13 + 1;
  HEAP8[i13 >> 0] = 46;
  i13 = HEAP8[i8 >> 0] | 0;
  if ((((i13 & 1) == 0 ? (i13 & 255) >>> 1 : HEAP32[i8 + 4 >> 2] | 0) | 0) != 0 ? (i13 = HEAP32[i10 >> 2] | 0, (i13 - i9 | 0) < 160) : 0) {
   i14 = HEAP32[i11 >> 2] | 0;
   HEAP32[i10 >> 2] = i13 + 4;
   HEAP32[i13 >> 2] = i14;
   i15 = 0;
  } else i15 = 0;
 } else i15 = -1; else {
  if (i1 << 24 >> 24 == i7 << 24 >> 24 ? (i14 = HEAP8[i8 >> 0] | 0, (((i14 & 1) == 0 ? (i14 & 255) >>> 1 : HEAP32[i8 + 4 >> 2] | 0) | 0) != 0) : 0) {
   if (!(HEAP8[i2 >> 0] | 0)) {
    i15 = -1;
    break;
   }
   i14 = HEAP32[i10 >> 2] | 0;
   if ((i14 - i9 | 0) >= 160) {
    i15 = 0;
    break;
   }
   i13 = HEAP32[i11 >> 2] | 0;
   HEAP32[i10 >> 2] = i14 + 4;
   HEAP32[i14 >> 2] = i13;
   HEAP32[i11 >> 2] = 0;
   i15 = 0;
   break;
  }
  i13 = i12 + 32 | 0;
  i14 = i12;
  while (1) {
   if ((HEAP8[i14 >> 0] | 0) == i1 << 24 >> 24) {
    i16 = i14;
    break;
   }
   i14 = i14 + 1 | 0;
   if ((i14 | 0) == (i13 | 0)) {
    i16 = i13;
    break;
   }
  }
  i13 = i16 - i12 | 0;
  if ((i13 | 0) > 31) i15 = -1; else {
   i14 = HEAP8[46161 + i13 >> 0] | 0;
   switch (i13 | 0) {
   case 24:
   case 25:
    {
     i17 = HEAP32[i5 >> 2] | 0;
     if ((i17 | 0) != (i4 | 0) ? (HEAPU8[i17 + -1 >> 0] & 95 | 0) != (HEAPU8[i3 >> 0] & 127 | 0) : 0) {
      i15 = -1;
      break L1;
     }
     HEAP32[i5 >> 2] = i17 + 1;
     HEAP8[i17 >> 0] = i14;
     i15 = 0;
     break L1;
     break;
    }
   case 23:
   case 22:
    {
     HEAP8[i3 >> 0] = 80;
     i17 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = i17 + 1;
     HEAP8[i17 >> 0] = i14;
     i15 = 0;
     break L1;
     break;
    }
   default:
    {
     i17 = i14 & 95;
     if ((((i17 | 0) == (HEAP8[i3 >> 0] | 0) ? (HEAP8[i3 >> 0] = i17 | 128, (HEAP8[i2 >> 0] | 0) != 0) : 0) ? (HEAP8[i2 >> 0] = 0, i17 = HEAP8[i8 >> 0] | 0, (((i17 & 1) == 0 ? (i17 & 255) >>> 1 : HEAP32[i8 + 4 >> 2] | 0) | 0) != 0) : 0) ? (i17 = HEAP32[i10 >> 2] | 0, (i17 - i9 | 0) < 160) : 0) {
      i18 = HEAP32[i11 >> 2] | 0;
      HEAP32[i10 >> 2] = i17 + 4;
      HEAP32[i17 >> 2] = i18;
     }
     i18 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = i18 + 1;
     HEAP8[i18 >> 0] = i14;
     if ((i13 | 0) > 21) {
      i15 = 0;
      break L1;
     }
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i15 = 0;
     break L1;
    }
   }
  }
 } while (0);
 return i15 | 0;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i7 = i6 + 20 | 0;
 i8 = i6 + 16 | 0;
 i9 = i6 + 12 | 0;
 i10 = i6;
 L1 : do if (!(HEAP32[i3 + 4 >> 2] & 1)) {
  i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  i12 = FUNCTION_TABLE_iiiiii[i11 & 31](i1, i7, i3, i4, i5 & 1) | 0;
 } else {
  i11 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
  HEAP32[i9 >> 2] = i11;
  __THREW__ = 0;
  i13 = invoke_iii(55, i9 | 0, 26728) | 0;
  i14 = __THREW__;
  __THREW__ = 0;
  L4 : do if (i14 & 1) {
   i15 = ___cxa_find_matching_catch() | 0;
   i16 = tempRet0;
   __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
   i17 = i16;
   i18 = i15;
  } else {
   __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
   i15 = HEAP32[i13 >> 2] | 0;
   if (i5) FUNCTION_TABLE_vii[HEAP32[i15 + 24 >> 2] & 127](i10, i13); else FUNCTION_TABLE_vii[HEAP32[i15 + 28 >> 2] & 127](i10, i13);
   i15 = HEAP8[i10 >> 0] | 0;
   i16 = (i15 & 1) == 0;
   i19 = i10 + 4 | 0;
   i20 = i10 + 8 | 0;
   i21 = i16 ? i19 : i10 + 4 | 0;
   i22 = i16 ? i19 : HEAP32[i10 + 8 >> 2] | 0;
   i19 = (i15 & 1) == 0;
   L11 : do if ((i22 | 0) != ((i19 ? i21 : HEAP32[i20 >> 2] | 0) + ((i19 ? (i15 & 255) >>> 1 : HEAP32[i21 >> 2] | 0) << 2) | 0)) {
    i16 = i22;
    while (1) {
     i23 = HEAP32[i16 >> 2] | 0;
     i24 = HEAP32[i2 >> 2] | 0;
     if (i24) {
      i25 = i24 + 24 | 0;
      i26 = HEAP32[i25 >> 2] | 0;
      if ((i26 | 0) == (HEAP32[i24 + 28 >> 2] | 0)) {
       __THREW__ = 0;
       i27 = invoke_iii(HEAP32[(HEAP32[i24 >> 2] | 0) + 52 >> 2] | 0, i24 | 0, i23 | 0) | 0;
       i24 = __THREW__;
       __THREW__ = 0;
       if (i24 & 1) break; else i28 = i27;
      } else {
       HEAP32[i25 >> 2] = i26 + 4;
       HEAP32[i26 >> 2] = i23;
       i28 = i23;
      }
      if ((i28 | 0) == -1) HEAP32[i2 >> 2] = 0;
     }
     i16 = i16 + 4 | 0;
     i23 = HEAP8[i10 >> 0] | 0;
     i26 = (i23 & 1) == 0;
     if ((i16 | 0) == ((i26 ? i21 : HEAP32[i20 >> 2] | 0) + ((i26 ? (i23 & 255) >>> 1 : HEAP32[i21 >> 2] | 0) << 2) | 0)) break L11;
    }
    i16 = ___cxa_find_matching_catch() | 0;
    i23 = tempRet0;
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
    i17 = i23;
    i18 = i16;
    break L4;
   } while (0);
   i21 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
   i12 = i21;
   break L1;
  } while (0);
  ___resumeException(i18 | 0);
 } while (0);
 STACKTOP = i6;
 return i12 | 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i7 = i6 + 20 | 0;
 i8 = i6 + 16 | 0;
 i9 = i6 + 12 | 0;
 i10 = i6;
 L1 : do if (!(HEAP32[i3 + 4 >> 2] & 1)) {
  i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  i12 = FUNCTION_TABLE_iiiiii[i11 & 31](i1, i7, i3, i4, i5 & 1) | 0;
 } else {
  i11 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
  HEAP32[i9 >> 2] = i11;
  __THREW__ = 0;
  i13 = invoke_iii(55, i9 | 0, 26720) | 0;
  i14 = __THREW__;
  __THREW__ = 0;
  L4 : do if (i14 & 1) {
   i15 = ___cxa_find_matching_catch() | 0;
   i16 = tempRet0;
   __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
   i17 = i16;
   i18 = i15;
  } else {
   __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
   i15 = HEAP32[i13 >> 2] | 0;
   if (i5) FUNCTION_TABLE_vii[HEAP32[i15 + 24 >> 2] & 127](i10, i13); else FUNCTION_TABLE_vii[HEAP32[i15 + 28 >> 2] & 127](i10, i13);
   i15 = HEAP8[i10 >> 0] | 0;
   i16 = (i15 & 1) == 0;
   i19 = i10 + 1 | 0;
   i20 = i10 + 8 | 0;
   i21 = i16 ? i19 : i10 + 1 | 0;
   i22 = i16 ? i19 : HEAP32[i10 + 8 >> 2] | 0;
   i19 = i10 + 4 | 0;
   i16 = (i15 & 1) == 0;
   L11 : do if ((i22 | 0) != ((i16 ? i21 : HEAP32[i20 >> 2] | 0) + (i16 ? (i15 & 255) >>> 1 : HEAP32[i19 >> 2] | 0) | 0)) {
    i23 = i22;
    L12 : while (1) {
     i24 = HEAP8[i23 >> 0] | 0;
     i25 = HEAP32[i2 >> 2] | 0;
     do if (i25) {
      i26 = i25 + 24 | 0;
      i27 = HEAP32[i26 >> 2] | 0;
      if ((i27 | 0) != (HEAP32[i25 + 28 >> 2] | 0)) {
       HEAP32[i26 >> 2] = i27 + 1;
       HEAP8[i27 >> 0] = i24;
       break;
      }
      __THREW__ = 0;
      i27 = invoke_iii(HEAP32[(HEAP32[i25 >> 2] | 0) + 52 >> 2] | 0, i25 | 0, i24 & 255 | 0) | 0;
      i26 = __THREW__;
      __THREW__ = 0;
      if (i26 & 1) break L12;
      if ((i27 | 0) == -1) HEAP32[i2 >> 2] = 0;
     } while (0);
     i23 = i23 + 1 | 0;
     i24 = HEAP8[i10 >> 0] | 0;
     i25 = (i24 & 1) == 0;
     if ((i23 | 0) == ((i25 ? i21 : HEAP32[i20 >> 2] | 0) + (i25 ? (i24 & 255) >>> 1 : HEAP32[i19 >> 2] | 0) | 0)) break L11;
    }
    i23 = ___cxa_find_matching_catch() | 0;
    i24 = tempRet0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
    i17 = i24;
    i18 = i23;
    break L4;
   } while (0);
   i19 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   i12 = i19;
   break L1;
  } while (0);
  ___resumeException(i18 | 0);
 } while (0);
 STACKTOP = i6;
 return i12 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1) {
  i6 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i6 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 255](i1) | 0; else i7 = HEAP32[i6 >> 2] | 0;
  if ((i7 | 0) == -1) {
   HEAP32[i2 >> 2] = 0;
   i8 = 1;
   break;
  } else {
   i8 = (HEAP32[i2 >> 2] | 0) == 0;
   break;
  }
 } else i8 = 1; while (0);
 i7 = HEAP32[i3 >> 2] | 0;
 do if (i7) {
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 255](i7) | 0; else i9 = HEAP32[i1 >> 2] | 0;
  if ((i9 | 0) != -1) if (i8) {
   i10 = i7;
   i11 = 17;
   break;
  } else {
   i11 = 16;
   break;
  } else {
   HEAP32[i3 >> 2] = 0;
   i11 = 14;
   break;
  }
 } else i11 = 14; while (0);
 if ((i11 | 0) == 14) if (i8) i11 = 16; else {
  i10 = 0;
  i11 = 17;
 }
 L22 : do if ((i11 | 0) == 16) HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 6; else if ((i11 | 0) == 17) {
  i8 = HEAP32[i2 >> 2] | 0;
  i7 = HEAP32[i8 + 12 >> 2] | 0;
  if ((i7 | 0) == (HEAP32[i8 + 16 >> 2] | 0)) i12 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] & 255](i8) | 0; else i12 = HEAP32[i7 >> 2] | 0;
  if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] & 63](i5, i12, 0) | 0) << 24 >> 24 != 37) {
   HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 4;
   break;
  }
  i7 = HEAP32[i2 >> 2] | 0;
  i8 = i7 + 12 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  if ((i9 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] & 255](i7) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i13 = 1; else {
    i14 = i1;
    i11 = 25;
   }
  } else {
   HEAP32[i8 >> 2] = i9 + 4;
   i14 = i7;
   i11 = 25;
  }
  do if ((i11 | 0) == 25) {
   i7 = HEAP32[i14 + 12 >> 2] | 0;
   if ((i7 | 0) == (HEAP32[i14 + 16 >> 2] | 0)) i15 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i14 >> 2] | 0) + 36 >> 2] & 255](i14) | 0; else i15 = HEAP32[i7 >> 2] | 0;
   if ((i15 | 0) == -1) {
    HEAP32[i2 >> 2] = 0;
    i13 = 1;
    break;
   } else {
    i13 = (HEAP32[i2 >> 2] | 0) == 0;
    break;
   }
  } while (0);
  do if (i10) {
   i7 = HEAP32[i10 + 12 >> 2] | 0;
   if ((i7 | 0) == (HEAP32[i10 + 16 >> 2] | 0)) i16 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] & 255](i10) | 0; else i16 = HEAP32[i7 >> 2] | 0;
   if ((i16 | 0) != -1) if (i13) break L22; else break; else {
    HEAP32[i3 >> 2] = 0;
    i11 = 37;
    break;
   }
  } else i11 = 37; while (0);
  if ((i11 | 0) == 37 ? !i13 : 0) break;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2;
 } while (0);
 return;
}

function _scanexp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i1 + 100 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i4 + 1;
  i6 = HEAPU8[i4 >> 0] | 0;
 } else i6 = ___shgetc(i1) | 0;
 switch (i6 | 0) {
 case 43:
 case 45:
  {
   i4 = (i6 | 0) == 45 & 1;
   i7 = HEAP32[i3 >> 2] | 0;
   if (i7 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
    HEAP32[i3 >> 2] = i7 + 1;
    i8 = HEAPU8[i7 >> 0] | 0;
   } else i8 = ___shgetc(i1) | 0;
   if ((i2 | 0) != 0 & (i8 + -48 | 0) >>> 0 > 9 ? (HEAP32[i5 >> 2] | 0) != 0 : 0) {
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
    i9 = i8;
    i10 = i4;
   } else {
    i9 = i8;
    i10 = i4;
   }
   break;
  }
 default:
  {
   i9 = i6;
   i10 = 0;
  }
 }
 if ((i9 + -48 | 0) >>> 0 > 9) if (!(HEAP32[i5 >> 2] | 0)) {
  i11 = -2147483648;
  i12 = 0;
 } else {
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i11 = -2147483648;
  i12 = 0;
 } else {
  i6 = i9;
  i9 = 0;
  while (1) {
   i4 = i6 + -48 + (i9 * 10 | 0) | 0;
   i8 = HEAP32[i3 >> 2] | 0;
   if (i8 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
    HEAP32[i3 >> 2] = i8 + 1;
    i13 = HEAPU8[i8 >> 0] | 0;
   } else i13 = ___shgetc(i1) | 0;
   if ((i13 + -48 | 0) >>> 0 < 10 & (i4 | 0) < 214748364) {
    i6 = i13;
    i9 = i4;
   } else {
    i14 = i4;
    i15 = i13;
    break;
   }
  }
  i13 = ((i14 | 0) < 0) << 31 >> 31;
  if ((i15 + -48 | 0) >>> 0 < 10) {
   i9 = i14;
   i6 = i13;
   i4 = i15;
   while (1) {
    i8 = ___muldi3(i9 | 0, i6 | 0, 10, 0) | 0;
    i2 = tempRet0;
    i7 = _i64Add(i4 | 0, ((i4 | 0) < 0) << 31 >> 31 | 0, -48, -1) | 0;
    i16 = _i64Add(i7 | 0, tempRet0 | 0, i8 | 0, i2 | 0) | 0;
    i2 = tempRet0;
    i8 = HEAP32[i3 >> 2] | 0;
    if (i8 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
     HEAP32[i3 >> 2] = i8 + 1;
     i17 = HEAPU8[i8 >> 0] | 0;
    } else i17 = ___shgetc(i1) | 0;
    if ((i17 + -48 | 0) >>> 0 < 10 & ((i2 | 0) < 21474836 | (i2 | 0) == 21474836 & i16 >>> 0 < 2061584302)) {
     i9 = i16;
     i6 = i2;
     i4 = i17;
    } else {
     i18 = i16;
     i19 = i2;
     i20 = i17;
     break;
    }
   }
  } else {
   i18 = i14;
   i19 = i13;
   i20 = i15;
  }
  if ((i20 + -48 | 0) >>> 0 < 10) do {
   i20 = HEAP32[i3 >> 2] | 0;
   if (i20 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
    HEAP32[i3 >> 2] = i20 + 1;
    i21 = HEAPU8[i20 >> 0] | 0;
   } else i21 = ___shgetc(i1) | 0;
  } while ((i21 + -48 | 0) >>> 0 < 10);
  if (HEAP32[i5 >> 2] | 0) HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = (i10 | 0) != 0;
  i10 = _i64Subtract(0, 0, i18 | 0, i19 | 0) | 0;
  i11 = i3 ? tempRet0 : i19;
  i12 = i3 ? i10 : i18;
 }
 tempRet0 = i11;
 return i12 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 L1 : while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  do if (i1) {
   i6 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i6 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 255](i1) | 0; else i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) == -1) {
    HEAP32[i2 >> 2] = 0;
    i8 = 1;
    break;
   } else {
    i8 = (HEAP32[i2 >> 2] | 0) == 0;
    break;
   }
  } else i8 = 1; while (0);
  i1 = HEAP32[i3 >> 2] | 0;
  do if (i1) {
   i6 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i6 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 255](i1) | 0; else i9 = HEAP32[i6 >> 2] | 0;
   if ((i9 | 0) != -1) if (i8) {
    i10 = i1;
    break;
   } else {
    i11 = i1;
    break L1;
   } else {
    HEAP32[i3 >> 2] = 0;
    i12 = 15;
    break;
   }
  } else i12 = 15; while (0);
  if ((i12 | 0) == 15) {
   i12 = 0;
   if (i8) {
    i11 = 0;
    break;
   } else i10 = 0;
  }
  i1 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i6 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i13 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 255](i1) | 0; else i13 = HEAP32[i6 >> 2] | 0;
  if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] & 63](i5, 8192, i13) | 0)) {
   i11 = i10;
   break;
  }
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = i6 + 12 | 0;
  i14 = HEAP32[i1 >> 2] | 0;
  if ((i14 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] & 255](i6) | 0;
   continue;
  } else {
   HEAP32[i1 >> 2] = i14 + 4;
   continue;
  }
 }
 i10 = HEAP32[i2 >> 2] | 0;
 do if (i10) {
  i13 = HEAP32[i10 + 12 >> 2] | 0;
  if ((i13 | 0) == (HEAP32[i10 + 16 >> 2] | 0)) i15 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] & 255](i10) | 0; else i15 = HEAP32[i13 >> 2] | 0;
  if ((i15 | 0) == -1) {
   HEAP32[i2 >> 2] = 0;
   i16 = 1;
   break;
  } else {
   i16 = (HEAP32[i2 >> 2] | 0) == 0;
   break;
  }
 } else i16 = 1; while (0);
 do if (i11) {
  i2 = HEAP32[i11 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) i17 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 255](i11) | 0; else i17 = HEAP32[i2 >> 2] | 0;
  if ((i17 | 0) != -1) if (i16) break; else {
   i12 = 39;
   break;
  } else {
   HEAP32[i3 >> 2] = 0;
   i12 = 37;
   break;
  }
 } else i12 = 37; while (0);
 if ((i12 | 0) == 37 ? i16 : 0) i12 = 39;
 if ((i12 | 0) == 39) HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2;
 return;
}

function __ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 L1 : do if ((i1 | 0) == (i6 | 0)) if (HEAP8[i2 >> 0] | 0) {
  HEAP8[i2 >> 0] = 0;
  i13 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i13 + 1;
  HEAP8[i13 >> 0] = 46;
  i13 = HEAP8[i8 >> 0] | 0;
  if ((((i13 & 1) == 0 ? (i13 & 255) >>> 1 : HEAP32[i8 + 4 >> 2] | 0) | 0) != 0 ? (i13 = HEAP32[i10 >> 2] | 0, (i13 - i9 | 0) < 160) : 0) {
   i14 = HEAP32[i11 >> 2] | 0;
   HEAP32[i10 >> 2] = i13 + 4;
   HEAP32[i13 >> 2] = i14;
   i15 = 0;
  } else i15 = 0;
 } else i15 = -1; else {
  if ((i1 | 0) == (i7 | 0) ? (i14 = HEAP8[i8 >> 0] | 0, (((i14 & 1) == 0 ? (i14 & 255) >>> 1 : HEAP32[i8 + 4 >> 2] | 0) | 0) != 0) : 0) {
   if (!(HEAP8[i2 >> 0] | 0)) {
    i15 = -1;
    break;
   }
   i14 = HEAP32[i10 >> 2] | 0;
   if ((i14 - i9 | 0) >= 160) {
    i15 = 0;
    break;
   }
   i13 = HEAP32[i11 >> 2] | 0;
   HEAP32[i10 >> 2] = i14 + 4;
   HEAP32[i14 >> 2] = i13;
   HEAP32[i11 >> 2] = 0;
   i15 = 0;
   break;
  }
  i13 = i12 + 128 | 0;
  i14 = i12;
  while (1) {
   if ((HEAP32[i14 >> 2] | 0) == (i1 | 0)) {
    i16 = i14;
    break;
   }
   i14 = i14 + 4 | 0;
   if ((i14 | 0) == (i13 | 0)) {
    i16 = i13;
    break;
   }
  }
  i13 = i16 - i12 | 0;
  i14 = i13 >> 2;
  if ((i13 | 0) <= 124) {
   i17 = HEAP8[46161 + i14 >> 0] | 0;
   switch (i14 | 0) {
   case 24:
   case 25:
    {
     i14 = HEAP32[i5 >> 2] | 0;
     if ((i14 | 0) != (i4 | 0) ? (HEAPU8[i14 + -1 >> 0] & 95 | 0) != (HEAPU8[i3 >> 0] & 127 | 0) : 0) {
      i15 = -1;
      break L1;
     }
     HEAP32[i5 >> 2] = i14 + 1;
     HEAP8[i14 >> 0] = i17;
     i15 = 0;
     break L1;
     break;
    }
   case 23:
   case 22:
    {
     HEAP8[i3 >> 0] = 80;
     break;
    }
   default:
    {
     i14 = i17 & 95;
     if ((((i14 | 0) == (HEAP8[i3 >> 0] | 0) ? (HEAP8[i3 >> 0] = i14 | 128, (HEAP8[i2 >> 0] | 0) != 0) : 0) ? (HEAP8[i2 >> 0] = 0, i14 = HEAP8[i8 >> 0] | 0, (((i14 & 1) == 0 ? (i14 & 255) >>> 1 : HEAP32[i8 + 4 >> 2] | 0) | 0) != 0) : 0) ? (i14 = HEAP32[i10 >> 2] | 0, (i14 - i9 | 0) < 160) : 0) {
      i18 = HEAP32[i11 >> 2] | 0;
      HEAP32[i10 >> 2] = i14 + 4;
      HEAP32[i14 >> 2] = i18;
     }
    }
   }
   i18 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i18 + 1;
   HEAP8[i18 >> 0] = i17;
   if ((i13 | 0) > 84) i15 = 0; else {
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    i15 = 0;
   }
  } else i15 = -1;
 } while (0);
 return i15 | 0;
}

function _wcsrtombs(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 L1 : do if (!i1) {
  i6 = HEAP32[i2 >> 2] | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (!i7) i8 = 0; else {
   i9 = 0;
   i10 = i7;
   i7 = i6;
   while (1) {
    if (i10 >>> 0 > 127) {
     i6 = _wcrtomb(i5, i10, 0) | 0;
     if ((i6 | 0) == -1) {
      i8 = -1;
      break L1;
     } else i11 = i6;
    } else i11 = 1;
    i6 = i11 + i9 | 0;
    i7 = i7 + 4 | 0;
    i10 = HEAP32[i7 >> 2] | 0;
    if (!i10) {
     i8 = i6;
     break;
    } else i9 = i6;
   }
  }
 } else {
  L9 : do if (i3 >>> 0 > 3) {
   i9 = i1;
   i10 = i3;
   i7 = HEAP32[i2 >> 2] | 0;
   while (1) {
    i6 = HEAP32[i7 >> 2] | 0;
    if ((i6 + -1 | 0) >>> 0 > 126) {
     if (!i6) {
      i12 = i9;
      i13 = i10;
      break;
     }
     i14 = _wcrtomb(i9, i6, 0) | 0;
     if ((i14 | 0) == -1) {
      i8 = -1;
      break L1;
     }
     i15 = i9 + i14 | 0;
     i16 = i10 - i14 | 0;
     i17 = i7;
    } else {
     HEAP8[i9 >> 0] = i6;
     i15 = i9 + 1 | 0;
     i16 = i10 + -1 | 0;
     i17 = HEAP32[i2 >> 2] | 0;
    }
    i7 = i17 + 4 | 0;
    HEAP32[i2 >> 2] = i7;
    if (i16 >>> 0 <= 3) {
     i18 = i15;
     i19 = i16;
     break L9;
    } else {
     i9 = i15;
     i10 = i16;
    }
   }
   HEAP8[i12 >> 0] = 0;
   HEAP32[i2 >> 2] = 0;
   i8 = i3 - i13 | 0;
   break L1;
  } else {
   i18 = i1;
   i19 = i3;
  } while (0);
  if (i19) {
   i10 = i18;
   i9 = i19;
   i7 = HEAP32[i2 >> 2] | 0;
   while (1) {
    i6 = HEAP32[i7 >> 2] | 0;
    if ((i6 + -1 | 0) >>> 0 > 126) {
     if (!i6) {
      i20 = i10;
      i21 = i9;
      i22 = 19;
      break;
     }
     i14 = _wcrtomb(i5, i6, 0) | 0;
     if ((i14 | 0) == -1) {
      i8 = -1;
      break L1;
     }
     if (i9 >>> 0 < i14 >>> 0) {
      i23 = i9;
      i22 = 22;
      break;
     }
     _wcrtomb(i10, HEAP32[i7 >> 2] | 0, 0) | 0;
     i24 = i10 + i14 | 0;
     i25 = i9 - i14 | 0;
     i26 = i7;
    } else {
     HEAP8[i10 >> 0] = i6;
     i24 = i10 + 1 | 0;
     i25 = i9 + -1 | 0;
     i26 = HEAP32[i2 >> 2] | 0;
    }
    i7 = i26 + 4 | 0;
    HEAP32[i2 >> 2] = i7;
    if (!i25) {
     i8 = i3;
     break L1;
    } else {
     i10 = i24;
     i9 = i25;
    }
   }
   if ((i22 | 0) == 19) {
    HEAP8[i20 >> 0] = 0;
    HEAP32[i2 >> 2] = 0;
    i8 = i3 - i21 | 0;
    break;
   } else if ((i22 | 0) == 22) {
    i8 = i3 - i23 | 0;
    break;
   }
  } else i8 = i3;
 } while (0);
 STACKTOP = i4;
 return i8 | 0;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = i5 + 8 | 0;
 L1 : while (1) {
  i5 = HEAP32[i2 >> 2] | 0;
  do if (i5) if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i5 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] & 255](i5) | 0) == -1) {
   HEAP32[i2 >> 2] = 0;
   i6 = 0;
   break;
  } else {
   i6 = HEAP32[i2 >> 2] | 0;
   break;
  } else i6 = i5; else i6 = 0; while (0);
  i5 = (i6 | 0) == 0;
  i7 = HEAP32[i3 >> 2] | 0;
  do if (i7) {
   if ((HEAP32[i7 + 12 >> 2] | 0) != (HEAP32[i7 + 16 >> 2] | 0)) if (i5) {
    i8 = i7;
    break;
   } else {
    i9 = i7;
    break L1;
   }
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 255](i7) | 0) != -1) if (i5) {
    i8 = i7;
    break;
   } else {
    i9 = i7;
    break L1;
   } else {
    HEAP32[i3 >> 2] = 0;
    i10 = 12;
    break;
   }
  } else i10 = 12; while (0);
  if ((i10 | 0) == 12) {
   i10 = 0;
   if (i5) {
    i9 = 0;
    break;
   } else i8 = 0;
  }
  i7 = HEAP32[i2 >> 2] | 0;
  i11 = HEAP32[i7 + 12 >> 2] | 0;
  if ((i11 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) i12 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 255](i7) | 0; else i12 = HEAPU8[i11 >> 0] | 0;
  if ((i12 & 255) << 24 >> 24 <= -1) {
   i9 = i8;
   break;
  }
  if (!(HEAP16[(HEAP32[i1 >> 2] | 0) + (i12 << 24 >> 24 << 1) >> 1] & 8192)) {
   i9 = i8;
   break;
  }
  i11 = HEAP32[i2 >> 2] | 0;
  i7 = i11 + 12 | 0;
  i13 = HEAP32[i7 >> 2] | 0;
  if ((i13 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] & 255](i11) | 0;
   continue;
  } else {
   HEAP32[i7 >> 2] = i13 + 1;
   continue;
  }
 }
 i8 = HEAP32[i2 >> 2] | 0;
 do if (i8) if ((HEAP32[i8 + 12 >> 2] | 0) == (HEAP32[i8 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] & 255](i8) | 0) == -1) {
  HEAP32[i2 >> 2] = 0;
  i14 = 0;
  break;
 } else {
  i14 = HEAP32[i2 >> 2] | 0;
  break;
 } else i14 = i8; else i14 = 0; while (0);
 i8 = (i14 | 0) == 0;
 do if (i9) {
  if ((HEAP32[i9 + 12 >> 2] | 0) == (HEAP32[i9 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 255](i9) | 0) == -1 : 0) {
   HEAP32[i3 >> 2] = 0;
   i10 = 32;
   break;
  }
  if (!i8) i10 = 33;
 } else i10 = 32; while (0);
 if ((i10 | 0) == 32 ? i8 : 0) i10 = 33;
 if ((i10 | 0) == 33) HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1) if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 255](i1) | 0) == -1) {
  HEAP32[i2 >> 2] = 0;
  i6 = 0;
  break;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  break;
 } else i6 = i1; else i6 = 0; while (0);
 i1 = (i6 | 0) == 0;
 i6 = HEAP32[i3 >> 2] | 0;
 do if (i6) {
  if ((HEAP32[i6 + 12 >> 2] | 0) == (HEAP32[i6 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] & 255](i6) | 0) == -1 : 0) {
   HEAP32[i3 >> 2] = 0;
   i7 = 11;
   break;
  }
  if (i1) {
   i8 = i6;
   i7 = 13;
  } else i7 = 12;
 } else i7 = 11; while (0);
 if ((i7 | 0) == 11) if (i1) i7 = 12; else {
  i8 = 0;
  i7 = 13;
 }
 L16 : do if ((i7 | 0) == 12) HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 6; else if ((i7 | 0) == 13) {
  i1 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i6 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 255](i1) | 0; else i9 = HEAPU8[i6 >> 0] | 0;
  if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] & 63](i5, i9 & 255, 0) | 0) << 24 >> 24 != 37) {
   HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 4;
   break;
  }
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = i6 + 12 | 0;
  i10 = HEAP32[i1 >> 2] | 0;
  if ((i10 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] & 255](i6) | 0;
   i11 = HEAP32[i2 >> 2] | 0;
   if (!i11) i12 = 0; else {
    i13 = i11;
    i7 = 21;
   }
  } else {
   HEAP32[i1 >> 2] = i10 + 1;
   i13 = i6;
   i7 = 21;
  }
  do if ((i7 | 0) == 21) if ((HEAP32[i13 + 12 >> 2] | 0) == (HEAP32[i13 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] & 255](i13) | 0) == -1) {
   HEAP32[i2 >> 2] = 0;
   i12 = 0;
   break;
  } else {
   i12 = HEAP32[i2 >> 2] | 0;
   break;
  } else i12 = i13; while (0);
  i6 = (i12 | 0) == 0;
  do if (i8) {
   if ((HEAP32[i8 + 12 >> 2] | 0) == (HEAP32[i8 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] & 255](i8) | 0) == -1 : 0) {
    HEAP32[i3 >> 2] = 0;
    i7 = 30;
    break;
   }
   if (i6) break L16;
  } else i7 = 30; while (0);
  if ((i7 | 0) == 30 ? !i6 : 0) break;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2;
 } while (0);
 return;
}

function __ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i6 >> 2] = i4;
 i1 = i5;
 if (i8 & 2) if ((i1 - i4 | 0) < 3) i9 = 1; else {
  HEAP32[i6 >> 2] = i4 + 1;
  HEAP8[i4 >> 0] = -17;
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + 1;
  HEAP8[i4 >> 0] = -69;
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + 1;
  HEAP8[i4 >> 0] = -65;
  i10 = 4;
 } else i10 = 4;
 L4 : do if ((i10 | 0) == 4) {
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < i2 >>> 0) {
   i8 = i4;
   while (1) {
    i4 = HEAP32[i8 >> 2] | 0;
    if (i4 >>> 0 > i7 >>> 0 | (i4 & -2048 | 0) == 55296) {
     i9 = 2;
     break L4;
    }
    do if (i4 >>> 0 >= 128) {
     if (i4 >>> 0 < 2048) {
      i5 = HEAP32[i6 >> 2] | 0;
      if ((i1 - i5 | 0) < 2) {
       i9 = 1;
       break L4;
      }
      HEAP32[i6 >> 2] = i5 + 1;
      HEAP8[i5 >> 0] = i4 >>> 6 | 192;
      i5 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i5 + 1;
      HEAP8[i5 >> 0] = i4 & 63 | 128;
      break;
     }
     i5 = HEAP32[i6 >> 2] | 0;
     i11 = i1 - i5 | 0;
     if (i4 >>> 0 < 65536) {
      if ((i11 | 0) < 3) {
       i9 = 1;
       break L4;
      }
      HEAP32[i6 >> 2] = i5 + 1;
      HEAP8[i5 >> 0] = i4 >>> 12 | 224;
      i12 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i4 >>> 6 & 63 | 128;
      i12 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i12 + 1;
      HEAP8[i12 >> 0] = i4 & 63 | 128;
      break;
     } else {
      if ((i11 | 0) < 4) {
       i9 = 1;
       break L4;
      }
      HEAP32[i6 >> 2] = i5 + 1;
      HEAP8[i5 >> 0] = i4 >>> 18 | 240;
      i5 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i5 + 1;
      HEAP8[i5 >> 0] = i4 >>> 12 & 63 | 128;
      i5 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i5 + 1;
      HEAP8[i5 >> 0] = i4 >>> 6 & 63 | 128;
      i5 = HEAP32[i6 >> 2] | 0;
      HEAP32[i6 >> 2] = i5 + 1;
      HEAP8[i5 >> 0] = i4 & 63 | 128;
      break;
     }
    } else {
     i5 = HEAP32[i6 >> 2] | 0;
     if ((i1 - i5 | 0) < 1) {
      i9 = 1;
      break L4;
     }
     HEAP32[i6 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i4;
    } while (0);
    i8 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
    HEAP32[i3 >> 2] = i8;
    if (i8 >>> 0 >= i2 >>> 0) {
     i9 = 0;
     break;
    }
   }
  } else i9 = 0;
 } while (0);
 return i9 | 0;
}

function _mbsnrtowcs(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i7 = i6 + 8 | 0;
 i8 = i6;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 >> 2] = i9;
 i10 = (i1 | 0) != 0;
 i11 = i10 ? i4 : 256;
 i4 = i10 ? i1 : i7;
 i1 = i9;
 L1 : do if ((i11 | 0) != 0 & (i9 | 0) != 0) {
  i12 = i3;
  i13 = i11;
  i14 = i1;
  i15 = 0;
  i16 = i4;
  while (1) {
   i17 = i12 >>> 2;
   i18 = i17 >>> 0 >= i13 >>> 0;
   if (!(i12 >>> 0 > 131 | i18)) {
    i19 = i12;
    i20 = i13;
    i21 = i14;
    i22 = i15;
    i23 = i16;
    break L1;
   }
   i24 = i18 ? i13 : i17;
   i17 = i12 - i24 | 0;
   i18 = _mbsrtowcs(i16, i8, i24, i5) | 0;
   if ((i18 | 0) == -1) {
    i25 = i17;
    i26 = i16;
    break;
   }
   i24 = (i16 | 0) == (i7 | 0);
   i27 = i24 ? 0 : i18;
   i28 = i13 - i27 | 0;
   i29 = i24 ? i16 : i16 + (i18 << 2) | 0;
   i24 = i18 + i15 | 0;
   i18 = HEAP32[i8 >> 2] | 0;
   if ((i13 | 0) != (i27 | 0) & (i18 | 0) != 0) {
    i12 = i17;
    i13 = i28;
    i14 = i18;
    i15 = i24;
    i16 = i29;
   } else {
    i19 = i17;
    i20 = i28;
    i21 = i18;
    i22 = i24;
    i23 = i29;
    break L1;
   }
  }
  i19 = i25;
  i20 = 0;
  i21 = HEAP32[i8 >> 2] | 0;
  i22 = -1;
  i23 = i26;
 } else {
  i19 = i3;
  i20 = i11;
  i21 = i1;
  i22 = 0;
  i23 = i4;
 } while (0);
 L8 : do if ((i21 | 0) != 0 ? (i20 | 0) != 0 & (i19 | 0) != 0 : 0) {
  i4 = i19;
  i1 = i20;
  i11 = i21;
  i3 = i22;
  i26 = i23;
  while (1) {
   i25 = _mbrtowc(i26, i11, i4, i5) | 0;
   if ((i25 + 2 | 0) >>> 0 < 3) {
    i30 = i25;
    i31 = i3;
    break;
   }
   i11 = (HEAP32[i8 >> 2] | 0) + i25 | 0;
   HEAP32[i8 >> 2] = i11;
   i1 = i1 + -1 | 0;
   i7 = i3 + 1 | 0;
   if (!((i1 | 0) != 0 & (i4 | 0) != (i25 | 0))) {
    i32 = i7;
    break L8;
   } else {
    i4 = i4 - i25 | 0;
    i3 = i7;
    i26 = i26 + 4 | 0;
   }
  }
  switch (i30 | 0) {
  case -1:
   {
    i32 = -1;
    break L8;
    break;
   }
  case 0:
   {
    HEAP32[i8 >> 2] = 0;
    i32 = i31;
    break L8;
    break;
   }
  default:
   {
    HEAP32[i5 >> 2] = 0;
    i32 = i31;
    break L8;
   }
  }
 } else i32 = i22; while (0);
 if (i10) HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 STACKTOP = i6;
 return i32 | 0;
}

function _pop_arg(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0;
 L1 : do if (i2 >>> 0 <= 20) do switch (i2 | 0) {
 case 9:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 4;
   HEAP32[i1 >> 2] = i5;
   break L1;
   break;
  }
 case 10:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 >> 2] = i5 + 4;
   i5 = i1;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = ((i4 | 0) < 0) << 31 >> 31;
   break L1;
   break;
  }
 case 11:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 4;
   i4 = i1;
   HEAP32[i4 >> 2] = i5;
   HEAP32[i4 + 4 >> 2] = 0;
   break L1;
   break;
  }
 case 12:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (8 - 1) & ~(8 - 1);
   i5 = i4;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 8;
   i4 = i1;
   HEAP32[i4 >> 2] = i6;
   HEAP32[i4 + 4 >> 2] = i7;
   break L1;
   break;
  }
 case 13:
  {
   i7 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i3 >> 2] = i7 + 4;
   i7 = (i4 & 65535) << 16 >> 16;
   i4 = i1;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i4 + 4 >> 2] = ((i7 | 0) < 0) << 31 >> 31;
   break L1;
   break;
  }
 case 14:
  {
   i7 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i3 >> 2] = i7 + 4;
   i7 = i1;
   HEAP32[i7 >> 2] = i4 & 65535;
   HEAP32[i7 + 4 >> 2] = 0;
   break L1;
   break;
  }
 case 15:
  {
   i7 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i3 >> 2] = i7 + 4;
   i7 = (i4 & 255) << 24 >> 24;
   i4 = i1;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i4 + 4 >> 2] = ((i7 | 0) < 0) << 31 >> 31;
   break L1;
   break;
  }
 case 16:
  {
   i7 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i3 >> 2] = i7 + 4;
   i7 = i1;
   HEAP32[i7 >> 2] = i4 & 255;
   HEAP32[i7 + 4 >> 2] = 0;
   break L1;
   break;
  }
 case 17:
  {
   i7 = (HEAP32[i3 >> 2] | 0) + (8 - 1) & ~(8 - 1);
   d8 = +HEAPF64[i7 >> 3];
   HEAP32[i3 >> 2] = i7 + 8;
   HEAPF64[i1 >> 3] = d8;
   break L1;
   break;
  }
 case 18:
  {
   i7 = (HEAP32[i3 >> 2] | 0) + (8 - 1) & ~(8 - 1);
   d8 = +HEAPF64[i7 >> 3];
   HEAP32[i3 >> 2] = i7 + 8;
   HEAPF64[i1 >> 3] = d8;
   break L1;
   break;
  }
 default:
  break L1;
 } while (0); while (0);
 return;
}

function __ZNSt3__110__stdinbufIcE9__getcharEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i3 + 16 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3 + 4 | 0;
 i7 = i3;
 i8 = i1 + 52 | 0;
 L1 : do if (HEAP8[i8 >> 0] | 0) {
  i9 = i1 + 48 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  if (i2) {
   HEAP32[i9 >> 2] = -1;
   HEAP8[i8 >> 0] = 0;
   i11 = i10;
  } else i11 = i10;
 } else {
  i10 = HEAP32[i1 + 44 >> 2] | 0;
  i9 = (i10 | 0) > 1 ? i10 : 1;
  i10 = i1 + 32 | 0;
  if ((i9 | 0) > 0) {
   i12 = 0;
   do {
    i13 = _getc(HEAP32[i10 >> 2] | 0) | 0;
    if ((i13 | 0) == -1) {
     i11 = -1;
     break L1;
    }
    HEAP8[i4 + i12 >> 0] = i13;
    i12 = i12 + 1 | 0;
   } while ((i12 | 0) < (i9 | 0));
  }
  L8 : do if (!(HEAP8[i1 + 53 >> 0] | 0)) {
   i12 = i1 + 40 | 0;
   i13 = i1 + 36 | 0;
   i14 = i5 + 1 | 0;
   i15 = i9;
   L10 : while (1) {
    i16 = HEAP32[i12 >> 2] | 0;
    i17 = i16;
    i18 = HEAP32[i17 >> 2] | 0;
    i19 = HEAP32[i17 + 4 >> 2] | 0;
    i17 = HEAP32[i13 >> 2] | 0;
    i20 = i4 + i15 | 0;
    switch (FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] & 15](i17, i16, i4, i20, i6, i5, i14, i7) | 0) {
    case 2:
     {
      i11 = -1;
      break L1;
      break;
     }
    case 3:
     {
      i21 = i15;
      break L10;
      break;
     }
    case 1:
     break;
    default:
     {
      i22 = i15;
      break L8;
     }
    }
    i16 = HEAP32[i12 >> 2] | 0;
    HEAP32[i16 >> 2] = i18;
    HEAP32[i16 + 4 >> 2] = i19;
    if ((i15 | 0) == 8) {
     i11 = -1;
     break L1;
    }
    i19 = _getc(HEAP32[i10 >> 2] | 0) | 0;
    if ((i19 | 0) == -1) {
     i11 = -1;
     break L1;
    }
    HEAP8[i20 >> 0] = i19;
    i15 = i15 + 1 | 0;
   }
   HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
   i22 = i21;
  } else {
   HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
   i22 = i9;
  } while (0);
  if (i2) {
   i9 = HEAP8[i5 >> 0] | 0;
   HEAP32[i1 + 48 >> 2] = i9 & 255;
   i23 = i9;
  } else {
   i9 = i22;
   while (1) {
    if ((i9 | 0) <= 0) break;
    i9 = i9 + -1 | 0;
    if ((_ungetc(HEAPU8[i4 + i9 >> 0] | 0, HEAP32[i10 >> 2] | 0) | 0) == -1) {
     i11 = -1;
     break L1;
    }
   }
   i23 = HEAP8[i5 >> 0] | 0;
  }
  i11 = i23 & 255;
 } while (0);
 STACKTOP = i3;
 return i11 | 0;
}

function __ZNSt3__110__stdinbufIwE9__getcharEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i3 + 16 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3 + 4 | 0;
 i7 = i3;
 i8 = i1 + 52 | 0;
 L1 : do if (HEAP8[i8 >> 0] | 0) {
  i9 = i1 + 48 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  if (i2) {
   HEAP32[i9 >> 2] = -1;
   HEAP8[i8 >> 0] = 0;
   i11 = i10;
  } else i11 = i10;
 } else {
  i10 = HEAP32[i1 + 44 >> 2] | 0;
  i9 = (i10 | 0) > 1 ? i10 : 1;
  i10 = i1 + 32 | 0;
  if ((i9 | 0) > 0) {
   i12 = 0;
   do {
    i13 = _getc(HEAP32[i10 >> 2] | 0) | 0;
    if ((i13 | 0) == -1) {
     i11 = -1;
     break L1;
    }
    HEAP8[i4 + i12 >> 0] = i13;
    i12 = i12 + 1 | 0;
   } while ((i12 | 0) < (i9 | 0));
  }
  L8 : do if (!(HEAP8[i1 + 53 >> 0] | 0)) {
   i12 = i1 + 40 | 0;
   i13 = i1 + 36 | 0;
   i14 = i5 + 4 | 0;
   i15 = i9;
   L10 : while (1) {
    i16 = HEAP32[i12 >> 2] | 0;
    i17 = i16;
    i18 = HEAP32[i17 >> 2] | 0;
    i19 = HEAP32[i17 + 4 >> 2] | 0;
    i17 = HEAP32[i13 >> 2] | 0;
    i20 = i4 + i15 | 0;
    switch (FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] & 15](i17, i16, i4, i20, i6, i5, i14, i7) | 0) {
    case 2:
     {
      i11 = -1;
      break L1;
      break;
     }
    case 3:
     {
      i21 = i15;
      break L10;
      break;
     }
    case 1:
     break;
    default:
     {
      i22 = i15;
      break L8;
     }
    }
    i16 = HEAP32[i12 >> 2] | 0;
    HEAP32[i16 >> 2] = i18;
    HEAP32[i16 + 4 >> 2] = i19;
    if ((i15 | 0) == 8) {
     i11 = -1;
     break L1;
    }
    i19 = _getc(HEAP32[i10 >> 2] | 0) | 0;
    if ((i19 | 0) == -1) {
     i11 = -1;
     break L1;
    }
    HEAP8[i20 >> 0] = i19;
    i15 = i15 + 1 | 0;
   }
   HEAP32[i5 >> 2] = HEAP8[i4 >> 0];
   i22 = i21;
  } else {
   HEAP32[i5 >> 2] = HEAP8[i4 >> 0];
   i22 = i9;
  } while (0);
  if (i2) {
   i9 = HEAP32[i5 >> 2] | 0;
   HEAP32[i1 + 48 >> 2] = i9;
   i11 = i9;
   break;
  } else i23 = i22;
  while (1) {
   if ((i23 | 0) <= 0) break;
   i23 = i23 + -1 | 0;
   if ((_ungetc(HEAP8[i4 + i23 >> 0] | 0, HEAP32[i10 >> 2] | 0) | 0) == -1) {
    i11 = -1;
    break L1;
   }
  }
  i11 = HEAP32[i5 >> 2] | 0;
 } while (0);
 STACKTOP = i3;
 return i11 | 0;
}

function ___stdio_write(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i5 = i4 + 16 | 0;
 i6 = i4;
 i7 = i4 + 32 | 0;
 i8 = i1 + 28 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 >> 2] = i9;
 i10 = i1 + 20 | 0;
 i11 = (HEAP32[i10 >> 2] | 0) - i9 | 0;
 HEAP32[i7 + 4 >> 2] = i11;
 HEAP32[i7 + 8 >> 2] = i2;
 HEAP32[i7 + 12 >> 2] = i3;
 i2 = i1 + 60 | 0;
 i9 = i1 + 44 | 0;
 i12 = i7;
 i7 = 2;
 i13 = i11 + i3 | 0;
 while (1) {
  if (!(HEAP32[4853] | 0)) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i5 + 4 >> 2] = i12;
   HEAP32[i5 + 8 >> 2] = i7;
   i14 = ___syscall_ret(___syscall146(146, i5 | 0) | 0) | 0;
  } else {
   _pthread_cleanup_push(283, i1 | 0);
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = i12;
   HEAP32[i6 + 8 >> 2] = i7;
   i11 = ___syscall_ret(___syscall146(146, i6 | 0) | 0) | 0;
   _pthread_cleanup_pop(0);
   i14 = i11;
  }
  if ((i13 | 0) == (i14 | 0)) {
   i15 = 6;
   break;
  }
  if ((i14 | 0) < 0) {
   i16 = i12;
   i17 = i7;
   i15 = 8;
   break;
  }
  i11 = i13 - i14 | 0;
  i18 = HEAP32[i12 + 4 >> 2] | 0;
  if (i14 >>> 0 <= i18 >>> 0) if ((i7 | 0) == 2) {
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i14;
   i19 = i18;
   i20 = i14;
   i21 = i12;
   i22 = 2;
  } else {
   i19 = i18;
   i20 = i14;
   i21 = i12;
   i22 = i7;
  } else {
   i23 = HEAP32[i9 >> 2] | 0;
   HEAP32[i8 >> 2] = i23;
   HEAP32[i10 >> 2] = i23;
   i19 = HEAP32[i12 + 12 >> 2] | 0;
   i20 = i14 - i18 | 0;
   i21 = i12 + 8 | 0;
   i22 = i7 + -1 | 0;
  }
  HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + i20;
  HEAP32[i21 + 4 >> 2] = i19 - i20;
  i12 = i21;
  i7 = i22;
  i13 = i11;
 }
 if ((i15 | 0) == 6) {
  i13 = HEAP32[i9 >> 2] | 0;
  HEAP32[i1 + 16 >> 2] = i13 + (HEAP32[i1 + 48 >> 2] | 0);
  i9 = i13;
  HEAP32[i8 >> 2] = i9;
  HEAP32[i10 >> 2] = i9;
  i24 = i3;
 } else if ((i15 | 0) == 8) {
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 32;
  if ((i17 | 0) == 2) i24 = 0; else i24 = i3 - (HEAP32[i16 + 4 >> 2] | 0) | 0;
 }
 STACKTOP = i4;
 return i24 | 0;
}

function _wcsnrtombs(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 i6 = i5 + 8 | 0;
 i7 = i5;
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 >> 2] = i8;
 i9 = (i1 | 0) != 0;
 i10 = i9 ? i4 : 256;
 i4 = i9 ? i1 : i6;
 i1 = i8;
 L1 : do if ((i10 | 0) != 0 & (i8 | 0) != 0) {
  i11 = i3;
  i12 = i10;
  i13 = i1;
  i14 = 0;
  i15 = i4;
  while (1) {
   i16 = i11 >>> 0 >= i12 >>> 0;
   if (!(i16 | i11 >>> 0 > 32)) {
    i17 = i11;
    i18 = i12;
    i19 = i13;
    i20 = i14;
    i21 = i15;
    break L1;
   }
   i22 = i16 ? i12 : i11;
   i16 = i11 - i22 | 0;
   i23 = _wcsrtombs(i15, i7, i22, 0) | 0;
   if ((i23 | 0) == -1) {
    i24 = i16;
    i25 = i15;
    break;
   }
   i22 = (i15 | 0) == (i6 | 0);
   i26 = i22 ? 0 : i23;
   i27 = i12 - i26 | 0;
   i28 = i22 ? i15 : i15 + i23 | 0;
   i22 = i23 + i14 | 0;
   i23 = HEAP32[i7 >> 2] | 0;
   if ((i12 | 0) != (i26 | 0) & (i23 | 0) != 0) {
    i11 = i16;
    i12 = i27;
    i13 = i23;
    i14 = i22;
    i15 = i28;
   } else {
    i17 = i16;
    i18 = i27;
    i19 = i23;
    i20 = i22;
    i21 = i28;
    break L1;
   }
  }
  i17 = i24;
  i18 = 0;
  i19 = HEAP32[i7 >> 2] | 0;
  i20 = -1;
  i21 = i25;
 } else {
  i17 = i3;
  i18 = i10;
  i19 = i1;
  i20 = 0;
  i21 = i4;
 } while (0);
 L8 : do if ((i19 | 0) != 0 ? (i18 | 0) != 0 & (i17 | 0) != 0 : 0) {
  i4 = i17;
  i1 = i18;
  i10 = i19;
  i3 = i20;
  i25 = i21;
  while (1) {
   i24 = _wcrtomb(i25, HEAP32[i10 >> 2] | 0, 0) | 0;
   if ((i24 + 1 | 0) >>> 0 < 2) {
    i29 = i24;
    i30 = i3;
    break;
   }
   i10 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
   HEAP32[i7 >> 2] = i10;
   i4 = i4 + -1 | 0;
   i6 = i3 + 1 | 0;
   if (!((i1 | 0) != (i24 | 0) & (i4 | 0) != 0)) {
    i31 = i6;
    break L8;
   } else {
    i1 = i1 - i24 | 0;
    i3 = i6;
    i25 = i25 + i24 | 0;
   }
  }
  if (!i29) {
   HEAP32[i7 >> 2] = 0;
   i31 = i30;
  } else i31 = -1;
 } else i31 = i20; while (0);
 if (i9) HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 STACKTOP = i5;
 return i31 | 0;
}

function __ZNSt3__16vectorIdNS_9allocatorIdEEE6assignIPdEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIdNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i4 = i2;
 i5 = i3 - i4 >> 3;
 i6 = i1 + 8 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = i8;
 if (i5 >>> 0 <= i7 - i9 >> 3 >>> 0) {
  i10 = i1 + 4 | 0;
  i11 = (HEAP32[i10 >> 2] | 0) - i9 >> 3;
  i12 = i5 >>> 0 > i11 >>> 0;
  i13 = i12 ? i2 + (i11 << 3) | 0 : i3;
  i11 = i13;
  i14 = i11 - i4 | 0;
  _memmove(i8 | 0, i2 | 0, i14 | 0) | 0;
  i15 = i8 + (i14 >> 3 << 3) | 0;
  if (!i12) {
   i12 = HEAP32[i10 >> 2] | 0;
   if ((i12 | 0) == (i15 | 0)) return;
   HEAP32[i10 >> 2] = i12 + (~((i12 + -8 - i15 | 0) >>> 3) << 3);
   return;
  }
  if ((i13 | 0) == (i3 | 0)) return;
  i15 = HEAP32[i10 >> 2] | 0;
  i12 = (i3 + -8 - i11 | 0) >>> 3;
  i11 = i13;
  i13 = i15;
  while (1) {
   HEAPF64[i13 >> 3] = +HEAPF64[i11 >> 3];
   i11 = i11 + 8 | 0;
   if ((i11 | 0) == (i3 | 0)) break; else i13 = i13 + 8 | 0;
  }
  HEAP32[i10 >> 2] = i15 + (i12 + 1 << 3);
  return;
 }
 if (!i8) i16 = i7; else {
  i7 = i1 + 4 | 0;
  i12 = HEAP32[i7 >> 2] | 0;
  if ((i12 | 0) != (i8 | 0)) HEAP32[i7 >> 2] = i12 + (~((i12 + -8 - i9 | 0) >>> 3) << 3);
  __ZdlPv(i8);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i16 = 0;
 }
 if (i5 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1);
 i7 = i16 - 0 | 0;
 if (i7 >> 3 >>> 0 < 268435455) {
  i16 = i7 >> 2;
  i7 = i16 >>> 0 < i5 >>> 0 ? i5 : i16;
  if (i7 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1); else i17 = i7;
 } else i17 = 536870911;
 i7 = __Znwj(i17 << 3) | 0;
 i16 = i1 + 4 | 0;
 HEAP32[i16 >> 2] = i7;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i6 >> 2] = i7 + (i17 << 3);
 if ((i2 | 0) == (i3 | 0)) return;
 i17 = (i3 + -8 - i4 | 0) >>> 3;
 i4 = i2;
 i2 = i7;
 while (1) {
  HEAPF64[i2 >> 3] = +HEAPF64[i4 >> 3];
  i4 = i4 + 8 | 0;
  if ((i4 | 0) == (i3 | 0)) break; else i2 = i2 + 8 | 0;
 }
 HEAP32[i16 >> 2] = i7 + (i17 + 1 << 3);
 return;
}

function __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i12 = (i11 | 0) == (i3 | 0);
 do if (i12) {
  i13 = (HEAP8[i10 + 24 >> 0] | 0) == i1 << 24 >> 24;
  if (!i13 ? (HEAP8[i10 + 25 >> 0] | 0) != i1 << 24 >> 24 : 0) {
   i14 = 5;
   break;
  }
  HEAP32[i4 >> 2] = i3 + 1;
  HEAP8[i3 >> 0] = i13 ? 43 : 45;
  HEAP32[i5 >> 2] = 0;
  i15 = 0;
 } else i14 = 5; while (0);
 L6 : do if ((i14 | 0) == 5) {
  i13 = HEAP8[i7 >> 0] | 0;
  if (i1 << 24 >> 24 == i6 << 24 >> 24 ? (((i13 & 1) == 0 ? (i13 & 255) >>> 1 : HEAP32[i7 + 4 >> 2] | 0) | 0) != 0 : 0) {
   i13 = HEAP32[i9 >> 2] | 0;
   if ((i13 - i8 | 0) >= 160) {
    i15 = 0;
    break;
   }
   i16 = HEAP32[i5 >> 2] | 0;
   HEAP32[i9 >> 2] = i13 + 4;
   HEAP32[i13 >> 2] = i16;
   HEAP32[i5 >> 2] = 0;
   i15 = 0;
   break;
  }
  i16 = i10 + 26 | 0;
  i13 = i10;
  while (1) {
   if ((HEAP8[i13 >> 0] | 0) == i1 << 24 >> 24) {
    i17 = i13;
    break;
   }
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i16 | 0)) {
    i17 = i16;
    break;
   }
  }
  i16 = i17 - i10 | 0;
  if ((i16 | 0) > 23) i15 = -1; else {
   switch (i2 | 0) {
   case 10:
   case 8:
    {
     if ((i16 | 0) >= (i2 | 0)) {
      i15 = -1;
      break L6;
     }
     break;
    }
   case 16:
    {
     if ((i16 | 0) >= 22) {
      if (i12) {
       i15 = -1;
       break L6;
      }
      if ((i11 - i3 | 0) >= 3) {
       i15 = -1;
       break L6;
      }
      if ((HEAP8[i11 + -1 >> 0] | 0) != 48) {
       i15 = -1;
       break L6;
      }
      HEAP32[i5 >> 2] = 0;
      i13 = HEAP8[46161 + i16 >> 0] | 0;
      HEAP32[i4 >> 2] = i11 + 1;
      HEAP8[i11 >> 0] = i13;
      i15 = 0;
      break L6;
     }
     break;
    }
   default:
    {}
   }
   i13 = HEAP8[46161 + i16 >> 0] | 0;
   HEAP32[i4 >> 2] = i11 + 1;
   HEAP8[i11 >> 0] = i13;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   i15 = 0;
  }
 } while (0);
 return i15 | 0;
}

function __ZN7maxiEnv4adsrEdddddli(i1, d2, d3, d4, d5, d6, i7, i8) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, d15 = 0.0, d16 = 0.0, i17 = 0, d18 = 0.0, d19 = 0.0, i20 = 0, i21 = 0, d22 = 0.0;
 i9 = (i8 | 0) == 1;
 i10 = i1 + 68 | 0;
 i11 = (HEAP32[i10 >> 2] | 0) == 1;
 if (i9) if (!i11) if ((HEAP32[i1 + 80 >> 2] | 0) != 1 ? (i12 = i1 + 72 | 0, (HEAP32[i12 >> 2] | 0) != 1) : 0) {
  HEAP32[i1 + 64 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i1 + 76 >> 2] = 0;
  HEAP32[i1 + 84 >> 2] = 0;
  HEAP32[i10 >> 2] = 1;
  i13 = 8;
 } else i13 = 7; else i13 = 8; else if (i11) i13 = 8; else i13 = 7;
 if ((i13 | 0) == 7) {
  i11 = i1 + 48 | 0;
  i14 = i11;
  d15 = +HEAPF64[i11 >> 3];
 } else if ((i13 | 0) == 8) {
  i11 = i1 + 48 | 0;
  d16 = +HEAPF64[i11 >> 3] + d3;
  HEAPF64[i11 >> 3] = d16;
  HEAPF64[i1 + 8 >> 3] = d16 * d2;
  i14 = i11;
  d15 = d16;
 }
 if (!(d15 >= 1.0)) {
  i11 = i1 + 72 | 0;
  if ((HEAP32[i11 >> 2] | 0) == 1) {
   i17 = i11;
   d18 = d15;
   i13 = 12;
  } else d19 = d15;
 } else {
  HEAPF64[i14 >> 3] = 1.0;
  HEAP32[i10 >> 2] = 0;
  i10 = i1 + 72 | 0;
  HEAP32[i10 >> 2] = 1;
  i17 = i10;
  d18 = 1.0;
  i13 = 12;
 }
 if ((i13 | 0) == 12) {
  d15 = d18 * d4;
  HEAPF64[i14 >> 3] = d15;
  HEAPF64[i1 + 8 >> 3] = d15 * d2;
  if (!(d15 <= d5)) d19 = d15; else {
   HEAP32[i17 >> 2] = 0;
   HEAP32[i1 + 80 >> 2] = 1;
   d19 = d15;
  }
 }
 i17 = i1 + 64 | 0;
 i13 = HEAP32[i17 >> 2] | 0;
 if ((i13 | 0) < (i7 | 0) ? (HEAP32[i1 + 80 >> 2] | 0) == 1 : 0) {
  HEAPF64[i1 + 8 >> 3] = d19 * d2;
  i10 = i13 + 1 | 0;
  HEAP32[i17 >> 2] = i10;
  i20 = i10;
 } else i20 = i13;
 i13 = (i20 | 0) == (i7 | 0);
 if (i9 & i13) HEAPF64[i1 + 8 >> 3] = d19 * d2;
 if ((i8 | 0) != 1 & i13) {
  HEAP32[i1 + 80 >> 2] = 0;
  HEAP32[i1 + 84 >> 2] = 1;
  if (!(d19 > 0.0)) {
   i21 = i1 + 8 | 0;
   d22 = +HEAPF64[i21 >> 3];
   return +d22;
  }
 } else if (!(d19 > 0.0 ? (HEAP32[i1 + 84 >> 2] | 0) == 1 : 0)) {
  i21 = i1 + 8 | 0;
  d22 = +HEAPF64[i21 >> 3];
  return +d22;
 }
 d15 = d19 * d6;
 HEAPF64[i14 >> 3] = d15;
 HEAPF64[i1 + 8 >> 3] = d15 * d2;
 i21 = i1 + 8 | 0;
 d22 = +HEAPF64[i21 >> 3];
 return +d22;
}

function __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i12 = (i11 | 0) == (i3 | 0);
 do if (i12) {
  i13 = (HEAP32[i10 + 96 >> 2] | 0) == (i1 | 0);
  if (!i13 ? (HEAP32[i10 + 100 >> 2] | 0) != (i1 | 0) : 0) {
   i14 = 5;
   break;
  }
  HEAP32[i4 >> 2] = i3 + 1;
  HEAP8[i3 >> 0] = i13 ? 43 : 45;
  HEAP32[i5 >> 2] = 0;
  i15 = 0;
 } else i14 = 5; while (0);
 L6 : do if ((i14 | 0) == 5) {
  i13 = HEAP8[i7 >> 0] | 0;
  if ((i1 | 0) == (i6 | 0) ? (((i13 & 1) == 0 ? (i13 & 255) >>> 1 : HEAP32[i7 + 4 >> 2] | 0) | 0) != 0 : 0) {
   i13 = HEAP32[i9 >> 2] | 0;
   if ((i13 - i8 | 0) >= 160) {
    i15 = 0;
    break;
   }
   i16 = HEAP32[i5 >> 2] | 0;
   HEAP32[i9 >> 2] = i13 + 4;
   HEAP32[i13 >> 2] = i16;
   HEAP32[i5 >> 2] = 0;
   i15 = 0;
   break;
  }
  i16 = i10 + 104 | 0;
  i13 = i10;
  while (1) {
   if ((HEAP32[i13 >> 2] | 0) == (i1 | 0)) {
    i17 = i13;
    break;
   }
   i13 = i13 + 4 | 0;
   if ((i13 | 0) == (i16 | 0)) {
    i17 = i16;
    break;
   }
  }
  i16 = i17 - i10 | 0;
  i13 = i16 >> 2;
  if ((i16 | 0) > 92) i15 = -1; else {
   switch (i2 | 0) {
   case 10:
   case 8:
    {
     if ((i13 | 0) >= (i2 | 0)) {
      i15 = -1;
      break L6;
     }
     break;
    }
   case 16:
    {
     if ((i16 | 0) >= 88) {
      if (i12) {
       i15 = -1;
       break L6;
      }
      if ((i11 - i3 | 0) >= 3) {
       i15 = -1;
       break L6;
      }
      if ((HEAP8[i11 + -1 >> 0] | 0) != 48) {
       i15 = -1;
       break L6;
      }
      HEAP32[i5 >> 2] = 0;
      i16 = HEAP8[46161 + i13 >> 0] | 0;
      HEAP32[i4 >> 2] = i11 + 1;
      HEAP8[i11 >> 0] = i16;
      i15 = 0;
      break L6;
     }
     break;
    }
   default:
    {}
   }
   i16 = HEAP8[46161 + i13 >> 0] | 0;
   HEAP32[i4 >> 2] = i11 + 1;
   HEAP8[i11 >> 0] = i16;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   i15 = 0;
  }
 } while (0);
 return i15 | 0;
}

function __ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i2;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = HEAP8[i6 >> 0] | 0;
 i9 = (i8 & 1) == 0;
 i10 = i9 ? i6 + 1 | 0 : HEAP32[i6 + 8 >> 2] | 0;
 i11 = i9 ? (i8 & 255) >>> 1 : HEAP32[i6 + 4 >> 2] | 0;
 i6 = i10 + i11 | 0;
 L1 : do if ((i11 | 0) > 0) {
  i8 = i10;
  while (1) {
   __THREW__ = 0;
   invoke_vii(67, i7 | 0, HEAP8[i8 >> 0] | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) break;
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= i6 >>> 0) {
    i12 = 4;
    break L1;
   }
  }
  i8 = ___cxa_find_matching_catch() | 0;
  i13 = i8;
  i14 = tempRet0;
  i12 = 7;
 } else i12 = 4; while (0);
 L6 : do if ((i12 | 0) == 4) {
  __THREW__ = 0;
  i6 = invoke_iiiii(12, ((i3 | 0) == -1 ? -1 : i3 << 1) | 0, i4 | 0, i5 | 0, ((HEAP8[i7 >> 0] & 1) == 0 ? i7 + 1 | 0 : HEAP32[i7 + 8 >> 2] | 0) | 0) | 0;
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) {
   i10 = ___cxa_find_matching_catch() | 0;
   i13 = i10;
   i14 = tempRet0;
   i12 = 7;
   break;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i10 = _strlen(i6) | 0;
  i11 = i6 + i10 | 0;
  L11 : do if ((i10 | 0) > 0) {
   i8 = i6;
   while (1) {
    __THREW__ = 0;
    invoke_vii(67, i1 | 0, HEAP8[i8 >> 0] | 0);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) break;
    i8 = i8 + 1 | 0;
    if (i8 >>> 0 >= i11 >>> 0) break L11;
   }
   i8 = ___cxa_find_matching_catch() | 0;
   i9 = tempRet0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
   i15 = i8;
   i16 = i9;
   break L6;
  } while (0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i2;
  return;
 } while (0);
 if ((i12 | 0) == 7) {
  i15 = i13;
  i16 = i14;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i15 | 0);
}

function __ZNSt3__110shared_ptrI20maxiEnvelopeFollowerEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 19032;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(60, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI14maxiDistortionEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 18768;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(57, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI13maxiDelaylineEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 17792;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(48, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI10maxiLagExpIdEEC2IS2_N10emscripten15smart_ptr_traitIS3_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleISA_PS2_EE5valueENS3_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 18124;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(51, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI12maxiEnvelopeEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 17700;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(47, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI11maxiFlangerEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 18856;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(58, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI10maxiSampleEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 18220;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(52, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI10maxiFilterEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 17896;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(49, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI10maxiChorusEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 18944;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(59, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI8maxiTestEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 17476;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(45, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI7maxiOscEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 17572;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(46, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI7maxiMixEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 17992;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(50, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI7maxiMapEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 18356;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(53, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI7maxiEnvEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 18572;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(55, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI7maxiDynEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 18456;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(54, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZNSt3__110shared_ptrI7convertEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 __THREW__ = 0;
 i4 = invoke_ii(125, 20) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __THREW__ = 0;
  invoke_vi(279, i6 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   __ZdlPv(i4);
   i8 = i7;
   break;
  }
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 18696;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  }
  HEAP32[i4 + 16 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i2;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  HEAP32[i1 + 4 >> 2] = i4;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  } else return;
 } else {
  i6 = ___cxa_find_matching_catch(0) | 0;
  i8 = i6;
 } while (0);
 ___cxa_begin_catch(i8 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(56, i3 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (!(i2 & 1)) {
  __THREW__ = 0;
  invoke_v(2);
  __THREW__ = 0;
 }
 i2 = ___cxa_find_matching_catch() | 0;
 __THREW__ = 0;
 invoke_v(3);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else ___resumeException(i2 | 0);
}

function __ZN10maxiSample4playEdddRd(i1, d2, d3, d4, i5) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, d10 = 0.0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, d16 = 0.0, d17 = 0.0, d18 = 0.0;
 i6 = HEAP32[i1 + 84 >> 2] | 0;
 i7 = i6 + -1 | 0;
 d8 = !(+(i6 | 0) <= d4) ? d4 : +(i7 | 0);
 if (!(d2 > 0.0)) {
  d4 = +HEAPF64[i5 >> 3];
  if (!(d4 <= d3)) d9 = d4; else {
   HEAPF64[i5 >> 3] = d8;
   d9 = d8;
  }
  d4 = d9 - (d8 - d3) / (+(HEAP32[4327] | 0) / ((d2 - (d2 + d2)) * +HEAPF32[4326]));
  HEAPF64[i5 >> 3] = d4;
  d9 = +Math_floor(+d4);
  d10 = d4 - d9;
  i11 = ~~d9;
  i12 = (i11 | 0) > 0 ? i11 + -1 | 0 : 0;
  i13 = i11 + -2 | 0;
  i11 = (i13 | 0) < 0 ? 0 : i13;
  i13 = i1 + 96 | 0;
  i14 = HEAP32[i1 + 100 >> 2] | 0;
  i15 = HEAP32[i13 >> 2] | 0;
  if (i14 - i15 >> 3 >>> 0 <= i12 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i13);
  d9 = (-1.0 - d10) * +HEAPF64[i15 + (i12 << 3) >> 3];
  if (i14 - i15 >> 3 >>> 0 <= i11 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i13);
  d4 = d9 + d10 * +HEAPF64[i15 + (i11 << 3) >> 3];
  HEAPF64[i1 + 64 >> 3] = d4;
  d16 = d4;
  return +d16;
 }
 d4 = +HEAPF64[i5 >> 3];
 if (d4 < d3) {
  HEAPF64[i5 >> 3] = d3;
  d17 = d3;
 } else d17 = d4;
 if (!(d17 >= d8)) d18 = d17; else {
  HEAPF64[i5 >> 3] = d3;
  d18 = d3;
 }
 d17 = (d8 - d3) / (+(HEAP32[4327] | 0) / (+HEAPF32[4326] * d2)) + d18;
 HEAPF64[i5 >> 3] = d17;
 d18 = +Math_floor(+d17);
 d2 = d17 - d18;
 i5 = ~~d18;
 i11 = i5 + 1 | 0;
 i15 = (i11 | 0) < (i6 | 0) ? i11 : i5 + -1 | 0;
 i11 = i5 + 2 | 0;
 i5 = (i11 | 0) < (i6 | 0) ? i11 : i7;
 i7 = i1 + 96 | 0;
 i11 = HEAP32[i1 + 100 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 if (i11 - i6 >> 3 >>> 0 <= i15 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i7);
 d18 = (1.0 - d2) * +HEAPF64[i6 + (i15 << 3) >> 3];
 if (i11 - i6 >> 3 >>> 0 <= i5 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i7);
 d17 = d18 + d2 * +HEAPF64[i6 + (i5 << 3) >> 3];
 HEAPF64[i1 + 64 >> 3] = d17;
 d16 = d17;
 return +d16;
}

function __ZNKSt3__120__time_get_c_storageIcE7__weeksEv(i1) {
 i1 = i1 | 0;
 do if ((HEAP8[16896] | 0) == 0 ? (___cxa_guard_acquire(16896) | 0) != 0 : 0) {
  if ((HEAP8[16904] | 0) == 0 ? (___cxa_guard_acquire(16904) | 0) != 0 : 0) {
   i1 = 27400;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != 27568);
   ___cxa_atexit(291, 0, ___dso_handle | 0) | 0;
   ___cxa_guard_release(16904);
  }
  __THREW__ = 0;
  invoke_iii(58, 27400, 47705) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (((((((((((((!(i1 & 1) ? (__THREW__ = 0, invoke_iii(58, 27412, 47712) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27424, 47719) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27436, 47727) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27448, 47737) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27460, 47746) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27472, 47753) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27484, 47762) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27496, 47766) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27508, 47770) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27520, 47774) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27532, 47778) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27544, 47782) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(58, 27556, 47786) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) {
   HEAP32[6892] = 27400;
   ___cxa_guard_release(16896);
   break;
  }
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(16896);
  ___resumeException(i1 | 0);
 } while (0);
 return HEAP32[6892] | 0;
}

function __ZNKSt3__120__time_get_c_storageIwE7__weeksEv(i1) {
 i1 = i1 | 0;
 do if ((HEAP8[16912] | 0) == 0 ? (___cxa_guard_acquire(16912) | 0) != 0 : 0) {
  if ((HEAP8[16920] | 0) == 0 ? (___cxa_guard_acquire(16920) | 0) != 0 : 0) {
   i1 = 27572;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != 27740);
   ___cxa_atexit(292, 0, ___dso_handle | 0) | 0;
   ___cxa_guard_release(16920);
  }
  __THREW__ = 0;
  invoke_iii(59, 27572, 27740) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (((((((((((((!(i1 & 1) ? (__THREW__ = 0, invoke_iii(59, 27584, 27768) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27596, 27796) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27608, 27828) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27620, 27868) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27632, 27904) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27644, 27932) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27656, 27968) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27668, 27984) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27680, 28e3) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27692, 28016) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27704, 28032) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27716, 28048) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_iii(59, 27728, 28064) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) {
   HEAP32[7020] = 27572;
   ___cxa_guard_release(16912);
   break;
  }
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(16912);
  ___resumeException(i1 | 0);
 } while (0);
 return HEAP32[7020] | 0;
}

function _memchr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i4 = i2 & 255;
 i5 = (i3 | 0) != 0;
 L1 : do if (i5 & (i1 & 3 | 0) != 0) {
  i6 = i2 & 255;
  i7 = i3;
  i8 = i1;
  while (1) {
   if ((HEAP8[i8 >> 0] | 0) == i6 << 24 >> 24) {
    i9 = i7;
    i10 = i8;
    i11 = 6;
    break L1;
   }
   i12 = i8 + 1 | 0;
   i13 = i7 + -1 | 0;
   i14 = (i13 | 0) != 0;
   if (i14 & (i12 & 3 | 0) != 0) {
    i7 = i13;
    i8 = i12;
   } else {
    i15 = i13;
    i16 = i14;
    i17 = i12;
    i11 = 5;
    break;
   }
  }
 } else {
  i15 = i3;
  i16 = i5;
  i17 = i1;
  i11 = 5;
 } while (0);
 if ((i11 | 0) == 5) if (i16) {
  i9 = i15;
  i10 = i17;
  i11 = 6;
 } else {
  i18 = 0;
  i19 = i17;
 }
 L8 : do if ((i11 | 0) == 6) {
  i17 = i2 & 255;
  if ((HEAP8[i10 >> 0] | 0) == i17 << 24 >> 24) {
   i18 = i9;
   i19 = i10;
  } else {
   i15 = Math_imul(i4, 16843009) | 0;
   L11 : do if (i9 >>> 0 > 3) {
    i16 = i9;
    i1 = i10;
    while (1) {
     i5 = HEAP32[i1 >> 2] ^ i15;
     if ((i5 & -2139062144 ^ -2139062144) & i5 + -16843009) {
      i20 = i16;
      i21 = i1;
      break;
     }
     i5 = i1 + 4 | 0;
     i3 = i16 + -4 | 0;
     if (i3 >>> 0 > 3) {
      i16 = i3;
      i1 = i5;
     } else {
      i22 = i3;
      i23 = i5;
      i11 = 11;
      break L11;
     }
    }
    i24 = i20;
    i25 = i21;
   } else {
    i22 = i9;
    i23 = i10;
    i11 = 11;
   } while (0);
   if ((i11 | 0) == 11) if (!i22) {
    i18 = 0;
    i19 = i23;
    break;
   } else {
    i24 = i22;
    i25 = i23;
   }
   while (1) {
    if ((HEAP8[i25 >> 0] | 0) == i17 << 24 >> 24) {
     i18 = i24;
     i19 = i25;
     break L8;
    }
    i15 = i25 + 1 | 0;
    i24 = i24 + -1 | 0;
    if (!i24) {
     i18 = 0;
     i19 = i15;
     break;
    } else i25 = i15;
   }
  }
 } while (0);
 return ((i18 | 0) != 0 ? i19 : 0) | 0;
}

function ___cxx_global_array_dtor120(i1) {
 i1 = i1 | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29756);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29744);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29732);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29720);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29708);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29696);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29684);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29672);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29660);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29648);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29636);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29624);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29612);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29600);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29588);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29576);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29564);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29552);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29540);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29528);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29516);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29504);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29492);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(29480);
 return;
}

function ___cxx_global_array_dtor117(i1) {
 i1 = i1 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29464);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29452);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29440);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29428);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29416);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29404);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29392);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29380);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29368);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29356);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29344);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29332);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29320);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29308);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29296);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29284);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29272);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29260);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29248);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29236);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29224);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29212);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29200);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(29188);
 return;
}

function ___cxx_global_array_dtor93(i1) {
 i1 = i1 | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28652);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28640);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28628);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28616);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28604);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28592);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28580);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28568);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28556);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28544);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28532);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28520);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28508);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28496);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28484);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28472);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28460);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28448);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28436);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28424);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28412);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28400);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28388);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(28376);
 return;
}

function ___cxx_global_array_dtor69(i1) {
 i1 = i1 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28360);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28348);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28336);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28324);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28312);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28300);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28288);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28276);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28264);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28252);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28240);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28228);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28216);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28204);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28192);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28180);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28168);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28156);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28144);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28132);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28120);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28108);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28096);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(28084);
 return;
}

function _mbrtowc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 i7 = (i4 | 0) == 0 ? 19728 : i4;
 i4 = HEAP32[i7 >> 2] | 0;
 L1 : do if (!i2) if (!i4) i8 = 0; else i9 = 15; else {
  i10 = (i1 | 0) == 0 ? i6 : i1;
  if (!i3) i8 = -2; else {
   if (!i4) {
    i11 = HEAP8[i2 >> 0] | 0;
    i12 = i11 & 255;
    if (i11 << 24 >> 24 > -1) {
     HEAP32[i10 >> 2] = i12;
     i8 = i11 << 24 >> 24 != 0 & 1;
     break;
    }
    i11 = i12 + -194 | 0;
    if (i11 >>> 0 > 50) {
     i9 = 15;
     break;
    }
    i12 = HEAP32[19456 + (i11 << 2) >> 2] | 0;
    i11 = i3 + -1 | 0;
    if (!i11) i13 = i12; else {
     i14 = i11;
     i15 = i12;
     i16 = i2 + 1 | 0;
     i9 = 9;
    }
   } else {
    i14 = i3;
    i15 = i4;
    i16 = i2;
    i9 = 9;
   }
   L11 : do if ((i9 | 0) == 9) {
    i12 = HEAP8[i16 >> 0] | 0;
    i11 = (i12 & 255) >>> 3;
    if ((i11 + -16 | i11 + (i15 >> 26)) >>> 0 > 7) {
     i9 = 15;
     break L1;
    } else {
     i17 = i14;
     i18 = i12;
     i19 = i15;
     i20 = i16;
    }
    while (1) {
     i20 = i20 + 1 | 0;
     i19 = (i18 & 255) + -128 | i19 << 6;
     i17 = i17 + -1 | 0;
     if ((i19 | 0) >= 0) {
      i21 = i19;
      i22 = i17;
      break;
     }
     if (!i17) {
      i13 = i19;
      break L11;
     }
     i18 = HEAP8[i20 >> 0] | 0;
     if ((i18 & -64) << 24 >> 24 != -128) {
      i9 = 15;
      break L1;
     }
    }
    HEAP32[i7 >> 2] = 0;
    HEAP32[i10 >> 2] = i21;
    i8 = i3 - i22 | 0;
    break L1;
   } while (0);
   HEAP32[i7 >> 2] = i13;
   i8 = -2;
  }
 } while (0);
 if ((i9 | 0) == 15) {
  HEAP32[i7 >> 2] = 0;
  i7 = ___errno_location() | 0;
  HEAP32[i7 >> 2] = 84;
  i8 = -1;
 }
 STACKTOP = i5;
 return i8 | 0;
}

function __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7;
 i9 = HEAP32[i1 >> 2] | 0;
 L1 : do if (!i9) i10 = 0; else {
  i11 = i4;
  i12 = i2;
  i13 = i11 - i12 >> 2;
  i14 = i5 + 12 | 0;
  i15 = HEAP32[i14 >> 2] | 0;
  i16 = (i15 | 0) > (i13 | 0) ? i15 - i13 | 0 : 0;
  i13 = i3;
  i15 = i13 - i12 | 0;
  i12 = i15 >> 2;
  if ((i15 | 0) > 0 ? (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i2, i12) | 0) != (i12 | 0) : 0) {
   HEAP32[i1 >> 2] = 0;
   i10 = 0;
   break;
  }
  do if ((i16 | 0) > 0) {
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i8, i16, i6);
   __THREW__ = 0;
   i12 = invoke_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] | 0, i9 | 0, ((HEAP8[i8 >> 0] & 1) == 0 ? i8 + 4 | 0 : HEAP32[i8 + 8 >> 2] | 0) | 0, i16 | 0) | 0;
   i15 = __THREW__;
   __THREW__ = 0;
   if (i15 & 1) {
    i15 = ___cxa_find_matching_catch() | 0;
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
    ___resumeException(i15 | 0);
   }
   if ((i12 | 0) == (i16 | 0)) {
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
    break;
   } else {
    HEAP32[i1 >> 2] = 0;
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
    i10 = 0;
    break L1;
   }
  } while (0);
  i16 = i11 - i13 | 0;
  i12 = i16 >> 2;
  if ((i16 | 0) > 0 ? (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i3, i12) | 0) != (i12 | 0) : 0) {
   HEAP32[i1 >> 2] = 0;
   i10 = 0;
   break;
  }
  HEAP32[i14 >> 2] = 0;
  i10 = i9;
 } while (0);
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN10maxiChorus6chorusEdjddd(i1, d2, i3, d4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 var d7 = 0.0, d8 = 0.0, i9 = 0, d10 = 0.0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0;
 d7 = +(_rand() | 0) * 4.656612873077393e-10 * 2.0 + -1.0;
 HEAPF64[i1 + 1411312 >> 3] = d7;
 d8 = d5 * .5;
 i9 = i1 + 1411552 | 0;
 d5 = d8 < 10.0 ? 10.0 : d8;
 HEAPF64[i9 >> 3] = d5;
 d8 = +(HEAP32[4327] | 0);
 d10 = d8 * .5;
 if (d5 > d10) {
  HEAPF64[i9 >> 3] = d10;
  d11 = d10;
 } else d11 = d5;
 d5 = +Math_cos(+(d11 * 6.283185307179586 / d8));
 HEAPF64[i1 + 1411536 >> 3] = d5;
 d8 = 2.0 - d5 * 2.0;
 HEAPF64[i1 + 1411544 >> 3] = d8;
 d11 = d5 + -1.0;
 d5 = (d11 + +Math_sqrt(+-+Math_pow(+d11, 3.0)) * 1.4142135623730951) / d11;
 i9 = i1 + 1411520 | 0;
 i12 = i1 + 1411528 | 0;
 d11 = +HEAPF64[i12 >> 3];
 d10 = +HEAPF64[i9 >> 3] + d8 * (d7 - d11);
 d7 = d11 + d10;
 HEAPF64[i12 >> 3] = d7;
 HEAPF64[i9 >> 3] = d5 * d10;
 HEAPF64[i1 + 1411344 >> 3] = d7;
 d10 = +(i3 >>> 0);
 d5 = d10 * (d7 * 2.0 * d6);
 i3 = i1 + 8 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 if ((i9 | 0) < (~~(d10 + d5 + 1.0) | 0)) i13 = i9; else {
  HEAP32[i3 >> 2] = 0;
  i13 = 0;
 }
 i9 = i1 + 40 + (i13 << 3) | 0;
 i13 = i1 + 32 | 0;
 HEAPF64[i13 >> 3] = +HEAPF64[i9 >> 3];
 HEAPF64[i9 >> 3] = d2 * d4 * .5 + +HEAPF64[i9 >> 3] * d4;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 d6 = +HEAPF64[i13 >> 3];
 d7 = d4 * .99;
 i13 = i1 + 705648 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if ((i3 | 0) < (~~((d10 + d5 * 1.02 + 1.0) * .98) | 0)) i14 = i3; else {
  HEAP32[i13 >> 2] = 0;
  i14 = 0;
 }
 i3 = i1 + 705680 + (i14 << 3) | 0;
 i14 = i1 + 705672 | 0;
 HEAPF64[i14 >> 3] = +HEAPF64[i3 >> 3];
 HEAPF64[i3 >> 3] = d7 * d2 * .5 + d7 * +HEAPF64[i3 >> 3];
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 d7 = +HEAPF64[i14 >> 3];
 return +((d6 * (1.0 - +Math_abs(+d6)) + d7 * (1.0 - +Math_abs(+d7)) + d2) / 3.0);
}

function __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7;
 i9 = HEAP32[i1 >> 2] | 0;
 if (!i9) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 i11 = i4;
 i4 = i2;
 i12 = i11 - i4 | 0;
 i13 = i5 + 12 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i14 = (i5 | 0) > (i12 | 0) ? i5 - i12 | 0 : 0;
 i12 = i3;
 i5 = i12 - i4 | 0;
 if ((i5 | 0) > 0 ? (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i2, i5) | 0) != (i5 | 0) : 0) {
  HEAP32[i1 >> 2] = 0;
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 do if ((i14 | 0) > 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i8, i14, i6);
  __THREW__ = 0;
  i5 = invoke_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] | 0, i9 | 0, ((HEAP8[i8 >> 0] & 1) == 0 ? i8 + 1 | 0 : HEAP32[i8 + 8 >> 2] | 0) | 0, i14 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = ___cxa_find_matching_catch() | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   ___resumeException(i2 | 0);
  }
  if ((i5 | 0) == (i14 | 0)) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   break;
  }
  HEAP32[i1 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 } while (0);
 i8 = i11 - i12 | 0;
 if ((i8 | 0) > 0 ? (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i3, i8) | 0) != (i8 | 0) : 0) {
  HEAP32[i1 >> 2] = 0;
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 HEAP32[i13 >> 2] = 0;
 i10 = i9;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI20maxiEnvelopeFollowerEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(25, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI14maxiDistortionEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(22, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI13maxiDelaylineEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(13, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiLagExpIdEEEE5shareEPS4_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(16, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI12maxiEnvelopeEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(12, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI11maxiFlangerEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(23, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiSampleEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(17, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiFilterEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(14, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiChorusEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(24, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI8maxiTestEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(10, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiOscEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(11, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMixEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(15, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMapEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(18, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiEnvEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(20, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiDynEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(19, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7convertEEE5shareEPS3_PNS_8internal7_EM_VALE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i7 = __Znwj(8) | 0;
 __THREW__ = 0;
 invoke_vi(279, i2 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 do if (!(i8 & 1) ? (HEAP32[i4 >> 2] = i2, __THREW__ = 0, i9 = invoke_iii(54, 13248, i4 | 0) | 0, i10 = __THREW__, __THREW__ = 0, !(i10 & 1)) : 0) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = 0;
  __THREW__ = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  invoke_viiii(21, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch() | 0;
   i10 = tempRet0;
   __THREW__ = 0;
   invoke_vi(280, HEAP32[i5 >> 2] | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (!(i11 & 1)) {
    i12 = i10;
    i13 = i9;
    break;
   }
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, HEAP32[i5 >> 2] | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  __THREW__ = 0;
  invoke_vi(280, i2 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  } else {
   STACKTOP = i3;
   return i7 | 0;
  }
 } else i14 = 9; while (0);
 if ((i14 | 0) == 9) {
  i14 = ___cxa_find_matching_catch() | 0;
  i12 = tempRet0;
  i13 = i14;
 }
 __THREW__ = 0;
 invoke_vi(280, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZdlPv(i7);
  ___resumeException(i13 | 0);
 }
 return 0;
}

function __ZN53EmscriptenBindingInitializer_native_and_builtin_typesC2Ev(i1) {
 i1 = i1 | 0;
 __embind_register_void(15048, 38207);
 __embind_register_bool(15064, 38212, 1, 1, 0);
 __embind_register_integer(15072, 38217, 1, -128, 127);
 __embind_register_integer(15088, 38222, 1, -128, 127);
 __embind_register_integer(15080, 38234, 1, 0, 255);
 __embind_register_integer(15096, 38248, 2, -32768, 32767);
 __embind_register_integer(15104, 38254, 2, 0, 65535);
 __embind_register_integer(15112, 38269, 4, -2147483648, 2147483647);
 __embind_register_integer(15120, 38273, 4, 0, -1);
 __embind_register_integer(15128, 38286, 4, -2147483648, 2147483647);
 __embind_register_integer(15136, 38291, 4, 0, -1);
 __embind_register_float(15144, 38305, 4);
 __embind_register_float(15152, 38311, 8);
 __embind_register_std_string(14696, 38318);
 __embind_register_std_string(14720, 38330);
 __embind_register_std_wstring(14744, 4, 38363);
 __embind_register_emval(13248, 38376);
 __embind_register_memory_view(14768, 0, 38392);
 __embind_register_memory_view(14776, 0, 38422);
 __embind_register_memory_view(14784, 1, 38459);
 __embind_register_memory_view(14792, 2, 38498);
 __embind_register_memory_view(14800, 3, 38529);
 __embind_register_memory_view(14808, 4, 38569);
 __embind_register_memory_view(14816, 5, 38598);
 __embind_register_memory_view(14824, 4, 38636);
 __embind_register_memory_view(14832, 5, 38666);
 __embind_register_memory_view(14776, 0, 38705);
 __embind_register_memory_view(14784, 1, 38737);
 __embind_register_memory_view(14792, 2, 38770);
 __embind_register_memory_view(14800, 3, 38803);
 __embind_register_memory_view(14808, 4, 38837);
 __embind_register_memory_view(14816, 5, 38870);
 __embind_register_memory_view(14840, 6, 38904);
 __embind_register_memory_view(14848, 7, 38935);
 __embind_register_memory_view(14856, 7, 38967);
 return;
}

function __ZN10maxiSample4playEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, i5 = 0, d6 = 0.0, d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, d14 = 0.0;
 i3 = i1 + 40 | 0;
 d4 = +HEAPF64[i3 >> 3] + +HEAPF32[4326] * d2 / +((HEAP32[4327] | 0) / (HEAP32[i1 + 80 >> 2] | 0) | 0 | 0);
 HEAPF64[i3 >> 3] = d4;
 i5 = ~~d4;
 if (!(d2 >= 0.0)) {
  if ((i5 | 0) < 0) {
   d2 = +(HEAP32[i1 + 84 >> 2] | 0);
   HEAPF64[i3 >> 3] = d2;
   d6 = d2;
  } else d6 = d4;
  d2 = d6 - +Math_floor(+d6);
  d7 = d6 + -1.0;
  i8 = !(d7 >= 0.0) ? 0 : ~~d7;
  d7 = d6 + -2.0;
  i9 = !(d7 >= 0.0) ? 0 : ~~d7;
  i10 = i1 + 96 | 0;
  i11 = HEAP32[i1 + 100 >> 2] | 0;
  i12 = HEAP32[i10 >> 2] | 0;
  if (i11 - i12 >> 3 >>> 0 <= i8 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i10);
  d7 = (-1.0 - d2) * +HEAPF64[i12 + (i8 << 3) >> 3];
  if (i11 - i12 >> 3 >>> 0 <= i9 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i10);
  d6 = d7 + d2 * +HEAPF64[i12 + (i9 << 3) >> 3];
  HEAPF64[i1 + 64 >> 3] = d6;
  d13 = d6;
  return +d13;
 } else {
  i9 = HEAP32[i1 + 84 >> 2] | 0;
  i12 = i9 + -1 | 0;
  if ((i5 | 0) < (i12 | 0)) d14 = d4; else {
   HEAPF64[i3 >> 3] = 1.0;
   d14 = 1.0;
  }
  d4 = d14 - +Math_floor(+d14);
  d6 = d14 + 1.0;
  d2 = +(i9 | 0);
  i9 = d6 < d2 ? ~~d6 : i12;
  d6 = d14 + 2.0;
  i3 = d6 < d2 ? ~~d6 : i12;
  i12 = i1 + 96 | 0;
  i5 = HEAP32[i1 + 100 >> 2] | 0;
  i10 = HEAP32[i12 >> 2] | 0;
  if (i5 - i10 >> 3 >>> 0 <= i9 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i12);
  d6 = (1.0 - d4) * +HEAPF64[i10 + (i9 << 3) >> 3];
  if (i5 - i10 >> 3 >>> 0 <= i3 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i12);
  d2 = d6 + d4 * +HEAPF64[i10 + (i3 << 3) >> 3];
  HEAPF64[i1 + 64 >> 3] = d2;
  d13 = d2;
  return +d13;
 }
 return +(0.0);
}

function __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i5 = HEAP8[i1 >> 0] | 0;
 i6 = i1 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 L1 : do if (((i5 & 1) == 0 ? (i5 & 255) >>> 1 : i7) | 0) {
  if ((i2 | 0) == (i3 | 0)) {
   i8 = i5;
   i9 = i7;
  } else {
   i10 = i3 + -4 | 0;
   if (i10 >>> 0 > i2 >>> 0) {
    i11 = i2;
    i12 = i10;
    do {
     i10 = HEAP32[i11 >> 2] | 0;
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i12 >> 2] = i10;
     i11 = i11 + 4 | 0;
     i12 = i12 + -4 | 0;
    } while (i11 >>> 0 < i12 >>> 0);
   }
   i8 = HEAP8[i1 >> 0] | 0;
   i9 = HEAP32[i6 >> 2] | 0;
  }
  i12 = (i8 & 1) == 0;
  i11 = i12 ? i1 + 1 | 0 : HEAP32[i1 + 8 >> 2] | 0;
  i10 = i3 + -4 | 0;
  i13 = i11 + (i12 ? (i8 & 255) >>> 1 : i9) | 0;
  i12 = HEAP8[i11 >> 0] | 0;
  i14 = i12 << 24 >> 24 < 1 | i12 << 24 >> 24 == 127;
  L10 : do if (i10 >>> 0 > i2 >>> 0) {
   i15 = i12;
   i16 = i11;
   i17 = i2;
   i18 = i14;
   while (1) {
    if (!i18 ? (i15 << 24 >> 24 | 0) != (HEAP32[i17 >> 2] | 0) : 0) break;
    i16 = (i13 - i16 | 0) > 1 ? i16 + 1 | 0 : i16;
    i17 = i17 + 4 | 0;
    i19 = HEAP8[i16 >> 0] | 0;
    i20 = i19 << 24 >> 24 < 1 | i19 << 24 >> 24 == 127;
    if (i17 >>> 0 >= i10 >>> 0) {
     i21 = i19;
     i22 = i20;
     break L10;
    } else {
     i15 = i19;
     i18 = i20;
    }
   }
   HEAP32[i4 >> 2] = 4;
   break L1;
  } else {
   i21 = i12;
   i22 = i14;
  } while (0);
  if (!i22 ? ((HEAP32[i10 >> 2] | 0) + -1 | 0) >>> 0 >= i21 << 24 >> 24 >>> 0 : 0) HEAP32[i4 >> 2] = 4;
 } while (0);
 return;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i6 = i1;
 i7 = i1 + 116 | 0;
 i8 = i1 + 104 | 0;
 i9 = i1 + 20 | 0;
 i10 = i1 + 16 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 4 | 0;
 HEAP8[i7 >> 0] = HEAP8[47550] | 0;
 HEAP8[i7 + 1 >> 0] = HEAP8[47551] | 0;
 HEAP8[i7 + 2 >> 0] = HEAP8[47552] | 0;
 HEAP8[i7 + 3 >> 0] = HEAP8[47553] | 0;
 HEAP8[i7 + 4 >> 0] = HEAP8[47554] | 0;
 HEAP8[i7 + 5 >> 0] = HEAP8[47555] | 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i7 + 1 | 0, 47556, 0, HEAP32[i3 + 4 >> 2] | 0);
 i14 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i6 >> 2] = i5;
 i5 = i8 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i8, 12, i14, i7, i6) | 0) | 0;
 i7 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i8, i5, i3) | 0;
 i14 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i12 >> 2] = i14;
 __THREW__ = 0;
 invoke_viiiiiii(3, i8 | 0, i7 | 0, i5 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0);
 i12 = __THREW__;
 __THREW__ = 0;
 if (i12 & 1) {
  i12 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i14) | 0;
  ___resumeException(i12 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i14) | 0;
  HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
  i13 = __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, i2, i10, i3, i4) | 0;
  STACKTOP = i1;
  return i13 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i6 = i1;
 i7 = i1 + 116 | 0;
 i8 = i1 + 104 | 0;
 i9 = i1 + 20 | 0;
 i10 = i1 + 16 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 4 | 0;
 HEAP8[i7 >> 0] = HEAP8[47550] | 0;
 HEAP8[i7 + 1 >> 0] = HEAP8[47551] | 0;
 HEAP8[i7 + 2 >> 0] = HEAP8[47552] | 0;
 HEAP8[i7 + 3 >> 0] = HEAP8[47553] | 0;
 HEAP8[i7 + 4 >> 0] = HEAP8[47554] | 0;
 HEAP8[i7 + 5 >> 0] = HEAP8[47555] | 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i7 + 1 | 0, 47556, 1, HEAP32[i3 + 4 >> 2] | 0);
 i14 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i6 >> 2] = i5;
 i5 = i8 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i8, 12, i14, i7, i6) | 0) | 0;
 i7 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i8, i5, i3) | 0;
 i14 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i12 >> 2] = i14;
 __THREW__ = 0;
 invoke_viiiiiii(3, i8 | 0, i7 | 0, i5 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0);
 i12 = __THREW__;
 __THREW__ = 0;
 if (i12 & 1) {
  i12 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i14) | 0;
  ___resumeException(i12 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i14) | 0;
  HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
  i13 = __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, i2, i10, i3, i4) | 0;
  STACKTOP = i1;
  return i13 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i6 = i1;
 i7 = i1 + 56 | 0;
 i8 = i1 + 44 | 0;
 i9 = i1 + 20 | 0;
 i10 = i1 + 16 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 4 | 0;
 HEAP8[i7 >> 0] = HEAP8[47550] | 0;
 HEAP8[i7 + 1 >> 0] = HEAP8[47551] | 0;
 HEAP8[i7 + 2 >> 0] = HEAP8[47552] | 0;
 HEAP8[i7 + 3 >> 0] = HEAP8[47553] | 0;
 HEAP8[i7 + 4 >> 0] = HEAP8[47554] | 0;
 HEAP8[i7 + 5 >> 0] = HEAP8[47555] | 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i7 + 1 | 0, 47556, 0, HEAP32[i3 + 4 >> 2] | 0);
 i14 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i6 >> 2] = i5;
 i5 = i8 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i8, 12, i14, i7, i6) | 0) | 0;
 i7 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i8, i5, i3) | 0;
 i14 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i12 >> 2] = i14;
 __THREW__ = 0;
 invoke_viiiiiii(1, i8 | 0, i7 | 0, i5 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0);
 i12 = __THREW__;
 __THREW__ = 0;
 if (i12 & 1) {
  i12 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i14) | 0;
  ___resumeException(i12 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i14) | 0;
  HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
  i13 = __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, i2, i10, i3, i4) | 0;
  STACKTOP = i1;
  return i13 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i6 = i1;
 i7 = i1 + 56 | 0;
 i8 = i1 + 44 | 0;
 i9 = i1 + 20 | 0;
 i10 = i1 + 16 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 8 | 0;
 i13 = i1 + 4 | 0;
 HEAP8[i7 >> 0] = HEAP8[47550] | 0;
 HEAP8[i7 + 1 >> 0] = HEAP8[47551] | 0;
 HEAP8[i7 + 2 >> 0] = HEAP8[47552] | 0;
 HEAP8[i7 + 3 >> 0] = HEAP8[47553] | 0;
 HEAP8[i7 + 4 >> 0] = HEAP8[47554] | 0;
 HEAP8[i7 + 5 >> 0] = HEAP8[47555] | 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i7 + 1 | 0, 47556, 1, HEAP32[i3 + 4 >> 2] | 0);
 i14 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i6 >> 2] = i5;
 i5 = i8 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i8, 12, i14, i7, i6) | 0) | 0;
 i7 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i8, i5, i3) | 0;
 i14 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i12 >> 2] = i14;
 __THREW__ = 0;
 invoke_viiiiiii(1, i8 | 0, i7 | 0, i5 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0);
 i12 = __THREW__;
 __THREW__ = 0;
 if (i12 & 1) {
  i12 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i14) | 0;
  ___resumeException(i12 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i14) | 0;
  HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
  i13 = __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, i2, i10, i3, i4) | 0;
  STACKTOP = i1;
  return i13 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 i6 = i1;
 i7 = i1 + 180 | 0;
 i8 = i1 + 160 | 0;
 i9 = i1 + 12 | 0;
 i10 = i1 + 8 | 0;
 i11 = i1 + 4 | 0;
 HEAP8[i7 >> 0] = HEAP8[47564] | 0;
 HEAP8[i7 + 1 >> 0] = HEAP8[47565] | 0;
 HEAP8[i7 + 2 >> 0] = HEAP8[47566] | 0;
 HEAP8[i7 + 3 >> 0] = HEAP8[47567] | 0;
 HEAP8[i7 + 4 >> 0] = HEAP8[47568] | 0;
 HEAP8[i7 + 5 >> 0] = HEAP8[47569] | 0;
 i12 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i6 >> 2] = i5;
 i5 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i8, 20, i12, i7, i6) | 0;
 i7 = i8 + i5 | 0;
 i12 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i8, i7, i3) | 0;
 i13 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i10 >> 2] = i13;
 __THREW__ = 0;
 i14 = invoke_iii(55, i10 | 0, 26572) | 0;
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) {
  i10 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i13) | 0;
  ___resumeException(i10 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i13) | 0;
  FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 48 >> 2] & 31](i14, i8, i7, i9) | 0;
  i14 = i9 + (i5 << 2) | 0;
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i11 = __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, (i12 | 0) == (i7 | 0) ? i14 : i9 + (i12 - i8 << 2) | 0, i14, i3, i4) | 0;
  STACKTOP = i1;
  return i11 | 0;
 }
 return 0;
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 L1 : do if (HEAP32[i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0) {
  __THREW__ = 0;
  invoke_vii(66, i3 | 0, i1 | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  L3 : do if (i4 & 1) {
   i5 = ___cxa_find_matching_catch(0) | 0;
   i6 = i5;
  } else {
   do if (HEAP8[i3 >> 0] | 0) {
    i5 = HEAP32[i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
    __THREW__ = 0;
    i7 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (!(i5 & 1)) {
     if ((i7 | 0) != -1) break;
     i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
     __THREW__ = 0;
     invoke_vii(65, i1 + i7 | 0, HEAP32[i1 + (i7 + 16) >> 2] | 1 | 0);
     i7 = __THREW__;
     __THREW__ = 0;
     if (!(i7 & 1)) break;
    }
    i7 = ___cxa_find_matching_catch(0) | 0;
    __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i3);
    i6 = i7;
    break L3;
   } while (0);
   __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i3);
   break L1;
  } while (0);
  ___cxa_begin_catch(i6 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(285, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i4 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_v(3);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i4 | 0);
 } while (0);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 L1 : do if (HEAP32[i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0) {
  __THREW__ = 0;
  invoke_vii(64, i3 | 0, i1 | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  L3 : do if (i4 & 1) {
   i5 = ___cxa_find_matching_catch(0) | 0;
   i6 = i5;
  } else {
   do if (HEAP8[i3 >> 0] | 0) {
    i5 = HEAP32[i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
    __THREW__ = 0;
    i7 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (!(i5 & 1)) {
     if ((i7 | 0) != -1) break;
     i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
     __THREW__ = 0;
     invoke_vii(65, i1 + i7 | 0, HEAP32[i1 + (i7 + 16) >> 2] | 1 | 0);
     i7 = __THREW__;
     __THREW__ = 0;
     if (!(i7 & 1)) break;
    }
    i7 = ___cxa_find_matching_catch(0) | 0;
    __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i3);
    i6 = i7;
    break L3;
   } while (0);
   __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i3);
   break L1;
  } while (0);
  ___cxa_begin_catch(i6 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(285, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i4 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_v(3);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i4 | 0);
 } while (0);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i6 = i1;
 i7 = i1 + 70 | 0;
 i8 = i1 + 12 | 0;
 i9 = i1 + 32 | 0;
 i10 = i1 + 8 | 0;
 i11 = i1 + 4 | 0;
 HEAP8[i7 >> 0] = HEAP8[47564] | 0;
 HEAP8[i7 + 1 >> 0] = HEAP8[47565] | 0;
 HEAP8[i7 + 2 >> 0] = HEAP8[47566] | 0;
 HEAP8[i7 + 3 >> 0] = HEAP8[47567] | 0;
 HEAP8[i7 + 4 >> 0] = HEAP8[47568] | 0;
 HEAP8[i7 + 5 >> 0] = HEAP8[47569] | 0;
 i12 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i6 >> 2] = i5;
 i5 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i8, 20, i12, i7, i6) | 0;
 i7 = i8 + i5 | 0;
 i12 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i8, i7, i3) | 0;
 i13 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i10 >> 2] = i13;
 __THREW__ = 0;
 i14 = invoke_iii(55, i10 | 0, 26580) | 0;
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) {
  i10 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i13) | 0;
  ___resumeException(i10 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i13) | 0;
  FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] & 31](i14, i8, i7, i9) | 0;
  i14 = i9 + i5 | 0;
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i11 = __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, (i12 | 0) == (i7 | 0) ? i14 : i9 + (i12 - i8) | 0, i14, i3, i4) | 0;
  STACKTOP = i1;
  return i11 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i7 = i1 + 8 | 0;
 i8 = i1;
 i9 = i1 + 204 | 0;
 i10 = i1 + 32 | 0;
 i11 = i1 + 28 | 0;
 i12 = i1 + 24 | 0;
 i13 = i1 + 20 | 0;
 i14 = i1 + 16 | 0;
 i15 = i8;
 HEAP32[i15 >> 2] = 37;
 HEAP32[i15 + 4 >> 2] = 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i8 + 1 | 0, 47558, 0, HEAP32[i3 + 4 >> 2] | 0);
 i15 = __ZNSt3__16__clocEv() | 0;
 i16 = i7;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i16 + 4 >> 2] = i6;
 i6 = i9 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i9, 23, i15, i8, i7) | 0) | 0;
 i8 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i9, i6, i3) | 0;
 i15 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i13 >> 2] = i15;
 __THREW__ = 0;
 invoke_viiiiiii(3, i9 | 0, i8 | 0, i6 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0);
 i13 = __THREW__;
 __THREW__ = 0;
 if (i13 & 1) {
  i13 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  ___resumeException(i13 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
  i14 = __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i7, i10, i2, i11, i3, i4) | 0;
  STACKTOP = i1;
  return i14 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i7 = i1 + 8 | 0;
 i8 = i1;
 i9 = i1 + 196 | 0;
 i10 = i1 + 32 | 0;
 i11 = i1 + 28 | 0;
 i12 = i1 + 24 | 0;
 i13 = i1 + 20 | 0;
 i14 = i1 + 16 | 0;
 i15 = i8;
 HEAP32[i15 >> 2] = 37;
 HEAP32[i15 + 4 >> 2] = 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i8 + 1 | 0, 47558, 1, HEAP32[i3 + 4 >> 2] | 0);
 i15 = __ZNSt3__16__clocEv() | 0;
 i16 = i7;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i16 + 4 >> 2] = i6;
 i6 = i9 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i9, 22, i15, i8, i7) | 0) | 0;
 i8 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i9, i6, i3) | 0;
 i15 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i13 >> 2] = i15;
 __THREW__ = 0;
 invoke_viiiiiii(3, i9 | 0, i8 | 0, i6 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0);
 i13 = __THREW__;
 __THREW__ = 0;
 if (i13 & 1) {
  i13 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  ___resumeException(i13 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
  i14 = __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i7, i10, i2, i11, i3, i4) | 0;
  STACKTOP = i1;
  return i14 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i7 = i1 + 8 | 0;
 i8 = i1;
 i9 = i1 + 75 | 0;
 i10 = i1 + 32 | 0;
 i11 = i1 + 28 | 0;
 i12 = i1 + 24 | 0;
 i13 = i1 + 20 | 0;
 i14 = i1 + 16 | 0;
 i15 = i8;
 HEAP32[i15 >> 2] = 37;
 HEAP32[i15 + 4 >> 2] = 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i8 + 1 | 0, 47558, 0, HEAP32[i3 + 4 >> 2] | 0);
 i15 = __ZNSt3__16__clocEv() | 0;
 i16 = i7;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i16 + 4 >> 2] = i6;
 i6 = i9 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i9, 23, i15, i8, i7) | 0) | 0;
 i8 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i9, i6, i3) | 0;
 i15 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i13 >> 2] = i15;
 __THREW__ = 0;
 invoke_viiiiiii(1, i9 | 0, i8 | 0, i6 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0);
 i13 = __THREW__;
 __THREW__ = 0;
 if (i13 & 1) {
  i13 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  ___resumeException(i13 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
  i14 = __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i7, i10, i2, i11, i3, i4) | 0;
  STACKTOP = i1;
  return i14 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i7 = i1 + 8 | 0;
 i8 = i1;
 i9 = i1 + 74 | 0;
 i10 = i1 + 32 | 0;
 i11 = i1 + 28 | 0;
 i12 = i1 + 24 | 0;
 i13 = i1 + 20 | 0;
 i14 = i1 + 16 | 0;
 i15 = i8;
 HEAP32[i15 >> 2] = 37;
 HEAP32[i15 + 4 >> 2] = 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i8 + 1 | 0, 47558, 1, HEAP32[i3 + 4 >> 2] | 0);
 i15 = __ZNSt3__16__clocEv() | 0;
 i16 = i7;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i16 + 4 >> 2] = i6;
 i6 = i9 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i9, 22, i15, i8, i7) | 0) | 0;
 i8 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i9, i6, i3) | 0;
 i15 = __ZNKSt3__18ios_base6getlocEv(i3) | 0;
 HEAP32[i13 >> 2] = i15;
 __THREW__ = 0;
 invoke_viiiiiii(1, i9 | 0, i8 | 0, i6 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0);
 i13 = __THREW__;
 __THREW__ = 0;
 if (i13 & 1) {
  i13 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  ___resumeException(i13 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i15) | 0;
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
  i14 = __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i7, i10, i2, i11, i3, i4) | 0;
  STACKTOP = i1;
  return i14 | 0;
 }
 return 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (i2 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 i3 = HEAP8[i1 >> 0] | 0;
 if (!(i3 & 1)) {
  i4 = 10;
  i5 = i3;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = (i3 & -2) + -1 | 0;
  i5 = i3 & 255;
 }
 if (!(i5 & 1)) i6 = (i5 & 255) >>> 1; else i6 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6 >>> 0 > i2 >>> 0 ? i6 : i2;
 if (i3 >>> 0 < 11) i7 = 10; else i7 = (i3 + 16 & -16) + -1 | 0;
 L14 : do if ((i7 | 0) != (i4 | 0)) {
  do if ((i7 | 0) != 10) {
   i3 = i7 + 1 | 0;
   if (i7 >>> 0 <= i4 >>> 0) {
    __THREW__ = 0;
    i2 = invoke_ii(125, i3 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (i8 & 1) {
     i8 = ___cxa_find_matching_catch(0) | 0;
     ___cxa_begin_catch(i8 | 0) | 0;
     ___cxa_end_catch();
     break L14;
    } else i9 = i2;
   } else i9 = __Znwj(i3) | 0;
   if (!(i5 & 1)) {
    i10 = i9;
    i11 = 1;
    i12 = i1 + 1 | 0;
    i13 = 0;
    break;
   } else {
    i10 = i9;
    i11 = 1;
    i12 = HEAP32[i1 + 8 >> 2] | 0;
    i13 = 1;
    break;
   }
  } else {
   i10 = i1 + 1 | 0;
   i11 = 0;
   i12 = HEAP32[i1 + 8 >> 2] | 0;
   i13 = 1;
  } while (0);
  if (!(i5 & 1)) i14 = (i5 & 255) >>> 1; else i14 = HEAP32[i1 + 4 >> 2] | 0;
  _memcpy(i10 | 0, i12 | 0, i14 + 1 | 0) | 0;
  if (i13) __ZdlPv(i12);
  if (i11) {
   HEAP32[i1 >> 2] = i7 + 1 | 1;
   HEAP32[i1 + 4 >> 2] = i6;
   HEAP32[i1 + 8 >> 2] = i10;
   break;
  } else {
   HEAP8[i1 >> 0] = i6 << 1;
   break;
  }
 } while (0);
 return;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (i2 >>> 0 > 1073741807) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 i3 = HEAP8[i1 >> 0] | 0;
 if (!(i3 & 1)) {
  i4 = 1;
  i5 = i3;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = (i3 & -2) + -1 | 0;
  i5 = i3 & 255;
 }
 if (!(i5 & 1)) i6 = (i5 & 255) >>> 1; else i6 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6 >>> 0 > i2 >>> 0 ? i6 : i2;
 if (i3 >>> 0 < 2) i7 = 1; else i7 = (i3 + 4 & -4) + -1 | 0;
 L14 : do if ((i7 | 0) != (i4 | 0)) {
  do if ((i7 | 0) != 1) {
   i3 = (i7 << 2) + 4 | 0;
   if (i7 >>> 0 <= i4 >>> 0) {
    __THREW__ = 0;
    i2 = invoke_ii(125, i3 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (i8 & 1) {
     i8 = ___cxa_find_matching_catch(0) | 0;
     ___cxa_begin_catch(i8 | 0) | 0;
     ___cxa_end_catch();
     break L14;
    } else i9 = i2;
   } else i9 = __Znwj(i3) | 0;
   if (!(i5 & 1)) {
    i10 = i9;
    i11 = 1;
    i12 = i1 + 4 | 0;
    i13 = 0;
    break;
   } else {
    i10 = i9;
    i11 = 1;
    i12 = HEAP32[i1 + 8 >> 2] | 0;
    i13 = 1;
    break;
   }
  } else {
   i10 = i1 + 4 | 0;
   i11 = 0;
   i12 = HEAP32[i1 + 8 >> 2] | 0;
   i13 = 1;
  } while (0);
  if (!(i5 & 1)) i14 = (i5 & 255) >>> 1; else i14 = HEAP32[i1 + 4 >> 2] | 0;
  _wmemcpy(i10, i12, i14 + 1 | 0) | 0;
  if (i13) __ZdlPv(i12);
  if (i11) {
   HEAP32[i1 >> 2] = i7 + 1 | 1;
   HEAP32[i1 + 4 >> 2] = i6;
   HEAP32[i1 + 8 >> 2] = i10;
   break;
  } else {
   HEAP8[i1 >> 0] = i6 << 1;
   break;
  }
 } while (0);
 return;
}

function __ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 L1 : do if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
  if ((HEAP32[i2 + 4 >> 2] | 0) == (i3 | 0) ? (i6 = i2 + 28 | 0, (HEAP32[i6 >> 2] | 0) != 1) : 0) HEAP32[i6 >> 2] = i4;
 } else {
  if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) {
   i6 = HEAP32[i1 + 8 >> 2] | 0;
   FUNCTION_TABLE_viiiii[HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] & 3](i6, i2, i3, i4, i5);
   break;
  }
  if ((HEAP32[i2 + 16 >> 2] | 0) != (i3 | 0) ? (i6 = i2 + 20 | 0, (HEAP32[i6 >> 2] | 0) != (i3 | 0)) : 0) {
   HEAP32[i2 + 32 >> 2] = i4;
   i7 = i2 + 44 | 0;
   if ((HEAP32[i7 >> 2] | 0) == 4) break;
   i8 = i2 + 52 | 0;
   HEAP8[i8 >> 0] = 0;
   i9 = i2 + 53 | 0;
   HEAP8[i9 >> 0] = 0;
   i10 = HEAP32[i1 + 8 >> 2] | 0;
   FUNCTION_TABLE_viiiiii[HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] & 7](i10, i2, i3, i3, 1, i5);
   if (HEAP8[i9 >> 0] | 0) {
    if (!(HEAP8[i8 >> 0] | 0)) {
     i11 = 1;
     i12 = 13;
    }
   } else {
    i11 = 0;
    i12 = 13;
   }
   do if ((i12 | 0) == 13) {
    HEAP32[i6 >> 2] = i3;
    i8 = i2 + 40 | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    if ((HEAP32[i2 + 36 >> 2] | 0) == 1 ? (HEAP32[i2 + 24 >> 2] | 0) == 2 : 0) {
     HEAP8[i2 + 54 >> 0] = 1;
     if (i11) break;
    } else i12 = 16;
    if ((i12 | 0) == 16 ? i11 : 0) break;
    HEAP32[i7 >> 2] = 4;
    break L1;
   } while (0);
   HEAP32[i7 >> 2] = 3;
   break;
  }
  if ((i4 | 0) == 1) HEAP32[i2 + 32 >> 2] = 1;
 } while (0);
 return;
}

function __ZN7maxiEnv2arEdddli(i1, d2, d3, d4, i5, i6) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, d17 = 0.0;
 i7 = (i6 | 0) == 1;
 i8 = i1 + 68 | 0;
 i9 = (HEAP32[i8 >> 2] | 0) == 1;
 if (i7) if (!i9) if ((HEAP32[i1 + 80 >> 2] | 0) == 1) i10 = 6; else {
  HEAP32[i1 + 64 >> 2] = 0;
  HEAP32[i1 + 84 >> 2] = 0;
  HEAP32[i8 >> 2] = 1;
  i10 = 7;
 } else i10 = 7; else if (i9) i10 = 7; else i10 = 6;
 if ((i10 | 0) == 6) {
  i9 = i1 + 48 | 0;
  i11 = i9;
  d12 = +HEAPF64[i9 >> 3];
 } else if ((i10 | 0) == 7) {
  i10 = i1 + 48 | 0;
  d13 = +HEAPF64[i10 >> 3] + d3;
  HEAPF64[i10 >> 3] = d13;
  HEAPF64[i1 + 8 >> 3] = d13 * d2;
  i11 = i10;
  d12 = d13;
 }
 if (!(d12 >= 1.0)) d14 = d12; else {
  HEAPF64[i11 >> 3] = 1.0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i1 + 80 >> 2] = 1;
  d14 = 1.0;
 }
 i8 = i1 + 64 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 if ((i10 | 0) < (i5 | 0) ? (HEAP32[i1 + 80 >> 2] | 0) == 1 : 0) {
  HEAPF64[i1 + 8 >> 3] = d2;
  i9 = i10 + 1 | 0;
  HEAP32[i8 >> 2] = i9;
  i15 = i9;
 } else i15 = i10;
 i10 = (i15 | 0) == (i5 | 0);
 if (i7 & i10) HEAPF64[i1 + 8 >> 3] = d2;
 if ((i6 | 0) != 1 & i10) {
  HEAP32[i1 + 80 >> 2] = 0;
  HEAP32[i1 + 84 >> 2] = 1;
  if (!(d14 > 0.0)) {
   i16 = i1 + 8 | 0;
   d17 = +HEAPF64[i16 >> 3];
   return +d17;
  }
 } else if (!(d14 > 0.0 ? (HEAP32[i1 + 84 >> 2] | 0) == 1 : 0)) {
  i16 = i1 + 8 | 0;
  d17 = +HEAPF64[i16 >> 3];
  return +d17;
 }
 d12 = d14 * d4;
 HEAPF64[i11 >> 3] = d12;
 HEAPF64[i1 + 8 >> 3] = d12 * d2;
 i16 = i1 + 8 | 0;
 d17 = +HEAPF64[i16 >> 3];
 return +d17;
}

function __ZNSt3__16vectorIdNS_9allocatorIdEEE8__appendEjRKd(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i4 = i1 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7;
 if (i5 - i8 >> 3 >>> 0 >= i2 >>> 0) {
  i9 = i2;
  i10 = i7;
  while (1) {
   HEAPF64[i10 >> 3] = +HEAPF64[i3 >> 3];
   i9 = i9 + -1 | 0;
   if (!i9) break; else i10 = i10 + 8 | 0;
  }
  HEAP32[i6 >> 2] = i7 + (i2 << 3);
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = i7;
 i9 = (i8 - i10 >> 3) + i2 | 0;
 if (i9 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1);
 i8 = i7;
 i11 = i5 - i8 | 0;
 if (i11 >> 3 >>> 0 < 268435455) {
  i5 = i11 >> 2;
  i11 = i5 >>> 0 < i9 >>> 0 ? i9 : i5;
  i5 = (HEAP32[i6 >> 2] | 0) - i8 | 0;
  i9 = i5 >> 3;
  if (!i11) {
   i12 = 0;
   i13 = 0;
   i14 = i9;
   i15 = i5;
  } else {
   i16 = i11;
   i17 = i9;
   i18 = i5;
   i19 = 9;
  }
 } else {
  i5 = (HEAP32[i6 >> 2] | 0) - i8 | 0;
  i16 = 536870911;
  i17 = i5 >> 3;
  i18 = i5;
  i19 = 9;
 }
 if ((i19 | 0) == 9) {
  i12 = i16;
  i13 = __Znwj(i16 << 3) | 0;
  i14 = i17;
  i15 = i18;
 }
 i18 = i13 + (i12 << 3) | 0;
 i12 = i2;
 i17 = i13 + (i14 << 3) | 0;
 while (1) {
  HEAPF64[i17 >> 3] = +HEAPF64[i3 >> 3];
  i12 = i12 + -1 | 0;
  if (!i12) break; else i17 = i17 + 8 | 0;
 }
 _memcpy(i13 | 0, i7 | 0, i15 | 0) | 0;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i6 >> 2] = i13 + (i14 + i2 << 3);
 HEAP32[i4 >> 2] = i18;
 if (!i10) return;
 __ZdlPv(i10);
 return;
}

function __ZNSt3__16vectorIiNS_9allocatorIiEEE8__appendEjRKi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i4 = i1 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7;
 if (i5 - i8 >> 2 >>> 0 >= i2 >>> 0) {
  i9 = i2;
  i10 = i7;
  while (1) {
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   i9 = i9 + -1 | 0;
   if (!i9) break; else i10 = i10 + 4 | 0;
  }
  HEAP32[i6 >> 2] = i7 + (i2 << 2);
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = i7;
 i9 = (i8 - i10 >> 2) + i2 | 0;
 if (i9 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1);
 i8 = i7;
 i11 = i5 - i8 | 0;
 if (i11 >> 2 >>> 0 < 536870911) {
  i5 = i11 >> 1;
  i11 = i5 >>> 0 < i9 >>> 0 ? i9 : i5;
  i5 = (HEAP32[i6 >> 2] | 0) - i8 | 0;
  i9 = i5 >> 2;
  if (!i11) {
   i12 = 0;
   i13 = 0;
   i14 = i9;
   i15 = i5;
  } else {
   i16 = i11;
   i17 = i9;
   i18 = i5;
   i19 = 9;
  }
 } else {
  i5 = (HEAP32[i6 >> 2] | 0) - i8 | 0;
  i16 = 1073741823;
  i17 = i5 >> 2;
  i18 = i5;
  i19 = 9;
 }
 if ((i19 | 0) == 9) {
  i12 = i16;
  i13 = __Znwj(i16 << 2) | 0;
  i14 = i17;
  i15 = i18;
 }
 i18 = i13 + (i12 << 2) | 0;
 i12 = i2;
 i17 = i13 + (i14 << 2) | 0;
 while (1) {
  HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
  i12 = i12 + -1 | 0;
  if (!i12) break; else i17 = i17 + 4 | 0;
 }
 _memcpy(i13 | 0, i7 | 0, i15 | 0) | 0;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i6 >> 2] = i13 + (i14 + i2 << 2);
 HEAP32[i4 >> 2] = i18;
 if (!i10) return;
 __ZdlPv(i10);
 return;
}

function __ZN7maxiDyn4gateEddldd(i1, d2, d3, i4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, d13 = 0.0, i14 = 0, i15 = 0, d16 = 0.0;
 i7 = +Math_abs(+d2) > d3;
 i8 = i1 + 72 | 0;
 i9 = (HEAP32[i8 >> 2] | 0) == 1;
 if (i7) if (!i9 ? (HEAP32[i1 + 68 >> 2] = 0, HEAP32[i1 + 80 >> 2] = 0, HEAP32[i8 >> 2] = 1, i7 = i1 + 56 | 0, +HEAPF64[i7 >> 3] == 0.0) : 0) {
  HEAPF64[i7 >> 3] = .01;
  i10 = 7;
 } else i10 = 7; else if (i9) i10 = 7; else {
  i9 = i1 + 56 | 0;
  i11 = i9;
  d12 = +HEAPF64[i9 >> 3];
 }
 if ((i10 | 0) == 7) {
  i10 = i1 + 56 | 0;
  d3 = +HEAPF64[i10 >> 3];
  if (d3 < 1.0) {
   d13 = (d5 + 1.0) * d3;
   HEAPF64[i10 >> 3] = d13;
   HEAPF64[i1 + 32 >> 3] = d13 * d2;
   i11 = i10;
   d12 = d13;
  } else {
   i11 = i10;
   d12 = d3;
  }
 }
 if (d12 >= 1.0) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i1 + 76 >> 2] = 1;
 }
 i8 = i1 + 68 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 if ((i10 | 0) < (i4 | 0) ? (HEAP32[i1 + 76 >> 2] | 0) == 1 : 0) {
  HEAPF64[i1 + 32 >> 3] = d2;
  i9 = i10 + 1 | 0;
  HEAP32[i8 >> 2] = i9;
  i14 = i9;
 } else i14 = i10;
 if ((i14 | 0) == (i4 | 0)) {
  HEAP32[i1 + 76 >> 2] = 0;
  HEAP32[i1 + 80 >> 2] = 1;
  if (!(d12 > 0.0)) {
   i15 = i1 + 32 | 0;
   d16 = +HEAPF64[i15 >> 3];
   return +d16;
  }
 } else if (!(d12 > 0.0 ? (HEAP32[i1 + 80 >> 2] | 0) == 1 : 0)) {
  i15 = i1 + 32 | 0;
  d16 = +HEAPF64[i15 >> 3];
  return +d16;
 }
 d3 = d12 * d6;
 HEAPF64[i11 >> 3] = d3;
 HEAPF64[i1 + 32 >> 3] = d3 * d2;
 i15 = i1 + 32 | 0;
 d16 = +HEAPF64[i15 >> 3];
 return +d16;
}

function _vfprintf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i5 = i4 + 80 | 0;
 i6 = i4 + 96 | 0;
 i7 = i4;
 i8 = i4 + 136 | 0;
 i9 = i6;
 i10 = i9 + 40 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i10 | 0));
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 if ((_printf_core(0, i2, i5, i7, i6) | 0) < 0) i11 = -1; else {
  if ((HEAP32[i1 + 76 >> 2] | 0) > -1) i12 = ___lockfile(i1) | 0; else i12 = 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i9 = i3 & 32;
  if ((HEAP8[i1 + 74 >> 0] | 0) < 1) HEAP32[i1 >> 2] = i3 & -33;
  i3 = i1 + 48 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i10 = i1 + 44 | 0;
   i13 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = i8;
   i14 = i1 + 28 | 0;
   HEAP32[i14 >> 2] = i8;
   i15 = i1 + 20 | 0;
   HEAP32[i15 >> 2] = i8;
   HEAP32[i3 >> 2] = 80;
   i16 = i1 + 16 | 0;
   HEAP32[i16 >> 2] = i8 + 80;
   i8 = _printf_core(i1, i2, i5, i7, i6) | 0;
   if (!i13) i17 = i8; else {
    FUNCTION_TABLE_iiii[HEAP32[i1 + 36 >> 2] & 63](i1, 0, 0) | 0;
    i18 = (HEAP32[i15 >> 2] | 0) == 0 ? -1 : i8;
    HEAP32[i10 >> 2] = i13;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i16 >> 2] = 0;
    HEAP32[i14 >> 2] = 0;
    HEAP32[i15 >> 2] = 0;
    i17 = i18;
   }
  } else i17 = _printf_core(i1, i2, i5, i7, i6) | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i6 | i9;
  if (i12) ___unlockfile(i1);
  i11 = (i6 & 32 | 0) == 0 ? i17 : -1;
 }
 STACKTOP = i4;
 return i11 | 0;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i6 = i4;
 i7 = i1 + 8 | 0;
 L1 : do if ((i3 | 0) == (i4 | 0) | (i5 | 0) == 0) i8 = 0; else {
  i1 = i3;
  i9 = 0;
  i10 = 0;
  while (1) {
   i11 = _uselocale(HEAP32[i7 >> 2] | 0) | 0;
   __THREW__ = 0;
   i12 = invoke_iiii(42, i1 | 0, i6 - i1 | 0, i2 | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) {
    i14 = i11;
    break;
   }
   if ((i11 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i11 | 0) | 0, i11 = __THREW__, __THREW__ = 0, i11 & 1) : 0) {
    i15 = 5;
    break;
   }
   switch (i12 | 0) {
   case -2:
   case -1:
    {
     i8 = i9;
     break L1;
     break;
    }
   case 0:
    {
     i16 = i1 + 1 | 0;
     i17 = 1;
     break;
    }
   default:
    {
     i16 = i1 + i12 | 0;
     i17 = i12;
    }
   }
   i12 = i17 + i9 | 0;
   i10 = i10 + 1 | 0;
   if ((i16 | 0) == (i4 | 0) | i10 >>> 0 >= i5 >>> 0) {
    i8 = i12;
    break L1;
   } else {
    i1 = i16;
    i9 = i12;
   }
  }
  if ((i15 | 0) == 5) {
   i9 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i9);
  }
  i9 = ___cxa_find_matching_catch() | 0;
  if ((i14 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i14 | 0) | 0, i1 = __THREW__, __THREW__ = 0, i1 & 1) : 0) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  }
  ___resumeException(i9 | 0);
 } while (0);
 return i8 | 0;
}

function ___dynamic_cast(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i6 = i5;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = i1 + (HEAP32[i7 + -8 >> 2] | 0) | 0;
 i9 = HEAP32[i7 + -4 >> 2] | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = i4;
 i4 = i6 + 16 | 0;
 i2 = i6 + 20 | 0;
 i1 = i6 + 24 | 0;
 i7 = i6 + 28 | 0;
 i10 = i6 + 32 | 0;
 i11 = i6 + 40 | 0;
 i12 = (i9 | 0) == (i3 | 0);
 i13 = i4;
 i14 = i13 + 36 | 0;
 do {
  HEAP32[i13 >> 2] = 0;
  i13 = i13 + 4 | 0;
 } while ((i13 | 0) < (i14 | 0));
 HEAP16[i4 + 36 >> 1] = 0;
 HEAP8[i4 + 38 >> 0] = 0;
 L1 : do if (i12) {
  HEAP32[i6 + 48 >> 2] = 1;
  FUNCTION_TABLE_viiiiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] & 7](i3, i6, i8, i8, 1, 0);
  i15 = (HEAP32[i1 >> 2] | 0) == 1 ? i8 : 0;
 } else {
  FUNCTION_TABLE_viiiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] & 3](i9, i6, i8, 1, 0);
  switch (HEAP32[i6 + 36 >> 2] | 0) {
  case 0:
   {
    i15 = (HEAP32[i11 >> 2] | 0) == 1 & (HEAP32[i7 >> 2] | 0) == 1 & (HEAP32[i10 >> 2] | 0) == 1 ? HEAP32[i2 >> 2] | 0 : 0;
    break L1;
    break;
   }
  case 1:
   break;
  default:
   {
    i15 = 0;
    break L1;
   }
  }
  if ((HEAP32[i1 >> 2] | 0) != 1 ? !((HEAP32[i11 >> 2] | 0) == 0 & (HEAP32[i7 >> 2] | 0) == 1 & (HEAP32[i10 >> 2] | 0) == 1) : 0) {
   i15 = 0;
   break;
  }
  i15 = HEAP32[i4 >> 2] | 0;
 } while (0);
 STACKTOP = i5;
 return i15 | 0;
}

function __ZNSt3__111__call_onceERVmPvPFvS2_E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 _pthread_mutex_lock(25036) | 0;
 if ((HEAP32[i1 >> 2] | 0) == 1) do _pthread_cond_wait(25064, 25036) | 0; while ((HEAP32[i1 >> 2] | 0) == 1);
 do if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_ii(128, 25036) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if ((((!(i4 & 1) ? (__THREW__ = 0, invoke_vi(i3 | 0, i2 | 0), i4 = __THREW__, __THREW__ = 0, !(i4 & 1)) : 0) ? (__THREW__ = 0, invoke_ii(129, 25036) | 0, i4 = __THREW__, __THREW__ = 0, !(i4 & 1)) : 0) ? (HEAP32[i1 >> 2] = -1, __THREW__ = 0, invoke_ii(128, 25036) | 0, i4 = __THREW__, __THREW__ = 0, !(i4 & 1)) : 0) ? (__THREW__ = 0, invoke_ii(130, 25064) | 0, i4 = __THREW__, __THREW__ = 0, !(i4 & 1)) : 0) break;
  i4 = ___cxa_find_matching_catch(0) | 0;
  ___cxa_begin_catch(i4 | 0) | 0;
  __THREW__ = 0;
  invoke_ii(129, 25036) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if ((!(i4 & 1) ? (HEAP32[i1 >> 2] = 0, __THREW__ = 0, invoke_ii(128, 25036) | 0, i4 = __THREW__, __THREW__ = 0, !(i4 & 1)) : 0) ? (__THREW__ = 0, invoke_ii(130, 25064) | 0, i4 = __THREW__, __THREW__ = 0, !(i4 & 1)) : 0) {
   __THREW__ = 0;
   invoke_v(2);
   __THREW__ = 0;
  }
  i4 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_v(3);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i5);
  } else ___resumeException(i4 | 0);
 } else _pthread_mutex_unlock(25036) | 0; while (0);
 return;
}

function __ZNSt3__111__stdoutbufIwE8overflowEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i3 + 16 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3 + 4 | 0;
 i7 = i3;
 i8 = (i2 | 0) == -1;
 L1 : do if (!i8) {
  HEAP32[i5 >> 2] = i2;
  if (HEAP8[i1 + 44 >> 0] | 0) if ((_fwrite(i5, 4, 1, HEAP32[i1 + 32 >> 2] | 0) | 0) == 1) {
   i9 = 11;
   break;
  } else {
   i10 = -1;
   break;
  }
  HEAP32[i6 >> 2] = i4;
  i11 = i5 + 4 | 0;
  i12 = i1 + 36 | 0;
  i13 = i1 + 40 | 0;
  i14 = i4 + 8 | 0;
  i15 = i4;
  i16 = i1 + 32 | 0;
  i17 = i5;
  while (1) {
   i18 = HEAP32[i12 >> 2] | 0;
   i19 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] & 15](i18, HEAP32[i13 >> 2] | 0, i17, i11, i7, i4, i14, i6) | 0;
   if ((HEAP32[i7 >> 2] | 0) == (i17 | 0)) {
    i10 = -1;
    break L1;
   }
   if ((i19 | 0) == 3) {
    i20 = i17;
    break;
   }
   i18 = (i19 | 0) == 1;
   if (i19 >>> 0 >= 2) {
    i10 = -1;
    break L1;
   }
   i19 = (HEAP32[i6 >> 2] | 0) - i15 | 0;
   if ((_fwrite(i4, 1, i19, HEAP32[i16 >> 2] | 0) | 0) != (i19 | 0)) {
    i10 = -1;
    break L1;
   }
   if (i18) i17 = i18 ? HEAP32[i7 >> 2] | 0 : i17; else {
    i9 = 11;
    break L1;
   }
  }
  if ((_fwrite(i20, 1, 1, HEAP32[i16 >> 2] | 0) | 0) != 1) i10 = -1; else i9 = 11;
 } else i9 = 11; while (0);
 if ((i9 | 0) == 11) i10 = i8 ? 0 : i2;
 STACKTOP = i3;
 return i10 | 0;
}

function __ZNSt3__111__stdoutbufIcE8overflowEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i3 + 16 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3 + 4 | 0;
 i7 = i3;
 i8 = (i2 | 0) == -1;
 L1 : do if (!i8) {
  HEAP8[i5 >> 0] = i2;
  if (HEAP8[i1 + 44 >> 0] | 0) if ((_fwrite(i5, 1, 1, HEAP32[i1 + 32 >> 2] | 0) | 0) == 1) {
   i9 = 11;
   break;
  } else {
   i10 = -1;
   break;
  }
  HEAP32[i6 >> 2] = i4;
  i11 = i5 + 1 | 0;
  i12 = i1 + 36 | 0;
  i13 = i1 + 40 | 0;
  i14 = i4 + 8 | 0;
  i15 = i4;
  i16 = i1 + 32 | 0;
  i17 = i5;
  while (1) {
   i18 = HEAP32[i12 >> 2] | 0;
   i19 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] & 15](i18, HEAP32[i13 >> 2] | 0, i17, i11, i7, i4, i14, i6) | 0;
   if ((HEAP32[i7 >> 2] | 0) == (i17 | 0)) {
    i10 = -1;
    break L1;
   }
   if ((i19 | 0) == 3) {
    i20 = i17;
    break;
   }
   i18 = (i19 | 0) == 1;
   if (i19 >>> 0 >= 2) {
    i10 = -1;
    break L1;
   }
   i19 = (HEAP32[i6 >> 2] | 0) - i15 | 0;
   if ((_fwrite(i4, 1, i19, HEAP32[i16 >> 2] | 0) | 0) != (i19 | 0)) {
    i10 = -1;
    break L1;
   }
   if (i18) i17 = i18 ? HEAP32[i7 >> 2] | 0 : i17; else {
    i9 = 11;
    break L1;
   }
  }
  if ((_fwrite(i20, 1, 1, HEAP32[i16 >> 2] | 0) | 0) != 1) i10 = -1; else i9 = 11;
 } else i9 = 11; while (0);
 if ((i9 | 0) == 11) i10 = i8 ? 0 : i2;
 STACKTOP = i3;
 return i10 | 0;
}

function __ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(0, i2, i3, i4, i5); else {
  i7 = i2 + 52 | 0;
  i8 = HEAP8[i7 >> 0] | 0;
  i9 = i2 + 53 | 0;
  i10 = HEAP8[i9 >> 0] | 0;
  i11 = HEAP32[i1 + 12 >> 2] | 0;
  i12 = i1 + 16 + (i11 << 3) | 0;
  HEAP8[i7 >> 0] = 0;
  HEAP8[i9 >> 0] = 0;
  __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1 + 16 | 0, i2, i3, i4, i5, i6);
  L4 : do if ((i11 | 0) > 1) {
   i13 = i2 + 24 | 0;
   i14 = i1 + 8 | 0;
   i15 = i2 + 54 | 0;
   i16 = i1 + 24 | 0;
   do {
    if (HEAP8[i15 >> 0] | 0) break L4;
    if (!(HEAP8[i7 >> 0] | 0)) {
     if ((HEAP8[i9 >> 0] | 0) != 0 ? (HEAP32[i14 >> 2] & 1 | 0) == 0 : 0) break L4;
    } else {
     if ((HEAP32[i13 >> 2] | 0) == 1) break L4;
     if (!(HEAP32[i14 >> 2] & 2)) break L4;
    }
    HEAP8[i7 >> 0] = 0;
    HEAP8[i9 >> 0] = 0;
    __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i16, i2, i3, i4, i5, i6);
    i16 = i16 + 8 | 0;
   } while (i16 >>> 0 < i12 >>> 0);
  } while (0);
  HEAP8[i7 >> 0] = i8;
  HEAP8[i9 >> 0] = i10;
 }
 return;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = i1 + 8 | 0;
 __THREW__ = 0;
 i1 = invoke_ii(132, HEAP32[i2 >> 2] | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 do if (i3 & 1) i4 = 16; else {
  __THREW__ = 0;
  i5 = invoke_iiii(41, 0, 0, 4) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   if (!i1) {
    i7 = i6;
    break;
   }
   __THREW__ = 0;
   invoke_ii(132, i1 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) {
    i7 = i6;
    break;
   }
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  if ((i1 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i1 | 0) | 0, i6 = __THREW__, __THREW__ = 0, i6 & 1) : 0) {
   i6 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i6);
  }
  if (!i5) {
   i5 = HEAP32[i2 >> 2] | 0;
   if (i5) {
    __THREW__ = 0;
    i6 = invoke_ii(132, i5 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i4 = 16;
     break;
    }
    if ((i6 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i6 | 0) | 0, i6 = __THREW__, __THREW__ = 0, i6 & 1) : 0) {
     i6 = ___cxa_find_matching_catch(0) | 0;
     ___clang_call_terminate(i6);
    } else i9 = 0;
   } else i9 = 1;
  } else i9 = -1;
  return i9 | 0;
 } while (0);
 if ((i4 | 0) == 16) {
  i4 = ___cxa_find_matching_catch(0) | 0;
  i7 = i4;
 }
 ___clang_call_terminate(i7);
 return 0;
}

function ___stdio_read(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i5 = i4 + 16 | 0;
 i6 = i4;
 i7 = i4 + 32 | 0;
 HEAP32[i7 >> 2] = i2;
 i8 = i7 + 4 | 0;
 i9 = i1 + 48 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i3 - ((i10 | 0) != 0 & 1);
 i11 = i1 + 44 | 0;
 HEAP32[i7 + 8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 12 >> 2] = i10;
 if (!(HEAP32[4853] | 0)) {
  HEAP32[i5 >> 2] = HEAP32[i1 + 60 >> 2];
  HEAP32[i5 + 4 >> 2] = i7;
  HEAP32[i5 + 8 >> 2] = 2;
  i12 = ___syscall_ret(___syscall145(145, i5 | 0) | 0) | 0;
 } else {
  _pthread_cleanup_push(282, i1 | 0);
  HEAP32[i6 >> 2] = HEAP32[i1 + 60 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i6 + 8 >> 2] = 2;
  i7 = ___syscall_ret(___syscall145(145, i6 | 0) | 0) | 0;
  _pthread_cleanup_pop(0);
  i12 = i7;
 }
 if ((i12 | 0) >= 1) {
  i7 = HEAP32[i8 >> 2] | 0;
  if (i12 >>> 0 > i7 >>> 0) {
   i8 = HEAP32[i11 >> 2] | 0;
   i11 = i1 + 4 | 0;
   HEAP32[i11 >> 2] = i8;
   i6 = i8;
   HEAP32[i1 + 8 >> 2] = i6 + (i12 - i7);
   if (!(HEAP32[i9 >> 2] | 0)) i13 = i3; else {
    HEAP32[i11 >> 2] = i6 + 1;
    HEAP8[i2 + (i3 + -1) >> 0] = HEAP8[i6 >> 0] | 0;
    i13 = i3;
   }
  } else i13 = i12;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i12 & 48 ^ 16;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i13 = i12;
 }
 STACKTOP = i4;
 return i13 | 0;
}

function __ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 i6 = HEAP32[i2 >> 2] | 0;
 do if (i6) {
  i7 = HEAP8[i3 >> 0] | 0;
  if (!(i7 & 1)) i8 = (i7 & 255) >>> 1; else i8 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i8) i9 = i6; else {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i3, 48483) | 0;
   i9 = HEAP32[i2 >> 2] | 0;
  }
  i7 = HEAP32[i2 + 4 >> 2] | 0;
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 15](i5, i7, i9);
  i7 = HEAP8[i5 >> 0] | 0;
  i10 = (i7 & 1) == 0;
  __THREW__ = 0;
  invoke_iiii(44, i3 | 0, (i10 ? i5 + 1 | 0 : HEAP32[i5 + 8 >> 2] | 0) | 0, (i10 ? (i7 & 255) >>> 1 : HEAP32[i5 + 4 >> 2] | 0) | 0) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch() | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   ___resumeException(i7 | 0);
  } else {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   break;
  }
 } while (0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!(i3 & 2048)) i4 = i1; else {
  HEAP8[i1 >> 0] = 43;
  i4 = i1 + 1 | 0;
 }
 if (!(i3 & 1024)) i5 = i4; else {
  HEAP8[i4 >> 0] = 35;
  i5 = i4 + 1 | 0;
 }
 i4 = i3 & 260;
 i1 = i3 >>> 14;
 i3 = (i4 | 0) == 260;
 if (i3) {
  i6 = i5;
  i7 = 0;
 } else {
  HEAP8[i5 >> 0] = 46;
  HEAP8[i5 + 1 >> 0] = 42;
  i6 = i5 + 2 | 0;
  i7 = 1;
 }
 i5 = HEAP8[i2 >> 0] | 0;
 if (!(i5 << 24 >> 24)) i8 = i6; else {
  i9 = i2;
  i2 = i6;
  i6 = i5;
  while (1) {
   i9 = i9 + 1 | 0;
   i5 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = i6;
   i6 = HEAP8[i9 >> 0] | 0;
   if (!(i6 << 24 >> 24)) {
    i8 = i5;
    break;
   } else i2 = i5;
  }
 }
 L14 : do switch (i4 | 0) {
 case 4:
  {
   if (!(i1 & 1)) {
    HEAP8[i8 >> 0] = 102;
    break L14;
   } else {
    HEAP8[i8 >> 0] = 70;
    break L14;
   }
   break;
  }
 case 256:
  {
   if (!(i1 & 1)) {
    HEAP8[i8 >> 0] = 101;
    break L14;
   } else {
    HEAP8[i8 >> 0] = 69;
    break L14;
   }
   break;
  }
 default:
  {
   i2 = (i1 & 1 | 0) != 0;
   if (i3) if (i2) {
    HEAP8[i8 >> 0] = 65;
    break L14;
   } else {
    HEAP8[i8 >> 0] = 97;
    break L14;
   } else if (i2) {
    HEAP8[i8 >> 0] = 71;
    break L14;
   } else {
    HEAP8[i8 >> 0] = 103;
    break L14;
   }
  }
 } while (0);
 return i7 | 0;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i6;
 HEAP32[i5 >> 2] = i3;
 i3 = _uselocale(HEAP32[i1 + 8 >> 2] | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iiii(40, i7 | 0, 0, i2 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch() | 0;
  if ((i3 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i3 | 0) | 0, i8 = __THREW__, __THREW__ = 0, i8 & 1) : 0) {
   i8 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i8);
  }
  ___resumeException(i2 | 0);
 }
 if ((i3 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i3 | 0) | 0, i3 = __THREW__, __THREW__ = 0, i3 & 1) : 0) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 switch (i1 | 0) {
 case 0:
 case -1:
  {
   i9 = 2;
   break;
  }
 default:
  {
   i3 = i1 + -1 | 0;
   if (i3 >>> 0 <= (i4 - (HEAP32[i5 >> 2] | 0) | 0) >>> 0) if (!i3) i9 = 0; else {
    i4 = i3;
    i3 = i7;
    while (1) {
     i7 = HEAP8[i3 >> 0] | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i7;
     i4 = i4 + -1 | 0;
     if (!i4) {
      i9 = 0;
      break;
     } else i3 = i3 + 1 | 0;
    }
   } else i9 = 1;
  }
 }
 STACKTOP = i6;
 return i9 | 0;
}

function __ZNK10__cxxabiv119__pointer_type_info9can_catchEPKNS_16__shim_type_infoERPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i5 = i4;
 HEAP32[i3 >> 2] = HEAP32[HEAP32[i3 >> 2] >> 2];
 if (!((i1 | 0) == (i2 | 0) | (i2 | 0) == 15056)) if (((i2 | 0) != 0 ? (i6 = ___dynamic_cast(i2, 14968, 15016, 0) | 0, (i6 | 0) != 0) : 0) ? (HEAP32[i6 + 8 >> 2] & ~HEAP32[i1 + 8 >> 2] | 0) == 0 : 0) {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i1 = i6 + 12 | 0;
  if (!((i2 | 0) == 15048 ? 1 : (i2 | 0) == (HEAP32[i1 >> 2] | 0))) if ((((i2 | 0) != 0 ? (i6 = ___dynamic_cast(i2, 14968, 14984, 0) | 0, (i6 | 0) != 0) : 0) ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) ? (i1 = ___dynamic_cast(i2, 14968, 14984, 0) | 0, (i1 | 0) != 0) : 0) {
   i2 = i5;
   i7 = i2 + 56 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) < (i7 | 0));
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 + 8 >> 2] = i6;
   HEAP32[i5 + 12 >> 2] = -1;
   HEAP32[i5 + 48 >> 2] = 1;
   FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 31](i1, i5, HEAP32[i3 >> 2] | 0, 1);
   if ((HEAP32[i5 + 24 >> 2] | 0) == 1) {
    HEAP32[i3 >> 2] = HEAP32[i5 + 16 >> 2];
    i8 = 1;
   } else i8 = 0;
   i9 = i8;
  } else i9 = 0; else i9 = 1;
 } else i9 = 0; else i9 = 1;
 STACKTOP = i4;
 return i9 | 0;
}

function __ZNSt3__110__stdinbufIwE9pbackfailEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i3 + 16 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3 + 4 | 0;
 i7 = i3;
 i8 = i1 + 52 | 0;
 i9 = (HEAP8[i8 >> 0] | 0) != 0;
 L1 : do if ((i2 | 0) == -1) if (i9) i10 = -1; else {
  i11 = HEAP32[i1 + 48 >> 2] | 0;
  HEAP8[i8 >> 0] = (i11 | 0) != -1 & 1;
  i10 = i11;
 } else {
  i11 = i1 + 48 | 0;
  L5 : do if (i9) {
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   i12 = HEAP32[i1 + 36 >> 2] | 0;
   switch (FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] & 15](i12, HEAP32[i1 + 40 >> 2] | 0, i6, i6 + 4 | 0, i7, i4, i4 + 8 | 0, i5) | 0) {
   case 1:
   case 2:
    {
     i10 = -1;
     break L1;
     break;
    }
   case 3:
    {
     HEAP8[i4 >> 0] = HEAP32[i11 >> 2];
     HEAP32[i5 >> 2] = i4 + 1;
     break;
    }
   default:
    {}
   }
   i12 = i1 + 32 | 0;
   while (1) {
    i13 = HEAP32[i5 >> 2] | 0;
    if (i13 >>> 0 <= i4 >>> 0) break L5;
    i14 = i13 + -1 | 0;
    HEAP32[i5 >> 2] = i14;
    if ((_ungetc(HEAP8[i14 >> 0] | 0, HEAP32[i12 >> 2] | 0) | 0) == -1) {
     i10 = -1;
     break L1;
    }
   }
  } while (0);
  HEAP32[i11 >> 2] = i2;
  HEAP8[i8 >> 0] = 1;
  i10 = i2;
 } while (0);
 STACKTOP = i3;
 return i10 | 0;
}

function __ZNSt3__110__stdinbufIcE9pbackfailEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i3 + 16 | 0;
 i5 = i3 + 4 | 0;
 i6 = i3 + 8 | 0;
 i7 = i3;
 i8 = i1 + 52 | 0;
 i9 = (HEAP8[i8 >> 0] | 0) != 0;
 L1 : do if ((i2 | 0) == -1) if (i9) i10 = -1; else {
  i11 = HEAP32[i1 + 48 >> 2] | 0;
  HEAP8[i8 >> 0] = (i11 | 0) != -1 & 1;
  i10 = i11;
 } else {
  i11 = i1 + 48 | 0;
  L5 : do if (i9) {
   HEAP8[i6 >> 0] = HEAP32[i11 >> 2];
   i12 = HEAP32[i1 + 36 >> 2] | 0;
   switch (FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] & 15](i12, HEAP32[i1 + 40 >> 2] | 0, i6, i6 + 1 | 0, i7, i4, i4 + 8 | 0, i5) | 0) {
   case 1:
   case 2:
    {
     i10 = -1;
     break L1;
     break;
    }
   case 3:
    {
     HEAP8[i4 >> 0] = HEAP32[i11 >> 2];
     HEAP32[i5 >> 2] = i4 + 1;
     break;
    }
   default:
    {}
   }
   i12 = i1 + 32 | 0;
   while (1) {
    i13 = HEAP32[i5 >> 2] | 0;
    if (i13 >>> 0 <= i4 >>> 0) break L5;
    i14 = i13 + -1 | 0;
    HEAP32[i5 >> 2] = i14;
    if ((_ungetc(HEAP8[i14 >> 0] | 0, HEAP32[i12 >> 2] | 0) | 0) == -1) {
     i10 = -1;
     break L1;
    }
   }
  } while (0);
  HEAP32[i11 >> 2] = i2;
  HEAP8[i8 >> 0] = 1;
  i10 = i2;
 } while (0);
 STACKTOP = i3;
 return i10 | 0;
}

function __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i6;
 i8 = __ZNKSt3__18ios_base6getlocEv(i2) | 0;
 HEAP32[i7 >> 2] = i8;
 __THREW__ = 0;
 i2 = invoke_iii(55, i7 | 0, 26572) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (((((!(i9 & 1) ? (__THREW__ = 0, invoke_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, 46161, 46193, i3 | 0) | 0, i3 = __THREW__, __THREW__ = 0, !(i3 & 1)) : 0) ? (__THREW__ = 0, i3 = invoke_iii(55, i7 | 0, 26728) | 0, i7 = __THREW__, __THREW__ = 0, !(i7 & 1)) : 0) ? (__THREW__ = 0, i7 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (HEAP32[i4 >> 2] = i7, __THREW__ = 0, i7 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0) | 0, i4 = __THREW__, __THREW__ = 0, !(i4 & 1)) : 0) ? (HEAP32[i5 >> 2] = i7, __THREW__ = 0, invoke_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i3 | 0), i3 = __THREW__, __THREW__ = 0, !(i3 & 1)) : 0) {
  __ZNSt3__114__shared_count16__release_sharedEv(i8) | 0;
  STACKTOP = i6;
  return;
 }
 i6 = ___cxa_find_matching_catch() | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(i8) | 0;
 ___resumeException(i6 | 0);
}

function __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i6;
 i8 = __ZNKSt3__18ios_base6getlocEv(i2) | 0;
 HEAP32[i7 >> 2] = i8;
 __THREW__ = 0;
 i2 = invoke_iii(55, i7 | 0, 26580) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (((((!(i9 & 1) ? (__THREW__ = 0, invoke_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, 46161, 46193, i3 | 0) | 0, i3 = __THREW__, __THREW__ = 0, !(i3 & 1)) : 0) ? (__THREW__ = 0, i3 = invoke_iii(55, i7 | 0, 26720) | 0, i7 = __THREW__, __THREW__ = 0, !(i7 & 1)) : 0) ? (__THREW__ = 0, i7 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (HEAP8[i4 >> 0] = i7, __THREW__ = 0, i7 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0) | 0, i4 = __THREW__, __THREW__ = 0, !(i4 & 1)) : 0) ? (HEAP8[i5 >> 0] = i7, __THREW__ = 0, invoke_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i3 | 0), i3 = __THREW__, __THREW__ = 0, !(i3 & 1)) : 0) {
  __ZNSt3__114__shared_count16__release_sharedEv(i8) | 0;
  STACKTOP = i6;
  return;
 }
 i6 = ___cxa_find_matching_catch() | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(i8) | 0;
 ___resumeException(i6 | 0);
}

function _mbtowc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 L1 : do if (!i2) i6 = 0; else {
  do if (i3) {
   i7 = (i1 | 0) == 0 ? i5 : i1;
   i8 = HEAP8[i2 >> 0] | 0;
   i9 = i8 & 255;
   if (i8 << 24 >> 24 > -1) {
    HEAP32[i7 >> 2] = i9;
    i6 = i8 << 24 >> 24 != 0 & 1;
    break L1;
   }
   i8 = i9 + -194 | 0;
   if (i8 >>> 0 <= 50) {
    i9 = i2 + 1 | 0;
    i10 = HEAP32[19456 + (i8 << 2) >> 2] | 0;
    if (i3 >>> 0 < 4 ? (i10 & -2147483648 >>> ((i3 * 6 | 0) + -6 | 0) | 0) != 0 : 0) break;
    i8 = HEAPU8[i9 >> 0] | 0;
    i9 = i8 >>> 3;
    if ((i9 + -16 | i9 + (i10 >> 26)) >>> 0 <= 7) {
     i9 = i8 + -128 | i10 << 6;
     if ((i9 | 0) >= 0) {
      HEAP32[i7 >> 2] = i9;
      i6 = 2;
      break L1;
     }
     i10 = HEAPU8[i2 + 2 >> 0] | 0;
     if ((i10 & 192 | 0) == 128) {
      i8 = i10 + -128 | i9 << 6;
      if ((i8 | 0) >= 0) {
       HEAP32[i7 >> 2] = i8;
       i6 = 3;
       break L1;
      }
      i9 = HEAPU8[i2 + 3 >> 0] | 0;
      if ((i9 & 192 | 0) == 128) {
       HEAP32[i7 >> 2] = i9 + -128 | i8 << 6;
       i6 = 4;
       break L1;
      }
     }
    }
   }
  } while (0);
  i8 = ___errno_location() | 0;
  HEAP32[i8 >> 2] = 84;
  i6 = -1;
 } while (0);
 STACKTOP = i4;
 return i6 | 0;
}

function __ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i8 = i7 + 16 | 0;
 i9 = i7 + 12 | 0;
 i10 = i7;
 i11 = i7 + 8 | 0;
 HEAP32[i9 >> 2] = i8 + 100;
 __ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc(i1, i8, i9, i4, i5, i6);
 i6 = i10;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i11 >> 2] = i8;
 i8 = (HEAP32[i3 >> 2] | 0) - i2 >> 2;
 i6 = _uselocale(HEAP32[i1 >> 2] | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iiiii(11, i2 | 0, i11 | 0, i8 | 0, i10 | 0) | 0;
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) {
  i10 = ___cxa_find_matching_catch() | 0;
  if ((i6 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i6 | 0) | 0, i8 = __THREW__, __THREW__ = 0, i8 & 1) : 0) {
   i8 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i8);
  }
  ___resumeException(i10 | 0);
 }
 if ((i6 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i6 | 0) | 0, i6 = __THREW__, __THREW__ = 0, i6 & 1) : 0) {
  i6 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i6);
 }
 if ((i1 | 0) == -1) __ZNSt3__121__throw_runtime_errorEPKc(47618); else {
  HEAP32[i3 >> 2] = i2 + (i1 << 2);
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = i2;
 i5 = HEAP8[i1 >> 0] | 0;
 if (!(i5 & 1)) {
  i6 = 1;
  i7 = (i5 & 255) >>> 1;
  i8 = i5;
 } else {
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = (i5 & -2) + -1 | 0;
  i7 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = i5 & 255;
 }
 i5 = i3 - i4 >> 2;
 do if (i5) {
  if ((i6 - i7 | 0) >>> 0 < i5 >>> 0) {
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i1, i6, i7 + i5 - i6 | 0, i7, i7, 0, 0);
   i9 = HEAP8[i1 >> 0] | 0;
  } else i9 = i8;
  if (!(i9 & 1)) i10 = i1 + 4 | 0; else i10 = HEAP32[i1 + 8 >> 2] | 0;
  i11 = i7 + ((i3 - i4 | 0) >>> 2) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i12 = i2;
   i13 = i10 + (i7 << 2) | 0;
   while (1) {
    HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
    i12 = i12 + 4 | 0;
    if ((i12 | 0) == (i3 | 0)) break; else i13 = i13 + 4 | 0;
   }
  }
  HEAP32[i10 + (i11 << 2) >> 2] = 0;
  i13 = i7 + i5 | 0;
  if (!(HEAP8[i1 >> 0] & 1)) {
   HEAP8[i1 >> 0] = i13 << 1;
   break;
  } else {
   HEAP32[i1 + 4 >> 2] = i13;
   break;
  }
 } while (0);
 return i1 | 0;
}

function __ZNSt3__112system_errorC2ENS_10error_codeEPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i4 + 12 | 0;
 i6 = i4;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, _strlen(i3) | 0);
 __THREW__ = 0;
 invoke_viii(15, i5 | 0, i2 | 0, i6 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 do if (!(i3 & 1)) {
  __THREW__ = 0;
  invoke_vii(106, i1 | 0, i5 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch() | 0;
   i8 = tempRet0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i9 = i8;
   i10 = i7;
   break;
  } else {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   HEAP32[i1 >> 2] = 30104;
   i7 = i2;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i11 = i1 + 8 | 0;
   HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i11 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 } else {
  i8 = ___cxa_find_matching_catch() | 0;
  i9 = tempRet0;
  i10 = i8;
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 ___resumeException(i10 | 0);
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = i2;
 i5 = HEAP8[i1 >> 0] | 0;
 if (!(i5 & 1)) {
  i6 = 10;
  i7 = (i5 & 255) >>> 1;
  i8 = i5;
 } else {
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = (i5 & -2) + -1 | 0;
  i7 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = i5 & 255;
 }
 i5 = i3 - i4 | 0;
 do if ((i3 | 0) != (i2 | 0)) {
  if ((i6 - i7 | 0) >>> 0 < i5 >>> 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i1, i6, i7 + i5 - i6 | 0, i7, i7, 0, 0);
   i9 = HEAP8[i1 >> 0] | 0;
  } else i9 = i8;
  if (!(i9 & 1)) i10 = i1 + 1 | 0; else i10 = HEAP32[i1 + 8 >> 2] | 0;
  i11 = i3 + (i7 - i4) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i12 = i2;
   i13 = i10 + i7 | 0;
   while (1) {
    HEAP8[i13 >> 0] = HEAP8[i12 >> 0] | 0;
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == (i3 | 0)) break; else i13 = i13 + 1 | 0;
   }
  }
  HEAP8[i10 + i11 >> 0] = 0;
  i13 = i7 + i5 | 0;
  if (!(HEAP8[i1 >> 0] & 1)) {
   HEAP8[i1 >> 0] = i13 << 1;
   break;
  } else {
   HEAP32[i1 + 4 >> 2] = i13;
   break;
  }
 } while (0);
 return i1 | 0;
}

function __ZN12maxiEnvelope4lineEiRNSt3__16vectorIdNS0_9allocatorIdEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0;
 if ((HEAP32[i1 + 40 >> 2] | 0) != 1) {
  HEAPF64[i1 + 8 >> 3] = 0.0;
  d4 = 0.0;
  return +d4;
 }
 i5 = i1 + 44 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 d8 = 2.0 / (+HEAPF64[i7 + (i6 + 1 << 3) >> 3] * .004);
 HEAPF64[i1 >> 3] = d8;
 i3 = i6 + 2 | 0;
 HEAPF64[i1 + 32 >> 3] = +HEAPF64[i7 + (i3 << 3) >> 3];
 d9 = +HEAPF64[i7 + (i6 << 3) >> 3];
 HEAPF64[i1 + 24 >> 3] = d9;
 i7 = i1 + 48 | 0;
 d10 = +HEAPF64[i7 >> 3];
 d11 = d9 - d10;
 do if (!(d11 > 1.0e-07 & (i6 | 0) < (i2 | 0))) {
  if (d11 < -1.0e-07 & (i6 | 0) < (i2 | 0)) {
   d12 = d10 - -(d9 - +HEAPF64[i1 + 16 >> 3]) / (+(HEAP32[4327] | 0) / d8);
   HEAPF64[i7 >> 3] = d12;
   d13 = d12;
   break;
  }
  if ((i6 | 0) > (i2 + -1 | 0)) {
   HEAP32[i5 >> 2] = i2 + -2;
   d13 = d10;
   break;
  } else {
   HEAP32[i5 >> 2] = i3;
   HEAPF64[i1 + 16 >> 3] = d9;
   d13 = d10;
   break;
  }
 } else {
  d12 = d10 + (d9 - +HEAPF64[i1 + 16 >> 3]) / (+(HEAP32[4327] | 0) / d8);
  HEAPF64[i7 >> 3] = d12;
  d13 = d12;
 } while (0);
 HEAPF64[i1 + 8 >> 3] = d13;
 d4 = d13;
 return +d4;
}

function ___fwritex(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i4 = i3 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) if (!(___towrite(i3) | 0)) {
  i6 = HEAP32[i4 >> 2] | 0;
  i7 = 4;
 } else i8 = 0; else {
  i6 = i5;
  i7 = 4;
 }
 L4 : do if ((i7 | 0) == 4) {
  i5 = i3 + 20 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  if ((i6 - i4 | 0) >>> 0 < i2 >>> 0) {
   i8 = FUNCTION_TABLE_iiii[HEAP32[i3 + 36 >> 2] & 63](i3, i1, i2) | 0;
   break;
  }
  L9 : do if ((HEAP8[i3 + 75 >> 0] | 0) > -1) {
   i9 = i2;
   while (1) {
    if (!i9) {
     i10 = i2;
     i11 = i1;
     i12 = i4;
     i13 = 0;
     break L9;
    }
    i14 = i9 + -1 | 0;
    if ((HEAP8[i1 + i14 >> 0] | 0) == 10) {
     i15 = i9;
     break;
    } else i9 = i14;
   }
   if ((FUNCTION_TABLE_iiii[HEAP32[i3 + 36 >> 2] & 63](i3, i1, i15) | 0) >>> 0 < i15 >>> 0) {
    i8 = i15;
    break L4;
   }
   i10 = i2 - i15 | 0;
   i11 = i1 + i15 | 0;
   i12 = HEAP32[i5 >> 2] | 0;
   i13 = i15;
  } else {
   i10 = i2;
   i11 = i1;
   i12 = i4;
   i13 = 0;
  } while (0);
  _memcpy(i12 | 0, i11 | 0, i10 | 0) | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i10;
  i8 = i13 + i10 | 0;
 } while (0);
 return i8 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i10 = i1 + 8 | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] & 255](i10) | 0;
 i10 = HEAP8[i1 >> 0] | 0;
 if (!(i10 & 1)) i11 = (i10 & 255) >>> 1; else i11 = HEAP32[i1 + 4 >> 2] | 0;
 i10 = HEAP8[i1 + 12 >> 0] | 0;
 if (!(i10 & 1)) i12 = (i10 & 255) >>> 1; else i12 = HEAP32[i1 + 16 >> 2] | 0;
 do if ((i11 | 0) != (0 - i12 | 0)) {
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  i10 = __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i3, i8, i1, i1 + 24 | 0, i6, i5, 0) | 0;
  i13 = HEAP32[i2 >> 2] | 0;
  if ((i10 | 0) == (i1 | 0) & (i13 | 0) == 12) {
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if ((i13 | 0) < 12 & (i10 - i1 | 0) == 12) HEAP32[i2 >> 2] = i13 + 12;
 } else HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 4; while (0);
 STACKTOP = i7;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i10 = i1 + 8 | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] & 255](i10) | 0;
 i10 = HEAP8[i1 >> 0] | 0;
 if (!(i10 & 1)) i11 = (i10 & 255) >>> 1; else i11 = HEAP32[i1 + 4 >> 2] | 0;
 i10 = HEAP8[i1 + 12 >> 0] | 0;
 if (!(i10 & 1)) i12 = (i10 & 255) >>> 1; else i12 = HEAP32[i1 + 16 >> 2] | 0;
 do if ((i11 | 0) != (0 - i12 | 0)) {
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  i10 = __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i3, i8, i1, i1 + 24 | 0, i6, i5, 0) | 0;
  i13 = HEAP32[i2 >> 2] | 0;
  if ((i10 | 0) == (i1 | 0) & (i13 | 0) == 12) {
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if ((i13 | 0) < 12 & (i10 - i1 | 0) == 12) HEAP32[i2 >> 2] = i13 + 12;
 } else HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 4; while (0);
 STACKTOP = i7;
 return;
}

function __ZL25default_terminate_handlerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i2 = i1 + 32 | 0;
 i3 = i1 + 24 | 0;
 i4 = i1 + 16 | 0;
 i5 = i1;
 i6 = i1 + 36 | 0;
 i1 = ___cxa_get_globals_fast() | 0;
 if ((i1 | 0) != 0 ? (i7 = HEAP32[i1 >> 2] | 0, (i7 | 0) != 0) : 0) {
  i1 = i7 + 48 | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  i9 = HEAP32[i1 + 4 >> 2] | 0;
  if (!((i8 & -256 | 0) == 1126902528 & (i9 | 0) == 1129074247)) {
   HEAP32[i3 >> 2] = HEAP32[4852];
   _abort_message(40626, i3);
  }
  if ((i8 | 0) == 1126902529 & (i9 | 0) == 1129074247) i10 = HEAP32[i7 + 44 >> 2] | 0; else i10 = i7 + 80 | 0;
  HEAP32[i6 >> 2] = i10;
  i10 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i10 + 4 >> 2] | 0;
  if (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[14888 >> 2] | 0) + 16 >> 2] & 63](14888, i10, i6) | 0) {
   i10 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[4852] | 0;
   i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] & 255](i10) | 0;
   HEAP32[i5 >> 2] = i6;
   HEAP32[i5 + 4 >> 2] = i7;
   HEAP32[i5 + 8 >> 2] = i9;
   _abort_message(40540, i5);
  } else {
   HEAP32[i4 >> 2] = HEAP32[4852];
   HEAP32[i4 + 4 >> 2] = i7;
   _abort_message(40585, i4);
  }
 }
 _abort_message(40664, i2);
}

function __ZN7maxiDyn10compressorEddddd(i1, d2, d3, d4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0;
 i7 = +Math_abs(+d2) > d4;
 i8 = i1 + 72 | 0;
 i9 = (HEAP32[i8 >> 2] | 0) == 1;
 if (i7) if (!i9 ? (HEAP32[i1 + 68 >> 2] = 0, HEAP32[i1 + 80 >> 2] = 0, HEAP32[i8 >> 2] = 1, i7 = i1 + 16 | 0, +HEAPF64[i7 >> 3] == 0.0) : 0) {
  HEAPF64[i7 >> 3] = d3;
  i10 = 7;
 } else i10 = 7; else if (i9) i10 = 7; else {
  i9 = i1 + 16 | 0;
  i11 = i9;
  d12 = d3 + -1.0;
  d13 = +HEAPF64[i9 >> 3];
 }
 if ((i10 | 0) == 7) {
  i9 = i1 + 16 | 0;
  d4 = +HEAPF64[i9 >> 3];
  d14 = d3 + -1.0;
  if (d4 < d14) {
   d15 = (d5 + 1.0) * d4;
   HEAPF64[i9 >> 3] = d15;
   i11 = i9;
   d12 = d14;
   d13 = d15;
  } else {
   i11 = i9;
   d12 = d14;
   d13 = d4;
  }
 }
 if (!(d13 >= d12)) if (d13 > 0.0 ? (HEAP32[i1 + 80 >> 2] | 0) == 1 : 0) i10 = 12; else d16 = d13; else {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i1 + 80 >> 2] = 1;
  if (d13 > 0.0) i10 = 12; else d16 = d13;
 }
 if ((i10 | 0) == 12) {
  d12 = d13 * d6;
  HEAPF64[i11 >> 3] = d12;
  d16 = d12;
 }
 d12 = d2 / (d16 + 1.0);
 HEAPF64[i1 + 32 >> 3] = d12;
 return +(d12 * (+Math_log(+d3) + 1.0));
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i3;
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 if (i5 - i6 >> 2 >>> 0 < i2 >>> 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i8 = i6 - i7 >> 2;
  i6 = i8 + i2 | 0;
  if (i6 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i9 = i5 - i7 | 0;
  if (i9 >> 2 >>> 0 < 536870911) {
   i7 = i9 >> 1;
   i10 = i7 >>> 0 < i6 >>> 0 ? i6 : i7;
  } else i10 = 1073741823;
  __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_(i4, i10, i8, i1 + 16 | 0);
  i8 = i4 + 8 | 0;
  i10 = HEAP32[i8 >> 2] | 0;
  _memset(i10 | 0, 0, i2 << 2 | 0) | 0;
  HEAP32[i8 >> 2] = i10 + (i2 << 2);
  __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i1, i4);
  __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev(i4);
 } else __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16vectorIdNS_9allocatorIdEEE21__push_back_slow_pathIRKdEEvOT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i4;
 i6 = ((HEAP32[i3 >> 2] | 0) - i5 >> 3) + 1 | 0;
 if (i6 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1);
 i7 = i1 + 8 | 0;
 i8 = i4;
 i9 = (HEAP32[i7 >> 2] | 0) - i8 | 0;
 if (i9 >> 3 >>> 0 < 268435455) {
  i10 = i9 >> 2;
  i9 = i10 >>> 0 < i6 >>> 0 ? i6 : i10;
  i10 = (HEAP32[i3 >> 2] | 0) - i8 | 0;
  i6 = i10 >> 3;
  if (!i9) {
   i11 = 0;
   i12 = 0;
   i13 = i6;
   i14 = i10;
  } else {
   i15 = i9;
   i16 = i6;
   i17 = i10;
   i18 = 6;
  }
 } else {
  i10 = (HEAP32[i3 >> 2] | 0) - i8 | 0;
  i15 = 536870911;
  i16 = i10 >> 3;
  i17 = i10;
  i18 = 6;
 }
 if ((i18 | 0) == 6) {
  i11 = i15;
  i12 = __Znwj(i15 << 3) | 0;
  i13 = i16;
  i14 = i17;
 }
 HEAPF64[i12 + (i13 << 3) >> 3] = +HEAPF64[i2 >> 3];
 _memcpy(i12 | 0, i4 | 0, i14 | 0) | 0;
 HEAP32[i1 >> 2] = i12;
 HEAP32[i3 >> 2] = i12 + (i13 + 1 << 3);
 HEAP32[i7 >> 2] = i12 + (i11 << 3);
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function __ZNSt3__16vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIRKiEEvOT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i4;
 i6 = ((HEAP32[i3 >> 2] | 0) - i5 >> 2) + 1 | 0;
 if (i6 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1);
 i7 = i1 + 8 | 0;
 i8 = i4;
 i9 = (HEAP32[i7 >> 2] | 0) - i8 | 0;
 if (i9 >> 2 >>> 0 < 536870911) {
  i10 = i9 >> 1;
  i9 = i10 >>> 0 < i6 >>> 0 ? i6 : i10;
  i10 = (HEAP32[i3 >> 2] | 0) - i8 | 0;
  i6 = i10 >> 2;
  if (!i9) {
   i11 = 0;
   i12 = 0;
   i13 = i6;
   i14 = i10;
  } else {
   i15 = i9;
   i16 = i6;
   i17 = i10;
   i18 = 6;
  }
 } else {
  i10 = (HEAP32[i3 >> 2] | 0) - i8 | 0;
  i15 = 1073741823;
  i16 = i10 >> 2;
  i17 = i10;
  i18 = 6;
 }
 if ((i18 | 0) == 6) {
  i11 = i15;
  i12 = __Znwj(i15 << 2) | 0;
  i13 = i16;
  i14 = i17;
 }
 HEAP32[i12 + (i13 << 2) >> 2] = HEAP32[i2 >> 2];
 _memcpy(i12 | 0, i4 | 0, i14 | 0) | 0;
 HEAP32[i1 >> 2] = i12;
 HEAP32[i3 >> 2] = i12 + (i13 + 1 << 2);
 HEAP32[i7 >> 2] = i12 + (i11 << 2);
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function ___shgetc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = i1 + 104 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 0 ? (HEAP32[i1 + 108 >> 2] | 0) >= (i3 | 0) : 0) i4 = 4; else {
  i3 = ___uflow(i1) | 0;
  if ((i3 | 0) >= 0) {
   i5 = HEAP32[i2 >> 2] | 0;
   i2 = i1 + 8 | 0;
   if (i5) {
    i6 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 4 >> 2] | 0;
    i8 = i6;
    i9 = i5 - (HEAP32[i1 + 108 >> 2] | 0) + -1 | 0;
    if ((i8 - i7 | 0) > (i9 | 0)) {
     HEAP32[i1 + 100 >> 2] = i7 + i9;
     i10 = i6;
    } else {
     i11 = i8;
     i12 = i6;
     i4 = 9;
    }
   } else {
    i6 = HEAP32[i2 >> 2] | 0;
    i11 = i6;
    i12 = i6;
    i4 = 9;
   }
   if ((i4 | 0) == 9) {
    HEAP32[i1 + 100 >> 2] = i11;
    i10 = i12;
   }
   i12 = HEAP32[i1 + 4 >> 2] | 0;
   if (i10) {
    i11 = i1 + 108 | 0;
    HEAP32[i11 >> 2] = i10 + 1 - i12 + (HEAP32[i11 >> 2] | 0);
   }
   i11 = i12 + -1 | 0;
   if ((HEAPU8[i11 >> 0] | 0 | 0) == (i3 | 0)) i13 = i3; else {
    HEAP8[i11 >> 0] = i3;
    i13 = i3;
   }
  } else i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP32[i1 + 100 >> 2] = 0;
  i13 = -1;
 }
 return i13 | 0;
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
 do if ((((HEAP32[i1 + (i3 + 24) >> 2] | 0) != 0 ? (HEAP32[i1 + (i3 + 16) >> 2] | 0) == 0 : 0) ? (HEAP32[i1 + (i3 + 4) >> 2] & 8192 | 0) != 0 : 0) ? !(__ZSt18uncaught_exceptionv() | 0) : 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[i4 + ((HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
  __THREW__ = 0;
  i4 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   if ((i4 | 0) != -1) break;
   i4 = HEAP32[i2 >> 2] | 0;
   i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0;
   __THREW__ = 0;
   invoke_vii(65, i4 + i5 | 0, HEAP32[i4 + (i5 + 16) >> 2] | 1 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (!(i5 & 1)) break;
  }
  i5 = ___cxa_find_matching_catch(0) | 0;
  ___cxa_begin_catch(i5 | 0) | 0;
  __THREW__ = 0;
  invoke_v(3);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i5);
  }
 } while (0);
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
 do if ((((HEAP32[i1 + (i3 + 24) >> 2] | 0) != 0 ? (HEAP32[i1 + (i3 + 16) >> 2] | 0) == 0 : 0) ? (HEAP32[i1 + (i3 + 4) >> 2] & 8192 | 0) != 0 : 0) ? !(__ZSt18uncaught_exceptionv() | 0) : 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[i4 + ((HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
  __THREW__ = 0;
  i4 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   if ((i4 | 0) != -1) break;
   i4 = HEAP32[i2 >> 2] | 0;
   i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0;
   __THREW__ = 0;
   invoke_vii(65, i4 + i5 | 0, HEAP32[i4 + (i5 + 16) >> 2] | 1 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (!(i5 & 1)) break;
  }
  i5 = ___cxa_find_matching_catch(0) | 0;
  ___cxa_begin_catch(i5 | 0) | 0;
  __THREW__ = 0;
  invoke_v(3);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i5);
  }
 } while (0);
 return;
}

function __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 i7 = __ZNKSt3__18ios_base6getlocEv(i2) | 0;
 HEAP32[i6 >> 2] = i7;
 __THREW__ = 0;
 i2 = invoke_iii(55, i6 | 0, 26572) | 0;
 i8 = __THREW__;
 __THREW__ = 0;
 if ((((!(i8 & 1) ? (__THREW__ = 0, invoke_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, 46161, 46187, i3 | 0) | 0, i3 = __THREW__, __THREW__ = 0, !(i3 & 1)) : 0) ? (__THREW__ = 0, i3 = invoke_iii(55, i6 | 0, 26728) | 0, i6 = __THREW__, __THREW__ = 0, !(i6 & 1)) : 0) ? (__THREW__ = 0, i6 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (HEAP32[i4 >> 2] = i6, __THREW__ = 0, invoke_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i3 | 0), i3 = __THREW__, __THREW__ = 0, !(i3 & 1)) : 0) {
  __ZNSt3__114__shared_count16__release_sharedEv(i7) | 0;
  STACKTOP = i5;
  return;
 }
 i5 = ___cxa_find_matching_catch() | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(i7) | 0;
 ___resumeException(i5 | 0);
}

function __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 i7 = __ZNKSt3__18ios_base6getlocEv(i2) | 0;
 HEAP32[i6 >> 2] = i7;
 __THREW__ = 0;
 i2 = invoke_iii(55, i6 | 0, 26580) | 0;
 i8 = __THREW__;
 __THREW__ = 0;
 if ((((!(i8 & 1) ? (__THREW__ = 0, invoke_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, 46161, 46187, i3 | 0) | 0, i3 = __THREW__, __THREW__ = 0, !(i3 & 1)) : 0) ? (__THREW__ = 0, i3 = invoke_iii(55, i6 | 0, 26720) | 0, i6 = __THREW__, __THREW__ = 0, !(i6 & 1)) : 0) ? (__THREW__ = 0, i6 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0) | 0, i2 = __THREW__, __THREW__ = 0, !(i2 & 1)) : 0) ? (HEAP8[i4 >> 0] = i6, __THREW__ = 0, invoke_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i3 | 0), i3 = __THREW__, __THREW__ = 0, !(i3 & 1)) : 0) {
  __ZNSt3__114__shared_count16__release_sharedEv(i7) | 0;
  STACKTOP = i5;
  return;
 }
 i5 = ___cxa_find_matching_catch() | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(i7) | 0;
 ___resumeException(i5 | 0);
}

function __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 L1 : do if ((i1 | 0) == (i2 | 0)) {
  HEAP32[i3 >> 2] = 4;
  i7 = 0;
 } else {
  i8 = ___errno_location() | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  i10 = _strtoll_l(i1, i6, i4, __ZNSt3__16__clocEv() | 0) | 0;
  i11 = tempRet0;
  i12 = HEAP32[i8 >> 2] | 0;
  if (!i12) HEAP32[i8 >> 2] = i9;
  if ((HEAP32[i6 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i3 >> 2] = 4;
   i7 = 0;
   break;
  }
  do if ((i12 | 0) == 34) {
   HEAP32[i3 >> 2] = 4;
   if ((i11 | 0) > 0 | (i11 | 0) == 0 & i10 >>> 0 > 0) {
    i7 = 2147483647;
    break L1;
   }
  } else {
   if ((i11 | 0) < -1 | (i11 | 0) == -1 & i10 >>> 0 < 2147483648) {
    HEAP32[i3 >> 2] = 4;
    break;
   }
   if ((i11 | 0) > 0 | (i11 | 0) == 0 & i10 >>> 0 > 2147483647) {
    HEAP32[i3 >> 2] = 4;
    i7 = 2147483647;
    break L1;
   } else {
    i7 = i10;
    break L1;
   }
  } while (0);
  i7 = -2147483648;
 } while (0);
 STACKTOP = i5;
 return i7 | 0;
}

function ___cxx_global_array_dtor54(i1) {
 i1 = i1 | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27728);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27716);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27704);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27692);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27680);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27668);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27656);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27644);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27632);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27620);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27608);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27596);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27584);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(27572);
 return;
}

function ___cxx_global_array_dtor(i1) {
 i1 = i1 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27556);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27544);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27532);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27520);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27508);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27496);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27484);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27472);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27460);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27448);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27436);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27424);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27412);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(27400);
 return;
}

function _vsnprintf(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i6 = i5 + 112 | 0;
 i7 = i5;
 i8 = i7;
 i9 = 19732;
 i10 = i8 + 112 | 0;
 do {
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  i8 = i8 + 4 | 0;
  i9 = i9 + 4 | 0;
 } while ((i8 | 0) < (i10 | 0));
 if ((i2 + -1 | 0) >>> 0 > 2147483646) if (!i2) {
  i11 = i6;
  i12 = 1;
  i13 = 4;
 } else {
  i6 = ___errno_location() | 0;
  HEAP32[i6 >> 2] = 75;
  i14 = -1;
 } else {
  i11 = i1;
  i12 = i2;
  i13 = 4;
 }
 if ((i13 | 0) == 4) {
  i13 = -2 - i11 | 0;
  i2 = i12 >>> 0 > i13 >>> 0 ? i13 : i12;
  HEAP32[i7 + 48 >> 2] = i2;
  i12 = i7 + 20 | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i7 + 44 >> 2] = i11;
  i13 = i11 + i2 | 0;
  i11 = i7 + 16 | 0;
  HEAP32[i11 >> 2] = i13;
  HEAP32[i7 + 28 >> 2] = i13;
  i13 = _vfprintf(i7, i3, i4) | 0;
  if (!i2) i14 = i13; else {
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[i2 + (((i2 | 0) == (HEAP32[i11 >> 2] | 0)) << 31 >> 31) >> 0] = 0;
   i14 = i13;
  }
 }
 STACKTOP = i5;
 return i14 | 0;
}

function __ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i3 = i4 + 4 | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = i3 + 100;
 __ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc(i1 + 8 | 0, i3, i8, i5, i6, i7);
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i7 | 0)) i9 = i8; else {
  i2 = i3;
  i3 = i8;
  while (1) {
   i8 = HEAP8[i2 >> 0] | 0;
   do if (i3) {
    i6 = i3 + 24 | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    if ((i5 | 0) == (HEAP32[i3 + 28 >> 2] | 0)) {
     i1 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] & 63](i3, i8 & 255) | 0) == -1;
     i10 = i1 ? 0 : i3;
     break;
    } else {
     HEAP32[i6 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i8;
     i10 = i3;
     break;
    }
   } else i10 = 0; while (0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i7 | 0)) {
    i9 = i10;
    break;
   } else i3 = i10;
  }
 }
 STACKTOP = i4;
 return i9 | 0;
}

function __ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 i3 = i4 + 8 | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = i3 + 400;
 __ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc(i1 + 8 | 0, i3, i8, i5, i6, i7);
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i7 | 0)) i9 = i8; else {
  i2 = i3;
  i3 = i8;
  while (1) {
   i8 = HEAP32[i2 >> 2] | 0;
   if (!i3) i10 = 0; else {
    i6 = i3 + 24 | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    if ((i5 | 0) == (HEAP32[i3 + 28 >> 2] | 0)) i11 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] & 63](i3, i8) | 0; else {
     HEAP32[i6 >> 2] = i5 + 4;
     HEAP32[i5 >> 2] = i8;
     i11 = i8;
    }
    i10 = (i11 | 0) == -1 ? 0 : i3;
   }
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i7 | 0)) {
    i9 = i10;
    break;
   } else i3 = i10;
  }
 }
 STACKTOP = i4;
 return i9 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if ((1073741806 - i2 | 0) >>> 0 < i3 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (!(HEAP8[i1 >> 0] & 1)) i9 = i1 + 4 | 0; else i9 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 >>> 0 < 536870887) {
  i10 = i3 + i2 | 0;
  i3 = i2 << 1;
  i11 = i10 >>> 0 < i3 >>> 0 ? i3 : i10;
  i12 = i11 >>> 0 < 2 ? 2 : i11 + 4 & -4;
 } else i12 = 1073741807;
 i11 = __Znwj(i12 << 2) | 0;
 if (i5) _wmemcpy(i11, i9, i5) | 0;
 if (i7) _wmemcpy(i11 + (i5 << 2) | 0, i8, i7) | 0;
 i8 = i4 - i6 | 0;
 if ((i8 | 0) != (i5 | 0)) _wmemcpy(i11 + (i7 + i5 << 2) | 0, i9 + (i6 + i5 << 2) | 0, i8 - i5 | 0) | 0;
 if ((i2 | 0) != 1) __ZdlPv(i9);
 HEAP32[i1 + 8 >> 2] = i11;
 HEAP32[i1 >> 2] = i12 | 1;
 i12 = i8 + i7 | 0;
 HEAP32[i1 + 4 >> 2] = i12;
 HEAP32[i11 + (i12 << 2) >> 2] = 0;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if ((-18 - i2 | 0) >>> 0 < i3 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (!(HEAP8[i1 >> 0] & 1)) i9 = i1 + 1 | 0; else i9 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 >>> 0 < 2147483623) {
  i10 = i3 + i2 | 0;
  i3 = i2 << 1;
  i11 = i10 >>> 0 < i3 >>> 0 ? i3 : i10;
  i12 = i11 >>> 0 < 11 ? 11 : i11 + 16 & -16;
 } else i12 = -17;
 i11 = __Znwj(i12) | 0;
 if (i5) _memcpy(i11 | 0, i9 | 0, i5 | 0) | 0;
 if (i7) _memcpy(i11 + i5 | 0, i8 | 0, i7 | 0) | 0;
 i8 = i4 - i6 | 0;
 if ((i8 | 0) != (i5 | 0)) _memcpy(i11 + (i7 + i5) | 0, i9 + (i6 + i5) | 0, i8 - i5 | 0) | 0;
 if ((i2 | 0) != 10) __ZdlPv(i9);
 HEAP32[i1 + 8 >> 2] = i11;
 HEAP32[i1 >> 2] = i12 | 1;
 i12 = i8 + i7 | 0;
 HEAP32[i1 + 4 >> 2] = i12;
 HEAP8[i11 + i12 >> 0] = 0;
 return;
}

function __ZN10emscripten15register_vectorIiEENS_6class_INSt3__16vectorIT_NS2_9allocatorIS4_EEEENS_8internal11NoBaseClassEEEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __embind_register_class(13192, 13216, 13232, 0, 32095, 119, 32098, 0, 32098, 0, i2 | 0, 32100, 277);
 __embind_register_class_constructor(13192, 1, 17320, 32095, 120, 19);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 43;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13192, 31873, 3, 17324, 32103, 5, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13192, 31883, 4, 17336, 32108, 9, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 121;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13192, 31890, 2, 17352, 32114, 50, i2 | 0, 0);
 i2 = __Znwj(4) | 0;
 HEAP32[i2 >> 2] = 51;
 __embind_register_class_function(13192, 31895, 3, 17360, 32137, 32, i2 | 0, 0);
 i2 = __Znwj(4) | 0;
 HEAP32[i2 >> 2] = 33;
 __embind_register_class_function(13192, 31899, 4, 17372, 32142, 8, i2 | 0, 0);
 return;
}

function __ZN10emscripten15register_vectorIdEENS_6class_INSt3__16vectorIT_NS2_9allocatorIS4_EEEENS_8internal11NoBaseClassEEEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __embind_register_class(13280, 13304, 13320, 0, 32095, 122, 32098, 0, 32098, 0, i2 | 0, 32100, 278);
 __embind_register_class_constructor(13280, 1, 17388, 32095, 123, 20);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 44;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13280, 31873, 3, 17392, 32303, 6, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 7;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13280, 31883, 4, 17404, 32308, 2, i2 | 0, 0);
 i2 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = 124;
 HEAP32[i2 + 4 >> 2] = 0;
 __embind_register_class_function(13280, 31890, 2, 17420, 32114, 52, i2 | 0, 0);
 i2 = __Znwj(4) | 0;
 HEAP32[i2 >> 2] = 53;
 __embind_register_class_function(13280, 31895, 3, 17428, 32137, 34, i2 | 0, 0);
 i2 = __Znwj(4) | 0;
 HEAP32[i2 >> 2] = 35;
 __embind_register_class_function(13280, 31899, 4, 17440, 32314, 1, i2 | 0, 0);
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 i12 = i1 + 8 | 0;
 i13 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] & 255](i12) | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP8[i13 >> 0] | 0;
 i2 = (i3 & 1) == 0;
 i12 = i13 + 4 | 0;
 i14 = i2 ? i12 : HEAP32[i13 + 8 >> 2] | 0;
 i13 = i14 + ((i2 ? (i3 & 255) >>> 1 : HEAP32[i12 >> 2] | 0) << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i9, i8, i4, i5, i6, i14, i13) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 8 | 0;
 i9 = i7 + 4 | 0;
 i10 = i7;
 i11 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i9 >> 2] = i11;
 __THREW__ = 0;
 i4 = invoke_iii(55, i9 | 0, 26572) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i9 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  ___resumeException(i9 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 16 | 0, i2, i8, i5, i4);
  STACKTOP = i7;
  return HEAP32[i2 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 8 | 0;
 i9 = i7 + 4 | 0;
 i10 = i7;
 i11 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i9 >> 2] = i11;
 __THREW__ = 0;
 i4 = invoke_iii(55, i9 | 0, 26572) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i9 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  ___resumeException(i9 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 24 | 0, i2, i8, i5, i4);
  STACKTOP = i7;
  return HEAP32[i2 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 8 | 0;
 i9 = i7 + 4 | 0;
 i10 = i7;
 i11 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i9 >> 2] = i11;
 __THREW__ = 0;
 i4 = invoke_iii(55, i9 | 0, 26580) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i9 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  ___resumeException(i9 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 16 | 0, i2, i8, i5, i4);
  STACKTOP = i7;
  return HEAP32[i2 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 8 | 0;
 i9 = i7 + 4 | 0;
 i10 = i7;
 i11 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i9 >> 2] = i11;
 __THREW__ = 0;
 i4 = invoke_iii(55, i9 | 0, 26580) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i9 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  ___resumeException(i9 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 24 | 0, i2, i8, i5, i4);
  STACKTOP = i7;
  return HEAP32[i2 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 8 | 0;
 i9 = i7 + 4 | 0;
 i10 = i7;
 i11 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i9 >> 2] = i11;
 __THREW__ = 0;
 i4 = invoke_iii(55, i9 | 0, 26572) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i9 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  ___resumeException(i9 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6 + 20 | 0, i2, i8, i5, i4);
  STACKTOP = i7;
  return HEAP32[i2 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 8 | 0;
 i9 = i7 + 4 | 0;
 i10 = i7;
 i11 = __ZNKSt3__18ios_base6getlocEv(i4) | 0;
 HEAP32[i9 >> 2] = i11;
 __THREW__ = 0;
 i4 = invoke_iii(55, i9 | 0, 26580) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i9 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  ___resumeException(i9 | 0);
 } else {
  __ZNSt3__114__shared_count16__release_sharedEv(i11) | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6 + 20 | 0, i2, i8, i5, i4);
  STACKTOP = i7;
  return HEAP32[i2 >> 2] | 0;
 }
 return 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI20maxiEnvelopeFollowerEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 i12 = i1 + 8 | 0;
 i13 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] & 255](i12) | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP8[i13 >> 0] | 0;
 i2 = (i3 & 1) == 0;
 i12 = i2 ? i13 + 1 | 0 : HEAP32[i13 + 8 >> 2] | 0;
 i14 = i12 + (i2 ? (i3 & 255) >>> 1 : HEAP32[i13 + 4 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i9, i8, i4, i5, i6, i12, i14) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = i1 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) != 287;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = i6;
 i8 = (HEAP32[i3 >> 2] | 0) - i7 | 0;
 i9 = i8 >>> 0 < 2147483647 ? i8 << 1 : -1;
 i8 = (HEAP32[i2 >> 2] | 0) - i7 >> 2;
 i7 = _realloc(i5 ? i6 : 0, i9) | 0;
 if (!i7) __ZSt17__throw_bad_allocv();
 do if (!i5) {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  if (i6) {
   __THREW__ = 0;
   invoke_vi(HEAP32[i4 >> 2] | 0, i6 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i6 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i6);
   } else {
    i10 = HEAP32[i1 >> 2] | 0;
    break;
   }
  } else i10 = i7;
 } else {
  HEAP32[i1 >> 2] = i7;
  i10 = i7;
 } while (0);
 HEAP32[i4 >> 2] = 299;
 HEAP32[i2 >> 2] = i10 + (i8 << 2);
 HEAP32[i3 >> 2] = (HEAP32[i1 >> 2] | 0) + (i9 >>> 2 << 2);
 return;
}

function __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = i1 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) != 287;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = i6;
 i8 = (HEAP32[i3 >> 2] | 0) - i7 | 0;
 i9 = i8 >>> 0 < 2147483647 ? i8 << 1 : -1;
 i8 = (HEAP32[i2 >> 2] | 0) - i7 >> 2;
 i7 = _realloc(i5 ? i6 : 0, i9) | 0;
 if (!i7) __ZSt17__throw_bad_allocv();
 do if (!i5) {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  if (i6) {
   __THREW__ = 0;
   invoke_vi(HEAP32[i4 >> 2] | 0, i6 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i6 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i6);
   } else {
    i10 = HEAP32[i1 >> 2] | 0;
    break;
   }
  } else i10 = i7;
 } else {
  HEAP32[i1 >> 2] = i7;
  i10 = i7;
 } while (0);
 HEAP32[i4 >> 2] = 299;
 HEAP32[i2 >> 2] = i10 + (i8 << 2);
 HEAP32[i3 >> 2] = (HEAP32[i1 >> 2] | 0) + (i9 >>> 2 << 2);
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI14maxiDistortionEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI13maxiDelaylineEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiLagExpIdEEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI12maxiEnvelopeEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI11maxiFlangerEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiSampleEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiFilterEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiChorusEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI8maxiTestEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiOscEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMixEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMapEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiEnvEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiDynEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7convertEEE11val_deleterclEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = __emval_call(HEAP32[i1 >> 2] | 0, 0, 17496, i2 | 0) | 0;
 __THREW__ = 0;
 invoke_vi(280, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 >> 2] | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, 1);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_vi(280, 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else {
   STACKTOP = i2;
   return;
  }
 }
}

function __ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = i1 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) != 287;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = i6;
 i8 = (HEAP32[i3 >> 2] | 0) - i7 | 0;
 i9 = i8 >>> 0 < 2147483647 ? i8 << 1 : -1;
 i8 = (HEAP32[i2 >> 2] | 0) - i7 | 0;
 i7 = _realloc(i5 ? i6 : 0, i9) | 0;
 if (!i7) __ZSt17__throw_bad_allocv();
 do if (!i5) {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  if (i6) {
   __THREW__ = 0;
   invoke_vi(HEAP32[i4 >> 2] | 0, i6 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i6 = ___cxa_find_matching_catch(0) | 0;
    ___clang_call_terminate(i6);
   } else {
    i10 = HEAP32[i1 >> 2] | 0;
    break;
   }
  } else i10 = i7;
 } else {
  HEAP32[i1 >> 2] = i7;
  i10 = i7;
 } while (0);
 HEAP32[i4 >> 2] = 299;
 HEAP32[i2 >> 2] = i10 + i8;
 HEAP32[i3 >> 2] = (HEAP32[i1 >> 2] | 0) + i9;
 return;
}

function __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 do if ((i1 | 0) != (i2 | 0)) {
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  i9 = _strtoll_l(i1, i6, i4, __ZNSt3__16__clocEv() | 0) | 0;
  i10 = tempRet0;
  i11 = HEAP32[i7 >> 2] | 0;
  if (!i11) HEAP32[i7 >> 2] = i8;
  if ((HEAP32[i6 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i3 >> 2] = 4;
   i12 = 0;
   i13 = 0;
   break;
  }
  if ((i11 | 0) == 34) {
   HEAP32[i3 >> 2] = 4;
   i11 = (i10 | 0) > 0 | (i10 | 0) == 0 & i9 >>> 0 > 0;
   tempRet0 = i11 ? 2147483647 : -2147483648;
   STACKTOP = i5;
   return (i11 ? -1 : 0) | 0;
  } else {
   i12 = i10;
   i13 = i9;
  }
 } else {
  HEAP32[i3 >> 2] = 4;
  i12 = 0;
  i13 = 0;
 } while (0);
 tempRet0 = i12;
 STACKTOP = i5;
 return i13 | 0;
}

function __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 if (!(i4 & 2048)) i5 = i1; else {
  HEAP8[i1 >> 0] = 43;
  i5 = i1 + 1 | 0;
 }
 if (!(i4 & 512)) i6 = i5; else {
  HEAP8[i5 >> 0] = 35;
  i6 = i5 + 1 | 0;
 }
 i5 = HEAP8[i2 >> 0] | 0;
 if (!(i5 << 24 >> 24)) i7 = i6; else {
  i1 = i2;
  i2 = i6;
  i6 = i5;
  while (1) {
   i1 = i1 + 1 | 0;
   i5 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = i6;
   i6 = HEAP8[i1 >> 0] | 0;
   if (!(i6 << 24 >> 24)) {
    i7 = i5;
    break;
   } else i2 = i5;
  }
 }
 L11 : do switch (i4 & 74 | 0) {
 case 64:
  {
   HEAP8[i7 >> 0] = 111;
   break;
  }
 case 8:
  {
   if (!(i4 & 16384)) {
    HEAP8[i7 >> 0] = 120;
    break L11;
   } else {
    HEAP8[i7 >> 0] = 88;
    break L11;
   }
   break;
  }
 default:
  if (i3) {
   HEAP8[i7 >> 0] = 100;
   break L11;
  } else {
   HEAP8[i7 >> 0] = 117;
   break L11;
  }
 } while (0);
 return;
}

function __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 do if ((i1 | 0) != (i2 | 0)) {
  if ((HEAP8[i1 >> 0] | 0) == 45) {
   HEAP32[i3 >> 2] = 4;
   i7 = 0;
   break;
  }
  i8 = ___errno_location() | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  i10 = _strtoull_l(i1, i6, i4, __ZNSt3__16__clocEv() | 0) | 0;
  i11 = tempRet0;
  i12 = HEAP32[i8 >> 2] | 0;
  if (!i12) HEAP32[i8 >> 2] = i9;
  if ((HEAP32[i6 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i3 >> 2] = 4;
   i7 = 0;
   break;
  }
  if (i11 >>> 0 > 0 | (i11 | 0) == 0 & i10 >>> 0 > 65535 | (i12 | 0) == 34) {
   HEAP32[i3 >> 2] = 4;
   i7 = -1;
   break;
  } else {
   i7 = i10 & 65535;
   break;
  }
 } else {
  HEAP32[i3 >> 2] = 4;
  i7 = 0;
 } while (0);
 STACKTOP = i5;
 return i7 | 0;
}

function __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 do if ((i1 | 0) != (i2 | 0)) {
  if ((HEAP8[i1 >> 0] | 0) == 45) {
   HEAP32[i3 >> 2] = 4;
   i7 = 0;
   break;
  }
  i8 = ___errno_location() | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  i10 = _strtoull_l(i1, i6, i4, __ZNSt3__16__clocEv() | 0) | 0;
  i11 = tempRet0;
  i12 = HEAP32[i8 >> 2] | 0;
  if (!i12) HEAP32[i8 >> 2] = i9;
  if ((HEAP32[i6 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i3 >> 2] = 4;
   i7 = 0;
   break;
  }
  if (i11 >>> 0 > 0 | (i11 | 0) == 0 & i10 >>> 0 > 4294967295 | (i12 | 0) == 34) {
   HEAP32[i3 >> 2] = 4;
   i7 = -1;
   break;
  } else {
   i7 = i10;
   break;
  }
 } else {
  HEAP32[i3 >> 2] = 4;
  i7 = 0;
 } while (0);
 STACKTOP = i5;
 return i7 | 0;
}

function __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 do if ((i1 | 0) != (i2 | 0)) {
  if ((HEAP8[i1 >> 0] | 0) == 45) {
   HEAP32[i3 >> 2] = 4;
   i7 = 0;
   break;
  }
  i8 = ___errno_location() | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  i10 = _strtoull_l(i1, i6, i4, __ZNSt3__16__clocEv() | 0) | 0;
  i11 = tempRet0;
  i12 = HEAP32[i8 >> 2] | 0;
  if (!i12) HEAP32[i8 >> 2] = i9;
  if ((HEAP32[i6 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i3 >> 2] = 4;
   i7 = 0;
   break;
  }
  if (i11 >>> 0 > 0 | (i11 | 0) == 0 & i10 >>> 0 > 4294967295 | (i12 | 0) == 34) {
   HEAP32[i3 >> 2] = 4;
   i7 = -1;
   break;
  } else {
   i7 = i10;
   break;
  }
 } else {
  HEAP32[i3 >> 2] = 4;
  i7 = 0;
 } while (0);
 STACKTOP = i5;
 return i7 | 0;
}

function __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 HEAP8[i2 + 53 >> 0] = 1;
 do if ((HEAP32[i2 + 4 >> 2] | 0) == (i4 | 0)) {
  HEAP8[i2 + 52 >> 0] = 1;
  i1 = i2 + 16 | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  if (!i6) {
   HEAP32[i1 >> 2] = i3;
   HEAP32[i2 + 24 >> 2] = i5;
   HEAP32[i2 + 36 >> 2] = 1;
   if (!((i5 | 0) == 1 ? (HEAP32[i2 + 48 >> 2] | 0) == 1 : 0)) break;
   HEAP8[i2 + 54 >> 0] = 1;
   break;
  }
  if ((i6 | 0) != (i3 | 0)) {
   i6 = i2 + 36 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   HEAP8[i2 + 54 >> 0] = 1;
   break;
  }
  i6 = i2 + 24 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == 2) {
   HEAP32[i6 >> 2] = i5;
   i7 = i5;
  } else i7 = i1;
  if ((i7 | 0) == 1 ? (HEAP32[i2 + 48 >> 2] | 0) == 1 : 0) HEAP8[i2 + 54 >> 0] = 1;
 } while (0);
 return;
}

function __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 do if ((i1 | 0) != (i2 | 0)) {
  if ((HEAP8[i1 >> 0] | 0) == 45) {
   HEAP32[i3 >> 2] = 4;
   i7 = 0;
   i8 = 0;
   break;
  }
  i9 = ___errno_location() | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  i11 = _strtoull_l(i1, i6, i4, __ZNSt3__16__clocEv() | 0) | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  if (!i12) HEAP32[i9 >> 2] = i10;
  if ((HEAP32[i6 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i3 >> 2] = 4;
   i7 = 0;
   i8 = 0;
   break;
  }
  if ((i12 | 0) == 34) {
   HEAP32[i3 >> 2] = 4;
   i7 = -1;
   i8 = -1;
  } else {
   i7 = tempRet0;
   i8 = i11;
  }
 } else {
  HEAP32[i3 >> 2] = 4;
  i7 = 0;
  i8 = 0;
 } while (0);
 tempRet0 = i7;
 STACKTOP = i5;
 return i8 | 0;
}

function __ZN11maxiFlanger6flangeEdjddd(i1, d2, i3, d4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 var i7 = 0, d8 = 0.0, d9 = 0.0, d10 = 0.0, i11 = 0;
 i7 = i1 + 705648 | 0;
 d8 = +HEAPF64[i7 >> 3];
 if (!(d8 >= 1.0)) d9 = d8; else {
  d10 = d8 + -1.0;
  HEAPF64[i7 >> 3] = d10;
  d9 = d10;
 }
 d10 = d9 + 1.0 / (+(HEAP32[4327] | 0) / d5);
 HEAPF64[i7 >> 3] = d10;
 d5 = ((!(d10 <= .5) ? 1.0 - d10 : d10) + -.25) * 4.0;
 HEAPF64[i1 + 705672 >> 3] = d5;
 d10 = +(i3 >>> 0);
 i3 = i1 + 8 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 if ((i7 | 0) < (~~(d10 + d10 * (d5 * d6) + 1.0) | 0)) i11 = i7; else {
  HEAP32[i3 >> 2] = 0;
  i11 = 0;
 }
 i7 = i1 + 40 + (i11 << 3) | 0;
 i11 = i1 + 32 | 0;
 HEAPF64[i11 >> 3] = +HEAPF64[i7 >> 3];
 HEAPF64[i7 >> 3] = d2 * d4 * .5 + +HEAPF64[i7 >> 3] * d4;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 d4 = +HEAPF64[i11 >> 3];
 return +((d4 * (1.0 - +Math_abs(+d4)) + d2) * .5);
}

function _fflush(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 do if (i1) {
  if ((HEAP32[i1 + 76 >> 2] | 0) <= -1) {
   i2 = ___fflush_unlocked(i1) | 0;
   break;
  }
  i3 = (___lockfile(i1) | 0) == 0;
  i4 = ___fflush_unlocked(i1) | 0;
  if (i3) i2 = i4; else {
   ___unlockfile(i1);
   i2 = i4;
  }
 } else {
  if (!(HEAP32[4918] | 0)) i5 = 0; else i5 = _fflush(HEAP32[4918] | 0) | 0;
  ___lock(19440);
  i4 = HEAP32[4859] | 0;
  if (!i4) i6 = i5; else {
   i3 = i4;
   i4 = i5;
   while (1) {
    if ((HEAP32[i3 + 76 >> 2] | 0) > -1) i7 = ___lockfile(i3) | 0; else i7 = 0;
    if ((HEAP32[i3 + 20 >> 2] | 0) >>> 0 > (HEAP32[i3 + 28 >> 2] | 0) >>> 0) i8 = ___fflush_unlocked(i3) | 0 | i4; else i8 = i4;
    if (i7) ___unlockfile(i3);
    i3 = HEAP32[i3 + 56 >> 2] | 0;
    if (!i3) {
     i6 = i8;
     break;
    } else i4 = i8;
   }
  }
  ___unlock(19440);
  i2 = i6;
 } while (0);
 return i2 | 0;
}

function __ZN7maxiMix9ambisonicEdRNSt3__16vectorIdNS0_9allocatorIdEEEEddd(i1, d2, i3, d4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 var d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0;
 d7 = d4 > 1.0 ? 1.0 : d4;
 d4 = d7 < 0.0 ? 0.0 : d7;
 d7 = d5 > 1.0 ? 1.0 : d5;
 d5 = d6 < 0.0 ? 0.0 : d6 > 1.0 ? 1.0 : d7 < 0.0 ? 0.0 : d7;
 d7 = 1.0 - d4;
 d8 = +Math_sqrt(+(d7 * d5));
 i1 = HEAP32[i3 >> 2] | 0;
 HEAPF64[i1 >> 3] = (d8 - d6) * d2;
 d9 = 1.0 - d5;
 d10 = +Math_sqrt(+(d7 * d9));
 HEAPF64[i1 + 8 >> 3] = (d10 - d6) * d2;
 d7 = d4 * d5;
 d5 = (+Math_sqrt(+d7) - d6) * d2;
 HEAPF64[i1 + 16 >> 3] = d5;
 d5 = d4 * d9;
 d9 = (+Math_sqrt(+d5) - d6) * d2;
 HEAPF64[i1 + 24 >> 3] = d9;
 HEAPF64[i1 + 32 >> 3] = d8 * d6 * d2;
 HEAPF64[i1 + 40 >> 3] = d10 * d6 * d2;
 d10 = +Math_sqrt(+(d7 * d6)) * d2;
 HEAPF64[i1 + 48 >> 3] = d10;
 d10 = +Math_sqrt(+(d5 * d6)) * d2;
 HEAPF64[i1 + 56 >> 3] = d10;
 return;
}

function __ZNSt3__111__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4 + 4 | 0;
 i6 = i4;
 __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev(i1);
 HEAP32[i1 >> 2] = 24788;
 HEAP32[i1 + 32 >> 2] = i2;
 __ZNSt3__16localeC2ERKS0_(i5, i1 + 4 | 0);
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 __THREW__ = 0;
 i5 = invoke_iii(55, i6 | 0, 26648) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__16localeD2Ev(i6);
  __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev(i1);
  ___resumeException(i2 | 0);
 } else {
  __ZNSt3__16localeD2Ev(i6);
  HEAP32[i1 + 36 >> 2] = i5;
  HEAP32[i1 + 40 >> 2] = i3;
  i3 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] & 255](i5) | 0) & 1;
  HEAP8[i1 + 44 >> 0] = i3;
  STACKTOP = i4;
  return;
 }
}

function __ZNSt3__111__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4 + 4 | 0;
 i6 = i4;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = 24916;
 HEAP32[i1 + 32 >> 2] = i2;
 __ZNSt3__16localeC2ERKS0_(i5, i1 + 4 | 0);
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 __THREW__ = 0;
 i5 = invoke_iii(55, i6 | 0, 26640) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__16localeD2Ev(i6);
  __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
  ___resumeException(i2 | 0);
 } else {
  __ZNSt3__16localeD2Ev(i6);
  HEAP32[i1 + 36 >> 2] = i5;
  HEAP32[i1 + 40 >> 2] = i3;
  i3 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] & 255](i5) | 0) & 1;
  HEAP8[i1 + 44 >> 0] = i3;
  STACKTOP = i4;
  return;
 }
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (i2) {
  i4 = HEAP8[i1 >> 0] | 0;
  if (!(i4 & 1)) {
   i5 = 10;
   i6 = i4;
  } else {
   i4 = HEAP32[i1 >> 2] | 0;
   i5 = (i4 & -2) + -1 | 0;
   i6 = i4 & 255;
  }
  if (!(i6 & 1)) i7 = (i6 & 255) >>> 1; else i7 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i5 - i7 | 0) >>> 0 < i2 >>> 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i1, i5, i2 - i5 + i7 | 0, i7, i7, 0, 0);
   i8 = HEAP8[i1 >> 0] | 0;
  } else i8 = i6;
  if (!(i8 & 1)) i9 = i1 + 1 | 0; else i9 = HEAP32[i1 + 8 >> 2] | 0;
  _memset(i9 + i7 | 0, i3 | 0, i2 | 0) | 0;
  i3 = i7 + i2 | 0;
  if (!(HEAP8[i1 >> 0] & 1)) HEAP8[i1 >> 0] = i3 << 1; else HEAP32[i1 + 4 >> 2] = i3;
  HEAP8[i9 + i3 >> 0] = 0;
 }
 return i1 | 0;
}

function _pad(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 i7 = i6;
 do if ((i3 | 0) > (i4 | 0) & (i5 & 73728 | 0) == 0) {
  i8 = i3 - i4 | 0;
  _memset(i7 | 0, i2 | 0, (i8 >>> 0 > 256 ? 256 : i8) | 0) | 0;
  i9 = HEAP32[i1 >> 2] | 0;
  i10 = (i9 & 32 | 0) == 0;
  if (i8 >>> 0 > 255) {
   i11 = i3 - i4 | 0;
   i12 = i8;
   i13 = i9;
   i9 = i10;
   while (1) {
    if (i9) {
     ___fwritex(i7, 256, i1) | 0;
     i14 = HEAP32[i1 >> 2] | 0;
    } else i14 = i13;
    i12 = i12 + -256 | 0;
    i9 = (i14 & 32 | 0) == 0;
    if (i12 >>> 0 <= 255) break; else i13 = i14;
   }
   if (i9) i15 = i11 & 255; else break;
  } else if (i10) i15 = i8; else break;
  ___fwritex(i7, i15, i1) | 0;
 } while (0);
 STACKTOP = i6;
 return;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if ((1073741807 - i2 | 0) >>> 0 < i3 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (!(HEAP8[i1 >> 0] & 1)) i8 = i1 + 4 | 0; else i8 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 >>> 0 < 536870887) {
  i9 = i3 + i2 | 0;
  i3 = i2 << 1;
  i10 = i9 >>> 0 < i3 >>> 0 ? i3 : i9;
  i11 = i10 >>> 0 < 2 ? 2 : i10 + 4 & -4;
 } else i11 = 1073741807;
 i10 = __Znwj(i11 << 2) | 0;
 if (i5) _wmemcpy(i10, i8, i5) | 0;
 i9 = i4 - i6 | 0;
 if ((i9 | 0) != (i5 | 0)) _wmemcpy(i10 + (i7 + i5 << 2) | 0, i8 + (i6 + i5 << 2) | 0, i9 - i5 | 0) | 0;
 if ((i2 | 0) != 1) __ZdlPv(i8);
 HEAP32[i1 + 8 >> 2] = i10;
 HEAP32[i1 >> 2] = i11 | 1;
 return;
}

function __ZN10maxiSample8playOnceEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, d5 = 0.0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0;
 i3 = i1 + 40 | 0;
 d4 = +HEAPF64[i3 >> 3] + +HEAPF32[4326] * d2 / +((HEAP32[4327] | 0) / (HEAP32[i1 + 80 >> 2] | 0) | 0 | 0);
 HEAPF64[i3 >> 3] = d4;
 i3 = ~~d4;
 d2 = d4 - +(i3 | 0);
 if ((i3 | 0) >= (HEAP32[i1 + 84 >> 2] | 0)) {
  HEAPF64[i1 + 64 >> 3] = 0.0;
  d5 = 0.0;
  return +d5;
 }
 i6 = i1 + 96 | 0;
 i7 = i3 + 1 | 0;
 i3 = HEAP32[i1 + 100 >> 2] | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 if (i3 - i8 >> 3 >>> 0 <= i7 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i6);
 d9 = (1.0 - d2) * +HEAPF64[i8 + (i7 << 3) >> 3];
 i7 = ~~d4 + 2 | 0;
 if (i3 - i8 >> 3 >>> 0 <= i7 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i6);
 d4 = d9 + d2 * +HEAPF64[i8 + (i7 << 3) >> 3];
 HEAPF64[i1 + 64 >> 3] = d4;
 d5 = d4;
 return +d5;
}

function _fmt_u(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (i2 >>> 0 > 0 | (i2 | 0) == 0 & i1 >>> 0 > 4294967295) {
  i4 = i3;
  i5 = i1;
  i6 = i2;
  while (1) {
   i2 = ___uremdi3(i5 | 0, i6 | 0, 10, 0) | 0;
   i7 = i4 + -1 | 0;
   HEAP8[i7 >> 0] = i2 | 48;
   i2 = ___udivdi3(i5 | 0, i6 | 0, 10, 0) | 0;
   if (i6 >>> 0 > 9 | (i6 | 0) == 9 & i5 >>> 0 > 4294967295) {
    i4 = i7;
    i5 = i2;
    i6 = tempRet0;
   } else {
    i8 = i7;
    i9 = i2;
    break;
   }
  }
  i10 = i8;
  i11 = i9;
 } else {
  i10 = i3;
  i11 = i1;
 }
 if (!i11) i12 = i10; else {
  i1 = i10;
  i10 = i11;
  while (1) {
   i11 = i1 + -1 | 0;
   HEAP8[i11 >> 0] = (i10 >>> 0) % 10 | 0 | 48;
   if (i10 >>> 0 < 10) {
    i12 = i11;
    break;
   } else {
    i1 = i11;
    i10 = (i10 >>> 0) / 10 | 0;
   }
  }
 }
 return i12 | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if ((-17 - i2 | 0) >>> 0 < i3 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (!(HEAP8[i1 >> 0] & 1)) i8 = i1 + 1 | 0; else i8 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 >>> 0 < 2147483623) {
  i9 = i3 + i2 | 0;
  i3 = i2 << 1;
  i10 = i9 >>> 0 < i3 >>> 0 ? i3 : i9;
  i11 = i10 >>> 0 < 11 ? 11 : i10 + 16 & -16;
 } else i11 = -17;
 i10 = __Znwj(i11) | 0;
 if (i5) _memcpy(i10 | 0, i8 | 0, i5 | 0) | 0;
 i9 = i4 - i6 | 0;
 if ((i9 | 0) != (i5 | 0)) _memcpy(i10 + (i7 + i5) | 0, i8 + (i6 + i5) | 0, i9 - i5 | 0) | 0;
 if ((i2 | 0) != 10) __ZdlPv(i8);
 HEAP32[i1 + 8 >> 2] = i10;
 HEAP32[i1 >> 2] = i11 | 1;
 return;
}

function __ZNKSt3__120__time_get_c_storageIwE7__am_pmEv(i1) {
 i1 = i1 | 0;
 do if ((HEAP8[16976] | 0) == 0 ? (___cxa_guard_acquire(16976) | 0) != 0 : 0) {
  if ((HEAP8[16984] | 0) == 0 ? (___cxa_guard_acquire(16984) | 0) != 0 : 0) {
   i1 = 29480;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != 29768);
   ___cxa_atexit(296, 0, ___dso_handle | 0) | 0;
   ___cxa_guard_release(16984);
  }
  __THREW__ = 0;
  invoke_iii(59, 29480, 29768) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (!(i1 & 1) ? (__THREW__ = 0, invoke_iii(59, 29492, 29780) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) {
   HEAP32[7448] = 29480;
   ___cxa_guard_release(16976);
   break;
  }
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(16976);
  ___resumeException(i1 | 0);
 } while (0);
 return HEAP32[7448] | 0;
}

function __ZNKSt3__120__time_get_c_storageIcE7__am_pmEv(i1) {
 i1 = i1 | 0;
 do if ((HEAP8[16960] | 0) == 0 ? (___cxa_guard_acquire(16960) | 0) != 0 : 0) {
  if ((HEAP8[16968] | 0) == 0 ? (___cxa_guard_acquire(16968) | 0) != 0 : 0) {
   i1 = 29188;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != 29476);
   ___cxa_atexit(295, 0, ___dso_handle | 0) | 0;
   ___cxa_guard_release(16968);
  }
  __THREW__ = 0;
  invoke_iii(58, 29188, 47920) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (!(i1 & 1) ? (__THREW__ = 0, invoke_iii(58, 29200, 47923) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) {
   HEAP32[7369] = 29188;
   ___cxa_guard_release(16960);
   break;
  }
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(16960);
  ___resumeException(i1 | 0);
 } while (0);
 return HEAP32[7369] | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = HEAP8[i1 >> 0] | 0;
 i4 = (i3 & 1) != 0;
 if (i4) {
  i5 = (HEAP32[i1 >> 2] & -2) + -1 | 0;
  i6 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i5 = 1;
  i6 = (i3 & 255) >>> 1;
 }
 if ((i6 | 0) == (i5 | 0)) {
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i1, i5, 1, i5, i5, 0, 0);
  if (!(HEAP8[i1 >> 0] & 1)) i7 = 7; else i7 = 8;
 } else if (i4) i7 = 8; else i7 = 7;
 if ((i7 | 0) == 7) {
  HEAP8[i1 >> 0] = (i6 << 1) + 2;
  i8 = i1 + 4 | 0;
  i9 = i6 + 1 | 0;
 } else if ((i7 | 0) == 8) {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  i4 = i6 + 1 | 0;
  HEAP32[i1 + 4 >> 2] = i4;
  i8 = i7;
  i9 = i4;
 }
 HEAP32[i8 + (i6 << 2) >> 2] = i2;
 HEAP32[i8 + (i9 << 2) >> 2] = 0;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = HEAP8[i1 >> 0] | 0;
 if (!(i4 & 1)) {
  i5 = 10;
  i6 = i4;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = (i4 & -2) + -1 | 0;
  i6 = i4 & 255;
 }
 i4 = (i6 & 1) == 0;
 do if (i5 >>> 0 >= i3 >>> 0) {
  if (i4) i7 = i1 + 1 | 0; else i7 = HEAP32[i1 + 8 >> 2] | 0;
  _memmove(i7 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i7 + i3 >> 0] = 0;
  if (!(HEAP8[i1 >> 0] & 1)) {
   HEAP8[i1 >> 0] = i3 << 1;
   break;
  } else {
   HEAP32[i1 + 4 >> 2] = i3;
   break;
  }
 } else {
  if (i4) i8 = (i6 & 255) >>> 1; else i8 = HEAP32[i1 + 4 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i3 - i5 | 0, i8, 0, i8, i3, i2);
 } while (0);
 return i1 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = HEAP8[i1 >> 0] | 0;
 if (!(i4 & 1)) {
  i5 = 1;
  i6 = i4;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = (i4 & -2) + -1 | 0;
  i6 = i4 & 255;
 }
 i4 = (i6 & 1) == 0;
 do if (i5 >>> 0 >= i3 >>> 0) {
  if (i4) i7 = i1 + 4 | 0; else i7 = HEAP32[i1 + 8 >> 2] | 0;
  _wmemmove(i7, i2, i3) | 0;
  HEAP32[i7 + (i3 << 2) >> 2] = 0;
  if (!(HEAP8[i1 >> 0] & 1)) {
   HEAP8[i1 >> 0] = i3 << 1;
   break;
  } else {
   HEAP32[i1 + 4 >> 2] = i3;
   break;
  }
 } else {
  if (i4) i8 = (i6 & 255) >>> 1; else i8 = HEAP32[i1 + 4 >> 2] | 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw(i1, i5, i3 - i5 | 0, i8, 0, i8, i3, i2);
 } while (0);
 return i1 | 0;
}

function __ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 L1 : do if ((i1 | 0) != (HEAP32[i2 + 8 >> 2] | 0)) {
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = i1 + 16 + (i5 << 3) | 0;
  __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1 + 16 | 0, i2, i3, i4);
  if ((i5 | 0) > 1) {
   i5 = i2 + 54 | 0;
   i7 = i1 + 24 | 0;
   do {
    __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i7, i2, i3, i4);
    if (HEAP8[i5 >> 0] | 0) break L1;
    i7 = i7 + 8 | 0;
   } while (i7 >>> 0 < i6 >>> 0);
  }
 } else __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(0, i2, i3, i4); while (0);
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = HEAP8[i1 >> 0] | 0;
 if (!(i4 & 1)) {
  i5 = 10;
  i6 = i4;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = (i4 & -2) + -1 | 0;
  i6 = i4 & 255;
 }
 if (!(i6 & 1)) i7 = (i6 & 255) >>> 1; else i7 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i5 - i7 | 0) >>> 0 >= i3 >>> 0) {
  if (i3) {
   if (!(i6 & 1)) i8 = i1 + 1 | 0; else i8 = HEAP32[i1 + 8 >> 2] | 0;
   _memcpy(i8 + i7 | 0, i2 | 0, i3 | 0) | 0;
   i6 = i7 + i3 | 0;
   if (!(HEAP8[i1 >> 0] & 1)) HEAP8[i1 >> 0] = i6 << 1; else HEAP32[i1 + 4 >> 2] = i6;
   HEAP8[i8 + i6 >> 0] = 0;
  }
 } else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i3 - i5 + i7 | 0, i7, i7, 0, i3, i2);
 return i1 | 0;
}

function __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i4;
 i4 = _uselocale(i2) | 0;
 __THREW__ = 0;
 i2 = invoke_iiii(43, i1 | 0, i3 | 0, i6 | 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 if (i6 & 1) {
  i6 = ___cxa_find_matching_catch() | 0;
  if ((i4 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i4 | 0) | 0, i3 = __THREW__, __THREW__ = 0, i3 & 1) : 0) {
   i3 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i3);
  }
  ___resumeException(i6 | 0);
 } else {
  if ((i4 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i4 | 0) | 0, i4 = __THREW__, __THREW__ = 0, i4 & 1) : 0) {
   i4 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i4);
  }
  STACKTOP = i5;
  return i2 | 0;
 }
 return 0;
}

function __ZNSt3__111__stdoutbufIwE4syncEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2 + 8 | 0;
 i4 = i2;
 i5 = i1 + 36 | 0;
 i6 = i1 + 40 | 0;
 i7 = i3 + 8 | 0;
 i8 = i3;
 i9 = i1 + 32 | 0;
 L1 : while (1) {
  i1 = HEAP32[i5 >> 2] | 0;
  i10 = FUNCTION_TABLE_iiiiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 31](i1, HEAP32[i6 >> 2] | 0, i3, i7, i4) | 0;
  i1 = (HEAP32[i4 >> 2] | 0) - i8 | 0;
  if ((_fwrite(i3, 1, i1, HEAP32[i9 >> 2] | 0) | 0) != (i1 | 0)) {
   i11 = -1;
   break;
  }
  switch (i10 | 0) {
  case 1:
   break;
  case 2:
   {
    i11 = -1;
    break L1;
    break;
   }
  default:
   {
    i12 = 4;
    break L1;
   }
  }
 }
 if ((i12 | 0) == 4) i11 = ((_fflush(HEAP32[i9 >> 2] | 0) | 0) != 0) << 31 >> 31;
 STACKTOP = i2;
 return i11 | 0;
}

function __ZNSt3__111__stdoutbufIcE4syncEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2 + 8 | 0;
 i4 = i2;
 i5 = i1 + 36 | 0;
 i6 = i1 + 40 | 0;
 i7 = i3 + 8 | 0;
 i8 = i3;
 i9 = i1 + 32 | 0;
 L1 : while (1) {
  i1 = HEAP32[i5 >> 2] | 0;
  i10 = FUNCTION_TABLE_iiiiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 31](i1, HEAP32[i6 >> 2] | 0, i3, i7, i4) | 0;
  i1 = (HEAP32[i4 >> 2] | 0) - i8 | 0;
  if ((_fwrite(i3, 1, i1, HEAP32[i9 >> 2] | 0) | 0) != (i1 | 0)) {
   i11 = -1;
   break;
  }
  switch (i10 | 0) {
  case 1:
   break;
  case 2:
   {
    i11 = -1;
    break L1;
    break;
   }
  default:
   {
    i12 = 4;
    break L1;
   }
  }
 }
 if ((i12 | 0) == 4) i11 = ((_fflush(HEAP32[i9 >> 2] | 0) | 0) != 0) << 31 >> 31;
 STACKTOP = i2;
 return i11 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i2;
 i5 = i3 - i4 | 0;
 i6 = i5 >> 2;
 if (i6 >>> 0 > 1073741807) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i6 >>> 0 < 2) {
  HEAP8[i1 >> 0] = i5 >>> 1;
  i7 = i1 + 4 | 0;
 } else {
  i5 = i6 + 4 & -4;
  i8 = __Znwj(i5 << 2) | 0;
  HEAP32[i1 + 8 >> 2] = i8;
  HEAP32[i1 >> 2] = i5 | 1;
  HEAP32[i1 + 4 >> 2] = i6;
  i7 = i8;
 }
 i8 = (i3 - i4 | 0) >>> 2;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i2;
  i2 = i7;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i4 = i4 + 4 | 0;
   if ((i4 | 0) == (i3 | 0)) break; else i2 = i2 + 4 | 0;
  }
 }
 HEAP32[i7 + (i8 << 2) >> 2] = 0;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = HEAP8[i1 >> 0] | 0;
 i4 = (i3 & 1) != 0;
 if (i4) {
  i5 = (HEAP32[i1 >> 2] & -2) + -1 | 0;
  i6 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i5 = 10;
  i6 = (i3 & 255) >>> 1;
 }
 if ((i6 | 0) == (i5 | 0)) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i1, i5, 1, i5, i5, 0, 0);
  if (!(HEAP8[i1 >> 0] & 1)) i7 = 7; else i7 = 8;
 } else if (i4) i7 = 8; else i7 = 7;
 if ((i7 | 0) == 7) {
  HEAP8[i1 >> 0] = (i6 << 1) + 2;
  i8 = i1 + 1 | 0;
  i9 = i6 + 1 | 0;
 } else if ((i7 | 0) == 8) {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  i4 = i6 + 1 | 0;
  HEAP32[i1 + 4 >> 2] = i4;
  i8 = i7;
  i9 = i4;
 }
 HEAP8[i8 + i6 >> 0] = i2;
 HEAP8[i8 + i9 >> 0] = 0;
 return;
}

function __ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i5 = i4;
 if ((i1 | 0) != (i2 | 0)) if ((i2 | 0) != 0 ? (i6 = ___dynamic_cast(i2, 14968, 14984, 0) | 0, (i6 | 0) != 0) : 0) {
  i2 = i5;
  i7 = i2 + 56 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i7 | 0));
  HEAP32[i5 >> 2] = i6;
  HEAP32[i5 + 8 >> 2] = i1;
  HEAP32[i5 + 12 >> 2] = -1;
  HEAP32[i5 + 48 >> 2] = 1;
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] & 31](i6, i5, HEAP32[i3 >> 2] | 0, 1);
  if ((HEAP32[i5 + 24 >> 2] | 0) == 1) {
   HEAP32[i3 >> 2] = HEAP32[i5 + 16 >> 2];
   i8 = 1;
  } else i8 = 0;
  i9 = i8;
 } else i9 = 0; else i9 = 1;
 STACKTOP = i4;
 return i9 | 0;
}

function _wcrtomb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 do if (i1) {
  if (i2 >>> 0 < 128) {
   HEAP8[i1 >> 0] = i2;
   i4 = 1;
   break;
  }
  if (i2 >>> 0 < 2048) {
   HEAP8[i1 >> 0] = i2 >>> 6 | 192;
   HEAP8[i1 + 1 >> 0] = i2 & 63 | 128;
   i4 = 2;
   break;
  }
  if (i2 >>> 0 < 55296 | (i2 & -8192 | 0) == 57344) {
   HEAP8[i1 >> 0] = i2 >>> 12 | 224;
   HEAP8[i1 + 1 >> 0] = i2 >>> 6 & 63 | 128;
   HEAP8[i1 + 2 >> 0] = i2 & 63 | 128;
   i4 = 3;
   break;
  }
  if ((i2 + -65536 | 0) >>> 0 < 1048576) {
   HEAP8[i1 >> 0] = i2 >>> 18 | 240;
   HEAP8[i1 + 1 >> 0] = i2 >>> 12 & 63 | 128;
   HEAP8[i1 + 2 >> 0] = i2 >>> 6 & 63 | 128;
   HEAP8[i1 + 3 >> 0] = i2 & 63 | 128;
   i4 = 4;
   break;
  } else {
   i3 = ___errno_location() | 0;
   HEAP32[i3 >> 2] = 84;
   i4 = -1;
   break;
  }
 } else i4 = 1; while (0);
 return i4 | 0;
}

function __ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 do if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
  if ((HEAP32[i2 + 4 >> 2] | 0) == (i3 | 0) ? (i5 = i2 + 28 | 0, (HEAP32[i5 >> 2] | 0) != 1) : 0) HEAP32[i5 >> 2] = i4;
 } else if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  if ((HEAP32[i2 + 16 >> 2] | 0) != (i3 | 0) ? (i5 = i2 + 20 | 0, (HEAP32[i5 >> 2] | 0) != (i3 | 0)) : 0) {
   HEAP32[i2 + 32 >> 2] = i4;
   HEAP32[i5 >> 2] = i3;
   i5 = i2 + 40 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   if ((HEAP32[i2 + 36 >> 2] | 0) == 1 ? (HEAP32[i2 + 24 >> 2] | 0) == 2 : 0) HEAP8[i2 + 54 >> 0] = 1;
   HEAP32[i2 + 44 >> 2] = 4;
   break;
  }
  if ((i4 | 0) == 1) HEAP32[i2 + 32 >> 2] = 1;
 } while (0);
 return;
}

function _strlen(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = i1;
 L1 : do if (!(i2 & 3)) {
  i3 = i1;
  i4 = 4;
 } else {
  i5 = i1;
  i6 = i2;
  while (1) {
   if (!(HEAP8[i5 >> 0] | 0)) {
    i7 = i6;
    break L1;
   }
   i8 = i5 + 1 | 0;
   i6 = i8;
   if (!(i6 & 3)) {
    i3 = i8;
    i4 = 4;
    break;
   } else i5 = i8;
  }
 } while (0);
 if ((i4 | 0) == 4) {
  i4 = i3;
  while (1) {
   i3 = HEAP32[i4 >> 2] | 0;
   if (!((i3 & -2139062144 ^ -2139062144) & i3 + -16843009)) i4 = i4 + 4 | 0; else {
    i9 = i3;
    i10 = i4;
    break;
   }
  }
  if (!((i9 & 255) << 24 >> 24)) i11 = i10; else {
   i9 = i10;
   while (1) {
    i10 = i9 + 1 | 0;
    if (!(HEAP8[i10 >> 0] | 0)) {
     i11 = i10;
     break;
    } else i9 = i10;
   }
  }
  i7 = i11;
 }
 return i7 - i2 | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i2;
 i5 = i3 - i4 | 0;
 if (i5 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i5 >>> 0 < 11) {
  HEAP8[i1 >> 0] = i5 << 1;
  i6 = i1 + 1 | 0;
 } else {
  i7 = i5 + 16 & -16;
  i8 = __Znwj(i7) | 0;
  HEAP32[i1 + 8 >> 2] = i8;
  HEAP32[i1 >> 2] = i7 | 1;
  HEAP32[i1 + 4 >> 2] = i5;
  i6 = i8;
 }
 i8 = i3 - i4 | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i2;
  i2 = i6;
  while (1) {
   HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 HEAP8[i6 + i8 >> 0] = 0;
 return;
}

function __ZN10maxiFilter5hiresEddd(i1, d2, d3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 var d5 = 0.0, i6 = 0, d7 = 0.0, d8 = 0.0, i9 = 0;
 d5 = d3 * .5;
 i6 = i1 + 224 | 0;
 d3 = d5 < 10.0 ? 10.0 : d5;
 HEAPF64[i6 >> 3] = d3;
 d5 = +(HEAP32[4327] | 0);
 d7 = d5 * .5;
 if (d3 > d7) {
  HEAPF64[i6 >> 3] = d7;
  d8 = d7;
 } else d8 = d3;
 d3 = +Math_cos(+(d8 * 6.283185307179586 / d5));
 HEAPF64[i1 + 208 >> 3] = d3;
 d5 = 2.0 - d3 * 2.0;
 HEAPF64[i1 + 216 >> 3] = d5;
 d8 = d3 + -1.0;
 d3 = (d4 < 1.0 ? 1.0 : d4) * d8;
 d4 = (d3 + +Math_sqrt(+-+Math_pow(+d8, 3.0)) * 1.4142135623730951) / d3;
 i6 = i1 + 192 | 0;
 i9 = i1 + 200 | 0;
 d3 = +HEAPF64[i9 >> 3];
 d8 = +HEAPF64[i6 >> 3] + d5 * (d2 - d3);
 d5 = d3 + d8;
 HEAPF64[i9 >> 3] = d5;
 HEAPF64[i6 >> 3] = d4 * d8;
 d8 = d2 - d5;
 HEAPF64[i1 + 16 >> 3] = d8;
 return +d8;
}

function _scalbn(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 if ((i2 | 0) > 1023) {
  d3 = d1 * 8988465674311579538646525.0e283;
  i4 = i2 + -1023 | 0;
  if ((i4 | 0) > 1023) {
   i5 = i2 + -2046 | 0;
   i6 = (i5 | 0) > 1023 ? 1023 : i5;
   d7 = d3 * 8988465674311579538646525.0e283;
  } else {
   i6 = i4;
   d7 = d3;
  }
 } else if ((i2 | 0) < -1022) {
  d3 = d1 * 2.2250738585072014e-308;
  i4 = i2 + 1022 | 0;
  if ((i4 | 0) < -1022) {
   i5 = i2 + 2044 | 0;
   i6 = (i5 | 0) < -1022 ? -1022 : i5;
   d7 = d3 * 2.2250738585072014e-308;
  } else {
   i6 = i4;
   d7 = d3;
  }
 } else {
  i6 = i2;
  d7 = d1;
 }
 i2 = _bitshift64Shl(i6 + 1023 | 0, 0, 52) | 0;
 i6 = tempRet0;
 HEAP32[tempDoublePtr >> 2] = i2;
 HEAP32[tempDoublePtr + 4 >> 2] = i6;
 return +(d7 * +HEAPF64[tempDoublePtr >> 3]);
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i10 = i1 + 8 | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] & 255](i10) | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i9 = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i3, i8, i1, i1 + 288 | 0, i6, i5, 0) | 0) - i1 | 0;
 if ((i9 | 0) < 288) HEAP32[i2 >> 2] = ((i9 | 0) / 12 | 0 | 0) % 12 | 0;
 STACKTOP = i7;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i10 = i1 + 8 | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] & 255](i10) | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i9 = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i3, i8, i1, i1 + 288 | 0, i6, i5, 0) | 0) - i1 | 0;
 if ((i9 | 0) < 288) HEAP32[i2 >> 2] = ((i9 | 0) / 12 | 0 | 0) % 12 | 0;
 STACKTOP = i7;
 return;
}

function __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZNSt3__114__shared_count12__add_sharedEv(i2);
 i4 = i1 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((HEAP32[i1 + 12 >> 2] | 0) - i5 >> 2 >>> 0 > i3 >>> 0) i6 = i5; else {
  __THREW__ = 0;
  invoke_vii(103, i4 | 0, i3 + 1 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   i6 = HEAP32[i4 >> 2] | 0;
   break;
  }
  i7 = ___cxa_find_matching_catch() | 0;
  if (i2) __ZNSt3__114__shared_count16__release_sharedEv(i2) | 0;
  ___resumeException(i7 | 0);
 } while (0);
 i5 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
 if (!i5) i8 = i6; else {
  __ZNSt3__114__shared_count16__release_sharedEv(i5) | 0;
  i8 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i8 + (i3 << 2) >> 2] = i2;
 return;
}

function __ZN10maxiFilter8bandpassEddd(i1, d2, d3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 var i5 = 0, d6 = 0.0, d7 = 0.0, d8 = 0.0, i9 = 0;
 i5 = i1 + 224 | 0;
 HEAPF64[i5 >> 3] = d3;
 d6 = +(HEAP32[4327] | 0);
 d7 = d6 * .5;
 if (d7 < d3) {
  HEAPF64[i5 >> 3] = d7;
  d8 = d7;
 } else d8 = d3;
 d3 = !(d4 >= 1.0) ? d4 : .999999;
 d4 = +Math_cos(+(d8 * 6.283185307179586 / d6));
 HEAPF64[i1 + 208 >> 3] = d4;
 d6 = (1.0 - d3) * +Math_sqrt(+(d3 * (d3 - d4 * d4 * 4.0 + 2.0) + 1.0));
 HEAPF64[i1 + 24 >> 3] = d6;
 d8 = d3 * (d4 * 2.0);
 HEAPF64[i1 + 32 >> 3] = d8;
 d4 = d3 * d3;
 HEAPF64[i1 + 40 >> 3] = d4;
 i5 = i1 + 112 | 0;
 d3 = +HEAPF64[i5 >> 3];
 i9 = i1 + 120 | 0;
 d7 = d6 * d2 + d8 * d3 + d4 * +HEAPF64[i9 >> 3];
 HEAPF64[i1 + 16 >> 3] = d7;
 HEAPF64[i9 >> 3] = d3;
 HEAPF64[i5 >> 3] = d7;
 return +d7;
}

function __ZNSt3__110__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4 + 4 | 0;
 i6 = i4;
 __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev(i1);
 HEAP32[i1 >> 2] = 24852;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = i3;
 HEAP32[i1 + 48 >> 2] = -1;
 HEAP8[i1 + 52 >> 0] = 0;
 __ZNSt3__16localeC2ERKS0_(i5, i1 + 4 | 0);
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 __THREW__ = 0;
 invoke_vii(2, i1 | 0, i6 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__16localeD2Ev(i6);
  __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev(i1);
  ___resumeException(i5 | 0);
 } else {
  __ZNSt3__16localeD2Ev(i6);
  STACKTOP = i4;
  return;
 }
}

function __ZNSt3__110__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4 + 4 | 0;
 i6 = i4;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = 24980;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = i3;
 HEAP32[i1 + 48 >> 2] = -1;
 HEAP8[i1 + 52 >> 0] = 0;
 __ZNSt3__16localeC2ERKS0_(i5, i1 + 4 | 0);
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 __THREW__ = 0;
 invoke_vii(4, i1 | 0, i6 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch() | 0;
  __ZNSt3__16localeD2Ev(i6);
  __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
  ___resumeException(i5 | 0);
 } else {
  __ZNSt3__16localeD2Ev(i6);
  STACKTOP = i4;
  return;
 }
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i10 = i1 + 8 | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i10 >> 2] >> 2] & 255](i10) | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i9 = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i3, i8, i1, i1 + 168 | 0, i6, i5, 0) | 0) - i1 | 0;
 if ((i9 | 0) < 168) HEAP32[i2 >> 2] = ((i9 | 0) / 12 | 0 | 0) % 7 | 0;
 STACKTOP = i7;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i10 = i1 + 8 | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i10 >> 2] >> 2] & 255](i10) | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i9 = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i3, i8, i1, i1 + 168 | 0, i6, i5, 0) | 0) - i1 | 0;
 if ((i9 | 0) < 168) HEAP32[i2 >> 2] = ((i9 | 0) / 12 | 0 | 0) % 7 | 0;
 STACKTOP = i7;
 return;
}

function __ZN10maxiFilter5loresEddd(i1, d2, d3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 var d5 = 0.0, i6 = 0, d7 = 0.0, d8 = 0.0, i9 = 0;
 d5 = d3 * .5;
 i6 = i1 + 224 | 0;
 d3 = d5 < 10.0 ? 10.0 : d5;
 HEAPF64[i6 >> 3] = d3;
 d5 = +(HEAP32[4327] | 0);
 d7 = d5 * .5;
 if (d3 > d7) {
  HEAPF64[i6 >> 3] = d7;
  d8 = d7;
 } else d8 = d3;
 d3 = +Math_cos(+(d8 * 6.283185307179586 / d5));
 HEAPF64[i1 + 208 >> 3] = d3;
 d5 = 2.0 - d3 * 2.0;
 HEAPF64[i1 + 216 >> 3] = d5;
 d8 = d3 + -1.0;
 d3 = (d4 < 1.0 ? 1.0 : d4) * d8;
 d4 = (d3 + +Math_sqrt(+-+Math_pow(+d8, 3.0)) * 1.4142135623730951) / d3;
 i6 = i1 + 192 | 0;
 i9 = i1 + 200 | 0;
 d3 = +HEAPF64[i9 >> 3];
 d8 = +HEAPF64[i6 >> 3] + d5 * (d2 - d3);
 d2 = d3 + d8;
 HEAPF64[i9 >> 3] = d2;
 HEAPF64[i6 >> 3] = d4 * d8;
 HEAPF64[i1 + 16 >> 3] = d2;
 return +d2;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = i1 + 12 | 0;
 i5 = i1 + 16 | 0;
 L1 : do if ((i3 | 0) > 0) {
  i6 = i2;
  i7 = 0;
  while (1) {
   i8 = HEAP32[i4 >> 2] | 0;
   if (i8 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
    i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 255](i1) | 0;
    if ((i9 | 0) == -1) {
     i10 = i7;
     break L1;
    } else i11 = i9;
   } else {
    HEAP32[i4 >> 2] = i8 + 4;
    i11 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i6 >> 2] = i11;
   i8 = i7 + 1 | 0;
   if ((i8 | 0) < (i3 | 0)) {
    i6 = i6 + 4 | 0;
    i7 = i8;
   } else {
    i10 = i8;
    break;
   }
  }
 } else i10 = 0; while (0);
 return i10 | 0;
}

function ___overflow(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = i2 & 255;
 HEAP8[i4 >> 0] = i5;
 i6 = i1 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if (!i7) if (!(___towrite(i1) | 0)) {
  i8 = HEAP32[i6 >> 2] | 0;
  i9 = 4;
 } else i10 = -1; else {
  i8 = i7;
  i9 = 4;
 }
 do if ((i9 | 0) == 4) {
  i7 = i1 + 20 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  if (i6 >>> 0 < i8 >>> 0 ? (i11 = i2 & 255, (i11 | 0) != (HEAP8[i1 + 75 >> 0] | 0)) : 0) {
   HEAP32[i7 >> 2] = i6 + 1;
   HEAP8[i6 >> 0] = i5;
   i10 = i11;
   break;
  }
  if ((FUNCTION_TABLE_iiii[HEAP32[i1 + 36 >> 2] & 63](i1, i4, 1) | 0) == 1) i10 = HEAPU8[i4 >> 0] | 0; else i10 = -1;
 } while (0);
 STACKTOP = i3;
 return i10 | 0;
}

function __ZN10emscripten8internal15FunctionInvokerIPFNS_3valERKNSt3__16vectorIiNS3_9allocatorIiEEEEjES2_S9_JjEE6invokeEPSB_PS7_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = FUNCTION_TABLE_iii[HEAP32[i1 >> 2] & 63](i2, i3) | 0;
 __THREW__ = 0;
 invoke_vi(279, i4 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, i4 | 0);
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i2);
  } else ___resumeException(i3 | 0);
 } else {
  __THREW__ = 0;
  invoke_vi(280, i4 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i3);
  } else return i4 | 0;
 }
 return 0;
}

function __ZN10emscripten8internal15FunctionInvokerIPFNS_3valERKNSt3__16vectorIdNS3_9allocatorIdEEEEjES2_S9_JjEE6invokeEPSB_PS7_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = FUNCTION_TABLE_iii[HEAP32[i1 >> 2] & 63](i2, i3) | 0;
 __THREW__ = 0;
 invoke_vi(279, i4 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  __THREW__ = 0;
  invoke_vi(280, i4 | 0);
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i2);
  } else ___resumeException(i3 | 0);
 } else {
  __THREW__ = 0;
  invoke_vi(280, i4 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i3);
  } else return i4 | 0;
 }
 return 0;
}

function _frexp(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, d8 = 0.0, i9 = 0, d10 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i3 = HEAP32[tempDoublePtr >> 2] | 0;
 i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i5 = _bitshift64Lshr(i3 | 0, i4 | 0, 52) | 0;
 i6 = i5 & 2047;
 switch (i6 | 0) {
 case 0:
  {
   if (d1 != 0.0) {
    d7 = +_frexp(d1 * 18446744073709551616.0, i2);
    d8 = d7;
    i9 = (HEAP32[i2 >> 2] | 0) + -64 | 0;
   } else {
    d8 = d1;
    i9 = 0;
   }
   HEAP32[i2 >> 2] = i9;
   d10 = d8;
   break;
  }
 case 2047:
  {
   d10 = d1;
   break;
  }
 default:
  {
   HEAP32[i2 >> 2] = i6 + -1022;
   HEAP32[tempDoublePtr >> 2] = i3;
   HEAP32[tempDoublePtr + 4 >> 2] = i4 & -2146435073 | 1071644672;
   d10 = +HEAPF64[tempDoublePtr >> 3];
  }
 }
 return +d10;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = i1 + 12 | 0;
 i5 = i1 + 16 | 0;
 L1 : do if ((i3 | 0) > 0) {
  i6 = i2;
  i7 = 0;
  while (1) {
   i8 = HEAP32[i4 >> 2] | 0;
   if (i8 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
    HEAP32[i4 >> 2] = i8 + 1;
    i9 = HEAP8[i8 >> 0] | 0;
   } else {
    i8 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 255](i1) | 0;
    if ((i8 | 0) == -1) {
     i10 = i7;
     break L1;
    }
    i9 = i8 & 255;
   }
   HEAP8[i6 >> 0] = i9;
   i8 = i7 + 1 | 0;
   if ((i8 | 0) < (i3 | 0)) {
    i6 = i6 + 1 | 0;
    i7 = i8;
   } else {
    i10 = i8;
    break;
   }
  }
 } else i10 = 0; while (0);
 return i10 | 0;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = i1 + 24 | 0;
 i5 = i1 + 28 | 0;
 L1 : do if ((i3 | 0) > 0) {
  i6 = i2;
  i7 = 0;
  while (1) {
   i8 = HEAP32[i4 >> 2] | 0;
   if (i8 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
    if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] & 63](i1, HEAP32[i6 >> 2] | 0) | 0) == -1) {
     i9 = i7;
     break L1;
    }
   } else {
    i10 = HEAP32[i6 >> 2] | 0;
    HEAP32[i4 >> 2] = i8 + 4;
    HEAP32[i8 >> 2] = i10;
   }
   i10 = i7 + 1 | 0;
   if ((i10 | 0) < (i3 | 0)) {
    i6 = i6 + 4 | 0;
    i7 = i10;
   } else {
    i9 = i10;
    break;
   }
  }
 } else i9 = 0; while (0);
 return i9 | 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = i1 + 24 | 0;
 i5 = i1 + 28 | 0;
 L1 : do if ((i3 | 0) > 0) {
  i6 = i2;
  i7 = 0;
  while (1) {
   i8 = HEAP32[i4 >> 2] | 0;
   if (i8 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
    if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] & 63](i1, HEAPU8[i6 >> 0] | 0) | 0) == -1) {
     i9 = i7;
     break L1;
    }
   } else {
    i10 = HEAP8[i6 >> 0] | 0;
    HEAP32[i4 >> 2] = i8 + 1;
    HEAP8[i8 >> 0] = i10;
   }
   i10 = i7 + 1 | 0;
   if ((i10 | 0) < (i3 | 0)) {
    i6 = i6 + 1 | 0;
    i7 = i10;
   } else {
    i9 = i10;
    break;
   }
  }
 } else i9 = 0; while (0);
 return i9 | 0;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i5 = i2 + 4 | 0;
 i6 = (HEAP32[i4 >> 2] | 0) - i3 | 0;
 i7 = (HEAP32[i5 >> 2] | 0) + (0 - (i6 >> 2) << 2) | 0;
 HEAP32[i5 >> 2] = i7;
 _memcpy(i7 | 0, i3 | 0, i6 | 0) | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 i6 = i2 + 8 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i3;
 i3 = i1 + 8 | 0;
 i1 = i2 + 12 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i6;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 return;
}

function __ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 L1 : do if ((i4 | 0) == (i5 | 0)) {
  i6 = i2;
  i7 = 6;
 } else {
  i1 = i4;
  i8 = i2;
  while (1) {
   if ((i8 | 0) == (i3 | 0)) {
    i9 = -1;
    break L1;
   }
   i10 = HEAP8[i8 >> 0] | 0;
   i11 = HEAP8[i1 >> 0] | 0;
   if (i10 << 24 >> 24 < i11 << 24 >> 24) {
    i9 = -1;
    break L1;
   }
   if (i11 << 24 >> 24 < i10 << 24 >> 24) {
    i9 = 1;
    break L1;
   }
   i10 = i8 + 1 | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i6 = i10;
    i7 = 6;
    break;
   } else i8 = i10;
  }
 } while (0);
 if ((i7 | 0) == 6) i9 = (i6 | 0) != (i3 | 0) & 1;
 return i9 | 0;
}

function _fputc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) >= 0 ? (___lockfile(i2) | 0) != 0 : 0) {
  if ((HEAP8[i2 + 75 >> 0] | 0) != (i1 | 0) ? (i3 = i2 + 20 | 0, i4 = HEAP32[i3 >> 2] | 0, i4 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) : 0) {
   HEAP32[i3 >> 2] = i4 + 1;
   HEAP8[i4 >> 0] = i1;
   i5 = i1 & 255;
  } else i5 = ___overflow(i2, i1) | 0;
  ___unlockfile(i2);
  i6 = i5;
 } else i7 = 3;
 do if ((i7 | 0) == 3) {
  if ((HEAP8[i2 + 75 >> 0] | 0) != (i1 | 0) ? (i5 = i2 + 20 | 0, i4 = HEAP32[i5 >> 2] | 0, i4 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) : 0) {
   HEAP32[i5 >> 2] = i4 + 1;
   HEAP8[i4 >> 0] = i1;
   i6 = i1 & 255;
   break;
  }
  i6 = ___overflow(i2, i1) | 0;
 } while (0);
 return i6 | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiSampleNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = HEAP32[i1 + 104 >> 2] | 0;
 if (i3) _free(i3);
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 if (i3) _free(i3);
 _printf(34962, i2) | 0;
 i3 = HEAP32[i1 + 112 >> 2] | 0;
 if (!i3) {
  i4 = i1 + 16 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i2;
  return;
 }
 i5 = i1 + 116 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -8 - i3 | 0) >>> 3) << 3);
 __ZdlPv(i3);
 i4 = i1 + 16 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 L1 : do if ((i4 | 0) == (i5 | 0)) {
  i6 = i2;
  i7 = 6;
 } else {
  i1 = i4;
  i8 = i2;
  while (1) {
   if ((i8 | 0) == (i3 | 0)) {
    i9 = -1;
    break L1;
   }
   i10 = HEAP32[i8 >> 2] | 0;
   i11 = HEAP32[i1 >> 2] | 0;
   if ((i10 | 0) < (i11 | 0)) {
    i9 = -1;
    break L1;
   }
   if ((i11 | 0) < (i10 | 0)) {
    i9 = 1;
    break L1;
   }
   i10 = i8 + 4 | 0;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i6 = i10;
    i7 = 6;
    break;
   } else i8 = i10;
  }
 } while (0);
 if ((i7 | 0) == 6) i9 = (i6 | 0) != (i3 | 0) & 1;
 return i9 | 0;
}

function __ZNSt3__111make_sharedI10maxiSampleJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = __Znwj(128) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18252;
 i3 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i4 = i2 + 56 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP16[i2 + 92 >> 1] = 1;
 HEAP32[i2 + 96 >> 2] = HEAP32[4327];
 i4 = i2 + 104 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 L1 : do switch (HEAP32[i3 + 4 >> 2] & 176 | 0) {
 case 16:
  {
   i4 = HEAP8[i1 >> 0] | 0;
   switch (i4 << 24 >> 24) {
   case 43:
   case 45:
    {
     i5 = i1 + 1 | 0;
     break L1;
     break;
    }
   default:
    {}
   }
   if ((i2 - i1 | 0) > 1 & i4 << 24 >> 24 == 48) {
    switch (HEAP8[i1 + 1 >> 0] | 0) {
    case 88:
    case 120:
     break;
    default:
     {
      i6 = 7;
      break L1;
     }
    }
    i5 = i1 + 2 | 0;
   } else i6 = 7;
   break;
  }
 case 32:
  {
   i5 = i2;
   break;
  }
 default:
  i6 = 7;
 } while (0);
 if ((i6 | 0) == 7) i5 = i1;
 return i5 | 0;
}

function ___remdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5 | 0;
 i7 = i2 >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i8 = ((i2 | 0) < 0 ? -1 : 0) >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i9 = i4 >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i10 = ((i4 | 0) < 0 ? -1 : 0) >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i11 = _i64Subtract(i7 ^ i1, i8 ^ i2, i7, i8) | 0;
 i2 = tempRet0;
 ___udivmoddi4(i11, i2, _i64Subtract(i9 ^ i3, i10 ^ i4, i9, i10) | 0, tempRet0, i6) | 0;
 i10 = _i64Subtract(HEAP32[i6 >> 2] ^ i7, HEAP32[i6 + 4 >> 2] ^ i8, i7, i8) | 0;
 i8 = tempRet0;
 STACKTOP = i5;
 return (tempRet0 = i8, i10) | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 4) | 0;
 if (!(HEAP32[i5 >> 2] & 4)) {
  if ((i8 | 0) < 69) i9 = i8 + 2e3 | 0; else i9 = (i8 + -69 | 0) >>> 0 < 31 ? i8 + 1900 | 0 : i8;
  HEAP32[i2 >> 2] = i9 + -1900;
 }
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 4) | 0;
 if (!(HEAP32[i5 >> 2] & 4)) {
  if ((i8 | 0) < 69) i9 = i8 + 2e3 | 0; else i9 = (i8 + -69 | 0) >>> 0 < 31 ? i8 + 1900 | 0 : i8;
  HEAP32[i2 >> 2] = i9 + -1900;
 }
 STACKTOP = i1;
 return;
}

function _ungetc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 do if ((i1 | 0) != -1) {
  if ((HEAP32[i2 + 76 >> 2] | 0) > -1) i3 = ___lockfile(i2) | 0; else i3 = 0;
  if (!((HEAP32[i2 + 8 >> 2] | 0) == 0 ? (___toread(i2) | 0) != 0 : 0)) i4 = 6;
  if ((i4 | 0) == 6 ? (i5 = i2 + 4 | 0, i6 = HEAP32[i5 >> 2] | 0, i6 >>> 0 > ((HEAP32[i2 + 44 >> 2] | 0) + -8 | 0) >>> 0) : 0) {
   i7 = i6 + -1 | 0;
   HEAP32[i5 >> 2] = i7;
   HEAP8[i7 >> 0] = i1;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -17;
   if (!i3) {
    i8 = i1;
    break;
   }
   ___unlockfile(i2);
   i8 = i1;
   break;
  }
  if (i3) {
   ___unlockfile(i2);
   i8 = -1;
  } else i8 = -1;
 } else i8 = -1; while (0);
 return i8 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i9, i8, i4, i5, i6, 27148, 27180) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i9, i8, i4, i5, i6, 47570, 47578) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNSt3__115__num_get_floatIeEET_PKcS3_Rj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, d10 = 0.0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 do if ((i1 | 0) != (i2 | 0)) {
  i6 = ___errno_location() | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  d8 = +_strtold_l(i1, i5, __ZNSt3__16__clocEv() | 0);
  i9 = HEAP32[i6 >> 2] | 0;
  if (!i9) HEAP32[i6 >> 2] = i7;
  if ((HEAP32[i5 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i3 >> 2] = 4;
   d10 = 0.0;
   break;
  }
  if ((i9 | 0) == 34) {
   HEAP32[i3 >> 2] = 4;
   d10 = d8;
  } else d10 = d8;
 } else {
  HEAP32[i3 >> 2] = 4;
  d10 = 0.0;
 } while (0);
 STACKTOP = i4;
 return +d10;
}

function __ZNSt3__115__num_get_floatIdEET_PKcS3_Rj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, d10 = 0.0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 do if ((i1 | 0) != (i2 | 0)) {
  i6 = ___errno_location() | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  d8 = +_strtold_l(i1, i5, __ZNSt3__16__clocEv() | 0);
  i9 = HEAP32[i6 >> 2] | 0;
  if (!i9) HEAP32[i6 >> 2] = i7;
  if ((HEAP32[i5 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i3 >> 2] = 4;
   d10 = 0.0;
   break;
  }
  if ((i9 | 0) == 34) {
   HEAP32[i3 >> 2] = 4;
   d10 = d8;
  } else d10 = d8;
 } else {
  HEAP32[i3 >> 2] = 4;
  d10 = 0.0;
 } while (0);
 STACKTOP = i4;
 return +d10;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i11 = __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiSampleNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 HEAP32[i1 >> 2] = 18252;
 i3 = HEAP32[i1 + 104 >> 2] | 0;
 if (i3) _free(i3);
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 if (i3) _free(i3);
 _printf(34962, i2) | 0;
 i3 = HEAP32[i1 + 112 >> 2] | 0;
 i4 = i3;
 if (i3) {
  i5 = i1 + 116 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -8 - i4 | 0) >>> 3) << 3);
  __ZdlPv(i3);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 16 | 0);
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiSampleNS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 HEAP32[i1 >> 2] = 18252;
 i3 = HEAP32[i1 + 104 >> 2] | 0;
 if (i3) _free(i3);
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 if (i3) _free(i3);
 _printf(34962, i2) | 0;
 i3 = HEAP32[i1 + 112 >> 2] | 0;
 i4 = i3;
 if (i3) {
  i5 = i1 + 116 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -8 - i4 | 0) >>> 3) << 3);
  __ZdlPv(i3);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 16 | 0);
 __ZNSt3__114__shared_countD2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__115__num_get_floatIfEET_PKcS3_Rj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, d6 = 0.0, i7 = 0, i8 = 0, d9 = 0.0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 do if ((i1 | 0) == (i2 | 0)) {
  HEAP32[i3 >> 2] = 4;
  d6 = 0.0;
 } else {
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  d9 = +_strtold_l(i1, i5, __ZNSt3__16__clocEv() | 0);
  i10 = HEAP32[i7 >> 2] | 0;
  if (!i10) HEAP32[i7 >> 2] = i8;
  if ((HEAP32[i5 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i3 >> 2] = 4;
   d6 = 0.0;
   break;
  }
  if ((i10 | 0) == 34) HEAP32[i3 >> 2] = 4;
  d6 = d9;
 } while (0);
 STACKTOP = i4;
 return +d6;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 + -1 | 0) >>> 0 < 12 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 + -1 | 0) >>> 0 < 12 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNSt3__18ios_base5clearEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = (HEAP32[i1 + 24 >> 2] | 0) == 0;
 HEAP32[i1 + 16 >> 2] = i5 & 1 | i2;
 if (!((i5 & 1 | i2) & HEAP32[i1 + 20 >> 2])) {
  STACKTOP = i3;
  return;
 }
 i3 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__117iostream_categoryEv() | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = 25472;
 __THREW__ = 0;
 invoke_viii(8, i3 | 0, 46100, i4 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch() | 0;
  ___cxa_free_exception(i3 | 0);
  ___resumeException(i4 | 0);
 } else ___cxa_throw(i3 | 0, 15296, 156);
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 + -1 | 0) >>> 0 < 31 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 3) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 366 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 + -1 | 0) >>> 0 < 31 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 3) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 366 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 13 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8 + -1; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 13 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8 + -1; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 1) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 7 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 61 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 60 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 1) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 7 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 61 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 60 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 24 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 2) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i8 | 0) < 24 & (i6 & 4 | 0) == 0) HEAP32[i2 >> 2] = i8; else HEAP32[i5 >> 2] = i6 | 4;
 STACKTOP = i1;
 return;
}

function __ZNSt3__111make_sharedI10maxiChorusJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __Znwj(1411584) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18976;
 _memset(i2 + 56 | 0, 0, 705600) | 0;
 _memset(i2 + 705696 | 0, 0, 705600) | 0;
 HEAPF64[i2 + 1411304 >> 3] = 0.0;
 i3 = i2 + 1411536 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = i2 + 16;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN10emscripten8internal14raw_destructorI10maxiSampleEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 i3 = HEAP32[i1 + 88 >> 2] | 0;
 if (i3) _free(i3);
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (i3) _free(i3);
 _printf(34962, i2) | 0;
 i3 = HEAP32[i1 + 96 >> 2] | 0;
 i4 = i3;
 if (i3) {
  i5 = i1 + 100 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -8 - i4 | 0) >>> 3) << 3);
  __ZdlPv(i3);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _strerror(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = 0;
 while (1) {
  if ((HEAPU8[40685 + i2 >> 0] | 0) == (i1 | 0)) {
   i3 = i2;
   i4 = 2;
   break;
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 87) {
   i5 = 87;
   i6 = 40773;
   i4 = 5;
   break;
  }
 }
 if ((i4 | 0) == 2) if (!i3) i7 = 40773; else {
  i5 = i3;
  i6 = 40773;
  i4 = 5;
 }
 if ((i4 | 0) == 5) while (1) {
  i4 = 0;
  i3 = i6;
  while (1) {
   i2 = i3 + 1 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i8 = i2;
    break;
   } else i3 = i2;
  }
  i5 = i5 + -1 | 0;
  if (!i5) {
   i7 = i8;
   break;
  } else {
   i6 = i8;
   i4 = 5;
  }
 }
 return i7 | 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI20maxiEnvelopeFollowerEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function ___fflush_unlocked(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = i1 + 20 | 0;
 i3 = i1 + 28 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0 ? (FUNCTION_TABLE_iiii[HEAP32[i1 + 36 >> 2] & 63](i1, 0, 0) | 0, (HEAP32[i2 >> 2] | 0) == 0) : 0) i4 = -1; else {
  i5 = i1 + 4 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i1 + 8 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i6 >>> 0 < i8 >>> 0) FUNCTION_TABLE_iiii[HEAP32[i1 + 40 >> 2] & 63](i1, i6 - i8 | 0, 1) | 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i4 = 0;
 }
 return i4 | 0;
}

function __ZNSt3__16locale5__impD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i1 >> 2] = 26556;
 i2 = i1 + 8 | 0;
 i3 = i1 + 12 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) != (i4 | 0)) {
  i5 = i4;
  i4 = 0;
  do {
   i6 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
   if (i6) __ZNSt3__114__shared_count16__release_sharedEv(i6) | 0;
   i4 = i4 + 1 | 0;
   i5 = HEAP32[i2 >> 2] | 0;
  } while (i4 >>> 0 < (HEAP32[i3 >> 2] | 0) - i5 >> 2 >>> 0);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 144 | 0);
 __ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i2);
 return;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 128 >> 0] = 0;
 do if (i2) {
  __THREW__ = 0;
  invoke_vii(104, i1 | 0, i2 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch() | 0;
   __ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i1);
   ___resumeException(i3 | 0);
  } else {
   __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i1, i2);
   break;
  }
 } while (0);
 return;
}

function _vasprintf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 i6 = _malloc(240) | 0;
 do if (i6) {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  i7 = _vsnprintf(i6, 240, i2, i5) | 0;
  if (i7 >>> 0 < 240) {
   i8 = _realloc(i6, i7 + 1 | 0) | 0;
   HEAP32[i1 >> 2] = (i8 | 0) != 0 ? i8 : i6;
   i9 = i7;
   break;
  }
  _free(i6);
  if ((i7 | 0) >= 0 ? (i8 = i7 + 1 | 0, i7 = _malloc(i8) | 0, HEAP32[i1 >> 2] = i7, (i7 | 0) != 0) : 0) i9 = _vsnprintf(i7, i8, i2, i3) | 0; else i9 = -1;
 } else i9 = -1; while (0);
 STACKTOP = i4;
 return i9 | 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI14maxiDistortionEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN7maxiOsc8sinebuf4Ed(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, d5 = 0.0, d6 = 0.0, d7 = 0.0, d8 = 0.0;
 i3 = i1 + 8 | 0;
 d4 = 512.0 / (+(HEAP32[4327] | 0) / d2) + +HEAPF64[i3 >> 3];
 d2 = !(d4 >= 511.0) ? d4 : d4 + -512.0;
 HEAPF64[i3 >> 3] = d2;
 d4 = d2 - +Math_floor(+d2);
 i3 = ~~d2;
 d5 = +HEAPF64[(d2 == 0.0 ? 4104 : 8 + (i3 + -1 << 3) | 0) >> 3];
 d2 = +HEAPF64[8 + (i3 << 3) >> 3];
 d6 = +HEAPF64[8 + (i3 + 1 << 3) >> 3];
 d7 = +HEAPF64[8 + (i3 + 2 << 3) >> 3];
 d8 = d2 + d4 * ((d6 - d5) * .5 + d4 * (d5 - d2 * 2.5 + d6 * 2.0 - d7 * .5 + d4 * ((d2 - d6) * 1.5 + (d7 - d5) * .5)));
 HEAPF64[i1 + 32 >> 3] = d8;
 return +d8;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI13maxiDelaylineEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI10maxiLagExpIdEEEJEE6invokeEPFS6_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI12maxiEnvelopeEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI11maxiFlangerEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i4 - i5 >> 2;
 if (i6 >>> 0 >= i2 >>> 0) {
  if (i6 >>> 0 > i2 >>> 0 ? (i7 = i5 + (i2 << 2) | 0, (i4 | 0) != (i7 | 0)) : 0) {
   i5 = i4;
   while (1) {
    i4 = i5 + -4 | 0;
    if ((i4 | 0) == (i7 | 0)) {
     i8 = i4;
     break;
    } else i5 = i4;
   }
   HEAP32[i3 >> 2] = i8;
  }
 } else __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj(i1, i2 - i6 | 0);
 return;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI10maxiSampleEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI10maxiFilterEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI10maxiChorusEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI8maxiTestEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiOscEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiMixEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiMapEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiEnvEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiDynEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7convertEEJEE6invokeEPFS5_vE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 FUNCTION_TABLE_vi[i1 & 511](i3);
 __THREW__ = 0;
 i1 = invoke_ii(125, 8) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = ___cxa_find_matching_catch() | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) ___resumeException(i1 | 0);
 __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 ___resumeException(i1 | 0);
 return 0;
}

function _strtox(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i5 = i4;
 i6 = i5;
 i7 = i6 + 112 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = i1;
 i7 = i5 + 8 | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i5 + 44 >> 2] = i1;
 HEAP32[i5 + 76 >> 2] = -1;
 ___shlim(i5, 0);
 d8 = +___floatscan(i5, i3, 1);
 i3 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) + (HEAP32[i5 + 108 >> 2] | 0) | 0;
 if (i2) HEAP32[i2 >> 2] = (i3 | 0) != 0 ? i1 + i3 | 0 : i1;
 STACKTOP = i4;
 return +d8;
}

function _realloc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i3 = _malloc(i2) | 0;
  return i3 | 0;
 }
 if (i2 >>> 0 > 4294967231) {
  i4 = ___errno_location() | 0;
  HEAP32[i4 >> 2] = 12;
  i3 = 0;
  return i3 | 0;
 }
 i4 = _try_realloc_chunk(i1 + -8 | 0, i2 >>> 0 < 11 ? 16 : i2 + 11 & -8) | 0;
 if (i4) {
  i3 = i4 + 8 | 0;
  return i3 | 0;
 }
 i4 = _malloc(i2) | 0;
 if (!i4) {
  i3 = 0;
  return i3 | 0;
 }
 i5 = HEAP32[i1 + -4 >> 2] | 0;
 i6 = (i5 & -8) - ((i5 & 3 | 0) == 0 ? 8 : 4) | 0;
 _memcpy(i4 | 0, i1 | 0, (i6 >>> 0 < i2 >>> 0 ? i6 : i2) | 0) | 0;
 _free(i1);
 i3 = i4;
 return i3 | 0;
}

function _getc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) >= 0 ? (___lockfile(i1) | 0) != 0 : 0) {
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 >>> 0 < (HEAP32[i1 + 8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = i3 + 1;
   i4 = HEAPU8[i3 >> 0] | 0;
  } else i4 = ___uflow(i1) | 0;
  i5 = i4;
 } else i6 = 3;
 do if ((i6 | 0) == 3) {
  i4 = i1 + 4 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < (HEAP32[i1 + 8 >> 2] | 0) >>> 0) {
   HEAP32[i4 >> 2] = i3 + 1;
   i5 = HEAPU8[i3 >> 0] | 0;
   break;
  } else {
   i5 = ___uflow(i1) | 0;
   break;
  }
 } while (0);
 return i5 | 0;
}

function __ZSt11__terminatePFvvE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 __THREW__ = 0;
 invoke_v(i1 | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (!(i1 & 1)) {
  __THREW__ = 0;
  invoke_vii(61, 40198, i2 | 0);
  __THREW__ = 0;
 }
 i1 = ___cxa_find_matching_catch(0) | 0;
 ___cxa_begin_catch(i1 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(61, 40238, i2 + 8 | 0);
 __THREW__ = 0;
 i2 = ___cxa_find_matching_catch(0) | 0;
 __THREW__ = 0;
 invoke_v(3);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 } else ___clang_call_terminate(i2);
}

function _memcpy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if ((i3 | 0) >= 4096) return _emscripten_memcpy_big(i1 | 0, i2 | 0, i3 | 0) | 0;
 i4 = i1 | 0;
 if ((i1 & 3) == (i2 & 3)) {
  while (i1 & 3) {
   if (!i3) return i4 | 0;
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 - 1 | 0;
  }
  while ((i3 | 0) >= 4) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
   i3 = i3 - 4 | 0;
  }
 }
 while ((i3 | 0) > 0) {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 - 1 | 0;
 }
 return i4 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 4) | 0;
 if (!(HEAP32[i5 >> 2] & 4)) HEAP32[i2 >> 2] = i8 + -1900;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i1 + 4 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i3, i7, i5, i6, 4) | 0;
 if (!(HEAP32[i5 >> 2] & 4)) HEAP32[i2 >> 2] = i8 + -1900;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7;
 HEAP8[i8 >> 0] = 37;
 i9 = i8 + 1 | 0;
 HEAP8[i9 >> 0] = i5;
 i10 = i8 + 2 | 0;
 HEAP8[i10 >> 0] = i6;
 HEAP8[i8 + 3 >> 0] = 0;
 if (i6 << 24 >> 24) {
  HEAP8[i9 >> 0] = i6;
  HEAP8[i10 >> 0] = i5;
 }
 i5 = i2 + (_strftime_l(i2 | 0, (HEAP32[i3 >> 2] | 0) - i2 | 0, i8 | 0, i4 | 0, HEAP32[i1 >> 2] | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i5;
 STACKTOP = i7;
 return;
}

function ___toread(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 74 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i3 + 255 | i3;
 i3 = i1 + 20 | 0;
 i2 = i1 + 44 | 0;
 if ((HEAP32[i3 >> 2] | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) FUNCTION_TABLE_iiii[HEAP32[i1 + 36 >> 2] & 63](i1, 0, 0) | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 & 20) if (!(i3 & 4)) i4 = -1; else {
  HEAP32[i1 >> 2] = i3 | 32;
  i4 = -1;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 + 8 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = i3;
  i4 = 0;
 }
 return i4 | 0;
}

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) {
  i5 = i4;
  while (1) {
   i4 = i5 + -4 | 0;
   if ((i4 | 0) == (i2 | 0)) {
    i6 = i4;
    break;
   } else i5 = i4;
  }
  HEAP32[i3 >> 2] = i6;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 do if (i6) {
  i3 = HEAP32[i1 + 16 >> 2] | 0;
  if ((i3 | 0) == (i6 | 0)) {
   HEAP8[i3 + 112 >> 0] = 0;
   break;
  } else {
   __ZdlPv(i6);
   break;
  }
 } while (0);
 return;
}

function _strtox530(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i7 + 44 >> 2] = i1;
 i9 = i7 + 8 | 0;
 HEAP32[i9 >> 2] = (i1 | 0) < 0 ? -1 : i1 + 2147483647 | 0;
 HEAP32[i7 + 76 >> 2] = -1;
 ___shlim(i7, 0);
 i10 = ___intscan(i7, i3, 1, i4, i5) | 0;
 if (i2) HEAP32[i2 >> 2] = i1 + ((HEAP32[i8 >> 2] | 0) + (HEAP32[i7 + 108 >> 2] | 0) - (HEAP32[i9 >> 2] | 0));
 STACKTOP = i6;
 return i10 | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP8[i1 >> 0] | 0;
 i5 = (i4 & 1) == 0;
 if (i5) i6 = (i4 & 255) >>> 1; else i6 = HEAP32[i1 + 4 >> 2] | 0;
 do if (i6 >>> 0 >= i2 >>> 0) if (i5) {
  HEAP8[i1 + 1 + i2 >> 0] = 0;
  HEAP8[i1 >> 0] = i2 << 1;
  break;
 } else {
  HEAP8[(HEAP32[i1 + 8 >> 2] | 0) + i2 >> 0] = 0;
  HEAP32[i1 + 4 >> 2] = i2;
  break;
 } else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc(i1, i2 - i6 | 0, i3) | 0; while (0);
 return;
}

function __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i1 = i2 + 16 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 do if (i5) {
  if ((i5 | 0) != (i3 | 0)) {
   i6 = i2 + 36 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   HEAP32[i2 + 24 >> 2] = 2;
   HEAP8[i2 + 54 >> 0] = 1;
   break;
  }
  i6 = i2 + 24 | 0;
  if ((HEAP32[i6 >> 2] | 0) == 2) HEAP32[i6 >> 2] = i4;
 } else {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 + 24 >> 2] = i4;
  HEAP32[i2 + 36 >> 2] = 1;
 } while (0);
 return;
}

function __ZNSt3__111__stdoutbufIwE6xsputnEPKwi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 L1 : do if (!(HEAP8[i1 + 44 >> 0] | 0)) if ((i3 | 0) > 0) {
  i4 = i2;
  i5 = 0;
  while (1) {
   if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] & 63](i1, HEAP32[i4 >> 2] | 0) | 0) == -1) {
    i6 = i5;
    break L1;
   }
   i7 = i5 + 1 | 0;
   if ((i7 | 0) < (i3 | 0)) {
    i4 = i4 + 4 | 0;
    i5 = i7;
   } else {
    i6 = i7;
    break;
   }
  }
 } else i6 = 0; else i6 = _fwrite(i2, 4, i3, HEAP32[i1 + 32 >> 2] | 0) | 0; while (0);
 return i6 | 0;
}

function __ZNSt3__111__stdoutbufIcE6xsputnEPKci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 L1 : do if (!(HEAP8[i1 + 44 >> 0] | 0)) if ((i3 | 0) > 0) {
  i4 = i2;
  i5 = 0;
  while (1) {
   if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] & 63](i1, HEAPU8[i4 >> 0] | 0) | 0) == -1) {
    i6 = i5;
    break L1;
   }
   i7 = i5 + 1 | 0;
   if ((i7 | 0) < (i3 | 0)) {
    i4 = i4 + 1 | 0;
    i5 = i7;
   } else {
    i6 = i7;
    break;
   }
  }
 } else i6 = 0; else i6 = _fwrite(i2, 1, i3, HEAP32[i1 + 32 >> 2] | 0) | 0; while (0);
 return i6 | 0;
}

function __ZN7maxiMix4quadEdRNSt3__16vectorIdNS0_9allocatorIdEEEEdd(i1, d2, i3, d4, d5) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 var d6 = 0.0, d7 = 0.0, d8 = 0.0;
 d6 = d4 > 1.0 ? 1.0 : d4;
 d4 = d6 < 0.0 ? 0.0 : d6;
 d6 = d5 > 1.0 ? 1.0 : d5;
 d5 = d6 < 0.0 ? 0.0 : d6;
 d6 = 1.0 - d4;
 d7 = +Math_sqrt(+(d6 * d5)) * d2;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAPF64[i1 >> 3] = d7;
 d7 = 1.0 - d5;
 d8 = +Math_sqrt(+(d6 * d7)) * d2;
 HEAPF64[i1 + 8 >> 3] = d8;
 d8 = +Math_sqrt(+(d4 * d5)) * d2;
 HEAPF64[i1 + 16 >> 3] = d8;
 d8 = +Math_sqrt(+(d4 * d7)) * d2;
 HEAPF64[i1 + 24 >> 3] = d8;
 return;
}

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = i4;
 do if (i2) {
  i5 = i4 + 112 | 0;
  if (i2 >>> 0 < 29 & (HEAP8[i5 >> 0] | 0) == 0) {
   HEAP8[i5 >> 0] = 1;
   i6 = i4;
   break;
  } else {
   i6 = __Znwj(i2 << 2) | 0;
   break;
  }
 } else i6 = 0; while (0);
 HEAP32[i1 >> 2] = i6;
 i4 = i6 + (i3 << 2) | 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = i6 + (i2 << 2);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(60, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function ___divdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = i2 >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i6 = ((i2 | 0) < 0 ? -1 : 0) >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i7 = i4 >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i8 = ((i4 | 0) < 0 ? -1 : 0) >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i9 = _i64Subtract(i5 ^ i1, i6 ^ i2, i5, i6) | 0;
 i2 = tempRet0;
 i1 = i7 ^ i5;
 i5 = i8 ^ i6;
 return _i64Subtract((___udivmoddi4(i9, i2, _i64Subtract(i7 ^ i3, i8 ^ i4, i7, i8) | 0, tempRet0, 0) | 0) ^ i1, tempRet0 ^ i5, i1, i5) | 0;
}

function __ZNSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(57, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNKSt3__120__time_get_c_storageIwE3__rEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if ((HEAP8[17048] | 0) == 0 ? (___cxa_guard_acquire(17048) | 0) != 0 : 0) {
  __THREW__ = 0;
  i1 = invoke_ii(133, 30036) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1) ? (__THREW__ = 0, invoke_viii(14, 30084, 30036, i1 | 0), i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) {
   ___cxa_atexit(298, 30084, ___dso_handle | 0) | 0;
   ___cxa_guard_release(17048);
   break;
  }
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(17048);
  ___resumeException(i1 | 0);
 } while (0);
 return 30084;
}

function __ZNKSt3__120__time_get_c_storageIwE3__cEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if ((HEAP8[17032] | 0) == 0 ? (___cxa_guard_acquire(17032) | 0) != 0 : 0) {
  __THREW__ = 0;
  i1 = invoke_ii(133, 29928) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1) ? (__THREW__ = 0, invoke_viii(14, 30012, 29928, i1 | 0), i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) {
   ___cxa_atexit(298, 30012, ___dso_handle | 0) | 0;
   ___cxa_guard_release(17032);
   break;
  }
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(17032);
  ___resumeException(i1 | 0);
 } while (0);
 return 30012;
}

function __ZNKSt3__120__time_get_c_storageIwE3__XEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if ((HEAP8[17016] | 0) == 0 ? (___cxa_guard_acquire(17016) | 0) != 0 : 0) {
  __THREW__ = 0;
  i1 = invoke_ii(133, 29868) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1) ? (__THREW__ = 0, invoke_viii(14, 29904, 29868, i1 | 0), i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) {
   ___cxa_atexit(298, 29904, ___dso_handle | 0) | 0;
   ___cxa_guard_release(17016);
   break;
  }
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(17016);
  ___resumeException(i1 | 0);
 } while (0);
 return 29904;
}

function __ZNSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(48, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(51, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(47, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZN10maxiSample9setSampleERNSt3__16vectorIdNS0_9allocatorIdEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 96 | 0;
 if ((i3 | 0) == (i2 | 0)) {
  i4 = i2;
  i5 = i2 + 4 | 0;
 } else {
  i6 = i2 + 4 | 0;
  __ZNSt3__16vectorIdNS_9allocatorIdEEE6assignIPdEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIdNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i3, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0);
  i4 = i2;
  i5 = i6;
 }
 HEAP32[i1 + 84 >> 2] = (HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 3;
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(58, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(52, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(49, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(59, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNKSt3__120__time_get_c_storageIwE3__xEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if ((HEAP8[17e3] | 0) == 0 ? (___cxa_guard_acquire(17e3) | 0) != 0 : 0) {
  __THREW__ = 0;
  i1 = invoke_ii(133, 29808) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1) ? (__THREW__ = 0, invoke_viii(14, 29844, 29808, i1 | 0), i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) {
   ___cxa_atexit(298, 29844, ___dso_handle | 0) | 0;
   ___cxa_guard_release(17e3);
   break;
  }
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_guard_abort(17e3);
  ___resumeException(i1 | 0);
 } while (0);
 return 29844;
}

function __ZNSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(45, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(46, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(50, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(53, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(55, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(54, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 __THREW__ = 0;
 invoke_vii(56, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i1);
 }
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i2 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return;
}

function __ZN7maxiOsc5pulseEdd(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 var d4 = 0.0, i5 = 0, d6 = 0.0, d7 = 0.0, d8 = 0.0;
 d4 = d3 < 0.0 ? 0.0 : d3;
 d3 = d4 > 1.0 ? 1.0 : d4;
 i5 = i1 + 8 | 0;
 d4 = +HEAPF64[i5 >> 3];
 if (!(d4 >= 1.0)) d6 = d4; else {
  d7 = d4 + -1.0;
  HEAPF64[i5 >> 3] = d7;
  d6 = d7;
 }
 d7 = 1.0 / (+(HEAP32[4327] | 0) / d2) + d6;
 HEAPF64[i5 >> 3] = d7;
 if (d7 < d3) HEAPF64[i1 + 32 >> 3] = -1.0;
 i5 = i1 + 32 | 0;
 if (d7 > d3) {
  HEAPF64[i5 >> 3] = 1.0;
  d8 = 1.0;
  return +d8;
 } else {
  d8 = +HEAPF64[i5 >> 3];
  return +d8;
 }
 return +(0.0);
}

function __ZN7maxiOsc4sawnEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, d5 = 0.0, d6 = 0.0;
 i3 = i1 + 8 | 0;
 d4 = +HEAPF64[i3 >> 3];
 if (!(d4 >= .5)) d5 = d4; else {
  d6 = d4 + -1.0;
  HEAPF64[i3 >> 3] = d6;
  d5 = d6;
 }
 d6 = 1.0 / (+(HEAP32[4327] | 0) / d2) + d5;
 HEAPF64[i3 >> 3] = d6;
 d5 = 8820.22 / d2 * d6;
 d2 = d5 < -.5 ? -.5 : d5;
 d5 = d2 > .5 ? 1.0e3 : d2 * 1.0e3 + 500.0;
 d2 = d5 - +Math_floor(+d5);
 i3 = ~~d5;
 d5 = +HEAPF64[4120 + (i3 + 1 << 3) >> 3] * d2 + +HEAPF64[4120 + (i3 << 3) >> 3] * (1.0 - d2) - d6;
 HEAPF64[i1 + 32 >> 3] = d5;
 return +d5;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i2 + 4 | 0;
 i9 = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i10 = __ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i1, i6, i7, i9, 1114111, 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i2;
 return i10 | 0;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i2 + 4 | 0;
 i9 = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i10 = __ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE(i3, i4, i1, i6, i7, i9, 1114111, 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i2;
 return i10 | 0;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i2 + 4 | 0;
 i9 = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i10 = __ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i1, i6, i7, i9, 1114111, 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i2;
 return i10 | 0;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i2 + 4 | 0;
 i9 = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i10 = __ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i1, i6, i7, i9, 1114111, 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i2;
 return i10 | 0;
}

function __ZNKSt3__15ctypeIwE11do_scan_notEtPKwS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 L1 : do if ((i3 | 0) == (i4 | 0)) i5 = i4; else {
  i1 = i3;
  while (1) {
   i6 = HEAP32[i1 >> 2] | 0;
   if (i6 >>> 0 >= 128) {
    i5 = i1;
    break L1;
   }
   i7 = (__ZNSt3__15ctypeIcE13classic_tableEv() | 0) + (i6 << 1) | 0;
   if (!((HEAP16[i7 >> 1] & i2) << 16 >> 16)) {
    i5 = i1;
    break L1;
   }
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i5 = i4;
    break;
   }
  }
 } while (0);
 return i5 | 0;
}

function __ZN10maxiSample4playEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 i2 = i1 + 40 | 0;
 d3 = +HEAPF64[i2 >> 3] + 1.0;
 HEAPF64[i2 >> 3] = d3;
 i4 = i1 + 96 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = (HEAP32[i1 + 100 >> 2] | 0) - i5 >> 3;
 if (~~d3 >>> 0 < i6 >>> 0) d7 = d3; else {
  HEAPF64[i2 >> 3] = 0.0;
  d7 = 0.0;
 }
 i2 = ~~d7;
 if (i6 >>> 0 > i2 >>> 0) {
  d7 = +HEAPF64[i5 + (i2 << 3) >> 3];
  HEAPF64[i1 + 64 >> 3] = d7;
  return +d7;
 } else __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i4);
 return +(0.0);
}

function __ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (i2) {
  i3 = i1 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i5 = i4;
   while (1) {
    i4 = i5 + -4 | 0;
    if ((i4 | 0) == (i2 | 0)) {
     i6 = i4;
     break;
    } else i5 = i4;
   }
   HEAP32[i3 >> 2] = i6;
  }
  if ((i1 + 16 | 0) == (i2 | 0)) {
   HEAP8[i1 + 128 >> 0] = 0;
   break;
  } else {
   __ZdlPv(i2);
   break;
  }
 } while (0);
 return;
}

function __ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 26648) | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = i3;
 i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 255](i3) | 0;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] & 255](i4) | 0) & 1;
 HEAP8[i1 + 53 >> 0] = i2;
 if ((HEAP32[i3 >> 2] | 0) > 8) __ZNSt3__121__throw_runtime_errorEPKc(45490);
 return;
}

function __ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 26640) | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = i3;
 i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 255](i3) | 0;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] & 255](i4) | 0) & 1;
 HEAP8[i1 + 53 >> 0] = i2;
 if ((HEAP32[i3 >> 2] | 0) > 8) __ZNSt3__121__throw_runtime_errorEPKc(45490);
 return;
}

function __ZN10maxiSample8playOnceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, d4 = 0.0, i5 = 0, i6 = 0;
 i2 = i1 + 40 | 0;
 d3 = +HEAPF64[i2 >> 3] + 1.0;
 HEAPF64[i2 >> 3] = d3;
 i2 = ~~d3;
 if ((i2 | 0) >= (HEAP32[i1 + 84 >> 2] | 0)) {
  HEAPF64[i1 + 64 >> 3] = 0.0;
  d4 = 0.0;
  return +d4;
 }
 i5 = i1 + 96 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i1 + 100 >> 2] | 0) - i6 >> 3 >>> 0 <= i2 >>> 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i5);
 d3 = +HEAPF64[i6 + (i2 << 3) >> 3];
 HEAPF64[i1 + 64 >> 3] = d3;
 d4 = d3;
 return +d4;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (i3 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i3 >>> 0 < 11) {
  HEAP8[i1 >> 0] = i3 << 1;
  i4 = i1 + 1 | 0;
 } else {
  i5 = i3 + 16 & -16;
  i6 = __Znwj(i5) | 0;
  HEAP32[i1 + 8 >> 2] = i6;
  HEAP32[i1 >> 2] = i5 | 1;
  HEAP32[i1 + 4 >> 2] = i3;
  i4 = i6;
 }
 _memcpy(i4 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i4 + i3 >> 0] = 0;
 return;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2) {
  __THREW__ = 0;
  i1 = invoke_ii(132, i2 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i2);
  }
  if ((i1 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i1 | 0) | 0, i1 = __THREW__, __THREW__ = 0, i1 & 1) : 0) {
   i1 = ___cxa_find_matching_catch(0) | 0;
   ___clang_call_terminate(i1);
  } else i3 = 4;
 } else i3 = 1;
 return i3 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (i3 >>> 0 > 1073741807) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i3 >>> 0 < 2) {
  HEAP8[i1 >> 0] = i3 << 1;
  i4 = i1 + 4 | 0;
 } else {
  i5 = i3 + 4 & -4;
  i6 = __Znwj(i5 << 2) | 0;
  HEAP32[i1 + 8 >> 2] = i6;
  HEAP32[i1 >> 2] = i5 | 1;
  HEAP32[i1 + 4 >> 2] = i3;
  i4 = i6;
 }
 _wmemcpy(i4, i2, i3) | 0;
 HEAP32[i4 + (i3 << 2) >> 2] = 0;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (i2 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i2 >>> 0 < 11) {
  HEAP8[i1 >> 0] = i2 << 1;
  i4 = i1 + 1 | 0;
 } else {
  i5 = i2 + 16 & -16;
  i6 = __Znwj(i5) | 0;
  HEAP32[i1 + 8 >> 2] = i6;
  HEAP32[i1 >> 2] = i5 | 1;
  HEAP32[i1 + 4 >> 2] = i2;
  i4 = i6;
 }
 _memset(i4 | 0, i3 | 0, i2 | 0) | 0;
 HEAP8[i4 + i2 >> 0] = 0;
 return;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (i2 >>> 0 > 1073741807) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i2 >>> 0 < 2) {
  HEAP8[i1 >> 0] = i2 << 1;
  i4 = i1 + 4 | 0;
 } else {
  i5 = i2 + 4 & -4;
  i6 = __Znwj(i5 << 2) | 0;
  HEAP32[i1 + 8 >> 2] = i6;
  HEAP32[i1 >> 2] = i5 | 1;
  HEAP32[i1 + 4 >> 2] = i2;
  i4 = i6;
 }
 _wmemset(i4, i3, i2) | 0;
 HEAP32[i4 + (i2 << 2) >> 2] = 0;
 return;
}

function __ZNKSt3__15ctypeIwE5do_isEPKwS3_Pt(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = (i3 - i2 | 0) >>> 2;
 if ((i2 | 0) != (i3 | 0)) {
  i5 = i2;
  i6 = i4;
  while (1) {
   i4 = HEAP32[i5 >> 2] | 0;
   if (i4 >>> 0 < 128) {
    i7 = (__ZNSt3__15ctypeIcE13classic_tableEv() | 0) + (i4 << 1) | 0;
    i8 = HEAPU16[i7 >> 1] | 0;
   } else i8 = 0;
   HEAP16[i6 >> 1] = i8;
   i5 = i5 + 4 | 0;
   if ((i5 | 0) == (i3 | 0)) break; else i6 = i6 + 2 | 0;
  }
 }
 return i2 + (i1 << 2) | 0;
}

function __ZNSt3__111make_sharedI10maxiFilterJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __Znwj(256) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 17928;
 i3 = i2 + 208 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = i2 + 16;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN13maxiDelayline2dlEdidi(i1, d2, i3, d4, i5) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = i1 + 8 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if ((i7 | 0) < (i3 | 0)) i8 = i7; else {
  HEAP32[i6 >> 2] = 0;
  i8 = 0;
 }
 i7 = i1 + 32 | 0;
 HEAPF64[i7 >> 3] = +HEAPF64[i1 + 40 + (((i5 | 0) < (i3 | 0) ? i5 : 0) << 3) >> 3];
 i5 = i1 + 40 + (i8 << 3) | 0;
 HEAPF64[i5 >> 3] = +HEAPF64[i5 >> 3] * d4 + d2 * d4 * +HEAPF32[4326];
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 return +(+HEAPF64[i7 >> 3]);
}

function __ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIiNS2_9allocatorIiEEEEFvjRKiEvPS6_JjS8_EE6invokeERKSA_SB_ji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i8 >> 1) | 0;
 if (!(i8 & 1)) i9 = i7; else i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 FUNCTION_TABLE_viii[i9 & 15](i1, i3, i6);
 STACKTOP = i5;
 return;
}

function __ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIdNS2_9allocatorIdEEEEFvjRKdEvPS6_JjS8_EE6invokeERKSA_SB_jd(i1, i2, i3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i8 >> 1) | 0;
 if (!(i8 & 1)) i9 = i7; else i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + i7 >> 2] | 0;
 HEAPF64[i6 >> 3] = d4;
 FUNCTION_TABLE_viii[i9 & 15](i1, i3, i6);
 STACKTOP = i5;
 return;
}

function _memset(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) >= 20) {
  i2 = i2 & 255;
  i5 = i1 & 3;
  i6 = i2 | i2 << 8 | i2 << 16 | i2 << 24;
  i7 = i4 & ~3;
  if (i5) {
   i5 = i1 + 4 - i5 | 0;
   while ((i1 | 0) < (i5 | 0)) {
    HEAP8[i1 >> 0] = i2;
    i1 = i1 + 1 | 0;
   }
  }
  while ((i1 | 0) < (i7 | 0)) {
   HEAP32[i1 >> 2] = i6;
   i1 = i1 + 4 | 0;
  }
 }
 while ((i1 | 0) < (i4 | 0)) {
  HEAP8[i1 >> 0] = i2;
  i1 = i1 + 1 | 0;
 }
 return i1 - i3 | 0;
}

function __ZNKSt3__15ctypeIwE10do_scan_isEtPKwS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 L1 : do if ((i3 | 0) == (i4 | 0)) i5 = i4; else {
  i1 = i3;
  while (1) {
   i6 = HEAP32[i1 >> 2] | 0;
   if (i6 >>> 0 < 128 ? (i7 = (__ZNSt3__15ctypeIcE13classic_tableEv() | 0) + (i6 << 1) | 0, (HEAP16[i7 >> 1] & i2) << 16 >> 16 != 0) : 0) {
    i5 = i1;
    break L1;
   }
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i5 = i4;
    break;
   }
  }
 } while (0);
 return i5 | 0;
}

function __ZNSt3__18ios_base7failureC2EPKcRKNS_10error_codeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4 + 8 | 0;
 i6 = i4;
 i7 = i3;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZNSt3__112system_errorC2ENS_10error_codeEPKc(i1, i5, i2);
 HEAP32[i1 >> 2] = 25408;
 STACKTOP = i4;
 return;
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiEnvFddddddliEdPS2_JdddddliEE6invokeERKS4_S5_dddddli(i1, i2, d3, d4, d5, d6, d7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0, i11 = 0, i12 = 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i11 >> 1) | 0;
 if (!(i11 & 1)) i12 = i10; else i12 = HEAP32[(HEAP32[i1 >> 2] | 0) + i10 >> 2] | 0;
 return +(+FUNCTION_TABLE_didddddii[i12 & 1](i1, d3, d4, d5, d6, d7, i8, i9));
}

function __ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(0, i2, i3, i4, i5); else {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  FUNCTION_TABLE_viiiiii[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 7](i7, i2, i3, i4, i5, i6);
 }
 return;
}

function __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = i5;
 i5 = _uselocale(i3) | 0;
 i3 = _vsnprintf(i1, i2, i4, i7) | 0;
 if ((i5 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i5 | 0) | 0, i5 = __THREW__, __THREW__ = 0, i5 & 1) : 0) {
  i5 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i5);
 }
 STACKTOP = i6;
 return i3 | 0;
}

function __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i7 >> 8;
 if (!(i7 & 1)) i9 = i8; else i9 = HEAP32[(HEAP32[i4 >> 2] | 0) + i8 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 FUNCTION_TABLE_viiiiii[HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] & 7](i8, i2, i3, i4 + i9 | 0, (i7 & 2 | 0) != 0 ? i5 : 2, i6);
 return;
}

function __ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIiNS2_9allocatorIiEEEEFvRKiEvPS6_JS8_EE6invokeERKSA_SB_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i7 >> 1) | 0;
 if (!(i7 & 1)) i8 = i6; else i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + i6 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 FUNCTION_TABLE_vii[i8 & 127](i1, i5);
 STACKTOP = i4;
 return;
}

function __ZSt9terminatev() {
 var i1 = 0, i2 = 0;
 __THREW__ = 0;
 i1 = invoke_i(21) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 }
 if (((i1 | 0) != 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) ? (i1 = i2 + 48 | 0, (HEAP32[i1 >> 2] & -256 | 0) == 1126902528 ? (HEAP32[i1 + 4 >> 2] | 0) == 1129074247 : 0) : 0) __ZSt11__terminatePFvvE(HEAP32[i2 + 12 >> 2] | 0);
 i2 = HEAP32[4779] | 0;
 HEAP32[4779] = i2 + 0;
 __ZSt11__terminatePFvvE(i2);
}

function __ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIdNS2_9allocatorIdEEEEFvRKdEvPS6_JS8_EE6invokeERKSA_SB_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i7 >> 1) | 0;
 if (!(i7 & 1)) i8 = i6; else i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + i6 >> 2] | 0;
 HEAPF64[i5 >> 3] = d3;
 FUNCTION_TABLE_vii[i8 & 127](i1, i5);
 STACKTOP = i4;
 return;
}

function _wmemmove(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = (i3 | 0) == 0;
 if (i1 - i2 >> 2 >>> 0 < i3 >>> 0) {
  if (!i4) {
   i5 = i3;
   do {
    i5 = i5 + -1 | 0;
    HEAP32[i1 + (i5 << 2) >> 2] = HEAP32[i2 + (i5 << 2) >> 2];
   } while ((i5 | 0) != 0);
  }
 } else if (!i4) {
  i4 = i2;
  i2 = i1;
  i5 = i3;
  while (1) {
   i5 = i5 + -1 | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   if (!i5) break; else {
    i4 = i4 + 4 | 0;
    i2 = i2 + 4 | 0;
   }
  }
 }
 return i1 | 0;
}

function __ZNSt3__16vectorIiNS_9allocatorIiEEE6resizeEjRKi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = i5 - i6 >> 2;
 if (i7 >>> 0 < i2 >>> 0) {
  __ZNSt3__16vectorIiNS_9allocatorIiEEE8__appendEjRKi(i1, i2 - i7 | 0, i3);
  return;
 }
 if (i7 >>> 0 <= i2 >>> 0) return;
 i7 = i6 + (i2 << 2) | 0;
 if ((i5 | 0) == (i7 | 0)) return;
 HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i7 | 0) >>> 2) << 2);
 return;
}

function __ZNSt3__16vectorIdNS_9allocatorIdEEE6resizeEjRKd(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = i5 - i6 >> 3;
 if (i7 >>> 0 < i2 >>> 0) {
  __ZNSt3__16vectorIdNS_9allocatorIdEEE8__appendEjRKd(i1, i2 - i7 | 0, i3);
  return;
 }
 if (i7 >>> 0 <= i2 >>> 0) return;
 i7 = i6 + (i2 << 3) | 0;
 if ((i5 | 0) == (i7 | 0)) return;
 HEAP32[i4 >> 2] = i5 + (~((i5 + -8 - i7 | 0) >>> 3) << 3);
 return;
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiMixFvdRNSt3__16vectorIdNS3_9allocatorIdEEEEdddEvPS2_JdS8_dddEE6invokeERKSA_SB_dPS7_ddd(i1, i2, d3, i4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 var i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i9 >> 1) | 0;
 if (!(i9 & 1)) i10 = i8; else i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + i8 >> 2] | 0;
 FUNCTION_TABLE_vididdd[i10 & 1](i1, d3, i4, d5, d6, d7);
 return;
}

function __ZNSt3__111make_sharedI20maxiEnvelopeFollowerJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0;
 i2 = __Znwj(40) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 19064;
 d3 = +Math_pow(.01, +(1.0 / (+(HEAP32[4327] | 0) * 100.0 * .001)));
 i4 = i2 + 16 | 0;
 HEAPF64[i4 >> 3] = d3;
 HEAPF64[i2 + 24 >> 3] = d3;
 HEAPF64[i2 + 32 >> 3] = 0.0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function dynCall_viiiiiiiiiiiiiii(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 FUNCTION_TABLE_viiiiiiiiiiiiiii[i1 & 3](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i16 | 0);
}

function __ZNSt3__110__sscanf_lEPKcP15__locale_structS1_z(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i4;
 i4 = _uselocale(i2) | 0;
 i2 = _vsscanf(i1, i3, i6) | 0;
 if ((i4 | 0) != 0 ? (__THREW__ = 0, invoke_ii(132, i4 | 0) | 0, i4 = __THREW__, __THREW__ = 0, i4 & 1) : 0) {
  i4 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i4);
 }
 STACKTOP = i5;
 return i2 | 0;
}

function ___stdio_seek(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i4;
 i6 = i4 + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i2;
 HEAP32[i5 + 12 >> 2] = i6;
 HEAP32[i5 + 16 >> 2] = i3;
 if ((___syscall_ret(___syscall140(140, i5 | 0) | 0) | 0) < 0) {
  HEAP32[i6 >> 2] = -1;
  i7 = -1;
 } else i7 = HEAP32[i6 >> 2] | 0;
 STACKTOP = i4;
 return i7 | 0;
}

function __ZN10emscripten8internal13MethodInvokerIM20maxiEnvelopeFollowerFddEdPS2_JdEE6invokeERKS4_S5_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  d7 = +FUNCTION_TABLE_did[i6 & 15](i1, d3);
  return +d7;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  d7 = +FUNCTION_TABLE_did[i6 & 15](i1, d3);
  return +d7;
 }
 return +(0.0);
}

function __ZNSt3__18ios_base4InitD2Ev(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_ii(126, 23836) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if (((!(i1 & 1) ? (__THREW__ = 0, invoke_ii(126, 24004) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_ii(127, 24176) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) ? (__THREW__ = 0, invoke_ii(127, 24344) | 0, i1 = __THREW__, __THREW__ = 0, !(i1 & 1)) : 0) return;
 i1 = ___cxa_find_matching_catch(0) | 0;
 ___clang_call_terminate(i1);
}

function __ZNKSt3__15ctypeIwE10do_toupperEPwPKw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = (i3 - i2 | 0) >>> 2;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i2;
  do {
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 >>> 0 < 128) {
    i6 = (__ZNSt3__15ctypeIcE21__classic_upper_tableEv() | 0) + (i5 << 2) | 0;
    i7 = HEAP32[i6 >> 2] | 0;
   } else i7 = i5;
   HEAP32[i4 >> 2] = i7;
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) != (i3 | 0));
 }
 return i2 + (i1 << 2) | 0;
}

function __ZNKSt3__15ctypeIwE10do_tolowerEPwPKw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = (i3 - i2 | 0) >>> 2;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i2;
  do {
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 >>> 0 < 128) {
    i6 = (__ZNSt3__15ctypeIcE21__classic_lower_tableEv() | 0) + (i5 << 2) | 0;
    i7 = HEAP32[i6 >> 2] | 0;
   } else i7 = i5;
   HEAP32[i4 >> 2] = i7;
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) != (i3 | 0));
 }
 return i2 + (i1 << 2) | 0;
}

function __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i6 >> 8;
 if (!(i6 & 1)) i8 = i7; else i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + i7 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 FUNCTION_TABLE_viiiii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 3](i7, i2, i3 + i8 | 0, (i6 & 2 | 0) != 0 ? i4 : 2, i5);
 return;
}

function _strcmp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP8[i1 >> 0] | 0;
 i4 = HEAP8[i2 >> 0] | 0;
 if (i3 << 24 >> 24 == 0 ? 1 : i3 << 24 >> 24 != i4 << 24 >> 24) {
  i5 = i3;
  i6 = i4;
 } else {
  i4 = i1;
  i1 = i2;
  do {
   i4 = i4 + 1 | 0;
   i1 = i1 + 1 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = HEAP8[i1 >> 0] | 0;
  } while (!(i2 << 24 >> 24 == 0 ? 1 : i2 << 24 >> 24 != i3 << 24 >> 24));
  i5 = i2;
  i6 = i3;
 }
 return (i5 & 255) - (i6 & 255) | 0;
}

function __ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIiNS2_9allocatorIiEEEEKFjvEjPKS6_JEE6invokeERKS8_SA_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  i6 = FUNCTION_TABLE_ii[i5 & 255](i1) | 0;
  return i6 | 0;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  i6 = FUNCTION_TABLE_ii[i5 & 255](i1) | 0;
  return i6 | 0;
 }
 return 0;
}

function __ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIdNS2_9allocatorIdEEEEKFjvEjPKS6_JEE6invokeERKS8_SA_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  i6 = FUNCTION_TABLE_ii[i5 & 255](i1) | 0;
  return i6 | 0;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  i6 = FUNCTION_TABLE_ii[i5 & 255](i1) | 0;
  return i6 | 0;
 }
 return 0;
}

function __ZN10emscripten8internal13MethodInvokerIM14maxiDistortionFddEdPS2_JdEE6invokeERKS4_S5_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  d7 = +FUNCTION_TABLE_did[i6 & 15](i1, d3);
  return +d7;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  d7 = +FUNCTION_TABLE_did[i6 & 15](i1, d3);
  return +d7;
 }
 return +(0.0);
}

function __ZNSt3__17codecvtIwc11__mbstate_tED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = 26664;
 i2 = i1 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 __THREW__ = 0;
 i3 = invoke_i(22) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (!(i4 & 1)) {
  if ((i1 | 0) != (i3 | 0) ? (__THREW__ = 0, invoke_vi(286, HEAP32[i2 >> 2] | 0), i5 = __THREW__, __THREW__ = 0, i5 & 1) : 0) break;
  return;
 } while (0);
 i2 = ___cxa_find_matching_catch(0) | 0;
 ___clang_call_terminate(i2);
}

function __ZNKSt3__120__time_get_c_storageIcE3__rEv(i1) {
 i1 = i1 | 0;
 do if ((HEAP8[17040] | 0) == 0 ? (___cxa_guard_acquire(17040) | 0) != 0 : 0) {
  __THREW__ = 0;
  invoke_viii(13, 30024, 47965, 11);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch() | 0;
   ___cxa_guard_abort(17040);
   ___resumeException(i1 | 0);
  } else {
   ___cxa_atexit(297, 30024, ___dso_handle | 0) | 0;
   ___cxa_guard_release(17040);
   break;
  }
 } while (0);
 return 30024;
}

function __ZNKSt3__120__time_get_c_storageIcE3__cEv(i1) {
 i1 = i1 | 0;
 do if ((HEAP8[17024] | 0) == 0 ? (___cxa_guard_acquire(17024) | 0) != 0 : 0) {
  __THREW__ = 0;
  invoke_viii(13, 29916, 47944, 20);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch() | 0;
   ___cxa_guard_abort(17024);
   ___resumeException(i1 | 0);
  } else {
   ___cxa_atexit(297, 29916, ___dso_handle | 0) | 0;
   ___cxa_guard_release(17024);
   break;
  }
 } while (0);
 return 29916;
}

function __ZNKSt3__120__time_get_c_storageIcE3__xEv(i1) {
 i1 = i1 | 0;
 do if ((HEAP8[16992] | 0) == 0 ? (___cxa_guard_acquire(16992) | 0) != 0 : 0) {
  __THREW__ = 0;
  invoke_viii(13, 29796, 47926, 8);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch() | 0;
   ___cxa_guard_abort(16992);
   ___resumeException(i1 | 0);
  } else {
   ___cxa_atexit(297, 29796, ___dso_handle | 0) | 0;
   ___cxa_guard_release(16992);
   break;
  }
 } while (0);
 return 29796;
}

function __ZNKSt3__120__time_get_c_storageIcE3__XEv(i1) {
 i1 = i1 | 0;
 do if ((HEAP8[17008] | 0) == 0 ? (___cxa_guard_acquire(17008) | 0) != 0 : 0) {
  __THREW__ = 0;
  invoke_viii(13, 29856, 47935, 8);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch() | 0;
   ___cxa_guard_abort(17008);
   ___resumeException(i1 | 0);
  } else {
   ___cxa_atexit(297, 29856, ___dso_handle | 0) | 0;
   ___cxa_guard_release(17008);
   break;
  }
 } while (0);
 return 29856;
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiSampleFvRNSt3__16vectorIdNS3_9allocatorIdEEEEEvPS2_JS8_EE6invokeERKSA_SB_PS7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  FUNCTION_TABLE_vii[i6 & 127](i1, i3);
  return;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  FUNCTION_TABLE_vii[i6 & 127](i1, i3);
  return;
 }
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiSampleFddEdPS2_JdEE6invokeERKS4_S5_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  d7 = +FUNCTION_TABLE_did[i6 & 15](i1, d3);
  return +d7;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  d7 = +FUNCTION_TABLE_did[i6 & 15](i1, d3);
  return +d7;
 }
 return +(0.0);
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiMixFvdRNSt3__16vectorIdNS3_9allocatorIdEEEEddEvPS2_JdS8_ddEE6invokeERKSA_SB_dPS7_dd(i1, i2, d3, i4, d5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i8 >> 1) | 0;
 if (!(i8 & 1)) i9 = i7; else i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + i7 >> 2] | 0;
 FUNCTION_TABLE_vididd[i9 & 1](i1, d3, i4, d5, d6);
 return;
}

function __ZN10emscripten8internal13MethodInvokerIM7convertFdiEdPS2_JiEE6invokeERKS4_S5_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  d7 = +FUNCTION_TABLE_dii[i6 & 7](i1, i3);
  return +d7;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  d7 = +FUNCTION_TABLE_dii[i6 & 7](i1, i3);
  return +d7;
 }
 return +(0.0);
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiOscFddEdPS2_JdEE6invokeERKS4_S5_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  d7 = +FUNCTION_TABLE_did[i6 & 15](i1, d3);
  return +d7;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  d7 = +FUNCTION_TABLE_did[i6 & 15](i1, d3);
  return +d7;
 }
 return +(0.0);
}

function __ZN10emscripten8internal12VectorAccessINSt3__16vectorIdNS2_9allocatorIdEEEEE3getERKS6_j(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) - i5 >> 3 >>> 0 <= i2 >>> 0) {
  i6 = 1;
  STACKTOP = i3;
  return i6 | 0;
 }
 HEAPF64[i4 >> 3] = +HEAPF64[i5 + (i2 << 3) >> 3];
 i6 = __emval_take_value(15152, i4 | 0) | 0;
 STACKTOP = i3;
 return i6 | 0;
}

function __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i5 >> 8;
 if (!(i5 & 1)) i7 = i6; else i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + i6 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] & 31](i6, i2, i3 + i7 | 0, (i5 & 2 | 0) != 0 ? i4 : 2);
 return;
}

function __ZN10emscripten8internal12VectorAccessINSt3__16vectorIiNS2_9allocatorIiEEEEE3getERKS6_j(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 i5 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) - i5 >> 2 >>> 0 <= i2 >>> 0) {
  i6 = 1;
  STACKTOP = i3;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
 i6 = __emval_take_value(15112, i4 | 0) | 0;
 STACKTOP = i3;
 return i6 | 0;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (i2 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1);
 i3 = i1 + 128 | 0;
 if (i2 >>> 0 < 29 & (HEAP8[i3 >> 0] | 0) == 0) {
  HEAP8[i3 >> 0] = 1;
  i4 = i1 + 16 | 0;
 } else i4 = __Znwj(i2 << 2) | 0;
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i4 + (i2 << 2);
 return;
}

function __ZN10emscripten8internal13MethodInvokerIM11maxiFlangerFddjdddEdPS2_JdjdddEE6invokeERKS4_S5_djddd(i1, i2, d3, i4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 var i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i9 >> 1) | 0;
 if (!(i9 & 1)) i10 = i8; else i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + i8 >> 2] | 0;
 return +(+FUNCTION_TABLE_dididdd[i10 & 3](i1, d3, i4, d5, d6, d7));
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiChorusFddjdddEdPS2_JdjdddEE6invokeERKS4_S5_djddd(i1, i2, d3, i4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 var i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i9 >> 1) | 0;
 if (!(i9 & 1)) i10 = i8; else i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + i8 >> 2] | 0;
 return +(+FUNCTION_TABLE_dididdd[i10 & 3](i1, d3, i4, d5, d6, d7));
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiEnvFddddliEdPS2_JdddliEE6invokeERKS4_S5_dddli(i1, i2, d3, d4, d5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i9 >> 1) | 0;
 if (!(i9 & 1)) i10 = i8; else i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + i8 >> 2] | 0;
 return +(+FUNCTION_TABLE_didddii[i10 & 1](i1, d3, d4, d5, i6, i7));
}

function __ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(0, i2, i3, i4); else {
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] & 31](i5, i2, i3, i4);
 }
 return;
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiDynFdddlddEdPS2_JddlddEE6invokeERKS4_S5_ddldd(i1, i2, d3, d4, i5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 var i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i9 >> 1) | 0;
 if (!(i9 & 1)) i10 = i8; else i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + i8 >> 2] | 0;
 return +(+FUNCTION_TABLE_diddidd[i10 & 1](i1, d3, d4, i5, d6, d7));
}

function __ZN10emscripten8internal13MethodInvokerIM12maxiEnvelopeFvidEvPS2_JidEE6invokeERKS4_S5_id(i1, i2, i3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i6 >> 1) | 0;
 if (!(i6 & 1)) {
  i7 = i5;
  FUNCTION_TABLE_viid[i7 & 7](i1, i3, d4);
  return;
 } else {
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + i5 >> 2] | 0;
  FUNCTION_TABLE_viid[i7 & 7](i1, i3, d4);
  return;
 }
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiLagExpIdEFvddEvPS3_JddEE6invokeERKS5_S6_dd(i1, i2, d3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i6 >> 1) | 0;
 if (!(i6 & 1)) {
  i7 = i5;
  FUNCTION_TABLE_vidd[i7 & 1](i1, d3, d4);
  return;
 } else {
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + i5 >> 2] | 0;
  FUNCTION_TABLE_vidd[i7 & 1](i1, d3, d4);
  return;
 }
}

function __ZN13maxiDelayline2dlEdid(i1, d2, i3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) < (i3 | 0)) i7 = i6; else {
  HEAP32[i5 >> 2] = 0;
  i7 = 0;
 }
 i6 = i1 + 40 + (i7 << 3) | 0;
 i7 = i1 + 32 | 0;
 HEAPF64[i7 >> 3] = +HEAPF64[i6 >> 3];
 HEAPF64[i6 >> 3] = d2 * d4 * .5 + +HEAPF64[i6 >> 3] * d4;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 return +(+HEAPF64[i7 >> 3]);
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiDynFddddddEdPS2_JdddddEE6invokeERKS4_S5_ddddd(i1, i2, d3, d4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 var i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i9 >> 1) | 0;
 if (!(i9 & 1)) i10 = i8; else i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + i8 >> 2] | 0;
 return +(+FUNCTION_TABLE_diddddd[i10 & 3](i1, d3, d4, d5, d6, d7));
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiSampleFlvElPS2_JEE6invokeERKS4_S5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  i6 = FUNCTION_TABLE_ii[i5 & 255](i1) | 0;
  return i6 | 0;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  i6 = FUNCTION_TABLE_ii[i5 & 255](i1) | 0;
  return i6 | 0;
 }
 return 0;
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiSampleFbvEbPS2_JEE6invokeERKS4_S5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  i6 = FUNCTION_TABLE_ii[i5 & 255](i1) | 0;
  return i6 | 0;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  i6 = FUNCTION_TABLE_ii[i5 & 255](i1) | 0;
  return i6 | 0;
 }
 return 0;
}

function ___towrite(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 74 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i3 + 255 | i3;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!(i3 & 8)) {
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i2 = HEAP32[i1 + 44 >> 2] | 0;
  HEAP32[i1 + 28 >> 2] = i2;
  HEAP32[i1 + 20 >> 2] = i2;
  HEAP32[i1 + 16 >> 2] = i2 + (HEAP32[i1 + 48 >> 2] | 0);
  i4 = 0;
 } else {
  HEAP32[i1 >> 2] = i3 | 32;
  i4 = -1;
 }
 return i4 | 0;
}

function __ZNSt3__16__clocEv() {
 var i1 = 0, i2 = 0;
 do if ((HEAP8[16400] | 0) == 0 ? (___cxa_guard_acquire(16400) | 0) != 0 : 0) {
  __THREW__ = 0;
  i1 = invoke_iiii(37, 2147483647, 47548, 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = ___cxa_find_matching_catch() | 0;
   ___cxa_guard_abort(16400);
   ___resumeException(i2 | 0);
  } else {
   HEAP32[6786] = i1;
   ___cxa_guard_release(16400);
   break;
  }
 } while (0);
 return HEAP32[6786] | 0;
}

function __ZNSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 19032;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiMixFvdRNSt3__16vectorIdNS3_9allocatorIdEEEEdEvPS2_JdS8_dEE6invokeERKSA_SB_dPS7_d(i1, i2, d3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i7 >> 1) | 0;
 if (!(i7 & 1)) i8 = i6; else i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + i6 >> 2] | 0;
 FUNCTION_TABLE_vidid[i8 & 1](i1, d3, i4, d5);
 return;
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiLagExpIdEFdvEdPS3_JEE6invokeERKS5_S6_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, d6 = 0.0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  d6 = +FUNCTION_TABLE_di[i5 & 7](i1);
  return +d6;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  d6 = +FUNCTION_TABLE_di[i5 & 7](i1);
  return +d6;
 }
 return +(0.0);
}

function _fwrite(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = Math_imul(i3, i2) | 0;
 if ((HEAP32[i4 + 76 >> 2] | 0) > -1) {
  i6 = (___lockfile(i4) | 0) == 0;
  i7 = ___fwritex(i1, i5, i4) | 0;
  if (i6) i8 = i7; else {
   ___unlockfile(i4);
   i8 = i7;
  }
 } else i8 = ___fwritex(i1, i5, i4) | 0;
 if ((i8 | 0) == (i5 | 0)) i9 = i3; else i9 = (i8 >>> 0) / (i2 >>> 0) | 0;
 return i9 | 0;
}

function __ZNKSt3__15ctypeIcE10do_toupperEPcPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i2;
  do {
   i2 = HEAP8[i1 >> 0] | 0;
   if (i2 << 24 >> 24 > -1) {
    i4 = (__ZNSt3__15ctypeIcE21__classic_upper_tableEv() | 0) + (i2 << 24 >> 24 << 2) | 0;
    i5 = HEAP32[i4 >> 2] & 255;
   } else i5 = i2;
   HEAP8[i1 >> 0] = i5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 return i3 | 0;
}

function __ZNKSt3__15ctypeIcE10do_tolowerEPcPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i2;
  do {
   i2 = HEAP8[i1 >> 0] | 0;
   if (i2 << 24 >> 24 > -1) {
    i4 = (__ZNSt3__15ctypeIcE21__classic_lower_tableEv() | 0) + (i2 << 24 >> 24 << 2) | 0;
    i5 = HEAP32[i4 >> 2] & 255;
   } else i5 = i2;
   HEAP8[i1 >> 0] = i5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 return i3 | 0;
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiSampleFdvEdPS2_JEE6invokeERKS4_S5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, d6 = 0.0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  d6 = +FUNCTION_TABLE_di[i5 & 7](i1);
  return +d6;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  d6 = +FUNCTION_TABLE_di[i5 & 7](i1);
  return +d6;
 }
 return +(0.0);
}

function __ZN10emscripten8internal12GetterPolicyIM12maxiEnvelopeKFdvEE3getIS2_EEdRKS4_RKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, d6 = 0.0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  d6 = +FUNCTION_TABLE_di[i5 & 7](i1);
  return +d6;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  d6 = +FUNCTION_TABLE_di[i5 & 7](i1);
  return +d6;
 }
 return +(0.0);
}

function __ZNSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18768;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZN10emscripten8internal13MethodInvokerIM13maxiDelaylineFddidiEdPS2_JdidiEE6invokeERKS4_S5_didi(i1, i2, d3, i4, d5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i8 >> 1) | 0;
 if (!(i8 & 1)) i9 = i7; else i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + i7 >> 2] | 0;
 return +(+FUNCTION_TABLE_dididi[i9 & 1](i1, d3, i4, d5, i6));
}

function __ZNSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17792;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18124;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiOscFdvEdPS2_JEE6invokeERKS4_S5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, d6 = 0.0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  d6 = +FUNCTION_TABLE_di[i5 & 7](i1);
  return +d6;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  d6 = +FUNCTION_TABLE_di[i5 & 7](i1);
  return +d6;
 }
 return +(0.0);
}

function ___stdout_write(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i5 = i4;
 HEAP32[i1 + 36 >> 2] = 5;
 if ((HEAP32[i1 >> 2] & 64 | 0) == 0 ? (HEAP32[i5 >> 2] = HEAP32[i1 + 60 >> 2], HEAP32[i5 + 4 >> 2] = 21505, HEAP32[i5 + 8 >> 2] = i4 + 12, (___syscall54(54, i5 | 0) | 0) != 0) : 0) HEAP8[i1 + 75 >> 0] = -1;
 i5 = ___stdio_write(i1, i2, i3) | 0;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZNSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17700;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __Znwj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = (i1 | 0) == 0 ? 1 : i1;
 i1 = _malloc(i2) | 0;
 L1 : do if (!i1) {
  while (1) {
   i3 = __ZSt15get_new_handlerv() | 0;
   if (!i3) break;
   FUNCTION_TABLE_v[i3 & 7]();
   i3 = _malloc(i2) | 0;
   if (i3) {
    i4 = i3;
    break L1;
   }
  }
  i3 = ___cxa_allocate_exception(4) | 0;
  HEAP32[i3 >> 2] = 19128;
  ___cxa_throw(i3 | 0, 14872, 115);
 } else i4 = i1; while (0);
 return i4 | 0;
}

function __ZNSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18856;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18220;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17896;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18944;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function copyTempDouble(i1) {
 i1 = i1 | 0;
 HEAP8[tempDoublePtr >> 0] = HEAP8[i1 >> 0];
 HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i1 + 1 >> 0];
 HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i1 + 2 >> 0];
 HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i1 + 3 >> 0];
 HEAP8[tempDoublePtr + 4 >> 0] = HEAP8[i1 + 4 >> 0];
 HEAP8[tempDoublePtr + 5 >> 0] = HEAP8[i1 + 5 >> 0];
 HEAP8[tempDoublePtr + 6 >> 0] = HEAP8[i1 + 6 >> 0];
 HEAP8[tempDoublePtr + 7 >> 0] = HEAP8[i1 + 7 >> 0];
}

function __ZN10emscripten8internal13MethodInvokerIM20maxiEnvelopeFollowerFvdEvPS2_JdEE6invokeERKS4_S5_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  FUNCTION_TABLE_vid[i6 & 7](i1, d3);
  return;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  FUNCTION_TABLE_vid[i6 & 7](i1, d3);
  return;
 }
}

function __ZN10emscripten8internal13MethodInvokerIM12maxiEnvelopeFdiRNSt3__16vectorIdNS3_9allocatorIdEEEEEdPS2_JiS8_EE6invokeERKSA_SB_iPS7_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i6 >> 1) | 0;
 if (!(i6 & 1)) i7 = i5; else i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + i5 >> 2] | 0;
 return +(+FUNCTION_TABLE_diii[i7 & 7](i1, i3, i4));
}

function __ZNSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17476;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__18ios_baseD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 25428;
 __THREW__ = 0;
 invoke_vii(63, i1 | 0, 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__16localeD2Ev(i1 + 28 | 0);
  _free(HEAP32[i1 + 32 >> 2] | 0);
  _free(HEAP32[i1 + 36 >> 2] | 0);
  _free(HEAP32[i1 + 48 >> 2] | 0);
  _free(HEAP32[i1 + 60 >> 2] | 0);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17572;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17992;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18356;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18572;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18456;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18696;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 19032;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function _vsscanf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i5 = i4;
 i6 = i5;
 i7 = i6 + 112 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i5 + 32 >> 2] = 36;
 HEAP32[i5 + 44 >> 2] = i1;
 HEAP32[i5 + 76 >> 2] = -1;
 HEAP32[i5 + 84 >> 2] = i1;
 i1 = _vfscanf(i5, i2, i3) | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 FUNCTION_TABLE_viii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 15](i5, i1, i2);
 if ((HEAP32[i5 + 4 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) i6 = (HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0); else i6 = 0;
 STACKTOP = i4;
 return i6 | 0;
}

function ___string_read(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i1 + 84 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i3 + 256 | 0;
 i7 = _memchr(i5, 0, i6) | 0;
 i8 = (i7 | 0) == 0 ? i6 : i7 - i5 | 0;
 i7 = i8 >>> 0 < i3 >>> 0 ? i8 : i3;
 _memcpy(i2 | 0, i5 | 0, i7 | 0) | 0;
 HEAP32[i1 + 4 >> 2] = i5 + i7;
 i2 = i5 + i8 | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 return i7 | 0;
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiLagExpIdEFvdEvPS3_JdEE6invokeERKS5_S6_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  FUNCTION_TABLE_vid[i6 & 7](i1, d3);
  return;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  FUNCTION_TABLE_vid[i6 & 7](i1, d3);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18768;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17792;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18124;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17700;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNKSt3__15ctypeIwE9do_narrowEPKwS3_cPc(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i1 = (i3 - i2 | 0) >>> 2;
 if ((i2 | 0) != (i3 | 0)) {
  i6 = i2;
  i7 = i5;
  while (1) {
   i5 = HEAP32[i6 >> 2] | 0;
   HEAP8[i7 >> 0] = i5 >>> 0 < 128 ? i5 & 255 : i4;
   i6 = i6 + 4 | 0;
   if ((i6 | 0) == (i3 | 0)) break; else i7 = i7 + 1 | 0;
  }
 }
 return i2 + (i1 << 2) | 0;
}

function __ZNSt3__16locale8__globalEv() {
 var i1 = 0;
 do if ((HEAP8[16888] | 0) == 0 ? (___cxa_guard_acquire(16888) | 0) != 0 : 0) {
  __THREW__ = 0;
  invoke_i(24) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch() | 0;
   ___cxa_guard_abort(16888);
   ___resumeException(i1 | 0);
  } else {
   HEAP32[6838] = 27348;
   ___cxa_guard_release(16888);
   break;
  }
 } while (0);
 return HEAP32[6838] | 0;
}

function __ZNSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18856;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__16locale7classicEv() {
 var i1 = 0;
 do if ((HEAP8[16720] | 0) == 0 ? (___cxa_guard_acquire(16720) | 0) != 0 : 0) {
  __THREW__ = 0;
  invoke_i(23) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch() | 0;
   ___cxa_guard_abort(16720);
   ___resumeException(i1 | 0);
  } else {
   HEAP32[6836] = 27340;
   ___cxa_guard_release(16720);
   break;
  }
 } while (0);
 return HEAP32[6836] | 0;
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18220;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17896;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18944;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiOscFvdEvPS2_JdEE6invokeERKS4_S5_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  FUNCTION_TABLE_vid[i6 & 7](i1, d3);
  return;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  FUNCTION_TABLE_vid[i6 & 7](i1, d3);
  return;
 }
}

function __ZN10emscripten8internal12SetterPolicyIM12maxiEnvelopeFvdEE3setIS2_EEvRKS4_RT_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i5 >> 1) | 0;
 if (!(i5 & 1)) {
  i6 = i4;
  FUNCTION_TABLE_vid[i6 & 7](i1, d3);
  return;
 } else {
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + i4 >> 2] | 0;
  FUNCTION_TABLE_vid[i6 & 7](i1, d3);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17476;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17572;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 17992;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18356;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18572;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18456;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 18696;
 __THREW__ = 0;
 invoke_vi(280, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__114__shared_countD2Ev(i1);
  return;
 }
}

function __ZNSt3__18ios_base4initEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 24 >> 2] = i2;
 HEAP32[i1 + 16 >> 2] = (i2 | 0) == 0 & 1;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 4098;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 6;
 i2 = i1 + 28 | 0;
 i3 = i1 + 32 | 0;
 i1 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 __ZNSt3__16localeC2Ev(i2);
 return;
}

function __ZNSt3__110__time_putD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 __THREW__ = 0;
 i3 = invoke_i(22) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (!(i4 & 1)) {
  if ((i2 | 0) != (i3 | 0) ? (__THREW__ = 0, invoke_vi(286, HEAP32[i1 >> 2] | 0), i5 = __THREW__, __THREW__ = 0, i5 & 1) : 0) break;
  return;
 } while (0);
 i1 = ___cxa_find_matching_catch(0) | 0;
 ___clang_call_terminate(i1);
}

function __ZN10emscripten8internal13MethodInvokerIM13maxiDelaylineFddidEdPS2_JdidEE6invokeERKS4_S5_did(i1, i2, d3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i7 >> 1) | 0;
 if (!(i7 & 1)) i8 = i6; else i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + i6 >> 2] | 0;
 return +(+FUNCTION_TABLE_didid[i8 & 1](i1, d3, i4, d5));
}

function __ZNKSt3__17collateIwE7do_hashEPKwS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i2 | 0) == (i3 | 0)) i4 = 0; else {
  i1 = 0;
  i5 = i2;
  while (1) {
   i2 = (HEAP32[i5 >> 2] | 0) + (i1 << 4) | 0;
   i6 = i2 & -268435456;
   i7 = (i6 >>> 24 | i6) ^ i2;
   i5 = i5 + 4 | 0;
   if ((i5 | 0) == (i3 | 0)) {
    i4 = i7;
    break;
   } else i1 = i7;
  }
 }
 return i4 | 0;
}

function __ZN10emscripten8internal13MethodInvokerIM20maxiEnvelopeFollowerFvvEvPS2_JEE6invokeERKS4_S5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  FUNCTION_TABLE_vi[i5 & 511](i1);
  return;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  FUNCTION_TABLE_vi[i5 & 511](i1);
  return;
 }
}

function __ZNKSt3__17collateIcE7do_hashEPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i2 | 0) == (i3 | 0)) i4 = 0; else {
  i1 = 0;
  i5 = i2;
  while (1) {
   i2 = (HEAP8[i5 >> 0] | 0) + (i1 << 4) | 0;
   i6 = i2 & -268435456;
   i7 = (i6 >>> 24 | i6) ^ i2;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i3 | 0)) {
    i4 = i7;
    break;
   } else i1 = i7;
  }
 }
 return i4 | 0;
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiSampleFddddEdPS2_JdddEE6invokeERKS4_S5_ddd(i1, i2, d3, d4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i7 >> 1) | 0;
 if (!(i7 & 1)) i8 = i6; else i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + i6 >> 2] | 0;
 return +(+FUNCTION_TABLE_diddd[i8 & 7](i1, d3, d4, d5));
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiFilterFddddEdPS2_JdddEE6invokeERKS4_S5_ddd(i1, i2, d3, d4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i7 >> 1) | 0;
 if (!(i7 & 1)) i8 = i6; else i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + i6 >> 2] | 0;
 return +(+FUNCTION_TABLE_diddd[i8 & 7](i1, d3, d4, d5));
}

function __ZN7maxiOsc6phasorEddd(i1, d2, d3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 var i5 = 0, d6 = 0.0, d7 = 0.0, d8 = 0.0;
 i5 = i1 + 8 | 0;
 d6 = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 32 >> 3] = d6;
 if (d6 < d3) {
  HEAPF64[i5 >> 3] = d3;
  d7 = d3;
 } else d7 = d6;
 if (!(d7 >= d4)) d8 = d7; else {
  HEAPF64[i5 >> 3] = d3;
  d8 = d3;
 }
 HEAPF64[i5 >> 3] = (d4 - d3) / (+(HEAP32[4327] | 0) / d2) + d8;
 return +d6;
}

function __ZNSt3__18ios_base16__call_callbacksENS0_5eventE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 i4 = i1 + 32 | 0;
 i5 = i1 + 36 | 0;
 if (i3) {
  i6 = i3;
  do {
   i6 = i6 + -1 | 0;
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] & 15](i2, i1, HEAP32[(HEAP32[i5 >> 2] | 0) + (i6 << 2) >> 2] | 0);
  } while ((i6 | 0) != 0);
 }
 return;
}

function __ZN7maxiOsc7sinebufEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0;
 i3 = i1 + 8 | 0;
 d4 = 512.0 / (+(HEAP32[4327] | 0) / (+HEAPF32[4326] * d2)) + +HEAPF64[i3 >> 3];
 d2 = !(d4 >= 511.0) ? d4 : d4 + -512.0;
 HEAPF64[i3 >> 3] = d2;
 d4 = d2 - +Math_floor(+d2);
 i3 = ~~d2;
 d2 = +HEAPF64[8 + (i3 + 2 << 3) >> 3] * d4 + +HEAPF64[8 + (i3 + 1 << 3) >> 3] * (1.0 - d4);
 HEAPF64[i1 + 32 >> 3] = d2;
 return +d2;
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiOscFddddEdPS2_JdddEE6invokeERKS4_S5_ddd(i1, i2, d3, d4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i7 >> 1) | 0;
 if (!(i7 & 1)) i8 = i6; else i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + i6 >> 2] | 0;
 return +(+FUNCTION_TABLE_diddd[i8 & 7](i1, d3, d4, d5));
}

function __ZNSt3__111make_sharedI10maxiLagExpIdEJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS4_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __Znwj(40) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18156;
 i3 = i2 + 16 | 0;
 HEAPF64[i3 >> 3] = .5;
 HEAPF64[i2 + 24 >> 3] = .5;
 HEAPF64[i2 + 32 >> 3] = 0.0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiSampleFvvEvPS2_JEE6invokeERKS4_S5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i5 = i3;
  FUNCTION_TABLE_vi[i5 & 511](i1);
  return;
 } else {
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  FUNCTION_TABLE_vi[i5 & 511](i1);
  return;
 }
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i2 >> 0] & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 } else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 return;
}

function __ZN7maxiOsc6squareEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, d5 = 0.0, d6 = 0.0;
 i3 = i1 + 8 | 0;
 d4 = +HEAPF64[i3 >> 3];
 if (d4 < .5) HEAPF64[i1 + 32 >> 3] = -1.0;
 if (d4 > .5) HEAPF64[i1 + 32 >> 3] = 1.0;
 if (!(d4 >= 1.0)) d5 = d4; else {
  d6 = d4 + -1.0;
  HEAPF64[i3 >> 3] = d6;
  d5 = d6;
 }
 HEAPF64[i3 >> 3] = 1.0 / (+(HEAP32[4327] | 0) / d2) + d5;
 return +(+HEAPF64[i1 + 32 >> 3]);
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP8[i1 >> 0] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
 if (!(HEAP32[i2 + (i3 + 16) >> 2] | 0)) {
  i4 = HEAP32[i2 + (i3 + 72) >> 2] | 0;
  if (i4) __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(i4) | 0;
  HEAP8[i1 >> 0] = 1;
 }
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP8[i1 >> 0] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
 if (!(HEAP32[i2 + (i3 + 16) >> 2] | 0)) {
  i4 = HEAP32[i2 + (i3 + 72) >> 2] | 0;
  if (i4) __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i4) | 0;
  HEAP8[i1 >> 0] = 1;
 }
 return;
}

function __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_vii(72, i1 | 0, 47687);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i2 | 0);
 } else {
  HEAP32[i1 >> 2] = 19192;
  ___cxa_throw(i1 | 0, 14912, 117);
 }
}

function __ZN10emscripten8internal15FunctionInvokerIPFbRNSt3__16vectorIiNS2_9allocatorIiEEEEjRKiEbS7_JjS9_EE6invokeEPSB_PS6_ji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i4 = FUNCTION_TABLE_iiii[i7 & 63](i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN10emscripten8internal15FunctionInvokerIPFbRNSt3__16vectorIdNS2_9allocatorIdEEEEjRKdEbS7_JjS9_EE6invokeEPSB_PS6_jd(i1, i2, i3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAPF64[i6 >> 3] = d4;
 i1 = FUNCTION_TABLE_iiii[i7 & 63](i2, i3, i6) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 19172;
 __THREW__ = 0;
 invoke_vii(105, i1 + 4 | 0, ((HEAP8[i2 >> 0] & 1) == 0 ? i2 + 1 | 0 : HEAP32[i2 + 8 >> 2] | 0) | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch() | 0;
  ___resumeException(i2 | 0);
 } else return;
}

function __ZN10emscripten8internal13MethodInvokerIM8maxiTestFijjEiPS2_JjjEE6invokeERKS4_S5_jj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i6 >> 1) | 0;
 if (!(i6 & 1)) i7 = i5; else i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + i5 >> 2] | 0;
 return FUNCTION_TABLE_iiii[i7 & 63](i1, i3, i4) | 0;
}

function __ZN10emscripten8internal13MethodInvokerIM14maxiDistortionFdddEdPS2_JddEE6invokeERKS4_S5_dd(i1, i2, d3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i6 >> 1) | 0;
 if (!(i6 & 1)) i7 = i5; else i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + i5 >> 2] | 0;
 return +(+FUNCTION_TABLE_didd[i7 & 7](i1, d3, d4));
}

function _copysign(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i3 = HEAP32[tempDoublePtr >> 2] | 0;
 i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] & -2147483648 | i4 & 2147483647;
 HEAP32[tempDoublePtr >> 2] = i3;
 HEAP32[tempDoublePtr + 4 >> 2] = i5;
 return +(+HEAPF64[tempDoublePtr >> 3]);
}

function __ZN10emscripten8internal13MethodInvokerIM10maxiFilterFdddEdPS2_JddEE6invokeERKS4_S5_dd(i1, i2, d3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i6 >> 1) | 0;
 if (!(i6 & 1)) i7 = i5; else i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + i5 >> 2] | 0;
 return +(+FUNCTION_TABLE_didd[i7 & 7](i1, d3, d4));
}

function __ZN7maxiOsc8triangleEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, d5 = 0.0, d6 = 0.0;
 i3 = i1 + 8 | 0;
 d4 = +HEAPF64[i3 >> 3];
 if (!(d4 >= 1.0)) d5 = d4; else {
  d6 = d4 + -1.0;
  HEAPF64[i3 >> 3] = d6;
  d5 = d6;
 }
 d6 = 1.0 / (+(HEAP32[4327] | 0) / d2) + d5;
 HEAPF64[i3 >> 3] = d6;
 d5 = ((!(d6 <= .5) ? 1.0 - d6 : d6) + -.25) * 4.0;
 HEAPF64[i1 + 32 >> 3] = d5;
 return +d5;
}

function ___muldsi3(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 & 65535;
 i4 = i2 & 65535;
 i5 = Math_imul(i4, i3) | 0;
 i6 = i1 >>> 16;
 i1 = (i5 >>> 16) + (Math_imul(i4, i6) | 0) | 0;
 i4 = i2 >>> 16;
 i2 = Math_imul(i4, i3) | 0;
 return (tempRet0 = (i1 >>> 16) + (Math_imul(i4, i6) | 0) + (((i1 & 65535) + i2 | 0) >>> 16) | 0, i1 + i2 << 16 | i5 & 65535 | 0) | 0;
}

function __ZN10emscripten8internal13MethodInvokerIM7maxiOscFdddEdPS2_JddEE6invokeERKS4_S5_dd(i1, i2, d3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + (i6 >> 1) | 0;
 if (!(i6 & 1)) i7 = i5; else i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + i5 >> 2] | 0;
 return +(+FUNCTION_TABLE_didd[i7 & 7](i1, d3, d4));
}

function __ZN7maxiOsc8sinewaveEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, d5 = 0.0, d6 = 0.0, d7 = 0.0;
 i3 = i1 + 8 | 0;
 d4 = +HEAPF64[i3 >> 3];
 d5 = +Math_sin(+(d4 * 6.283185307179586));
 HEAPF64[i1 + 32 >> 3] = d5;
 if (!(d4 >= 1.0)) d6 = d4; else {
  d7 = d4 + -1.0;
  HEAPF64[i3 >> 3] = d7;
  d6 = d7;
 }
 HEAPF64[i3 >> 3] = 1.0 / (+(HEAP32[4327] | 0) / d2) + d6;
 return +d5;
}

function __ZN7maxiOsc7coswaveEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, d5 = 0.0, d6 = 0.0, d7 = 0.0;
 i3 = i1 + 8 | 0;
 d4 = +HEAPF64[i3 >> 3];
 d5 = +Math_cos(+(d4 * 6.283185307179586));
 HEAPF64[i1 + 32 >> 3] = d5;
 if (!(d4 >= 1.0)) d6 = d4; else {
  d7 = d4 + -1.0;
  HEAPF64[i3 >> 3] = d7;
  d6 = d7;
 }
 HEAPF64[i3 >> 3] = 1.0 / (+(HEAP32[4327] | 0) / d2) + d6;
 return +d5;
}

function __ZNSt3__111make_sharedI11maxiFlangerJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(705704) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18888;
 _memset(i2 + 56 | 0, 0, 705600) | 0;
 HEAPF64[i2 + 705664 >> 3] = 0.0;
 HEAP32[i1 >> 2] = i2 + 16;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function dynCall_iiiiiiiiiiii(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 return FUNCTION_TABLE_iiiiiiiiiiii[i1 & 3](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0) | 0;
}

function __ZNSt3__16vectorIdNS_9allocatorIdEEE9push_backERKd(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) {
  __ZNSt3__16vectorIdNS_9allocatorIdEEE21__push_back_slow_pathIRKdEEvOT_(i1, i2);
  return;
 } else {
  HEAPF64[i4 >> 3] = +HEAPF64[i2 >> 3];
  HEAP32[i3 >> 2] = i4 + 8;
  return;
 }
}

function __ZNSt3__111__stdoutbufIwE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 255](i1) | 0;
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 26648) | 0;
 HEAP32[i1 + 36 >> 2] = i3;
 i2 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] & 255](i3) | 0) & 1;
 HEAP8[i1 + 44 >> 0] = i2;
 return;
}

function __ZNSt3__111__stdoutbufIcE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 255](i1) | 0;
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 26640) | 0;
 HEAP32[i1 + 36 >> 2] = i3;
 i2 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] & 255](i3) | 0) & 1;
 HEAP8[i1 + 44 >> 0] = i2;
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__16vectorIiNS2_9allocatorIiEEEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2;
 if (i2) {
  i4 = i1 + 4 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__16vectorIdNS2_9allocatorIdEEEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2;
 if (i2) {
  i4 = i1 + 4 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -8 - i3 | 0) >>> 3) << 3);
  __ZdlPv(i2);
 }
 __ZdlPv(i1);
 return;
}

function __ZNSt3__16vectorIiNS_9allocatorIiEEE9push_backERKi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) {
  __ZNSt3__16vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIRKiEEvOT_(i1, i2);
  return;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 >> 2] = i4 + 4;
  return;
 }
}

function __ZNSt3__117__call_once_proxyINS_5tupleIJNS_12_GLOBAL__N_111__fake_bindEEEEEEvPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + (i4 >> 1) | 0;
 if (!(i4 & 1)) i5 = i3; else i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + i3 >> 2] | 0;
 FUNCTION_TABLE_vi[i5 & 511](i2);
 return;
}

function __ZNKSt3__15ctypeIcE9do_narrowEPKcS3_cPc(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i2;
  i2 = i5;
  while (1) {
   i5 = HEAP8[i1 >> 0] | 0;
   HEAP8[i2 >> 0] = i5 << 24 >> 24 > -1 ? i5 : i4;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 return i3 | 0;
}

function _calloc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (i1) {
  i3 = Math_imul(i2, i1) | 0;
  if ((i2 | i1) >>> 0 > 65535) i4 = ((i3 >>> 0) / (i1 >>> 0) | 0 | 0) == (i2 | 0) ? i3 : -1; else i4 = i3;
 } else i4 = 0;
 i3 = _malloc(i4) | 0;
 if (!i3) return i3 | 0;
 if (!(HEAP32[i3 + -4 >> 2] & 3)) return i3 | 0;
 _memset(i3 | 0, 0, i4 | 0) | 0;
 return i3 | 0;
}

function __ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(0, i2, i3, i4, i5);
 return;
}

function _memmove(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if ((i2 | 0) < (i1 | 0) & (i1 | 0) < (i2 + i3 | 0)) {
  i4 = i1;
  i2 = i2 + i3 | 0;
  i1 = i1 + i3 | 0;
  while ((i3 | 0) > 0) {
   i1 = i1 - 1 | 0;
   i2 = i2 - 1 | 0;
   i3 = i3 - 1 | 0;
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  }
  i1 = i4;
 } else _memcpy(i1, i2, i3) | 0;
 return i1 | 0;
}

function ___cxa_can_catch(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i6 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 63](i1, i2, i5) | 0;
 if (i6) HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 STACKTOP = i4;
 return i6 & 1 | 0;
}

function _llvm_cttz_i32(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[cttz_i8 + (i1 & 255) >> 0] | 0;
 if ((i2 | 0) < 8) return i2 | 0;
 i2 = HEAP8[cttz_i8 + (i1 >> 8 & 255) >> 0] | 0;
 if ((i2 | 0) < 8) return i2 + 8 | 0;
 i2 = HEAP8[cttz_i8 + (i1 >> 16 & 255) >> 0] | 0;
 if ((i2 | 0) < 8) return i2 + 16 | 0;
 return (HEAP8[cttz_i8 + (i1 >>> 24) >> 0] | 0) + 24 | 0;
}

function __ZNSt3__17codecvtIwc11__mbstate_tEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = 26664;
 __THREW__ = 0;
 i2 = invoke_i(22) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 + 8 >> 2] = i2;
  return;
 }
}

function __ZNSt3__16locale2id5__getEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 if ((HEAP32[i1 >> 2] | 0) != -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = 289;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZNSt3__111__call_onceERVmPvPFvS2_E(i1, i3, 290);
 }
 STACKTOP = i2;
 return (HEAP32[i1 + 4 >> 2] | 0) + -1 | 0;
}

function _sumArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, d6 = 0.0, d7 = 0.0;
 if ((i2 | 0) > 0) {
  i3 = 0;
  d4 = 0.0;
 } else {
  i5 = 0;
  return i5 | 0;
 }
 while (1) {
  d6 = d4 + +HEAPF64[i1 + (i3 << 3) >> 3];
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i2 | 0)) {
   d7 = d6;
   break;
  } else d4 = d6;
 }
 i5 = ~~d7;
 return i5 | 0;
}

function __ZNSt3__111make_sharedI13maxiDelaylineJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(705656) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 17824;
 _memset(i2 + 56 | 0, 0, 705600) | 0;
 HEAP32[i1 >> 2] = i2 + 16;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNSt3__121__throw_runtime_errorEPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_vii(68, i2 | 0, i1 | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch() | 0;
  ___cxa_free_exception(i2 | 0);
  ___resumeException(i1 | 0);
 } else ___cxa_throw(i2 | 0, 14928, 119);
}

function __ZNSt3__16localeC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __THREW__ = 0;
 i2 = invoke_i(25) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i3);
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  __ZNSt3__114__shared_count12__add_sharedEv(i3);
  return;
 }
}

function __ZN7maxiMix6stereoEdRNSt3__16vectorIdNS0_9allocatorIdEEEEd(i1, d2, i3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 var d5 = 0.0;
 d5 = d4 > 1.0 ? 1.0 : d4;
 d4 = d5 < 0.0 ? 0.0 : d5;
 d5 = +Math_sqrt(+(1.0 - d4)) * d2;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAPF64[i1 >> 3] = d5;
 d5 = +Math_sqrt(+d4) * d2;
 HEAPF64[i1 + 8 >> 3] = d5;
 return;
}

function dynCall_viiiiiiiiii(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 FUNCTION_TABLE_viiiiiiiiii[i1 & 7](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0);
}

function ___uflow(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 if ((HEAP32[i1 + 8 >> 2] | 0) == 0 ? (___toread(i1) | 0) != 0 : 0) i4 = -1; else if ((FUNCTION_TABLE_iiii[HEAP32[i1 + 32 >> 2] & 63](i1, i3, 1) | 0) == 1) i4 = HEAPU8[i3 >> 0] | 0; else i4 = -1;
 STACKTOP = i2;
 return i4 | 0;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 i1 = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZNSt3__111make_sharedI7maxiOscJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(64) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 17604;
 HEAPF64[i2 + 24 >> 3] = 0.0;
 HEAP32[i1 >> 2] = i2 + 16;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN7maxiOsc6phasorEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, d5 = 0.0, d6 = 0.0;
 i3 = i1 + 8 | 0;
 d4 = +HEAPF64[i3 >> 3];
 HEAPF64[i1 + 32 >> 3] = d4;
 if (!(d4 >= 1.0)) d5 = d4; else {
  d6 = d4 + -1.0;
  HEAPF64[i3 >> 3] = d6;
  d5 = d6;
 }
 HEAPF64[i3 >> 3] = 1.0 / (+(HEAP32[4327] | 0) / d2) + d5;
 return +d4;
}

function __ZN7maxiOsc3sawEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, d5 = 0.0, d6 = 0.0;
 i3 = i1 + 8 | 0;
 d4 = +HEAPF64[i3 >> 3];
 HEAPF64[i1 + 32 >> 3] = d4;
 if (!(d4 >= 1.0)) d5 = d4; else {
  d6 = d4 + -2.0;
  HEAPF64[i3 >> 3] = d6;
  d5 = d6;
 }
 HEAPF64[i3 >> 3] = 1.0 / (+(HEAP32[4327] | 0) / d2) + d5;
 return +d4;
}

function _rand() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = 15192;
 i2 = ___muldi3(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, 1284865837, 1481765933) | 0;
 i1 = _i64Add(i2 | 0, tempRet0 | 0, 1, 0) | 0;
 i2 = tempRet0;
 i3 = 15192;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = _bitshift64Lshr(i1 | 0, i2 | 0, 33) | 0;
 return i3 | 0;
}

function ___shlim(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 104 >> 2] = i2;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = i4 - i3 | 0;
 HEAP32[i1 + 108 >> 2] = i5;
 if ((i2 | 0) != 0 & (i5 | 0) > (i2 | 0)) HEAP32[i1 + 100 >> 2] = i3 + i2; else HEAP32[i1 + 100 >> 2] = i4;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 25184;
 __ZNSt3__16localeC2Ev(i1 + 4 | 0);
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 25120;
 __ZNSt3__16localeC2Ev(i1 + 4 | 0);
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 return;
}

function __ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(0, i2, i3, i4);
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 return;
}

function __ZNSt3__118__libcpp_refstringC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = _strlen(i2) | 0;
 i4 = __Znwj(i3 + 13 | 0) | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i4 + 8 >> 2] = 0;
 i5 = i4 + 12 | 0;
 _memcpy(i5 | 0, i2 | 0, i3 + 1 | 0) | 0;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5uflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 255](i1) | 0) == -1) i2 = -1; else {
  i3 = i1 + 12 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 4;
  i2 = HEAP32[i1 >> 2] | 0;
 }
 return i2 | 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5uflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 255](i1) | 0) == -1) i2 = -1; else {
  i3 = i1 + 12 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 1;
  i2 = HEAPU8[i1 >> 0] | 0;
 }
 return i2 | 0;
}

function _sn_write(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = (HEAP32[i1 + 16 >> 2] | 0) - i5 | 0;
 i1 = i6 >>> 0 > i3 >>> 0 ? i3 : i6;
 _memcpy(i5 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i1;
 return i3 | 0;
}

function __ZNKSt3__15ctypeIcE8do_widenEPKcS3_Pc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i2;
  i2 = i4;
  while (1) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 return i3 | 0;
}

function __ZNKSt3__16locale5__imp9use_facetEl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (__ZNKSt3__16locale5__imp9has_facetEl(i1, i2) | 0) return HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 << 2) >> 2] | 0; else {
  i2 = ___cxa_allocate_exception(4) | 0;
  __ZNSt8bad_castC2Ev(i2);
  ___cxa_throw(i2 | 0, 14952, 122);
 }
 return 0;
}

function __ZNSt3__111make_sharedI14maxiDistortionJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(16) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18800;
 HEAP32[i1 >> 2] = i2 + 12;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNKSt3__15ctypeIwE8do_widenEPKcS3_Pw(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i2;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP8[i1 >> 0];
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 4 | 0;
  }
 }
 return i3 | 0;
}

function __ZN20maxiEnvelopeFollower4playEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var d3 = 0.0, i4 = 0, d5 = 0.0;
 d3 = +Math_abs(+d2);
 i4 = i1 + 16 | 0;
 d2 = +HEAPF64[i4 >> 3];
 if (d3 > d2) d5 = (d2 - d3) * +HEAPF64[i1 >> 3]; else d5 = (d2 - d3) * +HEAPF64[i1 + 8 >> 3];
 d2 = d3 + d5;
 HEAPF64[i4 >> 3] = d2;
 return +d2;
}

function __ZNSt3__111make_sharedI12maxiEnvelopeJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(72) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 17732;
 HEAP32[i1 >> 2] = i2 + 16;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNSt3__111make_sharedI8maxiTestJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(16) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 17508;
 HEAP32[i1 >> 2] = i2 + 12;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNSt3__111make_sharedI7maxiEnvJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(104) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18604;
 HEAP32[i1 >> 2] = i2 + 16;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNSt3__111make_sharedI7maxiDynJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(104) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18488;
 HEAP32[i1 >> 2] = i2 + 16;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNSt3__111make_sharedI7maxiMixJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(16) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18024;
 HEAP32[i1 >> 2] = i2 + 12;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNSt3__111make_sharedI7maxiMapJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(16) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18388;
 HEAP32[i1 >> 2] = i2 + 12;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNSt3__111make_sharedI7convertJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(16) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 18728;
 HEAP32[i1 >> 2] = i2 + 12;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function b46(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 abort(46);
}

function __ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _catopen((HEAP8[i2 >> 0] & 1) == 0 ? i2 + 1 | 0 : HEAP32[i2 + 8 >> 2] | 0, 1) | 0;
 return i3 >>> ((i3 | 0) != (-1 | 0) & 1) | 0;
}

function __ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _catopen((HEAP8[i2 >> 0] & 1) == 0 ? i2 + 1 | 0 : HEAP32[i2 + 8 >> 2] | 0, 1) | 0;
 return i3 >>> ((i3 | 0) != (-1 | 0) & 1) | 0;
}

function ___uremdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5 | 0;
 ___udivmoddi4(i1, i2, i3, i4, i6) | 0;
 STACKTOP = i5;
 return (tempRet0 = HEAP32[i6 + 4 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i4 + 4 >> 2] = -1;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i4 + 4 >> 2] = -1;
 return;
}

function __ZNSt3__114__shared_count16__release_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i3 + -1;
 if (!i3) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
  i4 = 1;
 } else i4 = 0;
 return i4 | 0;
}

function dynCall_iiiiiiiii(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return FUNCTION_TABLE_iiiiiiiii[i1 & 15](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0) | 0;
}

function __ZNKSt3__119__iostream_category7messageEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i3 | 0) != 1 & (i3 | 0) < 257) __ZNKSt3__112__do_message7messageEi(i1, i2, i3); else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 46125, 35);
 return;
}

function dynCall_diidddddii(i1, i2, i3, d4, d5, d6, d7, d8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 d8 = +d8;
 i9 = i9 | 0;
 i10 = i10 | 0;
 return +FUNCTION_TABLE_diidddddii[i1 & 1](i2 | 0, i3 | 0, +d4, +d5, +d6, +d7, +d8, i9 | 0, i10 | 0);
}

function _wmemcpy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (i3) {
  i4 = i3;
  i3 = i2;
  i2 = i1;
  while (1) {
   i4 = i4 + -1 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   if (!i4) break; else {
    i3 = i3 + 4 | 0;
    i2 = i2 + 4 | 0;
   }
  }
 }
 return i1 | 0;
}

function __ZN11vectorTools14clearVectorDblERNSt3__16vectorIdNS0_9allocatorIdEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i1 + (~((i1 + -8 - i2 | 0) >>> 3) << 3);
 return;
}

function __ZNKSt3__17collateIwE12do_transformEPKwS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i3, i4);
 return;
}

function __ZNKSt3__17collateIcE12do_transformEPKcS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i3, i4);
 return;
}

function __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 switch (HEAP32[i1 + 4 >> 2] & 74 | 0) {
 case 64:
  {
   i2 = 8;
   break;
  }
 case 8:
  {
   i2 = 16;
   break;
  }
 case 0:
  {
   i2 = 0;
   break;
  }
 default:
  i2 = 10;
 }
 return i2 | 0;
}

function __ZNSt13runtime_errorC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 19172;
 __THREW__ = 0;
 invoke_vii(105, i1 + 4 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch() | 0;
  ___resumeException(i2 | 0);
 } else return;
}

function __ZNKSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 37997 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNSt3__18numpunctIwEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = 26784;
 HEAP32[i1 + 8 >> 2] = 46;
 HEAP32[i1 + 12 >> 2] = 44;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZNSt11logic_errorC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 19152;
 __THREW__ = 0;
 invoke_vii(105, i1 + 4 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch() | 0;
  ___resumeException(i2 | 0);
 } else return;
}

function __ZNSt3__15ctypeIcE21__classic_upper_tableEv() {
 var i1 = 0, i2 = 0;
 __THREW__ = 0;
 i1 = invoke_i(27) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return HEAP32[i1 >> 2] | 0;
 return 0;
}

function __ZNSt3__15ctypeIcE21__classic_lower_tableEv() {
 var i1 = 0, i2 = 0;
 __THREW__ = 0;
 i1 = invoke_i(28) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return HEAP32[i1 >> 2] | 0;
 return 0;
}

function __ZNSt3__18numpunctIcEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = 26744;
 HEAP8[i1 + 8 >> 0] = 46;
 HEAP8[i1 + 9 >> 0] = 44;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 36867 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 33660 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 34754 ? i1 + 16 | 0 : 0) | 0;
}

function ___muldi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i1;
 i1 = i3;
 i3 = ___muldsi3(i5, i1) | 0;
 i6 = tempRet0;
 return (tempRet0 = (Math_imul(i2, i1) | 0) + (Math_imul(i4, i5) | 0) + i6 | i6 & 0, i3 | 0 | 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 33282 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 37237 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i8 >> 2] = i6;
 return 3;
}

function __ZNKSt3__15ctypeIwE5do_isEtw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (i3 >>> 0 < 128) {
  i1 = (__ZNSt3__15ctypeIcE13classic_tableEv() | 0) + (i3 << 1) | 0;
  i4 = (HEAP16[i1 >> 1] & i2) << 16 >> 16 != 0;
 } else i4 = 0;
 return i4 | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 35142 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 34038 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 37603 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNSt3__15ctypeIcE13classic_tableEv() {
 var i1 = 0, i2 = 0;
 __THREW__ = 0;
 i1 = invoke_i(26) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch(0) | 0;
  ___clang_call_terminate(i2);
 } else return HEAP32[i1 >> 2] | 0;
 return 0;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i8 >> 2] = i6;
 return 3;
}

function __ZNKSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 32531 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 32910 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 34376 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 35480 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 36158 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 35814 ? i1 + 16 | 0 : 0) | 0;
}

function __ZNKSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i2 + 4 >> 2] | 0) == 36504 ? i1 + 16 | 0 : 0) | 0;
}

function ___cxa_get_globals_fast() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if (!(_pthread_once(19404, 4) | 0)) {
  i2 = _pthread_getspecific(HEAP32[4850] | 0) | 0;
  STACKTOP = i1;
  return i2 | 0;
 } else _abort_message(40134, i1);
 return 0;
}

function __ZNKSt3__15ctypeIcE10do_tolowerEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2 << 24 >> 24 > -1) {
  i1 = (__ZNSt3__15ctypeIcE21__classic_lower_tableEv() | 0) + (i2 << 24 >> 24 << 2) | 0;
  i3 = HEAP32[i1 >> 2] & 255;
 } else i3 = i2;
 return i3 | 0;
}

function dynCall_iiiiiiii(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return FUNCTION_TABLE_iiiiiiii[i1 & 15](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI20maxiEnvelopeFollowerEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function _newlocale(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (((HEAP8[i2 >> 0] | 0) != 0 ? (_strcmp(i2, 47548) | 0) != 0 : 0) ? (_strcmp(i2, 42852) | 0) != 0 : 0) i4 = 0; else if (!i3) i4 = _calloc(1, 4) | 0; else i4 = i3;
 return i4 | 0;
}

function __ZNKSt3__15ctypeIcE10do_toupperEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2 << 24 >> 24 > -1) {
  i1 = (__ZNSt3__15ctypeIcE21__classic_upper_tableEv() | 0) + ((i2 & 255) << 2) | 0;
  i3 = HEAP32[i1 >> 2] & 255;
 } else i3 = i2;
 return i3 | 0;
}

function __ZNKSt3__16locale5__imp9has_facetEl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if ((HEAP32[i1 + 12 >> 2] | 0) - i3 >> 2 >>> 0 > i2 >>> 0) i4 = (HEAP32[i3 + (i2 << 2) >> 2] | 0) != 0; else i4 = 0;
 return i4 | 0;
}

function dynCall_didddddii(i1, i2, d3, d4, d5, d6, d7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return +FUNCTION_TABLE_didddddii[i1 & 1](i2 | 0, +d3, +d4, +d5, +d6, +d7, i8 | 0, i9 | 0);
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI14maxiDistortionEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI13maxiDelaylineEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI10maxiLagExpIdEEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI12maxiEnvelopeEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function _snprintf(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i4;
 i4 = _vsnprintf(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN10maxiFilter6hipassEdd(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 var i4 = 0, d5 = 0.0, d6 = 0.0;
 i4 = i1 + 104 | 0;
 d5 = +HEAPF64[i4 >> 3];
 d6 = d2 - (d5 + (d2 - d5) * d3);
 HEAPF64[i1 + 16 >> 3] = d6;
 HEAPF64[i4 >> 3] = d6;
 return +d6;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI11maxiFlangerEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_19destruct_EPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 _free(i1);
 if (!(_pthread_setspecific(HEAP32[4850] | 0, 0) | 0)) {
  STACKTOP = i2;
  return;
 } else _abort_message(40352, i2);
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI10maxiSampleEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI10maxiFilterEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI10maxiChorusEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function dynCall_viiiiiii(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 FUNCTION_TABLE_viiiiiii[i1 & 7](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
}

function __ZNSt3__119__shared_weak_count14__release_weakEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i3 + -1;
 if (!i3) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 511](i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI8maxiTestEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, 1114111, 0) | 0;
}

function __ZN10emscripten8internal15FunctionInvokerIPFddddddEddJddddEE6invokeEPS3_ddddd(i1, d2, d3, d4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 return +(+FUNCTION_TABLE_dddddd[HEAP32[i1 >> 2] & 3](d2, d3, d4, d5, d6));
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiOscEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiMixEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiMapEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiEnvEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiDynEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7convertEEEEvPT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2) __ZNSt3__119__shared_weak_count16__release_sharedEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, 1114111, 0) | 0;
}

function __ZN10maxiSample5clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 96 >> 2] | 0;
 i3 = i1 + 100 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i1 + (~((i1 + -8 - i2 | 0) >>> 3) << 3);
 return;
}

function __ZNSt3__16locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26460) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26424) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26388) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26352) | 0);
 return;
}

function __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = (HEAP32[i1 >> 2] | 0) + -4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i3 + -1;
 if ((i3 + -1 | 0) < 0) __ZdlPv((HEAP32[i1 >> 2] | 0) + -12 | 0);
 return;
}

function __ZN10maxiFilter6lopassEdd(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 var i4 = 0, d5 = 0.0, d6 = 0.0;
 i4 = i1 + 104 | 0;
 d5 = +HEAPF64[i4 >> 3];
 d6 = d5 + (d2 - d5) * d3;
 HEAPF64[i1 + 16 >> 3] = d6;
 HEAPF64[i4 >> 3] = d6;
 return +d6;
}

function __ZNSt3__16locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26060) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26028) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(25996) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(25904) | 0);
 return;
}

function __ZNKSt3__15ctypeIwE10do_toupperEw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2 >>> 0 < 128) {
  i1 = (__ZNSt3__15ctypeIcE21__classic_upper_tableEv() | 0) + (i2 << 2) | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else i3 = i2;
 return i3 | 0;
}

function __ZNKSt3__15ctypeIwE10do_tolowerEw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2 >>> 0 < 128) {
  i1 = (__ZNSt3__15ctypeIcE21__classic_lower_tableEv() | 0) + (i2 << 2) | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else i3 = i2;
 return i3 | 0;
}

function __ZNSt3__16locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(25812) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(25752) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(25692) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(25620) | 0);
 return;
}

function runPostSets() {}
function _i64Subtract(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = i2 - i4 >>> 0;
 i5 = i2 - i4 - (i3 >>> 0 > i1 >>> 0 | 0) >>> 0;
 return (tempRet0 = i5, i1 - i3 >>> 0 | 0) | 0;
}

function dynCall_diidddii(i1, i2, i3, d4, d5, d6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return +FUNCTION_TABLE_diidddii[i1 & 1](i2 | 0, i3 | 0, +d4, +d5, +d6, i7 | 0, i8 | 0);
}

function ___stdio_close(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i1 + 60 >> 2];
 i1 = ___syscall_ret(___syscall6(6, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function copyTempFloat(i1) {
 i1 = i1 | 0;
 HEAP8[tempDoublePtr >> 0] = HEAP8[i1 >> 0];
 HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i1 + 1 >> 0];
 HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i1 + 2 >> 0];
 HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i1 + 3 >> 0];
}

function _abort_message(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = HEAP32[4915] | 0;
 _vfprintf(i2, i1, i4) | 0;
 _fputc(10, i2) | 0;
 _abort();
}

function __ZNSt3__117iostream_categoryEv() {
 if ((HEAP8[15480] | 0) == 0 ? (___cxa_guard_acquire(15480) | 0) != 0 : 0) {
  HEAP32[6368] = 25444;
  ___cxa_atexit(160, 25472, ___dso_handle | 0) | 0;
  ___cxa_guard_release(15480);
 }
 return 25472;
}

function dynCall_iiiiiii(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return FUNCTION_TABLE_iiiiiii[i1 & 63](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
}

function dynCall_diididdd(i1, i2, i3, d4, i5, d6, d7, d8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 d8 = +d8;
 return +FUNCTION_TABLE_diididdd[i1 & 3](i2 | 0, i3 | 0, +d4, i5 | 0, +d6, +d7, +d8);
}

function dynCall_diiddidd(i1, i2, i3, d4, d5, i6, d7, d8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 i6 = i6 | 0;
 d7 = +d7;
 d8 = +d8;
 return +FUNCTION_TABLE_diiddidd[i1 & 1](i2 | 0, i3 | 0, +d4, +d5, i6 | 0, +d7, +d8);
}

function __ZN7maxiMap6explinEddddd(d1, d2, d3, d4, d5) {
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 var d6 = 0.0;
 d6 = d3 < d1 ? d3 : d1;
 return +((d5 - d4) * (+Math_log(+((d6 < d2 ? d2 : d6) / d2)) / +Math_log(+(d3 / d2))) + d4);
}

function _bitshift64Ashr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i3 | 0) < 32) {
  tempRet0 = i2 >> i3;
  return i1 >>> i3 | (i2 & (1 << i3) - 1) << 32 - i3;
 }
 tempRet0 = (i2 | 0) < 0 ? -1 : 0;
 return i2 >> i3 - 32 | 0;
}

function _wmemset(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (i3) {
  i4 = i3;
  i3 = i1;
  while (1) {
   i4 = i4 + -1 | 0;
   HEAP32[i3 >> 2] = i2;
   if (!i4) break; else i3 = i3 + 4 | 0;
  }
 }
 return i1 | 0;
}

function b34(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 abort(34);
 return 0;
}

function dynCall_diiddddd(i1, i2, i3, d4, d5, d6, d7, d8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 d8 = +d8;
 return +FUNCTION_TABLE_diiddddd[i1 & 1](i2 | 0, i3 | 0, +d4, +d5, +d6, +d7, +d8);
}

function dynCall_iiiiiid(i1, i2, i3, i4, i5, i6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 d7 = +d7;
 return FUNCTION_TABLE_iiiiiid[i1 & 3](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, +d7) | 0;
}

function __ZNKSt3__112__do_message7messageEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = _strerror(i3) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
 return;
}

function dynCall_viididdd(i1, i2, i3, d4, i5, d6, d7, d8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 d8 = +d8;
 FUNCTION_TABLE_viididdd[i1 & 1](i2 | 0, i3 | 0, +d4, i5 | 0, +d6, +d7, +d8);
}

function _sscanf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vsscanf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i1, i2, _wcslen(i2) | 0) | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i1, i2, _strlen(i2) | 0) | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i2, _strlen(i2) | 0) | 0;
}

function __ZN10emscripten8internal12VectorAccessINSt3__16vectorIdNS2_9allocatorIdEEEEE3setERS6_jRKd(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAPF64[(HEAP32[i1 >> 2] | 0) + (i2 << 3) >> 3] = +HEAPF64[i3 >> 3];
 return 1;
}

function _printf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _vfprintf(HEAP32[4917] | 0, i1, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function dynCall_viiiiii(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 FUNCTION_TABLE_viiiiii[i1 & 7](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function __ZN7maxiMap6linexpEddddd(d1, d2, d3, d4, d5) {
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 var d6 = 0.0;
 d6 = d3 < d1 ? d3 : d1;
 return +(+Math_pow(+(d5 / d4), +(((d6 < d2 ? d2 : d6) - d2) / (d3 - d2))) * d4);
}

function __ZN10emscripten8internal12VectorAccessINSt3__16vectorIiNS2_9allocatorIiEEEEE3setERS6_jRKi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i3 >> 2];
 return 1;
}

function _bitshift64Shl(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i3 | 0) < 32) {
  tempRet0 = i2 << i3 | (i1 & (1 << i3) - 1 << 32 - i3) >>> 32 - i3;
  return i1 << i3;
 }
 tempRet0 = i1 << i3 - 32;
 return 0;
}

function dynCall_diididi(i1, i2, i3, d4, i5, d6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 return +FUNCTION_TABLE_diididi[i1 & 1](i2 | 0, i3 | 0, +d4, i5 | 0, +d6, i7 | 0);
}

function __ZN10emscripten8internal12operator_newINSt3__16vectorIiNS2_9allocatorIiEEEEJEEEPT_DpOT0_() {
 var i1 = 0;
 i1 = __Znwj(12) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return i1 | 0;
}

function __ZN10emscripten8internal12operator_newINSt3__16vectorIdNS2_9allocatorIdEEEEJEEEPT_DpOT0_() {
 var i1 = 0;
 i1 = __Znwj(12) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return i1 | 0;
}

function _bitshift64Lshr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i3 | 0) < 32) {
  tempRet0 = i2 >>> i3;
  return i1 >>> i3 | (i2 & (1 << i3) - 1) << 32 - i3;
 }
 tempRet0 = 0;
 return i2 >>> i3 - 32 | 0;
}

function __ZNKSt3__18ios_base6getlocEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 __ZNSt3__16localeC2ERKS0_(i3, i1 + 28 | 0);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_110construct_Ev() {
 var i1 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if (!(_pthread_key_create(19400, 281) | 0)) {
  STACKTOP = i1;
  return;
 } else _abort_message(40302, i1);
}

function __ZNSt3__16locale5__imp11make_globalEv() {
 var i1 = 0, i2 = 0;
 i1 = __ZNSt3__16locale7classicEv() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[6837] = i2;
 __ZNSt3__114__shared_count12__add_sharedEv(i2);
 return 27348;
}

function dynCall_didddii(i1, i2, d3, d4, d5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return +FUNCTION_TABLE_didddii[i1 & 1](i2 | 0, +d3, +d4, +d5, i6 | 0, i7 | 0);
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i4 - i3 | 0;
 return (i2 >>> 0 < i5 >>> 0 ? i2 : i5) | 0;
}

function __ZNSt3__18ios_base33__set_badbit_and_consider_rethrowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
 if (!(HEAP32[i1 + 20 >> 2] & 1)) return; else ___cxa_rethrow();
}

function __ZN10emscripten8internal15FunctionInvokerIPFiiiiEiiJiiEE6invokeEPS3_iii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return FUNCTION_TABLE_iiii[HEAP32[i1 >> 2] & 63](i2, i3, i4) | 0;
}

function __ZNSt3__16locale5__imp7installINS_7codecvtIDsc11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26704) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_7codecvtIDic11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26712) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_7codecvtIwc11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26648) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_7codecvtIcc11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26640) | 0);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function dynCall_iiiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return FUNCTION_TABLE_iiiiii[i1 & 31](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
}

function dynCall_dididdd(i1, i2, d3, i4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 return +FUNCTION_TABLE_dididdd[i1 & 3](i2 | 0, +d3, i4 | 0, +d5, +d6, +d7);
}

function dynCall_diddidd(i1, i2, d3, d4, i5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 return +FUNCTION_TABLE_diddidd[i1 & 1](i2 | 0, +d3, +d4, i5 | 0, +d6, +d7);
}

function ___strdup(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = (_strlen(i1) | 0) + 1 | 0;
 i3 = _malloc(i2) | 0;
 if (!i3) i4 = 0; else {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i4 = i3;
 }
 return i4 | 0;
}

function __ZNKSt3__16locale9use_facetERNS0_2idE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 return __ZNKSt3__16locale5__imp9use_facetEl(i3, __ZNSt3__16locale2id5__getEv(i2) | 0) | 0;
}

function __ZNKSt3__114error_category10equivalentERKNS_10error_codeEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ((HEAP32[i2 >> 2] | 0) == (i3 | 0) ? (HEAP32[i2 + 4 >> 2] | 0) == (i1 | 0) : 0) | 0;
}

function dynCall_viididd(i1, i2, i3, d4, i5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 FUNCTION_TABLE_viididd[i1 & 1](i2 | 0, i3 | 0, +d4, i5 | 0, +d6, +d7);
}

function __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26316) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26252) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26188) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26124) | 0);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function dynCall_diddddd(i1, i2, d3, d4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 return +FUNCTION_TABLE_diddddd[i1 & 3](i2 | 0, +d3, +d4, +d5, +d6, +d7);
}

function __ZNSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function dynCall_iiiiid(i1, i2, i3, i4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 return FUNCTION_TABLE_iiiiid[i1 & 7](i2 | 0, i3 | 0, i4 | 0, i5 | 0, +d6) | 0;
}

function __ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function dynCall_vididdd(i1, i2, d3, i4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 FUNCTION_TABLE_vididdd[i1 & 1](i2 | 0, +d3, i4 | 0, +d5, +d6, +d7);
}

function b18(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 abort(18);
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI20maxiEnvelopeFollowerEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZNSt3__16locale5__imp7installINS_8numpunctIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26728) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_8numpunctIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26720) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_8messagesIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26540) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_8messagesIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26500) | 0);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__16locale5__imp7installINS_7collateIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(25548) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_7collateIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(25508) | 0);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function dynCall_viiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 FUNCTION_TABLE_viiiii[i1 & 3](i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
}

function __ZNSt3__119__shared_weak_count16__release_sharedEv(i1) {
 i1 = i1 | 0;
 if (__ZNSt3__114__shared_count16__release_sharedEv(i1) | 0) __ZNSt3__119__shared_weak_count14__release_weakEv(i1);
 return;
}

function __ZNKSt3__18numpunctIwE12do_falsenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, 27376, _wcslen(27376) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_5ctypeIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26572) | 0);
 return;
}

function __ZNSt3__16locale5__imp7installINS_5ctypeIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__16locale2id5__getEv(26580) | 0);
 return;
}

function __ZNKSt3__18numpunctIwE11do_truenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, 27356, _wcslen(27356) | 0);
 return;
}

function __ZN14maxiDistortion12fastAtanDistEdd(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 var d4 = 0.0;
 d4 = d2 * d3;
 return +(1.0 / (d3 / (d3 * d3 * .28 + 1.0)) * (d4 / (d4 * d4 * .28 + 1.0)));
}

function __ZN10maxiLagExpIdE9addSampleEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0;
 i3 = i1 + 16 | 0;
 HEAPF64[i3 >> 3] = +HEAPF64[i1 >> 3] * d2 + +HEAPF64[i1 + 8 >> 3] * +HEAPF64[i3 >> 3];
 return;
}

function __ZN20maxiEnvelopeFollower10setReleaseEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var d3 = 0.0;
 d3 = +Math_pow(.01, +(1.0 / (+(HEAP32[4327] | 0) * d2 * .001)));
 HEAPF64[i1 + 8 >> 3] = d3;
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI14maxiDistortionEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function dynCall_diidid(i1, i2, i3, d4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 return +FUNCTION_TABLE_diidid[i1 & 1](i2 | 0, i3 | 0, +d4, i5 | 0, +d6);
}

function dynCall_dididi(i1, i2, d3, i4, d5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 return +FUNCTION_TABLE_dididi[i1 & 1](i2 | 0, +d3, i4 | 0, +d5, i6 | 0);
}

function __ZNSt3__15ctypeIcED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 26596;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) != 0 ? (HEAP8[i1 + 12 >> 0] | 0) != 0 : 0) __ZdaPv(i2);
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI13maxiDelaylineEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiLagExpIdEEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function _i64Add(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = i1 + i3 >>> 0;
 return (tempRet0 = i2 + i4 + (i5 >>> 0 < i1 >>> 0 | 0) >>> 0, i5 | 0) | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI12maxiEnvelopeEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZNKSt3__110moneypunctIwLb1EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIwLb1EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI11maxiFlangerEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function ___syscall_ret(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (i1 >>> 0 > 4294963200) {
  i2 = ___errno_location() | 0;
  HEAP32[i2 >> 2] = 0 - i1;
  i3 = -1;
 } else i3 = i1;
 return i3 | 0;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiSampleEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiFilterEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiChorusEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZN20maxiEnvelopeFollower9setAttackEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var d3 = 0.0;
 d3 = +Math_pow(.01, +(1.0 / (+(HEAP32[4327] | 0) * d2 * .001)));
 HEAPF64[i1 >> 3] = d3;
 return;
}

function dynCall_diiddd(i1, i2, i3, d4, d5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 return +FUNCTION_TABLE_diiddd[i1 & 3](i2 | 0, i3 | 0, +d4, +d5, +d6);
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI8maxiTestEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, 1, 45);
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, 1, 45);
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, 1, 45);
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, 1, 45);
 return;
}

function __ZN10emscripten8internal7InvokerIvJiiiEE6invokeEPFviiiEiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 FUNCTION_TABLE_viii[i1 & 15](i2, i3, i4);
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiOscEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMixEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMapEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiEnvEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiDynEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7convertEEE14construct_nullEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function dynCall_viidid(i1, i2, i3, d4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 FUNCTION_TABLE_viidid[i1 & 1](i2 | 0, i3 | 0, +d4, i5 | 0, +d6);
}

function __ZNSt3__16localeC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 __ZNSt3__114__shared_count12__add_sharedEv(i3);
 return;
}

function dynCall_iiiii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return FUNCTION_TABLE_iiiii[i1 & 31](i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function __ZNKSt3__18numpunctIcE12do_falsenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 47699, 5);
 return;
}

function dynCall_vididd(i1, i2, d3, i4, d5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 FUNCTION_TABLE_vididd[i1 & 1](i2 | 0, +d3, i4 | 0, +d5, +d6);
}

function __ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 4) | 0);
 return;
}

function __ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 4) | 0);
 return;
}

function __ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 8) | 0);
 return;
}

function __ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 8) | 0);
 return;
}

function __ZNKSt3__18numpunctIcE11do_truenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 47694, 4);
 return;
}

function b42(i1, i2, d3, d4, d5, d6, d7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 i8 = i8 | 0;
 i9 = i9 | 0;
 abort(42);
 return 0.0;
}

function __ZNKSt3__18numpunctIwE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 16 | 0);
 return;
}

function __ZNKSt3__18numpunctIcE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 12 | 0);
 return;
}

function dynCall_diiii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return +FUNCTION_TABLE_diiii[i1 & 1](i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function __ZN12maxiEnvelope7triggerEid(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 HEAP32[i1 + 40 >> 2] = 1;
 HEAP32[i1 + 44 >> 2] = i2;
 HEAPF64[i1 + 48 >> 3] = d3;
 return;
}

function __ZN10emscripten8internal7InvokerIvJRNSt3__16vectorIdNS2_9allocatorIdEEEEEE6invokeEPFvS7_EPS6_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 FUNCTION_TABLE_vi[i1 & 511](i2);
 return;
}

function dynCall_dddddd(i1, d2, d3, d4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 return +FUNCTION_TABLE_dddddd[i1 & 3](+d2, +d3, +d4, +d5, +d6);
}

function dynCall_iiiid(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 return FUNCTION_TABLE_iiiid[i1 & 1](i2 | 0, i3 | 0, i4 | 0, +d5) | 0;
}

function ___errno_location() {
 var i1 = 0, i2 = 0;
 if (!(HEAP32[4853] | 0)) i1 = 19688; else {
  i2 = (_pthread_self() | 0) + 60 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 return i1 | 0;
}

function __ZN7maxiMap5clampEiii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = (i1 | 0) < (i3 | 0) ? i1 : i3;
 return ((i4 | 0) > (i2 | 0) ? i4 : i2) | 0;
}

function __ZN10maxiLagExpIdE4initEdd(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 HEAPF64[i1 >> 3] = d2;
 HEAPF64[i1 + 8 >> 3] = 1.0 - d2;
 HEAPF64[i1 + 16 >> 3] = d3;
 return;
}

function b54(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 abort(54);
 return 0;
}

function __ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function _wcslen(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1;
 while (1) if (!(HEAP32[i2 >> 2] | 0)) {
  i3 = i2;
  break;
 } else i2 = i2 + 4 | 0;
 return i3 - i1 >> 2 | 0;
}

function __ZNK10__cxxabiv123__fundamental_type_info9can_catchEPKNS_16__shim_type_infoERPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (i1 | 0) == (i2 | 0) | 0;
}

function dynCall_viiii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 FUNCTION_TABLE_viiii[i1 & 31](i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function __ZNKSt3__114error_category23default_error_conditionEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIwLb1EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNSt3__18numpunctIwED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 26784;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 16 | 0);
 return;
}

function __ZNSt3__18numpunctIcED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 26744;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
 return;
}

function dynCall_diidd(i1, i2, i3, d4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 return +FUNCTION_TABLE_diidd[i1 & 3](i2 | 0, i3 | 0, +d4, +d5);
}

function dynCall_didid(i1, i2, d3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 return +FUNCTION_TABLE_didid[i1 & 1](i2 | 0, +d3, i4 | 0, +d5);
}

function _uselocale(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = (_pthread_self() | 0) + 176 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i1) HEAP32[i2 >> 2] = i1;
 return i3 | 0;
}

function dynCall_viiid(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 FUNCTION_TABLE_viiid[i1 & 3](i2 | 0, i3 | 0, i4 | 0, +d5);
}

function __ZN10maxiSample4playEddd(i1, d2, d3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 return +(+__ZN10maxiSample4playEdddRd(i1, d2, d3, d4, i1 + 40 | 0));
}

function b14(i1, d2, d3, d4, d5, d6, i7, i8) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 i7 = i7 | 0;
 i8 = i8 | 0;
 abort(14);
 return 0.0;
}

function __ZNSt3__120__shared_ptr_emplaceI20maxiEnvelopeFollowerNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 25184;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 25120;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function dynCall_diddd(i1, i2, d3, d4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 return +FUNCTION_TABLE_diddd[i1 & 7](i2 | 0, +d3, +d4, +d5);
}

function __ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__110__time_putD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__110__time_putD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function dynCall_viidd(i1, i2, i3, d4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 FUNCTION_TABLE_viidd[i1 & 1](i2 | 0, i3 | 0, +d4, +d5);
}

function dynCall_vidid(i1, i2, d3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 FUNCTION_TABLE_vidid[i1 & 1](i2 | 0, +d3, i4 | 0, +d5);
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 >> 0] & 1) __ZdlPv(HEAP32[i1 + 8 >> 2] | 0);
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 >> 0] & 1) __ZdlPv(HEAP32[i1 + 8 >> 2] | 0);
 return;
}

function __ZN7maxiOsc5noiseEv(i1) {
 i1 = i1 | 0;
 var d2 = 0.0;
 d2 = +(_rand() | 0) * 4.656612873077393e-10 * 2.0 + -1.0;
 HEAPF64[i1 + 32 >> 3] = d2;
 return +d2;
}

function __ZN7maxiMap6linlinEddddd(d1, d2, d3, d4, d5) {
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 return +((d5 - d4) * ((d1 - d2) / (d3 - d2)) + d4);
}

function __ZNSt3__120__shared_ptr_emplaceI14maxiDistortionNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12maxiSettings5setupEiii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[4327] = i1;
 HEAP32[4328] = i2;
 HEAP32[4329] = i3;
 return;
}

function dynCall_iiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return FUNCTION_TABLE_iiii[i1 & 63](i2 | 0, i3 | 0, i4 | 0) | 0;
}

function b0(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 abort(0);
 return 0;
}

function ___cxa_is_pointer_type(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i2 = 0; else i2 = (___dynamic_cast(i1, 14968, 15016, 0) | 0) != 0;
 return i2 & 1 | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI13maxiDelaylineNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiLagExpIdENS_9allocatorIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI12maxiEnvelopeNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__16locale5facet16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 return;
}

function __ZNSt3__16locale2id6__initEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[6642] | 0;
 HEAP32[6642] = i2 + 1;
 HEAP32[i1 + 4 >> 2] = i2 + 1;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI11maxiFlangerNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal7InvokerIPNSt3__16vectorIiNS2_9allocatorIiEEEEJEE6invokeEPFS7_vE(i1) {
 i1 = i1 | 0;
 return FUNCTION_TABLE_i[i1 & 31]() | 0;
}

function __ZN10emscripten8internal7InvokerIPNSt3__16vectorIdNS2_9allocatorIdEEEEJEE6invokeEPFS7_vE(i1) {
 i1 = i1 | 0;
 return FUNCTION_TABLE_i[i1 & 31]() | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiFilterNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiChorusNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function dynCall_diii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return +FUNCTION_TABLE_diii[i1 & 7](i2 | 0, i3 | 0, i4 | 0);
}

function __ZNSt3__114__shared_count12__add_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function b40(i1, i2, d3, d4, d5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 i6 = i6 | 0;
 i7 = i7 | 0;
 abort(40);
 return 0.0;
}

function __ZNSt3__120__shared_ptr_emplaceI8maxiTestNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function _isxdigit(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((i1 + -48 | 0) >>> 0 < 10) i2 = 1; else i2 = ((i1 | 32) + -97 | 0) >>> 0 < 6;
 return i2 & 1 | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiOscNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiMixNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiMapNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiEnvNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiDynNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7convertNS_9allocatorIS1_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_countD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 25184;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 25120;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 return;
}

function b23(i1, i2, d3, d4, i5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 abort(23);
 return 0.0;
}

function __ZSt17__throw_bad_allocv() {
 var i1 = 0;
 i1 = ___cxa_allocate_exception(4) | 0;
 __ZNSt9bad_allocC2Ev(i1);
 ___cxa_throw(i1 | 0, 14872, 115);
}

function __ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__110__time_putD2Ev(i1 + 8 | 0);
 return;
}

function __ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__110__time_putD2Ev(i1 + 8 | 0);
 return;
}

function b33(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 abort(33);
}

function _strtoll(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = _strtox530(i1, i2, i3, 0, -2147483648) | 0;
 return i4 | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI20maxiEnvelopeFollowerNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function dynCall_diid(i1, i2, i3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 return +FUNCTION_TABLE_diid[i1 & 7](i2 | 0, i3 | 0, +d4);
}

function b7(i1, i2, d3, i4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 abort(7);
 return 0.0;
}

function dynCall_viii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 FUNCTION_TABLE_viii[i1 & 15](i2 | 0, i3 | 0, i4 | 0);
}

function b38(i1, i2, d3, d4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 abort(38);
 return 0.0;
}

function __ZN14maxiDistortion8atanDistEdd(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 return +(1.0 / +Math_atan(+d3) * +Math_atan(+(d2 * d3)));
}
function stackAlloc(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + i1 | 0;
 STACKTOP = STACKTOP + 15 & -16;
 return i2 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI20maxiEnvelopeFollowerEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI14maxiDistortionNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function dynCall_didd(i1, i2, d3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 return +FUNCTION_TABLE_didd[i1 & 7](i2 | 0, +d3, +d4);
}

function _strtoull(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = _strtox530(i1, i2, i3, -1, -1) | 0;
 return i4 | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI13maxiDelaylineNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiLagExpIdENS_9allocatorIS2_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI12maxiEnvelopeNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__15ctypeIwE9do_narrowEwc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (i2 >>> 0 < 128 ? i2 & 255 : i3) | 0;
}

function dynCall_viid(i1, i2, i3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 FUNCTION_TABLE_viid[i1 & 7](i2 | 0, i3 | 0, +d4);
}

function b6(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 abort(6);
 return 0;
}

function _strtoull_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = _strtoull(i1, i2, i3) | 0;
 return i4 | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI11maxiFlangerNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__111__stdoutbufIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__111__stdoutbufIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__15ctypeIcE9do_narrowEcc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (i2 << 24 >> 24 > -1 ? i2 : i3) | 0;
}

function b12(i1, i2, i3, i4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 abort(12);
 return 0;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiSampleNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiFilterNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiChorusNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i1 | 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6setbufEPci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i1 | 0;
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__110__stdinbufIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__110__stdinbufIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt13runtime_errorD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 19172;
 __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev(i1 + 4 | 0);
 return;
}

function __ZNKSt3__16vectorIiNS_9allocatorIiEEE4sizeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) >> 2 | 0;
}

function __ZNKSt3__16vectorIdNS_9allocatorIdEEE4sizeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) >> 3 | 0;
}

function _strtoll_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = _strtoll(i1, i2, i3) | 0;
 return i4 | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI14maxiDistortionEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function b36(i1, i2, d3, i4, d5, d6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 abort(36);
}

function __ZNSt11logic_errorD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 19152;
 __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev(i1 + 4 | 0);
 return;
}

function __ZN10emscripten8internal14raw_destructorI20maxiEnvelopeFollowerEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI13maxiDelaylineEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiLagExpIdEEEE3getERKS5_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function b3(i1, i2, d3, i4, d5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 abort(3);
 return 0.0;
}

function ___udivdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return ___udivmoddi4(i1, i2, i3, i4, 0) | 0;
}

function __ZNSt3__120__shared_ptr_emplaceI8maxiTestNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI12maxiEnvelopeEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function b52(i1, d2, d3, d4, i5, i6) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 abort(52);
 return 0.0;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiOscNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiMixNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiMapNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiEnvNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiDynNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7convertNS_9allocatorIS1_EEE21__on_zero_shared_weakEv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI11maxiFlangerEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function dynCall_vidd(i1, i2, d3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 FUNCTION_TABLE_vidd[i1 & 1](i2 | 0, +d3, +d4);
}

function __ZNSt3__17codecvtIwc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__17codecvtIwc11__mbstate_tED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1) {
 i1 = i1 | 0;
 ___assert_fail(40405, 40434, 1164, 40113);
}

function __ZN10emscripten8internal7InvokerIP12maxiSettingsJEE6invokeEPFS3_vE(i1) {
 i1 = i1 | 0;
 return FUNCTION_TABLE_i[i1 & 31]() | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiSampleEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiFilterEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiChorusEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function _wctomb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i3 = 0; else i3 = _wcrtomb(i1, i2, 0) | 0;
 return i3 | 0;
}

function __ZN10emscripten8internal7InvokerIP11vectorToolsJEE6invokeEPFS3_vE(i1) {
 i1 = i1 | 0;
 return FUNCTION_TABLE_i[i1 & 31]() | 0;
}

function b49(i1, d2, i3, d4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 abort(49);
 return 0.0;
}

function __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1) {
 i1 = i1 | 0;
 ___assert_fail(39984, 40007, 303, 40113);
}

function b25(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 abort(25);
}

function __ZN10emscripten8internal14raw_destructorI14maxiDistortionEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI8maxiTestEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function dynCall_iii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return FUNCTION_TABLE_iii[i1 & 63](i2 | 0, i3 | 0) | 0;
}

function b1(i1, d2, d3, i4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 abort(1);
 return 0.0;
}

function _mbrlen(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _mbrtowc(0, i1, i2, (i3 | 0) != 0 ? i3 : 19724) | 0;
}

function __ZNSt3__16localeD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI20maxiEnvelopeFollowerNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10emscripten8internal14raw_destructorI13maxiDelaylineEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI10maxiLagExpIdEEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiOscEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMixEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMapEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiEnvEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiDynEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7convertEEE3getERKS4_(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function b20(i1, d2, d3, d4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 abort(20);
 return 0.0;
}

function __ZN10emscripten8internal14raw_destructorI12maxiSettingsEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI12maxiEnvelopeEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI11vectorToolsEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI11maxiFlangerEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__16locale5__imp12make_classicEv() {
 __ZNSt3__16locale5__impC2Ej(16728, 1);
 HEAP32[6835] = 16728;
 return 27340;
}

function __ZN10emscripten8internal14raw_destructorI10maxiFilterEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI10maxiChorusEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function dynCall_dii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return +FUNCTION_TABLE_dii[i1 & 7](i2 | 0, i3 | 0);
}

function __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal13getActualTypeINSt3__16vectorIiNS2_9allocatorIiEEEEEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13192;
}

function __ZN10emscripten8internal13getActualTypeINSt3__16vectorIdNS2_9allocatorIdEEEEEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13280;
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + 4 | 0);
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + 4 | 0);
 return;
}

function __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + 8 | 0);
 return;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1 + 8 | 0);
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function b17(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 abort(17);
 return 0;
}

function __ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI14maxiDistortionNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10emscripten8internal14raw_destructorI8maxiTestEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function _mbsinit(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i2 = 1; else i2 = (HEAP32[i1 >> 2] | 0) == 0;
 return i2 & 1 | 0;
}

function __ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI13maxiDelaylineNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiLagExpIdENS_9allocatorIS2_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN10emscripten8internal14raw_destructorI7maxiOscEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI7maxiMixEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI7maxiMapEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI7maxiEnvEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI7maxiDynEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal14raw_destructorI7convertEEvPT_(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function b55(i1, i2, d3, i4, d5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 abort(55);
}

function __ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI12maxiEnvelopeNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __GLOBAL__I_000101() {
 __ZNSt3__18ios_base4InitC2Ev(0);
 ___cxa_atexit(284, 45464, ___dso_handle | 0) | 0;
 return;
}

function dynCall_did(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 return +FUNCTION_TABLE_did[i1 & 15](i2 | 0, +d3);
}

function b47(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 abort(47);
 return 0;
}

function __ZNSt3__120__shared_ptr_emplaceI11maxiFlangerNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__110__stdinbufIwE9underflowEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__110__stdinbufIwE9__getcharEb(i1, 0) | 0;
}

function __ZNSt3__110__stdinbufIcE9underflowEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__110__stdinbufIcE9__getcharEb(i1, 0) | 0;
}

function dynCall_vii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 FUNCTION_TABLE_vii[i1 & 127](i2 | 0, i3 | 0);
}

function b56(i1, d2, i3, d4, i5) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 abort(56);
 return 0.0;
}

function b32(i1, i2, d3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 abort(32);
 return 0.0;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiFilterNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI10maxiChorusNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function b10(i1, d2, i3, d4, d5, d6) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 abort(10);
}

function __emval_take_value__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __emval_take_value(i1 | 0, i2 | 0) | 0;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function b29(i1, i2, d3, d4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 abort(29);
 return 0.0;
}

function __ZNSt3__120__shared_ptr_emplaceI8maxiTestNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE8overflowEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE8overflowEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function __ZNSt3__110__stdinbufIwE5uflowEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__110__stdinbufIwE9__getcharEb(i1, 1) | 0;
}

function __ZNSt3__110__stdinbufIcE5uflowEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__110__stdinbufIcE9__getcharEb(i1, 1) | 0;
}

function __ZNKSt3__119__shared_weak_count13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiOscNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiMixNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiMapNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiEnvNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7maxiDynNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__120__shared_ptr_emplaceI7convertNS_9allocatorIS1_EEE16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8maxiTest8sumArrayEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return HEAP32[i2 >> 2] | 0;
}

function __ZNSt3__18ios_base7failureD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__112system_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function b15(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 abort(15);
}

function __ZN12maxiEnvelope12SetAmplitudeEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 HEAPF64[i1 + 48 >> 3] = d2;
 return;
}

function dynCall_vid(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 FUNCTION_TABLE_vid[i1 & 7](i2 | 0, +d3);
}

function __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1);
 return;
}

function __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1);
 return;
}

function __ZN10emscripten8internal13getActualTypeI20maxiEnvelopeFollowerEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 14616;
}

function __GLOBAL__sub_I_bind_cpp() {
 __ZN53EmscriptenBindingInitializer_native_and_builtin_typesC2Ev(0);
 return;
}

function setThrew(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!__THREW__) {
  __THREW__ = i1;
  threwValue = i2;
 }
}

function b24(d1, d2, d3, d4, d5) {
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 abort(24);
 return 0.0;
}

function __ZN7maxiOsc4rectEdd(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 return +(+HEAPF64[i1 + 32 >> 3]);
}

function __ZN14maxiDistortion8fastatanEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 return +(d2 / (d2 * d2 * .28 + 1.0));
}

function _do_read(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ___string_read(i1, i2, i3) | 0;
}

function __ZSt15get_new_handlerv() {
 var i1 = 0;
 i1 = HEAP32[4785] | 0;
 HEAP32[4785] = i1 + 0;
 return i1 | 0;
}

function __ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__16locale5__impD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__16locale5__impD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__112system_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function b26(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 abort(26);
 return 0.0;
}

function __ZNSt3__18numpunctIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18numpunctIwED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__18numpunctIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18numpunctIcED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7convert4mtofEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return +(+HEAPF64[12128 + (i2 << 3) >> 3]);
}

function b51(i1, i2, d3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 abort(51);
}

function b48(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 abort(48);
 return 0;
}

function __ZNSt13runtime_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN10emscripten8internal13getActualTypeI14maxiDistortionEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 14376;
}

function __ZN10emscripten8internal13getActualTypeI13maxiDelaylineEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13656;
}

function __ZN10emscripten8internal13getActualTypeI10maxiLagExpIdEEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13896;
}

function b16(i1, d2, i3, d4, d5) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 abort(16);
}

function _strtold_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return +(+_strtox(i1, i2, 2));
}

function _catgets(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return i4 | 0;
}

function __ZN7maxiOsc10phaseResetEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 HEAPF64[i1 + 8 >> 3] = d2;
 return;
}

function __ZN10emscripten8internal13getActualTypeI12maxiSettingsEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13456;
}

function __ZN10emscripten8internal13getActualTypeI12maxiEnvelopeEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13576;
}

function dynCall_ii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return FUNCTION_TABLE_ii[i1 & 255](i2 | 0) | 0;
}

function b57(i1, i2, i3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 abort(57);
 return 0;
}

function _pthread_cond_broadcast__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_cond_broadcast(i1 | 0) | 0;
}

function ___clang_call_terminate(i1) {
 i1 = i1 | 0;
 ___cxa_begin_catch(i1 | 0) | 0;
 __ZSt9terminatev();
}

function __ZNSt12out_of_rangeD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__18numpunctIwE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNKSt3__15ctypeIwE8do_widenEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 << 24 >> 24 | 0;
}

function __ZN10emscripten8internal13getActualTypeI11vectorToolsEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13336;
}

function __ZN10emscripten8internal13getActualTypeI11maxiFlangerEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 14456;
}

function __GLOBAL__sub_I_maxi_emscr_cpp() {
 __ZN38EmscriptenBindingInitializer_my_moduleC2Ev(0);
 return;
}

function b43(i1, i2, d3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 abort(43);
 return 0.0;
}

function b35(i1, d2, i3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 abort(35);
 return 0.0;
}

function __ZNSt3__18ios_baseD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__18ios_baseD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__15ctypeIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__15ctypeIcED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt11logic_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__18numpunctIwE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZN10emscripten8internal13getActualTypeI10maxiSampleEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13976;
}

function __ZN10emscripten8internal13getActualTypeI10maxiFilterEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13736;
}

function __ZN10emscripten8internal13getActualTypeI10maxiChorusEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 14536;
}

function __ZNSt3__18ios_base7failureD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__112system_errorD2Ev(i1);
 return;
}

function __ZNKSt3__18numpunctIcE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 9 >> 0] | 0;
}

function __ZNKSt3__18numpunctIcE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 8 >> 0] | 0;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9underflowEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9underflowEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZN10emscripten8internal12operator_newI12maxiSettingsJEEEPT_DpOT0_() {
 return __Znwj(1) | 0;
}

function _pthread_mutex_unlock__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_mutex_unlock(i1 | 0) | 0;
}

function _cleanup392(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 68 >> 2] | 0)) ___unlockfile(i1);
 return;
}

function _cleanup387(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 68 >> 2] | 0)) ___unlockfile(i1);
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9showmanycEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9showmanycEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN20maxiEnvelopeFollower5resetEv(i1) {
 i1 = i1 | 0;
 HEAPF64[i1 + 16 >> 3] = 0.0;
 return;
}

function __ZN10emscripten8internal13getActualTypeI8maxiTestEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13376;
}

function __ZN10emscripten8internal12operator_newI11vectorToolsJEEEPT_DpOT0_() {
 return __Znwj(1) | 0;
}

function dynCall_di(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return +FUNCTION_TABLE_di[i1 & 7](i2 | 0);
}

function __ZN10emscripten8internal13getActualTypeI7maxiOscEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13496;
}

function __ZN10emscripten8internal13getActualTypeI7maxiMixEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 13816;
}

function __ZN10emscripten8internal13getActualTypeI7maxiMapEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 14056;
}

function __ZN10emscripten8internal13getActualTypeI7maxiEnvEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 14216;
}

function __ZN10emscripten8internal13getActualTypeI7maxiDynEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 14136;
}

function __ZN10emscripten8internal13getActualTypeI7convertEEPKvPT_(i1) {
 i1 = i1 | 0;
 return 14296;
}

function b8(i1, d2, d3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 abort(8);
 return 0.0;
}

function establishStackSpace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 STACKTOP = i1;
 STACK_MAX = i2;
}

function __ZNKSt3__110moneypunctIwLb1EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNKSt3__110moneypunctIwLb1EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNKSt3__110moneypunctIwLb0EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNKSt3__110moneypunctIwLb0EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNK12maxiEnvelope12GetAmplitudeEv(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 + 48 >> 3]);
}

function __ZN10maxiSample7isReadyEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 84 >> 2] | 0) > 0 | 0;
}

function b58(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 abort(58);
}

function _pthread_mutex_lock__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_mutex_lock(i1 | 0) | 0;
}

function __ZNSt3__112system_errorD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 return;
}

function _isspace(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) == 32 | (i1 + -9 | 0) >>> 0 < 5) & 1 | 0;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE4syncEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE4syncEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN10__cxxabiv123__fundamental_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function dynCall_vi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 FUNCTION_TABLE_vi[i1 & 511](i2 | 0);
}

function b50(i1, i2, i3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 abort(50);
}
function _isdigit_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i1 + -48 | 0) >>> 0 < 10 | 0;
}

function __ZN10__cxxabiv121__vmi_class_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNKSt3__15ctypeIcE8do_widenEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 | 0;
}

function __ZN10maxiSample7triggerEv(i1) {
 i1 = i1 | 0;
 HEAPF64[i1 + 40 >> 3] = 0.0;
 return;
}

function __ZN10__cxxabiv120__si_class_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function b39(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 abort(39);
 return 0.0;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN10__cxxabiv119__pointer_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function b13(i1, i2, d3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 abort(13);
}

function b11(i1, d2, i3, d4) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 abort(11);
}

function __ZNSt3__17codecvtIDsc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__17codecvtIDic11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__117__widen_from_utf8ILj32EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__110moneypunctIcLb1EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNKSt3__110moneypunctIcLb1EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNKSt3__110moneypunctIcLb0EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNKSt3__110moneypunctIcLb0EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function b22(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 abort(22);
 return 0;
}

function ___getTypeName(i1) {
 i1 = i1 | 0;
 return ___strdup(HEAP32[i1 + 4 >> 2] | 0) | 0;
}

function __ZNSt3__17codecvtIcc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__116__narrow_to_utf8ILj32EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNKSt13runtime_error4whatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN10maxiSample9getLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZN10maxiLagExpIdE5valueEv(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 + 16 >> 3]);
}

function __ZN10__cxxabiv117__class_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function b31(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 abort(31);
 return 0.0;
}

function __ZNKSt3__18messagesIwE8do_closeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNKSt3__18messagesIcE8do_closeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNKSt11logic_error4whatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNKSt3__110moneypunctIwLb1EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__110moneypunctIwLb0EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__110moneypunctIcLb1EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__110moneypunctIcLb0EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function b41(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 abort(41);
 return 0.0;
}

function __ZNSt3__119__iostream_categoryD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function _isxdigit_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _isxdigit(i1) | 0;
}

function __ZNSt3__110moneypunctIwLb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__110moneypunctIwLb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__110moneypunctIcLb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__110moneypunctIcLb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt9bad_allocC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 19128;
 return;
}

function __ZNSt8bad_castC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 19212;
 return;
}

function __ZNKSt3__119__iostream_category4nameEv(i1) {
 i1 = i1 | 0;
 return 46116;
}

function _copysignl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_copysign(d1, d2));
}

function _scalbnl(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 return +(+_scalbn(d1, i2));
}

function __ZNK10__cxxabiv116__shim_type_info5noop2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK10__cxxabiv116__shim_type_info5noop1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function b27(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 abort(27);
}

function dynCall_i(i1) {
 i1 = i1 | 0;
 return FUNCTION_TABLE_i[i1 & 31]() | 0;
}

function _frexpl(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 return +(+_frexp(d1, i2));
}

function __ZNSt3__16locale5facetD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__18messagesIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__18messagesIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function b30(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 abort(30);
}

function __emval_incref__wrapper(i1) {
 i1 = i1 | 0;
 __emval_incref(i1 | 0);
}

function __emval_decref__wrapper(i1) {
 i1 = i1 | 0;
 __emval_decref(i1 | 0);
}

function __ZNSt3__17collateIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__17collateIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10__cxxabiv116__shim_type_infoD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function b44(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 abort(44);
 return 0.0;
}

function __ZNSt3__15ctypeIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function b21(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 abort(21);
}

function _fmodl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_fmod(d1, d2));
}

function b37(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 abort(37);
 return 0;
}

function b45(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 abort(45);
 return 0.0;
}

function __ZNSt9bad_allocD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function _catopen(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1 | 0;
}

function __ZNSt8bad_castD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__110moneypunctIwLb1EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__110moneypunctIwLb0EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__110moneypunctIcLb1EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__110moneypunctIcLb0EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__114error_categoryD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__114__shared_countD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNKSt9bad_alloc4whatEv(i1) {
 i1 = i1 | 0;
 return 40183;
}

function dynCall_v(i1) {
 i1 = i1 | 0;
 FUNCTION_TABLE_v[i1 & 7]();
}

function __ZNKSt8bad_cast4whatEv(i1) {
 i1 = i1 | 0;
 return 40288;
}

function __ZNSt3__16locale5facetD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__112__do_nothingEPv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__18messagesIwED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__18messagesIcED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17collateIwED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17collateIcED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function _freelocale(i1) {
 i1 = i1 | 0;
 _free(i1);
 return;
}

function b5(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 abort(5);
}

function ___cxa_end_catch__wrapper() {
 ___cxa_end_catch();
}

function __ZdaPv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt9type_infoD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt9exceptionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt9bad_allocD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function stackRestore(i1) {
 i1 = i1 | 0;
 STACKTOP = i1;
}

function b28(i1) {
 i1 = i1 | 0;
 abort(28);
 return 0.0;
}

function b2(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 abort(2);
}

function __ZdlPv(i1) {
 i1 = i1 | 0;
 _free(i1);
 return;
}

function __ZNSt8bad_castD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function setTempRet0(i1) {
 i1 = i1 | 0;
 tempRet0 = i1;
}

function ___cxa_rethrow__wrapper() {
 ___cxa_rethrow();
}

function b9(i1) {
 i1 = i1 | 0;
 abort(9);
 return 0;
}

function ___unlockfile(i1) {
 i1 = i1 | 0;
 return;
}

function ___lockfile(i1) {
 i1 = i1 | 0;
 return 0;
}

function __GLOBAL__sub_I_iostream_cpp() {
 return;
}

function _catclose(i1) {
 i1 = i1 | 0;
 return 0;
}

function ___ctype_toupper_loc() {
 return 19684;
}

function ___ctype_tolower_loc() {
 return 19680;
}

function getTempRet0() {
 return tempRet0 | 0;
}

function stackSave() {
 return STACKTOP | 0;
}

function b4(i1) {
 i1 = i1 | 0;
 abort(4);
}

function ___ctype_b_loc() {
 return 19676;
}

function b19() {
 abort(19);
 return 0;
}

function b53() {
 abort(53);
}

// EMSCRIPTEN_END_FUNCS
var FUNCTION_TABLE_iiiiiiii = [b0,__ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc,__ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc,__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE,__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE,__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb,__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb,b0,b0,b0,b0,b0,b0,b0];
var FUNCTION_TABLE_diddidd = [b1,__ZN7maxiDyn4gateEddldd];
var FUNCTION_TABLE_vid = [b2,__ZN7maxiOsc10phaseResetEd,__ZN12maxiEnvelope12SetAmplitudeEd,__ZN10maxiLagExpIdE9addSampleEd,__ZN20maxiEnvelopeFollower9setAttackEd,__ZN20maxiEnvelopeFollower10setReleaseEd,b2,b2];
var FUNCTION_TABLE_diididi = [b3,__ZN10emscripten8internal13MethodInvokerIM13maxiDelaylineFddidiEdPS2_JdidiEE6invokeERKS4_S5_didi];
var FUNCTION_TABLE_vi = [b4,__ZNSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__114__shared_countD2Ev,__ZNSt3__120__shared_ptr_emplaceI8maxiTestNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI8maxiTestNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI8maxiTestNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI7maxiOscNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI7maxiOscNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI7maxiOscNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI12maxiEnvelopeNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI12maxiEnvelopeNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI12maxiEnvelopeNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI13maxiDelaylineNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI13maxiDelaylineNS_9allocatorIS1_EEE16__on_zero_sharedEv
,__ZNSt3__120__shared_ptr_emplaceI13maxiDelaylineNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI10maxiFilterNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI10maxiFilterNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI10maxiFilterNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI7maxiMixNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI7maxiMixNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI7maxiMixNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI10maxiLagExpIdENS_9allocatorIS2_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI10maxiLagExpIdENS_9allocatorIS2_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI10maxiLagExpIdENS_9allocatorIS2_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI10maxiSampleNS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_emplaceI10maxiSampleNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI10maxiSampleNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI10maxiSampleNS_9allocatorIS1_EEE21__on_zero_shared_weakEv
,__ZNSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI7maxiMapNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI7maxiMapNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI7maxiMapNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI7maxiDynNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI7maxiDynNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI7maxiDynNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI7maxiEnvNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI7maxiEnvNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI7maxiEnvNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI7convertNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI7convertNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI7convertNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev
,__ZNSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI14maxiDistortionNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI14maxiDistortionNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI14maxiDistortionNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI11maxiFlangerNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI11maxiFlangerNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI11maxiFlangerNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI10maxiChorusNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI10maxiChorusNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI10maxiChorusNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED2Ev,__ZNSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt3__120__shared_ptr_emplaceI20maxiEnvelopeFollowerNS_9allocatorIS1_EEED0Ev,__ZNSt3__120__shared_ptr_emplaceI20maxiEnvelopeFollowerNS_9allocatorIS1_EEE16__on_zero_sharedEv,__ZNSt3__120__shared_ptr_emplaceI20maxiEnvelopeFollowerNS_9allocatorIS1_EEE21__on_zero_shared_weakEv,__ZNSt9bad_allocD2Ev,__ZNSt9bad_allocD0Ev,__ZNSt11logic_errorD2Ev,__ZNSt11logic_errorD0Ev
,__ZNSt13runtime_errorD2Ev,__ZNSt13runtime_errorD0Ev,__ZNSt12out_of_rangeD0Ev,__ZNSt8bad_castD2Ev,__ZNSt8bad_castD0Ev,__ZN10__cxxabiv116__shim_type_infoD2Ev,__ZN10__cxxabiv123__fundamental_type_infoD0Ev,__ZNK10__cxxabiv116__shim_type_info5noop1Ev,__ZNK10__cxxabiv116__shim_type_info5noop2Ev,__ZN10__cxxabiv117__class_type_infoD0Ev,__ZN10__cxxabiv120__si_class_type_infoD0Ev,__ZN10__cxxabiv121__vmi_class_type_infoD0Ev,__ZN10__cxxabiv119__pointer_type_infoD0Ev,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev,__ZNSt3__111__stdoutbufIwED0Ev,__ZNSt3__110__stdinbufIwED0Ev,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev,__ZNSt3__111__stdoutbufIcED0Ev,__ZNSt3__110__stdinbufIcED0Ev,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED0Ev,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED0Ev,__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev,__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev,__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev,__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev,__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev,__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev
,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev,__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev,__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev,__ZNSt3__18ios_base7failureD2Ev,__ZNSt3__18ios_base7failureD0Ev,__ZNSt3__18ios_baseD2Ev,__ZNSt3__18ios_baseD0Ev,__ZNSt3__114error_categoryD2Ev,__ZNSt3__119__iostream_categoryD0Ev,__ZNSt3__17collateIcED2Ev,__ZNSt3__17collateIcED0Ev,__ZNSt3__16locale5facet16__on_zero_sharedEv,__ZNSt3__17collateIwED2Ev,__ZNSt3__17collateIwED0Ev,__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev
,__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__110moneypunctIcLb0EED2Ev,__ZNSt3__110moneypunctIcLb0EED0Ev,__ZNSt3__110moneypunctIcLb1EED2Ev,__ZNSt3__110moneypunctIcLb1EED0Ev,__ZNSt3__110moneypunctIwLb0EED2Ev,__ZNSt3__110moneypunctIwLb0EED0Ev,__ZNSt3__110moneypunctIwLb1EED2Ev,__ZNSt3__110moneypunctIwLb1EED0Ev,__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__18messagesIcED2Ev,__ZNSt3__18messagesIcED0Ev,__ZNSt3__18messagesIwED2Ev,__ZNSt3__18messagesIwED0Ev,__ZNSt3__16locale5__impD2Ev,__ZNSt3__16locale5__impD0Ev,__ZNSt3__15ctypeIcED2Ev,__ZNSt3__15ctypeIcED0Ev,__ZNSt3__17codecvtIwc11__mbstate_tED2Ev,__ZNSt3__17codecvtIwc11__mbstate_tED0Ev
,__ZNSt3__18numpunctIcED2Ev,__ZNSt3__18numpunctIcED0Ev,__ZNSt3__18numpunctIwED2Ev,__ZNSt3__18numpunctIwED0Ev,__ZNSt3__16locale5facetD2Ev,__ZNSt3__16locale5facetD0Ev,__ZNSt3__15ctypeIwED0Ev,__ZNSt3__17codecvtIcc11__mbstate_tED0Ev,__ZNSt3__17codecvtIDsc11__mbstate_tED0Ev,__ZNSt3__17codecvtIDic11__mbstate_tED0Ev,__ZNSt3__116__narrow_to_utf8ILj32EED0Ev,__ZNSt3__117__widen_from_utf8ILj32EED0Ev,__ZNSt3__112system_errorD2Ev,__ZNSt3__112system_errorD0Ev,__ZN10emscripten8internal14raw_destructorI11vectorToolsEEvPT_,__ZN11vectorTools14clearVectorDblERNSt3__16vectorIdNS0_9allocatorIdEEEE,__ZN10emscripten8internal14raw_destructorI8maxiTestEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI8maxiTestEEEEvPT_,__ZNSt3__111make_sharedI8maxiTestJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI12maxiSettingsEEvPT_,__ZN10emscripten8internal14raw_destructorI7maxiOscEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiOscEEEEvPT_,__ZNSt3__111make_sharedI7maxiOscJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI12maxiEnvelopeEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI12maxiEnvelopeEEEEvPT_,__ZNSt3__111make_sharedI12maxiEnvelopeJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI13maxiDelaylineEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI13maxiDelaylineEEEEvPT_,__ZNSt3__111make_sharedI13maxiDelaylineJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI10maxiFilterEEvPT_
,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI10maxiFilterEEEEvPT_,__ZNSt3__111make_sharedI10maxiFilterJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI7maxiMixEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiMixEEEEvPT_,__ZNSt3__111make_sharedI7maxiMixJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI10maxiLagExpIdEEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI10maxiLagExpIdEEEEEvPT_,__ZNSt3__111make_sharedI10maxiLagExpIdEJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS4_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI10maxiSampleEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI10maxiSampleEEEEvPT_,__ZNSt3__111make_sharedI10maxiSampleJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10maxiSample7triggerEv,__ZN10maxiSample5clearEv,__ZN10emscripten8internal14raw_destructorI7maxiMapEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiMapEEEEvPT_,__ZNSt3__111make_sharedI7maxiMapJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI7maxiDynEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiDynEEEEvPT_,__ZNSt3__111make_sharedI7maxiDynJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI7maxiEnvEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7maxiEnvEEEEvPT_,__ZNSt3__111make_sharedI7maxiEnvJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI7convertEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI7convertEEEEvPT_,__ZNSt3__111make_sharedI7convertJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI14maxiDistortionEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI14maxiDistortionEEEEvPT_,__ZNSt3__111make_sharedI14maxiDistortionJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI11maxiFlangerEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI11maxiFlangerEEEEvPT_
,__ZNSt3__111make_sharedI11maxiFlangerJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI10maxiChorusEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI10maxiChorusEEEEvPT_,__ZNSt3__111make_sharedI10maxiChorusJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN10emscripten8internal14raw_destructorI20maxiEnvelopeFollowerEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__110shared_ptrI20maxiEnvelopeFollowerEEEEvPT_,__ZNSt3__111make_sharedI20maxiEnvelopeFollowerJEEENS_9enable_ifIXntsr8is_arrayIT_EE5valueENS_10shared_ptrIS3_EEE4typeEDpOT0_,__ZN20maxiEnvelopeFollower5resetEv,__ZN10emscripten8internal14raw_destructorINSt3__16vectorIiNS2_9allocatorIiEEEEEEvPT_,__ZN10emscripten8internal14raw_destructorINSt3__16vectorIdNS2_9allocatorIdEEEEEEvPT_,__emval_incref__wrapper,__emval_decref__wrapper,__ZN10__cxxabiv112_GLOBAL__N_19destruct_EPv,_cleanup387,_cleanup392,__ZNSt3__18ios_base4InitD2Ev,__ZNSt3__18ios_base33__set_badbit_and_consider_rethrowEv,_freelocale,__ZNSt3__112__do_nothingEPv,__ZNSt3__121__throw_runtime_errorEPKc,__ZNSt3__16locale2id6__initEv,__ZNSt3__117__call_once_proxyINS_5tupleIJNS_12_GLOBAL__N_111__fake_bindEEEEEEvPv,___cxx_global_array_dtor,___cxx_global_array_dtor54,___cxx_global_array_dtor69,___cxx_global_array_dtor93,___cxx_global_array_dtor117,___cxx_global_array_dtor120,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev,__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev
,_free,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4];
var FUNCTION_TABLE_vii = [b5,__ZNSt3__111__stdoutbufIwE5imbueERKNS_6localeE,__ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE,__ZNSt3__111__stdoutbufIcE5imbueERKNS_6localeE,__ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE,__ZNKSt3__110moneypunctIcLb0EE11do_groupingEv,__ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv,__ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv,__ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv,__ZNKSt3__110moneypunctIcLb0EE13do_pos_formatEv,__ZNKSt3__110moneypunctIcLb0EE13do_neg_formatEv,__ZNKSt3__110moneypunctIcLb1EE11do_groupingEv,__ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv,__ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv,__ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv,__ZNKSt3__110moneypunctIcLb1EE13do_pos_formatEv,__ZNKSt3__110moneypunctIcLb1EE13do_neg_formatEv,__ZNKSt3__110moneypunctIwLb0EE11do_groupingEv,__ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv,__ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv,__ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv,__ZNKSt3__110moneypunctIwLb0EE13do_pos_formatEv,__ZNKSt3__110moneypunctIwLb0EE13do_neg_formatEv,__ZNKSt3__110moneypunctIwLb1EE11do_groupingEv,__ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv,__ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv,__ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv
,__ZNKSt3__110moneypunctIwLb1EE13do_pos_formatEv,__ZNKSt3__110moneypunctIwLb1EE13do_neg_formatEv,__ZNKSt3__18messagesIcE8do_closeEi,__ZNKSt3__18messagesIwE8do_closeEi,__ZNKSt3__18numpunctIcE11do_groupingEv,__ZNKSt3__18numpunctIcE11do_truenameEv,__ZNKSt3__18numpunctIcE12do_falsenameEv,__ZNKSt3__18numpunctIwE11do_groupingEv,__ZNKSt3__18numpunctIwE11do_truenameEv,__ZNKSt3__18numpunctIwE12do_falsenameEv,__ZN10emscripten8internal7InvokerIvJRNSt3__16vectorIdNS2_9allocatorIdEEEEEE6invokeEPFvS7_EPS6_,__ZN10maxiSample9setSampleERNSt3__16vectorIdNS0_9allocatorIdEEEE,__ZN10emscripten8internal13MethodInvokerIM10maxiSampleFvvEvPS2_JEE6invokeERKS4_S5_,__ZN10emscripten8internal13MethodInvokerIM20maxiEnvelopeFollowerFvvEvPS2_JEE6invokeERKS4_S5_,__ZNSt3__16vectorIiNS_9allocatorIiEEE9push_backERKi,__ZNSt3__16vectorIdNS_9allocatorIdEEE9push_backERKd,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI8maxiTestEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiOscEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI12maxiEnvelopeEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI13maxiDelaylineEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiFilterEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMixEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiLagExpIdEEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiSampleEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMapEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiDynEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiEnvEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7convertEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI14maxiDistortionEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI11maxiFlangerEEE11val_deleterclEPKv
,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiChorusEEE11val_deleterclEPKv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI20maxiEnvelopeFollowerEEE11val_deleterclEPKv,_abort_message,__ZNSt3__18ios_base4initEPv,__ZNSt3__18ios_base16__call_callbacksENS0_5eventE,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_,__ZNSt3__18ios_base5clearEj,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc,__ZNSt13runtime_errorC2EPKc,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj,__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw,__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj,__ZNSt11logic_errorC2EPKc,__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej,__ZNSt3__16locale5__imp7installINS_7collateIcEEEEvPT_,__ZNSt3__16locale5__imp7installINS_7collateIwEEEEvPT_,__ZNSt3__16locale5__imp7installINS_5ctypeIcEEEEvPT_,__ZNSt3__16locale5__imp7installINS_5ctypeIwEEEEvPT_,__ZNSt3__16locale5__imp7installINS_7codecvtIcc11__mbstate_tEEEEvPT_,__ZNSt3__17codecvtIwc11__mbstate_tEC2Ej,__ZNSt3__16locale5__imp7installINS_7codecvtIwc11__mbstate_tEEEEvPT_,__ZNSt3__16locale5__imp7installINS_7codecvtIDsc11__mbstate_tEEEEvPT_,__ZNSt3__16locale5__imp7installINS_7codecvtIDic11__mbstate_tEEEEvPT_,__ZNSt3__16locale5__imp7installINS_8numpunctIcEEEEvPT_,__ZNSt3__16locale5__imp7installINS_8numpunctIwEEEEvPT_,__ZNSt3__16locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_
,__ZNSt3__16locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_,__ZNSt3__16locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_,__ZNSt3__16locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_,__ZNSt3__16locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_,__ZNSt3__16locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__16locale5__imp7installINS_8messagesIcEEEEvPT_,__ZNSt3__16locale5__imp7installINS_8messagesIwEEEEvPT_,__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj,__ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj,__ZNSt3__118__libcpp_refstringC2EPKc,__ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5
,b5,b5,b5,b5,b5,b5,b5,b5,b5];
var FUNCTION_TABLE_iiiiiii = [b6,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm
,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE,__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE,__ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_,__ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6
,b6,b6,b6,b6,b6];
var FUNCTION_TABLE_diididdd = [b7,__ZN10emscripten8internal13MethodInvokerIM11maxiFlangerFddjdddEdPS2_JdjdddEE6invokeERKS4_S5_djddd,__ZN10emscripten8internal13MethodInvokerIM10maxiChorusFddjdddEdPS2_JdjdddEE6invokeERKS4_S5_djddd,b7];
var FUNCTION_TABLE_diddd = [b8,__ZN7maxiOsc6phasorEddd,__ZN10maxiFilter5loresEddd,__ZN10maxiFilter5hiresEddd,__ZN10maxiFilter8bandpassEddd,__ZN10maxiSample4playEddd,__ZN10maxiSample5play4Eddd,b8];
var FUNCTION_TABLE_ii = [b9,__ZNKSt9bad_alloc4whatEv,__ZNKSt11logic_error4whatEv,__ZNKSt13runtime_error4whatEv,__ZNKSt8bad_cast4whatEv,___stdio_close,__ZNSt3__111__stdoutbufIwE4syncEv,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9showmanycEv,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9underflowEv,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5uflowEv,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE4syncEv,__ZNSt3__110__stdinbufIwE9underflowEv,__ZNSt3__110__stdinbufIwE5uflowEv,__ZNSt3__111__stdoutbufIcE4syncEv,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9showmanycEv,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9underflowEv,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5uflowEv,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE4syncEv,__ZNSt3__110__stdinbufIcE9underflowEv,__ZNSt3__110__stdinbufIcE5uflowEv,__ZNKSt3__119__iostream_category4nameEv,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv,__ZNKSt3__120__time_get_c_storageIcE7__weeksEv,__ZNKSt3__120__time_get_c_storageIcE8__monthsEv,__ZNKSt3__120__time_get_c_storageIcE7__am_pmEv,__ZNKSt3__120__time_get_c_storageIcE3__cEv,__ZNKSt3__120__time_get_c_storageIcE3__rEv,__ZNKSt3__120__time_get_c_storageIcE3__xEv,__ZNKSt3__120__time_get_c_storageIcE3__XEv
,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv,__ZNKSt3__120__time_get_c_storageIwE7__weeksEv,__ZNKSt3__120__time_get_c_storageIwE8__monthsEv,__ZNKSt3__120__time_get_c_storageIwE7__am_pmEv,__ZNKSt3__120__time_get_c_storageIwE3__cEv,__ZNKSt3__120__time_get_c_storageIwE3__rEv,__ZNKSt3__120__time_get_c_storageIwE3__xEv,__ZNKSt3__120__time_get_c_storageIwE3__XEv,__ZNKSt3__110moneypunctIcLb0EE16do_decimal_pointEv,__ZNKSt3__110moneypunctIcLb0EE16do_thousands_sepEv,__ZNKSt3__110moneypunctIcLb0EE14do_frac_digitsEv,__ZNKSt3__110moneypunctIcLb1EE16do_decimal_pointEv,__ZNKSt3__110moneypunctIcLb1EE16do_thousands_sepEv,__ZNKSt3__110moneypunctIcLb1EE14do_frac_digitsEv,__ZNKSt3__110moneypunctIwLb0EE16do_decimal_pointEv,__ZNKSt3__110moneypunctIwLb0EE16do_thousands_sepEv,__ZNKSt3__110moneypunctIwLb0EE14do_frac_digitsEv,__ZNKSt3__110moneypunctIwLb1EE16do_decimal_pointEv,__ZNKSt3__110moneypunctIwLb1EE16do_thousands_sepEv,__ZNKSt3__110moneypunctIwLb1EE14do_frac_digitsEv,__ZNKSt3__17codecvtIwc11__mbstate_tE11do_encodingEv,__ZNKSt3__17codecvtIwc11__mbstate_tE16do_always_noconvEv,__ZNKSt3__17codecvtIwc11__mbstate_tE13do_max_lengthEv,__ZNKSt3__18numpunctIcE16do_decimal_pointEv,__ZNKSt3__18numpunctIcE16do_thousands_sepEv,__ZNKSt3__18numpunctIwE16do_decimal_pointEv,__ZNKSt3__18numpunctIwE16do_thousands_sepEv,__ZNKSt3__17codecvtIcc11__mbstate_tE11do_encodingEv,__ZNKSt3__17codecvtIcc11__mbstate_tE16do_always_noconvEv,__ZNKSt3__17codecvtIcc11__mbstate_tE13do_max_lengthEv
,__ZNKSt3__17codecvtIDsc11__mbstate_tE11do_encodingEv,__ZNKSt3__17codecvtIDsc11__mbstate_tE16do_always_noconvEv,__ZNKSt3__17codecvtIDsc11__mbstate_tE13do_max_lengthEv,__ZNKSt3__17codecvtIDic11__mbstate_tE11do_encodingEv,__ZNKSt3__17codecvtIDic11__mbstate_tE16do_always_noconvEv,__ZNKSt3__17codecvtIDic11__mbstate_tE13do_max_lengthEv,__ZN10emscripten8internal13getActualTypeI11vectorToolsEEPKvPT_,__ZN10emscripten8internal7InvokerIP11vectorToolsJEE6invokeEPFS3_vE,__ZN10emscripten8internal13getActualTypeI8maxiTestEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI8maxiTestEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI8maxiTestEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI12maxiSettingsEEPKvPT_,__ZN10emscripten8internal7InvokerIP12maxiSettingsJEE6invokeEPFS3_vE,__ZN10emscripten8internal13getActualTypeI7maxiOscEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiOscEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiOscEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI12maxiEnvelopeEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI12maxiEnvelopeEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI12maxiEnvelopeEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI13maxiDelaylineEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI13maxiDelaylineEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI13maxiDelaylineEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI10maxiFilterEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiFilterEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI10maxiFilterEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI7maxiMixEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMixEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiMixEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI10maxiLagExpIdEEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiLagExpIdEEEE3getERKS5_
,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI10maxiLagExpIdEEEJEE6invokeEPFS6_vE,__ZN10emscripten8internal13getActualTypeI10maxiSampleEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiSampleEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI10maxiSampleEEJEE6invokeEPFS5_vE,__ZN10maxiSample9getLengthEv,__ZN10maxiSample7isReadyEv,__ZN10emscripten8internal13getActualTypeI7maxiMapEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMapEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiMapEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI7maxiDynEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiDynEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiDynEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI7maxiEnvEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiEnvEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7maxiEnvEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI7convertEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7convertEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI7convertEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI14maxiDistortionEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI14maxiDistortionEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI14maxiDistortionEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI11maxiFlangerEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI11maxiFlangerEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI11maxiFlangerEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI10maxiChorusEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiChorusEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI10maxiChorusEEJEE6invokeEPFS5_vE,__ZN10emscripten8internal13getActualTypeI20maxiEnvelopeFollowerEEPKvPT_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI20maxiEnvelopeFollowerEEE3getERKS4_,__ZN10emscripten8internal7InvokerINSt3__110shared_ptrI20maxiEnvelopeFollowerEEJEE6invokeEPFS5_vE
,__ZN10emscripten8internal13getActualTypeINSt3__16vectorIiNS2_9allocatorIiEEEEEEPKvPT_,__ZN10emscripten8internal7InvokerIPNSt3__16vectorIiNS2_9allocatorIiEEEEJEE6invokeEPFS7_vE,__ZNKSt3__16vectorIiNS_9allocatorIiEEE4sizeEv,__ZN10emscripten8internal13getActualTypeINSt3__16vectorIdNS2_9allocatorIdEEEEEEPKvPT_,__ZN10emscripten8internal7InvokerIPNSt3__16vectorIdNS2_9allocatorIdEEEEJEE6invokeEPFS7_vE,__ZNKSt3__16vectorIdNS_9allocatorIdEEE4sizeEv,__Znwj,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv,_pthread_mutex_unlock__wrapper,_pthread_mutex_lock__wrapper,_pthread_cond_broadcast__wrapper,__ZNKSt3__18ios_base6getlocEv,_uselocale,_wcslen,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9
,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9
,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9
,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9
,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9];
var FUNCTION_TABLE_vididdd = [b10,__ZN7maxiMix9ambisonicEdRNSt3__16vectorIdNS0_9allocatorIdEEEEddd];
var FUNCTION_TABLE_vidid = [b11,__ZN7maxiMix6stereoEdRNSt3__16vectorIdNS0_9allocatorIdEEEEd];
var FUNCTION_TABLE_iiiiiid = [b12,__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce,__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe,b12];
var FUNCTION_TABLE_viidd = [b13,__ZN10emscripten8internal13MethodInvokerIM10maxiLagExpIdEFvddEvPS3_JddEE6invokeERKS5_S6_dd];
var FUNCTION_TABLE_didddddii = [b14,__ZN7maxiEnv4adsrEdddddli];
var FUNCTION_TABLE_viiiii = [b15,__ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,__ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,__ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib];
var FUNCTION_TABLE_vididd = [b16,__ZN7maxiMix4quadEdRNSt3__16vectorIdNS0_9allocatorIdEEEEdd];
var FUNCTION_TABLE_iiiiii = [b17,__ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_,__ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv,__ZNKSt3__15ctypeIcE9do_narrowEPKcS3_cPc,__ZNKSt3__17codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__17codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__15ctypeIwE9do_narrowEPKwS3_cPc,__ZNKSt3__17codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__17codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__17codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__17codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__17codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__17codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j,_wcsnrtombs,_mbsnrtowcs,b17,b17,b17,b17,b17,b17
,b17,b17,b17];
var FUNCTION_TABLE_viiiiiiiiii = [b18,__ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri,__ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri,__ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri,__ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri,b18,b18,b18];
var FUNCTION_TABLE_i = [b19,__ZN10emscripten8internal12operator_newI11vectorToolsJEEEPT_DpOT0_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI8maxiTestEEE14construct_nullEv,__ZN10emscripten8internal12operator_newI12maxiSettingsJEEEPT_DpOT0_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiOscEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI12maxiEnvelopeEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI13maxiDelaylineEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiFilterEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMixEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiLagExpIdEEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiSampleEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMapEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiDynEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiEnvEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7convertEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI14maxiDistortionEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI11maxiFlangerEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiChorusEEE14construct_nullEv,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI20maxiEnvelopeFollowerEEE14construct_nullEv,__ZN10emscripten8internal12operator_newINSt3__16vectorIiNS2_9allocatorIiEEEEJEEEPT_DpOT0_,__ZN10emscripten8internal12operator_newINSt3__16vectorIdNS2_9allocatorIdEEEEJEEEPT_DpOT0_,___cxa_get_globals_fast,__ZNSt3__16__clocEv,__ZNSt3__16locale5__imp12make_classicEv,__ZNSt3__16locale5__imp11make_globalEv,__ZNSt3__16locale8__globalEv,___ctype_b_loc,___ctype_toupper_loc,___ctype_tolower_loc
,b19,b19,b19];
var FUNCTION_TABLE_diddddd = [b20,__ZN10emscripten8internal15FunctionInvokerIPFddddddEddJddddEE6invokeEPS3_ddddd,__ZN7maxiDyn10compressorEddddd,b20];
var FUNCTION_TABLE_vidd = [b21,__ZN10maxiLagExpIdE4initEdd];
var FUNCTION_TABLE_iiii = [b22,__ZNK10__cxxabiv123__fundamental_type_info9can_catchEPKNS_16__shim_type_infoERPv,__ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv,__ZNK10__cxxabiv119__pointer_type_info9can_catchEPKNS_16__shim_type_infoERPv,_sn_write,___stdio_write,___stdio_seek,___stdio_read,___stdout_write,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi,__ZNSt3__111__stdoutbufIwE6xsputnEPKwi,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6setbufEPci,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci,__ZNSt3__111__stdoutbufIcE6xsputnEPKci,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci,__ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE,__ZNKSt3__114error_category10equivalentERKNS_10error_codeEi,__ZNKSt3__17collateIcE7do_hashEPKcS3_,__ZNKSt3__17collateIwE7do_hashEPKwS3_,__ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,__ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,__ZNKSt3__15ctypeIcE10do_toupperEPcPKc,__ZNKSt3__15ctypeIcE10do_tolowerEPcPKc,__ZNKSt3__15ctypeIcE9do_narrowEcc,__ZNKSt3__15ctypeIwE5do_isEtw,__ZNKSt3__15ctypeIwE10do_toupperEPwPKw,__ZNKSt3__15ctypeIwE10do_tolowerEPwPKw
,__ZNKSt3__15ctypeIwE9do_narrowEwc,__ZN8maxiTest8sumArrayEjj,__ZN7maxiMap5clampEiii,__ZN10emscripten8internal15FunctionInvokerIPFNS_3valERKNSt3__16vectorIiNS3_9allocatorIiEEEEjES2_S9_JjEE6invokeEPSB_PS7_j,__ZN10emscripten8internal12VectorAccessINSt3__16vectorIiNS2_9allocatorIiEEEEE3setERS6_jRKi,__ZN10emscripten8internal15FunctionInvokerIPFNS_3valERKNSt3__16vectorIdNS3_9allocatorIdEEEEjES2_S9_JjEE6invokeEPSB_PS7_j,__ZN10emscripten8internal12VectorAccessINSt3__16vectorIdNS2_9allocatorIdEEEEE3setERS6_jRKd,_do_read,_newlocale,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_,__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_,_wcrtomb,_mbtowc,_mbrlen,_vasprintf,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj,b22,b22,b22,b22,b22,b22,b22,b22,b22,b22,b22,b22,b22,b22
,b22,b22,b22,b22,b22];
var FUNCTION_TABLE_diiddidd = [b23,__ZN10emscripten8internal13MethodInvokerIM7maxiDynFdddlddEdPS2_JddlddEE6invokeERKS4_S5_ddldd];
var FUNCTION_TABLE_dddddd = [b24,__ZN7maxiMap6linlinEddddd,__ZN7maxiMap6linexpEddddd,__ZN7maxiMap6explinEddddd];
var FUNCTION_TABLE_viiiiii = [b25,__ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,__ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,__ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj,__ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE];
var FUNCTION_TABLE_diiii = [b26,__ZN10emscripten8internal13MethodInvokerIM12maxiEnvelopeFdiRNSt3__16vectorIdNS3_9allocatorIdEEEEEdPS2_JiS8_EE6invokeERKSA_SB_iPS7_];
var FUNCTION_TABLE_viii = [b27,__ZNKSt3__114error_category23default_error_conditionEi,__ZNKSt3__119__iostream_category7messageEi,__ZN12maxiSettings5setupEiii,__ZN10emscripten8internal13MethodInvokerIM10maxiSampleFvRNSt3__16vectorIdNS3_9allocatorIdEEEEEvPS2_JS8_EE6invokeERKSA_SB_PS7_,__ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIiNS2_9allocatorIiEEEEFvRKiEvPS6_JS8_EE6invokeERKSA_SB_i,__ZNSt3__16vectorIiNS_9allocatorIiEEE6resizeEjRKi,__ZNSt3__16vectorIdNS_9allocatorIdEEE6resizeEjRKd,__ZNSt3__18ios_base7failureC2EPKcRKNS_10error_codeE,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc,__ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_,__ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_,__ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj,__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj,__ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE];
var FUNCTION_TABLE_di = [b28,__ZN7maxiOsc5noiseEv,__ZNK12maxiEnvelope12GetAmplitudeEv,__ZN10maxiLagExpIdE5valueEv,__ZN10maxiSample8playOnceEv,__ZN10maxiSample4playEv,b28,b28];
var FUNCTION_TABLE_diiddd = [b29,__ZN10emscripten8internal13MethodInvokerIM7maxiOscFddddEdPS2_JdddEE6invokeERKS4_S5_ddd,__ZN10emscripten8internal13MethodInvokerIM10maxiFilterFddddEdPS2_JdddEE6invokeERKS4_S5_ddd,__ZN10emscripten8internal13MethodInvokerIM10maxiSampleFddddEdPS2_JdddEE6invokeERKS4_S5_ddd];
var FUNCTION_TABLE_viid = [b30,__ZN10emscripten8internal13MethodInvokerIM7maxiOscFvdEvPS2_JdEE6invokeERKS4_S5_d,__ZN12maxiEnvelope7triggerEid,__ZN10emscripten8internal12SetterPolicyIM12maxiEnvelopeFvdEE3setIS2_EEvRKS4_RT_d,__ZN10emscripten8internal13MethodInvokerIM10maxiLagExpIdEFvdEvPS3_JdEE6invokeERKS5_S6_d,__ZN10emscripten8internal13MethodInvokerIM20maxiEnvelopeFollowerFvdEvPS2_JdEE6invokeERKS4_S5_d,__ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIdNS2_9allocatorIdEEEEFvRKdEvPS6_JS8_EE6invokeERKSA_SB_d,b30];
var FUNCTION_TABLE_diid = [b31,__ZN10emscripten8internal13MethodInvokerIM7maxiOscFddEdPS2_JdEE6invokeERKS4_S5_d,__ZN10emscripten8internal13MethodInvokerIM10maxiSampleFddEdPS2_JdEE6invokeERKS4_S5_d,__ZN10emscripten8internal13MethodInvokerIM14maxiDistortionFddEdPS2_JdEE6invokeERKS4_S5_d,__ZN10emscripten8internal13MethodInvokerIM20maxiEnvelopeFollowerFddEdPS2_JdEE6invokeERKS4_S5_d,b31,b31,b31];
var FUNCTION_TABLE_diidid = [b32,__ZN10emscripten8internal13MethodInvokerIM13maxiDelaylineFddidEdPS2_JdidEE6invokeERKS4_S5_did];
var FUNCTION_TABLE_viiiiiii = [b33,__ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE,__ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE,__ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE,__ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE,b33,b33,b33];
var FUNCTION_TABLE_iiiiiiiiiiii = [b34,__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_,__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_,b34];
var FUNCTION_TABLE_didid = [b35,__ZN13maxiDelayline2dlEdid];
var FUNCTION_TABLE_viididdd = [b36,__ZN10emscripten8internal13MethodInvokerIM7maxiMixFvdRNSt3__16vectorIdNS3_9allocatorIdEEEEdddEvPS2_JdS8_dddEE6invokeERKSA_SB_dPS7_ddd];
var FUNCTION_TABLE_iii = [b37,__ZNKSt3__120__shared_ptr_pointerIP8maxiTestN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__119__shared_weak_count13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP7maxiOscN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP12maxiEnvelopeN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP13maxiDelaylineN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP10maxiFilterN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP7maxiMixN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP10maxiLagExpIdEN10emscripten15smart_ptr_traitINS_10shared_ptrIS2_EEE11val_deleterENS_9allocatorIS2_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP10maxiSampleN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP7maxiMapN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP7maxiDynN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP7maxiEnvN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP7convertN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP14maxiDistortionN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP11maxiFlangerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP10maxiChorusN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNKSt3__120__shared_ptr_pointerIP20maxiEnvelopeFollowerN10emscripten15smart_ptr_traitINS_10shared_ptrIS1_EEE11val_deleterENS_9allocatorIS1_EEE13__get_deleterERKSt9type_info,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj,__ZNSt3__111__stdoutbufIwE8overflowEj,__ZNSt3__110__stdinbufIwE9pbackfailEj,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE8overflowEj,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi,__ZNSt3__111__stdoutbufIcE8overflowEi,__ZNSt3__110__stdinbufIcE9pbackfailEi,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE8overflowEi,__ZNKSt3__15ctypeIcE10do_toupperEc,__ZNKSt3__15ctypeIcE10do_tolowerEc,__ZNKSt3__15ctypeIcE8do_widenEc
,__ZNKSt3__15ctypeIwE10do_toupperEw,__ZNKSt3__15ctypeIwE10do_tolowerEw,__ZNKSt3__15ctypeIwE8do_widenEc,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI8maxiTestEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiOscEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI12maxiEnvelopeEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI13maxiDelaylineEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiFilterEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMixEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiLagExpIdEEEE5shareEPS4_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiSampleEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten8internal13MethodInvokerIM10maxiSampleFlvElPS2_JEE6invokeERKS4_S5_,__ZN10emscripten8internal13MethodInvokerIM10maxiSampleFbvEbPS2_JEE6invokeERKS4_S5_,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiMapEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiDynEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7maxiEnvEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI7convertEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI14maxiDistortionEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI11maxiFlangerEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI10maxiChorusEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten15smart_ptr_traitINSt3__110shared_ptrI20maxiEnvelopeFollowerEEE5shareEPS3_PNS_8internal7_EM_VALE,__ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIiNS2_9allocatorIiEEEEKFjvEjPKS6_JEE6invokeERKS8_SA_,__ZN10emscripten8internal12VectorAccessINSt3__16vectorIiNS2_9allocatorIiEEEEE3getERKS6_j,__ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIdNS2_9allocatorIdEEEEKFjvEjPKS6_JEE6invokeERKS8_SA_,__ZN10emscripten8internal12VectorAccessINSt3__16vectorIdNS2_9allocatorIdEEEEE3getERKS6_j,__emval_take_value__wrapper,__ZNKSt3__16locale9use_facetERNS0_2idE,_isxdigit_l,_isdigit_l,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc
,__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw,b37,b37,b37,b37];
var FUNCTION_TABLE_diiddddd = [b38,__ZN10emscripten8internal13MethodInvokerIM7maxiDynFddddddEdPS2_JdddddEE6invokeERKS4_S5_ddddd];
var FUNCTION_TABLE_diii = [b39,__ZN12maxiEnvelope4lineEiRNSt3__16vectorIdNS0_9allocatorIdEEEE,__ZN10emscripten8internal13MethodInvokerIM7convertFdiEdPS2_JiEE6invokeERKS4_S5_i,__ZNSt3__115__num_get_floatIfEET_PKcS3_Rj,__ZNSt3__115__num_get_floatIdEET_PKcS3_Rj,__ZNSt3__115__num_get_floatIeEET_PKcS3_Rj,b39,b39];
var FUNCTION_TABLE_diidddii = [b40,__ZN10emscripten8internal13MethodInvokerIM7maxiEnvFddddliEdPS2_JdddliEE6invokeERKS4_S5_dddli];
var FUNCTION_TABLE_didd = [b41,__ZN7maxiOsc5pulseEdd,__ZN7maxiOsc4rectEdd,__ZN10maxiFilter6lopassEdd,__ZN10maxiFilter6hipassEdd,__ZN14maxiDistortion8atanDistEdd,__ZN14maxiDistortion12fastAtanDistEdd,b41];
var FUNCTION_TABLE_diidddddii = [b42,__ZN10emscripten8internal13MethodInvokerIM7maxiEnvFddddddliEdPS2_JdddddliEE6invokeERKS4_S5_dddddli];
var FUNCTION_TABLE_diidd = [b43,__ZN10emscripten8internal13MethodInvokerIM7maxiOscFdddEdPS2_JddEE6invokeERKS4_S5_dd,__ZN10emscripten8internal13MethodInvokerIM10maxiFilterFdddEdPS2_JddEE6invokeERKS4_S5_dd,__ZN10emscripten8internal13MethodInvokerIM14maxiDistortionFdddEdPS2_JddEE6invokeERKS4_S5_dd];
var FUNCTION_TABLE_dii = [b44,__ZN10emscripten8internal13MethodInvokerIM7maxiOscFdvEdPS2_JEE6invokeERKS4_S5_,__ZN10emscripten8internal12GetterPolicyIM12maxiEnvelopeKFdvEE3getIS2_EEdRKS4_RKT_,__ZN10emscripten8internal13MethodInvokerIM10maxiLagExpIdEFdvEdPS3_JEE6invokeERKS5_S6_,__ZN10emscripten8internal13MethodInvokerIM10maxiSampleFdvEdPS2_JEE6invokeERKS4_S5_,__ZN7convert4mtofEi,b44,b44];
var FUNCTION_TABLE_did = [b45,__ZN7maxiOsc8sinewaveEd,__ZN7maxiOsc7coswaveEd,__ZN7maxiOsc6phasorEd,__ZN7maxiOsc3sawEd,__ZN7maxiOsc8triangleEd,__ZN7maxiOsc6squareEd,__ZN7maxiOsc7sinebufEd,__ZN7maxiOsc8sinebuf4Ed,__ZN7maxiOsc4sawnEd,__ZN10maxiSample8playOnceEd,__ZN10maxiSample4playEd,__ZN14maxiDistortion8fastatanEd,__ZN20maxiEnvelopeFollower4playEd,b45,b45];
var FUNCTION_TABLE_viiiiiiiiiiiiiii = [b46,__ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i,__ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i,b46];
var FUNCTION_TABLE_iiiiid = [b47,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe,b47,b47,b47];
var FUNCTION_TABLE_iiiii = [b48,__ZNKSt3__15ctypeIcE8do_widenEPKcS3_Pc,__ZNKSt3__15ctypeIwE5do_isEPKwS3_Pt,__ZNKSt3__15ctypeIwE10do_scan_isEtPKwS3_,__ZNKSt3__15ctypeIwE11do_scan_notEtPKwS3_,__ZNKSt3__15ctypeIwE8do_widenEPKcS3_Pw,__ZN10emscripten8internal13MethodInvokerIM8maxiTestFijjEiPS2_JjjEE6invokeERKS4_S5_jj,__ZN10emscripten8internal15FunctionInvokerIPFiiiiEiiJiiEE6invokeEPS3_iii,__ZN10emscripten8internal15FunctionInvokerIPFbRNSt3__16vectorIiNS2_9allocatorIiEEEEjRKiEbS7_JjS9_EE6invokeEPSB_PS6_ji,__ZNSt3__110__sscanf_lEPKcP15__locale_structS1_z,__ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz,_mbsrtowcs,_catgets,_mbrtowc,__ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji,__ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji,__ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji,__ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji,__ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji,__ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji,b48,b48,b48,b48,b48,b48,b48,b48,b48
,b48,b48,b48];
var FUNCTION_TABLE_dididdd = [b49,__ZN11maxiFlanger6flangeEdjddd,__ZN10maxiChorus6chorusEdjddd,b49];
var FUNCTION_TABLE_viiid = [b50,__ZN10emscripten8internal13MethodInvokerIM12maxiEnvelopeFvidEvPS2_JidEE6invokeERKS4_S5_id,__ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIdNS2_9allocatorIdEEEEFvjRKdEvPS6_JjS8_EE6invokeERKSA_SB_jd,b50];
var FUNCTION_TABLE_viidid = [b51,__ZN10emscripten8internal13MethodInvokerIM7maxiMixFvdRNSt3__16vectorIdNS3_9allocatorIdEEEEdEvPS2_JdS8_dEE6invokeERKSA_SB_dPS7_d];
var FUNCTION_TABLE_didddii = [b52,__ZN7maxiEnv2arEdddli];
var FUNCTION_TABLE_v = [b53,__ZL25default_terminate_handlerv,___cxa_rethrow__wrapper,___cxa_end_catch__wrapper,__ZN10__cxxabiv112_GLOBAL__N_110construct_Ev,__ZSt17__throw_bad_allocv,b53,b53];
var FUNCTION_TABLE_iiiiiiiii = [b54,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,__ZNKSt3__17codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_,__ZNKSt3__17codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_,__ZNKSt3__17codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_,b54,b54,b54,b54,b54];
var FUNCTION_TABLE_viididd = [b55,__ZN10emscripten8internal13MethodInvokerIM7maxiMixFvdRNSt3__16vectorIdNS3_9allocatorIdEEEEddEvPS2_JdS8_ddEE6invokeERKSA_SB_dPS7_dd];
var FUNCTION_TABLE_dididi = [b56,__ZN13maxiDelayline2dlEdidi];
var FUNCTION_TABLE_iiiid = [b57,__ZN10emscripten8internal15FunctionInvokerIPFbRNSt3__16vectorIdNS2_9allocatorIdEEEEjRKdEbS7_JjS9_EE6invokeEPSB_PS6_jd];
var FUNCTION_TABLE_viiii = [b58,__ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,__ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,__ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj,__ZNKSt3__17collateIcE12do_transformEPKcS3_,__ZNKSt3__17collateIwE12do_transformEPKwS3_,__ZN10emscripten8internal7InvokerIvJiiiEE6invokeEPFviiiEiii,__ZN10emscripten8internal13MethodInvokerIMNSt3__16vectorIiNS2_9allocatorIiEEEEFvjRKiEvPS6_JjS8_EE6invokeERKSA_SB_ji,__ZNSt3__110shared_ptrI8maxiTestEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI7maxiOscEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI12maxiEnvelopeEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI13maxiDelaylineEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI10maxiFilterEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI7maxiMixEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI10maxiLagExpIdEEC2IS2_N10emscripten15smart_ptr_traitIS3_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleISA_PS2_EE5valueENS3_5__natEE4typeE,__ZNSt3__110shared_ptrI10maxiSampleEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI7maxiMapEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI7maxiDynEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI7maxiEnvEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI7convertEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI14maxiDistortionEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI11maxiFlangerEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI10maxiChorusEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,__ZNSt3__110shared_ptrI20maxiEnvelopeFollowerEC2IS1_N10emscripten15smart_ptr_traitIS2_E11val_deleterEEEPT_T0_NS_9enable_ifIXsr14is_convertibleIS9_PS1_EE5valueENS2_5__natEE4typeE,b58,b58,b58
,b58,b58,b58];

  return { ___cxa_can_catch: ___cxa_can_catch, _fflush: _fflush, _sumArray: _sumArray, ___cxa_is_pointer_type: ___cxa_is_pointer_type, _i64Add: _i64Add, _memmove: _memmove, _i64Subtract: _i64Subtract, _memset: _memset, _malloc: _malloc, _memcpy: _memcpy, ___getTypeName: ___getTypeName, _bitshift64Lshr: _bitshift64Lshr, _free: _free, ___errno_location: ___errno_location, _bitshift64Shl: _bitshift64Shl, __GLOBAL__I_000101: __GLOBAL__I_000101, __GLOBAL__sub_I_maxi_emscr_cpp: __GLOBAL__sub_I_maxi_emscr_cpp, __GLOBAL__sub_I_bind_cpp: __GLOBAL__sub_I_bind_cpp, __GLOBAL__sub_I_iostream_cpp: __GLOBAL__sub_I_iostream_cpp, runPostSets: runPostSets, _emscripten_replace_memory: _emscripten_replace_memory, stackAlloc: stackAlloc, stackSave: stackSave, stackRestore: stackRestore, establishStackSpace: establishStackSpace, setThrew: setThrew, setTempRet0: setTempRet0, getTempRet0: getTempRet0, dynCall_iiiiiiii: dynCall_iiiiiiii, dynCall_diddidd: dynCall_diddidd, dynCall_vid: dynCall_vid, dynCall_diididi: dynCall_diididi, dynCall_vi: dynCall_vi, dynCall_vii: dynCall_vii, dynCall_iiiiiii: dynCall_iiiiiii, dynCall_diididdd: dynCall_diididdd, dynCall_diddd: dynCall_diddd, dynCall_ii: dynCall_ii, dynCall_vididdd: dynCall_vididdd, dynCall_vidid: dynCall_vidid, dynCall_iiiiiid: dynCall_iiiiiid, dynCall_viidd: dynCall_viidd, dynCall_didddddii: dynCall_didddddii, dynCall_viiiii: dynCall_viiiii, dynCall_vididd: dynCall_vididd, dynCall_iiiiii: dynCall_iiiiii, dynCall_viiiiiiiiii: dynCall_viiiiiiiiii, dynCall_i: dynCall_i, dynCall_diddddd: dynCall_diddddd, dynCall_vidd: dynCall_vidd, dynCall_iiii: dynCall_iiii, dynCall_diiddidd: dynCall_diiddidd, dynCall_dddddd: dynCall_dddddd, dynCall_viiiiii: dynCall_viiiiii, dynCall_diiii: dynCall_diiii, dynCall_viii: dynCall_viii, dynCall_di: dynCall_di, dynCall_diiddd: dynCall_diiddd, dynCall_viid: dynCall_viid, dynCall_diid: dynCall_diid, dynCall_diidid: dynCall_diidid, dynCall_viiiiiii: dynCall_viiiiiii, dynCall_iiiiiiiiiiii: dynCall_iiiiiiiiiiii, dynCall_didid: dynCall_didid, dynCall_viididdd: dynCall_viididdd, dynCall_iii: dynCall_iii, dynCall_diiddddd: dynCall_diiddddd, dynCall_diii: dynCall_diii, dynCall_diidddii: dynCall_diidddii, dynCall_didd: dynCall_didd, dynCall_diidddddii: dynCall_diidddddii, dynCall_diidd: dynCall_diidd, dynCall_dii: dynCall_dii, dynCall_did: dynCall_did, dynCall_viiiiiiiiiiiiiii: dynCall_viiiiiiiiiiiiiii, dynCall_iiiiid: dynCall_iiiiid, dynCall_iiiii: dynCall_iiiii, dynCall_dididdd: dynCall_dididdd, dynCall_viiid: dynCall_viiid, dynCall_viidid: dynCall_viidid, dynCall_didddii: dynCall_didddii, dynCall_v: dynCall_v, dynCall_iiiiiiiii: dynCall_iiiiiiiii, dynCall_viididd: dynCall_viididd, dynCall_dididi: dynCall_dididi, dynCall_iiiid: dynCall_iiiid, dynCall_viiii: dynCall_viiii };
})
// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg, Module.asmLibraryArg, buffer);
var ___cxa_can_catch = Module["___cxa_can_catch"] = asm["___cxa_can_catch"];
var __GLOBAL__sub_I_bind_cpp = Module["__GLOBAL__sub_I_bind_cpp"] = asm["__GLOBAL__sub_I_bind_cpp"];
var _fflush = Module["_fflush"] = asm["_fflush"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var _sumArray = Module["_sumArray"] = asm["_sumArray"];
var ___cxa_is_pointer_type = Module["___cxa_is_pointer_type"] = asm["___cxa_is_pointer_type"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var __GLOBAL__sub_I_maxi_emscr_cpp = Module["__GLOBAL__sub_I_maxi_emscr_cpp"] = asm["__GLOBAL__sub_I_maxi_emscr_cpp"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var ___getTypeName = Module["___getTypeName"] = asm["___getTypeName"];
var __GLOBAL__sub_I_iostream_cpp = Module["__GLOBAL__sub_I_iostream_cpp"] = asm["__GLOBAL__sub_I_iostream_cpp"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _free = Module["_free"] = asm["_free"];
var __GLOBAL__I_000101 = Module["__GLOBAL__I_000101"] = asm["__GLOBAL__I_000101"];
var _emscripten_replace_memory = Module["_emscripten_replace_memory"] = asm["_emscripten_replace_memory"];
var ___errno_location = Module["___errno_location"] = asm["___errno_location"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_diddidd = Module["dynCall_diddidd"] = asm["dynCall_diddidd"];
var dynCall_vid = Module["dynCall_vid"] = asm["dynCall_vid"];
var dynCall_diididi = Module["dynCall_diididi"] = asm["dynCall_diididi"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiii = Module["dynCall_iiiiiii"] = asm["dynCall_iiiiiii"];
var dynCall_diididdd = Module["dynCall_diididdd"] = asm["dynCall_diididdd"];
var dynCall_diddd = Module["dynCall_diddd"] = asm["dynCall_diddd"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_vididdd = Module["dynCall_vididdd"] = asm["dynCall_vididdd"];
var dynCall_vidid = Module["dynCall_vidid"] = asm["dynCall_vidid"];
var dynCall_iiiiiid = Module["dynCall_iiiiiid"] = asm["dynCall_iiiiiid"];
var dynCall_viidd = Module["dynCall_viidd"] = asm["dynCall_viidd"];
var dynCall_didddddii = Module["dynCall_didddddii"] = asm["dynCall_didddddii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_vididd = Module["dynCall_vididd"] = asm["dynCall_vididd"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_viiiiiiiiii = Module["dynCall_viiiiiiiiii"] = asm["dynCall_viiiiiiiiii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_diddddd = Module["dynCall_diddddd"] = asm["dynCall_diddddd"];
var dynCall_vidd = Module["dynCall_vidd"] = asm["dynCall_vidd"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_diiddidd = Module["dynCall_diiddidd"] = asm["dynCall_diiddidd"];
var dynCall_dddddd = Module["dynCall_dddddd"] = asm["dynCall_dddddd"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_diiii = Module["dynCall_diiii"] = asm["dynCall_diiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_di = Module["dynCall_di"] = asm["dynCall_di"];
var dynCall_diiddd = Module["dynCall_diiddd"] = asm["dynCall_diiddd"];
var dynCall_viid = Module["dynCall_viid"] = asm["dynCall_viid"];
var dynCall_diid = Module["dynCall_diid"] = asm["dynCall_diid"];
var dynCall_diidid = Module["dynCall_diidid"] = asm["dynCall_diidid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_iiiiiiiiiiii = Module["dynCall_iiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiii"];
var dynCall_didid = Module["dynCall_didid"] = asm["dynCall_didid"];
var dynCall_viididdd = Module["dynCall_viididdd"] = asm["dynCall_viididdd"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_diiddddd = Module["dynCall_diiddddd"] = asm["dynCall_diiddddd"];
var dynCall_diii = Module["dynCall_diii"] = asm["dynCall_diii"];
var dynCall_diidddii = Module["dynCall_diidddii"] = asm["dynCall_diidddii"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_diidddddii = Module["dynCall_diidddddii"] = asm["dynCall_diidddddii"];
var dynCall_diidd = Module["dynCall_diidd"] = asm["dynCall_diidd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_did = Module["dynCall_did"] = asm["dynCall_did"];
var dynCall_viiiiiiiiiiiiiii = Module["dynCall_viiiiiiiiiiiiiii"] = asm["dynCall_viiiiiiiiiiiiiii"];
var dynCall_iiiiid = Module["dynCall_iiiiid"] = asm["dynCall_iiiiid"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_dididdd = Module["dynCall_dididdd"] = asm["dynCall_dididdd"];
var dynCall_viiid = Module["dynCall_viiid"] = asm["dynCall_viiid"];
var dynCall_viidid = Module["dynCall_viidid"] = asm["dynCall_viidid"];
var dynCall_didddii = Module["dynCall_didddii"] = asm["dynCall_didddii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_viididd = Module["dynCall_viididd"] = asm["dynCall_viididd"];
var dynCall_dididi = Module["dynCall_dididi"] = asm["dynCall_dididi"];
var dynCall_iiiid = Module["dynCall_iiiid"] = asm["dynCall_iiiid"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];
Runtime.stackAlloc = asm["stackAlloc"];
Runtime.stackSave = asm["stackSave"];
Runtime.stackRestore = asm["stackRestore"];
Runtime.establishStackSpace = asm["establishStackSpace"];
Runtime.setTempRet0 = asm["setTempRet0"];
Runtime.getTempRet0 = asm["getTempRet0"];
function ExitStatus(status) {
 this.name = "ExitStatus";
 this.message = "Program terminated with exit(" + status + ")";
 this.status = status;
}
ExitStatus.prototype = new Error;
ExitStatus.prototype.constructor = ExitStatus;
var initialStackTop;
var preloadStartTime = null;
var calledMain = false;
dependenciesFulfilled = function runCaller() {
 if (!Module["calledRun"]) run();
 if (!Module["calledRun"]) dependenciesFulfilled = runCaller;
};
Module["callMain"] = Module.callMain = function callMain(args) {
 assert(runDependencies == 0, "cannot call main when async dependencies remain! (listen on __ATMAIN__)");
 assert(__ATPRERUN__.length == 0, "cannot call main when preRun functions remain to be called");
 args = args || [];
 ensureInitRuntime();
 var argc = args.length + 1;
 function pad() {
  for (var i = 0; i < 4 - 1; i++) {
   argv.push(0);
  }
 }
 var argv = [ allocate(intArrayFromString(Module["thisProgram"]), "i8", ALLOC_NORMAL) ];
 pad();
 for (var i = 0; i < argc - 1; i = i + 1) {
  argv.push(allocate(intArrayFromString(args[i]), "i8", ALLOC_NORMAL));
  pad();
 }
 argv.push(0);
 argv = allocate(argv, "i32", ALLOC_NORMAL);
 try {
  var ret = Module["_main"](argc, argv, 0);
  exit(ret, true);
 } catch (e) {
  if (e instanceof ExitStatus) {
   return;
  } else if (e == "SimulateInfiniteLoop") {
   Module["noExitRuntime"] = true;
   return;
  } else {
   if (e && typeof e === "object" && e.stack) Module.printErr("exception thrown: " + [ e, e.stack ]);
   throw e;
  }
 } finally {
  calledMain = true;
 }
};
function run(args) {
 args = args || Module["arguments"];
 if (preloadStartTime === null) preloadStartTime = Date.now();
 if (runDependencies > 0) {
  return;
 }
 preRun();
 if (runDependencies > 0) return;
 if (Module["calledRun"]) return;
 function doRun() {
  if (Module["calledRun"]) return;
  Module["calledRun"] = true;
  if (ABORT) return;
  ensureInitRuntime();
  preMain();
  if (Module["onRuntimeInitialized"]) Module["onRuntimeInitialized"]();
  if (Module["_main"] && shouldRunNow) Module["callMain"](args);
  postRun();
 }
 if (Module["setStatus"]) {
  Module["setStatus"]("Running...");
  setTimeout((function() {
   setTimeout((function() {
    Module["setStatus"]("");
   }), 1);
   doRun();
  }), 1);
 } else {
  doRun();
 }
}
Module["run"] = Module.run = run;
function exit(status, implicit) {
 if (implicit && Module["noExitRuntime"]) {
  return;
 }
 if (Module["noExitRuntime"]) {} else {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;
  exitRuntime();
  if (Module["onExit"]) Module["onExit"](status);
 }
 if (ENVIRONMENT_IS_NODE) {
  process["stdout"]["once"]("drain", (function() {
   process["exit"](status);
  }));
  console.log(" ");
  setTimeout((function() {
   process["exit"](status);
  }), 500);
 } else if (ENVIRONMENT_IS_SHELL && typeof quit === "function") {
  quit(status);
 }
 throw new ExitStatus(status);
}
Module["exit"] = Module.exit = exit;
var abortDecorators = [];
function abort(what) {
 if (what !== undefined) {
  Module.print(what);
  Module.printErr(what);
  what = JSON.stringify(what);
 } else {
  what = "";
 }
 ABORT = true;
 EXITSTATUS = 1;
 var extra = "\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";
 var output = "abort(" + what + ") at " + stackTrace() + extra;
 if (abortDecorators) {
  abortDecorators.forEach((function(decorator) {
   output = decorator(output, what);
  }));
 }
 throw output;
}
Module["abort"] = Module.abort = abort;
if (Module["preInit"]) {
 if (typeof Module["preInit"] == "function") Module["preInit"] = [ Module["preInit"] ];
 while (Module["preInit"].length > 0) {
  Module["preInit"].pop()();
 }
}
var shouldRunNow = true;
if (Module["noInitialRun"]) {
 shouldRunNow = false;
}
run();
var maximJs = {};
maximJs.maxiSettings = Module.maxiSettings;
maximJs.maxiOsc = Module.maxiOsc;
maximJs.maxiEnvelope = Module.maxiEnvelope;
maximJs.maxiDelayline = Module.maxiDelayline;
maximJs.maxiFilter = Module.maxiFilter;
maximJs.maxiMix = Module.maxiMix;
maximJs.maxiLagExp = Module.maxiLagExp;
maximJs.maxiSample = Module.maxiSample;
maximJs.maxiMap = Module.maxiMap;
maximJs.maxiDyn = Module.maxiDyn;
maximJs.maxiEnv = Module.maxiEnv;
maximJs.convert = Module.convert;
maximJs.maxiDistortion = Module.maxiDistortion;
maximJs.maxiFlanger = Module.maxiFlanger;
maximJs.maxiChorus = Module.maxiChorus;
maximJs.maxiEnvelopeFollower = Module.maxiEnvelopeFollower;
maximJs.maxiArray = function maxiArray() {
 this.length = 0;
 this.vec = new Module.VectorDouble;
 this.set = (function(arrayIn) {
  this.clear();
  this.vec = GetArrayAsVectorDbl(arrayIn);
  this.length = this.vec.size();
 });
 this.SetSqBrackets = (function(useSq) {
  for (var i = 0; i < this.length; i++) {
   if (useSq) {
    this[i] = this.vec.get(i);
   } else {
    delete this[i];
   }
  }
 });
 this.clear = (function(useSq) {
  for (var i = 0; i < this.length; i++) {
   delete this[i];
  }
  Module.vectorTools.clearVectorDbl(this.vec);
  this.length = 0;
 });
 this.push = (function(num) {
  this.vec.push_back(num);
  this.length++;
 });
};
function GetArrayAsVectorDbl(arrayIn) {
 var vecOut = new Module.VectorDouble;
 for (var i = 0; i < arrayIn.length; i++) {
  vecOut.push_back(arrayIn[i]);
 }
 return vecOut;
}
AudioContext = AudioContext || webkitAudioContext;
var context = new AudioContext;
var source;
var jsProcessor = 0;
var analyser;
var output = 0;
var bufferLoader;
var myBufferData = new Module.VectorDouble;
var sampleIsLoaded = false;
window.onload = init;
function setup() {
 console.log("non-overrided setup");
}
function play() {}
function setNumChannels(isArray, numChannelsOut_) {
 if (isArray) {
  OutputIsArray(true, numChannelsOut_);
 } else {
  OutputIsArray(false, numChannelsOut_);
 }
 source.disconnect();
 jsProcessor.disconnect();
 analyser.disconnect();
 initAudio(numChannelsOut_);
}
function OutputIsArray(isArray, numChannelsOut_) {
 if (isArray) {
  output = new Array(numChannelsOut_);
  for (var i = 0; i < numChannelsOut_; i++) {
   output[i] = 0;
  }
 } else {
  output = 0;
 }
}
var outputErrorLogged = false;
function process(event) {
 var numChannels = event.outputBuffer.numberOfChannels;
 var outputLength = event.outputBuffer.getChannelData(0).length;
 for (var i = 0; i < outputLength; ++i) {
  play();
  if (output instanceof Array) {
   for (var channel = 0; channel < numChannels; channel++) {
    event.outputBuffer.getChannelData(channel)[i] = output[channel];
   }
  } else {
   for (var channel = 0; channel < numChannels; channel++) {
    event.outputBuffer.getChannelData(channel)[i] = output;
   }
  }
 }
}
function initAudio(numChannels) {
 source = context.createBufferSource();
 jsProcessor = context.createScriptProcessor(4096, numChannels, numChannels);
 jsProcessor.onaudioprocess = process;
 analyser = context.createAnalyser();
 analyser.fftSize = 2048;
 source.connect(jsProcessor);
 jsProcessor.connect(analyser);
 analyser.connect(context.destination);
}
function init() {
 initAudio(2);
 setup();
}
function loadSample(url, samplePlayer) {
 var data = [];
 samplePlayer.clear();
 sampleIsLoaded = false;
 var request = new XMLHttpRequest;
 request.addEventListener("load", transferComplete);
 request.open("GET", url, true);
 request.responseType = "arraybuffer";
 request.onload = (function() {
  context.decodeAudioData(request.response, (function(buffer) {
   data = buffer.getChannelData(0);
   if (data) {
    Module.vectorTools.clearVectorDbl(myBufferData);
    for (var n = 0; n < data.length; n++) {
     myBufferData.push_back(data[n]);
    }
    samplePlayer.setSample(myBufferData);
    sampleIsLoaded = true;
   }
  }), (function(buffer) {
   console.log("Error decoding source!");
  }));
 });
 request.send();
}
function transferComplete(evt) {
 console.log("The transfer is complete.");
}




